from pybindgen import Module, FileCodeSink, param, retval, cppclass, typehandlers


import pybindgen.settings
import warnings

class ErrorHandler(pybindgen.settings.ErrorHandler):
    def handle_error(self, wrapper, exception, traceback_):
        warnings.warn("exception %r in wrapper %s" % (exception, wrapper))
        return True
pybindgen.settings.error_handler = ErrorHandler()


import sys

def module_init():
    root_module = Module('ns.mmwave', cpp_namespace='::ns3')
    return root_module

def register_types(module):
    root_module = module.get_root()

    ## queue-disc.h (module 'traffic-control'): ns3::QueueDiscSizePolicy [enumeration]
    module.add_enum('QueueDiscSizePolicy', ['SINGLE_INTERNAL_QUEUE', 'SINGLE_CHILD_QUEUE_DISC', 'MULTIPLE_QUEUES', 'NO_LIMITS'], import_from_module='ns.traffic-control')
    ## queue-size.h (module 'network'): ns3::QueueSizeUnit [enumeration]
    module.add_enum('QueueSizeUnit', ['PACKETS', 'BYTES'], import_from_module='ns.network')
    ## ff-mac-common.h (module 'lte'): ns3::Result_e [enumeration]
    module.add_enum('Result_e', ['SUCCESS', 'FAILURE'], import_from_module='ns.lte')
    ## ff-mac-common.h (module 'lte'): ns3::SetupRelease_e [enumeration]
    module.add_enum('SetupRelease_e', ['setup', 'release'], import_from_module='ns.lte')
    ## ff-mac-common.h (module 'lte'): ns3::CeBitmap_e [enumeration]
    module.add_enum('CeBitmap_e', ['TA', 'DRX', 'CR'], import_from_module='ns.lte')
    ## ff-mac-common.h (module 'lte'): ns3::NormalExtended_e [enumeration]
    module.add_enum('NormalExtended_e', ['normal', 'extended'], import_from_module='ns.lte')
    ## log.h (module 'core'): ns3::LogLevel [enumeration]
    module.add_enum('LogLevel', ['LOG_NONE', 'LOG_ERROR', 'LOG_LEVEL_ERROR', 'LOG_WARN', 'LOG_LEVEL_WARN', 'LOG_DEBUG', 'LOG_LEVEL_DEBUG', 'LOG_INFO', 'LOG_LEVEL_INFO', 'LOG_FUNCTION', 'LOG_LEVEL_FUNCTION', 'LOG_LOGIC', 'LOG_LEVEL_LOGIC', 'LOG_ALL', 'LOG_LEVEL_ALL', 'LOG_PREFIX_FUNC', 'LOG_PREFIX_TIME', 'LOG_PREFIX_NODE', 'LOG_PREFIX_LEVEL', 'LOG_PREFIX_ALL'], import_from_module='ns.core')
    ## address.h (module 'network'): ns3::Address [class]
    module.add_class('Address', import_from_module='ns.network')
    ## address.h (module 'network'): ns3::Address::MaxSize_e [enumeration]
    module.add_enum('MaxSize_e', ['MAX_SIZE'], outer_class=root_module['ns3::Address'], import_from_module='ns.network')
    ## eps-bearer.h (module 'lte'): ns3::AllocationRetentionPriority [struct]
    module.add_class('AllocationRetentionPriority', import_from_module='ns.lte')
    ## angles.h (module 'antenna'): ns3::Angles [struct]
    module.add_class('Angles', import_from_module='ns.antenna')
    ## attribute-construction-list.h (module 'core'): ns3::AttributeConstructionList [class]
    module.add_class('AttributeConstructionList', import_from_module='ns.core')
    ## attribute-construction-list.h (module 'core'): ns3::AttributeConstructionList::Item [struct]
    module.add_class('Item', import_from_module='ns.core', outer_class=root_module['ns3::AttributeConstructionList'])
    typehandlers.add_type_alias(u'std::list< ns3::AttributeConstructionList::Item > const_iterator', u'ns3::AttributeConstructionList::CIterator')
    typehandlers.add_type_alias(u'std::list< ns3::AttributeConstructionList::Item > const_iterator*', u'ns3::AttributeConstructionList::CIterator*')
    typehandlers.add_type_alias(u'std::list< ns3::AttributeConstructionList::Item > const_iterator&', u'ns3::AttributeConstructionList::CIterator&')
    ## spectrum-model.h (module 'spectrum'): ns3::BandInfo [struct]
    module.add_class('BandInfo', import_from_module='ns.spectrum')
    ## box.h (module 'mobility'): ns3::Box [class]
    module.add_class('Box', import_from_module='ns.mobility')
    ## box.h (module 'mobility'): ns3::Box::Side [enumeration]
    module.add_enum('Side', ['RIGHT', 'LEFT', 'TOP', 'BOTTOM', 'UP', 'DOWN'], outer_class=root_module['ns3::Box'], import_from_module='ns.mobility')
    ## buffer.h (module 'network'): ns3::Buffer [class]
    module.add_class('Buffer', import_from_module='ns.network')
    ## buffer.h (module 'network'): ns3::Buffer::Iterator [class]
    module.add_class('Iterator', import_from_module='ns.network', outer_class=root_module['ns3::Buffer'])
    ## lte-common.h (module 'lte'): ns3::BufferSizeLevelBsr [class]
    module.add_class('BufferSizeLevelBsr', import_from_module='ns.lte')
    ## ff-mac-common.h (module 'lte'): ns3::BuildBroadcastListElement_s [struct]
    module.add_class('BuildBroadcastListElement_s', import_from_module='ns.lte')
    ## ff-mac-common.h (module 'lte'): ns3::BuildBroadcastListElement_s::Type_e [enumeration]
    module.add_enum('Type_e', ['BCCH', 'PCCH'], outer_class=root_module['ns3::BuildBroadcastListElement_s'], import_from_module='ns.lte')
    ## ff-mac-common.h (module 'lte'): ns3::BuildDataListElement_s [struct]
    module.add_class('BuildDataListElement_s', import_from_module='ns.lte')
    ## ff-mac-common.h (module 'lte'): ns3::BuildRarListElement_s [struct]
    module.add_class('BuildRarListElement_s', import_from_module='ns.lte')
    ## ff-mac-common.h (module 'lte'): ns3::BwPart_s [struct]
    module.add_class('BwPart_s', import_from_module='ns.lte')
    ## packet.h (module 'network'): ns3::ByteTagIterator [class]
    module.add_class('ByteTagIterator', import_from_module='ns.network')
    ## packet.h (module 'network'): ns3::ByteTagIterator::Item [class]
    module.add_class('Item', import_from_module='ns.network', outer_class=root_module['ns3::ByteTagIterator'])
    ## byte-tag-list.h (module 'network'): ns3::ByteTagList [class]
    module.add_class('ByteTagList', import_from_module='ns.network')
    ## byte-tag-list.h (module 'network'): ns3::ByteTagList::Iterator [class]
    module.add_class('Iterator', import_from_module='ns.network', outer_class=root_module['ns3::ByteTagList'])
    ## byte-tag-list.h (module 'network'): ns3::ByteTagList::Iterator::Item [struct]
    module.add_class('Item', import_from_module='ns.network', outer_class=root_module['ns3::ByteTagList::Iterator'])
    ## callback.h (module 'core'): ns3::CallbackBase [class]
    module.add_class('CallbackBase', import_from_module='ns.core')
    ## constant-velocity-helper.h (module 'mobility'): ns3::ConstantVelocityHelper [class]
    module.add_class('ConstantVelocityHelper', import_from_module='ns.mobility')
    ## ff-mac-common.h (module 'lte'): ns3::CqiConfig_s [struct]
    module.add_class('CqiConfig_s', import_from_module='ns.lte')
    ## ff-mac-common.h (module 'lte'): ns3::CqiListElement_s [struct]
    module.add_class('CqiListElement_s', import_from_module='ns.lte')
    ## ff-mac-common.h (module 'lte'): ns3::CqiListElement_s::CqiType_e [enumeration]
    module.add_enum('CqiType_e', ['P10', 'P11', 'P20', 'P21', 'A12', 'A22', 'A20', 'A30', 'A31'], outer_class=root_module['ns3::CqiListElement_s'], import_from_module='ns.lte')
    ## data-output-interface.h (module 'stats'): ns3::DataOutputCallback [class]
    module.add_class('DataOutputCallback', allow_subclassing=True, import_from_module='ns.stats')
    ## data-rate.h (module 'network'): ns3::DataRate [class]
    module.add_class('DataRate', import_from_module='ns.network')
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::AttributeAccessor> [struct]
    module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::AttributeAccessor'])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::AttributeChecker> [struct]
    module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::AttributeChecker'])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::AttributeValue> [struct]
    module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::AttributeValue'])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::CallbackImplBase> [struct]
    module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::CallbackImplBase'])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::EpcTft> [struct]
    module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::EpcTft'])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::EventImpl> [struct]
    module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::EventImpl'])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::Hash::Implementation> [struct]
    module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::Hash::Implementation'])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::LteControlMessage> [struct]
    module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::LteControlMessage'])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::LteHarqPhy> [struct]
    module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::LteHarqPhy'])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::NixVector> [struct]
    module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::NixVector'])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::Packet> [struct]
    module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::Packet'])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::QueueItem> [struct]
    module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::QueueItem'])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::SpectrumModel> [struct]
    module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::SpectrumModel'])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::SpectrumSignalParameters> [struct]
    module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::SpectrumSignalParameters'])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::SpectrumValue> [struct]
    module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::SpectrumValue'])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::TraceSourceAccessor> [struct]
    module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::TraceSourceAccessor'])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::VendorSpecificValue> [struct]
    module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::VendorSpecificValue'])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::mmwave::BeamformingParams> [struct]
    module.add_class('DefaultDeleter', template_parameters=['ns3::mmwave::BeamformingParams'])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::mmwave::ChannelParams> [struct]
    module.add_class('DefaultDeleter', template_parameters=['ns3::mmwave::ChannelParams'])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::mmwave::MmWaveControlMessage> [struct]
    module.add_class('DefaultDeleter', template_parameters=['ns3::mmwave::MmWaveControlMessage'])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::mmwave::MmWaveHarqPhy> [struct]
    module.add_class('DefaultDeleter', template_parameters=['ns3::mmwave::MmWaveHarqPhy'])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::mmwave::Params3gpp> [struct]
    module.add_class('DefaultDeleter', template_parameters=['ns3::mmwave::Params3gpp'])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::mmwave::TraceParams> [struct]
    module.add_class('DefaultDeleter', template_parameters=['ns3::mmwave::TraceParams'])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::mmwave::mmWaveChunkProcessor> [struct]
    module.add_class('DefaultDeleter', template_parameters=['ns3::mmwave::mmWaveChunkProcessor'])
    ## ff-mac-common.h (module 'lte'): ns3::DlDciListElement_s [struct]
    module.add_class('DlDciListElement_s', import_from_module='ns.lte')
    ## ff-mac-common.h (module 'lte'): ns3::DlDciListElement_s::Format_e [enumeration]
    module.add_enum('Format_e', ['ONE', 'ONE_A', 'ONE_B', 'ONE_C', 'ONE_D', 'TWO', 'TWO_A', 'TWO_B'], outer_class=root_module['ns3::DlDciListElement_s'], import_from_module='ns.lte')
    ## ff-mac-common.h (module 'lte'): ns3::DlDciListElement_s::VrbFormat_e [enumeration]
    module.add_enum('VrbFormat_e', ['VRB_DISTRIBUTED', 'VRB_LOCALIZED'], outer_class=root_module['ns3::DlDciListElement_s'], import_from_module='ns.lte')
    ## ff-mac-common.h (module 'lte'): ns3::DlDciListElement_s::Ngap_e [enumeration]
    module.add_enum('Ngap_e', ['GAP1', 'GAP2'], outer_class=root_module['ns3::DlDciListElement_s'], import_from_module='ns.lte')
    ## ff-mac-common.h (module 'lte'): ns3::DlInfoListElement_s [struct]
    module.add_class('DlInfoListElement_s', import_from_module='ns.lte')
    ## ff-mac-common.h (module 'lte'): ns3::DlInfoListElement_s::HarqStatus_e [enumeration]
    module.add_enum('HarqStatus_e', ['ACK', 'NACK', 'DTX'], outer_class=root_module['ns3::DlInfoListElement_s'], import_from_module='ns.lte')
    ## lte-common.h (module 'lte'): ns3::DlSchedulingCallbackInfo [struct]
    module.add_class('DlSchedulingCallbackInfo', import_from_module='ns.lte')
    ## ff-mac-common.h (module 'lte'): ns3::DrxConfig_s [struct]
    module.add_class('DrxConfig_s', import_from_module='ns.lte')
    ## epc-enb-s1-sap.h (module 'lte'): ns3::EpcEnbS1SapProvider [class]
    module.add_class('EpcEnbS1SapProvider', allow_subclassing=True, import_from_module='ns.lte')
    ## epc-enb-s1-sap.h (module 'lte'): ns3::EpcEnbS1SapProvider::BearerToBeSwitched [struct]
    module.add_class('BearerToBeSwitched', import_from_module='ns.lte', outer_class=root_module['ns3::EpcEnbS1SapProvider'])
    ## epc-enb-s1-sap.h (module 'lte'): ns3::EpcEnbS1SapProvider::PathSwitchRequestParameters [struct]
    module.add_class('PathSwitchRequestParameters', import_from_module='ns.lte', outer_class=root_module['ns3::EpcEnbS1SapProvider'])
    ## epc-enb-s1-sap.h (module 'lte'): ns3::EpcEnbS1SapUser [class]
    module.add_class('EpcEnbS1SapUser', allow_subclassing=True, import_from_module='ns.lte')
    ## epc-enb-s1-sap.h (module 'lte'): ns3::EpcEnbS1SapUser::DataRadioBearerSetupRequestParameters [struct]
    module.add_class('DataRadioBearerSetupRequestParameters', import_from_module='ns.lte', outer_class=root_module['ns3::EpcEnbS1SapUser'])
    ## epc-enb-s1-sap.h (module 'lte'): ns3::EpcEnbS1SapUser::PathSwitchRequestAcknowledgeParameters [struct]
    module.add_class('PathSwitchRequestAcknowledgeParameters', import_from_module='ns.lte', outer_class=root_module['ns3::EpcEnbS1SapUser'])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap [class]
    module.add_class('EpcX2Sap', import_from_module='ns.lte')
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::UlInterferenceOverloadIndicationItem [enumeration]
    module.add_enum('UlInterferenceOverloadIndicationItem', ['HighInterference', 'MediumInterference', 'LowInterference'], outer_class=root_module['ns3::EpcX2Sap'], import_from_module='ns.lte')
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::LoadIndicator [enumeration]
    module.add_enum('LoadIndicator', ['LowLoad', 'MediumLoad', 'HighLoad', 'Overload'], outer_class=root_module['ns3::EpcX2Sap'], import_from_module='ns.lte')
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::IdCause [enumeration]
    module.add_enum('IdCause', ['HandoverDesirableForRadioReason', 'TimeCriticalHandover'], outer_class=root_module['ns3::EpcX2Sap'], import_from_module='ns.lte')
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::CellInformationItem [struct]
    module.add_class('CellInformationItem', import_from_module='ns.lte', outer_class=root_module['ns3::EpcX2Sap'])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::CellMeasurementResultItem [struct]
    module.add_class('CellMeasurementResultItem', import_from_module='ns.lte', outer_class=root_module['ns3::EpcX2Sap'])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::CompositeAvailCapacity [struct]
    module.add_class('CompositeAvailCapacity', import_from_module='ns.lte', outer_class=root_module['ns3::EpcX2Sap'])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::ErabAdmittedItem [struct]
    module.add_class('ErabAdmittedItem', import_from_module='ns.lte', outer_class=root_module['ns3::EpcX2Sap'])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::ErabNotAdmittedItem [struct]
    module.add_class('ErabNotAdmittedItem', import_from_module='ns.lte', outer_class=root_module['ns3::EpcX2Sap'])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::ErabToBeSetupItem [struct]
    module.add_class('ErabToBeSetupItem', import_from_module='ns.lte', outer_class=root_module['ns3::EpcX2Sap'])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::ErabsSubjectToStatusTransferItem [struct]
    module.add_class('ErabsSubjectToStatusTransferItem', import_from_module='ns.lte', outer_class=root_module['ns3::EpcX2Sap'])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::HandoverFailedParams [struct]
    module.add_class('HandoverFailedParams', import_from_module='ns.lte', outer_class=root_module['ns3::EpcX2Sap'])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::HandoverPreparationFailureParams [struct]
    module.add_class('HandoverPreparationFailureParams', import_from_module='ns.lte', outer_class=root_module['ns3::EpcX2Sap'])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::HandoverRequestAckParams [struct]
    module.add_class('HandoverRequestAckParams', import_from_module='ns.lte', outer_class=root_module['ns3::EpcX2Sap'])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::HandoverRequestParams [struct]
    module.add_class('HandoverRequestParams', import_from_module='ns.lte', outer_class=root_module['ns3::EpcX2Sap'])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::LoadInformationParams [struct]
    module.add_class('LoadInformationParams', import_from_module='ns.lte', outer_class=root_module['ns3::EpcX2Sap'])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::RelativeNarrowbandTxBand [struct]
    module.add_class('RelativeNarrowbandTxBand', import_from_module='ns.lte', outer_class=root_module['ns3::EpcX2Sap'])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::ResourceStatusUpdateParams [struct]
    module.add_class('ResourceStatusUpdateParams', import_from_module='ns.lte', outer_class=root_module['ns3::EpcX2Sap'])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::RlcSetupRequest [struct]
    module.add_class('RlcSetupRequest', import_from_module='ns.lte', outer_class=root_module['ns3::EpcX2Sap'])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::SecondaryHandoverCompletedParams [struct]
    module.add_class('SecondaryHandoverCompletedParams', import_from_module='ns.lte', outer_class=root_module['ns3::EpcX2Sap'])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::SecondaryHandoverParams [struct]
    module.add_class('SecondaryHandoverParams', import_from_module='ns.lte', outer_class=root_module['ns3::EpcX2Sap'])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::SnStatusTransferParams [struct]
    module.add_class('SnStatusTransferParams', import_from_module='ns.lte', outer_class=root_module['ns3::EpcX2Sap'])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::SwitchConnectionParams [struct]
    module.add_class('SwitchConnectionParams', import_from_module='ns.lte', outer_class=root_module['ns3::EpcX2Sap'])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::UeContextReleaseParams [struct]
    module.add_class('UeContextReleaseParams', import_from_module='ns.lte', outer_class=root_module['ns3::EpcX2Sap'])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::UeDataParams [struct]
    module.add_class('UeDataParams', import_from_module='ns.lte', outer_class=root_module['ns3::EpcX2Sap'])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::UeImsiSinrParams [struct]
    module.add_class('UeImsiSinrParams', import_from_module='ns.lte', outer_class=root_module['ns3::EpcX2Sap'])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::UlHighInterferenceInformationItem [struct]
    module.add_class('UlHighInterferenceInformationItem', import_from_module='ns.lte', outer_class=root_module['ns3::EpcX2Sap'])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2SapProvider [class]
    module.add_class('EpcX2SapProvider', import_from_module='ns.lte', parent=root_module['ns3::EpcX2Sap'])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2SapUser [class]
    module.add_class('EpcX2SapUser', import_from_module='ns.lte', parent=root_module['ns3::EpcX2Sap'])
    ## eps-bearer.h (module 'lte'): ns3::EpsBearer [struct]
    module.add_class('EpsBearer', import_from_module='ns.lte')
    ## eps-bearer.h (module 'lte'): ns3::EpsBearer::Qci [enumeration]
    module.add_enum('Qci', ['GBR_CONV_VOICE', 'GBR_CONV_VIDEO', 'GBR_GAMING', 'GBR_NON_CONV_VIDEO', 'GBR_MCPTT', 'GBR_NON_MCPTT', 'GBR_MC_VIDEO', 'GBR_V2X_MESSAGES', 'NGBR_IMS', 'NGBR_VIDEO_TCP_OPERATOR', 'NGBR_VOICE_VIDEO_GAMING', 'NGBR_VIDEO_TCP_PREMIUM', 'NGBR_VIDEO_TCP_DEFAULT', 'NGBR_MC_DELAY_SENSI_SIG', 'NGBR_MC_DATA', 'NGBR_V2X_MESSAGES', 'NGBR_LOW_LAT_EMBB_AR', 'GBR_DISC_AUTO_S_PACKETS', 'GBR_DISC_AUTO_B_PACKETS', 'GBR_INTEL_TRANSPORT_SYS', 'GBR_ELECTRIC_DIST_HV'], outer_class=root_module['ns3::EpsBearer'])
    ## lte-common.h (module 'lte'): ns3::EutranMeasurementMapping [class]
    module.add_class('EutranMeasurementMapping', import_from_module='ns.lte')
    ## event-id.h (module 'core'): ns3::EventId [class]
    module.add_class('EventId', import_from_module='ns.core')
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider [class]
    module.add_class('FfMacCschedSapProvider', allow_subclassing=True, import_from_module='ns.lte')
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters [struct]
    module.add_class('CschedCellConfigReqParameters', import_from_module='ns.lte', outer_class=root_module['ns3::FfMacCschedSapProvider'])
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::HoppingMode_e [enumeration]
    module.add_enum('HoppingMode_e', ['inter', 'interintra'], outer_class=root_module['ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters'], import_from_module='ns.lte')
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::PhichResource_e [enumeration]
    module.add_enum('PhichResource_e', ['PHICH_R_ONE_SIXTH', 'PHICH_R_HALF', 'PHICH_R_ONE', 'PHICH_R_TWO'], outer_class=root_module['ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters'], import_from_module='ns.lte')
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::DuplexMode_e [enumeration]
    module.add_enum('DuplexMode_e', ['DM_TDD', 'DM_FDD'], outer_class=root_module['ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters'], import_from_module='ns.lte')
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::Enable64Qam_e [enumeration]
    module.add_enum('Enable64Qam_e', ['MOD_16QAM', 'MOD_64QAM'], outer_class=root_module['ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters'], import_from_module='ns.lte')
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedLcConfigReqParameters [struct]
    module.add_class('CschedLcConfigReqParameters', import_from_module='ns.lte', outer_class=root_module['ns3::FfMacCschedSapProvider'])
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedLcReleaseReqParameters [struct]
    module.add_class('CschedLcReleaseReqParameters', import_from_module='ns.lte', outer_class=root_module['ns3::FfMacCschedSapProvider'])
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters [struct]
    module.add_class('CschedUeConfigReqParameters', import_from_module='ns.lte', outer_class=root_module['ns3::FfMacCschedSapProvider'])
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters::MeasGapConfigPattern_e [enumeration]
    module.add_enum('MeasGapConfigPattern_e', ['MGP_GP1', 'MGP_GP2', 'OFF'], outer_class=root_module['ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters'], import_from_module='ns.lte')
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters::OpenClosedLoop_e [enumeration]
    module.add_enum('OpenClosedLoop_e', ['noneloop', 'openloop', 'closedloop'], outer_class=root_module['ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters'], import_from_module='ns.lte')
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters::RepMode_e [enumeration]
    module.add_enum('RepMode_e', ['rm12', 'rm20', 'rm22', 'rm30', 'rm31', 'nonemode'], outer_class=root_module['ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters'], import_from_module='ns.lte')
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters::FeedbackMode_e [enumeration]
    module.add_enum('FeedbackMode_e', ['bundling', 'multiplexing'], outer_class=root_module['ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters'], import_from_module='ns.lte')
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeReleaseReqParameters [struct]
    module.add_class('CschedUeReleaseReqParameters', import_from_module='ns.lte', outer_class=root_module['ns3::FfMacCschedSapProvider'])
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser [class]
    module.add_class('FfMacCschedSapUser', allow_subclassing=True, import_from_module='ns.lte')
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedCellConfigCnfParameters [struct]
    module.add_class('CschedCellConfigCnfParameters', import_from_module='ns.lte', outer_class=root_module['ns3::FfMacCschedSapUser'])
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedCellConfigUpdateIndParameters [struct]
    module.add_class('CschedCellConfigUpdateIndParameters', import_from_module='ns.lte', outer_class=root_module['ns3::FfMacCschedSapUser'])
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedLcConfigCnfParameters [struct]
    module.add_class('CschedLcConfigCnfParameters', import_from_module='ns.lte', outer_class=root_module['ns3::FfMacCschedSapUser'])
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedLcReleaseCnfParameters [struct]
    module.add_class('CschedLcReleaseCnfParameters', import_from_module='ns.lte', outer_class=root_module['ns3::FfMacCschedSapUser'])
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedUeConfigCnfParameters [struct]
    module.add_class('CschedUeConfigCnfParameters', import_from_module='ns.lte', outer_class=root_module['ns3::FfMacCschedSapUser'])
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedUeConfigUpdateIndParameters [struct]
    module.add_class('CschedUeConfigUpdateIndParameters', import_from_module='ns.lte', outer_class=root_module['ns3::FfMacCschedSapUser'])
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedUeReleaseCnfParameters [struct]
    module.add_class('CschedUeReleaseCnfParameters', import_from_module='ns.lte', outer_class=root_module['ns3::FfMacCschedSapUser'])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider [class]
    module.add_class('FfMacSchedSapProvider', allow_subclassing=True, import_from_module='ns.lte')
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlCqiInfoReqParameters [struct]
    module.add_class('SchedDlCqiInfoReqParameters', import_from_module='ns.lte', outer_class=root_module['ns3::FfMacSchedSapProvider'])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlMacBufferReqParameters [struct]
    module.add_class('SchedDlMacBufferReqParameters', import_from_module='ns.lte', outer_class=root_module['ns3::FfMacSchedSapProvider'])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlPagingBufferReqParameters [struct]
    module.add_class('SchedDlPagingBufferReqParameters', import_from_module='ns.lte', outer_class=root_module['ns3::FfMacSchedSapProvider'])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlRachInfoReqParameters [struct]
    module.add_class('SchedDlRachInfoReqParameters', import_from_module='ns.lte', outer_class=root_module['ns3::FfMacSchedSapProvider'])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlRlcBufferReqParameters [struct]
    module.add_class('SchedDlRlcBufferReqParameters', import_from_module='ns.lte', outer_class=root_module['ns3::FfMacSchedSapProvider'])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlTriggerReqParameters [struct]
    module.add_class('SchedDlTriggerReqParameters', import_from_module='ns.lte', outer_class=root_module['ns3::FfMacSchedSapProvider'])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedUlCqiInfoReqParameters [struct]
    module.add_class('SchedUlCqiInfoReqParameters', import_from_module='ns.lte', outer_class=root_module['ns3::FfMacSchedSapProvider'])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters [struct]
    module.add_class('SchedUlMacCtrlInfoReqParameters', import_from_module='ns.lte', outer_class=root_module['ns3::FfMacSchedSapProvider'])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedUlNoiseInterferenceReqParameters [struct]
    module.add_class('SchedUlNoiseInterferenceReqParameters', import_from_module='ns.lte', outer_class=root_module['ns3::FfMacSchedSapProvider'])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedUlSrInfoReqParameters [struct]
    module.add_class('SchedUlSrInfoReqParameters', import_from_module='ns.lte', outer_class=root_module['ns3::FfMacSchedSapProvider'])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedUlTriggerReqParameters [struct]
    module.add_class('SchedUlTriggerReqParameters', import_from_module='ns.lte', outer_class=root_module['ns3::FfMacSchedSapProvider'])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapUser [class]
    module.add_class('FfMacSchedSapUser', allow_subclassing=True, import_from_module='ns.lte')
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapUser::SchedDlConfigIndParameters [struct]
    module.add_class('SchedDlConfigIndParameters', import_from_module='ns.lte', outer_class=root_module['ns3::FfMacSchedSapUser'])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapUser::SchedUlConfigIndParameters [struct]
    module.add_class('SchedUlConfigIndParameters', import_from_module='ns.lte', outer_class=root_module['ns3::FfMacSchedSapUser'])
    ## eps-bearer.h (module 'lte'): ns3::GbrQosInformation [struct]
    module.add_class('GbrQosInformation', import_from_module='ns.lte')
    ## lte-harq-phy.h (module 'lte'): ns3::HarqProcessInfoElement_t [struct]
    module.add_class('HarqProcessInfoElement_t', import_from_module='ns.lte')
    ## hash.h (module 'core'): ns3::Hasher [class]
    module.add_class('Hasher', import_from_module='ns.core')
    ## ff-mac-common.h (module 'lte'): ns3::HigherLayerSelected_s [struct]
    module.add_class('HigherLayerSelected_s', import_from_module='ns.lte')
    ## lte-common.h (module 'lte'): ns3::ImsiLcidPair_t [struct]
    module.add_class('ImsiLcidPair_t', import_from_module='ns.lte')
    ## inet6-socket-address.h (module 'network'): ns3::Inet6SocketAddress [class]
    module.add_class('Inet6SocketAddress', import_from_module='ns.network')
    ## inet6-socket-address.h (module 'network'): ns3::Inet6SocketAddress [class]
    root_module['ns3::Inet6SocketAddress'].implicitly_converts_to(root_module['ns3::Address'])
    ## inet-socket-address.h (module 'network'): ns3::InetSocketAddress [class]
    module.add_class('InetSocketAddress', import_from_module='ns.network')
    ## inet-socket-address.h (module 'network'): ns3::InetSocketAddress [class]
    root_module['ns3::InetSocketAddress'].implicitly_converts_to(root_module['ns3::Address'])
    ## ipv4-address.h (module 'network'): ns3::Ipv4Address [class]
    module.add_class('Ipv4Address', import_from_module='ns.network')
    ## ipv4-address.h (module 'network'): ns3::Ipv4Address [class]
    root_module['ns3::Ipv4Address'].implicitly_converts_to(root_module['ns3::Address'])
    ## ipv4-address-helper.h (module 'internet'): ns3::Ipv4AddressHelper [class]
    module.add_class('Ipv4AddressHelper', import_from_module='ns.internet')
    ## ipv4-interface-address.h (module 'internet'): ns3::Ipv4InterfaceAddress [class]
    module.add_class('Ipv4InterfaceAddress', import_from_module='ns.internet')
    ## ipv4-interface-address.h (module 'internet'): ns3::Ipv4InterfaceAddress::InterfaceAddressScope_e [enumeration]
    module.add_enum('InterfaceAddressScope_e', ['HOST', 'LINK', 'GLOBAL'], outer_class=root_module['ns3::Ipv4InterfaceAddress'], import_from_module='ns.internet')
    ## ipv4-interface-container.h (module 'internet'): ns3::Ipv4InterfaceContainer [class]
    module.add_class('Ipv4InterfaceContainer', import_from_module='ns.internet')
    typehandlers.add_type_alias(u'std::vector< std::pair< ns3::Ptr< ns3::Ipv4 >, unsigned int > > const_iterator', u'ns3::Ipv4InterfaceContainer::Iterator')
    typehandlers.add_type_alias(u'std::vector< std::pair< ns3::Ptr< ns3::Ipv4 >, unsigned int > > const_iterator*', u'ns3::Ipv4InterfaceContainer::Iterator*')
    typehandlers.add_type_alias(u'std::vector< std::pair< ns3::Ptr< ns3::Ipv4 >, unsigned int > > const_iterator&', u'ns3::Ipv4InterfaceContainer::Iterator&')
    ## ipv4-address.h (module 'network'): ns3::Ipv4Mask [class]
    module.add_class('Ipv4Mask', import_from_module='ns.network')
    ## ipv6-address.h (module 'network'): ns3::Ipv6Address [class]
    module.add_class('Ipv6Address', import_from_module='ns.network')
    ## ipv6-address.h (module 'network'): ns3::Ipv6Address [class]
    root_module['ns3::Ipv6Address'].implicitly_converts_to(root_module['ns3::Address'])
    ## ipv6-address-helper.h (module 'internet'): ns3::Ipv6AddressHelper [class]
    module.add_class('Ipv6AddressHelper', import_from_module='ns.internet')
    ## ipv6-interface-address.h (module 'internet'): ns3::Ipv6InterfaceAddress [class]
    module.add_class('Ipv6InterfaceAddress', import_from_module='ns.internet')
    ## ipv6-interface-address.h (module 'internet'): ns3::Ipv6InterfaceAddress::State_e [enumeration]
    module.add_enum('State_e', ['TENTATIVE', 'DEPRECATED', 'PREFERRED', 'PERMANENT', 'HOMEADDRESS', 'TENTATIVE_OPTIMISTIC', 'INVALID'], outer_class=root_module['ns3::Ipv6InterfaceAddress'], import_from_module='ns.internet')
    ## ipv6-interface-address.h (module 'internet'): ns3::Ipv6InterfaceAddress::Scope_e [enumeration]
    module.add_enum('Scope_e', ['HOST', 'LINKLOCAL', 'GLOBAL'], outer_class=root_module['ns3::Ipv6InterfaceAddress'], import_from_module='ns.internet')
    ## ipv6-interface-container.h (module 'internet'): ns3::Ipv6InterfaceContainer [class]
    module.add_class('Ipv6InterfaceContainer', import_from_module='ns.internet')
    typehandlers.add_type_alias(u'std::vector< std::pair< ns3::Ptr< ns3::Ipv6 >, unsigned int > > const_iterator', u'ns3::Ipv6InterfaceContainer::Iterator')
    typehandlers.add_type_alias(u'std::vector< std::pair< ns3::Ptr< ns3::Ipv6 >, unsigned int > > const_iterator*', u'ns3::Ipv6InterfaceContainer::Iterator*')
    typehandlers.add_type_alias(u'std::vector< std::pair< ns3::Ptr< ns3::Ipv6 >, unsigned int > > const_iterator&', u'ns3::Ipv6InterfaceContainer::Iterator&')
    ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix [class]
    module.add_class('Ipv6Prefix', import_from_module='ns.network')
    ## log.h (module 'core'): ns3::LogComponent [class]
    module.add_class('LogComponent', import_from_module='ns.core')
    typehandlers.add_type_alias(u'std::map< std::string, ns3::LogComponent * >', u'ns3::LogComponent::ComponentList')
    typehandlers.add_type_alias(u'std::map< std::string, ns3::LogComponent * >*', u'ns3::LogComponent::ComponentList*')
    typehandlers.add_type_alias(u'std::map< std::string, ns3::LogComponent * >&', u'ns3::LogComponent::ComponentList&')
    ## ff-mac-common.h (module 'lte'): ns3::LogicalChannelConfigListElement_s [struct]
    module.add_class('LogicalChannelConfigListElement_s', import_from_module='ns.lte')
    ## ff-mac-common.h (module 'lte'): ns3::LogicalChannelConfigListElement_s::Direction_e [enumeration]
    module.add_enum('Direction_e', ['DIR_UL', 'DIR_DL', 'DIR_BOTH'], outer_class=root_module['ns3::LogicalChannelConfigListElement_s'], import_from_module='ns.lte')
    ## ff-mac-common.h (module 'lte'): ns3::LogicalChannelConfigListElement_s::QosBearerType_e [enumeration]
    module.add_enum('QosBearerType_e', ['QBT_NON_GBR', 'QBT_GBR'], outer_class=root_module['ns3::LogicalChannelConfigListElement_s'], import_from_module='ns.lte')
    ## lte-anr-sap.h (module 'lte'): ns3::LteAnrSapProvider [class]
    module.add_class('LteAnrSapProvider', allow_subclassing=True, import_from_module='ns.lte')
    ## lte-anr-sap.h (module 'lte'): ns3::LteAnrSapUser [class]
    module.add_class('LteAnrSapUser', allow_subclassing=True, import_from_module='ns.lte')
    ## lte-as-sap.h (module 'lte'): ns3::LteAsSapProvider [class]
    module.add_class('LteAsSapProvider', allow_subclassing=True, import_from_module='ns.lte')
    ## lte-as-sap.h (module 'lte'): ns3::LteAsSapUser [class]
    module.add_class('LteAsSapUser', allow_subclassing=True, import_from_module='ns.lte')
    ## lte-ccm-mac-sap.h (module 'lte'): ns3::LteCcmMacSapProvider [class]
    module.add_class('LteCcmMacSapProvider', allow_subclassing=True, import_from_module='ns.lte')
    ## lte-ccm-rrc-sap.h (module 'lte'): ns3::LteCcmRrcSapProvider [class]
    module.add_class('LteCcmRrcSapProvider', allow_subclassing=True, import_from_module='ns.lte')
    ## lte-ccm-rrc-sap.h (module 'lte'): ns3::LteCcmRrcSapProvider::LcsConfig [struct]
    module.add_class('LcsConfig', import_from_module='ns.lte', outer_class=root_module['ns3::LteCcmRrcSapProvider'])
    ## lte-ccm-rrc-sap.h (module 'lte'): ns3::LteCcmRrcSapUser [class]
    module.add_class('LteCcmRrcSapUser', allow_subclassing=True, import_from_module='ns.lte')
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapProvider [class]
    module.add_class('LteEnbCmacSapProvider', allow_subclassing=True, import_from_module='ns.lte')
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapProvider::AllocateNcRaPreambleReturnValue [struct]
    module.add_class('AllocateNcRaPreambleReturnValue', import_from_module='ns.lte', outer_class=root_module['ns3::LteEnbCmacSapProvider'])
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapProvider::LcInfo [struct]
    module.add_class('LcInfo', import_from_module='ns.lte', outer_class=root_module['ns3::LteEnbCmacSapProvider'])
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapProvider::RachConfig [struct]
    module.add_class('RachConfig', import_from_module='ns.lte', outer_class=root_module['ns3::LteEnbCmacSapProvider'])
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapProvider::UeConfig [struct]
    module.add_class('UeConfig', import_from_module='ns.lte', outer_class=root_module['ns3::LteEnbCmacSapProvider'])
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapUser [class]
    module.add_class('LteEnbCmacSapUser', allow_subclassing=True, import_from_module='ns.lte')
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapUser::UeConfig [struct]
    module.add_class('UeConfig', import_from_module='ns.lte', outer_class=root_module['ns3::LteEnbCmacSapUser'])
    ## lte-enb-cphy-sap.h (module 'lte'): ns3::LteEnbCphySapProvider [class]
    module.add_class('LteEnbCphySapProvider', allow_subclassing=True, import_from_module='ns.lte')
    ## lte-enb-cphy-sap.h (module 'lte'): ns3::LteEnbCphySapUser [class]
    module.add_class('LteEnbCphySapUser', allow_subclassing=True, import_from_module='ns.lte')
    ## lte-enb-cphy-sap.h (module 'lte'): ns3::LteEnbCphySapUser::UeAssociatedSinrInfo [struct]
    module.add_class('UeAssociatedSinrInfo', import_from_module='ns.lte', outer_class=root_module['ns3::LteEnbCphySapUser'])
    ## lte-enb-phy-sap.h (module 'lte'): ns3::LteEnbPhySapProvider [class]
    module.add_class('LteEnbPhySapProvider', allow_subclassing=True, import_from_module='ns.lte')
    ## lte-enb-phy-sap.h (module 'lte'): ns3::LteEnbPhySapUser [class]
    module.add_class('LteEnbPhySapUser', allow_subclassing=True, import_from_module='ns.lte')
    ## lte-common.h (module 'lte'): ns3::LteFfConverter [class]
    module.add_class('LteFfConverter', import_from_module='ns.lte')
    ## lte-ffr-rrc-sap.h (module 'lte'): ns3::LteFfrRrcSapProvider [class]
    module.add_class('LteFfrRrcSapProvider', allow_subclassing=True, import_from_module='ns.lte')
    ## lte-ffr-rrc-sap.h (module 'lte'): ns3::LteFfrRrcSapUser [class]
    module.add_class('LteFfrRrcSapUser', allow_subclassing=True, import_from_module='ns.lte')
    ## lte-common.h (module 'lte'): ns3::LteFlowId_t [struct]
    module.add_class('LteFlowId_t', import_from_module='ns.lte')
    ## lte-handover-management-sap.h (module 'lte'): ns3::LteHandoverManagementSapProvider [class]
    module.add_class('LteHandoverManagementSapProvider', allow_subclassing=True, import_from_module='ns.lte')
    ## lte-handover-management-sap.h (module 'lte'): ns3::LteHandoverManagementSapUser [class]
    module.add_class('LteHandoverManagementSapUser', allow_subclassing=True, import_from_module='ns.lte')
    ## lte-mac-sap.h (module 'lte'): ns3::LteMacSapProvider [class]
    module.add_class('LteMacSapProvider', allow_subclassing=True, import_from_module='ns.lte')
    ## lte-mac-sap.h (module 'lte'): ns3::LteMacSapProvider::ReportBufferStatusParameters [struct]
    module.add_class('ReportBufferStatusParameters', import_from_module='ns.lte', outer_class=root_module['ns3::LteMacSapProvider'])
    ## lte-mac-sap.h (module 'lte'): ns3::LteMacSapProvider::TransmitPduParameters [struct]
    module.add_class('TransmitPduParameters', import_from_module='ns.lte', outer_class=root_module['ns3::LteMacSapProvider'])
    ## lte-mac-sap.h (module 'lte'): ns3::LteMacSapUser [class]
    module.add_class('LteMacSapUser', allow_subclassing=True, import_from_module='ns.lte')
    ## lte-pdcp-sap.h (module 'lte'): ns3::LtePdcpSapProvider [class]
    module.add_class('LtePdcpSapProvider', allow_subclassing=True, import_from_module='ns.lte')
    ## lte-pdcp-sap.h (module 'lte'): ns3::LtePdcpSapProvider::TransmitPdcpSduParameters [struct]
    module.add_class('TransmitPdcpSduParameters', import_from_module='ns.lte', outer_class=root_module['ns3::LtePdcpSapProvider'])
    ## lte-pdcp-sap.h (module 'lte'): ns3::LtePdcpSapUser [class]
    module.add_class('LtePdcpSapUser', allow_subclassing=True, import_from_module='ns.lte')
    ## lte-pdcp-sap.h (module 'lte'): ns3::LtePdcpSapUser::ReceivePdcpSduParameters [struct]
    module.add_class('ReceivePdcpSduParameters', import_from_module='ns.lte', outer_class=root_module['ns3::LtePdcpSapUser'])
    ## lte-rlc-sap.h (module 'lte'): ns3::LteRlcSapProvider [class]
    module.add_class('LteRlcSapProvider', allow_subclassing=True, import_from_module='ns.lte')
    ## lte-rlc-sap.h (module 'lte'): ns3::LteRlcSapProvider::TransmitPdcpPduParameters [struct]
    module.add_class('TransmitPdcpPduParameters', import_from_module='ns.lte', outer_class=root_module['ns3::LteRlcSapProvider'])
    ## lte-rlc-sap.h (module 'lte'): ns3::LteRlcSapUser [class]
    module.add_class('LteRlcSapUser', allow_subclassing=True, import_from_module='ns.lte')
    ## lte-rlc.h (module 'lte'): ns3::LteRlcSpecificLteMacSapUser [class]
    module.add_class('LteRlcSpecificLteMacSapUser', import_from_module='ns.lte', parent=root_module['ns3::LteMacSapUser'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap [class]
    module.add_class('LteRrcSap', import_from_module='ns.lte')
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::ReestablishmentCause [enumeration]
    module.add_enum('ReestablishmentCause', ['RECONFIGURATION_FAILURE', 'HANDOVER_FAILURE', 'OTHER_FAILURE'], outer_class=root_module['ns3::LteRrcSap'], import_from_module='ns.lte')
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::AntennaInfoCommon [struct]
    module.add_class('AntennaInfoCommon', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::AntennaInfoDedicated [struct]
    module.add_class('AntennaInfoDedicated', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::AntennaInfoUl [struct]
    module.add_class('AntennaInfoUl', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::AsConfig [struct]
    module.add_class('AsConfig', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::BlackCellsToAddMod [struct]
    module.add_class('BlackCellsToAddMod', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::CarrierBandwidthEutra [struct]
    module.add_class('CarrierBandwidthEutra', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::CarrierFreqEutra [struct]
    module.add_class('CarrierFreqEutra', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::CellAccessRelatedInfo [struct]
    module.add_class('CellAccessRelatedInfo', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::CellIdentification [struct]
    module.add_class('CellIdentification', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::CellSelectionInfo [struct]
    module.add_class('CellSelectionInfo', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::CellsToAddMod [struct]
    module.add_class('CellsToAddMod', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::CgiInfo [struct]
    module.add_class('CgiInfo', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::DrbToAddMod [struct]
    module.add_class('DrbToAddMod', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::FreqInfo [struct]
    module.add_class('FreqInfo', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::HandoverPreparationInfo [struct]
    module.add_class('HandoverPreparationInfo', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::LogicalChannelConfig [struct]
    module.add_class('LogicalChannelConfig', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MasterInformationBlock [struct]
    module.add_class('MasterInformationBlock', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasConfig [struct]
    module.add_class('MeasConfig', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasGapConfig [struct]
    module.add_class('MeasGapConfig', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasGapConfig::action [enumeration]
    module.add_enum('action', ['SETUP', 'RESET'], outer_class=root_module['ns3::LteRrcSap::MeasGapConfig'], import_from_module='ns.lte')
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasGapConfig::gap [enumeration]
    module.add_enum('gap', ['GP0', 'GP1'], outer_class=root_module['ns3::LteRrcSap::MeasGapConfig'], import_from_module='ns.lte')
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasIdToAddMod [struct]
    module.add_class('MeasIdToAddMod', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasObjectEutra [struct]
    module.add_class('MeasObjectEutra', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasObjectToAddMod [struct]
    module.add_class('MeasObjectToAddMod', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResultBestNeighCell [struct]
    module.add_class('MeasResultBestNeighCell', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResultEutra [struct]
    module.add_class('MeasResultEutra', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResultScell [struct]
    module.add_class('MeasResultScell', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResultServFreqList [struct]
    module.add_class('MeasResultServFreqList', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResults [struct]
    module.add_class('MeasResults', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasurementReport [struct]
    module.add_class('MeasurementReport', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MobilityControlInfo [struct]
    module.add_class('MobilityControlInfo', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MobilityStateParameters [struct]
    module.add_class('MobilityStateParameters', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::NonCriticalExtensionConfiguration [struct]
    module.add_class('NonCriticalExtensionConfiguration', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::NonUlConfiguration [struct]
    module.add_class('NonUlConfiguration', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PdschConfigCommon [struct]
    module.add_class('PdschConfigCommon', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PdschConfigDedicated [struct]
    module.add_class('PdschConfigDedicated', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PdschConfigDedicated::db [enumeration]
    module.add_enum('db', ['dB_6', 'dB_4dot77', 'dB_3', 'dB_1dot77', 'dB0', 'dB1', 'dB2', 'dB3'], outer_class=root_module['ns3::LteRrcSap::PdschConfigDedicated'], import_from_module='ns.lte')
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PhysCellIdRange [struct]
    module.add_class('PhysCellIdRange', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PhysicalConfigDedicated [struct]
    module.add_class('PhysicalConfigDedicated', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PhysicalConfigDedicatedSCell [struct]
    module.add_class('PhysicalConfigDedicatedSCell', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PlmnIdentityInfo [struct]
    module.add_class('PlmnIdentityInfo', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PrachConfigSCell [struct]
    module.add_class('PrachConfigSCell', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PreambleInfo [struct]
    module.add_class('PreambleInfo', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PuschConfigDedicatedSCell [struct]
    module.add_class('PuschConfigDedicatedSCell', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::QuantityConfig [struct]
    module.add_class('QuantityConfig', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RaSupervisionInfo [struct]
    module.add_class('RaSupervisionInfo', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RachConfigCommon [struct]
    module.add_class('RachConfigCommon', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RachConfigDedicated [struct]
    module.add_class('RachConfigDedicated', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RadioResourceConfigCommon [struct]
    module.add_class('RadioResourceConfigCommon', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RadioResourceConfigCommonSCell [struct]
    module.add_class('RadioResourceConfigCommonSCell', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RadioResourceConfigCommonSib [struct]
    module.add_class('RadioResourceConfigCommonSib', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RadioResourceConfigDedicated [struct]
    module.add_class('RadioResourceConfigDedicated', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RadioResourceConfigDedicatedSCell [struct]
    module.add_class('RadioResourceConfigDedicatedSCell', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::ReestabUeIdentity [struct]
    module.add_class('ReestabUeIdentity', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::ReportConfigEutra [struct]
    module.add_class('ReportConfigEutra', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::ReportConfigEutra [enumeration]
    module.add_enum('', ['EVENT', 'PERIODICAL'], outer_class=root_module['ns3::LteRrcSap::ReportConfigEutra'], import_from_module='ns.lte')
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::ReportConfigEutra [enumeration]
    module.add_enum('', ['EVENT_A1', 'EVENT_A2', 'EVENT_A3', 'EVENT_A4', 'EVENT_A5'], outer_class=root_module['ns3::LteRrcSap::ReportConfigEutra'], import_from_module='ns.lte')
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::ReportConfigEutra::report [enumeration]
    module.add_enum('report', ['REPORT_STRONGEST_CELLS', 'REPORT_CGI'], outer_class=root_module['ns3::LteRrcSap::ReportConfigEutra'], import_from_module='ns.lte')
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::ReportConfigEutra [enumeration]
    module.add_enum('', ['RSRP', 'RSRQ'], outer_class=root_module['ns3::LteRrcSap::ReportConfigEutra'], import_from_module='ns.lte')
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::ReportConfigEutra [enumeration]
    module.add_enum('', ['SAME_AS_TRIGGER_QUANTITY', 'BOTH'], outer_class=root_module['ns3::LteRrcSap::ReportConfigEutra'], import_from_module='ns.lte')
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::ReportConfigEutra [enumeration]
    module.add_enum('', ['MS120', 'MS240', 'MS480', 'MS640', 'MS1024', 'MS2048', 'MS5120', 'MS10240', 'MIN1', 'MIN6', 'MIN12', 'MIN30', 'MIN60', 'SPARE3', 'SPARE2', 'SPARE1'], outer_class=root_module['ns3::LteRrcSap::ReportConfigEutra'], import_from_module='ns.lte')
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::ReportConfigToAddMod [struct]
    module.add_class('ReportConfigToAddMod', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RlcConfig [struct]
    module.add_class('RlcConfig', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RlcConfig::direction [enumeration]
    module.add_enum('direction', ['AM', 'UM_BI_DIRECTIONAL', 'UM_UNI_DIRECTIONAL_UL', 'UM_UNI_DIRECTIONAL_DL', 'UM_BI_DIRECTIONAL_LOWLAT'], outer_class=root_module['ns3::LteRrcSap::RlcConfig'], import_from_module='ns.lte')
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReconfiguration [struct]
    module.add_class('RrcConnectionReconfiguration', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReconfigurationCompleted [struct]
    module.add_class('RrcConnectionReconfigurationCompleted', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReestablishment [struct]
    module.add_class('RrcConnectionReestablishment', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReestablishmentComplete [struct]
    module.add_class('RrcConnectionReestablishmentComplete', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReestablishmentReject [struct]
    module.add_class('RrcConnectionReestablishmentReject', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReestablishmentRequest [struct]
    module.add_class('RrcConnectionReestablishmentRequest', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReject [struct]
    module.add_class('RrcConnectionReject', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionRelease [struct]
    module.add_class('RrcConnectionRelease', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionRequest [struct]
    module.add_class('RrcConnectionRequest', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionSetup [struct]
    module.add_class('RrcConnectionSetup', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionSetupCompleted [struct]
    module.add_class('RrcConnectionSetupCompleted', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionSwitch [struct]
    module.add_class('RrcConnectionSwitch', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SCellToAddMod [struct]
    module.add_class('SCellToAddMod', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SoundingRsUlConfigCommon [struct]
    module.add_class('SoundingRsUlConfigCommon', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SoundingRsUlConfigCommon::action [enumeration]
    module.add_enum('action', ['SETUP', 'RESET'], outer_class=root_module['ns3::LteRrcSap::SoundingRsUlConfigCommon'], import_from_module='ns.lte')
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SoundingRsUlConfigDedicated [struct]
    module.add_class('SoundingRsUlConfigDedicated', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SoundingRsUlConfigDedicated::action [enumeration]
    module.add_enum('action', ['SETUP', 'RESET'], outer_class=root_module['ns3::LteRrcSap::SoundingRsUlConfigDedicated'], import_from_module='ns.lte')
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SpeedStatePars [struct]
    module.add_class('SpeedStatePars', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SpeedStatePars::action [enumeration]
    module.add_enum('action', ['SETUP', 'RESET'], outer_class=root_module['ns3::LteRrcSap::SpeedStatePars'], import_from_module='ns.lte')
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SpeedStateScaleFactors [struct]
    module.add_class('SpeedStateScaleFactors', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SrbToAddMod [struct]
    module.add_class('SrbToAddMod', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SystemInformation [struct]
    module.add_class('SystemInformation', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SystemInformationBlockType1 [struct]
    module.add_class('SystemInformationBlockType1', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SystemInformationBlockType2 [struct]
    module.add_class('SystemInformationBlockType2', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::ThresholdEutra [struct]
    module.add_class('ThresholdEutra', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::ThresholdEutra [enumeration]
    module.add_enum('', ['THRESHOLD_RSRP', 'THRESHOLD_RSRQ'], outer_class=root_module['ns3::LteRrcSap::ThresholdEutra'], import_from_module='ns.lte')
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::UlConfiguration [struct]
    module.add_class('UlConfiguration', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::UlPowerControlCommonSCell [struct]
    module.add_class('UlPowerControlCommonSCell', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::UlPowerControlDedicatedSCell [struct]
    module.add_class('UlPowerControlDedicatedSCell', import_from_module='ns.lte', outer_class=root_module['ns3::LteRrcSap'])
    ## lte-spectrum-value-helper.h (module 'lte'): ns3::LteSpectrumValueHelper [class]
    module.add_class('LteSpectrumValueHelper', import_from_module='ns.lte')
    ## lte-ue-ccm-rrc-sap.h (module 'lte'): ns3::LteUeCcmRrcSapProvider [class]
    module.add_class('LteUeCcmRrcSapProvider', allow_subclassing=True, import_from_module='ns.lte')
    ## lte-ue-ccm-rrc-sap.h (module 'lte'): ns3::LteUeCcmRrcSapProvider::LcsConfig [struct]
    module.add_class('LcsConfig', import_from_module='ns.lte', outer_class=root_module['ns3::LteUeCcmRrcSapProvider'])
    ## lte-ue-ccm-rrc-sap.h (module 'lte'): ns3::LteUeCcmRrcSapUser [class]
    module.add_class('LteUeCcmRrcSapUser', allow_subclassing=True, import_from_module='ns.lte')
    ## lte-ue-cmac-sap.h (module 'lte'): ns3::LteUeCmacSapProvider [class]
    module.add_class('LteUeCmacSapProvider', allow_subclassing=True, import_from_module='ns.lte')
    ## lte-ue-cmac-sap.h (module 'lte'): ns3::LteUeCmacSapProvider::LogicalChannelConfig [struct]
    module.add_class('LogicalChannelConfig', import_from_module='ns.lte', outer_class=root_module['ns3::LteUeCmacSapProvider'])
    ## lte-ue-cmac-sap.h (module 'lte'): ns3::LteUeCmacSapProvider::RachConfig [struct]
    module.add_class('RachConfig', import_from_module='ns.lte', outer_class=root_module['ns3::LteUeCmacSapProvider'])
    ## lte-ue-cmac-sap.h (module 'lte'): ns3::LteUeCmacSapUser [class]
    module.add_class('LteUeCmacSapUser', allow_subclassing=True, import_from_module='ns.lte')
    ## lte-common.h (module 'lte'): ns3::LteUeConfig_t [struct]
    module.add_class('LteUeConfig_t', import_from_module='ns.lte')
    ## lte-ue-cphy-sap.h (module 'lte'): ns3::LteUeCphySapProvider [class]
    module.add_class('LteUeCphySapProvider', allow_subclassing=True, import_from_module='ns.lte')
    ## lte-ue-cphy-sap.h (module 'lte'): ns3::LteUeCphySapUser [class]
    module.add_class('LteUeCphySapUser', allow_subclassing=True, import_from_module='ns.lte')
    ## lte-ue-cphy-sap.h (module 'lte'): ns3::LteUeCphySapUser::UeMeasurementsElement [struct]
    module.add_class('UeMeasurementsElement', import_from_module='ns.lte', outer_class=root_module['ns3::LteUeCphySapUser'])
    ## lte-ue-cphy-sap.h (module 'lte'): ns3::LteUeCphySapUser::UeMeasurementsParameters [struct]
    module.add_class('UeMeasurementsParameters', import_from_module='ns.lte', outer_class=root_module['ns3::LteUeCphySapUser'])
    ## lte-ue-phy-sap.h (module 'lte'): ns3::LteUePhySapProvider [class]
    module.add_class('LteUePhySapProvider', allow_subclassing=True, import_from_module='ns.lte')
    ## lte-ue-phy-sap.h (module 'lte'): ns3::LteUePhySapUser [class]
    module.add_class('LteUePhySapUser', allow_subclassing=True, import_from_module='ns.lte')
    ## lte-rrc-sap.h (module 'lte'): ns3::LteUeRrcSapProvider [class]
    module.add_class('LteUeRrcSapProvider', import_from_module='ns.lte', parent=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteUeRrcSapProvider::CompleteSetupParameters [struct]
    module.add_class('CompleteSetupParameters', import_from_module='ns.lte', outer_class=root_module['ns3::LteUeRrcSapProvider'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteUeRrcSapUser [class]
    module.add_class('LteUeRrcSapUser', import_from_module='ns.lte', parent=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteUeRrcSapUser::SetupParameters [struct]
    module.add_class('SetupParameters', import_from_module='ns.lte', outer_class=root_module['ns3::LteUeRrcSapUser'])
    ## mac48-address.h (module 'network'): ns3::Mac48Address [class]
    module.add_class('Mac48Address', import_from_module='ns.network')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Mac48Address )', u'ns3::Mac48Address::TracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Mac48Address )*', u'ns3::Mac48Address::TracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Mac48Address )&', u'ns3::Mac48Address::TracedCallback&')
    ## mac48-address.h (module 'network'): ns3::Mac48Address [class]
    root_module['ns3::Mac48Address'].implicitly_converts_to(root_module['ns3::Address'])
    ## mac64-address.h (module 'network'): ns3::Mac64Address [class]
    module.add_class('Mac64Address', import_from_module='ns.network')
    ## mac64-address.h (module 'network'): ns3::Mac64Address [class]
    root_module['ns3::Mac64Address'].implicitly_converts_to(root_module['ns3::Address'])
    ## mac8-address.h (module 'network'): ns3::Mac8Address [class]
    module.add_class('Mac8Address', import_from_module='ns.network')
    ## mac8-address.h (module 'network'): ns3::Mac8Address [class]
    root_module['ns3::Mac8Address'].implicitly_converts_to(root_module['ns3::Address'])
    ## ff-mac-common.h (module 'lte'): ns3::MacCeListElement_s [struct]
    module.add_class('MacCeListElement_s', import_from_module='ns.lte')
    ## ff-mac-common.h (module 'lte'): ns3::MacCeListElement_s::MacCeType_e [enumeration]
    module.add_enum('MacCeType_e', ['BSR', 'PHR', 'CRNTI'], outer_class=root_module['ns3::MacCeListElement_s'], import_from_module='ns.lte')
    ## ff-mac-common.h (module 'lte'): ns3::MacCeValue_u [struct]
    module.add_class('MacCeValue_u', import_from_module='ns.lte')
    ## names.h (module 'core'): ns3::Names [class]
    module.add_class('Names', import_from_module='ns.core')
    ## net-device-container.h (module 'network'): ns3::NetDeviceContainer [class]
    module.add_class('NetDeviceContainer', import_from_module='ns.network')
    typehandlers.add_type_alias(u'std::vector< ns3::Ptr< ns3::NetDevice > > const_iterator', u'ns3::NetDeviceContainer::Iterator')
    typehandlers.add_type_alias(u'std::vector< ns3::Ptr< ns3::NetDevice > > const_iterator*', u'ns3::NetDeviceContainer::Iterator*')
    typehandlers.add_type_alias(u'std::vector< ns3::Ptr< ns3::NetDevice > > const_iterator&', u'ns3::NetDeviceContainer::Iterator&')
    ## node-container.h (module 'network'): ns3::NodeContainer [class]
    module.add_class('NodeContainer', import_from_module='ns.network')
    typehandlers.add_type_alias(u'std::vector< ns3::Ptr< ns3::Node > > const_iterator', u'ns3::NodeContainer::Iterator')
    typehandlers.add_type_alias(u'std::vector< ns3::Ptr< ns3::Node > > const_iterator*', u'ns3::NodeContainer::Iterator*')
    typehandlers.add_type_alias(u'std::vector< ns3::Ptr< ns3::Node > > const_iterator&', u'ns3::NodeContainer::Iterator&')
    ## object-base.h (module 'core'): ns3::ObjectBase [class]
    module.add_class('ObjectBase', allow_subclassing=True, import_from_module='ns.core')
    ## object.h (module 'core'): ns3::ObjectDeleter [struct]
    module.add_class('ObjectDeleter', import_from_module='ns.core')
    ## object-factory.h (module 'core'): ns3::ObjectFactory [class]
    module.add_class('ObjectFactory', import_from_module='ns.core')
    ## packet-metadata.h (module 'network'): ns3::PacketMetadata [class]
    module.add_class('PacketMetadata', import_from_module='ns.network')
    ## packet-metadata.h (module 'network'): ns3::PacketMetadata::Item [struct]
    module.add_class('Item', import_from_module='ns.network', outer_class=root_module['ns3::PacketMetadata'])
    ## packet-metadata.h (module 'network'): ns3::PacketMetadata::Item::ItemType [enumeration]
    module.add_enum('ItemType', ['PAYLOAD', 'HEADER', 'TRAILER'], outer_class=root_module['ns3::PacketMetadata::Item'], import_from_module='ns.network')
    ## packet-metadata.h (module 'network'): ns3::PacketMetadata::ItemIterator [class]
    module.add_class('ItemIterator', import_from_module='ns.network', outer_class=root_module['ns3::PacketMetadata'])
    ## packet.h (module 'network'): ns3::PacketTagIterator [class]
    module.add_class('PacketTagIterator', import_from_module='ns.network')
    ## packet.h (module 'network'): ns3::PacketTagIterator::Item [class]
    module.add_class('Item', import_from_module='ns.network', outer_class=root_module['ns3::PacketTagIterator'])
    ## packet-tag-list.h (module 'network'): ns3::PacketTagList [class]
    module.add_class('PacketTagList', import_from_module='ns.network')
    ## packet-tag-list.h (module 'network'): ns3::PacketTagList::TagData [struct]
    module.add_class('TagData', import_from_module='ns.network', outer_class=root_module['ns3::PacketTagList'])
    ## ff-mac-common.h (module 'lte'): ns3::PagingInfoListElement_s [struct]
    module.add_class('PagingInfoListElement_s', import_from_module='ns.lte')
    ## log.h (module 'core'): ns3::ParameterLogger [class]
    module.add_class('ParameterLogger', import_from_module='ns.core')
    ## ff-mac-common.h (module 'lte'): ns3::PhichListElement_s [struct]
    module.add_class('PhichListElement_s', import_from_module='ns.lte')
    ## ff-mac-common.h (module 'lte'): ns3::PhichListElement_s::Phich_e [enumeration]
    module.add_enum('Phich_e', ['ACK', 'NACK'], outer_class=root_module['ns3::PhichListElement_s'], import_from_module='ns.lte')
    ## lte-common.h (module 'lte'): ns3::PhyReceptionStatParameters [struct]
    module.add_class('PhyReceptionStatParameters', import_from_module='ns.lte')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::PhyReceptionStatParameters const )', u'ns3::PhyReceptionStatParameters::TracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::PhyReceptionStatParameters const )*', u'ns3::PhyReceptionStatParameters::TracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::PhyReceptionStatParameters const )&', u'ns3::PhyReceptionStatParameters::TracedCallback&')
    ## lte-common.h (module 'lte'): ns3::PhyTransmissionStatParameters [struct]
    module.add_class('PhyTransmissionStatParameters', import_from_module='ns.lte')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::PhyTransmissionStatParameters const )', u'ns3::PhyTransmissionStatParameters::TracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::PhyTransmissionStatParameters const )*', u'ns3::PhyTransmissionStatParameters::TracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::PhyTransmissionStatParameters const )&', u'ns3::PhyTransmissionStatParameters::TracedCallback&')
    ## queue-size.h (module 'network'): ns3::QueueSize [class]
    module.add_class('QueueSize', import_from_module='ns.network')
    ## ff-mac-common.h (module 'lte'): ns3::RachListElement_s [struct]
    module.add_class('RachListElement_s', import_from_module='ns.lte')
    ## ff-mac-common.h (module 'lte'): ns3::RlcPduListElement_s [struct]
    module.add_class('RlcPduListElement_s', import_from_module='ns.lte')
    ## ff-mac-common.h (module 'lte'): ns3::SbMeasResult_s [struct]
    module.add_class('SbMeasResult_s', import_from_module='ns.lte')
    ## lte-rlc-sequence-number.h (module 'lte'): ns3::SequenceNumber10 [class]
    module.add_class('SequenceNumber10', import_from_module='ns.lte')
    ## ff-mac-common.h (module 'lte'): ns3::SiConfiguration_s [struct]
    module.add_class('SiConfiguration_s', import_from_module='ns.lte')
    ## ff-mac-common.h (module 'lte'): ns3::SiMessageListElement_s [struct]
    module.add_class('SiMessageListElement_s', import_from_module='ns.lte')
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::Object, ns3::ObjectBase, ns3::ObjectDeleter> [class]
    module.add_class('SimpleRefCount', automatic_type_narrowing=True, import_from_module='ns.core', template_parameters=['ns3::Object', 'ns3::ObjectBase', 'ns3::ObjectDeleter'], parent=root_module['ns3::ObjectBase'], memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'))
    ## simulator.h (module 'core'): ns3::Simulator [class]
    module.add_class('Simulator', destructor_visibility='private', import_from_module='ns.core')
    ## simulator.h (module 'core'): ns3::Simulator [enumeration]
    module.add_enum('', ['NO_CONTEXT'], outer_class=root_module['ns3::Simulator'], import_from_module='ns.core')
    ## ff-mac-common.h (module 'lte'): ns3::SpsConfig_s [struct]
    module.add_class('SpsConfig_s', import_from_module='ns.lte')
    ## ff-mac-common.h (module 'lte'): ns3::SrConfig_s [struct]
    module.add_class('SrConfig_s', import_from_module='ns.lte')
    ## ff-mac-common.h (module 'lte'): ns3::SrListElement_s [struct]
    module.add_class('SrListElement_s', import_from_module='ns.lte')
    ## data-calculator.h (module 'stats'): ns3::StatisticalSummary [class]
    module.add_class('StatisticalSummary', allow_subclassing=True, import_from_module='ns.stats')
    ## tag.h (module 'network'): ns3::Tag [class]
    module.add_class('Tag', import_from_module='ns.network', parent=root_module['ns3::ObjectBase'])
    ## tag-buffer.h (module 'network'): ns3::TagBuffer [class]
    module.add_class('TagBuffer', import_from_module='ns.network')
    ## lte-spectrum-phy.h (module 'lte'): ns3::TbId_t [struct]
    module.add_class('TbId_t', import_from_module='ns.lte')
    ## nstime.h (module 'core'): ns3::TimeWithUnit [class]
    module.add_class('TimeWithUnit', import_from_module='ns.core')
    ## traced-value.h (module 'core'): ns3::TracedValue<bool> [class]
    module.add_class('TracedValue', import_from_module='ns.core', template_parameters=['bool'])
    ## traced-value.h (module 'core'): ns3::TracedValue<unsigned int> [class]
    module.add_class('TracedValue', import_from_module='ns.core', template_parameters=['unsigned int'])
    ## lte-common.h (module 'lte'): ns3::TransmissionModesLayers [class]
    module.add_class('TransmissionModesLayers', import_from_module='ns.lte')
    ## type-id.h (module 'core'): ns3::TypeId [class]
    module.add_class('TypeId', import_from_module='ns.core')
    ## type-id.h (module 'core'): ns3::TypeId::AttributeFlag [enumeration]
    module.add_enum('AttributeFlag', ['ATTR_GET', 'ATTR_SET', 'ATTR_CONSTRUCT', 'ATTR_SGC'], outer_class=root_module['ns3::TypeId'], import_from_module='ns.core')
    ## type-id.h (module 'core'): ns3::TypeId::SupportLevel [enumeration]
    module.add_enum('SupportLevel', ['SUPPORTED', 'DEPRECATED', 'OBSOLETE'], outer_class=root_module['ns3::TypeId'], import_from_module='ns.core')
    ## type-id.h (module 'core'): ns3::TypeId::AttributeInformation [struct]
    module.add_class('AttributeInformation', import_from_module='ns.core', outer_class=root_module['ns3::TypeId'])
    ## type-id.h (module 'core'): ns3::TypeId::TraceSourceInformation [struct]
    module.add_class('TraceSourceInformation', import_from_module='ns.core', outer_class=root_module['ns3::TypeId'])
    typehandlers.add_type_alias(u'uint32_t', u'ns3::TypeId::hash_t')
    typehandlers.add_type_alias(u'uint32_t*', u'ns3::TypeId::hash_t*')
    typehandlers.add_type_alias(u'uint32_t&', u'ns3::TypeId::hash_t&')
    ## ff-mac-common.h (module 'lte'): ns3::UeCapabilities_s [struct]
    module.add_class('UeCapabilities_s', import_from_module='ns.lte')
    ## ff-mac-common.h (module 'lte'): ns3::UeSelected_s [struct]
    module.add_class('UeSelected_s', import_from_module='ns.lte')
    ## ff-mac-common.h (module 'lte'): ns3::UlCqi_s [struct]
    module.add_class('UlCqi_s', import_from_module='ns.lte')
    ## ff-mac-common.h (module 'lte'): ns3::UlCqi_s::Type_e [enumeration]
    module.add_enum('Type_e', ['SRS', 'PUSCH', 'PUCCH_1', 'PUCCH_2', 'PRACH'], outer_class=root_module['ns3::UlCqi_s'], import_from_module='ns.lte')
    ## ff-mac-common.h (module 'lte'): ns3::UlDciListElement_s [struct]
    module.add_class('UlDciListElement_s', import_from_module='ns.lte')
    ## ff-mac-common.h (module 'lte'): ns3::UlGrant_s [struct]
    module.add_class('UlGrant_s', import_from_module='ns.lte')
    ## ff-mac-common.h (module 'lte'): ns3::UlInfoListElement_s [struct]
    module.add_class('UlInfoListElement_s', import_from_module='ns.lte')
    ## ff-mac-common.h (module 'lte'): ns3::UlInfoListElement_s::ReceptionStatus_e [enumeration]
    module.add_enum('ReceptionStatus_e', ['Ok', 'NotOk', 'NotValid'], outer_class=root_module['ns3::UlInfoListElement_s'], import_from_module='ns.lte')
    ## vector.h (module 'core'): ns3::Vector2D [class]
    module.add_class('Vector2D', import_from_module='ns.core')
    ## vector.h (module 'core'): ns3::Vector3D [class]
    module.add_class('Vector3D', import_from_module='ns.core')
    ## ff-mac-common.h (module 'lte'): ns3::VendorSpecificListElement_s [struct]
    module.add_class('VendorSpecificListElement_s', import_from_module='ns.lte')
    ## empty.h (module 'core'): ns3::empty [class]
    module.add_class('empty', import_from_module='ns.core')
    ## int64x64-128.h (module 'core'): ns3::int64x64_t [class]
    module.add_class('int64x64_t', import_from_module='ns.core')
    ## int64x64-128.h (module 'core'): ns3::int64x64_t::impl_type [enumeration]
    module.add_enum('impl_type', ['int128_impl', 'cairo_impl', 'ld_impl'], outer_class=root_module['ns3::int64x64_t'], import_from_module='ns.core')
    ## lte-spectrum-phy.h (module 'lte'): ns3::tbInfo_t [struct]
    module.add_class('tbInfo_t', import_from_module='ns.lte')
    ## chunk.h (module 'network'): ns3::Chunk [class]
    module.add_class('Chunk', import_from_module='ns.network', parent=root_module['ns3::ObjectBase'])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2PdcpProvider [class]
    module.add_class('EpcX2PdcpProvider', import_from_module='ns.lte', parent=root_module['ns3::EpcX2Sap'])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2PdcpUser [class]
    module.add_class('EpcX2PdcpUser', import_from_module='ns.lte', parent=root_module['ns3::EpcX2Sap'])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2RlcProvider [class]
    module.add_class('EpcX2RlcProvider', import_from_module='ns.lte', parent=root_module['ns3::EpcX2Sap'])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2RlcUser [class]
    module.add_class('EpcX2RlcUser', import_from_module='ns.lte', parent=root_module['ns3::EpcX2Sap'])
    ## header.h (module 'network'): ns3::Header [class]
    module.add_class('Header', import_from_module='ns.network', parent=root_module['ns3::Chunk'])
    ## lte-ccm-mac-sap.h (module 'lte'): ns3::LteCcmMacSapUser [class]
    module.add_class('LteCcmMacSapUser', import_from_module='ns.lte', parent=root_module['ns3::LteMacSapUser'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteEnbRrcSapProvider [class]
    module.add_class('LteEnbRrcSapProvider', import_from_module='ns.lte', parent=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteEnbRrcSapProvider::CompleteSetupUeParameters [struct]
    module.add_class('CompleteSetupUeParameters', import_from_module='ns.lte', outer_class=root_module['ns3::LteEnbRrcSapProvider'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteEnbRrcSapUser [class]
    module.add_class('LteEnbRrcSapUser', import_from_module='ns.lte', parent=root_module['ns3::LteRrcSap'])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteEnbRrcSapUser::SetupUeParameters [struct]
    module.add_class('SetupUeParameters', import_from_module='ns.lte', outer_class=root_module['ns3::LteEnbRrcSapUser'])
    ## lte-pdcp-header.h (module 'lte'): ns3::LtePdcpHeader [class]
    module.add_class('LtePdcpHeader', import_from_module='ns.lte', parent=root_module['ns3::Header'])
    ## lte-pdcp-header.h (module 'lte'): ns3::LtePdcpHeader [enumeration]
    module.add_enum('', ['CONTROL_PDU', 'DATA_PDU'], outer_class=root_module['ns3::LtePdcpHeader'], import_from_module='ns.lte')
    ## lte-radio-bearer-tag.h (module 'lte'): ns3::LteRadioBearerTag [class]
    module.add_class('LteRadioBearerTag', import_from_module='ns.lte', parent=root_module['ns3::Tag'])
    ## object.h (module 'core'): ns3::Object [class]
    module.add_class('Object', import_from_module='ns.core', parent=root_module['ns3::SimpleRefCount< ns3::Object, ns3::ObjectBase, ns3::ObjectDeleter >'])
    ## object.h (module 'core'): ns3::Object::AggregateIterator [class]
    module.add_class('AggregateIterator', import_from_module='ns.core', outer_class=root_module['ns3::Object'])
    ## packet-burst.h (module 'network'): ns3::PacketBurst [class]
    module.add_class('PacketBurst', import_from_module='ns.network', parent=root_module['ns3::Object'])
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Ptr< ns3::PacketBurst const > )', u'ns3::PacketBurst::TracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Ptr< ns3::PacketBurst const > )*', u'ns3::PacketBurst::TracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Ptr< ns3::PacketBurst const > )&', u'ns3::PacketBurst::TracedCallback&')
    ## packet-filter.h (module 'traffic-control'): ns3::PacketFilter [class]
    module.add_class('PacketFilter', import_from_module='ns.traffic_control', parent=root_module['ns3::Object'])
    ## propagation-delay-model.h (module 'propagation'): ns3::PropagationDelayModel [class]
    module.add_class('PropagationDelayModel', import_from_module='ns.propagation', parent=root_module['ns3::Object'])
    ## propagation-loss-model.h (module 'propagation'): ns3::PropagationLossModel [class]
    module.add_class('PropagationLossModel', import_from_module='ns.propagation', parent=root_module['ns3::Object'])
    ## queue-disc.h (module 'traffic-control'): ns3::QueueDisc [class]
    module.add_class('QueueDisc', import_from_module='ns.traffic_control', parent=root_module['ns3::Object'])
    ## queue-disc.h (module 'traffic-control'): ns3::QueueDisc::WakeMode [enumeration]
    module.add_enum('WakeMode', ['WAKE_ROOT', 'WAKE_CHILD'], outer_class=root_module['ns3::QueueDisc'], import_from_module='ns.traffic-control')
    ## queue-disc.h (module 'traffic-control'): ns3::QueueDisc::Stats [struct]
    module.add_class('Stats', import_from_module='ns.traffic_control', outer_class=root_module['ns3::QueueDisc'])
    typehandlers.add_type_alias(u'ns3::Queue< ns3::QueueDiscItem >', u'ns3::QueueDisc::InternalQueue')
    typehandlers.add_type_alias(u'ns3::Queue< ns3::QueueDiscItem >*', u'ns3::QueueDisc::InternalQueue*')
    typehandlers.add_type_alias(u'ns3::Queue< ns3::QueueDiscItem >&', u'ns3::QueueDisc::InternalQueue&')
    ## queue-disc.h (module 'traffic-control'): ns3::QueueDiscClass [class]
    module.add_class('QueueDiscClass', import_from_module='ns.traffic_control', parent=root_module['ns3::Object'])
    ## propagation-delay-model.h (module 'propagation'): ns3::RandomPropagationDelayModel [class]
    module.add_class('RandomPropagationDelayModel', import_from_module='ns.propagation', parent=root_module['ns3::PropagationDelayModel'])
    ## propagation-loss-model.h (module 'propagation'): ns3::RandomPropagationLossModel [class]
    module.add_class('RandomPropagationLossModel', import_from_module='ns.propagation', parent=root_module['ns3::PropagationLossModel'])
    ## random-variable-stream.h (module 'core'): ns3::RandomVariableStream [class]
    module.add_class('RandomVariableStream', import_from_module='ns.core', parent=root_module['ns3::Object'])
    ## propagation-loss-model.h (module 'propagation'): ns3::RangePropagationLossModel [class]
    module.add_class('RangePropagationLossModel', import_from_module='ns.propagation', parent=root_module['ns3::PropagationLossModel'])
    ## lte-radio-bearer-info.h (module 'lte'): ns3::RlcBearerInfo [class]
    module.add_class('RlcBearerInfo', import_from_module='ns.lte', parent=root_module['ns3::Object'])
    ## random-variable-stream.h (module 'core'): ns3::SequentialRandomVariable [class]
    module.add_class('SequentialRandomVariable', import_from_module='ns.core', parent=root_module['ns3::RandomVariableStream'])
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::AttributeAccessor, ns3::empty, ns3::DefaultDeleter<ns3::AttributeAccessor> > [class]
    module.add_class('SimpleRefCount', automatic_type_narrowing=True, import_from_module='ns.core', template_parameters=['ns3::AttributeAccessor', 'ns3::empty', 'ns3::DefaultDeleter<ns3::AttributeAccessor>'], parent=root_module['ns3::empty'], memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'))
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::AttributeChecker, ns3::empty, ns3::DefaultDeleter<ns3::AttributeChecker> > [class]
    module.add_class('SimpleRefCount', automatic_type_narrowing=True, import_from_module='ns.core', template_parameters=['ns3::AttributeChecker', 'ns3::empty', 'ns3::DefaultDeleter<ns3::AttributeChecker>'], parent=root_module['ns3::empty'], memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'))
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::AttributeValue, ns3::empty, ns3::DefaultDeleter<ns3::AttributeValue> > [class]
    module.add_class('SimpleRefCount', automatic_type_narrowing=True, import_from_module='ns.core', template_parameters=['ns3::AttributeValue', 'ns3::empty', 'ns3::DefaultDeleter<ns3::AttributeValue>'], parent=root_module['ns3::empty'], memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'))
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::CallbackImplBase, ns3::empty, ns3::DefaultDeleter<ns3::CallbackImplBase> > [class]
    module.add_class('SimpleRefCount', automatic_type_narrowing=True, import_from_module='ns.core', template_parameters=['ns3::CallbackImplBase', 'ns3::empty', 'ns3::DefaultDeleter<ns3::CallbackImplBase>'], parent=root_module['ns3::empty'], memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'))
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::EpcTft, ns3::empty, ns3::DefaultDeleter<ns3::EpcTft> > [class]
    module.add_class('SimpleRefCount', automatic_type_narrowing=True, import_from_module='ns.core', template_parameters=['ns3::EpcTft', 'ns3::empty', 'ns3::DefaultDeleter<ns3::EpcTft>'], parent=root_module['ns3::empty'], memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'))
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::EpcTftClassifier, ns3::empty, ns3::DefaultDeleter<ns3::EpcTftClassifier> > [class]
    module.add_class('SimpleRefCount', automatic_type_narrowing=True, import_from_module='ns.core', template_parameters=['ns3::EpcTftClassifier', 'ns3::empty', 'ns3::DefaultDeleter<ns3::EpcTftClassifier>'], parent=root_module['ns3::empty'], memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'))
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::EventImpl, ns3::empty, ns3::DefaultDeleter<ns3::EventImpl> > [class]
    module.add_class('SimpleRefCount', automatic_type_narrowing=True, import_from_module='ns.core', template_parameters=['ns3::EventImpl', 'ns3::empty', 'ns3::DefaultDeleter<ns3::EventImpl>'], parent=root_module['ns3::empty'], memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'))
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::Hash::Implementation, ns3::empty, ns3::DefaultDeleter<ns3::Hash::Implementation> > [class]
    module.add_class('SimpleRefCount', automatic_type_narrowing=True, import_from_module='ns.core', template_parameters=['ns3::Hash::Implementation', 'ns3::empty', 'ns3::DefaultDeleter<ns3::Hash::Implementation>'], parent=root_module['ns3::empty'], memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'))
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::Ipv4MulticastRoute, ns3::empty, ns3::DefaultDeleter<ns3::Ipv4MulticastRoute> > [class]
    module.add_class('SimpleRefCount', automatic_type_narrowing=True, import_from_module='ns.core', template_parameters=['ns3::Ipv4MulticastRoute', 'ns3::empty', 'ns3::DefaultDeleter<ns3::Ipv4MulticastRoute>'], parent=root_module['ns3::empty'], memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'))
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::Ipv4Route, ns3::empty, ns3::DefaultDeleter<ns3::Ipv4Route> > [class]
    module.add_class('SimpleRefCount', automatic_type_narrowing=True, import_from_module='ns.core', template_parameters=['ns3::Ipv4Route', 'ns3::empty', 'ns3::DefaultDeleter<ns3::Ipv4Route>'], parent=root_module['ns3::empty'], memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'))
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::LteControlMessage, ns3::empty, ns3::DefaultDeleter<ns3::LteControlMessage> > [class]
    module.add_class('SimpleRefCount', automatic_type_narrowing=True, import_from_module='ns.core', template_parameters=['ns3::LteControlMessage', 'ns3::empty', 'ns3::DefaultDeleter<ns3::LteControlMessage>'], parent=root_module['ns3::empty'], memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'))
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::LteHarqPhy, ns3::empty, ns3::DefaultDeleter<ns3::LteHarqPhy> > [class]
    module.add_class('SimpleRefCount', automatic_type_narrowing=True, import_from_module='ns.core', template_parameters=['ns3::LteHarqPhy', 'ns3::empty', 'ns3::DefaultDeleter<ns3::LteHarqPhy>'], parent=root_module['ns3::empty'], memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'))
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::NixVector, ns3::empty, ns3::DefaultDeleter<ns3::NixVector> > [class]
    module.add_class('SimpleRefCount', automatic_type_narrowing=True, import_from_module='ns.core', template_parameters=['ns3::NixVector', 'ns3::empty', 'ns3::DefaultDeleter<ns3::NixVector>'], parent=root_module['ns3::empty'], memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'))
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::Packet, ns3::empty, ns3::DefaultDeleter<ns3::Packet> > [class]
    module.add_class('SimpleRefCount', automatic_type_narrowing=True, import_from_module='ns.core', template_parameters=['ns3::Packet', 'ns3::empty', 'ns3::DefaultDeleter<ns3::Packet>'], parent=root_module['ns3::empty'], memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'))
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::QueueItem, ns3::empty, ns3::DefaultDeleter<ns3::QueueItem> > [class]
    module.add_class('SimpleRefCount', automatic_type_narrowing=True, import_from_module='ns.core', template_parameters=['ns3::QueueItem', 'ns3::empty', 'ns3::DefaultDeleter<ns3::QueueItem>'], parent=root_module['ns3::empty'], memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'))
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::SpectrumModel, ns3::empty, ns3::DefaultDeleter<ns3::SpectrumModel> > [class]
    module.add_class('SimpleRefCount', automatic_type_narrowing=True, import_from_module='ns.core', template_parameters=['ns3::SpectrumModel', 'ns3::empty', 'ns3::DefaultDeleter<ns3::SpectrumModel>'], parent=root_module['ns3::empty'], memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'))
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::SpectrumSignalParameters, ns3::empty, ns3::DefaultDeleter<ns3::SpectrumSignalParameters> > [class]
    module.add_class('SimpleRefCount', automatic_type_narrowing=True, import_from_module='ns.core', template_parameters=['ns3::SpectrumSignalParameters', 'ns3::empty', 'ns3::DefaultDeleter<ns3::SpectrumSignalParameters>'], parent=root_module['ns3::empty'], memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'))
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::SpectrumValue, ns3::empty, ns3::DefaultDeleter<ns3::SpectrumValue> > [class]
    module.add_class('SimpleRefCount', automatic_type_narrowing=True, import_from_module='ns.core', template_parameters=['ns3::SpectrumValue', 'ns3::empty', 'ns3::DefaultDeleter<ns3::SpectrumValue>'], parent=root_module['ns3::empty'], memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'))
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::TraceSourceAccessor, ns3::empty, ns3::DefaultDeleter<ns3::TraceSourceAccessor> > [class]
    module.add_class('SimpleRefCount', automatic_type_narrowing=True, import_from_module='ns.core', template_parameters=['ns3::TraceSourceAccessor', 'ns3::empty', 'ns3::DefaultDeleter<ns3::TraceSourceAccessor>'], parent=root_module['ns3::empty'], memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'))
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::VendorSpecificValue, ns3::empty, ns3::DefaultDeleter<ns3::VendorSpecificValue> > [class]
    module.add_class('SimpleRefCount', automatic_type_narrowing=True, import_from_module='ns.core', template_parameters=['ns3::VendorSpecificValue', 'ns3::empty', 'ns3::DefaultDeleter<ns3::VendorSpecificValue>'], parent=root_module['ns3::empty'], memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'))
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::mmwave::BeamformingParams, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::BeamformingParams> > [class]
    module.add_class('SimpleRefCount', automatic_type_narrowing=True, template_parameters=['ns3::mmwave::BeamformingParams', 'ns3::empty', 'ns3::DefaultDeleter<ns3::mmwave::BeamformingParams>'], parent=root_module['ns3::empty'], memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'))
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::mmwave::ChannelParams, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::ChannelParams> > [class]
    module.add_class('SimpleRefCount', automatic_type_narrowing=True, template_parameters=['ns3::mmwave::ChannelParams', 'ns3::empty', 'ns3::DefaultDeleter<ns3::mmwave::ChannelParams>'], parent=root_module['ns3::empty'], memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'))
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::mmwave::MmWaveControlMessage, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::MmWaveControlMessage> > [class]
    module.add_class('SimpleRefCount', automatic_type_narrowing=True, template_parameters=['ns3::mmwave::MmWaveControlMessage', 'ns3::empty', 'ns3::DefaultDeleter<ns3::mmwave::MmWaveControlMessage>'], parent=root_module['ns3::empty'], memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'))
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::mmwave::MmWaveHarqPhy, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::MmWaveHarqPhy> > [class]
    module.add_class('SimpleRefCount', automatic_type_narrowing=True, template_parameters=['ns3::mmwave::MmWaveHarqPhy', 'ns3::empty', 'ns3::DefaultDeleter<ns3::mmwave::MmWaveHarqPhy>'], parent=root_module['ns3::empty'], memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'))
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::mmwave::Params3gpp, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::Params3gpp> > [class]
    module.add_class('SimpleRefCount', automatic_type_narrowing=True, template_parameters=['ns3::mmwave::Params3gpp', 'ns3::empty', 'ns3::DefaultDeleter<ns3::mmwave::Params3gpp>'], parent=root_module['ns3::empty'], memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'))
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::mmwave::TraceParams, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::TraceParams> > [class]
    module.add_class('SimpleRefCount', automatic_type_narrowing=True, template_parameters=['ns3::mmwave::TraceParams', 'ns3::empty', 'ns3::DefaultDeleter<ns3::mmwave::TraceParams>'], parent=root_module['ns3::empty'], memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'))
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::mmwave::channelMatrix, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::channelMatrix> > [class]
    module.add_class('SimpleRefCount', automatic_type_narrowing=True, template_parameters=['ns3::mmwave::channelMatrix', 'ns3::empty', 'ns3::DefaultDeleter<ns3::mmwave::channelMatrix>'], parent=root_module['ns3::empty'], memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'))
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::mmwave::mmWaveBeamFormingParams, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::mmWaveBeamFormingParams> > [class]
    module.add_class('SimpleRefCount', automatic_type_narrowing=True, template_parameters=['ns3::mmwave::mmWaveBeamFormingParams', 'ns3::empty', 'ns3::DefaultDeleter<ns3::mmwave::mmWaveBeamFormingParams>'], parent=root_module['ns3::empty'], memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'))
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::mmwave::mmWaveBeamFormingTraces, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::mmWaveBeamFormingTraces> > [class]
    module.add_class('SimpleRefCount', automatic_type_narrowing=True, template_parameters=['ns3::mmwave::mmWaveBeamFormingTraces', 'ns3::empty', 'ns3::DefaultDeleter<ns3::mmwave::mmWaveBeamFormingTraces>'], parent=root_module['ns3::empty'], memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'))
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::mmwave::mmWaveChunkProcessor, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::mmWaveChunkProcessor> > [class]
    module.add_class('SimpleRefCount', automatic_type_narrowing=True, template_parameters=['ns3::mmwave::mmWaveChunkProcessor', 'ns3::empty', 'ns3::DefaultDeleter<ns3::mmwave::mmWaveChunkProcessor>'], parent=root_module['ns3::empty'], memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'))
    ## socket.h (module 'network'): ns3::Socket [class]
    module.add_class('Socket', import_from_module='ns.network', parent=root_module['ns3::Object'])
    ## socket.h (module 'network'): ns3::Socket::SocketErrno [enumeration]
    module.add_enum('SocketErrno', ['ERROR_NOTERROR', 'ERROR_ISCONN', 'ERROR_NOTCONN', 'ERROR_MSGSIZE', 'ERROR_AGAIN', 'ERROR_SHUTDOWN', 'ERROR_OPNOTSUPP', 'ERROR_AFNOSUPPORT', 'ERROR_INVAL', 'ERROR_BADF', 'ERROR_NOROUTETOHOST', 'ERROR_NODEV', 'ERROR_ADDRNOTAVAIL', 'ERROR_ADDRINUSE', 'SOCKET_ERRNO_LAST'], outer_class=root_module['ns3::Socket'], import_from_module='ns.network')
    ## socket.h (module 'network'): ns3::Socket::SocketType [enumeration]
    module.add_enum('SocketType', ['NS3_SOCK_STREAM', 'NS3_SOCK_SEQPACKET', 'NS3_SOCK_DGRAM', 'NS3_SOCK_RAW'], outer_class=root_module['ns3::Socket'], import_from_module='ns.network')
    ## socket.h (module 'network'): ns3::Socket::SocketPriority [enumeration]
    module.add_enum('SocketPriority', ['NS3_PRIO_BESTEFFORT', 'NS3_PRIO_FILLER', 'NS3_PRIO_BULK', 'NS3_PRIO_INTERACTIVE_BULK', 'NS3_PRIO_INTERACTIVE', 'NS3_PRIO_CONTROL'], outer_class=root_module['ns3::Socket'], import_from_module='ns.network')
    ## socket.h (module 'network'): ns3::Socket::Ipv6MulticastFilterMode [enumeration]
    module.add_enum('Ipv6MulticastFilterMode', ['INCLUDE', 'EXCLUDE'], outer_class=root_module['ns3::Socket'], import_from_module='ns.network')
    ## socket.h (module 'network'): ns3::SocketIpTosTag [class]
    module.add_class('SocketIpTosTag', import_from_module='ns.network', parent=root_module['ns3::Tag'])
    ## socket.h (module 'network'): ns3::SocketIpTtlTag [class]
    module.add_class('SocketIpTtlTag', import_from_module='ns.network', parent=root_module['ns3::Tag'])
    ## socket.h (module 'network'): ns3::SocketIpv6HopLimitTag [class]
    module.add_class('SocketIpv6HopLimitTag', import_from_module='ns.network', parent=root_module['ns3::Tag'])
    ## socket.h (module 'network'): ns3::SocketIpv6TclassTag [class]
    module.add_class('SocketIpv6TclassTag', import_from_module='ns.network', parent=root_module['ns3::Tag'])
    ## socket.h (module 'network'): ns3::SocketPriorityTag [class]
    module.add_class('SocketPriorityTag', import_from_module='ns.network', parent=root_module['ns3::Tag'])
    ## socket.h (module 'network'): ns3::SocketSetDontFragmentTag [class]
    module.add_class('SocketSetDontFragmentTag', import_from_module='ns.network', parent=root_module['ns3::Tag'])
    ## spectrum-interference.h (module 'spectrum'): ns3::SpectrumInterference [class]
    module.add_class('SpectrumInterference', import_from_module='ns.spectrum', parent=root_module['ns3::Object'])
    ## spectrum-model.h (module 'spectrum'): ns3::SpectrumModel [class]
    module.add_class('SpectrumModel', import_from_module='ns.spectrum', parent=root_module['ns3::SimpleRefCount< ns3::SpectrumModel, ns3::empty, ns3::DefaultDeleter<ns3::SpectrumModel> >'])
    ## spectrum-phy.h (module 'spectrum'): ns3::SpectrumPhy [class]
    module.add_class('SpectrumPhy', import_from_module='ns.spectrum', parent=root_module['ns3::Object'])
    ## spectrum-propagation-loss-model.h (module 'spectrum'): ns3::SpectrumPropagationLossModel [class]
    module.add_class('SpectrumPropagationLossModel', import_from_module='ns.spectrum', parent=root_module['ns3::Object'])
    ## spectrum-signal-parameters.h (module 'spectrum'): ns3::SpectrumSignalParameters [struct]
    module.add_class('SpectrumSignalParameters', import_from_module='ns.spectrum', parent=root_module['ns3::SimpleRefCount< ns3::SpectrumSignalParameters, ns3::empty, ns3::DefaultDeleter<ns3::SpectrumSignalParameters> >'])
    ## spectrum-value.h (module 'spectrum'): ns3::SpectrumValue [class]
    module.add_class('SpectrumValue', import_from_module='ns.spectrum', parent=root_module['ns3::SimpleRefCount< ns3::SpectrumValue, ns3::empty, ns3::DefaultDeleter<ns3::SpectrumValue> >'])
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Ptr< ns3::SpectrumValue > )', u'ns3::SpectrumValue::TracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Ptr< ns3::SpectrumValue > )*', u'ns3::SpectrumValue::TracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Ptr< ns3::SpectrumValue > )&', u'ns3::SpectrumValue::TracedCallback&')
    ## propagation-loss-model.h (module 'propagation'): ns3::ThreeLogDistancePropagationLossModel [class]
    module.add_class('ThreeLogDistancePropagationLossModel', import_from_module='ns.propagation', parent=root_module['ns3::PropagationLossModel'])
    ## nstime.h (module 'core'): ns3::Time [class]
    module.add_class('Time', import_from_module='ns.core')
    ## nstime.h (module 'core'): ns3::Time::Unit [enumeration]
    module.add_enum('Unit', ['Y', 'D', 'H', 'MIN', 'S', 'MS', 'US', 'NS', 'PS', 'FS', 'LAST'], outer_class=root_module['ns3::Time'], import_from_module='ns.core')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Time )', u'ns3::Time::TracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Time )*', u'ns3::Time::TracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Time )&', u'ns3::Time::TracedCallback&')
    ## nstime.h (module 'core'): ns3::Time [class]
    root_module['ns3::Time'].implicitly_converts_to(root_module['ns3::int64x64_t'])
    ## trace-source-accessor.h (module 'core'): ns3::TraceSourceAccessor [class]
    module.add_class('TraceSourceAccessor', import_from_module='ns.core', parent=root_module['ns3::SimpleRefCount< ns3::TraceSourceAccessor, ns3::empty, ns3::DefaultDeleter<ns3::TraceSourceAccessor> >'])
    ## trailer.h (module 'network'): ns3::Trailer [class]
    module.add_class('Trailer', import_from_module='ns.network', parent=root_module['ns3::Chunk'])
    ## random-variable-stream.h (module 'core'): ns3::TriangularRandomVariable [class]
    module.add_class('TriangularRandomVariable', import_from_module='ns.core', parent=root_module['ns3::RandomVariableStream'])
    ## propagation-loss-model.h (module 'propagation'): ns3::TwoRayGroundPropagationLossModel [class]
    module.add_class('TwoRayGroundPropagationLossModel', import_from_module='ns.propagation', parent=root_module['ns3::PropagationLossModel'])
    ## lte-enb-rrc.h (module 'lte'): ns3::UeManager [class]
    module.add_class('UeManager', import_from_module='ns.lte', parent=root_module['ns3::Object'])
    ## lte-enb-rrc.h (module 'lte'): ns3::UeManager::State [enumeration]
    module.add_enum('State', ['INITIAL_RANDOM_ACCESS', 'CONNECTION_SETUP', 'CONNECTION_REJECTED', 'CONNECTED_NORMALLY', 'CONNECTION_RECONFIGURATION', 'CONNECTION_REESTABLISHMENT', 'HANDOVER_PREPARATION', 'HANDOVER_JOINING', 'HANDOVER_PATH_SWITCH', 'HANDOVER_LEAVING', 'PREPARE_MC_CONNECTION_RECONFIGURATION', 'MC_CONNECTION_RECONFIGURATION', 'NUM_STATES'], outer_class=root_module['ns3::UeManager'], import_from_module='ns.lte')
    typehandlers.add_type_alias(u'void ( * ) ( uint64_t const, uint16_t const, uint16_t const, ns3::UeManager::State const, ns3::UeManager::State const )', u'ns3::UeManager::StateTracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( uint64_t const, uint16_t const, uint16_t const, ns3::UeManager::State const, ns3::UeManager::State const )*', u'ns3::UeManager::StateTracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( uint64_t const, uint16_t const, uint16_t const, ns3::UeManager::State const, ns3::UeManager::State const )&', u'ns3::UeManager::StateTracedCallback&')
    typehandlers.add_type_alias(u'void ( * ) ( uint64_t, uint16_t, uint16_t )', u'ns3::UeManager::ImsiCidRntiTracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( uint64_t, uint16_t, uint16_t )*', u'ns3::UeManager::ImsiCidRntiTracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( uint64_t, uint16_t, uint16_t )&', u'ns3::UeManager::ImsiCidRntiTracedCallback&')
    ## random-variable-stream.h (module 'core'): ns3::UniformRandomVariable [class]
    module.add_class('UniformRandomVariable', import_from_module='ns.core', parent=root_module['ns3::RandomVariableStream'])
    ## ff-mac-common.h (module 'lte'): ns3::VendorSpecificValue [struct]
    module.add_class('VendorSpecificValue', import_from_module='ns.lte', parent=root_module['ns3::SimpleRefCount< ns3::VendorSpecificValue, ns3::empty, ns3::DefaultDeleter<ns3::VendorSpecificValue> >'])
    ## random-variable-stream.h (module 'core'): ns3::WeibullRandomVariable [class]
    module.add_class('WeibullRandomVariable', import_from_module='ns.core', parent=root_module['ns3::RandomVariableStream'])
    ## random-variable-stream.h (module 'core'): ns3::ZetaRandomVariable [class]
    module.add_class('ZetaRandomVariable', import_from_module='ns.core', parent=root_module['ns3::RandomVariableStream'])
    ## random-variable-stream.h (module 'core'): ns3::ZipfRandomVariable [class]
    module.add_class('ZipfRandomVariable', import_from_module='ns.core', parent=root_module['ns3::RandomVariableStream'])
    ## antenna-model.h (module 'antenna'): ns3::AntennaModel [class]
    module.add_class('AntennaModel', import_from_module='ns.antenna', parent=root_module['ns3::Object'])
    ## lte-asn1-header.h (module 'lte'): ns3::Asn1Header [class]
    module.add_class('Asn1Header', import_from_module='ns.lte', parent=root_module['ns3::Header'])
    ## attribute.h (module 'core'): ns3::AttributeAccessor [class]
    module.add_class('AttributeAccessor', import_from_module='ns.core', parent=root_module['ns3::SimpleRefCount< ns3::AttributeAccessor, ns3::empty, ns3::DefaultDeleter<ns3::AttributeAccessor> >'])
    ## attribute.h (module 'core'): ns3::AttributeChecker [class]
    module.add_class('AttributeChecker', allow_subclassing=False, automatic_type_narrowing=True, import_from_module='ns.core', parent=root_module['ns3::SimpleRefCount< ns3::AttributeChecker, ns3::empty, ns3::DefaultDeleter<ns3::AttributeChecker> >'])
    ## attribute.h (module 'core'): ns3::AttributeValue [class]
    module.add_class('AttributeValue', allow_subclassing=False, automatic_type_narrowing=True, import_from_module='ns.core', parent=root_module['ns3::SimpleRefCount< ns3::AttributeValue, ns3::empty, ns3::DefaultDeleter<ns3::AttributeValue> >'])
    ## boolean.h (module 'core'): ns3::BooleanChecker [class]
    module.add_class('BooleanChecker', import_from_module='ns.core', parent=root_module['ns3::AttributeChecker'])
    ## boolean.h (module 'core'): ns3::BooleanValue [class]
    module.add_class('BooleanValue', import_from_module='ns.core', parent=root_module['ns3::AttributeValue'])
    ## box.h (module 'mobility'): ns3::BoxChecker [class]
    module.add_class('BoxChecker', import_from_module='ns.mobility', parent=root_module['ns3::AttributeChecker'])
    ## box.h (module 'mobility'): ns3::BoxValue [class]
    module.add_class('BoxValue', import_from_module='ns.mobility', parent=root_module['ns3::AttributeValue'])
    ## building.h (module 'buildings'): ns3::Building [class]
    module.add_class('Building', import_from_module='ns.buildings', parent=root_module['ns3::Object'])
    ## building.h (module 'buildings'): ns3::Building::BuildingType_t [enumeration]
    module.add_enum('BuildingType_t', ['Residential', 'Office', 'Commercial'], outer_class=root_module['ns3::Building'], import_from_module='ns.buildings')
    ## building.h (module 'buildings'): ns3::Building::ExtWallsType_t [enumeration]
    module.add_enum('ExtWallsType_t', ['Wood', 'ConcreteWithWindows', 'ConcreteWithoutWindows', 'StoneBlocks'], outer_class=root_module['ns3::Building'], import_from_module='ns.buildings')
    ## buildings-propagation-loss-model.h (module 'buildings'): ns3::BuildingsPropagationLossModel [class]
    module.add_class('BuildingsPropagationLossModel', import_from_module='ns.buildings', parent=root_module['ns3::PropagationLossModel'])
    ## callback.h (module 'core'): ns3::CallbackChecker [class]
    module.add_class('CallbackChecker', import_from_module='ns.core', parent=root_module['ns3::AttributeChecker'])
    ## callback.h (module 'core'): ns3::CallbackImplBase [class]
    module.add_class('CallbackImplBase', import_from_module='ns.core', parent=root_module['ns3::SimpleRefCount< ns3::CallbackImplBase, ns3::empty, ns3::DefaultDeleter<ns3::CallbackImplBase> >'])
    ## callback.h (module 'core'): ns3::CallbackValue [class]
    module.add_class('CallbackValue', import_from_module='ns.core', parent=root_module['ns3::AttributeValue'])
    ## channel.h (module 'network'): ns3::Channel [class]
    module.add_class('Channel', import_from_module='ns.network', parent=root_module['ns3::Object'])
    ## codel-queue-disc.h (module 'traffic-control'): ns3::CoDelQueueDisc [class]
    module.add_class('CoDelQueueDisc', import_from_module='ns.traffic_control', parent=root_module['ns3::QueueDisc'])
    ## component-carrier.h (module 'lte'): ns3::ComponentCarrier [class]
    module.add_class('ComponentCarrier', import_from_module='ns.lte', parent=root_module['ns3::Object'])
    ## component-carrier-enb.h (module 'lte'): ns3::ComponentCarrierEnb [class]
    module.add_class('ComponentCarrierEnb', import_from_module='ns.lte', parent=root_module['ns3::ComponentCarrier'])
    ## component-carrier-ue.h (module 'lte'): ns3::ComponentCarrierUe [class]
    module.add_class('ComponentCarrierUe', import_from_module='ns.lte', parent=root_module['ns3::ComponentCarrier'])
    ## random-variable-stream.h (module 'core'): ns3::ConstantRandomVariable [class]
    module.add_class('ConstantRandomVariable', import_from_module='ns.core', parent=root_module['ns3::RandomVariableStream'])
    ## propagation-delay-model.h (module 'propagation'): ns3::ConstantSpeedPropagationDelayModel [class]
    module.add_class('ConstantSpeedPropagationDelayModel', import_from_module='ns.propagation', parent=root_module['ns3::PropagationDelayModel'])
    ## data-calculator.h (module 'stats'): ns3::DataCalculator [class]
    module.add_class('DataCalculator', import_from_module='ns.stats', parent=root_module['ns3::Object'])
    ## data-output-interface.h (module 'stats'): ns3::DataOutputInterface [class]
    module.add_class('DataOutputInterface', import_from_module='ns.stats', parent=root_module['ns3::Object'])
    ## data-rate.h (module 'network'): ns3::DataRateChecker [class]
    module.add_class('DataRateChecker', import_from_module='ns.network', parent=root_module['ns3::AttributeChecker'])
    ## data-rate.h (module 'network'): ns3::DataRateValue [class]
    module.add_class('DataRateValue', import_from_module='ns.network', parent=root_module['ns3::AttributeValue'])
    ## random-variable-stream.h (module 'core'): ns3::DeterministicRandomVariable [class]
    module.add_class('DeterministicRandomVariable', import_from_module='ns.core', parent=root_module['ns3::RandomVariableStream'])
    ## double.h (module 'core'): ns3::DoubleValue [class]
    module.add_class('DoubleValue', import_from_module='ns.core', parent=root_module['ns3::AttributeValue'])
    ## random-variable-stream.h (module 'core'): ns3::EmpiricalRandomVariable [class]
    module.add_class('EmpiricalRandomVariable', import_from_module='ns.core', parent=root_module['ns3::RandomVariableStream'])
    ## attribute.h (module 'core'): ns3::EmptyAttributeAccessor [class]
    module.add_class('EmptyAttributeAccessor', import_from_module='ns.core', parent=root_module['ns3::AttributeAccessor'])
    ## attribute.h (module 'core'): ns3::EmptyAttributeChecker [class]
    module.add_class('EmptyAttributeChecker', import_from_module='ns.core', parent=root_module['ns3::AttributeChecker'])
    ## attribute.h (module 'core'): ns3::EmptyAttributeValue [class]
    module.add_class('EmptyAttributeValue', import_from_module='ns.core', parent=root_module['ns3::AttributeValue'])
    ## enum.h (module 'core'): ns3::EnumChecker [class]
    module.add_class('EnumChecker', import_from_module='ns.core', parent=root_module['ns3::AttributeChecker'])
    ## enum.h (module 'core'): ns3::EnumValue [class]
    module.add_class('EnumValue', import_from_module='ns.core', parent=root_module['ns3::AttributeValue'])
    ## epc-helper.h (module 'lte'): ns3::EpcHelper [class]
    module.add_class('EpcHelper', import_from_module='ns.lte', parent=root_module['ns3::Object'])
    ## epc-tft.h (module 'lte'): ns3::EpcTft [class]
    module.add_class('EpcTft', import_from_module='ns.lte', parent=root_module['ns3::SimpleRefCount< ns3::EpcTft, ns3::empty, ns3::DefaultDeleter<ns3::EpcTft> >'])
    ## epc-tft.h (module 'lte'): ns3::EpcTft::Direction [enumeration]
    module.add_enum('Direction', ['DOWNLINK', 'UPLINK', 'BIDIRECTIONAL'], outer_class=root_module['ns3::EpcTft'], import_from_module='ns.lte')
    ## epc-tft.h (module 'lte'): ns3::EpcTft::PacketFilter [struct]
    module.add_class('PacketFilter', import_from_module='ns.lte', outer_class=root_module['ns3::EpcTft'])
    ## epc-tft-classifier.h (module 'lte'): ns3::EpcTftClassifier [class]
    module.add_class('EpcTftClassifier', import_from_module='ns.lte', parent=root_module['ns3::SimpleRefCount< ns3::EpcTftClassifier, ns3::empty, ns3::DefaultDeleter<ns3::EpcTftClassifier> >'])
    ## epc-ue-nas.h (module 'lte'): ns3::EpcUeNas [class]
    module.add_class('EpcUeNas', import_from_module='ns.lte', parent=root_module['ns3::Object'])
    ## epc-ue-nas.h (module 'lte'): ns3::EpcUeNas::State [enumeration]
    module.add_enum('State', ['OFF', 'ATTACHING', 'IDLE_REGISTERED', 'CONNECTING_TO_EPC', 'ACTIVE', 'NUM_STATES'], outer_class=root_module['ns3::EpcUeNas'], import_from_module='ns.lte')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::EpcUeNas::State const, ns3::EpcUeNas::State const )', u'ns3::EpcUeNas::StateTracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::EpcUeNas::State const, ns3::EpcUeNas::State const )*', u'ns3::EpcUeNas::StateTracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::EpcUeNas::State const, ns3::EpcUeNas::State const )&', u'ns3::EpcUeNas::StateTracedCallback&')
    ## random-variable-stream.h (module 'core'): ns3::ErlangRandomVariable [class]
    module.add_class('ErlangRandomVariable', import_from_module='ns.core', parent=root_module['ns3::RandomVariableStream'])
    ## event-impl.h (module 'core'): ns3::EventImpl [class]
    module.add_class('EventImpl', import_from_module='ns.core', parent=root_module['ns3::SimpleRefCount< ns3::EventImpl, ns3::empty, ns3::DefaultDeleter<ns3::EventImpl> >'])
    ## random-variable-stream.h (module 'core'): ns3::ExponentialRandomVariable [class]
    module.add_class('ExponentialRandomVariable', import_from_module='ns.core', parent=root_module['ns3::RandomVariableStream'])
    ## ff-mac-scheduler.h (module 'lte'): ns3::FfMacScheduler [class]
    module.add_class('FfMacScheduler', import_from_module='ns.lte', parent=root_module['ns3::Object'])
    ## ff-mac-scheduler.h (module 'lte'): ns3::FfMacScheduler::UlCqiFilter_t [enumeration]
    module.add_enum('UlCqiFilter_t', ['SRS_UL_CQI', 'PUSCH_UL_CQI', 'ALL_UL_CQI'], outer_class=root_module['ns3::FfMacScheduler'], import_from_module='ns.lte')
    ## propagation-loss-model.h (module 'propagation'): ns3::FixedRssLossModel [class]
    module.add_class('FixedRssLossModel', import_from_module='ns.propagation', parent=root_module['ns3::PropagationLossModel'])
    ## propagation-loss-model.h (module 'propagation'): ns3::FriisPropagationLossModel [class]
    module.add_class('FriisPropagationLossModel', import_from_module='ns.propagation', parent=root_module['ns3::PropagationLossModel'])
    ## random-variable-stream.h (module 'core'): ns3::GammaRandomVariable [class]
    module.add_class('GammaRandomVariable', import_from_module='ns.core', parent=root_module['ns3::RandomVariableStream'])
    ## integer.h (module 'core'): ns3::IntegerValue [class]
    module.add_class('IntegerValue', import_from_module='ns.core', parent=root_module['ns3::AttributeValue'])
    ## ipv4.h (module 'internet'): ns3::Ipv4 [class]
    module.add_class('Ipv4', import_from_module='ns.internet', parent=root_module['ns3::Object'])
    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressChecker [class]
    module.add_class('Ipv4AddressChecker', import_from_module='ns.network', parent=root_module['ns3::AttributeChecker'])
    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressValue [class]
    module.add_class('Ipv4AddressValue', import_from_module='ns.network', parent=root_module['ns3::AttributeValue'])
    ## ipv4-address.h (module 'network'): ns3::Ipv4MaskChecker [class]
    module.add_class('Ipv4MaskChecker', import_from_module='ns.network', parent=root_module['ns3::AttributeChecker'])
    ## ipv4-address.h (module 'network'): ns3::Ipv4MaskValue [class]
    module.add_class('Ipv4MaskValue', import_from_module='ns.network', parent=root_module['ns3::AttributeValue'])
    ## ipv4-route.h (module 'internet'): ns3::Ipv4MulticastRoute [class]
    module.add_class('Ipv4MulticastRoute', import_from_module='ns.internet', parent=root_module['ns3::SimpleRefCount< ns3::Ipv4MulticastRoute, ns3::empty, ns3::DefaultDeleter<ns3::Ipv4MulticastRoute> >'])
    ## ipv4-route.h (module 'internet'): ns3::Ipv4Route [class]
    module.add_class('Ipv4Route', import_from_module='ns.internet', parent=root_module['ns3::SimpleRefCount< ns3::Ipv4Route, ns3::empty, ns3::DefaultDeleter<ns3::Ipv4Route> >'])
    ## ipv6.h (module 'internet'): ns3::Ipv6 [class]
    module.add_class('Ipv6', import_from_module='ns.internet', parent=root_module['ns3::Object'])
    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressChecker [class]
    module.add_class('Ipv6AddressChecker', import_from_module='ns.network', parent=root_module['ns3::AttributeChecker'])
    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressValue [class]
    module.add_class('Ipv6AddressValue', import_from_module='ns.network', parent=root_module['ns3::AttributeValue'])
    ## ipv6-address.h (module 'network'): ns3::Ipv6PrefixChecker [class]
    module.add_class('Ipv6PrefixChecker', import_from_module='ns.network', parent=root_module['ns3::AttributeChecker'])
    ## ipv6-address.h (module 'network'): ns3::Ipv6PrefixValue [class]
    module.add_class('Ipv6PrefixValue', import_from_module='ns.network', parent=root_module['ns3::AttributeValue'])
    ## propagation-loss-model.h (module 'propagation'): ns3::LogDistancePropagationLossModel [class]
    module.add_class('LogDistancePropagationLossModel', import_from_module='ns.propagation', parent=root_module['ns3::PropagationLossModel'])
    ## random-variable-stream.h (module 'core'): ns3::LogNormalRandomVariable [class]
    module.add_class('LogNormalRandomVariable', import_from_module='ns.core', parent=root_module['ns3::RandomVariableStream'])
    ## lte-amc.h (module 'lte'): ns3::LteAmc [class]
    module.add_class('LteAmc', import_from_module='ns.lte', parent=root_module['ns3::Object'])
    ## lte-amc.h (module 'lte'): ns3::LteAmc::AmcModel [enumeration]
    module.add_enum('AmcModel', ['PiroEW2010', 'MiErrorModel'], outer_class=root_module['ns3::LteAmc'], import_from_module='ns.lte')
    ## lte-anr.h (module 'lte'): ns3::LteAnr [class]
    module.add_class('LteAnr', import_from_module='ns.lte', parent=root_module['ns3::Object'])
    ## lte-control-messages.h (module 'lte'): ns3::LteControlMessage [class]
    module.add_class('LteControlMessage', import_from_module='ns.lte', parent=root_module['ns3::SimpleRefCount< ns3::LteControlMessage, ns3::empty, ns3::DefaultDeleter<ns3::LteControlMessage> >'])
    ## lte-control-messages.h (module 'lte'): ns3::LteControlMessage::MessageType [enumeration]
    module.add_enum('MessageType', ['DL_DCI', 'UL_DCI', 'DL_CQI', 'UL_CQI', 'BSR', 'DL_HARQ', 'RACH_PREAMBLE', 'RAR', 'MIB', 'SIB1'], outer_class=root_module['ns3::LteControlMessage'], import_from_module='ns.lte')
    ## lte-enb-component-carrier-manager.h (module 'lte'): ns3::LteEnbComponentCarrierManager [class]
    module.add_class('LteEnbComponentCarrierManager', import_from_module='ns.lte', parent=root_module['ns3::Object'])
    ## lte-enb-mac.h (module 'lte'): ns3::LteEnbMac [class]
    module.add_class('LteEnbMac', import_from_module='ns.lte', parent=root_module['ns3::Object'])
    typehandlers.add_type_alias(u'void ( * ) ( uint32_t const, uint32_t const, uint16_t const, uint8_t const, uint16_t const, uint8_t const, uint16_t const, uint8_t const )', u'ns3::LteEnbMac::DlSchedulingTracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( uint32_t const, uint32_t const, uint16_t const, uint8_t const, uint16_t const, uint8_t const, uint16_t const, uint8_t const )*', u'ns3::LteEnbMac::DlSchedulingTracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( uint32_t const, uint32_t const, uint16_t const, uint8_t const, uint16_t const, uint8_t const, uint16_t const, uint8_t const )&', u'ns3::LteEnbMac::DlSchedulingTracedCallback&')
    typehandlers.add_type_alias(u'void ( * ) ( uint32_t const, uint32_t const, uint16_t const, uint8_t const, uint16_t const )', u'ns3::LteEnbMac::UlSchedulingTracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( uint32_t const, uint32_t const, uint16_t const, uint8_t const, uint16_t const )*', u'ns3::LteEnbMac::UlSchedulingTracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( uint32_t const, uint32_t const, uint16_t const, uint8_t const, uint16_t const )&', u'ns3::LteEnbMac::UlSchedulingTracedCallback&')
    ## lte-enb-rrc.h (module 'lte'): ns3::LteEnbRrc [class]
    module.add_class('LteEnbRrc', import_from_module='ns.lte', parent=root_module['ns3::Object'])
    ## lte-enb-rrc.h (module 'lte'): ns3::LteEnbRrc::LteEpsBearerToRlcMapping_t [enumeration]
    module.add_enum('LteEpsBearerToRlcMapping_t', ['RLC_SM_ALWAYS', 'RLC_UM_ALWAYS', 'RLC_AM_ALWAYS', 'PER_BASED', 'RLC_UM_LOWLAT_ALWAYS'], outer_class=root_module['ns3::LteEnbRrc'], import_from_module='ns.lte')
    ## lte-enb-rrc.h (module 'lte'): ns3::LteEnbRrc::HandoverMode [enumeration]
    module.add_enum('HandoverMode', ['FIXED_TTT', 'DYNAMIC_TTT', 'THRESHOLD'], outer_class=root_module['ns3::LteEnbRrc'], import_from_module='ns.lte')
    ## lte-enb-rrc.h (module 'lte'): ns3::LteEnbRrc::HandoverEventInfo [struct]
    module.add_class('HandoverEventInfo', import_from_module='ns.lte', outer_class=root_module['ns3::LteEnbRrc'])
    ## lte-enb-rrc.h (module 'lte'): ns3::LteEnbRrc::MmWaveComponentCarrierConf [struct]
    module.add_class('MmWaveComponentCarrierConf', import_from_module='ns.lte', outer_class=root_module['ns3::LteEnbRrc'])
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t const, uint16_t const )', u'ns3::LteEnbRrc::NewUeContextTracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t const, uint16_t const )*', u'ns3::LteEnbRrc::NewUeContextTracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t const, uint16_t const )&', u'ns3::LteEnbRrc::NewUeContextTracedCallback&')
    typehandlers.add_type_alias(u'void ( * ) ( uint64_t const, uint16_t const, uint16_t const )', u'ns3::LteEnbRrc::ConnectionHandoverTracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( uint64_t const, uint16_t const, uint16_t const )*', u'ns3::LteEnbRrc::ConnectionHandoverTracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( uint64_t const, uint16_t const, uint16_t const )&', u'ns3::LteEnbRrc::ConnectionHandoverTracedCallback&')
    typehandlers.add_type_alias(u'void ( * ) ( uint64_t const, uint16_t const, uint16_t const, uint16_t const )', u'ns3::LteEnbRrc::HandoverStartTracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( uint64_t const, uint16_t const, uint16_t const, uint16_t const )*', u'ns3::LteEnbRrc::HandoverStartTracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( uint64_t const, uint16_t const, uint16_t const, uint16_t const )&', u'ns3::LteEnbRrc::HandoverStartTracedCallback&')
    typehandlers.add_type_alias(u'void ( * ) ( uint64_t const, uint16_t const, uint16_t const, ns3::LteRrcSap::MeasurementReport const )', u'ns3::LteEnbRrc::ReceiveReportTracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( uint64_t const, uint16_t const, uint16_t const, ns3::LteRrcSap::MeasurementReport const )*', u'ns3::LteEnbRrc::ReceiveReportTracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( uint64_t const, uint16_t const, uint16_t const, ns3::LteRrcSap::MeasurementReport const )&', u'ns3::LteEnbRrc::ReceiveReportTracedCallback&')
    typehandlers.add_type_alias(u'void ( * ) ( uint64_t, uint16_t, long double )', u'ns3::LteEnbRrc::NotifyMmWaveSinrTracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( uint64_t, uint16_t, long double )*', u'ns3::LteEnbRrc::NotifyMmWaveSinrTracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( uint64_t, uint16_t, long double )&', u'ns3::LteEnbRrc::NotifyMmWaveSinrTracedCallback&')
    typehandlers.add_type_alias(u'std::map< unsigned long, ns3::LteEnbRrc::HandoverEventInfo >', u'ns3::LteEnbRrc::HandoverEventMap')
    typehandlers.add_type_alias(u'std::map< unsigned long, ns3::LteEnbRrc::HandoverEventInfo >*', u'ns3::LteEnbRrc::HandoverEventMap*')
    typehandlers.add_type_alias(u'std::map< unsigned long, ns3::LteEnbRrc::HandoverEventInfo >&', u'ns3::LteEnbRrc::HandoverEventMap&')
    ## lte-ffr-algorithm.h (module 'lte'): ns3::LteFfrAlgorithm [class]
    module.add_class('LteFfrAlgorithm', import_from_module='ns.lte', parent=root_module['ns3::Object'])
    ## lte-handover-algorithm.h (module 'lte'): ns3::LteHandoverAlgorithm [class]
    module.add_class('LteHandoverAlgorithm', import_from_module='ns.lte', parent=root_module['ns3::Object'])
    ## lte-harq-phy.h (module 'lte'): ns3::LteHarqPhy [class]
    module.add_class('LteHarqPhy', import_from_module='ns.lte', parent=root_module['ns3::SimpleRefCount< ns3::LteHarqPhy, ns3::empty, ns3::DefaultDeleter<ns3::LteHarqPhy> >'])
    ## lte-interference.h (module 'lte'): ns3::LteInterference [class]
    module.add_class('LteInterference', import_from_module='ns.lte', parent=root_module['ns3::Object'])
    ## lte-pdcp.h (module 'lte'): ns3::LtePdcp [class]
    module.add_class('LtePdcp', import_from_module='ns.lte', parent=root_module['ns3::Object'])
    ## lte-pdcp.h (module 'lte'): ns3::LtePdcp::Status [struct]
    module.add_class('Status', import_from_module='ns.lte', outer_class=root_module['ns3::LtePdcp'])
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t, uint8_t, uint32_t )', u'ns3::LtePdcp::PduTxTracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t, uint8_t, uint32_t )*', u'ns3::LtePdcp::PduTxTracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t, uint8_t, uint32_t )&', u'ns3::LtePdcp::PduTxTracedCallback&')
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t const, uint8_t const, uint32_t const, uint64_t const )', u'ns3::LtePdcp::PduRxTracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t const, uint8_t const, uint32_t const, uint64_t const )*', u'ns3::LtePdcp::PduRxTracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t const, uint8_t const, uint32_t const, uint64_t const )&', u'ns3::LtePdcp::PduRxTracedCallback&')
    ## lte-phy.h (module 'lte'): ns3::LtePhy [class]
    module.add_class('LtePhy', import_from_module='ns.lte', parent=root_module['ns3::Object'])
    ## lte-radio-bearer-info.h (module 'lte'): ns3::LteRadioBearerInfo [class]
    module.add_class('LteRadioBearerInfo', import_from_module='ns.lte', parent=root_module['ns3::Object'])
    ## lte-rlc.h (module 'lte'): ns3::LteRlc [class]
    module.add_class('LteRlc', import_from_module='ns.lte', parent=root_module['ns3::Object'])
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t, uint8_t, uint32_t )', u'ns3::LteRlc::NotifyTxTracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t, uint8_t, uint32_t )*', u'ns3::LteRlc::NotifyTxTracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t, uint8_t, uint32_t )&', u'ns3::LteRlc::NotifyTxTracedCallback&')
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t, uint8_t, uint32_t, uint64_t )', u'ns3::LteRlc::ReceiveTracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t, uint8_t, uint32_t, uint64_t )*', u'ns3::LteRlc::ReceiveTracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t, uint8_t, uint32_t, uint64_t )&', u'ns3::LteRlc::ReceiveTracedCallback&')
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t, uint8_t, uint32_t, uint32_t )', u'ns3::LteRlc::RetransmissionCountCallback')
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t, uint8_t, uint32_t, uint32_t )*', u'ns3::LteRlc::RetransmissionCountCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t, uint8_t, uint32_t, uint32_t )&', u'ns3::LteRlc::RetransmissionCountCallback&')
    ## lte-rlc-am.h (module 'lte'): ns3::LteRlcAm [class]
    module.add_class('LteRlcAm', import_from_module='ns.lte', parent=root_module['ns3::LteRlc'])
    ## lte-rlc-am.h (module 'lte'): ns3::LteRlcAm::RetxPdu [struct]
    module.add_class('RetxPdu', import_from_module='ns.lte', outer_class=root_module['ns3::LteRlcAm'])
    ## lte-rlc.h (module 'lte'): ns3::LteRlcSm [class]
    module.add_class('LteRlcSm', import_from_module='ns.lte', parent=root_module['ns3::LteRlc'])
    ## lte-radio-bearer-info.h (module 'lte'): ns3::LteSignalingRadioBearerInfo [class]
    module.add_class('LteSignalingRadioBearerInfo', import_from_module='ns.lte', parent=root_module['ns3::LteRadioBearerInfo'])
    ## lte-spectrum-phy.h (module 'lte'): ns3::LteSpectrumPhy [class]
    module.add_class('LteSpectrumPhy', import_from_module='ns.lte', parent=root_module['ns3::SpectrumPhy'])
    ## lte-spectrum-phy.h (module 'lte'): ns3::LteSpectrumPhy::State [enumeration]
    module.add_enum('State', ['IDLE', 'TX_DL_CTRL', 'TX_DATA', 'TX_UL_SRS', 'RX_DL_CTRL', 'RX_DATA', 'RX_UL_SRS'], outer_class=root_module['ns3::LteSpectrumPhy'], import_from_module='ns.lte')
    ## lte-stats-calculator.h (module 'lte'): ns3::LteStatsCalculator [class]
    module.add_class('LteStatsCalculator', import_from_module='ns.lte', parent=root_module['ns3::Object'])
    ## lte-ue-mac.h (module 'lte'): ns3::LteUeMac [class]
    module.add_class('LteUeMac', import_from_module='ns.lte', parent=root_module['ns3::Object'])
    ## lte-ue-phy.h (module 'lte'): ns3::LteUePhy [class]
    module.add_class('LteUePhy', import_from_module='ns.lte', parent=root_module['ns3::LtePhy'])
    ## lte-ue-phy.h (module 'lte'): ns3::LteUePhy::State [enumeration]
    module.add_enum('State', ['CELL_SEARCH', 'SYNCHRONIZED', 'NUM_STATES'], outer_class=root_module['ns3::LteUePhy'], import_from_module='ns.lte')
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t, uint16_t, ns3::LteUePhy::State, ns3::LteUePhy::State )', u'ns3::LteUePhy::StateTracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t, uint16_t, ns3::LteUePhy::State, ns3::LteUePhy::State )*', u'ns3::LteUePhy::StateTracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t, uint16_t, ns3::LteUePhy::State, ns3::LteUePhy::State )&', u'ns3::LteUePhy::StateTracedCallback&')
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t, uint16_t, double, double, uint8_t )', u'ns3::LteUePhy::RsrpSinrTracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t, uint16_t, double, double, uint8_t )*', u'ns3::LteUePhy::RsrpSinrTracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t, uint16_t, double, double, uint8_t )&', u'ns3::LteUePhy::RsrpSinrTracedCallback&')
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t, uint16_t, double, double, bool, uint8_t )', u'ns3::LteUePhy::RsrpRsrqTracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t, uint16_t, double, double, bool, uint8_t )*', u'ns3::LteUePhy::RsrpRsrqTracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t, uint16_t, double, double, bool, uint8_t )&', u'ns3::LteUePhy::RsrpRsrqTracedCallback&')
    ## lte-ue-power-control.h (module 'lte'): ns3::LteUePowerControl [class]
    module.add_class('LteUePowerControl', import_from_module='ns.lte', parent=root_module['ns3::Object'])
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t, uint16_t, double )', u'ns3::LteUePowerControl::TxPowerTracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t, uint16_t, double )*', u'ns3::LteUePowerControl::TxPowerTracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t, uint16_t, double )&', u'ns3::LteUePowerControl::TxPowerTracedCallback&')
    ## lte-ue-rrc.h (module 'lte'): ns3::LteUeRrc [class]
    module.add_class('LteUeRrc', import_from_module='ns.lte', parent=root_module['ns3::Object'])
    ## lte-ue-rrc.h (module 'lte'): ns3::LteUeRrc::State [enumeration]
    module.add_enum('State', ['IDLE_START', 'IDLE_CELL_SEARCH', 'IDLE_WAIT_MIB_SIB1', 'IDLE_WAIT_MIB', 'IDLE_WAIT_SIB1', 'IDLE_CAMPED_NORMALLY', 'IDLE_WAIT_SIB2', 'IDLE_RANDOM_ACCESS', 'IDLE_CONNECTING', 'CONNECTED_NORMALLY', 'CONNECTED_HANDOVER', 'CONNECTED_PHY_PROBLEM', 'CONNECTED_REESTABLISHING', 'NUM_STATES'], outer_class=root_module['ns3::LteUeRrc'], import_from_module='ns.lte')
    typehandlers.add_type_alias(u'void ( * ) ( uint64_t, uint16_t )', u'ns3::LteUeRrc::CellSelectionTracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( uint64_t, uint16_t )*', u'ns3::LteUeRrc::CellSelectionTracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( uint64_t, uint16_t )&', u'ns3::LteUeRrc::CellSelectionTracedCallback&')
    typehandlers.add_type_alias(u'void ( * ) ( uint64_t, uint16_t, uint16_t )', u'ns3::LteUeRrc::ImsiCidRntiTracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( uint64_t, uint16_t, uint16_t )*', u'ns3::LteUeRrc::ImsiCidRntiTracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( uint64_t, uint16_t, uint16_t )&', u'ns3::LteUeRrc::ImsiCidRntiTracedCallback&')
    typehandlers.add_type_alias(u'void ( * ) ( uint64_t, uint16_t, uint16_t, uint16_t )', u'ns3::LteUeRrc::MibSibHandoverTracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( uint64_t, uint16_t, uint16_t, uint16_t )*', u'ns3::LteUeRrc::MibSibHandoverTracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( uint64_t, uint16_t, uint16_t, uint16_t )&', u'ns3::LteUeRrc::MibSibHandoverTracedCallback&')
    typehandlers.add_type_alias(u'void ( * ) ( uint64_t, uint16_t, uint16_t, ns3::LteUeRrc::State, ns3::LteUeRrc::State )', u'ns3::LteUeRrc::StateTracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( uint64_t, uint16_t, uint16_t, ns3::LteUeRrc::State, ns3::LteUeRrc::State )*', u'ns3::LteUeRrc::StateTracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( uint64_t, uint16_t, uint16_t, ns3::LteUeRrc::State, ns3::LteUeRrc::State )&', u'ns3::LteUeRrc::StateTracedCallback&')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Ptr< ns3::LteUeRrc >, std::list< ns3::LteRrcSap::SCellToAddMod > )', u'ns3::LteUeRrc::SCarrierConfiguredTracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Ptr< ns3::LteUeRrc >, std::list< ns3::LteRrcSap::SCellToAddMod > )*', u'ns3::LteUeRrc::SCarrierConfiguredTracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Ptr< ns3::LteUeRrc >, std::list< ns3::LteRrcSap::SCellToAddMod > )&', u'ns3::LteUeRrc::SCarrierConfiguredTracedCallback&')
    ## mac48-address.h (module 'network'): ns3::Mac48AddressChecker [class]
    module.add_class('Mac48AddressChecker', import_from_module='ns.network', parent=root_module['ns3::AttributeChecker'])
    ## mac48-address.h (module 'network'): ns3::Mac48AddressValue [class]
    module.add_class('Mac48AddressValue', import_from_module='ns.network', parent=root_module['ns3::AttributeValue'])
    ## mac64-address.h (module 'network'): ns3::Mac64AddressChecker [class]
    module.add_class('Mac64AddressChecker', import_from_module='ns.network', parent=root_module['ns3::AttributeChecker'])
    ## mac64-address.h (module 'network'): ns3::Mac64AddressValue [class]
    module.add_class('Mac64AddressValue', import_from_module='ns.network', parent=root_module['ns3::AttributeValue'])
    ## propagation-loss-model.h (module 'propagation'): ns3::MatrixPropagationLossModel [class]
    module.add_class('MatrixPropagationLossModel', import_from_module='ns.propagation', parent=root_module['ns3::PropagationLossModel'])
    ## lte-control-messages.h (module 'lte'): ns3::MibLteControlMessage [class]
    module.add_class('MibLteControlMessage', import_from_module='ns.lte', parent=root_module['ns3::LteControlMessage'])
    ## basic-data-calculators.h (module 'stats'): ns3::MinMaxAvgTotalCalculator<unsigned int> [class]
    module.add_class('MinMaxAvgTotalCalculator', import_from_module='ns.stats', template_parameters=['unsigned int'], parent=[root_module['ns3::DataCalculator'], root_module['ns3::StatisticalSummary']])
    ## basic-data-calculators.h (module 'stats'): ns3::MinMaxAvgTotalCalculator<unsigned long> [class]
    module.add_class('MinMaxAvgTotalCalculator', import_from_module='ns.stats', template_parameters=['unsigned long'], parent=[root_module['ns3::DataCalculator'], root_module['ns3::StatisticalSummary']])
    ## mobility-building-info.h (module 'buildings'): ns3::MobilityBuildingInfo [class]
    module.add_class('MobilityBuildingInfo', import_from_module='ns.buildings', parent=root_module['ns3::Object'])
    ## mobility-model.h (module 'mobility'): ns3::MobilityModel [class]
    module.add_class('MobilityModel', import_from_module='ns.mobility', parent=root_module['ns3::Object'])
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Ptr< ns3::MobilityModel const > )', u'ns3::MobilityModel::TracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Ptr< ns3::MobilityModel const > )*', u'ns3::MobilityModel::TracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Ptr< ns3::MobilityModel const > )&', u'ns3::MobilityModel::TracedCallback&')
    ## propagation-loss-model.h (module 'propagation'): ns3::NakagamiPropagationLossModel [class]
    module.add_class('NakagamiPropagationLossModel', import_from_module='ns.propagation', parent=root_module['ns3::PropagationLossModel'])
    ## net-device.h (module 'network'): ns3::NetDevice [class]
    module.add_class('NetDevice', import_from_module='ns.network', parent=root_module['ns3::Object'])
    ## net-device.h (module 'network'): ns3::NetDevice::PacketType [enumeration]
    module.add_enum('PacketType', ['PACKET_HOST', 'NS3_PACKET_HOST', 'PACKET_BROADCAST', 'NS3_PACKET_BROADCAST', 'PACKET_MULTICAST', 'NS3_PACKET_MULTICAST', 'PACKET_OTHERHOST', 'NS3_PACKET_OTHERHOST'], outer_class=root_module['ns3::NetDevice'], import_from_module='ns.network')
    typehandlers.add_type_alias(u'void ( * ) (  )', u'ns3::NetDevice::LinkChangeTracedCallback')
    typehandlers.add_type_alias(u'void ( * ) (  )*', u'ns3::NetDevice::LinkChangeTracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) (  )&', u'ns3::NetDevice::LinkChangeTracedCallback&')
    typehandlers.add_type_alias(u'ns3::Callback< bool, ns3::Ptr< ns3::NetDevice >, ns3::Ptr< ns3::Packet const >, unsigned short, ns3::Address const &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', u'ns3::NetDevice::ReceiveCallback')
    typehandlers.add_type_alias(u'ns3::Callback< bool, ns3::Ptr< ns3::NetDevice >, ns3::Ptr< ns3::Packet const >, unsigned short, ns3::Address const &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >*', u'ns3::NetDevice::ReceiveCallback*')
    typehandlers.add_type_alias(u'ns3::Callback< bool, ns3::Ptr< ns3::NetDevice >, ns3::Ptr< ns3::Packet const >, unsigned short, ns3::Address const &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >&', u'ns3::NetDevice::ReceiveCallback&')
    typehandlers.add_type_alias(u'ns3::Callback< bool, ns3::Ptr< ns3::NetDevice >, ns3::Ptr< ns3::Packet const >, unsigned short, ns3::Address const &, ns3::Address const &, ns3::NetDevice::PacketType, ns3::empty, ns3::empty, ns3::empty >', u'ns3::NetDevice::PromiscReceiveCallback')
    typehandlers.add_type_alias(u'ns3::Callback< bool, ns3::Ptr< ns3::NetDevice >, ns3::Ptr< ns3::Packet const >, unsigned short, ns3::Address const &, ns3::Address const &, ns3::NetDevice::PacketType, ns3::empty, ns3::empty, ns3::empty >*', u'ns3::NetDevice::PromiscReceiveCallback*')
    typehandlers.add_type_alias(u'ns3::Callback< bool, ns3::Ptr< ns3::NetDevice >, ns3::Ptr< ns3::Packet const >, unsigned short, ns3::Address const &, ns3::Address const &, ns3::NetDevice::PacketType, ns3::empty, ns3::empty, ns3::empty >&', u'ns3::NetDevice::PromiscReceiveCallback&')
    ## nix-vector.h (module 'network'): ns3::NixVector [class]
    module.add_class('NixVector', import_from_module='ns.network', parent=root_module['ns3::SimpleRefCount< ns3::NixVector, ns3::empty, ns3::DefaultDeleter<ns3::NixVector> >'])
    ## node.h (module 'network'): ns3::Node [class]
    module.add_class('Node', import_from_module='ns.network', parent=root_module['ns3::Object'])
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::Ptr< ns3::NetDevice >, ns3::Ptr< ns3::Packet const >, unsigned short, ns3::Address const &, ns3::Address const &, ns3::NetDevice::PacketType, ns3::empty, ns3::empty, ns3::empty >', u'ns3::Node::ProtocolHandler')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::Ptr< ns3::NetDevice >, ns3::Ptr< ns3::Packet const >, unsigned short, ns3::Address const &, ns3::Address const &, ns3::NetDevice::PacketType, ns3::empty, ns3::empty, ns3::empty >*', u'ns3::Node::ProtocolHandler*')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::Ptr< ns3::NetDevice >, ns3::Ptr< ns3::Packet const >, unsigned short, ns3::Address const &, ns3::Address const &, ns3::NetDevice::PacketType, ns3::empty, ns3::empty, ns3::empty >&', u'ns3::Node::ProtocolHandler&')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::Ptr< ns3::NetDevice >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', u'ns3::Node::DeviceAdditionListener')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::Ptr< ns3::NetDevice >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >*', u'ns3::Node::DeviceAdditionListener*')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::Ptr< ns3::NetDevice >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >&', u'ns3::Node::DeviceAdditionListener&')
    ## random-variable-stream.h (module 'core'): ns3::NormalRandomVariable [class]
    module.add_class('NormalRandomVariable', import_from_module='ns.core', parent=root_module['ns3::RandomVariableStream'])
    ## object-factory.h (module 'core'): ns3::ObjectFactoryChecker [class]
    module.add_class('ObjectFactoryChecker', import_from_module='ns.core', parent=root_module['ns3::AttributeChecker'])
    ## object-factory.h (module 'core'): ns3::ObjectFactoryValue [class]
    module.add_class('ObjectFactoryValue', import_from_module='ns.core', parent=root_module['ns3::AttributeValue'])
    ## packet.h (module 'network'): ns3::Packet [class]
    module.add_class('Packet', import_from_module='ns.network', parent=root_module['ns3::SimpleRefCount< ns3::Packet, ns3::empty, ns3::DefaultDeleter<ns3::Packet> >'])
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Ptr< ns3::Packet const > )', u'ns3::Packet::TracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Ptr< ns3::Packet const > )*', u'ns3::Packet::TracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Ptr< ns3::Packet const > )&', u'ns3::Packet::TracedCallback&')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Ptr< ns3::Packet const >, ns3::Address const & )', u'ns3::Packet::AddressTracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Ptr< ns3::Packet const >, ns3::Address const & )*', u'ns3::Packet::AddressTracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Ptr< ns3::Packet const >, ns3::Address const & )&', u'ns3::Packet::AddressTracedCallback&')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Ptr< ns3::Packet const > const, ns3::Address const &, ns3::Address const & )', u'ns3::Packet::TwoAddressTracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Ptr< ns3::Packet const > const, ns3::Address const &, ns3::Address const & )*', u'ns3::Packet::TwoAddressTracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Ptr< ns3::Packet const > const, ns3::Address const &, ns3::Address const & )&', u'ns3::Packet::TwoAddressTracedCallback&')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Ptr< ns3::Packet const >, ns3::Mac48Address )', u'ns3::Packet::Mac48AddressTracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Ptr< ns3::Packet const >, ns3::Mac48Address )*', u'ns3::Packet::Mac48AddressTracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Ptr< ns3::Packet const >, ns3::Mac48Address )&', u'ns3::Packet::Mac48AddressTracedCallback&')
    typehandlers.add_type_alias(u'void ( * ) ( uint32_t, uint32_t )', u'ns3::Packet::SizeTracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( uint32_t, uint32_t )*', u'ns3::Packet::SizeTracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( uint32_t, uint32_t )&', u'ns3::Packet::SizeTracedCallback&')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Ptr< ns3::Packet const >, double )', u'ns3::Packet::SinrTracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Ptr< ns3::Packet const >, double )*', u'ns3::Packet::SinrTracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Ptr< ns3::Packet const >, double )&', u'ns3::Packet::SinrTracedCallback&')
    ## random-variable-stream.h (module 'core'): ns3::ParetoRandomVariable [class]
    module.add_class('ParetoRandomVariable', import_from_module='ns.core', parent=root_module['ns3::RandomVariableStream'])
    ## pointer.h (module 'core'): ns3::PointerChecker [class]
    module.add_class('PointerChecker', import_from_module='ns.core', parent=root_module['ns3::AttributeChecker'])
    ## pointer.h (module 'core'): ns3::PointerValue [class]
    module.add_class('PointerValue', import_from_module='ns.core', parent=root_module['ns3::AttributeValue'])
    ## queue-item.h (module 'network'): ns3::QueueItem [class]
    module.add_class('QueueItem', import_from_module='ns.network', parent=root_module['ns3::SimpleRefCount< ns3::QueueItem, ns3::empty, ns3::DefaultDeleter<ns3::QueueItem> >'])
    ## queue-item.h (module 'network'): ns3::QueueItem::Uint8Values [enumeration]
    module.add_enum('Uint8Values', ['IP_DSFIELD'], outer_class=root_module['ns3::QueueItem'], import_from_module='ns.network')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Ptr< ns3::QueueItem const > )', u'ns3::QueueItem::TracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Ptr< ns3::QueueItem const > )*', u'ns3::QueueItem::TracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Ptr< ns3::QueueItem const > )&', u'ns3::QueueItem::TracedCallback&')
    ## queue-size.h (module 'network'): ns3::QueueSizeChecker [class]
    module.add_class('QueueSizeChecker', import_from_module='ns.network', parent=root_module['ns3::AttributeChecker'])
    ## queue-size.h (module 'network'): ns3::QueueSizeValue [class]
    module.add_class('QueueSizeValue', import_from_module='ns.network', parent=root_module['ns3::AttributeValue'])
    ## lte-control-messages.h (module 'lte'): ns3::RachPreambleLteControlMessage [class]
    module.add_class('RachPreambleLteControlMessage', import_from_module='ns.lte', parent=root_module['ns3::LteControlMessage'])
    ## lte-control-messages.h (module 'lte'): ns3::RarLteControlMessage [class]
    module.add_class('RarLteControlMessage', import_from_module='ns.lte', parent=root_module['ns3::LteControlMessage'])
    ## lte-control-messages.h (module 'lte'): ns3::RarLteControlMessage::Rar [struct]
    module.add_class('Rar', import_from_module='ns.lte', outer_class=root_module['ns3::RarLteControlMessage'])
    ## lte-rrc-header.h (module 'lte'): ns3::RrcAsn1Header [class]
    module.add_class('RrcAsn1Header', import_from_module='ns.lte', parent=root_module['ns3::Asn1Header'])
    ## lte-rrc-header.h (module 'lte'): ns3::RrcDlCcchMessage [class]
    module.add_class('RrcDlCcchMessage', import_from_module='ns.lte', parent=root_module['ns3::RrcAsn1Header'])
    ## lte-rrc-header.h (module 'lte'): ns3::RrcDlDcchMessage [class]
    module.add_class('RrcDlDcchMessage', import_from_module='ns.lte', parent=root_module['ns3::RrcAsn1Header'])
    ## lte-rrc-header.h (module 'lte'): ns3::RrcUlCcchMessage [class]
    module.add_class('RrcUlCcchMessage', import_from_module='ns.lte', parent=root_module['ns3::RrcAsn1Header'])
    ## lte-rrc-header.h (module 'lte'): ns3::RrcUlDcchMessage [class]
    module.add_class('RrcUlDcchMessage', import_from_module='ns.lte', parent=root_module['ns3::RrcAsn1Header'])
    ## lte-control-messages.h (module 'lte'): ns3::Sib1LteControlMessage [class]
    module.add_class('Sib1LteControlMessage', import_from_module='ns.lte', parent=root_module['ns3::LteControlMessage'])
    ## spectrum-channel.h (module 'spectrum'): ns3::SpectrumChannel [class]
    module.add_class('SpectrumChannel', import_from_module='ns.spectrum', parent=root_module['ns3::Channel'])
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Ptr< ns3::SpectrumPhy const >, ns3::Ptr< ns3::SpectrumPhy const >, double )', u'ns3::SpectrumChannel::LossTracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Ptr< ns3::SpectrumPhy const >, ns3::Ptr< ns3::SpectrumPhy const >, double )*', u'ns3::SpectrumChannel::LossTracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Ptr< ns3::SpectrumPhy const >, ns3::Ptr< ns3::SpectrumPhy const >, double )&', u'ns3::SpectrumChannel::LossTracedCallback&')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Ptr< ns3::MobilityModel const >, ns3::Ptr< ns3::MobilityModel const >, double, double, double, double )', u'ns3::SpectrumChannel::GainTracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Ptr< ns3::MobilityModel const >, ns3::Ptr< ns3::MobilityModel const >, double, double, double, double )*', u'ns3::SpectrumChannel::GainTracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Ptr< ns3::MobilityModel const >, ns3::Ptr< ns3::MobilityModel const >, double, double, double, double )&', u'ns3::SpectrumChannel::GainTracedCallback&')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Ptr< ns3::SpectrumSignalParameters > )', u'ns3::SpectrumChannel::SignalParametersTracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Ptr< ns3::SpectrumSignalParameters > )*', u'ns3::SpectrumChannel::SignalParametersTracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Ptr< ns3::SpectrumSignalParameters > )&', u'ns3::SpectrumChannel::SignalParametersTracedCallback&')
    ## string.h (module 'core'): ns3::StringChecker [class]
    module.add_class('StringChecker', import_from_module='ns.core', parent=root_module['ns3::AttributeChecker'])
    ## string.h (module 'core'): ns3::StringValue [class]
    module.add_class('StringValue', import_from_module='ns.core', parent=root_module['ns3::AttributeValue'])
    ## nstime.h (module 'core'): ns3::TimeValue [class]
    module.add_class('TimeValue', import_from_module='ns.core', parent=root_module['ns3::AttributeValue'])
    ## type-id.h (module 'core'): ns3::TypeIdChecker [class]
    module.add_class('TypeIdChecker', import_from_module='ns.core', parent=root_module['ns3::AttributeChecker'])
    ## type-id.h (module 'core'): ns3::TypeIdValue [class]
    module.add_class('TypeIdValue', import_from_module='ns.core', parent=root_module['ns3::AttributeValue'])
    ## uinteger.h (module 'core'): ns3::UintegerValue [class]
    module.add_class('UintegerValue', import_from_module='ns.core', parent=root_module['ns3::AttributeValue'])
    ## lte-control-messages.h (module 'lte'): ns3::UlDciLteControlMessage [class]
    module.add_class('UlDciLteControlMessage', import_from_module='ns.lte', parent=root_module['ns3::LteControlMessage'])
    ## vector.h (module 'core'): ns3::Vector2DChecker [class]
    module.add_class('Vector2DChecker', import_from_module='ns.core', parent=root_module['ns3::AttributeChecker'])
    ## vector.h (module 'core'): ns3::Vector2DValue [class]
    module.add_class('Vector2DValue', import_from_module='ns.core', parent=root_module['ns3::AttributeValue'])
    ## vector.h (module 'core'): ns3::Vector3DChecker [class]
    module.add_class('Vector3DChecker', import_from_module='ns.core', parent=root_module['ns3::AttributeChecker'])
    ## vector.h (module 'core'): ns3::Vector3DValue [class]
    module.add_class('Vector3DValue', import_from_module='ns.core', parent=root_module['ns3::AttributeValue'])
    ## address.h (module 'network'): ns3::AddressChecker [class]
    module.add_class('AddressChecker', import_from_module='ns.network', parent=root_module['ns3::AttributeChecker'])
    ## address.h (module 'network'): ns3::AddressValue [class]
    module.add_class('AddressValue', import_from_module='ns.network', parent=root_module['ns3::AttributeValue'])
    ## lte-control-messages.h (module 'lte'): ns3::BsrLteControlMessage [class]
    module.add_class('BsrLteControlMessage', import_from_module='ns.lte', parent=root_module['ns3::LteControlMessage'])
    ## callback.h (module 'core'): ns3::CallbackImpl<bool, ns3::Ptr<ns3::NetDevice>, ns3::Ptr<const ns3::Packet>, unsigned short, const ns3::Address &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['bool', 'ns3::Ptr<ns3::NetDevice>', 'ns3::Ptr<const ns3::Packet>', 'unsigned short', 'const ns3::Address &', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<bool, ns3::Ptr<ns3::Socket>, const ns3::Address &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['bool', 'ns3::Ptr<ns3::Socket>', 'const ns3::Address &', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<ns3::ObjectBase *, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['ns3::ObjectBase *', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, bool, bool, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'bool', 'bool', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, const ns3::SpectrumValue &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'const ns3::SpectrumValue &', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::DlSchedulingCallbackInfo, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'ns3::DlSchedulingCallbackInfo', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::EpcUeNas::State, ns3::EpcUeNas::State, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'ns3::EpcUeNas::State', 'ns3::EpcUeNas::State', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::PhyReceptionStatParameters, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'ns3::PhyReceptionStatParameters', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::PhyTransmissionStatParameters, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'ns3::PhyTransmissionStatParameters', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<const ns3::MobilityModel>, ns3::Ptr<const ns3::MobilityModel>, double, double, double, double, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'ns3::Ptr<const ns3::MobilityModel>', 'ns3::Ptr<const ns3::MobilityModel>', 'double', 'double', 'double', 'double', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<const ns3::MobilityModel>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'ns3::Ptr<const ns3::MobilityModel>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<const ns3::Packet>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'ns3::Ptr<const ns3::Packet>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<const ns3::PacketBurst>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'ns3::Ptr<const ns3::PacketBurst>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<const ns3::QueueDiscItem>, const char *, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'ns3::Ptr<const ns3::QueueDiscItem>', 'const char *', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<const ns3::QueueDiscItem>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'ns3::Ptr<const ns3::QueueDiscItem>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<const ns3::SpectrumPhy>, ns3::Ptr<const ns3::SpectrumPhy>, double, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'ns3::Ptr<const ns3::SpectrumPhy>', 'ns3::Ptr<const ns3::SpectrumPhy>', 'double', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<ns3::LteUeRrc>, std::list<ns3::LteRrcSap::SCellToAddMod, std::allocator<ns3::LteRrcSap::SCellToAddMod> >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'ns3::Ptr<ns3::LteUeRrc>', 'std::list<ns3::LteRrcSap::SCellToAddMod, std::allocator<ns3::LteRrcSap::SCellToAddMod> >', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<ns3::NetDevice>, ns3::Ptr<const ns3::Packet>, unsigned short, const ns3::Address &, const ns3::Address &, ns3::NetDevice::PacketType, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'ns3::Ptr<ns3::NetDevice>', 'ns3::Ptr<const ns3::Packet>', 'unsigned short', 'const ns3::Address &', 'const ns3::Address &', 'ns3::NetDevice::PacketType', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<ns3::NetDevice>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'ns3::Ptr<ns3::NetDevice>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<ns3::Packet>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'ns3::Ptr<ns3::Packet>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<ns3::Socket>, const ns3::Address &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'ns3::Ptr<ns3::Socket>', 'const ns3::Address &', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<ns3::Socket>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'ns3::Ptr<ns3::Socket>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<ns3::Socket>, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'ns3::Ptr<ns3::Socket>', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<ns3::SpectrumSignalParameters>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'ns3::Ptr<ns3::SpectrumSignalParameters>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Time, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'ns3::Time', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::mmwave::RxPacketTraceParams, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', template_parameters=['void', 'ns3::mmwave::RxPacketTraceParams', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned int, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'unsigned int', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned int, unsigned int, unsigned short, unsigned char, unsigned short, unsigned char, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'unsigned int', 'unsigned int', 'unsigned short', 'unsigned char', 'unsigned short', 'unsigned char', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned long, ns3::SpectrumValue &, ns3::SpectrumValue &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'unsigned long', 'ns3::SpectrumValue &', 'ns3::SpectrumValue &', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned long, unsigned long, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'unsigned long', 'unsigned long', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned long, unsigned short, long double, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'unsigned long', 'unsigned short', 'long double', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned long, unsigned short, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'unsigned long', 'unsigned short', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned long, unsigned short, unsigned short, ns3::LteRrcSap::MeasurementReport, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'unsigned long', 'unsigned short', 'unsigned short', 'ns3::LteRrcSap::MeasurementReport', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned long, unsigned short, unsigned short, ns3::LteUeRrc::State, ns3::LteUeRrc::State, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'unsigned long', 'unsigned short', 'unsigned short', 'ns3::LteUeRrc::State', 'ns3::LteUeRrc::State', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned long, unsigned short, unsigned short, ns3::UeManager::State, ns3::UeManager::State, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'unsigned long', 'unsigned short', 'unsigned short', 'ns3::UeManager::State', 'ns3::UeManager::State', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned long, unsigned short, unsigned short, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'unsigned long', 'unsigned short', 'unsigned short', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned long, unsigned short, unsigned short, unsigned short, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'unsigned long', 'unsigned short', 'unsigned short', 'unsigned short', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned short, ns3::Ptr<ns3::SpectrumValue>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'unsigned short', 'ns3::Ptr<ns3::SpectrumValue>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned short, unsigned char, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'unsigned short', 'unsigned char', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned short, unsigned char, unsigned int, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'unsigned short', 'unsigned char', 'unsigned int', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned short, unsigned char, unsigned int, unsigned long, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'unsigned short', 'unsigned char', 'unsigned int', 'unsigned long', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned short, unsigned short, double, double, bool, unsigned char, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'unsigned short', 'unsigned short', 'double', 'double', 'bool', 'unsigned char', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned short, unsigned short, double, double, unsigned char, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'unsigned short', 'unsigned short', 'double', 'double', 'unsigned char', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned short, unsigned short, double, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'unsigned short', 'unsigned short', 'double', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned short, unsigned short, double, unsigned char, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'unsigned short', 'unsigned short', 'double', 'unsigned char', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned short, unsigned short, ns3::LteUePhy::State, ns3::LteUePhy::State, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'unsigned short', 'unsigned short', 'ns3::LteUePhy::State', 'ns3::LteUePhy::State', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned short, unsigned short, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'unsigned short', 'unsigned short', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned short, unsigned short, unsigned int, unsigned char, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
    module.add_class('CallbackImpl', import_from_module='ns.core', template_parameters=['void', 'unsigned short', 'unsigned short', 'unsigned int', 'unsigned char', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'], parent=root_module['ns3::CallbackImplBase'])
    ## lte-control-messages.h (module 'lte'): ns3::DlCqiLteControlMessage [class]
    module.add_class('DlCqiLteControlMessage', import_from_module='ns.lte', parent=root_module['ns3::LteControlMessage'])
    ## lte-control-messages.h (module 'lte'): ns3::DlDciLteControlMessage [class]
    module.add_class('DlDciLteControlMessage', import_from_module='ns.lte', parent=root_module['ns3::LteControlMessage'])
    ## lte-control-messages.h (module 'lte'): ns3::DlHarqFeedbackLteControlMessage [class]
    module.add_class('DlHarqFeedbackLteControlMessage', import_from_module='ns.lte', parent=root_module['ns3::LteControlMessage'])
    ## lte-rrc-header.h (module 'lte'): ns3::HandoverPreparationInfoHeader [class]
    module.add_class('HandoverPreparationInfoHeader', import_from_module='ns.lte', parent=root_module['ns3::RrcAsn1Header'])
    ## lte-radio-bearer-info.h (module 'lte'): ns3::LteDataRadioBearerInfo [class]
    module.add_class('LteDataRadioBearerInfo', import_from_module='ns.lte', parent=root_module['ns3::LteRadioBearerInfo'])
    ## lte-enb-phy.h (module 'lte'): ns3::LteEnbPhy [class]
    module.add_class('LteEnbPhy', import_from_module='ns.lte', parent=root_module['ns3::LtePhy'])
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t, uint16_t, double, uint8_t )', u'ns3::LteEnbPhy::ReportUeSinrTracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t, uint16_t, double, uint8_t )*', u'ns3::LteEnbPhy::ReportUeSinrTracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t, uint16_t, double, uint8_t )&', u'ns3::LteEnbPhy::ReportUeSinrTracedCallback&')
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t, ns3::Ptr< ns3::SpectrumValue > )', u'ns3::LteEnbPhy::ReportInterferenceTracedCallback')
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t, ns3::Ptr< ns3::SpectrumValue > )*', u'ns3::LteEnbPhy::ReportInterferenceTracedCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t, ns3::Ptr< ns3::SpectrumValue > )&', u'ns3::LteEnbPhy::ReportInterferenceTracedCallback&')
    ## lte-net-device.h (module 'lte'): ns3::LteNetDevice [class]
    module.add_class('LteNetDevice', import_from_module='ns.lte', parent=root_module['ns3::NetDevice'])
    ## lte-rrc-header.h (module 'lte'): ns3::MeasurementReportHeader [class]
    module.add_class('MeasurementReportHeader', import_from_module='ns.lte', parent=root_module['ns3::RrcUlDcchMessage'])
    ## queue-item.h (module 'network'): ns3::QueueDiscItem [class]
    module.add_class('QueueDiscItem', import_from_module='ns.network', parent=root_module['ns3::QueueItem'])
    ## lte-rrc-header.h (module 'lte'): ns3::RrcConnectToMmWaveHeader [class]
    module.add_class('RrcConnectToMmWaveHeader', import_from_module='ns.lte', parent=root_module['ns3::RrcDlCcchMessage'])
    ## lte-rrc-header.h (module 'lte'): ns3::RrcConnectionReconfigurationCompleteHeader [class]
    module.add_class('RrcConnectionReconfigurationCompleteHeader', import_from_module='ns.lte', parent=root_module['ns3::RrcUlDcchMessage'])
    ## lte-rrc-header.h (module 'lte'): ns3::RrcConnectionReconfigurationHeader [class]
    module.add_class('RrcConnectionReconfigurationHeader', import_from_module='ns.lte', parent=root_module['ns3::RrcDlDcchMessage'])
    ## lte-rrc-header.h (module 'lte'): ns3::RrcConnectionReestablishmentCompleteHeader [class]
    module.add_class('RrcConnectionReestablishmentCompleteHeader', import_from_module='ns.lte', parent=root_module['ns3::RrcUlDcchMessage'])
    ## lte-rrc-header.h (module 'lte'): ns3::RrcConnectionReestablishmentHeader [class]
    module.add_class('RrcConnectionReestablishmentHeader', import_from_module='ns.lte', parent=root_module['ns3::RrcDlCcchMessage'])
    ## lte-rrc-header.h (module 'lte'): ns3::RrcConnectionReestablishmentRejectHeader [class]
    module.add_class('RrcConnectionReestablishmentRejectHeader', import_from_module='ns.lte', parent=root_module['ns3::RrcDlCcchMessage'])
    ## lte-rrc-header.h (module 'lte'): ns3::RrcConnectionReestablishmentRequestHeader [class]
    module.add_class('RrcConnectionReestablishmentRequestHeader', import_from_module='ns.lte', parent=root_module['ns3::RrcUlCcchMessage'])
    ## lte-rrc-header.h (module 'lte'): ns3::RrcConnectionRejectHeader [class]
    module.add_class('RrcConnectionRejectHeader', import_from_module='ns.lte', parent=root_module['ns3::RrcDlCcchMessage'])
    ## lte-rrc-header.h (module 'lte'): ns3::RrcConnectionReleaseHeader [class]
    module.add_class('RrcConnectionReleaseHeader', import_from_module='ns.lte', parent=root_module['ns3::RrcDlDcchMessage'])
    ## lte-rrc-header.h (module 'lte'): ns3::RrcConnectionRequestHeader [class]
    module.add_class('RrcConnectionRequestHeader', import_from_module='ns.lte', parent=root_module['ns3::RrcUlCcchMessage'])
    ## lte-rrc-header.h (module 'lte'): ns3::RrcConnectionSetupCompleteHeader [class]
    module.add_class('RrcConnectionSetupCompleteHeader', import_from_module='ns.lte', parent=root_module['ns3::RrcUlDcchMessage'])
    ## lte-rrc-header.h (module 'lte'): ns3::RrcConnectionSetupHeader [class]
    module.add_class('RrcConnectionSetupHeader', import_from_module='ns.lte', parent=root_module['ns3::RrcDlCcchMessage'])
    ## lte-rrc-header.h (module 'lte'): ns3::RrcConnectionSwitchHeader [class]
    module.add_class('RrcConnectionSwitchHeader', import_from_module='ns.lte', parent=root_module['ns3::RrcDlDcchMessage'])
    ## lte-rrc-header.h (module 'lte'): ns3::RrcNotifySecondaryConnectedHeader [class]
    module.add_class('RrcNotifySecondaryConnectedHeader', import_from_module='ns.lte', parent=root_module['ns3::RrcUlDcchMessage'])
    ## lte-enb-net-device.h (module 'lte'): ns3::LteEnbNetDevice [class]
    module.add_class('LteEnbNetDevice', import_from_module='ns.lte', parent=root_module['ns3::LteNetDevice'])
    module.add_container('std::vector< ns3::CeBitmap_e >', 'ns3::CeBitmap_e', container_type=u'vector')
    module.add_container('std::vector< std::vector< ns3::RlcPduListElement_s > >', 'std::vector< ns3::RlcPduListElement_s >', container_type=u'vector')
    module.add_container('std::vector< unsigned char >', 'unsigned char', container_type=u'vector')
    module.add_container('std::vector< unsigned short >', 'short unsigned int', container_type=u'vector')
    module.add_container('std::vector< ns3::DlInfoListElement_s::HarqStatus_e >', 'ns3::DlInfoListElement_s::HarqStatus_e', container_type=u'vector')
    module.add_container('std::list< ns3::EpcEnbS1SapProvider::BearerToBeSwitched >', 'ns3::EpcEnbS1SapProvider::BearerToBeSwitched', container_type=u'list')
    module.add_container('std::vector< bool >', 'bool', container_type=u'vector')
    module.add_container('std::vector< ns3::EpcX2Sap::UlInterferenceOverloadIndicationItem >', 'ns3::EpcX2Sap::UlInterferenceOverloadIndicationItem', container_type=u'vector')
    module.add_container('std::vector< ns3::EpcX2Sap::UlHighInterferenceInformationItem >', 'ns3::EpcX2Sap::UlHighInterferenceInformationItem', container_type=u'vector')
    module.add_container('std::vector< ns3::EpcX2Sap::ErabToBeSetupItem >', 'ns3::EpcX2Sap::ErabToBeSetupItem', container_type=u'vector')
    module.add_container('std::vector< ns3::EpcX2Sap::RlcSetupRequest >', 'ns3::EpcX2Sap::RlcSetupRequest', container_type=u'vector')
    module.add_container('std::vector< ns3::EpcX2Sap::ErabAdmittedItem >', 'ns3::EpcX2Sap::ErabAdmittedItem', container_type=u'vector')
    module.add_container('std::vector< ns3::EpcX2Sap::ErabNotAdmittedItem >', 'ns3::EpcX2Sap::ErabNotAdmittedItem', container_type=u'vector')
    module.add_container('std::vector< ns3::EpcX2Sap::ErabsSubjectToStatusTransferItem >', 'ns3::EpcX2Sap::ErabsSubjectToStatusTransferItem', container_type=u'vector')
    module.add_container('std::vector< ns3::EpcX2Sap::CellInformationItem >', 'ns3::EpcX2Sap::CellInformationItem', container_type=u'vector')
    module.add_container('std::vector< ns3::EpcX2Sap::CellMeasurementResultItem >', 'ns3::EpcX2Sap::CellMeasurementResultItem', container_type=u'vector')
    module.add_container('std::map< unsigned long, double >', ('long unsigned int', 'double'), container_type=u'map')
    module.add_container('std::vector< ns3::VendorSpecificListElement_s >', 'ns3::VendorSpecificListElement_s', container_type=u'vector')
    module.add_container('std::vector< ns3::LogicalChannelConfigListElement_s >', 'ns3::LogicalChannelConfigListElement_s', container_type=u'vector')
    module.add_container('std::vector< ns3::PagingInfoListElement_s >', 'ns3::PagingInfoListElement_s', container_type=u'vector')
    module.add_container('std::vector< ns3::DlInfoListElement_s >', 'ns3::DlInfoListElement_s', container_type=u'vector')
    module.add_container('std::vector< ns3::RachListElement_s >', 'ns3::RachListElement_s', container_type=u'vector')
    module.add_container('std::vector< ns3::CqiListElement_s >', 'ns3::CqiListElement_s', container_type=u'vector')
    module.add_container('std::vector< ns3::UlInfoListElement_s >', 'ns3::UlInfoListElement_s', container_type=u'vector')
    module.add_container('std::vector< ns3::SrListElement_s >', 'ns3::SrListElement_s', container_type=u'vector')
    module.add_container('std::vector< ns3::MacCeListElement_s >', 'ns3::MacCeListElement_s', container_type=u'vector')
    module.add_container('std::vector< ns3::BuildDataListElement_s >', 'ns3::BuildDataListElement_s', container_type=u'vector')
    module.add_container('std::vector< ns3::BuildRarListElement_s >', 'ns3::BuildRarListElement_s', container_type=u'vector')
    module.add_container('std::vector< ns3::BuildBroadcastListElement_s >', 'ns3::BuildBroadcastListElement_s', container_type=u'vector')
    module.add_container('std::vector< ns3::UlDciListElement_s >', 'ns3::UlDciListElement_s', container_type=u'vector')
    module.add_container('std::vector< ns3::PhichListElement_s >', 'ns3::PhichListElement_s', container_type=u'vector')
    module.add_container('std::map< std::string, ns3::LogComponent * >', ('std::string', 'ns3::LogComponent *'), container_type=u'map')
    module.add_container('std::vector< ns3::LteCcmRrcSapProvider::LcsConfig >', 'ns3::LteCcmRrcSapProvider::LcsConfig', container_type=u'vector')
    module.add_container('std::vector< ns3::LteRrcSap::LogicalChannelConfig >', 'ns3::LteRrcSap::LogicalChannelConfig', container_type=u'vector')
    module.add_container('std::list< unsigned int >', 'unsigned int', container_type=u'list')
    module.add_container('std::list< double >', 'double', container_type=u'list')
    module.add_container('std::list< ns3::LteRrcSap::SrbToAddMod >', 'ns3::LteRrcSap::SrbToAddMod', container_type=u'list')
    module.add_container('std::list< ns3::LteRrcSap::DrbToAddMod >', 'ns3::LteRrcSap::DrbToAddMod', container_type=u'list')
    module.add_container('std::list< unsigned char >', 'unsigned char', container_type=u'list')
    module.add_container('std::list< ns3::LteRrcSap::CellsToAddMod >', 'ns3::LteRrcSap::CellsToAddMod', container_type=u'list')
    module.add_container('std::list< ns3::LteRrcSap::BlackCellsToAddMod >', 'ns3::LteRrcSap::BlackCellsToAddMod', container_type=u'list')
    module.add_container('std::list< ns3::LteRrcSap::MeasObjectToAddMod >', 'ns3::LteRrcSap::MeasObjectToAddMod', container_type=u'list')
    module.add_container('std::list< ns3::LteRrcSap::ReportConfigToAddMod >', 'ns3::LteRrcSap::ReportConfigToAddMod', container_type=u'list')
    module.add_container('std::list< ns3::LteRrcSap::MeasIdToAddMod >', 'ns3::LteRrcSap::MeasIdToAddMod', container_type=u'list')
    module.add_container('std::list< ns3::LteRrcSap::MeasResultScell >', 'ns3::LteRrcSap::MeasResultScell', container_type=u'list')
    module.add_container('std::list< ns3::LteRrcSap::MeasResultBestNeighCell >', 'ns3::LteRrcSap::MeasResultBestNeighCell', container_type=u'list')
    module.add_container('std::list< ns3::LteRrcSap::MeasResultEutra >', 'ns3::LteRrcSap::MeasResultEutra', container_type=u'list')
    module.add_container('std::list< ns3::LteRrcSap::SCellToAddMod >', 'ns3::LteRrcSap::SCellToAddMod', container_type=u'list')
    module.add_container('std::vector< int >', 'int', container_type=u'vector')
    module.add_container('std::map< int, double >', ('int', 'double'), container_type=u'map')
    module.add_container('std::vector< ns3::LteUeCcmRrcSapProvider::LcsConfig >', 'ns3::LteUeCcmRrcSapProvider::LcsConfig', container_type=u'vector')
    module.add_container('std::vector< ns3::LteUeCphySapUser::UeMeasurementsElement >', 'ns3::LteUeCphySapUser::UeMeasurementsElement', container_type=u'vector')
    module.add_container('std::vector< ns3::HigherLayerSelected_s >', 'ns3::HigherLayerSelected_s', container_type=u'vector')
    module.add_container('std::vector< ns3::SiMessageListElement_s >', 'ns3::SiMessageListElement_s', container_type=u'vector')
    module.add_container('std::list< ns3::Ptr< ns3::Packet > >', 'ns3::Ptr< ns3::Packet >', container_type=u'list')
    module.add_container('std::map< std::string, unsigned int >', ('std::string', 'unsigned int'), container_type=u'map')
    module.add_container('std::map< std::string, unsigned long >', ('std::string', 'long unsigned int'), container_type=u'map')
    module.add_container('std::vector< ns3::Ipv6Address >', 'ns3::Ipv6Address', container_type=u'vector')
    module.add_container('std::vector< double >', 'double', container_type=u'vector')
    module.add_container('ns3::Bands', 'ns3::BandInfo', container_type=u'vector')
    module.add_container('std::map< unsigned int, unsigned int >', ('unsigned int', 'unsigned int'), container_type=u'map')
    module.add_container('std::map< unsigned char, double >', ('unsigned char', 'double'), container_type=u'map')
    module.add_container('std::map< unsigned char, ns3::Ptr< ns3::ComponentCarrierEnb > >', ('unsigned char', 'ns3::Ptr< ns3::ComponentCarrierEnb >'), container_type=u'map')
    module.add_container('std::map< unsigned char, ns3::LteEnbRrc::MmWaveComponentCarrierConf >', ('unsigned char', 'ns3::LteEnbRrc::MmWaveComponentCarrierConf'), container_type=u'map')
    module.add_container('std::map< unsigned long, ns3::LteEnbRrc::HandoverEventInfo >', ('long unsigned int', 'ns3::LteEnbRrc::HandoverEventInfo'), container_type=u'map')
    module.add_container('ns3::HarqProcessInfoList_t', 'ns3::HarqProcessInfoElement_t', container_type=u'vector')
    module.add_container('std::list< ns3::Ptr< ns3::LteControlMessage > >', 'ns3::Ptr< ns3::LteControlMessage >', container_type=u'list')
    module.add_container('std::vector< ns3::Ptr< ns3::Packet > >', 'ns3::Ptr< ns3::Packet >', container_type=u'vector')
    module.add_container('std::vector< ns3::LteRlcAm::RetxPdu >', 'ns3::LteRlcAm::RetxPdu', container_type=u'vector')
    module.add_container('std::map< unsigned int, ns3::Ptr< ns3::Packet > >', ('unsigned int', 'ns3::Ptr< ns3::Packet >'), container_type=u'map')
    module.add_container('std::list< ns3::UlDciLteControlMessage >', 'ns3::UlDciLteControlMessage', container_type=u'list')
    typehandlers.add_type_alias(u'std::vector< std::vector< ns3::Ptr< ns3::PacketBurst > > >', u'ns3::DlHarqProcessesBuffer_t')
    typehandlers.add_type_alias(u'std::vector< std::vector< ns3::Ptr< ns3::PacketBurst > > >*', u'ns3::DlHarqProcessesBuffer_t*')
    typehandlers.add_type_alias(u'std::vector< std::vector< ns3::Ptr< ns3::PacketBurst > > >&', u'ns3::DlHarqProcessesBuffer_t&')
    typehandlers.add_type_alias(u'std::map< unsigned long, double >', u'ns3::ImsiSinrMap')
    typehandlers.add_type_alias(u'std::map< unsigned long, double >*', u'ns3::ImsiSinrMap*')
    typehandlers.add_type_alias(u'std::map< unsigned long, double >&', u'ns3::ImsiSinrMap&')
    typehandlers.add_type_alias(u'std::map< unsigned short, double >', u'ns3::CellSinrMap')
    typehandlers.add_type_alias(u'std::map< unsigned short, double >*', u'ns3::CellSinrMap*')
    typehandlers.add_type_alias(u'std::map< unsigned short, double >&', u'ns3::CellSinrMap&')
    typehandlers.add_type_alias(u'std::pair< unsigned long, unsigned long >', u'ns3::pairDevices_t')
    typehandlers.add_type_alias(u'std::pair< unsigned long, unsigned long >*', u'ns3::pairDevices_t*')
    typehandlers.add_type_alias(u'std::pair< unsigned long, unsigned long >&', u'ns3::pairDevices_t&')
    typehandlers.add_type_alias(u'std::map< ns3::TbId_t, ns3::tbInfo_t >', u'ns3::expectedTbs_t')
    typehandlers.add_type_alias(u'std::map< ns3::TbId_t, ns3::tbInfo_t >*', u'ns3::expectedTbs_t*')
    typehandlers.add_type_alias(u'std::map< ns3::TbId_t, ns3::tbInfo_t >&', u'ns3::expectedTbs_t&')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::Ptr< ns3::Packet const >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', u'ns3::LtePhyTxEndCallback')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::Ptr< ns3::Packet const >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >*', u'ns3::LtePhyTxEndCallback*')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::Ptr< ns3::Packet const >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >&', u'ns3::LtePhyTxEndCallback&')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', u'ns3::LtePhyRxDataEndErrorCallback')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >*', u'ns3::LtePhyRxDataEndErrorCallback*')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >&', u'ns3::LtePhyRxDataEndErrorCallback&')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::Ptr< ns3::Packet >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', u'ns3::LtePhyRxDataEndOkCallback')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::Ptr< ns3::Packet >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >*', u'ns3::LtePhyRxDataEndOkCallback*')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::Ptr< ns3::Packet >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >&', u'ns3::LtePhyRxDataEndOkCallback&')
    typehandlers.add_type_alias(u'ns3::Callback< void, std::list< ns3::Ptr< ns3::LteControlMessage > >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', u'ns3::LtePhyRxCtrlEndOkCallback')
    typehandlers.add_type_alias(u'ns3::Callback< void, std::list< ns3::Ptr< ns3::LteControlMessage > >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >*', u'ns3::LtePhyRxCtrlEndOkCallback*')
    typehandlers.add_type_alias(u'ns3::Callback< void, std::list< ns3::Ptr< ns3::LteControlMessage > >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >&', u'ns3::LtePhyRxCtrlEndOkCallback&')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', u'ns3::LtePhyRxCtrlEndErrorCallback')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >*', u'ns3::LtePhyRxCtrlEndErrorCallback*')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >&', u'ns3::LtePhyRxCtrlEndErrorCallback&')
    typehandlers.add_type_alias(u'ns3::Callback< void, unsigned short, ns3::Ptr< ns3::SpectrumValue >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', u'ns3::LtePhyRxPssCallback')
    typehandlers.add_type_alias(u'ns3::Callback< void, unsigned short, ns3::Ptr< ns3::SpectrumValue >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >*', u'ns3::LtePhyRxPssCallback*')
    typehandlers.add_type_alias(u'ns3::Callback< void, unsigned short, ns3::Ptr< ns3::SpectrumValue >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >&', u'ns3::LtePhyRxPssCallback&')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::DlInfoListElement_s, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', u'ns3::LtePhyDlHarqFeedbackCallback')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::DlInfoListElement_s, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >*', u'ns3::LtePhyDlHarqFeedbackCallback*')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::DlInfoListElement_s, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >&', u'ns3::LtePhyDlHarqFeedbackCallback&')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::UlInfoListElement_s, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', u'ns3::LtePhyUlHarqFeedbackCallback')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::UlInfoListElement_s, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >*', u'ns3::LtePhyUlHarqFeedbackCallback*')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::UlInfoListElement_s, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >&', u'ns3::LtePhyUlHarqFeedbackCallback&')
    typehandlers.add_type_alias(u'std::vector< ns3::HarqProcessInfoElement_t >', u'ns3::HarqProcessInfoList_t')
    typehandlers.add_type_alias(u'std::vector< ns3::HarqProcessInfoElement_t >*', u'ns3::HarqProcessInfoList_t*')
    typehandlers.add_type_alias(u'std::vector< ns3::HarqProcessInfoElement_t >&', u'ns3::HarqProcessInfoList_t&')
    typehandlers.add_type_alias(u'ns3::Callback< bool, ns3::Ptr< ns3::Packet >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', u'ns3::GenericPhyTxStartCallback')
    typehandlers.add_type_alias(u'ns3::Callback< bool, ns3::Ptr< ns3::Packet >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >*', u'ns3::GenericPhyTxStartCallback*')
    typehandlers.add_type_alias(u'ns3::Callback< bool, ns3::Ptr< ns3::Packet >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >&', u'ns3::GenericPhyTxStartCallback&')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::Ptr< ns3::Packet const >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', u'ns3::GenericPhyTxEndCallback')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::Ptr< ns3::Packet const >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >*', u'ns3::GenericPhyTxEndCallback*')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::Ptr< ns3::Packet const >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >&', u'ns3::GenericPhyTxEndCallback&')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', u'ns3::GenericPhyRxStartCallback')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >*', u'ns3::GenericPhyRxStartCallback*')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >&', u'ns3::GenericPhyRxStartCallback&')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', u'ns3::GenericPhyRxEndErrorCallback')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >*', u'ns3::GenericPhyRxEndErrorCallback*')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >&', u'ns3::GenericPhyRxEndErrorCallback&')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::Ptr< ns3::Packet >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', u'ns3::GenericPhyRxEndOkCallback')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::Ptr< ns3::Packet >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >*', u'ns3::GenericPhyRxEndOkCallback*')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::Ptr< ns3::Packet >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >&', u'ns3::GenericPhyRxEndOkCallback&')
    typehandlers.add_type_alias(u'std::vector< double >', u'ns3::Values')
    typehandlers.add_type_alias(u'std::vector< double >*', u'ns3::Values*')
    typehandlers.add_type_alias(u'std::vector< double >&', u'ns3::Values&')
    typehandlers.add_type_alias(u'std::vector< ns3::BandInfo >', u'ns3::Bands')
    typehandlers.add_type_alias(u'std::vector< ns3::BandInfo >*', u'ns3::Bands*')
    typehandlers.add_type_alias(u'std::vector< ns3::BandInfo >&', u'ns3::Bands&')
    typehandlers.add_type_alias(u'uint32_t', u'ns3::SpectrumModelUid_t')
    typehandlers.add_type_alias(u'uint32_t*', u'ns3::SpectrumModelUid_t*')
    typehandlers.add_type_alias(u'uint32_t&', u'ns3::SpectrumModelUid_t&')
    typehandlers.add_type_alias(u'void ( * ) ( std::ostream & )', u'ns3::LogTimePrinter')
    typehandlers.add_type_alias(u'void ( * ) ( std::ostream & )*', u'ns3::LogTimePrinter*')
    typehandlers.add_type_alias(u'void ( * ) ( std::ostream & )&', u'ns3::LogTimePrinter&')
    typehandlers.add_type_alias(u'void ( * ) ( std::ostream & )', u'ns3::LogNodePrinter')
    typehandlers.add_type_alias(u'void ( * ) ( std::ostream & )*', u'ns3::LogNodePrinter*')
    typehandlers.add_type_alias(u'void ( * ) ( std::ostream & )&', u'ns3::LogNodePrinter&')
    typehandlers.add_type_alias(u'ns3::Vector3D', u'ns3::Vector')
    typehandlers.add_type_alias(u'ns3::Vector3D*', u'ns3::Vector*')
    typehandlers.add_type_alias(u'ns3::Vector3D&', u'ns3::Vector&')
    module.add_typedef(root_module['ns3::Vector3D'], 'Vector')
    typehandlers.add_type_alias(u'ns3::Vector3DValue', u'ns3::VectorValue')
    typehandlers.add_type_alias(u'ns3::Vector3DValue*', u'ns3::VectorValue*')
    typehandlers.add_type_alias(u'ns3::Vector3DValue&', u'ns3::VectorValue&')
    module.add_typedef(root_module['ns3::Vector3DValue'], 'VectorValue')
    typehandlers.add_type_alias(u'ns3::Vector3DChecker', u'ns3::VectorChecker')
    typehandlers.add_type_alias(u'ns3::Vector3DChecker*', u'ns3::VectorChecker*')
    typehandlers.add_type_alias(u'ns3::Vector3DChecker&', u'ns3::VectorChecker&')
    module.add_typedef(root_module['ns3::Vector3DChecker'], 'VectorChecker')

    ## Register a nested module for the namespace Config

    nested_module = module.add_cpp_namespace('Config')
    register_types_ns3_Config(nested_module)


    ## Register a nested module for the namespace FatalImpl

    nested_module = module.add_cpp_namespace('FatalImpl')
    register_types_ns3_FatalImpl(nested_module)


    ## Register a nested module for the namespace Hash

    nested_module = module.add_cpp_namespace('Hash')
    register_types_ns3_Hash(nested_module)


    ## Register a nested module for the namespace TracedValueCallback

    nested_module = module.add_cpp_namespace('TracedValueCallback')
    register_types_ns3_TracedValueCallback(nested_module)


    ## Register a nested module for the namespace internal

    nested_module = module.add_cpp_namespace('internal')
    register_types_ns3_internal(nested_module)


    ## Register a nested module for the namespace mmwave

    nested_module = module.add_cpp_namespace('mmwave')
    register_types_ns3_mmwave(nested_module)


def register_types_ns3_Config(module):
    root_module = module.get_root()

    ## config.h (module 'core'): ns3::Config::MatchContainer [class]
    module.add_class('MatchContainer', import_from_module='ns.core')
    typehandlers.add_type_alias(u'std::vector< ns3::Ptr< ns3::Object > > const_iterator', u'ns3::Config::MatchContainer::Iterator')
    typehandlers.add_type_alias(u'std::vector< ns3::Ptr< ns3::Object > > const_iterator*', u'ns3::Config::MatchContainer::Iterator*')
    typehandlers.add_type_alias(u'std::vector< ns3::Ptr< ns3::Object > > const_iterator&', u'ns3::Config::MatchContainer::Iterator&')
    module.add_container('std::vector< ns3::Ptr< ns3::Object > >', 'ns3::Ptr< ns3::Object >', container_type=u'vector')
    module.add_container('std::vector< std::string >', 'std::string', container_type=u'vector')

def register_types_ns3_FatalImpl(module):
    root_module = module.get_root()


def register_types_ns3_Hash(module):
    root_module = module.get_root()

    ## hash-function.h (module 'core'): ns3::Hash::Implementation [class]
    module.add_class('Implementation', import_from_module='ns.core', parent=root_module['ns3::SimpleRefCount< ns3::Hash::Implementation, ns3::empty, ns3::DefaultDeleter<ns3::Hash::Implementation> >'])
    typehandlers.add_type_alias(u'uint32_t ( * ) ( char const *, std::size_t const )', u'ns3::Hash::Hash32Function_ptr')
    typehandlers.add_type_alias(u'uint32_t ( * ) ( char const *, std::size_t const )*', u'ns3::Hash::Hash32Function_ptr*')
    typehandlers.add_type_alias(u'uint32_t ( * ) ( char const *, std::size_t const )&', u'ns3::Hash::Hash32Function_ptr&')
    typehandlers.add_type_alias(u'uint64_t ( * ) ( char const *, std::size_t const )', u'ns3::Hash::Hash64Function_ptr')
    typehandlers.add_type_alias(u'uint64_t ( * ) ( char const *, std::size_t const )*', u'ns3::Hash::Hash64Function_ptr*')
    typehandlers.add_type_alias(u'uint64_t ( * ) ( char const *, std::size_t const )&', u'ns3::Hash::Hash64Function_ptr&')

    ## Register a nested module for the namespace Function

    nested_module = module.add_cpp_namespace('Function')
    register_types_ns3_Hash_Function(nested_module)


def register_types_ns3_Hash_Function(module):
    root_module = module.get_root()

    ## hash-fnv.h (module 'core'): ns3::Hash::Function::Fnv1a [class]
    module.add_class('Fnv1a', import_from_module='ns.core', parent=root_module['ns3::Hash::Implementation'])
    ## hash-function.h (module 'core'): ns3::Hash::Function::Hash32 [class]
    module.add_class('Hash32', import_from_module='ns.core', parent=root_module['ns3::Hash::Implementation'])
    ## hash-function.h (module 'core'): ns3::Hash::Function::Hash64 [class]
    module.add_class('Hash64', import_from_module='ns.core', parent=root_module['ns3::Hash::Implementation'])
    ## hash-murmur3.h (module 'core'): ns3::Hash::Function::Murmur3 [class]
    module.add_class('Murmur3', import_from_module='ns.core', parent=root_module['ns3::Hash::Implementation'])

def register_types_ns3_TracedValueCallback(module):
    root_module = module.get_root()

    typehandlers.add_type_alias(u'void ( * ) ( ns3::Time, ns3::Time )', u'ns3::TracedValueCallback::Time')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Time, ns3::Time )*', u'ns3::TracedValueCallback::Time*')
    typehandlers.add_type_alias(u'void ( * ) ( ns3::Time, ns3::Time )&', u'ns3::TracedValueCallback::Time&')
    typehandlers.add_type_alias(u'void ( * ) ( bool, bool )', u'ns3::TracedValueCallback::Bool')
    typehandlers.add_type_alias(u'void ( * ) ( bool, bool )*', u'ns3::TracedValueCallback::Bool*')
    typehandlers.add_type_alias(u'void ( * ) ( bool, bool )&', u'ns3::TracedValueCallback::Bool&')
    typehandlers.add_type_alias(u'void ( * ) ( int8_t, int8_t )', u'ns3::TracedValueCallback::Int8')
    typehandlers.add_type_alias(u'void ( * ) ( int8_t, int8_t )*', u'ns3::TracedValueCallback::Int8*')
    typehandlers.add_type_alias(u'void ( * ) ( int8_t, int8_t )&', u'ns3::TracedValueCallback::Int8&')
    typehandlers.add_type_alias(u'void ( * ) ( uint8_t, uint8_t )', u'ns3::TracedValueCallback::Uint8')
    typehandlers.add_type_alias(u'void ( * ) ( uint8_t, uint8_t )*', u'ns3::TracedValueCallback::Uint8*')
    typehandlers.add_type_alias(u'void ( * ) ( uint8_t, uint8_t )&', u'ns3::TracedValueCallback::Uint8&')
    typehandlers.add_type_alias(u'void ( * ) ( int16_t, int16_t )', u'ns3::TracedValueCallback::Int16')
    typehandlers.add_type_alias(u'void ( * ) ( int16_t, int16_t )*', u'ns3::TracedValueCallback::Int16*')
    typehandlers.add_type_alias(u'void ( * ) ( int16_t, int16_t )&', u'ns3::TracedValueCallback::Int16&')
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t, uint16_t )', u'ns3::TracedValueCallback::Uint16')
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t, uint16_t )*', u'ns3::TracedValueCallback::Uint16*')
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t, uint16_t )&', u'ns3::TracedValueCallback::Uint16&')
    typehandlers.add_type_alias(u'void ( * ) ( int32_t, int32_t )', u'ns3::TracedValueCallback::Int32')
    typehandlers.add_type_alias(u'void ( * ) ( int32_t, int32_t )*', u'ns3::TracedValueCallback::Int32*')
    typehandlers.add_type_alias(u'void ( * ) ( int32_t, int32_t )&', u'ns3::TracedValueCallback::Int32&')
    typehandlers.add_type_alias(u'void ( * ) ( uint32_t, uint32_t )', u'ns3::TracedValueCallback::Uint32')
    typehandlers.add_type_alias(u'void ( * ) ( uint32_t, uint32_t )*', u'ns3::TracedValueCallback::Uint32*')
    typehandlers.add_type_alias(u'void ( * ) ( uint32_t, uint32_t )&', u'ns3::TracedValueCallback::Uint32&')
    typehandlers.add_type_alias(u'void ( * ) ( double, double )', u'ns3::TracedValueCallback::Double')
    typehandlers.add_type_alias(u'void ( * ) ( double, double )*', u'ns3::TracedValueCallback::Double*')
    typehandlers.add_type_alias(u'void ( * ) ( double, double )&', u'ns3::TracedValueCallback::Double&')
    typehandlers.add_type_alias(u'void ( * ) (  )', u'ns3::TracedValueCallback::Void')
    typehandlers.add_type_alias(u'void ( * ) (  )*', u'ns3::TracedValueCallback::Void*')
    typehandlers.add_type_alias(u'void ( * ) (  )&', u'ns3::TracedValueCallback::Void&')

def register_types_ns3_internal(module):
    root_module = module.get_root()


def register_types_ns3_mmwave(module):
    root_module = module.get_root()

    ## antenna-array-model.h (module 'mmwave'): ns3::mmwave::AntennaArrayModel [class]
    module.add_class('AntennaArrayModel', parent=root_module['ns3::AntennaModel'])
    ## mmwave-beamforming.h (module 'mmwave'): ns3::mmwave::BeamformingParams [struct]
    module.add_class('BeamformingParams', parent=root_module['ns3::SimpleRefCount< ns3::mmwave::BeamformingParams, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::BeamformingParams> >'])
    ## buildings-obstacle-propagation-loss-model.h (module 'mmwave'): ns3::mmwave::BuildingsObstaclePropagationLossModel [class]
    module.add_class('BuildingsObstaclePropagationLossModel', parent=root_module['ns3::BuildingsPropagationLossModel'])
    ## mmwave-channel-matrix.h (module 'mmwave'): ns3::mmwave::ChannelParams [struct]
    module.add_class('ChannelParams', parent=root_module['ns3::SimpleRefCount< ns3::mmwave::ChannelParams, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::ChannelParams> >'])
    ## core-network-stats-calculator.h (module 'mmwave'): ns3::mmwave::CoreNetworkStatsCalculator [class]
    module.add_class('CoreNetworkStatsCalculator', parent=root_module['ns3::Object'])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DciInfoElement [struct]
    module.add_class('DciInfoElement')
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DciInfoElementTdma [struct]
    module.add_class('DciInfoElementTdma')
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DciInfoElementTdma::DciFormat [enumeration]
    module.add_enum('DciFormat', ['DL_dci', 'UL_dci'], outer_class=root_module['ns3::mmwave::DciInfoElementTdma'])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DlCqiInfo [struct]
    module.add_class('DlCqiInfo')
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DlCqiInfo::DlCqiType [enumeration]
    module.add_enum('DlCqiType', ['WB', 'SB'], outer_class=root_module['ns3::mmwave::DlCqiInfo'])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DlDciInfoElementTdma [struct]
    module.add_class('DlDciInfoElementTdma')
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DlHarqInfo [struct]
    module.add_class('DlHarqInfo')
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DlHarqInfo::HarqStatus [enumeration]
    module.add_enum('HarqStatus', ['ACK', 'NACK'], outer_class=root_module['ns3::mmwave::DlHarqInfo'])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::EnbPhyPacketCountParameter [struct]
    module.add_class('EnbPhyPacketCountParameter')
    ## mmwave-spectrum-phy.h (module 'mmwave'): ns3::mmwave::ExpectedTbInfo_t [struct]
    module.add_class('ExpectedTbInfo_t')
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::MacCeElement [struct]
    module.add_class('MacCeElement')
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::MacCeElement::MacCeType [enumeration]
    module.add_enum('MacCeType', ['BSR', 'PHR', 'CRNTI'], outer_class=root_module['ns3::mmwave::MacCeElement'])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::MacCeValue [struct]
    module.add_class('MacCeValue')
    ## mmwave-mac.h (module 'mmwave'): ns3::mmwave::MacPduInfo [struct]
    module.add_class('MacPduInfo')
    ## mmwave-mac-pdu-header.h (module 'mmwave'): ns3::mmwave::MacSubheader [struct]
    module.add_class('MacSubheader')
    ## mc-stats-calculator.h (module 'mmwave'): ns3::mmwave::McStatsCalculator [class]
    module.add_class('McStatsCalculator', parent=root_module['ns3::Object'])
    ## mc-ue-net-device.h (module 'mmwave'): ns3::mmwave::McUeNetDevice [class]
    module.add_class('McUeNetDevice', parent=root_module['ns3::NetDevice'])
    ## mmwave-3gpp-buildings-propagation-loss-model.h (module 'mmwave'): ns3::mmwave::MmWave3gppBuildingsPropagationLossModel [class]
    module.add_class('MmWave3gppBuildingsPropagationLossModel', parent=root_module['ns3::BuildingsPropagationLossModel'])
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::MmWave3gppChannel [class]
    module.add_class('MmWave3gppChannel', parent=root_module['ns3::SpectrumPropagationLossModel'])
    ## mmwave-3gpp-propagation-loss-model.h (module 'mmwave'): ns3::mmwave::MmWave3gppPropagationLossModel [class]
    module.add_class('MmWave3gppPropagationLossModel', parent=root_module['ns3::PropagationLossModel'])
    ## mmwave-amc.h (module 'mmwave'): ns3::mmwave::MmWaveAmc [class]
    module.add_class('MmWaveAmc', parent=root_module['ns3::Object'])
    ## mmwave-amc.h (module 'mmwave'): ns3::mmwave::MmWaveAmc::AmcModel [enumeration]
    module.add_enum('AmcModel', ['PiroEW2010', 'MiErrorModel'], outer_class=root_module['ns3::mmwave::MmWaveAmc'])
    ## mmwave-beamforming.h (module 'mmwave'): ns3::mmwave::MmWaveBeamforming [class]
    module.add_class('MmWaveBeamforming', parent=root_module['ns3::SpectrumPropagationLossModel'])
    ## mmwave-bearer-stats-calculator.h (module 'mmwave'): ns3::mmwave::MmWaveBearerStatsCalculator [class]
    module.add_class('MmWaveBearerStatsCalculator', parent=root_module['ns3::LteStatsCalculator'])
    ## mmwave-bearer-stats-connector.h (module 'mmwave'): ns3::mmwave::MmWaveBearerStatsConnector [class]
    module.add_class('MmWaveBearerStatsConnector', parent=root_module['ns3::Object'])
    ## mmwave-channel-matrix.h (module 'mmwave'): ns3::mmwave::MmWaveChannelMatrix [class]
    module.add_class('MmWaveChannelMatrix', parent=root_module['ns3::SpectrumPropagationLossModel'])
    ## mmwave-channel-raytracing.h (module 'mmwave'): ns3::mmwave::MmWaveChannelRaytracing [class]
    module.add_class('MmWaveChannelRaytracing', parent=root_module['ns3::SpectrumPropagationLossModel'])
    ## mmwave-component-carrier.h (module 'mmwave'): ns3::mmwave::MmWaveComponentCarrier [class]
    module.add_class('MmWaveComponentCarrier', parent=root_module['ns3::Object'])
    ## mmwave-component-carrier-enb.h (module 'mmwave'): ns3::mmwave::MmWaveComponentCarrierEnb [class]
    module.add_class('MmWaveComponentCarrierEnb', parent=root_module['ns3::mmwave::MmWaveComponentCarrier'])
    ## mmwave-component-carrier-ue.h (module 'mmwave'): ns3::mmwave::MmWaveComponentCarrierUe [class]
    module.add_class('MmWaveComponentCarrierUe', parent=root_module['ns3::mmwave::MmWaveComponentCarrier'])
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::MmWaveControlMessage [class]
    module.add_class('MmWaveControlMessage', parent=root_module['ns3::SimpleRefCount< ns3::mmwave::MmWaveControlMessage, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::MmWaveControlMessage> >'])
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::MmWaveControlMessage::messageType [enumeration]
    module.add_enum('messageType', ['DCI', 'DCI_TDMA', 'DL_CQI', 'MIB', 'SIB1', 'RACH_PREAMBLE', 'RAR', 'BSR', 'DL_HARQ'], outer_class=root_module['ns3::mmwave::MmWaveControlMessage'])
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::MmWaveDciMessage [class]
    module.add_class('MmWaveDciMessage', parent=root_module['ns3::mmwave::MmWaveControlMessage'])
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::MmWaveDlCqiMessage [class]
    module.add_class('MmWaveDlCqiMessage', parent=root_module['ns3::mmwave::MmWaveControlMessage'])
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::MmWaveDlHarqFeedbackMessage [class]
    module.add_class('MmWaveDlHarqFeedbackMessage', parent=root_module['ns3::mmwave::MmWaveControlMessage'])
    ## mmwave-enb-mac.h (module 'mmwave'): ns3::mmwave::MmWaveDlHarqProcessInfo [struct]
    module.add_class('MmWaveDlHarqProcessInfo')
    ## mmwave-enb-mac.h (module 'mmwave'): ns3::mmwave::MmWaveEnbMac [class]
    module.add_class('MmWaveEnbMac', parent=root_module['ns3::Object'])
    ## mmwave-enb-mac.h (module 'mmwave'): ns3::mmwave::MmWaveEnbMac::ReportBufferStatusParameters [struct]
    module.add_class('ReportBufferStatusParameters', outer_class=root_module['ns3::mmwave::MmWaveEnbMac'])
    ## mmwave-enb-mac.h (module 'mmwave'): ns3::mmwave::MmWaveEnbMac::TransmitPduParameters [struct]
    module.add_class('TransmitPduParameters', outer_class=root_module['ns3::mmwave::MmWaveEnbMac'])
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t, uint16_t, uint32_t, uint8_t )', u'ns3::mmwave::MmWaveEnbMac::HarqRetxCallback')
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t, uint16_t, uint32_t, uint8_t )*', u'ns3::mmwave::MmWaveEnbMac::HarqRetxCallback*')
    typehandlers.add_type_alias(u'void ( * ) ( uint16_t, uint16_t, uint32_t, uint8_t )&', u'ns3::mmwave::MmWaveEnbMac::HarqRetxCallback&')
    ## mmwave-phy-sap.h (module 'mmwave'): ns3::mmwave::MmWaveEnbPhySapUser [class]
    module.add_class('MmWaveEnbPhySapUser', allow_subclassing=True)
    ## mmwave-rrc-protocol-ideal.h (module 'mmwave'): ns3::mmwave::MmWaveEnbRrcProtocolIdeal [class]
    module.add_class('MmWaveEnbRrcProtocolIdeal', parent=root_module['ns3::Object'])
    ## mmwave-harq-phy.h (module 'mmwave'): ns3::mmwave::MmWaveHarqPhy [class]
    module.add_class('MmWaveHarqPhy', parent=root_module['ns3::SimpleRefCount< ns3::mmwave::MmWaveHarqPhy, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::MmWaveHarqPhy> >'])
    ## mmwave-harq-phy.h (module 'mmwave'): ns3::mmwave::MmWaveHarqProcessInfoElement_t [struct]
    module.add_class('MmWaveHarqProcessInfoElement_t')
    ## mmwave-helper.h (module 'mmwave'): ns3::mmwave::MmWaveHelper [class]
    module.add_class('MmWaveHelper', parent=root_module['ns3::Object'])
    ## mmwave-los-tracker.h (module 'mmwave'): ns3::mmwave::MmWaveLosTracker [class]
    module.add_class('MmWaveLosTracker', parent=root_module['ns3::Object'])
    ## mmwave-lte-rrc-protocol-real.h (module 'mmwave'): ns3::mmwave::MmWaveLteEnbRrcProtocolReal [class]
    module.add_class('MmWaveLteEnbRrcProtocolReal', parent=root_module['ns3::Object'])
    ## mmwave-lte-rrc-protocol-real.h (module 'mmwave'): ns3::mmwave::MmWaveLteUeRrcProtocolReal [class]
    module.add_class('MmWaveLteUeRrcProtocolReal', parent=root_module['ns3::Object'])
    ## mmwave-mac.h (module 'mmwave'): ns3::mmwave::MmWaveMac [class]
    module.add_class('MmWaveMac', parent=root_module['ns3::Object'])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider [class]
    module.add_class('MmWaveMacCschedSapProvider', allow_subclassing=True)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters [struct]
    module.add_class('CschedCellConfigReqParameters', outer_class=root_module['ns3::mmwave::MmWaveMacCschedSapProvider'])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::HoppingMode_e [enumeration]
    module.add_enum('HoppingMode_e', ['inter', 'interintra'], outer_class=root_module['ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters'])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::PhichResource_e [enumeration]
    module.add_enum('PhichResource_e', ['PHICH_R_ONE_SIXTH', 'PHICH_R_HALF', 'PHICH_R_ONE', 'PHICH_R_TWO'], outer_class=root_module['ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters'])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::DuplexMode_e [enumeration]
    module.add_enum('DuplexMode_e', ['DM_TDD', 'DM_FDD'], outer_class=root_module['ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters'])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::Enable64Qam_e [enumeration]
    module.add_enum('Enable64Qam_e', ['MOD_16QAM', 'MOD_64QAM'], outer_class=root_module['ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters'])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedLcConfigReqParameters [struct]
    module.add_class('CschedLcConfigReqParameters', outer_class=root_module['ns3::mmwave::MmWaveMacCschedSapProvider'])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedLcReleaseReqParameters [struct]
    module.add_class('CschedLcReleaseReqParameters', outer_class=root_module['ns3::mmwave::MmWaveMacCschedSapProvider'])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters [struct]
    module.add_class('CschedUeConfigReqParameters', outer_class=root_module['ns3::mmwave::MmWaveMacCschedSapProvider'])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters::MeasGapConfigPattern_e [enumeration]
    module.add_enum('MeasGapConfigPattern_e', ['MGP_GP1', 'MGP_GP2', 'OFF'], outer_class=root_module['ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters'])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters::OpenClosedLoop_e [enumeration]
    module.add_enum('OpenClosedLoop_e', ['noneloop', 'openloop', 'closedloop'], outer_class=root_module['ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters'])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters::RepMode_e [enumeration]
    module.add_enum('RepMode_e', ['rm12', 'rm20', 'rm22', 'rm30', 'rm31', 'nonemode'], outer_class=root_module['ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters'])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters::FeedbackMode_e [enumeration]
    module.add_enum('FeedbackMode_e', ['bundling', 'multiplexing'], outer_class=root_module['ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters'])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeReleaseReqParameters [struct]
    module.add_class('CschedUeReleaseReqParameters', outer_class=root_module['ns3::mmwave::MmWaveMacCschedSapProvider'])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser [class]
    module.add_class('MmWaveMacCschedSapUser', allow_subclassing=True)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedCellConfigCnfParameters [struct]
    module.add_class('CschedCellConfigCnfParameters', outer_class=root_module['ns3::mmwave::MmWaveMacCschedSapUser'])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedCellConfigUpdateIndParameters [struct]
    module.add_class('CschedCellConfigUpdateIndParameters', outer_class=root_module['ns3::mmwave::MmWaveMacCschedSapUser'])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedLcConfigCnfParameters [struct]
    module.add_class('CschedLcConfigCnfParameters', outer_class=root_module['ns3::mmwave::MmWaveMacCschedSapUser'])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedLcReleaseCnfParameters [struct]
    module.add_class('CschedLcReleaseCnfParameters', outer_class=root_module['ns3::mmwave::MmWaveMacCschedSapUser'])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedUeConfigCnfParameters [struct]
    module.add_class('CschedUeConfigCnfParameters', outer_class=root_module['ns3::mmwave::MmWaveMacCschedSapUser'])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedUeConfigUpdateIndParameters [struct]
    module.add_class('CschedUeConfigUpdateIndParameters', outer_class=root_module['ns3::mmwave::MmWaveMacCschedSapUser'])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedUeReleaseCnfParameters [struct]
    module.add_class('CschedUeReleaseCnfParameters', outer_class=root_module['ns3::mmwave::MmWaveMacCschedSapUser'])
    ## mmwave-mac-pdu-header.h (module 'mmwave'): ns3::mmwave::MmWaveMacPduHeader [class]
    module.add_class('MmWaveMacPduHeader', parent=root_module['ns3::Header'])
    ## mmwave-mac-pdu-tag.h (module 'mmwave'): ns3::mmwave::MmWaveMacPduTag [class]
    module.add_class('MmWaveMacPduTag', parent=root_module['ns3::Tag'])
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider [class]
    module.add_class('MmWaveMacSchedSapProvider', allow_subclassing=True)
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlCqiInfoReqParameters [struct]
    module.add_class('SchedDlCqiInfoReqParameters', outer_class=root_module['ns3::mmwave::MmWaveMacSchedSapProvider'])
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlRlcBufferReqParameters [struct]
    module.add_class('SchedDlRlcBufferReqParameters', outer_class=root_module['ns3::mmwave::MmWaveMacSchedSapProvider'])
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider::SchedTriggerReqParameters [struct]
    module.add_class('SchedTriggerReqParameters', outer_class=root_module['ns3::mmwave::MmWaveMacSchedSapProvider'])
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider::SchedUlCqiInfoReqParameters [struct]
    module.add_class('SchedUlCqiInfoReqParameters', outer_class=root_module['ns3::mmwave::MmWaveMacSchedSapProvider'])
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters [struct]
    module.add_class('SchedUlMacCtrlInfoReqParameters', outer_class=root_module['ns3::mmwave::MmWaveMacSchedSapProvider'])
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapUser [class]
    module.add_class('MmWaveMacSchedSapUser', allow_subclassing=True)
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapUser::SchedConfigIndParameters [struct]
    module.add_class('SchedConfigIndParameters', outer_class=root_module['ns3::mmwave::MmWaveMacSchedSapUser'])
    ## mmwave-mac-scheduler.h (module 'mmwave'): ns3::mmwave::MmWaveMacScheduler [class]
    module.add_class('MmWaveMacScheduler', parent=root_module['ns3::Object'])
    ## mmwave-mi-error-model.h (module 'mmwave'): ns3::mmwave::MmWaveMiErrorModel [class]
    module.add_class('MmWaveMiErrorModel')
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::MmWaveMibMessage [class]
    module.add_class('MmWaveMibMessage', parent=root_module['ns3::mmwave::MmWaveControlMessage'])
    ## mmwave-net-device.h (module 'mmwave'): ns3::mmwave::MmWaveNetDevice [class]
    module.add_class('MmWaveNetDevice', parent=root_module['ns3::NetDevice'])
    ## mmwave-no-op-component-carrier-manager.h (module 'mmwave'): ns3::mmwave::MmWaveNoOpComponentCarrierManager [class]
    module.add_class('MmWaveNoOpComponentCarrierManager', parent=root_module['ns3::LteEnbComponentCarrierManager'])
    ## mmwave-phy.h (module 'mmwave'): ns3::mmwave::MmWavePhy [class]
    module.add_class('MmWavePhy', parent=root_module['ns3::Object'])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::MmWavePhyMacCommon [class]
    module.add_class('MmWavePhyMacCommon', parent=root_module['ns3::Object'])
    ## mmwave-phy-rx-trace.h (module 'mmwave'): ns3::mmwave::MmWavePhyRxTrace [class]
    module.add_class('MmWavePhyRxTrace', parent=root_module['ns3::Object'])
    ## mmwave-phy-sap.h (module 'mmwave'): ns3::mmwave::MmWavePhySapProvider [class]
    module.add_class('MmWavePhySapProvider', allow_subclassing=True)
    ## mmwave-point-to-point-epc-helper.h (module 'mmwave'): ns3::mmwave::MmWavePointToPointEpcHelper [class]
    module.add_class('MmWavePointToPointEpcHelper', parent=root_module['ns3::EpcHelper'])
    ## mmwave-propagation-loss-model.h (module 'mmwave'): ns3::mmwave::MmWavePropagationLossModel [class]
    module.add_class('MmWavePropagationLossModel', parent=root_module['ns3::PropagationLossModel'])
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::MmWaveRachPreambleMessage [class]
    module.add_class('MmWaveRachPreambleMessage', parent=root_module['ns3::mmwave::MmWaveControlMessage'])
    ## mmwave-radio-bearer-tag.h (module 'mmwave'): ns3::mmwave::MmWaveRadioBearerTag [class]
    module.add_class('MmWaveRadioBearerTag', parent=root_module['ns3::Tag'])
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::MmWaveRarMessage [class]
    module.add_class('MmWaveRarMessage', parent=root_module['ns3::mmwave::MmWaveControlMessage'])
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::MmWaveRarMessage::Rar [struct]
    module.add_class('Rar', outer_class=root_module['ns3::mmwave::MmWaveRarMessage'])
    ## mmwave-lte-rrc-protocol-real.h (module 'mmwave'): ns3::mmwave::MmWaveRealProtocolRlcSapUser [class]
    module.add_class('MmWaveRealProtocolRlcSapUser', parent=root_module['ns3::LteRlcSapUser'])
    ## mmwave-no-op-component-carrier-manager.h (module 'mmwave'): ns3::mmwave::MmWaveRrComponentCarrierManager [class]
    module.add_class('MmWaveRrComponentCarrierManager', parent=root_module['ns3::mmwave::MmWaveNoOpComponentCarrierManager'])
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::MmWaveSib1Message [class]
    module.add_class('MmWaveSib1Message', parent=root_module['ns3::mmwave::MmWaveControlMessage'])
    ## mmwave-spectrum-phy.h (module 'mmwave'): ns3::mmwave::MmWaveSpectrumPhy [class]
    module.add_class('MmWaveSpectrumPhy', parent=root_module['ns3::SpectrumPhy'])
    ## mmwave-spectrum-phy.h (module 'mmwave'): ns3::mmwave::MmWaveSpectrumPhy::State [enumeration]
    module.add_enum('State', ['IDLE', 'TX', 'RX_DATA', 'RX_CTRL'], outer_class=root_module['ns3::mmwave::MmWaveSpectrumPhy'])
    ## mmwave-spectrum-signal-parameters.h (module 'mmwave'): ns3::mmwave::MmWaveSpectrumSignalParametersDlCtrlFrame [struct]
    module.add_class('MmWaveSpectrumSignalParametersDlCtrlFrame', parent=root_module['ns3::SpectrumSignalParameters'])
    ## mmwave-spectrum-value-helper.h (module 'mmwave'): ns3::mmwave::MmWaveSpectrumValueHelper [class]
    module.add_class('MmWaveSpectrumValueHelper')
    ## mmwave-mi-error-model.h (module 'mmwave'): ns3::mmwave::MmWaveTbStats_t [struct]
    module.add_class('MmWaveTbStats_t')
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::MmWaveTdmaDciMessage [class]
    module.add_class('MmWaveTdmaDciMessage', parent=root_module['ns3::mmwave::MmWaveControlMessage'])
    ## mmwave-ue-mac.h (module 'mmwave'): ns3::mmwave::MmWaveUeMac [class]
    module.add_class('MmWaveUeMac', parent=root_module['ns3::Object'])
    ## mmwave-ue-net-device.h (module 'mmwave'): ns3::mmwave::MmWaveUeNetDevice [class]
    module.add_class('MmWaveUeNetDevice', parent=root_module['ns3::mmwave::MmWaveNetDevice'])
    ## mmwave-ue-phy.h (module 'mmwave'): ns3::mmwave::MmWaveUePhy [class]
    module.add_class('MmWaveUePhy', parent=root_module['ns3::mmwave::MmWavePhy'])
    ## mmwave-phy-sap.h (module 'mmwave'): ns3::mmwave::MmWaveUePhySapUser [class]
    module.add_class('MmWaveUePhySapUser', allow_subclassing=True)
    ## mmwave-rrc-protocol-ideal.h (module 'mmwave'): ns3::mmwave::MmWaveUeRrcProtocolIdeal [class]
    module.add_class('MmWaveUeRrcProtocolIdeal', parent=root_module['ns3::Object'])
    ## mmwave-spectrum-signal-parameters.h (module 'mmwave'): ns3::mmwave::MmwaveSpectrumSignalParametersDataFrame [struct]
    module.add_class('MmwaveSpectrumSignalParametersDataFrame', parent=root_module['ns3::SpectrumSignalParameters'])
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::Params3gpp [struct]
    module.add_class('Params3gpp', parent=root_module['ns3::SimpleRefCount< ns3::mmwave::Params3gpp, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::Params3gpp> >'])
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::ParamsTable [struct]
    module.add_class('ParamsTable', parent=root_module['ns3::Object'])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::RlcListElement [struct]
    module.add_class('RlcListElement')
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::RlcPduInfo [struct]
    module.add_class('RlcPduInfo')
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::RxPacketTraceParams [struct]
    module.add_class('RxPacketTraceParams')
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SchedInfo [struct]
    module.add_class('SchedInfo')
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SfAllocInfo [struct]
    module.add_class('SfAllocInfo')
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SfnSf [struct]
    module.add_class('SfnSf')
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SlotAllocInfo [struct]
    module.add_class('SlotAllocInfo')
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SlotAllocInfo::TddSlotType [enumeration]
    module.add_enum('TddSlotType', ['CTRL_DATA', 'DATA', 'CTRL'], outer_class=root_module['ns3::mmwave::SlotAllocInfo'])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SlotAllocInfo::TddMode [enumeration]
    module.add_enum('TddMode', ['NA', 'DL_slotAllocInfo', 'UL_slotAllocInfo'], outer_class=root_module['ns3::mmwave::SlotAllocInfo'])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SlotAllocInfo::CtrlTxMode [enumeration]
    module.add_enum('CtrlTxMode', ['ANALOG', 'DIGITAL', 'OMNI'], outer_class=root_module['ns3::mmwave::SlotAllocInfo'])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::TbAllocInfo [struct]
    module.add_class('TbAllocInfo')
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::TbInfoElement [struct]
    module.add_class('TbInfoElement')
    ## mmwave-channel-raytracing.h (module 'mmwave'): ns3::mmwave::TraceParams [struct]
    module.add_class('TraceParams', parent=root_module['ns3::SimpleRefCount< ns3::mmwave::TraceParams, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::TraceParams> >'])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::UePhyPacketCountParameter [struct]
    module.add_class('UePhyPacketCountParameter')
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::UlCqiInfo [struct]
    module.add_class('UlCqiInfo')
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::UlCqiInfo::UlCqiType [enumeration]
    module.add_enum('UlCqiType', ['SRS', 'PUSCH', 'PUCCH_1', 'PUCCH_2', 'PRACH'], outer_class=root_module['ns3::mmwave::UlCqiInfo'])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::UlHarqInfo [struct]
    module.add_class('UlHarqInfo')
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::UlHarqInfo::ReceptionStatus [enumeration]
    module.add_enum('ReceptionStatus', ['Ok', 'NotOk', 'NotValid'], outer_class=root_module['ns3::mmwave::UlHarqInfo'])
    ## mmwave-3gpp-propagation-loss-model.h (module 'mmwave'): ns3::mmwave::channelCondition [struct]
    module.add_class('channelCondition')
    ## mmwave-beamforming.h (module 'mmwave'): ns3::mmwave::channelMatrix [struct]
    module.add_class('channelMatrix', parent=root_module['ns3::SimpleRefCount< ns3::mmwave::channelMatrix, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::channelMatrix> >'])
    ## mmwave-propagation-loss-model.h (module 'mmwave'): ns3::mmwave::channelScenario [struct]
    module.add_class('channelScenario')
    ## mmwave-channel-matrix.h (module 'mmwave'): ns3::mmwave::mmWaveBeamFormingParams [struct]
    module.add_class('mmWaveBeamFormingParams', parent=root_module['ns3::SimpleRefCount< ns3::mmwave::mmWaveBeamFormingParams, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::mmWaveBeamFormingParams> >'])
    ## mmwave-channel-raytracing.h (module 'mmwave'): ns3::mmwave::mmWaveBeamFormingTraces [struct]
    module.add_class('mmWaveBeamFormingTraces', parent=root_module['ns3::SimpleRefCount< ns3::mmwave::mmWaveBeamFormingTraces, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::mmWaveBeamFormingTraces> >'])
    ## mmwave-chunk-processor.h (module 'mmwave'): ns3::mmwave::mmWaveChunkProcessor [class]
    module.add_class('mmWaveChunkProcessor', parent=root_module['ns3::SimpleRefCount< ns3::mmwave::mmWaveChunkProcessor, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::mmWaveChunkProcessor> >'])
    ## mmwave-interference.h (module 'mmwave'): ns3::mmwave::mmWaveInterference [class]
    module.add_class('mmWaveInterference', parent=root_module['ns3::Object'])
    ## mmwave-spectrum-signal-parameters.h (module 'mmwave'): ns3::mmwave::mmwaveSpectrumSignalParameters [struct]
    module.add_class('mmwaveSpectrumSignalParameters', parent=root_module['ns3::SpectrumSignalParameters'])
    ## mmwave-no-op-component-carrier-manager.h (module 'mmwave'): ns3::mmwave::MmWaveBaRrComponentCarrierManager [class]
    module.add_class('MmWaveBaRrComponentCarrierManager', parent=root_module['ns3::mmwave::MmWaveNoOpComponentCarrierManager'])
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::MmWaveBsrMessage [class]
    module.add_class('MmWaveBsrMessage', parent=root_module['ns3::mmwave::MmWaveControlMessage'])
    ## mmwave-enb-net-device.h (module 'mmwave'): ns3::mmwave::MmWaveEnbNetDevice [class]
    module.add_class('MmWaveEnbNetDevice', parent=root_module['ns3::mmwave::MmWaveNetDevice'])
    ## mmwave-enb-phy.h (module 'mmwave'): ns3::mmwave::MmWaveEnbPhy [class]
    module.add_class('MmWaveEnbPhy', parent=root_module['ns3::mmwave::MmWavePhy'])
    ## mmwave-flex-tti-mac-scheduler.h (module 'mmwave'): ns3::mmwave::MmWaveFlexTtiMacScheduler [class]
    module.add_class('MmWaveFlexTtiMacScheduler', parent=root_module['ns3::mmwave::MmWaveMacScheduler'])
    typehandlers.add_type_alias(u'std::vector< unsigned char >', u'ns3::mmwave::MmWaveFlexTtiMacScheduler::DlHarqProcessesStatus_t')
    typehandlers.add_type_alias(u'std::vector< unsigned char >*', u'ns3::mmwave::MmWaveFlexTtiMacScheduler::DlHarqProcessesStatus_t*')
    typehandlers.add_type_alias(u'std::vector< unsigned char >&', u'ns3::mmwave::MmWaveFlexTtiMacScheduler::DlHarqProcessesStatus_t&')
    typehandlers.add_type_alias(u'std::vector< unsigned char >', u'ns3::mmwave::MmWaveFlexTtiMacScheduler::DlHarqProcessesTimer_t')
    typehandlers.add_type_alias(u'std::vector< unsigned char >*', u'ns3::mmwave::MmWaveFlexTtiMacScheduler::DlHarqProcessesTimer_t*')
    typehandlers.add_type_alias(u'std::vector< unsigned char >&', u'ns3::mmwave::MmWaveFlexTtiMacScheduler::DlHarqProcessesTimer_t&')
    typehandlers.add_type_alias(u'std::vector< ns3::mmwave::DciInfoElementTdma >', u'ns3::mmwave::MmWaveFlexTtiMacScheduler::DlHarqProcessesDciInfoList_t')
    typehandlers.add_type_alias(u'std::vector< ns3::mmwave::DciInfoElementTdma >*', u'ns3::mmwave::MmWaveFlexTtiMacScheduler::DlHarqProcessesDciInfoList_t*')
    typehandlers.add_type_alias(u'std::vector< ns3::mmwave::DciInfoElementTdma >&', u'ns3::mmwave::MmWaveFlexTtiMacScheduler::DlHarqProcessesDciInfoList_t&')
    typehandlers.add_type_alias(u'std::vector< std::vector< ns3::mmwave::RlcPduInfo > >', u'ns3::mmwave::MmWaveFlexTtiMacScheduler::DlHarqRlcPduList_t')
    typehandlers.add_type_alias(u'std::vector< std::vector< ns3::mmwave::RlcPduInfo > >*', u'ns3::mmwave::MmWaveFlexTtiMacScheduler::DlHarqRlcPduList_t*')
    typehandlers.add_type_alias(u'std::vector< std::vector< ns3::mmwave::RlcPduInfo > >&', u'ns3::mmwave::MmWaveFlexTtiMacScheduler::DlHarqRlcPduList_t&')
    typehandlers.add_type_alias(u'std::vector< unsigned char >', u'ns3::mmwave::MmWaveFlexTtiMacScheduler::UlHarqProcessesTimer_t')
    typehandlers.add_type_alias(u'std::vector< unsigned char >*', u'ns3::mmwave::MmWaveFlexTtiMacScheduler::UlHarqProcessesTimer_t*')
    typehandlers.add_type_alias(u'std::vector< unsigned char >&', u'ns3::mmwave::MmWaveFlexTtiMacScheduler::UlHarqProcessesTimer_t&')
    typehandlers.add_type_alias(u'std::vector< ns3::mmwave::DciInfoElementTdma >', u'ns3::mmwave::MmWaveFlexTtiMacScheduler::UlHarqProcessesDciInfoList_t')
    typehandlers.add_type_alias(u'std::vector< ns3::mmwave::DciInfoElementTdma >*', u'ns3::mmwave::MmWaveFlexTtiMacScheduler::UlHarqProcessesDciInfoList_t*')
    typehandlers.add_type_alias(u'std::vector< ns3::mmwave::DciInfoElementTdma >&', u'ns3::mmwave::MmWaveFlexTtiMacScheduler::UlHarqProcessesDciInfoList_t&')
    typehandlers.add_type_alias(u'std::vector< unsigned char >', u'ns3::mmwave::MmWaveFlexTtiMacScheduler::UlHarqProcessesStatus_t')
    typehandlers.add_type_alias(u'std::vector< unsigned char >*', u'ns3::mmwave::MmWaveFlexTtiMacScheduler::UlHarqProcessesStatus_t*')
    typehandlers.add_type_alias(u'std::vector< unsigned char >&', u'ns3::mmwave::MmWaveFlexTtiMacScheduler::UlHarqProcessesStatus_t&')
    ## mmwave-flex-tti-maxrate-mac-scheduler.h (module 'mmwave'): ns3::mmwave::MmWaveFlexTtiMaxRateMacScheduler [class]
    module.add_class('MmWaveFlexTtiMaxRateMacScheduler', parent=root_module['ns3::mmwave::MmWaveMacScheduler'])
    typehandlers.add_type_alias(u'std::vector< unsigned char >', u'ns3::mmwave::MmWaveFlexTtiMaxRateMacScheduler::DlHarqProcessesStatus_t')
    typehandlers.add_type_alias(u'std::vector< unsigned char >*', u'ns3::mmwave::MmWaveFlexTtiMaxRateMacScheduler::DlHarqProcessesStatus_t*')
    typehandlers.add_type_alias(u'std::vector< unsigned char >&', u'ns3::mmwave::MmWaveFlexTtiMaxRateMacScheduler::DlHarqProcessesStatus_t&')
    typehandlers.add_type_alias(u'std::vector< unsigned char >', u'ns3::mmwave::MmWaveFlexTtiMaxRateMacScheduler::DlHarqProcessesTimer_t')
    typehandlers.add_type_alias(u'std::vector< unsigned char >*', u'ns3::mmwave::MmWaveFlexTtiMaxRateMacScheduler::DlHarqProcessesTimer_t*')
    typehandlers.add_type_alias(u'std::vector< unsigned char >&', u'ns3::mmwave::MmWaveFlexTtiMaxRateMacScheduler::DlHarqProcessesTimer_t&')
    typehandlers.add_type_alias(u'std::vector< ns3::mmwave::DciInfoElementTdma >', u'ns3::mmwave::MmWaveFlexTtiMaxRateMacScheduler::DlHarqProcessesDciInfoList_t')
    typehandlers.add_type_alias(u'std::vector< ns3::mmwave::DciInfoElementTdma >*', u'ns3::mmwave::MmWaveFlexTtiMaxRateMacScheduler::DlHarqProcessesDciInfoList_t*')
    typehandlers.add_type_alias(u'std::vector< ns3::mmwave::DciInfoElementTdma >&', u'ns3::mmwave::MmWaveFlexTtiMaxRateMacScheduler::DlHarqProcessesDciInfoList_t&')
    typehandlers.add_type_alias(u'std::vector< std::vector< ns3::mmwave::RlcPduInfo > >', u'ns3::mmwave::MmWaveFlexTtiMaxRateMacScheduler::DlHarqRlcPduList_t')
    typehandlers.add_type_alias(u'std::vector< std::vector< ns3::mmwave::RlcPduInfo > >*', u'ns3::mmwave::MmWaveFlexTtiMaxRateMacScheduler::DlHarqRlcPduList_t*')
    typehandlers.add_type_alias(u'std::vector< std::vector< ns3::mmwave::RlcPduInfo > >&', u'ns3::mmwave::MmWaveFlexTtiMaxRateMacScheduler::DlHarqRlcPduList_t&')
    typehandlers.add_type_alias(u'std::vector< unsigned char >', u'ns3::mmwave::MmWaveFlexTtiMaxRateMacScheduler::UlHarqProcessesTimer_t')
    typehandlers.add_type_alias(u'std::vector< unsigned char >*', u'ns3::mmwave::MmWaveFlexTtiMaxRateMacScheduler::UlHarqProcessesTimer_t*')
    typehandlers.add_type_alias(u'std::vector< unsigned char >&', u'ns3::mmwave::MmWaveFlexTtiMaxRateMacScheduler::UlHarqProcessesTimer_t&')
    typehandlers.add_type_alias(u'std::vector< ns3::mmwave::DciInfoElementTdma >', u'ns3::mmwave::MmWaveFlexTtiMaxRateMacScheduler::UlHarqProcessesDciInfoList_t')
    typehandlers.add_type_alias(u'std::vector< ns3::mmwave::DciInfoElementTdma >*', u'ns3::mmwave::MmWaveFlexTtiMaxRateMacScheduler::UlHarqProcessesDciInfoList_t*')
    typehandlers.add_type_alias(u'std::vector< ns3::mmwave::DciInfoElementTdma >&', u'ns3::mmwave::MmWaveFlexTtiMaxRateMacScheduler::UlHarqProcessesDciInfoList_t&')
    typehandlers.add_type_alias(u'std::vector< unsigned char >', u'ns3::mmwave::MmWaveFlexTtiMaxRateMacScheduler::UlHarqProcessesStatus_t')
    typehandlers.add_type_alias(u'std::vector< unsigned char >*', u'ns3::mmwave::MmWaveFlexTtiMaxRateMacScheduler::UlHarqProcessesStatus_t*')
    typehandlers.add_type_alias(u'std::vector< unsigned char >&', u'ns3::mmwave::MmWaveFlexTtiMaxRateMacScheduler::UlHarqProcessesStatus_t&')
    ## mmwave-flex-tti-maxweight-mac-scheduler.h (module 'mmwave'): ns3::mmwave::MmWaveFlexTtiMaxWeightMacScheduler [class]
    module.add_class('MmWaveFlexTtiMaxWeightMacScheduler', parent=root_module['ns3::mmwave::MmWaveMacScheduler'])
    typehandlers.add_type_alias(u'std::vector< unsigned char >', u'ns3::mmwave::MmWaveFlexTtiMaxWeightMacScheduler::DlHarqProcessesStatus_t')
    typehandlers.add_type_alias(u'std::vector< unsigned char >*', u'ns3::mmwave::MmWaveFlexTtiMaxWeightMacScheduler::DlHarqProcessesStatus_t*')
    typehandlers.add_type_alias(u'std::vector< unsigned char >&', u'ns3::mmwave::MmWaveFlexTtiMaxWeightMacScheduler::DlHarqProcessesStatus_t&')
    typehandlers.add_type_alias(u'std::vector< unsigned char >', u'ns3::mmwave::MmWaveFlexTtiMaxWeightMacScheduler::DlHarqProcessesTimer_t')
    typehandlers.add_type_alias(u'std::vector< unsigned char >*', u'ns3::mmwave::MmWaveFlexTtiMaxWeightMacScheduler::DlHarqProcessesTimer_t*')
    typehandlers.add_type_alias(u'std::vector< unsigned char >&', u'ns3::mmwave::MmWaveFlexTtiMaxWeightMacScheduler::DlHarqProcessesTimer_t&')
    typehandlers.add_type_alias(u'std::vector< ns3::mmwave::DciInfoElementTdma >', u'ns3::mmwave::MmWaveFlexTtiMaxWeightMacScheduler::DlHarqProcessesDciInfoList_t')
    typehandlers.add_type_alias(u'std::vector< ns3::mmwave::DciInfoElementTdma >*', u'ns3::mmwave::MmWaveFlexTtiMaxWeightMacScheduler::DlHarqProcessesDciInfoList_t*')
    typehandlers.add_type_alias(u'std::vector< ns3::mmwave::DciInfoElementTdma >&', u'ns3::mmwave::MmWaveFlexTtiMaxWeightMacScheduler::DlHarqProcessesDciInfoList_t&')
    typehandlers.add_type_alias(u'std::vector< std::vector< ns3::mmwave::RlcPduInfo > >', u'ns3::mmwave::MmWaveFlexTtiMaxWeightMacScheduler::DlHarqRlcPduList_t')
    typehandlers.add_type_alias(u'std::vector< std::vector< ns3::mmwave::RlcPduInfo > >*', u'ns3::mmwave::MmWaveFlexTtiMaxWeightMacScheduler::DlHarqRlcPduList_t*')
    typehandlers.add_type_alias(u'std::vector< std::vector< ns3::mmwave::RlcPduInfo > >&', u'ns3::mmwave::MmWaveFlexTtiMaxWeightMacScheduler::DlHarqRlcPduList_t&')
    typehandlers.add_type_alias(u'std::vector< unsigned char >', u'ns3::mmwave::MmWaveFlexTtiMaxWeightMacScheduler::UlHarqProcessesTimer_t')
    typehandlers.add_type_alias(u'std::vector< unsigned char >*', u'ns3::mmwave::MmWaveFlexTtiMaxWeightMacScheduler::UlHarqProcessesTimer_t*')
    typehandlers.add_type_alias(u'std::vector< unsigned char >&', u'ns3::mmwave::MmWaveFlexTtiMaxWeightMacScheduler::UlHarqProcessesTimer_t&')
    typehandlers.add_type_alias(u'std::vector< ns3::mmwave::DciInfoElementTdma >', u'ns3::mmwave::MmWaveFlexTtiMaxWeightMacScheduler::UlHarqProcessesDciInfoList_t')
    typehandlers.add_type_alias(u'std::vector< ns3::mmwave::DciInfoElementTdma >*', u'ns3::mmwave::MmWaveFlexTtiMaxWeightMacScheduler::UlHarqProcessesDciInfoList_t*')
    typehandlers.add_type_alias(u'std::vector< ns3::mmwave::DciInfoElementTdma >&', u'ns3::mmwave::MmWaveFlexTtiMaxWeightMacScheduler::UlHarqProcessesDciInfoList_t&')
    typehandlers.add_type_alias(u'std::vector< unsigned char >', u'ns3::mmwave::MmWaveFlexTtiMaxWeightMacScheduler::UlHarqProcessesStatus_t')
    typehandlers.add_type_alias(u'std::vector< unsigned char >*', u'ns3::mmwave::MmWaveFlexTtiMaxWeightMacScheduler::UlHarqProcessesStatus_t*')
    typehandlers.add_type_alias(u'std::vector< unsigned char >&', u'ns3::mmwave::MmWaveFlexTtiMaxWeightMacScheduler::UlHarqProcessesStatus_t&')
    ## mmwave-flex-tti-pf-mac-scheduler.h (module 'mmwave'): ns3::mmwave::MmWaveFlexTtiPfMacScheduler [class]
    module.add_class('MmWaveFlexTtiPfMacScheduler', parent=root_module['ns3::mmwave::MmWaveMacScheduler'])
    typehandlers.add_type_alias(u'std::vector< unsigned char >', u'ns3::mmwave::MmWaveFlexTtiPfMacScheduler::DlHarqProcessesStatus_t')
    typehandlers.add_type_alias(u'std::vector< unsigned char >*', u'ns3::mmwave::MmWaveFlexTtiPfMacScheduler::DlHarqProcessesStatus_t*')
    typehandlers.add_type_alias(u'std::vector< unsigned char >&', u'ns3::mmwave::MmWaveFlexTtiPfMacScheduler::DlHarqProcessesStatus_t&')
    typehandlers.add_type_alias(u'std::vector< unsigned char >', u'ns3::mmwave::MmWaveFlexTtiPfMacScheduler::DlHarqProcessesTimer_t')
    typehandlers.add_type_alias(u'std::vector< unsigned char >*', u'ns3::mmwave::MmWaveFlexTtiPfMacScheduler::DlHarqProcessesTimer_t*')
    typehandlers.add_type_alias(u'std::vector< unsigned char >&', u'ns3::mmwave::MmWaveFlexTtiPfMacScheduler::DlHarqProcessesTimer_t&')
    typehandlers.add_type_alias(u'std::vector< ns3::mmwave::DciInfoElementTdma >', u'ns3::mmwave::MmWaveFlexTtiPfMacScheduler::DlHarqProcessesDciInfoList_t')
    typehandlers.add_type_alias(u'std::vector< ns3::mmwave::DciInfoElementTdma >*', u'ns3::mmwave::MmWaveFlexTtiPfMacScheduler::DlHarqProcessesDciInfoList_t*')
    typehandlers.add_type_alias(u'std::vector< ns3::mmwave::DciInfoElementTdma >&', u'ns3::mmwave::MmWaveFlexTtiPfMacScheduler::DlHarqProcessesDciInfoList_t&')
    typehandlers.add_type_alias(u'std::vector< std::vector< ns3::mmwave::RlcPduInfo > >', u'ns3::mmwave::MmWaveFlexTtiPfMacScheduler::DlHarqRlcPduList_t')
    typehandlers.add_type_alias(u'std::vector< std::vector< ns3::mmwave::RlcPduInfo > >*', u'ns3::mmwave::MmWaveFlexTtiPfMacScheduler::DlHarqRlcPduList_t*')
    typehandlers.add_type_alias(u'std::vector< std::vector< ns3::mmwave::RlcPduInfo > >&', u'ns3::mmwave::MmWaveFlexTtiPfMacScheduler::DlHarqRlcPduList_t&')
    typehandlers.add_type_alias(u'std::vector< unsigned char >', u'ns3::mmwave::MmWaveFlexTtiPfMacScheduler::UlHarqProcessesTimer_t')
    typehandlers.add_type_alias(u'std::vector< unsigned char >*', u'ns3::mmwave::MmWaveFlexTtiPfMacScheduler::UlHarqProcessesTimer_t*')
    typehandlers.add_type_alias(u'std::vector< unsigned char >&', u'ns3::mmwave::MmWaveFlexTtiPfMacScheduler::UlHarqProcessesTimer_t&')
    typehandlers.add_type_alias(u'std::vector< ns3::mmwave::DciInfoElementTdma >', u'ns3::mmwave::MmWaveFlexTtiPfMacScheduler::UlHarqProcessesDciInfoList_t')
    typehandlers.add_type_alias(u'std::vector< ns3::mmwave::DciInfoElementTdma >*', u'ns3::mmwave::MmWaveFlexTtiPfMacScheduler::UlHarqProcessesDciInfoList_t*')
    typehandlers.add_type_alias(u'std::vector< ns3::mmwave::DciInfoElementTdma >&', u'ns3::mmwave::MmWaveFlexTtiPfMacScheduler::UlHarqProcessesDciInfoList_t&')
    typehandlers.add_type_alias(u'std::vector< unsigned char >', u'ns3::mmwave::MmWaveFlexTtiPfMacScheduler::UlHarqProcessesStatus_t')
    typehandlers.add_type_alias(u'std::vector< unsigned char >*', u'ns3::mmwave::MmWaveFlexTtiPfMacScheduler::UlHarqProcessesStatus_t*')
    typehandlers.add_type_alias(u'std::vector< unsigned char >&', u'ns3::mmwave::MmWaveFlexTtiPfMacScheduler::UlHarqProcessesStatus_t&')
    module.add_container('ns3::mmwave::complexVector_t', 'std::complex< double >', container_type=u'vector')
    module.add_container('std::vector< std::complex< double > >', 'std::complex< double >', container_type=u'vector')
    module.add_container('ns3::mmwave::complex2DVector_t', 'std::vector< std::complex< double > >', container_type=u'vector')
    module.add_container('ns3::mmwave::doubleVector_t', 'double', container_type=u'vector')
    module.add_container('std::vector< ns3::mmwave::TbInfoElement >', 'ns3::mmwave::TbInfoElement', container_type=u'vector')
    module.add_container('std::map< unsigned char, ns3::Ptr< ns3::ComponentCarrierUe > >', ('unsigned char', 'ns3::Ptr< ns3::ComponentCarrierUe >'), container_type=u'map')
    module.add_container('std::map< unsigned char, ns3::Ptr< ns3::mmwave::MmWaveComponentCarrierUe > >', ('unsigned char', 'ns3::Ptr< ns3::mmwave::MmWaveComponentCarrierUe >'), container_type=u'map')
    module.add_container('ns3::mmwave::MmWaveHarqProcessInfoList_t', 'ns3::mmwave::MmWaveHarqProcessInfoElement_t', container_type=u'vector')
    module.add_container('std::map< unsigned char, ns3::mmwave::MmWaveComponentCarrier >', ('unsigned char', 'ns3::mmwave::MmWaveComponentCarrier'), container_type=u'map')
    module.add_container('std::map< unsigned char, ns3::ComponentCarrier >', ('unsigned char', 'ns3::ComponentCarrier'), container_type=u'map')
    module.add_container('std::map< unsigned char, bool >', ('unsigned char', 'bool'), container_type=u'map')
    module.add_container('std::vector< ns3::mmwave::MacSubheader >', 'ns3::mmwave::MacSubheader', container_type=u'vector')
    module.add_container('std::vector< ns3::mmwave::DlCqiInfo >', 'ns3::mmwave::DlCqiInfo', container_type=u'vector')
    module.add_container('std::vector< ns3::mmwave::MacCeElement >', 'ns3::mmwave::MacCeElement', container_type=u'vector')
    module.add_container('std::vector< ns3::mmwave::DlHarqInfo >', 'ns3::mmwave::DlHarqInfo', container_type=u'vector')
    module.add_container('std::vector< ns3::mmwave::UlHarqInfo >', 'ns3::mmwave::UlHarqInfo', container_type=u'vector')
    module.add_container('std::list< unsigned short >', 'short unsigned int', container_type=u'list')
    module.add_container('std::map< unsigned short, ns3::mmwave::SchedInfo >', ('short unsigned int', 'ns3::mmwave::SchedInfo'), container_type=u'map')
    module.add_container('std::list< ns3::Ptr< ns3::mmwave::MmWaveControlMessage > >', 'ns3::Ptr< ns3::mmwave::MmWaveControlMessage >', container_type=u'list')
    module.add_container('ns3::mmwave::complex3DVector_t', 'std::vector< std::vector< std::complex< double > > >', container_type=u'vector')
    module.add_container('ns3::mmwave::double2DVector_t', 'std::vector< double >', container_type=u'vector')
    module.add_container('std::map< ns3::Ptr< ns3::NetDevice >, std::vector< std::complex< double > > >', ('ns3::Ptr< ns3::NetDevice >', 'std::vector< std::complex< double > >'), container_type=u'map')
    module.add_container('std::vector< ns3::mmwave::RlcPduInfo >', 'ns3::mmwave::RlcPduInfo', container_type=u'vector')
    module.add_container('std::map< unsigned char, std::vector< ns3::mmwave::RlcPduInfo > >', ('unsigned char', 'std::vector< ns3::mmwave::RlcPduInfo >'), container_type=u'map')
    module.add_container('std::deque< ns3::mmwave::SlotAllocInfo >', 'ns3::mmwave::SlotAllocInfo', container_type=u'dequeue')
    module.add_container('std::vector< unsigned int >', 'unsigned int', container_type=u'vector')
    module.add_container('std::map< unsigned char, ns3::Ptr< ns3::mmwave::MmWaveComponentCarrierEnb > >', ('unsigned char', 'ns3::Ptr< ns3::mmwave::MmWaveComponentCarrierEnb >'), container_type=u'map')
    module.add_container('std::vector< ns3::mmwave::DciInfoElementTdma >', 'ns3::mmwave::DciInfoElementTdma', container_type=u'vector')
    module.add_container('std::vector< std::vector< ns3::mmwave::RlcPduInfo > >', 'std::vector< ns3::mmwave::RlcPduInfo >', container_type=u'vector')
    typehandlers.add_type_alias(u'std::vector< std::complex< double > >', u'ns3::mmwave::complexVector_t')
    typehandlers.add_type_alias(u'std::vector< std::complex< double > >*', u'ns3::mmwave::complexVector_t*')
    typehandlers.add_type_alias(u'std::vector< std::complex< double > >&', u'ns3::mmwave::complexVector_t&')
    typehandlers.add_type_alias(u'std::map< std::pair< ns3::Ptr< ns3::MobilityModel >, ns3::Ptr< ns3::MobilityModel > >, ns3::mmwave::channelScenario >', u'ns3::mmwave::channelScenarioMap_t')
    typehandlers.add_type_alias(u'std::map< std::pair< ns3::Ptr< ns3::MobilityModel >, ns3::Ptr< ns3::MobilityModel > >, ns3::mmwave::channelScenario >*', u'ns3::mmwave::channelScenarioMap_t*')
    typehandlers.add_type_alias(u'std::map< std::pair< ns3::Ptr< ns3::MobilityModel >, ns3::Ptr< ns3::MobilityModel > >, ns3::mmwave::channelScenario >&', u'ns3::mmwave::channelScenarioMap_t&')
    typehandlers.add_type_alias(u'std::vector< double >', u'ns3::mmwave::doubleVector_t')
    typehandlers.add_type_alias(u'std::vector< double >*', u'ns3::mmwave::doubleVector_t*')
    typehandlers.add_type_alias(u'std::vector< double >&', u'ns3::mmwave::doubleVector_t&')
    typehandlers.add_type_alias(u'std::vector< std::vector< std::complex< double > > >', u'ns3::mmwave::complex2DVector_t')
    typehandlers.add_type_alias(u'std::vector< std::vector< std::complex< double > > >*', u'ns3::mmwave::complex2DVector_t*')
    typehandlers.add_type_alias(u'std::vector< std::vector< std::complex< double > > >&', u'ns3::mmwave::complex2DVector_t&')
    typehandlers.add_type_alias(u'std::pair< ns3::Ptr< ns3::NetDevice >, ns3::Ptr< ns3::NetDevice > >', u'ns3::mmwave::key_t')
    typehandlers.add_type_alias(u'std::pair< ns3::Ptr< ns3::NetDevice >, ns3::Ptr< ns3::NetDevice > >*', u'ns3::mmwave::key_t*')
    typehandlers.add_type_alias(u'std::pair< ns3::Ptr< ns3::NetDevice >, ns3::Ptr< ns3::NetDevice > >&', u'ns3::mmwave::key_t&')
    typehandlers.add_type_alias(u'std::map< ns3::ImsiLcidPair_t, unsigned int >', u'ns3::mmwave::Uint32Map')
    typehandlers.add_type_alias(u'std::map< ns3::ImsiLcidPair_t, unsigned int >*', u'ns3::mmwave::Uint32Map*')
    typehandlers.add_type_alias(u'std::map< ns3::ImsiLcidPair_t, unsigned int >&', u'ns3::mmwave::Uint32Map&')
    typehandlers.add_type_alias(u'std::map< ns3::ImsiLcidPair_t, unsigned long >', u'ns3::mmwave::Uint64Map')
    typehandlers.add_type_alias(u'std::map< ns3::ImsiLcidPair_t, unsigned long >*', u'ns3::mmwave::Uint64Map*')
    typehandlers.add_type_alias(u'std::map< ns3::ImsiLcidPair_t, unsigned long >&', u'ns3::mmwave::Uint64Map&')
    typehandlers.add_type_alias(u'std::map< ns3::ImsiLcidPair_t, ns3::Ptr< ns3::MinMaxAvgTotalCalculator< unsigned int > > >', u'ns3::mmwave::Uint32StatsMap')
    typehandlers.add_type_alias(u'std::map< ns3::ImsiLcidPair_t, ns3::Ptr< ns3::MinMaxAvgTotalCalculator< unsigned int > > >*', u'ns3::mmwave::Uint32StatsMap*')
    typehandlers.add_type_alias(u'std::map< ns3::ImsiLcidPair_t, ns3::Ptr< ns3::MinMaxAvgTotalCalculator< unsigned int > > >&', u'ns3::mmwave::Uint32StatsMap&')
    typehandlers.add_type_alias(u'std::map< ns3::ImsiLcidPair_t, ns3::Ptr< ns3::MinMaxAvgTotalCalculator< unsigned long > > >', u'ns3::mmwave::Uint64StatsMap')
    typehandlers.add_type_alias(u'std::map< ns3::ImsiLcidPair_t, ns3::Ptr< ns3::MinMaxAvgTotalCalculator< unsigned long > > >*', u'ns3::mmwave::Uint64StatsMap*')
    typehandlers.add_type_alias(u'std::map< ns3::ImsiLcidPair_t, ns3::Ptr< ns3::MinMaxAvgTotalCalculator< unsigned long > > >&', u'ns3::mmwave::Uint64StatsMap&')
    typehandlers.add_type_alias(u'std::map< ns3::ImsiLcidPair_t, double >', u'ns3::mmwave::DoubleMap')
    typehandlers.add_type_alias(u'std::map< ns3::ImsiLcidPair_t, double >*', u'ns3::mmwave::DoubleMap*')
    typehandlers.add_type_alias(u'std::map< ns3::ImsiLcidPair_t, double >&', u'ns3::mmwave::DoubleMap&')
    typehandlers.add_type_alias(u'std::map< ns3::ImsiLcidPair_t, ns3::LteFlowId_t >', u'ns3::mmwave::FlowIdMap')
    typehandlers.add_type_alias(u'std::map< ns3::ImsiLcidPair_t, ns3::LteFlowId_t >*', u'ns3::mmwave::FlowIdMap*')
    typehandlers.add_type_alias(u'std::map< ns3::ImsiLcidPair_t, ns3::LteFlowId_t >&', u'ns3::mmwave::FlowIdMap&')
    typehandlers.add_type_alias(u'std::vector< std::vector< double > >', u'ns3::mmwave::double2DVector_t')
    typehandlers.add_type_alias(u'std::vector< std::vector< double > >*', u'ns3::mmwave::double2DVector_t*')
    typehandlers.add_type_alias(u'std::vector< std::vector< double > >&', u'ns3::mmwave::double2DVector_t&')
    typehandlers.add_type_alias(u'std::vector< std::vector< std::vector< std::complex< double > > > >', u'ns3::mmwave::complex3DVector_t')
    typehandlers.add_type_alias(u'std::vector< std::vector< std::vector< std::complex< double > > > >*', u'ns3::mmwave::complex3DVector_t*')
    typehandlers.add_type_alias(u'std::vector< std::vector< std::vector< std::complex< double > > > >&', u'ns3::mmwave::complex3DVector_t&')
    typehandlers.add_type_alias(u'std::map< std::pair< ns3::Ptr< ns3::MobilityModel >, ns3::Ptr< ns3::MobilityModel > >, ns3::mmwave::channelCondition >', u'ns3::mmwave::channelConditionMap_t')
    typehandlers.add_type_alias(u'std::map< std::pair< ns3::Ptr< ns3::MobilityModel >, ns3::Ptr< ns3::MobilityModel > >, ns3::mmwave::channelCondition >*', u'ns3::mmwave::channelConditionMap_t*')
    typehandlers.add_type_alias(u'std::map< std::pair< ns3::Ptr< ns3::MobilityModel >, ns3::Ptr< ns3::MobilityModel > >, ns3::mmwave::channelCondition >&', u'ns3::mmwave::channelConditionMap_t&')
    typehandlers.add_type_alias(u'std::vector< ns3::mmwave::MmWaveDlHarqProcessInfo >', u'ns3::mmwave::MmWaveDlHarqProcessesBuffer_t')
    typehandlers.add_type_alias(u'std::vector< ns3::mmwave::MmWaveDlHarqProcessInfo >*', u'ns3::mmwave::MmWaveDlHarqProcessesBuffer_t*')
    typehandlers.add_type_alias(u'std::vector< ns3::mmwave::MmWaveDlHarqProcessInfo >&', u'ns3::mmwave::MmWaveDlHarqProcessesBuffer_t&')
    typehandlers.add_type_alias(u'std::map< unsigned short, ns3::mmwave::ExpectedTbInfo_t >', u'ns3::mmwave::ExpectedTbMap_t')
    typehandlers.add_type_alias(u'std::map< unsigned short, ns3::mmwave::ExpectedTbInfo_t >*', u'ns3::mmwave::ExpectedTbMap_t*')
    typehandlers.add_type_alias(u'std::map< unsigned short, ns3::mmwave::ExpectedTbInfo_t >&', u'ns3::mmwave::ExpectedTbMap_t&')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::Ptr< ns3::Packet >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', u'ns3::mmwave::MmWavePhyRxDataEndOkCallback')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::Ptr< ns3::Packet >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >*', u'ns3::mmwave::MmWavePhyRxDataEndOkCallback*')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::Ptr< ns3::Packet >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >&', u'ns3::mmwave::MmWavePhyRxDataEndOkCallback&')
    typehandlers.add_type_alias(u'ns3::Callback< void, std::list< ns3::Ptr< ns3::mmwave::MmWaveControlMessage > >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', u'ns3::mmwave::MmWavePhyRxCtrlEndOkCallback')
    typehandlers.add_type_alias(u'ns3::Callback< void, std::list< ns3::Ptr< ns3::mmwave::MmWaveControlMessage > >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >*', u'ns3::mmwave::MmWavePhyRxCtrlEndOkCallback*')
    typehandlers.add_type_alias(u'ns3::Callback< void, std::list< ns3::Ptr< ns3::mmwave::MmWaveControlMessage > >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >&', u'ns3::mmwave::MmWavePhyRxCtrlEndOkCallback&')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::mmwave::DlHarqInfo, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', u'ns3::mmwave::MmWavePhyDlHarqFeedbackCallback')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::mmwave::DlHarqInfo, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >*', u'ns3::mmwave::MmWavePhyDlHarqFeedbackCallback*')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::mmwave::DlHarqInfo, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >&', u'ns3::mmwave::MmWavePhyDlHarqFeedbackCallback&')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::mmwave::UlHarqInfo, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', u'ns3::mmwave::MmWavePhyUlHarqFeedbackCallback')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::mmwave::UlHarqInfo, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >*', u'ns3::mmwave::MmWavePhyUlHarqFeedbackCallback*')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::mmwave::UlHarqInfo, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >&', u'ns3::mmwave::MmWavePhyUlHarqFeedbackCallback&')
    typehandlers.add_type_alias(u'std::vector< ns3::mmwave::MmWaveHarqProcessInfoElement_t >', u'ns3::mmwave::MmWaveHarqProcessInfoList_t')
    typehandlers.add_type_alias(u'std::vector< ns3::mmwave::MmWaveHarqProcessInfoElement_t >*', u'ns3::mmwave::MmWaveHarqProcessInfoList_t*')
    typehandlers.add_type_alias(u'std::vector< ns3::mmwave::MmWaveHarqProcessInfoElement_t >&', u'ns3::mmwave::MmWaveHarqProcessInfoList_t&')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::SpectrumValue const &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', u'ns3::mmwave::mmWaveChunkProcessorCallback')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::SpectrumValue const &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >*', u'ns3::mmwave::mmWaveChunkProcessorCallback*')
    typehandlers.add_type_alias(u'ns3::Callback< void, ns3::SpectrumValue const &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >&', u'ns3::mmwave::mmWaveChunkProcessorCallback&')
    typehandlers.add_type_alias(u'std::vector< unsigned int >', u'ns3::mmwave::allocatedUeImsiVector_t')
    typehandlers.add_type_alias(u'std::vector< unsigned int >*', u'ns3::mmwave::allocatedUeImsiVector_t*')
    typehandlers.add_type_alias(u'std::vector< unsigned int >&', u'ns3::mmwave::allocatedUeImsiVector_t&')
    typehandlers.add_type_alias(u'std::pair< ns3::Ptr< ns3::mmwave::AntennaArrayModel >, ns3::Ptr< ns3::mmwave::AntennaArrayModel > >', u'ns3::mmwave::antennaPair')
    typehandlers.add_type_alias(u'std::pair< ns3::Ptr< ns3::mmwave::AntennaArrayModel >, ns3::Ptr< ns3::mmwave::AntennaArrayModel > >*', u'ns3::mmwave::antennaPair*')
    typehandlers.add_type_alias(u'std::pair< ns3::Ptr< ns3::mmwave::AntennaArrayModel >, ns3::Ptr< ns3::mmwave::AntennaArrayModel > >&', u'ns3::mmwave::antennaPair&')
    typehandlers.add_type_alias(u'std::pair< ns3::Ptr< ns3::MobilityModel >, ns3::Ptr< ns3::MobilityModel > >', u'ns3::mmwave::keyMob_t')
    typehandlers.add_type_alias(u'std::pair< ns3::Ptr< ns3::MobilityModel >, ns3::Ptr< ns3::MobilityModel > >*', u'ns3::mmwave::keyMob_t*')
    typehandlers.add_type_alias(u'std::pair< ns3::Ptr< ns3::MobilityModel >, ns3::Ptr< ns3::MobilityModel > >&', u'ns3::mmwave::keyMob_t&')
    typehandlers.add_type_alias(u'std::vector< ns3::mmwave::SlotAllocInfo::TddSlotType >', u'ns3::mmwave::TddSlotTypeList')
    typehandlers.add_type_alias(u'std::vector< ns3::mmwave::SlotAllocInfo::TddSlotType >*', u'ns3::mmwave::TddSlotTypeList*')
    typehandlers.add_type_alias(u'std::vector< ns3::mmwave::SlotAllocInfo::TddSlotType >&', u'ns3::mmwave::TddSlotTypeList&')

def register_methods(root_module):
    register_Ns3Address_methods(root_module, root_module['ns3::Address'])
    register_Ns3AllocationRetentionPriority_methods(root_module, root_module['ns3::AllocationRetentionPriority'])
    register_Ns3Angles_methods(root_module, root_module['ns3::Angles'])
    register_Ns3AttributeConstructionList_methods(root_module, root_module['ns3::AttributeConstructionList'])
    register_Ns3AttributeConstructionListItem_methods(root_module, root_module['ns3::AttributeConstructionList::Item'])
    register_Ns3BandInfo_methods(root_module, root_module['ns3::BandInfo'])
    register_Ns3Box_methods(root_module, root_module['ns3::Box'])
    register_Ns3Buffer_methods(root_module, root_module['ns3::Buffer'])
    register_Ns3BufferIterator_methods(root_module, root_module['ns3::Buffer::Iterator'])
    register_Ns3BufferSizeLevelBsr_methods(root_module, root_module['ns3::BufferSizeLevelBsr'])
    register_Ns3BuildBroadcastListElement_s_methods(root_module, root_module['ns3::BuildBroadcastListElement_s'])
    register_Ns3BuildDataListElement_s_methods(root_module, root_module['ns3::BuildDataListElement_s'])
    register_Ns3BuildRarListElement_s_methods(root_module, root_module['ns3::BuildRarListElement_s'])
    register_Ns3BwPart_s_methods(root_module, root_module['ns3::BwPart_s'])
    register_Ns3ByteTagIterator_methods(root_module, root_module['ns3::ByteTagIterator'])
    register_Ns3ByteTagIteratorItem_methods(root_module, root_module['ns3::ByteTagIterator::Item'])
    register_Ns3ByteTagList_methods(root_module, root_module['ns3::ByteTagList'])
    register_Ns3ByteTagListIterator_methods(root_module, root_module['ns3::ByteTagList::Iterator'])
    register_Ns3ByteTagListIteratorItem_methods(root_module, root_module['ns3::ByteTagList::Iterator::Item'])
    register_Ns3CallbackBase_methods(root_module, root_module['ns3::CallbackBase'])
    register_Ns3ConstantVelocityHelper_methods(root_module, root_module['ns3::ConstantVelocityHelper'])
    register_Ns3CqiConfig_s_methods(root_module, root_module['ns3::CqiConfig_s'])
    register_Ns3CqiListElement_s_methods(root_module, root_module['ns3::CqiListElement_s'])
    register_Ns3DataOutputCallback_methods(root_module, root_module['ns3::DataOutputCallback'])
    register_Ns3DataRate_methods(root_module, root_module['ns3::DataRate'])
    register_Ns3DefaultDeleter__Ns3AttributeAccessor_methods(root_module, root_module['ns3::DefaultDeleter< ns3::AttributeAccessor >'])
    register_Ns3DefaultDeleter__Ns3AttributeChecker_methods(root_module, root_module['ns3::DefaultDeleter< ns3::AttributeChecker >'])
    register_Ns3DefaultDeleter__Ns3AttributeValue_methods(root_module, root_module['ns3::DefaultDeleter< ns3::AttributeValue >'])
    register_Ns3DefaultDeleter__Ns3CallbackImplBase_methods(root_module, root_module['ns3::DefaultDeleter< ns3::CallbackImplBase >'])
    register_Ns3DefaultDeleter__Ns3EpcTft_methods(root_module, root_module['ns3::DefaultDeleter< ns3::EpcTft >'])
    register_Ns3DefaultDeleter__Ns3EventImpl_methods(root_module, root_module['ns3::DefaultDeleter< ns3::EventImpl >'])
    register_Ns3DefaultDeleter__Ns3HashImplementation_methods(root_module, root_module['ns3::DefaultDeleter< ns3::Hash::Implementation >'])
    register_Ns3DefaultDeleter__Ns3LteControlMessage_methods(root_module, root_module['ns3::DefaultDeleter< ns3::LteControlMessage >'])
    register_Ns3DefaultDeleter__Ns3LteHarqPhy_methods(root_module, root_module['ns3::DefaultDeleter< ns3::LteHarqPhy >'])
    register_Ns3DefaultDeleter__Ns3NixVector_methods(root_module, root_module['ns3::DefaultDeleter< ns3::NixVector >'])
    register_Ns3DefaultDeleter__Ns3Packet_methods(root_module, root_module['ns3::DefaultDeleter< ns3::Packet >'])
    register_Ns3DefaultDeleter__Ns3QueueItem_methods(root_module, root_module['ns3::DefaultDeleter< ns3::QueueItem >'])
    register_Ns3DefaultDeleter__Ns3SpectrumModel_methods(root_module, root_module['ns3::DefaultDeleter< ns3::SpectrumModel >'])
    register_Ns3DefaultDeleter__Ns3SpectrumSignalParameters_methods(root_module, root_module['ns3::DefaultDeleter< ns3::SpectrumSignalParameters >'])
    register_Ns3DefaultDeleter__Ns3SpectrumValue_methods(root_module, root_module['ns3::DefaultDeleter< ns3::SpectrumValue >'])
    register_Ns3DefaultDeleter__Ns3TraceSourceAccessor_methods(root_module, root_module['ns3::DefaultDeleter< ns3::TraceSourceAccessor >'])
    register_Ns3DefaultDeleter__Ns3VendorSpecificValue_methods(root_module, root_module['ns3::DefaultDeleter< ns3::VendorSpecificValue >'])
    register_Ns3DefaultDeleter__Ns3MmwaveBeamformingParams_methods(root_module, root_module['ns3::DefaultDeleter< ns3::mmwave::BeamformingParams >'])
    register_Ns3DefaultDeleter__Ns3MmwaveChannelParams_methods(root_module, root_module['ns3::DefaultDeleter< ns3::mmwave::ChannelParams >'])
    register_Ns3DefaultDeleter__Ns3MmwaveMmWaveControlMessage_methods(root_module, root_module['ns3::DefaultDeleter< ns3::mmwave::MmWaveControlMessage >'])
    register_Ns3DefaultDeleter__Ns3MmwaveMmWaveHarqPhy_methods(root_module, root_module['ns3::DefaultDeleter< ns3::mmwave::MmWaveHarqPhy >'])
    register_Ns3DefaultDeleter__Ns3MmwaveParams3gpp_methods(root_module, root_module['ns3::DefaultDeleter< ns3::mmwave::Params3gpp >'])
    register_Ns3DefaultDeleter__Ns3MmwaveTraceParams_methods(root_module, root_module['ns3::DefaultDeleter< ns3::mmwave::TraceParams >'])
    register_Ns3DefaultDeleter__Ns3MmwaveMmWaveChunkProcessor_methods(root_module, root_module['ns3::DefaultDeleter< ns3::mmwave::mmWaveChunkProcessor >'])
    register_Ns3DlDciListElement_s_methods(root_module, root_module['ns3::DlDciListElement_s'])
    register_Ns3DlInfoListElement_s_methods(root_module, root_module['ns3::DlInfoListElement_s'])
    register_Ns3DlSchedulingCallbackInfo_methods(root_module, root_module['ns3::DlSchedulingCallbackInfo'])
    register_Ns3DrxConfig_s_methods(root_module, root_module['ns3::DrxConfig_s'])
    register_Ns3EpcEnbS1SapProvider_methods(root_module, root_module['ns3::EpcEnbS1SapProvider'])
    register_Ns3EpcEnbS1SapProviderBearerToBeSwitched_methods(root_module, root_module['ns3::EpcEnbS1SapProvider::BearerToBeSwitched'])
    register_Ns3EpcEnbS1SapProviderPathSwitchRequestParameters_methods(root_module, root_module['ns3::EpcEnbS1SapProvider::PathSwitchRequestParameters'])
    register_Ns3EpcEnbS1SapUser_methods(root_module, root_module['ns3::EpcEnbS1SapUser'])
    register_Ns3EpcEnbS1SapUserDataRadioBearerSetupRequestParameters_methods(root_module, root_module['ns3::EpcEnbS1SapUser::DataRadioBearerSetupRequestParameters'])
    register_Ns3EpcEnbS1SapUserPathSwitchRequestAcknowledgeParameters_methods(root_module, root_module['ns3::EpcEnbS1SapUser::PathSwitchRequestAcknowledgeParameters'])
    register_Ns3EpcX2Sap_methods(root_module, root_module['ns3::EpcX2Sap'])
    register_Ns3EpcX2SapCellInformationItem_methods(root_module, root_module['ns3::EpcX2Sap::CellInformationItem'])
    register_Ns3EpcX2SapCellMeasurementResultItem_methods(root_module, root_module['ns3::EpcX2Sap::CellMeasurementResultItem'])
    register_Ns3EpcX2SapCompositeAvailCapacity_methods(root_module, root_module['ns3::EpcX2Sap::CompositeAvailCapacity'])
    register_Ns3EpcX2SapErabAdmittedItem_methods(root_module, root_module['ns3::EpcX2Sap::ErabAdmittedItem'])
    register_Ns3EpcX2SapErabNotAdmittedItem_methods(root_module, root_module['ns3::EpcX2Sap::ErabNotAdmittedItem'])
    register_Ns3EpcX2SapErabToBeSetupItem_methods(root_module, root_module['ns3::EpcX2Sap::ErabToBeSetupItem'])
    register_Ns3EpcX2SapErabsSubjectToStatusTransferItem_methods(root_module, root_module['ns3::EpcX2Sap::ErabsSubjectToStatusTransferItem'])
    register_Ns3EpcX2SapHandoverFailedParams_methods(root_module, root_module['ns3::EpcX2Sap::HandoverFailedParams'])
    register_Ns3EpcX2SapHandoverPreparationFailureParams_methods(root_module, root_module['ns3::EpcX2Sap::HandoverPreparationFailureParams'])
    register_Ns3EpcX2SapHandoverRequestAckParams_methods(root_module, root_module['ns3::EpcX2Sap::HandoverRequestAckParams'])
    register_Ns3EpcX2SapHandoverRequestParams_methods(root_module, root_module['ns3::EpcX2Sap::HandoverRequestParams'])
    register_Ns3EpcX2SapLoadInformationParams_methods(root_module, root_module['ns3::EpcX2Sap::LoadInformationParams'])
    register_Ns3EpcX2SapRelativeNarrowbandTxBand_methods(root_module, root_module['ns3::EpcX2Sap::RelativeNarrowbandTxBand'])
    register_Ns3EpcX2SapResourceStatusUpdateParams_methods(root_module, root_module['ns3::EpcX2Sap::ResourceStatusUpdateParams'])
    register_Ns3EpcX2SapRlcSetupRequest_methods(root_module, root_module['ns3::EpcX2Sap::RlcSetupRequest'])
    register_Ns3EpcX2SapSecondaryHandoverCompletedParams_methods(root_module, root_module['ns3::EpcX2Sap::SecondaryHandoverCompletedParams'])
    register_Ns3EpcX2SapSecondaryHandoverParams_methods(root_module, root_module['ns3::EpcX2Sap::SecondaryHandoverParams'])
    register_Ns3EpcX2SapSnStatusTransferParams_methods(root_module, root_module['ns3::EpcX2Sap::SnStatusTransferParams'])
    register_Ns3EpcX2SapSwitchConnectionParams_methods(root_module, root_module['ns3::EpcX2Sap::SwitchConnectionParams'])
    register_Ns3EpcX2SapUeContextReleaseParams_methods(root_module, root_module['ns3::EpcX2Sap::UeContextReleaseParams'])
    register_Ns3EpcX2SapUeDataParams_methods(root_module, root_module['ns3::EpcX2Sap::UeDataParams'])
    register_Ns3EpcX2SapUeImsiSinrParams_methods(root_module, root_module['ns3::EpcX2Sap::UeImsiSinrParams'])
    register_Ns3EpcX2SapUlHighInterferenceInformationItem_methods(root_module, root_module['ns3::EpcX2Sap::UlHighInterferenceInformationItem'])
    register_Ns3EpcX2SapProvider_methods(root_module, root_module['ns3::EpcX2SapProvider'])
    register_Ns3EpcX2SapUser_methods(root_module, root_module['ns3::EpcX2SapUser'])
    register_Ns3EpsBearer_methods(root_module, root_module['ns3::EpsBearer'])
    register_Ns3EutranMeasurementMapping_methods(root_module, root_module['ns3::EutranMeasurementMapping'])
    register_Ns3EventId_methods(root_module, root_module['ns3::EventId'])
    register_Ns3FfMacCschedSapProvider_methods(root_module, root_module['ns3::FfMacCschedSapProvider'])
    register_Ns3FfMacCschedSapProviderCschedCellConfigReqParameters_methods(root_module, root_module['ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters'])
    register_Ns3FfMacCschedSapProviderCschedLcConfigReqParameters_methods(root_module, root_module['ns3::FfMacCschedSapProvider::CschedLcConfigReqParameters'])
    register_Ns3FfMacCschedSapProviderCschedLcReleaseReqParameters_methods(root_module, root_module['ns3::FfMacCschedSapProvider::CschedLcReleaseReqParameters'])
    register_Ns3FfMacCschedSapProviderCschedUeConfigReqParameters_methods(root_module, root_module['ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters'])
    register_Ns3FfMacCschedSapProviderCschedUeReleaseReqParameters_methods(root_module, root_module['ns3::FfMacCschedSapProvider::CschedUeReleaseReqParameters'])
    register_Ns3FfMacCschedSapUser_methods(root_module, root_module['ns3::FfMacCschedSapUser'])
    register_Ns3FfMacCschedSapUserCschedCellConfigCnfParameters_methods(root_module, root_module['ns3::FfMacCschedSapUser::CschedCellConfigCnfParameters'])
    register_Ns3FfMacCschedSapUserCschedCellConfigUpdateIndParameters_methods(root_module, root_module['ns3::FfMacCschedSapUser::CschedCellConfigUpdateIndParameters'])
    register_Ns3FfMacCschedSapUserCschedLcConfigCnfParameters_methods(root_module, root_module['ns3::FfMacCschedSapUser::CschedLcConfigCnfParameters'])
    register_Ns3FfMacCschedSapUserCschedLcReleaseCnfParameters_methods(root_module, root_module['ns3::FfMacCschedSapUser::CschedLcReleaseCnfParameters'])
    register_Ns3FfMacCschedSapUserCschedUeConfigCnfParameters_methods(root_module, root_module['ns3::FfMacCschedSapUser::CschedUeConfigCnfParameters'])
    register_Ns3FfMacCschedSapUserCschedUeConfigUpdateIndParameters_methods(root_module, root_module['ns3::FfMacCschedSapUser::CschedUeConfigUpdateIndParameters'])
    register_Ns3FfMacCschedSapUserCschedUeReleaseCnfParameters_methods(root_module, root_module['ns3::FfMacCschedSapUser::CschedUeReleaseCnfParameters'])
    register_Ns3FfMacSchedSapProvider_methods(root_module, root_module['ns3::FfMacSchedSapProvider'])
    register_Ns3FfMacSchedSapProviderSchedDlCqiInfoReqParameters_methods(root_module, root_module['ns3::FfMacSchedSapProvider::SchedDlCqiInfoReqParameters'])
    register_Ns3FfMacSchedSapProviderSchedDlMacBufferReqParameters_methods(root_module, root_module['ns3::FfMacSchedSapProvider::SchedDlMacBufferReqParameters'])
    register_Ns3FfMacSchedSapProviderSchedDlPagingBufferReqParameters_methods(root_module, root_module['ns3::FfMacSchedSapProvider::SchedDlPagingBufferReqParameters'])
    register_Ns3FfMacSchedSapProviderSchedDlRachInfoReqParameters_methods(root_module, root_module['ns3::FfMacSchedSapProvider::SchedDlRachInfoReqParameters'])
    register_Ns3FfMacSchedSapProviderSchedDlRlcBufferReqParameters_methods(root_module, root_module['ns3::FfMacSchedSapProvider::SchedDlRlcBufferReqParameters'])
    register_Ns3FfMacSchedSapProviderSchedDlTriggerReqParameters_methods(root_module, root_module['ns3::FfMacSchedSapProvider::SchedDlTriggerReqParameters'])
    register_Ns3FfMacSchedSapProviderSchedUlCqiInfoReqParameters_methods(root_module, root_module['ns3::FfMacSchedSapProvider::SchedUlCqiInfoReqParameters'])
    register_Ns3FfMacSchedSapProviderSchedUlMacCtrlInfoReqParameters_methods(root_module, root_module['ns3::FfMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters'])
    register_Ns3FfMacSchedSapProviderSchedUlNoiseInterferenceReqParameters_methods(root_module, root_module['ns3::FfMacSchedSapProvider::SchedUlNoiseInterferenceReqParameters'])
    register_Ns3FfMacSchedSapProviderSchedUlSrInfoReqParameters_methods(root_module, root_module['ns3::FfMacSchedSapProvider::SchedUlSrInfoReqParameters'])
    register_Ns3FfMacSchedSapProviderSchedUlTriggerReqParameters_methods(root_module, root_module['ns3::FfMacSchedSapProvider::SchedUlTriggerReqParameters'])
    register_Ns3FfMacSchedSapUser_methods(root_module, root_module['ns3::FfMacSchedSapUser'])
    register_Ns3FfMacSchedSapUserSchedDlConfigIndParameters_methods(root_module, root_module['ns3::FfMacSchedSapUser::SchedDlConfigIndParameters'])
    register_Ns3FfMacSchedSapUserSchedUlConfigIndParameters_methods(root_module, root_module['ns3::FfMacSchedSapUser::SchedUlConfigIndParameters'])
    register_Ns3GbrQosInformation_methods(root_module, root_module['ns3::GbrQosInformation'])
    register_Ns3HarqProcessInfoElement_t_methods(root_module, root_module['ns3::HarqProcessInfoElement_t'])
    register_Ns3Hasher_methods(root_module, root_module['ns3::Hasher'])
    register_Ns3HigherLayerSelected_s_methods(root_module, root_module['ns3::HigherLayerSelected_s'])
    register_Ns3ImsiLcidPair_t_methods(root_module, root_module['ns3::ImsiLcidPair_t'])
    register_Ns3Inet6SocketAddress_methods(root_module, root_module['ns3::Inet6SocketAddress'])
    register_Ns3InetSocketAddress_methods(root_module, root_module['ns3::InetSocketAddress'])
    register_Ns3Ipv4Address_methods(root_module, root_module['ns3::Ipv4Address'])
    register_Ns3Ipv4AddressHelper_methods(root_module, root_module['ns3::Ipv4AddressHelper'])
    register_Ns3Ipv4InterfaceAddress_methods(root_module, root_module['ns3::Ipv4InterfaceAddress'])
    register_Ns3Ipv4InterfaceContainer_methods(root_module, root_module['ns3::Ipv4InterfaceContainer'])
    register_Ns3Ipv4Mask_methods(root_module, root_module['ns3::Ipv4Mask'])
    register_Ns3Ipv6Address_methods(root_module, root_module['ns3::Ipv6Address'])
    register_Ns3Ipv6AddressHelper_methods(root_module, root_module['ns3::Ipv6AddressHelper'])
    register_Ns3Ipv6InterfaceAddress_methods(root_module, root_module['ns3::Ipv6InterfaceAddress'])
    register_Ns3Ipv6InterfaceContainer_methods(root_module, root_module['ns3::Ipv6InterfaceContainer'])
    register_Ns3Ipv6Prefix_methods(root_module, root_module['ns3::Ipv6Prefix'])
    register_Ns3LogComponent_methods(root_module, root_module['ns3::LogComponent'])
    register_Ns3LogicalChannelConfigListElement_s_methods(root_module, root_module['ns3::LogicalChannelConfigListElement_s'])
    register_Ns3LteAnrSapProvider_methods(root_module, root_module['ns3::LteAnrSapProvider'])
    register_Ns3LteAnrSapUser_methods(root_module, root_module['ns3::LteAnrSapUser'])
    register_Ns3LteAsSapProvider_methods(root_module, root_module['ns3::LteAsSapProvider'])
    register_Ns3LteAsSapUser_methods(root_module, root_module['ns3::LteAsSapUser'])
    register_Ns3LteCcmMacSapProvider_methods(root_module, root_module['ns3::LteCcmMacSapProvider'])
    register_Ns3LteCcmRrcSapProvider_methods(root_module, root_module['ns3::LteCcmRrcSapProvider'])
    register_Ns3LteCcmRrcSapProviderLcsConfig_methods(root_module, root_module['ns3::LteCcmRrcSapProvider::LcsConfig'])
    register_Ns3LteCcmRrcSapUser_methods(root_module, root_module['ns3::LteCcmRrcSapUser'])
    register_Ns3LteEnbCmacSapProvider_methods(root_module, root_module['ns3::LteEnbCmacSapProvider'])
    register_Ns3LteEnbCmacSapProviderAllocateNcRaPreambleReturnValue_methods(root_module, root_module['ns3::LteEnbCmacSapProvider::AllocateNcRaPreambleReturnValue'])
    register_Ns3LteEnbCmacSapProviderLcInfo_methods(root_module, root_module['ns3::LteEnbCmacSapProvider::LcInfo'])
    register_Ns3LteEnbCmacSapProviderRachConfig_methods(root_module, root_module['ns3::LteEnbCmacSapProvider::RachConfig'])
    register_Ns3LteEnbCmacSapProviderUeConfig_methods(root_module, root_module['ns3::LteEnbCmacSapProvider::UeConfig'])
    register_Ns3LteEnbCmacSapUser_methods(root_module, root_module['ns3::LteEnbCmacSapUser'])
    register_Ns3LteEnbCmacSapUserUeConfig_methods(root_module, root_module['ns3::LteEnbCmacSapUser::UeConfig'])
    register_Ns3LteEnbCphySapProvider_methods(root_module, root_module['ns3::LteEnbCphySapProvider'])
    register_Ns3LteEnbCphySapUser_methods(root_module, root_module['ns3::LteEnbCphySapUser'])
    register_Ns3LteEnbCphySapUserUeAssociatedSinrInfo_methods(root_module, root_module['ns3::LteEnbCphySapUser::UeAssociatedSinrInfo'])
    register_Ns3LteEnbPhySapProvider_methods(root_module, root_module['ns3::LteEnbPhySapProvider'])
    register_Ns3LteEnbPhySapUser_methods(root_module, root_module['ns3::LteEnbPhySapUser'])
    register_Ns3LteFfConverter_methods(root_module, root_module['ns3::LteFfConverter'])
    register_Ns3LteFfrRrcSapProvider_methods(root_module, root_module['ns3::LteFfrRrcSapProvider'])
    register_Ns3LteFfrRrcSapUser_methods(root_module, root_module['ns3::LteFfrRrcSapUser'])
    register_Ns3LteFlowId_t_methods(root_module, root_module['ns3::LteFlowId_t'])
    register_Ns3LteHandoverManagementSapProvider_methods(root_module, root_module['ns3::LteHandoverManagementSapProvider'])
    register_Ns3LteHandoverManagementSapUser_methods(root_module, root_module['ns3::LteHandoverManagementSapUser'])
    register_Ns3LteMacSapProvider_methods(root_module, root_module['ns3::LteMacSapProvider'])
    register_Ns3LteMacSapProviderReportBufferStatusParameters_methods(root_module, root_module['ns3::LteMacSapProvider::ReportBufferStatusParameters'])
    register_Ns3LteMacSapProviderTransmitPduParameters_methods(root_module, root_module['ns3::LteMacSapProvider::TransmitPduParameters'])
    register_Ns3LteMacSapUser_methods(root_module, root_module['ns3::LteMacSapUser'])
    register_Ns3LtePdcpSapProvider_methods(root_module, root_module['ns3::LtePdcpSapProvider'])
    register_Ns3LtePdcpSapProviderTransmitPdcpSduParameters_methods(root_module, root_module['ns3::LtePdcpSapProvider::TransmitPdcpSduParameters'])
    register_Ns3LtePdcpSapUser_methods(root_module, root_module['ns3::LtePdcpSapUser'])
    register_Ns3LtePdcpSapUserReceivePdcpSduParameters_methods(root_module, root_module['ns3::LtePdcpSapUser::ReceivePdcpSduParameters'])
    register_Ns3LteRlcSapProvider_methods(root_module, root_module['ns3::LteRlcSapProvider'])
    register_Ns3LteRlcSapProviderTransmitPdcpPduParameters_methods(root_module, root_module['ns3::LteRlcSapProvider::TransmitPdcpPduParameters'])
    register_Ns3LteRlcSapUser_methods(root_module, root_module['ns3::LteRlcSapUser'])
    register_Ns3LteRlcSpecificLteMacSapUser_methods(root_module, root_module['ns3::LteRlcSpecificLteMacSapUser'])
    register_Ns3LteRrcSap_methods(root_module, root_module['ns3::LteRrcSap'])
    register_Ns3LteRrcSapAntennaInfoCommon_methods(root_module, root_module['ns3::LteRrcSap::AntennaInfoCommon'])
    register_Ns3LteRrcSapAntennaInfoDedicated_methods(root_module, root_module['ns3::LteRrcSap::AntennaInfoDedicated'])
    register_Ns3LteRrcSapAntennaInfoUl_methods(root_module, root_module['ns3::LteRrcSap::AntennaInfoUl'])
    register_Ns3LteRrcSapAsConfig_methods(root_module, root_module['ns3::LteRrcSap::AsConfig'])
    register_Ns3LteRrcSapBlackCellsToAddMod_methods(root_module, root_module['ns3::LteRrcSap::BlackCellsToAddMod'])
    register_Ns3LteRrcSapCarrierBandwidthEutra_methods(root_module, root_module['ns3::LteRrcSap::CarrierBandwidthEutra'])
    register_Ns3LteRrcSapCarrierFreqEutra_methods(root_module, root_module['ns3::LteRrcSap::CarrierFreqEutra'])
    register_Ns3LteRrcSapCellAccessRelatedInfo_methods(root_module, root_module['ns3::LteRrcSap::CellAccessRelatedInfo'])
    register_Ns3LteRrcSapCellIdentification_methods(root_module, root_module['ns3::LteRrcSap::CellIdentification'])
    register_Ns3LteRrcSapCellSelectionInfo_methods(root_module, root_module['ns3::LteRrcSap::CellSelectionInfo'])
    register_Ns3LteRrcSapCellsToAddMod_methods(root_module, root_module['ns3::LteRrcSap::CellsToAddMod'])
    register_Ns3LteRrcSapCgiInfo_methods(root_module, root_module['ns3::LteRrcSap::CgiInfo'])
    register_Ns3LteRrcSapDrbToAddMod_methods(root_module, root_module['ns3::LteRrcSap::DrbToAddMod'])
    register_Ns3LteRrcSapFreqInfo_methods(root_module, root_module['ns3::LteRrcSap::FreqInfo'])
    register_Ns3LteRrcSapHandoverPreparationInfo_methods(root_module, root_module['ns3::LteRrcSap::HandoverPreparationInfo'])
    register_Ns3LteRrcSapLogicalChannelConfig_methods(root_module, root_module['ns3::LteRrcSap::LogicalChannelConfig'])
    register_Ns3LteRrcSapMasterInformationBlock_methods(root_module, root_module['ns3::LteRrcSap::MasterInformationBlock'])
    register_Ns3LteRrcSapMeasConfig_methods(root_module, root_module['ns3::LteRrcSap::MeasConfig'])
    register_Ns3LteRrcSapMeasGapConfig_methods(root_module, root_module['ns3::LteRrcSap::MeasGapConfig'])
    register_Ns3LteRrcSapMeasIdToAddMod_methods(root_module, root_module['ns3::LteRrcSap::MeasIdToAddMod'])
    register_Ns3LteRrcSapMeasObjectEutra_methods(root_module, root_module['ns3::LteRrcSap::MeasObjectEutra'])
    register_Ns3LteRrcSapMeasObjectToAddMod_methods(root_module, root_module['ns3::LteRrcSap::MeasObjectToAddMod'])
    register_Ns3LteRrcSapMeasResultBestNeighCell_methods(root_module, root_module['ns3::LteRrcSap::MeasResultBestNeighCell'])
    register_Ns3LteRrcSapMeasResultEutra_methods(root_module, root_module['ns3::LteRrcSap::MeasResultEutra'])
    register_Ns3LteRrcSapMeasResultScell_methods(root_module, root_module['ns3::LteRrcSap::MeasResultScell'])
    register_Ns3LteRrcSapMeasResultServFreqList_methods(root_module, root_module['ns3::LteRrcSap::MeasResultServFreqList'])
    register_Ns3LteRrcSapMeasResults_methods(root_module, root_module['ns3::LteRrcSap::MeasResults'])
    register_Ns3LteRrcSapMeasurementReport_methods(root_module, root_module['ns3::LteRrcSap::MeasurementReport'])
    register_Ns3LteRrcSapMobilityControlInfo_methods(root_module, root_module['ns3::LteRrcSap::MobilityControlInfo'])
    register_Ns3LteRrcSapMobilityStateParameters_methods(root_module, root_module['ns3::LteRrcSap::MobilityStateParameters'])
    register_Ns3LteRrcSapNonCriticalExtensionConfiguration_methods(root_module, root_module['ns3::LteRrcSap::NonCriticalExtensionConfiguration'])
    register_Ns3LteRrcSapNonUlConfiguration_methods(root_module, root_module['ns3::LteRrcSap::NonUlConfiguration'])
    register_Ns3LteRrcSapPdschConfigCommon_methods(root_module, root_module['ns3::LteRrcSap::PdschConfigCommon'])
    register_Ns3LteRrcSapPdschConfigDedicated_methods(root_module, root_module['ns3::LteRrcSap::PdschConfigDedicated'])
    register_Ns3LteRrcSapPhysCellIdRange_methods(root_module, root_module['ns3::LteRrcSap::PhysCellIdRange'])
    register_Ns3LteRrcSapPhysicalConfigDedicated_methods(root_module, root_module['ns3::LteRrcSap::PhysicalConfigDedicated'])
    register_Ns3LteRrcSapPhysicalConfigDedicatedSCell_methods(root_module, root_module['ns3::LteRrcSap::PhysicalConfigDedicatedSCell'])
    register_Ns3LteRrcSapPlmnIdentityInfo_methods(root_module, root_module['ns3::LteRrcSap::PlmnIdentityInfo'])
    register_Ns3LteRrcSapPrachConfigSCell_methods(root_module, root_module['ns3::LteRrcSap::PrachConfigSCell'])
    register_Ns3LteRrcSapPreambleInfo_methods(root_module, root_module['ns3::LteRrcSap::PreambleInfo'])
    register_Ns3LteRrcSapPuschConfigDedicatedSCell_methods(root_module, root_module['ns3::LteRrcSap::PuschConfigDedicatedSCell'])
    register_Ns3LteRrcSapQuantityConfig_methods(root_module, root_module['ns3::LteRrcSap::QuantityConfig'])
    register_Ns3LteRrcSapRaSupervisionInfo_methods(root_module, root_module['ns3::LteRrcSap::RaSupervisionInfo'])
    register_Ns3LteRrcSapRachConfigCommon_methods(root_module, root_module['ns3::LteRrcSap::RachConfigCommon'])
    register_Ns3LteRrcSapRachConfigDedicated_methods(root_module, root_module['ns3::LteRrcSap::RachConfigDedicated'])
    register_Ns3LteRrcSapRadioResourceConfigCommon_methods(root_module, root_module['ns3::LteRrcSap::RadioResourceConfigCommon'])
    register_Ns3LteRrcSapRadioResourceConfigCommonSCell_methods(root_module, root_module['ns3::LteRrcSap::RadioResourceConfigCommonSCell'])
    register_Ns3LteRrcSapRadioResourceConfigCommonSib_methods(root_module, root_module['ns3::LteRrcSap::RadioResourceConfigCommonSib'])
    register_Ns3LteRrcSapRadioResourceConfigDedicated_methods(root_module, root_module['ns3::LteRrcSap::RadioResourceConfigDedicated'])
    register_Ns3LteRrcSapRadioResourceConfigDedicatedSCell_methods(root_module, root_module['ns3::LteRrcSap::RadioResourceConfigDedicatedSCell'])
    register_Ns3LteRrcSapReestabUeIdentity_methods(root_module, root_module['ns3::LteRrcSap::ReestabUeIdentity'])
    register_Ns3LteRrcSapReportConfigEutra_methods(root_module, root_module['ns3::LteRrcSap::ReportConfigEutra'])
    register_Ns3LteRrcSapReportConfigToAddMod_methods(root_module, root_module['ns3::LteRrcSap::ReportConfigToAddMod'])
    register_Ns3LteRrcSapRlcConfig_methods(root_module, root_module['ns3::LteRrcSap::RlcConfig'])
    register_Ns3LteRrcSapRrcConnectionReconfiguration_methods(root_module, root_module['ns3::LteRrcSap::RrcConnectionReconfiguration'])
    register_Ns3LteRrcSapRrcConnectionReconfigurationCompleted_methods(root_module, root_module['ns3::LteRrcSap::RrcConnectionReconfigurationCompleted'])
    register_Ns3LteRrcSapRrcConnectionReestablishment_methods(root_module, root_module['ns3::LteRrcSap::RrcConnectionReestablishment'])
    register_Ns3LteRrcSapRrcConnectionReestablishmentComplete_methods(root_module, root_module['ns3::LteRrcSap::RrcConnectionReestablishmentComplete'])
    register_Ns3LteRrcSapRrcConnectionReestablishmentReject_methods(root_module, root_module['ns3::LteRrcSap::RrcConnectionReestablishmentReject'])
    register_Ns3LteRrcSapRrcConnectionReestablishmentRequest_methods(root_module, root_module['ns3::LteRrcSap::RrcConnectionReestablishmentRequest'])
    register_Ns3LteRrcSapRrcConnectionReject_methods(root_module, root_module['ns3::LteRrcSap::RrcConnectionReject'])
    register_Ns3LteRrcSapRrcConnectionRelease_methods(root_module, root_module['ns3::LteRrcSap::RrcConnectionRelease'])
    register_Ns3LteRrcSapRrcConnectionRequest_methods(root_module, root_module['ns3::LteRrcSap::RrcConnectionRequest'])
    register_Ns3LteRrcSapRrcConnectionSetup_methods(root_module, root_module['ns3::LteRrcSap::RrcConnectionSetup'])
    register_Ns3LteRrcSapRrcConnectionSetupCompleted_methods(root_module, root_module['ns3::LteRrcSap::RrcConnectionSetupCompleted'])
    register_Ns3LteRrcSapRrcConnectionSwitch_methods(root_module, root_module['ns3::LteRrcSap::RrcConnectionSwitch'])
    register_Ns3LteRrcSapSCellToAddMod_methods(root_module, root_module['ns3::LteRrcSap::SCellToAddMod'])
    register_Ns3LteRrcSapSoundingRsUlConfigCommon_methods(root_module, root_module['ns3::LteRrcSap::SoundingRsUlConfigCommon'])
    register_Ns3LteRrcSapSoundingRsUlConfigDedicated_methods(root_module, root_module['ns3::LteRrcSap::SoundingRsUlConfigDedicated'])
    register_Ns3LteRrcSapSpeedStatePars_methods(root_module, root_module['ns3::LteRrcSap::SpeedStatePars'])
    register_Ns3LteRrcSapSpeedStateScaleFactors_methods(root_module, root_module['ns3::LteRrcSap::SpeedStateScaleFactors'])
    register_Ns3LteRrcSapSrbToAddMod_methods(root_module, root_module['ns3::LteRrcSap::SrbToAddMod'])
    register_Ns3LteRrcSapSystemInformation_methods(root_module, root_module['ns3::LteRrcSap::SystemInformation'])
    register_Ns3LteRrcSapSystemInformationBlockType1_methods(root_module, root_module['ns3::LteRrcSap::SystemInformationBlockType1'])
    register_Ns3LteRrcSapSystemInformationBlockType2_methods(root_module, root_module['ns3::LteRrcSap::SystemInformationBlockType2'])
    register_Ns3LteRrcSapThresholdEutra_methods(root_module, root_module['ns3::LteRrcSap::ThresholdEutra'])
    register_Ns3LteRrcSapUlConfiguration_methods(root_module, root_module['ns3::LteRrcSap::UlConfiguration'])
    register_Ns3LteRrcSapUlPowerControlCommonSCell_methods(root_module, root_module['ns3::LteRrcSap::UlPowerControlCommonSCell'])
    register_Ns3LteRrcSapUlPowerControlDedicatedSCell_methods(root_module, root_module['ns3::LteRrcSap::UlPowerControlDedicatedSCell'])
    register_Ns3LteSpectrumValueHelper_methods(root_module, root_module['ns3::LteSpectrumValueHelper'])
    register_Ns3LteUeCcmRrcSapProvider_methods(root_module, root_module['ns3::LteUeCcmRrcSapProvider'])
    register_Ns3LteUeCcmRrcSapProviderLcsConfig_methods(root_module, root_module['ns3::LteUeCcmRrcSapProvider::LcsConfig'])
    register_Ns3LteUeCcmRrcSapUser_methods(root_module, root_module['ns3::LteUeCcmRrcSapUser'])
    register_Ns3LteUeCmacSapProvider_methods(root_module, root_module['ns3::LteUeCmacSapProvider'])
    register_Ns3LteUeCmacSapProviderLogicalChannelConfig_methods(root_module, root_module['ns3::LteUeCmacSapProvider::LogicalChannelConfig'])
    register_Ns3LteUeCmacSapProviderRachConfig_methods(root_module, root_module['ns3::LteUeCmacSapProvider::RachConfig'])
    register_Ns3LteUeCmacSapUser_methods(root_module, root_module['ns3::LteUeCmacSapUser'])
    register_Ns3LteUeConfig_t_methods(root_module, root_module['ns3::LteUeConfig_t'])
    register_Ns3LteUeCphySapProvider_methods(root_module, root_module['ns3::LteUeCphySapProvider'])
    register_Ns3LteUeCphySapUser_methods(root_module, root_module['ns3::LteUeCphySapUser'])
    register_Ns3LteUeCphySapUserUeMeasurementsElement_methods(root_module, root_module['ns3::LteUeCphySapUser::UeMeasurementsElement'])
    register_Ns3LteUeCphySapUserUeMeasurementsParameters_methods(root_module, root_module['ns3::LteUeCphySapUser::UeMeasurementsParameters'])
    register_Ns3LteUePhySapProvider_methods(root_module, root_module['ns3::LteUePhySapProvider'])
    register_Ns3LteUePhySapUser_methods(root_module, root_module['ns3::LteUePhySapUser'])
    register_Ns3LteUeRrcSapProvider_methods(root_module, root_module['ns3::LteUeRrcSapProvider'])
    register_Ns3LteUeRrcSapProviderCompleteSetupParameters_methods(root_module, root_module['ns3::LteUeRrcSapProvider::CompleteSetupParameters'])
    register_Ns3LteUeRrcSapUser_methods(root_module, root_module['ns3::LteUeRrcSapUser'])
    register_Ns3LteUeRrcSapUserSetupParameters_methods(root_module, root_module['ns3::LteUeRrcSapUser::SetupParameters'])
    register_Ns3Mac48Address_methods(root_module, root_module['ns3::Mac48Address'])
    register_Ns3Mac64Address_methods(root_module, root_module['ns3::Mac64Address'])
    register_Ns3Mac8Address_methods(root_module, root_module['ns3::Mac8Address'])
    register_Ns3MacCeListElement_s_methods(root_module, root_module['ns3::MacCeListElement_s'])
    register_Ns3MacCeValue_u_methods(root_module, root_module['ns3::MacCeValue_u'])
    register_Ns3Names_methods(root_module, root_module['ns3::Names'])
    register_Ns3NetDeviceContainer_methods(root_module, root_module['ns3::NetDeviceContainer'])
    register_Ns3NodeContainer_methods(root_module, root_module['ns3::NodeContainer'])
    register_Ns3ObjectBase_methods(root_module, root_module['ns3::ObjectBase'])
    register_Ns3ObjectDeleter_methods(root_module, root_module['ns3::ObjectDeleter'])
    register_Ns3ObjectFactory_methods(root_module, root_module['ns3::ObjectFactory'])
    register_Ns3PacketMetadata_methods(root_module, root_module['ns3::PacketMetadata'])
    register_Ns3PacketMetadataItem_methods(root_module, root_module['ns3::PacketMetadata::Item'])
    register_Ns3PacketMetadataItemIterator_methods(root_module, root_module['ns3::PacketMetadata::ItemIterator'])
    register_Ns3PacketTagIterator_methods(root_module, root_module['ns3::PacketTagIterator'])
    register_Ns3PacketTagIteratorItem_methods(root_module, root_module['ns3::PacketTagIterator::Item'])
    register_Ns3PacketTagList_methods(root_module, root_module['ns3::PacketTagList'])
    register_Ns3PacketTagListTagData_methods(root_module, root_module['ns3::PacketTagList::TagData'])
    register_Ns3PagingInfoListElement_s_methods(root_module, root_module['ns3::PagingInfoListElement_s'])
    register_Ns3ParameterLogger_methods(root_module, root_module['ns3::ParameterLogger'])
    register_Ns3PhichListElement_s_methods(root_module, root_module['ns3::PhichListElement_s'])
    register_Ns3PhyReceptionStatParameters_methods(root_module, root_module['ns3::PhyReceptionStatParameters'])
    register_Ns3PhyTransmissionStatParameters_methods(root_module, root_module['ns3::PhyTransmissionStatParameters'])
    register_Ns3QueueSize_methods(root_module, root_module['ns3::QueueSize'])
    register_Ns3RachListElement_s_methods(root_module, root_module['ns3::RachListElement_s'])
    register_Ns3RlcPduListElement_s_methods(root_module, root_module['ns3::RlcPduListElement_s'])
    register_Ns3SbMeasResult_s_methods(root_module, root_module['ns3::SbMeasResult_s'])
    register_Ns3SequenceNumber10_methods(root_module, root_module['ns3::SequenceNumber10'])
    register_Ns3SiConfiguration_s_methods(root_module, root_module['ns3::SiConfiguration_s'])
    register_Ns3SiMessageListElement_s_methods(root_module, root_module['ns3::SiMessageListElement_s'])
    register_Ns3SimpleRefCount__Ns3Object_Ns3ObjectBase_Ns3ObjectDeleter_methods(root_module, root_module['ns3::SimpleRefCount< ns3::Object, ns3::ObjectBase, ns3::ObjectDeleter >'])
    register_Ns3Simulator_methods(root_module, root_module['ns3::Simulator'])
    register_Ns3SpsConfig_s_methods(root_module, root_module['ns3::SpsConfig_s'])
    register_Ns3SrConfig_s_methods(root_module, root_module['ns3::SrConfig_s'])
    register_Ns3SrListElement_s_methods(root_module, root_module['ns3::SrListElement_s'])
    register_Ns3StatisticalSummary_methods(root_module, root_module['ns3::StatisticalSummary'])
    register_Ns3Tag_methods(root_module, root_module['ns3::Tag'])
    register_Ns3TagBuffer_methods(root_module, root_module['ns3::TagBuffer'])
    register_Ns3TbId_t_methods(root_module, root_module['ns3::TbId_t'])
    register_Ns3TimeWithUnit_methods(root_module, root_module['ns3::TimeWithUnit'])
    register_Ns3TracedValue__Bool_methods(root_module, root_module['ns3::TracedValue< bool >'])
    register_Ns3TracedValue__Unsigned_int_methods(root_module, root_module['ns3::TracedValue< unsigned int >'])
    register_Ns3TransmissionModesLayers_methods(root_module, root_module['ns3::TransmissionModesLayers'])
    register_Ns3TypeId_methods(root_module, root_module['ns3::TypeId'])
    register_Ns3TypeIdAttributeInformation_methods(root_module, root_module['ns3::TypeId::AttributeInformation'])
    register_Ns3TypeIdTraceSourceInformation_methods(root_module, root_module['ns3::TypeId::TraceSourceInformation'])
    register_Ns3UeCapabilities_s_methods(root_module, root_module['ns3::UeCapabilities_s'])
    register_Ns3UeSelected_s_methods(root_module, root_module['ns3::UeSelected_s'])
    register_Ns3UlCqi_s_methods(root_module, root_module['ns3::UlCqi_s'])
    register_Ns3UlDciListElement_s_methods(root_module, root_module['ns3::UlDciListElement_s'])
    register_Ns3UlGrant_s_methods(root_module, root_module['ns3::UlGrant_s'])
    register_Ns3UlInfoListElement_s_methods(root_module, root_module['ns3::UlInfoListElement_s'])
    register_Ns3Vector2D_methods(root_module, root_module['ns3::Vector2D'])
    register_Ns3Vector3D_methods(root_module, root_module['ns3::Vector3D'])
    register_Ns3VendorSpecificListElement_s_methods(root_module, root_module['ns3::VendorSpecificListElement_s'])
    register_Ns3Empty_methods(root_module, root_module['ns3::empty'])
    register_Ns3Int64x64_t_methods(root_module, root_module['ns3::int64x64_t'])
    register_Ns3TbInfo_t_methods(root_module, root_module['ns3::tbInfo_t'])
    register_Ns3Chunk_methods(root_module, root_module['ns3::Chunk'])
    register_Ns3EpcX2PdcpProvider_methods(root_module, root_module['ns3::EpcX2PdcpProvider'])
    register_Ns3EpcX2PdcpUser_methods(root_module, root_module['ns3::EpcX2PdcpUser'])
    register_Ns3EpcX2RlcProvider_methods(root_module, root_module['ns3::EpcX2RlcProvider'])
    register_Ns3EpcX2RlcUser_methods(root_module, root_module['ns3::EpcX2RlcUser'])
    register_Ns3Header_methods(root_module, root_module['ns3::Header'])
    register_Ns3LteCcmMacSapUser_methods(root_module, root_module['ns3::LteCcmMacSapUser'])
    register_Ns3LteEnbRrcSapProvider_methods(root_module, root_module['ns3::LteEnbRrcSapProvider'])
    register_Ns3LteEnbRrcSapProviderCompleteSetupUeParameters_methods(root_module, root_module['ns3::LteEnbRrcSapProvider::CompleteSetupUeParameters'])
    register_Ns3LteEnbRrcSapUser_methods(root_module, root_module['ns3::LteEnbRrcSapUser'])
    register_Ns3LteEnbRrcSapUserSetupUeParameters_methods(root_module, root_module['ns3::LteEnbRrcSapUser::SetupUeParameters'])
    register_Ns3LtePdcpHeader_methods(root_module, root_module['ns3::LtePdcpHeader'])
    register_Ns3LteRadioBearerTag_methods(root_module, root_module['ns3::LteRadioBearerTag'])
    register_Ns3Object_methods(root_module, root_module['ns3::Object'])
    register_Ns3ObjectAggregateIterator_methods(root_module, root_module['ns3::Object::AggregateIterator'])
    register_Ns3PacketBurst_methods(root_module, root_module['ns3::PacketBurst'])
    register_Ns3PacketFilter_methods(root_module, root_module['ns3::PacketFilter'])
    register_Ns3PropagationDelayModel_methods(root_module, root_module['ns3::PropagationDelayModel'])
    register_Ns3PropagationLossModel_methods(root_module, root_module['ns3::PropagationLossModel'])
    register_Ns3QueueDisc_methods(root_module, root_module['ns3::QueueDisc'])
    register_Ns3QueueDiscStats_methods(root_module, root_module['ns3::QueueDisc::Stats'])
    register_Ns3QueueDiscClass_methods(root_module, root_module['ns3::QueueDiscClass'])
    register_Ns3RandomPropagationDelayModel_methods(root_module, root_module['ns3::RandomPropagationDelayModel'])
    register_Ns3RandomPropagationLossModel_methods(root_module, root_module['ns3::RandomPropagationLossModel'])
    register_Ns3RandomVariableStream_methods(root_module, root_module['ns3::RandomVariableStream'])
    register_Ns3RangePropagationLossModel_methods(root_module, root_module['ns3::RangePropagationLossModel'])
    register_Ns3RlcBearerInfo_methods(root_module, root_module['ns3::RlcBearerInfo'])
    register_Ns3SequentialRandomVariable_methods(root_module, root_module['ns3::SequentialRandomVariable'])
    register_Ns3SimpleRefCount__Ns3AttributeAccessor_Ns3Empty_Ns3DefaultDeleter__lt__ns3AttributeAccessor__gt___methods(root_module, root_module['ns3::SimpleRefCount< ns3::AttributeAccessor, ns3::empty, ns3::DefaultDeleter<ns3::AttributeAccessor> >'])
    register_Ns3SimpleRefCount__Ns3AttributeChecker_Ns3Empty_Ns3DefaultDeleter__lt__ns3AttributeChecker__gt___methods(root_module, root_module['ns3::SimpleRefCount< ns3::AttributeChecker, ns3::empty, ns3::DefaultDeleter<ns3::AttributeChecker> >'])
    register_Ns3SimpleRefCount__Ns3AttributeValue_Ns3Empty_Ns3DefaultDeleter__lt__ns3AttributeValue__gt___methods(root_module, root_module['ns3::SimpleRefCount< ns3::AttributeValue, ns3::empty, ns3::DefaultDeleter<ns3::AttributeValue> >'])
    register_Ns3SimpleRefCount__Ns3CallbackImplBase_Ns3Empty_Ns3DefaultDeleter__lt__ns3CallbackImplBase__gt___methods(root_module, root_module['ns3::SimpleRefCount< ns3::CallbackImplBase, ns3::empty, ns3::DefaultDeleter<ns3::CallbackImplBase> >'])
    register_Ns3SimpleRefCount__Ns3EpcTft_Ns3Empty_Ns3DefaultDeleter__lt__ns3EpcTft__gt___methods(root_module, root_module['ns3::SimpleRefCount< ns3::EpcTft, ns3::empty, ns3::DefaultDeleter<ns3::EpcTft> >'])
    register_Ns3SimpleRefCount__Ns3EpcTftClassifier_Ns3Empty_Ns3DefaultDeleter__lt__ns3EpcTftClassifier__gt___methods(root_module, root_module['ns3::SimpleRefCount< ns3::EpcTftClassifier, ns3::empty, ns3::DefaultDeleter<ns3::EpcTftClassifier> >'])
    register_Ns3SimpleRefCount__Ns3EventImpl_Ns3Empty_Ns3DefaultDeleter__lt__ns3EventImpl__gt___methods(root_module, root_module['ns3::SimpleRefCount< ns3::EventImpl, ns3::empty, ns3::DefaultDeleter<ns3::EventImpl> >'])
    register_Ns3SimpleRefCount__Ns3HashImplementation_Ns3Empty_Ns3DefaultDeleter__lt__ns3HashImplementation__gt___methods(root_module, root_module['ns3::SimpleRefCount< ns3::Hash::Implementation, ns3::empty, ns3::DefaultDeleter<ns3::Hash::Implementation> >'])
    register_Ns3SimpleRefCount__Ns3Ipv4MulticastRoute_Ns3Empty_Ns3DefaultDeleter__lt__ns3Ipv4MulticastRoute__gt___methods(root_module, root_module['ns3::SimpleRefCount< ns3::Ipv4MulticastRoute, ns3::empty, ns3::DefaultDeleter<ns3::Ipv4MulticastRoute> >'])
    register_Ns3SimpleRefCount__Ns3Ipv4Route_Ns3Empty_Ns3DefaultDeleter__lt__ns3Ipv4Route__gt___methods(root_module, root_module['ns3::SimpleRefCount< ns3::Ipv4Route, ns3::empty, ns3::DefaultDeleter<ns3::Ipv4Route> >'])
    register_Ns3SimpleRefCount__Ns3LteControlMessage_Ns3Empty_Ns3DefaultDeleter__lt__ns3LteControlMessage__gt___methods(root_module, root_module['ns3::SimpleRefCount< ns3::LteControlMessage, ns3::empty, ns3::DefaultDeleter<ns3::LteControlMessage> >'])
    register_Ns3SimpleRefCount__Ns3LteHarqPhy_Ns3Empty_Ns3DefaultDeleter__lt__ns3LteHarqPhy__gt___methods(root_module, root_module['ns3::SimpleRefCount< ns3::LteHarqPhy, ns3::empty, ns3::DefaultDeleter<ns3::LteHarqPhy> >'])
    register_Ns3SimpleRefCount__Ns3NixVector_Ns3Empty_Ns3DefaultDeleter__lt__ns3NixVector__gt___methods(root_module, root_module['ns3::SimpleRefCount< ns3::NixVector, ns3::empty, ns3::DefaultDeleter<ns3::NixVector> >'])
    register_Ns3SimpleRefCount__Ns3Packet_Ns3Empty_Ns3DefaultDeleter__lt__ns3Packet__gt___methods(root_module, root_module['ns3::SimpleRefCount< ns3::Packet, ns3::empty, ns3::DefaultDeleter<ns3::Packet> >'])
    register_Ns3SimpleRefCount__Ns3QueueItem_Ns3Empty_Ns3DefaultDeleter__lt__ns3QueueItem__gt___methods(root_module, root_module['ns3::SimpleRefCount< ns3::QueueItem, ns3::empty, ns3::DefaultDeleter<ns3::QueueItem> >'])
    register_Ns3SimpleRefCount__Ns3SpectrumModel_Ns3Empty_Ns3DefaultDeleter__lt__ns3SpectrumModel__gt___methods(root_module, root_module['ns3::SimpleRefCount< ns3::SpectrumModel, ns3::empty, ns3::DefaultDeleter<ns3::SpectrumModel> >'])
    register_Ns3SimpleRefCount__Ns3SpectrumSignalParameters_Ns3Empty_Ns3DefaultDeleter__lt__ns3SpectrumSignalParameters__gt___methods(root_module, root_module['ns3::SimpleRefCount< ns3::SpectrumSignalParameters, ns3::empty, ns3::DefaultDeleter<ns3::SpectrumSignalParameters> >'])
    register_Ns3SimpleRefCount__Ns3SpectrumValue_Ns3Empty_Ns3DefaultDeleter__lt__ns3SpectrumValue__gt___methods(root_module, root_module['ns3::SimpleRefCount< ns3::SpectrumValue, ns3::empty, ns3::DefaultDeleter<ns3::SpectrumValue> >'])
    register_Ns3SimpleRefCount__Ns3TraceSourceAccessor_Ns3Empty_Ns3DefaultDeleter__lt__ns3TraceSourceAccessor__gt___methods(root_module, root_module['ns3::SimpleRefCount< ns3::TraceSourceAccessor, ns3::empty, ns3::DefaultDeleter<ns3::TraceSourceAccessor> >'])
    register_Ns3SimpleRefCount__Ns3VendorSpecificValue_Ns3Empty_Ns3DefaultDeleter__lt__ns3VendorSpecificValue__gt___methods(root_module, root_module['ns3::SimpleRefCount< ns3::VendorSpecificValue, ns3::empty, ns3::DefaultDeleter<ns3::VendorSpecificValue> >'])
    register_Ns3SimpleRefCount__Ns3MmwaveBeamformingParams_Ns3Empty_Ns3DefaultDeleter__lt__ns3MmwaveBeamformingParams__gt___methods(root_module, root_module['ns3::SimpleRefCount< ns3::mmwave::BeamformingParams, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::BeamformingParams> >'])
    register_Ns3SimpleRefCount__Ns3MmwaveChannelParams_Ns3Empty_Ns3DefaultDeleter__lt__ns3MmwaveChannelParams__gt___methods(root_module, root_module['ns3::SimpleRefCount< ns3::mmwave::ChannelParams, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::ChannelParams> >'])
    register_Ns3SimpleRefCount__Ns3MmwaveMmWaveControlMessage_Ns3Empty_Ns3DefaultDeleter__lt__ns3MmwaveMmWaveControlMessage__gt___methods(root_module, root_module['ns3::SimpleRefCount< ns3::mmwave::MmWaveControlMessage, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::MmWaveControlMessage> >'])
    register_Ns3SimpleRefCount__Ns3MmwaveMmWaveHarqPhy_Ns3Empty_Ns3DefaultDeleter__lt__ns3MmwaveMmWaveHarqPhy__gt___methods(root_module, root_module['ns3::SimpleRefCount< ns3::mmwave::MmWaveHarqPhy, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::MmWaveHarqPhy> >'])
    register_Ns3SimpleRefCount__Ns3MmwaveParams3gpp_Ns3Empty_Ns3DefaultDeleter__lt__ns3MmwaveParams3gpp__gt___methods(root_module, root_module['ns3::SimpleRefCount< ns3::mmwave::Params3gpp, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::Params3gpp> >'])
    register_Ns3SimpleRefCount__Ns3MmwaveTraceParams_Ns3Empty_Ns3DefaultDeleter__lt__ns3MmwaveTraceParams__gt___methods(root_module, root_module['ns3::SimpleRefCount< ns3::mmwave::TraceParams, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::TraceParams> >'])
    register_Ns3SimpleRefCount__Ns3MmwaveChannelMatrix_Ns3Empty_Ns3DefaultDeleter__lt__ns3MmwaveChannelMatrix__gt___methods(root_module, root_module['ns3::SimpleRefCount< ns3::mmwave::channelMatrix, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::channelMatrix> >'])
    register_Ns3SimpleRefCount__Ns3MmwaveMmWaveBeamFormingParams_Ns3Empty_Ns3DefaultDeleter__lt__ns3MmwaveMmWaveBeamFormingParams__gt___methods(root_module, root_module['ns3::SimpleRefCount< ns3::mmwave::mmWaveBeamFormingParams, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::mmWaveBeamFormingParams> >'])
    register_Ns3SimpleRefCount__Ns3MmwaveMmWaveBeamFormingTraces_Ns3Empty_Ns3DefaultDeleter__lt__ns3MmwaveMmWaveBeamFormingTraces__gt___methods(root_module, root_module['ns3::SimpleRefCount< ns3::mmwave::mmWaveBeamFormingTraces, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::mmWaveBeamFormingTraces> >'])
    register_Ns3SimpleRefCount__Ns3MmwaveMmWaveChunkProcessor_Ns3Empty_Ns3DefaultDeleter__lt__ns3MmwaveMmWaveChunkProcessor__gt___methods(root_module, root_module['ns3::SimpleRefCount< ns3::mmwave::mmWaveChunkProcessor, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::mmWaveChunkProcessor> >'])
    register_Ns3Socket_methods(root_module, root_module['ns3::Socket'])
    register_Ns3SocketIpTosTag_methods(root_module, root_module['ns3::SocketIpTosTag'])
    register_Ns3SocketIpTtlTag_methods(root_module, root_module['ns3::SocketIpTtlTag'])
    register_Ns3SocketIpv6HopLimitTag_methods(root_module, root_module['ns3::SocketIpv6HopLimitTag'])
    register_Ns3SocketIpv6TclassTag_methods(root_module, root_module['ns3::SocketIpv6TclassTag'])
    register_Ns3SocketPriorityTag_methods(root_module, root_module['ns3::SocketPriorityTag'])
    register_Ns3SocketSetDontFragmentTag_methods(root_module, root_module['ns3::SocketSetDontFragmentTag'])
    register_Ns3SpectrumInterference_methods(root_module, root_module['ns3::SpectrumInterference'])
    register_Ns3SpectrumModel_methods(root_module, root_module['ns3::SpectrumModel'])
    register_Ns3SpectrumPhy_methods(root_module, root_module['ns3::SpectrumPhy'])
    register_Ns3SpectrumPropagationLossModel_methods(root_module, root_module['ns3::SpectrumPropagationLossModel'])
    register_Ns3SpectrumSignalParameters_methods(root_module, root_module['ns3::SpectrumSignalParameters'])
    register_Ns3SpectrumValue_methods(root_module, root_module['ns3::SpectrumValue'])
    register_Ns3ThreeLogDistancePropagationLossModel_methods(root_module, root_module['ns3::ThreeLogDistancePropagationLossModel'])
    register_Ns3Time_methods(root_module, root_module['ns3::Time'])
    register_Ns3TraceSourceAccessor_methods(root_module, root_module['ns3::TraceSourceAccessor'])
    register_Ns3Trailer_methods(root_module, root_module['ns3::Trailer'])
    register_Ns3TriangularRandomVariable_methods(root_module, root_module['ns3::TriangularRandomVariable'])
    register_Ns3TwoRayGroundPropagationLossModel_methods(root_module, root_module['ns3::TwoRayGroundPropagationLossModel'])
    register_Ns3UeManager_methods(root_module, root_module['ns3::UeManager'])
    register_Ns3UniformRandomVariable_methods(root_module, root_module['ns3::UniformRandomVariable'])
    register_Ns3VendorSpecificValue_methods(root_module, root_module['ns3::VendorSpecificValue'])
    register_Ns3WeibullRandomVariable_methods(root_module, root_module['ns3::WeibullRandomVariable'])
    register_Ns3ZetaRandomVariable_methods(root_module, root_module['ns3::ZetaRandomVariable'])
    register_Ns3ZipfRandomVariable_methods(root_module, root_module['ns3::ZipfRandomVariable'])
    register_Ns3AntennaModel_methods(root_module, root_module['ns3::AntennaModel'])
    register_Ns3Asn1Header_methods(root_module, root_module['ns3::Asn1Header'])
    register_Ns3AttributeAccessor_methods(root_module, root_module['ns3::AttributeAccessor'])
    register_Ns3AttributeChecker_methods(root_module, root_module['ns3::AttributeChecker'])
    register_Ns3AttributeValue_methods(root_module, root_module['ns3::AttributeValue'])
    register_Ns3BooleanChecker_methods(root_module, root_module['ns3::BooleanChecker'])
    register_Ns3BooleanValue_methods(root_module, root_module['ns3::BooleanValue'])
    register_Ns3BoxChecker_methods(root_module, root_module['ns3::BoxChecker'])
    register_Ns3BoxValue_methods(root_module, root_module['ns3::BoxValue'])
    register_Ns3Building_methods(root_module, root_module['ns3::Building'])
    register_Ns3BuildingsPropagationLossModel_methods(root_module, root_module['ns3::BuildingsPropagationLossModel'])
    register_Ns3CallbackChecker_methods(root_module, root_module['ns3::CallbackChecker'])
    register_Ns3CallbackImplBase_methods(root_module, root_module['ns3::CallbackImplBase'])
    register_Ns3CallbackValue_methods(root_module, root_module['ns3::CallbackValue'])
    register_Ns3Channel_methods(root_module, root_module['ns3::Channel'])
    register_Ns3CoDelQueueDisc_methods(root_module, root_module['ns3::CoDelQueueDisc'])
    register_Ns3ComponentCarrier_methods(root_module, root_module['ns3::ComponentCarrier'])
    register_Ns3ComponentCarrierEnb_methods(root_module, root_module['ns3::ComponentCarrierEnb'])
    register_Ns3ComponentCarrierUe_methods(root_module, root_module['ns3::ComponentCarrierUe'])
    register_Ns3ConstantRandomVariable_methods(root_module, root_module['ns3::ConstantRandomVariable'])
    register_Ns3ConstantSpeedPropagationDelayModel_methods(root_module, root_module['ns3::ConstantSpeedPropagationDelayModel'])
    register_Ns3DataCalculator_methods(root_module, root_module['ns3::DataCalculator'])
    register_Ns3DataOutputInterface_methods(root_module, root_module['ns3::DataOutputInterface'])
    register_Ns3DataRateChecker_methods(root_module, root_module['ns3::DataRateChecker'])
    register_Ns3DataRateValue_methods(root_module, root_module['ns3::DataRateValue'])
    register_Ns3DeterministicRandomVariable_methods(root_module, root_module['ns3::DeterministicRandomVariable'])
    register_Ns3DoubleValue_methods(root_module, root_module['ns3::DoubleValue'])
    register_Ns3EmpiricalRandomVariable_methods(root_module, root_module['ns3::EmpiricalRandomVariable'])
    register_Ns3EmptyAttributeAccessor_methods(root_module, root_module['ns3::EmptyAttributeAccessor'])
    register_Ns3EmptyAttributeChecker_methods(root_module, root_module['ns3::EmptyAttributeChecker'])
    register_Ns3EmptyAttributeValue_methods(root_module, root_module['ns3::EmptyAttributeValue'])
    register_Ns3EnumChecker_methods(root_module, root_module['ns3::EnumChecker'])
    register_Ns3EnumValue_methods(root_module, root_module['ns3::EnumValue'])
    register_Ns3EpcHelper_methods(root_module, root_module['ns3::EpcHelper'])
    register_Ns3EpcTft_methods(root_module, root_module['ns3::EpcTft'])
    register_Ns3EpcTftPacketFilter_methods(root_module, root_module['ns3::EpcTft::PacketFilter'])
    register_Ns3EpcTftClassifier_methods(root_module, root_module['ns3::EpcTftClassifier'])
    register_Ns3EpcUeNas_methods(root_module, root_module['ns3::EpcUeNas'])
    register_Ns3ErlangRandomVariable_methods(root_module, root_module['ns3::ErlangRandomVariable'])
    register_Ns3EventImpl_methods(root_module, root_module['ns3::EventImpl'])
    register_Ns3ExponentialRandomVariable_methods(root_module, root_module['ns3::ExponentialRandomVariable'])
    register_Ns3FfMacScheduler_methods(root_module, root_module['ns3::FfMacScheduler'])
    register_Ns3FixedRssLossModel_methods(root_module, root_module['ns3::FixedRssLossModel'])
    register_Ns3FriisPropagationLossModel_methods(root_module, root_module['ns3::FriisPropagationLossModel'])
    register_Ns3GammaRandomVariable_methods(root_module, root_module['ns3::GammaRandomVariable'])
    register_Ns3IntegerValue_methods(root_module, root_module['ns3::IntegerValue'])
    register_Ns3Ipv4_methods(root_module, root_module['ns3::Ipv4'])
    register_Ns3Ipv4AddressChecker_methods(root_module, root_module['ns3::Ipv4AddressChecker'])
    register_Ns3Ipv4AddressValue_methods(root_module, root_module['ns3::Ipv4AddressValue'])
    register_Ns3Ipv4MaskChecker_methods(root_module, root_module['ns3::Ipv4MaskChecker'])
    register_Ns3Ipv4MaskValue_methods(root_module, root_module['ns3::Ipv4MaskValue'])
    register_Ns3Ipv4MulticastRoute_methods(root_module, root_module['ns3::Ipv4MulticastRoute'])
    register_Ns3Ipv4Route_methods(root_module, root_module['ns3::Ipv4Route'])
    register_Ns3Ipv6_methods(root_module, root_module['ns3::Ipv6'])
    register_Ns3Ipv6AddressChecker_methods(root_module, root_module['ns3::Ipv6AddressChecker'])
    register_Ns3Ipv6AddressValue_methods(root_module, root_module['ns3::Ipv6AddressValue'])
    register_Ns3Ipv6PrefixChecker_methods(root_module, root_module['ns3::Ipv6PrefixChecker'])
    register_Ns3Ipv6PrefixValue_methods(root_module, root_module['ns3::Ipv6PrefixValue'])
    register_Ns3LogDistancePropagationLossModel_methods(root_module, root_module['ns3::LogDistancePropagationLossModel'])
    register_Ns3LogNormalRandomVariable_methods(root_module, root_module['ns3::LogNormalRandomVariable'])
    register_Ns3LteAmc_methods(root_module, root_module['ns3::LteAmc'])
    register_Ns3LteAnr_methods(root_module, root_module['ns3::LteAnr'])
    register_Ns3LteControlMessage_methods(root_module, root_module['ns3::LteControlMessage'])
    register_Ns3LteEnbComponentCarrierManager_methods(root_module, root_module['ns3::LteEnbComponentCarrierManager'])
    register_Ns3LteEnbMac_methods(root_module, root_module['ns3::LteEnbMac'])
    register_Ns3LteEnbRrc_methods(root_module, root_module['ns3::LteEnbRrc'])
    register_Ns3LteEnbRrcHandoverEventInfo_methods(root_module, root_module['ns3::LteEnbRrc::HandoverEventInfo'])
    register_Ns3LteEnbRrcMmWaveComponentCarrierConf_methods(root_module, root_module['ns3::LteEnbRrc::MmWaveComponentCarrierConf'])
    register_Ns3LteFfrAlgorithm_methods(root_module, root_module['ns3::LteFfrAlgorithm'])
    register_Ns3LteHandoverAlgorithm_methods(root_module, root_module['ns3::LteHandoverAlgorithm'])
    register_Ns3LteHarqPhy_methods(root_module, root_module['ns3::LteHarqPhy'])
    register_Ns3LteInterference_methods(root_module, root_module['ns3::LteInterference'])
    register_Ns3LtePdcp_methods(root_module, root_module['ns3::LtePdcp'])
    register_Ns3LtePdcpStatus_methods(root_module, root_module['ns3::LtePdcp::Status'])
    register_Ns3LtePhy_methods(root_module, root_module['ns3::LtePhy'])
    register_Ns3LteRadioBearerInfo_methods(root_module, root_module['ns3::LteRadioBearerInfo'])
    register_Ns3LteRlc_methods(root_module, root_module['ns3::LteRlc'])
    register_Ns3LteRlcAm_methods(root_module, root_module['ns3::LteRlcAm'])
    register_Ns3LteRlcAmRetxPdu_methods(root_module, root_module['ns3::LteRlcAm::RetxPdu'])
    register_Ns3LteRlcSm_methods(root_module, root_module['ns3::LteRlcSm'])
    register_Ns3LteSignalingRadioBearerInfo_methods(root_module, root_module['ns3::LteSignalingRadioBearerInfo'])
    register_Ns3LteSpectrumPhy_methods(root_module, root_module['ns3::LteSpectrumPhy'])
    register_Ns3LteStatsCalculator_methods(root_module, root_module['ns3::LteStatsCalculator'])
    register_Ns3LteUeMac_methods(root_module, root_module['ns3::LteUeMac'])
    register_Ns3LteUePhy_methods(root_module, root_module['ns3::LteUePhy'])
    register_Ns3LteUePowerControl_methods(root_module, root_module['ns3::LteUePowerControl'])
    register_Ns3LteUeRrc_methods(root_module, root_module['ns3::LteUeRrc'])
    register_Ns3Mac48AddressChecker_methods(root_module, root_module['ns3::Mac48AddressChecker'])
    register_Ns3Mac48AddressValue_methods(root_module, root_module['ns3::Mac48AddressValue'])
    register_Ns3Mac64AddressChecker_methods(root_module, root_module['ns3::Mac64AddressChecker'])
    register_Ns3Mac64AddressValue_methods(root_module, root_module['ns3::Mac64AddressValue'])
    register_Ns3MatrixPropagationLossModel_methods(root_module, root_module['ns3::MatrixPropagationLossModel'])
    register_Ns3MibLteControlMessage_methods(root_module, root_module['ns3::MibLteControlMessage'])
    register_Ns3MinMaxAvgTotalCalculator__Unsigned_int_methods(root_module, root_module['ns3::MinMaxAvgTotalCalculator< unsigned int >'])
    register_Ns3MinMaxAvgTotalCalculator__Unsigned_long_methods(root_module, root_module['ns3::MinMaxAvgTotalCalculator< unsigned long >'])
    register_Ns3MobilityBuildingInfo_methods(root_module, root_module['ns3::MobilityBuildingInfo'])
    register_Ns3MobilityModel_methods(root_module, root_module['ns3::MobilityModel'])
    register_Ns3NakagamiPropagationLossModel_methods(root_module, root_module['ns3::NakagamiPropagationLossModel'])
    register_Ns3NetDevice_methods(root_module, root_module['ns3::NetDevice'])
    register_Ns3NixVector_methods(root_module, root_module['ns3::NixVector'])
    register_Ns3Node_methods(root_module, root_module['ns3::Node'])
    register_Ns3NormalRandomVariable_methods(root_module, root_module['ns3::NormalRandomVariable'])
    register_Ns3ObjectFactoryChecker_methods(root_module, root_module['ns3::ObjectFactoryChecker'])
    register_Ns3ObjectFactoryValue_methods(root_module, root_module['ns3::ObjectFactoryValue'])
    register_Ns3Packet_methods(root_module, root_module['ns3::Packet'])
    register_Ns3ParetoRandomVariable_methods(root_module, root_module['ns3::ParetoRandomVariable'])
    register_Ns3PointerChecker_methods(root_module, root_module['ns3::PointerChecker'])
    register_Ns3PointerValue_methods(root_module, root_module['ns3::PointerValue'])
    register_Ns3QueueItem_methods(root_module, root_module['ns3::QueueItem'])
    register_Ns3QueueSizeChecker_methods(root_module, root_module['ns3::QueueSizeChecker'])
    register_Ns3QueueSizeValue_methods(root_module, root_module['ns3::QueueSizeValue'])
    register_Ns3RachPreambleLteControlMessage_methods(root_module, root_module['ns3::RachPreambleLteControlMessage'])
    register_Ns3RarLteControlMessage_methods(root_module, root_module['ns3::RarLteControlMessage'])
    register_Ns3RarLteControlMessageRar_methods(root_module, root_module['ns3::RarLteControlMessage::Rar'])
    register_Ns3RrcAsn1Header_methods(root_module, root_module['ns3::RrcAsn1Header'])
    register_Ns3RrcDlCcchMessage_methods(root_module, root_module['ns3::RrcDlCcchMessage'])
    register_Ns3RrcDlDcchMessage_methods(root_module, root_module['ns3::RrcDlDcchMessage'])
    register_Ns3RrcUlCcchMessage_methods(root_module, root_module['ns3::RrcUlCcchMessage'])
    register_Ns3RrcUlDcchMessage_methods(root_module, root_module['ns3::RrcUlDcchMessage'])
    register_Ns3Sib1LteControlMessage_methods(root_module, root_module['ns3::Sib1LteControlMessage'])
    register_Ns3SpectrumChannel_methods(root_module, root_module['ns3::SpectrumChannel'])
    register_Ns3StringChecker_methods(root_module, root_module['ns3::StringChecker'])
    register_Ns3StringValue_methods(root_module, root_module['ns3::StringValue'])
    register_Ns3TimeValue_methods(root_module, root_module['ns3::TimeValue'])
    register_Ns3TypeIdChecker_methods(root_module, root_module['ns3::TypeIdChecker'])
    register_Ns3TypeIdValue_methods(root_module, root_module['ns3::TypeIdValue'])
    register_Ns3UintegerValue_methods(root_module, root_module['ns3::UintegerValue'])
    register_Ns3UlDciLteControlMessage_methods(root_module, root_module['ns3::UlDciLteControlMessage'])
    register_Ns3Vector2DChecker_methods(root_module, root_module['ns3::Vector2DChecker'])
    register_Ns3Vector2DValue_methods(root_module, root_module['ns3::Vector2DValue'])
    register_Ns3Vector3DChecker_methods(root_module, root_module['ns3::Vector3DChecker'])
    register_Ns3Vector3DValue_methods(root_module, root_module['ns3::Vector3DValue'])
    register_Ns3AddressChecker_methods(root_module, root_module['ns3::AddressChecker'])
    register_Ns3AddressValue_methods(root_module, root_module['ns3::AddressValue'])
    register_Ns3BsrLteControlMessage_methods(root_module, root_module['ns3::BsrLteControlMessage'])
    register_Ns3CallbackImpl__Bool_Ns3Ptr__lt__ns3NetDevice__gt___Ns3Ptr__lt__const_ns3Packet__gt___Unsigned_short_Const_ns3Address___amp___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< bool, ns3::Ptr<ns3::NetDevice>, ns3::Ptr<const ns3::Packet>, unsigned short, const ns3::Address &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Bool_Ns3Ptr__lt__ns3Socket__gt___Const_ns3Address___amp___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< bool, ns3::Ptr<ns3::Socket>, const ns3::Address &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Ns3ObjectBase___star___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< ns3::ObjectBase *, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Bool_Bool_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, bool, bool, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Const_ns3SpectrumValue___amp___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, const ns3::SpectrumValue &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Ns3DlSchedulingCallbackInfo_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, ns3::DlSchedulingCallbackInfo, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Ns3EpcUeNasState_Ns3EpcUeNasState_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, ns3::EpcUeNas::State, ns3::EpcUeNas::State, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Ns3PhyReceptionStatParameters_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, ns3::PhyReceptionStatParameters, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Ns3PhyTransmissionStatParameters_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, ns3::PhyTransmissionStatParameters, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Ns3Ptr__lt__const_ns3MobilityModel__gt___Ns3Ptr__lt__const_ns3MobilityModel__gt___Double_Double_Double_Double_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, ns3::Ptr<const ns3::MobilityModel>, ns3::Ptr<const ns3::MobilityModel>, double, double, double, double, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Ns3Ptr__lt__const_ns3MobilityModel__gt___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, ns3::Ptr<const ns3::MobilityModel>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Ns3Ptr__lt__const_ns3Packet__gt___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, ns3::Ptr<const ns3::Packet>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Ns3Ptr__lt__const_ns3PacketBurst__gt___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, ns3::Ptr<const ns3::PacketBurst>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Ns3Ptr__lt__const_ns3QueueDiscItem__gt___Const_char___star___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, ns3::Ptr<const ns3::QueueDiscItem>, const char *, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Ns3Ptr__lt__const_ns3QueueDiscItem__gt___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, ns3::Ptr<const ns3::QueueDiscItem>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Ns3Ptr__lt__const_ns3SpectrumPhy__gt___Ns3Ptr__lt__const_ns3SpectrumPhy__gt___Double_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, ns3::Ptr<const ns3::SpectrumPhy>, ns3::Ptr<const ns3::SpectrumPhy>, double, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Ns3Ptr__lt__ns3LteUeRrc__gt___StdList__lt__ns3LteRrcSapSCellToAddMod__stdAllocator__lt__ns3LteRrcSapSCellToAddMod__gt_____gt___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, ns3::Ptr<ns3::LteUeRrc>, std::list<ns3::LteRrcSap::SCellToAddMod, std::allocator<ns3::LteRrcSap::SCellToAddMod> >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Ns3Ptr__lt__ns3NetDevice__gt___Ns3Ptr__lt__const_ns3Packet__gt___Unsigned_short_Const_ns3Address___amp___Const_ns3Address___amp___Ns3NetDevicePacketType_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, ns3::Ptr<ns3::NetDevice>, ns3::Ptr<const ns3::Packet>, unsigned short, const ns3::Address &, const ns3::Address &, ns3::NetDevice::PacketType, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Ns3Ptr__lt__ns3NetDevice__gt___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, ns3::Ptr<ns3::NetDevice>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Ns3Ptr__lt__ns3Packet__gt___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, ns3::Ptr<ns3::Packet>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Ns3Ptr__lt__ns3Socket__gt___Const_ns3Address___amp___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, ns3::Ptr<ns3::Socket>, const ns3::Address &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Ns3Ptr__lt__ns3Socket__gt___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, ns3::Ptr<ns3::Socket>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Ns3Ptr__lt__ns3Socket__gt___Unsigned_int_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, ns3::Ptr<ns3::Socket>, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Ns3Ptr__lt__ns3SpectrumSignalParameters__gt___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, ns3::Ptr<ns3::SpectrumSignalParameters>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Ns3Time_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, ns3::Time, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Ns3MmwaveRxPacketTraceParams_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, ns3::mmwave::RxPacketTraceParams, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Unsigned_int_Unsigned_int_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, unsigned int, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Unsigned_int_Unsigned_int_Unsigned_short_Unsigned_char_Unsigned_short_Unsigned_char_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, unsigned int, unsigned int, unsigned short, unsigned char, unsigned short, unsigned char, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Unsigned_long_Ns3SpectrumValue___amp___Ns3SpectrumValue___amp___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, unsigned long, ns3::SpectrumValue &, ns3::SpectrumValue &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Unsigned_long_Unsigned_long_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, unsigned long, unsigned long, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Unsigned_long_Unsigned_short_Long_double_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, unsigned long, unsigned short, long double, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Unsigned_long_Unsigned_short_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, unsigned long, unsigned short, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Unsigned_long_Unsigned_short_Unsigned_short_Ns3LteRrcSapMeasurementReport_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, unsigned long, unsigned short, unsigned short, ns3::LteRrcSap::MeasurementReport, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Unsigned_long_Unsigned_short_Unsigned_short_Ns3LteUeRrcState_Ns3LteUeRrcState_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, unsigned long, unsigned short, unsigned short, ns3::LteUeRrc::State, ns3::LteUeRrc::State, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Unsigned_long_Unsigned_short_Unsigned_short_Ns3UeManagerState_Ns3UeManagerState_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, unsigned long, unsigned short, unsigned short, ns3::UeManager::State, ns3::UeManager::State, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Unsigned_long_Unsigned_short_Unsigned_short_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, unsigned long, unsigned short, unsigned short, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Unsigned_long_Unsigned_short_Unsigned_short_Unsigned_short_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, unsigned long, unsigned short, unsigned short, unsigned short, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Unsigned_short_Ns3Ptr__lt__ns3SpectrumValue__gt___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, unsigned short, ns3::Ptr<ns3::SpectrumValue>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Unsigned_short_Unsigned_char_Unsigned_int_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, unsigned short, unsigned char, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Unsigned_short_Unsigned_char_Unsigned_int_Unsigned_int_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, unsigned short, unsigned char, unsigned int, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Unsigned_short_Unsigned_char_Unsigned_int_Unsigned_long_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, unsigned short, unsigned char, unsigned int, unsigned long, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Unsigned_short_Unsigned_short_Double_Double_Bool_Unsigned_char_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, unsigned short, unsigned short, double, double, bool, unsigned char, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Unsigned_short_Unsigned_short_Double_Double_Unsigned_char_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, unsigned short, unsigned short, double, double, unsigned char, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Unsigned_short_Unsigned_short_Double_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, unsigned short, unsigned short, double, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Unsigned_short_Unsigned_short_Double_Unsigned_char_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, unsigned short, unsigned short, double, unsigned char, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Unsigned_short_Unsigned_short_Ns3LteUePhyState_Ns3LteUePhyState_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, unsigned short, unsigned short, ns3::LteUePhy::State, ns3::LteUePhy::State, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Unsigned_short_Unsigned_short_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, unsigned short, unsigned short, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3CallbackImpl__Void_Unsigned_short_Unsigned_short_Unsigned_int_Unsigned_char_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, root_module['ns3::CallbackImpl< void, unsigned short, unsigned short, unsigned int, unsigned char, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >'])
    register_Ns3DlCqiLteControlMessage_methods(root_module, root_module['ns3::DlCqiLteControlMessage'])
    register_Ns3DlDciLteControlMessage_methods(root_module, root_module['ns3::DlDciLteControlMessage'])
    register_Ns3DlHarqFeedbackLteControlMessage_methods(root_module, root_module['ns3::DlHarqFeedbackLteControlMessage'])
    register_Ns3HandoverPreparationInfoHeader_methods(root_module, root_module['ns3::HandoverPreparationInfoHeader'])
    register_Ns3LteDataRadioBearerInfo_methods(root_module, root_module['ns3::LteDataRadioBearerInfo'])
    register_Ns3LteEnbPhy_methods(root_module, root_module['ns3::LteEnbPhy'])
    register_Ns3LteNetDevice_methods(root_module, root_module['ns3::LteNetDevice'])
    register_Ns3MeasurementReportHeader_methods(root_module, root_module['ns3::MeasurementReportHeader'])
    register_Ns3QueueDiscItem_methods(root_module, root_module['ns3::QueueDiscItem'])
    register_Ns3RrcConnectToMmWaveHeader_methods(root_module, root_module['ns3::RrcConnectToMmWaveHeader'])
    register_Ns3RrcConnectionReconfigurationCompleteHeader_methods(root_module, root_module['ns3::RrcConnectionReconfigurationCompleteHeader'])
    register_Ns3RrcConnectionReconfigurationHeader_methods(root_module, root_module['ns3::RrcConnectionReconfigurationHeader'])
    register_Ns3RrcConnectionReestablishmentCompleteHeader_methods(root_module, root_module['ns3::RrcConnectionReestablishmentCompleteHeader'])
    register_Ns3RrcConnectionReestablishmentHeader_methods(root_module, root_module['ns3::RrcConnectionReestablishmentHeader'])
    register_Ns3RrcConnectionReestablishmentRejectHeader_methods(root_module, root_module['ns3::RrcConnectionReestablishmentRejectHeader'])
    register_Ns3RrcConnectionReestablishmentRequestHeader_methods(root_module, root_module['ns3::RrcConnectionReestablishmentRequestHeader'])
    register_Ns3RrcConnectionRejectHeader_methods(root_module, root_module['ns3::RrcConnectionRejectHeader'])
    register_Ns3RrcConnectionReleaseHeader_methods(root_module, root_module['ns3::RrcConnectionReleaseHeader'])
    register_Ns3RrcConnectionRequestHeader_methods(root_module, root_module['ns3::RrcConnectionRequestHeader'])
    register_Ns3RrcConnectionSetupCompleteHeader_methods(root_module, root_module['ns3::RrcConnectionSetupCompleteHeader'])
    register_Ns3RrcConnectionSetupHeader_methods(root_module, root_module['ns3::RrcConnectionSetupHeader'])
    register_Ns3RrcConnectionSwitchHeader_methods(root_module, root_module['ns3::RrcConnectionSwitchHeader'])
    register_Ns3RrcNotifySecondaryConnectedHeader_methods(root_module, root_module['ns3::RrcNotifySecondaryConnectedHeader'])
    register_Ns3LteEnbNetDevice_methods(root_module, root_module['ns3::LteEnbNetDevice'])
    register_Ns3ConfigMatchContainer_methods(root_module, root_module['ns3::Config::MatchContainer'])
    register_Ns3HashImplementation_methods(root_module, root_module['ns3::Hash::Implementation'])
    register_Ns3HashFunctionFnv1a_methods(root_module, root_module['ns3::Hash::Function::Fnv1a'])
    register_Ns3HashFunctionHash32_methods(root_module, root_module['ns3::Hash::Function::Hash32'])
    register_Ns3HashFunctionHash64_methods(root_module, root_module['ns3::Hash::Function::Hash64'])
    register_Ns3HashFunctionMurmur3_methods(root_module, root_module['ns3::Hash::Function::Murmur3'])
    register_Ns3MmwaveAntennaArrayModel_methods(root_module, root_module['ns3::mmwave::AntennaArrayModel'])
    register_Ns3MmwaveBeamformingParams_methods(root_module, root_module['ns3::mmwave::BeamformingParams'])
    register_Ns3MmwaveBuildingsObstaclePropagationLossModel_methods(root_module, root_module['ns3::mmwave::BuildingsObstaclePropagationLossModel'])
    register_Ns3MmwaveChannelParams_methods(root_module, root_module['ns3::mmwave::ChannelParams'])
    register_Ns3MmwaveCoreNetworkStatsCalculator_methods(root_module, root_module['ns3::mmwave::CoreNetworkStatsCalculator'])
    register_Ns3MmwaveDciInfoElement_methods(root_module, root_module['ns3::mmwave::DciInfoElement'])
    register_Ns3MmwaveDciInfoElementTdma_methods(root_module, root_module['ns3::mmwave::DciInfoElementTdma'])
    register_Ns3MmwaveDlCqiInfo_methods(root_module, root_module['ns3::mmwave::DlCqiInfo'])
    register_Ns3MmwaveDlDciInfoElementTdma_methods(root_module, root_module['ns3::mmwave::DlDciInfoElementTdma'])
    register_Ns3MmwaveDlHarqInfo_methods(root_module, root_module['ns3::mmwave::DlHarqInfo'])
    register_Ns3MmwaveEnbPhyPacketCountParameter_methods(root_module, root_module['ns3::mmwave::EnbPhyPacketCountParameter'])
    register_Ns3MmwaveExpectedTbInfo_t_methods(root_module, root_module['ns3::mmwave::ExpectedTbInfo_t'])
    register_Ns3MmwaveMacCeElement_methods(root_module, root_module['ns3::mmwave::MacCeElement'])
    register_Ns3MmwaveMacCeValue_methods(root_module, root_module['ns3::mmwave::MacCeValue'])
    register_Ns3MmwaveMacPduInfo_methods(root_module, root_module['ns3::mmwave::MacPduInfo'])
    register_Ns3MmwaveMacSubheader_methods(root_module, root_module['ns3::mmwave::MacSubheader'])
    register_Ns3MmwaveMcStatsCalculator_methods(root_module, root_module['ns3::mmwave::McStatsCalculator'])
    register_Ns3MmwaveMcUeNetDevice_methods(root_module, root_module['ns3::mmwave::McUeNetDevice'])
    register_Ns3MmwaveMmWave3gppBuildingsPropagationLossModel_methods(root_module, root_module['ns3::mmwave::MmWave3gppBuildingsPropagationLossModel'])
    register_Ns3MmwaveMmWave3gppChannel_methods(root_module, root_module['ns3::mmwave::MmWave3gppChannel'])
    register_Ns3MmwaveMmWave3gppPropagationLossModel_methods(root_module, root_module['ns3::mmwave::MmWave3gppPropagationLossModel'])
    register_Ns3MmwaveMmWaveAmc_methods(root_module, root_module['ns3::mmwave::MmWaveAmc'])
    register_Ns3MmwaveMmWaveBeamforming_methods(root_module, root_module['ns3::mmwave::MmWaveBeamforming'])
    register_Ns3MmwaveMmWaveBearerStatsCalculator_methods(root_module, root_module['ns3::mmwave::MmWaveBearerStatsCalculator'])
    register_Ns3MmwaveMmWaveBearerStatsConnector_methods(root_module, root_module['ns3::mmwave::MmWaveBearerStatsConnector'])
    register_Ns3MmwaveMmWaveChannelMatrix_methods(root_module, root_module['ns3::mmwave::MmWaveChannelMatrix'])
    register_Ns3MmwaveMmWaveChannelRaytracing_methods(root_module, root_module['ns3::mmwave::MmWaveChannelRaytracing'])
    register_Ns3MmwaveMmWaveComponentCarrier_methods(root_module, root_module['ns3::mmwave::MmWaveComponentCarrier'])
    register_Ns3MmwaveMmWaveComponentCarrierEnb_methods(root_module, root_module['ns3::mmwave::MmWaveComponentCarrierEnb'])
    register_Ns3MmwaveMmWaveComponentCarrierUe_methods(root_module, root_module['ns3::mmwave::MmWaveComponentCarrierUe'])
    register_Ns3MmwaveMmWaveControlMessage_methods(root_module, root_module['ns3::mmwave::MmWaveControlMessage'])
    register_Ns3MmwaveMmWaveDciMessage_methods(root_module, root_module['ns3::mmwave::MmWaveDciMessage'])
    register_Ns3MmwaveMmWaveDlCqiMessage_methods(root_module, root_module['ns3::mmwave::MmWaveDlCqiMessage'])
    register_Ns3MmwaveMmWaveDlHarqFeedbackMessage_methods(root_module, root_module['ns3::mmwave::MmWaveDlHarqFeedbackMessage'])
    register_Ns3MmwaveMmWaveDlHarqProcessInfo_methods(root_module, root_module['ns3::mmwave::MmWaveDlHarqProcessInfo'])
    register_Ns3MmwaveMmWaveEnbMac_methods(root_module, root_module['ns3::mmwave::MmWaveEnbMac'])
    register_Ns3MmwaveMmWaveEnbMacReportBufferStatusParameters_methods(root_module, root_module['ns3::mmwave::MmWaveEnbMac::ReportBufferStatusParameters'])
    register_Ns3MmwaveMmWaveEnbMacTransmitPduParameters_methods(root_module, root_module['ns3::mmwave::MmWaveEnbMac::TransmitPduParameters'])
    register_Ns3MmwaveMmWaveEnbPhySapUser_methods(root_module, root_module['ns3::mmwave::MmWaveEnbPhySapUser'])
    register_Ns3MmwaveMmWaveEnbRrcProtocolIdeal_methods(root_module, root_module['ns3::mmwave::MmWaveEnbRrcProtocolIdeal'])
    register_Ns3MmwaveMmWaveHarqPhy_methods(root_module, root_module['ns3::mmwave::MmWaveHarqPhy'])
    register_Ns3MmwaveMmWaveHarqProcessInfoElement_t_methods(root_module, root_module['ns3::mmwave::MmWaveHarqProcessInfoElement_t'])
    register_Ns3MmwaveMmWaveHelper_methods(root_module, root_module['ns3::mmwave::MmWaveHelper'])
    register_Ns3MmwaveMmWaveLosTracker_methods(root_module, root_module['ns3::mmwave::MmWaveLosTracker'])
    register_Ns3MmwaveMmWaveLteEnbRrcProtocolReal_methods(root_module, root_module['ns3::mmwave::MmWaveLteEnbRrcProtocolReal'])
    register_Ns3MmwaveMmWaveLteUeRrcProtocolReal_methods(root_module, root_module['ns3::mmwave::MmWaveLteUeRrcProtocolReal'])
    register_Ns3MmwaveMmWaveMac_methods(root_module, root_module['ns3::mmwave::MmWaveMac'])
    register_Ns3MmwaveMmWaveMacCschedSapProvider_methods(root_module, root_module['ns3::mmwave::MmWaveMacCschedSapProvider'])
    register_Ns3MmwaveMmWaveMacCschedSapProviderCschedCellConfigReqParameters_methods(root_module, root_module['ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters'])
    register_Ns3MmwaveMmWaveMacCschedSapProviderCschedLcConfigReqParameters_methods(root_module, root_module['ns3::mmwave::MmWaveMacCschedSapProvider::CschedLcConfigReqParameters'])
    register_Ns3MmwaveMmWaveMacCschedSapProviderCschedLcReleaseReqParameters_methods(root_module, root_module['ns3::mmwave::MmWaveMacCschedSapProvider::CschedLcReleaseReqParameters'])
    register_Ns3MmwaveMmWaveMacCschedSapProviderCschedUeConfigReqParameters_methods(root_module, root_module['ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters'])
    register_Ns3MmwaveMmWaveMacCschedSapProviderCschedUeReleaseReqParameters_methods(root_module, root_module['ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeReleaseReqParameters'])
    register_Ns3MmwaveMmWaveMacCschedSapUser_methods(root_module, root_module['ns3::mmwave::MmWaveMacCschedSapUser'])
    register_Ns3MmwaveMmWaveMacCschedSapUserCschedCellConfigCnfParameters_methods(root_module, root_module['ns3::mmwave::MmWaveMacCschedSapUser::CschedCellConfigCnfParameters'])
    register_Ns3MmwaveMmWaveMacCschedSapUserCschedCellConfigUpdateIndParameters_methods(root_module, root_module['ns3::mmwave::MmWaveMacCschedSapUser::CschedCellConfigUpdateIndParameters'])
    register_Ns3MmwaveMmWaveMacCschedSapUserCschedLcConfigCnfParameters_methods(root_module, root_module['ns3::mmwave::MmWaveMacCschedSapUser::CschedLcConfigCnfParameters'])
    register_Ns3MmwaveMmWaveMacCschedSapUserCschedLcReleaseCnfParameters_methods(root_module, root_module['ns3::mmwave::MmWaveMacCschedSapUser::CschedLcReleaseCnfParameters'])
    register_Ns3MmwaveMmWaveMacCschedSapUserCschedUeConfigCnfParameters_methods(root_module, root_module['ns3::mmwave::MmWaveMacCschedSapUser::CschedUeConfigCnfParameters'])
    register_Ns3MmwaveMmWaveMacCschedSapUserCschedUeConfigUpdateIndParameters_methods(root_module, root_module['ns3::mmwave::MmWaveMacCschedSapUser::CschedUeConfigUpdateIndParameters'])
    register_Ns3MmwaveMmWaveMacCschedSapUserCschedUeReleaseCnfParameters_methods(root_module, root_module['ns3::mmwave::MmWaveMacCschedSapUser::CschedUeReleaseCnfParameters'])
    register_Ns3MmwaveMmWaveMacPduHeader_methods(root_module, root_module['ns3::mmwave::MmWaveMacPduHeader'])
    register_Ns3MmwaveMmWaveMacPduTag_methods(root_module, root_module['ns3::mmwave::MmWaveMacPduTag'])
    register_Ns3MmwaveMmWaveMacSchedSapProvider_methods(root_module, root_module['ns3::mmwave::MmWaveMacSchedSapProvider'])
    register_Ns3MmwaveMmWaveMacSchedSapProviderSchedDlCqiInfoReqParameters_methods(root_module, root_module['ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlCqiInfoReqParameters'])
    register_Ns3MmwaveMmWaveMacSchedSapProviderSchedDlRlcBufferReqParameters_methods(root_module, root_module['ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlRlcBufferReqParameters'])
    register_Ns3MmwaveMmWaveMacSchedSapProviderSchedTriggerReqParameters_methods(root_module, root_module['ns3::mmwave::MmWaveMacSchedSapProvider::SchedTriggerReqParameters'])
    register_Ns3MmwaveMmWaveMacSchedSapProviderSchedUlCqiInfoReqParameters_methods(root_module, root_module['ns3::mmwave::MmWaveMacSchedSapProvider::SchedUlCqiInfoReqParameters'])
    register_Ns3MmwaveMmWaveMacSchedSapProviderSchedUlMacCtrlInfoReqParameters_methods(root_module, root_module['ns3::mmwave::MmWaveMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters'])
    register_Ns3MmwaveMmWaveMacSchedSapUser_methods(root_module, root_module['ns3::mmwave::MmWaveMacSchedSapUser'])
    register_Ns3MmwaveMmWaveMacSchedSapUserSchedConfigIndParameters_methods(root_module, root_module['ns3::mmwave::MmWaveMacSchedSapUser::SchedConfigIndParameters'])
    register_Ns3MmwaveMmWaveMacScheduler_methods(root_module, root_module['ns3::mmwave::MmWaveMacScheduler'])
    register_Ns3MmwaveMmWaveMiErrorModel_methods(root_module, root_module['ns3::mmwave::MmWaveMiErrorModel'])
    register_Ns3MmwaveMmWaveMibMessage_methods(root_module, root_module['ns3::mmwave::MmWaveMibMessage'])
    register_Ns3MmwaveMmWaveNetDevice_methods(root_module, root_module['ns3::mmwave::MmWaveNetDevice'])
    register_Ns3MmwaveMmWaveNoOpComponentCarrierManager_methods(root_module, root_module['ns3::mmwave::MmWaveNoOpComponentCarrierManager'])
    register_Ns3MmwaveMmWavePhy_methods(root_module, root_module['ns3::mmwave::MmWavePhy'])
    register_Ns3MmwaveMmWavePhyMacCommon_methods(root_module, root_module['ns3::mmwave::MmWavePhyMacCommon'])
    register_Ns3MmwaveMmWavePhyRxTrace_methods(root_module, root_module['ns3::mmwave::MmWavePhyRxTrace'])
    register_Ns3MmwaveMmWavePhySapProvider_methods(root_module, root_module['ns3::mmwave::MmWavePhySapProvider'])
    register_Ns3MmwaveMmWavePointToPointEpcHelper_methods(root_module, root_module['ns3::mmwave::MmWavePointToPointEpcHelper'])
    register_Ns3MmwaveMmWavePropagationLossModel_methods(root_module, root_module['ns3::mmwave::MmWavePropagationLossModel'])
    register_Ns3MmwaveMmWaveRachPreambleMessage_methods(root_module, root_module['ns3::mmwave::MmWaveRachPreambleMessage'])
    register_Ns3MmwaveMmWaveRadioBearerTag_methods(root_module, root_module['ns3::mmwave::MmWaveRadioBearerTag'])
    register_Ns3MmwaveMmWaveRarMessage_methods(root_module, root_module['ns3::mmwave::MmWaveRarMessage'])
    register_Ns3MmwaveMmWaveRarMessageRar_methods(root_module, root_module['ns3::mmwave::MmWaveRarMessage::Rar'])
    register_Ns3MmwaveMmWaveRealProtocolRlcSapUser_methods(root_module, root_module['ns3::mmwave::MmWaveRealProtocolRlcSapUser'])
    register_Ns3MmwaveMmWaveRrComponentCarrierManager_methods(root_module, root_module['ns3::mmwave::MmWaveRrComponentCarrierManager'])
    register_Ns3MmwaveMmWaveSib1Message_methods(root_module, root_module['ns3::mmwave::MmWaveSib1Message'])
    register_Ns3MmwaveMmWaveSpectrumPhy_methods(root_module, root_module['ns3::mmwave::MmWaveSpectrumPhy'])
    register_Ns3MmwaveMmWaveSpectrumSignalParametersDlCtrlFrame_methods(root_module, root_module['ns3::mmwave::MmWaveSpectrumSignalParametersDlCtrlFrame'])
    register_Ns3MmwaveMmWaveSpectrumValueHelper_methods(root_module, root_module['ns3::mmwave::MmWaveSpectrumValueHelper'])
    register_Ns3MmwaveMmWaveTbStats_t_methods(root_module, root_module['ns3::mmwave::MmWaveTbStats_t'])
    register_Ns3MmwaveMmWaveTdmaDciMessage_methods(root_module, root_module['ns3::mmwave::MmWaveTdmaDciMessage'])
    register_Ns3MmwaveMmWaveUeMac_methods(root_module, root_module['ns3::mmwave::MmWaveUeMac'])
    register_Ns3MmwaveMmWaveUeNetDevice_methods(root_module, root_module['ns3::mmwave::MmWaveUeNetDevice'])
    register_Ns3MmwaveMmWaveUePhy_methods(root_module, root_module['ns3::mmwave::MmWaveUePhy'])
    register_Ns3MmwaveMmWaveUePhySapUser_methods(root_module, root_module['ns3::mmwave::MmWaveUePhySapUser'])
    register_Ns3MmwaveMmWaveUeRrcProtocolIdeal_methods(root_module, root_module['ns3::mmwave::MmWaveUeRrcProtocolIdeal'])
    register_Ns3MmwaveMmwaveSpectrumSignalParametersDataFrame_methods(root_module, root_module['ns3::mmwave::MmwaveSpectrumSignalParametersDataFrame'])
    register_Ns3MmwaveParams3gpp_methods(root_module, root_module['ns3::mmwave::Params3gpp'])
    register_Ns3MmwaveParamsTable_methods(root_module, root_module['ns3::mmwave::ParamsTable'])
    register_Ns3MmwaveRlcListElement_methods(root_module, root_module['ns3::mmwave::RlcListElement'])
    register_Ns3MmwaveRlcPduInfo_methods(root_module, root_module['ns3::mmwave::RlcPduInfo'])
    register_Ns3MmwaveRxPacketTraceParams_methods(root_module, root_module['ns3::mmwave::RxPacketTraceParams'])
    register_Ns3MmwaveSchedInfo_methods(root_module, root_module['ns3::mmwave::SchedInfo'])
    register_Ns3MmwaveSfAllocInfo_methods(root_module, root_module['ns3::mmwave::SfAllocInfo'])
    register_Ns3MmwaveSfnSf_methods(root_module, root_module['ns3::mmwave::SfnSf'])
    register_Ns3MmwaveSlotAllocInfo_methods(root_module, root_module['ns3::mmwave::SlotAllocInfo'])
    register_Ns3MmwaveTbAllocInfo_methods(root_module, root_module['ns3::mmwave::TbAllocInfo'])
    register_Ns3MmwaveTbInfoElement_methods(root_module, root_module['ns3::mmwave::TbInfoElement'])
    register_Ns3MmwaveTraceParams_methods(root_module, root_module['ns3::mmwave::TraceParams'])
    register_Ns3MmwaveUePhyPacketCountParameter_methods(root_module, root_module['ns3::mmwave::UePhyPacketCountParameter'])
    register_Ns3MmwaveUlCqiInfo_methods(root_module, root_module['ns3::mmwave::UlCqiInfo'])
    register_Ns3MmwaveUlHarqInfo_methods(root_module, root_module['ns3::mmwave::UlHarqInfo'])
    register_Ns3MmwaveChannelCondition_methods(root_module, root_module['ns3::mmwave::channelCondition'])
    register_Ns3MmwaveChannelMatrix_methods(root_module, root_module['ns3::mmwave::channelMatrix'])
    register_Ns3MmwaveChannelScenario_methods(root_module, root_module['ns3::mmwave::channelScenario'])
    register_Ns3MmwaveMmWaveBeamFormingParams_methods(root_module, root_module['ns3::mmwave::mmWaveBeamFormingParams'])
    register_Ns3MmwaveMmWaveBeamFormingTraces_methods(root_module, root_module['ns3::mmwave::mmWaveBeamFormingTraces'])
    register_Ns3MmwaveMmWaveChunkProcessor_methods(root_module, root_module['ns3::mmwave::mmWaveChunkProcessor'])
    register_Ns3MmwaveMmWaveInterference_methods(root_module, root_module['ns3::mmwave::mmWaveInterference'])
    register_Ns3MmwaveMmwaveSpectrumSignalParameters_methods(root_module, root_module['ns3::mmwave::mmwaveSpectrumSignalParameters'])
    register_Ns3MmwaveMmWaveBaRrComponentCarrierManager_methods(root_module, root_module['ns3::mmwave::MmWaveBaRrComponentCarrierManager'])
    register_Ns3MmwaveMmWaveBsrMessage_methods(root_module, root_module['ns3::mmwave::MmWaveBsrMessage'])
    register_Ns3MmwaveMmWaveEnbNetDevice_methods(root_module, root_module['ns3::mmwave::MmWaveEnbNetDevice'])
    register_Ns3MmwaveMmWaveEnbPhy_methods(root_module, root_module['ns3::mmwave::MmWaveEnbPhy'])
    register_Ns3MmwaveMmWaveFlexTtiMacScheduler_methods(root_module, root_module['ns3::mmwave::MmWaveFlexTtiMacScheduler'])
    register_Ns3MmwaveMmWaveFlexTtiMaxRateMacScheduler_methods(root_module, root_module['ns3::mmwave::MmWaveFlexTtiMaxRateMacScheduler'])
    register_Ns3MmwaveMmWaveFlexTtiMaxWeightMacScheduler_methods(root_module, root_module['ns3::mmwave::MmWaveFlexTtiMaxWeightMacScheduler'])
    register_Ns3MmwaveMmWaveFlexTtiPfMacScheduler_methods(root_module, root_module['ns3::mmwave::MmWaveFlexTtiPfMacScheduler'])
    return

def register_Ns3Address_methods(root_module, cls):
    cls.add_binary_comparison_operator('==')
    cls.add_binary_comparison_operator('!=')
    cls.add_binary_comparison_operator('<')
    cls.add_output_stream_operator()
    ## address.h (module 'network'): ns3::Address::Address() [constructor]
    cls.add_constructor([])
    ## address.h (module 'network'): ns3::Address::Address(uint8_t type, uint8_t const * buffer, uint8_t len) [constructor]
    cls.add_constructor([param('uint8_t', 'type'), param('uint8_t const *', 'buffer'), param('uint8_t', 'len')])
    ## address.h (module 'network'): ns3::Address::Address(ns3::Address const & address) [constructor]
    cls.add_constructor([param('ns3::Address const &', 'address')])
    ## address.h (module 'network'): bool ns3::Address::CheckCompatible(uint8_t type, uint8_t len) const [member function]
    cls.add_method('CheckCompatible',
                   'bool',
                   [param('uint8_t', 'type'), param('uint8_t', 'len')],
                   is_const=True)
    ## address.h (module 'network'): uint32_t ns3::Address::CopyAllFrom(uint8_t const * buffer, uint8_t len) [member function]
    cls.add_method('CopyAllFrom',
                   'uint32_t',
                   [param('uint8_t const *', 'buffer'), param('uint8_t', 'len')])
    ## address.h (module 'network'): uint32_t ns3::Address::CopyAllTo(uint8_t * buffer, uint8_t len) const [member function]
    cls.add_method('CopyAllTo',
                   'uint32_t',
                   [param('uint8_t *', 'buffer'), param('uint8_t', 'len')],
                   is_const=True)
    ## address.h (module 'network'): uint32_t ns3::Address::CopyFrom(uint8_t const * buffer, uint8_t len) [member function]
    cls.add_method('CopyFrom',
                   'uint32_t',
                   [param('uint8_t const *', 'buffer'), param('uint8_t', 'len')])
    ## address.h (module 'network'): uint32_t ns3::Address::CopyTo(uint8_t * buffer) const [member function]
    cls.add_method('CopyTo',
                   'uint32_t',
                   [param('uint8_t *', 'buffer')],
                   is_const=True)
    ## address.h (module 'network'): void ns3::Address::Deserialize(ns3::TagBuffer buffer) [member function]
    cls.add_method('Deserialize',
                   'void',
                   [param('ns3::TagBuffer', 'buffer')])
    ## address.h (module 'network'): uint8_t ns3::Address::GetLength() const [member function]
    cls.add_method('GetLength',
                   'uint8_t',
                   [],
                   is_const=True)
    ## address.h (module 'network'): uint32_t ns3::Address::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize',
                   'uint32_t',
                   [],
                   is_const=True)
    ## address.h (module 'network'): bool ns3::Address::IsInvalid() const [member function]
    cls.add_method('IsInvalid',
                   'bool',
                   [],
                   is_const=True)
    ## address.h (module 'network'): bool ns3::Address::IsMatchingType(uint8_t type) const [member function]
    cls.add_method('IsMatchingType',
                   'bool',
                   [param('uint8_t', 'type')],
                   is_const=True)
    ## address.h (module 'network'): static uint8_t ns3::Address::Register() [member function]
    cls.add_method('Register',
                   'uint8_t',
                   [],
                   is_static=True)
    ## address.h (module 'network'): void ns3::Address::Serialize(ns3::TagBuffer buffer) const [member function]
    cls.add_method('Serialize',
                   'void',
                   [param('ns3::TagBuffer', 'buffer')],
                   is_const=True)
    return

def register_Ns3AllocationRetentionPriority_methods(root_module, cls):
    ## eps-bearer.h (module 'lte'): ns3::AllocationRetentionPriority::AllocationRetentionPriority(ns3::AllocationRetentionPriority const & arg0) [constructor]
    cls.add_constructor([param('ns3::AllocationRetentionPriority const &', 'arg0')])
    ## eps-bearer.h (module 'lte'): ns3::AllocationRetentionPriority::AllocationRetentionPriority() [constructor]
    cls.add_constructor([])
    ## eps-bearer.h (module 'lte'): ns3::AllocationRetentionPriority::preemptionCapability [variable]
    cls.add_instance_attribute('preemptionCapability', 'bool', is_const=False)
    ## eps-bearer.h (module 'lte'): ns3::AllocationRetentionPriority::preemptionVulnerability [variable]
    cls.add_instance_attribute('preemptionVulnerability', 'bool', is_const=False)
    ## eps-bearer.h (module 'lte'): ns3::AllocationRetentionPriority::priorityLevel [variable]
    cls.add_instance_attribute('priorityLevel', 'uint8_t', is_const=False)
    return

def register_Ns3Angles_methods(root_module, cls):
    cls.add_output_stream_operator()
    ## angles.h (module 'antenna'): ns3::Angles::Angles(ns3::Angles const & arg0) [constructor]
    cls.add_constructor([param('ns3::Angles const &', 'arg0')])
    ## angles.h (module 'antenna'): ns3::Angles::Angles() [constructor]
    cls.add_constructor([])
    ## angles.h (module 'antenna'): ns3::Angles::Angles(double phi, double theta) [constructor]
    cls.add_constructor([param('double', 'phi'), param('double', 'theta')])
    ## angles.h (module 'antenna'): ns3::Angles::Angles(ns3::Vector v) [constructor]
    cls.add_constructor([param('ns3::Vector', 'v')])
    ## angles.h (module 'antenna'): ns3::Angles::Angles(ns3::Vector v, ns3::Vector o) [constructor]
    cls.add_constructor([param('ns3::Vector', 'v'), param('ns3::Vector', 'o')])
    ## angles.h (module 'antenna'): ns3::Angles::phi [variable]
    cls.add_instance_attribute('phi', 'double', is_const=False)
    ## angles.h (module 'antenna'): ns3::Angles::theta [variable]
    cls.add_instance_attribute('theta', 'double', is_const=False)
    return

def register_Ns3AttributeConstructionList_methods(root_module, cls):
    ## attribute-construction-list.h (module 'core'): ns3::AttributeConstructionList::AttributeConstructionList(ns3::AttributeConstructionList const & arg0) [constructor]
    cls.add_constructor([param('ns3::AttributeConstructionList const &', 'arg0')])
    ## attribute-construction-list.h (module 'core'): ns3::AttributeConstructionList::AttributeConstructionList() [constructor]
    cls.add_constructor([])
    ## attribute-construction-list.h (module 'core'): void ns3::AttributeConstructionList::Add(std::string name, ns3::Ptr<const ns3::AttributeChecker> checker, ns3::Ptr<ns3::AttributeValue> value) [member function]
    cls.add_method('Add',
                   'void',
                   [param('std::string', 'name'), param('ns3::Ptr< ns3::AttributeChecker const >', 'checker'), param('ns3::Ptr< ns3::AttributeValue >', 'value')])
    ## attribute-construction-list.h (module 'core'): ns3::AttributeConstructionList::CIterator ns3::AttributeConstructionList::Begin() const [member function]
    cls.add_method('Begin',
                   'ns3::AttributeConstructionList::CIterator',
                   [],
                   is_const=True)
    ## attribute-construction-list.h (module 'core'): ns3::AttributeConstructionList::CIterator ns3::AttributeConstructionList::End() const [member function]
    cls.add_method('End',
                   'ns3::AttributeConstructionList::CIterator',
                   [],
                   is_const=True)
    ## attribute-construction-list.h (module 'core'): ns3::Ptr<ns3::AttributeValue> ns3::AttributeConstructionList::Find(ns3::Ptr<const ns3::AttributeChecker> checker) const [member function]
    cls.add_method('Find',
                   'ns3::Ptr< ns3::AttributeValue >',
                   [param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_const=True)
    return

def register_Ns3AttributeConstructionListItem_methods(root_module, cls):
    ## attribute-construction-list.h (module 'core'): ns3::AttributeConstructionList::Item::Item() [constructor]
    cls.add_constructor([])
    ## attribute-construction-list.h (module 'core'): ns3::AttributeConstructionList::Item::Item(ns3::AttributeConstructionList::Item const & arg0) [constructor]
    cls.add_constructor([param('ns3::AttributeConstructionList::Item const &', 'arg0')])
    ## attribute-construction-list.h (module 'core'): ns3::AttributeConstructionList::Item::checker [variable]
    cls.add_instance_attribute('checker', 'ns3::Ptr< ns3::AttributeChecker const >', is_const=False)
    ## attribute-construction-list.h (module 'core'): ns3::AttributeConstructionList::Item::name [variable]
    cls.add_instance_attribute('name', 'std::string', is_const=False)
    ## attribute-construction-list.h (module 'core'): ns3::AttributeConstructionList::Item::value [variable]
    cls.add_instance_attribute('value', 'ns3::Ptr< ns3::AttributeValue >', is_const=False)
    return

def register_Ns3BandInfo_methods(root_module, cls):
    ## spectrum-model.h (module 'spectrum'): ns3::BandInfo::BandInfo() [constructor]
    cls.add_constructor([])
    ## spectrum-model.h (module 'spectrum'): ns3::BandInfo::BandInfo(ns3::BandInfo const & arg0) [constructor]
    cls.add_constructor([param('ns3::BandInfo const &', 'arg0')])
    ## spectrum-model.h (module 'spectrum'): ns3::BandInfo::fc [variable]
    cls.add_instance_attribute('fc', 'double', is_const=False)
    ## spectrum-model.h (module 'spectrum'): ns3::BandInfo::fh [variable]
    cls.add_instance_attribute('fh', 'double', is_const=False)
    ## spectrum-model.h (module 'spectrum'): ns3::BandInfo::fl [variable]
    cls.add_instance_attribute('fl', 'double', is_const=False)
    return

def register_Ns3Box_methods(root_module, cls):
    cls.add_output_stream_operator()
    ## box.h (module 'mobility'): ns3::Box::Box(ns3::Box const & arg0) [constructor]
    cls.add_constructor([param('ns3::Box const &', 'arg0')])
    ## box.h (module 'mobility'): ns3::Box::Box(double _xMin, double _xMax, double _yMin, double _yMax, double _zMin, double _zMax) [constructor]
    cls.add_constructor([param('double', '_xMin'), param('double', '_xMax'), param('double', '_yMin'), param('double', '_yMax'), param('double', '_zMin'), param('double', '_zMax')])
    ## box.h (module 'mobility'): ns3::Box::Box() [constructor]
    cls.add_constructor([])
    ## box.h (module 'mobility'): ns3::Vector ns3::Box::CalculateIntersection(ns3::Vector const & current, ns3::Vector const & speed) const [member function]
    cls.add_method('CalculateIntersection',
                   'ns3::Vector',
                   [param('ns3::Vector const &', 'current'), param('ns3::Vector const &', 'speed')],
                   is_const=True)
    ## box.h (module 'mobility'): ns3::Box::Side ns3::Box::GetClosestSide(ns3::Vector const & position) const [member function]
    cls.add_method('GetClosestSide',
                   'ns3::Box::Side',
                   [param('ns3::Vector const &', 'position')],
                   is_const=True)
    ## box.h (module 'mobility'): bool ns3::Box::IsInside(ns3::Vector const & position) const [member function]
    cls.add_method('IsInside',
                   'bool',
                   [param('ns3::Vector const &', 'position')],
                   is_const=True)
    ## box.h (module 'mobility'): ns3::Box::xMax [variable]
    cls.add_instance_attribute('xMax', 'double', is_const=False)
    ## box.h (module 'mobility'): ns3::Box::xMin [variable]
    cls.add_instance_attribute('xMin', 'double', is_const=False)
    ## box.h (module 'mobility'): ns3::Box::yMax [variable]
    cls.add_instance_attribute('yMax', 'double', is_const=False)
    ## box.h (module 'mobility'): ns3::Box::yMin [variable]
    cls.add_instance_attribute('yMin', 'double', is_const=False)
    ## box.h (module 'mobility'): ns3::Box::zMax [variable]
    cls.add_instance_attribute('zMax', 'double', is_const=False)
    ## box.h (module 'mobility'): ns3::Box::zMin [variable]
    cls.add_instance_attribute('zMin', 'double', is_const=False)
    return

def register_Ns3Buffer_methods(root_module, cls):
    ## buffer.h (module 'network'): ns3::Buffer::Buffer(ns3::Buffer const & o) [constructor]
    cls.add_constructor([param('ns3::Buffer const &', 'o')])
    ## buffer.h (module 'network'): ns3::Buffer::Buffer() [constructor]
    cls.add_constructor([])
    ## buffer.h (module 'network'): ns3::Buffer::Buffer(uint32_t dataSize) [constructor]
    cls.add_constructor([param('uint32_t', 'dataSize')])
    ## buffer.h (module 'network'): ns3::Buffer::Buffer(uint32_t dataSize, bool initialize) [constructor]
    cls.add_constructor([param('uint32_t', 'dataSize'), param('bool', 'initialize')])
    ## buffer.h (module 'network'): void ns3::Buffer::AddAtEnd(uint32_t end) [member function]
    cls.add_method('AddAtEnd',
                   'void',
                   [param('uint32_t', 'end')])
    ## buffer.h (module 'network'): void ns3::Buffer::AddAtEnd(ns3::Buffer const & o) [member function]
    cls.add_method('AddAtEnd',
                   'void',
                   [param('ns3::Buffer const &', 'o')])
    ## buffer.h (module 'network'): void ns3::Buffer::AddAtStart(uint32_t start) [member function]
    cls.add_method('AddAtStart',
                   'void',
                   [param('uint32_t', 'start')])
    ## buffer.h (module 'network'): ns3::Buffer::Iterator ns3::Buffer::Begin() const [member function]
    cls.add_method('Begin',
                   'ns3::Buffer::Iterator',
                   [],
                   is_const=True)
    ## buffer.h (module 'network'): void ns3::Buffer::CopyData(std::ostream * os, uint32_t size) const [member function]
    cls.add_method('CopyData',
                   'void',
                   [param('std::ostream *', 'os'), param('uint32_t', 'size')],
                   is_const=True)
    ## buffer.h (module 'network'): uint32_t ns3::Buffer::CopyData(uint8_t * buffer, uint32_t size) const [member function]
    cls.add_method('CopyData',
                   'uint32_t',
                   [param('uint8_t *', 'buffer'), param('uint32_t', 'size')],
                   is_const=True)
    ## buffer.h (module 'network'): ns3::Buffer ns3::Buffer::CreateFragment(uint32_t start, uint32_t length) const [member function]
    cls.add_method('CreateFragment',
                   'ns3::Buffer',
                   [param('uint32_t', 'start'), param('uint32_t', 'length')],
                   is_const=True)
    ## buffer.h (module 'network'): uint32_t ns3::Buffer::Deserialize(uint8_t const * buffer, uint32_t size) [member function]
    cls.add_method('Deserialize',
                   'uint32_t',
                   [param('uint8_t const *', 'buffer'), param('uint32_t', 'size')])
    ## buffer.h (module 'network'): ns3::Buffer::Iterator ns3::Buffer::End() const [member function]
    cls.add_method('End',
                   'ns3::Buffer::Iterator',
                   [],
                   is_const=True)
    ## buffer.h (module 'network'): uint32_t ns3::Buffer::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize',
                   'uint32_t',
                   [],
                   is_const=True)
    ## buffer.h (module 'network'): uint32_t ns3::Buffer::GetSize() const [member function]
    cls.add_method('GetSize',
                   'uint32_t',
                   [],
                   is_const=True)
    ## buffer.h (module 'network'): uint8_t const * ns3::Buffer::PeekData() const [member function]
    cls.add_method('PeekData',
                   'uint8_t const *',
                   [],
                   is_const=True)
    ## buffer.h (module 'network'): void ns3::Buffer::RemoveAtEnd(uint32_t end) [member function]
    cls.add_method('RemoveAtEnd',
                   'void',
                   [param('uint32_t', 'end')])
    ## buffer.h (module 'network'): void ns3::Buffer::RemoveAtStart(uint32_t start) [member function]
    cls.add_method('RemoveAtStart',
                   'void',
                   [param('uint32_t', 'start')])
    ## buffer.h (module 'network'): uint32_t ns3::Buffer::Serialize(uint8_t * buffer, uint32_t maxSize) const [member function]
    cls.add_method('Serialize',
                   'uint32_t',
                   [param('uint8_t *', 'buffer'), param('uint32_t', 'maxSize')],
                   is_const=True)
    return

def register_Ns3BufferIterator_methods(root_module, cls):
    ## buffer.h (module 'network'): ns3::Buffer::Iterator::Iterator(ns3::Buffer::Iterator const & arg0) [constructor]
    cls.add_constructor([param('ns3::Buffer::Iterator const &', 'arg0')])
    ## buffer.h (module 'network'): ns3::Buffer::Iterator::Iterator() [constructor]
    cls.add_constructor([])
    ## buffer.h (module 'network'): uint16_t ns3::Buffer::Iterator::CalculateIpChecksum(uint16_t size) [member function]
    cls.add_method('CalculateIpChecksum',
                   'uint16_t',
                   [param('uint16_t', 'size')])
    ## buffer.h (module 'network'): uint16_t ns3::Buffer::Iterator::CalculateIpChecksum(uint16_t size, uint32_t initialChecksum) [member function]
    cls.add_method('CalculateIpChecksum',
                   'uint16_t',
                   [param('uint16_t', 'size'), param('uint32_t', 'initialChecksum')])
    ## buffer.h (module 'network'): uint32_t ns3::Buffer::Iterator::GetDistanceFrom(ns3::Buffer::Iterator const & o) const [member function]
    cls.add_method('GetDistanceFrom',
                   'uint32_t',
                   [param('ns3::Buffer::Iterator const &', 'o')],
                   is_const=True)
    ## buffer.h (module 'network'): uint32_t ns3::Buffer::Iterator::GetRemainingSize() const [member function]
    cls.add_method('GetRemainingSize',
                   'uint32_t',
                   [],
                   is_const=True)
    ## buffer.h (module 'network'): uint32_t ns3::Buffer::Iterator::GetSize() const [member function]
    cls.add_method('GetSize',
                   'uint32_t',
                   [],
                   is_const=True)
    ## buffer.h (module 'network'): bool ns3::Buffer::Iterator::IsEnd() const [member function]
    cls.add_method('IsEnd',
                   'bool',
                   [],
                   is_const=True)
    ## buffer.h (module 'network'): bool ns3::Buffer::Iterator::IsStart() const [member function]
    cls.add_method('IsStart',
                   'bool',
                   [],
                   is_const=True)
    ## buffer.h (module 'network'): void ns3::Buffer::Iterator::Next() [member function]
    cls.add_method('Next',
                   'void',
                   [])
    ## buffer.h (module 'network'): void ns3::Buffer::Iterator::Next(uint32_t delta) [member function]
    cls.add_method('Next',
                   'void',
                   [param('uint32_t', 'delta')])
    ## buffer.h (module 'network'): uint8_t ns3::Buffer::Iterator::PeekU8() [member function]
    cls.add_method('PeekU8',
                   'uint8_t',
                   [])
    ## buffer.h (module 'network'): void ns3::Buffer::Iterator::Prev() [member function]
    cls.add_method('Prev',
                   'void',
                   [])
    ## buffer.h (module 'network'): void ns3::Buffer::Iterator::Prev(uint32_t delta) [member function]
    cls.add_method('Prev',
                   'void',
                   [param('uint32_t', 'delta')])
    ## buffer.h (module 'network'): void ns3::Buffer::Iterator::Read(uint8_t * buffer, uint32_t size) [member function]
    cls.add_method('Read',
                   'void',
                   [param('uint8_t *', 'buffer'), param('uint32_t', 'size')])
    ## buffer.h (module 'network'): void ns3::Buffer::Iterator::Read(ns3::Buffer::Iterator start, uint32_t size) [member function]
    cls.add_method('Read',
                   'void',
                   [param('ns3::Buffer::Iterator', 'start'), param('uint32_t', 'size')])
    ## buffer.h (module 'network'): uint16_t ns3::Buffer::Iterator::ReadLsbtohU16() [member function]
    cls.add_method('ReadLsbtohU16',
                   'uint16_t',
                   [])
    ## buffer.h (module 'network'): uint32_t ns3::Buffer::Iterator::ReadLsbtohU32() [member function]
    cls.add_method('ReadLsbtohU32',
                   'uint32_t',
                   [])
    ## buffer.h (module 'network'): uint64_t ns3::Buffer::Iterator::ReadLsbtohU64() [member function]
    cls.add_method('ReadLsbtohU64',
                   'uint64_t',
                   [])
    ## buffer.h (module 'network'): uint16_t ns3::Buffer::Iterator::ReadNtohU16() [member function]
    cls.add_method('ReadNtohU16',
                   'uint16_t',
                   [])
    ## buffer.h (module 'network'): uint32_t ns3::Buffer::Iterator::ReadNtohU32() [member function]
    cls.add_method('ReadNtohU32',
                   'uint32_t',
                   [])
    ## buffer.h (module 'network'): uint64_t ns3::Buffer::Iterator::ReadNtohU64() [member function]
    cls.add_method('ReadNtohU64',
                   'uint64_t',
                   [])
    ## buffer.h (module 'network'): uint16_t ns3::Buffer::Iterator::ReadU16() [member function]
    cls.add_method('ReadU16',
                   'uint16_t',
                   [])
    ## buffer.h (module 'network'): uint32_t ns3::Buffer::Iterator::ReadU32() [member function]
    cls.add_method('ReadU32',
                   'uint32_t',
                   [])
    ## buffer.h (module 'network'): uint64_t ns3::Buffer::Iterator::ReadU64() [member function]
    cls.add_method('ReadU64',
                   'uint64_t',
                   [])
    ## buffer.h (module 'network'): uint8_t ns3::Buffer::Iterator::ReadU8() [member function]
    cls.add_method('ReadU8',
                   'uint8_t',
                   [])
    ## buffer.h (module 'network'): void ns3::Buffer::Iterator::Write(uint8_t const * buffer, uint32_t size) [member function]
    cls.add_method('Write',
                   'void',
                   [param('uint8_t const *', 'buffer'), param('uint32_t', 'size')])
    ## buffer.h (module 'network'): void ns3::Buffer::Iterator::Write(ns3::Buffer::Iterator start, ns3::Buffer::Iterator end) [member function]
    cls.add_method('Write',
                   'void',
                   [param('ns3::Buffer::Iterator', 'start'), param('ns3::Buffer::Iterator', 'end')])
    ## buffer.h (module 'network'): void ns3::Buffer::Iterator::WriteHtolsbU16(uint16_t data) [member function]
    cls.add_method('WriteHtolsbU16',
                   'void',
                   [param('uint16_t', 'data')])
    ## buffer.h (module 'network'): void ns3::Buffer::Iterator::WriteHtolsbU32(uint32_t data) [member function]
    cls.add_method('WriteHtolsbU32',
                   'void',
                   [param('uint32_t', 'data')])
    ## buffer.h (module 'network'): void ns3::Buffer::Iterator::WriteHtolsbU64(uint64_t data) [member function]
    cls.add_method('WriteHtolsbU64',
                   'void',
                   [param('uint64_t', 'data')])
    ## buffer.h (module 'network'): void ns3::Buffer::Iterator::WriteHtonU16(uint16_t data) [member function]
    cls.add_method('WriteHtonU16',
                   'void',
                   [param('uint16_t', 'data')])
    ## buffer.h (module 'network'): void ns3::Buffer::Iterator::WriteHtonU32(uint32_t data) [member function]
    cls.add_method('WriteHtonU32',
                   'void',
                   [param('uint32_t', 'data')])
    ## buffer.h (module 'network'): void ns3::Buffer::Iterator::WriteHtonU64(uint64_t data) [member function]
    cls.add_method('WriteHtonU64',
                   'void',
                   [param('uint64_t', 'data')])
    ## buffer.h (module 'network'): void ns3::Buffer::Iterator::WriteU16(uint16_t data) [member function]
    cls.add_method('WriteU16',
                   'void',
                   [param('uint16_t', 'data')])
    ## buffer.h (module 'network'): void ns3::Buffer::Iterator::WriteU32(uint32_t data) [member function]
    cls.add_method('WriteU32',
                   'void',
                   [param('uint32_t', 'data')])
    ## buffer.h (module 'network'): void ns3::Buffer::Iterator::WriteU64(uint64_t data) [member function]
    cls.add_method('WriteU64',
                   'void',
                   [param('uint64_t', 'data')])
    ## buffer.h (module 'network'): void ns3::Buffer::Iterator::WriteU8(uint8_t data) [member function]
    cls.add_method('WriteU8',
                   'void',
                   [param('uint8_t', 'data')])
    ## buffer.h (module 'network'): void ns3::Buffer::Iterator::WriteU8(uint8_t data, uint32_t len) [member function]
    cls.add_method('WriteU8',
                   'void',
                   [param('uint8_t', 'data'), param('uint32_t', 'len')])
    return

def register_Ns3BufferSizeLevelBsr_methods(root_module, cls):
    ## lte-common.h (module 'lte'): ns3::BufferSizeLevelBsr::BufferSizeLevelBsr() [constructor]
    cls.add_constructor([])
    ## lte-common.h (module 'lte'): ns3::BufferSizeLevelBsr::BufferSizeLevelBsr(ns3::BufferSizeLevelBsr const & arg0) [constructor]
    cls.add_constructor([param('ns3::BufferSizeLevelBsr const &', 'arg0')])
    ## lte-common.h (module 'lte'): static uint32_t ns3::BufferSizeLevelBsr::BsrId2BufferSize(uint8_t val) [member function]
    cls.add_method('BsrId2BufferSize',
                   'uint32_t',
                   [param('uint8_t', 'val')],
                   is_static=True)
    ## lte-common.h (module 'lte'): static uint8_t ns3::BufferSizeLevelBsr::BufferSize2BsrId(uint32_t val) [member function]
    cls.add_method('BufferSize2BsrId',
                   'uint8_t',
                   [param('uint32_t', 'val')],
                   is_static=True)
    ## lte-common.h (module 'lte'): ns3::BufferSizeLevelBsr::m_bufferSizeLevelBsr [variable]
    cls.add_static_attribute('m_bufferSizeLevelBsr', 'int [ 64 ]', is_const=False)
    return

def register_Ns3BuildBroadcastListElement_s_methods(root_module, cls):
    ## ff-mac-common.h (module 'lte'): ns3::BuildBroadcastListElement_s::BuildBroadcastListElement_s() [constructor]
    cls.add_constructor([])
    ## ff-mac-common.h (module 'lte'): ns3::BuildBroadcastListElement_s::BuildBroadcastListElement_s(ns3::BuildBroadcastListElement_s const & arg0) [constructor]
    cls.add_constructor([param('ns3::BuildBroadcastListElement_s const &', 'arg0')])
    ## ff-mac-common.h (module 'lte'): ns3::BuildBroadcastListElement_s::m_dci [variable]
    cls.add_instance_attribute('m_dci', 'ns3::DlDciListElement_s', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::BuildBroadcastListElement_s::m_index [variable]
    cls.add_instance_attribute('m_index', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::BuildBroadcastListElement_s::m_type [variable]
    cls.add_instance_attribute('m_type', 'ns3::BuildBroadcastListElement_s::Type_e', is_const=False)
    return

def register_Ns3BuildDataListElement_s_methods(root_module, cls):
    ## ff-mac-common.h (module 'lte'): ns3::BuildDataListElement_s::BuildDataListElement_s() [constructor]
    cls.add_constructor([])
    ## ff-mac-common.h (module 'lte'): ns3::BuildDataListElement_s::BuildDataListElement_s(ns3::BuildDataListElement_s const & arg0) [constructor]
    cls.add_constructor([param('ns3::BuildDataListElement_s const &', 'arg0')])
    ## ff-mac-common.h (module 'lte'): ns3::BuildDataListElement_s::m_ceBitmap [variable]
    cls.add_instance_attribute('m_ceBitmap', 'std::vector< ns3::CeBitmap_e >', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::BuildDataListElement_s::m_dci [variable]
    cls.add_instance_attribute('m_dci', 'ns3::DlDciListElement_s', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::BuildDataListElement_s::m_rlcPduList [variable]
    cls.add_instance_attribute('m_rlcPduList', 'std::vector< std::vector< ns3::RlcPduListElement_s > >', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::BuildDataListElement_s::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    return

def register_Ns3BuildRarListElement_s_methods(root_module, cls):
    ## ff-mac-common.h (module 'lte'): ns3::BuildRarListElement_s::BuildRarListElement_s() [constructor]
    cls.add_constructor([])
    ## ff-mac-common.h (module 'lte'): ns3::BuildRarListElement_s::BuildRarListElement_s(ns3::BuildRarListElement_s const & arg0) [constructor]
    cls.add_constructor([param('ns3::BuildRarListElement_s const &', 'arg0')])
    ## ff-mac-common.h (module 'lte'): ns3::BuildRarListElement_s::m_dci [variable]
    cls.add_instance_attribute('m_dci', 'ns3::DlDciListElement_s', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::BuildRarListElement_s::m_grant [variable]
    cls.add_instance_attribute('m_grant', 'ns3::UlGrant_s', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::BuildRarListElement_s::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    return

def register_Ns3BwPart_s_methods(root_module, cls):
    ## ff-mac-common.h (module 'lte'): ns3::BwPart_s::BwPart_s() [constructor]
    cls.add_constructor([])
    ## ff-mac-common.h (module 'lte'): ns3::BwPart_s::BwPart_s(ns3::BwPart_s const & arg0) [constructor]
    cls.add_constructor([param('ns3::BwPart_s const &', 'arg0')])
    ## ff-mac-common.h (module 'lte'): ns3::BwPart_s::m_bwPartIndex [variable]
    cls.add_instance_attribute('m_bwPartIndex', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::BwPart_s::m_cqi [variable]
    cls.add_instance_attribute('m_cqi', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::BwPart_s::m_sb [variable]
    cls.add_instance_attribute('m_sb', 'uint8_t', is_const=False)
    return

def register_Ns3ByteTagIterator_methods(root_module, cls):
    ## packet.h (module 'network'): ns3::ByteTagIterator::ByteTagIterator(ns3::ByteTagIterator const & arg0) [constructor]
    cls.add_constructor([param('ns3::ByteTagIterator const &', 'arg0')])
    ## packet.h (module 'network'): bool ns3::ByteTagIterator::HasNext() const [member function]
    cls.add_method('HasNext',
                   'bool',
                   [],
                   is_const=True)
    ## packet.h (module 'network'): ns3::ByteTagIterator::Item ns3::ByteTagIterator::Next() [member function]
    cls.add_method('Next',
                   'ns3::ByteTagIterator::Item',
                   [])
    return

def register_Ns3ByteTagIteratorItem_methods(root_module, cls):
    ## packet.h (module 'network'): ns3::ByteTagIterator::Item::Item(ns3::ByteTagIterator::Item const & arg0) [constructor]
    cls.add_constructor([param('ns3::ByteTagIterator::Item const &', 'arg0')])
    ## packet.h (module 'network'): uint32_t ns3::ByteTagIterator::Item::GetEnd() const [member function]
    cls.add_method('GetEnd',
                   'uint32_t',
                   [],
                   is_const=True)
    ## packet.h (module 'network'): uint32_t ns3::ByteTagIterator::Item::GetStart() const [member function]
    cls.add_method('GetStart',
                   'uint32_t',
                   [],
                   is_const=True)
    ## packet.h (module 'network'): void ns3::ByteTagIterator::Item::GetTag(ns3::Tag & tag) const [member function]
    cls.add_method('GetTag',
                   'void',
                   [param('ns3::Tag &', 'tag')],
                   is_const=True)
    ## packet.h (module 'network'): ns3::TypeId ns3::ByteTagIterator::Item::GetTypeId() const [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_const=True)
    return

def register_Ns3ByteTagList_methods(root_module, cls):
    ## byte-tag-list.h (module 'network'): ns3::ByteTagList::ByteTagList() [constructor]
    cls.add_constructor([])
    ## byte-tag-list.h (module 'network'): ns3::ByteTagList::ByteTagList(ns3::ByteTagList const & o) [constructor]
    cls.add_constructor([param('ns3::ByteTagList const &', 'o')])
    ## byte-tag-list.h (module 'network'): ns3::TagBuffer ns3::ByteTagList::Add(ns3::TypeId tid, uint32_t bufferSize, int32_t start, int32_t end) [member function]
    cls.add_method('Add',
                   'ns3::TagBuffer',
                   [param('ns3::TypeId', 'tid'), param('uint32_t', 'bufferSize'), param('int32_t', 'start'), param('int32_t', 'end')])
    ## byte-tag-list.h (module 'network'): void ns3::ByteTagList::Add(ns3::ByteTagList const & o) [member function]
    cls.add_method('Add',
                   'void',
                   [param('ns3::ByteTagList const &', 'o')])
    ## byte-tag-list.h (module 'network'): void ns3::ByteTagList::AddAtEnd(int32_t appendOffset) [member function]
    cls.add_method('AddAtEnd',
                   'void',
                   [param('int32_t', 'appendOffset')])
    ## byte-tag-list.h (module 'network'): void ns3::ByteTagList::AddAtStart(int32_t prependOffset) [member function]
    cls.add_method('AddAtStart',
                   'void',
                   [param('int32_t', 'prependOffset')])
    ## byte-tag-list.h (module 'network'): void ns3::ByteTagList::Adjust(int32_t adjustment) [member function]
    cls.add_method('Adjust',
                   'void',
                   [param('int32_t', 'adjustment')])
    ## byte-tag-list.h (module 'network'): ns3::ByteTagList::Iterator ns3::ByteTagList::Begin(int32_t offsetStart, int32_t offsetEnd) const [member function]
    cls.add_method('Begin',
                   'ns3::ByteTagList::Iterator',
                   [param('int32_t', 'offsetStart'), param('int32_t', 'offsetEnd')],
                   is_const=True)
    ## byte-tag-list.h (module 'network'): void ns3::ByteTagList::RemoveAll() [member function]
    cls.add_method('RemoveAll',
                   'void',
                   [])
    return

def register_Ns3ByteTagListIterator_methods(root_module, cls):
    ## byte-tag-list.h (module 'network'): ns3::ByteTagList::Iterator::Iterator(ns3::ByteTagList::Iterator const & arg0) [constructor]
    cls.add_constructor([param('ns3::ByteTagList::Iterator const &', 'arg0')])
    ## byte-tag-list.h (module 'network'): uint32_t ns3::ByteTagList::Iterator::GetOffsetStart() const [member function]
    cls.add_method('GetOffsetStart',
                   'uint32_t',
                   [],
                   is_const=True)
    ## byte-tag-list.h (module 'network'): bool ns3::ByteTagList::Iterator::HasNext() const [member function]
    cls.add_method('HasNext',
                   'bool',
                   [],
                   is_const=True)
    ## byte-tag-list.h (module 'network'): ns3::ByteTagList::Iterator::Item ns3::ByteTagList::Iterator::Next() [member function]
    cls.add_method('Next',
                   'ns3::ByteTagList::Iterator::Item',
                   [])
    return

def register_Ns3ByteTagListIteratorItem_methods(root_module, cls):
    ## byte-tag-list.h (module 'network'): ns3::ByteTagList::Iterator::Item::Item(ns3::ByteTagList::Iterator::Item const & arg0) [constructor]
    cls.add_constructor([param('ns3::ByteTagList::Iterator::Item const &', 'arg0')])
    ## byte-tag-list.h (module 'network'): ns3::ByteTagList::Iterator::Item::Item(ns3::TagBuffer buf) [constructor]
    cls.add_constructor([param('ns3::TagBuffer', 'buf')])
    ## byte-tag-list.h (module 'network'): ns3::ByteTagList::Iterator::Item::buf [variable]
    cls.add_instance_attribute('buf', 'ns3::TagBuffer', is_const=False)
    ## byte-tag-list.h (module 'network'): ns3::ByteTagList::Iterator::Item::end [variable]
    cls.add_instance_attribute('end', 'int32_t', is_const=False)
    ## byte-tag-list.h (module 'network'): ns3::ByteTagList::Iterator::Item::size [variable]
    cls.add_instance_attribute('size', 'uint32_t', is_const=False)
    ## byte-tag-list.h (module 'network'): ns3::ByteTagList::Iterator::Item::start [variable]
    cls.add_instance_attribute('start', 'int32_t', is_const=False)
    ## byte-tag-list.h (module 'network'): ns3::ByteTagList::Iterator::Item::tid [variable]
    cls.add_instance_attribute('tid', 'ns3::TypeId', is_const=False)
    return

def register_Ns3CallbackBase_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackBase::CallbackBase(ns3::CallbackBase const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackBase const &', 'arg0')])
    ## callback.h (module 'core'): ns3::CallbackBase::CallbackBase() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::Ptr<ns3::CallbackImplBase> ns3::CallbackBase::GetImpl() const [member function]
    cls.add_method('GetImpl',
                   'ns3::Ptr< ns3::CallbackImplBase >',
                   [],
                   is_const=True)
    ## callback.h (module 'core'): ns3::CallbackBase::CallbackBase(ns3::Ptr<ns3::CallbackImplBase> impl) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::CallbackImplBase >', 'impl')],
                        visibility='protected')
    return

def register_Ns3ConstantVelocityHelper_methods(root_module, cls):
    ## constant-velocity-helper.h (module 'mobility'): ns3::ConstantVelocityHelper::ConstantVelocityHelper(ns3::ConstantVelocityHelper const & arg0) [constructor]
    cls.add_constructor([param('ns3::ConstantVelocityHelper const &', 'arg0')])
    ## constant-velocity-helper.h (module 'mobility'): ns3::ConstantVelocityHelper::ConstantVelocityHelper() [constructor]
    cls.add_constructor([])
    ## constant-velocity-helper.h (module 'mobility'): ns3::ConstantVelocityHelper::ConstantVelocityHelper(ns3::Vector const & position) [constructor]
    cls.add_constructor([param('ns3::Vector const &', 'position')])
    ## constant-velocity-helper.h (module 'mobility'): ns3::ConstantVelocityHelper::ConstantVelocityHelper(ns3::Vector const & position, ns3::Vector const & vel) [constructor]
    cls.add_constructor([param('ns3::Vector const &', 'position'), param('ns3::Vector const &', 'vel')])
    ## constant-velocity-helper.h (module 'mobility'): ns3::Vector ns3::ConstantVelocityHelper::GetCurrentPosition() const [member function]
    cls.add_method('GetCurrentPosition',
                   'ns3::Vector',
                   [],
                   is_const=True)
    ## constant-velocity-helper.h (module 'mobility'): ns3::Vector ns3::ConstantVelocityHelper::GetVelocity() const [member function]
    cls.add_method('GetVelocity',
                   'ns3::Vector',
                   [],
                   is_const=True)
    ## constant-velocity-helper.h (module 'mobility'): void ns3::ConstantVelocityHelper::Pause() [member function]
    cls.add_method('Pause',
                   'void',
                   [])
    ## constant-velocity-helper.h (module 'mobility'): void ns3::ConstantVelocityHelper::SetPosition(ns3::Vector const & position) [member function]
    cls.add_method('SetPosition',
                   'void',
                   [param('ns3::Vector const &', 'position')])
    ## constant-velocity-helper.h (module 'mobility'): void ns3::ConstantVelocityHelper::SetVelocity(ns3::Vector const & vel) [member function]
    cls.add_method('SetVelocity',
                   'void',
                   [param('ns3::Vector const &', 'vel')])
    ## constant-velocity-helper.h (module 'mobility'): void ns3::ConstantVelocityHelper::Unpause() [member function]
    cls.add_method('Unpause',
                   'void',
                   [])
    ## constant-velocity-helper.h (module 'mobility'): void ns3::ConstantVelocityHelper::Update() const [member function]
    cls.add_method('Update',
                   'void',
                   [],
                   is_const=True)
    ## constant-velocity-helper.h (module 'mobility'): void ns3::ConstantVelocityHelper::UpdateWithBounds(ns3::Rectangle const & rectangle) const [member function]
    cls.add_method('UpdateWithBounds',
                   'void',
                   [param('ns3::Rectangle const &', 'rectangle')],
                   is_const=True)
    ## constant-velocity-helper.h (module 'mobility'): void ns3::ConstantVelocityHelper::UpdateWithBounds(ns3::Box const & bounds) const [member function]
    cls.add_method('UpdateWithBounds',
                   'void',
                   [param('ns3::Box const &', 'bounds')],
                   is_const=True)
    return

def register_Ns3CqiConfig_s_methods(root_module, cls):
    ## ff-mac-common.h (module 'lte'): ns3::CqiConfig_s::CqiConfig_s() [constructor]
    cls.add_constructor([])
    ## ff-mac-common.h (module 'lte'): ns3::CqiConfig_s::CqiConfig_s(ns3::CqiConfig_s const & arg0) [constructor]
    cls.add_constructor([param('ns3::CqiConfig_s const &', 'arg0')])
    ## ff-mac-common.h (module 'lte'): ns3::CqiConfig_s::m_action [variable]
    cls.add_instance_attribute('m_action', 'ns3::SetupRelease_e', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::CqiConfig_s::m_cqiSchedInterval [variable]
    cls.add_instance_attribute('m_cqiSchedInterval', 'uint16_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::CqiConfig_s::m_riSchedInterval [variable]
    cls.add_instance_attribute('m_riSchedInterval', 'uint8_t', is_const=False)
    return

def register_Ns3CqiListElement_s_methods(root_module, cls):
    ## ff-mac-common.h (module 'lte'): ns3::CqiListElement_s::CqiListElement_s() [constructor]
    cls.add_constructor([])
    ## ff-mac-common.h (module 'lte'): ns3::CqiListElement_s::CqiListElement_s(ns3::CqiListElement_s const & arg0) [constructor]
    cls.add_constructor([param('ns3::CqiListElement_s const &', 'arg0')])
    ## ff-mac-common.h (module 'lte'): ns3::CqiListElement_s::m_cqiType [variable]
    cls.add_instance_attribute('m_cqiType', 'ns3::CqiListElement_s::CqiType_e', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::CqiListElement_s::m_ri [variable]
    cls.add_instance_attribute('m_ri', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::CqiListElement_s::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::CqiListElement_s::m_sbMeasResult [variable]
    cls.add_instance_attribute('m_sbMeasResult', 'ns3::SbMeasResult_s', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::CqiListElement_s::m_wbCqi [variable]
    cls.add_instance_attribute('m_wbCqi', 'std::vector< unsigned char >', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::CqiListElement_s::m_wbPmi [variable]
    cls.add_instance_attribute('m_wbPmi', 'uint8_t', is_const=False)
    return

def register_Ns3DataOutputCallback_methods(root_module, cls):
    ## data-output-interface.h (module 'stats'): ns3::DataOutputCallback::DataOutputCallback() [constructor]
    cls.add_constructor([])
    ## data-output-interface.h (module 'stats'): ns3::DataOutputCallback::DataOutputCallback(ns3::DataOutputCallback const & arg0) [constructor]
    cls.add_constructor([param('ns3::DataOutputCallback const &', 'arg0')])
    ## data-output-interface.h (module 'stats'): void ns3::DataOutputCallback::OutputSingleton(std::string key, std::string variable, int val) [member function]
    cls.add_method('OutputSingleton',
                   'void',
                   [param('std::string', 'key'), param('std::string', 'variable'), param('int', 'val')],
                   is_pure_virtual=True, is_virtual=True)
    ## data-output-interface.h (module 'stats'): void ns3::DataOutputCallback::OutputSingleton(std::string key, std::string variable, uint32_t val) [member function]
    cls.add_method('OutputSingleton',
                   'void',
                   [param('std::string', 'key'), param('std::string', 'variable'), param('uint32_t', 'val')],
                   is_pure_virtual=True, is_virtual=True)
    ## data-output-interface.h (module 'stats'): void ns3::DataOutputCallback::OutputSingleton(std::string key, std::string variable, double val) [member function]
    cls.add_method('OutputSingleton',
                   'void',
                   [param('std::string', 'key'), param('std::string', 'variable'), param('double', 'val')],
                   is_pure_virtual=True, is_virtual=True)
    ## data-output-interface.h (module 'stats'): void ns3::DataOutputCallback::OutputSingleton(std::string key, std::string variable, std::string val) [member function]
    cls.add_method('OutputSingleton',
                   'void',
                   [param('std::string', 'key'), param('std::string', 'variable'), param('std::string', 'val')],
                   is_pure_virtual=True, is_virtual=True)
    ## data-output-interface.h (module 'stats'): void ns3::DataOutputCallback::OutputSingleton(std::string key, std::string variable, ns3::Time val) [member function]
    cls.add_method('OutputSingleton',
                   'void',
                   [param('std::string', 'key'), param('std::string', 'variable'), param('ns3::Time', 'val')],
                   is_pure_virtual=True, is_virtual=True)
    ## data-output-interface.h (module 'stats'): void ns3::DataOutputCallback::OutputStatistic(std::string key, std::string variable, ns3::StatisticalSummary const * statSum) [member function]
    cls.add_method('OutputStatistic',
                   'void',
                   [param('std::string', 'key'), param('std::string', 'variable'), param('ns3::StatisticalSummary const *', 'statSum')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3DataRate_methods(root_module, cls):
    cls.add_output_stream_operator()
    cls.add_binary_comparison_operator('!=')
    cls.add_binary_comparison_operator('<')
    cls.add_binary_comparison_operator('<=')
    cls.add_binary_comparison_operator('==')
    cls.add_binary_comparison_operator('>')
    cls.add_binary_comparison_operator('>=')
    ## data-rate.h (module 'network'): ns3::DataRate::DataRate(ns3::DataRate const & arg0) [constructor]
    cls.add_constructor([param('ns3::DataRate const &', 'arg0')])
    ## data-rate.h (module 'network'): ns3::DataRate::DataRate() [constructor]
    cls.add_constructor([])
    ## data-rate.h (module 'network'): ns3::DataRate::DataRate(uint64_t bps) [constructor]
    cls.add_constructor([param('uint64_t', 'bps')])
    ## data-rate.h (module 'network'): ns3::DataRate::DataRate(std::string rate) [constructor]
    cls.add_constructor([param('std::string', 'rate')])
    ## data-rate.h (module 'network'): ns3::Time ns3::DataRate::CalculateBitsTxTime(uint32_t bits) const [member function]
    cls.add_method('CalculateBitsTxTime',
                   'ns3::Time',
                   [param('uint32_t', 'bits')],
                   is_const=True)
    ## data-rate.h (module 'network'): ns3::Time ns3::DataRate::CalculateBytesTxTime(uint32_t bytes) const [member function]
    cls.add_method('CalculateBytesTxTime',
                   'ns3::Time',
                   [param('uint32_t', 'bytes')],
                   is_const=True)
    ## data-rate.h (module 'network'): double ns3::DataRate::CalculateTxTime(uint32_t bytes) const [member function]
    cls.add_method('CalculateTxTime',
                   'double',
                   [param('uint32_t', 'bytes')],
                   deprecated=True, is_const=True)
    ## data-rate.h (module 'network'): uint64_t ns3::DataRate::GetBitRate() const [member function]
    cls.add_method('GetBitRate',
                   'uint64_t',
                   [],
                   is_const=True)
    return

def register_Ns3DefaultDeleter__Ns3AttributeAccessor_methods(root_module, cls):
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::AttributeAccessor>::DefaultDeleter() [constructor]
    cls.add_constructor([])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::AttributeAccessor>::DefaultDeleter(ns3::DefaultDeleter<ns3::AttributeAccessor> const & arg0) [constructor]
    cls.add_constructor([param('ns3::DefaultDeleter< ns3::AttributeAccessor > const &', 'arg0')])
    ## default-deleter.h (module 'core'): static void ns3::DefaultDeleter<ns3::AttributeAccessor>::Delete(ns3::AttributeAccessor * object) [member function]
    cls.add_method('Delete',
                   'void',
                   [param('ns3::AttributeAccessor *', 'object')],
                   is_static=True)
    return

def register_Ns3DefaultDeleter__Ns3AttributeChecker_methods(root_module, cls):
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::AttributeChecker>::DefaultDeleter() [constructor]
    cls.add_constructor([])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::AttributeChecker>::DefaultDeleter(ns3::DefaultDeleter<ns3::AttributeChecker> const & arg0) [constructor]
    cls.add_constructor([param('ns3::DefaultDeleter< ns3::AttributeChecker > const &', 'arg0')])
    ## default-deleter.h (module 'core'): static void ns3::DefaultDeleter<ns3::AttributeChecker>::Delete(ns3::AttributeChecker * object) [member function]
    cls.add_method('Delete',
                   'void',
                   [param('ns3::AttributeChecker *', 'object')],
                   is_static=True)
    return

def register_Ns3DefaultDeleter__Ns3AttributeValue_methods(root_module, cls):
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::AttributeValue>::DefaultDeleter() [constructor]
    cls.add_constructor([])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::AttributeValue>::DefaultDeleter(ns3::DefaultDeleter<ns3::AttributeValue> const & arg0) [constructor]
    cls.add_constructor([param('ns3::DefaultDeleter< ns3::AttributeValue > const &', 'arg0')])
    ## default-deleter.h (module 'core'): static void ns3::DefaultDeleter<ns3::AttributeValue>::Delete(ns3::AttributeValue * object) [member function]
    cls.add_method('Delete',
                   'void',
                   [param('ns3::AttributeValue *', 'object')],
                   is_static=True)
    return

def register_Ns3DefaultDeleter__Ns3CallbackImplBase_methods(root_module, cls):
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::CallbackImplBase>::DefaultDeleter() [constructor]
    cls.add_constructor([])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::CallbackImplBase>::DefaultDeleter(ns3::DefaultDeleter<ns3::CallbackImplBase> const & arg0) [constructor]
    cls.add_constructor([param('ns3::DefaultDeleter< ns3::CallbackImplBase > const &', 'arg0')])
    ## default-deleter.h (module 'core'): static void ns3::DefaultDeleter<ns3::CallbackImplBase>::Delete(ns3::CallbackImplBase * object) [member function]
    cls.add_method('Delete',
                   'void',
                   [param('ns3::CallbackImplBase *', 'object')],
                   is_static=True)
    return

def register_Ns3DefaultDeleter__Ns3EpcTft_methods(root_module, cls):
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::EpcTft>::DefaultDeleter() [constructor]
    cls.add_constructor([])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::EpcTft>::DefaultDeleter(ns3::DefaultDeleter<ns3::EpcTft> const & arg0) [constructor]
    cls.add_constructor([param('ns3::DefaultDeleter< ns3::EpcTft > const &', 'arg0')])
    ## default-deleter.h (module 'core'): static void ns3::DefaultDeleter<ns3::EpcTft>::Delete(ns3::EpcTft * object) [member function]
    cls.add_method('Delete',
                   'void',
                   [param('ns3::EpcTft *', 'object')],
                   is_static=True)
    return

def register_Ns3DefaultDeleter__Ns3EventImpl_methods(root_module, cls):
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::EventImpl>::DefaultDeleter() [constructor]
    cls.add_constructor([])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::EventImpl>::DefaultDeleter(ns3::DefaultDeleter<ns3::EventImpl> const & arg0) [constructor]
    cls.add_constructor([param('ns3::DefaultDeleter< ns3::EventImpl > const &', 'arg0')])
    ## default-deleter.h (module 'core'): static void ns3::DefaultDeleter<ns3::EventImpl>::Delete(ns3::EventImpl * object) [member function]
    cls.add_method('Delete',
                   'void',
                   [param('ns3::EventImpl *', 'object')],
                   is_static=True)
    return

def register_Ns3DefaultDeleter__Ns3HashImplementation_methods(root_module, cls):
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::Hash::Implementation>::DefaultDeleter() [constructor]
    cls.add_constructor([])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::Hash::Implementation>::DefaultDeleter(ns3::DefaultDeleter<ns3::Hash::Implementation> const & arg0) [constructor]
    cls.add_constructor([param('ns3::DefaultDeleter< ns3::Hash::Implementation > const &', 'arg0')])
    ## default-deleter.h (module 'core'): static void ns3::DefaultDeleter<ns3::Hash::Implementation>::Delete(ns3::Hash::Implementation * object) [member function]
    cls.add_method('Delete',
                   'void',
                   [param('ns3::Hash::Implementation *', 'object')],
                   is_static=True)
    return

def register_Ns3DefaultDeleter__Ns3LteControlMessage_methods(root_module, cls):
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::LteControlMessage>::DefaultDeleter() [constructor]
    cls.add_constructor([])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::LteControlMessage>::DefaultDeleter(ns3::DefaultDeleter<ns3::LteControlMessage> const & arg0) [constructor]
    cls.add_constructor([param('ns3::DefaultDeleter< ns3::LteControlMessage > const &', 'arg0')])
    ## default-deleter.h (module 'core'): static void ns3::DefaultDeleter<ns3::LteControlMessage>::Delete(ns3::LteControlMessage * object) [member function]
    cls.add_method('Delete',
                   'void',
                   [param('ns3::LteControlMessage *', 'object')],
                   is_static=True)
    return

def register_Ns3DefaultDeleter__Ns3LteHarqPhy_methods(root_module, cls):
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::LteHarqPhy>::DefaultDeleter() [constructor]
    cls.add_constructor([])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::LteHarqPhy>::DefaultDeleter(ns3::DefaultDeleter<ns3::LteHarqPhy> const & arg0) [constructor]
    cls.add_constructor([param('ns3::DefaultDeleter< ns3::LteHarqPhy > const &', 'arg0')])
    ## default-deleter.h (module 'core'): static void ns3::DefaultDeleter<ns3::LteHarqPhy>::Delete(ns3::LteHarqPhy * object) [member function]
    cls.add_method('Delete',
                   'void',
                   [param('ns3::LteHarqPhy *', 'object')],
                   is_static=True)
    return

def register_Ns3DefaultDeleter__Ns3NixVector_methods(root_module, cls):
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::NixVector>::DefaultDeleter() [constructor]
    cls.add_constructor([])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::NixVector>::DefaultDeleter(ns3::DefaultDeleter<ns3::NixVector> const & arg0) [constructor]
    cls.add_constructor([param('ns3::DefaultDeleter< ns3::NixVector > const &', 'arg0')])
    ## default-deleter.h (module 'core'): static void ns3::DefaultDeleter<ns3::NixVector>::Delete(ns3::NixVector * object) [member function]
    cls.add_method('Delete',
                   'void',
                   [param('ns3::NixVector *', 'object')],
                   is_static=True)
    return

def register_Ns3DefaultDeleter__Ns3Packet_methods(root_module, cls):
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::Packet>::DefaultDeleter() [constructor]
    cls.add_constructor([])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::Packet>::DefaultDeleter(ns3::DefaultDeleter<ns3::Packet> const & arg0) [constructor]
    cls.add_constructor([param('ns3::DefaultDeleter< ns3::Packet > const &', 'arg0')])
    ## default-deleter.h (module 'core'): static void ns3::DefaultDeleter<ns3::Packet>::Delete(ns3::Packet * object) [member function]
    cls.add_method('Delete',
                   'void',
                   [param('ns3::Packet *', 'object')],
                   is_static=True)
    return

def register_Ns3DefaultDeleter__Ns3QueueItem_methods(root_module, cls):
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::QueueItem>::DefaultDeleter() [constructor]
    cls.add_constructor([])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::QueueItem>::DefaultDeleter(ns3::DefaultDeleter<ns3::QueueItem> const & arg0) [constructor]
    cls.add_constructor([param('ns3::DefaultDeleter< ns3::QueueItem > const &', 'arg0')])
    ## default-deleter.h (module 'core'): static void ns3::DefaultDeleter<ns3::QueueItem>::Delete(ns3::QueueItem * object) [member function]
    cls.add_method('Delete',
                   'void',
                   [param('ns3::QueueItem *', 'object')],
                   is_static=True)
    return

def register_Ns3DefaultDeleter__Ns3SpectrumModel_methods(root_module, cls):
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::SpectrumModel>::DefaultDeleter() [constructor]
    cls.add_constructor([])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::SpectrumModel>::DefaultDeleter(ns3::DefaultDeleter<ns3::SpectrumModel> const & arg0) [constructor]
    cls.add_constructor([param('ns3::DefaultDeleter< ns3::SpectrumModel > const &', 'arg0')])
    ## default-deleter.h (module 'core'): static void ns3::DefaultDeleter<ns3::SpectrumModel>::Delete(ns3::SpectrumModel * object) [member function]
    cls.add_method('Delete',
                   'void',
                   [param('ns3::SpectrumModel *', 'object')],
                   is_static=True)
    return

def register_Ns3DefaultDeleter__Ns3SpectrumSignalParameters_methods(root_module, cls):
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::SpectrumSignalParameters>::DefaultDeleter() [constructor]
    cls.add_constructor([])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::SpectrumSignalParameters>::DefaultDeleter(ns3::DefaultDeleter<ns3::SpectrumSignalParameters> const & arg0) [constructor]
    cls.add_constructor([param('ns3::DefaultDeleter< ns3::SpectrumSignalParameters > const &', 'arg0')])
    ## default-deleter.h (module 'core'): static void ns3::DefaultDeleter<ns3::SpectrumSignalParameters>::Delete(ns3::SpectrumSignalParameters * object) [member function]
    cls.add_method('Delete',
                   'void',
                   [param('ns3::SpectrumSignalParameters *', 'object')],
                   is_static=True)
    return

def register_Ns3DefaultDeleter__Ns3SpectrumValue_methods(root_module, cls):
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::SpectrumValue>::DefaultDeleter() [constructor]
    cls.add_constructor([])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::SpectrumValue>::DefaultDeleter(ns3::DefaultDeleter<ns3::SpectrumValue> const & arg0) [constructor]
    cls.add_constructor([param('ns3::DefaultDeleter< ns3::SpectrumValue > const &', 'arg0')])
    ## default-deleter.h (module 'core'): static void ns3::DefaultDeleter<ns3::SpectrumValue>::Delete(ns3::SpectrumValue * object) [member function]
    cls.add_method('Delete',
                   'void',
                   [param('ns3::SpectrumValue *', 'object')],
                   is_static=True)
    return

def register_Ns3DefaultDeleter__Ns3TraceSourceAccessor_methods(root_module, cls):
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::TraceSourceAccessor>::DefaultDeleter() [constructor]
    cls.add_constructor([])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::TraceSourceAccessor>::DefaultDeleter(ns3::DefaultDeleter<ns3::TraceSourceAccessor> const & arg0) [constructor]
    cls.add_constructor([param('ns3::DefaultDeleter< ns3::TraceSourceAccessor > const &', 'arg0')])
    ## default-deleter.h (module 'core'): static void ns3::DefaultDeleter<ns3::TraceSourceAccessor>::Delete(ns3::TraceSourceAccessor * object) [member function]
    cls.add_method('Delete',
                   'void',
                   [param('ns3::TraceSourceAccessor *', 'object')],
                   is_static=True)
    return

def register_Ns3DefaultDeleter__Ns3VendorSpecificValue_methods(root_module, cls):
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::VendorSpecificValue>::DefaultDeleter() [constructor]
    cls.add_constructor([])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::VendorSpecificValue>::DefaultDeleter(ns3::DefaultDeleter<ns3::VendorSpecificValue> const & arg0) [constructor]
    cls.add_constructor([param('ns3::DefaultDeleter< ns3::VendorSpecificValue > const &', 'arg0')])
    ## default-deleter.h (module 'core'): static void ns3::DefaultDeleter<ns3::VendorSpecificValue>::Delete(ns3::VendorSpecificValue * object) [member function]
    cls.add_method('Delete',
                   'void',
                   [param('ns3::VendorSpecificValue *', 'object')],
                   is_static=True)
    return

def register_Ns3DefaultDeleter__Ns3MmwaveBeamformingParams_methods(root_module, cls):
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::mmwave::BeamformingParams>::DefaultDeleter() [constructor]
    cls.add_constructor([])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::mmwave::BeamformingParams>::DefaultDeleter(ns3::DefaultDeleter<ns3::mmwave::BeamformingParams> const & arg0) [constructor]
    cls.add_constructor([param('ns3::DefaultDeleter< ns3::mmwave::BeamformingParams > const &', 'arg0')])
    ## default-deleter.h (module 'core'): static void ns3::DefaultDeleter<ns3::mmwave::BeamformingParams>::Delete(ns3::mmwave::BeamformingParams * object) [member function]
    cls.add_method('Delete',
                   'void',
                   [param('ns3::mmwave::BeamformingParams *', 'object')],
                   is_static=True)
    return

def register_Ns3DefaultDeleter__Ns3MmwaveChannelParams_methods(root_module, cls):
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::mmwave::ChannelParams>::DefaultDeleter() [constructor]
    cls.add_constructor([])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::mmwave::ChannelParams>::DefaultDeleter(ns3::DefaultDeleter<ns3::mmwave::ChannelParams> const & arg0) [constructor]
    cls.add_constructor([param('ns3::DefaultDeleter< ns3::mmwave::ChannelParams > const &', 'arg0')])
    ## default-deleter.h (module 'core'): static void ns3::DefaultDeleter<ns3::mmwave::ChannelParams>::Delete(ns3::mmwave::ChannelParams * object) [member function]
    cls.add_method('Delete',
                   'void',
                   [param('ns3::mmwave::ChannelParams *', 'object')],
                   is_static=True)
    return

def register_Ns3DefaultDeleter__Ns3MmwaveMmWaveControlMessage_methods(root_module, cls):
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::mmwave::MmWaveControlMessage>::DefaultDeleter() [constructor]
    cls.add_constructor([])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::mmwave::MmWaveControlMessage>::DefaultDeleter(ns3::DefaultDeleter<ns3::mmwave::MmWaveControlMessage> const & arg0) [constructor]
    cls.add_constructor([param('ns3::DefaultDeleter< ns3::mmwave::MmWaveControlMessage > const &', 'arg0')])
    ## default-deleter.h (module 'core'): static void ns3::DefaultDeleter<ns3::mmwave::MmWaveControlMessage>::Delete(ns3::mmwave::MmWaveControlMessage * object) [member function]
    cls.add_method('Delete',
                   'void',
                   [param('ns3::mmwave::MmWaveControlMessage *', 'object')],
                   is_static=True)
    return

def register_Ns3DefaultDeleter__Ns3MmwaveMmWaveHarqPhy_methods(root_module, cls):
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::mmwave::MmWaveHarqPhy>::DefaultDeleter() [constructor]
    cls.add_constructor([])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::mmwave::MmWaveHarqPhy>::DefaultDeleter(ns3::DefaultDeleter<ns3::mmwave::MmWaveHarqPhy> const & arg0) [constructor]
    cls.add_constructor([param('ns3::DefaultDeleter< ns3::mmwave::MmWaveHarqPhy > const &', 'arg0')])
    ## default-deleter.h (module 'core'): static void ns3::DefaultDeleter<ns3::mmwave::MmWaveHarqPhy>::Delete(ns3::mmwave::MmWaveHarqPhy * object) [member function]
    cls.add_method('Delete',
                   'void',
                   [param('ns3::mmwave::MmWaveHarqPhy *', 'object')],
                   is_static=True)
    return

def register_Ns3DefaultDeleter__Ns3MmwaveParams3gpp_methods(root_module, cls):
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::mmwave::Params3gpp>::DefaultDeleter() [constructor]
    cls.add_constructor([])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::mmwave::Params3gpp>::DefaultDeleter(ns3::DefaultDeleter<ns3::mmwave::Params3gpp> const & arg0) [constructor]
    cls.add_constructor([param('ns3::DefaultDeleter< ns3::mmwave::Params3gpp > const &', 'arg0')])
    ## default-deleter.h (module 'core'): static void ns3::DefaultDeleter<ns3::mmwave::Params3gpp>::Delete(ns3::mmwave::Params3gpp * object) [member function]
    cls.add_method('Delete',
                   'void',
                   [param('ns3::mmwave::Params3gpp *', 'object')],
                   is_static=True)
    return

def register_Ns3DefaultDeleter__Ns3MmwaveTraceParams_methods(root_module, cls):
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::mmwave::TraceParams>::DefaultDeleter() [constructor]
    cls.add_constructor([])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::mmwave::TraceParams>::DefaultDeleter(ns3::DefaultDeleter<ns3::mmwave::TraceParams> const & arg0) [constructor]
    cls.add_constructor([param('ns3::DefaultDeleter< ns3::mmwave::TraceParams > const &', 'arg0')])
    ## default-deleter.h (module 'core'): static void ns3::DefaultDeleter<ns3::mmwave::TraceParams>::Delete(ns3::mmwave::TraceParams * object) [member function]
    cls.add_method('Delete',
                   'void',
                   [param('ns3::mmwave::TraceParams *', 'object')],
                   is_static=True)
    return

def register_Ns3DefaultDeleter__Ns3MmwaveMmWaveChunkProcessor_methods(root_module, cls):
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::mmwave::mmWaveChunkProcessor>::DefaultDeleter() [constructor]
    cls.add_constructor([])
    ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::mmwave::mmWaveChunkProcessor>::DefaultDeleter(ns3::DefaultDeleter<ns3::mmwave::mmWaveChunkProcessor> const & arg0) [constructor]
    cls.add_constructor([param('ns3::DefaultDeleter< ns3::mmwave::mmWaveChunkProcessor > const &', 'arg0')])
    ## default-deleter.h (module 'core'): static void ns3::DefaultDeleter<ns3::mmwave::mmWaveChunkProcessor>::Delete(ns3::mmwave::mmWaveChunkProcessor * object) [member function]
    cls.add_method('Delete',
                   'void',
                   [param('ns3::mmwave::mmWaveChunkProcessor *', 'object')],
                   is_static=True)
    return

def register_Ns3DlDciListElement_s_methods(root_module, cls):
    ## ff-mac-common.h (module 'lte'): ns3::DlDciListElement_s::DlDciListElement_s() [constructor]
    cls.add_constructor([])
    ## ff-mac-common.h (module 'lte'): ns3::DlDciListElement_s::DlDciListElement_s(ns3::DlDciListElement_s const & arg0) [constructor]
    cls.add_constructor([param('ns3::DlDciListElement_s const &', 'arg0')])
    ## ff-mac-common.h (module 'lte'): ns3::DlDciListElement_s::m_aggrLevel [variable]
    cls.add_instance_attribute('m_aggrLevel', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::DlDciListElement_s::m_cceIndex [variable]
    cls.add_instance_attribute('m_cceIndex', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::DlDciListElement_s::m_dai [variable]
    cls.add_instance_attribute('m_dai', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::DlDciListElement_s::m_dlPowerOffset [variable]
    cls.add_instance_attribute('m_dlPowerOffset', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::DlDciListElement_s::m_format [variable]
    cls.add_instance_attribute('m_format', 'ns3::DlDciListElement_s::Format_e', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::DlDciListElement_s::m_harqProcess [variable]
    cls.add_instance_attribute('m_harqProcess', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::DlDciListElement_s::m_mcs [variable]
    cls.add_instance_attribute('m_mcs', 'std::vector< unsigned char >', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::DlDciListElement_s::m_nGap [variable]
    cls.add_instance_attribute('m_nGap', 'ns3::DlDciListElement_s::Ngap_e', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::DlDciListElement_s::m_ndi [variable]
    cls.add_instance_attribute('m_ndi', 'std::vector< unsigned char >', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::DlDciListElement_s::m_pdcchOrder [variable]
    cls.add_instance_attribute('m_pdcchOrder', 'bool', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::DlDciListElement_s::m_pdcchPowerOffset [variable]
    cls.add_instance_attribute('m_pdcchPowerOffset', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::DlDciListElement_s::m_prachMaskIndex [variable]
    cls.add_instance_attribute('m_prachMaskIndex', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::DlDciListElement_s::m_preambleIndex [variable]
    cls.add_instance_attribute('m_preambleIndex', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::DlDciListElement_s::m_precodingInfo [variable]
    cls.add_instance_attribute('m_precodingInfo', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::DlDciListElement_s::m_rbBitmap [variable]
    cls.add_instance_attribute('m_rbBitmap', 'uint32_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::DlDciListElement_s::m_rbShift [variable]
    cls.add_instance_attribute('m_rbShift', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::DlDciListElement_s::m_resAlloc [variable]
    cls.add_instance_attribute('m_resAlloc', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::DlDciListElement_s::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::DlDciListElement_s::m_rv [variable]
    cls.add_instance_attribute('m_rv', 'std::vector< unsigned char >', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::DlDciListElement_s::m_spsRelease [variable]
    cls.add_instance_attribute('m_spsRelease', 'bool', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::DlDciListElement_s::m_tbSwap [variable]
    cls.add_instance_attribute('m_tbSwap', 'bool', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::DlDciListElement_s::m_tbsIdx [variable]
    cls.add_instance_attribute('m_tbsIdx', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::DlDciListElement_s::m_tbsSize [variable]
    cls.add_instance_attribute('m_tbsSize', 'std::vector< unsigned short >', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::DlDciListElement_s::m_tpc [variable]
    cls.add_instance_attribute('m_tpc', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::DlDciListElement_s::m_vrbFormat [variable]
    cls.add_instance_attribute('m_vrbFormat', 'ns3::DlDciListElement_s::VrbFormat_e', is_const=False)
    return

def register_Ns3DlInfoListElement_s_methods(root_module, cls):
    ## ff-mac-common.h (module 'lte'): ns3::DlInfoListElement_s::DlInfoListElement_s() [constructor]
    cls.add_constructor([])
    ## ff-mac-common.h (module 'lte'): ns3::DlInfoListElement_s::DlInfoListElement_s(ns3::DlInfoListElement_s const & arg0) [constructor]
    cls.add_constructor([param('ns3::DlInfoListElement_s const &', 'arg0')])
    ## ff-mac-common.h (module 'lte'): ns3::DlInfoListElement_s::m_harqProcessId [variable]
    cls.add_instance_attribute('m_harqProcessId', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::DlInfoListElement_s::m_harqStatus [variable]
    cls.add_instance_attribute('m_harqStatus', 'std::vector< ns3::DlInfoListElement_s::HarqStatus_e >', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::DlInfoListElement_s::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    return

def register_Ns3DlSchedulingCallbackInfo_methods(root_module, cls):
    ## lte-common.h (module 'lte'): ns3::DlSchedulingCallbackInfo::DlSchedulingCallbackInfo() [constructor]
    cls.add_constructor([])
    ## lte-common.h (module 'lte'): ns3::DlSchedulingCallbackInfo::DlSchedulingCallbackInfo(ns3::DlSchedulingCallbackInfo const & arg0) [constructor]
    cls.add_constructor([param('ns3::DlSchedulingCallbackInfo const &', 'arg0')])
    ## lte-common.h (module 'lte'): ns3::DlSchedulingCallbackInfo::componentCarrierId [variable]
    cls.add_instance_attribute('componentCarrierId', 'uint8_t', is_const=False)
    ## lte-common.h (module 'lte'): ns3::DlSchedulingCallbackInfo::frameNo [variable]
    cls.add_instance_attribute('frameNo', 'uint32_t', is_const=False)
    ## lte-common.h (module 'lte'): ns3::DlSchedulingCallbackInfo::mcsTb1 [variable]
    cls.add_instance_attribute('mcsTb1', 'uint8_t', is_const=False)
    ## lte-common.h (module 'lte'): ns3::DlSchedulingCallbackInfo::mcsTb2 [variable]
    cls.add_instance_attribute('mcsTb2', 'uint8_t', is_const=False)
    ## lte-common.h (module 'lte'): ns3::DlSchedulingCallbackInfo::rnti [variable]
    cls.add_instance_attribute('rnti', 'uint16_t', is_const=False)
    ## lte-common.h (module 'lte'): ns3::DlSchedulingCallbackInfo::sizeTb1 [variable]
    cls.add_instance_attribute('sizeTb1', 'uint16_t', is_const=False)
    ## lte-common.h (module 'lte'): ns3::DlSchedulingCallbackInfo::sizeTb2 [variable]
    cls.add_instance_attribute('sizeTb2', 'uint16_t', is_const=False)
    ## lte-common.h (module 'lte'): ns3::DlSchedulingCallbackInfo::subframeNo [variable]
    cls.add_instance_attribute('subframeNo', 'uint32_t', is_const=False)
    return

def register_Ns3DrxConfig_s_methods(root_module, cls):
    ## ff-mac-common.h (module 'lte'): ns3::DrxConfig_s::DrxConfig_s() [constructor]
    cls.add_constructor([])
    ## ff-mac-common.h (module 'lte'): ns3::DrxConfig_s::DrxConfig_s(ns3::DrxConfig_s const & arg0) [constructor]
    cls.add_constructor([param('ns3::DrxConfig_s const &', 'arg0')])
    ## ff-mac-common.h (module 'lte'): ns3::DrxConfig_s::m_drxInactivityTimer [variable]
    cls.add_instance_attribute('m_drxInactivityTimer', 'uint16_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::DrxConfig_s::m_drxRetransmissionTimer [variable]
    cls.add_instance_attribute('m_drxRetransmissionTimer', 'uint16_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::DrxConfig_s::m_drxShortCycleTimer [variable]
    cls.add_instance_attribute('m_drxShortCycleTimer', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::DrxConfig_s::m_longDrxCycle [variable]
    cls.add_instance_attribute('m_longDrxCycle', 'uint16_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::DrxConfig_s::m_longDrxCycleStartOffset [variable]
    cls.add_instance_attribute('m_longDrxCycleStartOffset', 'uint16_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::DrxConfig_s::m_onDurationTimer [variable]
    cls.add_instance_attribute('m_onDurationTimer', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::DrxConfig_s::m_shortDrxCycle [variable]
    cls.add_instance_attribute('m_shortDrxCycle', 'uint16_t', is_const=False)
    return

def register_Ns3EpcEnbS1SapProvider_methods(root_module, cls):
    ## epc-enb-s1-sap.h (module 'lte'): ns3::EpcEnbS1SapProvider::EpcEnbS1SapProvider() [constructor]
    cls.add_constructor([])
    ## epc-enb-s1-sap.h (module 'lte'): ns3::EpcEnbS1SapProvider::EpcEnbS1SapProvider(ns3::EpcEnbS1SapProvider const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcEnbS1SapProvider const &', 'arg0')])
    ## epc-enb-s1-sap.h (module 'lte'): void ns3::EpcEnbS1SapProvider::DoSendReleaseIndication(uint64_t imsi, uint16_t rnti, uint8_t bearerId) [member function]
    cls.add_method('DoSendReleaseIndication',
                   'void',
                   [param('uint64_t', 'imsi'), param('uint16_t', 'rnti'), param('uint8_t', 'bearerId')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-enb-s1-sap.h (module 'lte'): void ns3::EpcEnbS1SapProvider::InitialUeMessage(uint64_t imsi, uint16_t rnti) [member function]
    cls.add_method('InitialUeMessage',
                   'void',
                   [param('uint64_t', 'imsi'), param('uint16_t', 'rnti')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-enb-s1-sap.h (module 'lte'): void ns3::EpcEnbS1SapProvider::PathSwitchRequest(ns3::EpcEnbS1SapProvider::PathSwitchRequestParameters params) [member function]
    cls.add_method('PathSwitchRequest',
                   'void',
                   [param('ns3::EpcEnbS1SapProvider::PathSwitchRequestParameters', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-enb-s1-sap.h (module 'lte'): void ns3::EpcEnbS1SapProvider::UeContextRelease(uint16_t rnti) [member function]
    cls.add_method('UeContextRelease',
                   'void',
                   [param('uint16_t', 'rnti')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3EpcEnbS1SapProviderBearerToBeSwitched_methods(root_module, cls):
    ## epc-enb-s1-sap.h (module 'lte'): ns3::EpcEnbS1SapProvider::BearerToBeSwitched::BearerToBeSwitched() [constructor]
    cls.add_constructor([])
    ## epc-enb-s1-sap.h (module 'lte'): ns3::EpcEnbS1SapProvider::BearerToBeSwitched::BearerToBeSwitched(ns3::EpcEnbS1SapProvider::BearerToBeSwitched const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcEnbS1SapProvider::BearerToBeSwitched const &', 'arg0')])
    ## epc-enb-s1-sap.h (module 'lte'): ns3::EpcEnbS1SapProvider::BearerToBeSwitched::epsBearerId [variable]
    cls.add_instance_attribute('epsBearerId', 'uint8_t', is_const=False)
    ## epc-enb-s1-sap.h (module 'lte'): ns3::EpcEnbS1SapProvider::BearerToBeSwitched::teid [variable]
    cls.add_instance_attribute('teid', 'uint32_t', is_const=False)
    return

def register_Ns3EpcEnbS1SapProviderPathSwitchRequestParameters_methods(root_module, cls):
    ## epc-enb-s1-sap.h (module 'lte'): ns3::EpcEnbS1SapProvider::PathSwitchRequestParameters::PathSwitchRequestParameters() [constructor]
    cls.add_constructor([])
    ## epc-enb-s1-sap.h (module 'lte'): ns3::EpcEnbS1SapProvider::PathSwitchRequestParameters::PathSwitchRequestParameters(ns3::EpcEnbS1SapProvider::PathSwitchRequestParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcEnbS1SapProvider::PathSwitchRequestParameters const &', 'arg0')])
    ## epc-enb-s1-sap.h (module 'lte'): ns3::EpcEnbS1SapProvider::PathSwitchRequestParameters::bearersToBeSwitched [variable]
    cls.add_instance_attribute('bearersToBeSwitched', 'std::list< ns3::EpcEnbS1SapProvider::BearerToBeSwitched >', is_const=False)
    ## epc-enb-s1-sap.h (module 'lte'): ns3::EpcEnbS1SapProvider::PathSwitchRequestParameters::cellId [variable]
    cls.add_instance_attribute('cellId', 'uint16_t', is_const=False)
    ## epc-enb-s1-sap.h (module 'lte'): ns3::EpcEnbS1SapProvider::PathSwitchRequestParameters::mmeUeS1Id [variable]
    cls.add_instance_attribute('mmeUeS1Id', 'uint32_t', is_const=False)
    ## epc-enb-s1-sap.h (module 'lte'): ns3::EpcEnbS1SapProvider::PathSwitchRequestParameters::rnti [variable]
    cls.add_instance_attribute('rnti', 'uint16_t', is_const=False)
    return

def register_Ns3EpcEnbS1SapUser_methods(root_module, cls):
    ## epc-enb-s1-sap.h (module 'lte'): ns3::EpcEnbS1SapUser::EpcEnbS1SapUser() [constructor]
    cls.add_constructor([])
    ## epc-enb-s1-sap.h (module 'lte'): ns3::EpcEnbS1SapUser::EpcEnbS1SapUser(ns3::EpcEnbS1SapUser const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcEnbS1SapUser const &', 'arg0')])
    ## epc-enb-s1-sap.h (module 'lte'): void ns3::EpcEnbS1SapUser::DataRadioBearerSetupRequest(ns3::EpcEnbS1SapUser::DataRadioBearerSetupRequestParameters params) [member function]
    cls.add_method('DataRadioBearerSetupRequest',
                   'void',
                   [param('ns3::EpcEnbS1SapUser::DataRadioBearerSetupRequestParameters', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-enb-s1-sap.h (module 'lte'): void ns3::EpcEnbS1SapUser::PathSwitchRequestAcknowledge(ns3::EpcEnbS1SapUser::PathSwitchRequestAcknowledgeParameters params) [member function]
    cls.add_method('PathSwitchRequestAcknowledge',
                   'void',
                   [param('ns3::EpcEnbS1SapUser::PathSwitchRequestAcknowledgeParameters', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3EpcEnbS1SapUserDataRadioBearerSetupRequestParameters_methods(root_module, cls):
    ## epc-enb-s1-sap.h (module 'lte'): ns3::EpcEnbS1SapUser::DataRadioBearerSetupRequestParameters::DataRadioBearerSetupRequestParameters() [constructor]
    cls.add_constructor([])
    ## epc-enb-s1-sap.h (module 'lte'): ns3::EpcEnbS1SapUser::DataRadioBearerSetupRequestParameters::DataRadioBearerSetupRequestParameters(ns3::EpcEnbS1SapUser::DataRadioBearerSetupRequestParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcEnbS1SapUser::DataRadioBearerSetupRequestParameters const &', 'arg0')])
    ## epc-enb-s1-sap.h (module 'lte'): ns3::EpcEnbS1SapUser::DataRadioBearerSetupRequestParameters::bearer [variable]
    cls.add_instance_attribute('bearer', 'ns3::EpsBearer', is_const=False)
    ## epc-enb-s1-sap.h (module 'lte'): ns3::EpcEnbS1SapUser::DataRadioBearerSetupRequestParameters::bearerId [variable]
    cls.add_instance_attribute('bearerId', 'uint8_t', is_const=False)
    ## epc-enb-s1-sap.h (module 'lte'): ns3::EpcEnbS1SapUser::DataRadioBearerSetupRequestParameters::gtpTeid [variable]
    cls.add_instance_attribute('gtpTeid', 'uint32_t', is_const=False)
    ## epc-enb-s1-sap.h (module 'lte'): ns3::EpcEnbS1SapUser::DataRadioBearerSetupRequestParameters::rnti [variable]
    cls.add_instance_attribute('rnti', 'uint16_t', is_const=False)
    ## epc-enb-s1-sap.h (module 'lte'): ns3::EpcEnbS1SapUser::DataRadioBearerSetupRequestParameters::transportLayerAddress [variable]
    cls.add_instance_attribute('transportLayerAddress', 'ns3::Ipv4Address', is_const=False)
    return

def register_Ns3EpcEnbS1SapUserPathSwitchRequestAcknowledgeParameters_methods(root_module, cls):
    ## epc-enb-s1-sap.h (module 'lte'): ns3::EpcEnbS1SapUser::PathSwitchRequestAcknowledgeParameters::PathSwitchRequestAcknowledgeParameters() [constructor]
    cls.add_constructor([])
    ## epc-enb-s1-sap.h (module 'lte'): ns3::EpcEnbS1SapUser::PathSwitchRequestAcknowledgeParameters::PathSwitchRequestAcknowledgeParameters(ns3::EpcEnbS1SapUser::PathSwitchRequestAcknowledgeParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcEnbS1SapUser::PathSwitchRequestAcknowledgeParameters const &', 'arg0')])
    ## epc-enb-s1-sap.h (module 'lte'): ns3::EpcEnbS1SapUser::PathSwitchRequestAcknowledgeParameters::rnti [variable]
    cls.add_instance_attribute('rnti', 'uint16_t', is_const=False)
    return

def register_Ns3EpcX2Sap_methods(root_module, cls):
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::EpcX2Sap() [constructor]
    cls.add_constructor([])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::EpcX2Sap(ns3::EpcX2Sap const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcX2Sap const &', 'arg0')])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::m_maxPdcpSn [variable]
    cls.add_static_attribute('m_maxPdcpSn', 'uint16_t const', is_const=True)
    return

def register_Ns3EpcX2SapCellInformationItem_methods(root_module, cls):
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::CellInformationItem::CellInformationItem() [constructor]
    cls.add_constructor([])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::CellInformationItem::CellInformationItem(ns3::EpcX2Sap::CellInformationItem const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcX2Sap::CellInformationItem const &', 'arg0')])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::CellInformationItem::relativeNarrowbandTxBand [variable]
    cls.add_instance_attribute('relativeNarrowbandTxBand', 'ns3::EpcX2Sap::RelativeNarrowbandTxBand', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::CellInformationItem::sourceCellId [variable]
    cls.add_instance_attribute('sourceCellId', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::CellInformationItem::ulHighInterferenceInformationList [variable]
    cls.add_instance_attribute('ulHighInterferenceInformationList', 'std::vector< ns3::EpcX2Sap::UlHighInterferenceInformationItem >', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::CellInformationItem::ulInterferenceOverloadIndicationList [variable]
    cls.add_instance_attribute('ulInterferenceOverloadIndicationList', 'std::vector< ns3::EpcX2Sap::UlInterferenceOverloadIndicationItem >', is_const=False)
    return

def register_Ns3EpcX2SapCellMeasurementResultItem_methods(root_module, cls):
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::CellMeasurementResultItem::CellMeasurementResultItem() [constructor]
    cls.add_constructor([])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::CellMeasurementResultItem::CellMeasurementResultItem(ns3::EpcX2Sap::CellMeasurementResultItem const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcX2Sap::CellMeasurementResultItem const &', 'arg0')])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::CellMeasurementResultItem::dlCompositeAvailableCapacity [variable]
    cls.add_instance_attribute('dlCompositeAvailableCapacity', 'ns3::EpcX2Sap::CompositeAvailCapacity', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::CellMeasurementResultItem::dlGbrPrbUsage [variable]
    cls.add_instance_attribute('dlGbrPrbUsage', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::CellMeasurementResultItem::dlHardwareLoadIndicator [variable]
    cls.add_instance_attribute('dlHardwareLoadIndicator', 'ns3::EpcX2Sap::LoadIndicator', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::CellMeasurementResultItem::dlNonGbrPrbUsage [variable]
    cls.add_instance_attribute('dlNonGbrPrbUsage', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::CellMeasurementResultItem::dlS1TnlLoadIndicator [variable]
    cls.add_instance_attribute('dlS1TnlLoadIndicator', 'ns3::EpcX2Sap::LoadIndicator', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::CellMeasurementResultItem::dlTotalPrbUsage [variable]
    cls.add_instance_attribute('dlTotalPrbUsage', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::CellMeasurementResultItem::sourceCellId [variable]
    cls.add_instance_attribute('sourceCellId', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::CellMeasurementResultItem::ulCompositeAvailableCapacity [variable]
    cls.add_instance_attribute('ulCompositeAvailableCapacity', 'ns3::EpcX2Sap::CompositeAvailCapacity', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::CellMeasurementResultItem::ulGbrPrbUsage [variable]
    cls.add_instance_attribute('ulGbrPrbUsage', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::CellMeasurementResultItem::ulHardwareLoadIndicator [variable]
    cls.add_instance_attribute('ulHardwareLoadIndicator', 'ns3::EpcX2Sap::LoadIndicator', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::CellMeasurementResultItem::ulNonGbrPrbUsage [variable]
    cls.add_instance_attribute('ulNonGbrPrbUsage', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::CellMeasurementResultItem::ulS1TnlLoadIndicator [variable]
    cls.add_instance_attribute('ulS1TnlLoadIndicator', 'ns3::EpcX2Sap::LoadIndicator', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::CellMeasurementResultItem::ulTotalPrbUsage [variable]
    cls.add_instance_attribute('ulTotalPrbUsage', 'uint16_t', is_const=False)
    return

def register_Ns3EpcX2SapCompositeAvailCapacity_methods(root_module, cls):
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::CompositeAvailCapacity::CompositeAvailCapacity() [constructor]
    cls.add_constructor([])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::CompositeAvailCapacity::CompositeAvailCapacity(ns3::EpcX2Sap::CompositeAvailCapacity const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcX2Sap::CompositeAvailCapacity const &', 'arg0')])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::CompositeAvailCapacity::capacityValue [variable]
    cls.add_instance_attribute('capacityValue', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::CompositeAvailCapacity::cellCapacityClassValue [variable]
    cls.add_instance_attribute('cellCapacityClassValue', 'uint16_t', is_const=False)
    return

def register_Ns3EpcX2SapErabAdmittedItem_methods(root_module, cls):
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::ErabAdmittedItem::ErabAdmittedItem() [constructor]
    cls.add_constructor([])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::ErabAdmittedItem::ErabAdmittedItem(ns3::EpcX2Sap::ErabAdmittedItem const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcX2Sap::ErabAdmittedItem const &', 'arg0')])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::ErabAdmittedItem::dlGtpTeid [variable]
    cls.add_instance_attribute('dlGtpTeid', 'uint32_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::ErabAdmittedItem::erabId [variable]
    cls.add_instance_attribute('erabId', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::ErabAdmittedItem::ulGtpTeid [variable]
    cls.add_instance_attribute('ulGtpTeid', 'uint32_t', is_const=False)
    return

def register_Ns3EpcX2SapErabNotAdmittedItem_methods(root_module, cls):
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::ErabNotAdmittedItem::ErabNotAdmittedItem() [constructor]
    cls.add_constructor([])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::ErabNotAdmittedItem::ErabNotAdmittedItem(ns3::EpcX2Sap::ErabNotAdmittedItem const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcX2Sap::ErabNotAdmittedItem const &', 'arg0')])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::ErabNotAdmittedItem::cause [variable]
    cls.add_instance_attribute('cause', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::ErabNotAdmittedItem::erabId [variable]
    cls.add_instance_attribute('erabId', 'uint16_t', is_const=False)
    return

def register_Ns3EpcX2SapErabToBeSetupItem_methods(root_module, cls):
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::ErabToBeSetupItem::ErabToBeSetupItem(ns3::EpcX2Sap::ErabToBeSetupItem const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcX2Sap::ErabToBeSetupItem const &', 'arg0')])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::ErabToBeSetupItem::ErabToBeSetupItem() [constructor]
    cls.add_constructor([])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::ErabToBeSetupItem::dlForwarding [variable]
    cls.add_instance_attribute('dlForwarding', 'bool', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::ErabToBeSetupItem::erabId [variable]
    cls.add_instance_attribute('erabId', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::ErabToBeSetupItem::erabLevelQosParameters [variable]
    cls.add_instance_attribute('erabLevelQosParameters', 'ns3::EpsBearer', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::ErabToBeSetupItem::gtpTeid [variable]
    cls.add_instance_attribute('gtpTeid', 'uint32_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::ErabToBeSetupItem::transportLayerAddress [variable]
    cls.add_instance_attribute('transportLayerAddress', 'ns3::Ipv4Address', is_const=False)
    return

def register_Ns3EpcX2SapErabsSubjectToStatusTransferItem_methods(root_module, cls):
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::ErabsSubjectToStatusTransferItem::ErabsSubjectToStatusTransferItem() [constructor]
    cls.add_constructor([])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::ErabsSubjectToStatusTransferItem::ErabsSubjectToStatusTransferItem(ns3::EpcX2Sap::ErabsSubjectToStatusTransferItem const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcX2Sap::ErabsSubjectToStatusTransferItem const &', 'arg0')])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::ErabsSubjectToStatusTransferItem::dlHfn [variable]
    cls.add_instance_attribute('dlHfn', 'uint32_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::ErabsSubjectToStatusTransferItem::dlPdcpSn [variable]
    cls.add_instance_attribute('dlPdcpSn', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::ErabsSubjectToStatusTransferItem::erabId [variable]
    cls.add_instance_attribute('erabId', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::ErabsSubjectToStatusTransferItem::receiveStatusOfUlPdcpSdus [variable]
    cls.add_instance_attribute('receiveStatusOfUlPdcpSdus', 'std::bitset< 4096 >', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::ErabsSubjectToStatusTransferItem::ulHfn [variable]
    cls.add_instance_attribute('ulHfn', 'uint32_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::ErabsSubjectToStatusTransferItem::ulPdcpSn [variable]
    cls.add_instance_attribute('ulPdcpSn', 'uint16_t', is_const=False)
    return

def register_Ns3EpcX2SapHandoverFailedParams_methods(root_module, cls):
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::HandoverFailedParams::HandoverFailedParams() [constructor]
    cls.add_constructor([])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::HandoverFailedParams::HandoverFailedParams(ns3::EpcX2Sap::HandoverFailedParams const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcX2Sap::HandoverFailedParams const &', 'arg0')])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::HandoverFailedParams::coordinatorId [variable]
    cls.add_instance_attribute('coordinatorId', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::HandoverFailedParams::imsi [variable]
    cls.add_instance_attribute('imsi', 'uint64_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::HandoverFailedParams::sourceCellId [variable]
    cls.add_instance_attribute('sourceCellId', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::HandoverFailedParams::targetCellId [variable]
    cls.add_instance_attribute('targetCellId', 'uint16_t', is_const=False)
    return

def register_Ns3EpcX2SapHandoverPreparationFailureParams_methods(root_module, cls):
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::HandoverPreparationFailureParams::HandoverPreparationFailureParams() [constructor]
    cls.add_constructor([])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::HandoverPreparationFailureParams::HandoverPreparationFailureParams(ns3::EpcX2Sap::HandoverPreparationFailureParams const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcX2Sap::HandoverPreparationFailureParams const &', 'arg0')])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::HandoverPreparationFailureParams::cause [variable]
    cls.add_instance_attribute('cause', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::HandoverPreparationFailureParams::criticalityDiagnostics [variable]
    cls.add_instance_attribute('criticalityDiagnostics', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::HandoverPreparationFailureParams::oldEnbUeX2apId [variable]
    cls.add_instance_attribute('oldEnbUeX2apId', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::HandoverPreparationFailureParams::sourceCellId [variable]
    cls.add_instance_attribute('sourceCellId', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::HandoverPreparationFailureParams::targetCellId [variable]
    cls.add_instance_attribute('targetCellId', 'uint16_t', is_const=False)
    return

def register_Ns3EpcX2SapHandoverRequestAckParams_methods(root_module, cls):
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::HandoverRequestAckParams::HandoverRequestAckParams() [constructor]
    cls.add_constructor([])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::HandoverRequestAckParams::HandoverRequestAckParams(ns3::EpcX2Sap::HandoverRequestAckParams const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcX2Sap::HandoverRequestAckParams const &', 'arg0')])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::HandoverRequestAckParams::admittedBearers [variable]
    cls.add_instance_attribute('admittedBearers', 'std::vector< ns3::EpcX2Sap::ErabAdmittedItem >', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::HandoverRequestAckParams::newEnbUeX2apId [variable]
    cls.add_instance_attribute('newEnbUeX2apId', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::HandoverRequestAckParams::notAdmittedBearers [variable]
    cls.add_instance_attribute('notAdmittedBearers', 'std::vector< ns3::EpcX2Sap::ErabNotAdmittedItem >', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::HandoverRequestAckParams::oldEnbUeX2apId [variable]
    cls.add_instance_attribute('oldEnbUeX2apId', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::HandoverRequestAckParams::rrcContext [variable]
    cls.add_instance_attribute('rrcContext', 'ns3::Ptr< ns3::Packet >', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::HandoverRequestAckParams::sourceCellId [variable]
    cls.add_instance_attribute('sourceCellId', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::HandoverRequestAckParams::targetCellId [variable]
    cls.add_instance_attribute('targetCellId', 'uint16_t', is_const=False)
    return

def register_Ns3EpcX2SapHandoverRequestParams_methods(root_module, cls):
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::HandoverRequestParams::HandoverRequestParams() [constructor]
    cls.add_constructor([])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::HandoverRequestParams::HandoverRequestParams(ns3::EpcX2Sap::HandoverRequestParams const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcX2Sap::HandoverRequestParams const &', 'arg0')])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::HandoverRequestParams::bearers [variable]
    cls.add_instance_attribute('bearers', 'std::vector< ns3::EpcX2Sap::ErabToBeSetupItem >', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::HandoverRequestParams::cause [variable]
    cls.add_instance_attribute('cause', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::HandoverRequestParams::isMc [variable]
    cls.add_instance_attribute('isMc', 'bool', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::HandoverRequestParams::mmeUeS1apId [variable]
    cls.add_instance_attribute('mmeUeS1apId', 'uint32_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::HandoverRequestParams::oldEnbUeX2apId [variable]
    cls.add_instance_attribute('oldEnbUeX2apId', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::HandoverRequestParams::rlcRequests [variable]
    cls.add_instance_attribute('rlcRequests', 'std::vector< ns3::EpcX2Sap::RlcSetupRequest >', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::HandoverRequestParams::rrcContext [variable]
    cls.add_instance_attribute('rrcContext', 'ns3::Ptr< ns3::Packet >', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::HandoverRequestParams::sourceCellId [variable]
    cls.add_instance_attribute('sourceCellId', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::HandoverRequestParams::targetCellId [variable]
    cls.add_instance_attribute('targetCellId', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::HandoverRequestParams::ueAggregateMaxBitRateDownlink [variable]
    cls.add_instance_attribute('ueAggregateMaxBitRateDownlink', 'uint64_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::HandoverRequestParams::ueAggregateMaxBitRateUplink [variable]
    cls.add_instance_attribute('ueAggregateMaxBitRateUplink', 'uint64_t', is_const=False)
    return

def register_Ns3EpcX2SapLoadInformationParams_methods(root_module, cls):
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::LoadInformationParams::LoadInformationParams() [constructor]
    cls.add_constructor([])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::LoadInformationParams::LoadInformationParams(ns3::EpcX2Sap::LoadInformationParams const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcX2Sap::LoadInformationParams const &', 'arg0')])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::LoadInformationParams::cellInformationList [variable]
    cls.add_instance_attribute('cellInformationList', 'std::vector< ns3::EpcX2Sap::CellInformationItem >', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::LoadInformationParams::targetCellId [variable]
    cls.add_instance_attribute('targetCellId', 'uint16_t', is_const=False)
    return

def register_Ns3EpcX2SapRelativeNarrowbandTxBand_methods(root_module, cls):
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::RelativeNarrowbandTxBand::RelativeNarrowbandTxBand() [constructor]
    cls.add_constructor([])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::RelativeNarrowbandTxBand::RelativeNarrowbandTxBand(ns3::EpcX2Sap::RelativeNarrowbandTxBand const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcX2Sap::RelativeNarrowbandTxBand const &', 'arg0')])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::RelativeNarrowbandTxBand::antennaPorts [variable]
    cls.add_instance_attribute('antennaPorts', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::RelativeNarrowbandTxBand::pB [variable]
    cls.add_instance_attribute('pB', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::RelativeNarrowbandTxBand::pdcchInterferenceImpact [variable]
    cls.add_instance_attribute('pdcchInterferenceImpact', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::RelativeNarrowbandTxBand::rntpPerPrbList [variable]
    cls.add_instance_attribute('rntpPerPrbList', 'std::vector< bool >', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::RelativeNarrowbandTxBand::rntpThreshold [variable]
    cls.add_instance_attribute('rntpThreshold', 'int16_t', is_const=False)
    return

def register_Ns3EpcX2SapResourceStatusUpdateParams_methods(root_module, cls):
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::ResourceStatusUpdateParams::ResourceStatusUpdateParams() [constructor]
    cls.add_constructor([])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::ResourceStatusUpdateParams::ResourceStatusUpdateParams(ns3::EpcX2Sap::ResourceStatusUpdateParams const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcX2Sap::ResourceStatusUpdateParams const &', 'arg0')])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::ResourceStatusUpdateParams::cellMeasurementResultList [variable]
    cls.add_instance_attribute('cellMeasurementResultList', 'std::vector< ns3::EpcX2Sap::CellMeasurementResultItem >', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::ResourceStatusUpdateParams::enb1MeasurementId [variable]
    cls.add_instance_attribute('enb1MeasurementId', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::ResourceStatusUpdateParams::enb2MeasurementId [variable]
    cls.add_instance_attribute('enb2MeasurementId', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::ResourceStatusUpdateParams::targetCellId [variable]
    cls.add_instance_attribute('targetCellId', 'uint16_t', is_const=False)
    return

def register_Ns3EpcX2SapRlcSetupRequest_methods(root_module, cls):
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::RlcSetupRequest::RlcSetupRequest() [constructor]
    cls.add_constructor([])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::RlcSetupRequest::RlcSetupRequest(ns3::EpcX2Sap::RlcSetupRequest const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcX2Sap::RlcSetupRequest const &', 'arg0')])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::RlcSetupRequest::drbid [variable]
    cls.add_instance_attribute('drbid', 'uint8_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::RlcSetupRequest::gtpTeid [variable]
    cls.add_instance_attribute('gtpTeid', 'uint32_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::RlcSetupRequest::lcinfo [variable]
    cls.add_instance_attribute('lcinfo', 'ns3::LteEnbCmacSapProvider::LcInfo', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::RlcSetupRequest::logicalChannelConfig [variable]
    cls.add_instance_attribute('logicalChannelConfig', 'ns3::LteRrcSap::LogicalChannelConfig', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::RlcSetupRequest::lteRnti [variable]
    cls.add_instance_attribute('lteRnti', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::RlcSetupRequest::mmWaveRnti [variable]
    cls.add_instance_attribute('mmWaveRnti', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::RlcSetupRequest::rlcConfig [variable]
    cls.add_instance_attribute('rlcConfig', 'ns3::LteRrcSap::RlcConfig', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::RlcSetupRequest::rlcType [variable]
    cls.add_instance_attribute('rlcType', 'ns3::TypeId', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::RlcSetupRequest::sourceCellId [variable]
    cls.add_instance_attribute('sourceCellId', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::RlcSetupRequest::targetCellId [variable]
    cls.add_instance_attribute('targetCellId', 'uint16_t', is_const=False)
    return

def register_Ns3EpcX2SapSecondaryHandoverCompletedParams_methods(root_module, cls):
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::SecondaryHandoverCompletedParams::SecondaryHandoverCompletedParams() [constructor]
    cls.add_constructor([])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::SecondaryHandoverCompletedParams::SecondaryHandoverCompletedParams(ns3::EpcX2Sap::SecondaryHandoverCompletedParams const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcX2Sap::SecondaryHandoverCompletedParams const &', 'arg0')])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::SecondaryHandoverCompletedParams::cellId [variable]
    cls.add_instance_attribute('cellId', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::SecondaryHandoverCompletedParams::imsi [variable]
    cls.add_instance_attribute('imsi', 'uint64_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::SecondaryHandoverCompletedParams::mmWaveRnti [variable]
    cls.add_instance_attribute('mmWaveRnti', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::SecondaryHandoverCompletedParams::oldEnbUeX2apId [variable]
    cls.add_instance_attribute('oldEnbUeX2apId', 'uint16_t', is_const=False)
    return

def register_Ns3EpcX2SapSecondaryHandoverParams_methods(root_module, cls):
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::SecondaryHandoverParams::SecondaryHandoverParams() [constructor]
    cls.add_constructor([])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::SecondaryHandoverParams::SecondaryHandoverParams(ns3::EpcX2Sap::SecondaryHandoverParams const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcX2Sap::SecondaryHandoverParams const &', 'arg0')])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::SecondaryHandoverParams::imsi [variable]
    cls.add_instance_attribute('imsi', 'uint64_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::SecondaryHandoverParams::oldCellId [variable]
    cls.add_instance_attribute('oldCellId', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::SecondaryHandoverParams::targetCellId [variable]
    cls.add_instance_attribute('targetCellId', 'uint16_t', is_const=False)
    return

def register_Ns3EpcX2SapSnStatusTransferParams_methods(root_module, cls):
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::SnStatusTransferParams::SnStatusTransferParams() [constructor]
    cls.add_constructor([])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::SnStatusTransferParams::SnStatusTransferParams(ns3::EpcX2Sap::SnStatusTransferParams const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcX2Sap::SnStatusTransferParams const &', 'arg0')])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::SnStatusTransferParams::erabsSubjectToStatusTransferList [variable]
    cls.add_instance_attribute('erabsSubjectToStatusTransferList', 'std::vector< ns3::EpcX2Sap::ErabsSubjectToStatusTransferItem >', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::SnStatusTransferParams::newEnbUeX2apId [variable]
    cls.add_instance_attribute('newEnbUeX2apId', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::SnStatusTransferParams::oldEnbUeX2apId [variable]
    cls.add_instance_attribute('oldEnbUeX2apId', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::SnStatusTransferParams::sourceCellId [variable]
    cls.add_instance_attribute('sourceCellId', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::SnStatusTransferParams::targetCellId [variable]
    cls.add_instance_attribute('targetCellId', 'uint16_t', is_const=False)
    return

def register_Ns3EpcX2SapSwitchConnectionParams_methods(root_module, cls):
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::SwitchConnectionParams::SwitchConnectionParams() [constructor]
    cls.add_constructor([])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::SwitchConnectionParams::SwitchConnectionParams(ns3::EpcX2Sap::SwitchConnectionParams const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcX2Sap::SwitchConnectionParams const &', 'arg0')])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::SwitchConnectionParams::drbid [variable]
    cls.add_instance_attribute('drbid', 'uint8_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::SwitchConnectionParams::mmWaveCellId [variable]
    cls.add_instance_attribute('mmWaveCellId', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::SwitchConnectionParams::mmWaveRnti [variable]
    cls.add_instance_attribute('mmWaveRnti', 'uint32_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::SwitchConnectionParams::useMmWaveConnection [variable]
    cls.add_instance_attribute('useMmWaveConnection', 'bool', is_const=False)
    return

def register_Ns3EpcX2SapUeContextReleaseParams_methods(root_module, cls):
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::UeContextReleaseParams::UeContextReleaseParams() [constructor]
    cls.add_constructor([])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::UeContextReleaseParams::UeContextReleaseParams(ns3::EpcX2Sap::UeContextReleaseParams const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcX2Sap::UeContextReleaseParams const &', 'arg0')])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::UeContextReleaseParams::newEnbUeX2apId [variable]
    cls.add_instance_attribute('newEnbUeX2apId', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::UeContextReleaseParams::oldEnbUeX2apId [variable]
    cls.add_instance_attribute('oldEnbUeX2apId', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::UeContextReleaseParams::sourceCellId [variable]
    cls.add_instance_attribute('sourceCellId', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::UeContextReleaseParams::targetCellId [variable]
    cls.add_instance_attribute('targetCellId', 'uint16_t', is_const=False)
    return

def register_Ns3EpcX2SapUeDataParams_methods(root_module, cls):
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::UeDataParams::UeDataParams() [constructor]
    cls.add_constructor([])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::UeDataParams::UeDataParams(ns3::EpcX2Sap::UeDataParams const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcX2Sap::UeDataParams const &', 'arg0')])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::UeDataParams::gtpTeid [variable]
    cls.add_instance_attribute('gtpTeid', 'uint32_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::UeDataParams::sourceCellId [variable]
    cls.add_instance_attribute('sourceCellId', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::UeDataParams::targetCellId [variable]
    cls.add_instance_attribute('targetCellId', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::UeDataParams::ueData [variable]
    cls.add_instance_attribute('ueData', 'ns3::Ptr< ns3::Packet >', is_const=False)
    return

def register_Ns3EpcX2SapUeImsiSinrParams_methods(root_module, cls):
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::UeImsiSinrParams::UeImsiSinrParams() [constructor]
    cls.add_constructor([])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::UeImsiSinrParams::UeImsiSinrParams(ns3::EpcX2Sap::UeImsiSinrParams const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcX2Sap::UeImsiSinrParams const &', 'arg0')])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::UeImsiSinrParams::sourceCellId [variable]
    cls.add_instance_attribute('sourceCellId', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::UeImsiSinrParams::targetCellId [variable]
    cls.add_instance_attribute('targetCellId', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::UeImsiSinrParams::ueImsiSinrMap [variable]
    cls.add_instance_attribute('ueImsiSinrMap', 'std::map< unsigned long, double >', is_const=False)
    return

def register_Ns3EpcX2SapUlHighInterferenceInformationItem_methods(root_module, cls):
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::UlHighInterferenceInformationItem::UlHighInterferenceInformationItem() [constructor]
    cls.add_constructor([])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::UlHighInterferenceInformationItem::UlHighInterferenceInformationItem(ns3::EpcX2Sap::UlHighInterferenceInformationItem const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcX2Sap::UlHighInterferenceInformationItem const &', 'arg0')])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::UlHighInterferenceInformationItem::targetCellId [variable]
    cls.add_instance_attribute('targetCellId', 'uint16_t', is_const=False)
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2Sap::UlHighInterferenceInformationItem::ulHighInterferenceIndicationList [variable]
    cls.add_instance_attribute('ulHighInterferenceIndicationList', 'std::vector< bool >', is_const=False)
    return

def register_Ns3EpcX2SapProvider_methods(root_module, cls):
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2SapProvider::EpcX2SapProvider() [constructor]
    cls.add_constructor([])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2SapProvider::EpcX2SapProvider(ns3::EpcX2SapProvider const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcX2SapProvider const &', 'arg0')])
    ## epc-x2-sap.h (module 'lte'): void ns3::EpcX2SapProvider::AddTeidToBeForwarded(uint32_t gtpTeid, uint16_t targetCellId) [member function]
    cls.add_method('AddTeidToBeForwarded',
                   'void',
                   [param('uint32_t', 'gtpTeid'), param('uint16_t', 'targetCellId')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-x2-sap.h (module 'lte'): void ns3::EpcX2SapProvider::ForwardRlcPdu(ns3::EpcX2Sap::UeDataParams params) [member function]
    cls.add_method('ForwardRlcPdu',
                   'void',
                   [param('ns3::EpcX2Sap::UeDataParams', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-x2-sap.h (module 'lte'): void ns3::EpcX2SapProvider::NotifyCoordinatorHandoverFailed(ns3::EpcX2Sap::HandoverFailedParams params) [member function]
    cls.add_method('NotifyCoordinatorHandoverFailed',
                   'void',
                   [param('ns3::EpcX2Sap::HandoverFailedParams', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-x2-sap.h (module 'lte'): void ns3::EpcX2SapProvider::NotifyLteMmWaveHandoverCompleted(ns3::EpcX2Sap::SecondaryHandoverParams params) [member function]
    cls.add_method('NotifyLteMmWaveHandoverCompleted',
                   'void',
                   [param('ns3::EpcX2Sap::SecondaryHandoverParams', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-x2-sap.h (module 'lte'): void ns3::EpcX2SapProvider::RemoveTeidToBeForwarded(uint32_t gtpTeid) [member function]
    cls.add_method('RemoveTeidToBeForwarded',
                   'void',
                   [param('uint32_t', 'gtpTeid')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-x2-sap.h (module 'lte'): void ns3::EpcX2SapProvider::SendHandoverPreparationFailure(ns3::EpcX2Sap::HandoverPreparationFailureParams params) [member function]
    cls.add_method('SendHandoverPreparationFailure',
                   'void',
                   [param('ns3::EpcX2Sap::HandoverPreparationFailureParams', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-x2-sap.h (module 'lte'): void ns3::EpcX2SapProvider::SendHandoverRequest(ns3::EpcX2Sap::HandoverRequestParams params) [member function]
    cls.add_method('SendHandoverRequest',
                   'void',
                   [param('ns3::EpcX2Sap::HandoverRequestParams', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-x2-sap.h (module 'lte'): void ns3::EpcX2SapProvider::SendHandoverRequestAck(ns3::EpcX2Sap::HandoverRequestAckParams params) [member function]
    cls.add_method('SendHandoverRequestAck',
                   'void',
                   [param('ns3::EpcX2Sap::HandoverRequestAckParams', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-x2-sap.h (module 'lte'): void ns3::EpcX2SapProvider::SendLoadInformation(ns3::EpcX2Sap::LoadInformationParams params) [member function]
    cls.add_method('SendLoadInformation',
                   'void',
                   [param('ns3::EpcX2Sap::LoadInformationParams', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-x2-sap.h (module 'lte'): void ns3::EpcX2SapProvider::SendMcHandoverRequest(ns3::EpcX2Sap::SecondaryHandoverParams params) [member function]
    cls.add_method('SendMcHandoverRequest',
                   'void',
                   [param('ns3::EpcX2Sap::SecondaryHandoverParams', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-x2-sap.h (module 'lte'): void ns3::EpcX2SapProvider::SendResourceStatusUpdate(ns3::EpcX2Sap::ResourceStatusUpdateParams params) [member function]
    cls.add_method('SendResourceStatusUpdate',
                   'void',
                   [param('ns3::EpcX2Sap::ResourceStatusUpdateParams', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-x2-sap.h (module 'lte'): void ns3::EpcX2SapProvider::SendRlcSetupCompleted(ns3::EpcX2Sap::UeDataParams params) [member function]
    cls.add_method('SendRlcSetupCompleted',
                   'void',
                   [param('ns3::EpcX2Sap::UeDataParams', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-x2-sap.h (module 'lte'): void ns3::EpcX2SapProvider::SendRlcSetupRequest(ns3::EpcX2Sap::RlcSetupRequest params) [member function]
    cls.add_method('SendRlcSetupRequest',
                   'void',
                   [param('ns3::EpcX2Sap::RlcSetupRequest', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-x2-sap.h (module 'lte'): void ns3::EpcX2SapProvider::SendSecondaryCellHandoverCompleted(ns3::EpcX2Sap::SecondaryHandoverCompletedParams params) [member function]
    cls.add_method('SendSecondaryCellHandoverCompleted',
                   'void',
                   [param('ns3::EpcX2Sap::SecondaryHandoverCompletedParams', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-x2-sap.h (module 'lte'): void ns3::EpcX2SapProvider::SendSnStatusTransfer(ns3::EpcX2Sap::SnStatusTransferParams params) [member function]
    cls.add_method('SendSnStatusTransfer',
                   'void',
                   [param('ns3::EpcX2Sap::SnStatusTransferParams', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-x2-sap.h (module 'lte'): void ns3::EpcX2SapProvider::SendSwitchConnectionToMmWave(ns3::EpcX2Sap::SwitchConnectionParams params) [member function]
    cls.add_method('SendSwitchConnectionToMmWave',
                   'void',
                   [param('ns3::EpcX2Sap::SwitchConnectionParams', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-x2-sap.h (module 'lte'): void ns3::EpcX2SapProvider::SendUeContextRelease(ns3::EpcX2Sap::UeContextReleaseParams params) [member function]
    cls.add_method('SendUeContextRelease',
                   'void',
                   [param('ns3::EpcX2Sap::UeContextReleaseParams', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-x2-sap.h (module 'lte'): void ns3::EpcX2SapProvider::SendUeData(ns3::EpcX2Sap::UeDataParams params) [member function]
    cls.add_method('SendUeData',
                   'void',
                   [param('ns3::EpcX2Sap::UeDataParams', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-x2-sap.h (module 'lte'): void ns3::EpcX2SapProvider::SendUeSinrUpdate(ns3::EpcX2Sap::UeImsiSinrParams params) [member function]
    cls.add_method('SendUeSinrUpdate',
                   'void',
                   [param('ns3::EpcX2Sap::UeImsiSinrParams', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-x2-sap.h (module 'lte'): void ns3::EpcX2SapProvider::SetEpcX2PdcpUser(uint32_t teid, ns3::EpcX2PdcpUser * s) [member function]
    cls.add_method('SetEpcX2PdcpUser',
                   'void',
                   [param('uint32_t', 'teid'), param('ns3::EpcX2PdcpUser *', 's')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-x2-sap.h (module 'lte'): void ns3::EpcX2SapProvider::SetEpcX2RlcUser(uint32_t teid, ns3::EpcX2RlcUser * s) [member function]
    cls.add_method('SetEpcX2RlcUser',
                   'void',
                   [param('uint32_t', 'teid'), param('ns3::EpcX2RlcUser *', 's')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3EpcX2SapUser_methods(root_module, cls):
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2SapUser::EpcX2SapUser() [constructor]
    cls.add_constructor([])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2SapUser::EpcX2SapUser(ns3::EpcX2SapUser const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcX2SapUser const &', 'arg0')])
    ## epc-x2-sap.h (module 'lte'): void ns3::EpcX2SapUser::RecvConnectionSwitchToMmWave(ns3::EpcX2Sap::SwitchConnectionParams params) [member function]
    cls.add_method('RecvConnectionSwitchToMmWave',
                   'void',
                   [param('ns3::EpcX2Sap::SwitchConnectionParams', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-x2-sap.h (module 'lte'): void ns3::EpcX2SapUser::RecvHandoverPreparationFailure(ns3::EpcX2Sap::HandoverPreparationFailureParams params) [member function]
    cls.add_method('RecvHandoverPreparationFailure',
                   'void',
                   [param('ns3::EpcX2Sap::HandoverPreparationFailureParams', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-x2-sap.h (module 'lte'): void ns3::EpcX2SapUser::RecvHandoverRequest(ns3::EpcX2Sap::HandoverRequestParams params) [member function]
    cls.add_method('RecvHandoverRequest',
                   'void',
                   [param('ns3::EpcX2Sap::HandoverRequestParams', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-x2-sap.h (module 'lte'): void ns3::EpcX2SapUser::RecvHandoverRequestAck(ns3::EpcX2Sap::HandoverRequestAckParams params) [member function]
    cls.add_method('RecvHandoverRequestAck',
                   'void',
                   [param('ns3::EpcX2Sap::HandoverRequestAckParams', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-x2-sap.h (module 'lte'): void ns3::EpcX2SapUser::RecvLoadInformation(ns3::EpcX2Sap::LoadInformationParams params) [member function]
    cls.add_method('RecvLoadInformation',
                   'void',
                   [param('ns3::EpcX2Sap::LoadInformationParams', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-x2-sap.h (module 'lte'): void ns3::EpcX2SapUser::RecvLteMmWaveHandoverCompleted(ns3::EpcX2Sap::SecondaryHandoverParams params) [member function]
    cls.add_method('RecvLteMmWaveHandoverCompleted',
                   'void',
                   [param('ns3::EpcX2Sap::SecondaryHandoverParams', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-x2-sap.h (module 'lte'): void ns3::EpcX2SapUser::RecvMcHandoverRequest(ns3::EpcX2Sap::SecondaryHandoverParams params) [member function]
    cls.add_method('RecvMcHandoverRequest',
                   'void',
                   [param('ns3::EpcX2Sap::SecondaryHandoverParams', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-x2-sap.h (module 'lte'): void ns3::EpcX2SapUser::RecvResourceStatusUpdate(ns3::EpcX2Sap::ResourceStatusUpdateParams params) [member function]
    cls.add_method('RecvResourceStatusUpdate',
                   'void',
                   [param('ns3::EpcX2Sap::ResourceStatusUpdateParams', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-x2-sap.h (module 'lte'): void ns3::EpcX2SapUser::RecvRlcSetupCompleted(ns3::EpcX2Sap::UeDataParams params) [member function]
    cls.add_method('RecvRlcSetupCompleted',
                   'void',
                   [param('ns3::EpcX2Sap::UeDataParams', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-x2-sap.h (module 'lte'): void ns3::EpcX2SapUser::RecvRlcSetupRequest(ns3::EpcX2Sap::RlcSetupRequest params) [member function]
    cls.add_method('RecvRlcSetupRequest',
                   'void',
                   [param('ns3::EpcX2Sap::RlcSetupRequest', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-x2-sap.h (module 'lte'): void ns3::EpcX2SapUser::RecvSecondaryCellHandoverCompleted(ns3::EpcX2Sap::SecondaryHandoverCompletedParams params) [member function]
    cls.add_method('RecvSecondaryCellHandoverCompleted',
                   'void',
                   [param('ns3::EpcX2Sap::SecondaryHandoverCompletedParams', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-x2-sap.h (module 'lte'): void ns3::EpcX2SapUser::RecvSnStatusTransfer(ns3::EpcX2Sap::SnStatusTransferParams params) [member function]
    cls.add_method('RecvSnStatusTransfer',
                   'void',
                   [param('ns3::EpcX2Sap::SnStatusTransferParams', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-x2-sap.h (module 'lte'): void ns3::EpcX2SapUser::RecvUeContextRelease(ns3::EpcX2Sap::UeContextReleaseParams params) [member function]
    cls.add_method('RecvUeContextRelease',
                   'void',
                   [param('ns3::EpcX2Sap::UeContextReleaseParams', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-x2-sap.h (module 'lte'): void ns3::EpcX2SapUser::RecvUeData(ns3::EpcX2Sap::UeDataParams params) [member function]
    cls.add_method('RecvUeData',
                   'void',
                   [param('ns3::EpcX2Sap::UeDataParams', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-x2-sap.h (module 'lte'): void ns3::EpcX2SapUser::RecvUeSinrUpdate(ns3::EpcX2Sap::UeImsiSinrParams params) [member function]
    cls.add_method('RecvUeSinrUpdate',
                   'void',
                   [param('ns3::EpcX2Sap::UeImsiSinrParams', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3EpsBearer_methods(root_module, cls):
    ## eps-bearer.h (module 'lte'): ns3::EpsBearer::EpsBearer(ns3::EpsBearer const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpsBearer const &', 'arg0')])
    ## eps-bearer.h (module 'lte'): ns3::EpsBearer::EpsBearer() [constructor]
    cls.add_constructor([])
    ## eps-bearer.h (module 'lte'): ns3::EpsBearer::EpsBearer(ns3::EpsBearer::Qci x) [constructor]
    cls.add_constructor([param('ns3::EpsBearer::Qci', 'x')])
    ## eps-bearer.h (module 'lte'): ns3::EpsBearer::EpsBearer(ns3::EpsBearer::Qci x, ns3::GbrQosInformation y) [constructor]
    cls.add_constructor([param('ns3::EpsBearer::Qci', 'x'), param('ns3::GbrQosInformation', 'y')])
    ## eps-bearer.h (module 'lte'): uint16_t ns3::EpsBearer::GetPacketDelayBudgetMs() const [member function]
    cls.add_method('GetPacketDelayBudgetMs',
                   'uint16_t',
                   [],
                   is_const=True)
    ## eps-bearer.h (module 'lte'): double ns3::EpsBearer::GetPacketErrorLossRate() const [member function]
    cls.add_method('GetPacketErrorLossRate',
                   'double',
                   [],
                   is_const=True)
    ## eps-bearer.h (module 'lte'): uint8_t ns3::EpsBearer::GetPriority() const [member function]
    cls.add_method('GetPriority',
                   'uint8_t',
                   [],
                   is_const=True)
    ## eps-bearer.h (module 'lte'): bool ns3::EpsBearer::IsGbr() const [member function]
    cls.add_method('IsGbr',
                   'bool',
                   [],
                   is_const=True)
    ## eps-bearer.h (module 'lte'): ns3::EpsBearer::arp [variable]
    cls.add_instance_attribute('arp', 'ns3::AllocationRetentionPriority', is_const=False)
    ## eps-bearer.h (module 'lte'): ns3::EpsBearer::gbrQosInfo [variable]
    cls.add_instance_attribute('gbrQosInfo', 'ns3::GbrQosInformation', is_const=False)
    ## eps-bearer.h (module 'lte'): ns3::EpsBearer::qci [variable]
    cls.add_instance_attribute('qci', 'ns3::EpsBearer::Qci', is_const=False)
    return

def register_Ns3EutranMeasurementMapping_methods(root_module, cls):
    ## lte-common.h (module 'lte'): ns3::EutranMeasurementMapping::EutranMeasurementMapping() [constructor]
    cls.add_constructor([])
    ## lte-common.h (module 'lte'): ns3::EutranMeasurementMapping::EutranMeasurementMapping(ns3::EutranMeasurementMapping const & arg0) [constructor]
    cls.add_constructor([param('ns3::EutranMeasurementMapping const &', 'arg0')])
    ## lte-common.h (module 'lte'): static int8_t ns3::EutranMeasurementMapping::ActualA3Offset2IeValue(double a3OffsetDb) [member function]
    cls.add_method('ActualA3Offset2IeValue',
                   'int8_t',
                   [param('double', 'a3OffsetDb')],
                   is_static=True)
    ## lte-common.h (module 'lte'): static uint8_t ns3::EutranMeasurementMapping::ActualHysteresis2IeValue(double hysteresisDb) [member function]
    cls.add_method('ActualHysteresis2IeValue',
                   'uint8_t',
                   [param('double', 'hysteresisDb')],
                   is_static=True)
    ## lte-common.h (module 'lte'): static uint8_t ns3::EutranMeasurementMapping::Db2RsrqRange(double db) [member function]
    cls.add_method('Db2RsrqRange',
                   'uint8_t',
                   [param('double', 'db')],
                   is_static=True)
    ## lte-common.h (module 'lte'): static uint8_t ns3::EutranMeasurementMapping::Dbm2RsrpRange(double dbm) [member function]
    cls.add_method('Dbm2RsrpRange',
                   'uint8_t',
                   [param('double', 'dbm')],
                   is_static=True)
    ## lte-common.h (module 'lte'): static double ns3::EutranMeasurementMapping::IeValue2ActualA3Offset(int8_t a3OffsetIeValue) [member function]
    cls.add_method('IeValue2ActualA3Offset',
                   'double',
                   [param('int8_t', 'a3OffsetIeValue')],
                   is_static=True)
    ## lte-common.h (module 'lte'): static double ns3::EutranMeasurementMapping::IeValue2ActualHysteresis(uint8_t hysteresisIeValue) [member function]
    cls.add_method('IeValue2ActualHysteresis',
                   'double',
                   [param('uint8_t', 'hysteresisIeValue')],
                   is_static=True)
    ## lte-common.h (module 'lte'): static double ns3::EutranMeasurementMapping::IeValue2ActualQQualMin(int8_t qQualMinIeValue) [member function]
    cls.add_method('IeValue2ActualQQualMin',
                   'double',
                   [param('int8_t', 'qQualMinIeValue')],
                   is_static=True)
    ## lte-common.h (module 'lte'): static double ns3::EutranMeasurementMapping::IeValue2ActualQRxLevMin(int8_t qRxLevMinIeValue) [member function]
    cls.add_method('IeValue2ActualQRxLevMin',
                   'double',
                   [param('int8_t', 'qRxLevMinIeValue')],
                   is_static=True)
    ## lte-common.h (module 'lte'): static double ns3::EutranMeasurementMapping::QuantizeRsrp(double v) [member function]
    cls.add_method('QuantizeRsrp',
                   'double',
                   [param('double', 'v')],
                   is_static=True)
    ## lte-common.h (module 'lte'): static double ns3::EutranMeasurementMapping::QuantizeRsrq(double v) [member function]
    cls.add_method('QuantizeRsrq',
                   'double',
                   [param('double', 'v')],
                   is_static=True)
    ## lte-common.h (module 'lte'): static double ns3::EutranMeasurementMapping::RsrpRange2Dbm(uint8_t range) [member function]
    cls.add_method('RsrpRange2Dbm',
                   'double',
                   [param('uint8_t', 'range')],
                   is_static=True)
    ## lte-common.h (module 'lte'): static double ns3::EutranMeasurementMapping::RsrqRange2Db(uint8_t range) [member function]
    cls.add_method('RsrqRange2Db',
                   'double',
                   [param('uint8_t', 'range')],
                   is_static=True)
    return

def register_Ns3EventId_methods(root_module, cls):
    cls.add_binary_comparison_operator('==')
    cls.add_binary_comparison_operator('!=')
    cls.add_binary_comparison_operator('<')
    ## event-id.h (module 'core'): ns3::EventId::EventId(ns3::EventId const & arg0) [constructor]
    cls.add_constructor([param('ns3::EventId const &', 'arg0')])
    ## event-id.h (module 'core'): ns3::EventId::EventId() [constructor]
    cls.add_constructor([])
    ## event-id.h (module 'core'): ns3::EventId::EventId(ns3::Ptr<ns3::EventImpl> const & impl, uint64_t ts, uint32_t context, uint32_t uid) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::EventImpl > const &', 'impl'), param('uint64_t', 'ts'), param('uint32_t', 'context'), param('uint32_t', 'uid')])
    ## event-id.h (module 'core'): void ns3::EventId::Cancel() [member function]
    cls.add_method('Cancel',
                   'void',
                   [])
    ## event-id.h (module 'core'): uint32_t ns3::EventId::GetContext() const [member function]
    cls.add_method('GetContext',
                   'uint32_t',
                   [],
                   is_const=True)
    ## event-id.h (module 'core'): uint64_t ns3::EventId::GetTs() const [member function]
    cls.add_method('GetTs',
                   'uint64_t',
                   [],
                   is_const=True)
    ## event-id.h (module 'core'): uint32_t ns3::EventId::GetUid() const [member function]
    cls.add_method('GetUid',
                   'uint32_t',
                   [],
                   is_const=True)
    ## event-id.h (module 'core'): bool ns3::EventId::IsExpired() const [member function]
    cls.add_method('IsExpired',
                   'bool',
                   [],
                   is_const=True)
    ## event-id.h (module 'core'): bool ns3::EventId::IsRunning() const [member function]
    cls.add_method('IsRunning',
                   'bool',
                   [],
                   is_const=True)
    ## event-id.h (module 'core'): ns3::EventImpl * ns3::EventId::PeekEventImpl() const [member function]
    cls.add_method('PeekEventImpl',
                   'ns3::EventImpl *',
                   [],
                   is_const=True)
    return

def register_Ns3FfMacCschedSapProvider_methods(root_module, cls):
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::FfMacCschedSapProvider() [constructor]
    cls.add_constructor([])
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::FfMacCschedSapProvider(ns3::FfMacCschedSapProvider const & arg0) [constructor]
    cls.add_constructor([param('ns3::FfMacCschedSapProvider const &', 'arg0')])
    ## ff-mac-csched-sap.h (module 'lte'): void ns3::FfMacCschedSapProvider::CschedCellConfigReq(ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters const & params) [member function]
    cls.add_method('CschedCellConfigReq',
                   'void',
                   [param('ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## ff-mac-csched-sap.h (module 'lte'): void ns3::FfMacCschedSapProvider::CschedLcConfigReq(ns3::FfMacCschedSapProvider::CschedLcConfigReqParameters const & params) [member function]
    cls.add_method('CschedLcConfigReq',
                   'void',
                   [param('ns3::FfMacCschedSapProvider::CschedLcConfigReqParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## ff-mac-csched-sap.h (module 'lte'): void ns3::FfMacCschedSapProvider::CschedLcReleaseReq(ns3::FfMacCschedSapProvider::CschedLcReleaseReqParameters const & params) [member function]
    cls.add_method('CschedLcReleaseReq',
                   'void',
                   [param('ns3::FfMacCschedSapProvider::CschedLcReleaseReqParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## ff-mac-csched-sap.h (module 'lte'): void ns3::FfMacCschedSapProvider::CschedUeConfigReq(ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters const & params) [member function]
    cls.add_method('CschedUeConfigReq',
                   'void',
                   [param('ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## ff-mac-csched-sap.h (module 'lte'): void ns3::FfMacCschedSapProvider::CschedUeReleaseReq(ns3::FfMacCschedSapProvider::CschedUeReleaseReqParameters const & params) [member function]
    cls.add_method('CschedUeReleaseReq',
                   'void',
                   [param('ns3::FfMacCschedSapProvider::CschedUeReleaseReqParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3FfMacCschedSapProviderCschedCellConfigReqParameters_methods(root_module, cls):
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::CschedCellConfigReqParameters() [constructor]
    cls.add_constructor([])
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::CschedCellConfigReqParameters(ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters const &', 'arg0')])
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::m_antennaPortsCount [variable]
    cls.add_instance_attribute('m_antennaPortsCount', 'uint8_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::m_deltaPucchShift [variable]
    cls.add_instance_attribute('m_deltaPucchShift', 'uint8_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::m_dlBandwidth [variable]
    cls.add_instance_attribute('m_dlBandwidth', 'uint8_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::m_dlCyclicPrefixLength [variable]
    cls.add_instance_attribute('m_dlCyclicPrefixLength', 'ns3::NormalExtended_e', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::m_duplexMode [variable]
    cls.add_instance_attribute('m_duplexMode', 'ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::DuplexMode_e', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::m_enable64Qam [variable]
    cls.add_instance_attribute('m_enable64Qam', 'ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::Enable64Qam_e', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::m_hoppingMode [variable]
    cls.add_instance_attribute('m_hoppingMode', 'ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::HoppingMode_e', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::m_initialNrOfPdcchOfdmSymbols [variable]
    cls.add_instance_attribute('m_initialNrOfPdcchOfdmSymbols', 'uint8_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::m_macContentionResolutionTimer [variable]
    cls.add_instance_attribute('m_macContentionResolutionTimer', 'uint8_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::m_maxHarqMsg3Tx [variable]
    cls.add_instance_attribute('m_maxHarqMsg3Tx', 'uint8_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::m_mbsfnSubframeConfigRfOffset [variable]
    cls.add_instance_attribute('m_mbsfnSubframeConfigRfOffset', 'std::vector< unsigned char >', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::m_mbsfnSubframeConfigRfPeriod [variable]
    cls.add_instance_attribute('m_mbsfnSubframeConfigRfPeriod', 'std::vector< unsigned char >', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::m_mbsfnSubframeConfigSfAllocation [variable]
    cls.add_instance_attribute('m_mbsfnSubframeConfigSfAllocation', 'std::vector< unsigned char >', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::m_n1PucchAn [variable]
    cls.add_instance_attribute('m_n1PucchAn', 'uint16_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::m_nSb [variable]
    cls.add_instance_attribute('m_nSb', 'uint8_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::m_ncsAn [variable]
    cls.add_instance_attribute('m_ncsAn', 'uint8_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::m_nrbCqi [variable]
    cls.add_instance_attribute('m_nrbCqi', 'uint8_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::m_phichDuration [variable]
    cls.add_instance_attribute('m_phichDuration', 'ns3::NormalExtended_e', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::m_phichResource [variable]
    cls.add_instance_attribute('m_phichResource', 'ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::PhichResource_e', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::m_prachConfigurationIndex [variable]
    cls.add_instance_attribute('m_prachConfigurationIndex', 'uint8_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::m_prachFreqOffset [variable]
    cls.add_instance_attribute('m_prachFreqOffset', 'uint8_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::m_puschHoppingOffset [variable]
    cls.add_instance_attribute('m_puschHoppingOffset', 'uint8_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::m_raResponseWindowSize [variable]
    cls.add_instance_attribute('m_raResponseWindowSize', 'uint8_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::m_siConfiguration [variable]
    cls.add_instance_attribute('m_siConfiguration', 'ns3::SiConfiguration_s', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::m_specialSubframePatterns [variable]
    cls.add_instance_attribute('m_specialSubframePatterns', 'uint8_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::m_srsBandwidthConfiguration [variable]
    cls.add_instance_attribute('m_srsBandwidthConfiguration', 'uint8_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::m_srsMaxUpPts [variable]
    cls.add_instance_attribute('m_srsMaxUpPts', 'bool', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::m_srsSubframeConfiguration [variable]
    cls.add_instance_attribute('m_srsSubframeConfiguration', 'uint8_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::m_srsSubframeOffset [variable]
    cls.add_instance_attribute('m_srsSubframeOffset', 'uint8_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::m_subframeAssignment [variable]
    cls.add_instance_attribute('m_subframeAssignment', 'uint8_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::m_ulBandwidth [variable]
    cls.add_instance_attribute('m_ulBandwidth', 'uint8_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::m_ulCyclicPrefixLength [variable]
    cls.add_instance_attribute('m_ulCyclicPrefixLength', 'ns3::NormalExtended_e', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedCellConfigReqParameters::m_vendorSpecificList [variable]
    cls.add_instance_attribute('m_vendorSpecificList', 'std::vector< ns3::VendorSpecificListElement_s >', is_const=False)
    return

def register_Ns3FfMacCschedSapProviderCschedLcConfigReqParameters_methods(root_module, cls):
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedLcConfigReqParameters::CschedLcConfigReqParameters() [constructor]
    cls.add_constructor([])
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedLcConfigReqParameters::CschedLcConfigReqParameters(ns3::FfMacCschedSapProvider::CschedLcConfigReqParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::FfMacCschedSapProvider::CschedLcConfigReqParameters const &', 'arg0')])
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedLcConfigReqParameters::m_logicalChannelConfigList [variable]
    cls.add_instance_attribute('m_logicalChannelConfigList', 'std::vector< ns3::LogicalChannelConfigListElement_s >', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedLcConfigReqParameters::m_reconfigureFlag [variable]
    cls.add_instance_attribute('m_reconfigureFlag', 'bool', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedLcConfigReqParameters::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedLcConfigReqParameters::m_vendorSpecificList [variable]
    cls.add_instance_attribute('m_vendorSpecificList', 'std::vector< ns3::VendorSpecificListElement_s >', is_const=False)
    return

def register_Ns3FfMacCschedSapProviderCschedLcReleaseReqParameters_methods(root_module, cls):
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedLcReleaseReqParameters::CschedLcReleaseReqParameters() [constructor]
    cls.add_constructor([])
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedLcReleaseReqParameters::CschedLcReleaseReqParameters(ns3::FfMacCschedSapProvider::CschedLcReleaseReqParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::FfMacCschedSapProvider::CschedLcReleaseReqParameters const &', 'arg0')])
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedLcReleaseReqParameters::m_logicalChannelIdentity [variable]
    cls.add_instance_attribute('m_logicalChannelIdentity', 'std::vector< unsigned char >', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedLcReleaseReqParameters::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedLcReleaseReqParameters::m_vendorSpecificList [variable]
    cls.add_instance_attribute('m_vendorSpecificList', 'std::vector< ns3::VendorSpecificListElement_s >', is_const=False)
    return

def register_Ns3FfMacCschedSapProviderCschedUeConfigReqParameters_methods(root_module, cls):
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters::CschedUeConfigReqParameters() [constructor]
    cls.add_constructor([])
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters::CschedUeConfigReqParameters(ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters const &', 'arg0')])
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters::m_ackNackRepetitionFactor [variable]
    cls.add_instance_attribute('m_ackNackRepetitionFactor', 'uint8_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters::m_ackNackSrsSimultaneousTransmission [variable]
    cls.add_instance_attribute('m_ackNackSrsSimultaneousTransmission', 'bool', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters::m_aperiodicCqiRepMode [variable]
    cls.add_instance_attribute('m_aperiodicCqiRepMode', 'ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters::RepMode_e', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters::m_betaOffsetAckIndex [variable]
    cls.add_instance_attribute('m_betaOffsetAckIndex', 'uint8_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters::m_betaOffsetCqiIndex [variable]
    cls.add_instance_attribute('m_betaOffsetCqiIndex', 'uint8_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters::m_betaOffsetRiIndex [variable]
    cls.add_instance_attribute('m_betaOffsetRiIndex', 'uint8_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters::m_cqiConfig [variable]
    cls.add_instance_attribute('m_cqiConfig', 'ns3::CqiConfig_s', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters::m_cqiConfigPresent [variable]
    cls.add_instance_attribute('m_cqiConfigPresent', 'bool', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters::m_drxConfig [variable]
    cls.add_instance_attribute('m_drxConfig', 'ns3::DrxConfig_s', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters::m_drxConfigPresent [variable]
    cls.add_instance_attribute('m_drxConfigPresent', 'bool', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters::m_maxHarqTx [variable]
    cls.add_instance_attribute('m_maxHarqTx', 'uint8_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters::m_measGapConfigPattern [variable]
    cls.add_instance_attribute('m_measGapConfigPattern', 'ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters::MeasGapConfigPattern_e', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters::m_measGapConfigSubframeOffset [variable]
    cls.add_instance_attribute('m_measGapConfigSubframeOffset', 'uint8_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters::m_reconfigureFlag [variable]
    cls.add_instance_attribute('m_reconfigureFlag', 'bool', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters::m_simultaneousAckNackAndCqi [variable]
    cls.add_instance_attribute('m_simultaneousAckNackAndCqi', 'bool', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters::m_spsConfig [variable]
    cls.add_instance_attribute('m_spsConfig', 'ns3::SpsConfig_s', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters::m_spsConfigPresent [variable]
    cls.add_instance_attribute('m_spsConfigPresent', 'bool', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters::m_srConfig [variable]
    cls.add_instance_attribute('m_srConfig', 'ns3::SrConfig_s', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters::m_srConfigPresent [variable]
    cls.add_instance_attribute('m_srConfigPresent', 'bool', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters::m_tddAckNackFeedbackMode [variable]
    cls.add_instance_attribute('m_tddAckNackFeedbackMode', 'ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters::FeedbackMode_e', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters::m_timeAlignmentTimer [variable]
    cls.add_instance_attribute('m_timeAlignmentTimer', 'uint16_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters::m_transmissionMode [variable]
    cls.add_instance_attribute('m_transmissionMode', 'uint8_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters::m_ttiBundling [variable]
    cls.add_instance_attribute('m_ttiBundling', 'bool', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters::m_ueAggregatedMaximumBitrateDl [variable]
    cls.add_instance_attribute('m_ueAggregatedMaximumBitrateDl', 'uint64_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters::m_ueAggregatedMaximumBitrateUl [variable]
    cls.add_instance_attribute('m_ueAggregatedMaximumBitrateUl', 'uint64_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters::m_ueCapabilities [variable]
    cls.add_instance_attribute('m_ueCapabilities', 'ns3::UeCapabilities_s', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters::m_ueTransmitAntennaSelection [variable]
    cls.add_instance_attribute('m_ueTransmitAntennaSelection', 'ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters::OpenClosedLoop_e', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeConfigReqParameters::m_vendorSpecificList [variable]
    cls.add_instance_attribute('m_vendorSpecificList', 'std::vector< ns3::VendorSpecificListElement_s >', is_const=False)
    return

def register_Ns3FfMacCschedSapProviderCschedUeReleaseReqParameters_methods(root_module, cls):
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeReleaseReqParameters::CschedUeReleaseReqParameters() [constructor]
    cls.add_constructor([])
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeReleaseReqParameters::CschedUeReleaseReqParameters(ns3::FfMacCschedSapProvider::CschedUeReleaseReqParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::FfMacCschedSapProvider::CschedUeReleaseReqParameters const &', 'arg0')])
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeReleaseReqParameters::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapProvider::CschedUeReleaseReqParameters::m_vendorSpecificList [variable]
    cls.add_instance_attribute('m_vendorSpecificList', 'std::vector< ns3::VendorSpecificListElement_s >', is_const=False)
    return

def register_Ns3FfMacCschedSapUser_methods(root_module, cls):
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::FfMacCschedSapUser() [constructor]
    cls.add_constructor([])
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::FfMacCschedSapUser(ns3::FfMacCschedSapUser const & arg0) [constructor]
    cls.add_constructor([param('ns3::FfMacCschedSapUser const &', 'arg0')])
    ## ff-mac-csched-sap.h (module 'lte'): void ns3::FfMacCschedSapUser::CschedCellConfigCnf(ns3::FfMacCschedSapUser::CschedCellConfigCnfParameters const & params) [member function]
    cls.add_method('CschedCellConfigCnf',
                   'void',
                   [param('ns3::FfMacCschedSapUser::CschedCellConfigCnfParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## ff-mac-csched-sap.h (module 'lte'): void ns3::FfMacCschedSapUser::CschedCellConfigUpdateInd(ns3::FfMacCschedSapUser::CschedCellConfigUpdateIndParameters const & params) [member function]
    cls.add_method('CschedCellConfigUpdateInd',
                   'void',
                   [param('ns3::FfMacCschedSapUser::CschedCellConfigUpdateIndParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## ff-mac-csched-sap.h (module 'lte'): void ns3::FfMacCschedSapUser::CschedLcConfigCnf(ns3::FfMacCschedSapUser::CschedLcConfigCnfParameters const & params) [member function]
    cls.add_method('CschedLcConfigCnf',
                   'void',
                   [param('ns3::FfMacCschedSapUser::CschedLcConfigCnfParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## ff-mac-csched-sap.h (module 'lte'): void ns3::FfMacCschedSapUser::CschedLcReleaseCnf(ns3::FfMacCschedSapUser::CschedLcReleaseCnfParameters const & params) [member function]
    cls.add_method('CschedLcReleaseCnf',
                   'void',
                   [param('ns3::FfMacCschedSapUser::CschedLcReleaseCnfParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## ff-mac-csched-sap.h (module 'lte'): void ns3::FfMacCschedSapUser::CschedUeConfigCnf(ns3::FfMacCschedSapUser::CschedUeConfigCnfParameters const & params) [member function]
    cls.add_method('CschedUeConfigCnf',
                   'void',
                   [param('ns3::FfMacCschedSapUser::CschedUeConfigCnfParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## ff-mac-csched-sap.h (module 'lte'): void ns3::FfMacCschedSapUser::CschedUeConfigUpdateInd(ns3::FfMacCschedSapUser::CschedUeConfigUpdateIndParameters const & params) [member function]
    cls.add_method('CschedUeConfigUpdateInd',
                   'void',
                   [param('ns3::FfMacCschedSapUser::CschedUeConfigUpdateIndParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## ff-mac-csched-sap.h (module 'lte'): void ns3::FfMacCschedSapUser::CschedUeReleaseCnf(ns3::FfMacCschedSapUser::CschedUeReleaseCnfParameters const & params) [member function]
    cls.add_method('CschedUeReleaseCnf',
                   'void',
                   [param('ns3::FfMacCschedSapUser::CschedUeReleaseCnfParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3FfMacCschedSapUserCschedCellConfigCnfParameters_methods(root_module, cls):
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedCellConfigCnfParameters::CschedCellConfigCnfParameters() [constructor]
    cls.add_constructor([])
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedCellConfigCnfParameters::CschedCellConfigCnfParameters(ns3::FfMacCschedSapUser::CschedCellConfigCnfParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::FfMacCschedSapUser::CschedCellConfigCnfParameters const &', 'arg0')])
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedCellConfigCnfParameters::m_result [variable]
    cls.add_instance_attribute('m_result', 'ns3::Result_e', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedCellConfigCnfParameters::m_vendorSpecificList [variable]
    cls.add_instance_attribute('m_vendorSpecificList', 'std::vector< ns3::VendorSpecificListElement_s >', is_const=False)
    return

def register_Ns3FfMacCschedSapUserCschedCellConfigUpdateIndParameters_methods(root_module, cls):
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedCellConfigUpdateIndParameters::CschedCellConfigUpdateIndParameters() [constructor]
    cls.add_constructor([])
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedCellConfigUpdateIndParameters::CschedCellConfigUpdateIndParameters(ns3::FfMacCschedSapUser::CschedCellConfigUpdateIndParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::FfMacCschedSapUser::CschedCellConfigUpdateIndParameters const &', 'arg0')])
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedCellConfigUpdateIndParameters::m_prbUtilizationDl [variable]
    cls.add_instance_attribute('m_prbUtilizationDl', 'uint8_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedCellConfigUpdateIndParameters::m_prbUtilizationUl [variable]
    cls.add_instance_attribute('m_prbUtilizationUl', 'uint8_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedCellConfigUpdateIndParameters::m_vendorSpecificList [variable]
    cls.add_instance_attribute('m_vendorSpecificList', 'std::vector< ns3::VendorSpecificListElement_s >', is_const=False)
    return

def register_Ns3FfMacCschedSapUserCschedLcConfigCnfParameters_methods(root_module, cls):
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedLcConfigCnfParameters::CschedLcConfigCnfParameters() [constructor]
    cls.add_constructor([])
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedLcConfigCnfParameters::CschedLcConfigCnfParameters(ns3::FfMacCschedSapUser::CschedLcConfigCnfParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::FfMacCschedSapUser::CschedLcConfigCnfParameters const &', 'arg0')])
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedLcConfigCnfParameters::m_logicalChannelIdentity [variable]
    cls.add_instance_attribute('m_logicalChannelIdentity', 'std::vector< unsigned char >', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedLcConfigCnfParameters::m_result [variable]
    cls.add_instance_attribute('m_result', 'ns3::Result_e', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedLcConfigCnfParameters::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedLcConfigCnfParameters::m_vendorSpecificList [variable]
    cls.add_instance_attribute('m_vendorSpecificList', 'std::vector< ns3::VendorSpecificListElement_s >', is_const=False)
    return

def register_Ns3FfMacCschedSapUserCschedLcReleaseCnfParameters_methods(root_module, cls):
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedLcReleaseCnfParameters::CschedLcReleaseCnfParameters() [constructor]
    cls.add_constructor([])
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedLcReleaseCnfParameters::CschedLcReleaseCnfParameters(ns3::FfMacCschedSapUser::CschedLcReleaseCnfParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::FfMacCschedSapUser::CschedLcReleaseCnfParameters const &', 'arg0')])
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedLcReleaseCnfParameters::m_logicalChannelIdentity [variable]
    cls.add_instance_attribute('m_logicalChannelIdentity', 'std::vector< unsigned char >', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedLcReleaseCnfParameters::m_result [variable]
    cls.add_instance_attribute('m_result', 'ns3::Result_e', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedLcReleaseCnfParameters::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedLcReleaseCnfParameters::m_vendorSpecificList [variable]
    cls.add_instance_attribute('m_vendorSpecificList', 'std::vector< ns3::VendorSpecificListElement_s >', is_const=False)
    return

def register_Ns3FfMacCschedSapUserCschedUeConfigCnfParameters_methods(root_module, cls):
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedUeConfigCnfParameters::CschedUeConfigCnfParameters() [constructor]
    cls.add_constructor([])
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedUeConfigCnfParameters::CschedUeConfigCnfParameters(ns3::FfMacCschedSapUser::CschedUeConfigCnfParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::FfMacCschedSapUser::CschedUeConfigCnfParameters const &', 'arg0')])
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedUeConfigCnfParameters::m_result [variable]
    cls.add_instance_attribute('m_result', 'ns3::Result_e', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedUeConfigCnfParameters::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedUeConfigCnfParameters::m_vendorSpecificList [variable]
    cls.add_instance_attribute('m_vendorSpecificList', 'std::vector< ns3::VendorSpecificListElement_s >', is_const=False)
    return

def register_Ns3FfMacCschedSapUserCschedUeConfigUpdateIndParameters_methods(root_module, cls):
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedUeConfigUpdateIndParameters::CschedUeConfigUpdateIndParameters() [constructor]
    cls.add_constructor([])
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedUeConfigUpdateIndParameters::CschedUeConfigUpdateIndParameters(ns3::FfMacCschedSapUser::CschedUeConfigUpdateIndParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::FfMacCschedSapUser::CschedUeConfigUpdateIndParameters const &', 'arg0')])
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedUeConfigUpdateIndParameters::m_cqiConfig [variable]
    cls.add_instance_attribute('m_cqiConfig', 'ns3::CqiConfig_s', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedUeConfigUpdateIndParameters::m_cqiConfigPresent [variable]
    cls.add_instance_attribute('m_cqiConfigPresent', 'bool', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedUeConfigUpdateIndParameters::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedUeConfigUpdateIndParameters::m_spsConfig [variable]
    cls.add_instance_attribute('m_spsConfig', 'ns3::SpsConfig_s', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedUeConfigUpdateIndParameters::m_spsConfigPresent [variable]
    cls.add_instance_attribute('m_spsConfigPresent', 'bool', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedUeConfigUpdateIndParameters::m_srConfig [variable]
    cls.add_instance_attribute('m_srConfig', 'ns3::SrConfig_s', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedUeConfigUpdateIndParameters::m_srConfigPresent [variable]
    cls.add_instance_attribute('m_srConfigPresent', 'bool', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedUeConfigUpdateIndParameters::m_transmissionMode [variable]
    cls.add_instance_attribute('m_transmissionMode', 'uint8_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedUeConfigUpdateIndParameters::m_vendorSpecificList [variable]
    cls.add_instance_attribute('m_vendorSpecificList', 'std::vector< ns3::VendorSpecificListElement_s >', is_const=False)
    return

def register_Ns3FfMacCschedSapUserCschedUeReleaseCnfParameters_methods(root_module, cls):
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedUeReleaseCnfParameters::CschedUeReleaseCnfParameters() [constructor]
    cls.add_constructor([])
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedUeReleaseCnfParameters::CschedUeReleaseCnfParameters(ns3::FfMacCschedSapUser::CschedUeReleaseCnfParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::FfMacCschedSapUser::CschedUeReleaseCnfParameters const &', 'arg0')])
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedUeReleaseCnfParameters::m_result [variable]
    cls.add_instance_attribute('m_result', 'ns3::Result_e', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedUeReleaseCnfParameters::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    ## ff-mac-csched-sap.h (module 'lte'): ns3::FfMacCschedSapUser::CschedUeReleaseCnfParameters::m_vendorSpecificList [variable]
    cls.add_instance_attribute('m_vendorSpecificList', 'std::vector< ns3::VendorSpecificListElement_s >', is_const=False)
    return

def register_Ns3FfMacSchedSapProvider_methods(root_module, cls):
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::FfMacSchedSapProvider() [constructor]
    cls.add_constructor([])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::FfMacSchedSapProvider(ns3::FfMacSchedSapProvider const & arg0) [constructor]
    cls.add_constructor([param('ns3::FfMacSchedSapProvider const &', 'arg0')])
    ## ff-mac-sched-sap.h (module 'lte'): void ns3::FfMacSchedSapProvider::SchedDlCqiInfoReq(ns3::FfMacSchedSapProvider::SchedDlCqiInfoReqParameters const & params) [member function]
    cls.add_method('SchedDlCqiInfoReq',
                   'void',
                   [param('ns3::FfMacSchedSapProvider::SchedDlCqiInfoReqParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## ff-mac-sched-sap.h (module 'lte'): void ns3::FfMacSchedSapProvider::SchedDlMacBufferReq(ns3::FfMacSchedSapProvider::SchedDlMacBufferReqParameters const & params) [member function]
    cls.add_method('SchedDlMacBufferReq',
                   'void',
                   [param('ns3::FfMacSchedSapProvider::SchedDlMacBufferReqParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## ff-mac-sched-sap.h (module 'lte'): void ns3::FfMacSchedSapProvider::SchedDlPagingBufferReq(ns3::FfMacSchedSapProvider::SchedDlPagingBufferReqParameters const & params) [member function]
    cls.add_method('SchedDlPagingBufferReq',
                   'void',
                   [param('ns3::FfMacSchedSapProvider::SchedDlPagingBufferReqParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## ff-mac-sched-sap.h (module 'lte'): void ns3::FfMacSchedSapProvider::SchedDlRachInfoReq(ns3::FfMacSchedSapProvider::SchedDlRachInfoReqParameters const & params) [member function]
    cls.add_method('SchedDlRachInfoReq',
                   'void',
                   [param('ns3::FfMacSchedSapProvider::SchedDlRachInfoReqParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## ff-mac-sched-sap.h (module 'lte'): void ns3::FfMacSchedSapProvider::SchedDlRlcBufferReq(ns3::FfMacSchedSapProvider::SchedDlRlcBufferReqParameters const & params) [member function]
    cls.add_method('SchedDlRlcBufferReq',
                   'void',
                   [param('ns3::FfMacSchedSapProvider::SchedDlRlcBufferReqParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## ff-mac-sched-sap.h (module 'lte'): void ns3::FfMacSchedSapProvider::SchedDlTriggerReq(ns3::FfMacSchedSapProvider::SchedDlTriggerReqParameters const & params) [member function]
    cls.add_method('SchedDlTriggerReq',
                   'void',
                   [param('ns3::FfMacSchedSapProvider::SchedDlTriggerReqParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## ff-mac-sched-sap.h (module 'lte'): void ns3::FfMacSchedSapProvider::SchedUlCqiInfoReq(ns3::FfMacSchedSapProvider::SchedUlCqiInfoReqParameters const & params) [member function]
    cls.add_method('SchedUlCqiInfoReq',
                   'void',
                   [param('ns3::FfMacSchedSapProvider::SchedUlCqiInfoReqParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## ff-mac-sched-sap.h (module 'lte'): void ns3::FfMacSchedSapProvider::SchedUlMacCtrlInfoReq(ns3::FfMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters const & params) [member function]
    cls.add_method('SchedUlMacCtrlInfoReq',
                   'void',
                   [param('ns3::FfMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## ff-mac-sched-sap.h (module 'lte'): void ns3::FfMacSchedSapProvider::SchedUlNoiseInterferenceReq(ns3::FfMacSchedSapProvider::SchedUlNoiseInterferenceReqParameters const & params) [member function]
    cls.add_method('SchedUlNoiseInterferenceReq',
                   'void',
                   [param('ns3::FfMacSchedSapProvider::SchedUlNoiseInterferenceReqParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## ff-mac-sched-sap.h (module 'lte'): void ns3::FfMacSchedSapProvider::SchedUlSrInfoReq(ns3::FfMacSchedSapProvider::SchedUlSrInfoReqParameters const & params) [member function]
    cls.add_method('SchedUlSrInfoReq',
                   'void',
                   [param('ns3::FfMacSchedSapProvider::SchedUlSrInfoReqParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## ff-mac-sched-sap.h (module 'lte'): void ns3::FfMacSchedSapProvider::SchedUlTriggerReq(ns3::FfMacSchedSapProvider::SchedUlTriggerReqParameters const & params) [member function]
    cls.add_method('SchedUlTriggerReq',
                   'void',
                   [param('ns3::FfMacSchedSapProvider::SchedUlTriggerReqParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3FfMacSchedSapProviderSchedDlCqiInfoReqParameters_methods(root_module, cls):
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlCqiInfoReqParameters::SchedDlCqiInfoReqParameters() [constructor]
    cls.add_constructor([])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlCqiInfoReqParameters::SchedDlCqiInfoReqParameters(ns3::FfMacSchedSapProvider::SchedDlCqiInfoReqParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::FfMacSchedSapProvider::SchedDlCqiInfoReqParameters const &', 'arg0')])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlCqiInfoReqParameters::m_cqiList [variable]
    cls.add_instance_attribute('m_cqiList', 'std::vector< ns3::CqiListElement_s >', is_const=False)
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlCqiInfoReqParameters::m_sfnSf [variable]
    cls.add_instance_attribute('m_sfnSf', 'uint16_t', is_const=False)
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlCqiInfoReqParameters::m_vendorSpecificList [variable]
    cls.add_instance_attribute('m_vendorSpecificList', 'std::vector< ns3::VendorSpecificListElement_s >', is_const=False)
    return

def register_Ns3FfMacSchedSapProviderSchedDlMacBufferReqParameters_methods(root_module, cls):
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlMacBufferReqParameters::SchedDlMacBufferReqParameters() [constructor]
    cls.add_constructor([])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlMacBufferReqParameters::SchedDlMacBufferReqParameters(ns3::FfMacSchedSapProvider::SchedDlMacBufferReqParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::FfMacSchedSapProvider::SchedDlMacBufferReqParameters const &', 'arg0')])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlMacBufferReqParameters::m_ceBitmap [variable]
    cls.add_instance_attribute('m_ceBitmap', 'ns3::CeBitmap_e', is_const=False)
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlMacBufferReqParameters::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlMacBufferReqParameters::m_vendorSpecificList [variable]
    cls.add_instance_attribute('m_vendorSpecificList', 'std::vector< ns3::VendorSpecificListElement_s >', is_const=False)
    return

def register_Ns3FfMacSchedSapProviderSchedDlPagingBufferReqParameters_methods(root_module, cls):
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlPagingBufferReqParameters::SchedDlPagingBufferReqParameters() [constructor]
    cls.add_constructor([])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlPagingBufferReqParameters::SchedDlPagingBufferReqParameters(ns3::FfMacSchedSapProvider::SchedDlPagingBufferReqParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::FfMacSchedSapProvider::SchedDlPagingBufferReqParameters const &', 'arg0')])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlPagingBufferReqParameters::m_pagingInfoList [variable]
    cls.add_instance_attribute('m_pagingInfoList', 'std::vector< ns3::PagingInfoListElement_s >', is_const=False)
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlPagingBufferReqParameters::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlPagingBufferReqParameters::m_vendorSpecificList [variable]
    cls.add_instance_attribute('m_vendorSpecificList', 'std::vector< ns3::VendorSpecificListElement_s >', is_const=False)
    return

def register_Ns3FfMacSchedSapProviderSchedDlRachInfoReqParameters_methods(root_module, cls):
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlRachInfoReqParameters::SchedDlRachInfoReqParameters() [constructor]
    cls.add_constructor([])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlRachInfoReqParameters::SchedDlRachInfoReqParameters(ns3::FfMacSchedSapProvider::SchedDlRachInfoReqParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::FfMacSchedSapProvider::SchedDlRachInfoReqParameters const &', 'arg0')])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlRachInfoReqParameters::m_rachList [variable]
    cls.add_instance_attribute('m_rachList', 'std::vector< ns3::RachListElement_s >', is_const=False)
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlRachInfoReqParameters::m_sfnSf [variable]
    cls.add_instance_attribute('m_sfnSf', 'uint16_t', is_const=False)
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlRachInfoReqParameters::m_vendorSpecificList [variable]
    cls.add_instance_attribute('m_vendorSpecificList', 'std::vector< ns3::VendorSpecificListElement_s >', is_const=False)
    return

def register_Ns3FfMacSchedSapProviderSchedDlRlcBufferReqParameters_methods(root_module, cls):
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlRlcBufferReqParameters::SchedDlRlcBufferReqParameters() [constructor]
    cls.add_constructor([])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlRlcBufferReqParameters::SchedDlRlcBufferReqParameters(ns3::FfMacSchedSapProvider::SchedDlRlcBufferReqParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::FfMacSchedSapProvider::SchedDlRlcBufferReqParameters const &', 'arg0')])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlRlcBufferReqParameters::m_logicalChannelIdentity [variable]
    cls.add_instance_attribute('m_logicalChannelIdentity', 'uint8_t', is_const=False)
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlRlcBufferReqParameters::m_rlcRetransmissionHolDelay [variable]
    cls.add_instance_attribute('m_rlcRetransmissionHolDelay', 'uint16_t', is_const=False)
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlRlcBufferReqParameters::m_rlcRetransmissionQueueSize [variable]
    cls.add_instance_attribute('m_rlcRetransmissionQueueSize', 'uint32_t', is_const=False)
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlRlcBufferReqParameters::m_rlcStatusPduSize [variable]
    cls.add_instance_attribute('m_rlcStatusPduSize', 'uint16_t', is_const=False)
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlRlcBufferReqParameters::m_rlcTransmissionQueueHolDelay [variable]
    cls.add_instance_attribute('m_rlcTransmissionQueueHolDelay', 'uint16_t', is_const=False)
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlRlcBufferReqParameters::m_rlcTransmissionQueueSize [variable]
    cls.add_instance_attribute('m_rlcTransmissionQueueSize', 'uint32_t', is_const=False)
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlRlcBufferReqParameters::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlRlcBufferReqParameters::m_vendorSpecificList [variable]
    cls.add_instance_attribute('m_vendorSpecificList', 'std::vector< ns3::VendorSpecificListElement_s >', is_const=False)
    return

def register_Ns3FfMacSchedSapProviderSchedDlTriggerReqParameters_methods(root_module, cls):
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlTriggerReqParameters::SchedDlTriggerReqParameters() [constructor]
    cls.add_constructor([])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlTriggerReqParameters::SchedDlTriggerReqParameters(ns3::FfMacSchedSapProvider::SchedDlTriggerReqParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::FfMacSchedSapProvider::SchedDlTriggerReqParameters const &', 'arg0')])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlTriggerReqParameters::m_dlInfoList [variable]
    cls.add_instance_attribute('m_dlInfoList', 'std::vector< ns3::DlInfoListElement_s >', is_const=False)
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlTriggerReqParameters::m_sfnSf [variable]
    cls.add_instance_attribute('m_sfnSf', 'uint16_t', is_const=False)
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedDlTriggerReqParameters::m_vendorSpecificList [variable]
    cls.add_instance_attribute('m_vendorSpecificList', 'std::vector< ns3::VendorSpecificListElement_s >', is_const=False)
    return

def register_Ns3FfMacSchedSapProviderSchedUlCqiInfoReqParameters_methods(root_module, cls):
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedUlCqiInfoReqParameters::SchedUlCqiInfoReqParameters() [constructor]
    cls.add_constructor([])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedUlCqiInfoReqParameters::SchedUlCqiInfoReqParameters(ns3::FfMacSchedSapProvider::SchedUlCqiInfoReqParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::FfMacSchedSapProvider::SchedUlCqiInfoReqParameters const &', 'arg0')])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedUlCqiInfoReqParameters::m_sfnSf [variable]
    cls.add_instance_attribute('m_sfnSf', 'uint16_t', is_const=False)
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedUlCqiInfoReqParameters::m_ulCqi [variable]
    cls.add_instance_attribute('m_ulCqi', 'ns3::UlCqi_s', is_const=False)
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedUlCqiInfoReqParameters::m_vendorSpecificList [variable]
    cls.add_instance_attribute('m_vendorSpecificList', 'std::vector< ns3::VendorSpecificListElement_s >', is_const=False)
    return

def register_Ns3FfMacSchedSapProviderSchedUlMacCtrlInfoReqParameters_methods(root_module, cls):
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters::SchedUlMacCtrlInfoReqParameters() [constructor]
    cls.add_constructor([])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters::SchedUlMacCtrlInfoReqParameters(ns3::FfMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::FfMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters const &', 'arg0')])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters::m_macCeList [variable]
    cls.add_instance_attribute('m_macCeList', 'std::vector< ns3::MacCeListElement_s >', is_const=False)
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters::m_sfnSf [variable]
    cls.add_instance_attribute('m_sfnSf', 'uint16_t', is_const=False)
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters::m_vendorSpecificList [variable]
    cls.add_instance_attribute('m_vendorSpecificList', 'std::vector< ns3::VendorSpecificListElement_s >', is_const=False)
    return

def register_Ns3FfMacSchedSapProviderSchedUlNoiseInterferenceReqParameters_methods(root_module, cls):
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedUlNoiseInterferenceReqParameters::SchedUlNoiseInterferenceReqParameters() [constructor]
    cls.add_constructor([])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedUlNoiseInterferenceReqParameters::SchedUlNoiseInterferenceReqParameters(ns3::FfMacSchedSapProvider::SchedUlNoiseInterferenceReqParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::FfMacSchedSapProvider::SchedUlNoiseInterferenceReqParameters const &', 'arg0')])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedUlNoiseInterferenceReqParameters::m_rip [variable]
    cls.add_instance_attribute('m_rip', 'uint16_t', is_const=False)
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedUlNoiseInterferenceReqParameters::m_sfnSf [variable]
    cls.add_instance_attribute('m_sfnSf', 'uint16_t', is_const=False)
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedUlNoiseInterferenceReqParameters::m_tnp [variable]
    cls.add_instance_attribute('m_tnp', 'uint16_t', is_const=False)
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedUlNoiseInterferenceReqParameters::m_vendorSpecificList [variable]
    cls.add_instance_attribute('m_vendorSpecificList', 'std::vector< ns3::VendorSpecificListElement_s >', is_const=False)
    return

def register_Ns3FfMacSchedSapProviderSchedUlSrInfoReqParameters_methods(root_module, cls):
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedUlSrInfoReqParameters::SchedUlSrInfoReqParameters() [constructor]
    cls.add_constructor([])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedUlSrInfoReqParameters::SchedUlSrInfoReqParameters(ns3::FfMacSchedSapProvider::SchedUlSrInfoReqParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::FfMacSchedSapProvider::SchedUlSrInfoReqParameters const &', 'arg0')])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedUlSrInfoReqParameters::m_sfnSf [variable]
    cls.add_instance_attribute('m_sfnSf', 'uint16_t', is_const=False)
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedUlSrInfoReqParameters::m_srList [variable]
    cls.add_instance_attribute('m_srList', 'std::vector< ns3::SrListElement_s >', is_const=False)
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedUlSrInfoReqParameters::m_vendorSpecificList [variable]
    cls.add_instance_attribute('m_vendorSpecificList', 'std::vector< ns3::VendorSpecificListElement_s >', is_const=False)
    return

def register_Ns3FfMacSchedSapProviderSchedUlTriggerReqParameters_methods(root_module, cls):
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedUlTriggerReqParameters::SchedUlTriggerReqParameters() [constructor]
    cls.add_constructor([])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedUlTriggerReqParameters::SchedUlTriggerReqParameters(ns3::FfMacSchedSapProvider::SchedUlTriggerReqParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::FfMacSchedSapProvider::SchedUlTriggerReqParameters const &', 'arg0')])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedUlTriggerReqParameters::m_sfnSf [variable]
    cls.add_instance_attribute('m_sfnSf', 'uint16_t', is_const=False)
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedUlTriggerReqParameters::m_ulInfoList [variable]
    cls.add_instance_attribute('m_ulInfoList', 'std::vector< ns3::UlInfoListElement_s >', is_const=False)
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedUlTriggerReqParameters::m_vendorSpecificList [variable]
    cls.add_instance_attribute('m_vendorSpecificList', 'std::vector< ns3::VendorSpecificListElement_s >', is_const=False)
    return

def register_Ns3FfMacSchedSapUser_methods(root_module, cls):
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapUser::FfMacSchedSapUser() [constructor]
    cls.add_constructor([])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapUser::FfMacSchedSapUser(ns3::FfMacSchedSapUser const & arg0) [constructor]
    cls.add_constructor([param('ns3::FfMacSchedSapUser const &', 'arg0')])
    ## ff-mac-sched-sap.h (module 'lte'): void ns3::FfMacSchedSapUser::SchedDlConfigInd(ns3::FfMacSchedSapUser::SchedDlConfigIndParameters const & params) [member function]
    cls.add_method('SchedDlConfigInd',
                   'void',
                   [param('ns3::FfMacSchedSapUser::SchedDlConfigIndParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## ff-mac-sched-sap.h (module 'lte'): void ns3::FfMacSchedSapUser::SchedUlConfigInd(ns3::FfMacSchedSapUser::SchedUlConfigIndParameters const & params) [member function]
    cls.add_method('SchedUlConfigInd',
                   'void',
                   [param('ns3::FfMacSchedSapUser::SchedUlConfigIndParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3FfMacSchedSapUserSchedDlConfigIndParameters_methods(root_module, cls):
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapUser::SchedDlConfigIndParameters::SchedDlConfigIndParameters() [constructor]
    cls.add_constructor([])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapUser::SchedDlConfigIndParameters::SchedDlConfigIndParameters(ns3::FfMacSchedSapUser::SchedDlConfigIndParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::FfMacSchedSapUser::SchedDlConfigIndParameters const &', 'arg0')])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapUser::SchedDlConfigIndParameters::m_buildBroadcastList [variable]
    cls.add_instance_attribute('m_buildBroadcastList', 'std::vector< ns3::BuildBroadcastListElement_s >', is_const=False)
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapUser::SchedDlConfigIndParameters::m_buildDataList [variable]
    cls.add_instance_attribute('m_buildDataList', 'std::vector< ns3::BuildDataListElement_s >', is_const=False)
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapUser::SchedDlConfigIndParameters::m_buildRarList [variable]
    cls.add_instance_attribute('m_buildRarList', 'std::vector< ns3::BuildRarListElement_s >', is_const=False)
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapUser::SchedDlConfigIndParameters::m_nrOfPdcchOfdmSymbols [variable]
    cls.add_instance_attribute('m_nrOfPdcchOfdmSymbols', 'uint8_t', is_const=False)
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapUser::SchedDlConfigIndParameters::m_vendorSpecificList [variable]
    cls.add_instance_attribute('m_vendorSpecificList', 'std::vector< ns3::VendorSpecificListElement_s >', is_const=False)
    return

def register_Ns3FfMacSchedSapUserSchedUlConfigIndParameters_methods(root_module, cls):
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapUser::SchedUlConfigIndParameters::SchedUlConfigIndParameters() [constructor]
    cls.add_constructor([])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapUser::SchedUlConfigIndParameters::SchedUlConfigIndParameters(ns3::FfMacSchedSapUser::SchedUlConfigIndParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::FfMacSchedSapUser::SchedUlConfigIndParameters const &', 'arg0')])
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapUser::SchedUlConfigIndParameters::m_dciList [variable]
    cls.add_instance_attribute('m_dciList', 'std::vector< ns3::UlDciListElement_s >', is_const=False)
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapUser::SchedUlConfigIndParameters::m_phichList [variable]
    cls.add_instance_attribute('m_phichList', 'std::vector< ns3::PhichListElement_s >', is_const=False)
    ## ff-mac-sched-sap.h (module 'lte'): ns3::FfMacSchedSapUser::SchedUlConfigIndParameters::m_vendorSpecificList [variable]
    cls.add_instance_attribute('m_vendorSpecificList', 'std::vector< ns3::VendorSpecificListElement_s >', is_const=False)
    return

def register_Ns3GbrQosInformation_methods(root_module, cls):
    ## eps-bearer.h (module 'lte'): ns3::GbrQosInformation::GbrQosInformation(ns3::GbrQosInformation const & arg0) [constructor]
    cls.add_constructor([param('ns3::GbrQosInformation const &', 'arg0')])
    ## eps-bearer.h (module 'lte'): ns3::GbrQosInformation::GbrQosInformation() [constructor]
    cls.add_constructor([])
    ## eps-bearer.h (module 'lte'): ns3::GbrQosInformation::gbrDl [variable]
    cls.add_instance_attribute('gbrDl', 'uint64_t', is_const=False)
    ## eps-bearer.h (module 'lte'): ns3::GbrQosInformation::gbrUl [variable]
    cls.add_instance_attribute('gbrUl', 'uint64_t', is_const=False)
    ## eps-bearer.h (module 'lte'): ns3::GbrQosInformation::mbrDl [variable]
    cls.add_instance_attribute('mbrDl', 'uint64_t', is_const=False)
    ## eps-bearer.h (module 'lte'): ns3::GbrQosInformation::mbrUl [variable]
    cls.add_instance_attribute('mbrUl', 'uint64_t', is_const=False)
    return

def register_Ns3HarqProcessInfoElement_t_methods(root_module, cls):
    ## lte-harq-phy.h (module 'lte'): ns3::HarqProcessInfoElement_t::HarqProcessInfoElement_t() [constructor]
    cls.add_constructor([])
    ## lte-harq-phy.h (module 'lte'): ns3::HarqProcessInfoElement_t::HarqProcessInfoElement_t(ns3::HarqProcessInfoElement_t const & arg0) [constructor]
    cls.add_constructor([param('ns3::HarqProcessInfoElement_t const &', 'arg0')])
    ## lte-harq-phy.h (module 'lte'): ns3::HarqProcessInfoElement_t::m_codeBits [variable]
    cls.add_instance_attribute('m_codeBits', 'uint16_t', is_const=False)
    ## lte-harq-phy.h (module 'lte'): ns3::HarqProcessInfoElement_t::m_infoBits [variable]
    cls.add_instance_attribute('m_infoBits', 'uint16_t', is_const=False)
    ## lte-harq-phy.h (module 'lte'): ns3::HarqProcessInfoElement_t::m_mi [variable]
    cls.add_instance_attribute('m_mi', 'double', is_const=False)
    ## lte-harq-phy.h (module 'lte'): ns3::HarqProcessInfoElement_t::m_rv [variable]
    cls.add_instance_attribute('m_rv', 'uint8_t', is_const=False)
    return

def register_Ns3Hasher_methods(root_module, cls):
    ## hash.h (module 'core'): ns3::Hasher::Hasher(ns3::Hasher const & arg0) [constructor]
    cls.add_constructor([param('ns3::Hasher const &', 'arg0')])
    ## hash.h (module 'core'): ns3::Hasher::Hasher() [constructor]
    cls.add_constructor([])
    ## hash.h (module 'core'): ns3::Hasher::Hasher(ns3::Ptr<ns3::Hash::Implementation> hp) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::Hash::Implementation >', 'hp')])
    ## hash.h (module 'core'): uint32_t ns3::Hasher::GetHash32(char const * buffer, std::size_t const size) [member function]
    cls.add_method('GetHash32',
                   'uint32_t',
                   [param('char const *', 'buffer'), param('std::size_t const', 'size')])
    ## hash.h (module 'core'): uint32_t ns3::Hasher::GetHash32(std::string const s) [member function]
    cls.add_method('GetHash32',
                   'uint32_t',
                   [param('std::string const', 's')])
    ## hash.h (module 'core'): uint64_t ns3::Hasher::GetHash64(char const * buffer, std::size_t const size) [member function]
    cls.add_method('GetHash64',
                   'uint64_t',
                   [param('char const *', 'buffer'), param('std::size_t const', 'size')])
    ## hash.h (module 'core'): uint64_t ns3::Hasher::GetHash64(std::string const s) [member function]
    cls.add_method('GetHash64',
                   'uint64_t',
                   [param('std::string const', 's')])
    ## hash.h (module 'core'): ns3::Hasher & ns3::Hasher::clear() [member function]
    cls.add_method('clear',
                   'ns3::Hasher &',
                   [])
    return

def register_Ns3HigherLayerSelected_s_methods(root_module, cls):
    ## ff-mac-common.h (module 'lte'): ns3::HigherLayerSelected_s::HigherLayerSelected_s() [constructor]
    cls.add_constructor([])
    ## ff-mac-common.h (module 'lte'): ns3::HigherLayerSelected_s::HigherLayerSelected_s(ns3::HigherLayerSelected_s const & arg0) [constructor]
    cls.add_constructor([param('ns3::HigherLayerSelected_s const &', 'arg0')])
    ## ff-mac-common.h (module 'lte'): ns3::HigherLayerSelected_s::m_sbCqi [variable]
    cls.add_instance_attribute('m_sbCqi', 'std::vector< unsigned char >', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::HigherLayerSelected_s::m_sbPmi [variable]
    cls.add_instance_attribute('m_sbPmi', 'uint8_t', is_const=False)
    return

def register_Ns3ImsiLcidPair_t_methods(root_module, cls):
    cls.add_binary_comparison_operator('<')
    cls.add_binary_comparison_operator('==')
    ## lte-common.h (module 'lte'): ns3::ImsiLcidPair_t::ImsiLcidPair_t(ns3::ImsiLcidPair_t const & arg0) [constructor]
    cls.add_constructor([param('ns3::ImsiLcidPair_t const &', 'arg0')])
    ## lte-common.h (module 'lte'): ns3::ImsiLcidPair_t::ImsiLcidPair_t() [constructor]
    cls.add_constructor([])
    ## lte-common.h (module 'lte'): ns3::ImsiLcidPair_t::ImsiLcidPair_t(uint64_t const a, uint8_t const b) [constructor]
    cls.add_constructor([param('uint64_t const', 'a'), param('uint8_t const', 'b')])
    ## lte-common.h (module 'lte'): ns3::ImsiLcidPair_t::m_imsi [variable]
    cls.add_instance_attribute('m_imsi', 'uint64_t', is_const=False)
    ## lte-common.h (module 'lte'): ns3::ImsiLcidPair_t::m_lcId [variable]
    cls.add_instance_attribute('m_lcId', 'uint8_t', is_const=False)
    return

def register_Ns3Inet6SocketAddress_methods(root_module, cls):
    ## inet6-socket-address.h (module 'network'): ns3::Inet6SocketAddress::Inet6SocketAddress(ns3::Inet6SocketAddress const & arg0) [constructor]
    cls.add_constructor([param('ns3::Inet6SocketAddress const &', 'arg0')])
    ## inet6-socket-address.h (module 'network'): ns3::Inet6SocketAddress::Inet6SocketAddress(ns3::Ipv6Address ipv6, uint16_t port) [constructor]
    cls.add_constructor([param('ns3::Ipv6Address', 'ipv6'), param('uint16_t', 'port')])
    ## inet6-socket-address.h (module 'network'): ns3::Inet6SocketAddress::Inet6SocketAddress(ns3::Ipv6Address ipv6) [constructor]
    cls.add_constructor([param('ns3::Ipv6Address', 'ipv6')])
    ## inet6-socket-address.h (module 'network'): ns3::Inet6SocketAddress::Inet6SocketAddress(uint16_t port) [constructor]
    cls.add_constructor([param('uint16_t', 'port')])
    ## inet6-socket-address.h (module 'network'): ns3::Inet6SocketAddress::Inet6SocketAddress(char const * ipv6, uint16_t port) [constructor]
    cls.add_constructor([param('char const *', 'ipv6'), param('uint16_t', 'port')])
    ## inet6-socket-address.h (module 'network'): ns3::Inet6SocketAddress::Inet6SocketAddress(char const * ipv6) [constructor]
    cls.add_constructor([param('char const *', 'ipv6')])
    ## inet6-socket-address.h (module 'network'): static ns3::Inet6SocketAddress ns3::Inet6SocketAddress::ConvertFrom(ns3::Address const & addr) [member function]
    cls.add_method('ConvertFrom',
                   'ns3::Inet6SocketAddress',
                   [param('ns3::Address const &', 'addr')],
                   is_static=True)
    ## inet6-socket-address.h (module 'network'): ns3::Ipv6Address ns3::Inet6SocketAddress::GetIpv6() const [member function]
    cls.add_method('GetIpv6',
                   'ns3::Ipv6Address',
                   [],
                   is_const=True)
    ## inet6-socket-address.h (module 'network'): uint16_t ns3::Inet6SocketAddress::GetPort() const [member function]
    cls.add_method('GetPort',
                   'uint16_t',
                   [],
                   is_const=True)
    ## inet6-socket-address.h (module 'network'): static bool ns3::Inet6SocketAddress::IsMatchingType(ns3::Address const & addr) [member function]
    cls.add_method('IsMatchingType',
                   'bool',
                   [param('ns3::Address const &', 'addr')],
                   is_static=True)
    ## inet6-socket-address.h (module 'network'): void ns3::Inet6SocketAddress::SetIpv6(ns3::Ipv6Address ipv6) [member function]
    cls.add_method('SetIpv6',
                   'void',
                   [param('ns3::Ipv6Address', 'ipv6')])
    ## inet6-socket-address.h (module 'network'): void ns3::Inet6SocketAddress::SetPort(uint16_t port) [member function]
    cls.add_method('SetPort',
                   'void',
                   [param('uint16_t', 'port')])
    return

def register_Ns3InetSocketAddress_methods(root_module, cls):
    ## inet-socket-address.h (module 'network'): ns3::InetSocketAddress::InetSocketAddress(ns3::InetSocketAddress const & arg0) [constructor]
    cls.add_constructor([param('ns3::InetSocketAddress const &', 'arg0')])
    ## inet-socket-address.h (module 'network'): ns3::InetSocketAddress::InetSocketAddress(ns3::Ipv4Address ipv4, uint16_t port) [constructor]
    cls.add_constructor([param('ns3::Ipv4Address', 'ipv4'), param('uint16_t', 'port')])
    ## inet-socket-address.h (module 'network'): ns3::InetSocketAddress::InetSocketAddress(ns3::Ipv4Address ipv4) [constructor]
    cls.add_constructor([param('ns3::Ipv4Address', 'ipv4')])
    ## inet-socket-address.h (module 'network'): ns3::InetSocketAddress::InetSocketAddress(uint16_t port) [constructor]
    cls.add_constructor([param('uint16_t', 'port')])
    ## inet-socket-address.h (module 'network'): ns3::InetSocketAddress::InetSocketAddress(char const * ipv4, uint16_t port) [constructor]
    cls.add_constructor([param('char const *', 'ipv4'), param('uint16_t', 'port')])
    ## inet-socket-address.h (module 'network'): ns3::InetSocketAddress::InetSocketAddress(char const * ipv4) [constructor]
    cls.add_constructor([param('char const *', 'ipv4')])
    ## inet-socket-address.h (module 'network'): static ns3::InetSocketAddress ns3::InetSocketAddress::ConvertFrom(ns3::Address const & address) [member function]
    cls.add_method('ConvertFrom',
                   'ns3::InetSocketAddress',
                   [param('ns3::Address const &', 'address')],
                   is_static=True)
    ## inet-socket-address.h (module 'network'): ns3::Ipv4Address ns3::InetSocketAddress::GetIpv4() const [member function]
    cls.add_method('GetIpv4',
                   'ns3::Ipv4Address',
                   [],
                   is_const=True)
    ## inet-socket-address.h (module 'network'): uint16_t ns3::InetSocketAddress::GetPort() const [member function]
    cls.add_method('GetPort',
                   'uint16_t',
                   [],
                   is_const=True)
    ## inet-socket-address.h (module 'network'): uint8_t ns3::InetSocketAddress::GetTos() const [member function]
    cls.add_method('GetTos',
                   'uint8_t',
                   [],
                   is_const=True)
    ## inet-socket-address.h (module 'network'): static bool ns3::InetSocketAddress::IsMatchingType(ns3::Address const & address) [member function]
    cls.add_method('IsMatchingType',
                   'bool',
                   [param('ns3::Address const &', 'address')],
                   is_static=True)
    ## inet-socket-address.h (module 'network'): void ns3::InetSocketAddress::SetIpv4(ns3::Ipv4Address address) [member function]
    cls.add_method('SetIpv4',
                   'void',
                   [param('ns3::Ipv4Address', 'address')])
    ## inet-socket-address.h (module 'network'): void ns3::InetSocketAddress::SetPort(uint16_t port) [member function]
    cls.add_method('SetPort',
                   'void',
                   [param('uint16_t', 'port')])
    ## inet-socket-address.h (module 'network'): void ns3::InetSocketAddress::SetTos(uint8_t tos) [member function]
    cls.add_method('SetTos',
                   'void',
                   [param('uint8_t', 'tos')])
    return

def register_Ns3Ipv4Address_methods(root_module, cls):
    cls.add_output_stream_operator()
    cls.add_binary_comparison_operator('==')
    cls.add_binary_comparison_operator('!=')
    cls.add_binary_comparison_operator('<')
    ## ipv4-address.h (module 'network'): ns3::Ipv4Address::Ipv4Address(ns3::Ipv4Address const & arg0) [constructor]
    cls.add_constructor([param('ns3::Ipv4Address const &', 'arg0')])
    ## ipv4-address.h (module 'network'): ns3::Ipv4Address::Ipv4Address() [constructor]
    cls.add_constructor([])
    ## ipv4-address.h (module 'network'): ns3::Ipv4Address::Ipv4Address(uint32_t address) [constructor]
    cls.add_constructor([param('uint32_t', 'address')])
    ## ipv4-address.h (module 'network'): ns3::Ipv4Address::Ipv4Address(char const * address) [constructor]
    cls.add_constructor([param('char const *', 'address')])
    ## ipv4-address.h (module 'network'): ns3::Ipv4Address ns3::Ipv4Address::CombineMask(ns3::Ipv4Mask const & mask) const [member function]
    cls.add_method('CombineMask',
                   'ns3::Ipv4Address',
                   [param('ns3::Ipv4Mask const &', 'mask')],
                   is_const=True)
    ## ipv4-address.h (module 'network'): static ns3::Ipv4Address ns3::Ipv4Address::ConvertFrom(ns3::Address const & address) [member function]
    cls.add_method('ConvertFrom',
                   'ns3::Ipv4Address',
                   [param('ns3::Address const &', 'address')],
                   is_static=True)
    ## ipv4-address.h (module 'network'): static ns3::Ipv4Address ns3::Ipv4Address::Deserialize(uint8_t const * buf) [member function]
    cls.add_method('Deserialize',
                   'ns3::Ipv4Address',
                   [param('uint8_t const *', 'buf')],
                   is_static=True)
    ## ipv4-address.h (module 'network'): uint32_t ns3::Ipv4Address::Get() const [member function]
    cls.add_method('Get',
                   'uint32_t',
                   [],
                   is_const=True)
    ## ipv4-address.h (module 'network'): static ns3::Ipv4Address ns3::Ipv4Address::GetAny() [member function]
    cls.add_method('GetAny',
                   'ns3::Ipv4Address',
                   [],
                   is_static=True)
    ## ipv4-address.h (module 'network'): static ns3::Ipv4Address ns3::Ipv4Address::GetBroadcast() [member function]
    cls.add_method('GetBroadcast',
                   'ns3::Ipv4Address',
                   [],
                   is_static=True)
    ## ipv4-address.h (module 'network'): static ns3::Ipv4Address ns3::Ipv4Address::GetLoopback() [member function]
    cls.add_method('GetLoopback',
                   'ns3::Ipv4Address',
                   [],
                   is_static=True)
    ## ipv4-address.h (module 'network'): ns3::Ipv4Address ns3::Ipv4Address::GetSubnetDirectedBroadcast(ns3::Ipv4Mask const & mask) const [member function]
    cls.add_method('GetSubnetDirectedBroadcast',
                   'ns3::Ipv4Address',
                   [param('ns3::Ipv4Mask const &', 'mask')],
                   is_const=True)
    ## ipv4-address.h (module 'network'): static ns3::Ipv4Address ns3::Ipv4Address::GetZero() [member function]
    cls.add_method('GetZero',
                   'ns3::Ipv4Address',
                   [],
                   is_static=True)
    ## ipv4-address.h (module 'network'): bool ns3::Ipv4Address::IsAny() const [member function]
    cls.add_method('IsAny',
                   'bool',
                   [],
                   is_const=True)
    ## ipv4-address.h (module 'network'): bool ns3::Ipv4Address::IsBroadcast() const [member function]
    cls.add_method('IsBroadcast',
                   'bool',
                   [],
                   is_const=True)
    ## ipv4-address.h (module 'network'): bool ns3::Ipv4Address::IsEqual(ns3::Ipv4Address const & other) const [member function]
    cls.add_method('IsEqual',
                   'bool',
                   [param('ns3::Ipv4Address const &', 'other')],
                   is_const=True)
    ## ipv4-address.h (module 'network'): bool ns3::Ipv4Address::IsLocalMulticast() const [member function]
    cls.add_method('IsLocalMulticast',
                   'bool',
                   [],
                   is_const=True)
    ## ipv4-address.h (module 'network'): bool ns3::Ipv4Address::IsLocalhost() const [member function]
    cls.add_method('IsLocalhost',
                   'bool',
                   [],
                   is_const=True)
    ## ipv4-address.h (module 'network'): static bool ns3::Ipv4Address::IsMatchingType(ns3::Address const & address) [member function]
    cls.add_method('IsMatchingType',
                   'bool',
                   [param('ns3::Address const &', 'address')],
                   is_static=True)
    ## ipv4-address.h (module 'network'): bool ns3::Ipv4Address::IsMulticast() const [member function]
    cls.add_method('IsMulticast',
                   'bool',
                   [],
                   is_const=True)
    ## ipv4-address.h (module 'network'): bool ns3::Ipv4Address::IsSubnetDirectedBroadcast(ns3::Ipv4Mask const & mask) const [member function]
    cls.add_method('IsSubnetDirectedBroadcast',
                   'bool',
                   [param('ns3::Ipv4Mask const &', 'mask')],
                   is_const=True)
    ## ipv4-address.h (module 'network'): void ns3::Ipv4Address::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True)
    ## ipv4-address.h (module 'network'): void ns3::Ipv4Address::Serialize(uint8_t * buf) const [member function]
    cls.add_method('Serialize',
                   'void',
                   [param('uint8_t *', 'buf')],
                   is_const=True)
    ## ipv4-address.h (module 'network'): void ns3::Ipv4Address::Set(uint32_t address) [member function]
    cls.add_method('Set',
                   'void',
                   [param('uint32_t', 'address')])
    ## ipv4-address.h (module 'network'): void ns3::Ipv4Address::Set(char const * address) [member function]
    cls.add_method('Set',
                   'void',
                   [param('char const *', 'address')])
    return

def register_Ns3Ipv4AddressHelper_methods(root_module, cls):
    ## ipv4-address-helper.h (module 'internet'): ns3::Ipv4AddressHelper::Ipv4AddressHelper(ns3::Ipv4AddressHelper const & arg0) [constructor]
    cls.add_constructor([param('ns3::Ipv4AddressHelper const &', 'arg0')])
    ## ipv4-address-helper.h (module 'internet'): ns3::Ipv4AddressHelper::Ipv4AddressHelper() [constructor]
    cls.add_constructor([])
    ## ipv4-address-helper.h (module 'internet'): ns3::Ipv4AddressHelper::Ipv4AddressHelper(ns3::Ipv4Address network, ns3::Ipv4Mask mask, ns3::Ipv4Address base="0.0.0.1") [constructor]
    cls.add_constructor([param('ns3::Ipv4Address', 'network'), param('ns3::Ipv4Mask', 'mask'), param('ns3::Ipv4Address', 'base', default_value='"0.0.0.1"')])
    ## ipv4-address-helper.h (module 'internet'): ns3::Ipv4InterfaceContainer ns3::Ipv4AddressHelper::Assign(ns3::NetDeviceContainer const & c) [member function]
    cls.add_method('Assign',
                   'ns3::Ipv4InterfaceContainer',
                   [param('ns3::NetDeviceContainer const &', 'c')])
    ## ipv4-address-helper.h (module 'internet'): ns3::Ipv4Address ns3::Ipv4AddressHelper::NewAddress() [member function]
    cls.add_method('NewAddress',
                   'ns3::Ipv4Address',
                   [])
    ## ipv4-address-helper.h (module 'internet'): ns3::Ipv4Address ns3::Ipv4AddressHelper::NewNetwork() [member function]
    cls.add_method('NewNetwork',
                   'ns3::Ipv4Address',
                   [])
    ## ipv4-address-helper.h (module 'internet'): void ns3::Ipv4AddressHelper::SetBase(ns3::Ipv4Address network, ns3::Ipv4Mask mask, ns3::Ipv4Address base="0.0.0.1") [member function]
    cls.add_method('SetBase',
                   'void',
                   [param('ns3::Ipv4Address', 'network'), param('ns3::Ipv4Mask', 'mask'), param('ns3::Ipv4Address', 'base', default_value='"0.0.0.1"')])
    return

def register_Ns3Ipv4InterfaceAddress_methods(root_module, cls):
    cls.add_output_stream_operator()
    cls.add_binary_comparison_operator('==')
    cls.add_binary_comparison_operator('!=')
    ## ipv4-interface-address.h (module 'internet'): ns3::Ipv4InterfaceAddress::Ipv4InterfaceAddress() [constructor]
    cls.add_constructor([])
    ## ipv4-interface-address.h (module 'internet'): ns3::Ipv4InterfaceAddress::Ipv4InterfaceAddress(ns3::Ipv4Address local, ns3::Ipv4Mask mask) [constructor]
    cls.add_constructor([param('ns3::Ipv4Address', 'local'), param('ns3::Ipv4Mask', 'mask')])
    ## ipv4-interface-address.h (module 'internet'): ns3::Ipv4InterfaceAddress::Ipv4InterfaceAddress(ns3::Ipv4InterfaceAddress const & o) [constructor]
    cls.add_constructor([param('ns3::Ipv4InterfaceAddress const &', 'o')])
    ## ipv4-interface-address.h (module 'internet'): ns3::Ipv4Address ns3::Ipv4InterfaceAddress::GetBroadcast() const [member function]
    cls.add_method('GetBroadcast',
                   'ns3::Ipv4Address',
                   [],
                   is_const=True)
    ## ipv4-interface-address.h (module 'internet'): ns3::Ipv4Address ns3::Ipv4InterfaceAddress::GetLocal() const [member function]
    cls.add_method('GetLocal',
                   'ns3::Ipv4Address',
                   [],
                   is_const=True)
    ## ipv4-interface-address.h (module 'internet'): ns3::Ipv4Mask ns3::Ipv4InterfaceAddress::GetMask() const [member function]
    cls.add_method('GetMask',
                   'ns3::Ipv4Mask',
                   [],
                   is_const=True)
    ## ipv4-interface-address.h (module 'internet'): ns3::Ipv4InterfaceAddress::InterfaceAddressScope_e ns3::Ipv4InterfaceAddress::GetScope() const [member function]
    cls.add_method('GetScope',
                   'ns3::Ipv4InterfaceAddress::InterfaceAddressScope_e',
                   [],
                   is_const=True)
    ## ipv4-interface-address.h (module 'internet'): bool ns3::Ipv4InterfaceAddress::IsSecondary() const [member function]
    cls.add_method('IsSecondary',
                   'bool',
                   [],
                   is_const=True)
    ## ipv4-interface-address.h (module 'internet'): void ns3::Ipv4InterfaceAddress::SetBroadcast(ns3::Ipv4Address broadcast) [member function]
    cls.add_method('SetBroadcast',
                   'void',
                   [param('ns3::Ipv4Address', 'broadcast')])
    ## ipv4-interface-address.h (module 'internet'): void ns3::Ipv4InterfaceAddress::SetLocal(ns3::Ipv4Address local) [member function]
    cls.add_method('SetLocal',
                   'void',
                   [param('ns3::Ipv4Address', 'local')])
    ## ipv4-interface-address.h (module 'internet'): void ns3::Ipv4InterfaceAddress::SetMask(ns3::Ipv4Mask mask) [member function]
    cls.add_method('SetMask',
                   'void',
                   [param('ns3::Ipv4Mask', 'mask')])
    ## ipv4-interface-address.h (module 'internet'): void ns3::Ipv4InterfaceAddress::SetPrimary() [member function]
    cls.add_method('SetPrimary',
                   'void',
                   [])
    ## ipv4-interface-address.h (module 'internet'): void ns3::Ipv4InterfaceAddress::SetScope(ns3::Ipv4InterfaceAddress::InterfaceAddressScope_e scope) [member function]
    cls.add_method('SetScope',
                   'void',
                   [param('ns3::Ipv4InterfaceAddress::InterfaceAddressScope_e', 'scope')])
    ## ipv4-interface-address.h (module 'internet'): void ns3::Ipv4InterfaceAddress::SetSecondary() [member function]
    cls.add_method('SetSecondary',
                   'void',
                   [])
    return

def register_Ns3Ipv4InterfaceContainer_methods(root_module, cls):
    ## ipv4-interface-container.h (module 'internet'): ns3::Ipv4InterfaceContainer::Ipv4InterfaceContainer(ns3::Ipv4InterfaceContainer const & arg0) [constructor]
    cls.add_constructor([param('ns3::Ipv4InterfaceContainer const &', 'arg0')])
    ## ipv4-interface-container.h (module 'internet'): ns3::Ipv4InterfaceContainer::Ipv4InterfaceContainer() [constructor]
    cls.add_constructor([])
    ## ipv4-interface-container.h (module 'internet'): void ns3::Ipv4InterfaceContainer::Add(ns3::Ipv4InterfaceContainer const & other) [member function]
    cls.add_method('Add',
                   'void',
                   [param('ns3::Ipv4InterfaceContainer const &', 'other')])
    ## ipv4-interface-container.h (module 'internet'): void ns3::Ipv4InterfaceContainer::Add(ns3::Ptr<ns3::Ipv4> ipv4, uint32_t interface) [member function]
    cls.add_method('Add',
                   'void',
                   [param('ns3::Ptr< ns3::Ipv4 >', 'ipv4'), param('uint32_t', 'interface')])
    ## ipv4-interface-container.h (module 'internet'): void ns3::Ipv4InterfaceContainer::Add(std::pair<ns3::Ptr<ns3::Ipv4>, unsigned int> ipInterfacePair) [member function]
    cls.add_method('Add',
                   'void',
                   [param('std::pair< ns3::Ptr< ns3::Ipv4 >, unsigned int >', 'ipInterfacePair')])
    ## ipv4-interface-container.h (module 'internet'): void ns3::Ipv4InterfaceContainer::Add(std::string ipv4Name, uint32_t interface) [member function]
    cls.add_method('Add',
                   'void',
                   [param('std::string', 'ipv4Name'), param('uint32_t', 'interface')])
    ## ipv4-interface-container.h (module 'internet'): ns3::Ipv4InterfaceContainer::Iterator ns3::Ipv4InterfaceContainer::Begin() const [member function]
    cls.add_method('Begin',
                   'ns3::Ipv4InterfaceContainer::Iterator',
                   [],
                   is_const=True)
    ## ipv4-interface-container.h (module 'internet'): ns3::Ipv4InterfaceContainer::Iterator ns3::Ipv4InterfaceContainer::End() const [member function]
    cls.add_method('End',
                   'ns3::Ipv4InterfaceContainer::Iterator',
                   [],
                   is_const=True)
    ## ipv4-interface-container.h (module 'internet'): std::pair<ns3::Ptr<ns3::Ipv4>, unsigned int> ns3::Ipv4InterfaceContainer::Get(uint32_t i) const [member function]
    cls.add_method('Get',
                   'std::pair< ns3::Ptr< ns3::Ipv4 >, unsigned int >',
                   [param('uint32_t', 'i')],
                   is_const=True)
    ## ipv4-interface-container.h (module 'internet'): ns3::Ipv4Address ns3::Ipv4InterfaceContainer::GetAddress(uint32_t i, uint32_t j=0) const [member function]
    cls.add_method('GetAddress',
                   'ns3::Ipv4Address',
                   [param('uint32_t', 'i'), param('uint32_t', 'j', default_value='0')],
                   is_const=True)
    ## ipv4-interface-container.h (module 'internet'): uint32_t ns3::Ipv4InterfaceContainer::GetN() const [member function]
    cls.add_method('GetN',
                   'uint32_t',
                   [],
                   is_const=True)
    ## ipv4-interface-container.h (module 'internet'): void ns3::Ipv4InterfaceContainer::SetMetric(uint32_t i, uint16_t metric) [member function]
    cls.add_method('SetMetric',
                   'void',
                   [param('uint32_t', 'i'), param('uint16_t', 'metric')])
    return

def register_Ns3Ipv4Mask_methods(root_module, cls):
    cls.add_output_stream_operator()
    cls.add_binary_comparison_operator('==')
    cls.add_binary_comparison_operator('!=')
    ## ipv4-address.h (module 'network'): ns3::Ipv4Mask::Ipv4Mask(ns3::Ipv4Mask const & arg0) [constructor]
    cls.add_constructor([param('ns3::Ipv4Mask const &', 'arg0')])
    ## ipv4-address.h (module 'network'): ns3::Ipv4Mask::Ipv4Mask() [constructor]
    cls.add_constructor([])
    ## ipv4-address.h (module 'network'): ns3::Ipv4Mask::Ipv4Mask(uint32_t mask) [constructor]
    cls.add_constructor([param('uint32_t', 'mask')])
    ## ipv4-address.h (module 'network'): ns3::Ipv4Mask::Ipv4Mask(char const * mask) [constructor]
    cls.add_constructor([param('char const *', 'mask')])
    ## ipv4-address.h (module 'network'): uint32_t ns3::Ipv4Mask::Get() const [member function]
    cls.add_method('Get',
                   'uint32_t',
                   [],
                   is_const=True)
    ## ipv4-address.h (module 'network'): uint32_t ns3::Ipv4Mask::GetInverse() const [member function]
    cls.add_method('GetInverse',
                   'uint32_t',
                   [],
                   is_const=True)
    ## ipv4-address.h (module 'network'): static ns3::Ipv4Mask ns3::Ipv4Mask::GetLoopback() [member function]
    cls.add_method('GetLoopback',
                   'ns3::Ipv4Mask',
                   [],
                   is_static=True)
    ## ipv4-address.h (module 'network'): static ns3::Ipv4Mask ns3::Ipv4Mask::GetOnes() [member function]
    cls.add_method('GetOnes',
                   'ns3::Ipv4Mask',
                   [],
                   is_static=True)
    ## ipv4-address.h (module 'network'): uint16_t ns3::Ipv4Mask::GetPrefixLength() const [member function]
    cls.add_method('GetPrefixLength',
                   'uint16_t',
                   [],
                   is_const=True)
    ## ipv4-address.h (module 'network'): static ns3::Ipv4Mask ns3::Ipv4Mask::GetZero() [member function]
    cls.add_method('GetZero',
                   'ns3::Ipv4Mask',
                   [],
                   is_static=True)
    ## ipv4-address.h (module 'network'): bool ns3::Ipv4Mask::IsEqual(ns3::Ipv4Mask other) const [member function]
    cls.add_method('IsEqual',
                   'bool',
                   [param('ns3::Ipv4Mask', 'other')],
                   is_const=True)
    ## ipv4-address.h (module 'network'): bool ns3::Ipv4Mask::IsMatch(ns3::Ipv4Address a, ns3::Ipv4Address b) const [member function]
    cls.add_method('IsMatch',
                   'bool',
                   [param('ns3::Ipv4Address', 'a'), param('ns3::Ipv4Address', 'b')],
                   is_const=True)
    ## ipv4-address.h (module 'network'): void ns3::Ipv4Mask::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True)
    ## ipv4-address.h (module 'network'): void ns3::Ipv4Mask::Set(uint32_t mask) [member function]
    cls.add_method('Set',
                   'void',
                   [param('uint32_t', 'mask')])
    return

def register_Ns3Ipv6Address_methods(root_module, cls):
    cls.add_output_stream_operator()
    cls.add_binary_comparison_operator('==')
    cls.add_binary_comparison_operator('!=')
    cls.add_binary_comparison_operator('<')
    ## ipv6-address.h (module 'network'): ns3::Ipv6Address::Ipv6Address() [constructor]
    cls.add_constructor([])
    ## ipv6-address.h (module 'network'): ns3::Ipv6Address::Ipv6Address(char const * address) [constructor]
    cls.add_constructor([param('char const *', 'address')])
    ## ipv6-address.h (module 'network'): ns3::Ipv6Address::Ipv6Address(uint8_t * address) [constructor]
    cls.add_constructor([param('uint8_t *', 'address')])
    ## ipv6-address.h (module 'network'): ns3::Ipv6Address::Ipv6Address(ns3::Ipv6Address const & addr) [constructor]
    cls.add_constructor([param('ns3::Ipv6Address const &', 'addr')])
    ## ipv6-address.h (module 'network'): ns3::Ipv6Address::Ipv6Address(ns3::Ipv6Address const * addr) [constructor]
    cls.add_constructor([param('ns3::Ipv6Address const *', 'addr')])
    ## ipv6-address.h (module 'network'): ns3::Ipv6Address ns3::Ipv6Address::CombinePrefix(ns3::Ipv6Prefix const & prefix) [member function]
    cls.add_method('CombinePrefix',
                   'ns3::Ipv6Address',
                   [param('ns3::Ipv6Prefix const &', 'prefix')])
    ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::ConvertFrom(ns3::Address const & address) [member function]
    cls.add_method('ConvertFrom',
                   'ns3::Ipv6Address',
                   [param('ns3::Address const &', 'address')],
                   is_static=True)
    ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::Deserialize(uint8_t const * buf) [member function]
    cls.add_method('Deserialize',
                   'ns3::Ipv6Address',
                   [param('uint8_t const *', 'buf')],
                   is_static=True)
    ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::GetAllHostsMulticast() [member function]
    cls.add_method('GetAllHostsMulticast',
                   'ns3::Ipv6Address',
                   [],
                   is_static=True)
    ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::GetAllNodesMulticast() [member function]
    cls.add_method('GetAllNodesMulticast',
                   'ns3::Ipv6Address',
                   [],
                   is_static=True)
    ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::GetAllRoutersMulticast() [member function]
    cls.add_method('GetAllRoutersMulticast',
                   'ns3::Ipv6Address',
                   [],
                   is_static=True)
    ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::GetAny() [member function]
    cls.add_method('GetAny',
                   'ns3::Ipv6Address',
                   [],
                   is_static=True)
    ## ipv6-address.h (module 'network'): void ns3::Ipv6Address::GetBytes(uint8_t * buf) const [member function]
    cls.add_method('GetBytes',
                   'void',
                   [param('uint8_t *', 'buf')],
                   is_const=True)
    ## ipv6-address.h (module 'network'): ns3::Ipv4Address ns3::Ipv6Address::GetIpv4MappedAddress() const [member function]
    cls.add_method('GetIpv4MappedAddress',
                   'ns3::Ipv4Address',
                   [],
                   is_const=True)
    ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::GetLoopback() [member function]
    cls.add_method('GetLoopback',
                   'ns3::Ipv6Address',
                   [],
                   is_static=True)
    ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::GetOnes() [member function]
    cls.add_method('GetOnes',
                   'ns3::Ipv6Address',
                   [],
                   is_static=True)
    ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::GetZero() [member function]
    cls.add_method('GetZero',
                   'ns3::Ipv6Address',
                   [],
                   is_static=True)
    ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::IsAllHostsMulticast() const [member function]
    cls.add_method('IsAllHostsMulticast',
                   'bool',
                   [],
                   deprecated=True, is_const=True)
    ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::IsAllNodesMulticast() const [member function]
    cls.add_method('IsAllNodesMulticast',
                   'bool',
                   [],
                   is_const=True)
    ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::IsAllRoutersMulticast() const [member function]
    cls.add_method('IsAllRoutersMulticast',
                   'bool',
                   [],
                   is_const=True)
    ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::IsAny() const [member function]
    cls.add_method('IsAny',
                   'bool',
                   [],
                   is_const=True)
    ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::IsDocumentation() const [member function]
    cls.add_method('IsDocumentation',
                   'bool',
                   [],
                   is_const=True)
    ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::IsEqual(ns3::Ipv6Address const & other) const [member function]
    cls.add_method('IsEqual',
                   'bool',
                   [param('ns3::Ipv6Address const &', 'other')],
                   is_const=True)
    ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::IsIpv4MappedAddress() const [member function]
    cls.add_method('IsIpv4MappedAddress',
                   'bool',
                   [],
                   is_const=True)
    ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::IsLinkLocal() const [member function]
    cls.add_method('IsLinkLocal',
                   'bool',
                   [],
                   is_const=True)
    ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::IsLinkLocalMulticast() const [member function]
    cls.add_method('IsLinkLocalMulticast',
                   'bool',
                   [],
                   is_const=True)
    ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::IsLocalhost() const [member function]
    cls.add_method('IsLocalhost',
                   'bool',
                   [],
                   is_const=True)
    ## ipv6-address.h (module 'network'): static bool ns3::Ipv6Address::IsMatchingType(ns3::Address const & address) [member function]
    cls.add_method('IsMatchingType',
                   'bool',
                   [param('ns3::Address const &', 'address')],
                   is_static=True)
    ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::IsMulticast() const [member function]
    cls.add_method('IsMulticast',
                   'bool',
                   [],
                   is_const=True)
    ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::IsSolicitedMulticast() const [member function]
    cls.add_method('IsSolicitedMulticast',
                   'bool',
                   [],
                   is_const=True)
    ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredAddress(ns3::Mac16Address addr, ns3::Ipv6Address prefix) [member function]
    cls.add_method('MakeAutoconfiguredAddress',
                   'ns3::Ipv6Address',
                   [param('ns3::Mac16Address', 'addr'), param('ns3::Ipv6Address', 'prefix')],
                   is_static=True)
    ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredAddress(ns3::Mac48Address addr, ns3::Ipv6Address prefix) [member function]
    cls.add_method('MakeAutoconfiguredAddress',
                   'ns3::Ipv6Address',
                   [param('ns3::Mac48Address', 'addr'), param('ns3::Ipv6Address', 'prefix')],
                   is_static=True)
    ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredAddress(ns3::Mac64Address addr, ns3::Ipv6Address prefix) [member function]
    cls.add_method('MakeAutoconfiguredAddress',
                   'ns3::Ipv6Address',
                   [param('ns3::Mac64Address', 'addr'), param('ns3::Ipv6Address', 'prefix')],
                   is_static=True)
    ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredAddress(ns3::Mac8Address addr, ns3::Ipv6Address prefix) [member function]
    cls.add_method('MakeAutoconfiguredAddress',
                   'ns3::Ipv6Address',
                   [param('ns3::Mac8Address', 'addr'), param('ns3::Ipv6Address', 'prefix')],
                   is_static=True)
    ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredLinkLocalAddress(ns3::Mac16Address mac) [member function]
    cls.add_method('MakeAutoconfiguredLinkLocalAddress',
                   'ns3::Ipv6Address',
                   [param('ns3::Mac16Address', 'mac')],
                   is_static=True)
    ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredLinkLocalAddress(ns3::Mac48Address mac) [member function]
    cls.add_method('MakeAutoconfiguredLinkLocalAddress',
                   'ns3::Ipv6Address',
                   [param('ns3::Mac48Address', 'mac')],
                   is_static=True)
    ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredLinkLocalAddress(ns3::Mac64Address mac) [member function]
    cls.add_method('MakeAutoconfiguredLinkLocalAddress',
                   'ns3::Ipv6Address',
                   [param('ns3::Mac64Address', 'mac')],
                   is_static=True)
    ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredLinkLocalAddress(ns3::Mac8Address mac) [member function]
    cls.add_method('MakeAutoconfiguredLinkLocalAddress',
                   'ns3::Ipv6Address',
                   [param('ns3::Mac8Address', 'mac')],
                   is_static=True)
    ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeIpv4MappedAddress(ns3::Ipv4Address addr) [member function]
    cls.add_method('MakeIpv4MappedAddress',
                   'ns3::Ipv6Address',
                   [param('ns3::Ipv4Address', 'addr')],
                   is_static=True)
    ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeSolicitedAddress(ns3::Ipv6Address addr) [member function]
    cls.add_method('MakeSolicitedAddress',
                   'ns3::Ipv6Address',
                   [param('ns3::Ipv6Address', 'addr')],
                   is_static=True)
    ## ipv6-address.h (module 'network'): void ns3::Ipv6Address::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True)
    ## ipv6-address.h (module 'network'): void ns3::Ipv6Address::Serialize(uint8_t * buf) const [member function]
    cls.add_method('Serialize',
                   'void',
                   [param('uint8_t *', 'buf')],
                   is_const=True)
    ## ipv6-address.h (module 'network'): void ns3::Ipv6Address::Set(char const * address) [member function]
    cls.add_method('Set',
                   'void',
                   [param('char const *', 'address')])
    ## ipv6-address.h (module 'network'): void ns3::Ipv6Address::Set(uint8_t * address) [member function]
    cls.add_method('Set',
                   'void',
                   [param('uint8_t *', 'address')])
    return

def register_Ns3Ipv6AddressHelper_methods(root_module, cls):
    ## ipv6-address-helper.h (module 'internet'): ns3::Ipv6AddressHelper::Ipv6AddressHelper(ns3::Ipv6AddressHelper const & arg0) [constructor]
    cls.add_constructor([param('ns3::Ipv6AddressHelper const &', 'arg0')])
    ## ipv6-address-helper.h (module 'internet'): ns3::Ipv6AddressHelper::Ipv6AddressHelper() [constructor]
    cls.add_constructor([])
    ## ipv6-address-helper.h (module 'internet'): ns3::Ipv6AddressHelper::Ipv6AddressHelper(ns3::Ipv6Address network, ns3::Ipv6Prefix prefix, ns3::Ipv6Address base=ns3::Ipv6Address("::1")) [constructor]
    cls.add_constructor([param('ns3::Ipv6Address', 'network'), param('ns3::Ipv6Prefix', 'prefix'), param('ns3::Ipv6Address', 'base', default_value='ns3::Ipv6Address("::1")')])
    ## ipv6-address-helper.h (module 'internet'): ns3::Ipv6InterfaceContainer ns3::Ipv6AddressHelper::Assign(ns3::NetDeviceContainer const & c) [member function]
    cls.add_method('Assign',
                   'ns3::Ipv6InterfaceContainer',
                   [param('ns3::NetDeviceContainer const &', 'c')])
    ## ipv6-address-helper.h (module 'internet'): ns3::Ipv6InterfaceContainer ns3::Ipv6AddressHelper::Assign(ns3::NetDeviceContainer const & c, std::vector<bool, std::allocator<bool> > withConfiguration) [member function]
    cls.add_method('Assign',
                   'ns3::Ipv6InterfaceContainer',
                   [param('ns3::NetDeviceContainer const &', 'c'), param('std::vector< bool >', 'withConfiguration')])
    ## ipv6-address-helper.h (module 'internet'): ns3::Ipv6InterfaceContainer ns3::Ipv6AddressHelper::AssignWithoutAddress(ns3::NetDeviceContainer const & c) [member function]
    cls.add_method('AssignWithoutAddress',
                   'ns3::Ipv6InterfaceContainer',
                   [param('ns3::NetDeviceContainer const &', 'c')])
    ## ipv6-address-helper.h (module 'internet'): ns3::Ipv6Address ns3::Ipv6AddressHelper::NewAddress(ns3::Address addr) [member function]
    cls.add_method('NewAddress',
                   'ns3::Ipv6Address',
                   [param('ns3::Address', 'addr')])
    ## ipv6-address-helper.h (module 'internet'): ns3::Ipv6Address ns3::Ipv6AddressHelper::NewAddress() [member function]
    cls.add_method('NewAddress',
                   'ns3::Ipv6Address',
                   [])
    ## ipv6-address-helper.h (module 'internet'): void ns3::Ipv6AddressHelper::NewNetwork() [member function]
    cls.add_method('NewNetwork',
                   'void',
                   [])
    ## ipv6-address-helper.h (module 'internet'): void ns3::Ipv6AddressHelper::SetBase(ns3::Ipv6Address network, ns3::Ipv6Prefix prefix, ns3::Ipv6Address base=ns3::Ipv6Address("::1")) [member function]
    cls.add_method('SetBase',
                   'void',
                   [param('ns3::Ipv6Address', 'network'), param('ns3::Ipv6Prefix', 'prefix'), param('ns3::Ipv6Address', 'base', default_value='ns3::Ipv6Address("::1")')])
    return

def register_Ns3Ipv6InterfaceAddress_methods(root_module, cls):
    cls.add_output_stream_operator()
    cls.add_binary_comparison_operator('==')
    cls.add_binary_comparison_operator('!=')
    ## ipv6-interface-address.h (module 'internet'): ns3::Ipv6InterfaceAddress::Ipv6InterfaceAddress() [constructor]
    cls.add_constructor([])
    ## ipv6-interface-address.h (module 'internet'): ns3::Ipv6InterfaceAddress::Ipv6InterfaceAddress(ns3::Ipv6Address address) [constructor]
    cls.add_constructor([param('ns3::Ipv6Address', 'address')])
    ## ipv6-interface-address.h (module 'internet'): ns3::Ipv6InterfaceAddress::Ipv6InterfaceAddress(ns3::Ipv6Address address, ns3::Ipv6Prefix prefix) [constructor]
    cls.add_constructor([param('ns3::Ipv6Address', 'address'), param('ns3::Ipv6Prefix', 'prefix')])
    ## ipv6-interface-address.h (module 'internet'): ns3::Ipv6InterfaceAddress::Ipv6InterfaceAddress(ns3::Ipv6InterfaceAddress const & o) [constructor]
    cls.add_constructor([param('ns3::Ipv6InterfaceAddress const &', 'o')])
    ## ipv6-interface-address.h (module 'internet'): ns3::Ipv6Address ns3::Ipv6InterfaceAddress::GetAddress() const [member function]
    cls.add_method('GetAddress',
                   'ns3::Ipv6Address',
                   [],
                   is_const=True)
    ## ipv6-interface-address.h (module 'internet'): uint32_t ns3::Ipv6InterfaceAddress::GetNsDadUid() const [member function]
    cls.add_method('GetNsDadUid',
                   'uint32_t',
                   [],
                   is_const=True)
    ## ipv6-interface-address.h (module 'internet'): ns3::Ipv6Prefix ns3::Ipv6InterfaceAddress::GetPrefix() const [member function]
    cls.add_method('GetPrefix',
                   'ns3::Ipv6Prefix',
                   [],
                   is_const=True)
    ## ipv6-interface-address.h (module 'internet'): ns3::Ipv6InterfaceAddress::Scope_e ns3::Ipv6InterfaceAddress::GetScope() const [member function]
    cls.add_method('GetScope',
                   'ns3::Ipv6InterfaceAddress::Scope_e',
                   [],
                   is_const=True)
    ## ipv6-interface-address.h (module 'internet'): ns3::Ipv6InterfaceAddress::State_e ns3::Ipv6InterfaceAddress::GetState() const [member function]
    cls.add_method('GetState',
                   'ns3::Ipv6InterfaceAddress::State_e',
                   [],
                   is_const=True)
    ## ipv6-interface-address.h (module 'internet'): bool ns3::Ipv6InterfaceAddress::IsInSameSubnet(ns3::Ipv6Address b) const [member function]
    cls.add_method('IsInSameSubnet',
                   'bool',
                   [param('ns3::Ipv6Address', 'b')],
                   is_const=True)
    ## ipv6-interface-address.h (module 'internet'): void ns3::Ipv6InterfaceAddress::SetAddress(ns3::Ipv6Address address) [member function]
    cls.add_method('SetAddress',
                   'void',
                   [param('ns3::Ipv6Address', 'address')])
    ## ipv6-interface-address.h (module 'internet'): void ns3::Ipv6InterfaceAddress::SetNsDadUid(uint32_t uid) [member function]
    cls.add_method('SetNsDadUid',
                   'void',
                   [param('uint32_t', 'uid')])
    ## ipv6-interface-address.h (module 'internet'): void ns3::Ipv6InterfaceAddress::SetScope(ns3::Ipv6InterfaceAddress::Scope_e scope) [member function]
    cls.add_method('SetScope',
                   'void',
                   [param('ns3::Ipv6InterfaceAddress::Scope_e', 'scope')])
    ## ipv6-interface-address.h (module 'internet'): void ns3::Ipv6InterfaceAddress::SetState(ns3::Ipv6InterfaceAddress::State_e state) [member function]
    cls.add_method('SetState',
                   'void',
                   [param('ns3::Ipv6InterfaceAddress::State_e', 'state')])
    return

def register_Ns3Ipv6InterfaceContainer_methods(root_module, cls):
    ## ipv6-interface-container.h (module 'internet'): ns3::Ipv6InterfaceContainer::Ipv6InterfaceContainer(ns3::Ipv6InterfaceContainer const & arg0) [constructor]
    cls.add_constructor([param('ns3::Ipv6InterfaceContainer const &', 'arg0')])
    ## ipv6-interface-container.h (module 'internet'): ns3::Ipv6InterfaceContainer::Ipv6InterfaceContainer() [constructor]
    cls.add_constructor([])
    ## ipv6-interface-container.h (module 'internet'): void ns3::Ipv6InterfaceContainer::Add(ns3::Ptr<ns3::Ipv6> ipv6, uint32_t interface) [member function]
    cls.add_method('Add',
                   'void',
                   [param('ns3::Ptr< ns3::Ipv6 >', 'ipv6'), param('uint32_t', 'interface')])
    ## ipv6-interface-container.h (module 'internet'): void ns3::Ipv6InterfaceContainer::Add(ns3::Ipv6InterfaceContainer const & c) [member function]
    cls.add_method('Add',
                   'void',
                   [param('ns3::Ipv6InterfaceContainer const &', 'c')])
    ## ipv6-interface-container.h (module 'internet'): void ns3::Ipv6InterfaceContainer::Add(std::string ipv6Name, uint32_t interface) [member function]
    cls.add_method('Add',
                   'void',
                   [param('std::string', 'ipv6Name'), param('uint32_t', 'interface')])
    ## ipv6-interface-container.h (module 'internet'): ns3::Ipv6InterfaceContainer::Iterator ns3::Ipv6InterfaceContainer::Begin() const [member function]
    cls.add_method('Begin',
                   'ns3::Ipv6InterfaceContainer::Iterator',
                   [],
                   is_const=True)
    ## ipv6-interface-container.h (module 'internet'): ns3::Ipv6InterfaceContainer::Iterator ns3::Ipv6InterfaceContainer::End() const [member function]
    cls.add_method('End',
                   'ns3::Ipv6InterfaceContainer::Iterator',
                   [],
                   is_const=True)
    ## ipv6-interface-container.h (module 'internet'): ns3::Ipv6Address ns3::Ipv6InterfaceContainer::GetAddress(uint32_t i, uint32_t j) const [member function]
    cls.add_method('GetAddress',
                   'ns3::Ipv6Address',
                   [param('uint32_t', 'i'), param('uint32_t', 'j')],
                   is_const=True)
    ## ipv6-interface-container.h (module 'internet'): uint32_t ns3::Ipv6InterfaceContainer::GetInterfaceIndex(uint32_t i) const [member function]
    cls.add_method('GetInterfaceIndex',
                   'uint32_t',
                   [param('uint32_t', 'i')],
                   is_const=True)
    ## ipv6-interface-container.h (module 'internet'): ns3::Ipv6Address ns3::Ipv6InterfaceContainer::GetLinkLocalAddress(uint32_t i) [member function]
    cls.add_method('GetLinkLocalAddress',
                   'ns3::Ipv6Address',
                   [param('uint32_t', 'i')])
    ## ipv6-interface-container.h (module 'internet'): ns3::Ipv6Address ns3::Ipv6InterfaceContainer::GetLinkLocalAddress(ns3::Ipv6Address address) [member function]
    cls.add_method('GetLinkLocalAddress',
                   'ns3::Ipv6Address',
                   [param('ns3::Ipv6Address', 'address')])
    ## ipv6-interface-container.h (module 'internet'): uint32_t ns3::Ipv6InterfaceContainer::GetN() const [member function]
    cls.add_method('GetN',
                   'uint32_t',
                   [],
                   is_const=True)
    ## ipv6-interface-container.h (module 'internet'): void ns3::Ipv6InterfaceContainer::SetDefaultRoute(uint32_t i, uint32_t router) [member function]
    cls.add_method('SetDefaultRoute',
                   'void',
                   [param('uint32_t', 'i'), param('uint32_t', 'router')])
    ## ipv6-interface-container.h (module 'internet'): void ns3::Ipv6InterfaceContainer::SetDefaultRoute(uint32_t i, ns3::Ipv6Address routerAddr) [member function]
    cls.add_method('SetDefaultRoute',
                   'void',
                   [param('uint32_t', 'i'), param('ns3::Ipv6Address', 'routerAddr')])
    ## ipv6-interface-container.h (module 'internet'): void ns3::Ipv6InterfaceContainer::SetDefaultRouteInAllNodes(uint32_t router) [member function]
    cls.add_method('SetDefaultRouteInAllNodes',
                   'void',
                   [param('uint32_t', 'router')])
    ## ipv6-interface-container.h (module 'internet'): void ns3::Ipv6InterfaceContainer::SetDefaultRouteInAllNodes(ns3::Ipv6Address routerAddr) [member function]
    cls.add_method('SetDefaultRouteInAllNodes',
                   'void',
                   [param('ns3::Ipv6Address', 'routerAddr')])
    ## ipv6-interface-container.h (module 'internet'): void ns3::Ipv6InterfaceContainer::SetForwarding(uint32_t i, bool state) [member function]
    cls.add_method('SetForwarding',
                   'void',
                   [param('uint32_t', 'i'), param('bool', 'state')])
    return

def register_Ns3Ipv6Prefix_methods(root_module, cls):
    cls.add_output_stream_operator()
    cls.add_binary_comparison_operator('==')
    cls.add_binary_comparison_operator('!=')
    ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix::Ipv6Prefix() [constructor]
    cls.add_constructor([])
    ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix::Ipv6Prefix(uint8_t * prefix) [constructor]
    cls.add_constructor([param('uint8_t *', 'prefix')])
    ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix::Ipv6Prefix(char const * prefix) [constructor]
    cls.add_constructor([param('char const *', 'prefix')])
    ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix::Ipv6Prefix(uint8_t prefix) [constructor]
    cls.add_constructor([param('uint8_t', 'prefix')])
    ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix::Ipv6Prefix(ns3::Ipv6Prefix const & prefix) [constructor]
    cls.add_constructor([param('ns3::Ipv6Prefix const &', 'prefix')])
    ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix::Ipv6Prefix(ns3::Ipv6Prefix const * prefix) [constructor]
    cls.add_constructor([param('ns3::Ipv6Prefix const *', 'prefix')])
    ## ipv6-address.h (module 'network'): void ns3::Ipv6Prefix::GetBytes(uint8_t * buf) const [member function]
    cls.add_method('GetBytes',
                   'void',
                   [param('uint8_t *', 'buf')],
                   is_const=True)
    ## ipv6-address.h (module 'network'): static ns3::Ipv6Prefix ns3::Ipv6Prefix::GetLoopback() [member function]
    cls.add_method('GetLoopback',
                   'ns3::Ipv6Prefix',
                   [],
                   is_static=True)
    ## ipv6-address.h (module 'network'): static ns3::Ipv6Prefix ns3::Ipv6Prefix::GetOnes() [member function]
    cls.add_method('GetOnes',
                   'ns3::Ipv6Prefix',
                   [],
                   is_static=True)
    ## ipv6-address.h (module 'network'): uint8_t ns3::Ipv6Prefix::GetPrefixLength() const [member function]
    cls.add_method('GetPrefixLength',
                   'uint8_t',
                   [],
                   is_const=True)
    ## ipv6-address.h (module 'network'): static ns3::Ipv6Prefix ns3::Ipv6Prefix::GetZero() [member function]
    cls.add_method('GetZero',
                   'ns3::Ipv6Prefix',
                   [],
                   is_static=True)
    ## ipv6-address.h (module 'network'): bool ns3::Ipv6Prefix::IsEqual(ns3::Ipv6Prefix const & other) const [member function]
    cls.add_method('IsEqual',
                   'bool',
                   [param('ns3::Ipv6Prefix const &', 'other')],
                   is_const=True)
    ## ipv6-address.h (module 'network'): bool ns3::Ipv6Prefix::IsMatch(ns3::Ipv6Address a, ns3::Ipv6Address b) const [member function]
    cls.add_method('IsMatch',
                   'bool',
                   [param('ns3::Ipv6Address', 'a'), param('ns3::Ipv6Address', 'b')],
                   is_const=True)
    ## ipv6-address.h (module 'network'): void ns3::Ipv6Prefix::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True)
    return

def register_Ns3LogComponent_methods(root_module, cls):
    ## log.h (module 'core'): ns3::LogComponent::LogComponent(ns3::LogComponent const & arg0) [constructor]
    cls.add_constructor([param('ns3::LogComponent const &', 'arg0')])
    ## log.h (module 'core'): ns3::LogComponent::LogComponent(std::string const & name, std::string const & file, ns3::LogLevel const mask=::ns3::LogLevel::LOG_NONE) [constructor]
    cls.add_constructor([param('std::string const &', 'name'), param('std::string const &', 'file'), param('ns3::LogLevel const', 'mask', default_value='::ns3::LogLevel::LOG_NONE')])
    ## log.h (module 'core'): void ns3::LogComponent::Disable(ns3::LogLevel const level) [member function]
    cls.add_method('Disable',
                   'void',
                   [param('ns3::LogLevel const', 'level')])
    ## log.h (module 'core'): void ns3::LogComponent::Enable(ns3::LogLevel const level) [member function]
    cls.add_method('Enable',
                   'void',
                   [param('ns3::LogLevel const', 'level')])
    ## log.h (module 'core'): std::string ns3::LogComponent::File() const [member function]
    cls.add_method('File',
                   'std::string',
                   [],
                   is_const=True)
    ## log.h (module 'core'): static ns3::LogComponent::ComponentList * ns3::LogComponent::GetComponentList() [member function]
    cls.add_method('GetComponentList',
                   'ns3::LogComponent::ComponentList *',
                   [],
                   is_static=True)
    ## log.h (module 'core'): static std::string ns3::LogComponent::GetLevelLabel(ns3::LogLevel const level) [member function]
    cls.add_method('GetLevelLabel',
                   'std::string',
                   [param('ns3::LogLevel const', 'level')],
                   is_static=True)
    ## log.h (module 'core'): bool ns3::LogComponent::IsEnabled(ns3::LogLevel const level) const [member function]
    cls.add_method('IsEnabled',
                   'bool',
                   [param('ns3::LogLevel const', 'level')],
                   is_const=True)
    ## log.h (module 'core'): bool ns3::LogComponent::IsNoneEnabled() const [member function]
    cls.add_method('IsNoneEnabled',
                   'bool',
                   [],
                   is_const=True)
    ## log.h (module 'core'): char const * ns3::LogComponent::Name() const [member function]
    cls.add_method('Name',
                   'char const *',
                   [],
                   is_const=True)
    ## log.h (module 'core'): void ns3::LogComponent::SetMask(ns3::LogLevel const level) [member function]
    cls.add_method('SetMask',
                   'void',
                   [param('ns3::LogLevel const', 'level')])
    return

def register_Ns3LogicalChannelConfigListElement_s_methods(root_module, cls):
    ## ff-mac-common.h (module 'lte'): ns3::LogicalChannelConfigListElement_s::LogicalChannelConfigListElement_s() [constructor]
    cls.add_constructor([])
    ## ff-mac-common.h (module 'lte'): ns3::LogicalChannelConfigListElement_s::LogicalChannelConfigListElement_s(ns3::LogicalChannelConfigListElement_s const & arg0) [constructor]
    cls.add_constructor([param('ns3::LogicalChannelConfigListElement_s const &', 'arg0')])
    ## ff-mac-common.h (module 'lte'): ns3::LogicalChannelConfigListElement_s::m_direction [variable]
    cls.add_instance_attribute('m_direction', 'ns3::LogicalChannelConfigListElement_s::Direction_e', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::LogicalChannelConfigListElement_s::m_eRabGuaranteedBitrateDl [variable]
    cls.add_instance_attribute('m_eRabGuaranteedBitrateDl', 'uint64_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::LogicalChannelConfigListElement_s::m_eRabGuaranteedBitrateUl [variable]
    cls.add_instance_attribute('m_eRabGuaranteedBitrateUl', 'uint64_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::LogicalChannelConfigListElement_s::m_eRabMaximulBitrateDl [variable]
    cls.add_instance_attribute('m_eRabMaximulBitrateDl', 'uint64_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::LogicalChannelConfigListElement_s::m_eRabMaximulBitrateUl [variable]
    cls.add_instance_attribute('m_eRabMaximulBitrateUl', 'uint64_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::LogicalChannelConfigListElement_s::m_logicalChannelGroup [variable]
    cls.add_instance_attribute('m_logicalChannelGroup', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::LogicalChannelConfigListElement_s::m_logicalChannelIdentity [variable]
    cls.add_instance_attribute('m_logicalChannelIdentity', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::LogicalChannelConfigListElement_s::m_qci [variable]
    cls.add_instance_attribute('m_qci', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::LogicalChannelConfigListElement_s::m_qosBearerType [variable]
    cls.add_instance_attribute('m_qosBearerType', 'ns3::LogicalChannelConfigListElement_s::QosBearerType_e', is_const=False)
    return

def register_Ns3LteAnrSapProvider_methods(root_module, cls):
    ## lte-anr-sap.h (module 'lte'): ns3::LteAnrSapProvider::LteAnrSapProvider() [constructor]
    cls.add_constructor([])
    ## lte-anr-sap.h (module 'lte'): ns3::LteAnrSapProvider::LteAnrSapProvider(ns3::LteAnrSapProvider const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteAnrSapProvider const &', 'arg0')])
    ## lte-anr-sap.h (module 'lte'): void ns3::LteAnrSapProvider::AddNeighbourRelation(uint16_t cellId) [member function]
    cls.add_method('AddNeighbourRelation',
                   'void',
                   [param('uint16_t', 'cellId')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-anr-sap.h (module 'lte'): bool ns3::LteAnrSapProvider::GetNoHo(uint16_t cellId) const [member function]
    cls.add_method('GetNoHo',
                   'bool',
                   [param('uint16_t', 'cellId')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## lte-anr-sap.h (module 'lte'): bool ns3::LteAnrSapProvider::GetNoRemove(uint16_t cellId) const [member function]
    cls.add_method('GetNoRemove',
                   'bool',
                   [param('uint16_t', 'cellId')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## lte-anr-sap.h (module 'lte'): bool ns3::LteAnrSapProvider::GetNoX2(uint16_t cellId) const [member function]
    cls.add_method('GetNoX2',
                   'bool',
                   [param('uint16_t', 'cellId')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## lte-anr-sap.h (module 'lte'): void ns3::LteAnrSapProvider::ReportUeMeas(ns3::LteRrcSap::MeasResults measResults) [member function]
    cls.add_method('ReportUeMeas',
                   'void',
                   [param('ns3::LteRrcSap::MeasResults', 'measResults')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3LteAnrSapUser_methods(root_module, cls):
    ## lte-anr-sap.h (module 'lte'): ns3::LteAnrSapUser::LteAnrSapUser() [constructor]
    cls.add_constructor([])
    ## lte-anr-sap.h (module 'lte'): ns3::LteAnrSapUser::LteAnrSapUser(ns3::LteAnrSapUser const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteAnrSapUser const &', 'arg0')])
    ## lte-anr-sap.h (module 'lte'): uint8_t ns3::LteAnrSapUser::AddUeMeasReportConfigForAnr(ns3::LteRrcSap::ReportConfigEutra reportConfig) [member function]
    cls.add_method('AddUeMeasReportConfigForAnr',
                   'uint8_t',
                   [param('ns3::LteRrcSap::ReportConfigEutra', 'reportConfig')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3LteAsSapProvider_methods(root_module, cls):
    ## lte-as-sap.h (module 'lte'): ns3::LteAsSapProvider::LteAsSapProvider() [constructor]
    cls.add_constructor([])
    ## lte-as-sap.h (module 'lte'): ns3::LteAsSapProvider::LteAsSapProvider(ns3::LteAsSapProvider const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteAsSapProvider const &', 'arg0')])
    ## lte-as-sap.h (module 'lte'): void ns3::LteAsSapProvider::Connect() [member function]
    cls.add_method('Connect',
                   'void',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-as-sap.h (module 'lte'): void ns3::LteAsSapProvider::Disconnect() [member function]
    cls.add_method('Disconnect',
                   'void',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-as-sap.h (module 'lte'): void ns3::LteAsSapProvider::ForceCampedOnEnb(uint16_t cellId, uint32_t dlEarfcn) [member function]
    cls.add_method('ForceCampedOnEnb',
                   'void',
                   [param('uint16_t', 'cellId'), param('uint32_t', 'dlEarfcn')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-as-sap.h (module 'lte'): void ns3::LteAsSapProvider::NotifySecondaryCellConnected(uint16_t rnti, uint16_t mmWaveCellId) [member function]
    cls.add_method('NotifySecondaryCellConnected',
                   'void',
                   [param('uint16_t', 'rnti'), param('uint16_t', 'mmWaveCellId')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-as-sap.h (module 'lte'): void ns3::LteAsSapProvider::NotifySecondaryCellHandover(uint16_t oldRnti, uint16_t newRnti, uint16_t mmWaveCellId, ns3::LteRrcSap::RadioResourceConfigDedicated radioResourceConfigDedicated) [member function]
    cls.add_method('NotifySecondaryCellHandover',
                   'void',
                   [param('uint16_t', 'oldRnti'), param('uint16_t', 'newRnti'), param('uint16_t', 'mmWaveCellId'), param('ns3::LteRrcSap::RadioResourceConfigDedicated', 'radioResourceConfigDedicated')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-as-sap.h (module 'lte'): void ns3::LteAsSapProvider::SendData(ns3::Ptr<ns3::Packet> packet, uint8_t bid) [member function]
    cls.add_method('SendData',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'packet'), param('uint8_t', 'bid')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-as-sap.h (module 'lte'): void ns3::LteAsSapProvider::SetCsgWhiteList(uint32_t csgId) [member function]
    cls.add_method('SetCsgWhiteList',
                   'void',
                   [param('uint32_t', 'csgId')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-as-sap.h (module 'lte'): void ns3::LteAsSapProvider::StartCellSelection(uint32_t dlEarfcn) [member function]
    cls.add_method('StartCellSelection',
                   'void',
                   [param('uint32_t', 'dlEarfcn')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3LteAsSapUser_methods(root_module, cls):
    ## lte-as-sap.h (module 'lte'): ns3::LteAsSapUser::LteAsSapUser() [constructor]
    cls.add_constructor([])
    ## lte-as-sap.h (module 'lte'): ns3::LteAsSapUser::LteAsSapUser(ns3::LteAsSapUser const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteAsSapUser const &', 'arg0')])
    ## lte-as-sap.h (module 'lte'): void ns3::LteAsSapUser::NotifyConnectToMmWave(uint16_t mmWaveCellId) [member function]
    cls.add_method('NotifyConnectToMmWave',
                   'void',
                   [param('uint16_t', 'mmWaveCellId')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-as-sap.h (module 'lte'): void ns3::LteAsSapUser::NotifyConnectionFailed() [member function]
    cls.add_method('NotifyConnectionFailed',
                   'void',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-as-sap.h (module 'lte'): void ns3::LteAsSapUser::NotifyConnectionReleased() [member function]
    cls.add_method('NotifyConnectionReleased',
                   'void',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-as-sap.h (module 'lte'): void ns3::LteAsSapUser::NotifyConnectionSuccessful(uint16_t rnti) [member function]
    cls.add_method('NotifyConnectionSuccessful',
                   'void',
                   [param('uint16_t', 'rnti')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-as-sap.h (module 'lte'): void ns3::LteAsSapUser::NotifyHandoverSuccessful(uint16_t rnti, uint16_t mmWaveCellId) [member function]
    cls.add_method('NotifyHandoverSuccessful',
                   'void',
                   [param('uint16_t', 'rnti'), param('uint16_t', 'mmWaveCellId')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-as-sap.h (module 'lte'): void ns3::LteAsSapUser::NotifySecondaryCellHandoverStarted(uint16_t oldRnti, uint16_t newRnti, uint16_t mmWaveCellId, ns3::LteRrcSap::RadioResourceConfigDedicated radioResourceConfigDedicated) [member function]
    cls.add_method('NotifySecondaryCellHandoverStarted',
                   'void',
                   [param('uint16_t', 'oldRnti'), param('uint16_t', 'newRnti'), param('uint16_t', 'mmWaveCellId'), param('ns3::LteRrcSap::RadioResourceConfigDedicated', 'radioResourceConfigDedicated')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-as-sap.h (module 'lte'): void ns3::LteAsSapUser::RecvData(ns3::Ptr<ns3::Packet> packet) [member function]
    cls.add_method('RecvData',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'packet')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3LteCcmMacSapProvider_methods(root_module, cls):
    ## lte-ccm-mac-sap.h (module 'lte'): ns3::LteCcmMacSapProvider::LteCcmMacSapProvider() [constructor]
    cls.add_constructor([])
    ## lte-ccm-mac-sap.h (module 'lte'): ns3::LteCcmMacSapProvider::LteCcmMacSapProvider(ns3::LteCcmMacSapProvider const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteCcmMacSapProvider const &', 'arg0')])
    ## lte-ccm-mac-sap.h (module 'lte'): void ns3::LteCcmMacSapProvider::ReportMacCeToScheduler(ns3::MacCeListElement_s bsr) [member function]
    cls.add_method('ReportMacCeToScheduler',
                   'void',
                   [param('ns3::MacCeListElement_s', 'bsr')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3LteCcmRrcSapProvider_methods(root_module, cls):
    ## lte-ccm-rrc-sap.h (module 'lte'): ns3::LteCcmRrcSapProvider::LteCcmRrcSapProvider() [constructor]
    cls.add_constructor([])
    ## lte-ccm-rrc-sap.h (module 'lte'): ns3::LteCcmRrcSapProvider::LteCcmRrcSapProvider(ns3::LteCcmRrcSapProvider const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteCcmRrcSapProvider const &', 'arg0')])
    ## lte-ccm-rrc-sap.h (module 'lte'): void ns3::LteCcmRrcSapProvider::AddLc(ns3::LteEnbCmacSapProvider::LcInfo lcInfo, ns3::LteMacSapUser * msu) [member function]
    cls.add_method('AddLc',
                   'void',
                   [param('ns3::LteEnbCmacSapProvider::LcInfo', 'lcInfo'), param('ns3::LteMacSapUser *', 'msu')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ccm-rrc-sap.h (module 'lte'): void ns3::LteCcmRrcSapProvider::AddUe(uint16_t rnti, uint8_t state) [member function]
    cls.add_method('AddUe',
                   'void',
                   [param('uint16_t', 'rnti'), param('uint8_t', 'state')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ccm-rrc-sap.h (module 'lte'): ns3::LteMacSapUser * ns3::LteCcmRrcSapProvider::ConfigureSignalBearer(ns3::LteEnbCmacSapProvider::LcInfo lcInfo, ns3::LteMacSapUser * rlcMacSapUser) [member function]
    cls.add_method('ConfigureSignalBearer',
                   'ns3::LteMacSapUser *',
                   [param('ns3::LteEnbCmacSapProvider::LcInfo', 'lcInfo'), param('ns3::LteMacSapUser *', 'rlcMacSapUser')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ccm-rrc-sap.h (module 'lte'): std::vector<unsigned char, std::allocator<unsigned char> > ns3::LteCcmRrcSapProvider::ReleaseDataRadioBearer(uint16_t rnti, uint8_t lcid) [member function]
    cls.add_method('ReleaseDataRadioBearer',
                   'std::vector< unsigned char >',
                   [param('uint16_t', 'rnti'), param('uint8_t', 'lcid')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ccm-rrc-sap.h (module 'lte'): void ns3::LteCcmRrcSapProvider::RemoveUe(uint16_t rnti) [member function]
    cls.add_method('RemoveUe',
                   'void',
                   [param('uint16_t', 'rnti')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ccm-rrc-sap.h (module 'lte'): void ns3::LteCcmRrcSapProvider::ReportUeMeas(uint16_t rnti, ns3::LteRrcSap::MeasResults measResults) [member function]
    cls.add_method('ReportUeMeas',
                   'void',
                   [param('uint16_t', 'rnti'), param('ns3::LteRrcSap::MeasResults', 'measResults')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ccm-rrc-sap.h (module 'lte'): std::vector<ns3::LteCcmRrcSapProvider::LcsConfig, std::allocator<ns3::LteCcmRrcSapProvider::LcsConfig> > ns3::LteCcmRrcSapProvider::SetupDataRadioBearer(ns3::EpsBearer bearer, uint8_t bearerId, uint16_t rnti, uint8_t lcid, uint8_t lcGroup, ns3::LteMacSapUser * msu) [member function]
    cls.add_method('SetupDataRadioBearer',
                   'std::vector< ns3::LteCcmRrcSapProvider::LcsConfig >',
                   [param('ns3::EpsBearer', 'bearer'), param('uint8_t', 'bearerId'), param('uint16_t', 'rnti'), param('uint8_t', 'lcid'), param('uint8_t', 'lcGroup'), param('ns3::LteMacSapUser *', 'msu')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3LteCcmRrcSapProviderLcsConfig_methods(root_module, cls):
    ## lte-ccm-rrc-sap.h (module 'lte'): ns3::LteCcmRrcSapProvider::LcsConfig::LcsConfig() [constructor]
    cls.add_constructor([])
    ## lte-ccm-rrc-sap.h (module 'lte'): ns3::LteCcmRrcSapProvider::LcsConfig::LcsConfig(ns3::LteCcmRrcSapProvider::LcsConfig const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteCcmRrcSapProvider::LcsConfig const &', 'arg0')])
    ## lte-ccm-rrc-sap.h (module 'lte'): ns3::LteCcmRrcSapProvider::LcsConfig::componentCarrierId [variable]
    cls.add_instance_attribute('componentCarrierId', 'uint16_t', is_const=False)
    ## lte-ccm-rrc-sap.h (module 'lte'): ns3::LteCcmRrcSapProvider::LcsConfig::lc [variable]
    cls.add_instance_attribute('lc', 'ns3::LteEnbCmacSapProvider::LcInfo', is_const=False)
    ## lte-ccm-rrc-sap.h (module 'lte'): ns3::LteCcmRrcSapProvider::LcsConfig::msu [variable]
    cls.add_instance_attribute('msu', 'ns3::LteMacSapUser *', is_const=False)
    return

def register_Ns3LteCcmRrcSapUser_methods(root_module, cls):
    ## lte-ccm-rrc-sap.h (module 'lte'): ns3::LteCcmRrcSapUser::LteCcmRrcSapUser() [constructor]
    cls.add_constructor([])
    ## lte-ccm-rrc-sap.h (module 'lte'): ns3::LteCcmRrcSapUser::LteCcmRrcSapUser(ns3::LteCcmRrcSapUser const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteCcmRrcSapUser const &', 'arg0')])
    ## lte-ccm-rrc-sap.h (module 'lte'): void ns3::LteCcmRrcSapUser::AddLcs(std::vector<ns3::LteRrcSap::LogicalChannelConfig, std::allocator<ns3::LteRrcSap::LogicalChannelConfig> > lcConfig) [member function]
    cls.add_method('AddLcs',
                   'void',
                   [param('std::vector< ns3::LteRrcSap::LogicalChannelConfig >', 'lcConfig')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ccm-rrc-sap.h (module 'lte'): uint8_t ns3::LteCcmRrcSapUser::AddUeMeasReportConfigForComponentCarrier(ns3::LteRrcSap::ReportConfigEutra reportConfig) [member function]
    cls.add_method('AddUeMeasReportConfigForComponentCarrier',
                   'uint8_t',
                   [param('ns3::LteRrcSap::ReportConfigEutra', 'reportConfig')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ccm-rrc-sap.h (module 'lte'): ns3::Ptr<ns3::UeManager> ns3::LteCcmRrcSapUser::GetUeManager(uint16_t rnti) [member function]
    cls.add_method('GetUeManager',
                   'ns3::Ptr< ns3::UeManager >',
                   [param('uint16_t', 'rnti')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ccm-rrc-sap.h (module 'lte'): void ns3::LteCcmRrcSapUser::ReleaseLcs(uint16_t rnti, uint8_t lcid) [member function]
    cls.add_method('ReleaseLcs',
                   'void',
                   [param('uint16_t', 'rnti'), param('uint8_t', 'lcid')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ccm-rrc-sap.h (module 'lte'): void ns3::LteCcmRrcSapUser::TriggerComponentCarrier(uint16_t rnti, uint16_t targetCellId) [member function]
    cls.add_method('TriggerComponentCarrier',
                   'void',
                   [param('uint16_t', 'rnti'), param('uint16_t', 'targetCellId')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3LteEnbCmacSapProvider_methods(root_module, cls):
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapProvider::LteEnbCmacSapProvider() [constructor]
    cls.add_constructor([])
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapProvider::LteEnbCmacSapProvider(ns3::LteEnbCmacSapProvider const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteEnbCmacSapProvider const &', 'arg0')])
    ## lte-enb-cmac-sap.h (module 'lte'): void ns3::LteEnbCmacSapProvider::AddLc(ns3::LteEnbCmacSapProvider::LcInfo lcinfo, ns3::LteMacSapUser * msu) [member function]
    cls.add_method('AddLc',
                   'void',
                   [param('ns3::LteEnbCmacSapProvider::LcInfo', 'lcinfo'), param('ns3::LteMacSapUser *', 'msu')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-enb-cmac-sap.h (module 'lte'): void ns3::LteEnbCmacSapProvider::AddUe(uint16_t rnti) [member function]
    cls.add_method('AddUe',
                   'void',
                   [param('uint16_t', 'rnti')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapProvider::AllocateNcRaPreambleReturnValue ns3::LteEnbCmacSapProvider::AllocateNcRaPreamble(uint16_t rnti) [member function]
    cls.add_method('AllocateNcRaPreamble',
                   'ns3::LteEnbCmacSapProvider::AllocateNcRaPreambleReturnValue',
                   [param('uint16_t', 'rnti')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-enb-cmac-sap.h (module 'lte'): void ns3::LteEnbCmacSapProvider::ConfigureMac(uint8_t ulBandwidth, uint8_t dlBandwidth) [member function]
    cls.add_method('ConfigureMac',
                   'void',
                   [param('uint8_t', 'ulBandwidth'), param('uint8_t', 'dlBandwidth')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapProvider::RachConfig ns3::LteEnbCmacSapProvider::GetRachConfig() [member function]
    cls.add_method('GetRachConfig',
                   'ns3::LteEnbCmacSapProvider::RachConfig',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-enb-cmac-sap.h (module 'lte'): void ns3::LteEnbCmacSapProvider::ReconfigureLc(ns3::LteEnbCmacSapProvider::LcInfo lcinfo) [member function]
    cls.add_method('ReconfigureLc',
                   'void',
                   [param('ns3::LteEnbCmacSapProvider::LcInfo', 'lcinfo')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-enb-cmac-sap.h (module 'lte'): void ns3::LteEnbCmacSapProvider::ReleaseLc(uint16_t rnti, uint8_t lcid) [member function]
    cls.add_method('ReleaseLc',
                   'void',
                   [param('uint16_t', 'rnti'), param('uint8_t', 'lcid')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-enb-cmac-sap.h (module 'lte'): void ns3::LteEnbCmacSapProvider::RemoveUe(uint16_t rnti) [member function]
    cls.add_method('RemoveUe',
                   'void',
                   [param('uint16_t', 'rnti')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-enb-cmac-sap.h (module 'lte'): void ns3::LteEnbCmacSapProvider::UeUpdateConfigurationReq(ns3::LteEnbCmacSapProvider::UeConfig params) [member function]
    cls.add_method('UeUpdateConfigurationReq',
                   'void',
                   [param('ns3::LteEnbCmacSapProvider::UeConfig', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3LteEnbCmacSapProviderAllocateNcRaPreambleReturnValue_methods(root_module, cls):
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapProvider::AllocateNcRaPreambleReturnValue::AllocateNcRaPreambleReturnValue() [constructor]
    cls.add_constructor([])
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapProvider::AllocateNcRaPreambleReturnValue::AllocateNcRaPreambleReturnValue(ns3::LteEnbCmacSapProvider::AllocateNcRaPreambleReturnValue const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteEnbCmacSapProvider::AllocateNcRaPreambleReturnValue const &', 'arg0')])
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapProvider::AllocateNcRaPreambleReturnValue::raPrachMaskIndex [variable]
    cls.add_instance_attribute('raPrachMaskIndex', 'uint8_t', is_const=False)
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapProvider::AllocateNcRaPreambleReturnValue::raPreambleId [variable]
    cls.add_instance_attribute('raPreambleId', 'uint8_t', is_const=False)
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapProvider::AllocateNcRaPreambleReturnValue::valid [variable]
    cls.add_instance_attribute('valid', 'bool', is_const=False)
    return

def register_Ns3LteEnbCmacSapProviderLcInfo_methods(root_module, cls):
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapProvider::LcInfo::LcInfo() [constructor]
    cls.add_constructor([])
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapProvider::LcInfo::LcInfo(ns3::LteEnbCmacSapProvider::LcInfo const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteEnbCmacSapProvider::LcInfo const &', 'arg0')])
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapProvider::LcInfo::gbrDl [variable]
    cls.add_instance_attribute('gbrDl', 'uint64_t', is_const=False)
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapProvider::LcInfo::gbrUl [variable]
    cls.add_instance_attribute('gbrUl', 'uint64_t', is_const=False)
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapProvider::LcInfo::isGbr [variable]
    cls.add_instance_attribute('isGbr', 'bool', is_const=False)
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapProvider::LcInfo::lcGroup [variable]
    cls.add_instance_attribute('lcGroup', 'uint8_t', is_const=False)
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapProvider::LcInfo::lcId [variable]
    cls.add_instance_attribute('lcId', 'uint8_t', is_const=False)
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapProvider::LcInfo::mbrDl [variable]
    cls.add_instance_attribute('mbrDl', 'uint64_t', is_const=False)
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapProvider::LcInfo::mbrUl [variable]
    cls.add_instance_attribute('mbrUl', 'uint64_t', is_const=False)
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapProvider::LcInfo::qci [variable]
    cls.add_instance_attribute('qci', 'uint8_t', is_const=False)
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapProvider::LcInfo::rnti [variable]
    cls.add_instance_attribute('rnti', 'uint16_t', is_const=False)
    return

def register_Ns3LteEnbCmacSapProviderRachConfig_methods(root_module, cls):
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapProvider::RachConfig::RachConfig() [constructor]
    cls.add_constructor([])
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapProvider::RachConfig::RachConfig(ns3::LteEnbCmacSapProvider::RachConfig const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteEnbCmacSapProvider::RachConfig const &', 'arg0')])
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapProvider::RachConfig::numberOfRaPreambles [variable]
    cls.add_instance_attribute('numberOfRaPreambles', 'uint8_t', is_const=False)
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapProvider::RachConfig::preambleTransMax [variable]
    cls.add_instance_attribute('preambleTransMax', 'uint8_t', is_const=False)
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapProvider::RachConfig::raResponseWindowSize [variable]
    cls.add_instance_attribute('raResponseWindowSize', 'uint8_t', is_const=False)
    return

def register_Ns3LteEnbCmacSapProviderUeConfig_methods(root_module, cls):
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapProvider::UeConfig::UeConfig() [constructor]
    cls.add_constructor([])
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapProvider::UeConfig::UeConfig(ns3::LteEnbCmacSapProvider::UeConfig const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteEnbCmacSapProvider::UeConfig const &', 'arg0')])
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapProvider::UeConfig::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapProvider::UeConfig::m_transmissionMode [variable]
    cls.add_instance_attribute('m_transmissionMode', 'uint8_t', is_const=False)
    return

def register_Ns3LteEnbCmacSapUser_methods(root_module, cls):
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapUser::LteEnbCmacSapUser() [constructor]
    cls.add_constructor([])
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapUser::LteEnbCmacSapUser(ns3::LteEnbCmacSapUser const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteEnbCmacSapUser const &', 'arg0')])
    ## lte-enb-cmac-sap.h (module 'lte'): uint16_t ns3::LteEnbCmacSapUser::AllocateTemporaryCellRnti() [member function]
    cls.add_method('AllocateTemporaryCellRnti',
                   'uint16_t',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-enb-cmac-sap.h (module 'lte'): void ns3::LteEnbCmacSapUser::NotifyLcConfigResult(uint16_t rnti, uint8_t lcid, bool success) [member function]
    cls.add_method('NotifyLcConfigResult',
                   'void',
                   [param('uint16_t', 'rnti'), param('uint8_t', 'lcid'), param('bool', 'success')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-enb-cmac-sap.h (module 'lte'): void ns3::LteEnbCmacSapUser::RrcConfigurationUpdateInd(ns3::LteEnbCmacSapUser::UeConfig params) [member function]
    cls.add_method('RrcConfigurationUpdateInd',
                   'void',
                   [param('ns3::LteEnbCmacSapUser::UeConfig', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3LteEnbCmacSapUserUeConfig_methods(root_module, cls):
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapUser::UeConfig::UeConfig() [constructor]
    cls.add_constructor([])
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapUser::UeConfig::UeConfig(ns3::LteEnbCmacSapUser::UeConfig const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteEnbCmacSapUser::UeConfig const &', 'arg0')])
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapUser::UeConfig::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    ## lte-enb-cmac-sap.h (module 'lte'): ns3::LteEnbCmacSapUser::UeConfig::m_transmissionMode [variable]
    cls.add_instance_attribute('m_transmissionMode', 'uint8_t', is_const=False)
    return

def register_Ns3LteEnbCphySapProvider_methods(root_module, cls):
    ## lte-enb-cphy-sap.h (module 'lte'): ns3::LteEnbCphySapProvider::LteEnbCphySapProvider() [constructor]
    cls.add_constructor([])
    ## lte-enb-cphy-sap.h (module 'lte'): ns3::LteEnbCphySapProvider::LteEnbCphySapProvider(ns3::LteEnbCphySapProvider const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteEnbCphySapProvider const &', 'arg0')])
    ## lte-enb-cphy-sap.h (module 'lte'): void ns3::LteEnbCphySapProvider::AddUe(uint16_t rnti) [member function]
    cls.add_method('AddUe',
                   'void',
                   [param('uint16_t', 'rnti')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-enb-cphy-sap.h (module 'lte'): int8_t ns3::LteEnbCphySapProvider::GetReferenceSignalPower() [member function]
    cls.add_method('GetReferenceSignalPower',
                   'int8_t',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-enb-cphy-sap.h (module 'lte'): void ns3::LteEnbCphySapProvider::RemoveUe(uint16_t rnti) [member function]
    cls.add_method('RemoveUe',
                   'void',
                   [param('uint16_t', 'rnti')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-enb-cphy-sap.h (module 'lte'): void ns3::LteEnbCphySapProvider::SetBandwidth(uint8_t ulBandwidth, uint8_t dlBandwidth) [member function]
    cls.add_method('SetBandwidth',
                   'void',
                   [param('uint8_t', 'ulBandwidth'), param('uint8_t', 'dlBandwidth')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-enb-cphy-sap.h (module 'lte'): void ns3::LteEnbCphySapProvider::SetCellId(uint16_t cellId) [member function]
    cls.add_method('SetCellId',
                   'void',
                   [param('uint16_t', 'cellId')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-enb-cphy-sap.h (module 'lte'): void ns3::LteEnbCphySapProvider::SetEarfcn(uint32_t ulEarfcn, uint32_t dlEarfcn) [member function]
    cls.add_method('SetEarfcn',
                   'void',
                   [param('uint32_t', 'ulEarfcn'), param('uint32_t', 'dlEarfcn')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-enb-cphy-sap.h (module 'lte'): void ns3::LteEnbCphySapProvider::SetMasterInformationBlock(ns3::LteRrcSap::MasterInformationBlock mib) [member function]
    cls.add_method('SetMasterInformationBlock',
                   'void',
                   [param('ns3::LteRrcSap::MasterInformationBlock', 'mib')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-enb-cphy-sap.h (module 'lte'): void ns3::LteEnbCphySapProvider::SetPa(uint16_t rnti, double pa) [member function]
    cls.add_method('SetPa',
                   'void',
                   [param('uint16_t', 'rnti'), param('double', 'pa')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-enb-cphy-sap.h (module 'lte'): void ns3::LteEnbCphySapProvider::SetSrsConfigurationIndex(uint16_t rnti, uint16_t srsCi) [member function]
    cls.add_method('SetSrsConfigurationIndex',
                   'void',
                   [param('uint16_t', 'rnti'), param('uint16_t', 'srsCi')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-enb-cphy-sap.h (module 'lte'): void ns3::LteEnbCphySapProvider::SetSystemInformationBlockType1(ns3::LteRrcSap::SystemInformationBlockType1 sib1) [member function]
    cls.add_method('SetSystemInformationBlockType1',
                   'void',
                   [param('ns3::LteRrcSap::SystemInformationBlockType1', 'sib1')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-enb-cphy-sap.h (module 'lte'): void ns3::LteEnbCphySapProvider::SetTransmissionMode(uint16_t rnti, uint8_t txMode) [member function]
    cls.add_method('SetTransmissionMode',
                   'void',
                   [param('uint16_t', 'rnti'), param('uint8_t', 'txMode')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3LteEnbCphySapUser_methods(root_module, cls):
    ## lte-enb-cphy-sap.h (module 'lte'): ns3::LteEnbCphySapUser::LteEnbCphySapUser() [constructor]
    cls.add_constructor([])
    ## lte-enb-cphy-sap.h (module 'lte'): ns3::LteEnbCphySapUser::LteEnbCphySapUser(ns3::LteEnbCphySapUser const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteEnbCphySapUser const &', 'arg0')])
    ## lte-enb-cphy-sap.h (module 'lte'): void ns3::LteEnbCphySapUser::UpdateUeSinrEstimate(ns3::LteEnbCphySapUser::UeAssociatedSinrInfo info) [member function]
    cls.add_method('UpdateUeSinrEstimate',
                   'void',
                   [param('ns3::LteEnbCphySapUser::UeAssociatedSinrInfo', 'info')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3LteEnbCphySapUserUeAssociatedSinrInfo_methods(root_module, cls):
    ## lte-enb-cphy-sap.h (module 'lte'): ns3::LteEnbCphySapUser::UeAssociatedSinrInfo::UeAssociatedSinrInfo() [constructor]
    cls.add_constructor([])
    ## lte-enb-cphy-sap.h (module 'lte'): ns3::LteEnbCphySapUser::UeAssociatedSinrInfo::UeAssociatedSinrInfo(ns3::LteEnbCphySapUser::UeAssociatedSinrInfo const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteEnbCphySapUser::UeAssociatedSinrInfo const &', 'arg0')])
    ## lte-enb-cphy-sap.h (module 'lte'): ns3::LteEnbCphySapUser::UeAssociatedSinrInfo::componentCarrierId [variable]
    cls.add_instance_attribute('componentCarrierId', 'uint8_t', is_const=False)
    ## lte-enb-cphy-sap.h (module 'lte'): ns3::LteEnbCphySapUser::UeAssociatedSinrInfo::ueImsiSinrMap [variable]
    cls.add_instance_attribute('ueImsiSinrMap', 'std::map< unsigned long, double >', is_const=False)
    return

def register_Ns3LteEnbPhySapProvider_methods(root_module, cls):
    ## lte-enb-phy-sap.h (module 'lte'): ns3::LteEnbPhySapProvider::LteEnbPhySapProvider() [constructor]
    cls.add_constructor([])
    ## lte-enb-phy-sap.h (module 'lte'): ns3::LteEnbPhySapProvider::LteEnbPhySapProvider(ns3::LteEnbPhySapProvider const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteEnbPhySapProvider const &', 'arg0')])
    ## lte-enb-phy-sap.h (module 'lte'): uint8_t ns3::LteEnbPhySapProvider::GetMacChTtiDelay() [member function]
    cls.add_method('GetMacChTtiDelay',
                   'uint8_t',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-enb-phy-sap.h (module 'lte'): void ns3::LteEnbPhySapProvider::SendLteControlMessage(ns3::Ptr<ns3::LteControlMessage> msg) [member function]
    cls.add_method('SendLteControlMessage',
                   'void',
                   [param('ns3::Ptr< ns3::LteControlMessage >', 'msg')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-enb-phy-sap.h (module 'lte'): void ns3::LteEnbPhySapProvider::SendMacPdu(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('SendMacPdu',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'p')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3LteEnbPhySapUser_methods(root_module, cls):
    ## lte-enb-phy-sap.h (module 'lte'): ns3::LteEnbPhySapUser::LteEnbPhySapUser() [constructor]
    cls.add_constructor([])
    ## lte-enb-phy-sap.h (module 'lte'): ns3::LteEnbPhySapUser::LteEnbPhySapUser(ns3::LteEnbPhySapUser const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteEnbPhySapUser const &', 'arg0')])
    ## lte-enb-phy-sap.h (module 'lte'): void ns3::LteEnbPhySapUser::DlInfoListElementHarqFeeback(ns3::DlInfoListElement_s params) [member function]
    cls.add_method('DlInfoListElementHarqFeeback',
                   'void',
                   [param('ns3::DlInfoListElement_s', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-enb-phy-sap.h (module 'lte'): void ns3::LteEnbPhySapUser::ReceiveLteControlMessage(ns3::Ptr<ns3::LteControlMessage> msg) [member function]
    cls.add_method('ReceiveLteControlMessage',
                   'void',
                   [param('ns3::Ptr< ns3::LteControlMessage >', 'msg')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-enb-phy-sap.h (module 'lte'): void ns3::LteEnbPhySapUser::ReceivePhyPdu(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('ReceivePhyPdu',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'p')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-enb-phy-sap.h (module 'lte'): void ns3::LteEnbPhySapUser::ReceiveRachPreamble(uint32_t prachId) [member function]
    cls.add_method('ReceiveRachPreamble',
                   'void',
                   [param('uint32_t', 'prachId')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-enb-phy-sap.h (module 'lte'): void ns3::LteEnbPhySapUser::SubframeIndication(uint32_t frameNo, uint32_t subframeNo) [member function]
    cls.add_method('SubframeIndication',
                   'void',
                   [param('uint32_t', 'frameNo'), param('uint32_t', 'subframeNo')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-enb-phy-sap.h (module 'lte'): void ns3::LteEnbPhySapUser::UlCqiReport(ns3::FfMacSchedSapProvider::SchedUlCqiInfoReqParameters ulcqi) [member function]
    cls.add_method('UlCqiReport',
                   'void',
                   [param('ns3::FfMacSchedSapProvider::SchedUlCqiInfoReqParameters', 'ulcqi')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-enb-phy-sap.h (module 'lte'): void ns3::LteEnbPhySapUser::UlInfoListElementHarqFeeback(ns3::UlInfoListElement_s params) [member function]
    cls.add_method('UlInfoListElementHarqFeeback',
                   'void',
                   [param('ns3::UlInfoListElement_s', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3LteFfConverter_methods(root_module, cls):
    ## lte-common.h (module 'lte'): ns3::LteFfConverter::LteFfConverter() [constructor]
    cls.add_constructor([])
    ## lte-common.h (module 'lte'): ns3::LteFfConverter::LteFfConverter(ns3::LteFfConverter const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteFfConverter const &', 'arg0')])
    ## lte-common.h (module 'lte'): static uint16_t ns3::LteFfConverter::double2fpS11dot3(double val) [member function]
    cls.add_method('double2fpS11dot3',
                   'uint16_t',
                   [param('double', 'val')],
                   is_static=True)
    ## lte-common.h (module 'lte'): static double ns3::LteFfConverter::fpS11dot3toDouble(uint16_t val) [member function]
    cls.add_method('fpS11dot3toDouble',
                   'double',
                   [param('uint16_t', 'val')],
                   is_static=True)
    ## lte-common.h (module 'lte'): static double ns3::LteFfConverter::getMinFpS11dot3Value() [member function]
    cls.add_method('getMinFpS11dot3Value',
                   'double',
                   [],
                   is_static=True)
    return

def register_Ns3LteFfrRrcSapProvider_methods(root_module, cls):
    ## lte-ffr-rrc-sap.h (module 'lte'): ns3::LteFfrRrcSapProvider::LteFfrRrcSapProvider() [constructor]
    cls.add_constructor([])
    ## lte-ffr-rrc-sap.h (module 'lte'): ns3::LteFfrRrcSapProvider::LteFfrRrcSapProvider(ns3::LteFfrRrcSapProvider const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteFfrRrcSapProvider const &', 'arg0')])
    ## lte-ffr-rrc-sap.h (module 'lte'): void ns3::LteFfrRrcSapProvider::RecvLoadInformation(ns3::EpcX2Sap::LoadInformationParams params) [member function]
    cls.add_method('RecvLoadInformation',
                   'void',
                   [param('ns3::EpcX2Sap::LoadInformationParams', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ffr-rrc-sap.h (module 'lte'): void ns3::LteFfrRrcSapProvider::ReportUeMeas(uint16_t rnti, ns3::LteRrcSap::MeasResults measResults) [member function]
    cls.add_method('ReportUeMeas',
                   'void',
                   [param('uint16_t', 'rnti'), param('ns3::LteRrcSap::MeasResults', 'measResults')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ffr-rrc-sap.h (module 'lte'): void ns3::LteFfrRrcSapProvider::SetBandwidth(uint8_t ulBandwidth, uint8_t dlBandwidth) [member function]
    cls.add_method('SetBandwidth',
                   'void',
                   [param('uint8_t', 'ulBandwidth'), param('uint8_t', 'dlBandwidth')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ffr-rrc-sap.h (module 'lte'): void ns3::LteFfrRrcSapProvider::SetCellId(uint16_t cellId) [member function]
    cls.add_method('SetCellId',
                   'void',
                   [param('uint16_t', 'cellId')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3LteFfrRrcSapUser_methods(root_module, cls):
    ## lte-ffr-rrc-sap.h (module 'lte'): ns3::LteFfrRrcSapUser::LteFfrRrcSapUser() [constructor]
    cls.add_constructor([])
    ## lte-ffr-rrc-sap.h (module 'lte'): ns3::LteFfrRrcSapUser::LteFfrRrcSapUser(ns3::LteFfrRrcSapUser const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteFfrRrcSapUser const &', 'arg0')])
    ## lte-ffr-rrc-sap.h (module 'lte'): uint8_t ns3::LteFfrRrcSapUser::AddUeMeasReportConfigForFfr(ns3::LteRrcSap::ReportConfigEutra reportConfig) [member function]
    cls.add_method('AddUeMeasReportConfigForFfr',
                   'uint8_t',
                   [param('ns3::LteRrcSap::ReportConfigEutra', 'reportConfig')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ffr-rrc-sap.h (module 'lte'): void ns3::LteFfrRrcSapUser::SendLoadInformation(ns3::EpcX2Sap::LoadInformationParams params) [member function]
    cls.add_method('SendLoadInformation',
                   'void',
                   [param('ns3::EpcX2Sap::LoadInformationParams', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ffr-rrc-sap.h (module 'lte'): void ns3::LteFfrRrcSapUser::SetPdschConfigDedicated(uint16_t rnti, ns3::LteRrcSap::PdschConfigDedicated pdschConfigDedicated) [member function]
    cls.add_method('SetPdschConfigDedicated',
                   'void',
                   [param('uint16_t', 'rnti'), param('ns3::LteRrcSap::PdschConfigDedicated', 'pdschConfigDedicated')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3LteFlowId_t_methods(root_module, cls):
    cls.add_binary_comparison_operator('<')
    cls.add_binary_comparison_operator('==')
    ## lte-common.h (module 'lte'): ns3::LteFlowId_t::LteFlowId_t(ns3::LteFlowId_t const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteFlowId_t const &', 'arg0')])
    ## lte-common.h (module 'lte'): ns3::LteFlowId_t::LteFlowId_t() [constructor]
    cls.add_constructor([])
    ## lte-common.h (module 'lte'): ns3::LteFlowId_t::LteFlowId_t(uint16_t const a, uint8_t const b) [constructor]
    cls.add_constructor([param('uint16_t const', 'a'), param('uint8_t const', 'b')])
    ## lte-common.h (module 'lte'): ns3::LteFlowId_t::m_lcId [variable]
    cls.add_instance_attribute('m_lcId', 'uint8_t', is_const=False)
    ## lte-common.h (module 'lte'): ns3::LteFlowId_t::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    return

def register_Ns3LteHandoverManagementSapProvider_methods(root_module, cls):
    ## lte-handover-management-sap.h (module 'lte'): ns3::LteHandoverManagementSapProvider::LteHandoverManagementSapProvider() [constructor]
    cls.add_constructor([])
    ## lte-handover-management-sap.h (module 'lte'): ns3::LteHandoverManagementSapProvider::LteHandoverManagementSapProvider(ns3::LteHandoverManagementSapProvider const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteHandoverManagementSapProvider const &', 'arg0')])
    ## lte-handover-management-sap.h (module 'lte'): void ns3::LteHandoverManagementSapProvider::ReportUeMeas(uint16_t rnti, ns3::LteRrcSap::MeasResults measResults) [member function]
    cls.add_method('ReportUeMeas',
                   'void',
                   [param('uint16_t', 'rnti'), param('ns3::LteRrcSap::MeasResults', 'measResults')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3LteHandoverManagementSapUser_methods(root_module, cls):
    ## lte-handover-management-sap.h (module 'lte'): ns3::LteHandoverManagementSapUser::LteHandoverManagementSapUser() [constructor]
    cls.add_constructor([])
    ## lte-handover-management-sap.h (module 'lte'): ns3::LteHandoverManagementSapUser::LteHandoverManagementSapUser(ns3::LteHandoverManagementSapUser const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteHandoverManagementSapUser const &', 'arg0')])
    ## lte-handover-management-sap.h (module 'lte'): uint8_t ns3::LteHandoverManagementSapUser::AddUeMeasReportConfigForHandover(ns3::LteRrcSap::ReportConfigEutra reportConfig) [member function]
    cls.add_method('AddUeMeasReportConfigForHandover',
                   'uint8_t',
                   [param('ns3::LteRrcSap::ReportConfigEutra', 'reportConfig')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-handover-management-sap.h (module 'lte'): void ns3::LteHandoverManagementSapUser::TriggerHandover(uint16_t rnti, uint16_t targetCellId) [member function]
    cls.add_method('TriggerHandover',
                   'void',
                   [param('uint16_t', 'rnti'), param('uint16_t', 'targetCellId')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3LteMacSapProvider_methods(root_module, cls):
    ## lte-mac-sap.h (module 'lte'): ns3::LteMacSapProvider::LteMacSapProvider() [constructor]
    cls.add_constructor([])
    ## lte-mac-sap.h (module 'lte'): ns3::LteMacSapProvider::LteMacSapProvider(ns3::LteMacSapProvider const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteMacSapProvider const &', 'arg0')])
    ## lte-mac-sap.h (module 'lte'): void ns3::LteMacSapProvider::ReportBufferStatus(ns3::LteMacSapProvider::ReportBufferStatusParameters params) [member function]
    cls.add_method('ReportBufferStatus',
                   'void',
                   [param('ns3::LteMacSapProvider::ReportBufferStatusParameters', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-mac-sap.h (module 'lte'): void ns3::LteMacSapProvider::TransmitPdu(ns3::LteMacSapProvider::TransmitPduParameters params) [member function]
    cls.add_method('TransmitPdu',
                   'void',
                   [param('ns3::LteMacSapProvider::TransmitPduParameters', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3LteMacSapProviderReportBufferStatusParameters_methods(root_module, cls):
    ## lte-mac-sap.h (module 'lte'): ns3::LteMacSapProvider::ReportBufferStatusParameters::ReportBufferStatusParameters() [constructor]
    cls.add_constructor([])
    ## lte-mac-sap.h (module 'lte'): ns3::LteMacSapProvider::ReportBufferStatusParameters::ReportBufferStatusParameters(ns3::LteMacSapProvider::ReportBufferStatusParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteMacSapProvider::ReportBufferStatusParameters const &', 'arg0')])
    ## lte-mac-sap.h (module 'lte'): ns3::LteMacSapProvider::ReportBufferStatusParameters::arrivalRate [variable]
    cls.add_instance_attribute('arrivalRate', 'double', is_const=False)
    ## lte-mac-sap.h (module 'lte'): ns3::LteMacSapProvider::ReportBufferStatusParameters::lcid [variable]
    cls.add_instance_attribute('lcid', 'uint8_t', is_const=False)
    ## lte-mac-sap.h (module 'lte'): ns3::LteMacSapProvider::ReportBufferStatusParameters::retxPacketDelays [variable]
    cls.add_instance_attribute('retxPacketDelays', 'std::list< double >', is_const=False)
    ## lte-mac-sap.h (module 'lte'): ns3::LteMacSapProvider::ReportBufferStatusParameters::retxPacketSizes [variable]
    cls.add_instance_attribute('retxPacketSizes', 'std::list< unsigned int >', is_const=False)
    ## lte-mac-sap.h (module 'lte'): ns3::LteMacSapProvider::ReportBufferStatusParameters::retxQueueHolDelay [variable]
    cls.add_instance_attribute('retxQueueHolDelay', 'uint16_t', is_const=False)
    ## lte-mac-sap.h (module 'lte'): ns3::LteMacSapProvider::ReportBufferStatusParameters::retxQueueSize [variable]
    cls.add_instance_attribute('retxQueueSize', 'uint32_t', is_const=False)
    ## lte-mac-sap.h (module 'lte'): ns3::LteMacSapProvider::ReportBufferStatusParameters::rnti [variable]
    cls.add_instance_attribute('rnti', 'uint16_t', is_const=False)
    ## lte-mac-sap.h (module 'lte'): ns3::LteMacSapProvider::ReportBufferStatusParameters::statusPduSize [variable]
    cls.add_instance_attribute('statusPduSize', 'uint16_t', is_const=False)
    ## lte-mac-sap.h (module 'lte'): ns3::LteMacSapProvider::ReportBufferStatusParameters::txPacketDelays [variable]
    cls.add_instance_attribute('txPacketDelays', 'std::list< double >', is_const=False)
    ## lte-mac-sap.h (module 'lte'): ns3::LteMacSapProvider::ReportBufferStatusParameters::txPacketSizes [variable]
    cls.add_instance_attribute('txPacketSizes', 'std::list< unsigned int >', is_const=False)
    ## lte-mac-sap.h (module 'lte'): ns3::LteMacSapProvider::ReportBufferStatusParameters::txQueueHolDelay [variable]
    cls.add_instance_attribute('txQueueHolDelay', 'uint16_t', is_const=False)
    ## lte-mac-sap.h (module 'lte'): ns3::LteMacSapProvider::ReportBufferStatusParameters::txQueueSize [variable]
    cls.add_instance_attribute('txQueueSize', 'uint32_t', is_const=False)
    return

def register_Ns3LteMacSapProviderTransmitPduParameters_methods(root_module, cls):
    ## lte-mac-sap.h (module 'lte'): ns3::LteMacSapProvider::TransmitPduParameters::TransmitPduParameters() [constructor]
    cls.add_constructor([])
    ## lte-mac-sap.h (module 'lte'): ns3::LteMacSapProvider::TransmitPduParameters::TransmitPduParameters(ns3::LteMacSapProvider::TransmitPduParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteMacSapProvider::TransmitPduParameters const &', 'arg0')])
    ## lte-mac-sap.h (module 'lte'): ns3::LteMacSapProvider::TransmitPduParameters::componentCarrierId [variable]
    cls.add_instance_attribute('componentCarrierId', 'uint8_t', is_const=False)
    ## lte-mac-sap.h (module 'lte'): ns3::LteMacSapProvider::TransmitPduParameters::harqProcessId [variable]
    cls.add_instance_attribute('harqProcessId', 'uint8_t', is_const=False)
    ## lte-mac-sap.h (module 'lte'): ns3::LteMacSapProvider::TransmitPduParameters::layer [variable]
    cls.add_instance_attribute('layer', 'uint8_t', is_const=False)
    ## lte-mac-sap.h (module 'lte'): ns3::LteMacSapProvider::TransmitPduParameters::lcid [variable]
    cls.add_instance_attribute('lcid', 'uint8_t', is_const=False)
    ## lte-mac-sap.h (module 'lte'): ns3::LteMacSapProvider::TransmitPduParameters::pdu [variable]
    cls.add_instance_attribute('pdu', 'ns3::Ptr< ns3::Packet >', is_const=False)
    ## lte-mac-sap.h (module 'lte'): ns3::LteMacSapProvider::TransmitPduParameters::rnti [variable]
    cls.add_instance_attribute('rnti', 'uint16_t', is_const=False)
    return

def register_Ns3LteMacSapUser_methods(root_module, cls):
    ## lte-mac-sap.h (module 'lte'): ns3::LteMacSapUser::LteMacSapUser() [constructor]
    cls.add_constructor([])
    ## lte-mac-sap.h (module 'lte'): ns3::LteMacSapUser::LteMacSapUser(ns3::LteMacSapUser const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteMacSapUser const &', 'arg0')])
    ## lte-mac-sap.h (module 'lte'): void ns3::LteMacSapUser::NotifyDlHarqDeliveryFailure(uint8_t harqId) [member function]
    cls.add_method('NotifyDlHarqDeliveryFailure',
                   'void',
                   [param('uint8_t', 'harqId')],
                   is_virtual=True)
    ## lte-mac-sap.h (module 'lte'): void ns3::LteMacSapUser::NotifyHarqDeliveryFailure() [member function]
    cls.add_method('NotifyHarqDeliveryFailure',
                   'void',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-mac-sap.h (module 'lte'): void ns3::LteMacSapUser::NotifyTxOpportunity(uint32_t bytes, uint8_t layer, uint8_t harqId, uint8_t componentCarrierId, uint16_t rnti, uint8_t lcid) [member function]
    cls.add_method('NotifyTxOpportunity',
                   'void',
                   [param('uint32_t', 'bytes'), param('uint8_t', 'layer'), param('uint8_t', 'harqId'), param('uint8_t', 'componentCarrierId'), param('uint16_t', 'rnti'), param('uint8_t', 'lcid')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-mac-sap.h (module 'lte'): void ns3::LteMacSapUser::NotifyUlHarqDeliveryFailure(uint8_t harqId) [member function]
    cls.add_method('NotifyUlHarqDeliveryFailure',
                   'void',
                   [param('uint8_t', 'harqId')],
                   is_virtual=True)
    ## lte-mac-sap.h (module 'lte'): void ns3::LteMacSapUser::ReceivePdu(ns3::Ptr<ns3::Packet> p, uint16_t rnti, uint8_t lcid) [member function]
    cls.add_method('ReceivePdu',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'p'), param('uint16_t', 'rnti'), param('uint8_t', 'lcid')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3LtePdcpSapProvider_methods(root_module, cls):
    ## lte-pdcp-sap.h (module 'lte'): ns3::LtePdcpSapProvider::LtePdcpSapProvider() [constructor]
    cls.add_constructor([])
    ## lte-pdcp-sap.h (module 'lte'): ns3::LtePdcpSapProvider::LtePdcpSapProvider(ns3::LtePdcpSapProvider const & arg0) [constructor]
    cls.add_constructor([param('ns3::LtePdcpSapProvider const &', 'arg0')])
    ## lte-pdcp-sap.h (module 'lte'): void ns3::LtePdcpSapProvider::TransmitPdcpSdu(ns3::LtePdcpSapProvider::TransmitPdcpSduParameters params) [member function]
    cls.add_method('TransmitPdcpSdu',
                   'void',
                   [param('ns3::LtePdcpSapProvider::TransmitPdcpSduParameters', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3LtePdcpSapProviderTransmitPdcpSduParameters_methods(root_module, cls):
    ## lte-pdcp-sap.h (module 'lte'): ns3::LtePdcpSapProvider::TransmitPdcpSduParameters::TransmitPdcpSduParameters() [constructor]
    cls.add_constructor([])
    ## lte-pdcp-sap.h (module 'lte'): ns3::LtePdcpSapProvider::TransmitPdcpSduParameters::TransmitPdcpSduParameters(ns3::LtePdcpSapProvider::TransmitPdcpSduParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::LtePdcpSapProvider::TransmitPdcpSduParameters const &', 'arg0')])
    ## lte-pdcp-sap.h (module 'lte'): ns3::LtePdcpSapProvider::TransmitPdcpSduParameters::lcid [variable]
    cls.add_instance_attribute('lcid', 'uint8_t', is_const=False)
    ## lte-pdcp-sap.h (module 'lte'): ns3::LtePdcpSapProvider::TransmitPdcpSduParameters::pdcpSdu [variable]
    cls.add_instance_attribute('pdcpSdu', 'ns3::Ptr< ns3::Packet >', is_const=False)
    ## lte-pdcp-sap.h (module 'lte'): ns3::LtePdcpSapProvider::TransmitPdcpSduParameters::rnti [variable]
    cls.add_instance_attribute('rnti', 'uint16_t', is_const=False)
    return

def register_Ns3LtePdcpSapUser_methods(root_module, cls):
    ## lte-pdcp-sap.h (module 'lte'): ns3::LtePdcpSapUser::LtePdcpSapUser() [constructor]
    cls.add_constructor([])
    ## lte-pdcp-sap.h (module 'lte'): ns3::LtePdcpSapUser::LtePdcpSapUser(ns3::LtePdcpSapUser const & arg0) [constructor]
    cls.add_constructor([param('ns3::LtePdcpSapUser const &', 'arg0')])
    ## lte-pdcp-sap.h (module 'lte'): void ns3::LtePdcpSapUser::ReceivePdcpSdu(ns3::LtePdcpSapUser::ReceivePdcpSduParameters params) [member function]
    cls.add_method('ReceivePdcpSdu',
                   'void',
                   [param('ns3::LtePdcpSapUser::ReceivePdcpSduParameters', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3LtePdcpSapUserReceivePdcpSduParameters_methods(root_module, cls):
    ## lte-pdcp-sap.h (module 'lte'): ns3::LtePdcpSapUser::ReceivePdcpSduParameters::ReceivePdcpSduParameters() [constructor]
    cls.add_constructor([])
    ## lte-pdcp-sap.h (module 'lte'): ns3::LtePdcpSapUser::ReceivePdcpSduParameters::ReceivePdcpSduParameters(ns3::LtePdcpSapUser::ReceivePdcpSduParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::LtePdcpSapUser::ReceivePdcpSduParameters const &', 'arg0')])
    ## lte-pdcp-sap.h (module 'lte'): ns3::LtePdcpSapUser::ReceivePdcpSduParameters::lcid [variable]
    cls.add_instance_attribute('lcid', 'uint8_t', is_const=False)
    ## lte-pdcp-sap.h (module 'lte'): ns3::LtePdcpSapUser::ReceivePdcpSduParameters::pdcpSdu [variable]
    cls.add_instance_attribute('pdcpSdu', 'ns3::Ptr< ns3::Packet >', is_const=False)
    ## lte-pdcp-sap.h (module 'lte'): ns3::LtePdcpSapUser::ReceivePdcpSduParameters::rnti [variable]
    cls.add_instance_attribute('rnti', 'uint16_t', is_const=False)
    return

def register_Ns3LteRlcSapProvider_methods(root_module, cls):
    ## lte-rlc-sap.h (module 'lte'): ns3::LteRlcSapProvider::LteRlcSapProvider() [constructor]
    cls.add_constructor([])
    ## lte-rlc-sap.h (module 'lte'): ns3::LteRlcSapProvider::LteRlcSapProvider(ns3::LteRlcSapProvider const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRlcSapProvider const &', 'arg0')])
    ## lte-rlc-sap.h (module 'lte'): void ns3::LteRlcSapProvider::TransmitPdcpPdu(ns3::LteRlcSapProvider::TransmitPdcpPduParameters params) [member function]
    cls.add_method('TransmitPdcpPdu',
                   'void',
                   [param('ns3::LteRlcSapProvider::TransmitPdcpPduParameters', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3LteRlcSapProviderTransmitPdcpPduParameters_methods(root_module, cls):
    ## lte-rlc-sap.h (module 'lte'): ns3::LteRlcSapProvider::TransmitPdcpPduParameters::TransmitPdcpPduParameters() [constructor]
    cls.add_constructor([])
    ## lte-rlc-sap.h (module 'lte'): ns3::LteRlcSapProvider::TransmitPdcpPduParameters::TransmitPdcpPduParameters(ns3::LteRlcSapProvider::TransmitPdcpPduParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRlcSapProvider::TransmitPdcpPduParameters const &', 'arg0')])
    ## lte-rlc-sap.h (module 'lte'): ns3::LteRlcSapProvider::TransmitPdcpPduParameters::lcid [variable]
    cls.add_instance_attribute('lcid', 'uint8_t', is_const=False)
    ## lte-rlc-sap.h (module 'lte'): ns3::LteRlcSapProvider::TransmitPdcpPduParameters::pdcpPdu [variable]
    cls.add_instance_attribute('pdcpPdu', 'ns3::Ptr< ns3::Packet >', is_const=False)
    ## lte-rlc-sap.h (module 'lte'): ns3::LteRlcSapProvider::TransmitPdcpPduParameters::rnti [variable]
    cls.add_instance_attribute('rnti', 'uint16_t', is_const=False)
    return

def register_Ns3LteRlcSapUser_methods(root_module, cls):
    ## lte-rlc-sap.h (module 'lte'): ns3::LteRlcSapUser::LteRlcSapUser() [constructor]
    cls.add_constructor([])
    ## lte-rlc-sap.h (module 'lte'): ns3::LteRlcSapUser::LteRlcSapUser(ns3::LteRlcSapUser const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRlcSapUser const &', 'arg0')])
    ## lte-rlc-sap.h (module 'lte'): void ns3::LteRlcSapUser::ReceivePdcpPdu(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('ReceivePdcpPdu',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'p')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3LteRlcSpecificLteMacSapUser_methods(root_module, cls):
    ## lte-rlc.h (module 'lte'): ns3::LteRlcSpecificLteMacSapUser::LteRlcSpecificLteMacSapUser(ns3::LteRlcSpecificLteMacSapUser const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRlcSpecificLteMacSapUser const &', 'arg0')])
    ## lte-rlc.h (module 'lte'): ns3::LteRlcSpecificLteMacSapUser::LteRlcSpecificLteMacSapUser(ns3::LteRlc * rlc) [constructor]
    cls.add_constructor([param('ns3::LteRlc *', 'rlc')])
    ## lte-rlc.h (module 'lte'): void ns3::LteRlcSpecificLteMacSapUser::NotifyHarqDeliveryFailure() [member function]
    cls.add_method('NotifyHarqDeliveryFailure',
                   'void',
                   [],
                   is_virtual=True)
    ## lte-rlc.h (module 'lte'): void ns3::LteRlcSpecificLteMacSapUser::NotifyHarqDeliveryFailure(uint8_t harqId) [member function]
    cls.add_method('NotifyHarqDeliveryFailure',
                   'void',
                   [param('uint8_t', 'harqId')],
                   is_virtual=True)
    ## lte-rlc.h (module 'lte'): void ns3::LteRlcSpecificLteMacSapUser::NotifyTxOpportunity(uint32_t bytes, uint8_t layer, uint8_t harqId, uint8_t componentCarrierId, uint16_t rnti, uint8_t lcid) [member function]
    cls.add_method('NotifyTxOpportunity',
                   'void',
                   [param('uint32_t', 'bytes'), param('uint8_t', 'layer'), param('uint8_t', 'harqId'), param('uint8_t', 'componentCarrierId'), param('uint16_t', 'rnti'), param('uint8_t', 'lcid')],
                   is_virtual=True)
    ## lte-rlc.h (module 'lte'): void ns3::LteRlcSpecificLteMacSapUser::ReceivePdu(ns3::Ptr<ns3::Packet> p, uint16_t rnti, uint8_t lcid) [member function]
    cls.add_method('ReceivePdu',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'p'), param('uint16_t', 'rnti'), param('uint8_t', 'lcid')],
                   is_virtual=True)
    return

def register_Ns3LteRrcSap_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::LteRrcSap() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::LteRrcSap(ns3::LteRrcSap const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): static double ns3::LteRrcSap::ConvertPdschConfigDedicated2Double(ns3::LteRrcSap::PdschConfigDedicated pdschConfigDedicated) [member function]
    cls.add_method('ConvertPdschConfigDedicated2Double',
                   'double',
                   [param('ns3::LteRrcSap::PdschConfigDedicated', 'pdschConfigDedicated')],
                   is_static=True)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MaxReportCells [variable]
    cls.add_static_attribute('MaxReportCells', 'uint8_t const', is_const=True)
    return

def register_Ns3LteRrcSapAntennaInfoCommon_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::AntennaInfoCommon::AntennaInfoCommon() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::AntennaInfoCommon::AntennaInfoCommon(ns3::LteRrcSap::AntennaInfoCommon const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::AntennaInfoCommon const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::AntennaInfoCommon::antennaPortsCount [variable]
    cls.add_instance_attribute('antennaPortsCount', 'uint16_t', is_const=False)
    return

def register_Ns3LteRrcSapAntennaInfoDedicated_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::AntennaInfoDedicated::AntennaInfoDedicated() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::AntennaInfoDedicated::AntennaInfoDedicated(ns3::LteRrcSap::AntennaInfoDedicated const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::AntennaInfoDedicated const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::AntennaInfoDedicated::transmissionMode [variable]
    cls.add_instance_attribute('transmissionMode', 'uint8_t', is_const=False)
    return

def register_Ns3LteRrcSapAntennaInfoUl_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::AntennaInfoUl::AntennaInfoUl() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::AntennaInfoUl::AntennaInfoUl(ns3::LteRrcSap::AntennaInfoUl const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::AntennaInfoUl const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::AntennaInfoUl::transmissionMode [variable]
    cls.add_instance_attribute('transmissionMode', 'uint8_t', is_const=False)
    return

def register_Ns3LteRrcSapAsConfig_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::AsConfig::AsConfig() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::AsConfig::AsConfig(ns3::LteRrcSap::AsConfig const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::AsConfig const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::AsConfig::sourceDlCarrierFreq [variable]
    cls.add_instance_attribute('sourceDlCarrierFreq', 'uint32_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::AsConfig::sourceMasterInformationBlock [variable]
    cls.add_instance_attribute('sourceMasterInformationBlock', 'ns3::LteRrcSap::MasterInformationBlock', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::AsConfig::sourceMeasConfig [variable]
    cls.add_instance_attribute('sourceMeasConfig', 'ns3::LteRrcSap::MeasConfig', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::AsConfig::sourceRadioResourceConfig [variable]
    cls.add_instance_attribute('sourceRadioResourceConfig', 'ns3::LteRrcSap::RadioResourceConfigDedicated', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::AsConfig::sourceSystemInformationBlockType1 [variable]
    cls.add_instance_attribute('sourceSystemInformationBlockType1', 'ns3::LteRrcSap::SystemInformationBlockType1', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::AsConfig::sourceSystemInformationBlockType2 [variable]
    cls.add_instance_attribute('sourceSystemInformationBlockType2', 'ns3::LteRrcSap::SystemInformationBlockType2', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::AsConfig::sourceUeIdentity [variable]
    cls.add_instance_attribute('sourceUeIdentity', 'uint16_t', is_const=False)
    return

def register_Ns3LteRrcSapBlackCellsToAddMod_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::BlackCellsToAddMod::BlackCellsToAddMod() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::BlackCellsToAddMod::BlackCellsToAddMod(ns3::LteRrcSap::BlackCellsToAddMod const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::BlackCellsToAddMod const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::BlackCellsToAddMod::cellIndex [variable]
    cls.add_instance_attribute('cellIndex', 'uint8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::BlackCellsToAddMod::physCellIdRange [variable]
    cls.add_instance_attribute('physCellIdRange', 'ns3::LteRrcSap::PhysCellIdRange', is_const=False)
    return

def register_Ns3LteRrcSapCarrierBandwidthEutra_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::CarrierBandwidthEutra::CarrierBandwidthEutra() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::CarrierBandwidthEutra::CarrierBandwidthEutra(ns3::LteRrcSap::CarrierBandwidthEutra const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::CarrierBandwidthEutra const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::CarrierBandwidthEutra::dlBandwidth [variable]
    cls.add_instance_attribute('dlBandwidth', 'uint8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::CarrierBandwidthEutra::ulBandwidth [variable]
    cls.add_instance_attribute('ulBandwidth', 'uint8_t', is_const=False)
    return

def register_Ns3LteRrcSapCarrierFreqEutra_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::CarrierFreqEutra::CarrierFreqEutra() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::CarrierFreqEutra::CarrierFreqEutra(ns3::LteRrcSap::CarrierFreqEutra const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::CarrierFreqEutra const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::CarrierFreqEutra::dlCarrierFreq [variable]
    cls.add_instance_attribute('dlCarrierFreq', 'uint32_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::CarrierFreqEutra::ulCarrierFreq [variable]
    cls.add_instance_attribute('ulCarrierFreq', 'uint32_t', is_const=False)
    return

def register_Ns3LteRrcSapCellAccessRelatedInfo_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::CellAccessRelatedInfo::CellAccessRelatedInfo() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::CellAccessRelatedInfo::CellAccessRelatedInfo(ns3::LteRrcSap::CellAccessRelatedInfo const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::CellAccessRelatedInfo const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::CellAccessRelatedInfo::cellIdentity [variable]
    cls.add_instance_attribute('cellIdentity', 'uint32_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::CellAccessRelatedInfo::csgIdentity [variable]
    cls.add_instance_attribute('csgIdentity', 'uint32_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::CellAccessRelatedInfo::csgIndication [variable]
    cls.add_instance_attribute('csgIndication', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::CellAccessRelatedInfo::plmnIdentityInfo [variable]
    cls.add_instance_attribute('plmnIdentityInfo', 'ns3::LteRrcSap::PlmnIdentityInfo', is_const=False)
    return

def register_Ns3LteRrcSapCellIdentification_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::CellIdentification::CellIdentification() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::CellIdentification::CellIdentification(ns3::LteRrcSap::CellIdentification const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::CellIdentification const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::CellIdentification::dlCarrierFreq [variable]
    cls.add_instance_attribute('dlCarrierFreq', 'uint32_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::CellIdentification::physCellId [variable]
    cls.add_instance_attribute('physCellId', 'uint32_t', is_const=False)
    return

def register_Ns3LteRrcSapCellSelectionInfo_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::CellSelectionInfo::CellSelectionInfo() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::CellSelectionInfo::CellSelectionInfo(ns3::LteRrcSap::CellSelectionInfo const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::CellSelectionInfo const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::CellSelectionInfo::qQualMin [variable]
    cls.add_instance_attribute('qQualMin', 'int8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::CellSelectionInfo::qRxLevMin [variable]
    cls.add_instance_attribute('qRxLevMin', 'int8_t', is_const=False)
    return

def register_Ns3LteRrcSapCellsToAddMod_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::CellsToAddMod::CellsToAddMod() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::CellsToAddMod::CellsToAddMod(ns3::LteRrcSap::CellsToAddMod const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::CellsToAddMod const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::CellsToAddMod::cellIndex [variable]
    cls.add_instance_attribute('cellIndex', 'uint8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::CellsToAddMod::cellIndividualOffset [variable]
    cls.add_instance_attribute('cellIndividualOffset', 'int8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::CellsToAddMod::physCellId [variable]
    cls.add_instance_attribute('physCellId', 'uint16_t', is_const=False)
    return

def register_Ns3LteRrcSapCgiInfo_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::CgiInfo::CgiInfo() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::CgiInfo::CgiInfo(ns3::LteRrcSap::CgiInfo const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::CgiInfo const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::CgiInfo::cellIdentity [variable]
    cls.add_instance_attribute('cellIdentity', 'uint32_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::CgiInfo::plmnIdentity [variable]
    cls.add_instance_attribute('plmnIdentity', 'uint32_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::CgiInfo::plmnIdentityList [variable]
    cls.add_instance_attribute('plmnIdentityList', 'std::list< unsigned int >', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::CgiInfo::trackingAreaCode [variable]
    cls.add_instance_attribute('trackingAreaCode', 'uint16_t', is_const=False)
    return

def register_Ns3LteRrcSapDrbToAddMod_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::DrbToAddMod::DrbToAddMod() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::DrbToAddMod::DrbToAddMod(ns3::LteRrcSap::DrbToAddMod const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::DrbToAddMod const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::DrbToAddMod::drbIdentity [variable]
    cls.add_instance_attribute('drbIdentity', 'uint8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::DrbToAddMod::epsBearerIdentity [variable]
    cls.add_instance_attribute('epsBearerIdentity', 'uint8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::DrbToAddMod::is_mc [variable]
    cls.add_instance_attribute('is_mc', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::DrbToAddMod::logicalChannelConfig [variable]
    cls.add_instance_attribute('logicalChannelConfig', 'ns3::LteRrcSap::LogicalChannelConfig', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::DrbToAddMod::logicalChannelIdentity [variable]
    cls.add_instance_attribute('logicalChannelIdentity', 'uint8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::DrbToAddMod::rlcConfig [variable]
    cls.add_instance_attribute('rlcConfig', 'ns3::LteRrcSap::RlcConfig', is_const=False)
    return

def register_Ns3LteRrcSapFreqInfo_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::FreqInfo::FreqInfo() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::FreqInfo::FreqInfo(ns3::LteRrcSap::FreqInfo const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::FreqInfo const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::FreqInfo::ulBandwidth [variable]
    cls.add_instance_attribute('ulBandwidth', 'uint8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::FreqInfo::ulCarrierFreq [variable]
    cls.add_instance_attribute('ulCarrierFreq', 'uint32_t', is_const=False)
    return

def register_Ns3LteRrcSapHandoverPreparationInfo_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::HandoverPreparationInfo::HandoverPreparationInfo() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::HandoverPreparationInfo::HandoverPreparationInfo(ns3::LteRrcSap::HandoverPreparationInfo const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::HandoverPreparationInfo const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::HandoverPreparationInfo::asConfig [variable]
    cls.add_instance_attribute('asConfig', 'ns3::LteRrcSap::AsConfig', is_const=False)
    return

def register_Ns3LteRrcSapLogicalChannelConfig_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::LogicalChannelConfig::LogicalChannelConfig() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::LogicalChannelConfig::LogicalChannelConfig(ns3::LteRrcSap::LogicalChannelConfig const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::LogicalChannelConfig const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::LogicalChannelConfig::bucketSizeDurationMs [variable]
    cls.add_instance_attribute('bucketSizeDurationMs', 'uint16_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::LogicalChannelConfig::logicalChannelGroup [variable]
    cls.add_instance_attribute('logicalChannelGroup', 'uint8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::LogicalChannelConfig::prioritizedBitRateKbps [variable]
    cls.add_instance_attribute('prioritizedBitRateKbps', 'uint16_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::LogicalChannelConfig::priority [variable]
    cls.add_instance_attribute('priority', 'uint8_t', is_const=False)
    return

def register_Ns3LteRrcSapMasterInformationBlock_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MasterInformationBlock::MasterInformationBlock() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MasterInformationBlock::MasterInformationBlock(ns3::LteRrcSap::MasterInformationBlock const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::MasterInformationBlock const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MasterInformationBlock::dlBandwidth [variable]
    cls.add_instance_attribute('dlBandwidth', 'uint8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MasterInformationBlock::systemFrameNumber [variable]
    cls.add_instance_attribute('systemFrameNumber', 'uint8_t', is_const=False)
    return

def register_Ns3LteRrcSapMeasConfig_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasConfig::MeasConfig() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasConfig::MeasConfig(ns3::LteRrcSap::MeasConfig const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::MeasConfig const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasConfig::haveMeasGapConfig [variable]
    cls.add_instance_attribute('haveMeasGapConfig', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasConfig::haveQuantityConfig [variable]
    cls.add_instance_attribute('haveQuantityConfig', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasConfig::haveSmeasure [variable]
    cls.add_instance_attribute('haveSmeasure', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasConfig::haveSpeedStatePars [variable]
    cls.add_instance_attribute('haveSpeedStatePars', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasConfig::measGapConfig [variable]
    cls.add_instance_attribute('measGapConfig', 'ns3::LteRrcSap::MeasGapConfig', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasConfig::measIdToAddModList [variable]
    cls.add_instance_attribute('measIdToAddModList', 'std::list< ns3::LteRrcSap::MeasIdToAddMod >', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasConfig::measIdToRemoveList [variable]
    cls.add_instance_attribute('measIdToRemoveList', 'std::list< unsigned char >', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasConfig::measObjectToAddModList [variable]
    cls.add_instance_attribute('measObjectToAddModList', 'std::list< ns3::LteRrcSap::MeasObjectToAddMod >', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasConfig::measObjectToRemoveList [variable]
    cls.add_instance_attribute('measObjectToRemoveList', 'std::list< unsigned char >', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasConfig::quantityConfig [variable]
    cls.add_instance_attribute('quantityConfig', 'ns3::LteRrcSap::QuantityConfig', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasConfig::reportConfigToAddModList [variable]
    cls.add_instance_attribute('reportConfigToAddModList', 'std::list< ns3::LteRrcSap::ReportConfigToAddMod >', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasConfig::reportConfigToRemoveList [variable]
    cls.add_instance_attribute('reportConfigToRemoveList', 'std::list< unsigned char >', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasConfig::sMeasure [variable]
    cls.add_instance_attribute('sMeasure', 'uint8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasConfig::speedStatePars [variable]
    cls.add_instance_attribute('speedStatePars', 'ns3::LteRrcSap::SpeedStatePars', is_const=False)
    return

def register_Ns3LteRrcSapMeasGapConfig_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasGapConfig::MeasGapConfig() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasGapConfig::MeasGapConfig(ns3::LteRrcSap::MeasGapConfig const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::MeasGapConfig const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasGapConfig::gapOffsetChoice [variable]
    cls.add_instance_attribute('gapOffsetChoice', 'ns3::LteRrcSap::MeasGapConfig::gap', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasGapConfig::gapOffsetValue [variable]
    cls.add_instance_attribute('gapOffsetValue', 'uint8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasGapConfig::type [variable]
    cls.add_instance_attribute('type', 'ns3::LteRrcSap::MeasGapConfig::action', is_const=False)
    return

def register_Ns3LteRrcSapMeasIdToAddMod_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasIdToAddMod::MeasIdToAddMod() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasIdToAddMod::MeasIdToAddMod(ns3::LteRrcSap::MeasIdToAddMod const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::MeasIdToAddMod const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasIdToAddMod::measId [variable]
    cls.add_instance_attribute('measId', 'uint8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasIdToAddMod::measObjectId [variable]
    cls.add_instance_attribute('measObjectId', 'uint8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasIdToAddMod::reportConfigId [variable]
    cls.add_instance_attribute('reportConfigId', 'uint8_t', is_const=False)
    return

def register_Ns3LteRrcSapMeasObjectEutra_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasObjectEutra::MeasObjectEutra() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasObjectEutra::MeasObjectEutra(ns3::LteRrcSap::MeasObjectEutra const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::MeasObjectEutra const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasObjectEutra::allowedMeasBandwidth [variable]
    cls.add_instance_attribute('allowedMeasBandwidth', 'uint8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasObjectEutra::blackCellsToAddModList [variable]
    cls.add_instance_attribute('blackCellsToAddModList', 'std::list< ns3::LteRrcSap::BlackCellsToAddMod >', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasObjectEutra::blackCellsToRemoveList [variable]
    cls.add_instance_attribute('blackCellsToRemoveList', 'std::list< unsigned char >', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasObjectEutra::carrierFreq [variable]
    cls.add_instance_attribute('carrierFreq', 'uint32_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasObjectEutra::cellForWhichToReportCGI [variable]
    cls.add_instance_attribute('cellForWhichToReportCGI', 'uint16_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasObjectEutra::cellsToAddModList [variable]
    cls.add_instance_attribute('cellsToAddModList', 'std::list< ns3::LteRrcSap::CellsToAddMod >', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasObjectEutra::cellsToRemoveList [variable]
    cls.add_instance_attribute('cellsToRemoveList', 'std::list< unsigned char >', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasObjectEutra::haveCellForWhichToReportCGI [variable]
    cls.add_instance_attribute('haveCellForWhichToReportCGI', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasObjectEutra::neighCellConfig [variable]
    cls.add_instance_attribute('neighCellConfig', 'uint8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasObjectEutra::offsetFreq [variable]
    cls.add_instance_attribute('offsetFreq', 'int8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasObjectEutra::presenceAntennaPort1 [variable]
    cls.add_instance_attribute('presenceAntennaPort1', 'bool', is_const=False)
    return

def register_Ns3LteRrcSapMeasObjectToAddMod_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasObjectToAddMod::MeasObjectToAddMod() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasObjectToAddMod::MeasObjectToAddMod(ns3::LteRrcSap::MeasObjectToAddMod const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::MeasObjectToAddMod const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasObjectToAddMod::measObjectEutra [variable]
    cls.add_instance_attribute('measObjectEutra', 'ns3::LteRrcSap::MeasObjectEutra', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasObjectToAddMod::measObjectId [variable]
    cls.add_instance_attribute('measObjectId', 'uint8_t', is_const=False)
    return

def register_Ns3LteRrcSapMeasResultBestNeighCell_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResultBestNeighCell::MeasResultBestNeighCell() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResultBestNeighCell::MeasResultBestNeighCell(ns3::LteRrcSap::MeasResultBestNeighCell const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::MeasResultBestNeighCell const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResultBestNeighCell::haveRsrpResult [variable]
    cls.add_instance_attribute('haveRsrpResult', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResultBestNeighCell::haveRsrqResult [variable]
    cls.add_instance_attribute('haveRsrqResult', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResultBestNeighCell::physCellId [variable]
    cls.add_instance_attribute('physCellId', 'uint16_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResultBestNeighCell::rsrpResult [variable]
    cls.add_instance_attribute('rsrpResult', 'uint8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResultBestNeighCell::rsrqResult [variable]
    cls.add_instance_attribute('rsrqResult', 'uint8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResultBestNeighCell::servFreqId [variable]
    cls.add_instance_attribute('servFreqId', 'uint16_t', is_const=False)
    return

def register_Ns3LteRrcSapMeasResultEutra_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResultEutra::MeasResultEutra() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResultEutra::MeasResultEutra(ns3::LteRrcSap::MeasResultEutra const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::MeasResultEutra const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResultEutra::cgiInfo [variable]
    cls.add_instance_attribute('cgiInfo', 'ns3::LteRrcSap::CgiInfo', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResultEutra::haveCgiInfo [variable]
    cls.add_instance_attribute('haveCgiInfo', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResultEutra::haveRsrpResult [variable]
    cls.add_instance_attribute('haveRsrpResult', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResultEutra::haveRsrqResult [variable]
    cls.add_instance_attribute('haveRsrqResult', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResultEutra::physCellId [variable]
    cls.add_instance_attribute('physCellId', 'uint16_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResultEutra::rsrpResult [variable]
    cls.add_instance_attribute('rsrpResult', 'uint8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResultEutra::rsrqResult [variable]
    cls.add_instance_attribute('rsrqResult', 'uint8_t', is_const=False)
    return

def register_Ns3LteRrcSapMeasResultScell_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResultScell::MeasResultScell() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResultScell::MeasResultScell(ns3::LteRrcSap::MeasResultScell const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::MeasResultScell const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResultScell::haveRsrpResult [variable]
    cls.add_instance_attribute('haveRsrpResult', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResultScell::haveRsrqResult [variable]
    cls.add_instance_attribute('haveRsrqResult', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResultScell::rsrpResult [variable]
    cls.add_instance_attribute('rsrpResult', 'uint8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResultScell::rsrqResult [variable]
    cls.add_instance_attribute('rsrqResult', 'uint8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResultScell::servFreqId [variable]
    cls.add_instance_attribute('servFreqId', 'uint16_t', is_const=False)
    return

def register_Ns3LteRrcSapMeasResultServFreqList_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResultServFreqList::MeasResultServFreqList() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResultServFreqList::MeasResultServFreqList(ns3::LteRrcSap::MeasResultServFreqList const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::MeasResultServFreqList const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResultServFreqList::haveMeasurementResultsNeighCell [variable]
    cls.add_instance_attribute('haveMeasurementResultsNeighCell', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResultServFreqList::haveMeasurementResultsServingSCells [variable]
    cls.add_instance_attribute('haveMeasurementResultsServingSCells', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResultServFreqList::measResultBestNeighCell [variable]
    cls.add_instance_attribute('measResultBestNeighCell', 'std::list< ns3::LteRrcSap::MeasResultBestNeighCell >', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResultServFreqList::measResultScell [variable]
    cls.add_instance_attribute('measResultScell', 'std::list< ns3::LteRrcSap::MeasResultScell >', is_const=False)
    return

def register_Ns3LteRrcSapMeasResults_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResults::MeasResults() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResults::MeasResults(ns3::LteRrcSap::MeasResults const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::MeasResults const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResults::haveMeasResultNeighCells [variable]
    cls.add_instance_attribute('haveMeasResultNeighCells', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResults::haveScellsMeas [variable]
    cls.add_instance_attribute('haveScellsMeas', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResults::measId [variable]
    cls.add_instance_attribute('measId', 'uint8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResults::measResultListEutra [variable]
    cls.add_instance_attribute('measResultListEutra', 'std::list< ns3::LteRrcSap::MeasResultEutra >', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResults::measScellResultList [variable]
    cls.add_instance_attribute('measScellResultList', 'ns3::LteRrcSap::MeasResultServFreqList', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResults::rsrpResult [variable]
    cls.add_instance_attribute('rsrpResult', 'uint8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasResults::rsrqResult [variable]
    cls.add_instance_attribute('rsrqResult', 'uint8_t', is_const=False)
    return

def register_Ns3LteRrcSapMeasurementReport_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasurementReport::MeasurementReport() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasurementReport::MeasurementReport(ns3::LteRrcSap::MeasurementReport const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::MeasurementReport const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MeasurementReport::measResults [variable]
    cls.add_instance_attribute('measResults', 'ns3::LteRrcSap::MeasResults', is_const=False)
    return

def register_Ns3LteRrcSapMobilityControlInfo_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MobilityControlInfo::MobilityControlInfo() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MobilityControlInfo::MobilityControlInfo(ns3::LteRrcSap::MobilityControlInfo const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::MobilityControlInfo const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MobilityControlInfo::carrierBandwidth [variable]
    cls.add_instance_attribute('carrierBandwidth', 'ns3::LteRrcSap::CarrierBandwidthEutra', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MobilityControlInfo::carrierFreq [variable]
    cls.add_instance_attribute('carrierFreq', 'ns3::LteRrcSap::CarrierFreqEutra', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MobilityControlInfo::haveCarrierBandwidth [variable]
    cls.add_instance_attribute('haveCarrierBandwidth', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MobilityControlInfo::haveCarrierFreq [variable]
    cls.add_instance_attribute('haveCarrierFreq', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MobilityControlInfo::haveRachConfigDedicated [variable]
    cls.add_instance_attribute('haveRachConfigDedicated', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MobilityControlInfo::newUeIdentity [variable]
    cls.add_instance_attribute('newUeIdentity', 'uint16_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MobilityControlInfo::rachConfigDedicated [variable]
    cls.add_instance_attribute('rachConfigDedicated', 'ns3::LteRrcSap::RachConfigDedicated', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MobilityControlInfo::radioResourceConfigCommon [variable]
    cls.add_instance_attribute('radioResourceConfigCommon', 'ns3::LteRrcSap::RadioResourceConfigCommon', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MobilityControlInfo::targetPhysCellId [variable]
    cls.add_instance_attribute('targetPhysCellId', 'uint16_t', is_const=False)
    return

def register_Ns3LteRrcSapMobilityStateParameters_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MobilityStateParameters::MobilityStateParameters() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MobilityStateParameters::MobilityStateParameters(ns3::LteRrcSap::MobilityStateParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::MobilityStateParameters const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MobilityStateParameters::nCellChangeHigh [variable]
    cls.add_instance_attribute('nCellChangeHigh', 'uint8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MobilityStateParameters::nCellChangeMedium [variable]
    cls.add_instance_attribute('nCellChangeMedium', 'uint8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MobilityStateParameters::tEvaluation [variable]
    cls.add_instance_attribute('tEvaluation', 'uint8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::MobilityStateParameters::tHystNormal [variable]
    cls.add_instance_attribute('tHystNormal', 'uint8_t', is_const=False)
    return

def register_Ns3LteRrcSapNonCriticalExtensionConfiguration_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::NonCriticalExtensionConfiguration::NonCriticalExtensionConfiguration() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::NonCriticalExtensionConfiguration::NonCriticalExtensionConfiguration(ns3::LteRrcSap::NonCriticalExtensionConfiguration const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::NonCriticalExtensionConfiguration const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::NonCriticalExtensionConfiguration::sCellToReleaseList [variable]
    cls.add_instance_attribute('sCellToReleaseList', 'std::list< unsigned int >', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::NonCriticalExtensionConfiguration::sCellsToAddModList [variable]
    cls.add_instance_attribute('sCellsToAddModList', 'std::list< ns3::LteRrcSap::SCellToAddMod >', is_const=False)
    return

def register_Ns3LteRrcSapNonUlConfiguration_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::NonUlConfiguration::NonUlConfiguration() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::NonUlConfiguration::NonUlConfiguration(ns3::LteRrcSap::NonUlConfiguration const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::NonUlConfiguration const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::NonUlConfiguration::antennaInfoCommon [variable]
    cls.add_instance_attribute('antennaInfoCommon', 'ns3::LteRrcSap::AntennaInfoCommon', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::NonUlConfiguration::dlBandwidth [variable]
    cls.add_instance_attribute('dlBandwidth', 'uint16_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::NonUlConfiguration::pdschConfigCommon [variable]
    cls.add_instance_attribute('pdschConfigCommon', 'ns3::LteRrcSap::PdschConfigCommon', is_const=False)
    return

def register_Ns3LteRrcSapPdschConfigCommon_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PdschConfigCommon::PdschConfigCommon() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PdschConfigCommon::PdschConfigCommon(ns3::LteRrcSap::PdschConfigCommon const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::PdschConfigCommon const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PdschConfigCommon::pb [variable]
    cls.add_instance_attribute('pb', 'int8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PdschConfigCommon::referenceSignalPower [variable]
    cls.add_instance_attribute('referenceSignalPower', 'int8_t', is_const=False)
    return

def register_Ns3LteRrcSapPdschConfigDedicated_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PdschConfigDedicated::PdschConfigDedicated() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PdschConfigDedicated::PdschConfigDedicated(ns3::LteRrcSap::PdschConfigDedicated const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::PdschConfigDedicated const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PdschConfigDedicated::pa [variable]
    cls.add_instance_attribute('pa', 'uint8_t', is_const=False)
    return

def register_Ns3LteRrcSapPhysCellIdRange_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PhysCellIdRange::PhysCellIdRange() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PhysCellIdRange::PhysCellIdRange(ns3::LteRrcSap::PhysCellIdRange const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::PhysCellIdRange const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PhysCellIdRange::haveRange [variable]
    cls.add_instance_attribute('haveRange', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PhysCellIdRange::range [variable]
    cls.add_instance_attribute('range', 'uint16_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PhysCellIdRange::start [variable]
    cls.add_instance_attribute('start', 'uint16_t', is_const=False)
    return

def register_Ns3LteRrcSapPhysicalConfigDedicated_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PhysicalConfigDedicated::PhysicalConfigDedicated() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PhysicalConfigDedicated::PhysicalConfigDedicated(ns3::LteRrcSap::PhysicalConfigDedicated const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::PhysicalConfigDedicated const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PhysicalConfigDedicated::antennaInfo [variable]
    cls.add_instance_attribute('antennaInfo', 'ns3::LteRrcSap::AntennaInfoDedicated', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PhysicalConfigDedicated::haveAntennaInfoDedicated [variable]
    cls.add_instance_attribute('haveAntennaInfoDedicated', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PhysicalConfigDedicated::havePdschConfigDedicated [variable]
    cls.add_instance_attribute('havePdschConfigDedicated', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PhysicalConfigDedicated::haveSoundingRsUlConfigDedicated [variable]
    cls.add_instance_attribute('haveSoundingRsUlConfigDedicated', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PhysicalConfigDedicated::pdschConfigDedicated [variable]
    cls.add_instance_attribute('pdschConfigDedicated', 'ns3::LteRrcSap::PdschConfigDedicated', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PhysicalConfigDedicated::soundingRsUlConfigDedicated [variable]
    cls.add_instance_attribute('soundingRsUlConfigDedicated', 'ns3::LteRrcSap::SoundingRsUlConfigDedicated', is_const=False)
    return

def register_Ns3LteRrcSapPhysicalConfigDedicatedSCell_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PhysicalConfigDedicatedSCell::PhysicalConfigDedicatedSCell() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PhysicalConfigDedicatedSCell::PhysicalConfigDedicatedSCell(ns3::LteRrcSap::PhysicalConfigDedicatedSCell const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::PhysicalConfigDedicatedSCell const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PhysicalConfigDedicatedSCell::antennaInfo [variable]
    cls.add_instance_attribute('antennaInfo', 'ns3::LteRrcSap::AntennaInfoDedicated', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PhysicalConfigDedicatedSCell::antennaInfoUl [variable]
    cls.add_instance_attribute('antennaInfoUl', 'ns3::LteRrcSap::AntennaInfoDedicated', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PhysicalConfigDedicatedSCell::crossCarrierSchedulingConfig [variable]
    cls.add_instance_attribute('crossCarrierSchedulingConfig', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PhysicalConfigDedicatedSCell::haveAntennaInfoDedicated [variable]
    cls.add_instance_attribute('haveAntennaInfoDedicated', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PhysicalConfigDedicatedSCell::haveAntennaInfoUlDedicated [variable]
    cls.add_instance_attribute('haveAntennaInfoUlDedicated', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PhysicalConfigDedicatedSCell::haveNonUlConfiguration [variable]
    cls.add_instance_attribute('haveNonUlConfiguration', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PhysicalConfigDedicatedSCell::havePdschConfigDedicated [variable]
    cls.add_instance_attribute('havePdschConfigDedicated', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PhysicalConfigDedicatedSCell::haveSoundingRsUlConfigDedicated [variable]
    cls.add_instance_attribute('haveSoundingRsUlConfigDedicated', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PhysicalConfigDedicatedSCell::haveUlConfiguration [variable]
    cls.add_instance_attribute('haveUlConfiguration', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PhysicalConfigDedicatedSCell::pdschConfigDedicated [variable]
    cls.add_instance_attribute('pdschConfigDedicated', 'ns3::LteRrcSap::PdschConfigDedicated', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PhysicalConfigDedicatedSCell::pushConfigDedicatedSCell [variable]
    cls.add_instance_attribute('pushConfigDedicatedSCell', 'ns3::LteRrcSap::PuschConfigDedicatedSCell', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PhysicalConfigDedicatedSCell::soundingRsUlConfigDedicated [variable]
    cls.add_instance_attribute('soundingRsUlConfigDedicated', 'ns3::LteRrcSap::SoundingRsUlConfigDedicated', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PhysicalConfigDedicatedSCell::ulPowerControlDedicatedSCell [variable]
    cls.add_instance_attribute('ulPowerControlDedicatedSCell', 'ns3::LteRrcSap::UlPowerControlDedicatedSCell', is_const=False)
    return

def register_Ns3LteRrcSapPlmnIdentityInfo_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PlmnIdentityInfo::PlmnIdentityInfo() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PlmnIdentityInfo::PlmnIdentityInfo(ns3::LteRrcSap::PlmnIdentityInfo const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::PlmnIdentityInfo const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PlmnIdentityInfo::plmnIdentity [variable]
    cls.add_instance_attribute('plmnIdentity', 'uint32_t', is_const=False)
    return

def register_Ns3LteRrcSapPrachConfigSCell_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PrachConfigSCell::PrachConfigSCell() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PrachConfigSCell::PrachConfigSCell(ns3::LteRrcSap::PrachConfigSCell const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::PrachConfigSCell const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PrachConfigSCell::index [variable]
    cls.add_instance_attribute('index', 'uint16_t', is_const=False)
    return

def register_Ns3LteRrcSapPreambleInfo_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PreambleInfo::PreambleInfo() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PreambleInfo::PreambleInfo(ns3::LteRrcSap::PreambleInfo const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::PreambleInfo const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PreambleInfo::numberOfRaPreambles [variable]
    cls.add_instance_attribute('numberOfRaPreambles', 'uint8_t', is_const=False)
    return

def register_Ns3LteRrcSapPuschConfigDedicatedSCell_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PuschConfigDedicatedSCell::PuschConfigDedicatedSCell() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PuschConfigDedicatedSCell::PuschConfigDedicatedSCell(ns3::LteRrcSap::PuschConfigDedicatedSCell const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::PuschConfigDedicatedSCell const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::PuschConfigDedicatedSCell::nPuschIdentity [variable]
    cls.add_instance_attribute('nPuschIdentity', 'uint16_t', is_const=False)
    return

def register_Ns3LteRrcSapQuantityConfig_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::QuantityConfig::QuantityConfig() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::QuantityConfig::QuantityConfig(ns3::LteRrcSap::QuantityConfig const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::QuantityConfig const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::QuantityConfig::filterCoefficientRSRP [variable]
    cls.add_instance_attribute('filterCoefficientRSRP', 'uint8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::QuantityConfig::filterCoefficientRSRQ [variable]
    cls.add_instance_attribute('filterCoefficientRSRQ', 'uint8_t', is_const=False)
    return

def register_Ns3LteRrcSapRaSupervisionInfo_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RaSupervisionInfo::RaSupervisionInfo() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RaSupervisionInfo::RaSupervisionInfo(ns3::LteRrcSap::RaSupervisionInfo const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::RaSupervisionInfo const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RaSupervisionInfo::preambleTransMax [variable]
    cls.add_instance_attribute('preambleTransMax', 'uint8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RaSupervisionInfo::raResponseWindowSize [variable]
    cls.add_instance_attribute('raResponseWindowSize', 'uint8_t', is_const=False)
    return

def register_Ns3LteRrcSapRachConfigCommon_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RachConfigCommon::RachConfigCommon() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RachConfigCommon::RachConfigCommon(ns3::LteRrcSap::RachConfigCommon const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::RachConfigCommon const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RachConfigCommon::preambleInfo [variable]
    cls.add_instance_attribute('preambleInfo', 'ns3::LteRrcSap::PreambleInfo', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RachConfigCommon::raSupervisionInfo [variable]
    cls.add_instance_attribute('raSupervisionInfo', 'ns3::LteRrcSap::RaSupervisionInfo', is_const=False)
    return

def register_Ns3LteRrcSapRachConfigDedicated_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RachConfigDedicated::RachConfigDedicated() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RachConfigDedicated::RachConfigDedicated(ns3::LteRrcSap::RachConfigDedicated const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::RachConfigDedicated const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RachConfigDedicated::raPrachMaskIndex [variable]
    cls.add_instance_attribute('raPrachMaskIndex', 'uint8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RachConfigDedicated::raPreambleIndex [variable]
    cls.add_instance_attribute('raPreambleIndex', 'uint8_t', is_const=False)
    return

def register_Ns3LteRrcSapRadioResourceConfigCommon_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RadioResourceConfigCommon::RadioResourceConfigCommon() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RadioResourceConfigCommon::RadioResourceConfigCommon(ns3::LteRrcSap::RadioResourceConfigCommon const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::RadioResourceConfigCommon const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RadioResourceConfigCommon::rachConfigCommon [variable]
    cls.add_instance_attribute('rachConfigCommon', 'ns3::LteRrcSap::RachConfigCommon', is_const=False)
    return

def register_Ns3LteRrcSapRadioResourceConfigCommonSCell_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RadioResourceConfigCommonSCell::RadioResourceConfigCommonSCell() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RadioResourceConfigCommonSCell::RadioResourceConfigCommonSCell(ns3::LteRrcSap::RadioResourceConfigCommonSCell const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::RadioResourceConfigCommonSCell const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RadioResourceConfigCommonSCell::haveNonUlConfiguration [variable]
    cls.add_instance_attribute('haveNonUlConfiguration', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RadioResourceConfigCommonSCell::haveUlConfiguration [variable]
    cls.add_instance_attribute('haveUlConfiguration', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RadioResourceConfigCommonSCell::nonUlConfiguration [variable]
    cls.add_instance_attribute('nonUlConfiguration', 'ns3::LteRrcSap::NonUlConfiguration', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RadioResourceConfigCommonSCell::ulConfiguration [variable]
    cls.add_instance_attribute('ulConfiguration', 'ns3::LteRrcSap::UlConfiguration', is_const=False)
    return

def register_Ns3LteRrcSapRadioResourceConfigCommonSib_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RadioResourceConfigCommonSib::RadioResourceConfigCommonSib() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RadioResourceConfigCommonSib::RadioResourceConfigCommonSib(ns3::LteRrcSap::RadioResourceConfigCommonSib const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::RadioResourceConfigCommonSib const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RadioResourceConfigCommonSib::pdschConfigCommon [variable]
    cls.add_instance_attribute('pdschConfigCommon', 'ns3::LteRrcSap::PdschConfigCommon', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RadioResourceConfigCommonSib::rachConfigCommon [variable]
    cls.add_instance_attribute('rachConfigCommon', 'ns3::LteRrcSap::RachConfigCommon', is_const=False)
    return

def register_Ns3LteRrcSapRadioResourceConfigDedicated_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RadioResourceConfigDedicated::RadioResourceConfigDedicated() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RadioResourceConfigDedicated::RadioResourceConfigDedicated(ns3::LteRrcSap::RadioResourceConfigDedicated const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::RadioResourceConfigDedicated const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RadioResourceConfigDedicated::drbToAddModList [variable]
    cls.add_instance_attribute('drbToAddModList', 'std::list< ns3::LteRrcSap::DrbToAddMod >', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RadioResourceConfigDedicated::drbToReleaseList [variable]
    cls.add_instance_attribute('drbToReleaseList', 'std::list< unsigned char >', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RadioResourceConfigDedicated::havePhysicalConfigDedicated [variable]
    cls.add_instance_attribute('havePhysicalConfigDedicated', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RadioResourceConfigDedicated::physicalConfigDedicated [variable]
    cls.add_instance_attribute('physicalConfigDedicated', 'ns3::LteRrcSap::PhysicalConfigDedicated', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RadioResourceConfigDedicated::srbToAddModList [variable]
    cls.add_instance_attribute('srbToAddModList', 'std::list< ns3::LteRrcSap::SrbToAddMod >', is_const=False)
    return

def register_Ns3LteRrcSapRadioResourceConfigDedicatedSCell_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RadioResourceConfigDedicatedSCell::RadioResourceConfigDedicatedSCell() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RadioResourceConfigDedicatedSCell::RadioResourceConfigDedicatedSCell(ns3::LteRrcSap::RadioResourceConfigDedicatedSCell const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::RadioResourceConfigDedicatedSCell const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RadioResourceConfigDedicatedSCell::physicalConfigDedicatedSCell [variable]
    cls.add_instance_attribute('physicalConfigDedicatedSCell', 'ns3::LteRrcSap::PhysicalConfigDedicatedSCell', is_const=False)
    return

def register_Ns3LteRrcSapReestabUeIdentity_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::ReestabUeIdentity::ReestabUeIdentity() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::ReestabUeIdentity::ReestabUeIdentity(ns3::LteRrcSap::ReestabUeIdentity const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::ReestabUeIdentity const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::ReestabUeIdentity::cRnti [variable]
    cls.add_instance_attribute('cRnti', 'uint16_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::ReestabUeIdentity::physCellId [variable]
    cls.add_instance_attribute('physCellId', 'uint16_t', is_const=False)
    return

def register_Ns3LteRrcSapReportConfigEutra_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::ReportConfigEutra::ReportConfigEutra(ns3::LteRrcSap::ReportConfigEutra const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::ReportConfigEutra const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::ReportConfigEutra::ReportConfigEutra() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::ReportConfigEutra::a3Offset [variable]
    cls.add_instance_attribute('a3Offset', 'int8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::ReportConfigEutra::hysteresis [variable]
    cls.add_instance_attribute('hysteresis', 'uint8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::ReportConfigEutra::maxReportCells [variable]
    cls.add_instance_attribute('maxReportCells', 'uint8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::ReportConfigEutra::purpose [variable]
    cls.add_instance_attribute('purpose', 'ns3::LteRrcSap::ReportConfigEutra::report', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::ReportConfigEutra::reportAmount [variable]
    cls.add_instance_attribute('reportAmount', 'uint8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::ReportConfigEutra::reportOnLeave [variable]
    cls.add_instance_attribute('reportOnLeave', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::ReportConfigEutra::threshold1 [variable]
    cls.add_instance_attribute('threshold1', 'ns3::LteRrcSap::ThresholdEutra', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::ReportConfigEutra::threshold2 [variable]
    cls.add_instance_attribute('threshold2', 'ns3::LteRrcSap::ThresholdEutra', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::ReportConfigEutra::timeToTrigger [variable]
    cls.add_instance_attribute('timeToTrigger', 'uint16_t', is_const=False)
    return

def register_Ns3LteRrcSapReportConfigToAddMod_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::ReportConfigToAddMod::ReportConfigToAddMod() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::ReportConfigToAddMod::ReportConfigToAddMod(ns3::LteRrcSap::ReportConfigToAddMod const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::ReportConfigToAddMod const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::ReportConfigToAddMod::reportConfigEutra [variable]
    cls.add_instance_attribute('reportConfigEutra', 'ns3::LteRrcSap::ReportConfigEutra', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::ReportConfigToAddMod::reportConfigId [variable]
    cls.add_instance_attribute('reportConfigId', 'uint8_t', is_const=False)
    return

def register_Ns3LteRrcSapRlcConfig_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RlcConfig::RlcConfig() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RlcConfig::RlcConfig(ns3::LteRrcSap::RlcConfig const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::RlcConfig const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RlcConfig::choice [variable]
    cls.add_instance_attribute('choice', 'ns3::LteRrcSap::RlcConfig::direction', is_const=False)
    return

def register_Ns3LteRrcSapRrcConnectionReconfiguration_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReconfiguration::RrcConnectionReconfiguration() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReconfiguration::RrcConnectionReconfiguration(ns3::LteRrcSap::RrcConnectionReconfiguration const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::RrcConnectionReconfiguration const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReconfiguration::haveMeasConfig [variable]
    cls.add_instance_attribute('haveMeasConfig', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReconfiguration::haveMobilityControlInfo [variable]
    cls.add_instance_attribute('haveMobilityControlInfo', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReconfiguration::haveNonCriticalExtension [variable]
    cls.add_instance_attribute('haveNonCriticalExtension', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReconfiguration::haveRadioResourceConfigDedicated [variable]
    cls.add_instance_attribute('haveRadioResourceConfigDedicated', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReconfiguration::measConfig [variable]
    cls.add_instance_attribute('measConfig', 'ns3::LteRrcSap::MeasConfig', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReconfiguration::mobilityControlInfo [variable]
    cls.add_instance_attribute('mobilityControlInfo', 'ns3::LteRrcSap::MobilityControlInfo', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReconfiguration::nonCriticalExtension [variable]
    cls.add_instance_attribute('nonCriticalExtension', 'ns3::LteRrcSap::NonCriticalExtensionConfiguration', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReconfiguration::radioResourceConfigDedicated [variable]
    cls.add_instance_attribute('radioResourceConfigDedicated', 'ns3::LteRrcSap::RadioResourceConfigDedicated', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReconfiguration::rrcTransactionIdentifier [variable]
    cls.add_instance_attribute('rrcTransactionIdentifier', 'uint8_t', is_const=False)
    return

def register_Ns3LteRrcSapRrcConnectionReconfigurationCompleted_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReconfigurationCompleted::RrcConnectionReconfigurationCompleted() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReconfigurationCompleted::RrcConnectionReconfigurationCompleted(ns3::LteRrcSap::RrcConnectionReconfigurationCompleted const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::RrcConnectionReconfigurationCompleted const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReconfigurationCompleted::rrcTransactionIdentifier [variable]
    cls.add_instance_attribute('rrcTransactionIdentifier', 'uint8_t', is_const=False)
    return

def register_Ns3LteRrcSapRrcConnectionReestablishment_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReestablishment::RrcConnectionReestablishment() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReestablishment::RrcConnectionReestablishment(ns3::LteRrcSap::RrcConnectionReestablishment const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::RrcConnectionReestablishment const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReestablishment::radioResourceConfigDedicated [variable]
    cls.add_instance_attribute('radioResourceConfigDedicated', 'ns3::LteRrcSap::RadioResourceConfigDedicated', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReestablishment::rrcTransactionIdentifier [variable]
    cls.add_instance_attribute('rrcTransactionIdentifier', 'uint8_t', is_const=False)
    return

def register_Ns3LteRrcSapRrcConnectionReestablishmentComplete_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReestablishmentComplete::RrcConnectionReestablishmentComplete() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReestablishmentComplete::RrcConnectionReestablishmentComplete(ns3::LteRrcSap::RrcConnectionReestablishmentComplete const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::RrcConnectionReestablishmentComplete const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReestablishmentComplete::rrcTransactionIdentifier [variable]
    cls.add_instance_attribute('rrcTransactionIdentifier', 'uint8_t', is_const=False)
    return

def register_Ns3LteRrcSapRrcConnectionReestablishmentReject_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReestablishmentReject::RrcConnectionReestablishmentReject() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReestablishmentReject::RrcConnectionReestablishmentReject(ns3::LteRrcSap::RrcConnectionReestablishmentReject const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::RrcConnectionReestablishmentReject const &', 'arg0')])
    return

def register_Ns3LteRrcSapRrcConnectionReestablishmentRequest_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReestablishmentRequest::RrcConnectionReestablishmentRequest() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReestablishmentRequest::RrcConnectionReestablishmentRequest(ns3::LteRrcSap::RrcConnectionReestablishmentRequest const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::RrcConnectionReestablishmentRequest const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReestablishmentRequest::reestablishmentCause [variable]
    cls.add_instance_attribute('reestablishmentCause', 'ns3::LteRrcSap::ReestablishmentCause', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReestablishmentRequest::ueIdentity [variable]
    cls.add_instance_attribute('ueIdentity', 'ns3::LteRrcSap::ReestabUeIdentity', is_const=False)
    return

def register_Ns3LteRrcSapRrcConnectionReject_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReject::RrcConnectionReject() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReject::RrcConnectionReject(ns3::LteRrcSap::RrcConnectionReject const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::RrcConnectionReject const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReject::waitTime [variable]
    cls.add_instance_attribute('waitTime', 'uint8_t', is_const=False)
    return

def register_Ns3LteRrcSapRrcConnectionRelease_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionRelease::RrcConnectionRelease() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionRelease::RrcConnectionRelease(ns3::LteRrcSap::RrcConnectionRelease const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::RrcConnectionRelease const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionRelease::rrcTransactionIdentifier [variable]
    cls.add_instance_attribute('rrcTransactionIdentifier', 'uint8_t', is_const=False)
    return

def register_Ns3LteRrcSapRrcConnectionRequest_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionRequest::RrcConnectionRequest() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionRequest::RrcConnectionRequest(ns3::LteRrcSap::RrcConnectionRequest const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::RrcConnectionRequest const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionRequest::isMc [variable]
    cls.add_instance_attribute('isMc', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionRequest::ueIdentity [variable]
    cls.add_instance_attribute('ueIdentity', 'uint64_t', is_const=False)
    return

def register_Ns3LteRrcSapRrcConnectionSetup_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionSetup::RrcConnectionSetup() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionSetup::RrcConnectionSetup(ns3::LteRrcSap::RrcConnectionSetup const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::RrcConnectionSetup const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionSetup::radioResourceConfigDedicated [variable]
    cls.add_instance_attribute('radioResourceConfigDedicated', 'ns3::LteRrcSap::RadioResourceConfigDedicated', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionSetup::rrcTransactionIdentifier [variable]
    cls.add_instance_attribute('rrcTransactionIdentifier', 'uint8_t', is_const=False)
    return

def register_Ns3LteRrcSapRrcConnectionSetupCompleted_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionSetupCompleted::RrcConnectionSetupCompleted() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionSetupCompleted::RrcConnectionSetupCompleted(ns3::LteRrcSap::RrcConnectionSetupCompleted const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::RrcConnectionSetupCompleted const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionSetupCompleted::rrcTransactionIdentifier [variable]
    cls.add_instance_attribute('rrcTransactionIdentifier', 'uint8_t', is_const=False)
    return

def register_Ns3LteRrcSapRrcConnectionSwitch_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionSwitch::RrcConnectionSwitch() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionSwitch::RrcConnectionSwitch(ns3::LteRrcSap::RrcConnectionSwitch const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::RrcConnectionSwitch const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionSwitch::drbidList [variable]
    cls.add_instance_attribute('drbidList', 'std::vector< unsigned char >', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionSwitch::rrcTransactionIdentifier [variable]
    cls.add_instance_attribute('rrcTransactionIdentifier', 'uint8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionSwitch::useMmWaveConnection [variable]
    cls.add_instance_attribute('useMmWaveConnection', 'uint16_t', is_const=False)
    return

def register_Ns3LteRrcSapSCellToAddMod_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SCellToAddMod::SCellToAddMod() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SCellToAddMod::SCellToAddMod(ns3::LteRrcSap::SCellToAddMod const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::SCellToAddMod const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SCellToAddMod::cellIdentification [variable]
    cls.add_instance_attribute('cellIdentification', 'ns3::LteRrcSap::CellIdentification', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SCellToAddMod::haveRadioResourceConfigDedicatedSCell [variable]
    cls.add_instance_attribute('haveRadioResourceConfigDedicatedSCell', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SCellToAddMod::radioResourceConfigCommonSCell [variable]
    cls.add_instance_attribute('radioResourceConfigCommonSCell', 'ns3::LteRrcSap::RadioResourceConfigCommonSCell', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SCellToAddMod::radioResourceConfigDedicateSCell [variable]
    cls.add_instance_attribute('radioResourceConfigDedicateSCell', 'ns3::LteRrcSap::RadioResourceConfigDedicatedSCell', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SCellToAddMod::sCellIndex [variable]
    cls.add_instance_attribute('sCellIndex', 'uint32_t', is_const=False)
    return

def register_Ns3LteRrcSapSoundingRsUlConfigCommon_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SoundingRsUlConfigCommon::SoundingRsUlConfigCommon() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SoundingRsUlConfigCommon::SoundingRsUlConfigCommon(ns3::LteRrcSap::SoundingRsUlConfigCommon const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::SoundingRsUlConfigCommon const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SoundingRsUlConfigCommon::srsBandwidthConfig [variable]
    cls.add_instance_attribute('srsBandwidthConfig', 'uint8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SoundingRsUlConfigCommon::srsSubframeConfig [variable]
    cls.add_instance_attribute('srsSubframeConfig', 'uint8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SoundingRsUlConfigCommon::type [variable]
    cls.add_instance_attribute('type', 'ns3::LteRrcSap::SoundingRsUlConfigCommon::action', is_const=False)
    return

def register_Ns3LteRrcSapSoundingRsUlConfigDedicated_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SoundingRsUlConfigDedicated::SoundingRsUlConfigDedicated() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SoundingRsUlConfigDedicated::SoundingRsUlConfigDedicated(ns3::LteRrcSap::SoundingRsUlConfigDedicated const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::SoundingRsUlConfigDedicated const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SoundingRsUlConfigDedicated::srsBandwidth [variable]
    cls.add_instance_attribute('srsBandwidth', 'uint8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SoundingRsUlConfigDedicated::srsConfigIndex [variable]
    cls.add_instance_attribute('srsConfigIndex', 'uint16_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SoundingRsUlConfigDedicated::type [variable]
    cls.add_instance_attribute('type', 'ns3::LteRrcSap::SoundingRsUlConfigDedicated::action', is_const=False)
    return

def register_Ns3LteRrcSapSpeedStatePars_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SpeedStatePars::SpeedStatePars() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SpeedStatePars::SpeedStatePars(ns3::LteRrcSap::SpeedStatePars const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::SpeedStatePars const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SpeedStatePars::mobilityStateParameters [variable]
    cls.add_instance_attribute('mobilityStateParameters', 'ns3::LteRrcSap::MobilityStateParameters', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SpeedStatePars::timeToTriggerSf [variable]
    cls.add_instance_attribute('timeToTriggerSf', 'ns3::LteRrcSap::SpeedStateScaleFactors', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SpeedStatePars::type [variable]
    cls.add_instance_attribute('type', 'ns3::LteRrcSap::SpeedStatePars::action', is_const=False)
    return

def register_Ns3LteRrcSapSpeedStateScaleFactors_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SpeedStateScaleFactors::SpeedStateScaleFactors() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SpeedStateScaleFactors::SpeedStateScaleFactors(ns3::LteRrcSap::SpeedStateScaleFactors const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::SpeedStateScaleFactors const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SpeedStateScaleFactors::sfHigh [variable]
    cls.add_instance_attribute('sfHigh', 'uint8_t', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SpeedStateScaleFactors::sfMedium [variable]
    cls.add_instance_attribute('sfMedium', 'uint8_t', is_const=False)
    return

def register_Ns3LteRrcSapSrbToAddMod_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SrbToAddMod::SrbToAddMod() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SrbToAddMod::SrbToAddMod(ns3::LteRrcSap::SrbToAddMod const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::SrbToAddMod const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SrbToAddMod::logicalChannelConfig [variable]
    cls.add_instance_attribute('logicalChannelConfig', 'ns3::LteRrcSap::LogicalChannelConfig', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SrbToAddMod::srbIdentity [variable]
    cls.add_instance_attribute('srbIdentity', 'uint8_t', is_const=False)
    return

def register_Ns3LteRrcSapSystemInformation_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SystemInformation::SystemInformation() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SystemInformation::SystemInformation(ns3::LteRrcSap::SystemInformation const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::SystemInformation const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SystemInformation::haveSib2 [variable]
    cls.add_instance_attribute('haveSib2', 'bool', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SystemInformation::sib2 [variable]
    cls.add_instance_attribute('sib2', 'ns3::LteRrcSap::SystemInformationBlockType2', is_const=False)
    return

def register_Ns3LteRrcSapSystemInformationBlockType1_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SystemInformationBlockType1::SystemInformationBlockType1() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SystemInformationBlockType1::SystemInformationBlockType1(ns3::LteRrcSap::SystemInformationBlockType1 const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::SystemInformationBlockType1 const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SystemInformationBlockType1::cellAccessRelatedInfo [variable]
    cls.add_instance_attribute('cellAccessRelatedInfo', 'ns3::LteRrcSap::CellAccessRelatedInfo', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SystemInformationBlockType1::cellSelectionInfo [variable]
    cls.add_instance_attribute('cellSelectionInfo', 'ns3::LteRrcSap::CellSelectionInfo', is_const=False)
    return

def register_Ns3LteRrcSapSystemInformationBlockType2_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SystemInformationBlockType2::SystemInformationBlockType2() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SystemInformationBlockType2::SystemInformationBlockType2(ns3::LteRrcSap::SystemInformationBlockType2 const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::SystemInformationBlockType2 const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SystemInformationBlockType2::freqInfo [variable]
    cls.add_instance_attribute('freqInfo', 'ns3::LteRrcSap::FreqInfo', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::SystemInformationBlockType2::radioResourceConfigCommon [variable]
    cls.add_instance_attribute('radioResourceConfigCommon', 'ns3::LteRrcSap::RadioResourceConfigCommonSib', is_const=False)
    return

def register_Ns3LteRrcSapThresholdEutra_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::ThresholdEutra::ThresholdEutra() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::ThresholdEutra::ThresholdEutra(ns3::LteRrcSap::ThresholdEutra const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::ThresholdEutra const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::ThresholdEutra::range [variable]
    cls.add_instance_attribute('range', 'uint8_t', is_const=False)
    return

def register_Ns3LteRrcSapUlConfiguration_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::UlConfiguration::UlConfiguration() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::UlConfiguration::UlConfiguration(ns3::LteRrcSap::UlConfiguration const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::UlConfiguration const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::UlConfiguration::prachConfigSCell [variable]
    cls.add_instance_attribute('prachConfigSCell', 'ns3::LteRrcSap::PrachConfigSCell', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::UlConfiguration::soundingRsUlConfigCommon [variable]
    cls.add_instance_attribute('soundingRsUlConfigCommon', 'ns3::LteRrcSap::SoundingRsUlConfigCommon', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::UlConfiguration::ulFreqInfo [variable]
    cls.add_instance_attribute('ulFreqInfo', 'ns3::LteRrcSap::FreqInfo', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::UlConfiguration::ulPowerControlCommonSCell [variable]
    cls.add_instance_attribute('ulPowerControlCommonSCell', 'ns3::LteRrcSap::UlPowerControlCommonSCell', is_const=False)
    return

def register_Ns3LteRrcSapUlPowerControlCommonSCell_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::UlPowerControlCommonSCell::UlPowerControlCommonSCell() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::UlPowerControlCommonSCell::UlPowerControlCommonSCell(ns3::LteRrcSap::UlPowerControlCommonSCell const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::UlPowerControlCommonSCell const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::UlPowerControlCommonSCell::alpha [variable]
    cls.add_instance_attribute('alpha', 'uint16_t', is_const=False)
    return

def register_Ns3LteRrcSapUlPowerControlDedicatedSCell_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::UlPowerControlDedicatedSCell::UlPowerControlDedicatedSCell() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::UlPowerControlDedicatedSCell::UlPowerControlDedicatedSCell(ns3::LteRrcSap::UlPowerControlDedicatedSCell const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRrcSap::UlPowerControlDedicatedSCell const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::UlPowerControlDedicatedSCell::pSrsOffset [variable]
    cls.add_instance_attribute('pSrsOffset', 'uint16_t', is_const=False)
    return

def register_Ns3LteSpectrumValueHelper_methods(root_module, cls):
    ## lte-spectrum-value-helper.h (module 'lte'): ns3::LteSpectrumValueHelper::LteSpectrumValueHelper() [constructor]
    cls.add_constructor([])
    ## lte-spectrum-value-helper.h (module 'lte'): ns3::LteSpectrumValueHelper::LteSpectrumValueHelper(ns3::LteSpectrumValueHelper const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteSpectrumValueHelper const &', 'arg0')])
    ## lte-spectrum-value-helper.h (module 'lte'): static ns3::Ptr<ns3::SpectrumValue> ns3::LteSpectrumValueHelper::CreateNoisePowerSpectralDensity(uint32_t earfcn, uint8_t bandwidth, double noiseFigure) [member function]
    cls.add_method('CreateNoisePowerSpectralDensity',
                   'ns3::Ptr< ns3::SpectrumValue >',
                   [param('uint32_t', 'earfcn'), param('uint8_t', 'bandwidth'), param('double', 'noiseFigure')],
                   is_static=True)
    ## lte-spectrum-value-helper.h (module 'lte'): static ns3::Ptr<ns3::SpectrumValue> ns3::LteSpectrumValueHelper::CreateNoisePowerSpectralDensity(double noiseFigure, ns3::Ptr<ns3::SpectrumModel> spectrumModel) [member function]
    cls.add_method('CreateNoisePowerSpectralDensity',
                   'ns3::Ptr< ns3::SpectrumValue >',
                   [param('double', 'noiseFigure'), param('ns3::Ptr< ns3::SpectrumModel >', 'spectrumModel')],
                   is_static=True)
    ## lte-spectrum-value-helper.h (module 'lte'): static ns3::Ptr<ns3::SpectrumValue> ns3::LteSpectrumValueHelper::CreateTxPowerSpectralDensity(uint32_t earfcn, uint8_t bandwidth, double powerTx, std::vector<int, std::allocator<int> > activeRbs) [member function]
    cls.add_method('CreateTxPowerSpectralDensity',
                   'ns3::Ptr< ns3::SpectrumValue >',
                   [param('uint32_t', 'earfcn'), param('uint8_t', 'bandwidth'), param('double', 'powerTx'), param('std::vector< int >', 'activeRbs')],
                   is_static=True)
    ## lte-spectrum-value-helper.h (module 'lte'): static ns3::Ptr<ns3::SpectrumValue> ns3::LteSpectrumValueHelper::CreateTxPowerSpectralDensity(uint32_t earfcn, uint8_t bandwidth, double powerTx, std::map<int, double, std::less<int>, std::allocator<std::pair<const int, double> > > powerTxMap, std::vector<int, std::allocator<int> > activeRbs) [member function]
    cls.add_method('CreateTxPowerSpectralDensity',
                   'ns3::Ptr< ns3::SpectrumValue >',
                   [param('uint32_t', 'earfcn'), param('uint8_t', 'bandwidth'), param('double', 'powerTx'), param('std::map< int, double >', 'powerTxMap'), param('std::vector< int >', 'activeRbs')],
                   is_static=True)
    ## lte-spectrum-value-helper.h (module 'lte'): static double ns3::LteSpectrumValueHelper::GetCarrierFrequency(uint32_t earfcn) [member function]
    cls.add_method('GetCarrierFrequency',
                   'double',
                   [param('uint32_t', 'earfcn')],
                   is_static=True)
    ## lte-spectrum-value-helper.h (module 'lte'): static double ns3::LteSpectrumValueHelper::GetChannelBandwidth(uint8_t txBandwidthConf) [member function]
    cls.add_method('GetChannelBandwidth',
                   'double',
                   [param('uint8_t', 'txBandwidthConf')],
                   is_static=True)
    ## lte-spectrum-value-helper.h (module 'lte'): static uint16_t ns3::LteSpectrumValueHelper::GetDownlinkCarrierBand(uint32_t nDl) [member function]
    cls.add_method('GetDownlinkCarrierBand',
                   'uint16_t',
                   [param('uint32_t', 'nDl')],
                   is_static=True)
    ## lte-spectrum-value-helper.h (module 'lte'): static double ns3::LteSpectrumValueHelper::GetDownlinkCarrierFrequency(uint32_t earfcn) [member function]
    cls.add_method('GetDownlinkCarrierFrequency',
                   'double',
                   [param('uint32_t', 'earfcn')],
                   is_static=True)
    ## lte-spectrum-value-helper.h (module 'lte'): static ns3::Ptr<ns3::SpectrumModel> ns3::LteSpectrumValueHelper::GetSpectrumModel(uint32_t earfcn, uint8_t bandwidth) [member function]
    cls.add_method('GetSpectrumModel',
                   'ns3::Ptr< ns3::SpectrumModel >',
                   [param('uint32_t', 'earfcn'), param('uint8_t', 'bandwidth')],
                   is_static=True)
    ## lte-spectrum-value-helper.h (module 'lte'): static uint16_t ns3::LteSpectrumValueHelper::GetUplinkCarrierBand(uint32_t nDl) [member function]
    cls.add_method('GetUplinkCarrierBand',
                   'uint16_t',
                   [param('uint32_t', 'nDl')],
                   is_static=True)
    ## lte-spectrum-value-helper.h (module 'lte'): static double ns3::LteSpectrumValueHelper::GetUplinkCarrierFrequency(uint32_t earfcn) [member function]
    cls.add_method('GetUplinkCarrierFrequency',
                   'double',
                   [param('uint32_t', 'earfcn')],
                   is_static=True)
    return

def register_Ns3LteUeCcmRrcSapProvider_methods(root_module, cls):
    ## lte-ue-ccm-rrc-sap.h (module 'lte'): ns3::LteUeCcmRrcSapProvider::LteUeCcmRrcSapProvider() [constructor]
    cls.add_constructor([])
    ## lte-ue-ccm-rrc-sap.h (module 'lte'): ns3::LteUeCcmRrcSapProvider::LteUeCcmRrcSapProvider(ns3::LteUeCcmRrcSapProvider const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteUeCcmRrcSapProvider const &', 'arg0')])
    ## lte-ue-ccm-rrc-sap.h (module 'lte'): std::vector<ns3::LteUeCcmRrcSapProvider::LcsConfig, std::allocator<ns3::LteUeCcmRrcSapProvider::LcsConfig> > ns3::LteUeCcmRrcSapProvider::AddLc(uint8_t lcId, ns3::LteUeCmacSapProvider::LogicalChannelConfig lcConfig, ns3::LteMacSapUser * msu) [member function]
    cls.add_method('AddLc',
                   'std::vector< ns3::LteUeCcmRrcSapProvider::LcsConfig >',
                   [param('uint8_t', 'lcId'), param('ns3::LteUeCmacSapProvider::LogicalChannelConfig', 'lcConfig'), param('ns3::LteMacSapUser *', 'msu')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ue-ccm-rrc-sap.h (module 'lte'): ns3::LteMacSapUser * ns3::LteUeCcmRrcSapProvider::ConfigureSignalBearer(uint8_t lcid, ns3::LteUeCmacSapProvider::LogicalChannelConfig lcConfig, ns3::LteMacSapUser * msu) [member function]
    cls.add_method('ConfigureSignalBearer',
                   'ns3::LteMacSapUser *',
                   [param('uint8_t', 'lcid'), param('ns3::LteUeCmacSapProvider::LogicalChannelConfig', 'lcConfig'), param('ns3::LteMacSapUser *', 'msu')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ue-ccm-rrc-sap.h (module 'lte'): void ns3::LteUeCcmRrcSapProvider::NotifyConnectionReconfigurationMsg() [member function]
    cls.add_method('NotifyConnectionReconfigurationMsg',
                   'void',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ue-ccm-rrc-sap.h (module 'lte'): std::vector<unsigned short, std::allocator<unsigned short> > ns3::LteUeCcmRrcSapProvider::RemoveLc(uint8_t lcid) [member function]
    cls.add_method('RemoveLc',
                   'std::vector< unsigned short >',
                   [param('uint8_t', 'lcid')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3LteUeCcmRrcSapProviderLcsConfig_methods(root_module, cls):
    ## lte-ue-ccm-rrc-sap.h (module 'lte'): ns3::LteUeCcmRrcSapProvider::LcsConfig::LcsConfig() [constructor]
    cls.add_constructor([])
    ## lte-ue-ccm-rrc-sap.h (module 'lte'): ns3::LteUeCcmRrcSapProvider::LcsConfig::LcsConfig(ns3::LteUeCcmRrcSapProvider::LcsConfig const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteUeCcmRrcSapProvider::LcsConfig const &', 'arg0')])
    ## lte-ue-ccm-rrc-sap.h (module 'lte'): ns3::LteUeCcmRrcSapProvider::LcsConfig::componentCarrierId [variable]
    cls.add_instance_attribute('componentCarrierId', 'uint8_t', is_const=False)
    ## lte-ue-ccm-rrc-sap.h (module 'lte'): ns3::LteUeCcmRrcSapProvider::LcsConfig::lcConfig [variable]
    cls.add_instance_attribute('lcConfig', 'ns3::LteUeCmacSapProvider::LogicalChannelConfig *', is_const=False)
    ## lte-ue-ccm-rrc-sap.h (module 'lte'): ns3::LteUeCcmRrcSapProvider::LcsConfig::msu [variable]
    cls.add_instance_attribute('msu', 'ns3::LteMacSapUser *', is_const=False)
    return

def register_Ns3LteUeCcmRrcSapUser_methods(root_module, cls):
    ## lte-ue-ccm-rrc-sap.h (module 'lte'): ns3::LteUeCcmRrcSapUser::LteUeCcmRrcSapUser() [constructor]
    cls.add_constructor([])
    ## lte-ue-ccm-rrc-sap.h (module 'lte'): ns3::LteUeCcmRrcSapUser::LteUeCcmRrcSapUser(ns3::LteUeCcmRrcSapUser const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteUeCcmRrcSapUser const &', 'arg0')])
    ## lte-ue-ccm-rrc-sap.h (module 'lte'): void ns3::LteUeCcmRrcSapUser::ComponentCarrierEnabling(std::vector<unsigned char, std::allocator<unsigned char> > componentCarrierList) [member function]
    cls.add_method('ComponentCarrierEnabling',
                   'void',
                   [param('std::vector< unsigned char >', 'componentCarrierList')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3LteUeCmacSapProvider_methods(root_module, cls):
    ## lte-ue-cmac-sap.h (module 'lte'): ns3::LteUeCmacSapProvider::LteUeCmacSapProvider() [constructor]
    cls.add_constructor([])
    ## lte-ue-cmac-sap.h (module 'lte'): ns3::LteUeCmacSapProvider::LteUeCmacSapProvider(ns3::LteUeCmacSapProvider const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteUeCmacSapProvider const &', 'arg0')])
    ## lte-ue-cmac-sap.h (module 'lte'): void ns3::LteUeCmacSapProvider::AddLc(uint8_t lcId, ns3::LteUeCmacSapProvider::LogicalChannelConfig lcConfig, ns3::LteMacSapUser * msu) [member function]
    cls.add_method('AddLc',
                   'void',
                   [param('uint8_t', 'lcId'), param('ns3::LteUeCmacSapProvider::LogicalChannelConfig', 'lcConfig'), param('ns3::LteMacSapUser *', 'msu')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ue-cmac-sap.h (module 'lte'): void ns3::LteUeCmacSapProvider::ConfigureRach(ns3::LteUeCmacSapProvider::RachConfig rc) [member function]
    cls.add_method('ConfigureRach',
                   'void',
                   [param('ns3::LteUeCmacSapProvider::RachConfig', 'rc')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ue-cmac-sap.h (module 'lte'): void ns3::LteUeCmacSapProvider::RemoveLc(uint8_t lcId) [member function]
    cls.add_method('RemoveLc',
                   'void',
                   [param('uint8_t', 'lcId')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ue-cmac-sap.h (module 'lte'): void ns3::LteUeCmacSapProvider::Reset() [member function]
    cls.add_method('Reset',
                   'void',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ue-cmac-sap.h (module 'lte'): void ns3::LteUeCmacSapProvider::SetRnti(uint16_t rnti) [member function]
    cls.add_method('SetRnti',
                   'void',
                   [param('uint16_t', 'rnti')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ue-cmac-sap.h (module 'lte'): void ns3::LteUeCmacSapProvider::StartContentionBasedRandomAccessProcedure() [member function]
    cls.add_method('StartContentionBasedRandomAccessProcedure',
                   'void',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ue-cmac-sap.h (module 'lte'): void ns3::LteUeCmacSapProvider::StartNonContentionBasedRandomAccessProcedure(uint16_t rnti, uint8_t rapId, uint8_t prachMask) [member function]
    cls.add_method('StartNonContentionBasedRandomAccessProcedure',
                   'void',
                   [param('uint16_t', 'rnti'), param('uint8_t', 'rapId'), param('uint8_t', 'prachMask')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3LteUeCmacSapProviderLogicalChannelConfig_methods(root_module, cls):
    ## lte-ue-cmac-sap.h (module 'lte'): ns3::LteUeCmacSapProvider::LogicalChannelConfig::LogicalChannelConfig() [constructor]
    cls.add_constructor([])
    ## lte-ue-cmac-sap.h (module 'lte'): ns3::LteUeCmacSapProvider::LogicalChannelConfig::LogicalChannelConfig(ns3::LteUeCmacSapProvider::LogicalChannelConfig const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteUeCmacSapProvider::LogicalChannelConfig const &', 'arg0')])
    ## lte-ue-cmac-sap.h (module 'lte'): ns3::LteUeCmacSapProvider::LogicalChannelConfig::bucketSizeDurationMs [variable]
    cls.add_instance_attribute('bucketSizeDurationMs', 'uint16_t', is_const=False)
    ## lte-ue-cmac-sap.h (module 'lte'): ns3::LteUeCmacSapProvider::LogicalChannelConfig::logicalChannelGroup [variable]
    cls.add_instance_attribute('logicalChannelGroup', 'uint8_t', is_const=False)
    ## lte-ue-cmac-sap.h (module 'lte'): ns3::LteUeCmacSapProvider::LogicalChannelConfig::prioritizedBitRateKbps [variable]
    cls.add_instance_attribute('prioritizedBitRateKbps', 'uint16_t', is_const=False)
    ## lte-ue-cmac-sap.h (module 'lte'): ns3::LteUeCmacSapProvider::LogicalChannelConfig::priority [variable]
    cls.add_instance_attribute('priority', 'uint8_t', is_const=False)
    return

def register_Ns3LteUeCmacSapProviderRachConfig_methods(root_module, cls):
    ## lte-ue-cmac-sap.h (module 'lte'): ns3::LteUeCmacSapProvider::RachConfig::RachConfig() [constructor]
    cls.add_constructor([])
    ## lte-ue-cmac-sap.h (module 'lte'): ns3::LteUeCmacSapProvider::RachConfig::RachConfig(ns3::LteUeCmacSapProvider::RachConfig const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteUeCmacSapProvider::RachConfig const &', 'arg0')])
    ## lte-ue-cmac-sap.h (module 'lte'): ns3::LteUeCmacSapProvider::RachConfig::numberOfRaPreambles [variable]
    cls.add_instance_attribute('numberOfRaPreambles', 'uint8_t', is_const=False)
    ## lte-ue-cmac-sap.h (module 'lte'): ns3::LteUeCmacSapProvider::RachConfig::preambleTransMax [variable]
    cls.add_instance_attribute('preambleTransMax', 'uint8_t', is_const=False)
    ## lte-ue-cmac-sap.h (module 'lte'): ns3::LteUeCmacSapProvider::RachConfig::raResponseWindowSize [variable]
    cls.add_instance_attribute('raResponseWindowSize', 'uint8_t', is_const=False)
    return

def register_Ns3LteUeCmacSapUser_methods(root_module, cls):
    ## lte-ue-cmac-sap.h (module 'lte'): ns3::LteUeCmacSapUser::LteUeCmacSapUser() [constructor]
    cls.add_constructor([])
    ## lte-ue-cmac-sap.h (module 'lte'): ns3::LteUeCmacSapUser::LteUeCmacSapUser(ns3::LteUeCmacSapUser const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteUeCmacSapUser const &', 'arg0')])
    ## lte-ue-cmac-sap.h (module 'lte'): void ns3::LteUeCmacSapUser::NotifyRandomAccessFailed() [member function]
    cls.add_method('NotifyRandomAccessFailed',
                   'void',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ue-cmac-sap.h (module 'lte'): void ns3::LteUeCmacSapUser::NotifyRandomAccessSuccessful() [member function]
    cls.add_method('NotifyRandomAccessSuccessful',
                   'void',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ue-cmac-sap.h (module 'lte'): void ns3::LteUeCmacSapUser::SetTemporaryCellRnti(uint16_t rnti) [member function]
    cls.add_method('SetTemporaryCellRnti',
                   'void',
                   [param('uint16_t', 'rnti')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3LteUeConfig_t_methods(root_module, cls):
    cls.add_binary_comparison_operator('<')
    cls.add_binary_comparison_operator('==')
    ## lte-common.h (module 'lte'): ns3::LteUeConfig_t::LteUeConfig_t(ns3::LteUeConfig_t const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteUeConfig_t const &', 'arg0')])
    ## lte-common.h (module 'lte'): ns3::LteUeConfig_t::LteUeConfig_t() [constructor]
    cls.add_constructor([])
    ## lte-common.h (module 'lte'): ns3::LteUeConfig_t::m_reconfigureFlag [variable]
    cls.add_instance_attribute('m_reconfigureFlag', 'bool', is_const=False)
    ## lte-common.h (module 'lte'): ns3::LteUeConfig_t::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    ## lte-common.h (module 'lte'): ns3::LteUeConfig_t::m_srsConfigurationIndex [variable]
    cls.add_instance_attribute('m_srsConfigurationIndex', 'uint16_t', is_const=False)
    ## lte-common.h (module 'lte'): ns3::LteUeConfig_t::m_transmissionMode [variable]
    cls.add_instance_attribute('m_transmissionMode', 'uint8_t', is_const=False)
    return

def register_Ns3LteUeCphySapProvider_methods(root_module, cls):
    ## lte-ue-cphy-sap.h (module 'lte'): ns3::LteUeCphySapProvider::LteUeCphySapProvider() [constructor]
    cls.add_constructor([])
    ## lte-ue-cphy-sap.h (module 'lte'): ns3::LteUeCphySapProvider::LteUeCphySapProvider(ns3::LteUeCphySapProvider const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteUeCphySapProvider const &', 'arg0')])
    ## lte-ue-cphy-sap.h (module 'lte'): void ns3::LteUeCphySapProvider::ConfigureReferenceSignalPower(int8_t referenceSignalPower) [member function]
    cls.add_method('ConfigureReferenceSignalPower',
                   'void',
                   [param('int8_t', 'referenceSignalPower')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ue-cphy-sap.h (module 'lte'): void ns3::LteUeCphySapProvider::ConfigureUplink(uint32_t ulEarfcn, uint8_t ulBandwidth) [member function]
    cls.add_method('ConfigureUplink',
                   'void',
                   [param('uint32_t', 'ulEarfcn'), param('uint8_t', 'ulBandwidth')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ue-cphy-sap.h (module 'lte'): void ns3::LteUeCphySapProvider::Reset() [member function]
    cls.add_method('Reset',
                   'void',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ue-cphy-sap.h (module 'lte'): void ns3::LteUeCphySapProvider::SetDlBandwidth(uint8_t dlBandwidth) [member function]
    cls.add_method('SetDlBandwidth',
                   'void',
                   [param('uint8_t', 'dlBandwidth')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ue-cphy-sap.h (module 'lte'): void ns3::LteUeCphySapProvider::SetPa(double pa) [member function]
    cls.add_method('SetPa',
                   'void',
                   [param('double', 'pa')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ue-cphy-sap.h (module 'lte'): void ns3::LteUeCphySapProvider::SetRnti(uint16_t rnti) [member function]
    cls.add_method('SetRnti',
                   'void',
                   [param('uint16_t', 'rnti')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ue-cphy-sap.h (module 'lte'): void ns3::LteUeCphySapProvider::SetSrsConfigurationIndex(uint16_t srcCi) [member function]
    cls.add_method('SetSrsConfigurationIndex',
                   'void',
                   [param('uint16_t', 'srcCi')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ue-cphy-sap.h (module 'lte'): void ns3::LteUeCphySapProvider::SetTransmissionMode(uint8_t txMode) [member function]
    cls.add_method('SetTransmissionMode',
                   'void',
                   [param('uint8_t', 'txMode')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ue-cphy-sap.h (module 'lte'): void ns3::LteUeCphySapProvider::StartCellSearch(uint32_t dlEarfcn) [member function]
    cls.add_method('StartCellSearch',
                   'void',
                   [param('uint32_t', 'dlEarfcn')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ue-cphy-sap.h (module 'lte'): void ns3::LteUeCphySapProvider::SynchronizeWithEnb(uint16_t cellId) [member function]
    cls.add_method('SynchronizeWithEnb',
                   'void',
                   [param('uint16_t', 'cellId')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ue-cphy-sap.h (module 'lte'): void ns3::LteUeCphySapProvider::SynchronizeWithEnb(uint16_t cellId, uint32_t dlEarfcn) [member function]
    cls.add_method('SynchronizeWithEnb',
                   'void',
                   [param('uint16_t', 'cellId'), param('uint32_t', 'dlEarfcn')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3LteUeCphySapUser_methods(root_module, cls):
    ## lte-ue-cphy-sap.h (module 'lte'): ns3::LteUeCphySapUser::LteUeCphySapUser() [constructor]
    cls.add_constructor([])
    ## lte-ue-cphy-sap.h (module 'lte'): ns3::LteUeCphySapUser::LteUeCphySapUser(ns3::LteUeCphySapUser const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteUeCphySapUser const &', 'arg0')])
    ## lte-ue-cphy-sap.h (module 'lte'): void ns3::LteUeCphySapUser::NotifyRadioLinkFailure(double lastSinrValue) [member function]
    cls.add_method('NotifyRadioLinkFailure',
                   'void',
                   [param('double', 'lastSinrValue')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ue-cphy-sap.h (module 'lte'): void ns3::LteUeCphySapUser::RecvMasterInformationBlock(uint16_t cellId, ns3::LteRrcSap::MasterInformationBlock mib) [member function]
    cls.add_method('RecvMasterInformationBlock',
                   'void',
                   [param('uint16_t', 'cellId'), param('ns3::LteRrcSap::MasterInformationBlock', 'mib')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ue-cphy-sap.h (module 'lte'): void ns3::LteUeCphySapUser::RecvSystemInformationBlockType1(uint16_t cellId, ns3::LteRrcSap::SystemInformationBlockType1 sib1) [member function]
    cls.add_method('RecvSystemInformationBlockType1',
                   'void',
                   [param('uint16_t', 'cellId'), param('ns3::LteRrcSap::SystemInformationBlockType1', 'sib1')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ue-cphy-sap.h (module 'lte'): void ns3::LteUeCphySapUser::ReportUeMeasurements(ns3::LteUeCphySapUser::UeMeasurementsParameters params) [member function]
    cls.add_method('ReportUeMeasurements',
                   'void',
                   [param('ns3::LteUeCphySapUser::UeMeasurementsParameters', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3LteUeCphySapUserUeMeasurementsElement_methods(root_module, cls):
    ## lte-ue-cphy-sap.h (module 'lte'): ns3::LteUeCphySapUser::UeMeasurementsElement::UeMeasurementsElement() [constructor]
    cls.add_constructor([])
    ## lte-ue-cphy-sap.h (module 'lte'): ns3::LteUeCphySapUser::UeMeasurementsElement::UeMeasurementsElement(ns3::LteUeCphySapUser::UeMeasurementsElement const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteUeCphySapUser::UeMeasurementsElement const &', 'arg0')])
    ## lte-ue-cphy-sap.h (module 'lte'): ns3::LteUeCphySapUser::UeMeasurementsElement::m_cellId [variable]
    cls.add_instance_attribute('m_cellId', 'uint16_t', is_const=False)
    ## lte-ue-cphy-sap.h (module 'lte'): ns3::LteUeCphySapUser::UeMeasurementsElement::m_rsrp [variable]
    cls.add_instance_attribute('m_rsrp', 'double', is_const=False)
    ## lte-ue-cphy-sap.h (module 'lte'): ns3::LteUeCphySapUser::UeMeasurementsElement::m_rsrq [variable]
    cls.add_instance_attribute('m_rsrq', 'double', is_const=False)
    return

def register_Ns3LteUeCphySapUserUeMeasurementsParameters_methods(root_module, cls):
    ## lte-ue-cphy-sap.h (module 'lte'): ns3::LteUeCphySapUser::UeMeasurementsParameters::UeMeasurementsParameters() [constructor]
    cls.add_constructor([])
    ## lte-ue-cphy-sap.h (module 'lte'): ns3::LteUeCphySapUser::UeMeasurementsParameters::UeMeasurementsParameters(ns3::LteUeCphySapUser::UeMeasurementsParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteUeCphySapUser::UeMeasurementsParameters const &', 'arg0')])
    ## lte-ue-cphy-sap.h (module 'lte'): ns3::LteUeCphySapUser::UeMeasurementsParameters::m_componentCarrierId [variable]
    cls.add_instance_attribute('m_componentCarrierId', 'uint8_t', is_const=False)
    ## lte-ue-cphy-sap.h (module 'lte'): ns3::LteUeCphySapUser::UeMeasurementsParameters::m_ueMeasurementsList [variable]
    cls.add_instance_attribute('m_ueMeasurementsList', 'std::vector< ns3::LteUeCphySapUser::UeMeasurementsElement >', is_const=False)
    return

def register_Ns3LteUePhySapProvider_methods(root_module, cls):
    ## lte-ue-phy-sap.h (module 'lte'): ns3::LteUePhySapProvider::LteUePhySapProvider() [constructor]
    cls.add_constructor([])
    ## lte-ue-phy-sap.h (module 'lte'): ns3::LteUePhySapProvider::LteUePhySapProvider(ns3::LteUePhySapProvider const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteUePhySapProvider const &', 'arg0')])
    ## lte-ue-phy-sap.h (module 'lte'): void ns3::LteUePhySapProvider::SendLteControlMessage(ns3::Ptr<ns3::LteControlMessage> msg) [member function]
    cls.add_method('SendLteControlMessage',
                   'void',
                   [param('ns3::Ptr< ns3::LteControlMessage >', 'msg')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ue-phy-sap.h (module 'lte'): void ns3::LteUePhySapProvider::SendMacPdu(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('SendMacPdu',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'p')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ue-phy-sap.h (module 'lte'): void ns3::LteUePhySapProvider::SendRachPreamble(uint32_t prachId, uint32_t raRnti) [member function]
    cls.add_method('SendRachPreamble',
                   'void',
                   [param('uint32_t', 'prachId'), param('uint32_t', 'raRnti')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3LteUePhySapUser_methods(root_module, cls):
    ## lte-ue-phy-sap.h (module 'lte'): ns3::LteUePhySapUser::LteUePhySapUser() [constructor]
    cls.add_constructor([])
    ## lte-ue-phy-sap.h (module 'lte'): ns3::LteUePhySapUser::LteUePhySapUser(ns3::LteUePhySapUser const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteUePhySapUser const &', 'arg0')])
    ## lte-ue-phy-sap.h (module 'lte'): void ns3::LteUePhySapUser::ReceiveLteControlMessage(ns3::Ptr<ns3::LteControlMessage> msg) [member function]
    cls.add_method('ReceiveLteControlMessage',
                   'void',
                   [param('ns3::Ptr< ns3::LteControlMessage >', 'msg')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ue-phy-sap.h (module 'lte'): void ns3::LteUePhySapUser::ReceivePhyPdu(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('ReceivePhyPdu',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'p')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ue-phy-sap.h (module 'lte'): void ns3::LteUePhySapUser::SubframeIndication(uint32_t frameNo, uint32_t subframeNo) [member function]
    cls.add_method('SubframeIndication',
                   'void',
                   [param('uint32_t', 'frameNo'), param('uint32_t', 'subframeNo')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3LteUeRrcSapProvider_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteUeRrcSapProvider::LteUeRrcSapProvider() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteUeRrcSapProvider::LteUeRrcSapProvider(ns3::LteUeRrcSapProvider const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteUeRrcSapProvider const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): void ns3::LteUeRrcSapProvider::CompleteSetup(ns3::LteUeRrcSapProvider::CompleteSetupParameters params) [member function]
    cls.add_method('CompleteSetup',
                   'void',
                   [param('ns3::LteUeRrcSapProvider::CompleteSetupParameters', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-rrc-sap.h (module 'lte'): void ns3::LteUeRrcSapProvider::RecvRrcConnectToMmWave(uint16_t mmWaveCellId) [member function]
    cls.add_method('RecvRrcConnectToMmWave',
                   'void',
                   [param('uint16_t', 'mmWaveCellId')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-rrc-sap.h (module 'lte'): void ns3::LteUeRrcSapProvider::RecvRrcConnectionReconfiguration(ns3::LteRrcSap::RrcConnectionReconfiguration msg) [member function]
    cls.add_method('RecvRrcConnectionReconfiguration',
                   'void',
                   [param('ns3::LteRrcSap::RrcConnectionReconfiguration', 'msg')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-rrc-sap.h (module 'lte'): void ns3::LteUeRrcSapProvider::RecvRrcConnectionReestablishment(ns3::LteRrcSap::RrcConnectionReestablishment msg) [member function]
    cls.add_method('RecvRrcConnectionReestablishment',
                   'void',
                   [param('ns3::LteRrcSap::RrcConnectionReestablishment', 'msg')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-rrc-sap.h (module 'lte'): void ns3::LteUeRrcSapProvider::RecvRrcConnectionReestablishmentReject(ns3::LteRrcSap::RrcConnectionReestablishmentReject msg) [member function]
    cls.add_method('RecvRrcConnectionReestablishmentReject',
                   'void',
                   [param('ns3::LteRrcSap::RrcConnectionReestablishmentReject', 'msg')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-rrc-sap.h (module 'lte'): void ns3::LteUeRrcSapProvider::RecvRrcConnectionReject(ns3::LteRrcSap::RrcConnectionReject msg) [member function]
    cls.add_method('RecvRrcConnectionReject',
                   'void',
                   [param('ns3::LteRrcSap::RrcConnectionReject', 'msg')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-rrc-sap.h (module 'lte'): void ns3::LteUeRrcSapProvider::RecvRrcConnectionRelease(ns3::LteRrcSap::RrcConnectionRelease msg) [member function]
    cls.add_method('RecvRrcConnectionRelease',
                   'void',
                   [param('ns3::LteRrcSap::RrcConnectionRelease', 'msg')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-rrc-sap.h (module 'lte'): void ns3::LteUeRrcSapProvider::RecvRrcConnectionSetup(ns3::LteRrcSap::RrcConnectionSetup msg) [member function]
    cls.add_method('RecvRrcConnectionSetup',
                   'void',
                   [param('ns3::LteRrcSap::RrcConnectionSetup', 'msg')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-rrc-sap.h (module 'lte'): void ns3::LteUeRrcSapProvider::RecvRrcConnectionSwitch(ns3::LteRrcSap::RrcConnectionSwitch msg) [member function]
    cls.add_method('RecvRrcConnectionSwitch',
                   'void',
                   [param('ns3::LteRrcSap::RrcConnectionSwitch', 'msg')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-rrc-sap.h (module 'lte'): void ns3::LteUeRrcSapProvider::RecvSystemInformation(ns3::LteRrcSap::SystemInformation msg) [member function]
    cls.add_method('RecvSystemInformation',
                   'void',
                   [param('ns3::LteRrcSap::SystemInformation', 'msg')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3LteUeRrcSapProviderCompleteSetupParameters_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteUeRrcSapProvider::CompleteSetupParameters::CompleteSetupParameters() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteUeRrcSapProvider::CompleteSetupParameters::CompleteSetupParameters(ns3::LteUeRrcSapProvider::CompleteSetupParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteUeRrcSapProvider::CompleteSetupParameters const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteUeRrcSapProvider::CompleteSetupParameters::srb0SapUser [variable]
    cls.add_instance_attribute('srb0SapUser', 'ns3::LteRlcSapUser *', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteUeRrcSapProvider::CompleteSetupParameters::srb1SapUser [variable]
    cls.add_instance_attribute('srb1SapUser', 'ns3::LtePdcpSapUser *', is_const=False)
    return

def register_Ns3LteUeRrcSapUser_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteUeRrcSapUser::LteUeRrcSapUser() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteUeRrcSapUser::LteUeRrcSapUser(ns3::LteUeRrcSapUser const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteUeRrcSapUser const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): void ns3::LteUeRrcSapUser::SendMeasurementReport(ns3::LteRrcSap::MeasurementReport msg) [member function]
    cls.add_method('SendMeasurementReport',
                   'void',
                   [param('ns3::LteRrcSap::MeasurementReport', 'msg')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-rrc-sap.h (module 'lte'): void ns3::LteUeRrcSapUser::SendNotifySecondaryCellConnected(uint16_t mmWaveRnti, uint16_t mmWaveCellId) [member function]
    cls.add_method('SendNotifySecondaryCellConnected',
                   'void',
                   [param('uint16_t', 'mmWaveRnti'), param('uint16_t', 'mmWaveCellId')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-rrc-sap.h (module 'lte'): void ns3::LteUeRrcSapUser::SendRrcConnectionReconfigurationCompleted(ns3::LteRrcSap::RrcConnectionReconfigurationCompleted msg) [member function]
    cls.add_method('SendRrcConnectionReconfigurationCompleted',
                   'void',
                   [param('ns3::LteRrcSap::RrcConnectionReconfigurationCompleted', 'msg')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-rrc-sap.h (module 'lte'): void ns3::LteUeRrcSapUser::SendRrcConnectionReestablishmentComplete(ns3::LteRrcSap::RrcConnectionReestablishmentComplete msg) [member function]
    cls.add_method('SendRrcConnectionReestablishmentComplete',
                   'void',
                   [param('ns3::LteRrcSap::RrcConnectionReestablishmentComplete', 'msg')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-rrc-sap.h (module 'lte'): void ns3::LteUeRrcSapUser::SendRrcConnectionReestablishmentRequest(ns3::LteRrcSap::RrcConnectionReestablishmentRequest msg) [member function]
    cls.add_method('SendRrcConnectionReestablishmentRequest',
                   'void',
                   [param('ns3::LteRrcSap::RrcConnectionReestablishmentRequest', 'msg')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-rrc-sap.h (module 'lte'): void ns3::LteUeRrcSapUser::SendRrcConnectionRequest(ns3::LteRrcSap::RrcConnectionRequest msg) [member function]
    cls.add_method('SendRrcConnectionRequest',
                   'void',
                   [param('ns3::LteRrcSap::RrcConnectionRequest', 'msg')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-rrc-sap.h (module 'lte'): void ns3::LteUeRrcSapUser::SendRrcConnectionSetupCompleted(ns3::LteRrcSap::RrcConnectionSetupCompleted msg) [member function]
    cls.add_method('SendRrcConnectionSetupCompleted',
                   'void',
                   [param('ns3::LteRrcSap::RrcConnectionSetupCompleted', 'msg')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-rrc-sap.h (module 'lte'): void ns3::LteUeRrcSapUser::Setup(ns3::LteUeRrcSapUser::SetupParameters params) [member function]
    cls.add_method('Setup',
                   'void',
                   [param('ns3::LteUeRrcSapUser::SetupParameters', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3LteUeRrcSapUserSetupParameters_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteUeRrcSapUser::SetupParameters::SetupParameters() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteUeRrcSapUser::SetupParameters::SetupParameters(ns3::LteUeRrcSapUser::SetupParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteUeRrcSapUser::SetupParameters const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteUeRrcSapUser::SetupParameters::srb0SapProvider [variable]
    cls.add_instance_attribute('srb0SapProvider', 'ns3::LteRlcSapProvider *', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteUeRrcSapUser::SetupParameters::srb1SapProvider [variable]
    cls.add_instance_attribute('srb1SapProvider', 'ns3::LtePdcpSapProvider *', is_const=False)
    return

def register_Ns3Mac48Address_methods(root_module, cls):
    cls.add_binary_comparison_operator('==')
    cls.add_binary_comparison_operator('!=')
    cls.add_binary_comparison_operator('<')
    cls.add_output_stream_operator()
    ## mac48-address.h (module 'network'): ns3::Mac48Address::Mac48Address(ns3::Mac48Address const & arg0) [constructor]
    cls.add_constructor([param('ns3::Mac48Address const &', 'arg0')])
    ## mac48-address.h (module 'network'): ns3::Mac48Address::Mac48Address() [constructor]
    cls.add_constructor([])
    ## mac48-address.h (module 'network'): ns3::Mac48Address::Mac48Address(char const * str) [constructor]
    cls.add_constructor([param('char const *', 'str')])
    ## mac48-address.h (module 'network'): static ns3::Mac48Address ns3::Mac48Address::Allocate() [member function]
    cls.add_method('Allocate',
                   'ns3::Mac48Address',
                   [],
                   is_static=True)
    ## mac48-address.h (module 'network'): static ns3::Mac48Address ns3::Mac48Address::ConvertFrom(ns3::Address const & address) [member function]
    cls.add_method('ConvertFrom',
                   'ns3::Mac48Address',
                   [param('ns3::Address const &', 'address')],
                   is_static=True)
    ## mac48-address.h (module 'network'): void ns3::Mac48Address::CopyFrom(uint8_t const * buffer) [member function]
    cls.add_method('CopyFrom',
                   'void',
                   [param('uint8_t const *', 'buffer')])
    ## mac48-address.h (module 'network'): void ns3::Mac48Address::CopyTo(uint8_t * buffer) const [member function]
    cls.add_method('CopyTo',
                   'void',
                   [param('uint8_t *', 'buffer')],
                   is_const=True)
    ## mac48-address.h (module 'network'): static ns3::Mac48Address ns3::Mac48Address::GetBroadcast() [member function]
    cls.add_method('GetBroadcast',
                   'ns3::Mac48Address',
                   [],
                   is_static=True)
    ## mac48-address.h (module 'network'): static ns3::Mac48Address ns3::Mac48Address::GetMulticast(ns3::Ipv4Address address) [member function]
    cls.add_method('GetMulticast',
                   'ns3::Mac48Address',
                   [param('ns3::Ipv4Address', 'address')],
                   is_static=True)
    ## mac48-address.h (module 'network'): static ns3::Mac48Address ns3::Mac48Address::GetMulticast(ns3::Ipv6Address address) [member function]
    cls.add_method('GetMulticast',
                   'ns3::Mac48Address',
                   [param('ns3::Ipv6Address', 'address')],
                   is_static=True)
    ## mac48-address.h (module 'network'): static ns3::Mac48Address ns3::Mac48Address::GetMulticast6Prefix() [member function]
    cls.add_method('GetMulticast6Prefix',
                   'ns3::Mac48Address',
                   [],
                   is_static=True)
    ## mac48-address.h (module 'network'): static ns3::Mac48Address ns3::Mac48Address::GetMulticastPrefix() [member function]
    cls.add_method('GetMulticastPrefix',
                   'ns3::Mac48Address',
                   [],
                   is_static=True)
    ## mac48-address.h (module 'network'): bool ns3::Mac48Address::IsBroadcast() const [member function]
    cls.add_method('IsBroadcast',
                   'bool',
                   [],
                   is_const=True)
    ## mac48-address.h (module 'network'): bool ns3::Mac48Address::IsGroup() const [member function]
    cls.add_method('IsGroup',
                   'bool',
                   [],
                   is_const=True)
    ## mac48-address.h (module 'network'): static bool ns3::Mac48Address::IsMatchingType(ns3::Address const & address) [member function]
    cls.add_method('IsMatchingType',
                   'bool',
                   [param('ns3::Address const &', 'address')],
                   is_static=True)
    return

def register_Ns3Mac64Address_methods(root_module, cls):
    cls.add_binary_comparison_operator('==')
    cls.add_binary_comparison_operator('!=')
    cls.add_binary_comparison_operator('<')
    cls.add_output_stream_operator()
    ## mac64-address.h (module 'network'): ns3::Mac64Address::Mac64Address(ns3::Mac64Address const & arg0) [constructor]
    cls.add_constructor([param('ns3::Mac64Address const &', 'arg0')])
    ## mac64-address.h (module 'network'): ns3::Mac64Address::Mac64Address() [constructor]
    cls.add_constructor([])
    ## mac64-address.h (module 'network'): ns3::Mac64Address::Mac64Address(char const * str) [constructor]
    cls.add_constructor([param('char const *', 'str')])
    ## mac64-address.h (module 'network'): static ns3::Mac64Address ns3::Mac64Address::Allocate() [member function]
    cls.add_method('Allocate',
                   'ns3::Mac64Address',
                   [],
                   is_static=True)
    ## mac64-address.h (module 'network'): static ns3::Mac64Address ns3::Mac64Address::ConvertFrom(ns3::Address const & address) [member function]
    cls.add_method('ConvertFrom',
                   'ns3::Mac64Address',
                   [param('ns3::Address const &', 'address')],
                   is_static=True)
    ## mac64-address.h (module 'network'): void ns3::Mac64Address::CopyFrom(uint8_t const * buffer) [member function]
    cls.add_method('CopyFrom',
                   'void',
                   [param('uint8_t const *', 'buffer')])
    ## mac64-address.h (module 'network'): void ns3::Mac64Address::CopyTo(uint8_t * buffer) const [member function]
    cls.add_method('CopyTo',
                   'void',
                   [param('uint8_t *', 'buffer')],
                   is_const=True)
    ## mac64-address.h (module 'network'): static bool ns3::Mac64Address::IsMatchingType(ns3::Address const & address) [member function]
    cls.add_method('IsMatchingType',
                   'bool',
                   [param('ns3::Address const &', 'address')],
                   is_static=True)
    return

def register_Ns3Mac8Address_methods(root_module, cls):
    cls.add_binary_comparison_operator('<')
    cls.add_binary_comparison_operator('==')
    cls.add_binary_comparison_operator('!=')
    cls.add_output_stream_operator()
    ## mac8-address.h (module 'network'): ns3::Mac8Address::Mac8Address(ns3::Mac8Address const & arg0) [constructor]
    cls.add_constructor([param('ns3::Mac8Address const &', 'arg0')])
    ## mac8-address.h (module 'network'): ns3::Mac8Address::Mac8Address() [constructor]
    cls.add_constructor([])
    ## mac8-address.h (module 'network'): ns3::Mac8Address::Mac8Address(uint8_t addr) [constructor]
    cls.add_constructor([param('uint8_t', 'addr')])
    ## mac8-address.h (module 'network'): static ns3::Mac8Address ns3::Mac8Address::Allocate() [member function]
    cls.add_method('Allocate',
                   'ns3::Mac8Address',
                   [],
                   is_static=True)
    ## mac8-address.h (module 'network'): static ns3::Mac8Address ns3::Mac8Address::ConvertFrom(ns3::Address const & address) [member function]
    cls.add_method('ConvertFrom',
                   'ns3::Mac8Address',
                   [param('ns3::Address const &', 'address')],
                   is_static=True)
    ## mac8-address.h (module 'network'): void ns3::Mac8Address::CopyFrom(uint8_t const * pBuffer) [member function]
    cls.add_method('CopyFrom',
                   'void',
                   [param('uint8_t const *', 'pBuffer')])
    ## mac8-address.h (module 'network'): void ns3::Mac8Address::CopyTo(uint8_t * pBuffer) const [member function]
    cls.add_method('CopyTo',
                   'void',
                   [param('uint8_t *', 'pBuffer')],
                   is_const=True)
    ## mac8-address.h (module 'network'): static ns3::Mac8Address ns3::Mac8Address::GetBroadcast() [member function]
    cls.add_method('GetBroadcast',
                   'ns3::Mac8Address',
                   [],
                   is_static=True)
    ## mac8-address.h (module 'network'): static bool ns3::Mac8Address::IsMatchingType(ns3::Address const & address) [member function]
    cls.add_method('IsMatchingType',
                   'bool',
                   [param('ns3::Address const &', 'address')],
                   is_static=True)
    return

def register_Ns3MacCeListElement_s_methods(root_module, cls):
    ## ff-mac-common.h (module 'lte'): ns3::MacCeListElement_s::MacCeListElement_s() [constructor]
    cls.add_constructor([])
    ## ff-mac-common.h (module 'lte'): ns3::MacCeListElement_s::MacCeListElement_s(ns3::MacCeListElement_s const & arg0) [constructor]
    cls.add_constructor([param('ns3::MacCeListElement_s const &', 'arg0')])
    ## ff-mac-common.h (module 'lte'): ns3::MacCeListElement_s::m_macCeType [variable]
    cls.add_instance_attribute('m_macCeType', 'ns3::MacCeListElement_s::MacCeType_e', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::MacCeListElement_s::m_macCeValue [variable]
    cls.add_instance_attribute('m_macCeValue', 'ns3::MacCeValue_u', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::MacCeListElement_s::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    return

def register_Ns3MacCeValue_u_methods(root_module, cls):
    ## ff-mac-common.h (module 'lte'): ns3::MacCeValue_u::MacCeValue_u() [constructor]
    cls.add_constructor([])
    ## ff-mac-common.h (module 'lte'): ns3::MacCeValue_u::MacCeValue_u(ns3::MacCeValue_u const & arg0) [constructor]
    cls.add_constructor([param('ns3::MacCeValue_u const &', 'arg0')])
    ## ff-mac-common.h (module 'lte'): ns3::MacCeValue_u::m_bufferStatus [variable]
    cls.add_instance_attribute('m_bufferStatus', 'std::vector< unsigned char >', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::MacCeValue_u::m_crnti [variable]
    cls.add_instance_attribute('m_crnti', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::MacCeValue_u::m_phr [variable]
    cls.add_instance_attribute('m_phr', 'uint8_t', is_const=False)
    return

def register_Ns3Names_methods(root_module, cls):
    ## names.h (module 'core'): ns3::Names::Names() [constructor]
    cls.add_constructor([])
    ## names.h (module 'core'): ns3::Names::Names(ns3::Names const & arg0) [constructor]
    cls.add_constructor([param('ns3::Names const &', 'arg0')])
    ## names.h (module 'core'): static void ns3::Names::Add(std::string name, ns3::Ptr<ns3::Object> object) [member function]
    cls.add_method('Add',
                   'void',
                   [param('std::string', 'name'), param('ns3::Ptr< ns3::Object >', 'object')],
                   is_static=True)
    ## names.h (module 'core'): static void ns3::Names::Add(std::string path, std::string name, ns3::Ptr<ns3::Object> object) [member function]
    cls.add_method('Add',
                   'void',
                   [param('std::string', 'path'), param('std::string', 'name'), param('ns3::Ptr< ns3::Object >', 'object')],
                   is_static=True)
    ## names.h (module 'core'): static void ns3::Names::Add(ns3::Ptr<ns3::Object> context, std::string name, ns3::Ptr<ns3::Object> object) [member function]
    cls.add_method('Add',
                   'void',
                   [param('ns3::Ptr< ns3::Object >', 'context'), param('std::string', 'name'), param('ns3::Ptr< ns3::Object >', 'object')],
                   is_static=True)
    ## names.h (module 'core'): static void ns3::Names::Clear() [member function]
    cls.add_method('Clear',
                   'void',
                   [],
                   is_static=True)
    ## names.h (module 'core'): static std::string ns3::Names::FindName(ns3::Ptr<ns3::Object> object) [member function]
    cls.add_method('FindName',
                   'std::string',
                   [param('ns3::Ptr< ns3::Object >', 'object')],
                   is_static=True)
    ## names.h (module 'core'): static std::string ns3::Names::FindPath(ns3::Ptr<ns3::Object> object) [member function]
    cls.add_method('FindPath',
                   'std::string',
                   [param('ns3::Ptr< ns3::Object >', 'object')],
                   is_static=True)
    ## names.h (module 'core'): static void ns3::Names::Rename(std::string oldpath, std::string newname) [member function]
    cls.add_method('Rename',
                   'void',
                   [param('std::string', 'oldpath'), param('std::string', 'newname')],
                   is_static=True)
    ## names.h (module 'core'): static void ns3::Names::Rename(std::string path, std::string oldname, std::string newname) [member function]
    cls.add_method('Rename',
                   'void',
                   [param('std::string', 'path'), param('std::string', 'oldname'), param('std::string', 'newname')],
                   is_static=True)
    ## names.h (module 'core'): static void ns3::Names::Rename(ns3::Ptr<ns3::Object> context, std::string oldname, std::string newname) [member function]
    cls.add_method('Rename',
                   'void',
                   [param('ns3::Ptr< ns3::Object >', 'context'), param('std::string', 'oldname'), param('std::string', 'newname')],
                   is_static=True)
    return

def register_Ns3NetDeviceContainer_methods(root_module, cls):
    ## net-device-container.h (module 'network'): ns3::NetDeviceContainer::NetDeviceContainer(ns3::NetDeviceContainer const & arg0) [constructor]
    cls.add_constructor([param('ns3::NetDeviceContainer const &', 'arg0')])
    ## net-device-container.h (module 'network'): ns3::NetDeviceContainer::NetDeviceContainer() [constructor]
    cls.add_constructor([])
    ## net-device-container.h (module 'network'): ns3::NetDeviceContainer::NetDeviceContainer(ns3::Ptr<ns3::NetDevice> dev) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::NetDevice >', 'dev')])
    ## net-device-container.h (module 'network'): ns3::NetDeviceContainer::NetDeviceContainer(std::string devName) [constructor]
    cls.add_constructor([param('std::string', 'devName')])
    ## net-device-container.h (module 'network'): ns3::NetDeviceContainer::NetDeviceContainer(ns3::NetDeviceContainer const & a, ns3::NetDeviceContainer const & b) [constructor]
    cls.add_constructor([param('ns3::NetDeviceContainer const &', 'a'), param('ns3::NetDeviceContainer const &', 'b')])
    ## net-device-container.h (module 'network'): void ns3::NetDeviceContainer::Add(ns3::NetDeviceContainer other) [member function]
    cls.add_method('Add',
                   'void',
                   [param('ns3::NetDeviceContainer', 'other')])
    ## net-device-container.h (module 'network'): void ns3::NetDeviceContainer::Add(ns3::Ptr<ns3::NetDevice> device) [member function]
    cls.add_method('Add',
                   'void',
                   [param('ns3::Ptr< ns3::NetDevice >', 'device')])
    ## net-device-container.h (module 'network'): void ns3::NetDeviceContainer::Add(std::string deviceName) [member function]
    cls.add_method('Add',
                   'void',
                   [param('std::string', 'deviceName')])
    ## net-device-container.h (module 'network'): ns3::NetDeviceContainer::Iterator ns3::NetDeviceContainer::Begin() const [member function]
    cls.add_method('Begin',
                   'ns3::NetDeviceContainer::Iterator',
                   [],
                   is_const=True)
    ## net-device-container.h (module 'network'): ns3::NetDeviceContainer::Iterator ns3::NetDeviceContainer::End() const [member function]
    cls.add_method('End',
                   'ns3::NetDeviceContainer::Iterator',
                   [],
                   is_const=True)
    ## net-device-container.h (module 'network'): ns3::Ptr<ns3::NetDevice> ns3::NetDeviceContainer::Get(uint32_t i) const [member function]
    cls.add_method('Get',
                   'ns3::Ptr< ns3::NetDevice >',
                   [param('uint32_t', 'i')],
                   is_const=True)
    ## net-device-container.h (module 'network'): uint32_t ns3::NetDeviceContainer::GetN() const [member function]
    cls.add_method('GetN',
                   'uint32_t',
                   [],
                   is_const=True)
    return

def register_Ns3NodeContainer_methods(root_module, cls):
    ## node-container.h (module 'network'): ns3::NodeContainer::NodeContainer(ns3::NodeContainer const & arg0) [constructor]
    cls.add_constructor([param('ns3::NodeContainer const &', 'arg0')])
    ## node-container.h (module 'network'): ns3::NodeContainer::NodeContainer() [constructor]
    cls.add_constructor([])
    ## node-container.h (module 'network'): ns3::NodeContainer::NodeContainer(ns3::Ptr<ns3::Node> node) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::Node >', 'node')])
    ## node-container.h (module 'network'): ns3::NodeContainer::NodeContainer(std::string nodeName) [constructor]
    cls.add_constructor([param('std::string', 'nodeName')])
    ## node-container.h (module 'network'): ns3::NodeContainer::NodeContainer(ns3::NodeContainer const & a, ns3::NodeContainer const & b) [constructor]
    cls.add_constructor([param('ns3::NodeContainer const &', 'a'), param('ns3::NodeContainer const &', 'b')])
    ## node-container.h (module 'network'): ns3::NodeContainer::NodeContainer(ns3::NodeContainer const & a, ns3::NodeContainer const & b, ns3::NodeContainer const & c) [constructor]
    cls.add_constructor([param('ns3::NodeContainer const &', 'a'), param('ns3::NodeContainer const &', 'b'), param('ns3::NodeContainer const &', 'c')])
    ## node-container.h (module 'network'): ns3::NodeContainer::NodeContainer(ns3::NodeContainer const & a, ns3::NodeContainer const & b, ns3::NodeContainer const & c, ns3::NodeContainer const & d) [constructor]
    cls.add_constructor([param('ns3::NodeContainer const &', 'a'), param('ns3::NodeContainer const &', 'b'), param('ns3::NodeContainer const &', 'c'), param('ns3::NodeContainer const &', 'd')])
    ## node-container.h (module 'network'): ns3::NodeContainer::NodeContainer(ns3::NodeContainer const & a, ns3::NodeContainer const & b, ns3::NodeContainer const & c, ns3::NodeContainer const & d, ns3::NodeContainer const & e) [constructor]
    cls.add_constructor([param('ns3::NodeContainer const &', 'a'), param('ns3::NodeContainer const &', 'b'), param('ns3::NodeContainer const &', 'c'), param('ns3::NodeContainer const &', 'd'), param('ns3::NodeContainer const &', 'e')])
    ## node-container.h (module 'network'): void ns3::NodeContainer::Add(ns3::NodeContainer other) [member function]
    cls.add_method('Add',
                   'void',
                   [param('ns3::NodeContainer', 'other')])
    ## node-container.h (module 'network'): void ns3::NodeContainer::Add(ns3::Ptr<ns3::Node> node) [member function]
    cls.add_method('Add',
                   'void',
                   [param('ns3::Ptr< ns3::Node >', 'node')])
    ## node-container.h (module 'network'): void ns3::NodeContainer::Add(std::string nodeName) [member function]
    cls.add_method('Add',
                   'void',
                   [param('std::string', 'nodeName')])
    ## node-container.h (module 'network'): ns3::NodeContainer::Iterator ns3::NodeContainer::Begin() const [member function]
    cls.add_method('Begin',
                   'ns3::NodeContainer::Iterator',
                   [],
                   is_const=True)
    ## node-container.h (module 'network'): bool ns3::NodeContainer::Contains(uint32_t id) const [member function]
    cls.add_method('Contains',
                   'bool',
                   [param('uint32_t', 'id')],
                   is_const=True)
    ## node-container.h (module 'network'): void ns3::NodeContainer::Create(uint32_t n) [member function]
    cls.add_method('Create',
                   'void',
                   [param('uint32_t', 'n')])
    ## node-container.h (module 'network'): void ns3::NodeContainer::Create(uint32_t n, uint32_t systemId) [member function]
    cls.add_method('Create',
                   'void',
                   [param('uint32_t', 'n'), param('uint32_t', 'systemId')])
    ## node-container.h (module 'network'): ns3::NodeContainer::Iterator ns3::NodeContainer::End() const [member function]
    cls.add_method('End',
                   'ns3::NodeContainer::Iterator',
                   [],
                   is_const=True)
    ## node-container.h (module 'network'): ns3::Ptr<ns3::Node> ns3::NodeContainer::Get(uint32_t i) const [member function]
    cls.add_method('Get',
                   'ns3::Ptr< ns3::Node >',
                   [param('uint32_t', 'i')],
                   is_const=True)
    ## node-container.h (module 'network'): static ns3::NodeContainer ns3::NodeContainer::GetGlobal() [member function]
    cls.add_method('GetGlobal',
                   'ns3::NodeContainer',
                   [],
                   is_static=True)
    ## node-container.h (module 'network'): uint32_t ns3::NodeContainer::GetN() const [member function]
    cls.add_method('GetN',
                   'uint32_t',
                   [],
                   is_const=True)
    return

def register_Ns3ObjectBase_methods(root_module, cls):
    ## object-base.h (module 'core'): ns3::ObjectBase::ObjectBase() [constructor]
    cls.add_constructor([])
    ## object-base.h (module 'core'): ns3::ObjectBase::ObjectBase(ns3::ObjectBase const & arg0) [constructor]
    cls.add_constructor([param('ns3::ObjectBase const &', 'arg0')])
    ## object-base.h (module 'core'): void ns3::ObjectBase::GetAttribute(std::string name, ns3::AttributeValue & value) const [member function]
    cls.add_method('GetAttribute',
                   'void',
                   [param('std::string', 'name'), param('ns3::AttributeValue &', 'value')],
                   is_const=True)
    ## object-base.h (module 'core'): bool ns3::ObjectBase::GetAttributeFailSafe(std::string name, ns3::AttributeValue & value) const [member function]
    cls.add_method('GetAttributeFailSafe',
                   'bool',
                   [param('std::string', 'name'), param('ns3::AttributeValue &', 'value')],
                   is_const=True)
    ## object-base.h (module 'core'): ns3::TypeId ns3::ObjectBase::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId',
                   'ns3::TypeId',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## object-base.h (module 'core'): static ns3::TypeId ns3::ObjectBase::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## object-base.h (module 'core'): void ns3::ObjectBase::SetAttribute(std::string name, ns3::AttributeValue const & value) [member function]
    cls.add_method('SetAttribute',
                   'void',
                   [param('std::string', 'name'), param('ns3::AttributeValue const &', 'value')])
    ## object-base.h (module 'core'): bool ns3::ObjectBase::SetAttributeFailSafe(std::string name, ns3::AttributeValue const & value) [member function]
    cls.add_method('SetAttributeFailSafe',
                   'bool',
                   [param('std::string', 'name'), param('ns3::AttributeValue const &', 'value')])
    ## object-base.h (module 'core'): bool ns3::ObjectBase::TraceConnect(std::string name, std::string context, ns3::CallbackBase const & cb) [member function]
    cls.add_method('TraceConnect',
                   'bool',
                   [param('std::string', 'name'), param('std::string', 'context'), param('ns3::CallbackBase const &', 'cb')])
    ## object-base.h (module 'core'): bool ns3::ObjectBase::TraceConnectWithoutContext(std::string name, ns3::CallbackBase const & cb) [member function]
    cls.add_method('TraceConnectWithoutContext',
                   'bool',
                   [param('std::string', 'name'), param('ns3::CallbackBase const &', 'cb')])
    ## object-base.h (module 'core'): bool ns3::ObjectBase::TraceDisconnect(std::string name, std::string context, ns3::CallbackBase const & cb) [member function]
    cls.add_method('TraceDisconnect',
                   'bool',
                   [param('std::string', 'name'), param('std::string', 'context'), param('ns3::CallbackBase const &', 'cb')])
    ## object-base.h (module 'core'): bool ns3::ObjectBase::TraceDisconnectWithoutContext(std::string name, ns3::CallbackBase const & cb) [member function]
    cls.add_method('TraceDisconnectWithoutContext',
                   'bool',
                   [param('std::string', 'name'), param('ns3::CallbackBase const &', 'cb')])
    ## object-base.h (module 'core'): void ns3::ObjectBase::ConstructSelf(ns3::AttributeConstructionList const & attributes) [member function]
    cls.add_method('ConstructSelf',
                   'void',
                   [param('ns3::AttributeConstructionList const &', 'attributes')],
                   visibility='protected')
    ## object-base.h (module 'core'): void ns3::ObjectBase::NotifyConstructionCompleted() [member function]
    cls.add_method('NotifyConstructionCompleted',
                   'void',
                   [],
                   visibility='protected', is_virtual=True)
    return

def register_Ns3ObjectDeleter_methods(root_module, cls):
    ## object.h (module 'core'): ns3::ObjectDeleter::ObjectDeleter() [constructor]
    cls.add_constructor([])
    ## object.h (module 'core'): ns3::ObjectDeleter::ObjectDeleter(ns3::ObjectDeleter const & arg0) [constructor]
    cls.add_constructor([param('ns3::ObjectDeleter const &', 'arg0')])
    ## object.h (module 'core'): static void ns3::ObjectDeleter::Delete(ns3::Object * object) [member function]
    cls.add_method('Delete',
                   'void',
                   [param('ns3::Object *', 'object')],
                   is_static=True)
    return

def register_Ns3ObjectFactory_methods(root_module, cls):
    cls.add_output_stream_operator()
    ## object-factory.h (module 'core'): ns3::ObjectFactory::ObjectFactory(ns3::ObjectFactory const & arg0) [constructor]
    cls.add_constructor([param('ns3::ObjectFactory const &', 'arg0')])
    ## object-factory.h (module 'core'): ns3::ObjectFactory::ObjectFactory() [constructor]
    cls.add_constructor([])
    ## object-factory.h (module 'core'): ns3::ObjectFactory::ObjectFactory(std::string typeId) [constructor]
    cls.add_constructor([param('std::string', 'typeId')])
    ## object-factory.h (module 'core'): ns3::Ptr<ns3::Object> ns3::ObjectFactory::Create() const [member function]
    cls.add_method('Create',
                   'ns3::Ptr< ns3::Object >',
                   [],
                   is_const=True)
    ## object-factory.h (module 'core'): ns3::TypeId ns3::ObjectFactory::GetTypeId() const [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_const=True)
    ## object-factory.h (module 'core'): void ns3::ObjectFactory::Set(std::string name, ns3::AttributeValue const & value) [member function]
    cls.add_method('Set',
                   'void',
                   [param('std::string', 'name'), param('ns3::AttributeValue const &', 'value')])
    ## object-factory.h (module 'core'): void ns3::ObjectFactory::SetTypeId(ns3::TypeId tid) [member function]
    cls.add_method('SetTypeId',
                   'void',
                   [param('ns3::TypeId', 'tid')])
    ## object-factory.h (module 'core'): void ns3::ObjectFactory::SetTypeId(char const * tid) [member function]
    cls.add_method('SetTypeId',
                   'void',
                   [param('char const *', 'tid')])
    ## object-factory.h (module 'core'): void ns3::ObjectFactory::SetTypeId(std::string tid) [member function]
    cls.add_method('SetTypeId',
                   'void',
                   [param('std::string', 'tid')])
    return

def register_Ns3PacketMetadata_methods(root_module, cls):
    ## packet-metadata.h (module 'network'): ns3::PacketMetadata::PacketMetadata(uint64_t uid, uint32_t size) [constructor]
    cls.add_constructor([param('uint64_t', 'uid'), param('uint32_t', 'size')])
    ## packet-metadata.h (module 'network'): ns3::PacketMetadata::PacketMetadata(ns3::PacketMetadata const & o) [constructor]
    cls.add_constructor([param('ns3::PacketMetadata const &', 'o')])
    ## packet-metadata.h (module 'network'): void ns3::PacketMetadata::AddAtEnd(ns3::PacketMetadata const & o) [member function]
    cls.add_method('AddAtEnd',
                   'void',
                   [param('ns3::PacketMetadata const &', 'o')])
    ## packet-metadata.h (module 'network'): void ns3::PacketMetadata::AddHeader(ns3::Header const & header, uint32_t size) [member function]
    cls.add_method('AddHeader',
                   'void',
                   [param('ns3::Header const &', 'header'), param('uint32_t', 'size')])
    ## packet-metadata.h (module 'network'): void ns3::PacketMetadata::AddPaddingAtEnd(uint32_t end) [member function]
    cls.add_method('AddPaddingAtEnd',
                   'void',
                   [param('uint32_t', 'end')])
    ## packet-metadata.h (module 'network'): void ns3::PacketMetadata::AddTrailer(ns3::Trailer const & trailer, uint32_t size) [member function]
    cls.add_method('AddTrailer',
                   'void',
                   [param('ns3::Trailer const &', 'trailer'), param('uint32_t', 'size')])
    ## packet-metadata.h (module 'network'): ns3::PacketMetadata::ItemIterator ns3::PacketMetadata::BeginItem(ns3::Buffer buffer) const [member function]
    cls.add_method('BeginItem',
                   'ns3::PacketMetadata::ItemIterator',
                   [param('ns3::Buffer', 'buffer')],
                   is_const=True)
    ## packet-metadata.h (module 'network'): ns3::PacketMetadata ns3::PacketMetadata::CreateFragment(uint32_t start, uint32_t end) const [member function]
    cls.add_method('CreateFragment',
                   'ns3::PacketMetadata',
                   [param('uint32_t', 'start'), param('uint32_t', 'end')],
                   is_const=True)
    ## packet-metadata.h (module 'network'): uint32_t ns3::PacketMetadata::Deserialize(uint8_t const * buffer, uint32_t size) [member function]
    cls.add_method('Deserialize',
                   'uint32_t',
                   [param('uint8_t const *', 'buffer'), param('uint32_t', 'size')])
    ## packet-metadata.h (module 'network'): static void ns3::PacketMetadata::Enable() [member function]
    cls.add_method('Enable',
                   'void',
                   [],
                   is_static=True)
    ## packet-metadata.h (module 'network'): static void ns3::PacketMetadata::EnableChecking() [member function]
    cls.add_method('EnableChecking',
                   'void',
                   [],
                   is_static=True)
    ## packet-metadata.h (module 'network'): uint32_t ns3::PacketMetadata::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize',
                   'uint32_t',
                   [],
                   is_const=True)
    ## packet-metadata.h (module 'network'): uint64_t ns3::PacketMetadata::GetUid() const [member function]
    cls.add_method('GetUid',
                   'uint64_t',
                   [],
                   is_const=True)
    ## packet-metadata.h (module 'network'): void ns3::PacketMetadata::RemoveAtEnd(uint32_t end) [member function]
    cls.add_method('RemoveAtEnd',
                   'void',
                   [param('uint32_t', 'end')])
    ## packet-metadata.h (module 'network'): void ns3::PacketMetadata::RemoveAtStart(uint32_t start) [member function]
    cls.add_method('RemoveAtStart',
                   'void',
                   [param('uint32_t', 'start')])
    ## packet-metadata.h (module 'network'): void ns3::PacketMetadata::RemoveHeader(ns3::Header const & header, uint32_t size) [member function]
    cls.add_method('RemoveHeader',
                   'void',
                   [param('ns3::Header const &', 'header'), param('uint32_t', 'size')])
    ## packet-metadata.h (module 'network'): void ns3::PacketMetadata::RemoveTrailer(ns3::Trailer const & trailer, uint32_t size) [member function]
    cls.add_method('RemoveTrailer',
                   'void',
                   [param('ns3::Trailer const &', 'trailer'), param('uint32_t', 'size')])
    ## packet-metadata.h (module 'network'): uint32_t ns3::PacketMetadata::Serialize(uint8_t * buffer, uint32_t maxSize) const [member function]
    cls.add_method('Serialize',
                   'uint32_t',
                   [param('uint8_t *', 'buffer'), param('uint32_t', 'maxSize')],
                   is_const=True)
    return

def register_Ns3PacketMetadataItem_methods(root_module, cls):
    ## packet-metadata.h (module 'network'): ns3::PacketMetadata::Item::Item() [constructor]
    cls.add_constructor([])
    ## packet-metadata.h (module 'network'): ns3::PacketMetadata::Item::Item(ns3::PacketMetadata::Item const & arg0) [constructor]
    cls.add_constructor([param('ns3::PacketMetadata::Item const &', 'arg0')])
    ## packet-metadata.h (module 'network'): ns3::PacketMetadata::Item::current [variable]
    cls.add_instance_attribute('current', 'ns3::Buffer::Iterator', is_const=False)
    ## packet-metadata.h (module 'network'): ns3::PacketMetadata::Item::currentSize [variable]
    cls.add_instance_attribute('currentSize', 'uint32_t', is_const=False)
    ## packet-metadata.h (module 'network'): ns3::PacketMetadata::Item::currentTrimedFromEnd [variable]
    cls.add_instance_attribute('currentTrimedFromEnd', 'uint32_t', is_const=False)
    ## packet-metadata.h (module 'network'): ns3::PacketMetadata::Item::currentTrimedFromStart [variable]
    cls.add_instance_attribute('currentTrimedFromStart', 'uint32_t', is_const=False)
    ## packet-metadata.h (module 'network'): ns3::PacketMetadata::Item::isFragment [variable]
    cls.add_instance_attribute('isFragment', 'bool', is_const=False)
    ## packet-metadata.h (module 'network'): ns3::PacketMetadata::Item::tid [variable]
    cls.add_instance_attribute('tid', 'ns3::TypeId', is_const=False)
    ## packet-metadata.h (module 'network'): ns3::PacketMetadata::Item::type [variable]
    cls.add_instance_attribute('type', 'ns3::PacketMetadata::Item::ItemType', is_const=False)
    return

def register_Ns3PacketMetadataItemIterator_methods(root_module, cls):
    ## packet-metadata.h (module 'network'): ns3::PacketMetadata::ItemIterator::ItemIterator(ns3::PacketMetadata::ItemIterator const & arg0) [constructor]
    cls.add_constructor([param('ns3::PacketMetadata::ItemIterator const &', 'arg0')])
    ## packet-metadata.h (module 'network'): ns3::PacketMetadata::ItemIterator::ItemIterator(ns3::PacketMetadata const * metadata, ns3::Buffer buffer) [constructor]
    cls.add_constructor([param('ns3::PacketMetadata const *', 'metadata'), param('ns3::Buffer', 'buffer')])
    ## packet-metadata.h (module 'network'): bool ns3::PacketMetadata::ItemIterator::HasNext() const [member function]
    cls.add_method('HasNext',
                   'bool',
                   [],
                   is_const=True)
    ## packet-metadata.h (module 'network'): ns3::PacketMetadata::Item ns3::PacketMetadata::ItemIterator::Next() [member function]
    cls.add_method('Next',
                   'ns3::PacketMetadata::Item',
                   [])
    return

def register_Ns3PacketTagIterator_methods(root_module, cls):
    ## packet.h (module 'network'): ns3::PacketTagIterator::PacketTagIterator(ns3::PacketTagIterator const & arg0) [constructor]
    cls.add_constructor([param('ns3::PacketTagIterator const &', 'arg0')])
    ## packet.h (module 'network'): bool ns3::PacketTagIterator::HasNext() const [member function]
    cls.add_method('HasNext',
                   'bool',
                   [],
                   is_const=True)
    ## packet.h (module 'network'): ns3::PacketTagIterator::Item ns3::PacketTagIterator::Next() [member function]
    cls.add_method('Next',
                   'ns3::PacketTagIterator::Item',
                   [])
    return

def register_Ns3PacketTagIteratorItem_methods(root_module, cls):
    ## packet.h (module 'network'): ns3::PacketTagIterator::Item::Item(ns3::PacketTagIterator::Item const & arg0) [constructor]
    cls.add_constructor([param('ns3::PacketTagIterator::Item const &', 'arg0')])
    ## packet.h (module 'network'): void ns3::PacketTagIterator::Item::GetTag(ns3::Tag & tag) const [member function]
    cls.add_method('GetTag',
                   'void',
                   [param('ns3::Tag &', 'tag')],
                   is_const=True)
    ## packet.h (module 'network'): ns3::TypeId ns3::PacketTagIterator::Item::GetTypeId() const [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_const=True)
    return

def register_Ns3PacketTagList_methods(root_module, cls):
    ## packet-tag-list.h (module 'network'): ns3::PacketTagList::PacketTagList() [constructor]
    cls.add_constructor([])
    ## packet-tag-list.h (module 'network'): ns3::PacketTagList::PacketTagList(ns3::PacketTagList const & o) [constructor]
    cls.add_constructor([param('ns3::PacketTagList const &', 'o')])
    ## packet-tag-list.h (module 'network'): void ns3::PacketTagList::Add(ns3::Tag const & tag) const [member function]
    cls.add_method('Add',
                   'void',
                   [param('ns3::Tag const &', 'tag')],
                   is_const=True)
    ## packet-tag-list.h (module 'network'): ns3::PacketTagList::TagData const * ns3::PacketTagList::Head() const [member function]
    cls.add_method('Head',
                   'ns3::PacketTagList::TagData const *',
                   [],
                   is_const=True)
    ## packet-tag-list.h (module 'network'): bool ns3::PacketTagList::Peek(ns3::Tag & tag) const [member function]
    cls.add_method('Peek',
                   'bool',
                   [param('ns3::Tag &', 'tag')],
                   is_const=True)
    ## packet-tag-list.h (module 'network'): bool ns3::PacketTagList::Remove(ns3::Tag & tag) [member function]
    cls.add_method('Remove',
                   'bool',
                   [param('ns3::Tag &', 'tag')])
    ## packet-tag-list.h (module 'network'): void ns3::PacketTagList::RemoveAll() [member function]
    cls.add_method('RemoveAll',
                   'void',
                   [])
    ## packet-tag-list.h (module 'network'): bool ns3::PacketTagList::Replace(ns3::Tag & tag) [member function]
    cls.add_method('Replace',
                   'bool',
                   [param('ns3::Tag &', 'tag')])
    return

def register_Ns3PacketTagListTagData_methods(root_module, cls):
    ## packet-tag-list.h (module 'network'): ns3::PacketTagList::TagData::TagData() [constructor]
    cls.add_constructor([])
    ## packet-tag-list.h (module 'network'): ns3::PacketTagList::TagData::TagData(ns3::PacketTagList::TagData const & arg0) [constructor]
    cls.add_constructor([param('ns3::PacketTagList::TagData const &', 'arg0')])
    ## packet-tag-list.h (module 'network'): ns3::PacketTagList::TagData::count [variable]
    cls.add_instance_attribute('count', 'uint32_t', is_const=False)
    ## packet-tag-list.h (module 'network'): ns3::PacketTagList::TagData::data [variable]
    cls.add_instance_attribute('data', 'uint8_t [ 1 ]', is_const=False)
    ## packet-tag-list.h (module 'network'): ns3::PacketTagList::TagData::next [variable]
    cls.add_instance_attribute('next', 'ns3::PacketTagList::TagData *', is_const=False)
    ## packet-tag-list.h (module 'network'): ns3::PacketTagList::TagData::size [variable]
    cls.add_instance_attribute('size', 'uint32_t', is_const=False)
    ## packet-tag-list.h (module 'network'): ns3::PacketTagList::TagData::tid [variable]
    cls.add_instance_attribute('tid', 'ns3::TypeId', is_const=False)
    return

def register_Ns3PagingInfoListElement_s_methods(root_module, cls):
    ## ff-mac-common.h (module 'lte'): ns3::PagingInfoListElement_s::PagingInfoListElement_s() [constructor]
    cls.add_constructor([])
    ## ff-mac-common.h (module 'lte'): ns3::PagingInfoListElement_s::PagingInfoListElement_s(ns3::PagingInfoListElement_s const & arg0) [constructor]
    cls.add_constructor([param('ns3::PagingInfoListElement_s const &', 'arg0')])
    ## ff-mac-common.h (module 'lte'): ns3::PagingInfoListElement_s::m_pagingIndex [variable]
    cls.add_instance_attribute('m_pagingIndex', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::PagingInfoListElement_s::m_pagingMessageSize [variable]
    cls.add_instance_attribute('m_pagingMessageSize', 'uint16_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::PagingInfoListElement_s::m_pagingSubframe [variable]
    cls.add_instance_attribute('m_pagingSubframe', 'uint8_t', is_const=False)
    return

def register_Ns3ParameterLogger_methods(root_module, cls):
    ## log.h (module 'core'): ns3::ParameterLogger::ParameterLogger(ns3::ParameterLogger const & arg0) [constructor]
    cls.add_constructor([param('ns3::ParameterLogger const &', 'arg0')])
    ## log.h (module 'core'): ns3::ParameterLogger::ParameterLogger(std::ostream & os) [constructor]
    cls.add_constructor([param('std::ostream &', 'os')])
    return

def register_Ns3PhichListElement_s_methods(root_module, cls):
    ## ff-mac-common.h (module 'lte'): ns3::PhichListElement_s::PhichListElement_s() [constructor]
    cls.add_constructor([])
    ## ff-mac-common.h (module 'lte'): ns3::PhichListElement_s::PhichListElement_s(ns3::PhichListElement_s const & arg0) [constructor]
    cls.add_constructor([param('ns3::PhichListElement_s const &', 'arg0')])
    ## ff-mac-common.h (module 'lte'): ns3::PhichListElement_s::m_phich [variable]
    cls.add_instance_attribute('m_phich', 'ns3::PhichListElement_s::Phich_e', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::PhichListElement_s::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    return

def register_Ns3PhyReceptionStatParameters_methods(root_module, cls):
    ## lte-common.h (module 'lte'): ns3::PhyReceptionStatParameters::PhyReceptionStatParameters() [constructor]
    cls.add_constructor([])
    ## lte-common.h (module 'lte'): ns3::PhyReceptionStatParameters::PhyReceptionStatParameters(ns3::PhyReceptionStatParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::PhyReceptionStatParameters const &', 'arg0')])
    ## lte-common.h (module 'lte'): ns3::PhyReceptionStatParameters::m_ccId [variable]
    cls.add_instance_attribute('m_ccId', 'uint8_t', is_const=False)
    ## lte-common.h (module 'lte'): ns3::PhyReceptionStatParameters::m_cellId [variable]
    cls.add_instance_attribute('m_cellId', 'uint16_t', is_const=False)
    ## lte-common.h (module 'lte'): ns3::PhyReceptionStatParameters::m_correctness [variable]
    cls.add_instance_attribute('m_correctness', 'uint8_t', is_const=False)
    ## lte-common.h (module 'lte'): ns3::PhyReceptionStatParameters::m_imsi [variable]
    cls.add_instance_attribute('m_imsi', 'uint64_t', is_const=False)
    ## lte-common.h (module 'lte'): ns3::PhyReceptionStatParameters::m_layer [variable]
    cls.add_instance_attribute('m_layer', 'uint8_t', is_const=False)
    ## lte-common.h (module 'lte'): ns3::PhyReceptionStatParameters::m_mcs [variable]
    cls.add_instance_attribute('m_mcs', 'uint8_t', is_const=False)
    ## lte-common.h (module 'lte'): ns3::PhyReceptionStatParameters::m_ndi [variable]
    cls.add_instance_attribute('m_ndi', 'uint8_t', is_const=False)
    ## lte-common.h (module 'lte'): ns3::PhyReceptionStatParameters::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    ## lte-common.h (module 'lte'): ns3::PhyReceptionStatParameters::m_rv [variable]
    cls.add_instance_attribute('m_rv', 'uint8_t', is_const=False)
    ## lte-common.h (module 'lte'): ns3::PhyReceptionStatParameters::m_size [variable]
    cls.add_instance_attribute('m_size', 'uint16_t', is_const=False)
    ## lte-common.h (module 'lte'): ns3::PhyReceptionStatParameters::m_timestamp [variable]
    cls.add_instance_attribute('m_timestamp', 'int64_t', is_const=False)
    ## lte-common.h (module 'lte'): ns3::PhyReceptionStatParameters::m_txMode [variable]
    cls.add_instance_attribute('m_txMode', 'uint8_t', is_const=False)
    return

def register_Ns3PhyTransmissionStatParameters_methods(root_module, cls):
    ## lte-common.h (module 'lte'): ns3::PhyTransmissionStatParameters::PhyTransmissionStatParameters() [constructor]
    cls.add_constructor([])
    ## lte-common.h (module 'lte'): ns3::PhyTransmissionStatParameters::PhyTransmissionStatParameters(ns3::PhyTransmissionStatParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::PhyTransmissionStatParameters const &', 'arg0')])
    ## lte-common.h (module 'lte'): ns3::PhyTransmissionStatParameters::m_ccId [variable]
    cls.add_instance_attribute('m_ccId', 'uint8_t', is_const=False)
    ## lte-common.h (module 'lte'): ns3::PhyTransmissionStatParameters::m_cellId [variable]
    cls.add_instance_attribute('m_cellId', 'uint16_t', is_const=False)
    ## lte-common.h (module 'lte'): ns3::PhyTransmissionStatParameters::m_imsi [variable]
    cls.add_instance_attribute('m_imsi', 'uint64_t', is_const=False)
    ## lte-common.h (module 'lte'): ns3::PhyTransmissionStatParameters::m_layer [variable]
    cls.add_instance_attribute('m_layer', 'uint8_t', is_const=False)
    ## lte-common.h (module 'lte'): ns3::PhyTransmissionStatParameters::m_mcs [variable]
    cls.add_instance_attribute('m_mcs', 'uint8_t', is_const=False)
    ## lte-common.h (module 'lte'): ns3::PhyTransmissionStatParameters::m_ndi [variable]
    cls.add_instance_attribute('m_ndi', 'uint8_t', is_const=False)
    ## lte-common.h (module 'lte'): ns3::PhyTransmissionStatParameters::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    ## lte-common.h (module 'lte'): ns3::PhyTransmissionStatParameters::m_rv [variable]
    cls.add_instance_attribute('m_rv', 'uint8_t', is_const=False)
    ## lte-common.h (module 'lte'): ns3::PhyTransmissionStatParameters::m_size [variable]
    cls.add_instance_attribute('m_size', 'uint16_t', is_const=False)
    ## lte-common.h (module 'lte'): ns3::PhyTransmissionStatParameters::m_timestamp [variable]
    cls.add_instance_attribute('m_timestamp', 'int64_t', is_const=False)
    ## lte-common.h (module 'lte'): ns3::PhyTransmissionStatParameters::m_txMode [variable]
    cls.add_instance_attribute('m_txMode', 'uint8_t', is_const=False)
    return

def register_Ns3QueueSize_methods(root_module, cls):
    cls.add_output_stream_operator()
    cls.add_binary_comparison_operator('!=')
    cls.add_binary_comparison_operator('<')
    cls.add_binary_comparison_operator('<=')
    cls.add_binary_comparison_operator('==')
    cls.add_binary_comparison_operator('>')
    cls.add_binary_comparison_operator('>=')
    ## queue-size.h (module 'network'): ns3::QueueSize::QueueSize(ns3::QueueSize const & arg0) [constructor]
    cls.add_constructor([param('ns3::QueueSize const &', 'arg0')])
    ## queue-size.h (module 'network'): ns3::QueueSize::QueueSize() [constructor]
    cls.add_constructor([])
    ## queue-size.h (module 'network'): ns3::QueueSize::QueueSize(ns3::QueueSizeUnit unit, uint32_t value) [constructor]
    cls.add_constructor([param('ns3::QueueSizeUnit', 'unit'), param('uint32_t', 'value')])
    ## queue-size.h (module 'network'): ns3::QueueSize::QueueSize(std::string size) [constructor]
    cls.add_constructor([param('std::string', 'size')])
    ## queue-size.h (module 'network'): ns3::QueueSizeUnit ns3::QueueSize::GetUnit() const [member function]
    cls.add_method('GetUnit',
                   'ns3::QueueSizeUnit',
                   [],
                   is_const=True)
    ## queue-size.h (module 'network'): uint32_t ns3::QueueSize::GetValue() const [member function]
    cls.add_method('GetValue',
                   'uint32_t',
                   [],
                   is_const=True)
    return

def register_Ns3RachListElement_s_methods(root_module, cls):
    ## ff-mac-common.h (module 'lte'): ns3::RachListElement_s::RachListElement_s() [constructor]
    cls.add_constructor([])
    ## ff-mac-common.h (module 'lte'): ns3::RachListElement_s::RachListElement_s(ns3::RachListElement_s const & arg0) [constructor]
    cls.add_constructor([param('ns3::RachListElement_s const &', 'arg0')])
    ## ff-mac-common.h (module 'lte'): ns3::RachListElement_s::m_estimatedSize [variable]
    cls.add_instance_attribute('m_estimatedSize', 'uint16_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::RachListElement_s::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    return

def register_Ns3RlcPduListElement_s_methods(root_module, cls):
    ## ff-mac-common.h (module 'lte'): ns3::RlcPduListElement_s::RlcPduListElement_s() [constructor]
    cls.add_constructor([])
    ## ff-mac-common.h (module 'lte'): ns3::RlcPduListElement_s::RlcPduListElement_s(ns3::RlcPduListElement_s const & arg0) [constructor]
    cls.add_constructor([param('ns3::RlcPduListElement_s const &', 'arg0')])
    ## ff-mac-common.h (module 'lte'): ns3::RlcPduListElement_s::m_logicalChannelIdentity [variable]
    cls.add_instance_attribute('m_logicalChannelIdentity', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::RlcPduListElement_s::m_size [variable]
    cls.add_instance_attribute('m_size', 'uint16_t', is_const=False)
    return

def register_Ns3SbMeasResult_s_methods(root_module, cls):
    ## ff-mac-common.h (module 'lte'): ns3::SbMeasResult_s::SbMeasResult_s() [constructor]
    cls.add_constructor([])
    ## ff-mac-common.h (module 'lte'): ns3::SbMeasResult_s::SbMeasResult_s(ns3::SbMeasResult_s const & arg0) [constructor]
    cls.add_constructor([param('ns3::SbMeasResult_s const &', 'arg0')])
    ## ff-mac-common.h (module 'lte'): ns3::SbMeasResult_s::m_bwPart [variable]
    cls.add_instance_attribute('m_bwPart', 'ns3::BwPart_s', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::SbMeasResult_s::m_higherLayerSelected [variable]
    cls.add_instance_attribute('m_higherLayerSelected', 'std::vector< ns3::HigherLayerSelected_s >', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::SbMeasResult_s::m_ueSelected [variable]
    cls.add_instance_attribute('m_ueSelected', 'ns3::UeSelected_s', is_const=False)
    return

def register_Ns3SequenceNumber10_methods(root_module, cls):
    cls.add_output_stream_operator()
    cls.add_binary_comparison_operator('!=')
    cls.add_binary_numeric_operator('+', root_module['ns3::SequenceNumber10'], root_module['ns3::SequenceNumber10'], param('uint16_t', u'right'))
    cls.add_binary_numeric_operator('-', root_module['ns3::SequenceNumber10'], root_module['ns3::SequenceNumber10'], param('uint16_t', u'right'))
    cls.add_binary_comparison_operator('<')
    cls.add_binary_comparison_operator('<=')
    cls.add_binary_comparison_operator('==')
    cls.add_binary_comparison_operator('>')
    cls.add_binary_comparison_operator('>=')
    ## lte-rlc-sequence-number.h (module 'lte'): ns3::SequenceNumber10::SequenceNumber10() [constructor]
    cls.add_constructor([])
    ## lte-rlc-sequence-number.h (module 'lte'): ns3::SequenceNumber10::SequenceNumber10(uint16_t value) [constructor]
    cls.add_constructor([param('uint16_t', 'value')])
    ## lte-rlc-sequence-number.h (module 'lte'): ns3::SequenceNumber10::SequenceNumber10(ns3::SequenceNumber10 const & value) [constructor]
    cls.add_constructor([param('ns3::SequenceNumber10 const &', 'value')])
    ## lte-rlc-sequence-number.h (module 'lte'): uint16_t ns3::SequenceNumber10::GetValue() const [member function]
    cls.add_method('GetValue',
                   'uint16_t',
                   [],
                   is_const=True)
    ## lte-rlc-sequence-number.h (module 'lte'): void ns3::SequenceNumber10::SetModulusBase(ns3::SequenceNumber10 modulusBase) [member function]
    cls.add_method('SetModulusBase',
                   'void',
                   [param('ns3::SequenceNumber10', 'modulusBase')])
    ## lte-rlc-sequence-number.h (module 'lte'): void ns3::SequenceNumber10::SetModulusBase(uint16_t modulusBase) [member function]
    cls.add_method('SetModulusBase',
                   'void',
                   [param('uint16_t', 'modulusBase')])
    return

def register_Ns3SiConfiguration_s_methods(root_module, cls):
    ## ff-mac-common.h (module 'lte'): ns3::SiConfiguration_s::SiConfiguration_s() [constructor]
    cls.add_constructor([])
    ## ff-mac-common.h (module 'lte'): ns3::SiConfiguration_s::SiConfiguration_s(ns3::SiConfiguration_s const & arg0) [constructor]
    cls.add_constructor([param('ns3::SiConfiguration_s const &', 'arg0')])
    ## ff-mac-common.h (module 'lte'): ns3::SiConfiguration_s::m_sfn [variable]
    cls.add_instance_attribute('m_sfn', 'uint16_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::SiConfiguration_s::m_siMessageList [variable]
    cls.add_instance_attribute('m_siMessageList', 'std::vector< ns3::SiMessageListElement_s >', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::SiConfiguration_s::m_siWindowLength [variable]
    cls.add_instance_attribute('m_siWindowLength', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::SiConfiguration_s::m_sib1Length [variable]
    cls.add_instance_attribute('m_sib1Length', 'uint16_t', is_const=False)
    return

def register_Ns3SiMessageListElement_s_methods(root_module, cls):
    ## ff-mac-common.h (module 'lte'): ns3::SiMessageListElement_s::SiMessageListElement_s() [constructor]
    cls.add_constructor([])
    ## ff-mac-common.h (module 'lte'): ns3::SiMessageListElement_s::SiMessageListElement_s(ns3::SiMessageListElement_s const & arg0) [constructor]
    cls.add_constructor([param('ns3::SiMessageListElement_s const &', 'arg0')])
    ## ff-mac-common.h (module 'lte'): ns3::SiMessageListElement_s::m_length [variable]
    cls.add_instance_attribute('m_length', 'uint16_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::SiMessageListElement_s::m_periodicity [variable]
    cls.add_instance_attribute('m_periodicity', 'uint16_t', is_const=False)
    return

def register_Ns3SimpleRefCount__Ns3Object_Ns3ObjectBase_Ns3ObjectDeleter_methods(root_module, cls):
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::Object, ns3::ObjectBase, ns3::ObjectDeleter>::SimpleRefCount() [constructor]
    cls.add_constructor([])
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::Object, ns3::ObjectBase, ns3::ObjectDeleter>::SimpleRefCount(ns3::SimpleRefCount<ns3::Object, ns3::ObjectBase, ns3::ObjectDeleter> const & o) [constructor]
    cls.add_constructor([param('ns3::SimpleRefCount< ns3::Object, ns3::ObjectBase, ns3::ObjectDeleter > const &', 'o')])
    return

def register_Ns3Simulator_methods(root_module, cls):
    ## simulator.h (module 'core'): ns3::Simulator::Simulator(ns3::Simulator const & arg0) [constructor]
    cls.add_constructor([param('ns3::Simulator const &', 'arg0')])
    ## simulator.h (module 'core'): static void ns3::Simulator::Cancel(ns3::EventId const & id) [member function]
    cls.add_method('Cancel',
                   'void',
                   [param('ns3::EventId const &', 'id')],
                   is_static=True)
    ## simulator.h (module 'core'): static void ns3::Simulator::Destroy() [member function]
    cls.add_method('Destroy',
                   'void',
                   [],
                   is_static=True)
    ## simulator.h (module 'core'): static uint32_t ns3::Simulator::GetContext() [member function]
    cls.add_method('GetContext',
                   'uint32_t',
                   [],
                   is_static=True)
    ## simulator.h (module 'core'): static ns3::Time ns3::Simulator::GetDelayLeft(ns3::EventId const & id) [member function]
    cls.add_method('GetDelayLeft',
                   'ns3::Time',
                   [param('ns3::EventId const &', 'id')],
                   is_static=True)
    ## simulator.h (module 'core'): static ns3::Ptr<ns3::SimulatorImpl> ns3::Simulator::GetImplementation() [member function]
    cls.add_method('GetImplementation',
                   'ns3::Ptr< ns3::SimulatorImpl >',
                   [],
                   is_static=True)
    ## simulator.h (module 'core'): static ns3::Time ns3::Simulator::GetMaximumSimulationTime() [member function]
    cls.add_method('GetMaximumSimulationTime',
                   'ns3::Time',
                   [],
                   is_static=True)
    ## simulator.h (module 'core'): static uint32_t ns3::Simulator::GetSystemId() [member function]
    cls.add_method('GetSystemId',
                   'uint32_t',
                   [],
                   is_static=True)
    ## simulator.h (module 'core'): static bool ns3::Simulator::IsExpired(ns3::EventId const & id) [member function]
    cls.add_method('IsExpired',
                   'bool',
                   [param('ns3::EventId const &', 'id')],
                   is_static=True)
    ## simulator.h (module 'core'): static bool ns3::Simulator::IsFinished() [member function]
    cls.add_method('IsFinished',
                   'bool',
                   [],
                   is_static=True)
    ## simulator.h (module 'core'): static ns3::Time ns3::Simulator::Now() [member function]
    cls.add_method('Now',
                   'ns3::Time',
                   [],
                   is_static=True)
    ## simulator.h (module 'core'): static void ns3::Simulator::Remove(ns3::EventId const & id) [member function]
    cls.add_method('Remove',
                   'void',
                   [param('ns3::EventId const &', 'id')],
                   is_static=True)
    ## simulator.h (module 'core'): static void ns3::Simulator::SetImplementation(ns3::Ptr<ns3::SimulatorImpl> impl) [member function]
    cls.add_method('SetImplementation',
                   'void',
                   [param('ns3::Ptr< ns3::SimulatorImpl >', 'impl')],
                   is_static=True)
    ## simulator.h (module 'core'): static void ns3::Simulator::SetScheduler(ns3::ObjectFactory schedulerFactory) [member function]
    cls.add_method('SetScheduler',
                   'void',
                   [param('ns3::ObjectFactory', 'schedulerFactory')],
                   is_static=True)
    ## simulator.h (module 'core'): static void ns3::Simulator::Stop() [member function]
    cls.add_method('Stop',
                   'void',
                   [],
                   is_static=True)
    ## simulator.h (module 'core'): static void ns3::Simulator::Stop(ns3::Time const & delay) [member function]
    cls.add_method('Stop',
                   'void',
                   [param('ns3::Time const &', 'delay')],
                   is_static=True)
    return

def register_Ns3SpsConfig_s_methods(root_module, cls):
    ## ff-mac-common.h (module 'lte'): ns3::SpsConfig_s::SpsConfig_s() [constructor]
    cls.add_constructor([])
    ## ff-mac-common.h (module 'lte'): ns3::SpsConfig_s::SpsConfig_s(ns3::SpsConfig_s const & arg0) [constructor]
    cls.add_constructor([param('ns3::SpsConfig_s const &', 'arg0')])
    ## ff-mac-common.h (module 'lte'): ns3::SpsConfig_s::m_implicitReleaseAfter [variable]
    cls.add_instance_attribute('m_implicitReleaseAfter', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::SpsConfig_s::m_n1PucchAnPersistentList [variable]
    cls.add_instance_attribute('m_n1PucchAnPersistentList', 'std::vector< unsigned short >', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::SpsConfig_s::m_n1PucchAnPersistentListSize [variable]
    cls.add_instance_attribute('m_n1PucchAnPersistentListSize', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::SpsConfig_s::m_numberOfConfSpsProcesses [variable]
    cls.add_instance_attribute('m_numberOfConfSpsProcesses', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::SpsConfig_s::m_semiPersistSchedIntervalDl [variable]
    cls.add_instance_attribute('m_semiPersistSchedIntervalDl', 'uint16_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::SpsConfig_s::m_semiPersistSchedIntervalUl [variable]
    cls.add_instance_attribute('m_semiPersistSchedIntervalUl', 'uint16_t', is_const=False)
    return

def register_Ns3SrConfig_s_methods(root_module, cls):
    ## ff-mac-common.h (module 'lte'): ns3::SrConfig_s::SrConfig_s() [constructor]
    cls.add_constructor([])
    ## ff-mac-common.h (module 'lte'): ns3::SrConfig_s::SrConfig_s(ns3::SrConfig_s const & arg0) [constructor]
    cls.add_constructor([param('ns3::SrConfig_s const &', 'arg0')])
    ## ff-mac-common.h (module 'lte'): ns3::SrConfig_s::m_action [variable]
    cls.add_instance_attribute('m_action', 'ns3::SetupRelease_e', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::SrConfig_s::m_dsrTransMax [variable]
    cls.add_instance_attribute('m_dsrTransMax', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::SrConfig_s::m_schedInterval [variable]
    cls.add_instance_attribute('m_schedInterval', 'uint8_t', is_const=False)
    return

def register_Ns3SrListElement_s_methods(root_module, cls):
    ## ff-mac-common.h (module 'lte'): ns3::SrListElement_s::SrListElement_s() [constructor]
    cls.add_constructor([])
    ## ff-mac-common.h (module 'lte'): ns3::SrListElement_s::SrListElement_s(ns3::SrListElement_s const & arg0) [constructor]
    cls.add_constructor([param('ns3::SrListElement_s const &', 'arg0')])
    ## ff-mac-common.h (module 'lte'): ns3::SrListElement_s::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    return

def register_Ns3StatisticalSummary_methods(root_module, cls):
    ## data-calculator.h (module 'stats'): ns3::StatisticalSummary::StatisticalSummary() [constructor]
    cls.add_constructor([])
    ## data-calculator.h (module 'stats'): ns3::StatisticalSummary::StatisticalSummary(ns3::StatisticalSummary const & arg0) [constructor]
    cls.add_constructor([param('ns3::StatisticalSummary const &', 'arg0')])
    ## data-calculator.h (module 'stats'): long int ns3::StatisticalSummary::getCount() const [member function]
    cls.add_method('getCount',
                   'long int',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## data-calculator.h (module 'stats'): double ns3::StatisticalSummary::getMax() const [member function]
    cls.add_method('getMax',
                   'double',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## data-calculator.h (module 'stats'): double ns3::StatisticalSummary::getMean() const [member function]
    cls.add_method('getMean',
                   'double',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## data-calculator.h (module 'stats'): double ns3::StatisticalSummary::getMin() const [member function]
    cls.add_method('getMin',
                   'double',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## data-calculator.h (module 'stats'): double ns3::StatisticalSummary::getSqrSum() const [member function]
    cls.add_method('getSqrSum',
                   'double',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## data-calculator.h (module 'stats'): double ns3::StatisticalSummary::getStddev() const [member function]
    cls.add_method('getStddev',
                   'double',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## data-calculator.h (module 'stats'): double ns3::StatisticalSummary::getSum() const [member function]
    cls.add_method('getSum',
                   'double',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## data-calculator.h (module 'stats'): double ns3::StatisticalSummary::getVariance() const [member function]
    cls.add_method('getVariance',
                   'double',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    return

def register_Ns3Tag_methods(root_module, cls):
    ## tag.h (module 'network'): ns3::Tag::Tag() [constructor]
    cls.add_constructor([])
    ## tag.h (module 'network'): ns3::Tag::Tag(ns3::Tag const & arg0) [constructor]
    cls.add_constructor([param('ns3::Tag const &', 'arg0')])
    ## tag.h (module 'network'): void ns3::Tag::Deserialize(ns3::TagBuffer i) [member function]
    cls.add_method('Deserialize',
                   'void',
                   [param('ns3::TagBuffer', 'i')],
                   is_pure_virtual=True, is_virtual=True)
    ## tag.h (module 'network'): uint32_t ns3::Tag::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize',
                   'uint32_t',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## tag.h (module 'network'): static ns3::TypeId ns3::Tag::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## tag.h (module 'network'): void ns3::Tag::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## tag.h (module 'network'): void ns3::Tag::Serialize(ns3::TagBuffer i) const [member function]
    cls.add_method('Serialize',
                   'void',
                   [param('ns3::TagBuffer', 'i')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    return

def register_Ns3TagBuffer_methods(root_module, cls):
    ## tag-buffer.h (module 'network'): ns3::TagBuffer::TagBuffer(ns3::TagBuffer const & arg0) [constructor]
    cls.add_constructor([param('ns3::TagBuffer const &', 'arg0')])
    ## tag-buffer.h (module 'network'): ns3::TagBuffer::TagBuffer(uint8_t * start, uint8_t * end) [constructor]
    cls.add_constructor([param('uint8_t *', 'start'), param('uint8_t *', 'end')])
    ## tag-buffer.h (module 'network'): void ns3::TagBuffer::CopyFrom(ns3::TagBuffer o) [member function]
    cls.add_method('CopyFrom',
                   'void',
                   [param('ns3::TagBuffer', 'o')])
    ## tag-buffer.h (module 'network'): void ns3::TagBuffer::Read(uint8_t * buffer, uint32_t size) [member function]
    cls.add_method('Read',
                   'void',
                   [param('uint8_t *', 'buffer'), param('uint32_t', 'size')])
    ## tag-buffer.h (module 'network'): double ns3::TagBuffer::ReadDouble() [member function]
    cls.add_method('ReadDouble',
                   'double',
                   [])
    ## tag-buffer.h (module 'network'): uint16_t ns3::TagBuffer::ReadU16() [member function]
    cls.add_method('ReadU16',
                   'uint16_t',
                   [])
    ## tag-buffer.h (module 'network'): uint32_t ns3::TagBuffer::ReadU32() [member function]
    cls.add_method('ReadU32',
                   'uint32_t',
                   [])
    ## tag-buffer.h (module 'network'): uint64_t ns3::TagBuffer::ReadU64() [member function]
    cls.add_method('ReadU64',
                   'uint64_t',
                   [])
    ## tag-buffer.h (module 'network'): uint8_t ns3::TagBuffer::ReadU8() [member function]
    cls.add_method('ReadU8',
                   'uint8_t',
                   [])
    ## tag-buffer.h (module 'network'): void ns3::TagBuffer::TrimAtEnd(uint32_t trim) [member function]
    cls.add_method('TrimAtEnd',
                   'void',
                   [param('uint32_t', 'trim')])
    ## tag-buffer.h (module 'network'): void ns3::TagBuffer::Write(uint8_t const * buffer, uint32_t size) [member function]
    cls.add_method('Write',
                   'void',
                   [param('uint8_t const *', 'buffer'), param('uint32_t', 'size')])
    ## tag-buffer.h (module 'network'): void ns3::TagBuffer::WriteDouble(double v) [member function]
    cls.add_method('WriteDouble',
                   'void',
                   [param('double', 'v')])
    ## tag-buffer.h (module 'network'): void ns3::TagBuffer::WriteU16(uint16_t v) [member function]
    cls.add_method('WriteU16',
                   'void',
                   [param('uint16_t', 'v')])
    ## tag-buffer.h (module 'network'): void ns3::TagBuffer::WriteU32(uint32_t v) [member function]
    cls.add_method('WriteU32',
                   'void',
                   [param('uint32_t', 'v')])
    ## tag-buffer.h (module 'network'): void ns3::TagBuffer::WriteU64(uint64_t v) [member function]
    cls.add_method('WriteU64',
                   'void',
                   [param('uint64_t', 'v')])
    ## tag-buffer.h (module 'network'): void ns3::TagBuffer::WriteU8(uint8_t v) [member function]
    cls.add_method('WriteU8',
                   'void',
                   [param('uint8_t', 'v')])
    return

def register_Ns3TbId_t_methods(root_module, cls):
    cls.add_binary_comparison_operator('<')
    cls.add_binary_comparison_operator('==')
    ## lte-spectrum-phy.h (module 'lte'): ns3::TbId_t::TbId_t(ns3::TbId_t const & arg0) [constructor]
    cls.add_constructor([param('ns3::TbId_t const &', 'arg0')])
    ## lte-spectrum-phy.h (module 'lte'): ns3::TbId_t::TbId_t() [constructor]
    cls.add_constructor([])
    ## lte-spectrum-phy.h (module 'lte'): ns3::TbId_t::TbId_t(uint16_t const a, uint8_t const b) [constructor]
    cls.add_constructor([param('uint16_t const', 'a'), param('uint8_t const', 'b')])
    ## lte-spectrum-phy.h (module 'lte'): ns3::TbId_t::m_layer [variable]
    cls.add_instance_attribute('m_layer', 'uint8_t', is_const=False)
    ## lte-spectrum-phy.h (module 'lte'): ns3::TbId_t::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    return

def register_Ns3TimeWithUnit_methods(root_module, cls):
    cls.add_output_stream_operator()
    ## nstime.h (module 'core'): ns3::TimeWithUnit::TimeWithUnit(ns3::TimeWithUnit const & arg0) [constructor]
    cls.add_constructor([param('ns3::TimeWithUnit const &', 'arg0')])
    ## nstime.h (module 'core'): ns3::TimeWithUnit::TimeWithUnit(ns3::Time const time, ns3::Time::Unit const unit) [constructor]
    cls.add_constructor([param('ns3::Time const', 'time'), param('ns3::Time::Unit const', 'unit')])
    return

def register_Ns3TracedValue__Bool_methods(root_module, cls):
    ## traced-value.h (module 'core'): ns3::TracedValue<bool>::TracedValue() [constructor]
    cls.add_constructor([])
    ## traced-value.h (module 'core'): ns3::TracedValue<bool>::TracedValue(ns3::TracedValue<bool> const & o) [constructor]
    cls.add_constructor([param('ns3::TracedValue< bool > const &', 'o')])
    ## traced-value.h (module 'core'): ns3::TracedValue<bool>::TracedValue(bool const & v) [constructor]
    cls.add_constructor([param('bool const &', 'v')])
    ## traced-value.h (module 'core'): void ns3::TracedValue<bool>::Connect(ns3::CallbackBase const & cb, std::string path) [member function]
    cls.add_method('Connect',
                   'void',
                   [param('ns3::CallbackBase const &', 'cb'), param('std::string', 'path')])
    ## traced-value.h (module 'core'): void ns3::TracedValue<bool>::ConnectWithoutContext(ns3::CallbackBase const & cb) [member function]
    cls.add_method('ConnectWithoutContext',
                   'void',
                   [param('ns3::CallbackBase const &', 'cb')])
    ## traced-value.h (module 'core'): void ns3::TracedValue<bool>::Disconnect(ns3::CallbackBase const & cb, std::string path) [member function]
    cls.add_method('Disconnect',
                   'void',
                   [param('ns3::CallbackBase const &', 'cb'), param('std::string', 'path')])
    ## traced-value.h (module 'core'): void ns3::TracedValue<bool>::DisconnectWithoutContext(ns3::CallbackBase const & cb) [member function]
    cls.add_method('DisconnectWithoutContext',
                   'void',
                   [param('ns3::CallbackBase const &', 'cb')])
    ## traced-value.h (module 'core'): bool ns3::TracedValue<bool>::Get() const [member function]
    cls.add_method('Get',
                   'bool',
                   [],
                   is_const=True)
    ## traced-value.h (module 'core'): void ns3::TracedValue<bool>::Set(bool const & v) [member function]
    cls.add_method('Set',
                   'void',
                   [param('bool const &', 'v')])
    return

def register_Ns3TracedValue__Unsigned_int_methods(root_module, cls):
    ## traced-value.h (module 'core'): ns3::TracedValue<unsigned int>::TracedValue() [constructor]
    cls.add_constructor([])
    ## traced-value.h (module 'core'): ns3::TracedValue<unsigned int>::TracedValue(ns3::TracedValue<unsigned int> const & o) [constructor]
    cls.add_constructor([param('ns3::TracedValue< unsigned int > const &', 'o')])
    ## traced-value.h (module 'core'): ns3::TracedValue<unsigned int>::TracedValue(unsigned int const & v) [constructor]
    cls.add_constructor([param('unsigned int const &', 'v')])
    ## traced-value.h (module 'core'): void ns3::TracedValue<unsigned int>::Connect(ns3::CallbackBase const & cb, std::string path) [member function]
    cls.add_method('Connect',
                   'void',
                   [param('ns3::CallbackBase const &', 'cb'), param('std::string', 'path')])
    ## traced-value.h (module 'core'): void ns3::TracedValue<unsigned int>::ConnectWithoutContext(ns3::CallbackBase const & cb) [member function]
    cls.add_method('ConnectWithoutContext',
                   'void',
                   [param('ns3::CallbackBase const &', 'cb')])
    ## traced-value.h (module 'core'): void ns3::TracedValue<unsigned int>::Disconnect(ns3::CallbackBase const & cb, std::string path) [member function]
    cls.add_method('Disconnect',
                   'void',
                   [param('ns3::CallbackBase const &', 'cb'), param('std::string', 'path')])
    ## traced-value.h (module 'core'): void ns3::TracedValue<unsigned int>::DisconnectWithoutContext(ns3::CallbackBase const & cb) [member function]
    cls.add_method('DisconnectWithoutContext',
                   'void',
                   [param('ns3::CallbackBase const &', 'cb')])
    ## traced-value.h (module 'core'): unsigned int ns3::TracedValue<unsigned int>::Get() const [member function]
    cls.add_method('Get',
                   'unsigned int',
                   [],
                   is_const=True)
    ## traced-value.h (module 'core'): void ns3::TracedValue<unsigned int>::Set(unsigned int const & v) [member function]
    cls.add_method('Set',
                   'void',
                   [param('unsigned int const &', 'v')])
    return

def register_Ns3TransmissionModesLayers_methods(root_module, cls):
    ## lte-common.h (module 'lte'): ns3::TransmissionModesLayers::TransmissionModesLayers() [constructor]
    cls.add_constructor([])
    ## lte-common.h (module 'lte'): ns3::TransmissionModesLayers::TransmissionModesLayers(ns3::TransmissionModesLayers const & arg0) [constructor]
    cls.add_constructor([param('ns3::TransmissionModesLayers const &', 'arg0')])
    ## lte-common.h (module 'lte'): static uint8_t ns3::TransmissionModesLayers::TxMode2LayerNum(uint8_t txMode) [member function]
    cls.add_method('TxMode2LayerNum',
                   'uint8_t',
                   [param('uint8_t', 'txMode')],
                   is_static=True)
    return

def register_Ns3TypeId_methods(root_module, cls):
    cls.add_binary_comparison_operator('==')
    cls.add_binary_comparison_operator('!=')
    cls.add_output_stream_operator()
    cls.add_binary_comparison_operator('<')
    ## type-id.h (module 'core'): ns3::TypeId::TypeId(char const * name) [constructor]
    cls.add_constructor([param('char const *', 'name')])
    ## type-id.h (module 'core'): ns3::TypeId::TypeId() [constructor]
    cls.add_constructor([])
    ## type-id.h (module 'core'): ns3::TypeId::TypeId(ns3::TypeId const & o) [constructor]
    cls.add_constructor([param('ns3::TypeId const &', 'o')])
    ## type-id.h (module 'core'): ns3::TypeId ns3::TypeId::AddAttribute(std::string name, std::string help, ns3::AttributeValue const & initialValue, ns3::Ptr<const ns3::AttributeAccessor> accessor, ns3::Ptr<const ns3::AttributeChecker> checker, ns3::TypeId::SupportLevel supportLevel=::ns3::TypeId::SupportLevel::SUPPORTED, std::string const & supportMsg="") [member function]
    cls.add_method('AddAttribute',
                   'ns3::TypeId',
                   [param('std::string', 'name'), param('std::string', 'help'), param('ns3::AttributeValue const &', 'initialValue'), param('ns3::Ptr< ns3::AttributeAccessor const >', 'accessor'), param('ns3::Ptr< ns3::AttributeChecker const >', 'checker'), param('ns3::TypeId::SupportLevel', 'supportLevel', default_value='::ns3::TypeId::SupportLevel::SUPPORTED'), param('std::string const &', 'supportMsg', default_value='""')])
    ## type-id.h (module 'core'): ns3::TypeId ns3::TypeId::AddAttribute(std::string name, std::string help, uint32_t flags, ns3::AttributeValue const & initialValue, ns3::Ptr<const ns3::AttributeAccessor> accessor, ns3::Ptr<const ns3::AttributeChecker> checker, ns3::TypeId::SupportLevel supportLevel=::ns3::TypeId::SupportLevel::SUPPORTED, std::string const & supportMsg="") [member function]
    cls.add_method('AddAttribute',
                   'ns3::TypeId',
                   [param('std::string', 'name'), param('std::string', 'help'), param('uint32_t', 'flags'), param('ns3::AttributeValue const &', 'initialValue'), param('ns3::Ptr< ns3::AttributeAccessor const >', 'accessor'), param('ns3::Ptr< ns3::AttributeChecker const >', 'checker'), param('ns3::TypeId::SupportLevel', 'supportLevel', default_value='::ns3::TypeId::SupportLevel::SUPPORTED'), param('std::string const &', 'supportMsg', default_value='""')])
    ## type-id.h (module 'core'): ns3::TypeId ns3::TypeId::AddTraceSource(std::string name, std::string help, ns3::Ptr<const ns3::TraceSourceAccessor> accessor) [member function]
    cls.add_method('AddTraceSource',
                   'ns3::TypeId',
                   [param('std::string', 'name'), param('std::string', 'help'), param('ns3::Ptr< ns3::TraceSourceAccessor const >', 'accessor')],
                   deprecated=True)
    ## type-id.h (module 'core'): ns3::TypeId ns3::TypeId::AddTraceSource(std::string name, std::string help, ns3::Ptr<const ns3::TraceSourceAccessor> accessor, std::string callback, ns3::TypeId::SupportLevel supportLevel=::ns3::TypeId::SupportLevel::SUPPORTED, std::string const & supportMsg="") [member function]
    cls.add_method('AddTraceSource',
                   'ns3::TypeId',
                   [param('std::string', 'name'), param('std::string', 'help'), param('ns3::Ptr< ns3::TraceSourceAccessor const >', 'accessor'), param('std::string', 'callback'), param('ns3::TypeId::SupportLevel', 'supportLevel', default_value='::ns3::TypeId::SupportLevel::SUPPORTED'), param('std::string const &', 'supportMsg', default_value='""')])
    ## type-id.h (module 'core'): ns3::TypeId::AttributeInformation ns3::TypeId::GetAttribute(std::size_t i) const [member function]
    cls.add_method('GetAttribute',
                   'ns3::TypeId::AttributeInformation',
                   [param('std::size_t', 'i')],
                   is_const=True)
    ## type-id.h (module 'core'): std::string ns3::TypeId::GetAttributeFullName(std::size_t i) const [member function]
    cls.add_method('GetAttributeFullName',
                   'std::string',
                   [param('std::size_t', 'i')],
                   is_const=True)
    ## type-id.h (module 'core'): std::size_t ns3::TypeId::GetAttributeN() const [member function]
    cls.add_method('GetAttributeN',
                   'std::size_t',
                   [],
                   is_const=True)
    ## type-id.h (module 'core'): ns3::Callback<ns3::ObjectBase *, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> ns3::TypeId::GetConstructor() const [member function]
    cls.add_method('GetConstructor',
                   'ns3::Callback< ns3::ObjectBase *, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >',
                   [],
                   is_const=True)
    ## type-id.h (module 'core'): std::string ns3::TypeId::GetGroupName() const [member function]
    cls.add_method('GetGroupName',
                   'std::string',
                   [],
                   is_const=True)
    ## type-id.h (module 'core'): ns3::TypeId::hash_t ns3::TypeId::GetHash() const [member function]
    cls.add_method('GetHash',
                   'ns3::TypeId::hash_t',
                   [],
                   is_const=True)
    ## type-id.h (module 'core'): std::string ns3::TypeId::GetName() const [member function]
    cls.add_method('GetName',
                   'std::string',
                   [],
                   is_const=True)
    ## type-id.h (module 'core'): ns3::TypeId ns3::TypeId::GetParent() const [member function]
    cls.add_method('GetParent',
                   'ns3::TypeId',
                   [],
                   is_const=True)
    ## type-id.h (module 'core'): static ns3::TypeId ns3::TypeId::GetRegistered(uint16_t i) [member function]
    cls.add_method('GetRegistered',
                   'ns3::TypeId',
                   [param('uint16_t', 'i')],
                   is_static=True)
    ## type-id.h (module 'core'): static uint16_t ns3::TypeId::GetRegisteredN() [member function]
    cls.add_method('GetRegisteredN',
                   'uint16_t',
                   [],
                   is_static=True)
    ## type-id.h (module 'core'): std::size_t ns3::TypeId::GetSize() const [member function]
    cls.add_method('GetSize',
                   'std::size_t',
                   [],
                   is_const=True)
    ## type-id.h (module 'core'): ns3::TypeId::TraceSourceInformation ns3::TypeId::GetTraceSource(std::size_t i) const [member function]
    cls.add_method('GetTraceSource',
                   'ns3::TypeId::TraceSourceInformation',
                   [param('std::size_t', 'i')],
                   is_const=True)
    ## type-id.h (module 'core'): std::size_t ns3::TypeId::GetTraceSourceN() const [member function]
    cls.add_method('GetTraceSourceN',
                   'std::size_t',
                   [],
                   is_const=True)
    ## type-id.h (module 'core'): uint16_t ns3::TypeId::GetUid() const [member function]
    cls.add_method('GetUid',
                   'uint16_t',
                   [],
                   is_const=True)
    ## type-id.h (module 'core'): bool ns3::TypeId::HasConstructor() const [member function]
    cls.add_method('HasConstructor',
                   'bool',
                   [],
                   is_const=True)
    ## type-id.h (module 'core'): bool ns3::TypeId::HasParent() const [member function]
    cls.add_method('HasParent',
                   'bool',
                   [],
                   is_const=True)
    ## type-id.h (module 'core'): ns3::TypeId ns3::TypeId::HideFromDocumentation() [member function]
    cls.add_method('HideFromDocumentation',
                   'ns3::TypeId',
                   [])
    ## type-id.h (module 'core'): bool ns3::TypeId::IsChildOf(ns3::TypeId other) const [member function]
    cls.add_method('IsChildOf',
                   'bool',
                   [param('ns3::TypeId', 'other')],
                   is_const=True)
    ## type-id.h (module 'core'): bool ns3::TypeId::LookupAttributeByName(std::string name, ns3::TypeId::AttributeInformation * info) const [member function]
    cls.add_method('LookupAttributeByName',
                   'bool',
                   [param('std::string', 'name'), param('ns3::TypeId::AttributeInformation *', 'info', transfer_ownership=False)],
                   is_const=True)
    ## type-id.h (module 'core'): static ns3::TypeId ns3::TypeId::LookupByHash(ns3::TypeId::hash_t hash) [member function]
    cls.add_method('LookupByHash',
                   'ns3::TypeId',
                   [param('uint32_t', 'hash')],
                   is_static=True)
    ## type-id.h (module 'core'): static bool ns3::TypeId::LookupByHashFailSafe(ns3::TypeId::hash_t hash, ns3::TypeId * tid) [member function]
    cls.add_method('LookupByHashFailSafe',
                   'bool',
                   [param('uint32_t', 'hash'), param('ns3::TypeId *', 'tid')],
                   is_static=True)
    ## type-id.h (module 'core'): static ns3::TypeId ns3::TypeId::LookupByName(std::string name) [member function]
    cls.add_method('LookupByName',
                   'ns3::TypeId',
                   [param('std::string', 'name')],
                   is_static=True)
    ## type-id.h (module 'core'): ns3::Ptr<const ns3::TraceSourceAccessor> ns3::TypeId::LookupTraceSourceByName(std::string name) const [member function]
    cls.add_method('LookupTraceSourceByName',
                   'ns3::Ptr< ns3::TraceSourceAccessor const >',
                   [param('std::string', 'name')],
                   is_const=True)
    ## type-id.h (module 'core'): ns3::Ptr<const ns3::TraceSourceAccessor> ns3::TypeId::LookupTraceSourceByName(std::string name, ns3::TypeId::TraceSourceInformation * info) const [member function]
    cls.add_method('LookupTraceSourceByName',
                   'ns3::Ptr< ns3::TraceSourceAccessor const >',
                   [param('std::string', 'name'), param('ns3::TypeId::TraceSourceInformation *', 'info')],
                   is_const=True)
    ## type-id.h (module 'core'): bool ns3::TypeId::MustHideFromDocumentation() const [member function]
    cls.add_method('MustHideFromDocumentation',
                   'bool',
                   [],
                   is_const=True)
    ## type-id.h (module 'core'): bool ns3::TypeId::SetAttributeInitialValue(std::size_t i, ns3::Ptr<const ns3::AttributeValue> initialValue) [member function]
    cls.add_method('SetAttributeInitialValue',
                   'bool',
                   [param('std::size_t', 'i'), param('ns3::Ptr< ns3::AttributeValue const >', 'initialValue')])
    ## type-id.h (module 'core'): ns3::TypeId ns3::TypeId::SetGroupName(std::string groupName) [member function]
    cls.add_method('SetGroupName',
                   'ns3::TypeId',
                   [param('std::string', 'groupName')])
    ## type-id.h (module 'core'): ns3::TypeId ns3::TypeId::SetParent(ns3::TypeId tid) [member function]
    cls.add_method('SetParent',
                   'ns3::TypeId',
                   [param('ns3::TypeId', 'tid')])
    ## type-id.h (module 'core'): ns3::TypeId ns3::TypeId::SetParent() [member function]
    cls.add_method('SetParent',
                   'ns3::TypeId',
                   [],
                   template_parameters=[u'ns3::Object'])
    ## type-id.h (module 'core'): ns3::TypeId ns3::TypeId::SetSize(std::size_t size) [member function]
    cls.add_method('SetSize',
                   'ns3::TypeId',
                   [param('std::size_t', 'size')])
    ## type-id.h (module 'core'): void ns3::TypeId::SetUid(uint16_t uid) [member function]
    cls.add_method('SetUid',
                   'void',
                   [param('uint16_t', 'uid')])
    return

def register_Ns3TypeIdAttributeInformation_methods(root_module, cls):
    ## type-id.h (module 'core'): ns3::TypeId::AttributeInformation::AttributeInformation() [constructor]
    cls.add_constructor([])
    ## type-id.h (module 'core'): ns3::TypeId::AttributeInformation::AttributeInformation(ns3::TypeId::AttributeInformation const & arg0) [constructor]
    cls.add_constructor([param('ns3::TypeId::AttributeInformation const &', 'arg0')])
    ## type-id.h (module 'core'): ns3::TypeId::AttributeInformation::accessor [variable]
    cls.add_instance_attribute('accessor', 'ns3::Ptr< ns3::AttributeAccessor const >', is_const=False)
    ## type-id.h (module 'core'): ns3::TypeId::AttributeInformation::checker [variable]
    cls.add_instance_attribute('checker', 'ns3::Ptr< ns3::AttributeChecker const >', is_const=False)
    cls.add_instance_attribute('flags', 'uint32_t', is_const=False)
    ## type-id.h (module 'core'): ns3::TypeId::AttributeInformation::help [variable]
    cls.add_instance_attribute('help', 'std::string', is_const=False)
    ## type-id.h (module 'core'): ns3::TypeId::AttributeInformation::initialValue [variable]
    cls.add_instance_attribute('initialValue', 'ns3::Ptr< ns3::AttributeValue const >', is_const=False)
    ## type-id.h (module 'core'): ns3::TypeId::AttributeInformation::name [variable]
    cls.add_instance_attribute('name', 'std::string', is_const=False)
    ## type-id.h (module 'core'): ns3::TypeId::AttributeInformation::originalInitialValue [variable]
    cls.add_instance_attribute('originalInitialValue', 'ns3::Ptr< ns3::AttributeValue const >', is_const=False)
    ## type-id.h (module 'core'): ns3::TypeId::AttributeInformation::supportLevel [variable]
    cls.add_instance_attribute('supportLevel', 'ns3::TypeId::SupportLevel', is_const=False)
    ## type-id.h (module 'core'): ns3::TypeId::AttributeInformation::supportMsg [variable]
    cls.add_instance_attribute('supportMsg', 'std::string', is_const=False)
    return

def register_Ns3TypeIdTraceSourceInformation_methods(root_module, cls):
    ## type-id.h (module 'core'): ns3::TypeId::TraceSourceInformation::TraceSourceInformation() [constructor]
    cls.add_constructor([])
    ## type-id.h (module 'core'): ns3::TypeId::TraceSourceInformation::TraceSourceInformation(ns3::TypeId::TraceSourceInformation const & arg0) [constructor]
    cls.add_constructor([param('ns3::TypeId::TraceSourceInformation const &', 'arg0')])
    ## type-id.h (module 'core'): ns3::TypeId::TraceSourceInformation::accessor [variable]
    cls.add_instance_attribute('accessor', 'ns3::Ptr< ns3::TraceSourceAccessor const >', is_const=False)
    ## type-id.h (module 'core'): ns3::TypeId::TraceSourceInformation::callback [variable]
    cls.add_instance_attribute('callback', 'std::string', is_const=False)
    ## type-id.h (module 'core'): ns3::TypeId::TraceSourceInformation::help [variable]
    cls.add_instance_attribute('help', 'std::string', is_const=False)
    ## type-id.h (module 'core'): ns3::TypeId::TraceSourceInformation::name [variable]
    cls.add_instance_attribute('name', 'std::string', is_const=False)
    ## type-id.h (module 'core'): ns3::TypeId::TraceSourceInformation::supportLevel [variable]
    cls.add_instance_attribute('supportLevel', 'ns3::TypeId::SupportLevel', is_const=False)
    ## type-id.h (module 'core'): ns3::TypeId::TraceSourceInformation::supportMsg [variable]
    cls.add_instance_attribute('supportMsg', 'std::string', is_const=False)
    return

def register_Ns3UeCapabilities_s_methods(root_module, cls):
    ## ff-mac-common.h (module 'lte'): ns3::UeCapabilities_s::UeCapabilities_s() [constructor]
    cls.add_constructor([])
    ## ff-mac-common.h (module 'lte'): ns3::UeCapabilities_s::UeCapabilities_s(ns3::UeCapabilities_s const & arg0) [constructor]
    cls.add_constructor([param('ns3::UeCapabilities_s const &', 'arg0')])
    ## ff-mac-common.h (module 'lte'): ns3::UeCapabilities_s::m_halfDuplex [variable]
    cls.add_instance_attribute('m_halfDuplex', 'bool', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::UeCapabilities_s::m_intraSfHopping [variable]
    cls.add_instance_attribute('m_intraSfHopping', 'bool', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::UeCapabilities_s::m_resAllocType1 [variable]
    cls.add_instance_attribute('m_resAllocType1', 'bool', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::UeCapabilities_s::m_type2Sb1 [variable]
    cls.add_instance_attribute('m_type2Sb1', 'bool', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::UeCapabilities_s::m_ueCategory [variable]
    cls.add_instance_attribute('m_ueCategory', 'uint8_t', is_const=False)
    return

def register_Ns3UeSelected_s_methods(root_module, cls):
    ## ff-mac-common.h (module 'lte'): ns3::UeSelected_s::UeSelected_s() [constructor]
    cls.add_constructor([])
    ## ff-mac-common.h (module 'lte'): ns3::UeSelected_s::UeSelected_s(ns3::UeSelected_s const & arg0) [constructor]
    cls.add_constructor([param('ns3::UeSelected_s const &', 'arg0')])
    ## ff-mac-common.h (module 'lte'): ns3::UeSelected_s::m_sbCqi [variable]
    cls.add_instance_attribute('m_sbCqi', 'std::vector< unsigned char >', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::UeSelected_s::m_sbList [variable]
    cls.add_instance_attribute('m_sbList', 'std::vector< unsigned char >', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::UeSelected_s::m_sbPmi [variable]
    cls.add_instance_attribute('m_sbPmi', 'uint8_t', is_const=False)
    return

def register_Ns3UlCqi_s_methods(root_module, cls):
    ## ff-mac-common.h (module 'lte'): ns3::UlCqi_s::UlCqi_s() [constructor]
    cls.add_constructor([])
    ## ff-mac-common.h (module 'lte'): ns3::UlCqi_s::UlCqi_s(ns3::UlCqi_s const & arg0) [constructor]
    cls.add_constructor([param('ns3::UlCqi_s const &', 'arg0')])
    ## ff-mac-common.h (module 'lte'): ns3::UlCqi_s::m_sinr [variable]
    cls.add_instance_attribute('m_sinr', 'std::vector< unsigned short >', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::UlCqi_s::m_type [variable]
    cls.add_instance_attribute('m_type', 'ns3::UlCqi_s::Type_e', is_const=False)
    return

def register_Ns3UlDciListElement_s_methods(root_module, cls):
    ## ff-mac-common.h (module 'lte'): ns3::UlDciListElement_s::UlDciListElement_s() [constructor]
    cls.add_constructor([])
    ## ff-mac-common.h (module 'lte'): ns3::UlDciListElement_s::UlDciListElement_s(ns3::UlDciListElement_s const & arg0) [constructor]
    cls.add_constructor([param('ns3::UlDciListElement_s const &', 'arg0')])
    ## ff-mac-common.h (module 'lte'): ns3::UlDciListElement_s::m_aggrLevel [variable]
    cls.add_instance_attribute('m_aggrLevel', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::UlDciListElement_s::m_cceIndex [variable]
    cls.add_instance_attribute('m_cceIndex', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::UlDciListElement_s::m_cqiRequest [variable]
    cls.add_instance_attribute('m_cqiRequest', 'bool', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::UlDciListElement_s::m_dai [variable]
    cls.add_instance_attribute('m_dai', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::UlDciListElement_s::m_freqHopping [variable]
    cls.add_instance_attribute('m_freqHopping', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::UlDciListElement_s::m_hopping [variable]
    cls.add_instance_attribute('m_hopping', 'bool', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::UlDciListElement_s::m_mcs [variable]
    cls.add_instance_attribute('m_mcs', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::UlDciListElement_s::m_n2Dmrs [variable]
    cls.add_instance_attribute('m_n2Dmrs', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::UlDciListElement_s::m_ndi [variable]
    cls.add_instance_attribute('m_ndi', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::UlDciListElement_s::m_pdcchPowerOffset [variable]
    cls.add_instance_attribute('m_pdcchPowerOffset', 'int8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::UlDciListElement_s::m_rbLen [variable]
    cls.add_instance_attribute('m_rbLen', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::UlDciListElement_s::m_rbStart [variable]
    cls.add_instance_attribute('m_rbStart', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::UlDciListElement_s::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::UlDciListElement_s::m_tbSize [variable]
    cls.add_instance_attribute('m_tbSize', 'uint16_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::UlDciListElement_s::m_tpc [variable]
    cls.add_instance_attribute('m_tpc', 'int8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::UlDciListElement_s::m_ueTxAntennaSelection [variable]
    cls.add_instance_attribute('m_ueTxAntennaSelection', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::UlDciListElement_s::m_ulIndex [variable]
    cls.add_instance_attribute('m_ulIndex', 'uint8_t', is_const=False)
    return

def register_Ns3UlGrant_s_methods(root_module, cls):
    ## ff-mac-common.h (module 'lte'): ns3::UlGrant_s::UlGrant_s() [constructor]
    cls.add_constructor([])
    ## ff-mac-common.h (module 'lte'): ns3::UlGrant_s::UlGrant_s(ns3::UlGrant_s const & arg0) [constructor]
    cls.add_constructor([param('ns3::UlGrant_s const &', 'arg0')])
    ## ff-mac-common.h (module 'lte'): ns3::UlGrant_s::m_cqiRequest [variable]
    cls.add_instance_attribute('m_cqiRequest', 'bool', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::UlGrant_s::m_hopping [variable]
    cls.add_instance_attribute('m_hopping', 'bool', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::UlGrant_s::m_mcs [variable]
    cls.add_instance_attribute('m_mcs', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::UlGrant_s::m_rbLen [variable]
    cls.add_instance_attribute('m_rbLen', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::UlGrant_s::m_rbStart [variable]
    cls.add_instance_attribute('m_rbStart', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::UlGrant_s::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::UlGrant_s::m_tbSize [variable]
    cls.add_instance_attribute('m_tbSize', 'uint16_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::UlGrant_s::m_tpc [variable]
    cls.add_instance_attribute('m_tpc', 'int8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::UlGrant_s::m_ulDelay [variable]
    cls.add_instance_attribute('m_ulDelay', 'bool', is_const=False)
    return

def register_Ns3UlInfoListElement_s_methods(root_module, cls):
    ## ff-mac-common.h (module 'lte'): ns3::UlInfoListElement_s::UlInfoListElement_s() [constructor]
    cls.add_constructor([])
    ## ff-mac-common.h (module 'lte'): ns3::UlInfoListElement_s::UlInfoListElement_s(ns3::UlInfoListElement_s const & arg0) [constructor]
    cls.add_constructor([param('ns3::UlInfoListElement_s const &', 'arg0')])
    ## ff-mac-common.h (module 'lte'): ns3::UlInfoListElement_s::m_receptionStatus [variable]
    cls.add_instance_attribute('m_receptionStatus', 'ns3::UlInfoListElement_s::ReceptionStatus_e', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::UlInfoListElement_s::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::UlInfoListElement_s::m_tpc [variable]
    cls.add_instance_attribute('m_tpc', 'uint8_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::UlInfoListElement_s::m_ulReception [variable]
    cls.add_instance_attribute('m_ulReception', 'std::vector< unsigned short >', is_const=False)
    return

def register_Ns3Vector2D_methods(root_module, cls):
    cls.add_output_stream_operator()
    cls.add_binary_comparison_operator('<')
    cls.add_binary_numeric_operator('-', root_module['ns3::Vector2D'], root_module['ns3::Vector2D'], param('ns3::Vector2D const &', u'right'))
    cls.add_binary_numeric_operator('+', root_module['ns3::Vector2D'], root_module['ns3::Vector2D'], param('ns3::Vector2D const &', u'right'))
    ## vector.h (module 'core'): ns3::Vector2D::Vector2D(ns3::Vector2D const & arg0) [constructor]
    cls.add_constructor([param('ns3::Vector2D const &', 'arg0')])
    ## vector.h (module 'core'): ns3::Vector2D::Vector2D(double _x, double _y) [constructor]
    cls.add_constructor([param('double', '_x'), param('double', '_y')])
    ## vector.h (module 'core'): ns3::Vector2D::Vector2D() [constructor]
    cls.add_constructor([])
    ## vector.h (module 'core'): double ns3::Vector2D::GetLength() const [member function]
    cls.add_method('GetLength',
                   'double',
                   [],
                   is_const=True)
    ## vector.h (module 'core'): ns3::Vector2D::x [variable]
    cls.add_instance_attribute('x', 'double', is_const=False)
    ## vector.h (module 'core'): ns3::Vector2D::y [variable]
    cls.add_instance_attribute('y', 'double', is_const=False)
    return

def register_Ns3Vector3D_methods(root_module, cls):
    cls.add_output_stream_operator()
    cls.add_binary_comparison_operator('<')
    cls.add_binary_numeric_operator('-', root_module['ns3::Vector3D'], root_module['ns3::Vector3D'], param('ns3::Vector3D const &', u'right'))
    cls.add_binary_numeric_operator('+', root_module['ns3::Vector3D'], root_module['ns3::Vector3D'], param('ns3::Vector3D const &', u'right'))
    ## vector.h (module 'core'): ns3::Vector3D::Vector3D(ns3::Vector3D const & arg0) [constructor]
    cls.add_constructor([param('ns3::Vector3D const &', 'arg0')])
    ## vector.h (module 'core'): ns3::Vector3D::Vector3D(double _x, double _y, double _z) [constructor]
    cls.add_constructor([param('double', '_x'), param('double', '_y'), param('double', '_z')])
    ## vector.h (module 'core'): ns3::Vector3D::Vector3D() [constructor]
    cls.add_constructor([])
    ## vector.h (module 'core'): double ns3::Vector3D::GetLength() const [member function]
    cls.add_method('GetLength',
                   'double',
                   [],
                   is_const=True)
    ## vector.h (module 'core'): ns3::Vector3D::x [variable]
    cls.add_instance_attribute('x', 'double', is_const=False)
    ## vector.h (module 'core'): ns3::Vector3D::y [variable]
    cls.add_instance_attribute('y', 'double', is_const=False)
    ## vector.h (module 'core'): ns3::Vector3D::z [variable]
    cls.add_instance_attribute('z', 'double', is_const=False)
    return

def register_Ns3VendorSpecificListElement_s_methods(root_module, cls):
    ## ff-mac-common.h (module 'lte'): ns3::VendorSpecificListElement_s::VendorSpecificListElement_s() [constructor]
    cls.add_constructor([])
    ## ff-mac-common.h (module 'lte'): ns3::VendorSpecificListElement_s::VendorSpecificListElement_s(ns3::VendorSpecificListElement_s const & arg0) [constructor]
    cls.add_constructor([param('ns3::VendorSpecificListElement_s const &', 'arg0')])
    ## ff-mac-common.h (module 'lte'): ns3::VendorSpecificListElement_s::m_length [variable]
    cls.add_instance_attribute('m_length', 'uint32_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::VendorSpecificListElement_s::m_type [variable]
    cls.add_instance_attribute('m_type', 'uint32_t', is_const=False)
    ## ff-mac-common.h (module 'lte'): ns3::VendorSpecificListElement_s::m_value [variable]
    cls.add_instance_attribute('m_value', 'ns3::Ptr< ns3::VendorSpecificValue >', is_const=False)
    return

def register_Ns3Empty_methods(root_module, cls):
    ## empty.h (module 'core'): ns3::empty::empty() [constructor]
    cls.add_constructor([])
    ## empty.h (module 'core'): ns3::empty::empty(ns3::empty const & arg0) [constructor]
    cls.add_constructor([param('ns3::empty const &', 'arg0')])
    return

def register_Ns3Int64x64_t_methods(root_module, cls):
    cls.add_binary_numeric_operator('+', root_module['ns3::int64x64_t'], root_module['ns3::int64x64_t'], param('ns3::int64x64_t const &', u'right'))
    cls.add_binary_numeric_operator('-', root_module['ns3::int64x64_t'], root_module['ns3::int64x64_t'], param('ns3::int64x64_t const &', u'right'))
    cls.add_binary_numeric_operator('*', root_module['ns3::int64x64_t'], root_module['ns3::int64x64_t'], param('ns3::int64x64_t const &', u'right'))
    cls.add_binary_numeric_operator('/', root_module['ns3::int64x64_t'], root_module['ns3::int64x64_t'], param('ns3::int64x64_t const &', u'right'))
    cls.add_binary_comparison_operator('!=')
    cls.add_binary_comparison_operator('<=')
    cls.add_binary_comparison_operator('>=')
    cls.add_output_stream_operator()
    cls.add_binary_comparison_operator('==')
    cls.add_binary_comparison_operator('<')
    cls.add_binary_comparison_operator('>')
    cls.add_inplace_numeric_operator('+=', param('ns3::int64x64_t const &', u'right'))
    cls.add_inplace_numeric_operator('-=', param('ns3::int64x64_t const &', u'right'))
    cls.add_inplace_numeric_operator('*=', param('ns3::int64x64_t const &', u'right'))
    cls.add_inplace_numeric_operator('/=', param('ns3::int64x64_t const &', u'right'))
    cls.add_unary_numeric_operator('-')
    ## int64x64-128.h (module 'core'): ns3::int64x64_t::int64x64_t() [constructor]
    cls.add_constructor([])
    ## int64x64-128.h (module 'core'): ns3::int64x64_t::int64x64_t(double const value) [constructor]
    cls.add_constructor([param('double const', 'value')])
    ## int64x64-128.h (module 'core'): ns3::int64x64_t::int64x64_t(long double const value) [constructor]
    cls.add_constructor([param('long double const', 'value')])
    ## int64x64-128.h (module 'core'): ns3::int64x64_t::int64x64_t(int const v) [constructor]
    cls.add_constructor([param('int const', 'v')])
    ## int64x64-128.h (module 'core'): ns3::int64x64_t::int64x64_t(long int const v) [constructor]
    cls.add_constructor([param('long int const', 'v')])
    ## int64x64-128.h (module 'core'): ns3::int64x64_t::int64x64_t(long long int const v) [constructor]
    cls.add_constructor([param('long long int const', 'v')])
    ## int64x64-128.h (module 'core'): ns3::int64x64_t::int64x64_t(unsigned int const v) [constructor]
    cls.add_constructor([param('unsigned int const', 'v')])
    ## int64x64-128.h (module 'core'): ns3::int64x64_t::int64x64_t(long unsigned int const v) [constructor]
    cls.add_constructor([param('long unsigned int const', 'v')])
    ## int64x64-128.h (module 'core'): ns3::int64x64_t::int64x64_t(long long unsigned int const v) [constructor]
    cls.add_constructor([param('long long unsigned int const', 'v')])
    ## int64x64-128.h (module 'core'): ns3::int64x64_t::int64x64_t(int64_t const hi, uint64_t const lo) [constructor]
    cls.add_constructor([param('int64_t const', 'hi'), param('uint64_t const', 'lo')])
    ## int64x64-128.h (module 'core'): ns3::int64x64_t::int64x64_t(ns3::int64x64_t const & o) [constructor]
    cls.add_constructor([param('ns3::int64x64_t const &', 'o')])
    ## int64x64-128.h (module 'core'): double ns3::int64x64_t::GetDouble() const [member function]
    cls.add_method('GetDouble',
                   'double',
                   [],
                   is_const=True)
    ## int64x64-128.h (module 'core'): int64_t ns3::int64x64_t::GetHigh() const [member function]
    cls.add_method('GetHigh',
                   'int64_t',
                   [],
                   is_const=True)
    ## int64x64-128.h (module 'core'): uint64_t ns3::int64x64_t::GetLow() const [member function]
    cls.add_method('GetLow',
                   'uint64_t',
                   [],
                   is_const=True)
    ## int64x64-128.h (module 'core'): static ns3::int64x64_t ns3::int64x64_t::Invert(uint64_t const v) [member function]
    cls.add_method('Invert',
                   'ns3::int64x64_t',
                   [param('uint64_t const', 'v')],
                   is_static=True)
    ## int64x64-128.h (module 'core'): void ns3::int64x64_t::MulByInvert(ns3::int64x64_t const & o) [member function]
    cls.add_method('MulByInvert',
                   'void',
                   [param('ns3::int64x64_t const &', 'o')])
    ## int64x64-128.h (module 'core'): ns3::int64x64_t::implementation [variable]
    cls.add_static_attribute('implementation', 'ns3::int64x64_t::impl_type const', is_const=True)
    return

def register_Ns3TbInfo_t_methods(root_module, cls):
    ## lte-spectrum-phy.h (module 'lte'): ns3::tbInfo_t::tbInfo_t() [constructor]
    cls.add_constructor([])
    ## lte-spectrum-phy.h (module 'lte'): ns3::tbInfo_t::tbInfo_t(ns3::tbInfo_t const & arg0) [constructor]
    cls.add_constructor([param('ns3::tbInfo_t const &', 'arg0')])
    ## lte-spectrum-phy.h (module 'lte'): ns3::tbInfo_t::corrupt [variable]
    cls.add_instance_attribute('corrupt', 'bool', is_const=False)
    ## lte-spectrum-phy.h (module 'lte'): ns3::tbInfo_t::downlink [variable]
    cls.add_instance_attribute('downlink', 'bool', is_const=False)
    ## lte-spectrum-phy.h (module 'lte'): ns3::tbInfo_t::harqFeedbackSent [variable]
    cls.add_instance_attribute('harqFeedbackSent', 'bool', is_const=False)
    ## lte-spectrum-phy.h (module 'lte'): ns3::tbInfo_t::harqProcessId [variable]
    cls.add_instance_attribute('harqProcessId', 'uint8_t', is_const=False)
    ## lte-spectrum-phy.h (module 'lte'): ns3::tbInfo_t::mcs [variable]
    cls.add_instance_attribute('mcs', 'uint8_t', is_const=False)
    ## lte-spectrum-phy.h (module 'lte'): ns3::tbInfo_t::mi [variable]
    cls.add_instance_attribute('mi', 'double', is_const=False)
    ## lte-spectrum-phy.h (module 'lte'): ns3::tbInfo_t::ndi [variable]
    cls.add_instance_attribute('ndi', 'uint8_t', is_const=False)
    ## lte-spectrum-phy.h (module 'lte'): ns3::tbInfo_t::rbBitmap [variable]
    cls.add_instance_attribute('rbBitmap', 'std::vector< int >', is_const=False)
    ## lte-spectrum-phy.h (module 'lte'): ns3::tbInfo_t::rv [variable]
    cls.add_instance_attribute('rv', 'uint8_t', is_const=False)
    ## lte-spectrum-phy.h (module 'lte'): ns3::tbInfo_t::size [variable]
    cls.add_instance_attribute('size', 'uint16_t', is_const=False)
    return

def register_Ns3Chunk_methods(root_module, cls):
    ## chunk.h (module 'network'): ns3::Chunk::Chunk() [constructor]
    cls.add_constructor([])
    ## chunk.h (module 'network'): ns3::Chunk::Chunk(ns3::Chunk const & arg0) [constructor]
    cls.add_constructor([param('ns3::Chunk const &', 'arg0')])
    ## chunk.h (module 'network'): uint32_t ns3::Chunk::Deserialize(ns3::Buffer::Iterator start) [member function]
    cls.add_method('Deserialize',
                   'uint32_t',
                   [param('ns3::Buffer::Iterator', 'start')],
                   is_pure_virtual=True, is_virtual=True)
    ## chunk.h (module 'network'): uint32_t ns3::Chunk::Deserialize(ns3::Buffer::Iterator start, ns3::Buffer::Iterator end) [member function]
    cls.add_method('Deserialize',
                   'uint32_t',
                   [param('ns3::Buffer::Iterator', 'start'), param('ns3::Buffer::Iterator', 'end')],
                   is_virtual=True)
    ## chunk.h (module 'network'): static ns3::TypeId ns3::Chunk::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## chunk.h (module 'network'): void ns3::Chunk::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    return

def register_Ns3EpcX2PdcpProvider_methods(root_module, cls):
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2PdcpProvider::EpcX2PdcpProvider() [constructor]
    cls.add_constructor([])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2PdcpProvider::EpcX2PdcpProvider(ns3::EpcX2PdcpProvider const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcX2PdcpProvider const &', 'arg0')])
    ## epc-x2-sap.h (module 'lte'): void ns3::EpcX2PdcpProvider::SendMcPdcpPdu(ns3::EpcX2Sap::UeDataParams params) [member function]
    cls.add_method('SendMcPdcpPdu',
                   'void',
                   [param('ns3::EpcX2Sap::UeDataParams', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3EpcX2PdcpUser_methods(root_module, cls):
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2PdcpUser::EpcX2PdcpUser() [constructor]
    cls.add_constructor([])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2PdcpUser::EpcX2PdcpUser(ns3::EpcX2PdcpUser const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcX2PdcpUser const &', 'arg0')])
    ## epc-x2-sap.h (module 'lte'): void ns3::EpcX2PdcpUser::ReceiveMcPdcpPdu(ns3::EpcX2Sap::UeDataParams params) [member function]
    cls.add_method('ReceiveMcPdcpPdu',
                   'void',
                   [param('ns3::EpcX2Sap::UeDataParams', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3EpcX2RlcProvider_methods(root_module, cls):
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2RlcProvider::EpcX2RlcProvider() [constructor]
    cls.add_constructor([])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2RlcProvider::EpcX2RlcProvider(ns3::EpcX2RlcProvider const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcX2RlcProvider const &', 'arg0')])
    ## epc-x2-sap.h (module 'lte'): void ns3::EpcX2RlcProvider::ReceiveMcPdcpSdu(ns3::EpcX2Sap::UeDataParams params) [member function]
    cls.add_method('ReceiveMcPdcpSdu',
                   'void',
                   [param('ns3::EpcX2Sap::UeDataParams', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3EpcX2RlcUser_methods(root_module, cls):
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2RlcUser::EpcX2RlcUser() [constructor]
    cls.add_constructor([])
    ## epc-x2-sap.h (module 'lte'): ns3::EpcX2RlcUser::EpcX2RlcUser(ns3::EpcX2RlcUser const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcX2RlcUser const &', 'arg0')])
    ## epc-x2-sap.h (module 'lte'): void ns3::EpcX2RlcUser::SendMcPdcpSdu(ns3::EpcX2Sap::UeDataParams params) [member function]
    cls.add_method('SendMcPdcpSdu',
                   'void',
                   [param('ns3::EpcX2Sap::UeDataParams', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3Header_methods(root_module, cls):
    cls.add_output_stream_operator()
    ## header.h (module 'network'): ns3::Header::Header() [constructor]
    cls.add_constructor([])
    ## header.h (module 'network'): ns3::Header::Header(ns3::Header const & arg0) [constructor]
    cls.add_constructor([param('ns3::Header const &', 'arg0')])
    ## header.h (module 'network'): uint32_t ns3::Header::Deserialize(ns3::Buffer::Iterator start) [member function]
    cls.add_method('Deserialize',
                   'uint32_t',
                   [param('ns3::Buffer::Iterator', 'start')],
                   is_pure_virtual=True, is_virtual=True)
    ## header.h (module 'network'): uint32_t ns3::Header::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize',
                   'uint32_t',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## header.h (module 'network'): static ns3::TypeId ns3::Header::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## header.h (module 'network'): void ns3::Header::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## header.h (module 'network'): void ns3::Header::Serialize(ns3::Buffer::Iterator start) const [member function]
    cls.add_method('Serialize',
                   'void',
                   [param('ns3::Buffer::Iterator', 'start')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    return

def register_Ns3LteCcmMacSapUser_methods(root_module, cls):
    ## lte-ccm-mac-sap.h (module 'lte'): ns3::LteCcmMacSapUser::LteCcmMacSapUser() [constructor]
    cls.add_constructor([])
    ## lte-ccm-mac-sap.h (module 'lte'): ns3::LteCcmMacSapUser::LteCcmMacSapUser(ns3::LteCcmMacSapUser const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteCcmMacSapUser const &', 'arg0')])
    ## lte-ccm-mac-sap.h (module 'lte'): void ns3::LteCcmMacSapUser::NotifyPrbOccupancy(double prbOccupancy, uint8_t componentCarrierId) [member function]
    cls.add_method('NotifyPrbOccupancy',
                   'void',
                   [param('double', 'prbOccupancy'), param('uint8_t', 'componentCarrierId')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ccm-mac-sap.h (module 'lte'): void ns3::LteCcmMacSapUser::UlReceiveMacCe(ns3::MacCeListElement_s bsr, uint8_t componentCarrierId) [member function]
    cls.add_method('UlReceiveMacCe',
                   'void',
                   [param('ns3::MacCeListElement_s', 'bsr'), param('uint8_t', 'componentCarrierId')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3LteEnbRrcSapProvider_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteEnbRrcSapProvider::LteEnbRrcSapProvider() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteEnbRrcSapProvider::LteEnbRrcSapProvider(ns3::LteEnbRrcSapProvider const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteEnbRrcSapProvider const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): void ns3::LteEnbRrcSapProvider::CompleteSetupUe(uint16_t rnti, ns3::LteEnbRrcSapProvider::CompleteSetupUeParameters params) [member function]
    cls.add_method('CompleteSetupUe',
                   'void',
                   [param('uint16_t', 'rnti'), param('ns3::LteEnbRrcSapProvider::CompleteSetupUeParameters', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-rrc-sap.h (module 'lte'): void ns3::LteEnbRrcSapProvider::RecvMeasurementReport(uint16_t rnti, ns3::LteRrcSap::MeasurementReport msg) [member function]
    cls.add_method('RecvMeasurementReport',
                   'void',
                   [param('uint16_t', 'rnti'), param('ns3::LteRrcSap::MeasurementReport', 'msg')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-rrc-sap.h (module 'lte'): void ns3::LteEnbRrcSapProvider::RecvRrcConnectionReconfigurationCompleted(uint16_t rnti, ns3::LteRrcSap::RrcConnectionReconfigurationCompleted msg) [member function]
    cls.add_method('RecvRrcConnectionReconfigurationCompleted',
                   'void',
                   [param('uint16_t', 'rnti'), param('ns3::LteRrcSap::RrcConnectionReconfigurationCompleted', 'msg')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-rrc-sap.h (module 'lte'): void ns3::LteEnbRrcSapProvider::RecvRrcConnectionReestablishmentComplete(uint16_t rnti, ns3::LteRrcSap::RrcConnectionReestablishmentComplete msg) [member function]
    cls.add_method('RecvRrcConnectionReestablishmentComplete',
                   'void',
                   [param('uint16_t', 'rnti'), param('ns3::LteRrcSap::RrcConnectionReestablishmentComplete', 'msg')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-rrc-sap.h (module 'lte'): void ns3::LteEnbRrcSapProvider::RecvRrcConnectionReestablishmentRequest(uint16_t rnti, ns3::LteRrcSap::RrcConnectionReestablishmentRequest msg) [member function]
    cls.add_method('RecvRrcConnectionReestablishmentRequest',
                   'void',
                   [param('uint16_t', 'rnti'), param('ns3::LteRrcSap::RrcConnectionReestablishmentRequest', 'msg')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-rrc-sap.h (module 'lte'): void ns3::LteEnbRrcSapProvider::RecvRrcConnectionRequest(uint16_t rnti, ns3::LteRrcSap::RrcConnectionRequest msg) [member function]
    cls.add_method('RecvRrcConnectionRequest',
                   'void',
                   [param('uint16_t', 'rnti'), param('ns3::LteRrcSap::RrcConnectionRequest', 'msg')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-rrc-sap.h (module 'lte'): void ns3::LteEnbRrcSapProvider::RecvRrcConnectionSetupCompleted(uint16_t rnti, ns3::LteRrcSap::RrcConnectionSetupCompleted msg) [member function]
    cls.add_method('RecvRrcConnectionSetupCompleted',
                   'void',
                   [param('uint16_t', 'rnti'), param('ns3::LteRrcSap::RrcConnectionSetupCompleted', 'msg')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-rrc-sap.h (module 'lte'): void ns3::LteEnbRrcSapProvider::RecvRrcSecondaryCellInitialAccessSuccessful(uint16_t rnti, uint16_t mmWaveRnti, uint16_t mmWaveCellId) [member function]
    cls.add_method('RecvRrcSecondaryCellInitialAccessSuccessful',
                   'void',
                   [param('uint16_t', 'rnti'), param('uint16_t', 'mmWaveRnti'), param('uint16_t', 'mmWaveCellId')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3LteEnbRrcSapProviderCompleteSetupUeParameters_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteEnbRrcSapProvider::CompleteSetupUeParameters::CompleteSetupUeParameters() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteEnbRrcSapProvider::CompleteSetupUeParameters::CompleteSetupUeParameters(ns3::LteEnbRrcSapProvider::CompleteSetupUeParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteEnbRrcSapProvider::CompleteSetupUeParameters const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteEnbRrcSapProvider::CompleteSetupUeParameters::srb0SapUser [variable]
    cls.add_instance_attribute('srb0SapUser', 'ns3::LteRlcSapUser *', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteEnbRrcSapProvider::CompleteSetupUeParameters::srb1SapUser [variable]
    cls.add_instance_attribute('srb1SapUser', 'ns3::LtePdcpSapUser *', is_const=False)
    return

def register_Ns3LteEnbRrcSapUser_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteEnbRrcSapUser::LteEnbRrcSapUser() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteEnbRrcSapUser::LteEnbRrcSapUser(ns3::LteEnbRrcSapUser const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteEnbRrcSapUser const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReconfiguration ns3::LteEnbRrcSapUser::DecodeHandoverCommand(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('DecodeHandoverCommand',
                   'ns3::LteRrcSap::RrcConnectionReconfiguration',
                   [param('ns3::Ptr< ns3::Packet >', 'p')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteRrcSap::HandoverPreparationInfo ns3::LteEnbRrcSapUser::DecodeHandoverPreparationInformation(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('DecodeHandoverPreparationInformation',
                   'ns3::LteRrcSap::HandoverPreparationInfo',
                   [param('ns3::Ptr< ns3::Packet >', 'p')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-rrc-sap.h (module 'lte'): ns3::Ptr<ns3::Packet> ns3::LteEnbRrcSapUser::EncodeHandoverCommand(ns3::LteRrcSap::RrcConnectionReconfiguration msg) [member function]
    cls.add_method('EncodeHandoverCommand',
                   'ns3::Ptr< ns3::Packet >',
                   [param('ns3::LteRrcSap::RrcConnectionReconfiguration', 'msg')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-rrc-sap.h (module 'lte'): ns3::Ptr<ns3::Packet> ns3::LteEnbRrcSapUser::EncodeHandoverPreparationInformation(ns3::LteRrcSap::HandoverPreparationInfo msg) [member function]
    cls.add_method('EncodeHandoverPreparationInformation',
                   'ns3::Ptr< ns3::Packet >',
                   [param('ns3::LteRrcSap::HandoverPreparationInfo', 'msg')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-rrc-sap.h (module 'lte'): void ns3::LteEnbRrcSapUser::RemoveUe(uint16_t rnti) [member function]
    cls.add_method('RemoveUe',
                   'void',
                   [param('uint16_t', 'rnti')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-rrc-sap.h (module 'lte'): void ns3::LteEnbRrcSapUser::SendRrcConnectToMmWave(uint16_t rnti, uint16_t mmWaveCellId) [member function]
    cls.add_method('SendRrcConnectToMmWave',
                   'void',
                   [param('uint16_t', 'rnti'), param('uint16_t', 'mmWaveCellId')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-rrc-sap.h (module 'lte'): void ns3::LteEnbRrcSapUser::SendRrcConnectionReconfiguration(uint16_t rnti, ns3::LteRrcSap::RrcConnectionReconfiguration msg) [member function]
    cls.add_method('SendRrcConnectionReconfiguration',
                   'void',
                   [param('uint16_t', 'rnti'), param('ns3::LteRrcSap::RrcConnectionReconfiguration', 'msg')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-rrc-sap.h (module 'lte'): void ns3::LteEnbRrcSapUser::SendRrcConnectionReestablishment(uint16_t rnti, ns3::LteRrcSap::RrcConnectionReestablishment msg) [member function]
    cls.add_method('SendRrcConnectionReestablishment',
                   'void',
                   [param('uint16_t', 'rnti'), param('ns3::LteRrcSap::RrcConnectionReestablishment', 'msg')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-rrc-sap.h (module 'lte'): void ns3::LteEnbRrcSapUser::SendRrcConnectionReestablishmentReject(uint16_t rnti, ns3::LteRrcSap::RrcConnectionReestablishmentReject msg) [member function]
    cls.add_method('SendRrcConnectionReestablishmentReject',
                   'void',
                   [param('uint16_t', 'rnti'), param('ns3::LteRrcSap::RrcConnectionReestablishmentReject', 'msg')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-rrc-sap.h (module 'lte'): void ns3::LteEnbRrcSapUser::SendRrcConnectionReject(uint16_t rnti, ns3::LteRrcSap::RrcConnectionReject msg) [member function]
    cls.add_method('SendRrcConnectionReject',
                   'void',
                   [param('uint16_t', 'rnti'), param('ns3::LteRrcSap::RrcConnectionReject', 'msg')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-rrc-sap.h (module 'lte'): void ns3::LteEnbRrcSapUser::SendRrcConnectionRelease(uint16_t rnti, ns3::LteRrcSap::RrcConnectionRelease msg) [member function]
    cls.add_method('SendRrcConnectionRelease',
                   'void',
                   [param('uint16_t', 'rnti'), param('ns3::LteRrcSap::RrcConnectionRelease', 'msg')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-rrc-sap.h (module 'lte'): void ns3::LteEnbRrcSapUser::SendRrcConnectionSetup(uint16_t rnti, ns3::LteRrcSap::RrcConnectionSetup msg) [member function]
    cls.add_method('SendRrcConnectionSetup',
                   'void',
                   [param('uint16_t', 'rnti'), param('ns3::LteRrcSap::RrcConnectionSetup', 'msg')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-rrc-sap.h (module 'lte'): void ns3::LteEnbRrcSapUser::SendRrcConnectionSwitch(uint16_t rnti, ns3::LteRrcSap::RrcConnectionSwitch msg) [member function]
    cls.add_method('SendRrcConnectionSwitch',
                   'void',
                   [param('uint16_t', 'rnti'), param('ns3::LteRrcSap::RrcConnectionSwitch', 'msg')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-rrc-sap.h (module 'lte'): void ns3::LteEnbRrcSapUser::SendSystemInformation(uint16_t cellId, ns3::LteRrcSap::SystemInformation msg) [member function]
    cls.add_method('SendSystemInformation',
                   'void',
                   [param('uint16_t', 'cellId'), param('ns3::LteRrcSap::SystemInformation', 'msg')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-rrc-sap.h (module 'lte'): void ns3::LteEnbRrcSapUser::SetupUe(uint16_t rnti, ns3::LteEnbRrcSapUser::SetupUeParameters params) [member function]
    cls.add_method('SetupUe',
                   'void',
                   [param('uint16_t', 'rnti'), param('ns3::LteEnbRrcSapUser::SetupUeParameters', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3LteEnbRrcSapUserSetupUeParameters_methods(root_module, cls):
    ## lte-rrc-sap.h (module 'lte'): ns3::LteEnbRrcSapUser::SetupUeParameters::SetupUeParameters() [constructor]
    cls.add_constructor([])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteEnbRrcSapUser::SetupUeParameters::SetupUeParameters(ns3::LteEnbRrcSapUser::SetupUeParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteEnbRrcSapUser::SetupUeParameters const &', 'arg0')])
    ## lte-rrc-sap.h (module 'lte'): ns3::LteEnbRrcSapUser::SetupUeParameters::srb0SapProvider [variable]
    cls.add_instance_attribute('srb0SapProvider', 'ns3::LteRlcSapProvider *', is_const=False)
    ## lte-rrc-sap.h (module 'lte'): ns3::LteEnbRrcSapUser::SetupUeParameters::srb1SapProvider [variable]
    cls.add_instance_attribute('srb1SapProvider', 'ns3::LtePdcpSapProvider *', is_const=False)
    return

def register_Ns3LtePdcpHeader_methods(root_module, cls):
    ## lte-pdcp-header.h (module 'lte'): ns3::LtePdcpHeader::LtePdcpHeader(ns3::LtePdcpHeader const & arg0) [constructor]
    cls.add_constructor([param('ns3::LtePdcpHeader const &', 'arg0')])
    ## lte-pdcp-header.h (module 'lte'): ns3::LtePdcpHeader::LtePdcpHeader() [constructor]
    cls.add_constructor([])
    ## lte-pdcp-header.h (module 'lte'): uint32_t ns3::LtePdcpHeader::Deserialize(ns3::Buffer::Iterator start) [member function]
    cls.add_method('Deserialize',
                   'uint32_t',
                   [param('ns3::Buffer::Iterator', 'start')],
                   is_virtual=True)
    ## lte-pdcp-header.h (module 'lte'): uint8_t ns3::LtePdcpHeader::GetDcBit() const [member function]
    cls.add_method('GetDcBit',
                   'uint8_t',
                   [],
                   is_const=True)
    ## lte-pdcp-header.h (module 'lte'): ns3::TypeId ns3::LtePdcpHeader::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId',
                   'ns3::TypeId',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-pdcp-header.h (module 'lte'): uint16_t ns3::LtePdcpHeader::GetSequenceNumber() const [member function]
    cls.add_method('GetSequenceNumber',
                   'uint16_t',
                   [],
                   is_const=True)
    ## lte-pdcp-header.h (module 'lte'): uint32_t ns3::LtePdcpHeader::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize',
                   'uint32_t',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-pdcp-header.h (module 'lte'): static ns3::TypeId ns3::LtePdcpHeader::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## lte-pdcp-header.h (module 'lte'): void ns3::LtePdcpHeader::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True, is_virtual=True)
    ## lte-pdcp-header.h (module 'lte'): void ns3::LtePdcpHeader::Serialize(ns3::Buffer::Iterator start) const [member function]
    cls.add_method('Serialize',
                   'void',
                   [param('ns3::Buffer::Iterator', 'start')],
                   is_const=True, is_virtual=True)
    ## lte-pdcp-header.h (module 'lte'): void ns3::LtePdcpHeader::SetDcBit(uint8_t dcBit) [member function]
    cls.add_method('SetDcBit',
                   'void',
                   [param('uint8_t', 'dcBit')])
    ## lte-pdcp-header.h (module 'lte'): void ns3::LtePdcpHeader::SetSequenceNumber(uint16_t sequenceNumber) [member function]
    cls.add_method('SetSequenceNumber',
                   'void',
                   [param('uint16_t', 'sequenceNumber')])
    return

def register_Ns3LteRadioBearerTag_methods(root_module, cls):
    ## lte-radio-bearer-tag.h (module 'lte'): ns3::LteRadioBearerTag::LteRadioBearerTag(ns3::LteRadioBearerTag const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRadioBearerTag const &', 'arg0')])
    ## lte-radio-bearer-tag.h (module 'lte'): ns3::LteRadioBearerTag::LteRadioBearerTag() [constructor]
    cls.add_constructor([])
    ## lte-radio-bearer-tag.h (module 'lte'): ns3::LteRadioBearerTag::LteRadioBearerTag(uint16_t rnti, uint8_t lcId) [constructor]
    cls.add_constructor([param('uint16_t', 'rnti'), param('uint8_t', 'lcId')])
    ## lte-radio-bearer-tag.h (module 'lte'): ns3::LteRadioBearerTag::LteRadioBearerTag(uint16_t rnti, uint8_t lcId, uint8_t layer) [constructor]
    cls.add_constructor([param('uint16_t', 'rnti'), param('uint8_t', 'lcId'), param('uint8_t', 'layer')])
    ## lte-radio-bearer-tag.h (module 'lte'): void ns3::LteRadioBearerTag::Deserialize(ns3::TagBuffer i) [member function]
    cls.add_method('Deserialize',
                   'void',
                   [param('ns3::TagBuffer', 'i')],
                   is_virtual=True)
    ## lte-radio-bearer-tag.h (module 'lte'): ns3::TypeId ns3::LteRadioBearerTag::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId',
                   'ns3::TypeId',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-radio-bearer-tag.h (module 'lte'): uint8_t ns3::LteRadioBearerTag::GetLayer() const [member function]
    cls.add_method('GetLayer',
                   'uint8_t',
                   [],
                   is_const=True)
    ## lte-radio-bearer-tag.h (module 'lte'): uint8_t ns3::LteRadioBearerTag::GetLcid() const [member function]
    cls.add_method('GetLcid',
                   'uint8_t',
                   [],
                   is_const=True)
    ## lte-radio-bearer-tag.h (module 'lte'): uint16_t ns3::LteRadioBearerTag::GetRnti() const [member function]
    cls.add_method('GetRnti',
                   'uint16_t',
                   [],
                   is_const=True)
    ## lte-radio-bearer-tag.h (module 'lte'): uint32_t ns3::LteRadioBearerTag::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize',
                   'uint32_t',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-radio-bearer-tag.h (module 'lte'): static ns3::TypeId ns3::LteRadioBearerTag::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## lte-radio-bearer-tag.h (module 'lte'): void ns3::LteRadioBearerTag::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True, is_virtual=True)
    ## lte-radio-bearer-tag.h (module 'lte'): void ns3::LteRadioBearerTag::Serialize(ns3::TagBuffer i) const [member function]
    cls.add_method('Serialize',
                   'void',
                   [param('ns3::TagBuffer', 'i')],
                   is_const=True, is_virtual=True)
    ## lte-radio-bearer-tag.h (module 'lte'): void ns3::LteRadioBearerTag::SetLayer(uint8_t layer) [member function]
    cls.add_method('SetLayer',
                   'void',
                   [param('uint8_t', 'layer')])
    ## lte-radio-bearer-tag.h (module 'lte'): void ns3::LteRadioBearerTag::SetLcid(uint8_t lcid) [member function]
    cls.add_method('SetLcid',
                   'void',
                   [param('uint8_t', 'lcid')])
    ## lte-radio-bearer-tag.h (module 'lte'): void ns3::LteRadioBearerTag::SetRnti(uint16_t rnti) [member function]
    cls.add_method('SetRnti',
                   'void',
                   [param('uint16_t', 'rnti')])
    return

def register_Ns3Object_methods(root_module, cls):
    ## object.h (module 'core'): ns3::Object::Object() [constructor]
    cls.add_constructor([])
    ## object.h (module 'core'): void ns3::Object::AggregateObject(ns3::Ptr<ns3::Object> other) [member function]
    cls.add_method('AggregateObject',
                   'void',
                   [param('ns3::Ptr< ns3::Object >', 'other')])
    ## object.h (module 'core'): void ns3::Object::Dispose() [member function]
    cls.add_method('Dispose',
                   'void',
                   [])
    ## object.h (module 'core'): ns3::Object::AggregateIterator ns3::Object::GetAggregateIterator() const [member function]
    cls.add_method('GetAggregateIterator',
                   'ns3::Object::AggregateIterator',
                   [],
                   is_const=True)
    ## object.h (module 'core'): ns3::TypeId ns3::Object::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId',
                   'ns3::TypeId',
                   [],
                   is_const=True, is_virtual=True)
    ## object.h (module 'core'): static ns3::TypeId ns3::Object::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## object.h (module 'core'): void ns3::Object::Initialize() [member function]
    cls.add_method('Initialize',
                   'void',
                   [])
    ## object.h (module 'core'): bool ns3::Object::IsInitialized() const [member function]
    cls.add_method('IsInitialized',
                   'bool',
                   [],
                   is_const=True)
    ## object.h (module 'core'): ns3::Object::Object(ns3::Object const & o) [constructor]
    cls.add_constructor([param('ns3::Object const &', 'o')],
                        visibility='protected')
    ## object.h (module 'core'): void ns3::Object::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   visibility='protected', is_virtual=True)
    ## object.h (module 'core'): void ns3::Object::DoInitialize() [member function]
    cls.add_method('DoInitialize',
                   'void',
                   [],
                   visibility='protected', is_virtual=True)
    ## object.h (module 'core'): void ns3::Object::NotifyNewAggregate() [member function]
    cls.add_method('NotifyNewAggregate',
                   'void',
                   [],
                   visibility='protected', is_virtual=True)
    return

def register_Ns3ObjectAggregateIterator_methods(root_module, cls):
    ## object.h (module 'core'): ns3::Object::AggregateIterator::AggregateIterator(ns3::Object::AggregateIterator const & arg0) [constructor]
    cls.add_constructor([param('ns3::Object::AggregateIterator const &', 'arg0')])
    ## object.h (module 'core'): ns3::Object::AggregateIterator::AggregateIterator() [constructor]
    cls.add_constructor([])
    ## object.h (module 'core'): bool ns3::Object::AggregateIterator::HasNext() const [member function]
    cls.add_method('HasNext',
                   'bool',
                   [],
                   is_const=True)
    ## object.h (module 'core'): ns3::Ptr<const ns3::Object> ns3::Object::AggregateIterator::Next() [member function]
    cls.add_method('Next',
                   'ns3::Ptr< ns3::Object const >',
                   [])
    return

def register_Ns3PacketBurst_methods(root_module, cls):
    ## packet-burst.h (module 'network'): ns3::PacketBurst::PacketBurst(ns3::PacketBurst const & arg0) [constructor]
    cls.add_constructor([param('ns3::PacketBurst const &', 'arg0')])
    ## packet-burst.h (module 'network'): ns3::PacketBurst::PacketBurst() [constructor]
    cls.add_constructor([])
    ## packet-burst.h (module 'network'): void ns3::PacketBurst::AddPacket(ns3::Ptr<ns3::Packet> packet) [member function]
    cls.add_method('AddPacket',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'packet')])
    ## packet-burst.h (module 'network'): std::list<ns3::Ptr<ns3::Packet>, std::allocator<ns3::Ptr<ns3::Packet> > >::const_iterator ns3::PacketBurst::Begin() const [member function]
    cls.add_method('Begin',
                   'std::list< ns3::Ptr< ns3::Packet > > const_iterator',
                   [],
                   is_const=True)
    ## packet-burst.h (module 'network'): ns3::Ptr<ns3::PacketBurst> ns3::PacketBurst::Copy() const [member function]
    cls.add_method('Copy',
                   'ns3::Ptr< ns3::PacketBurst >',
                   [],
                   is_const=True)
    ## packet-burst.h (module 'network'): std::list<ns3::Ptr<ns3::Packet>, std::allocator<ns3::Ptr<ns3::Packet> > >::const_iterator ns3::PacketBurst::End() const [member function]
    cls.add_method('End',
                   'std::list< ns3::Ptr< ns3::Packet > > const_iterator',
                   [],
                   is_const=True)
    ## packet-burst.h (module 'network'): uint32_t ns3::PacketBurst::GetNPackets() const [member function]
    cls.add_method('GetNPackets',
                   'uint32_t',
                   [],
                   is_const=True)
    ## packet-burst.h (module 'network'): std::list<ns3::Ptr<ns3::Packet>, std::allocator<ns3::Ptr<ns3::Packet> > > ns3::PacketBurst::GetPackets() const [member function]
    cls.add_method('GetPackets',
                   'std::list< ns3::Ptr< ns3::Packet > >',
                   [],
                   is_const=True)
    ## packet-burst.h (module 'network'): uint32_t ns3::PacketBurst::GetSize() const [member function]
    cls.add_method('GetSize',
                   'uint32_t',
                   [],
                   is_const=True)
    ## packet-burst.h (module 'network'): static ns3::TypeId ns3::PacketBurst::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## packet-burst.h (module 'network'): void ns3::PacketBurst::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   visibility='private', is_virtual=True)
    return

def register_Ns3PacketFilter_methods(root_module, cls):
    ## packet-filter.h (module 'traffic-control'): ns3::PacketFilter::PacketFilter(ns3::PacketFilter const & arg0) [constructor]
    cls.add_constructor([param('ns3::PacketFilter const &', 'arg0')])
    ## packet-filter.h (module 'traffic-control'): ns3::PacketFilter::PacketFilter() [constructor]
    cls.add_constructor([])
    ## packet-filter.h (module 'traffic-control'): int32_t ns3::PacketFilter::Classify(ns3::Ptr<ns3::QueueDiscItem> item) const [member function]
    cls.add_method('Classify',
                   'int32_t',
                   [param('ns3::Ptr< ns3::QueueDiscItem >', 'item')],
                   is_const=True)
    ## packet-filter.h (module 'traffic-control'): static ns3::TypeId ns3::PacketFilter::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## packet-filter.h (module 'traffic-control'): ns3::PacketFilter::PF_NO_MATCH [variable]
    cls.add_static_attribute('PF_NO_MATCH', 'int const', is_const=True)
    ## packet-filter.h (module 'traffic-control'): bool ns3::PacketFilter::CheckProtocol(ns3::Ptr<ns3::QueueDiscItem> item) const [member function]
    cls.add_method('CheckProtocol',
                   'bool',
                   [param('ns3::Ptr< ns3::QueueDiscItem >', 'item')],
                   is_pure_virtual=True, is_const=True, visibility='private', is_virtual=True)
    ## packet-filter.h (module 'traffic-control'): int32_t ns3::PacketFilter::DoClassify(ns3::Ptr<ns3::QueueDiscItem> item) const [member function]
    cls.add_method('DoClassify',
                   'int32_t',
                   [param('ns3::Ptr< ns3::QueueDiscItem >', 'item')],
                   is_pure_virtual=True, is_const=True, visibility='private', is_virtual=True)
    return

def register_Ns3PropagationDelayModel_methods(root_module, cls):
    ## propagation-delay-model.h (module 'propagation'): ns3::PropagationDelayModel::PropagationDelayModel() [constructor]
    cls.add_constructor([])
    ## propagation-delay-model.h (module 'propagation'): ns3::PropagationDelayModel::PropagationDelayModel(ns3::PropagationDelayModel const & arg0) [constructor]
    cls.add_constructor([param('ns3::PropagationDelayModel const &', 'arg0')])
    ## propagation-delay-model.h (module 'propagation'): int64_t ns3::PropagationDelayModel::AssignStreams(int64_t stream) [member function]
    cls.add_method('AssignStreams',
                   'int64_t',
                   [param('int64_t', 'stream')])
    ## propagation-delay-model.h (module 'propagation'): ns3::Time ns3::PropagationDelayModel::GetDelay(ns3::Ptr<ns3::MobilityModel> a, ns3::Ptr<ns3::MobilityModel> b) const [member function]
    cls.add_method('GetDelay',
                   'ns3::Time',
                   [param('ns3::Ptr< ns3::MobilityModel >', 'a'), param('ns3::Ptr< ns3::MobilityModel >', 'b')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## propagation-delay-model.h (module 'propagation'): static ns3::TypeId ns3::PropagationDelayModel::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## propagation-delay-model.h (module 'propagation'): int64_t ns3::PropagationDelayModel::DoAssignStreams(int64_t stream) [member function]
    cls.add_method('DoAssignStreams',
                   'int64_t',
                   [param('int64_t', 'stream')],
                   is_pure_virtual=True, visibility='private', is_virtual=True)
    return

def register_Ns3PropagationLossModel_methods(root_module, cls):
    ## propagation-loss-model.h (module 'propagation'): static ns3::TypeId ns3::PropagationLossModel::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## propagation-loss-model.h (module 'propagation'): ns3::PropagationLossModel::PropagationLossModel() [constructor]
    cls.add_constructor([])
    ## propagation-loss-model.h (module 'propagation'): void ns3::PropagationLossModel::SetNext(ns3::Ptr<ns3::PropagationLossModel> next) [member function]
    cls.add_method('SetNext',
                   'void',
                   [param('ns3::Ptr< ns3::PropagationLossModel >', 'next')])
    ## propagation-loss-model.h (module 'propagation'): ns3::Ptr<ns3::PropagationLossModel> ns3::PropagationLossModel::GetNext() [member function]
    cls.add_method('GetNext',
                   'ns3::Ptr< ns3::PropagationLossModel >',
                   [])
    ## propagation-loss-model.h (module 'propagation'): double ns3::PropagationLossModel::CalcRxPower(double txPowerDbm, ns3::Ptr<ns3::MobilityModel> a, ns3::Ptr<ns3::MobilityModel> b) const [member function]
    cls.add_method('CalcRxPower',
                   'double',
                   [param('double', 'txPowerDbm'), param('ns3::Ptr< ns3::MobilityModel >', 'a'), param('ns3::Ptr< ns3::MobilityModel >', 'b')],
                   is_const=True)
    ## propagation-loss-model.h (module 'propagation'): int64_t ns3::PropagationLossModel::AssignStreams(int64_t stream) [member function]
    cls.add_method('AssignStreams',
                   'int64_t',
                   [param('int64_t', 'stream')])
    ## propagation-loss-model.h (module 'propagation'): double ns3::PropagationLossModel::DoCalcRxPower(double txPowerDbm, ns3::Ptr<ns3::MobilityModel> a, ns3::Ptr<ns3::MobilityModel> b) const [member function]
    cls.add_method('DoCalcRxPower',
                   'double',
                   [param('double', 'txPowerDbm'), param('ns3::Ptr< ns3::MobilityModel >', 'a'), param('ns3::Ptr< ns3::MobilityModel >', 'b')],
                   is_pure_virtual=True, is_const=True, visibility='private', is_virtual=True)
    ## propagation-loss-model.h (module 'propagation'): int64_t ns3::PropagationLossModel::DoAssignStreams(int64_t stream) [member function]
    cls.add_method('DoAssignStreams',
                   'int64_t',
                   [param('int64_t', 'stream')],
                   is_pure_virtual=True, visibility='private', is_virtual=True)
    return

def register_Ns3QueueDisc_methods(root_module, cls):
    ## queue-disc.h (module 'traffic-control'): ns3::QueueDisc::QueueDisc(ns3::QueueDiscSizePolicy policy=::ns3::QueueDiscSizePolicy::SINGLE_INTERNAL_QUEUE) [constructor]
    cls.add_constructor([param('ns3::QueueDiscSizePolicy', 'policy', default_value='::ns3::QueueDiscSizePolicy::SINGLE_INTERNAL_QUEUE')])
    ## queue-disc.h (module 'traffic-control'): ns3::QueueDisc::QueueDisc(ns3::QueueDiscSizePolicy policy, ns3::QueueSizeUnit unit) [constructor]
    cls.add_constructor([param('ns3::QueueDiscSizePolicy', 'policy'), param('ns3::QueueSizeUnit', 'unit')])
    ## queue-disc.h (module 'traffic-control'): void ns3::QueueDisc::AddInternalQueue(ns3::Ptr<ns3::Queue<ns3::QueueDiscItem> > queue) [member function]
    cls.add_method('AddInternalQueue',
                   'void',
                   [param('ns3::Ptr< ns3::Queue< ns3::QueueDiscItem > >', 'queue')])
    ## queue-disc.h (module 'traffic-control'): void ns3::QueueDisc::AddPacketFilter(ns3::Ptr<ns3::PacketFilter> filter) [member function]
    cls.add_method('AddPacketFilter',
                   'void',
                   [param('ns3::Ptr< ns3::PacketFilter >', 'filter')])
    ## queue-disc.h (module 'traffic-control'): void ns3::QueueDisc::AddQueueDiscClass(ns3::Ptr<ns3::QueueDiscClass> qdClass) [member function]
    cls.add_method('AddQueueDiscClass',
                   'void',
                   [param('ns3::Ptr< ns3::QueueDiscClass >', 'qdClass')])
    ## queue-disc.h (module 'traffic-control'): int32_t ns3::QueueDisc::Classify(ns3::Ptr<ns3::QueueDiscItem> item) [member function]
    cls.add_method('Classify',
                   'int32_t',
                   [param('ns3::Ptr< ns3::QueueDiscItem >', 'item')])
    ## queue-disc.h (module 'traffic-control'): ns3::Ptr<ns3::QueueDiscItem> ns3::QueueDisc::Dequeue() [member function]
    cls.add_method('Dequeue',
                   'ns3::Ptr< ns3::QueueDiscItem >',
                   [])
    ## queue-disc.h (module 'traffic-control'): bool ns3::QueueDisc::Enqueue(ns3::Ptr<ns3::QueueDiscItem> item) [member function]
    cls.add_method('Enqueue',
                   'bool',
                   [param('ns3::Ptr< ns3::QueueDiscItem >', 'item')])
    ## queue-disc.h (module 'traffic-control'): ns3::QueueSize ns3::QueueDisc::GetCurrentSize() [member function]
    cls.add_method('GetCurrentSize',
                   'ns3::QueueSize',
                   [])
    ## queue-disc.h (module 'traffic-control'): ns3::Ptr<ns3::Queue<ns3::QueueDiscItem> > ns3::QueueDisc::GetInternalQueue(std::size_t i) const [member function]
    cls.add_method('GetInternalQueue',
                   'ns3::Ptr< ns3::Queue< ns3::QueueDiscItem > >',
                   [param('std::size_t', 'i')],
                   is_const=True)
    ## queue-disc.h (module 'traffic-control'): ns3::QueueSize ns3::QueueDisc::GetMaxSize() const [member function]
    cls.add_method('GetMaxSize',
                   'ns3::QueueSize',
                   [],
                   is_const=True)
    ## queue-disc.h (module 'traffic-control'): uint32_t ns3::QueueDisc::GetNBytes() const [member function]
    cls.add_method('GetNBytes',
                   'uint32_t',
                   [],
                   is_const=True)
    ## queue-disc.h (module 'traffic-control'): std::size_t ns3::QueueDisc::GetNInternalQueues() const [member function]
    cls.add_method('GetNInternalQueues',
                   'std::size_t',
                   [],
                   is_const=True)
    ## queue-disc.h (module 'traffic-control'): std::size_t ns3::QueueDisc::GetNPacketFilters() const [member function]
    cls.add_method('GetNPacketFilters',
                   'std::size_t',
                   [],
                   is_const=True)
    ## queue-disc.h (module 'traffic-control'): uint32_t ns3::QueueDisc::GetNPackets() const [member function]
    cls.add_method('GetNPackets',
                   'uint32_t',
                   [],
                   is_const=True)
    ## queue-disc.h (module 'traffic-control'): std::size_t ns3::QueueDisc::GetNQueueDiscClasses() const [member function]
    cls.add_method('GetNQueueDiscClasses',
                   'std::size_t',
                   [],
                   is_const=True)
    ## queue-disc.h (module 'traffic-control'): ns3::Ptr<ns3::NetDevice> ns3::QueueDisc::GetNetDevice() const [member function]
    cls.add_method('GetNetDevice',
                   'ns3::Ptr< ns3::NetDevice >',
                   [],
                   is_const=True)
    ## queue-disc.h (module 'traffic-control'): ns3::Ptr<ns3::PacketFilter> ns3::QueueDisc::GetPacketFilter(std::size_t i) const [member function]
    cls.add_method('GetPacketFilter',
                   'ns3::Ptr< ns3::PacketFilter >',
                   [param('std::size_t', 'i')],
                   is_const=True)
    ## queue-disc.h (module 'traffic-control'): ns3::Ptr<ns3::QueueDiscClass> ns3::QueueDisc::GetQueueDiscClass(std::size_t i) const [member function]
    cls.add_method('GetQueueDiscClass',
                   'ns3::Ptr< ns3::QueueDiscClass >',
                   [param('std::size_t', 'i')],
                   is_const=True)
    ## queue-disc.h (module 'traffic-control'): uint32_t ns3::QueueDisc::GetQuota() const [member function]
    cls.add_method('GetQuota',
                   'uint32_t',
                   [],
                   is_const=True, is_virtual=True)
    ## queue-disc.h (module 'traffic-control'): ns3::QueueDisc::Stats const & ns3::QueueDisc::GetStats() [member function]
    cls.add_method('GetStats',
                   'ns3::QueueDisc::Stats const &',
                   [])
    ## queue-disc.h (module 'traffic-control'): static ns3::TypeId ns3::QueueDisc::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## queue-disc.h (module 'traffic-control'): ns3::QueueDisc::WakeMode ns3::QueueDisc::GetWakeMode() const [member function]
    cls.add_method('GetWakeMode',
                   'ns3::QueueDisc::WakeMode',
                   [],
                   is_const=True, is_virtual=True)
    ## queue-disc.h (module 'traffic-control'): ns3::Ptr<const ns3::QueueDiscItem> ns3::QueueDisc::Peek() [member function]
    cls.add_method('Peek',
                   'ns3::Ptr< ns3::QueueDiscItem const >',
                   [])
    ## queue-disc.h (module 'traffic-control'): void ns3::QueueDisc::Run() [member function]
    cls.add_method('Run',
                   'void',
                   [])
    ## queue-disc.h (module 'traffic-control'): bool ns3::QueueDisc::SetMaxSize(ns3::QueueSize size) [member function]
    cls.add_method('SetMaxSize',
                   'bool',
                   [param('ns3::QueueSize', 'size')])
    ## queue-disc.h (module 'traffic-control'): void ns3::QueueDisc::SetNetDevice(ns3::Ptr<ns3::NetDevice> device) [member function]
    cls.add_method('SetNetDevice',
                   'void',
                   [param('ns3::Ptr< ns3::NetDevice >', 'device')])
    ## queue-disc.h (module 'traffic-control'): void ns3::QueueDisc::SetQuota(uint32_t const quota) [member function]
    cls.add_method('SetQuota',
                   'void',
                   [param('uint32_t const', 'quota')],
                   is_virtual=True)
    ## queue-disc.h (module 'traffic-control'): ns3::QueueDisc::CHILD_QUEUE_DISC_DROP [variable]
    cls.add_static_attribute('CHILD_QUEUE_DISC_DROP', 'char const * const', is_const=True)
    ## queue-disc.h (module 'traffic-control'): ns3::QueueDisc::INTERNAL_QUEUE_DROP [variable]
    cls.add_static_attribute('INTERNAL_QUEUE_DROP', 'char const * const', is_const=True)
    ## queue-disc.h (module 'traffic-control'): void ns3::QueueDisc::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   visibility='protected', is_virtual=True)
    ## queue-disc.h (module 'traffic-control'): void ns3::QueueDisc::DoInitialize() [member function]
    cls.add_method('DoInitialize',
                   'void',
                   [],
                   visibility='protected', is_virtual=True)
    ## queue-disc.h (module 'traffic-control'): void ns3::QueueDisc::DropAfterDequeue(ns3::Ptr<const ns3::QueueDiscItem> item, char const * reason) [member function]
    cls.add_method('DropAfterDequeue',
                   'void',
                   [param('ns3::Ptr< ns3::QueueDiscItem const >', 'item'), param('char const *', 'reason')],
                   visibility='protected')
    ## queue-disc.h (module 'traffic-control'): void ns3::QueueDisc::DropBeforeEnqueue(ns3::Ptr<const ns3::QueueDiscItem> item, char const * reason) [member function]
    cls.add_method('DropBeforeEnqueue',
                   'void',
                   [param('ns3::Ptr< ns3::QueueDiscItem const >', 'item'), param('char const *', 'reason')],
                   visibility='protected')
    ## queue-disc.h (module 'traffic-control'): bool ns3::QueueDisc::Mark(ns3::Ptr<ns3::QueueDiscItem> item, char const * reason) [member function]
    cls.add_method('Mark',
                   'bool',
                   [param('ns3::Ptr< ns3::QueueDiscItem >', 'item'), param('char const *', 'reason')],
                   visibility='protected')
    ## queue-disc.h (module 'traffic-control'): bool ns3::QueueDisc::CheckConfig() [member function]
    cls.add_method('CheckConfig',
                   'bool',
                   [],
                   is_pure_virtual=True, visibility='private', is_virtual=True)
    ## queue-disc.h (module 'traffic-control'): ns3::Ptr<ns3::QueueDiscItem> ns3::QueueDisc::DoDequeue() [member function]
    cls.add_method('DoDequeue',
                   'ns3::Ptr< ns3::QueueDiscItem >',
                   [],
                   is_pure_virtual=True, visibility='private', is_virtual=True)
    ## queue-disc.h (module 'traffic-control'): bool ns3::QueueDisc::DoEnqueue(ns3::Ptr<ns3::QueueDiscItem> item) [member function]
    cls.add_method('DoEnqueue',
                   'bool',
                   [param('ns3::Ptr< ns3::QueueDiscItem >', 'item')],
                   is_pure_virtual=True, visibility='private', is_virtual=True)
    ## queue-disc.h (module 'traffic-control'): ns3::Ptr<const ns3::QueueDiscItem> ns3::QueueDisc::DoPeek() [member function]
    cls.add_method('DoPeek',
                   'ns3::Ptr< ns3::QueueDiscItem const >',
                   [],
                   visibility='private', is_virtual=True)
    ## queue-disc.h (module 'traffic-control'): void ns3::QueueDisc::InitializeParams() [member function]
    cls.add_method('InitializeParams',
                   'void',
                   [],
                   is_pure_virtual=True, visibility='private', is_virtual=True)
    return

def register_Ns3QueueDiscStats_methods(root_module, cls):
    cls.add_output_stream_operator()
    ## queue-disc.h (module 'traffic-control'): ns3::QueueDisc::Stats::Stats(ns3::QueueDisc::Stats const & arg0) [constructor]
    cls.add_constructor([param('ns3::QueueDisc::Stats const &', 'arg0')])
    ## queue-disc.h (module 'traffic-control'): ns3::QueueDisc::Stats::Stats() [constructor]
    cls.add_constructor([])
    ## queue-disc.h (module 'traffic-control'): uint64_t ns3::QueueDisc::Stats::GetNDroppedBytes(std::string reason) const [member function]
    cls.add_method('GetNDroppedBytes',
                   'uint64_t',
                   [param('std::string', 'reason')],
                   is_const=True)
    ## queue-disc.h (module 'traffic-control'): uint32_t ns3::QueueDisc::Stats::GetNDroppedPackets(std::string reason) const [member function]
    cls.add_method('GetNDroppedPackets',
                   'uint32_t',
                   [param('std::string', 'reason')],
                   is_const=True)
    ## queue-disc.h (module 'traffic-control'): uint64_t ns3::QueueDisc::Stats::GetNMarkedBytes(std::string reason) const [member function]
    cls.add_method('GetNMarkedBytes',
                   'uint64_t',
                   [param('std::string', 'reason')],
                   is_const=True)
    ## queue-disc.h (module 'traffic-control'): uint32_t ns3::QueueDisc::Stats::GetNMarkedPackets(std::string reason) const [member function]
    cls.add_method('GetNMarkedPackets',
                   'uint32_t',
                   [param('std::string', 'reason')],
                   is_const=True)
    ## queue-disc.h (module 'traffic-control'): void ns3::QueueDisc::Stats::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True)
    ## queue-disc.h (module 'traffic-control'): ns3::QueueDisc::Stats::nDroppedBytesAfterDequeue [variable]
    cls.add_instance_attribute('nDroppedBytesAfterDequeue', 'std::map< std::string, unsigned long >', is_const=False)
    ## queue-disc.h (module 'traffic-control'): ns3::QueueDisc::Stats::nDroppedBytesBeforeEnqueue [variable]
    cls.add_instance_attribute('nDroppedBytesBeforeEnqueue', 'std::map< std::string, unsigned long >', is_const=False)
    ## queue-disc.h (module 'traffic-control'): ns3::QueueDisc::Stats::nDroppedPacketsAfterDequeue [variable]
    cls.add_instance_attribute('nDroppedPacketsAfterDequeue', 'std::map< std::string, unsigned int >', is_const=False)
    ## queue-disc.h (module 'traffic-control'): ns3::QueueDisc::Stats::nDroppedPacketsBeforeEnqueue [variable]
    cls.add_instance_attribute('nDroppedPacketsBeforeEnqueue', 'std::map< std::string, unsigned int >', is_const=False)
    ## queue-disc.h (module 'traffic-control'): ns3::QueueDisc::Stats::nMarkedBytes [variable]
    cls.add_instance_attribute('nMarkedBytes', 'std::map< std::string, unsigned long >', is_const=False)
    ## queue-disc.h (module 'traffic-control'): ns3::QueueDisc::Stats::nMarkedPackets [variable]
    cls.add_instance_attribute('nMarkedPackets', 'std::map< std::string, unsigned int >', is_const=False)
    ## queue-disc.h (module 'traffic-control'): ns3::QueueDisc::Stats::nTotalDequeuedBytes [variable]
    cls.add_instance_attribute('nTotalDequeuedBytes', 'uint64_t', is_const=False)
    ## queue-disc.h (module 'traffic-control'): ns3::QueueDisc::Stats::nTotalDequeuedPackets [variable]
    cls.add_instance_attribute('nTotalDequeuedPackets', 'uint32_t', is_const=False)
    ## queue-disc.h (module 'traffic-control'): ns3::QueueDisc::Stats::nTotalDroppedBytes [variable]
    cls.add_instance_attribute('nTotalDroppedBytes', 'uint64_t', is_const=False)
    ## queue-disc.h (module 'traffic-control'): ns3::QueueDisc::Stats::nTotalDroppedBytesAfterDequeue [variable]
    cls.add_instance_attribute('nTotalDroppedBytesAfterDequeue', 'uint64_t', is_const=False)
    ## queue-disc.h (module 'traffic-control'): ns3::QueueDisc::Stats::nTotalDroppedBytesBeforeEnqueue [variable]
    cls.add_instance_attribute('nTotalDroppedBytesBeforeEnqueue', 'uint64_t', is_const=False)
    ## queue-disc.h (module 'traffic-control'): ns3::QueueDisc::Stats::nTotalDroppedPackets [variable]
    cls.add_instance_attribute('nTotalDroppedPackets', 'uint32_t', is_const=False)
    ## queue-disc.h (module 'traffic-control'): ns3::QueueDisc::Stats::nTotalDroppedPacketsAfterDequeue [variable]
    cls.add_instance_attribute('nTotalDroppedPacketsAfterDequeue', 'uint32_t', is_const=False)
    ## queue-disc.h (module 'traffic-control'): ns3::QueueDisc::Stats::nTotalDroppedPacketsBeforeEnqueue [variable]
    cls.add_instance_attribute('nTotalDroppedPacketsBeforeEnqueue', 'uint32_t', is_const=False)
    ## queue-disc.h (module 'traffic-control'): ns3::QueueDisc::Stats::nTotalEnqueuedBytes [variable]
    cls.add_instance_attribute('nTotalEnqueuedBytes', 'uint64_t', is_const=False)
    ## queue-disc.h (module 'traffic-control'): ns3::QueueDisc::Stats::nTotalEnqueuedPackets [variable]
    cls.add_instance_attribute('nTotalEnqueuedPackets', 'uint32_t', is_const=False)
    ## queue-disc.h (module 'traffic-control'): ns3::QueueDisc::Stats::nTotalMarkedBytes [variable]
    cls.add_instance_attribute('nTotalMarkedBytes', 'uint32_t', is_const=False)
    ## queue-disc.h (module 'traffic-control'): ns3::QueueDisc::Stats::nTotalMarkedPackets [variable]
    cls.add_instance_attribute('nTotalMarkedPackets', 'uint32_t', is_const=False)
    ## queue-disc.h (module 'traffic-control'): ns3::QueueDisc::Stats::nTotalReceivedBytes [variable]
    cls.add_instance_attribute('nTotalReceivedBytes', 'uint64_t', is_const=False)
    ## queue-disc.h (module 'traffic-control'): ns3::QueueDisc::Stats::nTotalReceivedPackets [variable]
    cls.add_instance_attribute('nTotalReceivedPackets', 'uint32_t', is_const=False)
    ## queue-disc.h (module 'traffic-control'): ns3::QueueDisc::Stats::nTotalRequeuedBytes [variable]
    cls.add_instance_attribute('nTotalRequeuedBytes', 'uint64_t', is_const=False)
    ## queue-disc.h (module 'traffic-control'): ns3::QueueDisc::Stats::nTotalRequeuedPackets [variable]
    cls.add_instance_attribute('nTotalRequeuedPackets', 'uint32_t', is_const=False)
    ## queue-disc.h (module 'traffic-control'): ns3::QueueDisc::Stats::nTotalSentBytes [variable]
    cls.add_instance_attribute('nTotalSentBytes', 'uint64_t', is_const=False)
    ## queue-disc.h (module 'traffic-control'): ns3::QueueDisc::Stats::nTotalSentPackets [variable]
    cls.add_instance_attribute('nTotalSentPackets', 'uint32_t', is_const=False)
    return

def register_Ns3QueueDiscClass_methods(root_module, cls):
    ## queue-disc.h (module 'traffic-control'): ns3::QueueDiscClass::QueueDiscClass(ns3::QueueDiscClass const & arg0) [constructor]
    cls.add_constructor([param('ns3::QueueDiscClass const &', 'arg0')])
    ## queue-disc.h (module 'traffic-control'): ns3::QueueDiscClass::QueueDiscClass() [constructor]
    cls.add_constructor([])
    ## queue-disc.h (module 'traffic-control'): ns3::Ptr<ns3::QueueDisc> ns3::QueueDiscClass::GetQueueDisc() const [member function]
    cls.add_method('GetQueueDisc',
                   'ns3::Ptr< ns3::QueueDisc >',
                   [],
                   is_const=True)
    ## queue-disc.h (module 'traffic-control'): static ns3::TypeId ns3::QueueDiscClass::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## queue-disc.h (module 'traffic-control'): void ns3::QueueDiscClass::SetQueueDisc(ns3::Ptr<ns3::QueueDisc> qd) [member function]
    cls.add_method('SetQueueDisc',
                   'void',
                   [param('ns3::Ptr< ns3::QueueDisc >', 'qd')])
    ## queue-disc.h (module 'traffic-control'): void ns3::QueueDiscClass::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   visibility='protected', is_virtual=True)
    return

def register_Ns3RandomPropagationDelayModel_methods(root_module, cls):
    ## propagation-delay-model.h (module 'propagation'): ns3::RandomPropagationDelayModel::RandomPropagationDelayModel(ns3::RandomPropagationDelayModel const & arg0) [constructor]
    cls.add_constructor([param('ns3::RandomPropagationDelayModel const &', 'arg0')])
    ## propagation-delay-model.h (module 'propagation'): ns3::RandomPropagationDelayModel::RandomPropagationDelayModel() [constructor]
    cls.add_constructor([])
    ## propagation-delay-model.h (module 'propagation'): ns3::Time ns3::RandomPropagationDelayModel::GetDelay(ns3::Ptr<ns3::MobilityModel> a, ns3::Ptr<ns3::MobilityModel> b) const [member function]
    cls.add_method('GetDelay',
                   'ns3::Time',
                   [param('ns3::Ptr< ns3::MobilityModel >', 'a'), param('ns3::Ptr< ns3::MobilityModel >', 'b')],
                   is_const=True, is_virtual=True)
    ## propagation-delay-model.h (module 'propagation'): static ns3::TypeId ns3::RandomPropagationDelayModel::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## propagation-delay-model.h (module 'propagation'): int64_t ns3::RandomPropagationDelayModel::DoAssignStreams(int64_t stream) [member function]
    cls.add_method('DoAssignStreams',
                   'int64_t',
                   [param('int64_t', 'stream')],
                   visibility='private', is_virtual=True)
    return

def register_Ns3RandomPropagationLossModel_methods(root_module, cls):
    ## propagation-loss-model.h (module 'propagation'): static ns3::TypeId ns3::RandomPropagationLossModel::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## propagation-loss-model.h (module 'propagation'): ns3::RandomPropagationLossModel::RandomPropagationLossModel() [constructor]
    cls.add_constructor([])
    ## propagation-loss-model.h (module 'propagation'): double ns3::RandomPropagationLossModel::DoCalcRxPower(double txPowerDbm, ns3::Ptr<ns3::MobilityModel> a, ns3::Ptr<ns3::MobilityModel> b) const [member function]
    cls.add_method('DoCalcRxPower',
                   'double',
                   [param('double', 'txPowerDbm'), param('ns3::Ptr< ns3::MobilityModel >', 'a'), param('ns3::Ptr< ns3::MobilityModel >', 'b')],
                   is_const=True, visibility='private', is_virtual=True)
    ## propagation-loss-model.h (module 'propagation'): int64_t ns3::RandomPropagationLossModel::DoAssignStreams(int64_t stream) [member function]
    cls.add_method('DoAssignStreams',
                   'int64_t',
                   [param('int64_t', 'stream')],
                   visibility='private', is_virtual=True)
    return

def register_Ns3RandomVariableStream_methods(root_module, cls):
    ## random-variable-stream.h (module 'core'): static ns3::TypeId ns3::RandomVariableStream::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## random-variable-stream.h (module 'core'): ns3::RandomVariableStream::RandomVariableStream() [constructor]
    cls.add_constructor([])
    ## random-variable-stream.h (module 'core'): void ns3::RandomVariableStream::SetStream(int64_t stream) [member function]
    cls.add_method('SetStream',
                   'void',
                   [param('int64_t', 'stream')])
    ## random-variable-stream.h (module 'core'): int64_t ns3::RandomVariableStream::GetStream() const [member function]
    cls.add_method('GetStream',
                   'int64_t',
                   [],
                   is_const=True)
    ## random-variable-stream.h (module 'core'): void ns3::RandomVariableStream::SetAntithetic(bool isAntithetic) [member function]
    cls.add_method('SetAntithetic',
                   'void',
                   [param('bool', 'isAntithetic')])
    ## random-variable-stream.h (module 'core'): bool ns3::RandomVariableStream::IsAntithetic() const [member function]
    cls.add_method('IsAntithetic',
                   'bool',
                   [],
                   is_const=True)
    ## random-variable-stream.h (module 'core'): double ns3::RandomVariableStream::GetValue() [member function]
    cls.add_method('GetValue',
                   'double',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## random-variable-stream.h (module 'core'): uint32_t ns3::RandomVariableStream::GetInteger() [member function]
    cls.add_method('GetInteger',
                   'uint32_t',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## random-variable-stream.h (module 'core'): ns3::RngStream * ns3::RandomVariableStream::Peek() const [member function]
    cls.add_method('Peek',
                   'ns3::RngStream *',
                   [],
                   is_const=True, visibility='protected')
    return

def register_Ns3RangePropagationLossModel_methods(root_module, cls):
    ## propagation-loss-model.h (module 'propagation'): static ns3::TypeId ns3::RangePropagationLossModel::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## propagation-loss-model.h (module 'propagation'): ns3::RangePropagationLossModel::RangePropagationLossModel() [constructor]
    cls.add_constructor([])
    ## propagation-loss-model.h (module 'propagation'): double ns3::RangePropagationLossModel::DoCalcRxPower(double txPowerDbm, ns3::Ptr<ns3::MobilityModel> a, ns3::Ptr<ns3::MobilityModel> b) const [member function]
    cls.add_method('DoCalcRxPower',
                   'double',
                   [param('double', 'txPowerDbm'), param('ns3::Ptr< ns3::MobilityModel >', 'a'), param('ns3::Ptr< ns3::MobilityModel >', 'b')],
                   is_const=True, visibility='private', is_virtual=True)
    ## propagation-loss-model.h (module 'propagation'): int64_t ns3::RangePropagationLossModel::DoAssignStreams(int64_t stream) [member function]
    cls.add_method('DoAssignStreams',
                   'int64_t',
                   [param('int64_t', 'stream')],
                   visibility='private', is_virtual=True)
    return

def register_Ns3RlcBearerInfo_methods(root_module, cls):
    ## lte-radio-bearer-info.h (module 'lte'): ns3::RlcBearerInfo::RlcBearerInfo(ns3::RlcBearerInfo const & arg0) [constructor]
    cls.add_constructor([param('ns3::RlcBearerInfo const &', 'arg0')])
    ## lte-radio-bearer-info.h (module 'lte'): ns3::RlcBearerInfo::RlcBearerInfo() [constructor]
    cls.add_constructor([])
    ## lte-radio-bearer-info.h (module 'lte'): static ns3::TypeId ns3::RlcBearerInfo::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## lte-radio-bearer-info.h (module 'lte'): ns3::RlcBearerInfo::drbid [variable]
    cls.add_instance_attribute('drbid', 'uint8_t', is_const=False)
    ## lte-radio-bearer-info.h (module 'lte'): ns3::RlcBearerInfo::gtpTeid [variable]
    cls.add_instance_attribute('gtpTeid', 'uint32_t', is_const=False)
    ## lte-radio-bearer-info.h (module 'lte'): ns3::RlcBearerInfo::lcinfo [variable]
    cls.add_instance_attribute('lcinfo', 'ns3::LteEnbCmacSapProvider::LcInfo', is_const=False)
    ## lte-radio-bearer-info.h (module 'lte'): ns3::RlcBearerInfo::logicalChannelConfig [variable]
    cls.add_instance_attribute('logicalChannelConfig', 'ns3::LteRrcSap::LogicalChannelConfig', is_const=False)
    ## lte-radio-bearer-info.h (module 'lte'): ns3::RlcBearerInfo::logicalChannelIdentity [variable]
    cls.add_instance_attribute('logicalChannelIdentity', 'uint8_t', is_const=False)
    ## lte-radio-bearer-info.h (module 'lte'): ns3::RlcBearerInfo::lteRnti [variable]
    cls.add_instance_attribute('lteRnti', 'uint16_t', is_const=False)
    ## lte-radio-bearer-info.h (module 'lte'): ns3::RlcBearerInfo::m_rlc [variable]
    cls.add_instance_attribute('m_rlc', 'ns3::Ptr< ns3::LteRlc >', is_const=False)
    ## lte-radio-bearer-info.h (module 'lte'): ns3::RlcBearerInfo::mmWaveRnti [variable]
    cls.add_instance_attribute('mmWaveRnti', 'uint16_t', is_const=False)
    ## lte-radio-bearer-info.h (module 'lte'): ns3::RlcBearerInfo::rlcConfig [variable]
    cls.add_instance_attribute('rlcConfig', 'ns3::LteRrcSap::RlcConfig', is_const=False)
    ## lte-radio-bearer-info.h (module 'lte'): ns3::RlcBearerInfo::sourceCellId [variable]
    cls.add_instance_attribute('sourceCellId', 'uint16_t', is_const=False)
    ## lte-radio-bearer-info.h (module 'lte'): ns3::RlcBearerInfo::targetCellId [variable]
    cls.add_instance_attribute('targetCellId', 'uint16_t', is_const=False)
    return

def register_Ns3SequentialRandomVariable_methods(root_module, cls):
    ## random-variable-stream.h (module 'core'): static ns3::TypeId ns3::SequentialRandomVariable::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## random-variable-stream.h (module 'core'): ns3::SequentialRandomVariable::SequentialRandomVariable() [constructor]
    cls.add_constructor([])
    ## random-variable-stream.h (module 'core'): double ns3::SequentialRandomVariable::GetMin() const [member function]
    cls.add_method('GetMin',
                   'double',
                   [],
                   is_const=True)
    ## random-variable-stream.h (module 'core'): double ns3::SequentialRandomVariable::GetMax() const [member function]
    cls.add_method('GetMax',
                   'double',
                   [],
                   is_const=True)
    ## random-variable-stream.h (module 'core'): ns3::Ptr<ns3::RandomVariableStream> ns3::SequentialRandomVariable::GetIncrement() const [member function]
    cls.add_method('GetIncrement',
                   'ns3::Ptr< ns3::RandomVariableStream >',
                   [],
                   is_const=True)
    ## random-variable-stream.h (module 'core'): uint32_t ns3::SequentialRandomVariable::GetConsecutive() const [member function]
    cls.add_method('GetConsecutive',
                   'uint32_t',
                   [],
                   is_const=True)
    ## random-variable-stream.h (module 'core'): double ns3::SequentialRandomVariable::GetValue() [member function]
    cls.add_method('GetValue',
                   'double',
                   [],
                   is_virtual=True)
    ## random-variable-stream.h (module 'core'): uint32_t ns3::SequentialRandomVariable::GetInteger() [member function]
    cls.add_method('GetInteger',
                   'uint32_t',
                   [],
                   is_virtual=True)
    return

def register_Ns3SimpleRefCount__Ns3AttributeAccessor_Ns3Empty_Ns3DefaultDeleter__lt__ns3AttributeAccessor__gt___methods(root_module, cls):
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::AttributeAccessor, ns3::empty, ns3::DefaultDeleter<ns3::AttributeAccessor> >::SimpleRefCount() [constructor]
    cls.add_constructor([])
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::AttributeAccessor, ns3::empty, ns3::DefaultDeleter<ns3::AttributeAccessor> >::SimpleRefCount(ns3::SimpleRefCount<ns3::AttributeAccessor, ns3::empty, ns3::DefaultDeleter<ns3::AttributeAccessor> > const & o) [constructor]
    cls.add_constructor([param('ns3::SimpleRefCount< ns3::AttributeAccessor, ns3::empty, ns3::DefaultDeleter< ns3::AttributeAccessor > > const &', 'o')])
    return

def register_Ns3SimpleRefCount__Ns3AttributeChecker_Ns3Empty_Ns3DefaultDeleter__lt__ns3AttributeChecker__gt___methods(root_module, cls):
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::AttributeChecker, ns3::empty, ns3::DefaultDeleter<ns3::AttributeChecker> >::SimpleRefCount() [constructor]
    cls.add_constructor([])
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::AttributeChecker, ns3::empty, ns3::DefaultDeleter<ns3::AttributeChecker> >::SimpleRefCount(ns3::SimpleRefCount<ns3::AttributeChecker, ns3::empty, ns3::DefaultDeleter<ns3::AttributeChecker> > const & o) [constructor]
    cls.add_constructor([param('ns3::SimpleRefCount< ns3::AttributeChecker, ns3::empty, ns3::DefaultDeleter< ns3::AttributeChecker > > const &', 'o')])
    return

def register_Ns3SimpleRefCount__Ns3AttributeValue_Ns3Empty_Ns3DefaultDeleter__lt__ns3AttributeValue__gt___methods(root_module, cls):
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::AttributeValue, ns3::empty, ns3::DefaultDeleter<ns3::AttributeValue> >::SimpleRefCount() [constructor]
    cls.add_constructor([])
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::AttributeValue, ns3::empty, ns3::DefaultDeleter<ns3::AttributeValue> >::SimpleRefCount(ns3::SimpleRefCount<ns3::AttributeValue, ns3::empty, ns3::DefaultDeleter<ns3::AttributeValue> > const & o) [constructor]
    cls.add_constructor([param('ns3::SimpleRefCount< ns3::AttributeValue, ns3::empty, ns3::DefaultDeleter< ns3::AttributeValue > > const &', 'o')])
    return

def register_Ns3SimpleRefCount__Ns3CallbackImplBase_Ns3Empty_Ns3DefaultDeleter__lt__ns3CallbackImplBase__gt___methods(root_module, cls):
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::CallbackImplBase, ns3::empty, ns3::DefaultDeleter<ns3::CallbackImplBase> >::SimpleRefCount() [constructor]
    cls.add_constructor([])
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::CallbackImplBase, ns3::empty, ns3::DefaultDeleter<ns3::CallbackImplBase> >::SimpleRefCount(ns3::SimpleRefCount<ns3::CallbackImplBase, ns3::empty, ns3::DefaultDeleter<ns3::CallbackImplBase> > const & o) [constructor]
    cls.add_constructor([param('ns3::SimpleRefCount< ns3::CallbackImplBase, ns3::empty, ns3::DefaultDeleter< ns3::CallbackImplBase > > const &', 'o')])
    return

def register_Ns3SimpleRefCount__Ns3EpcTft_Ns3Empty_Ns3DefaultDeleter__lt__ns3EpcTft__gt___methods(root_module, cls):
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::EpcTft, ns3::empty, ns3::DefaultDeleter<ns3::EpcTft> >::SimpleRefCount() [constructor]
    cls.add_constructor([])
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::EpcTft, ns3::empty, ns3::DefaultDeleter<ns3::EpcTft> >::SimpleRefCount(ns3::SimpleRefCount<ns3::EpcTft, ns3::empty, ns3::DefaultDeleter<ns3::EpcTft> > const & o) [constructor]
    cls.add_constructor([param('ns3::SimpleRefCount< ns3::EpcTft, ns3::empty, ns3::DefaultDeleter< ns3::EpcTft > > const &', 'o')])
    return

def register_Ns3SimpleRefCount__Ns3EpcTftClassifier_Ns3Empty_Ns3DefaultDeleter__lt__ns3EpcTftClassifier__gt___methods(root_module, cls):
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::EpcTftClassifier, ns3::empty, ns3::DefaultDeleter<ns3::EpcTftClassifier> >::SimpleRefCount() [constructor]
    cls.add_constructor([])
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::EpcTftClassifier, ns3::empty, ns3::DefaultDeleter<ns3::EpcTftClassifier> >::SimpleRefCount(ns3::SimpleRefCount<ns3::EpcTftClassifier, ns3::empty, ns3::DefaultDeleter<ns3::EpcTftClassifier> > const & o) [constructor]
    cls.add_constructor([param('ns3::SimpleRefCount< ns3::EpcTftClassifier, ns3::empty, ns3::DefaultDeleter< ns3::EpcTftClassifier > > const &', 'o')])
    return

def register_Ns3SimpleRefCount__Ns3EventImpl_Ns3Empty_Ns3DefaultDeleter__lt__ns3EventImpl__gt___methods(root_module, cls):
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::EventImpl, ns3::empty, ns3::DefaultDeleter<ns3::EventImpl> >::SimpleRefCount() [constructor]
    cls.add_constructor([])
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::EventImpl, ns3::empty, ns3::DefaultDeleter<ns3::EventImpl> >::SimpleRefCount(ns3::SimpleRefCount<ns3::EventImpl, ns3::empty, ns3::DefaultDeleter<ns3::EventImpl> > const & o) [constructor]
    cls.add_constructor([param('ns3::SimpleRefCount< ns3::EventImpl, ns3::empty, ns3::DefaultDeleter< ns3::EventImpl > > const &', 'o')])
    return

def register_Ns3SimpleRefCount__Ns3HashImplementation_Ns3Empty_Ns3DefaultDeleter__lt__ns3HashImplementation__gt___methods(root_module, cls):
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::Hash::Implementation, ns3::empty, ns3::DefaultDeleter<ns3::Hash::Implementation> >::SimpleRefCount() [constructor]
    cls.add_constructor([])
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::Hash::Implementation, ns3::empty, ns3::DefaultDeleter<ns3::Hash::Implementation> >::SimpleRefCount(ns3::SimpleRefCount<ns3::Hash::Implementation, ns3::empty, ns3::DefaultDeleter<ns3::Hash::Implementation> > const & o) [constructor]
    cls.add_constructor([param('ns3::SimpleRefCount< ns3::Hash::Implementation, ns3::empty, ns3::DefaultDeleter< ns3::Hash::Implementation > > const &', 'o')])
    return

def register_Ns3SimpleRefCount__Ns3Ipv4MulticastRoute_Ns3Empty_Ns3DefaultDeleter__lt__ns3Ipv4MulticastRoute__gt___methods(root_module, cls):
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::Ipv4MulticastRoute, ns3::empty, ns3::DefaultDeleter<ns3::Ipv4MulticastRoute> >::SimpleRefCount() [constructor]
    cls.add_constructor([])
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::Ipv4MulticastRoute, ns3::empty, ns3::DefaultDeleter<ns3::Ipv4MulticastRoute> >::SimpleRefCount(ns3::SimpleRefCount<ns3::Ipv4MulticastRoute, ns3::empty, ns3::DefaultDeleter<ns3::Ipv4MulticastRoute> > const & o) [constructor]
    cls.add_constructor([param('ns3::SimpleRefCount< ns3::Ipv4MulticastRoute, ns3::empty, ns3::DefaultDeleter< ns3::Ipv4MulticastRoute > > const &', 'o')])
    return

def register_Ns3SimpleRefCount__Ns3Ipv4Route_Ns3Empty_Ns3DefaultDeleter__lt__ns3Ipv4Route__gt___methods(root_module, cls):
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::Ipv4Route, ns3::empty, ns3::DefaultDeleter<ns3::Ipv4Route> >::SimpleRefCount() [constructor]
    cls.add_constructor([])
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::Ipv4Route, ns3::empty, ns3::DefaultDeleter<ns3::Ipv4Route> >::SimpleRefCount(ns3::SimpleRefCount<ns3::Ipv4Route, ns3::empty, ns3::DefaultDeleter<ns3::Ipv4Route> > const & o) [constructor]
    cls.add_constructor([param('ns3::SimpleRefCount< ns3::Ipv4Route, ns3::empty, ns3::DefaultDeleter< ns3::Ipv4Route > > const &', 'o')])
    return

def register_Ns3SimpleRefCount__Ns3LteControlMessage_Ns3Empty_Ns3DefaultDeleter__lt__ns3LteControlMessage__gt___methods(root_module, cls):
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::LteControlMessage, ns3::empty, ns3::DefaultDeleter<ns3::LteControlMessage> >::SimpleRefCount() [constructor]
    cls.add_constructor([])
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::LteControlMessage, ns3::empty, ns3::DefaultDeleter<ns3::LteControlMessage> >::SimpleRefCount(ns3::SimpleRefCount<ns3::LteControlMessage, ns3::empty, ns3::DefaultDeleter<ns3::LteControlMessage> > const & o) [constructor]
    cls.add_constructor([param('ns3::SimpleRefCount< ns3::LteControlMessage, ns3::empty, ns3::DefaultDeleter< ns3::LteControlMessage > > const &', 'o')])
    return

def register_Ns3SimpleRefCount__Ns3LteHarqPhy_Ns3Empty_Ns3DefaultDeleter__lt__ns3LteHarqPhy__gt___methods(root_module, cls):
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::LteHarqPhy, ns3::empty, ns3::DefaultDeleter<ns3::LteHarqPhy> >::SimpleRefCount() [constructor]
    cls.add_constructor([])
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::LteHarqPhy, ns3::empty, ns3::DefaultDeleter<ns3::LteHarqPhy> >::SimpleRefCount(ns3::SimpleRefCount<ns3::LteHarqPhy, ns3::empty, ns3::DefaultDeleter<ns3::LteHarqPhy> > const & o) [constructor]
    cls.add_constructor([param('ns3::SimpleRefCount< ns3::LteHarqPhy, ns3::empty, ns3::DefaultDeleter< ns3::LteHarqPhy > > const &', 'o')])
    return

def register_Ns3SimpleRefCount__Ns3NixVector_Ns3Empty_Ns3DefaultDeleter__lt__ns3NixVector__gt___methods(root_module, cls):
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::NixVector, ns3::empty, ns3::DefaultDeleter<ns3::NixVector> >::SimpleRefCount() [constructor]
    cls.add_constructor([])
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::NixVector, ns3::empty, ns3::DefaultDeleter<ns3::NixVector> >::SimpleRefCount(ns3::SimpleRefCount<ns3::NixVector, ns3::empty, ns3::DefaultDeleter<ns3::NixVector> > const & o) [constructor]
    cls.add_constructor([param('ns3::SimpleRefCount< ns3::NixVector, ns3::empty, ns3::DefaultDeleter< ns3::NixVector > > const &', 'o')])
    return

def register_Ns3SimpleRefCount__Ns3Packet_Ns3Empty_Ns3DefaultDeleter__lt__ns3Packet__gt___methods(root_module, cls):
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::Packet, ns3::empty, ns3::DefaultDeleter<ns3::Packet> >::SimpleRefCount() [constructor]
    cls.add_constructor([])
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::Packet, ns3::empty, ns3::DefaultDeleter<ns3::Packet> >::SimpleRefCount(ns3::SimpleRefCount<ns3::Packet, ns3::empty, ns3::DefaultDeleter<ns3::Packet> > const & o) [constructor]
    cls.add_constructor([param('ns3::SimpleRefCount< ns3::Packet, ns3::empty, ns3::DefaultDeleter< ns3::Packet > > const &', 'o')])
    return

def register_Ns3SimpleRefCount__Ns3QueueItem_Ns3Empty_Ns3DefaultDeleter__lt__ns3QueueItem__gt___methods(root_module, cls):
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::QueueItem, ns3::empty, ns3::DefaultDeleter<ns3::QueueItem> >::SimpleRefCount() [constructor]
    cls.add_constructor([])
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::QueueItem, ns3::empty, ns3::DefaultDeleter<ns3::QueueItem> >::SimpleRefCount(ns3::SimpleRefCount<ns3::QueueItem, ns3::empty, ns3::DefaultDeleter<ns3::QueueItem> > const & o) [constructor]
    cls.add_constructor([param('ns3::SimpleRefCount< ns3::QueueItem, ns3::empty, ns3::DefaultDeleter< ns3::QueueItem > > const &', 'o')])
    return

def register_Ns3SimpleRefCount__Ns3SpectrumModel_Ns3Empty_Ns3DefaultDeleter__lt__ns3SpectrumModel__gt___methods(root_module, cls):
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::SpectrumModel, ns3::empty, ns3::DefaultDeleter<ns3::SpectrumModel> >::SimpleRefCount() [constructor]
    cls.add_constructor([])
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::SpectrumModel, ns3::empty, ns3::DefaultDeleter<ns3::SpectrumModel> >::SimpleRefCount(ns3::SimpleRefCount<ns3::SpectrumModel, ns3::empty, ns3::DefaultDeleter<ns3::SpectrumModel> > const & o) [constructor]
    cls.add_constructor([param('ns3::SimpleRefCount< ns3::SpectrumModel, ns3::empty, ns3::DefaultDeleter< ns3::SpectrumModel > > const &', 'o')])
    return

def register_Ns3SimpleRefCount__Ns3SpectrumSignalParameters_Ns3Empty_Ns3DefaultDeleter__lt__ns3SpectrumSignalParameters__gt___methods(root_module, cls):
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::SpectrumSignalParameters, ns3::empty, ns3::DefaultDeleter<ns3::SpectrumSignalParameters> >::SimpleRefCount() [constructor]
    cls.add_constructor([])
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::SpectrumSignalParameters, ns3::empty, ns3::DefaultDeleter<ns3::SpectrumSignalParameters> >::SimpleRefCount(ns3::SimpleRefCount<ns3::SpectrumSignalParameters, ns3::empty, ns3::DefaultDeleter<ns3::SpectrumSignalParameters> > const & o) [constructor]
    cls.add_constructor([param('ns3::SimpleRefCount< ns3::SpectrumSignalParameters, ns3::empty, ns3::DefaultDeleter< ns3::SpectrumSignalParameters > > const &', 'o')])
    return

def register_Ns3SimpleRefCount__Ns3SpectrumValue_Ns3Empty_Ns3DefaultDeleter__lt__ns3SpectrumValue__gt___methods(root_module, cls):
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::SpectrumValue, ns3::empty, ns3::DefaultDeleter<ns3::SpectrumValue> >::SimpleRefCount() [constructor]
    cls.add_constructor([])
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::SpectrumValue, ns3::empty, ns3::DefaultDeleter<ns3::SpectrumValue> >::SimpleRefCount(ns3::SimpleRefCount<ns3::SpectrumValue, ns3::empty, ns3::DefaultDeleter<ns3::SpectrumValue> > const & o) [constructor]
    cls.add_constructor([param('ns3::SimpleRefCount< ns3::SpectrumValue, ns3::empty, ns3::DefaultDeleter< ns3::SpectrumValue > > const &', 'o')])
    return

def register_Ns3SimpleRefCount__Ns3TraceSourceAccessor_Ns3Empty_Ns3DefaultDeleter__lt__ns3TraceSourceAccessor__gt___methods(root_module, cls):
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::TraceSourceAccessor, ns3::empty, ns3::DefaultDeleter<ns3::TraceSourceAccessor> >::SimpleRefCount() [constructor]
    cls.add_constructor([])
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::TraceSourceAccessor, ns3::empty, ns3::DefaultDeleter<ns3::TraceSourceAccessor> >::SimpleRefCount(ns3::SimpleRefCount<ns3::TraceSourceAccessor, ns3::empty, ns3::DefaultDeleter<ns3::TraceSourceAccessor> > const & o) [constructor]
    cls.add_constructor([param('ns3::SimpleRefCount< ns3::TraceSourceAccessor, ns3::empty, ns3::DefaultDeleter< ns3::TraceSourceAccessor > > const &', 'o')])
    return

def register_Ns3SimpleRefCount__Ns3VendorSpecificValue_Ns3Empty_Ns3DefaultDeleter__lt__ns3VendorSpecificValue__gt___methods(root_module, cls):
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::VendorSpecificValue, ns3::empty, ns3::DefaultDeleter<ns3::VendorSpecificValue> >::SimpleRefCount() [constructor]
    cls.add_constructor([])
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::VendorSpecificValue, ns3::empty, ns3::DefaultDeleter<ns3::VendorSpecificValue> >::SimpleRefCount(ns3::SimpleRefCount<ns3::VendorSpecificValue, ns3::empty, ns3::DefaultDeleter<ns3::VendorSpecificValue> > const & o) [constructor]
    cls.add_constructor([param('ns3::SimpleRefCount< ns3::VendorSpecificValue, ns3::empty, ns3::DefaultDeleter< ns3::VendorSpecificValue > > const &', 'o')])
    return

def register_Ns3SimpleRefCount__Ns3MmwaveBeamformingParams_Ns3Empty_Ns3DefaultDeleter__lt__ns3MmwaveBeamformingParams__gt___methods(root_module, cls):
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::mmwave::BeamformingParams, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::BeamformingParams> >::SimpleRefCount() [constructor]
    cls.add_constructor([])
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::mmwave::BeamformingParams, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::BeamformingParams> >::SimpleRefCount(ns3::SimpleRefCount<ns3::mmwave::BeamformingParams, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::BeamformingParams> > const & o) [constructor]
    cls.add_constructor([param('ns3::SimpleRefCount< ns3::mmwave::BeamformingParams, ns3::empty, ns3::DefaultDeleter< ns3::mmwave::BeamformingParams > > const &', 'o')])
    return

def register_Ns3SimpleRefCount__Ns3MmwaveChannelParams_Ns3Empty_Ns3DefaultDeleter__lt__ns3MmwaveChannelParams__gt___methods(root_module, cls):
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::mmwave::ChannelParams, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::ChannelParams> >::SimpleRefCount() [constructor]
    cls.add_constructor([])
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::mmwave::ChannelParams, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::ChannelParams> >::SimpleRefCount(ns3::SimpleRefCount<ns3::mmwave::ChannelParams, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::ChannelParams> > const & o) [constructor]
    cls.add_constructor([param('ns3::SimpleRefCount< ns3::mmwave::ChannelParams, ns3::empty, ns3::DefaultDeleter< ns3::mmwave::ChannelParams > > const &', 'o')])
    return

def register_Ns3SimpleRefCount__Ns3MmwaveMmWaveControlMessage_Ns3Empty_Ns3DefaultDeleter__lt__ns3MmwaveMmWaveControlMessage__gt___methods(root_module, cls):
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::mmwave::MmWaveControlMessage, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::MmWaveControlMessage> >::SimpleRefCount() [constructor]
    cls.add_constructor([])
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::mmwave::MmWaveControlMessage, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::MmWaveControlMessage> >::SimpleRefCount(ns3::SimpleRefCount<ns3::mmwave::MmWaveControlMessage, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::MmWaveControlMessage> > const & o) [constructor]
    cls.add_constructor([param('ns3::SimpleRefCount< ns3::mmwave::MmWaveControlMessage, ns3::empty, ns3::DefaultDeleter< ns3::mmwave::MmWaveControlMessage > > const &', 'o')])
    return

def register_Ns3SimpleRefCount__Ns3MmwaveMmWaveHarqPhy_Ns3Empty_Ns3DefaultDeleter__lt__ns3MmwaveMmWaveHarqPhy__gt___methods(root_module, cls):
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::mmwave::MmWaveHarqPhy, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::MmWaveHarqPhy> >::SimpleRefCount() [constructor]
    cls.add_constructor([])
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::mmwave::MmWaveHarqPhy, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::MmWaveHarqPhy> >::SimpleRefCount(ns3::SimpleRefCount<ns3::mmwave::MmWaveHarqPhy, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::MmWaveHarqPhy> > const & o) [constructor]
    cls.add_constructor([param('ns3::SimpleRefCount< ns3::mmwave::MmWaveHarqPhy, ns3::empty, ns3::DefaultDeleter< ns3::mmwave::MmWaveHarqPhy > > const &', 'o')])
    return

def register_Ns3SimpleRefCount__Ns3MmwaveParams3gpp_Ns3Empty_Ns3DefaultDeleter__lt__ns3MmwaveParams3gpp__gt___methods(root_module, cls):
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::mmwave::Params3gpp, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::Params3gpp> >::SimpleRefCount() [constructor]
    cls.add_constructor([])
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::mmwave::Params3gpp, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::Params3gpp> >::SimpleRefCount(ns3::SimpleRefCount<ns3::mmwave::Params3gpp, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::Params3gpp> > const & o) [constructor]
    cls.add_constructor([param('ns3::SimpleRefCount< ns3::mmwave::Params3gpp, ns3::empty, ns3::DefaultDeleter< ns3::mmwave::Params3gpp > > const &', 'o')])
    return

def register_Ns3SimpleRefCount__Ns3MmwaveTraceParams_Ns3Empty_Ns3DefaultDeleter__lt__ns3MmwaveTraceParams__gt___methods(root_module, cls):
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::mmwave::TraceParams, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::TraceParams> >::SimpleRefCount() [constructor]
    cls.add_constructor([])
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::mmwave::TraceParams, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::TraceParams> >::SimpleRefCount(ns3::SimpleRefCount<ns3::mmwave::TraceParams, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::TraceParams> > const & o) [constructor]
    cls.add_constructor([param('ns3::SimpleRefCount< ns3::mmwave::TraceParams, ns3::empty, ns3::DefaultDeleter< ns3::mmwave::TraceParams > > const &', 'o')])
    return

def register_Ns3SimpleRefCount__Ns3MmwaveChannelMatrix_Ns3Empty_Ns3DefaultDeleter__lt__ns3MmwaveChannelMatrix__gt___methods(root_module, cls):
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::mmwave::channelMatrix, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::channelMatrix> >::SimpleRefCount() [constructor]
    cls.add_constructor([])
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::mmwave::channelMatrix, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::channelMatrix> >::SimpleRefCount(ns3::SimpleRefCount<ns3::mmwave::channelMatrix, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::channelMatrix> > const & o) [constructor]
    cls.add_constructor([param('ns3::SimpleRefCount< ns3::mmwave::channelMatrix, ns3::empty, ns3::DefaultDeleter< ns3::mmwave::channelMatrix > > const &', 'o')])
    return

def register_Ns3SimpleRefCount__Ns3MmwaveMmWaveBeamFormingParams_Ns3Empty_Ns3DefaultDeleter__lt__ns3MmwaveMmWaveBeamFormingParams__gt___methods(root_module, cls):
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::mmwave::mmWaveBeamFormingParams, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::mmWaveBeamFormingParams> >::SimpleRefCount() [constructor]
    cls.add_constructor([])
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::mmwave::mmWaveBeamFormingParams, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::mmWaveBeamFormingParams> >::SimpleRefCount(ns3::SimpleRefCount<ns3::mmwave::mmWaveBeamFormingParams, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::mmWaveBeamFormingParams> > const & o) [constructor]
    cls.add_constructor([param('ns3::SimpleRefCount< ns3::mmwave::mmWaveBeamFormingParams, ns3::empty, ns3::DefaultDeleter< ns3::mmwave::mmWaveBeamFormingParams > > const &', 'o')])
    return

def register_Ns3SimpleRefCount__Ns3MmwaveMmWaveBeamFormingTraces_Ns3Empty_Ns3DefaultDeleter__lt__ns3MmwaveMmWaveBeamFormingTraces__gt___methods(root_module, cls):
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::mmwave::mmWaveBeamFormingTraces, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::mmWaveBeamFormingTraces> >::SimpleRefCount() [constructor]
    cls.add_constructor([])
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::mmwave::mmWaveBeamFormingTraces, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::mmWaveBeamFormingTraces> >::SimpleRefCount(ns3::SimpleRefCount<ns3::mmwave::mmWaveBeamFormingTraces, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::mmWaveBeamFormingTraces> > const & o) [constructor]
    cls.add_constructor([param('ns3::SimpleRefCount< ns3::mmwave::mmWaveBeamFormingTraces, ns3::empty, ns3::DefaultDeleter< ns3::mmwave::mmWaveBeamFormingTraces > > const &', 'o')])
    return

def register_Ns3SimpleRefCount__Ns3MmwaveMmWaveChunkProcessor_Ns3Empty_Ns3DefaultDeleter__lt__ns3MmwaveMmWaveChunkProcessor__gt___methods(root_module, cls):
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::mmwave::mmWaveChunkProcessor, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::mmWaveChunkProcessor> >::SimpleRefCount() [constructor]
    cls.add_constructor([])
    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::mmwave::mmWaveChunkProcessor, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::mmWaveChunkProcessor> >::SimpleRefCount(ns3::SimpleRefCount<ns3::mmwave::mmWaveChunkProcessor, ns3::empty, ns3::DefaultDeleter<ns3::mmwave::mmWaveChunkProcessor> > const & o) [constructor]
    cls.add_constructor([param('ns3::SimpleRefCount< ns3::mmwave::mmWaveChunkProcessor, ns3::empty, ns3::DefaultDeleter< ns3::mmwave::mmWaveChunkProcessor > > const &', 'o')])
    return

def register_Ns3Socket_methods(root_module, cls):
    ## socket.h (module 'network'): ns3::Socket::Socket(ns3::Socket const & arg0) [constructor]
    cls.add_constructor([param('ns3::Socket const &', 'arg0')])
    ## socket.h (module 'network'): ns3::Socket::Socket() [constructor]
    cls.add_constructor([])
    ## socket.h (module 'network'): int ns3::Socket::Bind(ns3::Address const & address) [member function]
    cls.add_method('Bind',
                   'int',
                   [param('ns3::Address const &', 'address')],
                   is_pure_virtual=True, is_virtual=True)
    ## socket.h (module 'network'): int ns3::Socket::Bind() [member function]
    cls.add_method('Bind',
                   'int',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## socket.h (module 'network'): int ns3::Socket::Bind6() [member function]
    cls.add_method('Bind6',
                   'int',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## socket.h (module 'network'): void ns3::Socket::BindToNetDevice(ns3::Ptr<ns3::NetDevice> netdevice) [member function]
    cls.add_method('BindToNetDevice',
                   'void',
                   [param('ns3::Ptr< ns3::NetDevice >', 'netdevice')],
                   is_virtual=True)
    ## socket.h (module 'network'): int ns3::Socket::Close() [member function]
    cls.add_method('Close',
                   'int',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## socket.h (module 'network'): int ns3::Socket::Connect(ns3::Address const & address) [member function]
    cls.add_method('Connect',
                   'int',
                   [param('ns3::Address const &', 'address')],
                   is_pure_virtual=True, is_virtual=True)
    ## socket.h (module 'network'): static ns3::Ptr<ns3::Socket> ns3::Socket::CreateSocket(ns3::Ptr<ns3::Node> node, ns3::TypeId tid) [member function]
    cls.add_method('CreateSocket',
                   'ns3::Ptr< ns3::Socket >',
                   [param('ns3::Ptr< ns3::Node >', 'node'), param('ns3::TypeId', 'tid')],
                   is_static=True)
    ## socket.h (module 'network'): bool ns3::Socket::GetAllowBroadcast() const [member function]
    cls.add_method('GetAllowBroadcast',
                   'bool',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## socket.h (module 'network'): ns3::Ptr<ns3::NetDevice> ns3::Socket::GetBoundNetDevice() [member function]
    cls.add_method('GetBoundNetDevice',
                   'ns3::Ptr< ns3::NetDevice >',
                   [])
    ## socket.h (module 'network'): ns3::Socket::SocketErrno ns3::Socket::GetErrno() const [member function]
    cls.add_method('GetErrno',
                   'ns3::Socket::SocketErrno',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## socket.h (module 'network'): uint8_t ns3::Socket::GetIpTos() const [member function]
    cls.add_method('GetIpTos',
                   'uint8_t',
                   [],
                   is_const=True)
    ## socket.h (module 'network'): uint8_t ns3::Socket::GetIpTtl() const [member function]
    cls.add_method('GetIpTtl',
                   'uint8_t',
                   [],
                   is_const=True, is_virtual=True)
    ## socket.h (module 'network'): uint8_t ns3::Socket::GetIpv6HopLimit() const [member function]
    cls.add_method('GetIpv6HopLimit',
                   'uint8_t',
                   [],
                   is_const=True, is_virtual=True)
    ## socket.h (module 'network'): uint8_t ns3::Socket::GetIpv6Tclass() const [member function]
    cls.add_method('GetIpv6Tclass',
                   'uint8_t',
                   [],
                   is_const=True)
    ## socket.h (module 'network'): ns3::Ptr<ns3::Node> ns3::Socket::GetNode() const [member function]
    cls.add_method('GetNode',
                   'ns3::Ptr< ns3::Node >',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## socket.h (module 'network'): int ns3::Socket::GetPeerName(ns3::Address & address) const [member function]
    cls.add_method('GetPeerName',
                   'int',
                   [param('ns3::Address &', 'address')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## socket.h (module 'network'): uint8_t ns3::Socket::GetPriority() const [member function]
    cls.add_method('GetPriority',
                   'uint8_t',
                   [],
                   is_const=True)
    ## socket.h (module 'network'): uint32_t ns3::Socket::GetRxAvailable() const [member function]
    cls.add_method('GetRxAvailable',
                   'uint32_t',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## socket.h (module 'network'): int ns3::Socket::GetSockName(ns3::Address & address) const [member function]
    cls.add_method('GetSockName',
                   'int',
                   [param('ns3::Address &', 'address')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## socket.h (module 'network'): ns3::Socket::SocketType ns3::Socket::GetSocketType() const [member function]
    cls.add_method('GetSocketType',
                   'ns3::Socket::SocketType',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## socket.h (module 'network'): uint32_t ns3::Socket::GetTxAvailable() const [member function]
    cls.add_method('GetTxAvailable',
                   'uint32_t',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## socket.h (module 'network'): static ns3::TypeId ns3::Socket::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## socket.h (module 'network'): static uint8_t ns3::Socket::IpTos2Priority(uint8_t ipTos) [member function]
    cls.add_method('IpTos2Priority',
                   'uint8_t',
                   [param('uint8_t', 'ipTos')],
                   is_static=True)
    ## socket.h (module 'network'): void ns3::Socket::Ipv6JoinGroup(ns3::Ipv6Address address, ns3::Socket::Ipv6MulticastFilterMode filterMode, std::vector<ns3::Ipv6Address, std::allocator<ns3::Ipv6Address> > sourceAddresses) [member function]
    cls.add_method('Ipv6JoinGroup',
                   'void',
                   [param('ns3::Ipv6Address', 'address'), param('ns3::Socket::Ipv6MulticastFilterMode', 'filterMode'), param('std::vector< ns3::Ipv6Address >', 'sourceAddresses')],
                   is_virtual=True)
    ## socket.h (module 'network'): void ns3::Socket::Ipv6JoinGroup(ns3::Ipv6Address address) [member function]
    cls.add_method('Ipv6JoinGroup',
                   'void',
                   [param('ns3::Ipv6Address', 'address')],
                   is_virtual=True)
    ## socket.h (module 'network'): void ns3::Socket::Ipv6LeaveGroup() [member function]
    cls.add_method('Ipv6LeaveGroup',
                   'void',
                   [],
                   is_virtual=True)
    ## socket.h (module 'network'): bool ns3::Socket::IsIpRecvTos() const [member function]
    cls.add_method('IsIpRecvTos',
                   'bool',
                   [],
                   is_const=True)
    ## socket.h (module 'network'): bool ns3::Socket::IsIpRecvTtl() const [member function]
    cls.add_method('IsIpRecvTtl',
                   'bool',
                   [],
                   is_const=True)
    ## socket.h (module 'network'): bool ns3::Socket::IsIpv6RecvHopLimit() const [member function]
    cls.add_method('IsIpv6RecvHopLimit',
                   'bool',
                   [],
                   is_const=True)
    ## socket.h (module 'network'): bool ns3::Socket::IsIpv6RecvTclass() const [member function]
    cls.add_method('IsIpv6RecvTclass',
                   'bool',
                   [],
                   is_const=True)
    ## socket.h (module 'network'): bool ns3::Socket::IsRecvPktInfo() const [member function]
    cls.add_method('IsRecvPktInfo',
                   'bool',
                   [],
                   is_const=True)
    ## socket.h (module 'network'): int ns3::Socket::Listen() [member function]
    cls.add_method('Listen',
                   'int',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## socket.h (module 'network'): ns3::Ptr<ns3::Packet> ns3::Socket::Recv(uint32_t maxSize, uint32_t flags) [member function]
    cls.add_method('Recv',
                   'ns3::Ptr< ns3::Packet >',
                   [param('uint32_t', 'maxSize'), param('uint32_t', 'flags')],
                   is_pure_virtual=True, is_virtual=True)
    ## socket.h (module 'network'): ns3::Ptr<ns3::Packet> ns3::Socket::Recv() [member function]
    cls.add_method('Recv',
                   'ns3::Ptr< ns3::Packet >',
                   [])
    ## socket.h (module 'network'): int ns3::Socket::Recv(uint8_t * buf, uint32_t size, uint32_t flags) [member function]
    cls.add_method('Recv',
                   'int',
                   [param('uint8_t *', 'buf'), param('uint32_t', 'size'), param('uint32_t', 'flags')])
    ## socket.h (module 'network'): ns3::Ptr<ns3::Packet> ns3::Socket::RecvFrom(uint32_t maxSize, uint32_t flags, ns3::Address & fromAddress) [member function]
    cls.add_method('RecvFrom',
                   'ns3::Ptr< ns3::Packet >',
                   [param('uint32_t', 'maxSize'), param('uint32_t', 'flags'), param('ns3::Address &', 'fromAddress')],
                   is_pure_virtual=True, is_virtual=True)
    ## socket.h (module 'network'): ns3::Ptr<ns3::Packet> ns3::Socket::RecvFrom(ns3::Address & fromAddress) [member function]
    cls.add_method('RecvFrom',
                   'ns3::Ptr< ns3::Packet >',
                   [param('ns3::Address &', 'fromAddress')])
    ## socket.h (module 'network'): int ns3::Socket::RecvFrom(uint8_t * buf, uint32_t size, uint32_t flags, ns3::Address & fromAddress) [member function]
    cls.add_method('RecvFrom',
                   'int',
                   [param('uint8_t *', 'buf'), param('uint32_t', 'size'), param('uint32_t', 'flags'), param('ns3::Address &', 'fromAddress')])
    ## socket.h (module 'network'): int ns3::Socket::Send(ns3::Ptr<ns3::Packet> p, uint32_t flags) [member function]
    cls.add_method('Send',
                   'int',
                   [param('ns3::Ptr< ns3::Packet >', 'p'), param('uint32_t', 'flags')],
                   is_pure_virtual=True, is_virtual=True)
    ## socket.h (module 'network'): int ns3::Socket::Send(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('Send',
                   'int',
                   [param('ns3::Ptr< ns3::Packet >', 'p')])
    ## socket.h (module 'network'): int ns3::Socket::Send(uint8_t const * buf, uint32_t size, uint32_t flags) [member function]
    cls.add_method('Send',
                   'int',
                   [param('uint8_t const *', 'buf'), param('uint32_t', 'size'), param('uint32_t', 'flags')])
    ## socket.h (module 'network'): int ns3::Socket::SendTo(ns3::Ptr<ns3::Packet> p, uint32_t flags, ns3::Address const & toAddress) [member function]
    cls.add_method('SendTo',
                   'int',
                   [param('ns3::Ptr< ns3::Packet >', 'p'), param('uint32_t', 'flags'), param('ns3::Address const &', 'toAddress')],
                   is_pure_virtual=True, is_virtual=True)
    ## socket.h (module 'network'): int ns3::Socket::SendTo(uint8_t const * buf, uint32_t size, uint32_t flags, ns3::Address const & address) [member function]
    cls.add_method('SendTo',
                   'int',
                   [param('uint8_t const *', 'buf'), param('uint32_t', 'size'), param('uint32_t', 'flags'), param('ns3::Address const &', 'address')])
    ## socket.h (module 'network'): void ns3::Socket::SetAcceptCallback(ns3::Callback<bool, ns3::Ptr<ns3::Socket>, const ns3::Address &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> connectionRequest, ns3::Callback<void, ns3::Ptr<ns3::Socket>, const ns3::Address &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> newConnectionCreated) [member function]
    cls.add_method('SetAcceptCallback',
                   'void',
                   [param('ns3::Callback< bool, ns3::Ptr< ns3::Socket >, ns3::Address const &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'connectionRequest'), param('ns3::Callback< void, ns3::Ptr< ns3::Socket >, ns3::Address const &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'newConnectionCreated')])
    ## socket.h (module 'network'): bool ns3::Socket::SetAllowBroadcast(bool allowBroadcast) [member function]
    cls.add_method('SetAllowBroadcast',
                   'bool',
                   [param('bool', 'allowBroadcast')],
                   is_pure_virtual=True, is_virtual=True)
    ## socket.h (module 'network'): void ns3::Socket::SetCloseCallbacks(ns3::Callback<void, ns3::Ptr<ns3::Socket>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> normalClose, ns3::Callback<void, ns3::Ptr<ns3::Socket>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> errorClose) [member function]
    cls.add_method('SetCloseCallbacks',
                   'void',
                   [param('ns3::Callback< void, ns3::Ptr< ns3::Socket >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'normalClose'), param('ns3::Callback< void, ns3::Ptr< ns3::Socket >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'errorClose')])
    ## socket.h (module 'network'): void ns3::Socket::SetConnectCallback(ns3::Callback<void, ns3::Ptr<ns3::Socket>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> connectionSucceeded, ns3::Callback<void, ns3::Ptr<ns3::Socket>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> connectionFailed) [member function]
    cls.add_method('SetConnectCallback',
                   'void',
                   [param('ns3::Callback< void, ns3::Ptr< ns3::Socket >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'connectionSucceeded'), param('ns3::Callback< void, ns3::Ptr< ns3::Socket >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'connectionFailed')])
    ## socket.h (module 'network'): void ns3::Socket::SetDataSentCallback(ns3::Callback<void, ns3::Ptr<ns3::Socket>, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> dataSent) [member function]
    cls.add_method('SetDataSentCallback',
                   'void',
                   [param('ns3::Callback< void, ns3::Ptr< ns3::Socket >, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'dataSent')])
    ## socket.h (module 'network'): void ns3::Socket::SetIpRecvTos(bool ipv4RecvTos) [member function]
    cls.add_method('SetIpRecvTos',
                   'void',
                   [param('bool', 'ipv4RecvTos')])
    ## socket.h (module 'network'): void ns3::Socket::SetIpRecvTtl(bool ipv4RecvTtl) [member function]
    cls.add_method('SetIpRecvTtl',
                   'void',
                   [param('bool', 'ipv4RecvTtl')])
    ## socket.h (module 'network'): void ns3::Socket::SetIpTos(uint8_t ipTos) [member function]
    cls.add_method('SetIpTos',
                   'void',
                   [param('uint8_t', 'ipTos')])
    ## socket.h (module 'network'): void ns3::Socket::SetIpTtl(uint8_t ipTtl) [member function]
    cls.add_method('SetIpTtl',
                   'void',
                   [param('uint8_t', 'ipTtl')],
                   is_virtual=True)
    ## socket.h (module 'network'): void ns3::Socket::SetIpv6HopLimit(uint8_t ipHopLimit) [member function]
    cls.add_method('SetIpv6HopLimit',
                   'void',
                   [param('uint8_t', 'ipHopLimit')],
                   is_virtual=True)
    ## socket.h (module 'network'): void ns3::Socket::SetIpv6RecvHopLimit(bool ipv6RecvHopLimit) [member function]
    cls.add_method('SetIpv6RecvHopLimit',
                   'void',
                   [param('bool', 'ipv6RecvHopLimit')])
    ## socket.h (module 'network'): void ns3::Socket::SetIpv6RecvTclass(bool ipv6RecvTclass) [member function]
    cls.add_method('SetIpv6RecvTclass',
                   'void',
                   [param('bool', 'ipv6RecvTclass')])
    ## socket.h (module 'network'): void ns3::Socket::SetIpv6Tclass(int ipTclass) [member function]
    cls.add_method('SetIpv6Tclass',
                   'void',
                   [param('int', 'ipTclass')])
    ## socket.h (module 'network'): void ns3::Socket::SetPriority(uint8_t priority) [member function]
    cls.add_method('SetPriority',
                   'void',
                   [param('uint8_t', 'priority')])
    ## socket.h (module 'network'): void ns3::Socket::SetRecvCallback(ns3::Callback<void, ns3::Ptr<ns3::Socket>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> arg0) [member function]
    cls.add_method('SetRecvCallback',
                   'void',
                   [param('ns3::Callback< void, ns3::Ptr< ns3::Socket >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'arg0')])
    ## socket.h (module 'network'): void ns3::Socket::SetRecvPktInfo(bool flag) [member function]
    cls.add_method('SetRecvPktInfo',
                   'void',
                   [param('bool', 'flag')])
    ## socket.h (module 'network'): void ns3::Socket::SetSendCallback(ns3::Callback<void, ns3::Ptr<ns3::Socket>, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> sendCb) [member function]
    cls.add_method('SetSendCallback',
                   'void',
                   [param('ns3::Callback< void, ns3::Ptr< ns3::Socket >, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'sendCb')])
    ## socket.h (module 'network'): int ns3::Socket::ShutdownRecv() [member function]
    cls.add_method('ShutdownRecv',
                   'int',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## socket.h (module 'network'): int ns3::Socket::ShutdownSend() [member function]
    cls.add_method('ShutdownSend',
                   'int',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## socket.h (module 'network'): void ns3::Socket::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   visibility='protected', is_virtual=True)
    ## socket.h (module 'network'): bool ns3::Socket::IsManualIpTtl() const [member function]
    cls.add_method('IsManualIpTtl',
                   'bool',
                   [],
                   is_const=True, visibility='protected')
    ## socket.h (module 'network'): bool ns3::Socket::IsManualIpv6HopLimit() const [member function]
    cls.add_method('IsManualIpv6HopLimit',
                   'bool',
                   [],
                   is_const=True, visibility='protected')
    ## socket.h (module 'network'): bool ns3::Socket::IsManualIpv6Tclass() const [member function]
    cls.add_method('IsManualIpv6Tclass',
                   'bool',
                   [],
                   is_const=True, visibility='protected')
    ## socket.h (module 'network'): void ns3::Socket::NotifyConnectionFailed() [member function]
    cls.add_method('NotifyConnectionFailed',
                   'void',
                   [],
                   visibility='protected')
    ## socket.h (module 'network'): bool ns3::Socket::NotifyConnectionRequest(ns3::Address const & from) [member function]
    cls.add_method('NotifyConnectionRequest',
                   'bool',
                   [param('ns3::Address const &', 'from')],
                   visibility='protected')
    ## socket.h (module 'network'): void ns3::Socket::NotifyConnectionSucceeded() [member function]
    cls.add_method('NotifyConnectionSucceeded',
                   'void',
                   [],
                   visibility='protected')
    ## socket.h (module 'network'): void ns3::Socket::NotifyDataRecv() [member function]
    cls.add_method('NotifyDataRecv',
                   'void',
                   [],
                   visibility='protected')
    ## socket.h (module 'network'): void ns3::Socket::NotifyDataSent(uint32_t size) [member function]
    cls.add_method('NotifyDataSent',
                   'void',
                   [param('uint32_t', 'size')],
                   visibility='protected')
    ## socket.h (module 'network'): void ns3::Socket::NotifyErrorClose() [member function]
    cls.add_method('NotifyErrorClose',
                   'void',
                   [],
                   visibility='protected')
    ## socket.h (module 'network'): void ns3::Socket::NotifyNewConnectionCreated(ns3::Ptr<ns3::Socket> socket, ns3::Address const & from) [member function]
    cls.add_method('NotifyNewConnectionCreated',
                   'void',
                   [param('ns3::Ptr< ns3::Socket >', 'socket'), param('ns3::Address const &', 'from')],
                   visibility='protected')
    ## socket.h (module 'network'): void ns3::Socket::NotifyNormalClose() [member function]
    cls.add_method('NotifyNormalClose',
                   'void',
                   [],
                   visibility='protected')
    ## socket.h (module 'network'): void ns3::Socket::NotifySend(uint32_t spaceAvailable) [member function]
    cls.add_method('NotifySend',
                   'void',
                   [param('uint32_t', 'spaceAvailable')],
                   visibility='protected')
    return

def register_Ns3SocketIpTosTag_methods(root_module, cls):
    ## socket.h (module 'network'): ns3::SocketIpTosTag::SocketIpTosTag(ns3::SocketIpTosTag const & arg0) [constructor]
    cls.add_constructor([param('ns3::SocketIpTosTag const &', 'arg0')])
    ## socket.h (module 'network'): ns3::SocketIpTosTag::SocketIpTosTag() [constructor]
    cls.add_constructor([])
    ## socket.h (module 'network'): void ns3::SocketIpTosTag::Deserialize(ns3::TagBuffer i) [member function]
    cls.add_method('Deserialize',
                   'void',
                   [param('ns3::TagBuffer', 'i')],
                   is_virtual=True)
    ## socket.h (module 'network'): ns3::TypeId ns3::SocketIpTosTag::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId',
                   'ns3::TypeId',
                   [],
                   is_const=True, is_virtual=True)
    ## socket.h (module 'network'): uint32_t ns3::SocketIpTosTag::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize',
                   'uint32_t',
                   [],
                   is_const=True, is_virtual=True)
    ## socket.h (module 'network'): uint8_t ns3::SocketIpTosTag::GetTos() const [member function]
    cls.add_method('GetTos',
                   'uint8_t',
                   [],
                   is_const=True)
    ## socket.h (module 'network'): static ns3::TypeId ns3::SocketIpTosTag::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## socket.h (module 'network'): void ns3::SocketIpTosTag::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True, is_virtual=True)
    ## socket.h (module 'network'): void ns3::SocketIpTosTag::Serialize(ns3::TagBuffer i) const [member function]
    cls.add_method('Serialize',
                   'void',
                   [param('ns3::TagBuffer', 'i')],
                   is_const=True, is_virtual=True)
    ## socket.h (module 'network'): void ns3::SocketIpTosTag::SetTos(uint8_t tos) [member function]
    cls.add_method('SetTos',
                   'void',
                   [param('uint8_t', 'tos')])
    return

def register_Ns3SocketIpTtlTag_methods(root_module, cls):
    ## socket.h (module 'network'): ns3::SocketIpTtlTag::SocketIpTtlTag(ns3::SocketIpTtlTag const & arg0) [constructor]
    cls.add_constructor([param('ns3::SocketIpTtlTag const &', 'arg0')])
    ## socket.h (module 'network'): ns3::SocketIpTtlTag::SocketIpTtlTag() [constructor]
    cls.add_constructor([])
    ## socket.h (module 'network'): void ns3::SocketIpTtlTag::Deserialize(ns3::TagBuffer i) [member function]
    cls.add_method('Deserialize',
                   'void',
                   [param('ns3::TagBuffer', 'i')],
                   is_virtual=True)
    ## socket.h (module 'network'): ns3::TypeId ns3::SocketIpTtlTag::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId',
                   'ns3::TypeId',
                   [],
                   is_const=True, is_virtual=True)
    ## socket.h (module 'network'): uint32_t ns3::SocketIpTtlTag::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize',
                   'uint32_t',
                   [],
                   is_const=True, is_virtual=True)
    ## socket.h (module 'network'): uint8_t ns3::SocketIpTtlTag::GetTtl() const [member function]
    cls.add_method('GetTtl',
                   'uint8_t',
                   [],
                   is_const=True)
    ## socket.h (module 'network'): static ns3::TypeId ns3::SocketIpTtlTag::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## socket.h (module 'network'): void ns3::SocketIpTtlTag::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True, is_virtual=True)
    ## socket.h (module 'network'): void ns3::SocketIpTtlTag::Serialize(ns3::TagBuffer i) const [member function]
    cls.add_method('Serialize',
                   'void',
                   [param('ns3::TagBuffer', 'i')],
                   is_const=True, is_virtual=True)
    ## socket.h (module 'network'): void ns3::SocketIpTtlTag::SetTtl(uint8_t ttl) [member function]
    cls.add_method('SetTtl',
                   'void',
                   [param('uint8_t', 'ttl')])
    return

def register_Ns3SocketIpv6HopLimitTag_methods(root_module, cls):
    ## socket.h (module 'network'): ns3::SocketIpv6HopLimitTag::SocketIpv6HopLimitTag(ns3::SocketIpv6HopLimitTag const & arg0) [constructor]
    cls.add_constructor([param('ns3::SocketIpv6HopLimitTag const &', 'arg0')])
    ## socket.h (module 'network'): ns3::SocketIpv6HopLimitTag::SocketIpv6HopLimitTag() [constructor]
    cls.add_constructor([])
    ## socket.h (module 'network'): void ns3::SocketIpv6HopLimitTag::Deserialize(ns3::TagBuffer i) [member function]
    cls.add_method('Deserialize',
                   'void',
                   [param('ns3::TagBuffer', 'i')],
                   is_virtual=True)
    ## socket.h (module 'network'): uint8_t ns3::SocketIpv6HopLimitTag::GetHopLimit() const [member function]
    cls.add_method('GetHopLimit',
                   'uint8_t',
                   [],
                   is_const=True)
    ## socket.h (module 'network'): ns3::TypeId ns3::SocketIpv6HopLimitTag::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId',
                   'ns3::TypeId',
                   [],
                   is_const=True, is_virtual=True)
    ## socket.h (module 'network'): uint32_t ns3::SocketIpv6HopLimitTag::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize',
                   'uint32_t',
                   [],
                   is_const=True, is_virtual=True)
    ## socket.h (module 'network'): static ns3::TypeId ns3::SocketIpv6HopLimitTag::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## socket.h (module 'network'): void ns3::SocketIpv6HopLimitTag::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True, is_virtual=True)
    ## socket.h (module 'network'): void ns3::SocketIpv6HopLimitTag::Serialize(ns3::TagBuffer i) const [member function]
    cls.add_method('Serialize',
                   'void',
                   [param('ns3::TagBuffer', 'i')],
                   is_const=True, is_virtual=True)
    ## socket.h (module 'network'): void ns3::SocketIpv6HopLimitTag::SetHopLimit(uint8_t hopLimit) [member function]
    cls.add_method('SetHopLimit',
                   'void',
                   [param('uint8_t', 'hopLimit')])
    return

def register_Ns3SocketIpv6TclassTag_methods(root_module, cls):
    ## socket.h (module 'network'): ns3::SocketIpv6TclassTag::SocketIpv6TclassTag(ns3::SocketIpv6TclassTag const & arg0) [constructor]
    cls.add_constructor([param('ns3::SocketIpv6TclassTag const &', 'arg0')])
    ## socket.h (module 'network'): ns3::SocketIpv6TclassTag::SocketIpv6TclassTag() [constructor]
    cls.add_constructor([])
    ## socket.h (module 'network'): void ns3::SocketIpv6TclassTag::Deserialize(ns3::TagBuffer i) [member function]
    cls.add_method('Deserialize',
                   'void',
                   [param('ns3::TagBuffer', 'i')],
                   is_virtual=True)
    ## socket.h (module 'network'): ns3::TypeId ns3::SocketIpv6TclassTag::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId',
                   'ns3::TypeId',
                   [],
                   is_const=True, is_virtual=True)
    ## socket.h (module 'network'): uint32_t ns3::SocketIpv6TclassTag::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize',
                   'uint32_t',
                   [],
                   is_const=True, is_virtual=True)
    ## socket.h (module 'network'): uint8_t ns3::SocketIpv6TclassTag::GetTclass() const [member function]
    cls.add_method('GetTclass',
                   'uint8_t',
                   [],
                   is_const=True)
    ## socket.h (module 'network'): static ns3::TypeId ns3::SocketIpv6TclassTag::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## socket.h (module 'network'): void ns3::SocketIpv6TclassTag::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True, is_virtual=True)
    ## socket.h (module 'network'): void ns3::SocketIpv6TclassTag::Serialize(ns3::TagBuffer i) const [member function]
    cls.add_method('Serialize',
                   'void',
                   [param('ns3::TagBuffer', 'i')],
                   is_const=True, is_virtual=True)
    ## socket.h (module 'network'): void ns3::SocketIpv6TclassTag::SetTclass(uint8_t tclass) [member function]
    cls.add_method('SetTclass',
                   'void',
                   [param('uint8_t', 'tclass')])
    return

def register_Ns3SocketPriorityTag_methods(root_module, cls):
    ## socket.h (module 'network'): ns3::SocketPriorityTag::SocketPriorityTag(ns3::SocketPriorityTag const & arg0) [constructor]
    cls.add_constructor([param('ns3::SocketPriorityTag const &', 'arg0')])
    ## socket.h (module 'network'): ns3::SocketPriorityTag::SocketPriorityTag() [constructor]
    cls.add_constructor([])
    ## socket.h (module 'network'): void ns3::SocketPriorityTag::Deserialize(ns3::TagBuffer i) [member function]
    cls.add_method('Deserialize',
                   'void',
                   [param('ns3::TagBuffer', 'i')],
                   is_virtual=True)
    ## socket.h (module 'network'): ns3::TypeId ns3::SocketPriorityTag::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId',
                   'ns3::TypeId',
                   [],
                   is_const=True, is_virtual=True)
    ## socket.h (module 'network'): uint8_t ns3::SocketPriorityTag::GetPriority() const [member function]
    cls.add_method('GetPriority',
                   'uint8_t',
                   [],
                   is_const=True)
    ## socket.h (module 'network'): uint32_t ns3::SocketPriorityTag::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize',
                   'uint32_t',
                   [],
                   is_const=True, is_virtual=True)
    ## socket.h (module 'network'): static ns3::TypeId ns3::SocketPriorityTag::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## socket.h (module 'network'): void ns3::SocketPriorityTag::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True, is_virtual=True)
    ## socket.h (module 'network'): void ns3::SocketPriorityTag::Serialize(ns3::TagBuffer i) const [member function]
    cls.add_method('Serialize',
                   'void',
                   [param('ns3::TagBuffer', 'i')],
                   is_const=True, is_virtual=True)
    ## socket.h (module 'network'): void ns3::SocketPriorityTag::SetPriority(uint8_t priority) [member function]
    cls.add_method('SetPriority',
                   'void',
                   [param('uint8_t', 'priority')])
    return

def register_Ns3SocketSetDontFragmentTag_methods(root_module, cls):
    ## socket.h (module 'network'): ns3::SocketSetDontFragmentTag::SocketSetDontFragmentTag(ns3::SocketSetDontFragmentTag const & arg0) [constructor]
    cls.add_constructor([param('ns3::SocketSetDontFragmentTag const &', 'arg0')])
    ## socket.h (module 'network'): ns3::SocketSetDontFragmentTag::SocketSetDontFragmentTag() [constructor]
    cls.add_constructor([])
    ## socket.h (module 'network'): void ns3::SocketSetDontFragmentTag::Deserialize(ns3::TagBuffer i) [member function]
    cls.add_method('Deserialize',
                   'void',
                   [param('ns3::TagBuffer', 'i')],
                   is_virtual=True)
    ## socket.h (module 'network'): void ns3::SocketSetDontFragmentTag::Disable() [member function]
    cls.add_method('Disable',
                   'void',
                   [])
    ## socket.h (module 'network'): void ns3::SocketSetDontFragmentTag::Enable() [member function]
    cls.add_method('Enable',
                   'void',
                   [])
    ## socket.h (module 'network'): ns3::TypeId ns3::SocketSetDontFragmentTag::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId',
                   'ns3::TypeId',
                   [],
                   is_const=True, is_virtual=True)
    ## socket.h (module 'network'): uint32_t ns3::SocketSetDontFragmentTag::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize',
                   'uint32_t',
                   [],
                   is_const=True, is_virtual=True)
    ## socket.h (module 'network'): static ns3::TypeId ns3::SocketSetDontFragmentTag::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## socket.h (module 'network'): bool ns3::SocketSetDontFragmentTag::IsEnabled() const [member function]
    cls.add_method('IsEnabled',
                   'bool',
                   [],
                   is_const=True)
    ## socket.h (module 'network'): void ns3::SocketSetDontFragmentTag::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True, is_virtual=True)
    ## socket.h (module 'network'): void ns3::SocketSetDontFragmentTag::Serialize(ns3::TagBuffer i) const [member function]
    cls.add_method('Serialize',
                   'void',
                   [param('ns3::TagBuffer', 'i')],
                   is_const=True, is_virtual=True)
    return

def register_Ns3SpectrumInterference_methods(root_module, cls):
    ## spectrum-interference.h (module 'spectrum'): ns3::SpectrumInterference::SpectrumInterference() [constructor]
    cls.add_constructor([])
    ## spectrum-interference.h (module 'spectrum'): static ns3::TypeId ns3::SpectrumInterference::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## spectrum-interference.h (module 'spectrum'): void ns3::SpectrumInterference::SetErrorModel(ns3::Ptr<ns3::SpectrumErrorModel> e) [member function]
    cls.add_method('SetErrorModel',
                   'void',
                   [param('ns3::Ptr< ns3::SpectrumErrorModel >', 'e')])
    ## spectrum-interference.h (module 'spectrum'): void ns3::SpectrumInterference::StartRx(ns3::Ptr<const ns3::Packet> p, ns3::Ptr<const ns3::SpectrumValue> rxPsd) [member function]
    cls.add_method('StartRx',
                   'void',
                   [param('ns3::Ptr< ns3::Packet const >', 'p'), param('ns3::Ptr< ns3::SpectrumValue const >', 'rxPsd')])
    ## spectrum-interference.h (module 'spectrum'): void ns3::SpectrumInterference::AbortRx() [member function]
    cls.add_method('AbortRx',
                   'void',
                   [])
    ## spectrum-interference.h (module 'spectrum'): bool ns3::SpectrumInterference::EndRx() [member function]
    cls.add_method('EndRx',
                   'bool',
                   [])
    ## spectrum-interference.h (module 'spectrum'): void ns3::SpectrumInterference::AddSignal(ns3::Ptr<const ns3::SpectrumValue> spd, ns3::Time const duration) [member function]
    cls.add_method('AddSignal',
                   'void',
                   [param('ns3::Ptr< ns3::SpectrumValue const >', 'spd'), param('ns3::Time const', 'duration')])
    ## spectrum-interference.h (module 'spectrum'): void ns3::SpectrumInterference::SetNoisePowerSpectralDensity(ns3::Ptr<const ns3::SpectrumValue> noisePsd) [member function]
    cls.add_method('SetNoisePowerSpectralDensity',
                   'void',
                   [param('ns3::Ptr< ns3::SpectrumValue const >', 'noisePsd')])
    ## spectrum-interference.h (module 'spectrum'): ns3::SpectrumInterference::SpectrumInterference(ns3::SpectrumInterference const & arg0) [constructor]
    cls.add_constructor([param('ns3::SpectrumInterference const &', 'arg0')])
    ## spectrum-interference.h (module 'spectrum'): void ns3::SpectrumInterference::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   visibility='protected', is_virtual=True)
    return

def register_Ns3SpectrumModel_methods(root_module, cls):
    cls.add_binary_comparison_operator('==')
    ## spectrum-model.h (module 'spectrum'): ns3::SpectrumModel::SpectrumModel(ns3::SpectrumModel const & arg0) [constructor]
    cls.add_constructor([param('ns3::SpectrumModel const &', 'arg0')])
    ## spectrum-model.h (module 'spectrum'): ns3::SpectrumModel::SpectrumModel(std::vector<double, std::allocator<double> > centerFreqs) [constructor]
    cls.add_constructor([param('std::vector< double >', 'centerFreqs')])
    ## spectrum-model.h (module 'spectrum'): ns3::SpectrumModel::SpectrumModel(ns3::Bands bands) [constructor]
    cls.add_constructor([param('ns3::Bands', 'bands')])
    ## spectrum-model.h (module 'spectrum'): std::vector<ns3::BandInfo, std::allocator<ns3::BandInfo> >::const_iterator ns3::SpectrumModel::Begin() const [member function]
    cls.add_method('Begin',
                   'std::vector< ns3::BandInfo > const_iterator',
                   [],
                   is_const=True)
    ## spectrum-model.h (module 'spectrum'): std::vector<ns3::BandInfo, std::allocator<ns3::BandInfo> >::const_iterator ns3::SpectrumModel::End() const [member function]
    cls.add_method('End',
                   'std::vector< ns3::BandInfo > const_iterator',
                   [],
                   is_const=True)
    ## spectrum-model.h (module 'spectrum'): size_t ns3::SpectrumModel::GetNumBands() const [member function]
    cls.add_method('GetNumBands',
                   'size_t',
                   [],
                   is_const=True)
    ## spectrum-model.h (module 'spectrum'): ns3::SpectrumModelUid_t ns3::SpectrumModel::GetUid() const [member function]
    cls.add_method('GetUid',
                   'ns3::SpectrumModelUid_t',
                   [],
                   is_const=True)
    ## spectrum-model.h (module 'spectrum'): bool ns3::SpectrumModel::IsOrthogonal(ns3::SpectrumModel const & other) const [member function]
    cls.add_method('IsOrthogonal',
                   'bool',
                   [param('ns3::SpectrumModel const &', 'other')],
                   is_const=True)
    return

def register_Ns3SpectrumPhy_methods(root_module, cls):
    ## spectrum-phy.h (module 'spectrum'): ns3::SpectrumPhy::SpectrumPhy() [constructor]
    cls.add_constructor([])
    ## spectrum-phy.h (module 'spectrum'): static ns3::TypeId ns3::SpectrumPhy::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## spectrum-phy.h (module 'spectrum'): void ns3::SpectrumPhy::SetDevice(ns3::Ptr<ns3::NetDevice> d) [member function]
    cls.add_method('SetDevice',
                   'void',
                   [param('ns3::Ptr< ns3::NetDevice >', 'd')],
                   is_pure_virtual=True, is_virtual=True)
    ## spectrum-phy.h (module 'spectrum'): ns3::Ptr<ns3::NetDevice> ns3::SpectrumPhy::GetDevice() const [member function]
    cls.add_method('GetDevice',
                   'ns3::Ptr< ns3::NetDevice >',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## spectrum-phy.h (module 'spectrum'): void ns3::SpectrumPhy::SetMobility(ns3::Ptr<ns3::MobilityModel> m) [member function]
    cls.add_method('SetMobility',
                   'void',
                   [param('ns3::Ptr< ns3::MobilityModel >', 'm')],
                   is_pure_virtual=True, is_virtual=True)
    ## spectrum-phy.h (module 'spectrum'): ns3::Ptr<ns3::MobilityModel> ns3::SpectrumPhy::GetMobility() [member function]
    cls.add_method('GetMobility',
                   'ns3::Ptr< ns3::MobilityModel >',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## spectrum-phy.h (module 'spectrum'): void ns3::SpectrumPhy::SetChannel(ns3::Ptr<ns3::SpectrumChannel> c) [member function]
    cls.add_method('SetChannel',
                   'void',
                   [param('ns3::Ptr< ns3::SpectrumChannel >', 'c')],
                   is_pure_virtual=True, is_virtual=True)
    ## spectrum-phy.h (module 'spectrum'): ns3::Ptr<const ns3::SpectrumModel> ns3::SpectrumPhy::GetRxSpectrumModel() const [member function]
    cls.add_method('GetRxSpectrumModel',
                   'ns3::Ptr< ns3::SpectrumModel const >',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## spectrum-phy.h (module 'spectrum'): ns3::Ptr<ns3::AntennaModel> ns3::SpectrumPhy::GetRxAntenna() [member function]
    cls.add_method('GetRxAntenna',
                   'ns3::Ptr< ns3::AntennaModel >',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## spectrum-phy.h (module 'spectrum'): void ns3::SpectrumPhy::StartRx(ns3::Ptr<ns3::SpectrumSignalParameters> params) [member function]
    cls.add_method('StartRx',
                   'void',
                   [param('ns3::Ptr< ns3::SpectrumSignalParameters >', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3SpectrumPropagationLossModel_methods(root_module, cls):
    ## spectrum-propagation-loss-model.h (module 'spectrum'): ns3::SpectrumPropagationLossModel::SpectrumPropagationLossModel(ns3::SpectrumPropagationLossModel const & arg0) [constructor]
    cls.add_constructor([param('ns3::SpectrumPropagationLossModel const &', 'arg0')])
    ## spectrum-propagation-loss-model.h (module 'spectrum'): ns3::SpectrumPropagationLossModel::SpectrumPropagationLossModel() [constructor]
    cls.add_constructor([])
    ## spectrum-propagation-loss-model.h (module 'spectrum'): ns3::Ptr<ns3::SpectrumValue> ns3::SpectrumPropagationLossModel::CalcRxPowerSpectralDensity(ns3::Ptr<const ns3::SpectrumValue> txPsd, ns3::Ptr<const ns3::MobilityModel> a, ns3::Ptr<const ns3::MobilityModel> b) const [member function]
    cls.add_method('CalcRxPowerSpectralDensity',
                   'ns3::Ptr< ns3::SpectrumValue >',
                   [param('ns3::Ptr< ns3::SpectrumValue const >', 'txPsd'), param('ns3::Ptr< ns3::MobilityModel const >', 'a'), param('ns3::Ptr< ns3::MobilityModel const >', 'b')],
                   is_const=True)
    ## spectrum-propagation-loss-model.h (module 'spectrum'): static ns3::TypeId ns3::SpectrumPropagationLossModel::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## spectrum-propagation-loss-model.h (module 'spectrum'): void ns3::SpectrumPropagationLossModel::SetNext(ns3::Ptr<ns3::SpectrumPropagationLossModel> next) [member function]
    cls.add_method('SetNext',
                   'void',
                   [param('ns3::Ptr< ns3::SpectrumPropagationLossModel >', 'next')])
    ## spectrum-propagation-loss-model.h (module 'spectrum'): void ns3::SpectrumPropagationLossModel::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   visibility='protected', is_virtual=True)
    ## spectrum-propagation-loss-model.h (module 'spectrum'): ns3::Ptr<ns3::SpectrumValue> ns3::SpectrumPropagationLossModel::DoCalcRxPowerSpectralDensity(ns3::Ptr<const ns3::SpectrumValue> txPsd, ns3::Ptr<const ns3::MobilityModel> a, ns3::Ptr<const ns3::MobilityModel> b) const [member function]
    cls.add_method('DoCalcRxPowerSpectralDensity',
                   'ns3::Ptr< ns3::SpectrumValue >',
                   [param('ns3::Ptr< ns3::SpectrumValue const >', 'txPsd'), param('ns3::Ptr< ns3::MobilityModel const >', 'a'), param('ns3::Ptr< ns3::MobilityModel const >', 'b')],
                   is_pure_virtual=True, is_const=True, visibility='private', is_virtual=True)
    return

def register_Ns3SpectrumSignalParameters_methods(root_module, cls):
    ## spectrum-signal-parameters.h (module 'spectrum'): ns3::SpectrumSignalParameters::SpectrumSignalParameters() [constructor]
    cls.add_constructor([])
    ## spectrum-signal-parameters.h (module 'spectrum'): ns3::SpectrumSignalParameters::SpectrumSignalParameters(ns3::SpectrumSignalParameters const & p) [constructor]
    cls.add_constructor([param('ns3::SpectrumSignalParameters const &', 'p')])
    ## spectrum-signal-parameters.h (module 'spectrum'): ns3::Ptr<ns3::SpectrumSignalParameters> ns3::SpectrumSignalParameters::Copy() [member function]
    cls.add_method('Copy',
                   'ns3::Ptr< ns3::SpectrumSignalParameters >',
                   [],
                   is_virtual=True)
    ## spectrum-signal-parameters.h (module 'spectrum'): ns3::SpectrumSignalParameters::duration [variable]
    cls.add_instance_attribute('duration', 'ns3::Time', is_const=False)
    ## spectrum-signal-parameters.h (module 'spectrum'): ns3::SpectrumSignalParameters::psd [variable]
    cls.add_instance_attribute('psd', 'ns3::Ptr< ns3::SpectrumValue >', is_const=False)
    ## spectrum-signal-parameters.h (module 'spectrum'): ns3::SpectrumSignalParameters::txAntenna [variable]
    cls.add_instance_attribute('txAntenna', 'ns3::Ptr< ns3::AntennaModel >', is_const=False)
    ## spectrum-signal-parameters.h (module 'spectrum'): ns3::SpectrumSignalParameters::txPhy [variable]
    cls.add_instance_attribute('txPhy', 'ns3::Ptr< ns3::SpectrumPhy >', is_const=False)
    return

def register_Ns3SpectrumValue_methods(root_module, cls):
    cls.add_output_stream_operator()
    cls.add_unary_numeric_operator('-')
    cls.add_binary_numeric_operator('/', root_module['ns3::SpectrumValue'], root_module['ns3::SpectrumValue'], param('double', u'right'))
    cls.add_binary_numeric_operator('/', root_module['ns3::SpectrumValue'], root_module['ns3::SpectrumValue'], param('ns3::SpectrumValue const &', u'right'))
    cls.add_binary_numeric_operator('*', root_module['ns3::SpectrumValue'], root_module['ns3::SpectrumValue'], param('double', u'right'))
    cls.add_binary_numeric_operator('*', root_module['ns3::SpectrumValue'], root_module['ns3::SpectrumValue'], param('ns3::SpectrumValue const &', u'right'))
    cls.add_binary_numeric_operator('-', root_module['ns3::SpectrumValue'], root_module['ns3::SpectrumValue'], param('double', u'right'))
    cls.add_binary_numeric_operator('-', root_module['ns3::SpectrumValue'], root_module['ns3::SpectrumValue'], param('ns3::SpectrumValue const &', u'right'))
    cls.add_binary_numeric_operator('+', root_module['ns3::SpectrumValue'], root_module['ns3::SpectrumValue'], param('double', u'right'))
    cls.add_binary_numeric_operator('+', root_module['ns3::SpectrumValue'], root_module['ns3::SpectrumValue'], param('ns3::SpectrumValue const &', u'right'))
    cls.add_inplace_numeric_operator('*=', param('ns3::SpectrumValue const &', u'right'))
    cls.add_inplace_numeric_operator('*=', param('double', u'right'))
    cls.add_inplace_numeric_operator('+=', param('ns3::SpectrumValue const &', u'right'))
    cls.add_inplace_numeric_operator('+=', param('double', u'right'))
    cls.add_inplace_numeric_operator('-=', param('ns3::SpectrumValue const &', u'right'))
    cls.add_inplace_numeric_operator('-=', param('double', u'right'))
    cls.add_inplace_numeric_operator('/=', param('ns3::SpectrumValue const &', u'right'))
    cls.add_inplace_numeric_operator('/=', param('double', u'right'))
    ## spectrum-value.h (module 'spectrum'): ns3::SpectrumValue::SpectrumValue(ns3::SpectrumValue const & arg0) [constructor]
    cls.add_constructor([param('ns3::SpectrumValue const &', 'arg0')])
    ## spectrum-value.h (module 'spectrum'): ns3::SpectrumValue::SpectrumValue(ns3::Ptr<const ns3::SpectrumModel> sm) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::SpectrumModel const >', 'sm')])
    ## spectrum-value.h (module 'spectrum'): ns3::SpectrumValue::SpectrumValue() [constructor]
    cls.add_constructor([])
    ## spectrum-value.h (module 'spectrum'): std::vector<ns3::BandInfo, std::allocator<ns3::BandInfo> >::const_iterator ns3::SpectrumValue::ConstBandsBegin() const [member function]
    cls.add_method('ConstBandsBegin',
                   'std::vector< ns3::BandInfo > const_iterator',
                   [],
                   is_const=True)
    ## spectrum-value.h (module 'spectrum'): std::vector<ns3::BandInfo, std::allocator<ns3::BandInfo> >::const_iterator ns3::SpectrumValue::ConstBandsEnd() const [member function]
    cls.add_method('ConstBandsEnd',
                   'std::vector< ns3::BandInfo > const_iterator',
                   [],
                   is_const=True)
    ## spectrum-value.h (module 'spectrum'): std::vector<double, std::allocator<double> >::const_iterator ns3::SpectrumValue::ConstValuesBegin() const [member function]
    cls.add_method('ConstValuesBegin',
                   'std::vector< double > const_iterator',
                   [],
                   is_const=True)
    ## spectrum-value.h (module 'spectrum'): std::vector<double, std::allocator<double> >::const_iterator ns3::SpectrumValue::ConstValuesEnd() const [member function]
    cls.add_method('ConstValuesEnd',
                   'std::vector< double > const_iterator',
                   [],
                   is_const=True)
    ## spectrum-value.h (module 'spectrum'): ns3::Ptr<ns3::SpectrumValue> ns3::SpectrumValue::Copy() const [member function]
    cls.add_method('Copy',
                   'ns3::Ptr< ns3::SpectrumValue >',
                   [],
                   is_const=True)
    ## spectrum-value.h (module 'spectrum'): ns3::Ptr<const ns3::SpectrumModel> ns3::SpectrumValue::GetSpectrumModel() const [member function]
    cls.add_method('GetSpectrumModel',
                   'ns3::Ptr< ns3::SpectrumModel const >',
                   [],
                   is_const=True)
    ## spectrum-value.h (module 'spectrum'): ns3::SpectrumModelUid_t ns3::SpectrumValue::GetSpectrumModelUid() const [member function]
    cls.add_method('GetSpectrumModelUid',
                   'ns3::SpectrumModelUid_t',
                   [],
                   is_const=True)
    ## spectrum-value.h (module 'spectrum'): std::vector<double, std::allocator<double> >::iterator ns3::SpectrumValue::ValuesBegin() [member function]
    cls.add_method('ValuesBegin',
                   'std::vector< double > iterator',
                   [])
    ## spectrum-value.h (module 'spectrum'): std::vector<double, std::allocator<double> >::iterator ns3::SpectrumValue::ValuesEnd() [member function]
    cls.add_method('ValuesEnd',
                   'std::vector< double > iterator',
                   [])
    return

def register_Ns3ThreeLogDistancePropagationLossModel_methods(root_module, cls):
    ## propagation-loss-model.h (module 'propagation'): static ns3::TypeId ns3::ThreeLogDistancePropagationLossModel::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## propagation-loss-model.h (module 'propagation'): ns3::ThreeLogDistancePropagationLossModel::ThreeLogDistancePropagationLossModel() [constructor]
    cls.add_constructor([])
    ## propagation-loss-model.h (module 'propagation'): double ns3::ThreeLogDistancePropagationLossModel::DoCalcRxPower(double txPowerDbm, ns3::Ptr<ns3::MobilityModel> a, ns3::Ptr<ns3::MobilityModel> b) const [member function]
    cls.add_method('DoCalcRxPower',
                   'double',
                   [param('double', 'txPowerDbm'), param('ns3::Ptr< ns3::MobilityModel >', 'a'), param('ns3::Ptr< ns3::MobilityModel >', 'b')],
                   is_const=True, visibility='private', is_virtual=True)
    ## propagation-loss-model.h (module 'propagation'): int64_t ns3::ThreeLogDistancePropagationLossModel::DoAssignStreams(int64_t stream) [member function]
    cls.add_method('DoAssignStreams',
                   'int64_t',
                   [param('int64_t', 'stream')],
                   visibility='private', is_virtual=True)
    return

def register_Ns3Time_methods(root_module, cls):
    cls.add_binary_comparison_operator('==')
    cls.add_binary_comparison_operator('!=')
    cls.add_binary_comparison_operator('<=')
    cls.add_binary_comparison_operator('>=')
    cls.add_binary_comparison_operator('<')
    cls.add_binary_comparison_operator('>')
    cls.add_binary_numeric_operator('+', root_module['ns3::Time'], root_module['ns3::Time'], param('ns3::Time const &', u'right'))
    cls.add_binary_numeric_operator('-', root_module['ns3::Time'], root_module['ns3::Time'], param('ns3::Time const &', u'right'))
    cls.add_binary_numeric_operator('*', root_module['ns3::Time'], root_module['ns3::Time'], param('int64_t const &', u'right'))
    cls.add_binary_numeric_operator('/', root_module['ns3::Time'], root_module['ns3::Time'], param('int64_t const &', u'right'))
    cls.add_inplace_numeric_operator('+=', param('ns3::Time const &', u'right'))
    cls.add_inplace_numeric_operator('-=', param('ns3::Time const &', u'right'))
    cls.add_output_stream_operator()
    ## nstime.h (module 'core'): ns3::Time::Time() [constructor]
    cls.add_constructor([])
    ## nstime.h (module 'core'): ns3::Time::Time(ns3::Time const & o) [constructor]
    cls.add_constructor([param('ns3::Time const &', 'o')])
    ## nstime.h (module 'core'): ns3::Time::Time(double v) [constructor]
    cls.add_constructor([param('double', 'v')])
    ## nstime.h (module 'core'): ns3::Time::Time(int v) [constructor]
    cls.add_constructor([param('int', 'v')])
    ## nstime.h (module 'core'): ns3::Time::Time(long int v) [constructor]
    cls.add_constructor([param('long int', 'v')])
    ## nstime.h (module 'core'): ns3::Time::Time(long long int v) [constructor]
    cls.add_constructor([param('long long int', 'v')])
    ## nstime.h (module 'core'): ns3::Time::Time(unsigned int v) [constructor]
    cls.add_constructor([param('unsigned int', 'v')])
    ## nstime.h (module 'core'): ns3::Time::Time(long unsigned int v) [constructor]
    cls.add_constructor([param('long unsigned int', 'v')])
    ## nstime.h (module 'core'): ns3::Time::Time(long long unsigned int v) [constructor]
    cls.add_constructor([param('long long unsigned int', 'v')])
    ## nstime.h (module 'core'): ns3::Time::Time(ns3::int64x64_t const & v) [constructor]
    cls.add_constructor([param('ns3::int64x64_t const &', 'v')])
    ## nstime.h (module 'core'): ns3::Time::Time(std::string const & s) [constructor]
    cls.add_constructor([param('std::string const &', 's')])
    ## nstime.h (module 'core'): ns3::TimeWithUnit ns3::Time::As(ns3::Time::Unit const unit) const [member function]
    cls.add_method('As',
                   'ns3::TimeWithUnit',
                   [param('ns3::Time::Unit const', 'unit')],
                   is_const=True)
    ## nstime.h (module 'core'): int ns3::Time::Compare(ns3::Time const & o) const [member function]
    cls.add_method('Compare',
                   'int',
                   [param('ns3::Time const &', 'o')],
                   is_const=True)
    ## nstime.h (module 'core'): static ns3::Time ns3::Time::From(ns3::int64x64_t const & value) [member function]
    cls.add_method('From',
                   'ns3::Time',
                   [param('ns3::int64x64_t const &', 'value')],
                   is_static=True)
    ## nstime.h (module 'core'): static ns3::Time ns3::Time::From(ns3::int64x64_t const & value, ns3::Time::Unit unit) [member function]
    cls.add_method('From',
                   'ns3::Time',
                   [param('ns3::int64x64_t const &', 'value'), param('ns3::Time::Unit', 'unit')],
                   is_static=True)
    ## nstime.h (module 'core'): static ns3::Time ns3::Time::FromDouble(double value, ns3::Time::Unit unit) [member function]
    cls.add_method('FromDouble',
                   'ns3::Time',
                   [param('double', 'value'), param('ns3::Time::Unit', 'unit')],
                   is_static=True)
    ## nstime.h (module 'core'): static ns3::Time ns3::Time::FromInteger(uint64_t value, ns3::Time::Unit unit) [member function]
    cls.add_method('FromInteger',
                   'ns3::Time',
                   [param('uint64_t', 'value'), param('ns3::Time::Unit', 'unit')],
                   is_static=True)
    ## nstime.h (module 'core'): double ns3::Time::GetDays() const [member function]
    cls.add_method('GetDays',
                   'double',
                   [],
                   is_const=True)
    ## nstime.h (module 'core'): double ns3::Time::GetDouble() const [member function]
    cls.add_method('GetDouble',
                   'double',
                   [],
                   is_const=True)
    ## nstime.h (module 'core'): int64_t ns3::Time::GetFemtoSeconds() const [member function]
    cls.add_method('GetFemtoSeconds',
                   'int64_t',
                   [],
                   is_const=True)
    ## nstime.h (module 'core'): double ns3::Time::GetHours() const [member function]
    cls.add_method('GetHours',
                   'double',
                   [],
                   is_const=True)
    ## nstime.h (module 'core'): int64_t ns3::Time::GetInteger() const [member function]
    cls.add_method('GetInteger',
                   'int64_t',
                   [],
                   is_const=True)
    ## nstime.h (module 'core'): int64_t ns3::Time::GetMicroSeconds() const [member function]
    cls.add_method('GetMicroSeconds',
                   'int64_t',
                   [],
                   is_const=True)
    ## nstime.h (module 'core'): int64_t ns3::Time::GetMilliSeconds() const [member function]
    cls.add_method('GetMilliSeconds',
                   'int64_t',
                   [],
                   is_const=True)
    ## nstime.h (module 'core'): double ns3::Time::GetMinutes() const [member function]
    cls.add_method('GetMinutes',
                   'double',
                   [],
                   is_const=True)
    ## nstime.h (module 'core'): int64_t ns3::Time::GetNanoSeconds() const [member function]
    cls.add_method('GetNanoSeconds',
                   'int64_t',
                   [],
                   is_const=True)
    ## nstime.h (module 'core'): int64_t ns3::Time::GetPicoSeconds() const [member function]
    cls.add_method('GetPicoSeconds',
                   'int64_t',
                   [],
                   is_const=True)
    ## nstime.h (module 'core'): static ns3::Time::Unit ns3::Time::GetResolution() [member function]
    cls.add_method('GetResolution',
                   'ns3::Time::Unit',
                   [],
                   is_static=True)
    ## nstime.h (module 'core'): double ns3::Time::GetSeconds() const [member function]
    cls.add_method('GetSeconds',
                   'double',
                   [],
                   is_const=True)
    ## nstime.h (module 'core'): int64_t ns3::Time::GetTimeStep() const [member function]
    cls.add_method('GetTimeStep',
                   'int64_t',
                   [],
                   is_const=True)
    ## nstime.h (module 'core'): double ns3::Time::GetYears() const [member function]
    cls.add_method('GetYears',
                   'double',
                   [],
                   is_const=True)
    ## nstime.h (module 'core'): bool ns3::Time::IsNegative() const [member function]
    cls.add_method('IsNegative',
                   'bool',
                   [],
                   is_const=True)
    ## nstime.h (module 'core'): bool ns3::Time::IsPositive() const [member function]
    cls.add_method('IsPositive',
                   'bool',
                   [],
                   is_const=True)
    ## nstime.h (module 'core'): bool ns3::Time::IsStrictlyNegative() const [member function]
    cls.add_method('IsStrictlyNegative',
                   'bool',
                   [],
                   is_const=True)
    ## nstime.h (module 'core'): bool ns3::Time::IsStrictlyPositive() const [member function]
    cls.add_method('IsStrictlyPositive',
                   'bool',
                   [],
                   is_const=True)
    ## nstime.h (module 'core'): bool ns3::Time::IsZero() const [member function]
    cls.add_method('IsZero',
                   'bool',
                   [],
                   is_const=True)
    ## nstime.h (module 'core'): static ns3::Time ns3::Time::Max() [member function]
    cls.add_method('Max',
                   'ns3::Time',
                   [],
                   is_static=True)
    ## nstime.h (module 'core'): static ns3::Time ns3::Time::Min() [member function]
    cls.add_method('Min',
                   'ns3::Time',
                   [],
                   is_static=True)
    ## nstime.h (module 'core'): static void ns3::Time::SetResolution(ns3::Time::Unit resolution) [member function]
    cls.add_method('SetResolution',
                   'void',
                   [param('ns3::Time::Unit', 'resolution')],
                   is_static=True)
    ## nstime.h (module 'core'): static bool ns3::Time::StaticInit() [member function]
    cls.add_method('StaticInit',
                   'bool',
                   [],
                   is_static=True)
    ## nstime.h (module 'core'): ns3::int64x64_t ns3::Time::To(ns3::Time::Unit unit) const [member function]
    cls.add_method('To',
                   'ns3::int64x64_t',
                   [param('ns3::Time::Unit', 'unit')],
                   is_const=True)
    ## nstime.h (module 'core'): double ns3::Time::ToDouble(ns3::Time::Unit unit) const [member function]
    cls.add_method('ToDouble',
                   'double',
                   [param('ns3::Time::Unit', 'unit')],
                   is_const=True)
    ## nstime.h (module 'core'): int64_t ns3::Time::ToInteger(ns3::Time::Unit unit) const [member function]
    cls.add_method('ToInteger',
                   'int64_t',
                   [param('ns3::Time::Unit', 'unit')],
                   is_const=True)
    return

def register_Ns3TraceSourceAccessor_methods(root_module, cls):
    ## trace-source-accessor.h (module 'core'): ns3::TraceSourceAccessor::TraceSourceAccessor(ns3::TraceSourceAccessor const & arg0) [constructor]
    cls.add_constructor([param('ns3::TraceSourceAccessor const &', 'arg0')])
    ## trace-source-accessor.h (module 'core'): ns3::TraceSourceAccessor::TraceSourceAccessor() [constructor]
    cls.add_constructor([])
    ## trace-source-accessor.h (module 'core'): bool ns3::TraceSourceAccessor::Connect(ns3::ObjectBase * obj, std::string context, ns3::CallbackBase const & cb) const [member function]
    cls.add_method('Connect',
                   'bool',
                   [param('ns3::ObjectBase *', 'obj', transfer_ownership=False), param('std::string', 'context'), param('ns3::CallbackBase const &', 'cb')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## trace-source-accessor.h (module 'core'): bool ns3::TraceSourceAccessor::ConnectWithoutContext(ns3::ObjectBase * obj, ns3::CallbackBase const & cb) const [member function]
    cls.add_method('ConnectWithoutContext',
                   'bool',
                   [param('ns3::ObjectBase *', 'obj', transfer_ownership=False), param('ns3::CallbackBase const &', 'cb')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## trace-source-accessor.h (module 'core'): bool ns3::TraceSourceAccessor::Disconnect(ns3::ObjectBase * obj, std::string context, ns3::CallbackBase const & cb) const [member function]
    cls.add_method('Disconnect',
                   'bool',
                   [param('ns3::ObjectBase *', 'obj', transfer_ownership=False), param('std::string', 'context'), param('ns3::CallbackBase const &', 'cb')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## trace-source-accessor.h (module 'core'): bool ns3::TraceSourceAccessor::DisconnectWithoutContext(ns3::ObjectBase * obj, ns3::CallbackBase const & cb) const [member function]
    cls.add_method('DisconnectWithoutContext',
                   'bool',
                   [param('ns3::ObjectBase *', 'obj', transfer_ownership=False), param('ns3::CallbackBase const &', 'cb')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    return

def register_Ns3Trailer_methods(root_module, cls):
    cls.add_output_stream_operator()
    ## trailer.h (module 'network'): ns3::Trailer::Trailer() [constructor]
    cls.add_constructor([])
    ## trailer.h (module 'network'): ns3::Trailer::Trailer(ns3::Trailer const & arg0) [constructor]
    cls.add_constructor([param('ns3::Trailer const &', 'arg0')])
    ## trailer.h (module 'network'): uint32_t ns3::Trailer::Deserialize(ns3::Buffer::Iterator end) [member function]
    cls.add_method('Deserialize',
                   'uint32_t',
                   [param('ns3::Buffer::Iterator', 'end')],
                   is_pure_virtual=True, is_virtual=True)
    ## trailer.h (module 'network'): uint32_t ns3::Trailer::Deserialize(ns3::Buffer::Iterator start, ns3::Buffer::Iterator end) [member function]
    cls.add_method('Deserialize',
                   'uint32_t',
                   [param('ns3::Buffer::Iterator', 'start'), param('ns3::Buffer::Iterator', 'end')],
                   is_virtual=True)
    ## trailer.h (module 'network'): uint32_t ns3::Trailer::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize',
                   'uint32_t',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## trailer.h (module 'network'): static ns3::TypeId ns3::Trailer::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## trailer.h (module 'network'): void ns3::Trailer::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## trailer.h (module 'network'): void ns3::Trailer::Serialize(ns3::Buffer::Iterator start) const [member function]
    cls.add_method('Serialize',
                   'void',
                   [param('ns3::Buffer::Iterator', 'start')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    return

def register_Ns3TriangularRandomVariable_methods(root_module, cls):
    ## random-variable-stream.h (module 'core'): static ns3::TypeId ns3::TriangularRandomVariable::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## random-variable-stream.h (module 'core'): ns3::TriangularRandomVariable::TriangularRandomVariable() [constructor]
    cls.add_constructor([])
    ## random-variable-stream.h (module 'core'): double ns3::TriangularRandomVariable::GetMean() const [member function]
    cls.add_method('GetMean',
                   'double',
                   [],
                   is_const=True)
    ## random-variable-stream.h (module 'core'): double ns3::TriangularRandomVariable::GetMin() const [member function]
    cls.add_method('GetMin',
                   'double',
                   [],
                   is_const=True)
    ## random-variable-stream.h (module 'core'): double ns3::TriangularRandomVariable::GetMax() const [member function]
    cls.add_method('GetMax',
                   'double',
                   [],
                   is_const=True)
    ## random-variable-stream.h (module 'core'): double ns3::TriangularRandomVariable::GetValue(double mean, double min, double max) [member function]
    cls.add_method('GetValue',
                   'double',
                   [param('double', 'mean'), param('double', 'min'), param('double', 'max')])
    ## random-variable-stream.h (module 'core'): uint32_t ns3::TriangularRandomVariable::GetInteger(uint32_t mean, uint32_t min, uint32_t max) [member function]
    cls.add_method('GetInteger',
                   'uint32_t',
                   [param('uint32_t', 'mean'), param('uint32_t', 'min'), param('uint32_t', 'max')])
    ## random-variable-stream.h (module 'core'): double ns3::TriangularRandomVariable::GetValue() [member function]
    cls.add_method('GetValue',
                   'double',
                   [],
                   is_virtual=True)
    ## random-variable-stream.h (module 'core'): uint32_t ns3::TriangularRandomVariable::GetInteger() [member function]
    cls.add_method('GetInteger',
                   'uint32_t',
                   [],
                   is_virtual=True)
    return

def register_Ns3TwoRayGroundPropagationLossModel_methods(root_module, cls):
    ## propagation-loss-model.h (module 'propagation'): static ns3::TypeId ns3::TwoRayGroundPropagationLossModel::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## propagation-loss-model.h (module 'propagation'): ns3::TwoRayGroundPropagationLossModel::TwoRayGroundPropagationLossModel() [constructor]
    cls.add_constructor([])
    ## propagation-loss-model.h (module 'propagation'): void ns3::TwoRayGroundPropagationLossModel::SetFrequency(double frequency) [member function]
    cls.add_method('SetFrequency',
                   'void',
                   [param('double', 'frequency')])
    ## propagation-loss-model.h (module 'propagation'): void ns3::TwoRayGroundPropagationLossModel::SetSystemLoss(double systemLoss) [member function]
    cls.add_method('SetSystemLoss',
                   'void',
                   [param('double', 'systemLoss')])
    ## propagation-loss-model.h (module 'propagation'): void ns3::TwoRayGroundPropagationLossModel::SetMinDistance(double minDistance) [member function]
    cls.add_method('SetMinDistance',
                   'void',
                   [param('double', 'minDistance')])
    ## propagation-loss-model.h (module 'propagation'): double ns3::TwoRayGroundPropagationLossModel::GetMinDistance() const [member function]
    cls.add_method('GetMinDistance',
                   'double',
                   [],
                   is_const=True)
    ## propagation-loss-model.h (module 'propagation'): double ns3::TwoRayGroundPropagationLossModel::GetFrequency() const [member function]
    cls.add_method('GetFrequency',
                   'double',
                   [],
                   is_const=True)
    ## propagation-loss-model.h (module 'propagation'): double ns3::TwoRayGroundPropagationLossModel::GetSystemLoss() const [member function]
    cls.add_method('GetSystemLoss',
                   'double',
                   [],
                   is_const=True)
    ## propagation-loss-model.h (module 'propagation'): void ns3::TwoRayGroundPropagationLossModel::SetHeightAboveZ(double heightAboveZ) [member function]
    cls.add_method('SetHeightAboveZ',
                   'void',
                   [param('double', 'heightAboveZ')])
    ## propagation-loss-model.h (module 'propagation'): double ns3::TwoRayGroundPropagationLossModel::DoCalcRxPower(double txPowerDbm, ns3::Ptr<ns3::MobilityModel> a, ns3::Ptr<ns3::MobilityModel> b) const [member function]
    cls.add_method('DoCalcRxPower',
                   'double',
                   [param('double', 'txPowerDbm'), param('ns3::Ptr< ns3::MobilityModel >', 'a'), param('ns3::Ptr< ns3::MobilityModel >', 'b')],
                   is_const=True, visibility='private', is_virtual=True)
    ## propagation-loss-model.h (module 'propagation'): int64_t ns3::TwoRayGroundPropagationLossModel::DoAssignStreams(int64_t stream) [member function]
    cls.add_method('DoAssignStreams',
                   'int64_t',
                   [param('int64_t', 'stream')],
                   visibility='private', is_virtual=True)
    return

def register_Ns3UeManager_methods(root_module, cls):
    ## lte-enb-rrc.h (module 'lte'): ns3::UeManager::UeManager(ns3::UeManager const & arg0) [constructor]
    cls.add_constructor([param('ns3::UeManager const &', 'arg0')])
    ## lte-enb-rrc.h (module 'lte'): ns3::UeManager::UeManager() [constructor]
    cls.add_constructor([])
    ## lte-enb-rrc.h (module 'lte'): ns3::UeManager::UeManager(ns3::Ptr<ns3::LteEnbRrc> rrc, uint16_t rnti, ns3::UeManager::State s, uint8_t componentCarrierId) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::LteEnbRrc >', 'rrc'), param('uint16_t', 'rnti'), param('ns3::UeManager::State', 's'), param('uint8_t', 'componentCarrierId')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::UeManager::CmacUeConfigUpdateInd(ns3::LteEnbCmacSapUser::UeConfig cmacParams) [member function]
    cls.add_method('CmacUeConfigUpdateInd',
                   'void',
                   [param('ns3::LteEnbCmacSapUser::UeConfig', 'cmacParams')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::UeManager::CompleteSetupUe(ns3::LteEnbRrcSapProvider::CompleteSetupUeParameters params) [member function]
    cls.add_method('CompleteSetupUe',
                   'void',
                   [param('ns3::LteEnbRrcSapProvider::CompleteSetupUeParameters', 'params')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::UeManager::DoReceivePdcpSdu(ns3::LtePdcpSapUser::ReceivePdcpSduParameters params) [member function]
    cls.add_method('DoReceivePdcpSdu',
                   'void',
                   [param('ns3::LtePdcpSapUser::ReceivePdcpSduParameters', 'params')])
    ## lte-enb-rrc.h (module 'lte'): bool ns3::UeManager::GetAllMmWaveInOutageAtInitialAccess() [member function]
    cls.add_method('GetAllMmWaveInOutageAtInitialAccess',
                   'bool',
                   [])
    ## lte-enb-rrc.h (module 'lte'): uint8_t ns3::UeManager::GetComponentCarrierId() const [member function]
    cls.add_method('GetComponentCarrierId',
                   'uint8_t',
                   [],
                   is_const=True)
    ## lte-enb-rrc.h (module 'lte'): std::vector<ns3::EpcX2Sap::ErabToBeSetupItem, std::allocator<ns3::EpcX2Sap::ErabToBeSetupItem> > ns3::UeManager::GetErabList() [member function]
    cls.add_method('GetErabList',
                   'std::vector< ns3::EpcX2Sap::ErabToBeSetupItem >',
                   [])
    ## lte-enb-rrc.h (module 'lte'): uint64_t ns3::UeManager::GetImsi() const [member function]
    cls.add_method('GetImsi',
                   'uint64_t',
                   [],
                   is_const=True)
    ## lte-enb-rrc.h (module 'lte'): bool ns3::UeManager::GetIsMc() const [member function]
    cls.add_method('GetIsMc',
                   'bool',
                   [],
                   is_const=True)
    ## lte-enb-rrc.h (module 'lte'): ns3::LteRrcSap::RadioResourceConfigDedicated ns3::UeManager::GetRadioResourceConfigForHandoverPreparationInfo() [member function]
    cls.add_method('GetRadioResourceConfigForHandoverPreparationInfo',
                   'ns3::LteRrcSap::RadioResourceConfigDedicated',
                   [])
    ## lte-enb-rrc.h (module 'lte'): uint16_t ns3::UeManager::GetRnti() const [member function]
    cls.add_method('GetRnti',
                   'uint16_t',
                   [],
                   is_const=True)
    ## lte-enb-rrc.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReconfiguration ns3::UeManager::GetRrcConnectionReconfigurationForHandover() [member function]
    cls.add_method('GetRrcConnectionReconfigurationForHandover',
                   'ns3::LteRrcSap::RrcConnectionReconfiguration',
                   [])
    ## lte-enb-rrc.h (module 'lte'): std::pair<unsigned short, unsigned short> ns3::UeManager::GetSource() [member function]
    cls.add_method('GetSource',
                   'std::pair< unsigned short, unsigned short >',
                   [])
    ## lte-enb-rrc.h (module 'lte'): uint16_t ns3::UeManager::GetSrsConfigurationIndex() const [member function]
    cls.add_method('GetSrsConfigurationIndex',
                   'uint16_t',
                   [],
                   is_const=True)
    ## lte-enb-rrc.h (module 'lte'): ns3::UeManager::State ns3::UeManager::GetState() const [member function]
    cls.add_method('GetState',
                   'ns3::UeManager::State',
                   [],
                   is_const=True)
    ## lte-enb-rrc.h (module 'lte'): static ns3::TypeId ns3::UeManager::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## lte-enb-rrc.h (module 'lte'): void ns3::UeManager::PrepareHandover(uint16_t cellId) [member function]
    cls.add_method('PrepareHandover',
                   'void',
                   [param('uint16_t', 'cellId')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::UeManager::RecordDataRadioBearersToBeStarted() [member function]
    cls.add_method('RecordDataRadioBearersToBeStarted',
                   'void',
                   [])
    ## lte-enb-rrc.h (module 'lte'): void ns3::UeManager::RecvConnectionSwitchToMmWave(bool useMmWaveConnection, uint8_t drbid) [member function]
    cls.add_method('RecvConnectionSwitchToMmWave',
                   'void',
                   [param('bool', 'useMmWaveConnection'), param('uint8_t', 'drbid')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::UeManager::RecvHandoverPreparationFailure(uint16_t cellId) [member function]
    cls.add_method('RecvHandoverPreparationFailure',
                   'void',
                   [param('uint16_t', 'cellId')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::UeManager::RecvHandoverRequestAck(ns3::EpcX2Sap::HandoverRequestAckParams params) [member function]
    cls.add_method('RecvHandoverRequestAck',
                   'void',
                   [param('ns3::EpcX2Sap::HandoverRequestAckParams', 'params')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::UeManager::RecvMeasurementReport(ns3::LteRrcSap::MeasurementReport msg) [member function]
    cls.add_method('RecvMeasurementReport',
                   'void',
                   [param('ns3::LteRrcSap::MeasurementReport', 'msg')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::UeManager::RecvNotifyLteMmWaveHandoverCompleted() [member function]
    cls.add_method('RecvNotifyLteMmWaveHandoverCompleted',
                   'void',
                   [])
    ## lte-enb-rrc.h (module 'lte'): void ns3::UeManager::RecvRlcSetupCompleted(uint8_t drbid) [member function]
    cls.add_method('RecvRlcSetupCompleted',
                   'void',
                   [param('uint8_t', 'drbid')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::UeManager::RecvRlcSetupRequest(ns3::EpcX2Sap::RlcSetupRequest params) [member function]
    cls.add_method('RecvRlcSetupRequest',
                   'void',
                   [param('ns3::EpcX2Sap::RlcSetupRequest', 'params')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::UeManager::RecvRrcConnectionReconfigurationCompleted(ns3::LteRrcSap::RrcConnectionReconfigurationCompleted msg) [member function]
    cls.add_method('RecvRrcConnectionReconfigurationCompleted',
                   'void',
                   [param('ns3::LteRrcSap::RrcConnectionReconfigurationCompleted', 'msg')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::UeManager::RecvRrcConnectionReestablishmentComplete(ns3::LteRrcSap::RrcConnectionReestablishmentComplete msg) [member function]
    cls.add_method('RecvRrcConnectionReestablishmentComplete',
                   'void',
                   [param('ns3::LteRrcSap::RrcConnectionReestablishmentComplete', 'msg')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::UeManager::RecvRrcConnectionReestablishmentRequest(ns3::LteRrcSap::RrcConnectionReestablishmentRequest msg) [member function]
    cls.add_method('RecvRrcConnectionReestablishmentRequest',
                   'void',
                   [param('ns3::LteRrcSap::RrcConnectionReestablishmentRequest', 'msg')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::UeManager::RecvRrcConnectionRequest(ns3::LteRrcSap::RrcConnectionRequest msg) [member function]
    cls.add_method('RecvRrcConnectionRequest',
                   'void',
                   [param('ns3::LteRrcSap::RrcConnectionRequest', 'msg')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::UeManager::RecvRrcConnectionSetupCompleted(ns3::LteRrcSap::RrcConnectionSetupCompleted msg) [member function]
    cls.add_method('RecvRrcConnectionSetupCompleted',
                   'void',
                   [param('ns3::LteRrcSap::RrcConnectionSetupCompleted', 'msg')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::UeManager::RecvRrcSecondaryCellInitialAccessSuccessful(uint16_t mmWaveRnti, uint16_t mmWaveCellId) [member function]
    cls.add_method('RecvRrcSecondaryCellInitialAccessSuccessful',
                   'void',
                   [param('uint16_t', 'mmWaveRnti'), param('uint16_t', 'mmWaveCellId')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::UeManager::RecvSecondaryCellHandoverCompleted(ns3::EpcX2Sap::SecondaryHandoverCompletedParams params) [member function]
    cls.add_method('RecvSecondaryCellHandoverCompleted',
                   'void',
                   [param('ns3::EpcX2Sap::SecondaryHandoverCompletedParams', 'params')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::UeManager::RecvSnStatusTransfer(ns3::EpcX2Sap::SnStatusTransferParams params) [member function]
    cls.add_method('RecvSnStatusTransfer',
                   'void',
                   [param('ns3::EpcX2Sap::SnStatusTransferParams', 'params')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::UeManager::RecvUeContextRelease(ns3::EpcX2Sap::UeContextReleaseParams params) [member function]
    cls.add_method('RecvUeContextRelease',
                   'void',
                   [param('ns3::EpcX2Sap::UeContextReleaseParams', 'params')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::UeManager::ReleaseDataRadioBearer(uint8_t drbid) [member function]
    cls.add_method('ReleaseDataRadioBearer',
                   'void',
                   [param('uint8_t', 'drbid')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::UeManager::ScheduleRrcConnectionReconfiguration() [member function]
    cls.add_method('ScheduleRrcConnectionReconfiguration',
                   'void',
                   [])
    ## lte-enb-rrc.h (module 'lte'): void ns3::UeManager::SendData(uint8_t bid, ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('SendData',
                   'void',
                   [param('uint8_t', 'bid'), param('ns3::Ptr< ns3::Packet >', 'p')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::UeManager::SendRrcConnectionSwitch(bool useMmWaveConnection) [member function]
    cls.add_method('SendRrcConnectionSwitch',
                   'void',
                   [param('bool', 'useMmWaveConnection')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::UeManager::SendUeContextRelease() [member function]
    cls.add_method('SendUeContextRelease',
                   'void',
                   [])
    ## lte-enb-rrc.h (module 'lte'): void ns3::UeManager::SetAllMmWaveInOutageAtInitialAccess(bool param) [member function]
    cls.add_method('SetAllMmWaveInOutageAtInitialAccess',
                   'void',
                   [param('bool', 'param')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::UeManager::SetFirstConnection() [member function]
    cls.add_method('SetFirstConnection',
                   'void',
                   [])
    ## lte-enb-rrc.h (module 'lte'): void ns3::UeManager::SetImsi(uint64_t imsi) [member function]
    cls.add_method('SetImsi',
                   'void',
                   [param('uint64_t', 'imsi')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::UeManager::SetIsMc(bool isMc) [member function]
    cls.add_method('SetIsMc',
                   'void',
                   [param('bool', 'isMc')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::UeManager::SetPdschConfigDedicated(ns3::LteRrcSap::PdschConfigDedicated pdschConfigDedicated) [member function]
    cls.add_method('SetPdschConfigDedicated',
                   'void',
                   [param('ns3::LteRrcSap::PdschConfigDedicated', 'pdschConfigDedicated')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::UeManager::SetSource(uint16_t sourceCellId, uint16_t sourceX2apId) [member function]
    cls.add_method('SetSource',
                   'void',
                   [param('uint16_t', 'sourceCellId'), param('uint16_t', 'sourceX2apId')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::UeManager::SetSrsConfigurationIndex(uint16_t srsConfIndex) [member function]
    cls.add_method('SetSrsConfigurationIndex',
                   'void',
                   [param('uint16_t', 'srsConfIndex')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::UeManager::SetupDataRadioBearer(ns3::EpsBearer bearer, uint8_t bearerId, uint32_t gtpTeid, ns3::Ipv4Address transportLayerAddress) [member function]
    cls.add_method('SetupDataRadioBearer',
                   'void',
                   [param('ns3::EpsBearer', 'bearer'), param('uint8_t', 'bearerId'), param('uint32_t', 'gtpTeid'), param('ns3::Ipv4Address', 'transportLayerAddress')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::UeManager::StartDataRadioBearers() [member function]
    cls.add_method('StartDataRadioBearers',
                   'void',
                   [])
    ## lte-enb-rrc.h (module 'lte'): void ns3::UeManager::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   visibility='protected', is_virtual=True)
    ## lte-enb-rrc.h (module 'lte'): void ns3::UeManager::DoInitialize() [member function]
    cls.add_method('DoInitialize',
                   'void',
                   [],
                   visibility='protected', is_virtual=True)
    return

def register_Ns3UniformRandomVariable_methods(root_module, cls):
    ## random-variable-stream.h (module 'core'): static ns3::TypeId ns3::UniformRandomVariable::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## random-variable-stream.h (module 'core'): ns3::UniformRandomVariable::UniformRandomVariable() [constructor]
    cls.add_constructor([])
    ## random-variable-stream.h (module 'core'): double ns3::UniformRandomVariable::GetMin() const [member function]
    cls.add_method('GetMin',
                   'double',
                   [],
                   is_const=True)
    ## random-variable-stream.h (module 'core'): double ns3::UniformRandomVariable::GetMax() const [member function]
    cls.add_method('GetMax',
                   'double',
                   [],
                   is_const=True)
    ## random-variable-stream.h (module 'core'): double ns3::UniformRandomVariable::GetValue(double min, double max) [member function]
    cls.add_method('GetValue',
                   'double',
                   [param('double', 'min'), param('double', 'max')])
    ## random-variable-stream.h (module 'core'): uint32_t ns3::UniformRandomVariable::GetInteger(uint32_t min, uint32_t max) [member function]
    cls.add_method('GetInteger',
                   'uint32_t',
                   [param('uint32_t', 'min'), param('uint32_t', 'max')])
    ## random-variable-stream.h (module 'core'): double ns3::UniformRandomVariable::GetValue() [member function]
    cls.add_method('GetValue',
                   'double',
                   [],
                   is_virtual=True)
    ## random-variable-stream.h (module 'core'): uint32_t ns3::UniformRandomVariable::GetInteger() [member function]
    cls.add_method('GetInteger',
                   'uint32_t',
                   [],
                   is_virtual=True)
    return

def register_Ns3VendorSpecificValue_methods(root_module, cls):
    ## ff-mac-common.h (module 'lte'): ns3::VendorSpecificValue::VendorSpecificValue() [constructor]
    cls.add_constructor([])
    ## ff-mac-common.h (module 'lte'): ns3::VendorSpecificValue::VendorSpecificValue(ns3::VendorSpecificValue const & arg0) [constructor]
    cls.add_constructor([param('ns3::VendorSpecificValue const &', 'arg0')])
    return

def register_Ns3WeibullRandomVariable_methods(root_module, cls):
    ## random-variable-stream.h (module 'core'): static ns3::TypeId ns3::WeibullRandomVariable::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## random-variable-stream.h (module 'core'): ns3::WeibullRandomVariable::WeibullRandomVariable() [constructor]
    cls.add_constructor([])
    ## random-variable-stream.h (module 'core'): double ns3::WeibullRandomVariable::GetScale() const [member function]
    cls.add_method('GetScale',
                   'double',
                   [],
                   is_const=True)
    ## random-variable-stream.h (module 'core'): double ns3::WeibullRandomVariable::GetShape() const [member function]
    cls.add_method('GetShape',
                   'double',
                   [],
                   is_const=True)
    ## random-variable-stream.h (module 'core'): double ns3::WeibullRandomVariable::GetBound() const [member function]
    cls.add_method('GetBound',
                   'double',
                   [],
                   is_const=True)
    ## random-variable-stream.h (module 'core'): double ns3::WeibullRandomVariable::GetValue(double scale, double shape, double bound) [member function]
    cls.add_method('GetValue',
                   'double',
                   [param('double', 'scale'), param('double', 'shape'), param('double', 'bound')])
    ## random-variable-stream.h (module 'core'): uint32_t ns3::WeibullRandomVariable::GetInteger(uint32_t scale, uint32_t shape, uint32_t bound) [member function]
    cls.add_method('GetInteger',
                   'uint32_t',
                   [param('uint32_t', 'scale'), param('uint32_t', 'shape'), param('uint32_t', 'bound')])
    ## random-variable-stream.h (module 'core'): double ns3::WeibullRandomVariable::GetValue() [member function]
    cls.add_method('GetValue',
                   'double',
                   [],
                   is_virtual=True)
    ## random-variable-stream.h (module 'core'): uint32_t ns3::WeibullRandomVariable::GetInteger() [member function]
    cls.add_method('GetInteger',
                   'uint32_t',
                   [],
                   is_virtual=True)
    return

def register_Ns3ZetaRandomVariable_methods(root_module, cls):
    ## random-variable-stream.h (module 'core'): static ns3::TypeId ns3::ZetaRandomVariable::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## random-variable-stream.h (module 'core'): ns3::ZetaRandomVariable::ZetaRandomVariable() [constructor]
    cls.add_constructor([])
    ## random-variable-stream.h (module 'core'): double ns3::ZetaRandomVariable::GetAlpha() const [member function]
    cls.add_method('GetAlpha',
                   'double',
                   [],
                   is_const=True)
    ## random-variable-stream.h (module 'core'): double ns3::ZetaRandomVariable::GetValue(double alpha) [member function]
    cls.add_method('GetValue',
                   'double',
                   [param('double', 'alpha')])
    ## random-variable-stream.h (module 'core'): uint32_t ns3::ZetaRandomVariable::GetInteger(uint32_t alpha) [member function]
    cls.add_method('GetInteger',
                   'uint32_t',
                   [param('uint32_t', 'alpha')])
    ## random-variable-stream.h (module 'core'): double ns3::ZetaRandomVariable::GetValue() [member function]
    cls.add_method('GetValue',
                   'double',
                   [],
                   is_virtual=True)
    ## random-variable-stream.h (module 'core'): uint32_t ns3::ZetaRandomVariable::GetInteger() [member function]
    cls.add_method('GetInteger',
                   'uint32_t',
                   [],
                   is_virtual=True)
    return

def register_Ns3ZipfRandomVariable_methods(root_module, cls):
    ## random-variable-stream.h (module 'core'): static ns3::TypeId ns3::ZipfRandomVariable::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## random-variable-stream.h (module 'core'): ns3::ZipfRandomVariable::ZipfRandomVariable() [constructor]
    cls.add_constructor([])
    ## random-variable-stream.h (module 'core'): uint32_t ns3::ZipfRandomVariable::GetN() const [member function]
    cls.add_method('GetN',
                   'uint32_t',
                   [],
                   is_const=True)
    ## random-variable-stream.h (module 'core'): double ns3::ZipfRandomVariable::GetAlpha() const [member function]
    cls.add_method('GetAlpha',
                   'double',
                   [],
                   is_const=True)
    ## random-variable-stream.h (module 'core'): double ns3::ZipfRandomVariable::GetValue(uint32_t n, double alpha) [member function]
    cls.add_method('GetValue',
                   'double',
                   [param('uint32_t', 'n'), param('double', 'alpha')])
    ## random-variable-stream.h (module 'core'): uint32_t ns3::ZipfRandomVariable::GetInteger(uint32_t n, uint32_t alpha) [member function]
    cls.add_method('GetInteger',
                   'uint32_t',
                   [param('uint32_t', 'n'), param('uint32_t', 'alpha')])
    ## random-variable-stream.h (module 'core'): double ns3::ZipfRandomVariable::GetValue() [member function]
    cls.add_method('GetValue',
                   'double',
                   [],
                   is_virtual=True)
    ## random-variable-stream.h (module 'core'): uint32_t ns3::ZipfRandomVariable::GetInteger() [member function]
    cls.add_method('GetInteger',
                   'uint32_t',
                   [],
                   is_virtual=True)
    return

def register_Ns3AntennaModel_methods(root_module, cls):
    ## antenna-model.h (module 'antenna'): ns3::AntennaModel::AntennaModel(ns3::AntennaModel const & arg0) [constructor]
    cls.add_constructor([param('ns3::AntennaModel const &', 'arg0')])
    ## antenna-model.h (module 'antenna'): ns3::AntennaModel::AntennaModel() [constructor]
    cls.add_constructor([])
    ## antenna-model.h (module 'antenna'): double ns3::AntennaModel::GetGainDb(ns3::Angles a) [member function]
    cls.add_method('GetGainDb',
                   'double',
                   [param('ns3::Angles', 'a')],
                   is_pure_virtual=True, is_virtual=True)
    ## antenna-model.h (module 'antenna'): static ns3::TypeId ns3::AntennaModel::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    return

def register_Ns3Asn1Header_methods(root_module, cls):
    ## lte-asn1-header.h (module 'lte'): ns3::Asn1Header::Asn1Header(ns3::Asn1Header const & arg0) [constructor]
    cls.add_constructor([param('ns3::Asn1Header const &', 'arg0')])
    ## lte-asn1-header.h (module 'lte'): ns3::Asn1Header::Asn1Header() [constructor]
    cls.add_constructor([])
    ## lte-asn1-header.h (module 'lte'): uint32_t ns3::Asn1Header::Deserialize(ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('Deserialize',
                   'uint32_t',
                   [param('ns3::Buffer::Iterator', 'bIterator')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-asn1-header.h (module 'lte'): ns3::TypeId ns3::Asn1Header::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId',
                   'ns3::TypeId',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-asn1-header.h (module 'lte'): uint32_t ns3::Asn1Header::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize',
                   'uint32_t',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-asn1-header.h (module 'lte'): static ns3::TypeId ns3::Asn1Header::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## lte-asn1-header.h (module 'lte'): void ns3::Asn1Header::PreSerialize() const [member function]
    cls.add_method('PreSerialize',
                   'void',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## lte-asn1-header.h (module 'lte'): void ns3::Asn1Header::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## lte-asn1-header.h (module 'lte'): void ns3::Asn1Header::Serialize(ns3::Buffer::Iterator bIterator) const [member function]
    cls.add_method('Serialize',
                   'void',
                   [param('ns3::Buffer::Iterator', 'bIterator')],
                   is_const=True, is_virtual=True)
    ## lte-asn1-header.h (module 'lte'): ns3::Buffer::Iterator ns3::Asn1Header::DeserializeBitset(std::bitset<8> * data, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeBitset',
                   'ns3::Buffer::Iterator',
                   [param('std::bitset< 8 > *', 'data'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-asn1-header.h (module 'lte'): ns3::Buffer::Iterator ns3::Asn1Header::DeserializeBitstring(std::bitset<1> * bitstring, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeBitstring',
                   'ns3::Buffer::Iterator',
                   [param('std::bitset< 1 > *', 'bitstring'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-asn1-header.h (module 'lte'): ns3::Buffer::Iterator ns3::Asn1Header::DeserializeBitstring(std::bitset<2> * bitstring, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeBitstring',
                   'ns3::Buffer::Iterator',
                   [param('std::bitset< 2 > *', 'bitstring'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-asn1-header.h (module 'lte'): ns3::Buffer::Iterator ns3::Asn1Header::DeserializeBitstring(std::bitset<8> * bitstring, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeBitstring',
                   'ns3::Buffer::Iterator',
                   [param('std::bitset< 8 > *', 'bitstring'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-asn1-header.h (module 'lte'): ns3::Buffer::Iterator ns3::Asn1Header::DeserializeBitstring(std::bitset<10> * bitstring, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeBitstring',
                   'ns3::Buffer::Iterator',
                   [param('std::bitset< 10 > *', 'bitstring'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-asn1-header.h (module 'lte'): ns3::Buffer::Iterator ns3::Asn1Header::DeserializeBitstring(std::bitset<16> * bitstring, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeBitstring',
                   'ns3::Buffer::Iterator',
                   [param('std::bitset< 16 > *', 'bitstring'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-asn1-header.h (module 'lte'): ns3::Buffer::Iterator ns3::Asn1Header::DeserializeBitstring(std::bitset<27> * bitstring, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeBitstring',
                   'ns3::Buffer::Iterator',
                   [param('std::bitset< 27 > *', 'bitstring'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-asn1-header.h (module 'lte'): ns3::Buffer::Iterator ns3::Asn1Header::DeserializeBitstring(std::bitset<28> * bitstring, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeBitstring',
                   'ns3::Buffer::Iterator',
                   [param('std::bitset< 28 > *', 'bitstring'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-asn1-header.h (module 'lte'): ns3::Buffer::Iterator ns3::Asn1Header::DeserializeBitstring(std::bitset<32> * bitstring, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeBitstring',
                   'ns3::Buffer::Iterator',
                   [param('std::bitset< 32 > *', 'bitstring'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-asn1-header.h (module 'lte'): ns3::Buffer::Iterator ns3::Asn1Header::DeserializeBoolean(bool * value, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeBoolean',
                   'ns3::Buffer::Iterator',
                   [param('bool *', 'value'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-asn1-header.h (module 'lte'): ns3::Buffer::Iterator ns3::Asn1Header::DeserializeChoice(int numOptions, bool isExtensionMarkerPresent, int * selectedOption, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeChoice',
                   'ns3::Buffer::Iterator',
                   [param('int', 'numOptions'), param('bool', 'isExtensionMarkerPresent'), param('int *', 'selectedOption'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-asn1-header.h (module 'lte'): ns3::Buffer::Iterator ns3::Asn1Header::DeserializeEnum(int numElems, int * selectedElem, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeEnum',
                   'ns3::Buffer::Iterator',
                   [param('int', 'numElems'), param('int *', 'selectedElem'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-asn1-header.h (module 'lte'): ns3::Buffer::Iterator ns3::Asn1Header::DeserializeInteger(int * n, int nmin, int nmax, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeInteger',
                   'ns3::Buffer::Iterator',
                   [param('int *', 'n'), param('int', 'nmin'), param('int', 'nmax'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-asn1-header.h (module 'lte'): ns3::Buffer::Iterator ns3::Asn1Header::DeserializeNull(ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeNull',
                   'ns3::Buffer::Iterator',
                   [param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-asn1-header.h (module 'lte'): ns3::Buffer::Iterator ns3::Asn1Header::DeserializeSequence(std::bitset<0> * optionalOrDefaultMask, bool isExtensionMarkerPresent, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeSequence',
                   'ns3::Buffer::Iterator',
                   [param('std::bitset< 0 > *', 'optionalOrDefaultMask'), param('bool', 'isExtensionMarkerPresent'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-asn1-header.h (module 'lte'): ns3::Buffer::Iterator ns3::Asn1Header::DeserializeSequence(std::bitset<1> * optionalOrDefaultMask, bool isExtensionMarkerPresent, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeSequence',
                   'ns3::Buffer::Iterator',
                   [param('std::bitset< 1 > *', 'optionalOrDefaultMask'), param('bool', 'isExtensionMarkerPresent'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-asn1-header.h (module 'lte'): ns3::Buffer::Iterator ns3::Asn1Header::DeserializeSequence(std::bitset<2> * optionalOrDefaultMask, bool isExtensionMarkerPresent, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeSequence',
                   'ns3::Buffer::Iterator',
                   [param('std::bitset< 2 > *', 'optionalOrDefaultMask'), param('bool', 'isExtensionMarkerPresent'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-asn1-header.h (module 'lte'): ns3::Buffer::Iterator ns3::Asn1Header::DeserializeSequence(std::bitset<3> * optionalOrDefaultMask, bool isExtensionMarkerPresent, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeSequence',
                   'ns3::Buffer::Iterator',
                   [param('std::bitset< 3 > *', 'optionalOrDefaultMask'), param('bool', 'isExtensionMarkerPresent'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-asn1-header.h (module 'lte'): ns3::Buffer::Iterator ns3::Asn1Header::DeserializeSequence(std::bitset<4> * optionalOrDefaultMask, bool isExtensionMarkerPresent, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeSequence',
                   'ns3::Buffer::Iterator',
                   [param('std::bitset< 4 > *', 'optionalOrDefaultMask'), param('bool', 'isExtensionMarkerPresent'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-asn1-header.h (module 'lte'): ns3::Buffer::Iterator ns3::Asn1Header::DeserializeSequence(std::bitset<5> * optionalOrDefaultMask, bool isExtensionMarkerPresent, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeSequence',
                   'ns3::Buffer::Iterator',
                   [param('std::bitset< 5 > *', 'optionalOrDefaultMask'), param('bool', 'isExtensionMarkerPresent'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-asn1-header.h (module 'lte'): ns3::Buffer::Iterator ns3::Asn1Header::DeserializeSequence(std::bitset<6> * optionalOrDefaultMask, bool isExtensionMarkerPresent, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeSequence',
                   'ns3::Buffer::Iterator',
                   [param('std::bitset< 6 > *', 'optionalOrDefaultMask'), param('bool', 'isExtensionMarkerPresent'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-asn1-header.h (module 'lte'): ns3::Buffer::Iterator ns3::Asn1Header::DeserializeSequence(std::bitset<7> * optionalOrDefaultMask, bool isExtensionMarkerPresent, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeSequence',
                   'ns3::Buffer::Iterator',
                   [param('std::bitset< 7 > *', 'optionalOrDefaultMask'), param('bool', 'isExtensionMarkerPresent'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-asn1-header.h (module 'lte'): ns3::Buffer::Iterator ns3::Asn1Header::DeserializeSequence(std::bitset<9> * optionalOrDefaultMask, bool isExtensionMarkerPresent, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeSequence',
                   'ns3::Buffer::Iterator',
                   [param('std::bitset< 9 > *', 'optionalOrDefaultMask'), param('bool', 'isExtensionMarkerPresent'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-asn1-header.h (module 'lte'): ns3::Buffer::Iterator ns3::Asn1Header::DeserializeSequence(std::bitset<10> * optionalOrDefaultMask, bool isExtensionMarkerPresent, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeSequence',
                   'ns3::Buffer::Iterator',
                   [param('std::bitset< 10 > *', 'optionalOrDefaultMask'), param('bool', 'isExtensionMarkerPresent'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-asn1-header.h (module 'lte'): ns3::Buffer::Iterator ns3::Asn1Header::DeserializeSequence(std::bitset<11> * optionalOrDefaultMask, bool isExtensionMarkerPresent, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeSequence',
                   'ns3::Buffer::Iterator',
                   [param('std::bitset< 11 > *', 'optionalOrDefaultMask'), param('bool', 'isExtensionMarkerPresent'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-asn1-header.h (module 'lte'): ns3::Buffer::Iterator ns3::Asn1Header::DeserializeSequenceOf(int * numElems, int nMax, int nMin, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeSequenceOf',
                   'ns3::Buffer::Iterator',
                   [param('int *', 'numElems'), param('int', 'nMax'), param('int', 'nMin'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-asn1-header.h (module 'lte'): void ns3::Asn1Header::FinalizeSerialization() const [member function]
    cls.add_method('FinalizeSerialization',
                   'void',
                   [],
                   is_const=True, visibility='protected')
    ## lte-asn1-header.h (module 'lte'): void ns3::Asn1Header::SerializeBitstring(std::bitset<1> bitstring) const [member function]
    cls.add_method('SerializeBitstring',
                   'void',
                   [param('std::bitset< 1 >', 'bitstring')],
                   is_const=True, visibility='protected')
    ## lte-asn1-header.h (module 'lte'): void ns3::Asn1Header::SerializeBitstring(std::bitset<2> bitstring) const [member function]
    cls.add_method('SerializeBitstring',
                   'void',
                   [param('std::bitset< 2 >', 'bitstring')],
                   is_const=True, visibility='protected')
    ## lte-asn1-header.h (module 'lte'): void ns3::Asn1Header::SerializeBitstring(std::bitset<8> bitstring) const [member function]
    cls.add_method('SerializeBitstring',
                   'void',
                   [param('std::bitset< 8 >', 'bitstring')],
                   is_const=True, visibility='protected')
    ## lte-asn1-header.h (module 'lte'): void ns3::Asn1Header::SerializeBitstring(std::bitset<10> bitstring) const [member function]
    cls.add_method('SerializeBitstring',
                   'void',
                   [param('std::bitset< 10 >', 'bitstring')],
                   is_const=True, visibility='protected')
    ## lte-asn1-header.h (module 'lte'): void ns3::Asn1Header::SerializeBitstring(std::bitset<16> bitstring) const [member function]
    cls.add_method('SerializeBitstring',
                   'void',
                   [param('std::bitset< 16 >', 'bitstring')],
                   is_const=True, visibility='protected')
    ## lte-asn1-header.h (module 'lte'): void ns3::Asn1Header::SerializeBitstring(std::bitset<27> bitstring) const [member function]
    cls.add_method('SerializeBitstring',
                   'void',
                   [param('std::bitset< 27 >', 'bitstring')],
                   is_const=True, visibility='protected')
    ## lte-asn1-header.h (module 'lte'): void ns3::Asn1Header::SerializeBitstring(std::bitset<28> bitstring) const [member function]
    cls.add_method('SerializeBitstring',
                   'void',
                   [param('std::bitset< 28 >', 'bitstring')],
                   is_const=True, visibility='protected')
    ## lte-asn1-header.h (module 'lte'): void ns3::Asn1Header::SerializeBitstring(std::bitset<32> bitstring) const [member function]
    cls.add_method('SerializeBitstring',
                   'void',
                   [param('std::bitset< 32 >', 'bitstring')],
                   is_const=True, visibility='protected')
    ## lte-asn1-header.h (module 'lte'): void ns3::Asn1Header::SerializeBoolean(bool value) const [member function]
    cls.add_method('SerializeBoolean',
                   'void',
                   [param('bool', 'value')],
                   is_const=True, visibility='protected')
    ## lte-asn1-header.h (module 'lte'): void ns3::Asn1Header::SerializeChoice(int numOptions, int selectedOption, bool isExtensionMarkerPresent) const [member function]
    cls.add_method('SerializeChoice',
                   'void',
                   [param('int', 'numOptions'), param('int', 'selectedOption'), param('bool', 'isExtensionMarkerPresent')],
                   is_const=True, visibility='protected')
    ## lte-asn1-header.h (module 'lte'): void ns3::Asn1Header::SerializeEnum(int numElems, int selectedElem) const [member function]
    cls.add_method('SerializeEnum',
                   'void',
                   [param('int', 'numElems'), param('int', 'selectedElem')],
                   is_const=True, visibility='protected')
    ## lte-asn1-header.h (module 'lte'): void ns3::Asn1Header::SerializeInteger(int n, int nmin, int nmax) const [member function]
    cls.add_method('SerializeInteger',
                   'void',
                   [param('int', 'n'), param('int', 'nmin'), param('int', 'nmax')],
                   is_const=True, visibility='protected')
    ## lte-asn1-header.h (module 'lte'): void ns3::Asn1Header::SerializeNull() const [member function]
    cls.add_method('SerializeNull',
                   'void',
                   [],
                   is_const=True, visibility='protected')
    ## lte-asn1-header.h (module 'lte'): void ns3::Asn1Header::SerializeSequence(std::bitset<0> optionalOrDefaultMask, bool isExtensionMarkerPresent) const [member function]
    cls.add_method('SerializeSequence',
                   'void',
                   [param('std::bitset< 0 >', 'optionalOrDefaultMask'), param('bool', 'isExtensionMarkerPresent')],
                   is_const=True, visibility='protected')
    ## lte-asn1-header.h (module 'lte'): void ns3::Asn1Header::SerializeSequence(std::bitset<1> optionalOrDefaultMask, bool isExtensionMarkerPresent) const [member function]
    cls.add_method('SerializeSequence',
                   'void',
                   [param('std::bitset< 1 >', 'optionalOrDefaultMask'), param('bool', 'isExtensionMarkerPresent')],
                   is_const=True, visibility='protected')
    ## lte-asn1-header.h (module 'lte'): void ns3::Asn1Header::SerializeSequence(std::bitset<2> optionalOrDefaultMask, bool isExtensionMarkerPresent) const [member function]
    cls.add_method('SerializeSequence',
                   'void',
                   [param('std::bitset< 2 >', 'optionalOrDefaultMask'), param('bool', 'isExtensionMarkerPresent')],
                   is_const=True, visibility='protected')
    ## lte-asn1-header.h (module 'lte'): void ns3::Asn1Header::SerializeSequence(std::bitset<3> optionalOrDefaultMask, bool isExtensionMarkerPresent) const [member function]
    cls.add_method('SerializeSequence',
                   'void',
                   [param('std::bitset< 3 >', 'optionalOrDefaultMask'), param('bool', 'isExtensionMarkerPresent')],
                   is_const=True, visibility='protected')
    ## lte-asn1-header.h (module 'lte'): void ns3::Asn1Header::SerializeSequence(std::bitset<4> optionalOrDefaultMask, bool isExtensionMarkerPresent) const [member function]
    cls.add_method('SerializeSequence',
                   'void',
                   [param('std::bitset< 4 >', 'optionalOrDefaultMask'), param('bool', 'isExtensionMarkerPresent')],
                   is_const=True, visibility='protected')
    ## lte-asn1-header.h (module 'lte'): void ns3::Asn1Header::SerializeSequence(std::bitset<5> optionalOrDefaultMask, bool isExtensionMarkerPresent) const [member function]
    cls.add_method('SerializeSequence',
                   'void',
                   [param('std::bitset< 5 >', 'optionalOrDefaultMask'), param('bool', 'isExtensionMarkerPresent')],
                   is_const=True, visibility='protected')
    ## lte-asn1-header.h (module 'lte'): void ns3::Asn1Header::SerializeSequence(std::bitset<6> optionalOrDefaultMask, bool isExtensionMarkerPresent) const [member function]
    cls.add_method('SerializeSequence',
                   'void',
                   [param('std::bitset< 6 >', 'optionalOrDefaultMask'), param('bool', 'isExtensionMarkerPresent')],
                   is_const=True, visibility='protected')
    ## lte-asn1-header.h (module 'lte'): void ns3::Asn1Header::SerializeSequence(std::bitset<7> optionalOrDefaultMask, bool isExtensionMarkerPresent) const [member function]
    cls.add_method('SerializeSequence',
                   'void',
                   [param('std::bitset< 7 >', 'optionalOrDefaultMask'), param('bool', 'isExtensionMarkerPresent')],
                   is_const=True, visibility='protected')
    ## lte-asn1-header.h (module 'lte'): void ns3::Asn1Header::SerializeSequence(std::bitset<9> optionalOrDefaultMask, bool isExtensionMarkerPresent) const [member function]
    cls.add_method('SerializeSequence',
                   'void',
                   [param('std::bitset< 9 >', 'optionalOrDefaultMask'), param('bool', 'isExtensionMarkerPresent')],
                   is_const=True, visibility='protected')
    ## lte-asn1-header.h (module 'lte'): void ns3::Asn1Header::SerializeSequence(std::bitset<10> optionalOrDefaultMask, bool isExtensionMarkerPresent) const [member function]
    cls.add_method('SerializeSequence',
                   'void',
                   [param('std::bitset< 10 >', 'optionalOrDefaultMask'), param('bool', 'isExtensionMarkerPresent')],
                   is_const=True, visibility='protected')
    ## lte-asn1-header.h (module 'lte'): void ns3::Asn1Header::SerializeSequence(std::bitset<11> optionalOrDefaultMask, bool isExtensionMarkerPresent) const [member function]
    cls.add_method('SerializeSequence',
                   'void',
                   [param('std::bitset< 11 >', 'optionalOrDefaultMask'), param('bool', 'isExtensionMarkerPresent')],
                   is_const=True, visibility='protected')
    ## lte-asn1-header.h (module 'lte'): void ns3::Asn1Header::SerializeSequenceOf(int numElems, int nMax, int nMin) const [member function]
    cls.add_method('SerializeSequenceOf',
                   'void',
                   [param('int', 'numElems'), param('int', 'nMax'), param('int', 'nMin')],
                   is_const=True, visibility='protected')
    ## lte-asn1-header.h (module 'lte'): void ns3::Asn1Header::WriteOctet(uint8_t octet) const [member function]
    cls.add_method('WriteOctet',
                   'void',
                   [param('uint8_t', 'octet')],
                   is_const=True, visibility='protected')
    return

def register_Ns3AttributeAccessor_methods(root_module, cls):
    ## attribute.h (module 'core'): ns3::AttributeAccessor::AttributeAccessor(ns3::AttributeAccessor const & arg0) [constructor]
    cls.add_constructor([param('ns3::AttributeAccessor const &', 'arg0')])
    ## attribute.h (module 'core'): ns3::AttributeAccessor::AttributeAccessor() [constructor]
    cls.add_constructor([])
    ## attribute.h (module 'core'): bool ns3::AttributeAccessor::Get(ns3::ObjectBase const * object, ns3::AttributeValue & attribute) const [member function]
    cls.add_method('Get',
                   'bool',
                   [param('ns3::ObjectBase const *', 'object'), param('ns3::AttributeValue &', 'attribute')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## attribute.h (module 'core'): bool ns3::AttributeAccessor::HasGetter() const [member function]
    cls.add_method('HasGetter',
                   'bool',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## attribute.h (module 'core'): bool ns3::AttributeAccessor::HasSetter() const [member function]
    cls.add_method('HasSetter',
                   'bool',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## attribute.h (module 'core'): bool ns3::AttributeAccessor::Set(ns3::ObjectBase * object, ns3::AttributeValue const & value) const [member function]
    cls.add_method('Set',
                   'bool',
                   [param('ns3::ObjectBase *', 'object', transfer_ownership=False), param('ns3::AttributeValue const &', 'value')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    return

def register_Ns3AttributeChecker_methods(root_module, cls):
    ## attribute.h (module 'core'): ns3::AttributeChecker::AttributeChecker(ns3::AttributeChecker const & arg0) [constructor]
    cls.add_constructor([param('ns3::AttributeChecker const &', 'arg0')])
    ## attribute.h (module 'core'): ns3::AttributeChecker::AttributeChecker() [constructor]
    cls.add_constructor([])
    ## attribute.h (module 'core'): bool ns3::AttributeChecker::Check(ns3::AttributeValue const & value) const [member function]
    cls.add_method('Check',
                   'bool',
                   [param('ns3::AttributeValue const &', 'value')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## attribute.h (module 'core'): bool ns3::AttributeChecker::Copy(ns3::AttributeValue const & source, ns3::AttributeValue & destination) const [member function]
    cls.add_method('Copy',
                   'bool',
                   [param('ns3::AttributeValue const &', 'source'), param('ns3::AttributeValue &', 'destination')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## attribute.h (module 'core'): ns3::Ptr<ns3::AttributeValue> ns3::AttributeChecker::Create() const [member function]
    cls.add_method('Create',
                   'ns3::Ptr< ns3::AttributeValue >',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## attribute.h (module 'core'): ns3::Ptr<ns3::AttributeValue> ns3::AttributeChecker::CreateValidValue(ns3::AttributeValue const & value) const [member function]
    cls.add_method('CreateValidValue',
                   'ns3::Ptr< ns3::AttributeValue >',
                   [param('ns3::AttributeValue const &', 'value')],
                   is_const=True)
    ## attribute.h (module 'core'): std::string ns3::AttributeChecker::GetUnderlyingTypeInformation() const [member function]
    cls.add_method('GetUnderlyingTypeInformation',
                   'std::string',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## attribute.h (module 'core'): std::string ns3::AttributeChecker::GetValueTypeName() const [member function]
    cls.add_method('GetValueTypeName',
                   'std::string',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## attribute.h (module 'core'): bool ns3::AttributeChecker::HasUnderlyingTypeInformation() const [member function]
    cls.add_method('HasUnderlyingTypeInformation',
                   'bool',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    return

def register_Ns3AttributeValue_methods(root_module, cls):
    ## attribute.h (module 'core'): ns3::AttributeValue::AttributeValue(ns3::AttributeValue const & arg0) [constructor]
    cls.add_constructor([param('ns3::AttributeValue const &', 'arg0')])
    ## attribute.h (module 'core'): ns3::AttributeValue::AttributeValue() [constructor]
    cls.add_constructor([])
    ## attribute.h (module 'core'): ns3::Ptr<ns3::AttributeValue> ns3::AttributeValue::Copy() const [member function]
    cls.add_method('Copy',
                   'ns3::Ptr< ns3::AttributeValue >',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## attribute.h (module 'core'): bool ns3::AttributeValue::DeserializeFromString(std::string value, ns3::Ptr<const ns3::AttributeChecker> checker) [member function]
    cls.add_method('DeserializeFromString',
                   'bool',
                   [param('std::string', 'value'), param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_pure_virtual=True, is_virtual=True)
    ## attribute.h (module 'core'): std::string ns3::AttributeValue::SerializeToString(ns3::Ptr<const ns3::AttributeChecker> checker) const [member function]
    cls.add_method('SerializeToString',
                   'std::string',
                   [param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    return

def register_Ns3BooleanChecker_methods(root_module, cls):
    ## boolean.h (module 'core'): ns3::BooleanChecker::BooleanChecker() [constructor]
    cls.add_constructor([])
    ## boolean.h (module 'core'): ns3::BooleanChecker::BooleanChecker(ns3::BooleanChecker const & arg0) [constructor]
    cls.add_constructor([param('ns3::BooleanChecker const &', 'arg0')])
    return

def register_Ns3BooleanValue_methods(root_module, cls):
    cls.add_output_stream_operator()
    ## boolean.h (module 'core'): ns3::BooleanValue::BooleanValue(ns3::BooleanValue const & arg0) [constructor]
    cls.add_constructor([param('ns3::BooleanValue const &', 'arg0')])
    ## boolean.h (module 'core'): ns3::BooleanValue::BooleanValue() [constructor]
    cls.add_constructor([])
    ## boolean.h (module 'core'): ns3::BooleanValue::BooleanValue(bool value) [constructor]
    cls.add_constructor([param('bool', 'value')])
    ## boolean.h (module 'core'): ns3::Ptr<ns3::AttributeValue> ns3::BooleanValue::Copy() const [member function]
    cls.add_method('Copy',
                   'ns3::Ptr< ns3::AttributeValue >',
                   [],
                   is_const=True, is_virtual=True)
    ## boolean.h (module 'core'): bool ns3::BooleanValue::DeserializeFromString(std::string value, ns3::Ptr<const ns3::AttributeChecker> checker) [member function]
    cls.add_method('DeserializeFromString',
                   'bool',
                   [param('std::string', 'value'), param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_virtual=True)
    ## boolean.h (module 'core'): bool ns3::BooleanValue::Get() const [member function]
    cls.add_method('Get',
                   'bool',
                   [],
                   is_const=True)
    ## boolean.h (module 'core'): std::string ns3::BooleanValue::SerializeToString(ns3::Ptr<const ns3::AttributeChecker> checker) const [member function]
    cls.add_method('SerializeToString',
                   'std::string',
                   [param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_const=True, is_virtual=True)
    ## boolean.h (module 'core'): void ns3::BooleanValue::Set(bool value) [member function]
    cls.add_method('Set',
                   'void',
                   [param('bool', 'value')])
    return

def register_Ns3BoxChecker_methods(root_module, cls):
    ## box.h (module 'mobility'): ns3::BoxChecker::BoxChecker() [constructor]
    cls.add_constructor([])
    ## box.h (module 'mobility'): ns3::BoxChecker::BoxChecker(ns3::BoxChecker const & arg0) [constructor]
    cls.add_constructor([param('ns3::BoxChecker const &', 'arg0')])
    return

def register_Ns3BoxValue_methods(root_module, cls):
    ## box.h (module 'mobility'): ns3::BoxValue::BoxValue() [constructor]
    cls.add_constructor([])
    ## box.h (module 'mobility'): ns3::BoxValue::BoxValue(ns3::Box const & value) [constructor]
    cls.add_constructor([param('ns3::Box const &', 'value')])
    ## box.h (module 'mobility'): ns3::BoxValue::BoxValue(ns3::BoxValue const & arg0) [constructor]
    cls.add_constructor([param('ns3::BoxValue const &', 'arg0')])
    ## box.h (module 'mobility'): ns3::Ptr<ns3::AttributeValue> ns3::BoxValue::Copy() const [member function]
    cls.add_method('Copy',
                   'ns3::Ptr< ns3::AttributeValue >',
                   [],
                   is_const=True, is_virtual=True)
    ## box.h (module 'mobility'): bool ns3::BoxValue::DeserializeFromString(std::string value, ns3::Ptr<const ns3::AttributeChecker> checker) [member function]
    cls.add_method('DeserializeFromString',
                   'bool',
                   [param('std::string', 'value'), param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_virtual=True)
    ## box.h (module 'mobility'): ns3::Box ns3::BoxValue::Get() const [member function]
    cls.add_method('Get',
                   'ns3::Box',
                   [],
                   is_const=True)
    ## box.h (module 'mobility'): std::string ns3::BoxValue::SerializeToString(ns3::Ptr<const ns3::AttributeChecker> checker) const [member function]
    cls.add_method('SerializeToString',
                   'std::string',
                   [param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_const=True, is_virtual=True)
    ## box.h (module 'mobility'): void ns3::BoxValue::Set(ns3::Box const & value) [member function]
    cls.add_method('Set',
                   'void',
                   [param('ns3::Box const &', 'value')])
    return

def register_Ns3Building_methods(root_module, cls):
    ## building.h (module 'buildings'): ns3::Building::Building(ns3::Building const & arg0) [constructor]
    cls.add_constructor([param('ns3::Building const &', 'arg0')])
    ## building.h (module 'buildings'): ns3::Building::Building(double xMin, double xMax, double yMin, double yMax, double zMin, double zMax) [constructor]
    cls.add_constructor([param('double', 'xMin'), param('double', 'xMax'), param('double', 'yMin'), param('double', 'yMax'), param('double', 'zMin'), param('double', 'zMax')])
    ## building.h (module 'buildings'): ns3::Building::Building() [constructor]
    cls.add_constructor([])
    ## building.h (module 'buildings'): void ns3::Building::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## building.h (module 'buildings'): ns3::Box ns3::Building::GetBoundaries() const [member function]
    cls.add_method('GetBoundaries',
                   'ns3::Box',
                   [],
                   is_const=True)
    ## building.h (module 'buildings'): ns3::Building::BuildingType_t ns3::Building::GetBuildingType() const [member function]
    cls.add_method('GetBuildingType',
                   'ns3::Building::BuildingType_t',
                   [],
                   is_const=True)
    ## building.h (module 'buildings'): ns3::Building::ExtWallsType_t ns3::Building::GetExtWallsType() const [member function]
    cls.add_method('GetExtWallsType',
                   'ns3::Building::ExtWallsType_t',
                   [],
                   is_const=True)
    ## building.h (module 'buildings'): uint16_t ns3::Building::GetFloor(ns3::Vector position) const [member function]
    cls.add_method('GetFloor',
                   'uint16_t',
                   [param('ns3::Vector3D', 'position')],
                   is_const=True)
    ## building.h (module 'buildings'): uint32_t ns3::Building::GetId() const [member function]
    cls.add_method('GetId',
                   'uint32_t',
                   [],
                   is_const=True)
    ## building.h (module 'buildings'): uint16_t ns3::Building::GetNFloors() const [member function]
    cls.add_method('GetNFloors',
                   'uint16_t',
                   [],
                   is_const=True)
    ## building.h (module 'buildings'): uint16_t ns3::Building::GetNRoomsX() const [member function]
    cls.add_method('GetNRoomsX',
                   'uint16_t',
                   [],
                   is_const=True)
    ## building.h (module 'buildings'): uint16_t ns3::Building::GetNRoomsY() const [member function]
    cls.add_method('GetNRoomsY',
                   'uint16_t',
                   [],
                   is_const=True)
    ## building.h (module 'buildings'): uint16_t ns3::Building::GetRoomX(ns3::Vector position) const [member function]
    cls.add_method('GetRoomX',
                   'uint16_t',
                   [param('ns3::Vector3D', 'position')],
                   is_const=True)
    ## building.h (module 'buildings'): uint16_t ns3::Building::GetRoomY(ns3::Vector position) const [member function]
    cls.add_method('GetRoomY',
                   'uint16_t',
                   [param('ns3::Vector3D', 'position')],
                   is_const=True)
    ## building.h (module 'buildings'): static ns3::TypeId ns3::Building::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## building.h (module 'buildings'): bool ns3::Building::IsInside(ns3::Vector position) const [member function]
    cls.add_method('IsInside',
                   'bool',
                   [param('ns3::Vector3D', 'position')],
                   is_const=True)
    ## building.h (module 'buildings'): void ns3::Building::SetBoundaries(ns3::Box box) [member function]
    cls.add_method('SetBoundaries',
                   'void',
                   [param('ns3::Box', 'box')])
    ## building.h (module 'buildings'): void ns3::Building::SetBuildingType(ns3::Building::BuildingType_t t) [member function]
    cls.add_method('SetBuildingType',
                   'void',
                   [param('ns3::Building::BuildingType_t', 't')])
    ## building.h (module 'buildings'): void ns3::Building::SetExtWallsType(ns3::Building::ExtWallsType_t t) [member function]
    cls.add_method('SetExtWallsType',
                   'void',
                   [param('ns3::Building::ExtWallsType_t', 't')])
    ## building.h (module 'buildings'): void ns3::Building::SetNFloors(uint16_t nfloors) [member function]
    cls.add_method('SetNFloors',
                   'void',
                   [param('uint16_t', 'nfloors')])
    ## building.h (module 'buildings'): void ns3::Building::SetNRoomsX(uint16_t nroomx) [member function]
    cls.add_method('SetNRoomsX',
                   'void',
                   [param('uint16_t', 'nroomx')])
    ## building.h (module 'buildings'): void ns3::Building::SetNRoomsY(uint16_t nroomy) [member function]
    cls.add_method('SetNRoomsY',
                   'void',
                   [param('uint16_t', 'nroomy')])
    return

def register_Ns3BuildingsPropagationLossModel_methods(root_module, cls):
    ## buildings-propagation-loss-model.h (module 'buildings'): ns3::BuildingsPropagationLossModel::BuildingsPropagationLossModel() [constructor]
    cls.add_constructor([])
    ## buildings-propagation-loss-model.h (module 'buildings'): double ns3::BuildingsPropagationLossModel::DoCalcRxPower(double txPowerDbm, ns3::Ptr<ns3::MobilityModel> a, ns3::Ptr<ns3::MobilityModel> b) const [member function]
    cls.add_method('DoCalcRxPower',
                   'double',
                   [param('double', 'txPowerDbm'), param('ns3::Ptr< ns3::MobilityModel >', 'a'), param('ns3::Ptr< ns3::MobilityModel >', 'b')],
                   is_const=True, is_virtual=True)
    ## buildings-propagation-loss-model.h (module 'buildings'): double ns3::BuildingsPropagationLossModel::GetLoss(ns3::Ptr<ns3::MobilityModel> a, ns3::Ptr<ns3::MobilityModel> b) const [member function]
    cls.add_method('GetLoss',
                   'double',
                   [param('ns3::Ptr< ns3::MobilityModel >', 'a'), param('ns3::Ptr< ns3::MobilityModel >', 'b')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## buildings-propagation-loss-model.h (module 'buildings'): static ns3::TypeId ns3::BuildingsPropagationLossModel::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## buildings-propagation-loss-model.h (module 'buildings'): int64_t ns3::BuildingsPropagationLossModel::DoAssignStreams(int64_t stream) [member function]
    cls.add_method('DoAssignStreams',
                   'int64_t',
                   [param('int64_t', 'stream')],
                   visibility='protected', is_virtual=True)
    ## buildings-propagation-loss-model.h (module 'buildings'): double ns3::BuildingsPropagationLossModel::EvaluateSigma(ns3::Ptr<ns3::MobilityBuildingInfo> a, ns3::Ptr<ns3::MobilityBuildingInfo> b) const [member function]
    cls.add_method('EvaluateSigma',
                   'double',
                   [param('ns3::Ptr< ns3::MobilityBuildingInfo >', 'a'), param('ns3::Ptr< ns3::MobilityBuildingInfo >', 'b')],
                   is_const=True, visibility='protected')
    ## buildings-propagation-loss-model.h (module 'buildings'): double ns3::BuildingsPropagationLossModel::ExternalWallLoss(ns3::Ptr<ns3::MobilityBuildingInfo> a) const [member function]
    cls.add_method('ExternalWallLoss',
                   'double',
                   [param('ns3::Ptr< ns3::MobilityBuildingInfo >', 'a')],
                   is_const=True, visibility='protected')
    ## buildings-propagation-loss-model.h (module 'buildings'): double ns3::BuildingsPropagationLossModel::GetShadowing(ns3::Ptr<ns3::MobilityModel> a, ns3::Ptr<ns3::MobilityModel> b) const [member function]
    cls.add_method('GetShadowing',
                   'double',
                   [param('ns3::Ptr< ns3::MobilityModel >', 'a'), param('ns3::Ptr< ns3::MobilityModel >', 'b')],
                   is_const=True, visibility='protected')
    ## buildings-propagation-loss-model.h (module 'buildings'): double ns3::BuildingsPropagationLossModel::HeightLoss(ns3::Ptr<ns3::MobilityBuildingInfo> n) const [member function]
    cls.add_method('HeightLoss',
                   'double',
                   [param('ns3::Ptr< ns3::MobilityBuildingInfo >', 'n')],
                   is_const=True, visibility='protected')
    ## buildings-propagation-loss-model.h (module 'buildings'): double ns3::BuildingsPropagationLossModel::InternalWallsLoss(ns3::Ptr<ns3::MobilityBuildingInfo> a, ns3::Ptr<ns3::MobilityBuildingInfo> b) const [member function]
    cls.add_method('InternalWallsLoss',
                   'double',
                   [param('ns3::Ptr< ns3::MobilityBuildingInfo >', 'a'), param('ns3::Ptr< ns3::MobilityBuildingInfo >', 'b')],
                   is_const=True, visibility='protected')
    return

def register_Ns3CallbackChecker_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackChecker::CallbackChecker() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackChecker::CallbackChecker(ns3::CallbackChecker const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackChecker const &', 'arg0')])
    return

def register_Ns3CallbackImplBase_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImplBase::CallbackImplBase() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImplBase::CallbackImplBase(ns3::CallbackImplBase const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImplBase const &', 'arg0')])
    ## callback.h (module 'core'): std::string ns3::CallbackImplBase::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## callback.h (module 'core'): bool ns3::CallbackImplBase::IsEqual(ns3::Ptr<const ns3::CallbackImplBase> other) const [member function]
    cls.add_method('IsEqual',
                   'bool',
                   [param('ns3::Ptr< ns3::CallbackImplBase const >', 'other')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::Demangle(std::string const & mangled) [member function]
    cls.add_method('Demangle',
                   'std::string',
                   [param('std::string const &', 'mangled')],
                   is_static=True, visibility='protected')
    ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
    cls.add_method('GetCppTypeid',
                   'std::string',
                   [],
                   is_static=True, visibility='protected', template_parameters=[u'ns3::ObjectBase*'])
    ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
    cls.add_method('GetCppTypeid',
                   'std::string',
                   [],
                   is_static=True, visibility='protected', template_parameters=[u'void'])
    ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
    cls.add_method('GetCppTypeid',
                   'std::string',
                   [],
                   is_static=True, visibility='protected', template_parameters=[u'unsigned int'])
    ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
    cls.add_method('GetCppTypeid',
                   'std::string',
                   [],
                   is_static=True, visibility='protected', template_parameters=[u'bool'])
    ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
    cls.add_method('GetCppTypeid',
                   'std::string',
                   [],
                   is_static=True, visibility='protected', template_parameters=[u'ns3::Ptr<ns3::NetDevice> '])
    ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
    cls.add_method('GetCppTypeid',
                   'std::string',
                   [],
                   is_static=True, visibility='protected', template_parameters=[u'ns3::Ptr<ns3::Packet const> '])
    ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
    cls.add_method('GetCppTypeid',
                   'std::string',
                   [],
                   is_static=True, visibility='protected', template_parameters=[u'unsigned short'])
    ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
    cls.add_method('GetCppTypeid',
                   'std::string',
                   [],
                   is_static=True, visibility='protected', template_parameters=[u'ns3::Address const&'])
    ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
    cls.add_method('GetCppTypeid',
                   'std::string',
                   [],
                   is_static=True, visibility='protected', template_parameters=[u'ns3::NetDevice::PacketType'])
    ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
    cls.add_method('GetCppTypeid',
                   'std::string',
                   [],
                   is_static=True, visibility='protected', template_parameters=[u'ns3::Ptr<ns3::MobilityModel const> '])
    ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
    cls.add_method('GetCppTypeid',
                   'std::string',
                   [],
                   is_static=True, visibility='protected', template_parameters=[u'ns3::Ptr<ns3::SpectrumPhy const> '])
    ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
    cls.add_method('GetCppTypeid',
                   'std::string',
                   [],
                   is_static=True, visibility='protected', template_parameters=[u'double'])
    ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
    cls.add_method('GetCppTypeid',
                   'std::string',
                   [],
                   is_static=True, visibility='protected', template_parameters=[u'ns3::Ptr<ns3::SpectrumSignalParameters> '])
    ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
    cls.add_method('GetCppTypeid',
                   'std::string',
                   [],
                   is_static=True, visibility='protected', template_parameters=[u'ns3::Ptr<ns3::PacketBurst const> '])
    ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
    cls.add_method('GetCppTypeid',
                   'std::string',
                   [],
                   is_static=True, visibility='protected', template_parameters=[u'ns3::PhyReceptionStatParameters'])
    ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
    cls.add_method('GetCppTypeid',
                   'std::string',
                   [],
                   is_static=True, visibility='protected', template_parameters=[u'ns3::LteUePhy::State'])
    ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
    cls.add_method('GetCppTypeid',
                   'std::string',
                   [],
                   is_static=True, visibility='protected', template_parameters=[u'unsigned char'])
    ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
    cls.add_method('GetCppTypeid',
                   'std::string',
                   [],
                   is_static=True, visibility='protected', template_parameters=[u'ns3::PhyTransmissionStatParameters'])
    ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
    cls.add_method('GetCppTypeid',
                   'std::string',
                   [],
                   is_static=True, visibility='protected', template_parameters=[u'ns3::Ptr<ns3::SpectrumValue> '])
    ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
    cls.add_method('GetCppTypeid',
                   'std::string',
                   [],
                   is_static=True, visibility='protected', template_parameters=[u'unsigned long'])
    ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
    cls.add_method('GetCppTypeid',
                   'std::string',
                   [],
                   is_static=True, visibility='protected', template_parameters=[u'ns3::Time'])
    ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
    cls.add_method('GetCppTypeid',
                   'std::string',
                   [],
                   is_static=True, visibility='protected', template_parameters=[u'ns3::Ptr<ns3::QueueDiscItem const> '])
    ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
    cls.add_method('GetCppTypeid',
                   'std::string',
                   [],
                   is_static=True, visibility='protected', template_parameters=[u'char const*'])
    ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
    cls.add_method('GetCppTypeid',
                   'std::string',
                   [],
                   is_static=True, visibility='protected', template_parameters=[u'ns3::LteUeRrc::State'])
    ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
    cls.add_method('GetCppTypeid',
                   'std::string',
                   [],
                   is_static=True, visibility='protected', template_parameters=[u'ns3::Ptr<ns3::LteUeRrc> '])
    ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
    cls.add_method('GetCppTypeid',
                   'std::string',
                   [],
                   is_static=True, visibility='protected', template_parameters=[u'std::__cxx11::list<ns3::LteRrcSap::SCellToAddMod', u' std::allocator<ns3::LteRrcSap::SCellToAddMod> > '])
    ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
    cls.add_method('GetCppTypeid',
                   'std::string',
                   [],
                   is_static=True, visibility='protected', template_parameters=[u'ns3::EpcUeNas::State'])
    ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
    cls.add_method('GetCppTypeid',
                   'std::string',
                   [],
                   is_static=True, visibility='protected', template_parameters=[u'ns3::Ptr<ns3::Packet> '])
    ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
    cls.add_method('GetCppTypeid',
                   'std::string',
                   [],
                   is_static=True, visibility='protected', template_parameters=[u'ns3::SpectrumValue const&'])
    ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
    cls.add_method('GetCppTypeid',
                   'std::string',
                   [],
                   is_static=True, visibility='protected', template_parameters=[u'ns3::mmwave::RxPacketTraceParams'])
    ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
    cls.add_method('GetCppTypeid',
                   'std::string',
                   [],
                   is_static=True, visibility='protected', template_parameters=[u'ns3::SpectrumValue&'])
    ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
    cls.add_method('GetCppTypeid',
                   'std::string',
                   [],
                   is_static=True, visibility='protected', template_parameters=[u'ns3::UeManager::State'])
    ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
    cls.add_method('GetCppTypeid',
                   'std::string',
                   [],
                   is_static=True, visibility='protected', template_parameters=[u'ns3::LteRrcSap::MeasurementReport'])
    ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
    cls.add_method('GetCppTypeid',
                   'std::string',
                   [],
                   is_static=True, visibility='protected', template_parameters=[u'long double'])
    ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
    cls.add_method('GetCppTypeid',
                   'std::string',
                   [],
                   is_static=True, visibility='protected', template_parameters=[u'ns3::Ptr<ns3::Socket> '])
    ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
    cls.add_method('GetCppTypeid',
                   'std::string',
                   [],
                   is_static=True, visibility='protected', template_parameters=[u'ns3::DlSchedulingCallbackInfo'])
    return

def register_Ns3CallbackValue_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackValue::CallbackValue(ns3::CallbackValue const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackValue const &', 'arg0')])
    ## callback.h (module 'core'): ns3::CallbackValue::CallbackValue() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackValue::CallbackValue(ns3::CallbackBase const & base) [constructor]
    cls.add_constructor([param('ns3::CallbackBase const &', 'base')])
    ## callback.h (module 'core'): ns3::Ptr<ns3::AttributeValue> ns3::CallbackValue::Copy() const [member function]
    cls.add_method('Copy',
                   'ns3::Ptr< ns3::AttributeValue >',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): bool ns3::CallbackValue::DeserializeFromString(std::string value, ns3::Ptr<const ns3::AttributeChecker> checker) [member function]
    cls.add_method('DeserializeFromString',
                   'bool',
                   [param('std::string', 'value'), param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_virtual=True)
    ## callback.h (module 'core'): std::string ns3::CallbackValue::SerializeToString(ns3::Ptr<const ns3::AttributeChecker> checker) const [member function]
    cls.add_method('SerializeToString',
                   'std::string',
                   [param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackValue::Set(ns3::CallbackBase base) [member function]
    cls.add_method('Set',
                   'void',
                   [param('ns3::CallbackBase', 'base')])
    return

def register_Ns3Channel_methods(root_module, cls):
    ## channel.h (module 'network'): ns3::Channel::Channel(ns3::Channel const & arg0) [constructor]
    cls.add_constructor([param('ns3::Channel const &', 'arg0')])
    ## channel.h (module 'network'): ns3::Channel::Channel() [constructor]
    cls.add_constructor([])
    ## channel.h (module 'network'): ns3::Ptr<ns3::NetDevice> ns3::Channel::GetDevice(std::size_t i) const [member function]
    cls.add_method('GetDevice',
                   'ns3::Ptr< ns3::NetDevice >',
                   [param('std::size_t', 'i')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## channel.h (module 'network'): uint32_t ns3::Channel::GetId() const [member function]
    cls.add_method('GetId',
                   'uint32_t',
                   [],
                   is_const=True)
    ## channel.h (module 'network'): std::size_t ns3::Channel::GetNDevices() const [member function]
    cls.add_method('GetNDevices',
                   'std::size_t',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## channel.h (module 'network'): static ns3::TypeId ns3::Channel::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    return

def register_Ns3CoDelQueueDisc_methods(root_module, cls):
    ## codel-queue-disc.h (module 'traffic-control'): static ns3::TypeId ns3::CoDelQueueDisc::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## codel-queue-disc.h (module 'traffic-control'): ns3::CoDelQueueDisc::CoDelQueueDisc() [constructor]
    cls.add_constructor([])
    ## codel-queue-disc.h (module 'traffic-control'): ns3::Time ns3::CoDelQueueDisc::GetTarget() [member function]
    cls.add_method('GetTarget',
                   'ns3::Time',
                   [])
    ## codel-queue-disc.h (module 'traffic-control'): ns3::Time ns3::CoDelQueueDisc::GetInterval() [member function]
    cls.add_method('GetInterval',
                   'ns3::Time',
                   [])
    ## codel-queue-disc.h (module 'traffic-control'): uint32_t ns3::CoDelQueueDisc::GetDropNext() [member function]
    cls.add_method('GetDropNext',
                   'uint32_t',
                   [])
    ## codel-queue-disc.h (module 'traffic-control'): ns3::CoDelQueueDisc::TARGET_EXCEEDED_DROP [variable]
    cls.add_static_attribute('TARGET_EXCEEDED_DROP', 'char const * const', is_const=True)
    ## codel-queue-disc.h (module 'traffic-control'): ns3::CoDelQueueDisc::OVERLIMIT_DROP [variable]
    cls.add_static_attribute('OVERLIMIT_DROP', 'char const * const', is_const=True)
    ## codel-queue-disc.h (module 'traffic-control'): bool ns3::CoDelQueueDisc::DoEnqueue(ns3::Ptr<ns3::QueueDiscItem> item) [member function]
    cls.add_method('DoEnqueue',
                   'bool',
                   [param('ns3::Ptr< ns3::QueueDiscItem >', 'item')],
                   visibility='private', is_virtual=True)
    ## codel-queue-disc.h (module 'traffic-control'): ns3::Ptr<ns3::QueueDiscItem> ns3::CoDelQueueDisc::DoDequeue() [member function]
    cls.add_method('DoDequeue',
                   'ns3::Ptr< ns3::QueueDiscItem >',
                   [],
                   visibility='private', is_virtual=True)
    ## codel-queue-disc.h (module 'traffic-control'): bool ns3::CoDelQueueDisc::CheckConfig() [member function]
    cls.add_method('CheckConfig',
                   'bool',
                   [],
                   visibility='private', is_virtual=True)
    ## codel-queue-disc.h (module 'traffic-control'): void ns3::CoDelQueueDisc::InitializeParams() [member function]
    cls.add_method('InitializeParams',
                   'void',
                   [],
                   visibility='private', is_virtual=True)
    return

def register_Ns3ComponentCarrier_methods(root_module, cls):
    ## component-carrier.h (module 'lte'): ns3::ComponentCarrier::ComponentCarrier(ns3::ComponentCarrier const & arg0) [constructor]
    cls.add_constructor([param('ns3::ComponentCarrier const &', 'arg0')])
    ## component-carrier.h (module 'lte'): ns3::ComponentCarrier::ComponentCarrier() [constructor]
    cls.add_constructor([])
    ## component-carrier.h (module 'lte'): void ns3::ComponentCarrier::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## component-carrier.h (module 'lte'): uint32_t ns3::ComponentCarrier::GetCsgId() const [member function]
    cls.add_method('GetCsgId',
                   'uint32_t',
                   [],
                   is_const=True)
    ## component-carrier.h (module 'lte'): bool ns3::ComponentCarrier::GetCsgIndication() const [member function]
    cls.add_method('GetCsgIndication',
                   'bool',
                   [],
                   is_const=True)
    ## component-carrier.h (module 'lte'): uint8_t ns3::ComponentCarrier::GetDlBandwidth() const [member function]
    cls.add_method('GetDlBandwidth',
                   'uint8_t',
                   [],
                   is_const=True)
    ## component-carrier.h (module 'lte'): uint32_t ns3::ComponentCarrier::GetDlEarfcn() const [member function]
    cls.add_method('GetDlEarfcn',
                   'uint32_t',
                   [],
                   is_const=True)
    ## component-carrier.h (module 'lte'): static ns3::TypeId ns3::ComponentCarrier::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## component-carrier.h (module 'lte'): uint8_t ns3::ComponentCarrier::GetUlBandwidth() const [member function]
    cls.add_method('GetUlBandwidth',
                   'uint8_t',
                   [],
                   is_const=True)
    ## component-carrier.h (module 'lte'): uint32_t ns3::ComponentCarrier::GetUlEarfcn() const [member function]
    cls.add_method('GetUlEarfcn',
                   'uint32_t',
                   [],
                   is_const=True)
    ## component-carrier.h (module 'lte'): bool ns3::ComponentCarrier::IsPrimary() const [member function]
    cls.add_method('IsPrimary',
                   'bool',
                   [],
                   is_const=True)
    ## component-carrier.h (module 'lte'): void ns3::ComponentCarrier::SetAsPrimary(bool primaryCarrier) [member function]
    cls.add_method('SetAsPrimary',
                   'void',
                   [param('bool', 'primaryCarrier')])
    ## component-carrier.h (module 'lte'): void ns3::ComponentCarrier::SetCsgId(uint32_t csgId) [member function]
    cls.add_method('SetCsgId',
                   'void',
                   [param('uint32_t', 'csgId')])
    ## component-carrier.h (module 'lte'): void ns3::ComponentCarrier::SetCsgIndication(bool csgIndication) [member function]
    cls.add_method('SetCsgIndication',
                   'void',
                   [param('bool', 'csgIndication')])
    ## component-carrier.h (module 'lte'): void ns3::ComponentCarrier::SetDlBandwidth(uint8_t bw) [member function]
    cls.add_method('SetDlBandwidth',
                   'void',
                   [param('uint8_t', 'bw')])
    ## component-carrier.h (module 'lte'): void ns3::ComponentCarrier::SetDlEarfcn(uint32_t earfcn) [member function]
    cls.add_method('SetDlEarfcn',
                   'void',
                   [param('uint32_t', 'earfcn')])
    ## component-carrier.h (module 'lte'): void ns3::ComponentCarrier::SetUlBandwidth(uint8_t bw) [member function]
    cls.add_method('SetUlBandwidth',
                   'void',
                   [param('uint8_t', 'bw')])
    ## component-carrier.h (module 'lte'): void ns3::ComponentCarrier::SetUlEarfcn(uint32_t earfcn) [member function]
    cls.add_method('SetUlEarfcn',
                   'void',
                   [param('uint32_t', 'earfcn')])
    ## component-carrier.h (module 'lte'): ns3::ComponentCarrier::m_dlBandwidth [variable]
    cls.add_instance_attribute('m_dlBandwidth', 'uint8_t', is_const=False)
    ## component-carrier.h (module 'lte'): ns3::ComponentCarrier::m_dlEarfcn [variable]
    cls.add_instance_attribute('m_dlEarfcn', 'uint32_t', is_const=False)
    ## component-carrier.h (module 'lte'): ns3::ComponentCarrier::m_ulBandwidth [variable]
    cls.add_instance_attribute('m_ulBandwidth', 'uint8_t', is_const=False)
    ## component-carrier.h (module 'lte'): ns3::ComponentCarrier::m_ulEarfcn [variable]
    cls.add_instance_attribute('m_ulEarfcn', 'uint32_t', is_const=False)
    ## component-carrier.h (module 'lte'): void ns3::ComponentCarrier::DoInitialize() [member function]
    cls.add_method('DoInitialize',
                   'void',
                   [],
                   visibility='protected', is_virtual=True)
    return

def register_Ns3ComponentCarrierEnb_methods(root_module, cls):
    ## component-carrier-enb.h (module 'lte'): ns3::ComponentCarrierEnb::ComponentCarrierEnb(ns3::ComponentCarrierEnb const & arg0) [constructor]
    cls.add_constructor([param('ns3::ComponentCarrierEnb const &', 'arg0')])
    ## component-carrier-enb.h (module 'lte'): ns3::ComponentCarrierEnb::ComponentCarrierEnb() [constructor]
    cls.add_constructor([])
    ## component-carrier-enb.h (module 'lte'): void ns3::ComponentCarrierEnb::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## component-carrier-enb.h (module 'lte'): uint16_t ns3::ComponentCarrierEnb::GetCellId() [member function]
    cls.add_method('GetCellId',
                   'uint16_t',
                   [])
    ## component-carrier-enb.h (module 'lte'): ns3::Ptr<ns3::FfMacScheduler> ns3::ComponentCarrierEnb::GetFfMacScheduler() [member function]
    cls.add_method('GetFfMacScheduler',
                   'ns3::Ptr< ns3::FfMacScheduler >',
                   [])
    ## component-carrier-enb.h (module 'lte'): ns3::Ptr<ns3::LteFfrAlgorithm> ns3::ComponentCarrierEnb::GetFfrAlgorithm() [member function]
    cls.add_method('GetFfrAlgorithm',
                   'ns3::Ptr< ns3::LteFfrAlgorithm >',
                   [])
    ## component-carrier-enb.h (module 'lte'): ns3::Ptr<ns3::LteEnbMac> ns3::ComponentCarrierEnb::GetMac() [member function]
    cls.add_method('GetMac',
                   'ns3::Ptr< ns3::LteEnbMac >',
                   [])
    ## component-carrier-enb.h (module 'lte'): ns3::Ptr<ns3::LteEnbPhy> ns3::ComponentCarrierEnb::GetPhy() [member function]
    cls.add_method('GetPhy',
                   'ns3::Ptr< ns3::LteEnbPhy >',
                   [])
    ## component-carrier-enb.h (module 'lte'): static ns3::TypeId ns3::ComponentCarrierEnb::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## component-carrier-enb.h (module 'lte'): void ns3::ComponentCarrierEnb::SetCellId(uint16_t cellId) [member function]
    cls.add_method('SetCellId',
                   'void',
                   [param('uint16_t', 'cellId')])
    ## component-carrier-enb.h (module 'lte'): void ns3::ComponentCarrierEnb::SetFfMacScheduler(ns3::Ptr<ns3::FfMacScheduler> s) [member function]
    cls.add_method('SetFfMacScheduler',
                   'void',
                   [param('ns3::Ptr< ns3::FfMacScheduler >', 's')])
    ## component-carrier-enb.h (module 'lte'): void ns3::ComponentCarrierEnb::SetFfrAlgorithm(ns3::Ptr<ns3::LteFfrAlgorithm> s) [member function]
    cls.add_method('SetFfrAlgorithm',
                   'void',
                   [param('ns3::Ptr< ns3::LteFfrAlgorithm >', 's')])
    ## component-carrier-enb.h (module 'lte'): void ns3::ComponentCarrierEnb::SetMac(ns3::Ptr<ns3::LteEnbMac> s) [member function]
    cls.add_method('SetMac',
                   'void',
                   [param('ns3::Ptr< ns3::LteEnbMac >', 's')])
    ## component-carrier-enb.h (module 'lte'): void ns3::ComponentCarrierEnb::SetPhy(ns3::Ptr<ns3::LteEnbPhy> s) [member function]
    cls.add_method('SetPhy',
                   'void',
                   [param('ns3::Ptr< ns3::LteEnbPhy >', 's')])
    ## component-carrier-enb.h (module 'lte'): void ns3::ComponentCarrierEnb::DoInitialize() [member function]
    cls.add_method('DoInitialize',
                   'void',
                   [],
                   visibility='protected', is_virtual=True)
    return

def register_Ns3ComponentCarrierUe_methods(root_module, cls):
    ## component-carrier-ue.h (module 'lte'): ns3::ComponentCarrierUe::ComponentCarrierUe(ns3::ComponentCarrierUe const & arg0) [constructor]
    cls.add_constructor([param('ns3::ComponentCarrierUe const &', 'arg0')])
    ## component-carrier-ue.h (module 'lte'): ns3::ComponentCarrierUe::ComponentCarrierUe() [constructor]
    cls.add_constructor([])
    ## component-carrier-ue.h (module 'lte'): void ns3::ComponentCarrierUe::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## component-carrier-ue.h (module 'lte'): ns3::Ptr<ns3::LteUeMac> ns3::ComponentCarrierUe::GetMac() const [member function]
    cls.add_method('GetMac',
                   'ns3::Ptr< ns3::LteUeMac >',
                   [],
                   is_const=True)
    ## component-carrier-ue.h (module 'lte'): ns3::Ptr<ns3::LteUePhy> ns3::ComponentCarrierUe::GetPhy() const [member function]
    cls.add_method('GetPhy',
                   'ns3::Ptr< ns3::LteUePhy >',
                   [],
                   is_const=True)
    ## component-carrier-ue.h (module 'lte'): static ns3::TypeId ns3::ComponentCarrierUe::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## component-carrier-ue.h (module 'lte'): void ns3::ComponentCarrierUe::SetMac(ns3::Ptr<ns3::LteUeMac> s) [member function]
    cls.add_method('SetMac',
                   'void',
                   [param('ns3::Ptr< ns3::LteUeMac >', 's')])
    ## component-carrier-ue.h (module 'lte'): void ns3::ComponentCarrierUe::SetPhy(ns3::Ptr<ns3::LteUePhy> s) [member function]
    cls.add_method('SetPhy',
                   'void',
                   [param('ns3::Ptr< ns3::LteUePhy >', 's')])
    ## component-carrier-ue.h (module 'lte'): void ns3::ComponentCarrierUe::DoInitialize() [member function]
    cls.add_method('DoInitialize',
                   'void',
                   [],
                   visibility='protected', is_virtual=True)
    return

def register_Ns3ConstantRandomVariable_methods(root_module, cls):
    ## random-variable-stream.h (module 'core'): static ns3::TypeId ns3::ConstantRandomVariable::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## random-variable-stream.h (module 'core'): ns3::ConstantRandomVariable::ConstantRandomVariable() [constructor]
    cls.add_constructor([])
    ## random-variable-stream.h (module 'core'): double ns3::ConstantRandomVariable::GetConstant() const [member function]
    cls.add_method('GetConstant',
                   'double',
                   [],
                   is_const=True)
    ## random-variable-stream.h (module 'core'): double ns3::ConstantRandomVariable::GetValue(double constant) [member function]
    cls.add_method('GetValue',
                   'double',
                   [param('double', 'constant')])
    ## random-variable-stream.h (module 'core'): uint32_t ns3::ConstantRandomVariable::GetInteger(uint32_t constant) [member function]
    cls.add_method('GetInteger',
                   'uint32_t',
                   [param('uint32_t', 'constant')])
    ## random-variable-stream.h (module 'core'): double ns3::ConstantRandomVariable::GetValue() [member function]
    cls.add_method('GetValue',
                   'double',
                   [],
                   is_virtual=True)
    ## random-variable-stream.h (module 'core'): uint32_t ns3::ConstantRandomVariable::GetInteger() [member function]
    cls.add_method('GetInteger',
                   'uint32_t',
                   [],
                   is_virtual=True)
    return

def register_Ns3ConstantSpeedPropagationDelayModel_methods(root_module, cls):
    ## propagation-delay-model.h (module 'propagation'): ns3::ConstantSpeedPropagationDelayModel::ConstantSpeedPropagationDelayModel(ns3::ConstantSpeedPropagationDelayModel const & arg0) [constructor]
    cls.add_constructor([param('ns3::ConstantSpeedPropagationDelayModel const &', 'arg0')])
    ## propagation-delay-model.h (module 'propagation'): ns3::ConstantSpeedPropagationDelayModel::ConstantSpeedPropagationDelayModel() [constructor]
    cls.add_constructor([])
    ## propagation-delay-model.h (module 'propagation'): ns3::Time ns3::ConstantSpeedPropagationDelayModel::GetDelay(ns3::Ptr<ns3::MobilityModel> a, ns3::Ptr<ns3::MobilityModel> b) const [member function]
    cls.add_method('GetDelay',
                   'ns3::Time',
                   [param('ns3::Ptr< ns3::MobilityModel >', 'a'), param('ns3::Ptr< ns3::MobilityModel >', 'b')],
                   is_const=True, is_virtual=True)
    ## propagation-delay-model.h (module 'propagation'): double ns3::ConstantSpeedPropagationDelayModel::GetSpeed() const [member function]
    cls.add_method('GetSpeed',
                   'double',
                   [],
                   is_const=True)
    ## propagation-delay-model.h (module 'propagation'): static ns3::TypeId ns3::ConstantSpeedPropagationDelayModel::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## propagation-delay-model.h (module 'propagation'): void ns3::ConstantSpeedPropagationDelayModel::SetSpeed(double speed) [member function]
    cls.add_method('SetSpeed',
                   'void',
                   [param('double', 'speed')])
    ## propagation-delay-model.h (module 'propagation'): int64_t ns3::ConstantSpeedPropagationDelayModel::DoAssignStreams(int64_t stream) [member function]
    cls.add_method('DoAssignStreams',
                   'int64_t',
                   [param('int64_t', 'stream')],
                   visibility='private', is_virtual=True)
    return

def register_Ns3DataCalculator_methods(root_module, cls):
    ## data-calculator.h (module 'stats'): ns3::DataCalculator::DataCalculator(ns3::DataCalculator const & arg0) [constructor]
    cls.add_constructor([param('ns3::DataCalculator const &', 'arg0')])
    ## data-calculator.h (module 'stats'): ns3::DataCalculator::DataCalculator() [constructor]
    cls.add_constructor([])
    ## data-calculator.h (module 'stats'): void ns3::DataCalculator::Disable() [member function]
    cls.add_method('Disable',
                   'void',
                   [])
    ## data-calculator.h (module 'stats'): void ns3::DataCalculator::Enable() [member function]
    cls.add_method('Enable',
                   'void',
                   [])
    ## data-calculator.h (module 'stats'): std::string ns3::DataCalculator::GetContext() const [member function]
    cls.add_method('GetContext',
                   'std::string',
                   [],
                   is_const=True)
    ## data-calculator.h (module 'stats'): bool ns3::DataCalculator::GetEnabled() const [member function]
    cls.add_method('GetEnabled',
                   'bool',
                   [],
                   is_const=True)
    ## data-calculator.h (module 'stats'): std::string ns3::DataCalculator::GetKey() const [member function]
    cls.add_method('GetKey',
                   'std::string',
                   [],
                   is_const=True)
    ## data-calculator.h (module 'stats'): static ns3::TypeId ns3::DataCalculator::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## data-calculator.h (module 'stats'): void ns3::DataCalculator::Output(ns3::DataOutputCallback & callback) const [member function]
    cls.add_method('Output',
                   'void',
                   [param('ns3::DataOutputCallback &', 'callback')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## data-calculator.h (module 'stats'): void ns3::DataCalculator::SetContext(std::string const context) [member function]
    cls.add_method('SetContext',
                   'void',
                   [param('std::string const', 'context')])
    ## data-calculator.h (module 'stats'): void ns3::DataCalculator::SetKey(std::string const key) [member function]
    cls.add_method('SetKey',
                   'void',
                   [param('std::string const', 'key')])
    ## data-calculator.h (module 'stats'): void ns3::DataCalculator::Start(ns3::Time const & startTime) [member function]
    cls.add_method('Start',
                   'void',
                   [param('ns3::Time const &', 'startTime')],
                   is_virtual=True)
    ## data-calculator.h (module 'stats'): void ns3::DataCalculator::Stop(ns3::Time const & stopTime) [member function]
    cls.add_method('Stop',
                   'void',
                   [param('ns3::Time const &', 'stopTime')],
                   is_virtual=True)
    ## data-calculator.h (module 'stats'): void ns3::DataCalculator::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   visibility='protected', is_virtual=True)
    return

def register_Ns3DataOutputInterface_methods(root_module, cls):
    ## data-output-interface.h (module 'stats'): ns3::DataOutputInterface::DataOutputInterface(ns3::DataOutputInterface const & arg0) [constructor]
    cls.add_constructor([param('ns3::DataOutputInterface const &', 'arg0')])
    ## data-output-interface.h (module 'stats'): ns3::DataOutputInterface::DataOutputInterface() [constructor]
    cls.add_constructor([])
    ## data-output-interface.h (module 'stats'): std::string ns3::DataOutputInterface::GetFilePrefix() const [member function]
    cls.add_method('GetFilePrefix',
                   'std::string',
                   [],
                   is_const=True)
    ## data-output-interface.h (module 'stats'): static ns3::TypeId ns3::DataOutputInterface::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## data-output-interface.h (module 'stats'): void ns3::DataOutputInterface::Output(ns3::DataCollector & dc) [member function]
    cls.add_method('Output',
                   'void',
                   [param('ns3::DataCollector &', 'dc')],
                   is_pure_virtual=True, is_virtual=True)
    ## data-output-interface.h (module 'stats'): void ns3::DataOutputInterface::SetFilePrefix(std::string const prefix) [member function]
    cls.add_method('SetFilePrefix',
                   'void',
                   [param('std::string const', 'prefix')])
    ## data-output-interface.h (module 'stats'): void ns3::DataOutputInterface::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   visibility='protected', is_virtual=True)
    return

def register_Ns3DataRateChecker_methods(root_module, cls):
    ## data-rate.h (module 'network'): ns3::DataRateChecker::DataRateChecker() [constructor]
    cls.add_constructor([])
    ## data-rate.h (module 'network'): ns3::DataRateChecker::DataRateChecker(ns3::DataRateChecker const & arg0) [constructor]
    cls.add_constructor([param('ns3::DataRateChecker const &', 'arg0')])
    return

def register_Ns3DataRateValue_methods(root_module, cls):
    ## data-rate.h (module 'network'): ns3::DataRateValue::DataRateValue() [constructor]
    cls.add_constructor([])
    ## data-rate.h (module 'network'): ns3::DataRateValue::DataRateValue(ns3::DataRate const & value) [constructor]
    cls.add_constructor([param('ns3::DataRate const &', 'value')])
    ## data-rate.h (module 'network'): ns3::DataRateValue::DataRateValue(ns3::DataRateValue const & arg0) [constructor]
    cls.add_constructor([param('ns3::DataRateValue const &', 'arg0')])
    ## data-rate.h (module 'network'): ns3::Ptr<ns3::AttributeValue> ns3::DataRateValue::Copy() const [member function]
    cls.add_method('Copy',
                   'ns3::Ptr< ns3::AttributeValue >',
                   [],
                   is_const=True, is_virtual=True)
    ## data-rate.h (module 'network'): bool ns3::DataRateValue::DeserializeFromString(std::string value, ns3::Ptr<const ns3::AttributeChecker> checker) [member function]
    cls.add_method('DeserializeFromString',
                   'bool',
                   [param('std::string', 'value'), param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_virtual=True)
    ## data-rate.h (module 'network'): ns3::DataRate ns3::DataRateValue::Get() const [member function]
    cls.add_method('Get',
                   'ns3::DataRate',
                   [],
                   is_const=True)
    ## data-rate.h (module 'network'): std::string ns3::DataRateValue::SerializeToString(ns3::Ptr<const ns3::AttributeChecker> checker) const [member function]
    cls.add_method('SerializeToString',
                   'std::string',
                   [param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_const=True, is_virtual=True)
    ## data-rate.h (module 'network'): void ns3::DataRateValue::Set(ns3::DataRate const & value) [member function]
    cls.add_method('Set',
                   'void',
                   [param('ns3::DataRate const &', 'value')])
    return

def register_Ns3DeterministicRandomVariable_methods(root_module, cls):
    ## random-variable-stream.h (module 'core'): static ns3::TypeId ns3::DeterministicRandomVariable::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## random-variable-stream.h (module 'core'): ns3::DeterministicRandomVariable::DeterministicRandomVariable() [constructor]
    cls.add_constructor([])
    ## random-variable-stream.h (module 'core'): void ns3::DeterministicRandomVariable::SetValueArray(double * values, std::size_t length) [member function]
    cls.add_method('SetValueArray',
                   'void',
                   [param('double *', 'values'), param('std::size_t', 'length')])
    ## random-variable-stream.h (module 'core'): double ns3::DeterministicRandomVariable::GetValue() [member function]
    cls.add_method('GetValue',
                   'double',
                   [],
                   is_virtual=True)
    ## random-variable-stream.h (module 'core'): uint32_t ns3::DeterministicRandomVariable::GetInteger() [member function]
    cls.add_method('GetInteger',
                   'uint32_t',
                   [],
                   is_virtual=True)
    return

def register_Ns3DoubleValue_methods(root_module, cls):
    ## double.h (module 'core'): ns3::DoubleValue::DoubleValue() [constructor]
    cls.add_constructor([])
    ## double.h (module 'core'): ns3::DoubleValue::DoubleValue(double const & value) [constructor]
    cls.add_constructor([param('double const &', 'value')])
    ## double.h (module 'core'): ns3::DoubleValue::DoubleValue(ns3::DoubleValue const & arg0) [constructor]
    cls.add_constructor([param('ns3::DoubleValue const &', 'arg0')])
    ## double.h (module 'core'): ns3::Ptr<ns3::AttributeValue> ns3::DoubleValue::Copy() const [member function]
    cls.add_method('Copy',
                   'ns3::Ptr< ns3::AttributeValue >',
                   [],
                   is_const=True, is_virtual=True)
    ## double.h (module 'core'): bool ns3::DoubleValue::DeserializeFromString(std::string value, ns3::Ptr<const ns3::AttributeChecker> checker) [member function]
    cls.add_method('DeserializeFromString',
                   'bool',
                   [param('std::string', 'value'), param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_virtual=True)
    ## double.h (module 'core'): double ns3::DoubleValue::Get() const [member function]
    cls.add_method('Get',
                   'double',
                   [],
                   is_const=True)
    ## double.h (module 'core'): std::string ns3::DoubleValue::SerializeToString(ns3::Ptr<const ns3::AttributeChecker> checker) const [member function]
    cls.add_method('SerializeToString',
                   'std::string',
                   [param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_const=True, is_virtual=True)
    ## double.h (module 'core'): void ns3::DoubleValue::Set(double const & value) [member function]
    cls.add_method('Set',
                   'void',
                   [param('double const &', 'value')])
    return

def register_Ns3EmpiricalRandomVariable_methods(root_module, cls):
    ## random-variable-stream.h (module 'core'): ns3::EmpiricalRandomVariable::EmpiricalRandomVariable() [constructor]
    cls.add_constructor([])
    ## random-variable-stream.h (module 'core'): void ns3::EmpiricalRandomVariable::CDF(double v, double c) [member function]
    cls.add_method('CDF',
                   'void',
                   [param('double', 'v'), param('double', 'c')])
    ## random-variable-stream.h (module 'core'): uint32_t ns3::EmpiricalRandomVariable::GetInteger() [member function]
    cls.add_method('GetInteger',
                   'uint32_t',
                   [],
                   is_virtual=True)
    ## random-variable-stream.h (module 'core'): static ns3::TypeId ns3::EmpiricalRandomVariable::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## random-variable-stream.h (module 'core'): double ns3::EmpiricalRandomVariable::GetValue() [member function]
    cls.add_method('GetValue',
                   'double',
                   [],
                   is_virtual=True)
    ## random-variable-stream.h (module 'core'): double ns3::EmpiricalRandomVariable::Interpolate(double c1, double c2, double v1, double v2, double r) [member function]
    cls.add_method('Interpolate',
                   'double',
                   [param('double', 'c1'), param('double', 'c2'), param('double', 'v1'), param('double', 'v2'), param('double', 'r')],
                   visibility='private', is_virtual=True)
    ## random-variable-stream.h (module 'core'): void ns3::EmpiricalRandomVariable::Validate() [member function]
    cls.add_method('Validate',
                   'void',
                   [],
                   visibility='private', is_virtual=True)
    return

def register_Ns3EmptyAttributeAccessor_methods(root_module, cls):
    ## attribute.h (module 'core'): ns3::EmptyAttributeAccessor::EmptyAttributeAccessor(ns3::EmptyAttributeAccessor const & arg0) [constructor]
    cls.add_constructor([param('ns3::EmptyAttributeAccessor const &', 'arg0')])
    ## attribute.h (module 'core'): ns3::EmptyAttributeAccessor::EmptyAttributeAccessor() [constructor]
    cls.add_constructor([])
    ## attribute.h (module 'core'): bool ns3::EmptyAttributeAccessor::Get(ns3::ObjectBase const * object, ns3::AttributeValue & attribute) const [member function]
    cls.add_method('Get',
                   'bool',
                   [param('ns3::ObjectBase const *', 'object'), param('ns3::AttributeValue &', 'attribute')],
                   is_const=True, is_virtual=True)
    ## attribute.h (module 'core'): bool ns3::EmptyAttributeAccessor::HasGetter() const [member function]
    cls.add_method('HasGetter',
                   'bool',
                   [],
                   is_const=True, is_virtual=True)
    ## attribute.h (module 'core'): bool ns3::EmptyAttributeAccessor::HasSetter() const [member function]
    cls.add_method('HasSetter',
                   'bool',
                   [],
                   is_const=True, is_virtual=True)
    ## attribute.h (module 'core'): bool ns3::EmptyAttributeAccessor::Set(ns3::ObjectBase * object, ns3::AttributeValue const & value) const [member function]
    cls.add_method('Set',
                   'bool',
                   [param('ns3::ObjectBase *', 'object'), param('ns3::AttributeValue const &', 'value')],
                   is_const=True, is_virtual=True)
    return

def register_Ns3EmptyAttributeChecker_methods(root_module, cls):
    ## attribute.h (module 'core'): ns3::EmptyAttributeChecker::EmptyAttributeChecker(ns3::EmptyAttributeChecker const & arg0) [constructor]
    cls.add_constructor([param('ns3::EmptyAttributeChecker const &', 'arg0')])
    ## attribute.h (module 'core'): ns3::EmptyAttributeChecker::EmptyAttributeChecker() [constructor]
    cls.add_constructor([])
    ## attribute.h (module 'core'): bool ns3::EmptyAttributeChecker::Check(ns3::AttributeValue const & value) const [member function]
    cls.add_method('Check',
                   'bool',
                   [param('ns3::AttributeValue const &', 'value')],
                   is_const=True, is_virtual=True)
    ## attribute.h (module 'core'): bool ns3::EmptyAttributeChecker::Copy(ns3::AttributeValue const & source, ns3::AttributeValue & destination) const [member function]
    cls.add_method('Copy',
                   'bool',
                   [param('ns3::AttributeValue const &', 'source'), param('ns3::AttributeValue &', 'destination')],
                   is_const=True, is_virtual=True)
    ## attribute.h (module 'core'): ns3::Ptr<ns3::AttributeValue> ns3::EmptyAttributeChecker::Create() const [member function]
    cls.add_method('Create',
                   'ns3::Ptr< ns3::AttributeValue >',
                   [],
                   is_const=True, is_virtual=True)
    ## attribute.h (module 'core'): std::string ns3::EmptyAttributeChecker::GetUnderlyingTypeInformation() const [member function]
    cls.add_method('GetUnderlyingTypeInformation',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## attribute.h (module 'core'): std::string ns3::EmptyAttributeChecker::GetValueTypeName() const [member function]
    cls.add_method('GetValueTypeName',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## attribute.h (module 'core'): bool ns3::EmptyAttributeChecker::HasUnderlyingTypeInformation() const [member function]
    cls.add_method('HasUnderlyingTypeInformation',
                   'bool',
                   [],
                   is_const=True, is_virtual=True)
    return

def register_Ns3EmptyAttributeValue_methods(root_module, cls):
    ## attribute.h (module 'core'): ns3::EmptyAttributeValue::EmptyAttributeValue(ns3::EmptyAttributeValue const & arg0) [constructor]
    cls.add_constructor([param('ns3::EmptyAttributeValue const &', 'arg0')])
    ## attribute.h (module 'core'): ns3::EmptyAttributeValue::EmptyAttributeValue() [constructor]
    cls.add_constructor([])
    ## attribute.h (module 'core'): ns3::Ptr<ns3::AttributeValue> ns3::EmptyAttributeValue::Copy() const [member function]
    cls.add_method('Copy',
                   'ns3::Ptr< ns3::AttributeValue >',
                   [],
                   is_const=True, visibility='private', is_virtual=True)
    ## attribute.h (module 'core'): bool ns3::EmptyAttributeValue::DeserializeFromString(std::string value, ns3::Ptr<const ns3::AttributeChecker> checker) [member function]
    cls.add_method('DeserializeFromString',
                   'bool',
                   [param('std::string', 'value'), param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   visibility='private', is_virtual=True)
    ## attribute.h (module 'core'): std::string ns3::EmptyAttributeValue::SerializeToString(ns3::Ptr<const ns3::AttributeChecker> checker) const [member function]
    cls.add_method('SerializeToString',
                   'std::string',
                   [param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_const=True, visibility='private', is_virtual=True)
    return

def register_Ns3EnumChecker_methods(root_module, cls):
    ## enum.h (module 'core'): ns3::EnumChecker::EnumChecker(ns3::EnumChecker const & arg0) [constructor]
    cls.add_constructor([param('ns3::EnumChecker const &', 'arg0')])
    ## enum.h (module 'core'): ns3::EnumChecker::EnumChecker() [constructor]
    cls.add_constructor([])
    ## enum.h (module 'core'): void ns3::EnumChecker::Add(int value, std::string name) [member function]
    cls.add_method('Add',
                   'void',
                   [param('int', 'value'), param('std::string', 'name')])
    ## enum.h (module 'core'): void ns3::EnumChecker::AddDefault(int value, std::string name) [member function]
    cls.add_method('AddDefault',
                   'void',
                   [param('int', 'value'), param('std::string', 'name')])
    ## enum.h (module 'core'): bool ns3::EnumChecker::Check(ns3::AttributeValue const & value) const [member function]
    cls.add_method('Check',
                   'bool',
                   [param('ns3::AttributeValue const &', 'value')],
                   is_const=True, is_virtual=True)
    ## enum.h (module 'core'): bool ns3::EnumChecker::Copy(ns3::AttributeValue const & src, ns3::AttributeValue & dst) const [member function]
    cls.add_method('Copy',
                   'bool',
                   [param('ns3::AttributeValue const &', 'src'), param('ns3::AttributeValue &', 'dst')],
                   is_const=True, is_virtual=True)
    ## enum.h (module 'core'): ns3::Ptr<ns3::AttributeValue> ns3::EnumChecker::Create() const [member function]
    cls.add_method('Create',
                   'ns3::Ptr< ns3::AttributeValue >',
                   [],
                   is_const=True, is_virtual=True)
    ## enum.h (module 'core'): std::string ns3::EnumChecker::GetUnderlyingTypeInformation() const [member function]
    cls.add_method('GetUnderlyingTypeInformation',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## enum.h (module 'core'): std::string ns3::EnumChecker::GetValueTypeName() const [member function]
    cls.add_method('GetValueTypeName',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## enum.h (module 'core'): bool ns3::EnumChecker::HasUnderlyingTypeInformation() const [member function]
    cls.add_method('HasUnderlyingTypeInformation',
                   'bool',
                   [],
                   is_const=True, is_virtual=True)
    return

def register_Ns3EnumValue_methods(root_module, cls):
    ## enum.h (module 'core'): ns3::EnumValue::EnumValue(ns3::EnumValue const & arg0) [constructor]
    cls.add_constructor([param('ns3::EnumValue const &', 'arg0')])
    ## enum.h (module 'core'): ns3::EnumValue::EnumValue() [constructor]
    cls.add_constructor([])
    ## enum.h (module 'core'): ns3::EnumValue::EnumValue(int value) [constructor]
    cls.add_constructor([param('int', 'value')])
    ## enum.h (module 'core'): ns3::Ptr<ns3::AttributeValue> ns3::EnumValue::Copy() const [member function]
    cls.add_method('Copy',
                   'ns3::Ptr< ns3::AttributeValue >',
                   [],
                   is_const=True, is_virtual=True)
    ## enum.h (module 'core'): bool ns3::EnumValue::DeserializeFromString(std::string value, ns3::Ptr<const ns3::AttributeChecker> checker) [member function]
    cls.add_method('DeserializeFromString',
                   'bool',
                   [param('std::string', 'value'), param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_virtual=True)
    ## enum.h (module 'core'): int ns3::EnumValue::Get() const [member function]
    cls.add_method('Get',
                   'int',
                   [],
                   is_const=True)
    ## enum.h (module 'core'): std::string ns3::EnumValue::SerializeToString(ns3::Ptr<const ns3::AttributeChecker> checker) const [member function]
    cls.add_method('SerializeToString',
                   'std::string',
                   [param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_const=True, is_virtual=True)
    ## enum.h (module 'core'): void ns3::EnumValue::Set(int value) [member function]
    cls.add_method('Set',
                   'void',
                   [param('int', 'value')])
    return

def register_Ns3EpcHelper_methods(root_module, cls):
    ## epc-helper.h (module 'lte'): ns3::EpcHelper::EpcHelper(ns3::EpcHelper const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcHelper const &', 'arg0')])
    ## epc-helper.h (module 'lte'): ns3::EpcHelper::EpcHelper() [constructor]
    cls.add_constructor([])
    ## epc-helper.h (module 'lte'): uint8_t ns3::EpcHelper::ActivateEpsBearer(ns3::Ptr<ns3::NetDevice> ueLteDevice, uint64_t imsi, ns3::Ptr<ns3::EpcTft> tft, ns3::EpsBearer bearer) [member function]
    cls.add_method('ActivateEpsBearer',
                   'uint8_t',
                   [param('ns3::Ptr< ns3::NetDevice >', 'ueLteDevice'), param('uint64_t', 'imsi'), param('ns3::Ptr< ns3::EpcTft >', 'tft'), param('ns3::EpsBearer', 'bearer')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-helper.h (module 'lte'): uint8_t ns3::EpcHelper::ActivateEpsBearer(ns3::Ptr<ns3::NetDevice> ueLteDevice, ns3::Ptr<ns3::EpcUeNas> ueNas, uint64_t imsi, ns3::Ptr<ns3::EpcTft> tft, ns3::EpsBearer bearer) [member function]
    cls.add_method('ActivateEpsBearer',
                   'uint8_t',
                   [param('ns3::Ptr< ns3::NetDevice >', 'ueLteDevice'), param('ns3::Ptr< ns3::EpcUeNas >', 'ueNas'), param('uint64_t', 'imsi'), param('ns3::Ptr< ns3::EpcTft >', 'tft'), param('ns3::EpsBearer', 'bearer')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-helper.h (module 'lte'): void ns3::EpcHelper::AddEnb(ns3::Ptr<ns3::Node> enbNode, ns3::Ptr<ns3::NetDevice> lteEnbNetDevice, uint16_t cellId) [member function]
    cls.add_method('AddEnb',
                   'void',
                   [param('ns3::Ptr< ns3::Node >', 'enbNode'), param('ns3::Ptr< ns3::NetDevice >', 'lteEnbNetDevice'), param('uint16_t', 'cellId')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-helper.h (module 'lte'): void ns3::EpcHelper::AddUe(ns3::Ptr<ns3::NetDevice> ueLteDevice, uint64_t imsi) [member function]
    cls.add_method('AddUe',
                   'void',
                   [param('ns3::Ptr< ns3::NetDevice >', 'ueLteDevice'), param('uint64_t', 'imsi')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-helper.h (module 'lte'): void ns3::EpcHelper::AddX2Interface(ns3::Ptr<ns3::Node> enbNode1, ns3::Ptr<ns3::Node> enbNode2) [member function]
    cls.add_method('AddX2Interface',
                   'void',
                   [param('ns3::Ptr< ns3::Node >', 'enbNode1'), param('ns3::Ptr< ns3::Node >', 'enbNode2')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-helper.h (module 'lte'): ns3::Ipv4InterfaceContainer ns3::EpcHelper::AssignUeIpv4Address(ns3::NetDeviceContainer ueDevices) [member function]
    cls.add_method('AssignUeIpv4Address',
                   'ns3::Ipv4InterfaceContainer',
                   [param('ns3::NetDeviceContainer', 'ueDevices')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-helper.h (module 'lte'): ns3::Ipv6InterfaceContainer ns3::EpcHelper::AssignUeIpv6Address(ns3::NetDeviceContainer ueDevices) [member function]
    cls.add_method('AssignUeIpv6Address',
                   'ns3::Ipv6InterfaceContainer',
                   [param('ns3::NetDeviceContainer', 'ueDevices')],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-helper.h (module 'lte'): void ns3::EpcHelper::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## epc-helper.h (module 'lte'): ns3::Ptr<ns3::Node> ns3::EpcHelper::GetPgwNode() [member function]
    cls.add_method('GetPgwNode',
                   'ns3::Ptr< ns3::Node >',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-helper.h (module 'lte'): static ns3::TypeId ns3::EpcHelper::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## epc-helper.h (module 'lte'): ns3::Ipv4Address ns3::EpcHelper::GetUeDefaultGatewayAddress() [member function]
    cls.add_method('GetUeDefaultGatewayAddress',
                   'ns3::Ipv4Address',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## epc-helper.h (module 'lte'): ns3::Ipv6Address ns3::EpcHelper::GetUeDefaultGatewayAddress6() [member function]
    cls.add_method('GetUeDefaultGatewayAddress6',
                   'ns3::Ipv6Address',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3EpcTft_methods(root_module, cls):
    ## epc-tft.h (module 'lte'): ns3::EpcTft::EpcTft(ns3::EpcTft const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcTft const &', 'arg0')])
    ## epc-tft.h (module 'lte'): ns3::EpcTft::EpcTft() [constructor]
    cls.add_constructor([])
    ## epc-tft.h (module 'lte'): uint8_t ns3::EpcTft::Add(ns3::EpcTft::PacketFilter f) [member function]
    cls.add_method('Add',
                   'uint8_t',
                   [param('ns3::EpcTft::PacketFilter', 'f')])
    ## epc-tft.h (module 'lte'): static ns3::Ptr<ns3::EpcTft> ns3::EpcTft::Default() [member function]
    cls.add_method('Default',
                   'ns3::Ptr< ns3::EpcTft >',
                   [],
                   is_static=True)
    ## epc-tft.h (module 'lte'): bool ns3::EpcTft::Matches(ns3::EpcTft::Direction direction, ns3::Ipv4Address remoteAddress, ns3::Ipv4Address localAddress, uint16_t remotePort, uint16_t localPort, uint8_t typeOfService) [member function]
    cls.add_method('Matches',
                   'bool',
                   [param('ns3::EpcTft::Direction', 'direction'), param('ns3::Ipv4Address', 'remoteAddress'), param('ns3::Ipv4Address', 'localAddress'), param('uint16_t', 'remotePort'), param('uint16_t', 'localPort'), param('uint8_t', 'typeOfService')])
    ## epc-tft.h (module 'lte'): bool ns3::EpcTft::Matches(ns3::EpcTft::Direction direction, ns3::Ipv6Address remoteAddress, ns3::Ipv6Address localAddress, uint16_t remotePort, uint16_t localPort, uint8_t typeOfService) [member function]
    cls.add_method('Matches',
                   'bool',
                   [param('ns3::EpcTft::Direction', 'direction'), param('ns3::Ipv6Address', 'remoteAddress'), param('ns3::Ipv6Address', 'localAddress'), param('uint16_t', 'remotePort'), param('uint16_t', 'localPort'), param('uint8_t', 'typeOfService')])
    return

def register_Ns3EpcTftPacketFilter_methods(root_module, cls):
    ## epc-tft.h (module 'lte'): ns3::EpcTft::PacketFilter::PacketFilter(ns3::EpcTft::PacketFilter const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcTft::PacketFilter const &', 'arg0')])
    ## epc-tft.h (module 'lte'): ns3::EpcTft::PacketFilter::PacketFilter() [constructor]
    cls.add_constructor([])
    ## epc-tft.h (module 'lte'): bool ns3::EpcTft::PacketFilter::Matches(ns3::EpcTft::Direction d, ns3::Ipv4Address ra, ns3::Ipv4Address la, uint16_t rp, uint16_t lp, uint8_t tos) [member function]
    cls.add_method('Matches',
                   'bool',
                   [param('ns3::EpcTft::Direction', 'd'), param('ns3::Ipv4Address', 'ra'), param('ns3::Ipv4Address', 'la'), param('uint16_t', 'rp'), param('uint16_t', 'lp'), param('uint8_t', 'tos')])
    ## epc-tft.h (module 'lte'): bool ns3::EpcTft::PacketFilter::Matches(ns3::EpcTft::Direction d, ns3::Ipv6Address ra, ns3::Ipv6Address la, uint16_t rp, uint16_t lp, uint8_t tos) [member function]
    cls.add_method('Matches',
                   'bool',
                   [param('ns3::EpcTft::Direction', 'd'), param('ns3::Ipv6Address', 'ra'), param('ns3::Ipv6Address', 'la'), param('uint16_t', 'rp'), param('uint16_t', 'lp'), param('uint8_t', 'tos')])
    ## epc-tft.h (module 'lte'): ns3::EpcTft::PacketFilter::direction [variable]
    cls.add_instance_attribute('direction', 'ns3::EpcTft::Direction', is_const=False)
    ## epc-tft.h (module 'lte'): ns3::EpcTft::PacketFilter::localAddress [variable]
    cls.add_instance_attribute('localAddress', 'ns3::Ipv4Address', is_const=False)
    ## epc-tft.h (module 'lte'): ns3::EpcTft::PacketFilter::localAddress6 [variable]
    cls.add_instance_attribute('localAddress6', 'ns3::Ipv6Address', is_const=False)
    ## epc-tft.h (module 'lte'): ns3::EpcTft::PacketFilter::localMask [variable]
    cls.add_instance_attribute('localMask', 'ns3::Ipv4Mask', is_const=False)
    ## epc-tft.h (module 'lte'): ns3::EpcTft::PacketFilter::localPortEnd [variable]
    cls.add_instance_attribute('localPortEnd', 'uint16_t', is_const=False)
    ## epc-tft.h (module 'lte'): ns3::EpcTft::PacketFilter::localPortStart [variable]
    cls.add_instance_attribute('localPortStart', 'uint16_t', is_const=False)
    ## epc-tft.h (module 'lte'): ns3::EpcTft::PacketFilter::precedence [variable]
    cls.add_instance_attribute('precedence', 'uint8_t', is_const=False)
    ## epc-tft.h (module 'lte'): ns3::EpcTft::PacketFilter::remoteAddress [variable]
    cls.add_instance_attribute('remoteAddress', 'ns3::Ipv4Address', is_const=False)
    ## epc-tft.h (module 'lte'): ns3::EpcTft::PacketFilter::remoteAddress6 [variable]
    cls.add_instance_attribute('remoteAddress6', 'ns3::Ipv6Address', is_const=False)
    ## epc-tft.h (module 'lte'): ns3::EpcTft::PacketFilter::remoteMask [variable]
    cls.add_instance_attribute('remoteMask', 'ns3::Ipv4Mask', is_const=False)
    ## epc-tft.h (module 'lte'): ns3::EpcTft::PacketFilter::remotePortEnd [variable]
    cls.add_instance_attribute('remotePortEnd', 'uint16_t', is_const=False)
    ## epc-tft.h (module 'lte'): ns3::EpcTft::PacketFilter::remotePortStart [variable]
    cls.add_instance_attribute('remotePortStart', 'uint16_t', is_const=False)
    ## epc-tft.h (module 'lte'): ns3::EpcTft::PacketFilter::typeOfService [variable]
    cls.add_instance_attribute('typeOfService', 'uint8_t', is_const=False)
    ## epc-tft.h (module 'lte'): ns3::EpcTft::PacketFilter::typeOfServiceMask [variable]
    cls.add_instance_attribute('typeOfServiceMask', 'uint8_t', is_const=False)
    return

def register_Ns3EpcTftClassifier_methods(root_module, cls):
    ## epc-tft-classifier.h (module 'lte'): ns3::EpcTftClassifier::EpcTftClassifier(ns3::EpcTftClassifier const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcTftClassifier const &', 'arg0')])
    ## epc-tft-classifier.h (module 'lte'): ns3::EpcTftClassifier::EpcTftClassifier() [constructor]
    cls.add_constructor([])
    ## epc-tft-classifier.h (module 'lte'): void ns3::EpcTftClassifier::Add(ns3::Ptr<ns3::EpcTft> tft, uint32_t id) [member function]
    cls.add_method('Add',
                   'void',
                   [param('ns3::Ptr< ns3::EpcTft >', 'tft'), param('uint32_t', 'id')])
    ## epc-tft-classifier.h (module 'lte'): uint32_t ns3::EpcTftClassifier::Classify(ns3::Ptr<ns3::Packet> p, ns3::EpcTft::Direction direction) [member function]
    cls.add_method('Classify',
                   'uint32_t',
                   [param('ns3::Ptr< ns3::Packet >', 'p'), param('ns3::EpcTft::Direction', 'direction')])
    ## epc-tft-classifier.h (module 'lte'): void ns3::EpcTftClassifier::Delete(uint32_t id) [member function]
    cls.add_method('Delete',
                   'void',
                   [param('uint32_t', 'id')])
    return

def register_Ns3EpcUeNas_methods(root_module, cls):
    ## epc-ue-nas.h (module 'lte'): ns3::EpcUeNas::EpcUeNas(ns3::EpcUeNas const & arg0) [constructor]
    cls.add_constructor([param('ns3::EpcUeNas const &', 'arg0')])
    ## epc-ue-nas.h (module 'lte'): ns3::EpcUeNas::EpcUeNas() [constructor]
    cls.add_constructor([])
    ## epc-ue-nas.h (module 'lte'): void ns3::EpcUeNas::ActivateEpsBearer(ns3::EpsBearer bearer, ns3::Ptr<ns3::EpcTft> tft) [member function]
    cls.add_method('ActivateEpsBearer',
                   'void',
                   [param('ns3::EpsBearer', 'bearer'), param('ns3::Ptr< ns3::EpcTft >', 'tft')])
    ## epc-ue-nas.h (module 'lte'): void ns3::EpcUeNas::Connect() [member function]
    cls.add_method('Connect',
                   'void',
                   [])
    ## epc-ue-nas.h (module 'lte'): void ns3::EpcUeNas::Connect(uint16_t cellId, uint32_t dlEarfcn) [member function]
    cls.add_method('Connect',
                   'void',
                   [param('uint16_t', 'cellId'), param('uint32_t', 'dlEarfcn')])
    ## epc-ue-nas.h (module 'lte'): void ns3::EpcUeNas::ConnectMc(uint16_t cellId, uint16_t dlEarfcn, uint16_t mmWaveCellId) [member function]
    cls.add_method('ConnectMc',
                   'void',
                   [param('uint16_t', 'cellId'), param('uint16_t', 'dlEarfcn'), param('uint16_t', 'mmWaveCellId')])
    ## epc-ue-nas.h (module 'lte'): void ns3::EpcUeNas::Disconnect() [member function]
    cls.add_method('Disconnect',
                   'void',
                   [])
    ## epc-ue-nas.h (module 'lte'): void ns3::EpcUeNas::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## epc-ue-nas.h (module 'lte'): ns3::LteAsSapUser * ns3::EpcUeNas::GetAsSapUser() [member function]
    cls.add_method('GetAsSapUser',
                   'ns3::LteAsSapUser *',
                   [])
    ## epc-ue-nas.h (module 'lte'): uint32_t ns3::EpcUeNas::GetCsgId() const [member function]
    cls.add_method('GetCsgId',
                   'uint32_t',
                   [],
                   is_const=True)
    ## epc-ue-nas.h (module 'lte'): ns3::EpcUeNas::State ns3::EpcUeNas::GetState() const [member function]
    cls.add_method('GetState',
                   'ns3::EpcUeNas::State',
                   [],
                   is_const=True)
    ## epc-ue-nas.h (module 'lte'): static ns3::TypeId ns3::EpcUeNas::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## epc-ue-nas.h (module 'lte'): bool ns3::EpcUeNas::Send(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('Send',
                   'bool',
                   [param('ns3::Ptr< ns3::Packet >', 'p')])
    ## epc-ue-nas.h (module 'lte'): void ns3::EpcUeNas::SetAsSapProvider(ns3::LteAsSapProvider * s) [member function]
    cls.add_method('SetAsSapProvider',
                   'void',
                   [param('ns3::LteAsSapProvider *', 's')])
    ## epc-ue-nas.h (module 'lte'): void ns3::EpcUeNas::SetCsgId(uint32_t csgId) [member function]
    cls.add_method('SetCsgId',
                   'void',
                   [param('uint32_t', 'csgId')])
    ## epc-ue-nas.h (module 'lte'): void ns3::EpcUeNas::SetDevice(ns3::Ptr<ns3::NetDevice> dev) [member function]
    cls.add_method('SetDevice',
                   'void',
                   [param('ns3::Ptr< ns3::NetDevice >', 'dev')])
    ## epc-ue-nas.h (module 'lte'): void ns3::EpcUeNas::SetForwardUpCallback(ns3::Callback<void, ns3::Ptr<ns3::Packet>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> cb) [member function]
    cls.add_method('SetForwardUpCallback',
                   'void',
                   [param('ns3::Callback< void, ns3::Ptr< ns3::Packet >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'cb')])
    ## epc-ue-nas.h (module 'lte'): void ns3::EpcUeNas::SetImsi(uint64_t imsi) [member function]
    cls.add_method('SetImsi',
                   'void',
                   [param('uint64_t', 'imsi')])
    ## epc-ue-nas.h (module 'lte'): void ns3::EpcUeNas::SetMmWaveAsSapProvider(ns3::LteAsSapProvider * s) [member function]
    cls.add_method('SetMmWaveAsSapProvider',
                   'void',
                   [param('ns3::LteAsSapProvider *', 's')])
    ## epc-ue-nas.h (module 'lte'): void ns3::EpcUeNas::StartCellSelection(uint32_t dlEarfcn) [member function]
    cls.add_method('StartCellSelection',
                   'void',
                   [param('uint32_t', 'dlEarfcn')])
    return

def register_Ns3ErlangRandomVariable_methods(root_module, cls):
    ## random-variable-stream.h (module 'core'): static ns3::TypeId ns3::ErlangRandomVariable::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## random-variable-stream.h (module 'core'): ns3::ErlangRandomVariable::ErlangRandomVariable() [constructor]
    cls.add_constructor([])
    ## random-variable-stream.h (module 'core'): uint32_t ns3::ErlangRandomVariable::GetK() const [member function]
    cls.add_method('GetK',
                   'uint32_t',
                   [],
                   is_const=True)
    ## random-variable-stream.h (module 'core'): double ns3::ErlangRandomVariable::GetLambda() const [member function]
    cls.add_method('GetLambda',
                   'double',
                   [],
                   is_const=True)
    ## random-variable-stream.h (module 'core'): double ns3::ErlangRandomVariable::GetValue(uint32_t k, double lambda) [member function]
    cls.add_method('GetValue',
                   'double',
                   [param('uint32_t', 'k'), param('double', 'lambda')])
    ## random-variable-stream.h (module 'core'): uint32_t ns3::ErlangRandomVariable::GetInteger(uint32_t k, uint32_t lambda) [member function]
    cls.add_method('GetInteger',
                   'uint32_t',
                   [param('uint32_t', 'k'), param('uint32_t', 'lambda')])
    ## random-variable-stream.h (module 'core'): double ns3::ErlangRandomVariable::GetValue() [member function]
    cls.add_method('GetValue',
                   'double',
                   [],
                   is_virtual=True)
    ## random-variable-stream.h (module 'core'): uint32_t ns3::ErlangRandomVariable::GetInteger() [member function]
    cls.add_method('GetInteger',
                   'uint32_t',
                   [],
                   is_virtual=True)
    return

def register_Ns3EventImpl_methods(root_module, cls):
    ## event-impl.h (module 'core'): ns3::EventImpl::EventImpl(ns3::EventImpl const & arg0) [constructor]
    cls.add_constructor([param('ns3::EventImpl const &', 'arg0')])
    ## event-impl.h (module 'core'): ns3::EventImpl::EventImpl() [constructor]
    cls.add_constructor([])
    ## event-impl.h (module 'core'): void ns3::EventImpl::Cancel() [member function]
    cls.add_method('Cancel',
                   'void',
                   [])
    ## event-impl.h (module 'core'): void ns3::EventImpl::Invoke() [member function]
    cls.add_method('Invoke',
                   'void',
                   [])
    ## event-impl.h (module 'core'): bool ns3::EventImpl::IsCancelled() [member function]
    cls.add_method('IsCancelled',
                   'bool',
                   [])
    ## event-impl.h (module 'core'): void ns3::EventImpl::Notify() [member function]
    cls.add_method('Notify',
                   'void',
                   [],
                   is_pure_virtual=True, visibility='protected', is_virtual=True)
    return

def register_Ns3ExponentialRandomVariable_methods(root_module, cls):
    ## random-variable-stream.h (module 'core'): static ns3::TypeId ns3::ExponentialRandomVariable::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## random-variable-stream.h (module 'core'): ns3::ExponentialRandomVariable::ExponentialRandomVariable() [constructor]
    cls.add_constructor([])
    ## random-variable-stream.h (module 'core'): double ns3::ExponentialRandomVariable::GetMean() const [member function]
    cls.add_method('GetMean',
                   'double',
                   [],
                   is_const=True)
    ## random-variable-stream.h (module 'core'): double ns3::ExponentialRandomVariable::GetBound() const [member function]
    cls.add_method('GetBound',
                   'double',
                   [],
                   is_const=True)
    ## random-variable-stream.h (module 'core'): double ns3::ExponentialRandomVariable::GetValue(double mean, double bound) [member function]
    cls.add_method('GetValue',
                   'double',
                   [param('double', 'mean'), param('double', 'bound')])
    ## random-variable-stream.h (module 'core'): uint32_t ns3::ExponentialRandomVariable::GetInteger(uint32_t mean, uint32_t bound) [member function]
    cls.add_method('GetInteger',
                   'uint32_t',
                   [param('uint32_t', 'mean'), param('uint32_t', 'bound')])
    ## random-variable-stream.h (module 'core'): double ns3::ExponentialRandomVariable::GetValue() [member function]
    cls.add_method('GetValue',
                   'double',
                   [],
                   is_virtual=True)
    ## random-variable-stream.h (module 'core'): uint32_t ns3::ExponentialRandomVariable::GetInteger() [member function]
    cls.add_method('GetInteger',
                   'uint32_t',
                   [],
                   is_virtual=True)
    return

def register_Ns3FfMacScheduler_methods(root_module, cls):
    ## ff-mac-scheduler.h (module 'lte'): ns3::FfMacScheduler::FfMacScheduler(ns3::FfMacScheduler const & arg0) [constructor]
    cls.add_constructor([param('ns3::FfMacScheduler const &', 'arg0')])
    ## ff-mac-scheduler.h (module 'lte'): ns3::FfMacScheduler::FfMacScheduler() [constructor]
    cls.add_constructor([])
    ## ff-mac-scheduler.h (module 'lte'): void ns3::FfMacScheduler::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## ff-mac-scheduler.h (module 'lte'): ns3::FfMacCschedSapProvider * ns3::FfMacScheduler::GetFfMacCschedSapProvider() [member function]
    cls.add_method('GetFfMacCschedSapProvider',
                   'ns3::FfMacCschedSapProvider *',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## ff-mac-scheduler.h (module 'lte'): ns3::FfMacSchedSapProvider * ns3::FfMacScheduler::GetFfMacSchedSapProvider() [member function]
    cls.add_method('GetFfMacSchedSapProvider',
                   'ns3::FfMacSchedSapProvider *',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## ff-mac-scheduler.h (module 'lte'): ns3::LteFfrSapUser * ns3::FfMacScheduler::GetLteFfrSapUser() [member function]
    cls.add_method('GetLteFfrSapUser',
                   'ns3::LteFfrSapUser *',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## ff-mac-scheduler.h (module 'lte'): static ns3::TypeId ns3::FfMacScheduler::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## ff-mac-scheduler.h (module 'lte'): void ns3::FfMacScheduler::SetFfMacCschedSapUser(ns3::FfMacCschedSapUser * s) [member function]
    cls.add_method('SetFfMacCschedSapUser',
                   'void',
                   [param('ns3::FfMacCschedSapUser *', 's')],
                   is_pure_virtual=True, is_virtual=True)
    ## ff-mac-scheduler.h (module 'lte'): void ns3::FfMacScheduler::SetFfMacSchedSapUser(ns3::FfMacSchedSapUser * s) [member function]
    cls.add_method('SetFfMacSchedSapUser',
                   'void',
                   [param('ns3::FfMacSchedSapUser *', 's')],
                   is_pure_virtual=True, is_virtual=True)
    ## ff-mac-scheduler.h (module 'lte'): void ns3::FfMacScheduler::SetLteFfrSapProvider(ns3::LteFfrSapProvider * s) [member function]
    cls.add_method('SetLteFfrSapProvider',
                   'void',
                   [param('ns3::LteFfrSapProvider *', 's')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3FixedRssLossModel_methods(root_module, cls):
    ## propagation-loss-model.h (module 'propagation'): static ns3::TypeId ns3::FixedRssLossModel::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## propagation-loss-model.h (module 'propagation'): ns3::FixedRssLossModel::FixedRssLossModel() [constructor]
    cls.add_constructor([])
    ## propagation-loss-model.h (module 'propagation'): void ns3::FixedRssLossModel::SetRss(double rss) [member function]
    cls.add_method('SetRss',
                   'void',
                   [param('double', 'rss')])
    ## propagation-loss-model.h (module 'propagation'): double ns3::FixedRssLossModel::DoCalcRxPower(double txPowerDbm, ns3::Ptr<ns3::MobilityModel> a, ns3::Ptr<ns3::MobilityModel> b) const [member function]
    cls.add_method('DoCalcRxPower',
                   'double',
                   [param('double', 'txPowerDbm'), param('ns3::Ptr< ns3::MobilityModel >', 'a'), param('ns3::Ptr< ns3::MobilityModel >', 'b')],
                   is_const=True, visibility='private', is_virtual=True)
    ## propagation-loss-model.h (module 'propagation'): int64_t ns3::FixedRssLossModel::DoAssignStreams(int64_t stream) [member function]
    cls.add_method('DoAssignStreams',
                   'int64_t',
                   [param('int64_t', 'stream')],
                   visibility='private', is_virtual=True)
    return

def register_Ns3FriisPropagationLossModel_methods(root_module, cls):
    ## propagation-loss-model.h (module 'propagation'): static ns3::TypeId ns3::FriisPropagationLossModel::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## propagation-loss-model.h (module 'propagation'): ns3::FriisPropagationLossModel::FriisPropagationLossModel() [constructor]
    cls.add_constructor([])
    ## propagation-loss-model.h (module 'propagation'): void ns3::FriisPropagationLossModel::SetFrequency(double frequency) [member function]
    cls.add_method('SetFrequency',
                   'void',
                   [param('double', 'frequency')])
    ## propagation-loss-model.h (module 'propagation'): void ns3::FriisPropagationLossModel::SetSystemLoss(double systemLoss) [member function]
    cls.add_method('SetSystemLoss',
                   'void',
                   [param('double', 'systemLoss')])
    ## propagation-loss-model.h (module 'propagation'): void ns3::FriisPropagationLossModel::SetMinLoss(double minLoss) [member function]
    cls.add_method('SetMinLoss',
                   'void',
                   [param('double', 'minLoss')])
    ## propagation-loss-model.h (module 'propagation'): double ns3::FriisPropagationLossModel::GetMinLoss() const [member function]
    cls.add_method('GetMinLoss',
                   'double',
                   [],
                   is_const=True)
    ## propagation-loss-model.h (module 'propagation'): double ns3::FriisPropagationLossModel::GetFrequency() const [member function]
    cls.add_method('GetFrequency',
                   'double',
                   [],
                   is_const=True)
    ## propagation-loss-model.h (module 'propagation'): double ns3::FriisPropagationLossModel::GetSystemLoss() const [member function]
    cls.add_method('GetSystemLoss',
                   'double',
                   [],
                   is_const=True)
    ## propagation-loss-model.h (module 'propagation'): double ns3::FriisPropagationLossModel::DoCalcRxPower(double txPowerDbm, ns3::Ptr<ns3::MobilityModel> a, ns3::Ptr<ns3::MobilityModel> b) const [member function]
    cls.add_method('DoCalcRxPower',
                   'double',
                   [param('double', 'txPowerDbm'), param('ns3::Ptr< ns3::MobilityModel >', 'a'), param('ns3::Ptr< ns3::MobilityModel >', 'b')],
                   is_const=True, visibility='private', is_virtual=True)
    ## propagation-loss-model.h (module 'propagation'): int64_t ns3::FriisPropagationLossModel::DoAssignStreams(int64_t stream) [member function]
    cls.add_method('DoAssignStreams',
                   'int64_t',
                   [param('int64_t', 'stream')],
                   visibility='private', is_virtual=True)
    return

def register_Ns3GammaRandomVariable_methods(root_module, cls):
    ## random-variable-stream.h (module 'core'): static ns3::TypeId ns3::GammaRandomVariable::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## random-variable-stream.h (module 'core'): ns3::GammaRandomVariable::GammaRandomVariable() [constructor]
    cls.add_constructor([])
    ## random-variable-stream.h (module 'core'): double ns3::GammaRandomVariable::GetAlpha() const [member function]
    cls.add_method('GetAlpha',
                   'double',
                   [],
                   is_const=True)
    ## random-variable-stream.h (module 'core'): double ns3::GammaRandomVariable::GetBeta() const [member function]
    cls.add_method('GetBeta',
                   'double',
                   [],
                   is_const=True)
    ## random-variable-stream.h (module 'core'): double ns3::GammaRandomVariable::GetValue(double alpha, double beta) [member function]
    cls.add_method('GetValue',
                   'double',
                   [param('double', 'alpha'), param('double', 'beta')])
    ## random-variable-stream.h (module 'core'): uint32_t ns3::GammaRandomVariable::GetInteger(uint32_t alpha, uint32_t beta) [member function]
    cls.add_method('GetInteger',
                   'uint32_t',
                   [param('uint32_t', 'alpha'), param('uint32_t', 'beta')])
    ## random-variable-stream.h (module 'core'): double ns3::GammaRandomVariable::GetValue() [member function]
    cls.add_method('GetValue',
                   'double',
                   [],
                   is_virtual=True)
    ## random-variable-stream.h (module 'core'): uint32_t ns3::GammaRandomVariable::GetInteger() [member function]
    cls.add_method('GetInteger',
                   'uint32_t',
                   [],
                   is_virtual=True)
    return

def register_Ns3IntegerValue_methods(root_module, cls):
    ## integer.h (module 'core'): ns3::IntegerValue::IntegerValue() [constructor]
    cls.add_constructor([])
    ## integer.h (module 'core'): ns3::IntegerValue::IntegerValue(int64_t const & value) [constructor]
    cls.add_constructor([param('int64_t const &', 'value')])
    ## integer.h (module 'core'): ns3::IntegerValue::IntegerValue(ns3::IntegerValue const & arg0) [constructor]
    cls.add_constructor([param('ns3::IntegerValue const &', 'arg0')])
    ## integer.h (module 'core'): ns3::Ptr<ns3::AttributeValue> ns3::IntegerValue::Copy() const [member function]
    cls.add_method('Copy',
                   'ns3::Ptr< ns3::AttributeValue >',
                   [],
                   is_const=True, is_virtual=True)
    ## integer.h (module 'core'): bool ns3::IntegerValue::DeserializeFromString(std::string value, ns3::Ptr<const ns3::AttributeChecker> checker) [member function]
    cls.add_method('DeserializeFromString',
                   'bool',
                   [param('std::string', 'value'), param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_virtual=True)
    ## integer.h (module 'core'): int64_t ns3::IntegerValue::Get() const [member function]
    cls.add_method('Get',
                   'int64_t',
                   [],
                   is_const=True)
    ## integer.h (module 'core'): std::string ns3::IntegerValue::SerializeToString(ns3::Ptr<const ns3::AttributeChecker> checker) const [member function]
    cls.add_method('SerializeToString',
                   'std::string',
                   [param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_const=True, is_virtual=True)
    ## integer.h (module 'core'): void ns3::IntegerValue::Set(int64_t const & value) [member function]
    cls.add_method('Set',
                   'void',
                   [param('int64_t const &', 'value')])
    return

def register_Ns3Ipv4_methods(root_module, cls):
    ## ipv4.h (module 'internet'): ns3::Ipv4::Ipv4(ns3::Ipv4 const & arg0) [constructor]
    cls.add_constructor([param('ns3::Ipv4 const &', 'arg0')])
    ## ipv4.h (module 'internet'): ns3::Ipv4::Ipv4() [constructor]
    cls.add_constructor([])
    ## ipv4.h (module 'internet'): bool ns3::Ipv4::AddAddress(uint32_t interface, ns3::Ipv4InterfaceAddress address) [member function]
    cls.add_method('AddAddress',
                   'bool',
                   [param('uint32_t', 'interface'), param('ns3::Ipv4InterfaceAddress', 'address')],
                   is_pure_virtual=True, is_virtual=True)
    ## ipv4.h (module 'internet'): uint32_t ns3::Ipv4::AddInterface(ns3::Ptr<ns3::NetDevice> device) [member function]
    cls.add_method('AddInterface',
                   'uint32_t',
                   [param('ns3::Ptr< ns3::NetDevice >', 'device')],
                   is_pure_virtual=True, is_virtual=True)
    ## ipv4.h (module 'internet'): ns3::Ptr<ns3::Socket> ns3::Ipv4::CreateRawSocket() [member function]
    cls.add_method('CreateRawSocket',
                   'ns3::Ptr< ns3::Socket >',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## ipv4.h (module 'internet'): void ns3::Ipv4::DeleteRawSocket(ns3::Ptr<ns3::Socket> socket) [member function]
    cls.add_method('DeleteRawSocket',
                   'void',
                   [param('ns3::Ptr< ns3::Socket >', 'socket')],
                   is_pure_virtual=True, is_virtual=True)
    ## ipv4.h (module 'internet'): ns3::Ipv4InterfaceAddress ns3::Ipv4::GetAddress(uint32_t interface, uint32_t addressIndex) const [member function]
    cls.add_method('GetAddress',
                   'ns3::Ipv4InterfaceAddress',
                   [param('uint32_t', 'interface'), param('uint32_t', 'addressIndex')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## ipv4.h (module 'internet'): int32_t ns3::Ipv4::GetInterfaceForAddress(ns3::Ipv4Address address) const [member function]
    cls.add_method('GetInterfaceForAddress',
                   'int32_t',
                   [param('ns3::Ipv4Address', 'address')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## ipv4.h (module 'internet'): int32_t ns3::Ipv4::GetInterfaceForDevice(ns3::Ptr<const ns3::NetDevice> device) const [member function]
    cls.add_method('GetInterfaceForDevice',
                   'int32_t',
                   [param('ns3::Ptr< ns3::NetDevice const >', 'device')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## ipv4.h (module 'internet'): int32_t ns3::Ipv4::GetInterfaceForPrefix(ns3::Ipv4Address address, ns3::Ipv4Mask mask) const [member function]
    cls.add_method('GetInterfaceForPrefix',
                   'int32_t',
                   [param('ns3::Ipv4Address', 'address'), param('ns3::Ipv4Mask', 'mask')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## ipv4.h (module 'internet'): uint16_t ns3::Ipv4::GetMetric(uint32_t interface) const [member function]
    cls.add_method('GetMetric',
                   'uint16_t',
                   [param('uint32_t', 'interface')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## ipv4.h (module 'internet'): uint16_t ns3::Ipv4::GetMtu(uint32_t interface) const [member function]
    cls.add_method('GetMtu',
                   'uint16_t',
                   [param('uint32_t', 'interface')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## ipv4.h (module 'internet'): uint32_t ns3::Ipv4::GetNAddresses(uint32_t interface) const [member function]
    cls.add_method('GetNAddresses',
                   'uint32_t',
                   [param('uint32_t', 'interface')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## ipv4.h (module 'internet'): uint32_t ns3::Ipv4::GetNInterfaces() const [member function]
    cls.add_method('GetNInterfaces',
                   'uint32_t',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## ipv4.h (module 'internet'): ns3::Ptr<ns3::NetDevice> ns3::Ipv4::GetNetDevice(uint32_t interface) [member function]
    cls.add_method('GetNetDevice',
                   'ns3::Ptr< ns3::NetDevice >',
                   [param('uint32_t', 'interface')],
                   is_pure_virtual=True, is_virtual=True)
    ## ipv4.h (module 'internet'): ns3::Ptr<ns3::IpL4Protocol> ns3::Ipv4::GetProtocol(int protocolNumber) const [member function]
    cls.add_method('GetProtocol',
                   'ns3::Ptr< ns3::IpL4Protocol >',
                   [param('int', 'protocolNumber')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## ipv4.h (module 'internet'): ns3::Ptr<ns3::IpL4Protocol> ns3::Ipv4::GetProtocol(int protocolNumber, int32_t interfaceIndex) const [member function]
    cls.add_method('GetProtocol',
                   'ns3::Ptr< ns3::IpL4Protocol >',
                   [param('int', 'protocolNumber'), param('int32_t', 'interfaceIndex')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## ipv4.h (module 'internet'): ns3::Ptr<ns3::Ipv4RoutingProtocol> ns3::Ipv4::GetRoutingProtocol() const [member function]
    cls.add_method('GetRoutingProtocol',
                   'ns3::Ptr< ns3::Ipv4RoutingProtocol >',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## ipv4.h (module 'internet'): static ns3::TypeId ns3::Ipv4::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## ipv4.h (module 'internet'): void ns3::Ipv4::Insert(ns3::Ptr<ns3::IpL4Protocol> protocol) [member function]
    cls.add_method('Insert',
                   'void',
                   [param('ns3::Ptr< ns3::IpL4Protocol >', 'protocol')],
                   is_pure_virtual=True, is_virtual=True)
    ## ipv4.h (module 'internet'): void ns3::Ipv4::Insert(ns3::Ptr<ns3::IpL4Protocol> protocol, uint32_t interfaceIndex) [member function]
    cls.add_method('Insert',
                   'void',
                   [param('ns3::Ptr< ns3::IpL4Protocol >', 'protocol'), param('uint32_t', 'interfaceIndex')],
                   is_pure_virtual=True, is_virtual=True)
    ## ipv4.h (module 'internet'): bool ns3::Ipv4::IsDestinationAddress(ns3::Ipv4Address address, uint32_t iif) const [member function]
    cls.add_method('IsDestinationAddress',
                   'bool',
                   [param('ns3::Ipv4Address', 'address'), param('uint32_t', 'iif')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## ipv4.h (module 'internet'): bool ns3::Ipv4::IsForwarding(uint32_t interface) const [member function]
    cls.add_method('IsForwarding',
                   'bool',
                   [param('uint32_t', 'interface')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## ipv4.h (module 'internet'): bool ns3::Ipv4::IsUp(uint32_t interface) const [member function]
    cls.add_method('IsUp',
                   'bool',
                   [param('uint32_t', 'interface')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## ipv4.h (module 'internet'): void ns3::Ipv4::Remove(ns3::Ptr<ns3::IpL4Protocol> protocol) [member function]
    cls.add_method('Remove',
                   'void',
                   [param('ns3::Ptr< ns3::IpL4Protocol >', 'protocol')],
                   is_pure_virtual=True, is_virtual=True)
    ## ipv4.h (module 'internet'): void ns3::Ipv4::Remove(ns3::Ptr<ns3::IpL4Protocol> protocol, uint32_t interfaceIndex) [member function]
    cls.add_method('Remove',
                   'void',
                   [param('ns3::Ptr< ns3::IpL4Protocol >', 'protocol'), param('uint32_t', 'interfaceIndex')],
                   is_pure_virtual=True, is_virtual=True)
    ## ipv4.h (module 'internet'): bool ns3::Ipv4::RemoveAddress(uint32_t interface, uint32_t addressIndex) [member function]
    cls.add_method('RemoveAddress',
                   'bool',
                   [param('uint32_t', 'interface'), param('uint32_t', 'addressIndex')],
                   is_pure_virtual=True, is_virtual=True)
    ## ipv4.h (module 'internet'): bool ns3::Ipv4::RemoveAddress(uint32_t interface, ns3::Ipv4Address address) [member function]
    cls.add_method('RemoveAddress',
                   'bool',
                   [param('uint32_t', 'interface'), param('ns3::Ipv4Address', 'address')],
                   is_pure_virtual=True, is_virtual=True)
    ## ipv4.h (module 'internet'): ns3::Ipv4Address ns3::Ipv4::SelectSourceAddress(ns3::Ptr<const ns3::NetDevice> device, ns3::Ipv4Address dst, ns3::Ipv4InterfaceAddress::InterfaceAddressScope_e scope) [member function]
    cls.add_method('SelectSourceAddress',
                   'ns3::Ipv4Address',
                   [param('ns3::Ptr< ns3::NetDevice const >', 'device'), param('ns3::Ipv4Address', 'dst'), param('ns3::Ipv4InterfaceAddress::InterfaceAddressScope_e', 'scope')],
                   is_pure_virtual=True, is_virtual=True)
    ## ipv4.h (module 'internet'): void ns3::Ipv4::Send(ns3::Ptr<ns3::Packet> packet, ns3::Ipv4Address source, ns3::Ipv4Address destination, uint8_t protocol, ns3::Ptr<ns3::Ipv4Route> route) [member function]
    cls.add_method('Send',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'packet'), param('ns3::Ipv4Address', 'source'), param('ns3::Ipv4Address', 'destination'), param('uint8_t', 'protocol'), param('ns3::Ptr< ns3::Ipv4Route >', 'route')],
                   is_pure_virtual=True, is_virtual=True)
    ## ipv4.h (module 'internet'): void ns3::Ipv4::SendWithHeader(ns3::Ptr<ns3::Packet> packet, ns3::Ipv4Header ipHeader, ns3::Ptr<ns3::Ipv4Route> route) [member function]
    cls.add_method('SendWithHeader',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'packet'), param('ns3::Ipv4Header', 'ipHeader'), param('ns3::Ptr< ns3::Ipv4Route >', 'route')],
                   is_pure_virtual=True, is_virtual=True)
    ## ipv4.h (module 'internet'): void ns3::Ipv4::SetDown(uint32_t interface) [member function]
    cls.add_method('SetDown',
                   'void',
                   [param('uint32_t', 'interface')],
                   is_pure_virtual=True, is_virtual=True)
    ## ipv4.h (module 'internet'): void ns3::Ipv4::SetForwarding(uint32_t interface, bool val) [member function]
    cls.add_method('SetForwarding',
                   'void',
                   [param('uint32_t', 'interface'), param('bool', 'val')],
                   is_pure_virtual=True, is_virtual=True)
    ## ipv4.h (module 'internet'): void ns3::Ipv4::SetMetric(uint32_t interface, uint16_t metric) [member function]
    cls.add_method('SetMetric',
                   'void',
                   [param('uint32_t', 'interface'), param('uint16_t', 'metric')],
                   is_pure_virtual=True, is_virtual=True)
    ## ipv4.h (module 'internet'): void ns3::Ipv4::SetRoutingProtocol(ns3::Ptr<ns3::Ipv4RoutingProtocol> routingProtocol) [member function]
    cls.add_method('SetRoutingProtocol',
                   'void',
                   [param('ns3::Ptr< ns3::Ipv4RoutingProtocol >', 'routingProtocol')],
                   is_pure_virtual=True, is_virtual=True)
    ## ipv4.h (module 'internet'): void ns3::Ipv4::SetUp(uint32_t interface) [member function]
    cls.add_method('SetUp',
                   'void',
                   [param('uint32_t', 'interface')],
                   is_pure_virtual=True, is_virtual=True)
    ## ipv4.h (module 'internet'): ns3::Ipv4Address ns3::Ipv4::SourceAddressSelection(uint32_t interface, ns3::Ipv4Address dest) [member function]
    cls.add_method('SourceAddressSelection',
                   'ns3::Ipv4Address',
                   [param('uint32_t', 'interface'), param('ns3::Ipv4Address', 'dest')],
                   is_pure_virtual=True, is_virtual=True)
    ## ipv4.h (module 'internet'): ns3::Ipv4::IF_ANY [variable]
    cls.add_static_attribute('IF_ANY', 'uint32_t const', is_const=True)
    ## ipv4.h (module 'internet'): bool ns3::Ipv4::GetIpForward() const [member function]
    cls.add_method('GetIpForward',
                   'bool',
                   [],
                   is_pure_virtual=True, is_const=True, visibility='private', is_virtual=True)
    ## ipv4.h (module 'internet'): bool ns3::Ipv4::GetWeakEsModel() const [member function]
    cls.add_method('GetWeakEsModel',
                   'bool',
                   [],
                   is_pure_virtual=True, is_const=True, visibility='private', is_virtual=True)
    ## ipv4.h (module 'internet'): void ns3::Ipv4::SetIpForward(bool forward) [member function]
    cls.add_method('SetIpForward',
                   'void',
                   [param('bool', 'forward')],
                   is_pure_virtual=True, visibility='private', is_virtual=True)
    ## ipv4.h (module 'internet'): void ns3::Ipv4::SetWeakEsModel(bool model) [member function]
    cls.add_method('SetWeakEsModel',
                   'void',
                   [param('bool', 'model')],
                   is_pure_virtual=True, visibility='private', is_virtual=True)
    return

def register_Ns3Ipv4AddressChecker_methods(root_module, cls):
    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressChecker::Ipv4AddressChecker() [constructor]
    cls.add_constructor([])
    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressChecker::Ipv4AddressChecker(ns3::Ipv4AddressChecker const & arg0) [constructor]
    cls.add_constructor([param('ns3::Ipv4AddressChecker const &', 'arg0')])
    return

def register_Ns3Ipv4AddressValue_methods(root_module, cls):
    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressValue::Ipv4AddressValue() [constructor]
    cls.add_constructor([])
    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressValue::Ipv4AddressValue(ns3::Ipv4Address const & value) [constructor]
    cls.add_constructor([param('ns3::Ipv4Address const &', 'value')])
    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressValue::Ipv4AddressValue(ns3::Ipv4AddressValue const & arg0) [constructor]
    cls.add_constructor([param('ns3::Ipv4AddressValue const &', 'arg0')])
    ## ipv4-address.h (module 'network'): ns3::Ptr<ns3::AttributeValue> ns3::Ipv4AddressValue::Copy() const [member function]
    cls.add_method('Copy',
                   'ns3::Ptr< ns3::AttributeValue >',
                   [],
                   is_const=True, is_virtual=True)
    ## ipv4-address.h (module 'network'): bool ns3::Ipv4AddressValue::DeserializeFromString(std::string value, ns3::Ptr<const ns3::AttributeChecker> checker) [member function]
    cls.add_method('DeserializeFromString',
                   'bool',
                   [param('std::string', 'value'), param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_virtual=True)
    ## ipv4-address.h (module 'network'): ns3::Ipv4Address ns3::Ipv4AddressValue::Get() const [member function]
    cls.add_method('Get',
                   'ns3::Ipv4Address',
                   [],
                   is_const=True)
    ## ipv4-address.h (module 'network'): std::string ns3::Ipv4AddressValue::SerializeToString(ns3::Ptr<const ns3::AttributeChecker> checker) const [member function]
    cls.add_method('SerializeToString',
                   'std::string',
                   [param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_const=True, is_virtual=True)
    ## ipv4-address.h (module 'network'): void ns3::Ipv4AddressValue::Set(ns3::Ipv4Address const & value) [member function]
    cls.add_method('Set',
                   'void',
                   [param('ns3::Ipv4Address const &', 'value')])
    return

def register_Ns3Ipv4MaskChecker_methods(root_module, cls):
    ## ipv4-address.h (module 'network'): ns3::Ipv4MaskChecker::Ipv4MaskChecker() [constructor]
    cls.add_constructor([])
    ## ipv4-address.h (module 'network'): ns3::Ipv4MaskChecker::Ipv4MaskChecker(ns3::Ipv4MaskChecker const & arg0) [constructor]
    cls.add_constructor([param('ns3::Ipv4MaskChecker const &', 'arg0')])
    return

def register_Ns3Ipv4MaskValue_methods(root_module, cls):
    ## ipv4-address.h (module 'network'): ns3::Ipv4MaskValue::Ipv4MaskValue() [constructor]
    cls.add_constructor([])
    ## ipv4-address.h (module 'network'): ns3::Ipv4MaskValue::Ipv4MaskValue(ns3::Ipv4Mask const & value) [constructor]
    cls.add_constructor([param('ns3::Ipv4Mask const &', 'value')])
    ## ipv4-address.h (module 'network'): ns3::Ipv4MaskValue::Ipv4MaskValue(ns3::Ipv4MaskValue const & arg0) [constructor]
    cls.add_constructor([param('ns3::Ipv4MaskValue const &', 'arg0')])
    ## ipv4-address.h (module 'network'): ns3::Ptr<ns3::AttributeValue> ns3::Ipv4MaskValue::Copy() const [member function]
    cls.add_method('Copy',
                   'ns3::Ptr< ns3::AttributeValue >',
                   [],
                   is_const=True, is_virtual=True)
    ## ipv4-address.h (module 'network'): bool ns3::Ipv4MaskValue::DeserializeFromString(std::string value, ns3::Ptr<const ns3::AttributeChecker> checker) [member function]
    cls.add_method('DeserializeFromString',
                   'bool',
                   [param('std::string', 'value'), param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_virtual=True)
    ## ipv4-address.h (module 'network'): ns3::Ipv4Mask ns3::Ipv4MaskValue::Get() const [member function]
    cls.add_method('Get',
                   'ns3::Ipv4Mask',
                   [],
                   is_const=True)
    ## ipv4-address.h (module 'network'): std::string ns3::Ipv4MaskValue::SerializeToString(ns3::Ptr<const ns3::AttributeChecker> checker) const [member function]
    cls.add_method('SerializeToString',
                   'std::string',
                   [param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_const=True, is_virtual=True)
    ## ipv4-address.h (module 'network'): void ns3::Ipv4MaskValue::Set(ns3::Ipv4Mask const & value) [member function]
    cls.add_method('Set',
                   'void',
                   [param('ns3::Ipv4Mask const &', 'value')])
    return

def register_Ns3Ipv4MulticastRoute_methods(root_module, cls):
    ## ipv4-route.h (module 'internet'): ns3::Ipv4MulticastRoute::Ipv4MulticastRoute(ns3::Ipv4MulticastRoute const & arg0) [constructor]
    cls.add_constructor([param('ns3::Ipv4MulticastRoute const &', 'arg0')])
    ## ipv4-route.h (module 'internet'): ns3::Ipv4MulticastRoute::Ipv4MulticastRoute() [constructor]
    cls.add_constructor([])
    ## ipv4-route.h (module 'internet'): ns3::Ipv4Address ns3::Ipv4MulticastRoute::GetGroup() const [member function]
    cls.add_method('GetGroup',
                   'ns3::Ipv4Address',
                   [],
                   is_const=True)
    ## ipv4-route.h (module 'internet'): ns3::Ipv4Address ns3::Ipv4MulticastRoute::GetOrigin() const [member function]
    cls.add_method('GetOrigin',
                   'ns3::Ipv4Address',
                   [],
                   is_const=True)
    ## ipv4-route.h (module 'internet'): std::map<unsigned int, unsigned int, std::less<unsigned int>, std::allocator<std::pair<const unsigned int, unsigned int> > > ns3::Ipv4MulticastRoute::GetOutputTtlMap() const [member function]
    cls.add_method('GetOutputTtlMap',
                   'std::map< unsigned int, unsigned int >',
                   [],
                   is_const=True)
    ## ipv4-route.h (module 'internet'): uint32_t ns3::Ipv4MulticastRoute::GetParent() const [member function]
    cls.add_method('GetParent',
                   'uint32_t',
                   [],
                   is_const=True)
    ## ipv4-route.h (module 'internet'): void ns3::Ipv4MulticastRoute::SetGroup(ns3::Ipv4Address const group) [member function]
    cls.add_method('SetGroup',
                   'void',
                   [param('ns3::Ipv4Address const', 'group')])
    ## ipv4-route.h (module 'internet'): void ns3::Ipv4MulticastRoute::SetOrigin(ns3::Ipv4Address const origin) [member function]
    cls.add_method('SetOrigin',
                   'void',
                   [param('ns3::Ipv4Address const', 'origin')])
    ## ipv4-route.h (module 'internet'): void ns3::Ipv4MulticastRoute::SetOutputTtl(uint32_t oif, uint32_t ttl) [member function]
    cls.add_method('SetOutputTtl',
                   'void',
                   [param('uint32_t', 'oif'), param('uint32_t', 'ttl')])
    ## ipv4-route.h (module 'internet'): void ns3::Ipv4MulticastRoute::SetParent(uint32_t iif) [member function]
    cls.add_method('SetParent',
                   'void',
                   [param('uint32_t', 'iif')])
    ## ipv4-route.h (module 'internet'): ns3::Ipv4MulticastRoute::MAX_INTERFACES [variable]
    cls.add_static_attribute('MAX_INTERFACES', 'uint32_t const', is_const=True)
    ## ipv4-route.h (module 'internet'): ns3::Ipv4MulticastRoute::MAX_TTL [variable]
    cls.add_static_attribute('MAX_TTL', 'uint32_t const', is_const=True)
    return

def register_Ns3Ipv4Route_methods(root_module, cls):
    cls.add_output_stream_operator()
    ## ipv4-route.h (module 'internet'): ns3::Ipv4Route::Ipv4Route(ns3::Ipv4Route const & arg0) [constructor]
    cls.add_constructor([param('ns3::Ipv4Route const &', 'arg0')])
    ## ipv4-route.h (module 'internet'): ns3::Ipv4Route::Ipv4Route() [constructor]
    cls.add_constructor([])
    ## ipv4-route.h (module 'internet'): ns3::Ipv4Address ns3::Ipv4Route::GetDestination() const [member function]
    cls.add_method('GetDestination',
                   'ns3::Ipv4Address',
                   [],
                   is_const=True)
    ## ipv4-route.h (module 'internet'): ns3::Ipv4Address ns3::Ipv4Route::GetGateway() const [member function]
    cls.add_method('GetGateway',
                   'ns3::Ipv4Address',
                   [],
                   is_const=True)
    ## ipv4-route.h (module 'internet'): ns3::Ptr<ns3::NetDevice> ns3::Ipv4Route::GetOutputDevice() const [member function]
    cls.add_method('GetOutputDevice',
                   'ns3::Ptr< ns3::NetDevice >',
                   [],
                   is_const=True)
    ## ipv4-route.h (module 'internet'): ns3::Ipv4Address ns3::Ipv4Route::GetSource() const [member function]
    cls.add_method('GetSource',
                   'ns3::Ipv4Address',
                   [],
                   is_const=True)
    ## ipv4-route.h (module 'internet'): void ns3::Ipv4Route::SetDestination(ns3::Ipv4Address dest) [member function]
    cls.add_method('SetDestination',
                   'void',
                   [param('ns3::Ipv4Address', 'dest')])
    ## ipv4-route.h (module 'internet'): void ns3::Ipv4Route::SetGateway(ns3::Ipv4Address gw) [member function]
    cls.add_method('SetGateway',
                   'void',
                   [param('ns3::Ipv4Address', 'gw')])
    ## ipv4-route.h (module 'internet'): void ns3::Ipv4Route::SetOutputDevice(ns3::Ptr<ns3::NetDevice> outputDevice) [member function]
    cls.add_method('SetOutputDevice',
                   'void',
                   [param('ns3::Ptr< ns3::NetDevice >', 'outputDevice')])
    ## ipv4-route.h (module 'internet'): void ns3::Ipv4Route::SetSource(ns3::Ipv4Address src) [member function]
    cls.add_method('SetSource',
                   'void',
                   [param('ns3::Ipv4Address', 'src')])
    return

def register_Ns3Ipv6_methods(root_module, cls):
    ## ipv6.h (module 'internet'): ns3::Ipv6::Ipv6(ns3::Ipv6 const & arg0) [constructor]
    cls.add_constructor([param('ns3::Ipv6 const &', 'arg0')])
    ## ipv6.h (module 'internet'): ns3::Ipv6::Ipv6() [constructor]
    cls.add_constructor([])
    ## ipv6.h (module 'internet'): bool ns3::Ipv6::AddAddress(uint32_t interface, ns3::Ipv6InterfaceAddress address) [member function]
    cls.add_method('AddAddress',
                   'bool',
                   [param('uint32_t', 'interface'), param('ns3::Ipv6InterfaceAddress', 'address')],
                   is_pure_virtual=True, is_virtual=True)
    ## ipv6.h (module 'internet'): uint32_t ns3::Ipv6::AddInterface(ns3::Ptr<ns3::NetDevice> device) [member function]
    cls.add_method('AddInterface',
                   'uint32_t',
                   [param('ns3::Ptr< ns3::NetDevice >', 'device')],
                   is_pure_virtual=True, is_virtual=True)
    ## ipv6.h (module 'internet'): ns3::Ipv6InterfaceAddress ns3::Ipv6::GetAddress(uint32_t interface, uint32_t addressIndex) const [member function]
    cls.add_method('GetAddress',
                   'ns3::Ipv6InterfaceAddress',
                   [param('uint32_t', 'interface'), param('uint32_t', 'addressIndex')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## ipv6.h (module 'internet'): int32_t ns3::Ipv6::GetInterfaceForAddress(ns3::Ipv6Address address) const [member function]
    cls.add_method('GetInterfaceForAddress',
                   'int32_t',
                   [param('ns3::Ipv6Address', 'address')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## ipv6.h (module 'internet'): int32_t ns3::Ipv6::GetInterfaceForDevice(ns3::Ptr<const ns3::NetDevice> device) const [member function]
    cls.add_method('GetInterfaceForDevice',
                   'int32_t',
                   [param('ns3::Ptr< ns3::NetDevice const >', 'device')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## ipv6.h (module 'internet'): int32_t ns3::Ipv6::GetInterfaceForPrefix(ns3::Ipv6Address address, ns3::Ipv6Prefix mask) const [member function]
    cls.add_method('GetInterfaceForPrefix',
                   'int32_t',
                   [param('ns3::Ipv6Address', 'address'), param('ns3::Ipv6Prefix', 'mask')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## ipv6.h (module 'internet'): uint16_t ns3::Ipv6::GetMetric(uint32_t interface) const [member function]
    cls.add_method('GetMetric',
                   'uint16_t',
                   [param('uint32_t', 'interface')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## ipv6.h (module 'internet'): uint16_t ns3::Ipv6::GetMtu(uint32_t interface) const [member function]
    cls.add_method('GetMtu',
                   'uint16_t',
                   [param('uint32_t', 'interface')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## ipv6.h (module 'internet'): uint32_t ns3::Ipv6::GetNAddresses(uint32_t interface) const [member function]
    cls.add_method('GetNAddresses',
                   'uint32_t',
                   [param('uint32_t', 'interface')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## ipv6.h (module 'internet'): uint32_t ns3::Ipv6::GetNInterfaces() const [member function]
    cls.add_method('GetNInterfaces',
                   'uint32_t',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## ipv6.h (module 'internet'): ns3::Ptr<ns3::NetDevice> ns3::Ipv6::GetNetDevice(uint32_t interface) [member function]
    cls.add_method('GetNetDevice',
                   'ns3::Ptr< ns3::NetDevice >',
                   [param('uint32_t', 'interface')],
                   is_pure_virtual=True, is_virtual=True)
    ## ipv6.h (module 'internet'): ns3::Ptr<ns3::IpL4Protocol> ns3::Ipv6::GetProtocol(int protocolNumber) const [member function]
    cls.add_method('GetProtocol',
                   'ns3::Ptr< ns3::IpL4Protocol >',
                   [param('int', 'protocolNumber')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## ipv6.h (module 'internet'): ns3::Ptr<ns3::IpL4Protocol> ns3::Ipv6::GetProtocol(int protocolNumber, int32_t interfaceIndex) const [member function]
    cls.add_method('GetProtocol',
                   'ns3::Ptr< ns3::IpL4Protocol >',
                   [param('int', 'protocolNumber'), param('int32_t', 'interfaceIndex')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## ipv6.h (module 'internet'): ns3::Ptr<ns3::Ipv6RoutingProtocol> ns3::Ipv6::GetRoutingProtocol() const [member function]
    cls.add_method('GetRoutingProtocol',
                   'ns3::Ptr< ns3::Ipv6RoutingProtocol >',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## ipv6.h (module 'internet'): static ns3::TypeId ns3::Ipv6::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## ipv6.h (module 'internet'): void ns3::Ipv6::Insert(ns3::Ptr<ns3::IpL4Protocol> protocol) [member function]
    cls.add_method('Insert',
                   'void',
                   [param('ns3::Ptr< ns3::IpL4Protocol >', 'protocol')],
                   is_pure_virtual=True, is_virtual=True)
    ## ipv6.h (module 'internet'): void ns3::Ipv6::Insert(ns3::Ptr<ns3::IpL4Protocol> protocol, uint32_t interfaceIndex) [member function]
    cls.add_method('Insert',
                   'void',
                   [param('ns3::Ptr< ns3::IpL4Protocol >', 'protocol'), param('uint32_t', 'interfaceIndex')],
                   is_pure_virtual=True, is_virtual=True)
    ## ipv6.h (module 'internet'): bool ns3::Ipv6::IsForwarding(uint32_t interface) const [member function]
    cls.add_method('IsForwarding',
                   'bool',
                   [param('uint32_t', 'interface')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## ipv6.h (module 'internet'): bool ns3::Ipv6::IsUp(uint32_t interface) const [member function]
    cls.add_method('IsUp',
                   'bool',
                   [param('uint32_t', 'interface')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## ipv6.h (module 'internet'): void ns3::Ipv6::RegisterExtensions() [member function]
    cls.add_method('RegisterExtensions',
                   'void',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## ipv6.h (module 'internet'): void ns3::Ipv6::RegisterOptions() [member function]
    cls.add_method('RegisterOptions',
                   'void',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## ipv6.h (module 'internet'): void ns3::Ipv6::Remove(ns3::Ptr<ns3::IpL4Protocol> protocol) [member function]
    cls.add_method('Remove',
                   'void',
                   [param('ns3::Ptr< ns3::IpL4Protocol >', 'protocol')],
                   is_pure_virtual=True, is_virtual=True)
    ## ipv6.h (module 'internet'): void ns3::Ipv6::Remove(ns3::Ptr<ns3::IpL4Protocol> protocol, uint32_t interfaceIndex) [member function]
    cls.add_method('Remove',
                   'void',
                   [param('ns3::Ptr< ns3::IpL4Protocol >', 'protocol'), param('uint32_t', 'interfaceIndex')],
                   is_pure_virtual=True, is_virtual=True)
    ## ipv6.h (module 'internet'): bool ns3::Ipv6::RemoveAddress(uint32_t interface, uint32_t addressIndex) [member function]
    cls.add_method('RemoveAddress',
                   'bool',
                   [param('uint32_t', 'interface'), param('uint32_t', 'addressIndex')],
                   is_pure_virtual=True, is_virtual=True)
    ## ipv6.h (module 'internet'): bool ns3::Ipv6::RemoveAddress(uint32_t interface, ns3::Ipv6Address address) [member function]
    cls.add_method('RemoveAddress',
                   'bool',
                   [param('uint32_t', 'interface'), param('ns3::Ipv6Address', 'address')],
                   is_pure_virtual=True, is_virtual=True)
    ## ipv6.h (module 'internet'): void ns3::Ipv6::Send(ns3::Ptr<ns3::Packet> packet, ns3::Ipv6Address source, ns3::Ipv6Address destination, uint8_t protocol, ns3::Ptr<ns3::Ipv6Route> route) [member function]
    cls.add_method('Send',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'packet'), param('ns3::Ipv6Address', 'source'), param('ns3::Ipv6Address', 'destination'), param('uint8_t', 'protocol'), param('ns3::Ptr< ns3::Ipv6Route >', 'route')],
                   is_pure_virtual=True, is_virtual=True)
    ## ipv6.h (module 'internet'): void ns3::Ipv6::SetDown(uint32_t interface) [member function]
    cls.add_method('SetDown',
                   'void',
                   [param('uint32_t', 'interface')],
                   is_pure_virtual=True, is_virtual=True)
    ## ipv6.h (module 'internet'): void ns3::Ipv6::SetForwarding(uint32_t interface, bool val) [member function]
    cls.add_method('SetForwarding',
                   'void',
                   [param('uint32_t', 'interface'), param('bool', 'val')],
                   is_pure_virtual=True, is_virtual=True)
    ## ipv6.h (module 'internet'): void ns3::Ipv6::SetMetric(uint32_t interface, uint16_t metric) [member function]
    cls.add_method('SetMetric',
                   'void',
                   [param('uint32_t', 'interface'), param('uint16_t', 'metric')],
                   is_pure_virtual=True, is_virtual=True)
    ## ipv6.h (module 'internet'): void ns3::Ipv6::SetPmtu(ns3::Ipv6Address dst, uint32_t pmtu) [member function]
    cls.add_method('SetPmtu',
                   'void',
                   [param('ns3::Ipv6Address', 'dst'), param('uint32_t', 'pmtu')],
                   is_pure_virtual=True, is_virtual=True)
    ## ipv6.h (module 'internet'): void ns3::Ipv6::SetRoutingProtocol(ns3::Ptr<ns3::Ipv6RoutingProtocol> routingProtocol) [member function]
    cls.add_method('SetRoutingProtocol',
                   'void',
                   [param('ns3::Ptr< ns3::Ipv6RoutingProtocol >', 'routingProtocol')],
                   is_pure_virtual=True, is_virtual=True)
    ## ipv6.h (module 'internet'): void ns3::Ipv6::SetUp(uint32_t interface) [member function]
    cls.add_method('SetUp',
                   'void',
                   [param('uint32_t', 'interface')],
                   is_pure_virtual=True, is_virtual=True)
    ## ipv6.h (module 'internet'): ns3::Ipv6Address ns3::Ipv6::SourceAddressSelection(uint32_t interface, ns3::Ipv6Address dest) [member function]
    cls.add_method('SourceAddressSelection',
                   'ns3::Ipv6Address',
                   [param('uint32_t', 'interface'), param('ns3::Ipv6Address', 'dest')],
                   is_pure_virtual=True, is_virtual=True)
    ## ipv6.h (module 'internet'): ns3::Ipv6::IF_ANY [variable]
    cls.add_static_attribute('IF_ANY', 'uint32_t const', is_const=True)
    ## ipv6.h (module 'internet'): bool ns3::Ipv6::GetIpForward() const [member function]
    cls.add_method('GetIpForward',
                   'bool',
                   [],
                   is_pure_virtual=True, is_const=True, visibility='private', is_virtual=True)
    ## ipv6.h (module 'internet'): bool ns3::Ipv6::GetMtuDiscover() const [member function]
    cls.add_method('GetMtuDiscover',
                   'bool',
                   [],
                   is_pure_virtual=True, is_const=True, visibility='private', is_virtual=True)
    ## ipv6.h (module 'internet'): void ns3::Ipv6::SetIpForward(bool forward) [member function]
    cls.add_method('SetIpForward',
                   'void',
                   [param('bool', 'forward')],
                   is_pure_virtual=True, visibility='private', is_virtual=True)
    ## ipv6.h (module 'internet'): void ns3::Ipv6::SetMtuDiscover(bool mtuDiscover) [member function]
    cls.add_method('SetMtuDiscover',
                   'void',
                   [param('bool', 'mtuDiscover')],
                   is_pure_virtual=True, visibility='private', is_virtual=True)
    return

def register_Ns3Ipv6AddressChecker_methods(root_module, cls):
    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressChecker::Ipv6AddressChecker() [constructor]
    cls.add_constructor([])
    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressChecker::Ipv6AddressChecker(ns3::Ipv6AddressChecker const & arg0) [constructor]
    cls.add_constructor([param('ns3::Ipv6AddressChecker const &', 'arg0')])
    return

def register_Ns3Ipv6AddressValue_methods(root_module, cls):
    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressValue::Ipv6AddressValue() [constructor]
    cls.add_constructor([])
    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressValue::Ipv6AddressValue(ns3::Ipv6Address const & value) [constructor]
    cls.add_constructor([param('ns3::Ipv6Address const &', 'value')])
    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressValue::Ipv6AddressValue(ns3::Ipv6AddressValue const & arg0) [constructor]
    cls.add_constructor([param('ns3::Ipv6AddressValue const &', 'arg0')])
    ## ipv6-address.h (module 'network'): ns3::Ptr<ns3::AttributeValue> ns3::Ipv6AddressValue::Copy() const [member function]
    cls.add_method('Copy',
                   'ns3::Ptr< ns3::AttributeValue >',
                   [],
                   is_const=True, is_virtual=True)
    ## ipv6-address.h (module 'network'): bool ns3::Ipv6AddressValue::DeserializeFromString(std::string value, ns3::Ptr<const ns3::AttributeChecker> checker) [member function]
    cls.add_method('DeserializeFromString',
                   'bool',
                   [param('std::string', 'value'), param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_virtual=True)
    ## ipv6-address.h (module 'network'): ns3::Ipv6Address ns3::Ipv6AddressValue::Get() const [member function]
    cls.add_method('Get',
                   'ns3::Ipv6Address',
                   [],
                   is_const=True)
    ## ipv6-address.h (module 'network'): std::string ns3::Ipv6AddressValue::SerializeToString(ns3::Ptr<const ns3::AttributeChecker> checker) const [member function]
    cls.add_method('SerializeToString',
                   'std::string',
                   [param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_const=True, is_virtual=True)
    ## ipv6-address.h (module 'network'): void ns3::Ipv6AddressValue::Set(ns3::Ipv6Address const & value) [member function]
    cls.add_method('Set',
                   'void',
                   [param('ns3::Ipv6Address const &', 'value')])
    return

def register_Ns3Ipv6PrefixChecker_methods(root_module, cls):
    ## ipv6-address.h (module 'network'): ns3::Ipv6PrefixChecker::Ipv6PrefixChecker() [constructor]
    cls.add_constructor([])
    ## ipv6-address.h (module 'network'): ns3::Ipv6PrefixChecker::Ipv6PrefixChecker(ns3::Ipv6PrefixChecker const & arg0) [constructor]
    cls.add_constructor([param('ns3::Ipv6PrefixChecker const &', 'arg0')])
    return

def register_Ns3Ipv6PrefixValue_methods(root_module, cls):
    ## ipv6-address.h (module 'network'): ns3::Ipv6PrefixValue::Ipv6PrefixValue() [constructor]
    cls.add_constructor([])
    ## ipv6-address.h (module 'network'): ns3::Ipv6PrefixValue::Ipv6PrefixValue(ns3::Ipv6Prefix const & value) [constructor]
    cls.add_constructor([param('ns3::Ipv6Prefix const &', 'value')])
    ## ipv6-address.h (module 'network'): ns3::Ipv6PrefixValue::Ipv6PrefixValue(ns3::Ipv6PrefixValue const & arg0) [constructor]
    cls.add_constructor([param('ns3::Ipv6PrefixValue const &', 'arg0')])
    ## ipv6-address.h (module 'network'): ns3::Ptr<ns3::AttributeValue> ns3::Ipv6PrefixValue::Copy() const [member function]
    cls.add_method('Copy',
                   'ns3::Ptr< ns3::AttributeValue >',
                   [],
                   is_const=True, is_virtual=True)
    ## ipv6-address.h (module 'network'): bool ns3::Ipv6PrefixValue::DeserializeFromString(std::string value, ns3::Ptr<const ns3::AttributeChecker> checker) [member function]
    cls.add_method('DeserializeFromString',
                   'bool',
                   [param('std::string', 'value'), param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_virtual=True)
    ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix ns3::Ipv6PrefixValue::Get() const [member function]
    cls.add_method('Get',
                   'ns3::Ipv6Prefix',
                   [],
                   is_const=True)
    ## ipv6-address.h (module 'network'): std::string ns3::Ipv6PrefixValue::SerializeToString(ns3::Ptr<const ns3::AttributeChecker> checker) const [member function]
    cls.add_method('SerializeToString',
                   'std::string',
                   [param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_const=True, is_virtual=True)
    ## ipv6-address.h (module 'network'): void ns3::Ipv6PrefixValue::Set(ns3::Ipv6Prefix const & value) [member function]
    cls.add_method('Set',
                   'void',
                   [param('ns3::Ipv6Prefix const &', 'value')])
    return

def register_Ns3LogDistancePropagationLossModel_methods(root_module, cls):
    ## propagation-loss-model.h (module 'propagation'): static ns3::TypeId ns3::LogDistancePropagationLossModel::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## propagation-loss-model.h (module 'propagation'): ns3::LogDistancePropagationLossModel::LogDistancePropagationLossModel() [constructor]
    cls.add_constructor([])
    ## propagation-loss-model.h (module 'propagation'): void ns3::LogDistancePropagationLossModel::SetPathLossExponent(double n) [member function]
    cls.add_method('SetPathLossExponent',
                   'void',
                   [param('double', 'n')])
    ## propagation-loss-model.h (module 'propagation'): double ns3::LogDistancePropagationLossModel::GetPathLossExponent() const [member function]
    cls.add_method('GetPathLossExponent',
                   'double',
                   [],
                   is_const=True)
    ## propagation-loss-model.h (module 'propagation'): void ns3::LogDistancePropagationLossModel::SetReference(double referenceDistance, double referenceLoss) [member function]
    cls.add_method('SetReference',
                   'void',
                   [param('double', 'referenceDistance'), param('double', 'referenceLoss')])
    ## propagation-loss-model.h (module 'propagation'): double ns3::LogDistancePropagationLossModel::DoCalcRxPower(double txPowerDbm, ns3::Ptr<ns3::MobilityModel> a, ns3::Ptr<ns3::MobilityModel> b) const [member function]
    cls.add_method('DoCalcRxPower',
                   'double',
                   [param('double', 'txPowerDbm'), param('ns3::Ptr< ns3::MobilityModel >', 'a'), param('ns3::Ptr< ns3::MobilityModel >', 'b')],
                   is_const=True, visibility='private', is_virtual=True)
    ## propagation-loss-model.h (module 'propagation'): int64_t ns3::LogDistancePropagationLossModel::DoAssignStreams(int64_t stream) [member function]
    cls.add_method('DoAssignStreams',
                   'int64_t',
                   [param('int64_t', 'stream')],
                   visibility='private', is_virtual=True)
    return

def register_Ns3LogNormalRandomVariable_methods(root_module, cls):
    ## random-variable-stream.h (module 'core'): static ns3::TypeId ns3::LogNormalRandomVariable::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## random-variable-stream.h (module 'core'): ns3::LogNormalRandomVariable::LogNormalRandomVariable() [constructor]
    cls.add_constructor([])
    ## random-variable-stream.h (module 'core'): double ns3::LogNormalRandomVariable::GetMu() const [member function]
    cls.add_method('GetMu',
                   'double',
                   [],
                   is_const=True)
    ## random-variable-stream.h (module 'core'): double ns3::LogNormalRandomVariable::GetSigma() const [member function]
    cls.add_method('GetSigma',
                   'double',
                   [],
                   is_const=True)
    ## random-variable-stream.h (module 'core'): double ns3::LogNormalRandomVariable::GetValue(double mu, double sigma) [member function]
    cls.add_method('GetValue',
                   'double',
                   [param('double', 'mu'), param('double', 'sigma')])
    ## random-variable-stream.h (module 'core'): uint32_t ns3::LogNormalRandomVariable::GetInteger(uint32_t mu, uint32_t sigma) [member function]
    cls.add_method('GetInteger',
                   'uint32_t',
                   [param('uint32_t', 'mu'), param('uint32_t', 'sigma')])
    ## random-variable-stream.h (module 'core'): double ns3::LogNormalRandomVariable::GetValue() [member function]
    cls.add_method('GetValue',
                   'double',
                   [],
                   is_virtual=True)
    ## random-variable-stream.h (module 'core'): uint32_t ns3::LogNormalRandomVariable::GetInteger() [member function]
    cls.add_method('GetInteger',
                   'uint32_t',
                   [],
                   is_virtual=True)
    return

def register_Ns3LteAmc_methods(root_module, cls):
    ## lte-amc.h (module 'lte'): ns3::LteAmc::LteAmc(ns3::LteAmc const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteAmc const &', 'arg0')])
    ## lte-amc.h (module 'lte'): ns3::LteAmc::LteAmc() [constructor]
    cls.add_constructor([])
    ## lte-amc.h (module 'lte'): std::vector<int, std::allocator<int> > ns3::LteAmc::CreateCqiFeedbacks(ns3::SpectrumValue const & sinr, uint8_t rbgSize=0) [member function]
    cls.add_method('CreateCqiFeedbacks',
                   'std::vector< int >',
                   [param('ns3::SpectrumValue const &', 'sinr'), param('uint8_t', 'rbgSize', default_value='0')])
    ## lte-amc.h (module 'lte'): int ns3::LteAmc::GetCqiFromSpectralEfficiency(double s) [member function]
    cls.add_method('GetCqiFromSpectralEfficiency',
                   'int',
                   [param('double', 's')])
    ## lte-amc.h (module 'lte'): int ns3::LteAmc::GetDlTbSizeFromMcs(int mcs, int nprb) [member function]
    cls.add_method('GetDlTbSizeFromMcs',
                   'int',
                   [param('int', 'mcs'), param('int', 'nprb')])
    ## lte-amc.h (module 'lte'): int ns3::LteAmc::GetMcsFromCqi(int cqi) [member function]
    cls.add_method('GetMcsFromCqi',
                   'int',
                   [param('int', 'cqi')])
    ## lte-amc.h (module 'lte'): double ns3::LteAmc::GetSpectralEfficiencyFromCqi(int cqi) [member function]
    cls.add_method('GetSpectralEfficiencyFromCqi',
                   'double',
                   [param('int', 'cqi')])
    ## lte-amc.h (module 'lte'): static ns3::TypeId ns3::LteAmc::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## lte-amc.h (module 'lte'): int ns3::LteAmc::GetUlTbSizeFromMcs(int mcs, int nprb) [member function]
    cls.add_method('GetUlTbSizeFromMcs',
                   'int',
                   [param('int', 'mcs'), param('int', 'nprb')])
    return

def register_Ns3LteAnr_methods(root_module, cls):
    ## lte-anr.h (module 'lte'): ns3::LteAnr::LteAnr(ns3::LteAnr const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteAnr const &', 'arg0')])
    ## lte-anr.h (module 'lte'): ns3::LteAnr::LteAnr(uint16_t servingCellId) [constructor]
    cls.add_constructor([param('uint16_t', 'servingCellId')])
    ## lte-anr.h (module 'lte'): void ns3::LteAnr::AddNeighbourRelation(uint16_t cellId) [member function]
    cls.add_method('AddNeighbourRelation',
                   'void',
                   [param('uint16_t', 'cellId')])
    ## lte-anr.h (module 'lte'): ns3::LteAnrSapProvider * ns3::LteAnr::GetLteAnrSapProvider() [member function]
    cls.add_method('GetLteAnrSapProvider',
                   'ns3::LteAnrSapProvider *',
                   [],
                   is_virtual=True)
    ## lte-anr.h (module 'lte'): static ns3::TypeId ns3::LteAnr::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## lte-anr.h (module 'lte'): void ns3::LteAnr::RemoveNeighbourRelation(uint16_t cellId) [member function]
    cls.add_method('RemoveNeighbourRelation',
                   'void',
                   [param('uint16_t', 'cellId')])
    ## lte-anr.h (module 'lte'): void ns3::LteAnr::SetLteAnrSapUser(ns3::LteAnrSapUser * s) [member function]
    cls.add_method('SetLteAnrSapUser',
                   'void',
                   [param('ns3::LteAnrSapUser *', 's')],
                   is_virtual=True)
    ## lte-anr.h (module 'lte'): void ns3::LteAnr::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   visibility='protected', is_virtual=True)
    ## lte-anr.h (module 'lte'): void ns3::LteAnr::DoInitialize() [member function]
    cls.add_method('DoInitialize',
                   'void',
                   [],
                   visibility='protected', is_virtual=True)
    return

def register_Ns3LteControlMessage_methods(root_module, cls):
    ## lte-control-messages.h (module 'lte'): ns3::LteControlMessage::LteControlMessage(ns3::LteControlMessage const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteControlMessage const &', 'arg0')])
    ## lte-control-messages.h (module 'lte'): ns3::LteControlMessage::LteControlMessage() [constructor]
    cls.add_constructor([])
    ## lte-control-messages.h (module 'lte'): ns3::LteControlMessage::MessageType ns3::LteControlMessage::GetMessageType() [member function]
    cls.add_method('GetMessageType',
                   'ns3::LteControlMessage::MessageType',
                   [])
    ## lte-control-messages.h (module 'lte'): void ns3::LteControlMessage::SetMessageType(ns3::LteControlMessage::MessageType type) [member function]
    cls.add_method('SetMessageType',
                   'void',
                   [param('ns3::LteControlMessage::MessageType', 'type')])
    return

def register_Ns3LteEnbComponentCarrierManager_methods(root_module, cls):
    ## lte-enb-component-carrier-manager.h (module 'lte'): ns3::LteEnbComponentCarrierManager::LteEnbComponentCarrierManager(ns3::LteEnbComponentCarrierManager const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteEnbComponentCarrierManager const &', 'arg0')])
    ## lte-enb-component-carrier-manager.h (module 'lte'): ns3::LteEnbComponentCarrierManager::LteEnbComponentCarrierManager() [constructor]
    cls.add_constructor([])
    ## lte-enb-component-carrier-manager.h (module 'lte'): ns3::LteCcmMacSapUser * ns3::LteEnbComponentCarrierManager::GetLteCcmMacSapUser() [member function]
    cls.add_method('GetLteCcmMacSapUser',
                   'ns3::LteCcmMacSapUser *',
                   [],
                   is_virtual=True)
    ## lte-enb-component-carrier-manager.h (module 'lte'): ns3::LteCcmRrcSapProvider * ns3::LteEnbComponentCarrierManager::GetLteCcmRrcSapProvider() [member function]
    cls.add_method('GetLteCcmRrcSapProvider',
                   'ns3::LteCcmRrcSapProvider *',
                   [],
                   is_virtual=True)
    ## lte-enb-component-carrier-manager.h (module 'lte'): ns3::LteMacSapProvider * ns3::LteEnbComponentCarrierManager::GetLteMacSapProvider() [member function]
    cls.add_method('GetLteMacSapProvider',
                   'ns3::LteMacSapProvider *',
                   [],
                   is_virtual=True)
    ## lte-enb-component-carrier-manager.h (module 'lte'): static ns3::TypeId ns3::LteEnbComponentCarrierManager::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## lte-enb-component-carrier-manager.h (module 'lte'): void ns3::LteEnbComponentCarrierManager::SetBandwidthMap(std::map<unsigned char, double, std::less<unsigned char>, std::allocator<std::pair<const unsigned char, double> > > bandwidthMap) [member function]
    cls.add_method('SetBandwidthMap',
                   'void',
                   [param('std::map< unsigned char, double >', 'bandwidthMap')],
                   is_virtual=True)
    ## lte-enb-component-carrier-manager.h (module 'lte'): bool ns3::LteEnbComponentCarrierManager::SetCcmMacSapProviders(uint8_t componentCarrierId, ns3::LteCcmMacSapProvider * sap) [member function]
    cls.add_method('SetCcmMacSapProviders',
                   'bool',
                   [param('uint8_t', 'componentCarrierId'), param('ns3::LteCcmMacSapProvider *', 'sap')],
                   is_virtual=True)
    ## lte-enb-component-carrier-manager.h (module 'lte'): void ns3::LteEnbComponentCarrierManager::SetLteCcmRrcSapUser(ns3::LteCcmRrcSapUser * s) [member function]
    cls.add_method('SetLteCcmRrcSapUser',
                   'void',
                   [param('ns3::LteCcmRrcSapUser *', 's')],
                   is_virtual=True)
    ## lte-enb-component-carrier-manager.h (module 'lte'): bool ns3::LteEnbComponentCarrierManager::SetMacSapProvider(uint8_t componentCarrierId, ns3::LteMacSapProvider * sap) [member function]
    cls.add_method('SetMacSapProvider',
                   'bool',
                   [param('uint8_t', 'componentCarrierId'), param('ns3::LteMacSapProvider *', 'sap')],
                   is_virtual=True)
    ## lte-enb-component-carrier-manager.h (module 'lte'): void ns3::LteEnbComponentCarrierManager::SetNumberOfComponentCarriers(uint16_t noOfComponentCarriers) [member function]
    cls.add_method('SetNumberOfComponentCarriers',
                   'void',
                   [param('uint16_t', 'noOfComponentCarriers')],
                   is_virtual=True)
    ## lte-enb-component-carrier-manager.h (module 'lte'): void ns3::LteEnbComponentCarrierManager::SetRrc(ns3::Ptr<ns3::LteEnbRrc> const rrc) [member function]
    cls.add_method('SetRrc',
                   'void',
                   [param('ns3::Ptr< ns3::LteEnbRrc > const', 'rrc')],
                   is_virtual=True)
    ## lte-enb-component-carrier-manager.h (module 'lte'): void ns3::LteEnbComponentCarrierManager::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   visibility='protected', is_virtual=True)
    ## lte-enb-component-carrier-manager.h (module 'lte'): void ns3::LteEnbComponentCarrierManager::DoReportUeMeas(uint16_t rnti, ns3::LteRrcSap::MeasResults measResults) [member function]
    cls.add_method('DoReportUeMeas',
                   'void',
                   [param('uint16_t', 'rnti'), param('ns3::LteRrcSap::MeasResults', 'measResults')],
                   is_pure_virtual=True, visibility='protected', is_virtual=True)
    return

def register_Ns3LteEnbMac_methods(root_module, cls):
    ## lte-enb-mac.h (module 'lte'): ns3::LteEnbMac::LteEnbMac(ns3::LteEnbMac const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteEnbMac const &', 'arg0')])
    ## lte-enb-mac.h (module 'lte'): ns3::LteEnbMac::LteEnbMac() [constructor]
    cls.add_constructor([])
    ## lte-enb-mac.h (module 'lte'): void ns3::LteEnbMac::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## lte-enb-mac.h (module 'lte'): void ns3::LteEnbMac::DoReceivePhyPdu(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('DoReceivePhyPdu',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'p')])
    ## lte-enb-mac.h (module 'lte'): ns3::FfMacCschedSapUser * ns3::LteEnbMac::GetFfMacCschedSapUser() [member function]
    cls.add_method('GetFfMacCschedSapUser',
                   'ns3::FfMacCschedSapUser *',
                   [])
    ## lte-enb-mac.h (module 'lte'): ns3::FfMacSchedSapUser * ns3::LteEnbMac::GetFfMacSchedSapUser() [member function]
    cls.add_method('GetFfMacSchedSapUser',
                   'ns3::FfMacSchedSapUser *',
                   [])
    ## lte-enb-mac.h (module 'lte'): ns3::LteCcmMacSapProvider * ns3::LteEnbMac::GetLteCcmMacSapProvider() [member function]
    cls.add_method('GetLteCcmMacSapProvider',
                   'ns3::LteCcmMacSapProvider *',
                   [])
    ## lte-enb-mac.h (module 'lte'): ns3::LteEnbCmacSapProvider * ns3::LteEnbMac::GetLteEnbCmacSapProvider() [member function]
    cls.add_method('GetLteEnbCmacSapProvider',
                   'ns3::LteEnbCmacSapProvider *',
                   [])
    ## lte-enb-mac.h (module 'lte'): ns3::LteEnbPhySapUser * ns3::LteEnbMac::GetLteEnbPhySapUser() [member function]
    cls.add_method('GetLteEnbPhySapUser',
                   'ns3::LteEnbPhySapUser *',
                   [])
    ## lte-enb-mac.h (module 'lte'): ns3::LteMacSapProvider * ns3::LteEnbMac::GetLteMacSapProvider() [member function]
    cls.add_method('GetLteMacSapProvider',
                   'ns3::LteMacSapProvider *',
                   [])
    ## lte-enb-mac.h (module 'lte'): static ns3::TypeId ns3::LteEnbMac::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## lte-enb-mac.h (module 'lte'): void ns3::LteEnbMac::SetComponentCarrierId(uint8_t index) [member function]
    cls.add_method('SetComponentCarrierId',
                   'void',
                   [param('uint8_t', 'index')])
    ## lte-enb-mac.h (module 'lte'): void ns3::LteEnbMac::SetFfMacCschedSapProvider(ns3::FfMacCschedSapProvider * s) [member function]
    cls.add_method('SetFfMacCschedSapProvider',
                   'void',
                   [param('ns3::FfMacCschedSapProvider *', 's')])
    ## lte-enb-mac.h (module 'lte'): void ns3::LteEnbMac::SetFfMacSchedSapProvider(ns3::FfMacSchedSapProvider * s) [member function]
    cls.add_method('SetFfMacSchedSapProvider',
                   'void',
                   [param('ns3::FfMacSchedSapProvider *', 's')])
    ## lte-enb-mac.h (module 'lte'): void ns3::LteEnbMac::SetLteCcmMacSapUser(ns3::LteCcmMacSapUser * s) [member function]
    cls.add_method('SetLteCcmMacSapUser',
                   'void',
                   [param('ns3::LteCcmMacSapUser *', 's')])
    ## lte-enb-mac.h (module 'lte'): void ns3::LteEnbMac::SetLteEnbCmacSapUser(ns3::LteEnbCmacSapUser * s) [member function]
    cls.add_method('SetLteEnbCmacSapUser',
                   'void',
                   [param('ns3::LteEnbCmacSapUser *', 's')])
    ## lte-enb-mac.h (module 'lte'): void ns3::LteEnbMac::SetLteEnbPhySapProvider(ns3::LteEnbPhySapProvider * s) [member function]
    cls.add_method('SetLteEnbPhySapProvider',
                   'void',
                   [param('ns3::LteEnbPhySapProvider *', 's')])
    ## lte-enb-mac.h (module 'lte'): void ns3::LteEnbMac::SetLteMacSapUser(ns3::LteMacSapUser * s) [member function]
    cls.add_method('SetLteMacSapUser',
                   'void',
                   [param('ns3::LteMacSapUser *', 's')])
    return

def register_Ns3LteEnbRrc_methods(root_module, cls):
    ## lte-enb-rrc.h (module 'lte'): ns3::LteEnbRrc::LteEnbRrc(ns3::LteEnbRrc const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteEnbRrc const &', 'arg0')])
    ## lte-enb-rrc.h (module 'lte'): ns3::LteEnbRrc::LteEnbRrc() [constructor]
    cls.add_constructor([])
    ## lte-enb-rrc.h (module 'lte'): uint8_t ns3::LteEnbRrc::AddUeMeasReportConfig(ns3::LteRrcSap::ReportConfigEutra config) [member function]
    cls.add_method('AddUeMeasReportConfig',
                   'uint8_t',
                   [param('ns3::LteRrcSap::ReportConfigEutra', 'config')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::LteEnbRrc::AddX2Neighbour(uint16_t cellId) [member function]
    cls.add_method('AddX2Neighbour',
                   'void',
                   [param('uint16_t', 'cellId')])
    ## lte-enb-rrc.h (module 'lte'): uint8_t ns3::LteEnbRrc::CellToComponentCarrierId(uint16_t cellId) [member function]
    cls.add_method('CellToComponentCarrierId',
                   'uint8_t',
                   [param('uint16_t', 'cellId')])
    ## lte-enb-rrc.h (module 'lte'): uint16_t ns3::LteEnbRrc::ComponentCarrierToCellId(uint8_t componentCarrierId) [member function]
    cls.add_method('ComponentCarrierToCellId',
                   'uint16_t',
                   [param('uint8_t', 'componentCarrierId')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::LteEnbRrc::ConfigureCarriers(std::map<unsigned char, ns3::Ptr<ns3::ComponentCarrierEnb>, std::less<unsigned char>, std::allocator<std::pair<const unsigned char, ns3::Ptr<ns3::ComponentCarrierEnb> > > > ccPhyConf) [member function]
    cls.add_method('ConfigureCarriers',
                   'void',
                   [param('std::map< unsigned char, ns3::Ptr< ns3::ComponentCarrierEnb > >', 'ccPhyConf')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::LteEnbRrc::ConfigureCell(std::map<unsigned char, ns3::Ptr<ns3::ComponentCarrierEnb>, std::less<unsigned char>, std::allocator<std::pair<const unsigned char, ns3::Ptr<ns3::ComponentCarrierEnb> > > > ccPhyConf) [member function]
    cls.add_method('ConfigureCell',
                   'void',
                   [param('std::map< unsigned char, ns3::Ptr< ns3::ComponentCarrierEnb > >', 'ccPhyConf')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::LteEnbRrc::ConfigureCell(std::map<unsigned char, ns3::LteEnbRrc::MmWaveComponentCarrierConf, std::less<unsigned char>, std::allocator<std::pair<const unsigned char, ns3::LteEnbRrc::MmWaveComponentCarrierConf> > > ccPhyConf) [member function]
    cls.add_method('ConfigureCell',
                   'void',
                   [param('std::map< unsigned char, ns3::LteEnbRrc::MmWaveComponentCarrierConf >', 'ccPhyConf')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::LteEnbRrc::ConfigureMmWaveCarriers(std::map<unsigned char, ns3::LteEnbRrc::MmWaveComponentCarrierConf, std::less<unsigned char>, std::allocator<std::pair<const unsigned char, ns3::LteEnbRrc::MmWaveComponentCarrierConf> > > ccPhyConf) [member function]
    cls.add_method('ConfigureMmWaveCarriers',
                   'void',
                   [param('std::map< unsigned char, ns3::LteEnbRrc::MmWaveComponentCarrierConf >', 'ccPhyConf')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::LteEnbRrc::ConnectionRejectedTimeout(uint16_t rnti) [member function]
    cls.add_method('ConnectionRejectedTimeout',
                   'void',
                   [param('uint16_t', 'rnti')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::LteEnbRrc::ConnectionRequestTimeout(uint16_t rnti) [member function]
    cls.add_method('ConnectionRequestTimeout',
                   'void',
                   [param('uint16_t', 'rnti')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::LteEnbRrc::ConnectionSetupTimeout(uint16_t rnti) [member function]
    cls.add_method('ConnectionSetupTimeout',
                   'void',
                   [param('uint16_t', 'rnti')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::LteEnbRrc::DoSendReleaseDataRadioBearer(uint64_t imsi, uint16_t rnti, uint8_t bearerId) [member function]
    cls.add_method('DoSendReleaseDataRadioBearer',
                   'void',
                   [param('uint64_t', 'imsi'), param('uint16_t', 'rnti'), param('uint8_t', 'bearerId')])
    ## lte-enb-rrc.h (module 'lte'): uint16_t ns3::LteEnbRrc::GetCellId() const [member function]
    cls.add_method('GetCellId',
                   'uint16_t',
                   [],
                   is_const=True)
    ## lte-enb-rrc.h (module 'lte'): ns3::EpcX2PdcpProvider * ns3::LteEnbRrc::GetEpcX2PdcpProvider() const [member function]
    cls.add_method('GetEpcX2PdcpProvider',
                   'ns3::EpcX2PdcpProvider *',
                   [],
                   is_const=True)
    ## lte-enb-rrc.h (module 'lte'): ns3::EpcX2RlcProvider * ns3::LteEnbRrc::GetEpcX2RlcProvider() const [member function]
    cls.add_method('GetEpcX2RlcProvider',
                   'ns3::EpcX2RlcProvider *',
                   [],
                   is_const=True)
    ## lte-enb-rrc.h (module 'lte'): ns3::EpcX2SapUser * ns3::LteEnbRrc::GetEpcX2SapUser() [member function]
    cls.add_method('GetEpcX2SapUser',
                   'ns3::EpcX2SapUser *',
                   [])
    ## lte-enb-rrc.h (module 'lte'): uint64_t ns3::LteEnbRrc::GetImsiFromRnti(uint16_t rnti) [member function]
    cls.add_method('GetImsiFromRnti',
                   'uint64_t',
                   [param('uint16_t', 'rnti')])
    ## lte-enb-rrc.h (module 'lte'): ns3::LteAnrSapUser * ns3::LteEnbRrc::GetLteAnrSapUser() [member function]
    cls.add_method('GetLteAnrSapUser',
                   'ns3::LteAnrSapUser *',
                   [])
    ## lte-enb-rrc.h (module 'lte'): ns3::LteCcmRrcSapUser * ns3::LteEnbRrc::GetLteCcmRrcSapUser() [member function]
    cls.add_method('GetLteCcmRrcSapUser',
                   'ns3::LteCcmRrcSapUser *',
                   [])
    ## lte-enb-rrc.h (module 'lte'): ns3::LteEnbCmacSapUser * ns3::LteEnbRrc::GetLteEnbCmacSapUser() [member function]
    cls.add_method('GetLteEnbCmacSapUser',
                   'ns3::LteEnbCmacSapUser *',
                   [])
    ## lte-enb-rrc.h (module 'lte'): ns3::LteEnbCmacSapUser * ns3::LteEnbRrc::GetLteEnbCmacSapUser(uint8_t pos) [member function]
    cls.add_method('GetLteEnbCmacSapUser',
                   'ns3::LteEnbCmacSapUser *',
                   [param('uint8_t', 'pos')])
    ## lte-enb-rrc.h (module 'lte'): ns3::LteEnbCphySapUser * ns3::LteEnbRrc::GetLteEnbCphySapUser() [member function]
    cls.add_method('GetLteEnbCphySapUser',
                   'ns3::LteEnbCphySapUser *',
                   [])
    ## lte-enb-rrc.h (module 'lte'): ns3::LteEnbCphySapUser * ns3::LteEnbRrc::GetLteEnbCphySapUser(uint8_t pos) [member function]
    cls.add_method('GetLteEnbCphySapUser',
                   'ns3::LteEnbCphySapUser *',
                   [param('uint8_t', 'pos')])
    ## lte-enb-rrc.h (module 'lte'): ns3::LteEnbRrcSapProvider * ns3::LteEnbRrc::GetLteEnbRrcSapProvider() [member function]
    cls.add_method('GetLteEnbRrcSapProvider',
                   'ns3::LteEnbRrcSapProvider *',
                   [])
    ## lte-enb-rrc.h (module 'lte'): ns3::LteFfrRrcSapUser * ns3::LteEnbRrc::GetLteFfrRrcSapUser() [member function]
    cls.add_method('GetLteFfrRrcSapUser',
                   'ns3::LteFfrRrcSapUser *',
                   [])
    ## lte-enb-rrc.h (module 'lte'): ns3::LteFfrRrcSapUser * ns3::LteEnbRrc::GetLteFfrRrcSapUser(uint8_t index) [member function]
    cls.add_method('GetLteFfrRrcSapUser',
                   'ns3::LteFfrRrcSapUser *',
                   [param('uint8_t', 'index')])
    ## lte-enb-rrc.h (module 'lte'): ns3::LteHandoverManagementSapUser * ns3::LteEnbRrc::GetLteHandoverManagementSapUser() [member function]
    cls.add_method('GetLteHandoverManagementSapUser',
                   'ns3::LteHandoverManagementSapUser *',
                   [])
    ## lte-enb-rrc.h (module 'lte'): uint16_t ns3::LteEnbRrc::GetRntiFromImsi(uint64_t imsi) [member function]
    cls.add_method('GetRntiFromImsi',
                   'uint16_t',
                   [param('uint64_t', 'imsi')])
    ## lte-enb-rrc.h (module 'lte'): ns3::EpcEnbS1SapUser * ns3::LteEnbRrc::GetS1SapUser() [member function]
    cls.add_method('GetS1SapUser',
                   'ns3::EpcEnbS1SapUser *',
                   [])
    ## lte-enb-rrc.h (module 'lte'): uint32_t ns3::LteEnbRrc::GetSrsPeriodicity() const [member function]
    cls.add_method('GetSrsPeriodicity',
                   'uint32_t',
                   [],
                   is_const=True)
    ## lte-enb-rrc.h (module 'lte'): static ns3::TypeId ns3::LteEnbRrc::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## lte-enb-rrc.h (module 'lte'): ns3::Ptr<ns3::UeManager> ns3::LteEnbRrc::GetUeManager(uint16_t rnti) [member function]
    cls.add_method('GetUeManager',
                   'ns3::Ptr< ns3::UeManager >',
                   [param('uint16_t', 'rnti')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::LteEnbRrc::HandoverJoiningTimeout(uint16_t rnti) [member function]
    cls.add_method('HandoverJoiningTimeout',
                   'void',
                   [param('uint16_t', 'rnti')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::LteEnbRrc::HandoverLeavingTimeout(uint16_t rnti) [member function]
    cls.add_method('HandoverLeavingTimeout',
                   'void',
                   [param('uint16_t', 'rnti')])
    ## lte-enb-rrc.h (module 'lte'): bool ns3::LteEnbRrc::HasUeManager(uint16_t rnti) const [member function]
    cls.add_method('HasUeManager',
                   'bool',
                   [param('uint16_t', 'rnti')],
                   is_const=True)
    ## lte-enb-rrc.h (module 'lte'): void ns3::LteEnbRrc::RegisterImsiToRnti(uint64_t imsi, uint16_t rnti) [member function]
    cls.add_method('RegisterImsiToRnti',
                   'void',
                   [param('uint64_t', 'imsi'), param('uint16_t', 'rnti')])
    ## lte-enb-rrc.h (module 'lte'): bool ns3::LteEnbRrc::SendData(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('SendData',
                   'bool',
                   [param('ns3::Ptr< ns3::Packet >', 'p')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::LteEnbRrc::SendHandoverRequest(uint16_t rnti, uint16_t cellId) [member function]
    cls.add_method('SendHandoverRequest',
                   'void',
                   [param('uint16_t', 'rnti'), param('uint16_t', 'cellId')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::LteEnbRrc::SetCellId(uint16_t m_cellId) [member function]
    cls.add_method('SetCellId',
                   'void',
                   [param('uint16_t', 'm_cellId')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::LteEnbRrc::SetCellId(uint16_t m_cellId, uint8_t ccIndex) [member function]
    cls.add_method('SetCellId',
                   'void',
                   [param('uint16_t', 'm_cellId'), param('uint8_t', 'ccIndex')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::LteEnbRrc::SetClosestLteCellId(uint16_t cellId) [member function]
    cls.add_method('SetClosestLteCellId',
                   'void',
                   [param('uint16_t', 'cellId')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::LteEnbRrc::SetCsgId(uint32_t csgId, bool csgIndication) [member function]
    cls.add_method('SetCsgId',
                   'void',
                   [param('uint32_t', 'csgId'), param('bool', 'csgIndication')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::LteEnbRrc::SetEpcX2PdcpProvider(ns3::EpcX2PdcpProvider * s) [member function]
    cls.add_method('SetEpcX2PdcpProvider',
                   'void',
                   [param('ns3::EpcX2PdcpProvider *', 's')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::LteEnbRrc::SetEpcX2RlcProvider(ns3::EpcX2RlcProvider * s) [member function]
    cls.add_method('SetEpcX2RlcProvider',
                   'void',
                   [param('ns3::EpcX2RlcProvider *', 's')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::LteEnbRrc::SetEpcX2SapProvider(ns3::EpcX2SapProvider * s) [member function]
    cls.add_method('SetEpcX2SapProvider',
                   'void',
                   [param('ns3::EpcX2SapProvider *', 's')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::LteEnbRrc::SetForwardUpCallback(ns3::Callback<void, ns3::Ptr<ns3::Packet>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> cb) [member function]
    cls.add_method('SetForwardUpCallback',
                   'void',
                   [param('ns3::Callback< void, ns3::Ptr< ns3::Packet >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'cb')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::LteEnbRrc::SetInterRatHoMode() [member function]
    cls.add_method('SetInterRatHoMode',
                   'void',
                   [])
    ## lte-enb-rrc.h (module 'lte'): void ns3::LteEnbRrc::SetLteAnrSapProvider(ns3::LteAnrSapProvider * s) [member function]
    cls.add_method('SetLteAnrSapProvider',
                   'void',
                   [param('ns3::LteAnrSapProvider *', 's')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::LteEnbRrc::SetLteCcmRrcSapProvider(ns3::LteCcmRrcSapProvider * s) [member function]
    cls.add_method('SetLteCcmRrcSapProvider',
                   'void',
                   [param('ns3::LteCcmRrcSapProvider *', 's')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::LteEnbRrc::SetLteEnbCmacSapProvider(ns3::LteEnbCmacSapProvider * s) [member function]
    cls.add_method('SetLteEnbCmacSapProvider',
                   'void',
                   [param('ns3::LteEnbCmacSapProvider *', 's')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::LteEnbRrc::SetLteEnbCmacSapProvider(ns3::LteEnbCmacSapProvider * s, uint8_t pos) [member function]
    cls.add_method('SetLteEnbCmacSapProvider',
                   'void',
                   [param('ns3::LteEnbCmacSapProvider *', 's'), param('uint8_t', 'pos')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::LteEnbRrc::SetLteEnbCphySapProvider(ns3::LteEnbCphySapProvider * s) [member function]
    cls.add_method('SetLteEnbCphySapProvider',
                   'void',
                   [param('ns3::LteEnbCphySapProvider *', 's')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::LteEnbRrc::SetLteEnbCphySapProvider(ns3::LteEnbCphySapProvider * s, uint8_t pos) [member function]
    cls.add_method('SetLteEnbCphySapProvider',
                   'void',
                   [param('ns3::LteEnbCphySapProvider *', 's'), param('uint8_t', 'pos')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::LteEnbRrc::SetLteEnbRrcSapUser(ns3::LteEnbRrcSapUser * s) [member function]
    cls.add_method('SetLteEnbRrcSapUser',
                   'void',
                   [param('ns3::LteEnbRrcSapUser *', 's')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::LteEnbRrc::SetLteFfrRrcSapProvider(ns3::LteFfrRrcSapProvider * s) [member function]
    cls.add_method('SetLteFfrRrcSapProvider',
                   'void',
                   [param('ns3::LteFfrRrcSapProvider *', 's')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::LteEnbRrc::SetLteFfrRrcSapProvider(ns3::LteFfrRrcSapProvider * s, uint8_t index) [member function]
    cls.add_method('SetLteFfrRrcSapProvider',
                   'void',
                   [param('ns3::LteFfrRrcSapProvider *', 's'), param('uint8_t', 'index')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::LteEnbRrc::SetLteHandoverManagementSapProvider(ns3::LteHandoverManagementSapProvider * s) [member function]
    cls.add_method('SetLteHandoverManagementSapProvider',
                   'void',
                   [param('ns3::LteHandoverManagementSapProvider *', 's')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::LteEnbRrc::SetLteMacSapProvider(ns3::LteMacSapProvider * s) [member function]
    cls.add_method('SetLteMacSapProvider',
                   'void',
                   [param('ns3::LteMacSapProvider *', 's')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::LteEnbRrc::SetNumberOfComponentCarriers(uint16_t numberOfComponentCarriers) [member function]
    cls.add_method('SetNumberOfComponentCarriers',
                   'void',
                   [param('uint16_t', 'numberOfComponentCarriers')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::LteEnbRrc::SetS1SapProvider(ns3::EpcEnbS1SapProvider * s) [member function]
    cls.add_method('SetS1SapProvider',
                   'void',
                   [param('ns3::EpcEnbS1SapProvider *', 's')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::LteEnbRrc::SetSrsPeriodicity(uint32_t p) [member function]
    cls.add_method('SetSrsPeriodicity',
                   'void',
                   [param('uint32_t', 'p')])
    ## lte-enb-rrc.h (module 'lte'): void ns3::LteEnbRrc::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   visibility='protected', is_virtual=True)
    return

def register_Ns3LteEnbRrcHandoverEventInfo_methods(root_module, cls):
    ## lte-enb-rrc.h (module 'lte'): ns3::LteEnbRrc::HandoverEventInfo::HandoverEventInfo() [constructor]
    cls.add_constructor([])
    ## lte-enb-rrc.h (module 'lte'): ns3::LteEnbRrc::HandoverEventInfo::HandoverEventInfo(ns3::LteEnbRrc::HandoverEventInfo const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteEnbRrc::HandoverEventInfo const &', 'arg0')])
    ## lte-enb-rrc.h (module 'lte'): ns3::LteEnbRrc::HandoverEventInfo::scheduledHandoverEvent [variable]
    cls.add_instance_attribute('scheduledHandoverEvent', 'ns3::EventId', is_const=False)
    ## lte-enb-rrc.h (module 'lte'): ns3::LteEnbRrc::HandoverEventInfo::sourceCellId [variable]
    cls.add_instance_attribute('sourceCellId', 'uint16_t', is_const=False)
    ## lte-enb-rrc.h (module 'lte'): ns3::LteEnbRrc::HandoverEventInfo::targetCellId [variable]
    cls.add_instance_attribute('targetCellId', 'uint16_t', is_const=False)
    return

def register_Ns3LteEnbRrcMmWaveComponentCarrierConf_methods(root_module, cls):
    ## lte-enb-rrc.h (module 'lte'): ns3::LteEnbRrc::MmWaveComponentCarrierConf::MmWaveComponentCarrierConf() [constructor]
    cls.add_constructor([])
    ## lte-enb-rrc.h (module 'lte'): ns3::LteEnbRrc::MmWaveComponentCarrierConf::MmWaveComponentCarrierConf(ns3::LteEnbRrc::MmWaveComponentCarrierConf const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteEnbRrc::MmWaveComponentCarrierConf const &', 'arg0')])
    ## lte-enb-rrc.h (module 'lte'): ns3::LteEnbRrc::MmWaveComponentCarrierConf::m_bandwidth [variable]
    cls.add_instance_attribute('m_bandwidth', 'uint32_t', is_const=False)
    ## lte-enb-rrc.h (module 'lte'): ns3::LteEnbRrc::MmWaveComponentCarrierConf::m_ccId [variable]
    cls.add_instance_attribute('m_ccId', 'uint8_t', is_const=False)
    ## lte-enb-rrc.h (module 'lte'): ns3::LteEnbRrc::MmWaveComponentCarrierConf::m_cellId [variable]
    cls.add_instance_attribute('m_cellId', 'uint16_t', is_const=False)
    return

def register_Ns3LteFfrAlgorithm_methods(root_module, cls):
    ## lte-ffr-algorithm.h (module 'lte'): ns3::LteFfrAlgorithm::LteFfrAlgorithm(ns3::LteFfrAlgorithm const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteFfrAlgorithm const &', 'arg0')])
    ## lte-ffr-algorithm.h (module 'lte'): ns3::LteFfrAlgorithm::LteFfrAlgorithm() [constructor]
    cls.add_constructor([])
    ## lte-ffr-algorithm.h (module 'lte'): uint8_t ns3::LteFfrAlgorithm::GetDlBandwidth() const [member function]
    cls.add_method('GetDlBandwidth',
                   'uint8_t',
                   [],
                   is_const=True)
    ## lte-ffr-algorithm.h (module 'lte'): uint8_t ns3::LteFfrAlgorithm::GetFrCellTypeId() const [member function]
    cls.add_method('GetFrCellTypeId',
                   'uint8_t',
                   [],
                   is_const=True)
    ## lte-ffr-algorithm.h (module 'lte'): ns3::LteFfrRrcSapProvider * ns3::LteFfrAlgorithm::GetLteFfrRrcSapProvider() [member function]
    cls.add_method('GetLteFfrRrcSapProvider',
                   'ns3::LteFfrRrcSapProvider *',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ffr-algorithm.h (module 'lte'): ns3::LteFfrSapProvider * ns3::LteFfrAlgorithm::GetLteFfrSapProvider() [member function]
    cls.add_method('GetLteFfrSapProvider',
                   'ns3::LteFfrSapProvider *',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ffr-algorithm.h (module 'lte'): static ns3::TypeId ns3::LteFfrAlgorithm::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## lte-ffr-algorithm.h (module 'lte'): uint8_t ns3::LteFfrAlgorithm::GetUlBandwidth() const [member function]
    cls.add_method('GetUlBandwidth',
                   'uint8_t',
                   [],
                   is_const=True)
    ## lte-ffr-algorithm.h (module 'lte'): void ns3::LteFfrAlgorithm::SetDlBandwidth(uint8_t bw) [member function]
    cls.add_method('SetDlBandwidth',
                   'void',
                   [param('uint8_t', 'bw')])
    ## lte-ffr-algorithm.h (module 'lte'): void ns3::LteFfrAlgorithm::SetFrCellTypeId(uint8_t cellTypeId) [member function]
    cls.add_method('SetFrCellTypeId',
                   'void',
                   [param('uint8_t', 'cellTypeId')])
    ## lte-ffr-algorithm.h (module 'lte'): void ns3::LteFfrAlgorithm::SetLteFfrRrcSapUser(ns3::LteFfrRrcSapUser * s) [member function]
    cls.add_method('SetLteFfrRrcSapUser',
                   'void',
                   [param('ns3::LteFfrRrcSapUser *', 's')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ffr-algorithm.h (module 'lte'): void ns3::LteFfrAlgorithm::SetLteFfrSapUser(ns3::LteFfrSapUser * s) [member function]
    cls.add_method('SetLteFfrSapUser',
                   'void',
                   [param('ns3::LteFfrSapUser *', 's')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-ffr-algorithm.h (module 'lte'): void ns3::LteFfrAlgorithm::SetUlBandwidth(uint8_t bw) [member function]
    cls.add_method('SetUlBandwidth',
                   'void',
                   [param('uint8_t', 'bw')])
    ## lte-ffr-algorithm.h (module 'lte'): void ns3::LteFfrAlgorithm::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   visibility='protected', is_virtual=True)
    ## lte-ffr-algorithm.h (module 'lte'): std::vector<bool, std::allocator<bool> > ns3::LteFfrAlgorithm::DoGetAvailableDlRbg() [member function]
    cls.add_method('DoGetAvailableDlRbg',
                   'std::vector< bool >',
                   [],
                   is_pure_virtual=True, visibility='protected', is_virtual=True)
    ## lte-ffr-algorithm.h (module 'lte'): std::vector<bool, std::allocator<bool> > ns3::LteFfrAlgorithm::DoGetAvailableUlRbg() [member function]
    cls.add_method('DoGetAvailableUlRbg',
                   'std::vector< bool >',
                   [],
                   is_pure_virtual=True, visibility='protected', is_virtual=True)
    ## lte-ffr-algorithm.h (module 'lte'): uint8_t ns3::LteFfrAlgorithm::DoGetMinContinuousUlBandwidth() [member function]
    cls.add_method('DoGetMinContinuousUlBandwidth',
                   'uint8_t',
                   [],
                   is_pure_virtual=True, visibility='protected', is_virtual=True)
    ## lte-ffr-algorithm.h (module 'lte'): uint8_t ns3::LteFfrAlgorithm::DoGetTpc(uint16_t rnti) [member function]
    cls.add_method('DoGetTpc',
                   'uint8_t',
                   [param('uint16_t', 'rnti')],
                   is_pure_virtual=True, visibility='protected', is_virtual=True)
    ## lte-ffr-algorithm.h (module 'lte'): bool ns3::LteFfrAlgorithm::DoIsDlRbgAvailableForUe(int rbId, uint16_t rnti) [member function]
    cls.add_method('DoIsDlRbgAvailableForUe',
                   'bool',
                   [param('int', 'rbId'), param('uint16_t', 'rnti')],
                   is_pure_virtual=True, visibility='protected', is_virtual=True)
    ## lte-ffr-algorithm.h (module 'lte'): bool ns3::LteFfrAlgorithm::DoIsUlRbgAvailableForUe(int rbId, uint16_t rnti) [member function]
    cls.add_method('DoIsUlRbgAvailableForUe',
                   'bool',
                   [param('int', 'rbId'), param('uint16_t', 'rnti')],
                   is_pure_virtual=True, visibility='protected', is_virtual=True)
    ## lte-ffr-algorithm.h (module 'lte'): void ns3::LteFfrAlgorithm::DoRecvLoadInformation(ns3::EpcX2Sap::LoadInformationParams params) [member function]
    cls.add_method('DoRecvLoadInformation',
                   'void',
                   [param('ns3::EpcX2Sap::LoadInformationParams', 'params')],
                   is_pure_virtual=True, visibility='protected', is_virtual=True)
    ## lte-ffr-algorithm.h (module 'lte'): void ns3::LteFfrAlgorithm::DoReportDlCqiInfo(ns3::FfMacSchedSapProvider::SchedDlCqiInfoReqParameters const & params) [member function]
    cls.add_method('DoReportDlCqiInfo',
                   'void',
                   [param('ns3::FfMacSchedSapProvider::SchedDlCqiInfoReqParameters const &', 'params')],
                   is_pure_virtual=True, visibility='protected', is_virtual=True)
    ## lte-ffr-algorithm.h (module 'lte'): void ns3::LteFfrAlgorithm::DoReportUeMeas(uint16_t rnti, ns3::LteRrcSap::MeasResults measResults) [member function]
    cls.add_method('DoReportUeMeas',
                   'void',
                   [param('uint16_t', 'rnti'), param('ns3::LteRrcSap::MeasResults', 'measResults')],
                   is_pure_virtual=True, visibility='protected', is_virtual=True)
    ## lte-ffr-algorithm.h (module 'lte'): void ns3::LteFfrAlgorithm::DoReportUlCqiInfo(ns3::FfMacSchedSapProvider::SchedUlCqiInfoReqParameters const & params) [member function]
    cls.add_method('DoReportUlCqiInfo',
                   'void',
                   [param('ns3::FfMacSchedSapProvider::SchedUlCqiInfoReqParameters const &', 'params')],
                   is_pure_virtual=True, visibility='protected', is_virtual=True)
    ## lte-ffr-algorithm.h (module 'lte'): void ns3::LteFfrAlgorithm::DoReportUlCqiInfo(std::map<unsigned short, std::vector<double, std::allocator<double> >, std::less<unsigned short>, std::allocator<std::pair<const unsigned short, std::vector<double, std::allocator<double> > > > > ulCqiMap) [member function]
    cls.add_method('DoReportUlCqiInfo',
                   'void',
                   [param('std::map< unsigned short, std::vector< double > >', 'ulCqiMap')],
                   is_pure_virtual=True, visibility='protected', is_virtual=True)
    ## lte-ffr-algorithm.h (module 'lte'): void ns3::LteFfrAlgorithm::DoSetBandwidth(uint8_t ulBandwidth, uint8_t dlBandwidth) [member function]
    cls.add_method('DoSetBandwidth',
                   'void',
                   [param('uint8_t', 'ulBandwidth'), param('uint8_t', 'dlBandwidth')],
                   visibility='protected', is_virtual=True)
    ## lte-ffr-algorithm.h (module 'lte'): void ns3::LteFfrAlgorithm::DoSetCellId(uint16_t cellId) [member function]
    cls.add_method('DoSetCellId',
                   'void',
                   [param('uint16_t', 'cellId')],
                   visibility='protected', is_virtual=True)
    ## lte-ffr-algorithm.h (module 'lte'): int ns3::LteFfrAlgorithm::GetRbgSize(int dlbandwidth) [member function]
    cls.add_method('GetRbgSize',
                   'int',
                   [param('int', 'dlbandwidth')],
                   visibility='protected')
    ## lte-ffr-algorithm.h (module 'lte'): void ns3::LteFfrAlgorithm::Reconfigure() [member function]
    cls.add_method('Reconfigure',
                   'void',
                   [],
                   is_pure_virtual=True, visibility='protected', is_virtual=True)
    return

def register_Ns3LteHandoverAlgorithm_methods(root_module, cls):
    ## lte-handover-algorithm.h (module 'lte'): ns3::LteHandoverAlgorithm::LteHandoverAlgorithm(ns3::LteHandoverAlgorithm const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteHandoverAlgorithm const &', 'arg0')])
    ## lte-handover-algorithm.h (module 'lte'): ns3::LteHandoverAlgorithm::LteHandoverAlgorithm() [constructor]
    cls.add_constructor([])
    ## lte-handover-algorithm.h (module 'lte'): ns3::LteHandoverManagementSapProvider * ns3::LteHandoverAlgorithm::GetLteHandoverManagementSapProvider() [member function]
    cls.add_method('GetLteHandoverManagementSapProvider',
                   'ns3::LteHandoverManagementSapProvider *',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-handover-algorithm.h (module 'lte'): static ns3::TypeId ns3::LteHandoverAlgorithm::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## lte-handover-algorithm.h (module 'lte'): void ns3::LteHandoverAlgorithm::SetLteHandoverManagementSapUser(ns3::LteHandoverManagementSapUser * s) [member function]
    cls.add_method('SetLteHandoverManagementSapUser',
                   'void',
                   [param('ns3::LteHandoverManagementSapUser *', 's')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-handover-algorithm.h (module 'lte'): void ns3::LteHandoverAlgorithm::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   visibility='protected', is_virtual=True)
    ## lte-handover-algorithm.h (module 'lte'): void ns3::LteHandoverAlgorithm::DoReportUeMeas(uint16_t rnti, ns3::LteRrcSap::MeasResults measResults) [member function]
    cls.add_method('DoReportUeMeas',
                   'void',
                   [param('uint16_t', 'rnti'), param('ns3::LteRrcSap::MeasResults', 'measResults')],
                   is_pure_virtual=True, visibility='protected', is_virtual=True)
    return

def register_Ns3LteHarqPhy_methods(root_module, cls):
    ## lte-harq-phy.h (module 'lte'): ns3::LteHarqPhy::LteHarqPhy(ns3::LteHarqPhy const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteHarqPhy const &', 'arg0')])
    ## lte-harq-phy.h (module 'lte'): ns3::LteHarqPhy::LteHarqPhy() [constructor]
    cls.add_constructor([])
    ## lte-harq-phy.h (module 'lte'): double ns3::LteHarqPhy::GetAccumulatedMiDl(uint8_t harqProcId, uint8_t layer) [member function]
    cls.add_method('GetAccumulatedMiDl',
                   'double',
                   [param('uint8_t', 'harqProcId'), param('uint8_t', 'layer')])
    ## lte-harq-phy.h (module 'lte'): double ns3::LteHarqPhy::GetAccumulatedMiUl(uint16_t rnti) [member function]
    cls.add_method('GetAccumulatedMiUl',
                   'double',
                   [param('uint16_t', 'rnti')])
    ## lte-harq-phy.h (module 'lte'): ns3::HarqProcessInfoList_t ns3::LteHarqPhy::GetHarqProcessInfoDl(uint8_t harqProcId, uint8_t layer) [member function]
    cls.add_method('GetHarqProcessInfoDl',
                   'ns3::HarqProcessInfoList_t',
                   [param('uint8_t', 'harqProcId'), param('uint8_t', 'layer')])
    ## lte-harq-phy.h (module 'lte'): ns3::HarqProcessInfoList_t ns3::LteHarqPhy::GetHarqProcessInfoUl(uint16_t rnti, uint8_t harqProcId) [member function]
    cls.add_method('GetHarqProcessInfoUl',
                   'ns3::HarqProcessInfoList_t',
                   [param('uint16_t', 'rnti'), param('uint8_t', 'harqProcId')])
    ## lte-harq-phy.h (module 'lte'): void ns3::LteHarqPhy::ResetDlHarqProcessStatus(uint8_t id) [member function]
    cls.add_method('ResetDlHarqProcessStatus',
                   'void',
                   [param('uint8_t', 'id')])
    ## lte-harq-phy.h (module 'lte'): void ns3::LteHarqPhy::ResetUlHarqProcessStatus(uint16_t rnti, uint8_t id) [member function]
    cls.add_method('ResetUlHarqProcessStatus',
                   'void',
                   [param('uint16_t', 'rnti'), param('uint8_t', 'id')])
    ## lte-harq-phy.h (module 'lte'): void ns3::LteHarqPhy::SubframeIndication(uint32_t frameNo, uint32_t subframeNo) [member function]
    cls.add_method('SubframeIndication',
                   'void',
                   [param('uint32_t', 'frameNo'), param('uint32_t', 'subframeNo')])
    ## lte-harq-phy.h (module 'lte'): void ns3::LteHarqPhy::UpdateDlHarqProcessStatus(uint8_t id, uint8_t layer, double mi, uint16_t infoBytes, uint16_t codeBytes) [member function]
    cls.add_method('UpdateDlHarqProcessStatus',
                   'void',
                   [param('uint8_t', 'id'), param('uint8_t', 'layer'), param('double', 'mi'), param('uint16_t', 'infoBytes'), param('uint16_t', 'codeBytes')])
    ## lte-harq-phy.h (module 'lte'): void ns3::LteHarqPhy::UpdateUlHarqProcessStatus(uint16_t rnti, double mi, uint16_t infoBytes, uint16_t codeBytes) [member function]
    cls.add_method('UpdateUlHarqProcessStatus',
                   'void',
                   [param('uint16_t', 'rnti'), param('double', 'mi'), param('uint16_t', 'infoBytes'), param('uint16_t', 'codeBytes')])
    return

def register_Ns3LteInterference_methods(root_module, cls):
    ## lte-interference.h (module 'lte'): ns3::LteInterference::LteInterference(ns3::LteInterference const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteInterference const &', 'arg0')])
    ## lte-interference.h (module 'lte'): ns3::LteInterference::LteInterference() [constructor]
    cls.add_constructor([])
    ## lte-interference.h (module 'lte'): void ns3::LteInterference::AddInterferenceChunkProcessor(ns3::Ptr<ns3::LteChunkProcessor> p) [member function]
    cls.add_method('AddInterferenceChunkProcessor',
                   'void',
                   [param('ns3::Ptr< ns3::LteChunkProcessor >', 'p')])
    ## lte-interference.h (module 'lte'): void ns3::LteInterference::AddRsPowerChunkProcessor(ns3::Ptr<ns3::LteChunkProcessor> p) [member function]
    cls.add_method('AddRsPowerChunkProcessor',
                   'void',
                   [param('ns3::Ptr< ns3::LteChunkProcessor >', 'p')])
    ## lte-interference.h (module 'lte'): void ns3::LteInterference::AddSignal(ns3::Ptr<const ns3::SpectrumValue> spd, ns3::Time const duration) [member function]
    cls.add_method('AddSignal',
                   'void',
                   [param('ns3::Ptr< ns3::SpectrumValue const >', 'spd'), param('ns3::Time const', 'duration')])
    ## lte-interference.h (module 'lte'): void ns3::LteInterference::AddSinrChunkProcessor(ns3::Ptr<ns3::LteChunkProcessor> p) [member function]
    cls.add_method('AddSinrChunkProcessor',
                   'void',
                   [param('ns3::Ptr< ns3::LteChunkProcessor >', 'p')])
    ## lte-interference.h (module 'lte'): void ns3::LteInterference::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## lte-interference.h (module 'lte'): void ns3::LteInterference::EndRx() [member function]
    cls.add_method('EndRx',
                   'void',
                   [])
    ## lte-interference.h (module 'lte'): static ns3::TypeId ns3::LteInterference::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## lte-interference.h (module 'lte'): void ns3::LteInterference::SetNoisePowerSpectralDensity(ns3::Ptr<const ns3::SpectrumValue> noisePsd) [member function]
    cls.add_method('SetNoisePowerSpectralDensity',
                   'void',
                   [param('ns3::Ptr< ns3::SpectrumValue const >', 'noisePsd')])
    ## lte-interference.h (module 'lte'): void ns3::LteInterference::StartRx(ns3::Ptr<const ns3::SpectrumValue> rxPsd) [member function]
    cls.add_method('StartRx',
                   'void',
                   [param('ns3::Ptr< ns3::SpectrumValue const >', 'rxPsd')])
    return

def register_Ns3LtePdcp_methods(root_module, cls):
    ## lte-pdcp.h (module 'lte'): ns3::LtePdcp::LtePdcp(ns3::LtePdcp const & arg0) [constructor]
    cls.add_constructor([param('ns3::LtePdcp const &', 'arg0')])
    ## lte-pdcp.h (module 'lte'): ns3::LtePdcp::LtePdcp() [constructor]
    cls.add_constructor([])
    ## lte-pdcp.h (module 'lte'): void ns3::LtePdcp::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## lte-pdcp.h (module 'lte'): ns3::LtePdcpSapProvider * ns3::LtePdcp::GetLtePdcpSapProvider() [member function]
    cls.add_method('GetLtePdcpSapProvider',
                   'ns3::LtePdcpSapProvider *',
                   [])
    ## lte-pdcp.h (module 'lte'): ns3::LteRlcSapUser * ns3::LtePdcp::GetLteRlcSapUser() [member function]
    cls.add_method('GetLteRlcSapUser',
                   'ns3::LteRlcSapUser *',
                   [])
    ## lte-pdcp.h (module 'lte'): ns3::LtePdcp::Status ns3::LtePdcp::GetStatus() [member function]
    cls.add_method('GetStatus',
                   'ns3::LtePdcp::Status',
                   [])
    ## lte-pdcp.h (module 'lte'): static ns3::TypeId ns3::LtePdcp::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## lte-pdcp.h (module 'lte'): void ns3::LtePdcp::SetLcId(uint8_t lcId) [member function]
    cls.add_method('SetLcId',
                   'void',
                   [param('uint8_t', 'lcId')])
    ## lte-pdcp.h (module 'lte'): void ns3::LtePdcp::SetLtePdcpSapUser(ns3::LtePdcpSapUser * s) [member function]
    cls.add_method('SetLtePdcpSapUser',
                   'void',
                   [param('ns3::LtePdcpSapUser *', 's')])
    ## lte-pdcp.h (module 'lte'): void ns3::LtePdcp::SetLteRlcSapProvider(ns3::LteRlcSapProvider * s) [member function]
    cls.add_method('SetLteRlcSapProvider',
                   'void',
                   [param('ns3::LteRlcSapProvider *', 's')])
    ## lte-pdcp.h (module 'lte'): void ns3::LtePdcp::SetRnti(uint16_t rnti) [member function]
    cls.add_method('SetRnti',
                   'void',
                   [param('uint16_t', 'rnti')])
    ## lte-pdcp.h (module 'lte'): void ns3::LtePdcp::SetStatus(ns3::LtePdcp::Status s) [member function]
    cls.add_method('SetStatus',
                   'void',
                   [param('ns3::LtePdcp::Status', 's')])
    ## lte-pdcp.h (module 'lte'): ns3::LtePdcp::MAX_PDCP_SN [variable]
    cls.add_static_attribute('MAX_PDCP_SN', 'uint16_t const', is_const=True)
    ## lte-pdcp.h (module 'lte'): void ns3::LtePdcp::DoReceivePdu(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('DoReceivePdu',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'p')],
                   visibility='protected', is_virtual=True)
    ## lte-pdcp.h (module 'lte'): void ns3::LtePdcp::DoTransmitPdcpSdu(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('DoTransmitPdcpSdu',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'p')],
                   visibility='protected', is_virtual=True)
    return

def register_Ns3LtePdcpStatus_methods(root_module, cls):
    ## lte-pdcp.h (module 'lte'): ns3::LtePdcp::Status::Status() [constructor]
    cls.add_constructor([])
    ## lte-pdcp.h (module 'lte'): ns3::LtePdcp::Status::Status(ns3::LtePdcp::Status const & arg0) [constructor]
    cls.add_constructor([param('ns3::LtePdcp::Status const &', 'arg0')])
    ## lte-pdcp.h (module 'lte'): ns3::LtePdcp::Status::rxSn [variable]
    cls.add_instance_attribute('rxSn', 'uint16_t', is_const=False)
    ## lte-pdcp.h (module 'lte'): ns3::LtePdcp::Status::txSn [variable]
    cls.add_instance_attribute('txSn', 'uint16_t', is_const=False)
    return

def register_Ns3LtePhy_methods(root_module, cls):
    ## lte-phy.h (module 'lte'): ns3::LtePhy::LtePhy(ns3::LtePhy const & arg0) [constructor]
    cls.add_constructor([param('ns3::LtePhy const &', 'arg0')])
    ## lte-phy.h (module 'lte'): ns3::LtePhy::LtePhy() [constructor]
    cls.add_constructor([])
    ## lte-phy.h (module 'lte'): ns3::LtePhy::LtePhy(ns3::Ptr<ns3::LteSpectrumPhy> dlPhy, ns3::Ptr<ns3::LteSpectrumPhy> ulPhy) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::LteSpectrumPhy >', 'dlPhy'), param('ns3::Ptr< ns3::LteSpectrumPhy >', 'ulPhy')])
    ## lte-phy.h (module 'lte'): ns3::Ptr<ns3::SpectrumValue> ns3::LtePhy::CreateTxPowerSpectralDensity() [member function]
    cls.add_method('CreateTxPowerSpectralDensity',
                   'ns3::Ptr< ns3::SpectrumValue >',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-phy.h (module 'lte'): void ns3::LtePhy::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## lte-phy.h (module 'lte'): void ns3::LtePhy::DoSendMacPdu(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('DoSendMacPdu',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'p')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-phy.h (module 'lte'): void ns3::LtePhy::DoSetCellId(uint16_t cellId) [member function]
    cls.add_method('DoSetCellId',
                   'void',
                   [param('uint16_t', 'cellId')])
    ## lte-phy.h (module 'lte'): void ns3::LtePhy::GenerateCtrlCqiReport(ns3::SpectrumValue const & sinr) [member function]
    cls.add_method('GenerateCtrlCqiReport',
                   'void',
                   [param('ns3::SpectrumValue const &', 'sinr')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-phy.h (module 'lte'): void ns3::LtePhy::GenerateDataCqiReport(ns3::SpectrumValue const & sinr) [member function]
    cls.add_method('GenerateDataCqiReport',
                   'void',
                   [param('ns3::SpectrumValue const &', 'sinr')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-phy.h (module 'lte'): uint8_t ns3::LtePhy::GetComponentCarrierId() [member function]
    cls.add_method('GetComponentCarrierId',
                   'uint8_t',
                   [])
    ## lte-phy.h (module 'lte'): std::list<ns3::Ptr<ns3::LteControlMessage>, std::allocator<ns3::Ptr<ns3::LteControlMessage> > > ns3::LtePhy::GetControlMessages() [member function]
    cls.add_method('GetControlMessages',
                   'std::list< ns3::Ptr< ns3::LteControlMessage > >',
                   [])
    ## lte-phy.h (module 'lte'): ns3::Ptr<ns3::NetDevice> ns3::LtePhy::GetDevice() const [member function]
    cls.add_method('GetDevice',
                   'ns3::Ptr< ns3::NetDevice >',
                   [],
                   is_const=True)
    ## lte-phy.h (module 'lte'): ns3::Ptr<ns3::LteSpectrumPhy> ns3::LtePhy::GetDownlinkSpectrumPhy() [member function]
    cls.add_method('GetDownlinkSpectrumPhy',
                   'ns3::Ptr< ns3::LteSpectrumPhy >',
                   [])
    ## lte-phy.h (module 'lte'): ns3::Ptr<ns3::PacketBurst> ns3::LtePhy::GetPacketBurst() [member function]
    cls.add_method('GetPacketBurst',
                   'ns3::Ptr< ns3::PacketBurst >',
                   [])
    ## lte-phy.h (module 'lte'): uint8_t ns3::LtePhy::GetRbgSize() const [member function]
    cls.add_method('GetRbgSize',
                   'uint8_t',
                   [],
                   is_const=True)
    ## lte-phy.h (module 'lte'): uint16_t ns3::LtePhy::GetSrsPeriodicity(uint16_t srcCi) const [member function]
    cls.add_method('GetSrsPeriodicity',
                   'uint16_t',
                   [param('uint16_t', 'srcCi')],
                   is_const=True)
    ## lte-phy.h (module 'lte'): uint16_t ns3::LtePhy::GetSrsSubframeOffset(uint16_t srcCi) const [member function]
    cls.add_method('GetSrsSubframeOffset',
                   'uint16_t',
                   [param('uint16_t', 'srcCi')],
                   is_const=True)
    ## lte-phy.h (module 'lte'): double ns3::LtePhy::GetTti() const [member function]
    cls.add_method('GetTti',
                   'double',
                   [],
                   is_const=True)
    ## lte-phy.h (module 'lte'): static ns3::TypeId ns3::LtePhy::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## lte-phy.h (module 'lte'): ns3::Ptr<ns3::LteSpectrumPhy> ns3::LtePhy::GetUplinkSpectrumPhy() [member function]
    cls.add_method('GetUplinkSpectrumPhy',
                   'ns3::Ptr< ns3::LteSpectrumPhy >',
                   [])
    ## lte-phy.h (module 'lte'): void ns3::LtePhy::ReportInterference(ns3::SpectrumValue const & interf) [member function]
    cls.add_method('ReportInterference',
                   'void',
                   [param('ns3::SpectrumValue const &', 'interf')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-phy.h (module 'lte'): void ns3::LtePhy::ReportRsReceivedPower(ns3::SpectrumValue const & power) [member function]
    cls.add_method('ReportRsReceivedPower',
                   'void',
                   [param('ns3::SpectrumValue const &', 'power')],
                   is_pure_virtual=True, is_virtual=True)
    ## lte-phy.h (module 'lte'): void ns3::LtePhy::SetComponentCarrierId(uint8_t index) [member function]
    cls.add_method('SetComponentCarrierId',
                   'void',
                   [param('uint8_t', 'index')])
    ## lte-phy.h (module 'lte'): void ns3::LtePhy::SetControlMessages(ns3::Ptr<ns3::LteControlMessage> m) [member function]
    cls.add_method('SetControlMessages',
                   'void',
                   [param('ns3::Ptr< ns3::LteControlMessage >', 'm')])
    ## lte-phy.h (module 'lte'): void ns3::LtePhy::SetDevice(ns3::Ptr<ns3::NetDevice> d) [member function]
    cls.add_method('SetDevice',
                   'void',
                   [param('ns3::Ptr< ns3::NetDevice >', 'd')])
    ## lte-phy.h (module 'lte'): void ns3::LtePhy::SetDownlinkChannel(ns3::Ptr<ns3::SpectrumChannel> c) [member function]
    cls.add_method('SetDownlinkChannel',
                   'void',
                   [param('ns3::Ptr< ns3::SpectrumChannel >', 'c')])
    ## lte-phy.h (module 'lte'): void ns3::LtePhy::SetMacPdu(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('SetMacPdu',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'p')])
    ## lte-phy.h (module 'lte'): void ns3::LtePhy::SetTti(double tti) [member function]
    cls.add_method('SetTti',
                   'void',
                   [param('double', 'tti')])
    ## lte-phy.h (module 'lte'): void ns3::LtePhy::SetUplinkChannel(ns3::Ptr<ns3::SpectrumChannel> c) [member function]
    cls.add_method('SetUplinkChannel',
                   'void',
                   [param('ns3::Ptr< ns3::SpectrumChannel >', 'c')])
    return

def register_Ns3LteRadioBearerInfo_methods(root_module, cls):
    ## lte-radio-bearer-info.h (module 'lte'): ns3::LteRadioBearerInfo::LteRadioBearerInfo(ns3::LteRadioBearerInfo const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRadioBearerInfo const &', 'arg0')])
    ## lte-radio-bearer-info.h (module 'lte'): ns3::LteRadioBearerInfo::LteRadioBearerInfo() [constructor]
    cls.add_constructor([])
    ## lte-radio-bearer-info.h (module 'lte'): static ns3::TypeId ns3::LteRadioBearerInfo::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## lte-radio-bearer-info.h (module 'lte'): ns3::LteRadioBearerInfo::m_pdcp [variable]
    cls.add_instance_attribute('m_pdcp', 'ns3::Ptr< ns3::LtePdcp >', is_const=False)
    ## lte-radio-bearer-info.h (module 'lte'): ns3::LteRadioBearerInfo::m_rlc [variable]
    cls.add_instance_attribute('m_rlc', 'ns3::Ptr< ns3::LteRlc >', is_const=False)
    return

def register_Ns3LteRlc_methods(root_module, cls):
    ## lte-rlc.h (module 'lte'): ns3::LteRlc::LteRlc(ns3::LteRlc const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRlc const &', 'arg0')])
    ## lte-rlc.h (module 'lte'): ns3::LteRlc::LteRlc() [constructor]
    cls.add_constructor([])
    ## lte-rlc.h (module 'lte'): void ns3::LteRlc::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## lte-rlc.h (module 'lte'): ns3::EpcX2RlcUser * ns3::LteRlc::GetEpcX2RlcUser() [member function]
    cls.add_method('GetEpcX2RlcUser',
                   'ns3::EpcX2RlcUser *',
                   [])
    ## lte-rlc.h (module 'lte'): ns3::LteMacSapUser * ns3::LteRlc::GetLteMacSapUser() [member function]
    cls.add_method('GetLteMacSapUser',
                   'ns3::LteMacSapUser *',
                   [])
    ## lte-rlc.h (module 'lte'): ns3::LteRlcSapProvider * ns3::LteRlc::GetLteRlcSapProvider() [member function]
    cls.add_method('GetLteRlcSapProvider',
                   'ns3::LteRlcSapProvider *',
                   [])
    ## lte-rlc.h (module 'lte'): static ns3::TypeId ns3::LteRlc::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## lte-rlc.h (module 'lte'): void ns3::LteRlc::SetEpcX2RlcProvider(ns3::EpcX2RlcProvider * s) [member function]
    cls.add_method('SetEpcX2RlcProvider',
                   'void',
                   [param('ns3::EpcX2RlcProvider *', 's')])
    ## lte-rlc.h (module 'lte'): void ns3::LteRlc::SetLcId(uint8_t lcId) [member function]
    cls.add_method('SetLcId',
                   'void',
                   [param('uint8_t', 'lcId')])
    ## lte-rlc.h (module 'lte'): void ns3::LteRlc::SetLteMacSapProvider(ns3::LteMacSapProvider * s) [member function]
    cls.add_method('SetLteMacSapProvider',
                   'void',
                   [param('ns3::LteMacSapProvider *', 's')])
    ## lte-rlc.h (module 'lte'): void ns3::LteRlc::SetLteRlcSapUser(ns3::LteRlcSapUser * s) [member function]
    cls.add_method('SetLteRlcSapUser',
                   'void',
                   [param('ns3::LteRlcSapUser *', 's')])
    ## lte-rlc.h (module 'lte'): void ns3::LteRlc::SetRnti(uint16_t rnti) [member function]
    cls.add_method('SetRnti',
                   'void',
                   [param('uint16_t', 'rnti')])
    ## lte-rlc.h (module 'lte'): void ns3::LteRlc::SetUeDataParams(ns3::EpcX2Sap::UeDataParams params) [member function]
    cls.add_method('SetUeDataParams',
                   'void',
                   [param('ns3::EpcX2Sap::UeDataParams', 'params')])
    ## lte-rlc.h (module 'lte'): void ns3::LteRlc::DoNotifyHarqDeliveryFailure() [member function]
    cls.add_method('DoNotifyHarqDeliveryFailure',
                   'void',
                   [],
                   is_pure_virtual=True, visibility='protected', is_virtual=True)
    ## lte-rlc.h (module 'lte'): void ns3::LteRlc::DoNotifyHarqDeliveryFailure(uint8_t harqId) [member function]
    cls.add_method('DoNotifyHarqDeliveryFailure',
                   'void',
                   [param('uint8_t', 'harqId')],
                   visibility='protected', is_virtual=True)
    ## lte-rlc.h (module 'lte'): void ns3::LteRlc::DoNotifyTxOpportunity(uint32_t bytes, uint8_t layer, uint8_t harqId, uint8_t componentCarrierId, uint16_t rnti, uint8_t lcid) [member function]
    cls.add_method('DoNotifyTxOpportunity',
                   'void',
                   [param('uint32_t', 'bytes'), param('uint8_t', 'layer'), param('uint8_t', 'harqId'), param('uint8_t', 'componentCarrierId'), param('uint16_t', 'rnti'), param('uint8_t', 'lcid')],
                   is_pure_virtual=True, visibility='protected', is_virtual=True)
    ## lte-rlc.h (module 'lte'): void ns3::LteRlc::DoReceivePdu(ns3::Ptr<ns3::Packet> p, uint16_t rnti, uint8_t lcid) [member function]
    cls.add_method('DoReceivePdu',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'p'), param('uint16_t', 'rnti'), param('uint8_t', 'lcid')],
                   is_pure_virtual=True, visibility='protected', is_virtual=True)
    ## lte-rlc.h (module 'lte'): void ns3::LteRlc::DoSendMcPdcpSdu(ns3::EpcX2Sap::UeDataParams params) [member function]
    cls.add_method('DoSendMcPdcpSdu',
                   'void',
                   [param('ns3::EpcX2Sap::UeDataParams', 'params')],
                   is_pure_virtual=True, visibility='protected', is_virtual=True)
    ## lte-rlc.h (module 'lte'): void ns3::LteRlc::DoTransmitPdcpPdu(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('DoTransmitPdcpPdu',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'p')],
                   is_pure_virtual=True, visibility='protected', is_virtual=True)
    return

def register_Ns3LteRlcAm_methods(root_module, cls):
    ## lte-rlc-am.h (module 'lte'): ns3::LteRlcAm::LteRlcAm() [constructor]
    cls.add_constructor([])
    ## lte-rlc-am.h (module 'lte'): void ns3::LteRlcAm::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## lte-rlc-am.h (module 'lte'): void ns3::LteRlcAm::DoNotifyDlHarqDeliveryFailure(uint8_t harqId) [member function]
    cls.add_method('DoNotifyDlHarqDeliveryFailure',
                   'void',
                   [param('uint8_t', 'harqId')],
                   is_virtual=True)
    ## lte-rlc-am.h (module 'lte'): void ns3::LteRlcAm::DoNotifyHarqDeliveryFailure() [member function]
    cls.add_method('DoNotifyHarqDeliveryFailure',
                   'void',
                   [],
                   is_virtual=True)
    ## lte-rlc-am.h (module 'lte'): void ns3::LteRlcAm::DoNotifyTxOpportunity(uint32_t bytes, uint8_t layer, uint8_t harqId, uint8_t componentCarrierId, uint16_t rnti, uint8_t lcid) [member function]
    cls.add_method('DoNotifyTxOpportunity',
                   'void',
                   [param('uint32_t', 'bytes'), param('uint8_t', 'layer'), param('uint8_t', 'harqId'), param('uint8_t', 'componentCarrierId'), param('uint16_t', 'rnti'), param('uint8_t', 'lcid')],
                   is_virtual=True)
    ## lte-rlc-am.h (module 'lte'): void ns3::LteRlcAm::DoNotifyUlHarqDeliveryFailure(uint8_t harqId) [member function]
    cls.add_method('DoNotifyUlHarqDeliveryFailure',
                   'void',
                   [param('uint8_t', 'harqId')],
                   is_virtual=True)
    ## lte-rlc-am.h (module 'lte'): void ns3::LteRlcAm::DoReceivePdu(ns3::Ptr<ns3::Packet> p, uint16_t rnti, uint8_t lcid) [member function]
    cls.add_method('DoReceivePdu',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'p'), param('uint16_t', 'rnti'), param('uint8_t', 'lcid')],
                   is_virtual=True)
    ## lte-rlc-am.h (module 'lte'): void ns3::LteRlcAm::DoSendMcPdcpSdu(ns3::EpcX2Sap::UeDataParams params) [member function]
    cls.add_method('DoSendMcPdcpSdu',
                   'void',
                   [param('ns3::EpcX2Sap::UeDataParams', 'params')],
                   is_virtual=True)
    ## lte-rlc-am.h (module 'lte'): void ns3::LteRlcAm::DoTransmitPdcpPdu(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('DoTransmitPdcpPdu',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'p')],
                   is_virtual=True)
    ## lte-rlc-am.h (module 'lte'): std::vector<ns3::LteRlcAm::RetxPdu, std::allocator<ns3::LteRlcAm::RetxPdu> > ns3::LteRlcAm::GetRetxBuffer() [member function]
    cls.add_method('GetRetxBuffer',
                   'std::vector< ns3::LteRlcAm::RetxPdu >',
                   [])
    ## lte-rlc-am.h (module 'lte'): uint32_t ns3::LteRlcAm::GetRetxBufferSize() [member function]
    cls.add_method('GetRetxBufferSize',
                   'uint32_t',
                   [])
    ## lte-rlc-am.h (module 'lte'): ns3::Ptr<ns3::Packet> ns3::LteRlcAm::GetSegmentedRlcsdu() [member function]
    cls.add_method('GetSegmentedRlcsdu',
                   'ns3::Ptr< ns3::Packet >',
                   [])
    ## lte-rlc-am.h (module 'lte'): std::map<unsigned int, ns3::Ptr<ns3::Packet>, std::less<unsigned int>, std::allocator<std::pair<const unsigned int, ns3::Ptr<ns3::Packet> > > > ns3::LteRlcAm::GetTransmittingRlcSduBuffer() [member function]
    cls.add_method('GetTransmittingRlcSduBuffer',
                   'std::map< unsigned int, ns3::Ptr< ns3::Packet > >',
                   [])
    ## lte-rlc-am.h (module 'lte'): uint32_t ns3::LteRlcAm::GetTransmittingRlcSduBufferSize() [member function]
    cls.add_method('GetTransmittingRlcSduBufferSize',
                   'uint32_t',
                   [])
    ## lte-rlc-am.h (module 'lte'): std::vector<ns3::Ptr<ns3::Packet>, std::allocator<ns3::Ptr<ns3::Packet> > > ns3::LteRlcAm::GetTxBuffer() [member function]
    cls.add_method('GetTxBuffer',
                   'std::vector< ns3::Ptr< ns3::Packet > >',
                   [])
    ## lte-rlc-am.h (module 'lte'): uint32_t ns3::LteRlcAm::GetTxBufferSize() [member function]
    cls.add_method('GetTxBufferSize',
                   'uint32_t',
                   [])
    ## lte-rlc-am.h (module 'lte'): std::vector<ns3::LteRlcAm::RetxPdu, std::allocator<ns3::LteRlcAm::RetxPdu> > ns3::LteRlcAm::GetTxedBuffer() [member function]
    cls.add_method('GetTxedBuffer',
                   'std::vector< ns3::LteRlcAm::RetxPdu >',
                   [])
    ## lte-rlc-am.h (module 'lte'): uint32_t ns3::LteRlcAm::GetTxedBufferSize() [member function]
    cls.add_method('GetTxedBufferSize',
                   'uint32_t',
                   [])
    ## lte-rlc-am.h (module 'lte'): std::vector<ns3::Ptr<ns3::Packet>, std::allocator<ns3::Ptr<ns3::Packet> > > ns3::LteRlcAm::GetTxedRlcSduBuffer() [member function]
    cls.add_method('GetTxedRlcSduBuffer',
                   'std::vector< ns3::Ptr< ns3::Packet > >',
                   [])
    ## lte-rlc-am.h (module 'lte'): static ns3::TypeId ns3::LteRlcAm::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## lte-rlc-am.h (module 'lte'): void ns3::LteRlcAm::RlcPdusToRlcSdus(std::vector<ns3::LteRlcAm::RetxPdu, std::allocator<ns3::LteRlcAm::RetxPdu> > Pdus) [member function]
    cls.add_method('RlcPdusToRlcSdus',
                   'void',
                   [param('std::vector< ns3::LteRlcAm::RetxPdu >', 'Pdus')])
    return

def register_Ns3LteRlcAmRetxPdu_methods(root_module, cls):
    ## lte-rlc-am.h (module 'lte'): ns3::LteRlcAm::RetxPdu::RetxPdu() [constructor]
    cls.add_constructor([])
    ## lte-rlc-am.h (module 'lte'): ns3::LteRlcAm::RetxPdu::RetxPdu(ns3::LteRlcAm::RetxPdu const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRlcAm::RetxPdu const &', 'arg0')])
    ## lte-rlc-am.h (module 'lte'): ns3::LteRlcAm::RetxPdu::m_pdu [variable]
    cls.add_instance_attribute('m_pdu', 'ns3::Ptr< ns3::Packet >', is_const=False)
    ## lte-rlc-am.h (module 'lte'): ns3::LteRlcAm::RetxPdu::m_retxCount [variable]
    cls.add_instance_attribute('m_retxCount', 'uint16_t', is_const=False)
    return

def register_Ns3LteRlcSm_methods(root_module, cls):
    ## lte-rlc.h (module 'lte'): ns3::LteRlcSm::LteRlcSm(ns3::LteRlcSm const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteRlcSm const &', 'arg0')])
    ## lte-rlc.h (module 'lte'): ns3::LteRlcSm::LteRlcSm() [constructor]
    cls.add_constructor([])
    ## lte-rlc.h (module 'lte'): void ns3::LteRlcSm::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## lte-rlc.h (module 'lte'): void ns3::LteRlcSm::DoInitialize() [member function]
    cls.add_method('DoInitialize',
                   'void',
                   [],
                   is_virtual=True)
    ## lte-rlc.h (module 'lte'): void ns3::LteRlcSm::DoNotifyHarqDeliveryFailure() [member function]
    cls.add_method('DoNotifyHarqDeliveryFailure',
                   'void',
                   [],
                   is_virtual=True)
    ## lte-rlc.h (module 'lte'): void ns3::LteRlcSm::DoNotifyTxOpportunity(uint32_t bytes, uint8_t layer, uint8_t harqId, uint8_t componentCarrierId, uint16_t rnti, uint8_t lcid) [member function]
    cls.add_method('DoNotifyTxOpportunity',
                   'void',
                   [param('uint32_t', 'bytes'), param('uint8_t', 'layer'), param('uint8_t', 'harqId'), param('uint8_t', 'componentCarrierId'), param('uint16_t', 'rnti'), param('uint8_t', 'lcid')],
                   is_virtual=True)
    ## lte-rlc.h (module 'lte'): void ns3::LteRlcSm::DoReceivePdu(ns3::Ptr<ns3::Packet> p, uint16_t rnti, uint8_t lcid) [member function]
    cls.add_method('DoReceivePdu',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'p'), param('uint16_t', 'rnti'), param('uint8_t', 'lcid')],
                   is_virtual=True)
    ## lte-rlc.h (module 'lte'): void ns3::LteRlcSm::DoSendMcPdcpSdu(ns3::EpcX2Sap::UeDataParams params) [member function]
    cls.add_method('DoSendMcPdcpSdu',
                   'void',
                   [param('ns3::EpcX2Sap::UeDataParams', 'params')],
                   is_virtual=True)
    ## lte-rlc.h (module 'lte'): void ns3::LteRlcSm::DoTransmitPdcpPdu(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('DoTransmitPdcpPdu',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'p')],
                   is_virtual=True)
    ## lte-rlc.h (module 'lte'): static ns3::TypeId ns3::LteRlcSm::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    return

def register_Ns3LteSignalingRadioBearerInfo_methods(root_module, cls):
    ## lte-radio-bearer-info.h (module 'lte'): ns3::LteSignalingRadioBearerInfo::LteSignalingRadioBearerInfo() [constructor]
    cls.add_constructor([])
    ## lte-radio-bearer-info.h (module 'lte'): ns3::LteSignalingRadioBearerInfo::LteSignalingRadioBearerInfo(ns3::LteSignalingRadioBearerInfo const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteSignalingRadioBearerInfo const &', 'arg0')])
    ## lte-radio-bearer-info.h (module 'lte'): static ns3::TypeId ns3::LteSignalingRadioBearerInfo::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## lte-radio-bearer-info.h (module 'lte'): ns3::LteSignalingRadioBearerInfo::m_logicalChannelConfig [variable]
    cls.add_instance_attribute('m_logicalChannelConfig', 'ns3::LteRrcSap::LogicalChannelConfig', is_const=False)
    ## lte-radio-bearer-info.h (module 'lte'): ns3::LteSignalingRadioBearerInfo::m_srbIdentity [variable]
    cls.add_instance_attribute('m_srbIdentity', 'uint8_t', is_const=False)
    return

def register_Ns3LteSpectrumPhy_methods(root_module, cls):
    ## lte-spectrum-phy.h (module 'lte'): ns3::LteSpectrumPhy::LteSpectrumPhy() [constructor]
    cls.add_constructor([])
    ## lte-spectrum-phy.h (module 'lte'): static ns3::TypeId ns3::LteSpectrumPhy::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## lte-spectrum-phy.h (module 'lte'): void ns3::LteSpectrumPhy::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## lte-spectrum-phy.h (module 'lte'): void ns3::LteSpectrumPhy::SetChannel(ns3::Ptr<ns3::SpectrumChannel> c) [member function]
    cls.add_method('SetChannel',
                   'void',
                   [param('ns3::Ptr< ns3::SpectrumChannel >', 'c')],
                   is_virtual=True)
    ## lte-spectrum-phy.h (module 'lte'): void ns3::LteSpectrumPhy::SetMobility(ns3::Ptr<ns3::MobilityModel> m) [member function]
    cls.add_method('SetMobility',
                   'void',
                   [param('ns3::Ptr< ns3::MobilityModel >', 'm')],
                   is_virtual=True)
    ## lte-spectrum-phy.h (module 'lte'): void ns3::LteSpectrumPhy::SetDevice(ns3::Ptr<ns3::NetDevice> d) [member function]
    cls.add_method('SetDevice',
                   'void',
                   [param('ns3::Ptr< ns3::NetDevice >', 'd')],
                   is_virtual=True)
    ## lte-spectrum-phy.h (module 'lte'): ns3::Ptr<ns3::MobilityModel> ns3::LteSpectrumPhy::GetMobility() [member function]
    cls.add_method('GetMobility',
                   'ns3::Ptr< ns3::MobilityModel >',
                   [],
                   is_virtual=True)
    ## lte-spectrum-phy.h (module 'lte'): ns3::Ptr<ns3::NetDevice> ns3::LteSpectrumPhy::GetDevice() const [member function]
    cls.add_method('GetDevice',
                   'ns3::Ptr< ns3::NetDevice >',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-spectrum-phy.h (module 'lte'): ns3::Ptr<const ns3::SpectrumModel> ns3::LteSpectrumPhy::GetRxSpectrumModel() const [member function]
    cls.add_method('GetRxSpectrumModel',
                   'ns3::Ptr< ns3::SpectrumModel const >',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-spectrum-phy.h (module 'lte'): ns3::Ptr<ns3::AntennaModel> ns3::LteSpectrumPhy::GetRxAntenna() [member function]
    cls.add_method('GetRxAntenna',
                   'ns3::Ptr< ns3::AntennaModel >',
                   [],
                   is_virtual=True)
    ## lte-spectrum-phy.h (module 'lte'): void ns3::LteSpectrumPhy::StartRx(ns3::Ptr<ns3::SpectrumSignalParameters> params) [member function]
    cls.add_method('StartRx',
                   'void',
                   [param('ns3::Ptr< ns3::SpectrumSignalParameters >', 'params')],
                   is_virtual=True)
    ## lte-spectrum-phy.h (module 'lte'): void ns3::LteSpectrumPhy::StartRxData(ns3::Ptr<ns3::LteSpectrumSignalParametersDataFrame> params) [member function]
    cls.add_method('StartRxData',
                   'void',
                   [param('ns3::Ptr< ns3::LteSpectrumSignalParametersDataFrame >', 'params')])
    ## lte-spectrum-phy.h (module 'lte'): void ns3::LteSpectrumPhy::StartRxDlCtrl(ns3::Ptr<ns3::LteSpectrumSignalParametersDlCtrlFrame> lteDlCtrlRxParams) [member function]
    cls.add_method('StartRxDlCtrl',
                   'void',
                   [param('ns3::Ptr< ns3::LteSpectrumSignalParametersDlCtrlFrame >', 'lteDlCtrlRxParams')])
    ## lte-spectrum-phy.h (module 'lte'): void ns3::LteSpectrumPhy::StartRxUlSrs(ns3::Ptr<ns3::LteSpectrumSignalParametersUlSrsFrame> lteUlSrsRxParams) [member function]
    cls.add_method('StartRxUlSrs',
                   'void',
                   [param('ns3::Ptr< ns3::LteSpectrumSignalParametersUlSrsFrame >', 'lteUlSrsRxParams')])
    ## lte-spectrum-phy.h (module 'lte'): void ns3::LteSpectrumPhy::SetHarqPhyModule(ns3::Ptr<ns3::LteHarqPhy> harq) [member function]
    cls.add_method('SetHarqPhyModule',
                   'void',
                   [param('ns3::Ptr< ns3::LteHarqPhy >', 'harq')])
    ## lte-spectrum-phy.h (module 'lte'): void ns3::LteSpectrumPhy::SetTxPowerSpectralDensity(ns3::Ptr<ns3::SpectrumValue> txPsd) [member function]
    cls.add_method('SetTxPowerSpectralDensity',
                   'void',
                   [param('ns3::Ptr< ns3::SpectrumValue >', 'txPsd')])
    ## lte-spectrum-phy.h (module 'lte'): void ns3::LteSpectrumPhy::SetNoisePowerSpectralDensity(ns3::Ptr<const ns3::SpectrumValue> noisePsd) [member function]
    cls.add_method('SetNoisePowerSpectralDensity',
                   'void',
                   [param('ns3::Ptr< ns3::SpectrumValue const >', 'noisePsd')])
    ## lte-spectrum-phy.h (module 'lte'): void ns3::LteSpectrumPhy::Reset() [member function]
    cls.add_method('Reset',
                   'void',
                   [])
    ## lte-spectrum-phy.h (module 'lte'): void ns3::LteSpectrumPhy::SetAntenna(ns3::Ptr<ns3::AntennaModel> a) [member function]
    cls.add_method('SetAntenna',
                   'void',
                   [param('ns3::Ptr< ns3::AntennaModel >', 'a')])
    ## lte-spectrum-phy.h (module 'lte'): bool ns3::LteSpectrumPhy::StartTxDataFrame(ns3::Ptr<ns3::PacketBurst> pb, std::list<ns3::Ptr<ns3::LteControlMessage>, std::allocator<ns3::Ptr<ns3::LteControlMessage> > > ctrlMsgList, ns3::Time duration) [member function]
    cls.add_method('StartTxDataFrame',
                   'bool',
                   [param('ns3::Ptr< ns3::PacketBurst >', 'pb'), param('std::list< ns3::Ptr< ns3::LteControlMessage > >', 'ctrlMsgList'), param('ns3::Time', 'duration')])
    ## lte-spectrum-phy.h (module 'lte'): bool ns3::LteSpectrumPhy::StartTxDlCtrlFrame(std::list<ns3::Ptr<ns3::LteControlMessage>, std::allocator<ns3::Ptr<ns3::LteControlMessage> > > ctrlMsgList, bool pss) [member function]
    cls.add_method('StartTxDlCtrlFrame',
                   'bool',
                   [param('std::list< ns3::Ptr< ns3::LteControlMessage > >', 'ctrlMsgList'), param('bool', 'pss')])
    ## lte-spectrum-phy.h (module 'lte'): bool ns3::LteSpectrumPhy::StartTxUlSrsFrame() [member function]
    cls.add_method('StartTxUlSrsFrame',
                   'bool',
                   [])
    ## lte-spectrum-phy.h (module 'lte'): void ns3::LteSpectrumPhy::SetLtePhyTxEndCallback(ns3::LtePhyTxEndCallback c) [member function]
    cls.add_method('SetLtePhyTxEndCallback',
                   'void',
                   [param('ns3::Callback< void, ns3::Ptr< ns3::Packet const >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'c')])
    ## lte-spectrum-phy.h (module 'lte'): void ns3::LteSpectrumPhy::SetLtePhyRxDataEndErrorCallback(ns3::LtePhyRxDataEndErrorCallback c) [member function]
    cls.add_method('SetLtePhyRxDataEndErrorCallback',
                   'void',
                   [param('ns3::Callback< void, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'c')])
    ## lte-spectrum-phy.h (module 'lte'): void ns3::LteSpectrumPhy::SetLtePhyRxDataEndOkCallback(ns3::LtePhyRxDataEndOkCallback c) [member function]
    cls.add_method('SetLtePhyRxDataEndOkCallback',
                   'void',
                   [param('ns3::Callback< void, ns3::Ptr< ns3::Packet >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'c')])
    ## lte-spectrum-phy.h (module 'lte'): void ns3::LteSpectrumPhy::SetLtePhyRxCtrlEndOkCallback(ns3::LtePhyRxCtrlEndOkCallback c) [member function]
    cls.add_method('SetLtePhyRxCtrlEndOkCallback',
                   'void',
                   [param('ns3::Callback< void, std::list< ns3::Ptr< ns3::LteControlMessage > >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'c')])
    ## lte-spectrum-phy.h (module 'lte'): void ns3::LteSpectrumPhy::SetLtePhyRxCtrlEndErrorCallback(ns3::LtePhyRxCtrlEndErrorCallback c) [member function]
    cls.add_method('SetLtePhyRxCtrlEndErrorCallback',
                   'void',
                   [param('ns3::Callback< void, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'c')])
    ## lte-spectrum-phy.h (module 'lte'): void ns3::LteSpectrumPhy::SetLtePhyRxPssCallback(ns3::LtePhyRxPssCallback c) [member function]
    cls.add_method('SetLtePhyRxPssCallback',
                   'void',
                   [param('ns3::Callback< void, unsigned short, ns3::Ptr< ns3::SpectrumValue >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'c')])
    ## lte-spectrum-phy.h (module 'lte'): void ns3::LteSpectrumPhy::SetLtePhyDlHarqFeedbackCallback(ns3::LtePhyDlHarqFeedbackCallback c) [member function]
    cls.add_method('SetLtePhyDlHarqFeedbackCallback',
                   'void',
                   [param('ns3::Callback< void, ns3::DlInfoListElement_s, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'c')])
    ## lte-spectrum-phy.h (module 'lte'): void ns3::LteSpectrumPhy::SetLtePhyUlHarqFeedbackCallback(ns3::LtePhyUlHarqFeedbackCallback c) [member function]
    cls.add_method('SetLtePhyUlHarqFeedbackCallback',
                   'void',
                   [param('ns3::Callback< void, ns3::UlInfoListElement_s, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'c')])
    ## lte-spectrum-phy.h (module 'lte'): void ns3::LteSpectrumPhy::SetState(ns3::LteSpectrumPhy::State newState) [member function]
    cls.add_method('SetState',
                   'void',
                   [param('ns3::LteSpectrumPhy::State', 'newState')])
    ## lte-spectrum-phy.h (module 'lte'): void ns3::LteSpectrumPhy::SetCellId(uint16_t cellId) [member function]
    cls.add_method('SetCellId',
                   'void',
                   [param('uint16_t', 'cellId')])
    ## lte-spectrum-phy.h (module 'lte'): void ns3::LteSpectrumPhy::SetComponentCarrierId(uint8_t componentCarrierId) [member function]
    cls.add_method('SetComponentCarrierId',
                   'void',
                   [param('uint8_t', 'componentCarrierId')])
    ## lte-spectrum-phy.h (module 'lte'): void ns3::LteSpectrumPhy::AddRsPowerChunkProcessor(ns3::Ptr<ns3::LteChunkProcessor> p) [member function]
    cls.add_method('AddRsPowerChunkProcessor',
                   'void',
                   [param('ns3::Ptr< ns3::LteChunkProcessor >', 'p')])
    ## lte-spectrum-phy.h (module 'lte'): void ns3::LteSpectrumPhy::AddDataPowerChunkProcessor(ns3::Ptr<ns3::LteChunkProcessor> p) [member function]
    cls.add_method('AddDataPowerChunkProcessor',
                   'void',
                   [param('ns3::Ptr< ns3::LteChunkProcessor >', 'p')])
    ## lte-spectrum-phy.h (module 'lte'): void ns3::LteSpectrumPhy::AddDataSinrChunkProcessor(ns3::Ptr<ns3::LteChunkProcessor> p) [member function]
    cls.add_method('AddDataSinrChunkProcessor',
                   'void',
                   [param('ns3::Ptr< ns3::LteChunkProcessor >', 'p')])
    ## lte-spectrum-phy.h (module 'lte'): void ns3::LteSpectrumPhy::AddInterferenceCtrlChunkProcessor(ns3::Ptr<ns3::LteChunkProcessor> p) [member function]
    cls.add_method('AddInterferenceCtrlChunkProcessor',
                   'void',
                   [param('ns3::Ptr< ns3::LteChunkProcessor >', 'p')])
    ## lte-spectrum-phy.h (module 'lte'): void ns3::LteSpectrumPhy::AddInterferenceDataChunkProcessor(ns3::Ptr<ns3::LteChunkProcessor> p) [member function]
    cls.add_method('AddInterferenceDataChunkProcessor',
                   'void',
                   [param('ns3::Ptr< ns3::LteChunkProcessor >', 'p')])
    ## lte-spectrum-phy.h (module 'lte'): void ns3::LteSpectrumPhy::AddCtrlSinrChunkProcessor(ns3::Ptr<ns3::LteChunkProcessor> p) [member function]
    cls.add_method('AddCtrlSinrChunkProcessor',
                   'void',
                   [param('ns3::Ptr< ns3::LteChunkProcessor >', 'p')])
    ## lte-spectrum-phy.h (module 'lte'): void ns3::LteSpectrumPhy::AddExpectedTb(uint16_t rnti, uint8_t ndi, uint16_t size, uint8_t mcs, std::vector<int, std::allocator<int> > map, uint8_t layer, uint8_t harqId, uint8_t rv, bool downlink) [member function]
    cls.add_method('AddExpectedTb',
                   'void',
                   [param('uint16_t', 'rnti'), param('uint8_t', 'ndi'), param('uint16_t', 'size'), param('uint8_t', 'mcs'), param('std::vector< int >', 'map'), param('uint8_t', 'layer'), param('uint8_t', 'harqId'), param('uint8_t', 'rv'), param('bool', 'downlink')])
    ## lte-spectrum-phy.h (module 'lte'): void ns3::LteSpectrumPhy::UpdateSinrPerceived(ns3::SpectrumValue const & sinr) [member function]
    cls.add_method('UpdateSinrPerceived',
                   'void',
                   [param('ns3::SpectrumValue const &', 'sinr')])
    ## lte-spectrum-phy.h (module 'lte'): void ns3::LteSpectrumPhy::SetTransmissionMode(uint8_t txMode) [member function]
    cls.add_method('SetTransmissionMode',
                   'void',
                   [param('uint8_t', 'txMode')])
    ## lte-spectrum-phy.h (module 'lte'): ns3::Ptr<ns3::SpectrumChannel> ns3::LteSpectrumPhy::GetChannel() [member function]
    cls.add_method('GetChannel',
                   'ns3::Ptr< ns3::SpectrumChannel >',
                   [])
    ## lte-spectrum-phy.h (module 'lte'): int64_t ns3::LteSpectrumPhy::AssignStreams(int64_t stream) [member function]
    cls.add_method('AssignStreams',
                   'int64_t',
                   [param('int64_t', 'stream')])
    return

def register_Ns3LteStatsCalculator_methods(root_module, cls):
    ## lte-stats-calculator.h (module 'lte'): ns3::LteStatsCalculator::LteStatsCalculator(ns3::LteStatsCalculator const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteStatsCalculator const &', 'arg0')])
    ## lte-stats-calculator.h (module 'lte'): ns3::LteStatsCalculator::LteStatsCalculator() [constructor]
    cls.add_constructor([])
    ## lte-stats-calculator.h (module 'lte'): bool ns3::LteStatsCalculator::ExistsCellIdPath(std::string path) [member function]
    cls.add_method('ExistsCellIdPath',
                   'bool',
                   [param('std::string', 'path')])
    ## lte-stats-calculator.h (module 'lte'): bool ns3::LteStatsCalculator::ExistsImsiPath(std::string path) [member function]
    cls.add_method('ExistsImsiPath',
                   'bool',
                   [param('std::string', 'path')])
    ## lte-stats-calculator.h (module 'lte'): uint16_t ns3::LteStatsCalculator::GetCellIdPath(std::string path) [member function]
    cls.add_method('GetCellIdPath',
                   'uint16_t',
                   [param('std::string', 'path')])
    ## lte-stats-calculator.h (module 'lte'): std::string ns3::LteStatsCalculator::GetDlOutputFilename() [member function]
    cls.add_method('GetDlOutputFilename',
                   'std::string',
                   [])
    ## lte-stats-calculator.h (module 'lte'): uint64_t ns3::LteStatsCalculator::GetImsiPath(std::string path) [member function]
    cls.add_method('GetImsiPath',
                   'uint64_t',
                   [param('std::string', 'path')])
    ## lte-stats-calculator.h (module 'lte'): static ns3::TypeId ns3::LteStatsCalculator::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## lte-stats-calculator.h (module 'lte'): std::string ns3::LteStatsCalculator::GetUlOutputFilename() [member function]
    cls.add_method('GetUlOutputFilename',
                   'std::string',
                   [])
    ## lte-stats-calculator.h (module 'lte'): void ns3::LteStatsCalculator::SetCellIdPath(std::string path, uint16_t cellId) [member function]
    cls.add_method('SetCellIdPath',
                   'void',
                   [param('std::string', 'path'), param('uint16_t', 'cellId')])
    ## lte-stats-calculator.h (module 'lte'): void ns3::LteStatsCalculator::SetDlOutputFilename(std::string outputFilename) [member function]
    cls.add_method('SetDlOutputFilename',
                   'void',
                   [param('std::string', 'outputFilename')])
    ## lte-stats-calculator.h (module 'lte'): void ns3::LteStatsCalculator::SetImsiPath(std::string path, uint64_t imsi) [member function]
    cls.add_method('SetImsiPath',
                   'void',
                   [param('std::string', 'path'), param('uint64_t', 'imsi')])
    ## lte-stats-calculator.h (module 'lte'): void ns3::LteStatsCalculator::SetUlOutputFilename(std::string outputFilename) [member function]
    cls.add_method('SetUlOutputFilename',
                   'void',
                   [param('std::string', 'outputFilename')])
    ## lte-stats-calculator.h (module 'lte'): static uint16_t ns3::LteStatsCalculator::FindCellIdFromEnbMac(std::string path, uint16_t rnti) [member function]
    cls.add_method('FindCellIdFromEnbMac',
                   'uint16_t',
                   [param('std::string', 'path'), param('uint16_t', 'rnti')],
                   is_static=True, visibility='protected')
    ## lte-stats-calculator.h (module 'lte'): static uint16_t ns3::LteStatsCalculator::FindCellIdFromEnbRlcPath(std::string path) [member function]
    cls.add_method('FindCellIdFromEnbRlcPath',
                   'uint16_t',
                   [param('std::string', 'path')],
                   is_static=True, visibility='protected')
    ## lte-stats-calculator.h (module 'lte'): static uint64_t ns3::LteStatsCalculator::FindImsiForEnb(std::string path, uint16_t rnti) [member function]
    cls.add_method('FindImsiForEnb',
                   'uint64_t',
                   [param('std::string', 'path'), param('uint16_t', 'rnti')],
                   is_static=True, visibility='protected')
    ## lte-stats-calculator.h (module 'lte'): static uint64_t ns3::LteStatsCalculator::FindImsiForUe(std::string path, uint16_t rnti) [member function]
    cls.add_method('FindImsiForUe',
                   'uint64_t',
                   [param('std::string', 'path'), param('uint16_t', 'rnti')],
                   is_static=True, visibility='protected')
    ## lte-stats-calculator.h (module 'lte'): static uint64_t ns3::LteStatsCalculator::FindImsiFromEnbMac(std::string path, uint16_t rnti) [member function]
    cls.add_method('FindImsiFromEnbMac',
                   'uint64_t',
                   [param('std::string', 'path'), param('uint16_t', 'rnti')],
                   is_static=True, visibility='protected')
    ## lte-stats-calculator.h (module 'lte'): static uint64_t ns3::LteStatsCalculator::FindImsiFromEnbRlcPath(std::string path) [member function]
    cls.add_method('FindImsiFromEnbRlcPath',
                   'uint64_t',
                   [param('std::string', 'path')],
                   is_static=True, visibility='protected')
    ## lte-stats-calculator.h (module 'lte'): static uint64_t ns3::LteStatsCalculator::FindImsiFromLteNetDevice(std::string path) [member function]
    cls.add_method('FindImsiFromLteNetDevice',
                   'uint64_t',
                   [param('std::string', 'path')],
                   is_static=True, visibility='protected')
    ## lte-stats-calculator.h (module 'lte'): static uint64_t ns3::LteStatsCalculator::FindImsiFromUePhy(std::string path) [member function]
    cls.add_method('FindImsiFromUePhy',
                   'uint64_t',
                   [param('std::string', 'path')],
                   is_static=True, visibility='protected')
    return

def register_Ns3LteUeMac_methods(root_module, cls):
    ## lte-ue-mac.h (module 'lte'): ns3::LteUeMac::LteUeMac(ns3::LteUeMac const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteUeMac const &', 'arg0')])
    ## lte-ue-mac.h (module 'lte'): ns3::LteUeMac::LteUeMac() [constructor]
    cls.add_constructor([])
    ## lte-ue-mac.h (module 'lte'): int64_t ns3::LteUeMac::AssignStreams(int64_t stream) [member function]
    cls.add_method('AssignStreams',
                   'int64_t',
                   [param('int64_t', 'stream')])
    ## lte-ue-mac.h (module 'lte'): void ns3::LteUeMac::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## lte-ue-mac.h (module 'lte'): void ns3::LteUeMac::DoSubframeIndication(uint32_t frameNo, uint32_t subframeNo) [member function]
    cls.add_method('DoSubframeIndication',
                   'void',
                   [param('uint32_t', 'frameNo'), param('uint32_t', 'subframeNo')])
    ## lte-ue-mac.h (module 'lte'): ns3::LteMacSapProvider * ns3::LteUeMac::GetLteMacSapProvider() [member function]
    cls.add_method('GetLteMacSapProvider',
                   'ns3::LteMacSapProvider *',
                   [])
    ## lte-ue-mac.h (module 'lte'): ns3::LteUeCmacSapProvider * ns3::LteUeMac::GetLteUeCmacSapProvider() [member function]
    cls.add_method('GetLteUeCmacSapProvider',
                   'ns3::LteUeCmacSapProvider *',
                   [])
    ## lte-ue-mac.h (module 'lte'): ns3::LteUePhySapUser * ns3::LteUeMac::GetLteUePhySapUser() [member function]
    cls.add_method('GetLteUePhySapUser',
                   'ns3::LteUePhySapUser *',
                   [])
    ## lte-ue-mac.h (module 'lte'): static ns3::TypeId ns3::LteUeMac::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## lte-ue-mac.h (module 'lte'): void ns3::LteUeMac::SetComponentCarrierId(uint8_t index) [member function]
    cls.add_method('SetComponentCarrierId',
                   'void',
                   [param('uint8_t', 'index')])
    ## lte-ue-mac.h (module 'lte'): void ns3::LteUeMac::SetLteUeCmacSapUser(ns3::LteUeCmacSapUser * s) [member function]
    cls.add_method('SetLteUeCmacSapUser',
                   'void',
                   [param('ns3::LteUeCmacSapUser *', 's')])
    ## lte-ue-mac.h (module 'lte'): void ns3::LteUeMac::SetLteUePhySapProvider(ns3::LteUePhySapProvider * s) [member function]
    cls.add_method('SetLteUePhySapProvider',
                   'void',
                   [param('ns3::LteUePhySapProvider *', 's')])
    return

def register_Ns3LteUePhy_methods(root_module, cls):
    ## lte-ue-phy.h (module 'lte'): ns3::LteUePhy::LteUePhy(ns3::LteUePhy const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteUePhy const &', 'arg0')])
    ## lte-ue-phy.h (module 'lte'): ns3::LteUePhy::LteUePhy() [constructor]
    cls.add_constructor([])
    ## lte-ue-phy.h (module 'lte'): ns3::LteUePhy::LteUePhy(ns3::Ptr<ns3::LteSpectrumPhy> dlPhy, ns3::Ptr<ns3::LteSpectrumPhy> ulPhy) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::LteSpectrumPhy >', 'dlPhy'), param('ns3::Ptr< ns3::LteSpectrumPhy >', 'ulPhy')])
    ## lte-ue-phy.h (module 'lte'): ns3::Ptr<ns3::DlCqiLteControlMessage> ns3::LteUePhy::CreateDlCqiFeedbackMessage(ns3::SpectrumValue const & sinr) [member function]
    cls.add_method('CreateDlCqiFeedbackMessage',
                   'ns3::Ptr< ns3::DlCqiLteControlMessage >',
                   [param('ns3::SpectrumValue const &', 'sinr')])
    ## lte-ue-phy.h (module 'lte'): ns3::Ptr<ns3::SpectrumValue> ns3::LteUePhy::CreateTxPowerSpectralDensity() [member function]
    cls.add_method('CreateTxPowerSpectralDensity',
                   'ns3::Ptr< ns3::SpectrumValue >',
                   [],
                   is_virtual=True)
    ## lte-ue-phy.h (module 'lte'): void ns3::LteUePhy::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## lte-ue-phy.h (module 'lte'): void ns3::LteUePhy::DoInitialize() [member function]
    cls.add_method('DoInitialize',
                   'void',
                   [],
                   is_virtual=True)
    ## lte-ue-phy.h (module 'lte'): void ns3::LteUePhy::GenerateCtrlCqiReport(ns3::SpectrumValue const & sinr) [member function]
    cls.add_method('GenerateCtrlCqiReport',
                   'void',
                   [param('ns3::SpectrumValue const &', 'sinr')],
                   is_virtual=True)
    ## lte-ue-phy.h (module 'lte'): void ns3::LteUePhy::GenerateDataCqiReport(ns3::SpectrumValue const & sinr) [member function]
    cls.add_method('GenerateDataCqiReport',
                   'void',
                   [param('ns3::SpectrumValue const &', 'sinr')],
                   is_virtual=True)
    ## lte-ue-phy.h (module 'lte'): void ns3::LteUePhy::GenerateMixedCqiReport(ns3::SpectrumValue const & sinr) [member function]
    cls.add_method('GenerateMixedCqiReport',
                   'void',
                   [param('ns3::SpectrumValue const &', 'sinr')],
                   is_virtual=True)
    ## lte-ue-phy.h (module 'lte'): ns3::Ptr<ns3::LteSpectrumPhy> ns3::LteUePhy::GetDlSpectrumPhy() const [member function]
    cls.add_method('GetDlSpectrumPhy',
                   'ns3::Ptr< ns3::LteSpectrumPhy >',
                   [],
                   is_const=True)
    ## lte-ue-phy.h (module 'lte'): ns3::LteUeCphySapProvider * ns3::LteUePhy::GetLteUeCphySapProvider() [member function]
    cls.add_method('GetLteUeCphySapProvider',
                   'ns3::LteUeCphySapProvider *',
                   [])
    ## lte-ue-phy.h (module 'lte'): ns3::LteUePhySapProvider * ns3::LteUePhy::GetLteUePhySapProvider() [member function]
    cls.add_method('GetLteUePhySapProvider',
                   'ns3::LteUePhySapProvider *',
                   [])
    ## lte-ue-phy.h (module 'lte'): uint8_t ns3::LteUePhy::GetMacChDelay() const [member function]
    cls.add_method('GetMacChDelay',
                   'uint8_t',
                   [],
                   is_const=True)
    ## lte-ue-phy.h (module 'lte'): double ns3::LteUePhy::GetNoiseFigure() const [member function]
    cls.add_method('GetNoiseFigure',
                   'double',
                   [],
                   is_const=True)
    ## lte-ue-phy.h (module 'lte'): ns3::LteUePhy::State ns3::LteUePhy::GetState() const [member function]
    cls.add_method('GetState',
                   'ns3::LteUePhy::State',
                   [],
                   is_const=True)
    ## lte-ue-phy.h (module 'lte'): std::vector<int, std::allocator<int> > ns3::LteUePhy::GetSubChannelsForReception() [member function]
    cls.add_method('GetSubChannelsForReception',
                   'std::vector< int >',
                   [])
    ## lte-ue-phy.h (module 'lte'): std::vector<int, std::allocator<int> > ns3::LteUePhy::GetSubChannelsForTransmission() [member function]
    cls.add_method('GetSubChannelsForTransmission',
                   'std::vector< int >',
                   [])
    ## lte-ue-phy.h (module 'lte'): double ns3::LteUePhy::GetTxPower() const [member function]
    cls.add_method('GetTxPower',
                   'double',
                   [],
                   is_const=True)
    ## lte-ue-phy.h (module 'lte'): static ns3::TypeId ns3::LteUePhy::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## lte-ue-phy.h (module 'lte'): ns3::Ptr<ns3::LteSpectrumPhy> ns3::LteUePhy::GetUlSpectrumPhy() const [member function]
    cls.add_method('GetUlSpectrumPhy',
                   'ns3::Ptr< ns3::LteSpectrumPhy >',
                   [],
                   is_const=True)
    ## lte-ue-phy.h (module 'lte'): ns3::Ptr<ns3::LteUePowerControl> ns3::LteUePhy::GetUplinkPowerControl() const [member function]
    cls.add_method('GetUplinkPowerControl',
                   'ns3::Ptr< ns3::LteUePowerControl >',
                   [],
                   is_const=True)
    ## lte-ue-phy.h (module 'lte'): void ns3::LteUePhy::PhyPduReceived(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('PhyPduReceived',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'p')])
    ## lte-ue-phy.h (module 'lte'): void ns3::LteUePhy::ReceiveLteControlMessageList(std::list<ns3::Ptr<ns3::LteControlMessage>, std::allocator<ns3::Ptr<ns3::LteControlMessage> > > msgList) [member function]
    cls.add_method('ReceiveLteControlMessageList',
                   'void',
                   [param('std::list< ns3::Ptr< ns3::LteControlMessage > >', 'msgList')],
                   is_virtual=True)
    ## lte-ue-phy.h (module 'lte'): void ns3::LteUePhy::ReceiveLteDlHarqFeedback(ns3::DlInfoListElement_s mes) [member function]
    cls.add_method('ReceiveLteDlHarqFeedback',
                   'void',
                   [param('ns3::DlInfoListElement_s', 'mes')],
                   is_virtual=True)
    ## lte-ue-phy.h (module 'lte'): void ns3::LteUePhy::ReceivePss(uint16_t cellId, ns3::Ptr<ns3::SpectrumValue> p) [member function]
    cls.add_method('ReceivePss',
                   'void',
                   [param('uint16_t', 'cellId'), param('ns3::Ptr< ns3::SpectrumValue >', 'p')],
                   is_virtual=True)
    ## lte-ue-phy.h (module 'lte'): void ns3::LteUePhy::ReportDataInterference(ns3::SpectrumValue const & interf) [member function]
    cls.add_method('ReportDataInterference',
                   'void',
                   [param('ns3::SpectrumValue const &', 'interf')],
                   is_virtual=True)
    ## lte-ue-phy.h (module 'lte'): void ns3::LteUePhy::ReportInterference(ns3::SpectrumValue const & interf) [member function]
    cls.add_method('ReportInterference',
                   'void',
                   [param('ns3::SpectrumValue const &', 'interf')],
                   is_virtual=True)
    ## lte-ue-phy.h (module 'lte'): void ns3::LteUePhy::ReportRsReceivedPower(ns3::SpectrumValue const & power) [member function]
    cls.add_method('ReportRsReceivedPower',
                   'void',
                   [param('ns3::SpectrumValue const &', 'power')],
                   is_virtual=True)
    ## lte-ue-phy.h (module 'lte'): void ns3::LteUePhy::SendSrs() [member function]
    cls.add_method('SendSrs',
                   'void',
                   [])
    ## lte-ue-phy.h (module 'lte'): void ns3::LteUePhy::SetHarqPhyModule(ns3::Ptr<ns3::LteHarqPhy> harq) [member function]
    cls.add_method('SetHarqPhyModule',
                   'void',
                   [param('ns3::Ptr< ns3::LteHarqPhy >', 'harq')])
    ## lte-ue-phy.h (module 'lte'): void ns3::LteUePhy::SetLteUeCphySapUser(ns3::LteUeCphySapUser * s) [member function]
    cls.add_method('SetLteUeCphySapUser',
                   'void',
                   [param('ns3::LteUeCphySapUser *', 's')])
    ## lte-ue-phy.h (module 'lte'): void ns3::LteUePhy::SetLteUePhySapUser(ns3::LteUePhySapUser * s) [member function]
    cls.add_method('SetLteUePhySapUser',
                   'void',
                   [param('ns3::LteUePhySapUser *', 's')])
    ## lte-ue-phy.h (module 'lte'): void ns3::LteUePhy::SetNoiseFigure(double nf) [member function]
    cls.add_method('SetNoiseFigure',
                   'void',
                   [param('double', 'nf')])
    ## lte-ue-phy.h (module 'lte'): void ns3::LteUePhy::SetSubChannelsForReception(std::vector<int, std::allocator<int> > mask) [member function]
    cls.add_method('SetSubChannelsForReception',
                   'void',
                   [param('std::vector< int >', 'mask')])
    ## lte-ue-phy.h (module 'lte'): void ns3::LteUePhy::SetSubChannelsForTransmission(std::vector<int, std::allocator<int> > mask) [member function]
    cls.add_method('SetSubChannelsForTransmission',
                   'void',
                   [param('std::vector< int >', 'mask')])
    ## lte-ue-phy.h (module 'lte'): void ns3::LteUePhy::SetTxPower(double pow) [member function]
    cls.add_method('SetTxPower',
                   'void',
                   [param('double', 'pow')])
    ## lte-ue-phy.h (module 'lte'): void ns3::LteUePhy::SubframeIndication(uint32_t frameNo, uint32_t subframeNo) [member function]
    cls.add_method('SubframeIndication',
                   'void',
                   [param('uint32_t', 'frameNo'), param('uint32_t', 'subframeNo')])
    ## lte-ue-phy.h (module 'lte'): void ns3::LteUePhy::DoSendLteControlMessage(ns3::Ptr<ns3::LteControlMessage> msg) [member function]
    cls.add_method('DoSendLteControlMessage',
                   'void',
                   [param('ns3::Ptr< ns3::LteControlMessage >', 'msg')],
                   visibility='private', is_virtual=True)
    ## lte-ue-phy.h (module 'lte'): void ns3::LteUePhy::DoSendMacPdu(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('DoSendMacPdu',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'p')],
                   visibility='private', is_virtual=True)
    ## lte-ue-phy.h (module 'lte'): void ns3::LteUePhy::DoSendRachPreamble(uint32_t prachId, uint32_t raRnti) [member function]
    cls.add_method('DoSendRachPreamble',
                   'void',
                   [param('uint32_t', 'prachId'), param('uint32_t', 'raRnti')],
                   visibility='private', is_virtual=True)
    return

def register_Ns3LteUePowerControl_methods(root_module, cls):
    ## lte-ue-power-control.h (module 'lte'): ns3::LteUePowerControl::LteUePowerControl(ns3::LteUePowerControl const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteUePowerControl const &', 'arg0')])
    ## lte-ue-power-control.h (module 'lte'): ns3::LteUePowerControl::LteUePowerControl() [constructor]
    cls.add_constructor([])
    ## lte-ue-power-control.h (module 'lte'): void ns3::LteUePowerControl::CalculatePucchTxPower() [member function]
    cls.add_method('CalculatePucchTxPower',
                   'void',
                   [])
    ## lte-ue-power-control.h (module 'lte'): void ns3::LteUePowerControl::CalculatePuschTxPower() [member function]
    cls.add_method('CalculatePuschTxPower',
                   'void',
                   [])
    ## lte-ue-power-control.h (module 'lte'): void ns3::LteUePowerControl::CalculateSrsTxPower() [member function]
    cls.add_method('CalculateSrsTxPower',
                   'void',
                   [])
    ## lte-ue-power-control.h (module 'lte'): void ns3::LteUePowerControl::ConfigureReferenceSignalPower(int8_t referenceSignalPower) [member function]
    cls.add_method('ConfigureReferenceSignalPower',
                   'void',
                   [param('int8_t', 'referenceSignalPower')])
    ## lte-ue-power-control.h (module 'lte'): void ns3::LteUePowerControl::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## lte-ue-power-control.h (module 'lte'): void ns3::LteUePowerControl::DoInitialize() [member function]
    cls.add_method('DoInitialize',
                   'void',
                   [],
                   is_virtual=True)
    ## lte-ue-power-control.h (module 'lte'): double ns3::LteUePowerControl::GetPcmax() [member function]
    cls.add_method('GetPcmax',
                   'double',
                   [])
    ## lte-ue-power-control.h (module 'lte'): double ns3::LteUePowerControl::GetPucchTxPower(std::vector<int, std::allocator<int> > rb) [member function]
    cls.add_method('GetPucchTxPower',
                   'double',
                   [param('std::vector< int >', 'rb')])
    ## lte-ue-power-control.h (module 'lte'): double ns3::LteUePowerControl::GetPuschTxPower(std::vector<int, std::allocator<int> > rb) [member function]
    cls.add_method('GetPuschTxPower',
                   'double',
                   [param('std::vector< int >', 'rb')])
    ## lte-ue-power-control.h (module 'lte'): double ns3::LteUePowerControl::GetSrsTxPower(std::vector<int, std::allocator<int> > rb) [member function]
    cls.add_method('GetSrsTxPower',
                   'double',
                   [param('std::vector< int >', 'rb')])
    ## lte-ue-power-control.h (module 'lte'): static ns3::TypeId ns3::LteUePowerControl::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## lte-ue-power-control.h (module 'lte'): void ns3::LteUePowerControl::ReportTpc(uint8_t tpc) [member function]
    cls.add_method('ReportTpc',
                   'void',
                   [param('uint8_t', 'tpc')])
    ## lte-ue-power-control.h (module 'lte'): void ns3::LteUePowerControl::SetAlpha(double value) [member function]
    cls.add_method('SetAlpha',
                   'void',
                   [param('double', 'value')])
    ## lte-ue-power-control.h (module 'lte'): void ns3::LteUePowerControl::SetCellId(uint16_t cellId) [member function]
    cls.add_method('SetCellId',
                   'void',
                   [param('uint16_t', 'cellId')])
    ## lte-ue-power-control.h (module 'lte'): void ns3::LteUePowerControl::SetPcmax(double value) [member function]
    cls.add_method('SetPcmax',
                   'void',
                   [param('double', 'value')])
    ## lte-ue-power-control.h (module 'lte'): void ns3::LteUePowerControl::SetPoNominalPusch(int16_t value) [member function]
    cls.add_method('SetPoNominalPusch',
                   'void',
                   [param('int16_t', 'value')])
    ## lte-ue-power-control.h (module 'lte'): void ns3::LteUePowerControl::SetPoUePusch(int16_t value) [member function]
    cls.add_method('SetPoUePusch',
                   'void',
                   [param('int16_t', 'value')])
    ## lte-ue-power-control.h (module 'lte'): void ns3::LteUePowerControl::SetRnti(uint16_t rnti) [member function]
    cls.add_method('SetRnti',
                   'void',
                   [param('uint16_t', 'rnti')])
    ## lte-ue-power-control.h (module 'lte'): void ns3::LteUePowerControl::SetRsrp(double value) [member function]
    cls.add_method('SetRsrp',
                   'void',
                   [param('double', 'value')])
    ## lte-ue-power-control.h (module 'lte'): void ns3::LteUePowerControl::SetTxPower(double value) [member function]
    cls.add_method('SetTxPower',
                   'void',
                   [param('double', 'value')])
    return

def register_Ns3LteUeRrc_methods(root_module, cls):
    ## lte-ue-rrc.h (module 'lte'): ns3::LteUeRrc::LteUeRrc(ns3::LteUeRrc const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteUeRrc const &', 'arg0')])
    ## lte-ue-rrc.h (module 'lte'): ns3::LteUeRrc::LteUeRrc() [constructor]
    cls.add_constructor([])
    ## lte-ue-rrc.h (module 'lte'): void ns3::LteUeRrc::AddLteCellId(uint16_t cellId) [member function]
    cls.add_method('AddLteCellId',
                   'void',
                   [param('uint16_t', 'cellId')])
    ## lte-ue-rrc.h (module 'lte'): void ns3::LteUeRrc::AddMmWaveCellId(uint16_t cellId) [member function]
    cls.add_method('AddMmWaveCellId',
                   'void',
                   [param('uint16_t', 'cellId')])
    ## lte-ue-rrc.h (module 'lte'): ns3::LteAsSapProvider * ns3::LteUeRrc::GetAsSapProvider() [member function]
    cls.add_method('GetAsSapProvider',
                   'ns3::LteAsSapProvider *',
                   [])
    ## lte-ue-rrc.h (module 'lte'): uint16_t ns3::LteUeRrc::GetCellId() const [member function]
    cls.add_method('GetCellId',
                   'uint16_t',
                   [],
                   is_const=True)
    ## lte-ue-rrc.h (module 'lte'): uint8_t ns3::LteUeRrc::GetDlBandwidth() const [member function]
    cls.add_method('GetDlBandwidth',
                   'uint8_t',
                   [],
                   is_const=True)
    ## lte-ue-rrc.h (module 'lte'): uint32_t ns3::LteUeRrc::GetDlEarfcn() const [member function]
    cls.add_method('GetDlEarfcn',
                   'uint32_t',
                   [],
                   is_const=True)
    ## lte-ue-rrc.h (module 'lte'): uint64_t ns3::LteUeRrc::GetImsi() const [member function]
    cls.add_method('GetImsi',
                   'uint64_t',
                   [],
                   is_const=True)
    ## lte-ue-rrc.h (module 'lte'): ns3::LteUeCcmRrcSapUser * ns3::LteUeRrc::GetLteCcmRrcSapUser() [member function]
    cls.add_method('GetLteCcmRrcSapUser',
                   'ns3::LteUeCcmRrcSapUser *',
                   [])
    ## lte-ue-rrc.h (module 'lte'): ns3::LteUeCmacSapUser * ns3::LteUeRrc::GetLteUeCmacSapUser() [member function]
    cls.add_method('GetLteUeCmacSapUser',
                   'ns3::LteUeCmacSapUser *',
                   [])
    ## lte-ue-rrc.h (module 'lte'): ns3::LteUeCmacSapUser * ns3::LteUeRrc::GetLteUeCmacSapUser(uint8_t index) [member function]
    cls.add_method('GetLteUeCmacSapUser',
                   'ns3::LteUeCmacSapUser *',
                   [param('uint8_t', 'index')])
    ## lte-ue-rrc.h (module 'lte'): ns3::LteUeCphySapUser * ns3::LteUeRrc::GetLteUeCphySapUser() [member function]
    cls.add_method('GetLteUeCphySapUser',
                   'ns3::LteUeCphySapUser *',
                   [])
    ## lte-ue-rrc.h (module 'lte'): ns3::LteUeCphySapUser * ns3::LteUeRrc::GetLteUeCphySapUser(uint8_t index) [member function]
    cls.add_method('GetLteUeCphySapUser',
                   'ns3::LteUeCphySapUser *',
                   [param('uint8_t', 'index')])
    ## lte-ue-rrc.h (module 'lte'): ns3::LteUeRrcSapProvider * ns3::LteUeRrc::GetLteUeRrcSapProvider() [member function]
    cls.add_method('GetLteUeRrcSapProvider',
                   'ns3::LteUeRrcSapProvider *',
                   [])
    ## lte-ue-rrc.h (module 'lte'): uint16_t ns3::LteUeRrc::GetRnti() const [member function]
    cls.add_method('GetRnti',
                   'uint16_t',
                   [],
                   is_const=True)
    ## lte-ue-rrc.h (module 'lte'): ns3::LteUeRrc::State ns3::LteUeRrc::GetState() const [member function]
    cls.add_method('GetState',
                   'ns3::LteUeRrc::State',
                   [],
                   is_const=True)
    ## lte-ue-rrc.h (module 'lte'): static ns3::TypeId ns3::LteUeRrc::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## lte-ue-rrc.h (module 'lte'): uint8_t ns3::LteUeRrc::GetUlBandwidth() const [member function]
    cls.add_method('GetUlBandwidth',
                   'uint8_t',
                   [],
                   is_const=True)
    ## lte-ue-rrc.h (module 'lte'): uint32_t ns3::LteUeRrc::GetUlEarfcn() const [member function]
    cls.add_method('GetUlEarfcn',
                   'uint32_t',
                   [],
                   is_const=True)
    ## lte-ue-rrc.h (module 'lte'): void ns3::LteUeRrc::InitializeSap() [member function]
    cls.add_method('InitializeSap',
                   'void',
                   [])
    ## lte-ue-rrc.h (module 'lte'): void ns3::LteUeRrc::SetAsSapUser(ns3::LteAsSapUser * s) [member function]
    cls.add_method('SetAsSapUser',
                   'void',
                   [param('ns3::LteAsSapUser *', 's')])
    ## lte-ue-rrc.h (module 'lte'): void ns3::LteUeRrc::SetImsi(uint64_t imsi) [member function]
    cls.add_method('SetImsi',
                   'void',
                   [param('uint64_t', 'imsi')])
    ## lte-ue-rrc.h (module 'lte'): void ns3::LteUeRrc::SetLteCcmRrcSapProvider(ns3::LteUeCcmRrcSapProvider * s) [member function]
    cls.add_method('SetLteCcmRrcSapProvider',
                   'void',
                   [param('ns3::LteUeCcmRrcSapProvider *', 's')])
    ## lte-ue-rrc.h (module 'lte'): void ns3::LteUeRrc::SetLteMacSapProvider(ns3::LteMacSapProvider * s) [member function]
    cls.add_method('SetLteMacSapProvider',
                   'void',
                   [param('ns3::LteMacSapProvider *', 's')])
    ## lte-ue-rrc.h (module 'lte'): void ns3::LteUeRrc::SetLteUeCmacSapProvider(ns3::LteUeCmacSapProvider * s) [member function]
    cls.add_method('SetLteUeCmacSapProvider',
                   'void',
                   [param('ns3::LteUeCmacSapProvider *', 's')])
    ## lte-ue-rrc.h (module 'lte'): void ns3::LteUeRrc::SetLteUeCmacSapProvider(ns3::LteUeCmacSapProvider * s, uint8_t index) [member function]
    cls.add_method('SetLteUeCmacSapProvider',
                   'void',
                   [param('ns3::LteUeCmacSapProvider *', 's'), param('uint8_t', 'index')])
    ## lte-ue-rrc.h (module 'lte'): void ns3::LteUeRrc::SetLteUeCphySapProvider(ns3::LteUeCphySapProvider * s) [member function]
    cls.add_method('SetLteUeCphySapProvider',
                   'void',
                   [param('ns3::LteUeCphySapProvider *', 's')])
    ## lte-ue-rrc.h (module 'lte'): void ns3::LteUeRrc::SetLteUeCphySapProvider(ns3::LteUeCphySapProvider * s, uint8_t index) [member function]
    cls.add_method('SetLteUeCphySapProvider',
                   'void',
                   [param('ns3::LteUeCphySapProvider *', 's'), param('uint8_t', 'index')])
    ## lte-ue-rrc.h (module 'lte'): void ns3::LteUeRrc::SetLteUeRrcSapUser(ns3::LteUeRrcSapUser * s) [member function]
    cls.add_method('SetLteUeRrcSapUser',
                   'void',
                   [param('ns3::LteUeRrcSapUser *', 's')])
    ## lte-ue-rrc.h (module 'lte'): void ns3::LteUeRrc::SetMmWaveMacSapProvider(ns3::LteMacSapProvider * s) [member function]
    cls.add_method('SetMmWaveMacSapProvider',
                   'void',
                   [param('ns3::LteMacSapProvider *', 's')])
    ## lte-ue-rrc.h (module 'lte'): void ns3::LteUeRrc::SetMmWaveUeCmacSapProvider(ns3::LteUeCmacSapProvider * s) [member function]
    cls.add_method('SetMmWaveUeCmacSapProvider',
                   'void',
                   [param('ns3::LteUeCmacSapProvider *', 's')])
    ## lte-ue-rrc.h (module 'lte'): void ns3::LteUeRrc::SetMmWaveUeCmacSapProvider(ns3::LteUeCmacSapProvider * s, uint8_t index) [member function]
    cls.add_method('SetMmWaveUeCmacSapProvider',
                   'void',
                   [param('ns3::LteUeCmacSapProvider *', 's'), param('uint8_t', 'index')])
    ## lte-ue-rrc.h (module 'lte'): void ns3::LteUeRrc::SetMmWaveUeCphySapProvider(ns3::LteUeCphySapProvider * s) [member function]
    cls.add_method('SetMmWaveUeCphySapProvider',
                   'void',
                   [param('ns3::LteUeCphySapProvider *', 's')])
    ## lte-ue-rrc.h (module 'lte'): void ns3::LteUeRrc::SetUseRlcSm(bool val) [member function]
    cls.add_method('SetUseRlcSm',
                   'void',
                   [param('bool', 'val')])
    ## lte-ue-rrc.h (module 'lte'): bool ns3::LteUeRrc::SwitchLowerLayerProviders(uint16_t cellId) [member function]
    cls.add_method('SwitchLowerLayerProviders',
                   'bool',
                   [param('uint16_t', 'cellId')])
    ## lte-ue-rrc.h (module 'lte'): ns3::LteUeRrc::m_numberOfComponentCarriers [variable]
    cls.add_instance_attribute('m_numberOfComponentCarriers', 'uint16_t', is_const=False)
    ## lte-ue-rrc.h (module 'lte'): ns3::LteUeRrc::m_numberOfMmWaveComponentCarriers [variable]
    cls.add_instance_attribute('m_numberOfMmWaveComponentCarriers', 'uint16_t', is_const=False)
    ## lte-ue-rrc.h (module 'lte'): void ns3::LteUeRrc::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   visibility='private', is_virtual=True)
    ## lte-ue-rrc.h (module 'lte'): void ns3::LteUeRrc::DoInitialize() [member function]
    cls.add_method('DoInitialize',
                   'void',
                   [],
                   visibility='private', is_virtual=True)
    return

def register_Ns3Mac48AddressChecker_methods(root_module, cls):
    ## mac48-address.h (module 'network'): ns3::Mac48AddressChecker::Mac48AddressChecker() [constructor]
    cls.add_constructor([])
    ## mac48-address.h (module 'network'): ns3::Mac48AddressChecker::Mac48AddressChecker(ns3::Mac48AddressChecker const & arg0) [constructor]
    cls.add_constructor([param('ns3::Mac48AddressChecker const &', 'arg0')])
    return

def register_Ns3Mac48AddressValue_methods(root_module, cls):
    ## mac48-address.h (module 'network'): ns3::Mac48AddressValue::Mac48AddressValue() [constructor]
    cls.add_constructor([])
    ## mac48-address.h (module 'network'): ns3::Mac48AddressValue::Mac48AddressValue(ns3::Mac48Address const & value) [constructor]
    cls.add_constructor([param('ns3::Mac48Address const &', 'value')])
    ## mac48-address.h (module 'network'): ns3::Mac48AddressValue::Mac48AddressValue(ns3::Mac48AddressValue const & arg0) [constructor]
    cls.add_constructor([param('ns3::Mac48AddressValue const &', 'arg0')])
    ## mac48-address.h (module 'network'): ns3::Ptr<ns3::AttributeValue> ns3::Mac48AddressValue::Copy() const [member function]
    cls.add_method('Copy',
                   'ns3::Ptr< ns3::AttributeValue >',
                   [],
                   is_const=True, is_virtual=True)
    ## mac48-address.h (module 'network'): bool ns3::Mac48AddressValue::DeserializeFromString(std::string value, ns3::Ptr<const ns3::AttributeChecker> checker) [member function]
    cls.add_method('DeserializeFromString',
                   'bool',
                   [param('std::string', 'value'), param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_virtual=True)
    ## mac48-address.h (module 'network'): ns3::Mac48Address ns3::Mac48AddressValue::Get() const [member function]
    cls.add_method('Get',
                   'ns3::Mac48Address',
                   [],
                   is_const=True)
    ## mac48-address.h (module 'network'): std::string ns3::Mac48AddressValue::SerializeToString(ns3::Ptr<const ns3::AttributeChecker> checker) const [member function]
    cls.add_method('SerializeToString',
                   'std::string',
                   [param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_const=True, is_virtual=True)
    ## mac48-address.h (module 'network'): void ns3::Mac48AddressValue::Set(ns3::Mac48Address const & value) [member function]
    cls.add_method('Set',
                   'void',
                   [param('ns3::Mac48Address const &', 'value')])
    return

def register_Ns3Mac64AddressChecker_methods(root_module, cls):
    ## mac64-address.h (module 'network'): ns3::Mac64AddressChecker::Mac64AddressChecker() [constructor]
    cls.add_constructor([])
    ## mac64-address.h (module 'network'): ns3::Mac64AddressChecker::Mac64AddressChecker(ns3::Mac64AddressChecker const & arg0) [constructor]
    cls.add_constructor([param('ns3::Mac64AddressChecker const &', 'arg0')])
    return

def register_Ns3Mac64AddressValue_methods(root_module, cls):
    ## mac64-address.h (module 'network'): ns3::Mac64AddressValue::Mac64AddressValue() [constructor]
    cls.add_constructor([])
    ## mac64-address.h (module 'network'): ns3::Mac64AddressValue::Mac64AddressValue(ns3::Mac64Address const & value) [constructor]
    cls.add_constructor([param('ns3::Mac64Address const &', 'value')])
    ## mac64-address.h (module 'network'): ns3::Mac64AddressValue::Mac64AddressValue(ns3::Mac64AddressValue const & arg0) [constructor]
    cls.add_constructor([param('ns3::Mac64AddressValue const &', 'arg0')])
    ## mac64-address.h (module 'network'): ns3::Ptr<ns3::AttributeValue> ns3::Mac64AddressValue::Copy() const [member function]
    cls.add_method('Copy',
                   'ns3::Ptr< ns3::AttributeValue >',
                   [],
                   is_const=True, is_virtual=True)
    ## mac64-address.h (module 'network'): bool ns3::Mac64AddressValue::DeserializeFromString(std::string value, ns3::Ptr<const ns3::AttributeChecker> checker) [member function]
    cls.add_method('DeserializeFromString',
                   'bool',
                   [param('std::string', 'value'), param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_virtual=True)
    ## mac64-address.h (module 'network'): ns3::Mac64Address ns3::Mac64AddressValue::Get() const [member function]
    cls.add_method('Get',
                   'ns3::Mac64Address',
                   [],
                   is_const=True)
    ## mac64-address.h (module 'network'): std::string ns3::Mac64AddressValue::SerializeToString(ns3::Ptr<const ns3::AttributeChecker> checker) const [member function]
    cls.add_method('SerializeToString',
                   'std::string',
                   [param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_const=True, is_virtual=True)
    ## mac64-address.h (module 'network'): void ns3::Mac64AddressValue::Set(ns3::Mac64Address const & value) [member function]
    cls.add_method('Set',
                   'void',
                   [param('ns3::Mac64Address const &', 'value')])
    return

def register_Ns3MatrixPropagationLossModel_methods(root_module, cls):
    ## propagation-loss-model.h (module 'propagation'): static ns3::TypeId ns3::MatrixPropagationLossModel::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## propagation-loss-model.h (module 'propagation'): ns3::MatrixPropagationLossModel::MatrixPropagationLossModel() [constructor]
    cls.add_constructor([])
    ## propagation-loss-model.h (module 'propagation'): void ns3::MatrixPropagationLossModel::SetLoss(ns3::Ptr<ns3::MobilityModel> a, ns3::Ptr<ns3::MobilityModel> b, double loss, bool symmetric=true) [member function]
    cls.add_method('SetLoss',
                   'void',
                   [param('ns3::Ptr< ns3::MobilityModel >', 'a'), param('ns3::Ptr< ns3::MobilityModel >', 'b'), param('double', 'loss'), param('bool', 'symmetric', default_value='true')])
    ## propagation-loss-model.h (module 'propagation'): void ns3::MatrixPropagationLossModel::SetDefaultLoss(double defaultLoss) [member function]
    cls.add_method('SetDefaultLoss',
                   'void',
                   [param('double', 'defaultLoss')])
    ## propagation-loss-model.h (module 'propagation'): double ns3::MatrixPropagationLossModel::DoCalcRxPower(double txPowerDbm, ns3::Ptr<ns3::MobilityModel> a, ns3::Ptr<ns3::MobilityModel> b) const [member function]
    cls.add_method('DoCalcRxPower',
                   'double',
                   [param('double', 'txPowerDbm'), param('ns3::Ptr< ns3::MobilityModel >', 'a'), param('ns3::Ptr< ns3::MobilityModel >', 'b')],
                   is_const=True, visibility='private', is_virtual=True)
    ## propagation-loss-model.h (module 'propagation'): int64_t ns3::MatrixPropagationLossModel::DoAssignStreams(int64_t stream) [member function]
    cls.add_method('DoAssignStreams',
                   'int64_t',
                   [param('int64_t', 'stream')],
                   visibility='private', is_virtual=True)
    return

def register_Ns3MibLteControlMessage_methods(root_module, cls):
    ## lte-control-messages.h (module 'lte'): ns3::MibLteControlMessage::MibLteControlMessage(ns3::MibLteControlMessage const & arg0) [constructor]
    cls.add_constructor([param('ns3::MibLteControlMessage const &', 'arg0')])
    ## lte-control-messages.h (module 'lte'): ns3::MibLteControlMessage::MibLteControlMessage() [constructor]
    cls.add_constructor([])
    ## lte-control-messages.h (module 'lte'): ns3::LteRrcSap::MasterInformationBlock ns3::MibLteControlMessage::GetMib() const [member function]
    cls.add_method('GetMib',
                   'ns3::LteRrcSap::MasterInformationBlock',
                   [],
                   is_const=True)
    ## lte-control-messages.h (module 'lte'): void ns3::MibLteControlMessage::SetMib(ns3::LteRrcSap::MasterInformationBlock mib) [member function]
    cls.add_method('SetMib',
                   'void',
                   [param('ns3::LteRrcSap::MasterInformationBlock', 'mib')])
    return

def register_Ns3MinMaxAvgTotalCalculator__Unsigned_int_methods(root_module, cls):
    ## basic-data-calculators.h (module 'stats'): ns3::MinMaxAvgTotalCalculator<unsigned int>::MinMaxAvgTotalCalculator(ns3::MinMaxAvgTotalCalculator<unsigned int> const & arg0) [constructor]
    cls.add_constructor([param('ns3::MinMaxAvgTotalCalculator< unsigned int > const &', 'arg0')])
    ## basic-data-calculators.h (module 'stats'): ns3::MinMaxAvgTotalCalculator<unsigned int>::MinMaxAvgTotalCalculator() [constructor]
    cls.add_constructor([])
    ## basic-data-calculators.h (module 'stats'): static ns3::TypeId ns3::MinMaxAvgTotalCalculator<unsigned int>::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## basic-data-calculators.h (module 'stats'): void ns3::MinMaxAvgTotalCalculator<unsigned int>::Output(ns3::DataOutputCallback & callback) const [member function]
    cls.add_method('Output',
                   'void',
                   [param('ns3::DataOutputCallback &', 'callback')],
                   is_const=True, is_virtual=True)
    ## basic-data-calculators.h (module 'stats'): void ns3::MinMaxAvgTotalCalculator<unsigned int>::Reset() [member function]
    cls.add_method('Reset',
                   'void',
                   [])
    ## basic-data-calculators.h (module 'stats'): void ns3::MinMaxAvgTotalCalculator<unsigned int>::Update(unsigned int const i) [member function]
    cls.add_method('Update',
                   'void',
                   [param('unsigned int const', 'i')])
    ## basic-data-calculators.h (module 'stats'): long int ns3::MinMaxAvgTotalCalculator<unsigned int>::getCount() const [member function]
    cls.add_method('getCount',
                   'long int',
                   [],
                   is_const=True, is_virtual=True)
    ## basic-data-calculators.h (module 'stats'): double ns3::MinMaxAvgTotalCalculator<unsigned int>::getMax() const [member function]
    cls.add_method('getMax',
                   'double',
                   [],
                   is_const=True, is_virtual=True)
    ## basic-data-calculators.h (module 'stats'): double ns3::MinMaxAvgTotalCalculator<unsigned int>::getMean() const [member function]
    cls.add_method('getMean',
                   'double',
                   [],
                   is_const=True, is_virtual=True)
    ## basic-data-calculators.h (module 'stats'): double ns3::MinMaxAvgTotalCalculator<unsigned int>::getMin() const [member function]
    cls.add_method('getMin',
                   'double',
                   [],
                   is_const=True, is_virtual=True)
    ## basic-data-calculators.h (module 'stats'): double ns3::MinMaxAvgTotalCalculator<unsigned int>::getSqrSum() const [member function]
    cls.add_method('getSqrSum',
                   'double',
                   [],
                   is_const=True, is_virtual=True)
    ## basic-data-calculators.h (module 'stats'): double ns3::MinMaxAvgTotalCalculator<unsigned int>::getStddev() const [member function]
    cls.add_method('getStddev',
                   'double',
                   [],
                   is_const=True, is_virtual=True)
    ## basic-data-calculators.h (module 'stats'): double ns3::MinMaxAvgTotalCalculator<unsigned int>::getSum() const [member function]
    cls.add_method('getSum',
                   'double',
                   [],
                   is_const=True, is_virtual=True)
    ## basic-data-calculators.h (module 'stats'): double ns3::MinMaxAvgTotalCalculator<unsigned int>::getVariance() const [member function]
    cls.add_method('getVariance',
                   'double',
                   [],
                   is_const=True, is_virtual=True)
    ## basic-data-calculators.h (module 'stats'): void ns3::MinMaxAvgTotalCalculator<unsigned int>::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   visibility='protected', is_virtual=True)
    return

def register_Ns3MinMaxAvgTotalCalculator__Unsigned_long_methods(root_module, cls):
    ## basic-data-calculators.h (module 'stats'): ns3::MinMaxAvgTotalCalculator<unsigned long>::MinMaxAvgTotalCalculator(ns3::MinMaxAvgTotalCalculator<unsigned long> const & arg0) [constructor]
    cls.add_constructor([param('ns3::MinMaxAvgTotalCalculator< unsigned long > const &', 'arg0')])
    ## basic-data-calculators.h (module 'stats'): ns3::MinMaxAvgTotalCalculator<unsigned long>::MinMaxAvgTotalCalculator() [constructor]
    cls.add_constructor([])
    ## basic-data-calculators.h (module 'stats'): static ns3::TypeId ns3::MinMaxAvgTotalCalculator<unsigned long>::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## basic-data-calculators.h (module 'stats'): void ns3::MinMaxAvgTotalCalculator<unsigned long>::Output(ns3::DataOutputCallback & callback) const [member function]
    cls.add_method('Output',
                   'void',
                   [param('ns3::DataOutputCallback &', 'callback')],
                   is_const=True, is_virtual=True)
    ## basic-data-calculators.h (module 'stats'): void ns3::MinMaxAvgTotalCalculator<unsigned long>::Reset() [member function]
    cls.add_method('Reset',
                   'void',
                   [])
    ## basic-data-calculators.h (module 'stats'): void ns3::MinMaxAvgTotalCalculator<unsigned long>::Update(long unsigned int const i) [member function]
    cls.add_method('Update',
                   'void',
                   [param('long unsigned int const', 'i')])
    ## basic-data-calculators.h (module 'stats'): long int ns3::MinMaxAvgTotalCalculator<unsigned long>::getCount() const [member function]
    cls.add_method('getCount',
                   'long int',
                   [],
                   is_const=True, is_virtual=True)
    ## basic-data-calculators.h (module 'stats'): double ns3::MinMaxAvgTotalCalculator<unsigned long>::getMax() const [member function]
    cls.add_method('getMax',
                   'double',
                   [],
                   is_const=True, is_virtual=True)
    ## basic-data-calculators.h (module 'stats'): double ns3::MinMaxAvgTotalCalculator<unsigned long>::getMean() const [member function]
    cls.add_method('getMean',
                   'double',
                   [],
                   is_const=True, is_virtual=True)
    ## basic-data-calculators.h (module 'stats'): double ns3::MinMaxAvgTotalCalculator<unsigned long>::getMin() const [member function]
    cls.add_method('getMin',
                   'double',
                   [],
                   is_const=True, is_virtual=True)
    ## basic-data-calculators.h (module 'stats'): double ns3::MinMaxAvgTotalCalculator<unsigned long>::getSqrSum() const [member function]
    cls.add_method('getSqrSum',
                   'double',
                   [],
                   is_const=True, is_virtual=True)
    ## basic-data-calculators.h (module 'stats'): double ns3::MinMaxAvgTotalCalculator<unsigned long>::getStddev() const [member function]
    cls.add_method('getStddev',
                   'double',
                   [],
                   is_const=True, is_virtual=True)
    ## basic-data-calculators.h (module 'stats'): double ns3::MinMaxAvgTotalCalculator<unsigned long>::getSum() const [member function]
    cls.add_method('getSum',
                   'double',
                   [],
                   is_const=True, is_virtual=True)
    ## basic-data-calculators.h (module 'stats'): double ns3::MinMaxAvgTotalCalculator<unsigned long>::getVariance() const [member function]
    cls.add_method('getVariance',
                   'double',
                   [],
                   is_const=True, is_virtual=True)
    ## basic-data-calculators.h (module 'stats'): void ns3::MinMaxAvgTotalCalculator<unsigned long>::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   visibility='protected', is_virtual=True)
    return

def register_Ns3MobilityBuildingInfo_methods(root_module, cls):
    ## mobility-building-info.h (module 'buildings'): ns3::MobilityBuildingInfo::MobilityBuildingInfo(ns3::MobilityBuildingInfo const & arg0) [constructor]
    cls.add_constructor([param('ns3::MobilityBuildingInfo const &', 'arg0')])
    ## mobility-building-info.h (module 'buildings'): ns3::MobilityBuildingInfo::MobilityBuildingInfo() [constructor]
    cls.add_constructor([])
    ## mobility-building-info.h (module 'buildings'): ns3::MobilityBuildingInfo::MobilityBuildingInfo(ns3::Ptr<ns3::Building> building) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::Building >', 'building')])
    ## mobility-building-info.h (module 'buildings'): ns3::Ptr<ns3::Building> ns3::MobilityBuildingInfo::GetBuilding() [member function]
    cls.add_method('GetBuilding',
                   'ns3::Ptr< ns3::Building >',
                   [])
    ## mobility-building-info.h (module 'buildings'): uint8_t ns3::MobilityBuildingInfo::GetFloorNumber() [member function]
    cls.add_method('GetFloorNumber',
                   'uint8_t',
                   [])
    ## mobility-building-info.h (module 'buildings'): uint8_t ns3::MobilityBuildingInfo::GetRoomNumberX() [member function]
    cls.add_method('GetRoomNumberX',
                   'uint8_t',
                   [])
    ## mobility-building-info.h (module 'buildings'): uint8_t ns3::MobilityBuildingInfo::GetRoomNumberY() [member function]
    cls.add_method('GetRoomNumberY',
                   'uint8_t',
                   [])
    ## mobility-building-info.h (module 'buildings'): static ns3::TypeId ns3::MobilityBuildingInfo::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mobility-building-info.h (module 'buildings'): bool ns3::MobilityBuildingInfo::IsIndoor() [member function]
    cls.add_method('IsIndoor',
                   'bool',
                   [])
    ## mobility-building-info.h (module 'buildings'): bool ns3::MobilityBuildingInfo::IsOutdoor() [member function]
    cls.add_method('IsOutdoor',
                   'bool',
                   [])
    ## mobility-building-info.h (module 'buildings'): void ns3::MobilityBuildingInfo::SetIndoor(ns3::Ptr<ns3::Building> building, uint8_t nfloor, uint8_t nroomx, uint8_t nroomy) [member function]
    cls.add_method('SetIndoor',
                   'void',
                   [param('ns3::Ptr< ns3::Building >', 'building'), param('uint8_t', 'nfloor'), param('uint8_t', 'nroomx'), param('uint8_t', 'nroomy')])
    ## mobility-building-info.h (module 'buildings'): void ns3::MobilityBuildingInfo::SetIndoor(uint8_t nfloor, uint8_t nroomx, uint8_t nroomy) [member function]
    cls.add_method('SetIndoor',
                   'void',
                   [param('uint8_t', 'nfloor'), param('uint8_t', 'nroomx'), param('uint8_t', 'nroomy')])
    ## mobility-building-info.h (module 'buildings'): void ns3::MobilityBuildingInfo::SetOutdoor() [member function]
    cls.add_method('SetOutdoor',
                   'void',
                   [])
    return

def register_Ns3MobilityModel_methods(root_module, cls):
    ## mobility-model.h (module 'mobility'): ns3::MobilityModel::MobilityModel(ns3::MobilityModel const & arg0) [constructor]
    cls.add_constructor([param('ns3::MobilityModel const &', 'arg0')])
    ## mobility-model.h (module 'mobility'): ns3::MobilityModel::MobilityModel() [constructor]
    cls.add_constructor([])
    ## mobility-model.h (module 'mobility'): int64_t ns3::MobilityModel::AssignStreams(int64_t stream) [member function]
    cls.add_method('AssignStreams',
                   'int64_t',
                   [param('int64_t', 'stream')])
    ## mobility-model.h (module 'mobility'): double ns3::MobilityModel::GetDistanceFrom(ns3::Ptr<const ns3::MobilityModel> position) const [member function]
    cls.add_method('GetDistanceFrom',
                   'double',
                   [param('ns3::Ptr< ns3::MobilityModel const >', 'position')],
                   is_const=True)
    ## mobility-model.h (module 'mobility'): ns3::Vector ns3::MobilityModel::GetPosition() const [member function]
    cls.add_method('GetPosition',
                   'ns3::Vector',
                   [],
                   is_const=True)
    ## mobility-model.h (module 'mobility'): double ns3::MobilityModel::GetRelativeSpeed(ns3::Ptr<const ns3::MobilityModel> other) const [member function]
    cls.add_method('GetRelativeSpeed',
                   'double',
                   [param('ns3::Ptr< ns3::MobilityModel const >', 'other')],
                   is_const=True)
    ## mobility-model.h (module 'mobility'): static ns3::TypeId ns3::MobilityModel::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mobility-model.h (module 'mobility'): ns3::Vector ns3::MobilityModel::GetVelocity() const [member function]
    cls.add_method('GetVelocity',
                   'ns3::Vector',
                   [],
                   is_const=True)
    ## mobility-model.h (module 'mobility'): void ns3::MobilityModel::SetPosition(ns3::Vector const & position) [member function]
    cls.add_method('SetPosition',
                   'void',
                   [param('ns3::Vector const &', 'position')])
    ## mobility-model.h (module 'mobility'): void ns3::MobilityModel::NotifyCourseChange() const [member function]
    cls.add_method('NotifyCourseChange',
                   'void',
                   [],
                   is_const=True, visibility='protected')
    ## mobility-model.h (module 'mobility'): int64_t ns3::MobilityModel::DoAssignStreams(int64_t start) [member function]
    cls.add_method('DoAssignStreams',
                   'int64_t',
                   [param('int64_t', 'start')],
                   visibility='private', is_virtual=True)
    ## mobility-model.h (module 'mobility'): ns3::Vector ns3::MobilityModel::DoGetPosition() const [member function]
    cls.add_method('DoGetPosition',
                   'ns3::Vector',
                   [],
                   is_pure_virtual=True, is_const=True, visibility='private', is_virtual=True)
    ## mobility-model.h (module 'mobility'): ns3::Vector ns3::MobilityModel::DoGetVelocity() const [member function]
    cls.add_method('DoGetVelocity',
                   'ns3::Vector',
                   [],
                   is_pure_virtual=True, is_const=True, visibility='private', is_virtual=True)
    ## mobility-model.h (module 'mobility'): void ns3::MobilityModel::DoSetPosition(ns3::Vector const & position) [member function]
    cls.add_method('DoSetPosition',
                   'void',
                   [param('ns3::Vector const &', 'position')],
                   is_pure_virtual=True, visibility='private', is_virtual=True)
    return

def register_Ns3NakagamiPropagationLossModel_methods(root_module, cls):
    ## propagation-loss-model.h (module 'propagation'): static ns3::TypeId ns3::NakagamiPropagationLossModel::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## propagation-loss-model.h (module 'propagation'): ns3::NakagamiPropagationLossModel::NakagamiPropagationLossModel() [constructor]
    cls.add_constructor([])
    ## propagation-loss-model.h (module 'propagation'): double ns3::NakagamiPropagationLossModel::DoCalcRxPower(double txPowerDbm, ns3::Ptr<ns3::MobilityModel> a, ns3::Ptr<ns3::MobilityModel> b) const [member function]
    cls.add_method('DoCalcRxPower',
                   'double',
                   [param('double', 'txPowerDbm'), param('ns3::Ptr< ns3::MobilityModel >', 'a'), param('ns3::Ptr< ns3::MobilityModel >', 'b')],
                   is_const=True, visibility='private', is_virtual=True)
    ## propagation-loss-model.h (module 'propagation'): int64_t ns3::NakagamiPropagationLossModel::DoAssignStreams(int64_t stream) [member function]
    cls.add_method('DoAssignStreams',
                   'int64_t',
                   [param('int64_t', 'stream')],
                   visibility='private', is_virtual=True)
    return

def register_Ns3NetDevice_methods(root_module, cls):
    ## net-device.h (module 'network'): ns3::NetDevice::NetDevice() [constructor]
    cls.add_constructor([])
    ## net-device.h (module 'network'): ns3::NetDevice::NetDevice(ns3::NetDevice const & arg0) [constructor]
    cls.add_constructor([param('ns3::NetDevice const &', 'arg0')])
    ## net-device.h (module 'network'): void ns3::NetDevice::AddLinkChangeCallback(ns3::Callback<void, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> callback) [member function]
    cls.add_method('AddLinkChangeCallback',
                   'void',
                   [param('ns3::Callback< void, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'callback')],
                   is_pure_virtual=True, is_virtual=True)
    ## net-device.h (module 'network'): ns3::Address ns3::NetDevice::GetAddress() const [member function]
    cls.add_method('GetAddress',
                   'ns3::Address',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## net-device.h (module 'network'): ns3::Address ns3::NetDevice::GetBroadcast() const [member function]
    cls.add_method('GetBroadcast',
                   'ns3::Address',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## net-device.h (module 'network'): ns3::Ptr<ns3::Channel> ns3::NetDevice::GetChannel() const [member function]
    cls.add_method('GetChannel',
                   'ns3::Ptr< ns3::Channel >',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## net-device.h (module 'network'): uint32_t ns3::NetDevice::GetIfIndex() const [member function]
    cls.add_method('GetIfIndex',
                   'uint32_t',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## net-device.h (module 'network'): uint16_t ns3::NetDevice::GetMtu() const [member function]
    cls.add_method('GetMtu',
                   'uint16_t',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## net-device.h (module 'network'): ns3::Address ns3::NetDevice::GetMulticast(ns3::Ipv4Address multicastGroup) const [member function]
    cls.add_method('GetMulticast',
                   'ns3::Address',
                   [param('ns3::Ipv4Address', 'multicastGroup')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## net-device.h (module 'network'): ns3::Address ns3::NetDevice::GetMulticast(ns3::Ipv6Address addr) const [member function]
    cls.add_method('GetMulticast',
                   'ns3::Address',
                   [param('ns3::Ipv6Address', 'addr')],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## net-device.h (module 'network'): ns3::Ptr<ns3::Node> ns3::NetDevice::GetNode() const [member function]
    cls.add_method('GetNode',
                   'ns3::Ptr< ns3::Node >',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## net-device.h (module 'network'): static ns3::TypeId ns3::NetDevice::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## net-device.h (module 'network'): bool ns3::NetDevice::IsBridge() const [member function]
    cls.add_method('IsBridge',
                   'bool',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## net-device.h (module 'network'): bool ns3::NetDevice::IsBroadcast() const [member function]
    cls.add_method('IsBroadcast',
                   'bool',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## net-device.h (module 'network'): bool ns3::NetDevice::IsLinkUp() const [member function]
    cls.add_method('IsLinkUp',
                   'bool',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## net-device.h (module 'network'): bool ns3::NetDevice::IsMulticast() const [member function]
    cls.add_method('IsMulticast',
                   'bool',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## net-device.h (module 'network'): bool ns3::NetDevice::IsPointToPoint() const [member function]
    cls.add_method('IsPointToPoint',
                   'bool',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## net-device.h (module 'network'): bool ns3::NetDevice::NeedsArp() const [member function]
    cls.add_method('NeedsArp',
                   'bool',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    ## net-device.h (module 'network'): bool ns3::NetDevice::Send(ns3::Ptr<ns3::Packet> packet, ns3::Address const & dest, uint16_t protocolNumber) [member function]
    cls.add_method('Send',
                   'bool',
                   [param('ns3::Ptr< ns3::Packet >', 'packet'), param('ns3::Address const &', 'dest'), param('uint16_t', 'protocolNumber')],
                   is_pure_virtual=True, is_virtual=True)
    ## net-device.h (module 'network'): bool ns3::NetDevice::SendFrom(ns3::Ptr<ns3::Packet> packet, ns3::Address const & source, ns3::Address const & dest, uint16_t protocolNumber) [member function]
    cls.add_method('SendFrom',
                   'bool',
                   [param('ns3::Ptr< ns3::Packet >', 'packet'), param('ns3::Address const &', 'source'), param('ns3::Address const &', 'dest'), param('uint16_t', 'protocolNumber')],
                   is_pure_virtual=True, is_virtual=True)
    ## net-device.h (module 'network'): void ns3::NetDevice::SetAddress(ns3::Address address) [member function]
    cls.add_method('SetAddress',
                   'void',
                   [param('ns3::Address', 'address')],
                   is_pure_virtual=True, is_virtual=True)
    ## net-device.h (module 'network'): void ns3::NetDevice::SetIfIndex(uint32_t const index) [member function]
    cls.add_method('SetIfIndex',
                   'void',
                   [param('uint32_t const', 'index')],
                   is_pure_virtual=True, is_virtual=True)
    ## net-device.h (module 'network'): bool ns3::NetDevice::SetMtu(uint16_t const mtu) [member function]
    cls.add_method('SetMtu',
                   'bool',
                   [param('uint16_t const', 'mtu')],
                   is_pure_virtual=True, is_virtual=True)
    ## net-device.h (module 'network'): void ns3::NetDevice::SetNode(ns3::Ptr<ns3::Node> node) [member function]
    cls.add_method('SetNode',
                   'void',
                   [param('ns3::Ptr< ns3::Node >', 'node')],
                   is_pure_virtual=True, is_virtual=True)
    ## net-device.h (module 'network'): void ns3::NetDevice::SetPromiscReceiveCallback(ns3::NetDevice::PromiscReceiveCallback cb) [member function]
    cls.add_method('SetPromiscReceiveCallback',
                   'void',
                   [param('ns3::Callback< bool, ns3::Ptr< ns3::NetDevice >, ns3::Ptr< ns3::Packet const >, unsigned short, ns3::Address const &, ns3::Address const &, ns3::NetDevice::PacketType, ns3::empty, ns3::empty, ns3::empty >', 'cb')],
                   is_pure_virtual=True, is_virtual=True)
    ## net-device.h (module 'network'): void ns3::NetDevice::SetReceiveCallback(ns3::NetDevice::ReceiveCallback cb) [member function]
    cls.add_method('SetReceiveCallback',
                   'void',
                   [param('ns3::Callback< bool, ns3::Ptr< ns3::NetDevice >, ns3::Ptr< ns3::Packet const >, unsigned short, ns3::Address const &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'cb')],
                   is_pure_virtual=True, is_virtual=True)
    ## net-device.h (module 'network'): bool ns3::NetDevice::SupportsSendFrom() const [member function]
    cls.add_method('SupportsSendFrom',
                   'bool',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    return

def register_Ns3NixVector_methods(root_module, cls):
    cls.add_output_stream_operator()
    ## nix-vector.h (module 'network'): ns3::NixVector::NixVector() [constructor]
    cls.add_constructor([])
    ## nix-vector.h (module 'network'): ns3::NixVector::NixVector(ns3::NixVector const & o) [constructor]
    cls.add_constructor([param('ns3::NixVector const &', 'o')])
    ## nix-vector.h (module 'network'): void ns3::NixVector::AddNeighborIndex(uint32_t newBits, uint32_t numberOfBits) [member function]
    cls.add_method('AddNeighborIndex',
                   'void',
                   [param('uint32_t', 'newBits'), param('uint32_t', 'numberOfBits')])
    ## nix-vector.h (module 'network'): uint32_t ns3::NixVector::BitCount(uint32_t numberOfNeighbors) const [member function]
    cls.add_method('BitCount',
                   'uint32_t',
                   [param('uint32_t', 'numberOfNeighbors')],
                   is_const=True)
    ## nix-vector.h (module 'network'): ns3::Ptr<ns3::NixVector> ns3::NixVector::Copy() const [member function]
    cls.add_method('Copy',
                   'ns3::Ptr< ns3::NixVector >',
                   [],
                   is_const=True)
    ## nix-vector.h (module 'network'): uint32_t ns3::NixVector::Deserialize(uint32_t const * buffer, uint32_t size) [member function]
    cls.add_method('Deserialize',
                   'uint32_t',
                   [param('uint32_t const *', 'buffer'), param('uint32_t', 'size')])
    ## nix-vector.h (module 'network'): uint32_t ns3::NixVector::ExtractNeighborIndex(uint32_t numberOfBits) [member function]
    cls.add_method('ExtractNeighborIndex',
                   'uint32_t',
                   [param('uint32_t', 'numberOfBits')])
    ## nix-vector.h (module 'network'): uint32_t ns3::NixVector::GetRemainingBits() [member function]
    cls.add_method('GetRemainingBits',
                   'uint32_t',
                   [])
    ## nix-vector.h (module 'network'): uint32_t ns3::NixVector::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize',
                   'uint32_t',
                   [],
                   is_const=True)
    ## nix-vector.h (module 'network'): uint32_t ns3::NixVector::Serialize(uint32_t * buffer, uint32_t maxSize) const [member function]
    cls.add_method('Serialize',
                   'uint32_t',
                   [param('uint32_t *', 'buffer'), param('uint32_t', 'maxSize')],
                   is_const=True)
    return

def register_Ns3Node_methods(root_module, cls):
    ## node.h (module 'network'): ns3::Node::Node(ns3::Node const & arg0) [constructor]
    cls.add_constructor([param('ns3::Node const &', 'arg0')])
    ## node.h (module 'network'): ns3::Node::Node() [constructor]
    cls.add_constructor([])
    ## node.h (module 'network'): ns3::Node::Node(uint32_t systemId) [constructor]
    cls.add_constructor([param('uint32_t', 'systemId')])
    ## node.h (module 'network'): uint32_t ns3::Node::AddApplication(ns3::Ptr<ns3::Application> application) [member function]
    cls.add_method('AddApplication',
                   'uint32_t',
                   [param('ns3::Ptr< ns3::Application >', 'application')])
    ## node.h (module 'network'): uint32_t ns3::Node::AddDevice(ns3::Ptr<ns3::NetDevice> device) [member function]
    cls.add_method('AddDevice',
                   'uint32_t',
                   [param('ns3::Ptr< ns3::NetDevice >', 'device')])
    ## node.h (module 'network'): static bool ns3::Node::ChecksumEnabled() [member function]
    cls.add_method('ChecksumEnabled',
                   'bool',
                   [],
                   is_static=True)
    ## node.h (module 'network'): ns3::Ptr<ns3::Application> ns3::Node::GetApplication(uint32_t index) const [member function]
    cls.add_method('GetApplication',
                   'ns3::Ptr< ns3::Application >',
                   [param('uint32_t', 'index')],
                   is_const=True)
    ## node.h (module 'network'): ns3::Ptr<ns3::NetDevice> ns3::Node::GetDevice(uint32_t index) const [member function]
    cls.add_method('GetDevice',
                   'ns3::Ptr< ns3::NetDevice >',
                   [param('uint32_t', 'index')],
                   is_const=True)
    ## node.h (module 'network'): uint32_t ns3::Node::GetId() const [member function]
    cls.add_method('GetId',
                   'uint32_t',
                   [],
                   is_const=True)
    ## node.h (module 'network'): ns3::Time ns3::Node::GetLocalTime() const [member function]
    cls.add_method('GetLocalTime',
                   'ns3::Time',
                   [],
                   is_const=True)
    ## node.h (module 'network'): uint32_t ns3::Node::GetNApplications() const [member function]
    cls.add_method('GetNApplications',
                   'uint32_t',
                   [],
                   is_const=True)
    ## node.h (module 'network'): uint32_t ns3::Node::GetNDevices() const [member function]
    cls.add_method('GetNDevices',
                   'uint32_t',
                   [],
                   is_const=True)
    ## node.h (module 'network'): uint32_t ns3::Node::GetSystemId() const [member function]
    cls.add_method('GetSystemId',
                   'uint32_t',
                   [],
                   is_const=True)
    ## node.h (module 'network'): static ns3::TypeId ns3::Node::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## node.h (module 'network'): void ns3::Node::RegisterDeviceAdditionListener(ns3::Node::DeviceAdditionListener listener) [member function]
    cls.add_method('RegisterDeviceAdditionListener',
                   'void',
                   [param('ns3::Callback< void, ns3::Ptr< ns3::NetDevice >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'listener')])
    ## node.h (module 'network'): void ns3::Node::RegisterProtocolHandler(ns3::Node::ProtocolHandler handler, uint16_t protocolType, ns3::Ptr<ns3::NetDevice> device, bool promiscuous=false) [member function]
    cls.add_method('RegisterProtocolHandler',
                   'void',
                   [param('ns3::Callback< void, ns3::Ptr< ns3::NetDevice >, ns3::Ptr< ns3::Packet const >, unsigned short, ns3::Address const &, ns3::Address const &, ns3::NetDevice::PacketType, ns3::empty, ns3::empty, ns3::empty >', 'handler'), param('uint16_t', 'protocolType'), param('ns3::Ptr< ns3::NetDevice >', 'device'), param('bool', 'promiscuous', default_value='false')])
    ## node.h (module 'network'): void ns3::Node::UnregisterDeviceAdditionListener(ns3::Node::DeviceAdditionListener listener) [member function]
    cls.add_method('UnregisterDeviceAdditionListener',
                   'void',
                   [param('ns3::Callback< void, ns3::Ptr< ns3::NetDevice >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'listener')])
    ## node.h (module 'network'): void ns3::Node::UnregisterProtocolHandler(ns3::Node::ProtocolHandler handler) [member function]
    cls.add_method('UnregisterProtocolHandler',
                   'void',
                   [param('ns3::Callback< void, ns3::Ptr< ns3::NetDevice >, ns3::Ptr< ns3::Packet const >, unsigned short, ns3::Address const &, ns3::Address const &, ns3::NetDevice::PacketType, ns3::empty, ns3::empty, ns3::empty >', 'handler')])
    ## node.h (module 'network'): void ns3::Node::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   visibility='protected', is_virtual=True)
    ## node.h (module 'network'): void ns3::Node::DoInitialize() [member function]
    cls.add_method('DoInitialize',
                   'void',
                   [],
                   visibility='protected', is_virtual=True)
    return

def register_Ns3NormalRandomVariable_methods(root_module, cls):
    ## random-variable-stream.h (module 'core'): ns3::NormalRandomVariable::INFINITE_VALUE [variable]
    cls.add_static_attribute('INFINITE_VALUE', 'double const', is_const=True)
    ## random-variable-stream.h (module 'core'): static ns3::TypeId ns3::NormalRandomVariable::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## random-variable-stream.h (module 'core'): ns3::NormalRandomVariable::NormalRandomVariable() [constructor]
    cls.add_constructor([])
    ## random-variable-stream.h (module 'core'): double ns3::NormalRandomVariable::GetMean() const [member function]
    cls.add_method('GetMean',
                   'double',
                   [],
                   is_const=True)
    ## random-variable-stream.h (module 'core'): double ns3::NormalRandomVariable::GetVariance() const [member function]
    cls.add_method('GetVariance',
                   'double',
                   [],
                   is_const=True)
    ## random-variable-stream.h (module 'core'): double ns3::NormalRandomVariable::GetBound() const [member function]
    cls.add_method('GetBound',
                   'double',
                   [],
                   is_const=True)
    ## random-variable-stream.h (module 'core'): double ns3::NormalRandomVariable::GetValue(double mean, double variance, double bound=ns3::NormalRandomVariable::INFINITE_VALUE) [member function]
    cls.add_method('GetValue',
                   'double',
                   [param('double', 'mean'), param('double', 'variance'), param('double', 'bound', default_value='ns3::NormalRandomVariable::INFINITE_VALUE')])
    ## random-variable-stream.h (module 'core'): uint32_t ns3::NormalRandomVariable::GetInteger(uint32_t mean, uint32_t variance, uint32_t bound) [member function]
    cls.add_method('GetInteger',
                   'uint32_t',
                   [param('uint32_t', 'mean'), param('uint32_t', 'variance'), param('uint32_t', 'bound')])
    ## random-variable-stream.h (module 'core'): double ns3::NormalRandomVariable::GetValue() [member function]
    cls.add_method('GetValue',
                   'double',
                   [],
                   is_virtual=True)
    ## random-variable-stream.h (module 'core'): uint32_t ns3::NormalRandomVariable::GetInteger() [member function]
    cls.add_method('GetInteger',
                   'uint32_t',
                   [],
                   is_virtual=True)
    return

def register_Ns3ObjectFactoryChecker_methods(root_module, cls):
    ## object-factory.h (module 'core'): ns3::ObjectFactoryChecker::ObjectFactoryChecker() [constructor]
    cls.add_constructor([])
    ## object-factory.h (module 'core'): ns3::ObjectFactoryChecker::ObjectFactoryChecker(ns3::ObjectFactoryChecker const & arg0) [constructor]
    cls.add_constructor([param('ns3::ObjectFactoryChecker const &', 'arg0')])
    return

def register_Ns3ObjectFactoryValue_methods(root_module, cls):
    ## object-factory.h (module 'core'): ns3::ObjectFactoryValue::ObjectFactoryValue() [constructor]
    cls.add_constructor([])
    ## object-factory.h (module 'core'): ns3::ObjectFactoryValue::ObjectFactoryValue(ns3::ObjectFactory const & value) [constructor]
    cls.add_constructor([param('ns3::ObjectFactory const &', 'value')])
    ## object-factory.h (module 'core'): ns3::ObjectFactoryValue::ObjectFactoryValue(ns3::ObjectFactoryValue const & arg0) [constructor]
    cls.add_constructor([param('ns3::ObjectFactoryValue const &', 'arg0')])
    ## object-factory.h (module 'core'): ns3::Ptr<ns3::AttributeValue> ns3::ObjectFactoryValue::Copy() const [member function]
    cls.add_method('Copy',
                   'ns3::Ptr< ns3::AttributeValue >',
                   [],
                   is_const=True, is_virtual=True)
    ## object-factory.h (module 'core'): bool ns3::ObjectFactoryValue::DeserializeFromString(std::string value, ns3::Ptr<const ns3::AttributeChecker> checker) [member function]
    cls.add_method('DeserializeFromString',
                   'bool',
                   [param('std::string', 'value'), param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_virtual=True)
    ## object-factory.h (module 'core'): ns3::ObjectFactory ns3::ObjectFactoryValue::Get() const [member function]
    cls.add_method('Get',
                   'ns3::ObjectFactory',
                   [],
                   is_const=True)
    ## object-factory.h (module 'core'): std::string ns3::ObjectFactoryValue::SerializeToString(ns3::Ptr<const ns3::AttributeChecker> checker) const [member function]
    cls.add_method('SerializeToString',
                   'std::string',
                   [param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_const=True, is_virtual=True)
    ## object-factory.h (module 'core'): void ns3::ObjectFactoryValue::Set(ns3::ObjectFactory const & value) [member function]
    cls.add_method('Set',
                   'void',
                   [param('ns3::ObjectFactory const &', 'value')])
    return

def register_Ns3Packet_methods(root_module, cls):
    cls.add_output_stream_operator()
    ## packet.h (module 'network'): ns3::Packet::Packet() [constructor]
    cls.add_constructor([])
    ## packet.h (module 'network'): ns3::Packet::Packet(ns3::Packet const & o) [constructor]
    cls.add_constructor([param('ns3::Packet const &', 'o')])
    ## packet.h (module 'network'): ns3::Packet::Packet(uint32_t size) [constructor]
    cls.add_constructor([param('uint32_t', 'size')])
    ## packet.h (module 'network'): ns3::Packet::Packet(uint8_t const * buffer, uint32_t size, bool magic) [constructor]
    cls.add_constructor([param('uint8_t const *', 'buffer'), param('uint32_t', 'size'), param('bool', 'magic')])
    ## packet.h (module 'network'): ns3::Packet::Packet(uint8_t const * buffer, uint32_t size) [constructor]
    cls.add_constructor([param('uint8_t const *', 'buffer'), param('uint32_t', 'size')])
    ## packet.h (module 'network'): void ns3::Packet::AddAtEnd(ns3::Ptr<const ns3::Packet> packet) [member function]
    cls.add_method('AddAtEnd',
                   'void',
                   [param('ns3::Ptr< ns3::Packet const >', 'packet')])
    ## packet.h (module 'network'): void ns3::Packet::AddByteTag(ns3::Tag const & tag) const [member function]
    cls.add_method('AddByteTag',
                   'void',
                   [param('ns3::Tag const &', 'tag')],
                   is_const=True)
    ## packet.h (module 'network'): void ns3::Packet::AddHeader(ns3::Header const & header) [member function]
    cls.add_method('AddHeader',
                   'void',
                   [param('ns3::Header const &', 'header')])
    ## packet.h (module 'network'): void ns3::Packet::AddPacketTag(ns3::Tag const & tag) const [member function]
    cls.add_method('AddPacketTag',
                   'void',
                   [param('ns3::Tag const &', 'tag')],
                   is_const=True)
    ## packet.h (module 'network'): void ns3::Packet::AddPaddingAtEnd(uint32_t size) [member function]
    cls.add_method('AddPaddingAtEnd',
                   'void',
                   [param('uint32_t', 'size')])
    ## packet.h (module 'network'): void ns3::Packet::AddTrailer(ns3::Trailer const & trailer) [member function]
    cls.add_method('AddTrailer',
                   'void',
                   [param('ns3::Trailer const &', 'trailer')])
    ## packet.h (module 'network'): ns3::PacketMetadata::ItemIterator ns3::Packet::BeginItem() const [member function]
    cls.add_method('BeginItem',
                   'ns3::PacketMetadata::ItemIterator',
                   [],
                   is_const=True)
    ## packet.h (module 'network'): ns3::Ptr<ns3::Packet> ns3::Packet::Copy() const [member function]
    cls.add_method('Copy',
                   'ns3::Ptr< ns3::Packet >',
                   [],
                   is_const=True)
    ## packet.h (module 'network'): uint32_t ns3::Packet::CopyData(uint8_t * buffer, uint32_t size) const [member function]
    cls.add_method('CopyData',
                   'uint32_t',
                   [param('uint8_t *', 'buffer'), param('uint32_t', 'size')],
                   is_const=True)
    ## packet.h (module 'network'): void ns3::Packet::CopyData(std::ostream * os, uint32_t size) const [member function]
    cls.add_method('CopyData',
                   'void',
                   [param('std::ostream *', 'os'), param('uint32_t', 'size')],
                   is_const=True)
    ## packet.h (module 'network'): ns3::Ptr<ns3::Packet> ns3::Packet::CreateFragment(uint32_t start, uint32_t length) const [member function]
    cls.add_method('CreateFragment',
                   'ns3::Ptr< ns3::Packet >',
                   [param('uint32_t', 'start'), param('uint32_t', 'length')],
                   is_const=True)
    ## packet.h (module 'network'): static void ns3::Packet::EnableChecking() [member function]
    cls.add_method('EnableChecking',
                   'void',
                   [],
                   is_static=True)
    ## packet.h (module 'network'): static void ns3::Packet::EnablePrinting() [member function]
    cls.add_method('EnablePrinting',
                   'void',
                   [],
                   is_static=True)
    ## packet.h (module 'network'): bool ns3::Packet::FindFirstMatchingByteTag(ns3::Tag & tag) const [member function]
    cls.add_method('FindFirstMatchingByteTag',
                   'bool',
                   [param('ns3::Tag &', 'tag')],
                   is_const=True)
    ## packet.h (module 'network'): ns3::ByteTagIterator ns3::Packet::GetByteTagIterator() const [member function]
    cls.add_method('GetByteTagIterator',
                   'ns3::ByteTagIterator',
                   [],
                   is_const=True)
    ## packet.h (module 'network'): ns3::Ptr<ns3::NixVector> ns3::Packet::GetNixVector() const [member function]
    cls.add_method('GetNixVector',
                   'ns3::Ptr< ns3::NixVector >',
                   [],
                   is_const=True)
    ## packet.h (module 'network'): ns3::PacketTagIterator ns3::Packet::GetPacketTagIterator() const [member function]
    cls.add_method('GetPacketTagIterator',
                   'ns3::PacketTagIterator',
                   [],
                   is_const=True)
    ## packet.h (module 'network'): uint32_t ns3::Packet::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize',
                   'uint32_t',
                   [],
                   is_const=True)
    ## packet.h (module 'network'): uint32_t ns3::Packet::GetSize() const [member function]
    cls.add_method('GetSize',
                   'uint32_t',
                   [],
                   is_const=True)
    ## packet.h (module 'network'): uint64_t ns3::Packet::GetUid() const [member function]
    cls.add_method('GetUid',
                   'uint64_t',
                   [],
                   is_const=True)
    ## packet.h (module 'network'): uint32_t ns3::Packet::PeekHeader(ns3::Header & header) const [member function]
    cls.add_method('PeekHeader',
                   'uint32_t',
                   [param('ns3::Header &', 'header')],
                   is_const=True)
    ## packet.h (module 'network'): uint32_t ns3::Packet::PeekHeader(ns3::Header & header, uint32_t size) const [member function]
    cls.add_method('PeekHeader',
                   'uint32_t',
                   [param('ns3::Header &', 'header'), param('uint32_t', 'size')],
                   is_const=True)
    ## packet.h (module 'network'): bool ns3::Packet::PeekPacketTag(ns3::Tag & tag) const [member function]
    cls.add_method('PeekPacketTag',
                   'bool',
                   [param('ns3::Tag &', 'tag')],
                   is_const=True)
    ## packet.h (module 'network'): uint32_t ns3::Packet::PeekTrailer(ns3::Trailer & trailer) [member function]
    cls.add_method('PeekTrailer',
                   'uint32_t',
                   [param('ns3::Trailer &', 'trailer')])
    ## packet.h (module 'network'): void ns3::Packet::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True)
    ## packet.h (module 'network'): void ns3::Packet::PrintByteTags(std::ostream & os) const [member function]
    cls.add_method('PrintByteTags',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True)
    ## packet.h (module 'network'): void ns3::Packet::PrintPacketTags(std::ostream & os) const [member function]
    cls.add_method('PrintPacketTags',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True)
    ## packet.h (module 'network'): void ns3::Packet::RemoveAllByteTags() [member function]
    cls.add_method('RemoveAllByteTags',
                   'void',
                   [])
    ## packet.h (module 'network'): void ns3::Packet::RemoveAllPacketTags() [member function]
    cls.add_method('RemoveAllPacketTags',
                   'void',
                   [])
    ## packet.h (module 'network'): void ns3::Packet::RemoveAtEnd(uint32_t size) [member function]
    cls.add_method('RemoveAtEnd',
                   'void',
                   [param('uint32_t', 'size')])
    ## packet.h (module 'network'): void ns3::Packet::RemoveAtStart(uint32_t size) [member function]
    cls.add_method('RemoveAtStart',
                   'void',
                   [param('uint32_t', 'size')])
    ## packet.h (module 'network'): uint32_t ns3::Packet::RemoveHeader(ns3::Header & header) [member function]
    cls.add_method('RemoveHeader',
                   'uint32_t',
                   [param('ns3::Header &', 'header')])
    ## packet.h (module 'network'): uint32_t ns3::Packet::RemoveHeader(ns3::Header & header, uint32_t size) [member function]
    cls.add_method('RemoveHeader',
                   'uint32_t',
                   [param('ns3::Header &', 'header'), param('uint32_t', 'size')])
    ## packet.h (module 'network'): bool ns3::Packet::RemovePacketTag(ns3::Tag & tag) [member function]
    cls.add_method('RemovePacketTag',
                   'bool',
                   [param('ns3::Tag &', 'tag')])
    ## packet.h (module 'network'): uint32_t ns3::Packet::RemoveTrailer(ns3::Trailer & trailer) [member function]
    cls.add_method('RemoveTrailer',
                   'uint32_t',
                   [param('ns3::Trailer &', 'trailer')])
    ## packet.h (module 'network'): bool ns3::Packet::ReplacePacketTag(ns3::Tag & tag) [member function]
    cls.add_method('ReplacePacketTag',
                   'bool',
                   [param('ns3::Tag &', 'tag')])
    ## packet.h (module 'network'): uint32_t ns3::Packet::Serialize(uint8_t * buffer, uint32_t maxSize) const [member function]
    cls.add_method('Serialize',
                   'uint32_t',
                   [param('uint8_t *', 'buffer'), param('uint32_t', 'maxSize')],
                   is_const=True)
    ## packet.h (module 'network'): void ns3::Packet::SetNixVector(ns3::Ptr<ns3::NixVector> nixVector) [member function]
    cls.add_method('SetNixVector',
                   'void',
                   [param('ns3::Ptr< ns3::NixVector >', 'nixVector')])
    ## packet.h (module 'network'): std::string ns3::Packet::ToString() const [member function]
    cls.add_method('ToString',
                   'std::string',
                   [],
                   is_const=True)
    return

def register_Ns3ParetoRandomVariable_methods(root_module, cls):
    ## random-variable-stream.h (module 'core'): static ns3::TypeId ns3::ParetoRandomVariable::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## random-variable-stream.h (module 'core'): ns3::ParetoRandomVariable::ParetoRandomVariable() [constructor]
    cls.add_constructor([])
    ## random-variable-stream.h (module 'core'): double ns3::ParetoRandomVariable::GetMean() const [member function]
    cls.add_method('GetMean',
                   'double',
                   [],
                   deprecated=True, is_const=True)
    ## random-variable-stream.h (module 'core'): double ns3::ParetoRandomVariable::GetScale() const [member function]
    cls.add_method('GetScale',
                   'double',
                   [],
                   is_const=True)
    ## random-variable-stream.h (module 'core'): double ns3::ParetoRandomVariable::GetShape() const [member function]
    cls.add_method('GetShape',
                   'double',
                   [],
                   is_const=True)
    ## random-variable-stream.h (module 'core'): double ns3::ParetoRandomVariable::GetBound() const [member function]
    cls.add_method('GetBound',
                   'double',
                   [],
                   is_const=True)
    ## random-variable-stream.h (module 'core'): double ns3::ParetoRandomVariable::GetValue(double scale, double shape, double bound) [member function]
    cls.add_method('GetValue',
                   'double',
                   [param('double', 'scale'), param('double', 'shape'), param('double', 'bound')])
    ## random-variable-stream.h (module 'core'): uint32_t ns3::ParetoRandomVariable::GetInteger(uint32_t scale, uint32_t shape, uint32_t bound) [member function]
    cls.add_method('GetInteger',
                   'uint32_t',
                   [param('uint32_t', 'scale'), param('uint32_t', 'shape'), param('uint32_t', 'bound')])
    ## random-variable-stream.h (module 'core'): double ns3::ParetoRandomVariable::GetValue() [member function]
    cls.add_method('GetValue',
                   'double',
                   [],
                   is_virtual=True)
    ## random-variable-stream.h (module 'core'): uint32_t ns3::ParetoRandomVariable::GetInteger() [member function]
    cls.add_method('GetInteger',
                   'uint32_t',
                   [],
                   is_virtual=True)
    return

def register_Ns3PointerChecker_methods(root_module, cls):
    ## pointer.h (module 'core'): ns3::PointerChecker::PointerChecker() [constructor]
    cls.add_constructor([])
    ## pointer.h (module 'core'): ns3::PointerChecker::PointerChecker(ns3::PointerChecker const & arg0) [constructor]
    cls.add_constructor([param('ns3::PointerChecker const &', 'arg0')])
    ## pointer.h (module 'core'): ns3::TypeId ns3::PointerChecker::GetPointeeTypeId() const [member function]
    cls.add_method('GetPointeeTypeId',
                   'ns3::TypeId',
                   [],
                   is_pure_virtual=True, is_const=True, is_virtual=True)
    return

def register_Ns3PointerValue_methods(root_module, cls):
    ## pointer.h (module 'core'): ns3::PointerValue::PointerValue(ns3::PointerValue const & arg0) [constructor]
    cls.add_constructor([param('ns3::PointerValue const &', 'arg0')])
    ## pointer.h (module 'core'): ns3::PointerValue::PointerValue() [constructor]
    cls.add_constructor([])
    ## pointer.h (module 'core'): ns3::PointerValue::PointerValue(ns3::Ptr<ns3::Object> object) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::Object >', 'object')])
    ## pointer.h (module 'core'): ns3::Ptr<ns3::AttributeValue> ns3::PointerValue::Copy() const [member function]
    cls.add_method('Copy',
                   'ns3::Ptr< ns3::AttributeValue >',
                   [],
                   is_const=True, is_virtual=True)
    ## pointer.h (module 'core'): bool ns3::PointerValue::DeserializeFromString(std::string value, ns3::Ptr<const ns3::AttributeChecker> checker) [member function]
    cls.add_method('DeserializeFromString',
                   'bool',
                   [param('std::string', 'value'), param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_virtual=True)
    ## pointer.h (module 'core'): ns3::Ptr<ns3::Object> ns3::PointerValue::GetObject() const [member function]
    cls.add_method('GetObject',
                   'ns3::Ptr< ns3::Object >',
                   [],
                   is_const=True)
    ## pointer.h (module 'core'): std::string ns3::PointerValue::SerializeToString(ns3::Ptr<const ns3::AttributeChecker> checker) const [member function]
    cls.add_method('SerializeToString',
                   'std::string',
                   [param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_const=True, is_virtual=True)
    ## pointer.h (module 'core'): void ns3::PointerValue::SetObject(ns3::Ptr<ns3::Object> object) [member function]
    cls.add_method('SetObject',
                   'void',
                   [param('ns3::Ptr< ns3::Object >', 'object')])
    return

def register_Ns3QueueItem_methods(root_module, cls):
    cls.add_output_stream_operator()
    ## queue-item.h (module 'network'): ns3::QueueItem::QueueItem(ns3::Ptr<ns3::Packet> p) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::Packet >', 'p')])
    ## queue-item.h (module 'network'): ns3::Ptr<ns3::Packet> ns3::QueueItem::GetPacket() const [member function]
    cls.add_method('GetPacket',
                   'ns3::Ptr< ns3::Packet >',
                   [],
                   is_const=True)
    ## queue-item.h (module 'network'): uint32_t ns3::QueueItem::GetSize() const [member function]
    cls.add_method('GetSize',
                   'uint32_t',
                   [],
                   is_const=True, is_virtual=True)
    ## queue-item.h (module 'network'): bool ns3::QueueItem::GetUint8Value(ns3::QueueItem::Uint8Values field, uint8_t & value) const [member function]
    cls.add_method('GetUint8Value',
                   'bool',
                   [param('ns3::QueueItem::Uint8Values', 'field'), param('uint8_t &', 'value')],
                   is_const=True, is_virtual=True)
    ## queue-item.h (module 'network'): void ns3::QueueItem::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True, is_virtual=True)
    return

def register_Ns3QueueSizeChecker_methods(root_module, cls):
    ## queue-size.h (module 'network'): ns3::QueueSizeChecker::QueueSizeChecker() [constructor]
    cls.add_constructor([])
    ## queue-size.h (module 'network'): ns3::QueueSizeChecker::QueueSizeChecker(ns3::QueueSizeChecker const & arg0) [constructor]
    cls.add_constructor([param('ns3::QueueSizeChecker const &', 'arg0')])
    return

def register_Ns3QueueSizeValue_methods(root_module, cls):
    ## queue-size.h (module 'network'): ns3::QueueSizeValue::QueueSizeValue() [constructor]
    cls.add_constructor([])
    ## queue-size.h (module 'network'): ns3::QueueSizeValue::QueueSizeValue(ns3::QueueSize const & value) [constructor]
    cls.add_constructor([param('ns3::QueueSize const &', 'value')])
    ## queue-size.h (module 'network'): ns3::QueueSizeValue::QueueSizeValue(ns3::QueueSizeValue const & arg0) [constructor]
    cls.add_constructor([param('ns3::QueueSizeValue const &', 'arg0')])
    ## queue-size.h (module 'network'): ns3::Ptr<ns3::AttributeValue> ns3::QueueSizeValue::Copy() const [member function]
    cls.add_method('Copy',
                   'ns3::Ptr< ns3::AttributeValue >',
                   [],
                   is_const=True, is_virtual=True)
    ## queue-size.h (module 'network'): bool ns3::QueueSizeValue::DeserializeFromString(std::string value, ns3::Ptr<const ns3::AttributeChecker> checker) [member function]
    cls.add_method('DeserializeFromString',
                   'bool',
                   [param('std::string', 'value'), param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_virtual=True)
    ## queue-size.h (module 'network'): ns3::QueueSize ns3::QueueSizeValue::Get() const [member function]
    cls.add_method('Get',
                   'ns3::QueueSize',
                   [],
                   is_const=True)
    ## queue-size.h (module 'network'): std::string ns3::QueueSizeValue::SerializeToString(ns3::Ptr<const ns3::AttributeChecker> checker) const [member function]
    cls.add_method('SerializeToString',
                   'std::string',
                   [param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_const=True, is_virtual=True)
    ## queue-size.h (module 'network'): void ns3::QueueSizeValue::Set(ns3::QueueSize const & value) [member function]
    cls.add_method('Set',
                   'void',
                   [param('ns3::QueueSize const &', 'value')])
    return

def register_Ns3RachPreambleLteControlMessage_methods(root_module, cls):
    ## lte-control-messages.h (module 'lte'): ns3::RachPreambleLteControlMessage::RachPreambleLteControlMessage(ns3::RachPreambleLteControlMessage const & arg0) [constructor]
    cls.add_constructor([param('ns3::RachPreambleLteControlMessage const &', 'arg0')])
    ## lte-control-messages.h (module 'lte'): ns3::RachPreambleLteControlMessage::RachPreambleLteControlMessage() [constructor]
    cls.add_constructor([])
    ## lte-control-messages.h (module 'lte'): uint32_t ns3::RachPreambleLteControlMessage::GetRapId() const [member function]
    cls.add_method('GetRapId',
                   'uint32_t',
                   [],
                   is_const=True)
    ## lte-control-messages.h (module 'lte'): void ns3::RachPreambleLteControlMessage::SetRapId(uint32_t rapid) [member function]
    cls.add_method('SetRapId',
                   'void',
                   [param('uint32_t', 'rapid')])
    return

def register_Ns3RarLteControlMessage_methods(root_module, cls):
    ## lte-control-messages.h (module 'lte'): ns3::RarLteControlMessage::RarLteControlMessage(ns3::RarLteControlMessage const & arg0) [constructor]
    cls.add_constructor([param('ns3::RarLteControlMessage const &', 'arg0')])
    ## lte-control-messages.h (module 'lte'): ns3::RarLteControlMessage::RarLteControlMessage() [constructor]
    cls.add_constructor([])
    ## lte-control-messages.h (module 'lte'): void ns3::RarLteControlMessage::AddRar(ns3::RarLteControlMessage::Rar rar) [member function]
    cls.add_method('AddRar',
                   'void',
                   [param('ns3::RarLteControlMessage::Rar', 'rar')])
    ## lte-control-messages.h (module 'lte'): uint16_t ns3::RarLteControlMessage::GetRaRnti() const [member function]
    cls.add_method('GetRaRnti',
                   'uint16_t',
                   [],
                   is_const=True)
    ## lte-control-messages.h (module 'lte'): std::list<ns3::RarLteControlMessage::Rar, std::allocator<ns3::RarLteControlMessage::Rar> >::const_iterator ns3::RarLteControlMessage::RarListBegin() const [member function]
    cls.add_method('RarListBegin',
                   'std::list< ns3::RarLteControlMessage::Rar > const_iterator',
                   [],
                   is_const=True)
    ## lte-control-messages.h (module 'lte'): std::list<ns3::RarLteControlMessage::Rar, std::allocator<ns3::RarLteControlMessage::Rar> >::const_iterator ns3::RarLteControlMessage::RarListEnd() const [member function]
    cls.add_method('RarListEnd',
                   'std::list< ns3::RarLteControlMessage::Rar > const_iterator',
                   [],
                   is_const=True)
    ## lte-control-messages.h (module 'lte'): void ns3::RarLteControlMessage::SetRaRnti(uint16_t raRnti) [member function]
    cls.add_method('SetRaRnti',
                   'void',
                   [param('uint16_t', 'raRnti')])
    return

def register_Ns3RarLteControlMessageRar_methods(root_module, cls):
    ## lte-control-messages.h (module 'lte'): ns3::RarLteControlMessage::Rar::Rar() [constructor]
    cls.add_constructor([])
    ## lte-control-messages.h (module 'lte'): ns3::RarLteControlMessage::Rar::Rar(ns3::RarLteControlMessage::Rar const & arg0) [constructor]
    cls.add_constructor([param('ns3::RarLteControlMessage::Rar const &', 'arg0')])
    ## lte-control-messages.h (module 'lte'): ns3::RarLteControlMessage::Rar::rapId [variable]
    cls.add_instance_attribute('rapId', 'uint8_t', is_const=False)
    ## lte-control-messages.h (module 'lte'): ns3::RarLteControlMessage::Rar::rarPayload [variable]
    cls.add_instance_attribute('rarPayload', 'ns3::BuildRarListElement_s', is_const=False)
    return

def register_Ns3RrcAsn1Header_methods(root_module, cls):
    ## lte-rrc-header.h (module 'lte'): ns3::RrcAsn1Header::RrcAsn1Header(ns3::RrcAsn1Header const & arg0) [constructor]
    cls.add_constructor([param('ns3::RrcAsn1Header const &', 'arg0')])
    ## lte-rrc-header.h (module 'lte'): ns3::RrcAsn1Header::RrcAsn1Header() [constructor]
    cls.add_constructor([])
    ## lte-rrc-header.h (module 'lte'): int ns3::RrcAsn1Header::GetMessageType() [member function]
    cls.add_method('GetMessageType',
                   'int',
                   [])
    ## lte-rrc-header.h (module 'lte'): int ns3::RrcAsn1Header::BandwidthToEnum(uint8_t bandwidth) const [member function]
    cls.add_method('BandwidthToEnum',
                   'int',
                   [param('uint8_t', 'bandwidth')],
                   is_const=True, visibility='protected')
    ## lte-rrc-header.h (module 'lte'): uint32_t ns3::RrcAsn1Header::Deserialize(ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('Deserialize',
                   'uint32_t',
                   [param('ns3::Buffer::Iterator', 'bIterator')],
                   is_pure_virtual=True, visibility='protected', is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): ns3::Buffer::Iterator ns3::RrcAsn1Header::DeserializeCellIdentification(ns3::LteRrcSap::CellIdentification * ci, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeCellIdentification',
                   'ns3::Buffer::Iterator',
                   [param('ns3::LteRrcSap::CellIdentification *', 'ci'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-rrc-header.h (module 'lte'): ns3::Buffer::Iterator ns3::RrcAsn1Header::DeserializeDrbToAddModList(std::list<ns3::LteRrcSap::DrbToAddMod, std::allocator<ns3::LteRrcSap::DrbToAddMod> > * drbToAddModLis, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeDrbToAddModList',
                   'ns3::Buffer::Iterator',
                   [param('std::list< ns3::LteRrcSap::DrbToAddMod > *', 'drbToAddModLis'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-rrc-header.h (module 'lte'): ns3::Buffer::Iterator ns3::RrcAsn1Header::DeserializeLogicalChannelConfig(ns3::LteRrcSap::LogicalChannelConfig * logicalChannelConfig, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeLogicalChannelConfig',
                   'ns3::Buffer::Iterator',
                   [param('ns3::LteRrcSap::LogicalChannelConfig *', 'logicalChannelConfig'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-rrc-header.h (module 'lte'): ns3::Buffer::Iterator ns3::RrcAsn1Header::DeserializeMeasConfig(ns3::LteRrcSap::MeasConfig * measConfig, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeMeasConfig',
                   'ns3::Buffer::Iterator',
                   [param('ns3::LteRrcSap::MeasConfig *', 'measConfig'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-rrc-header.h (module 'lte'): ns3::Buffer::Iterator ns3::RrcAsn1Header::DeserializeMeasResults(ns3::LteRrcSap::MeasResults * measResults, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeMeasResults',
                   'ns3::Buffer::Iterator',
                   [param('ns3::LteRrcSap::MeasResults *', 'measResults'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-rrc-header.h (module 'lte'): ns3::Buffer::Iterator ns3::RrcAsn1Header::DeserializeNonCriticalExtensionConfig(ns3::LteRrcSap::NonCriticalExtensionConfiguration * nonCriticalExtension, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeNonCriticalExtensionConfig',
                   'ns3::Buffer::Iterator',
                   [param('ns3::LteRrcSap::NonCriticalExtensionConfiguration *', 'nonCriticalExtension'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-rrc-header.h (module 'lte'): ns3::Buffer::Iterator ns3::RrcAsn1Header::DeserializePhysicalConfigDedicated(ns3::LteRrcSap::PhysicalConfigDedicated * physicalConfigDedicated, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializePhysicalConfigDedicated',
                   'ns3::Buffer::Iterator',
                   [param('ns3::LteRrcSap::PhysicalConfigDedicated *', 'physicalConfigDedicated'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-rrc-header.h (module 'lte'): ns3::Buffer::Iterator ns3::RrcAsn1Header::DeserializePhysicalConfigDedicatedSCell(ns3::LteRrcSap::PhysicalConfigDedicatedSCell * pcdsc, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializePhysicalConfigDedicatedSCell',
                   'ns3::Buffer::Iterator',
                   [param('ns3::LteRrcSap::PhysicalConfigDedicatedSCell *', 'pcdsc'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-rrc-header.h (module 'lte'): ns3::Buffer::Iterator ns3::RrcAsn1Header::DeserializePlmnIdentity(uint32_t * plmnId, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializePlmnIdentity',
                   'ns3::Buffer::Iterator',
                   [param('uint32_t *', 'plmnId'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-rrc-header.h (module 'lte'): ns3::Buffer::Iterator ns3::RrcAsn1Header::DeserializeQoffsetRange(int8_t * qOffsetRange, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeQoffsetRange',
                   'ns3::Buffer::Iterator',
                   [param('int8_t *', 'qOffsetRange'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-rrc-header.h (module 'lte'): ns3::Buffer::Iterator ns3::RrcAsn1Header::DeserializeRachConfigCommon(ns3::LteRrcSap::RachConfigCommon * rachConfigCommon, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeRachConfigCommon',
                   'ns3::Buffer::Iterator',
                   [param('ns3::LteRrcSap::RachConfigCommon *', 'rachConfigCommon'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-rrc-header.h (module 'lte'): ns3::Buffer::Iterator ns3::RrcAsn1Header::DeserializeRadioResourceConfigCommon(ns3::LteRrcSap::RadioResourceConfigCommon * radioResourceConfigCommon, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeRadioResourceConfigCommon',
                   'ns3::Buffer::Iterator',
                   [param('ns3::LteRrcSap::RadioResourceConfigCommon *', 'radioResourceConfigCommon'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-rrc-header.h (module 'lte'): ns3::Buffer::Iterator ns3::RrcAsn1Header::DeserializeRadioResourceConfigCommonSCell(ns3::LteRrcSap::RadioResourceConfigCommonSCell * rrccsc, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeRadioResourceConfigCommonSCell',
                   'ns3::Buffer::Iterator',
                   [param('ns3::LteRrcSap::RadioResourceConfigCommonSCell *', 'rrccsc'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-rrc-header.h (module 'lte'): ns3::Buffer::Iterator ns3::RrcAsn1Header::DeserializeRadioResourceConfigCommonSib(ns3::LteRrcSap::RadioResourceConfigCommonSib * radioResourceConfigCommonSib, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeRadioResourceConfigCommonSib',
                   'ns3::Buffer::Iterator',
                   [param('ns3::LteRrcSap::RadioResourceConfigCommonSib *', 'radioResourceConfigCommonSib'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-rrc-header.h (module 'lte'): ns3::Buffer::Iterator ns3::RrcAsn1Header::DeserializeRadioResourceConfigDedicated(ns3::LteRrcSap::RadioResourceConfigDedicated * radioResourceConfigDedicated, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeRadioResourceConfigDedicated',
                   'ns3::Buffer::Iterator',
                   [param('ns3::LteRrcSap::RadioResourceConfigDedicated *', 'radioResourceConfigDedicated'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-rrc-header.h (module 'lte'): ns3::Buffer::Iterator ns3::RrcAsn1Header::DeserializeRadioResourceConfigDedicatedSCell(ns3::LteRrcSap::RadioResourceConfigDedicatedSCell * rrcdsc, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeRadioResourceConfigDedicatedSCell',
                   'ns3::Buffer::Iterator',
                   [param('ns3::LteRrcSap::RadioResourceConfigDedicatedSCell *', 'rrcdsc'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-rrc-header.h (module 'lte'): ns3::Buffer::Iterator ns3::RrcAsn1Header::DeserializeSrbToAddModList(std::list<ns3::LteRrcSap::SrbToAddMod, std::allocator<ns3::LteRrcSap::SrbToAddMod> > * srbToAddModList, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeSrbToAddModList',
                   'ns3::Buffer::Iterator',
                   [param('std::list< ns3::LteRrcSap::SrbToAddMod > *', 'srbToAddModList'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-rrc-header.h (module 'lte'): ns3::Buffer::Iterator ns3::RrcAsn1Header::DeserializeSystemInformationBlockType1(ns3::LteRrcSap::SystemInformationBlockType1 * systemInformationBlockType1, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeSystemInformationBlockType1',
                   'ns3::Buffer::Iterator',
                   [param('ns3::LteRrcSap::SystemInformationBlockType1 *', 'systemInformationBlockType1'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-rrc-header.h (module 'lte'): ns3::Buffer::Iterator ns3::RrcAsn1Header::DeserializeSystemInformationBlockType2(ns3::LteRrcSap::SystemInformationBlockType2 * systemInformationBlockType2, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeSystemInformationBlockType2',
                   'ns3::Buffer::Iterator',
                   [param('ns3::LteRrcSap::SystemInformationBlockType2 *', 'systemInformationBlockType2'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-rrc-header.h (module 'lte'): ns3::Buffer::Iterator ns3::RrcAsn1Header::DeserializeThresholdEutra(ns3::LteRrcSap::ThresholdEutra * thresholdEutra, ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeThresholdEutra',
                   'ns3::Buffer::Iterator',
                   [param('ns3::LteRrcSap::ThresholdEutra *', 'thresholdEutra'), param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-rrc-header.h (module 'lte'): uint8_t ns3::RrcAsn1Header::EnumToBandwidth(int n) const [member function]
    cls.add_method('EnumToBandwidth',
                   'uint8_t',
                   [param('int', 'n')],
                   is_const=True, visibility='protected')
    ## lte-rrc-header.h (module 'lte'): ns3::TypeId ns3::RrcAsn1Header::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId',
                   'ns3::TypeId',
                   [],
                   is_const=True, visibility='protected', is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): static ns3::TypeId ns3::RrcAsn1Header::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True, visibility='protected')
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcAsn1Header::PreSerialize() const [member function]
    cls.add_method('PreSerialize',
                   'void',
                   [],
                   is_pure_virtual=True, is_const=True, visibility='protected', is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcAsn1Header::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True, visibility='protected', is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcAsn1Header::Print(std::ostream & os, ns3::LteRrcSap::RadioResourceConfigDedicated radioResourceConfigDedicated) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os'), param('ns3::LteRrcSap::RadioResourceConfigDedicated', 'radioResourceConfigDedicated')],
                   is_const=True, visibility='protected')
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcAsn1Header::SerializeDrbToAddModList(std::list<ns3::LteRrcSap::DrbToAddMod, std::allocator<ns3::LteRrcSap::DrbToAddMod> > drbToAddModList) const [member function]
    cls.add_method('SerializeDrbToAddModList',
                   'void',
                   [param('std::list< ns3::LteRrcSap::DrbToAddMod >', 'drbToAddModList')],
                   is_const=True, visibility='protected')
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcAsn1Header::SerializeLogicalChannelConfig(ns3::LteRrcSap::LogicalChannelConfig logicalChannelConfig) const [member function]
    cls.add_method('SerializeLogicalChannelConfig',
                   'void',
                   [param('ns3::LteRrcSap::LogicalChannelConfig', 'logicalChannelConfig')],
                   is_const=True, visibility='protected')
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcAsn1Header::SerializeMeasConfig(ns3::LteRrcSap::MeasConfig measConfig) const [member function]
    cls.add_method('SerializeMeasConfig',
                   'void',
                   [param('ns3::LteRrcSap::MeasConfig', 'measConfig')],
                   is_const=True, visibility='protected')
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcAsn1Header::SerializeMeasResults(ns3::LteRrcSap::MeasResults measResults) const [member function]
    cls.add_method('SerializeMeasResults',
                   'void',
                   [param('ns3::LteRrcSap::MeasResults', 'measResults')],
                   is_const=True, visibility='protected')
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcAsn1Header::SerializeNonCriticalExtensionConfiguration(ns3::LteRrcSap::NonCriticalExtensionConfiguration nonCriticalExtensionConfiguration) const [member function]
    cls.add_method('SerializeNonCriticalExtensionConfiguration',
                   'void',
                   [param('ns3::LteRrcSap::NonCriticalExtensionConfiguration', 'nonCriticalExtensionConfiguration')],
                   is_const=True, visibility='protected')
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcAsn1Header::SerializePhysicalConfigDedicated(ns3::LteRrcSap::PhysicalConfigDedicated physicalConfigDedicated) const [member function]
    cls.add_method('SerializePhysicalConfigDedicated',
                   'void',
                   [param('ns3::LteRrcSap::PhysicalConfigDedicated', 'physicalConfigDedicated')],
                   is_const=True, visibility='protected')
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcAsn1Header::SerializePhysicalConfigDedicatedSCell(ns3::LteRrcSap::PhysicalConfigDedicatedSCell pcdsc) const [member function]
    cls.add_method('SerializePhysicalConfigDedicatedSCell',
                   'void',
                   [param('ns3::LteRrcSap::PhysicalConfigDedicatedSCell', 'pcdsc')],
                   is_const=True, visibility='protected')
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcAsn1Header::SerializePlmnIdentity(uint32_t plmnId) const [member function]
    cls.add_method('SerializePlmnIdentity',
                   'void',
                   [param('uint32_t', 'plmnId')],
                   is_const=True, visibility='protected')
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcAsn1Header::SerializeQoffsetRange(int8_t qOffsetRange) const [member function]
    cls.add_method('SerializeQoffsetRange',
                   'void',
                   [param('int8_t', 'qOffsetRange')],
                   is_const=True, visibility='protected')
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcAsn1Header::SerializeRachConfigCommon(ns3::LteRrcSap::RachConfigCommon rachConfigCommon) const [member function]
    cls.add_method('SerializeRachConfigCommon',
                   'void',
                   [param('ns3::LteRrcSap::RachConfigCommon', 'rachConfigCommon')],
                   is_const=True, visibility='protected')
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcAsn1Header::SerializeRadioResourceConfigCommon(ns3::LteRrcSap::RadioResourceConfigCommon radioResourceConfigCommon) const [member function]
    cls.add_method('SerializeRadioResourceConfigCommon',
                   'void',
                   [param('ns3::LteRrcSap::RadioResourceConfigCommon', 'radioResourceConfigCommon')],
                   is_const=True, visibility='protected')
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcAsn1Header::SerializeRadioResourceConfigCommonSCell(ns3::LteRrcSap::RadioResourceConfigCommonSCell rrccsc) const [member function]
    cls.add_method('SerializeRadioResourceConfigCommonSCell',
                   'void',
                   [param('ns3::LteRrcSap::RadioResourceConfigCommonSCell', 'rrccsc')],
                   is_const=True, visibility='protected')
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcAsn1Header::SerializeRadioResourceConfigCommonSib(ns3::LteRrcSap::RadioResourceConfigCommonSib radioResourceConfigCommonSib) const [member function]
    cls.add_method('SerializeRadioResourceConfigCommonSib',
                   'void',
                   [param('ns3::LteRrcSap::RadioResourceConfigCommonSib', 'radioResourceConfigCommonSib')],
                   is_const=True, visibility='protected')
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcAsn1Header::SerializeRadioResourceConfigDedicated(ns3::LteRrcSap::RadioResourceConfigDedicated radioResourceConfigDedicated) const [member function]
    cls.add_method('SerializeRadioResourceConfigDedicated',
                   'void',
                   [param('ns3::LteRrcSap::RadioResourceConfigDedicated', 'radioResourceConfigDedicated')],
                   is_const=True, visibility='protected')
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcAsn1Header::SerializeRadioResourceDedicatedSCell(ns3::LteRrcSap::RadioResourceConfigDedicatedSCell rrcdsc) const [member function]
    cls.add_method('SerializeRadioResourceDedicatedSCell',
                   'void',
                   [param('ns3::LteRrcSap::RadioResourceConfigDedicatedSCell', 'rrcdsc')],
                   is_const=True, visibility='protected')
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcAsn1Header::SerializeSrbToAddModList(std::list<ns3::LteRrcSap::SrbToAddMod, std::allocator<ns3::LteRrcSap::SrbToAddMod> > srbToAddModList) const [member function]
    cls.add_method('SerializeSrbToAddModList',
                   'void',
                   [param('std::list< ns3::LteRrcSap::SrbToAddMod >', 'srbToAddModList')],
                   is_const=True, visibility='protected')
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcAsn1Header::SerializeSystemInformationBlockType1(ns3::LteRrcSap::SystemInformationBlockType1 systemInformationBlockType1) const [member function]
    cls.add_method('SerializeSystemInformationBlockType1',
                   'void',
                   [param('ns3::LteRrcSap::SystemInformationBlockType1', 'systemInformationBlockType1')],
                   is_const=True, visibility='protected')
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcAsn1Header::SerializeSystemInformationBlockType2(ns3::LteRrcSap::SystemInformationBlockType2 systemInformationBlockType2) const [member function]
    cls.add_method('SerializeSystemInformationBlockType2',
                   'void',
                   [param('ns3::LteRrcSap::SystemInformationBlockType2', 'systemInformationBlockType2')],
                   is_const=True, visibility='protected')
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcAsn1Header::SerializeThresholdEutra(ns3::LteRrcSap::ThresholdEutra thresholdEutra) const [member function]
    cls.add_method('SerializeThresholdEutra',
                   'void',
                   [param('ns3::LteRrcSap::ThresholdEutra', 'thresholdEutra')],
                   is_const=True, visibility='protected')
    return

def register_Ns3RrcDlCcchMessage_methods(root_module, cls):
    ## lte-rrc-header.h (module 'lte'): ns3::RrcDlCcchMessage::RrcDlCcchMessage(ns3::RrcDlCcchMessage const & arg0) [constructor]
    cls.add_constructor([param('ns3::RrcDlCcchMessage const &', 'arg0')])
    ## lte-rrc-header.h (module 'lte'): ns3::RrcDlCcchMessage::RrcDlCcchMessage() [constructor]
    cls.add_constructor([])
    ## lte-rrc-header.h (module 'lte'): uint32_t ns3::RrcDlCcchMessage::Deserialize(ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('Deserialize',
                   'uint32_t',
                   [param('ns3::Buffer::Iterator', 'bIterator')],
                   is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcDlCcchMessage::PreSerialize() const [member function]
    cls.add_method('PreSerialize',
                   'void',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcDlCcchMessage::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True, is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): ns3::Buffer::Iterator ns3::RrcDlCcchMessage::DeserializeDlCcchMessage(ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeDlCcchMessage',
                   'ns3::Buffer::Iterator',
                   [param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcDlCcchMessage::SerializeDlCcchMessage(int msgType) const [member function]
    cls.add_method('SerializeDlCcchMessage',
                   'void',
                   [param('int', 'msgType')],
                   is_const=True, visibility='protected')
    return

def register_Ns3RrcDlDcchMessage_methods(root_module, cls):
    ## lte-rrc-header.h (module 'lte'): ns3::RrcDlDcchMessage::RrcDlDcchMessage(ns3::RrcDlDcchMessage const & arg0) [constructor]
    cls.add_constructor([param('ns3::RrcDlDcchMessage const &', 'arg0')])
    ## lte-rrc-header.h (module 'lte'): ns3::RrcDlDcchMessage::RrcDlDcchMessage() [constructor]
    cls.add_constructor([])
    ## lte-rrc-header.h (module 'lte'): uint32_t ns3::RrcDlDcchMessage::Deserialize(ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('Deserialize',
                   'uint32_t',
                   [param('ns3::Buffer::Iterator', 'bIterator')],
                   is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcDlDcchMessage::PreSerialize() const [member function]
    cls.add_method('PreSerialize',
                   'void',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcDlDcchMessage::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True, is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): ns3::Buffer::Iterator ns3::RrcDlDcchMessage::DeserializeDlDcchMessage(ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeDlDcchMessage',
                   'ns3::Buffer::Iterator',
                   [param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcDlDcchMessage::SerializeDlDcchMessage(int msgType) const [member function]
    cls.add_method('SerializeDlDcchMessage',
                   'void',
                   [param('int', 'msgType')],
                   is_const=True, visibility='protected')
    return

def register_Ns3RrcUlCcchMessage_methods(root_module, cls):
    ## lte-rrc-header.h (module 'lte'): ns3::RrcUlCcchMessage::RrcUlCcchMessage(ns3::RrcUlCcchMessage const & arg0) [constructor]
    cls.add_constructor([param('ns3::RrcUlCcchMessage const &', 'arg0')])
    ## lte-rrc-header.h (module 'lte'): ns3::RrcUlCcchMessage::RrcUlCcchMessage() [constructor]
    cls.add_constructor([])
    ## lte-rrc-header.h (module 'lte'): uint32_t ns3::RrcUlCcchMessage::Deserialize(ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('Deserialize',
                   'uint32_t',
                   [param('ns3::Buffer::Iterator', 'bIterator')],
                   is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcUlCcchMessage::PreSerialize() const [member function]
    cls.add_method('PreSerialize',
                   'void',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcUlCcchMessage::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True, is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): ns3::Buffer::Iterator ns3::RrcUlCcchMessage::DeserializeUlCcchMessage(ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeUlCcchMessage',
                   'ns3::Buffer::Iterator',
                   [param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcUlCcchMessage::SerializeUlCcchMessage(int msgType) const [member function]
    cls.add_method('SerializeUlCcchMessage',
                   'void',
                   [param('int', 'msgType')],
                   is_const=True, visibility='protected')
    return

def register_Ns3RrcUlDcchMessage_methods(root_module, cls):
    ## lte-rrc-header.h (module 'lte'): ns3::RrcUlDcchMessage::RrcUlDcchMessage(ns3::RrcUlDcchMessage const & arg0) [constructor]
    cls.add_constructor([param('ns3::RrcUlDcchMessage const &', 'arg0')])
    ## lte-rrc-header.h (module 'lte'): ns3::RrcUlDcchMessage::RrcUlDcchMessage() [constructor]
    cls.add_constructor([])
    ## lte-rrc-header.h (module 'lte'): uint32_t ns3::RrcUlDcchMessage::Deserialize(ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('Deserialize',
                   'uint32_t',
                   [param('ns3::Buffer::Iterator', 'bIterator')],
                   is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcUlDcchMessage::PreSerialize() const [member function]
    cls.add_method('PreSerialize',
                   'void',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcUlDcchMessage::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True, is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): ns3::Buffer::Iterator ns3::RrcUlDcchMessage::DeserializeUlDcchMessage(ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('DeserializeUlDcchMessage',
                   'ns3::Buffer::Iterator',
                   [param('ns3::Buffer::Iterator', 'bIterator')],
                   visibility='protected')
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcUlDcchMessage::SerializeUlDcchMessage(int msgType) const [member function]
    cls.add_method('SerializeUlDcchMessage',
                   'void',
                   [param('int', 'msgType')],
                   is_const=True, visibility='protected')
    return

def register_Ns3Sib1LteControlMessage_methods(root_module, cls):
    ## lte-control-messages.h (module 'lte'): ns3::Sib1LteControlMessage::Sib1LteControlMessage(ns3::Sib1LteControlMessage const & arg0) [constructor]
    cls.add_constructor([param('ns3::Sib1LteControlMessage const &', 'arg0')])
    ## lte-control-messages.h (module 'lte'): ns3::Sib1LteControlMessage::Sib1LteControlMessage() [constructor]
    cls.add_constructor([])
    ## lte-control-messages.h (module 'lte'): ns3::LteRrcSap::SystemInformationBlockType1 ns3::Sib1LteControlMessage::GetSib1() const [member function]
    cls.add_method('GetSib1',
                   'ns3::LteRrcSap::SystemInformationBlockType1',
                   [],
                   is_const=True)
    ## lte-control-messages.h (module 'lte'): void ns3::Sib1LteControlMessage::SetSib1(ns3::LteRrcSap::SystemInformationBlockType1 sib1) [member function]
    cls.add_method('SetSib1',
                   'void',
                   [param('ns3::LteRrcSap::SystemInformationBlockType1', 'sib1')])
    return

def register_Ns3SpectrumChannel_methods(root_module, cls):
    ## spectrum-channel.h (module 'spectrum'): ns3::SpectrumChannel::SpectrumChannel(ns3::SpectrumChannel const & arg0) [constructor]
    cls.add_constructor([param('ns3::SpectrumChannel const &', 'arg0')])
    ## spectrum-channel.h (module 'spectrum'): ns3::SpectrumChannel::SpectrumChannel() [constructor]
    cls.add_constructor([])
    ## spectrum-channel.h (module 'spectrum'): void ns3::SpectrumChannel::AddPropagationLossModel(ns3::Ptr<ns3::PropagationLossModel> loss) [member function]
    cls.add_method('AddPropagationLossModel',
                   'void',
                   [param('ns3::Ptr< ns3::PropagationLossModel >', 'loss')])
    ## spectrum-channel.h (module 'spectrum'): void ns3::SpectrumChannel::AddRx(ns3::Ptr<ns3::SpectrumPhy> phy) [member function]
    cls.add_method('AddRx',
                   'void',
                   [param('ns3::Ptr< ns3::SpectrumPhy >', 'phy')],
                   is_pure_virtual=True, is_virtual=True)
    ## spectrum-channel.h (module 'spectrum'): void ns3::SpectrumChannel::AddSpectrumPropagationLossModel(ns3::Ptr<ns3::SpectrumPropagationLossModel> loss) [member function]
    cls.add_method('AddSpectrumPropagationLossModel',
                   'void',
                   [param('ns3::Ptr< ns3::SpectrumPropagationLossModel >', 'loss')])
    ## spectrum-channel.h (module 'spectrum'): void ns3::SpectrumChannel::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## spectrum-channel.h (module 'spectrum'): ns3::Ptr<ns3::SpectrumPropagationLossModel> ns3::SpectrumChannel::GetSpectrumPropagationLossModel() [member function]
    cls.add_method('GetSpectrumPropagationLossModel',
                   'ns3::Ptr< ns3::SpectrumPropagationLossModel >',
                   [])
    ## spectrum-channel.h (module 'spectrum'): static ns3::TypeId ns3::SpectrumChannel::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## spectrum-channel.h (module 'spectrum'): void ns3::SpectrumChannel::SetPropagationDelayModel(ns3::Ptr<ns3::PropagationDelayModel> delay) [member function]
    cls.add_method('SetPropagationDelayModel',
                   'void',
                   [param('ns3::Ptr< ns3::PropagationDelayModel >', 'delay')])
    ## spectrum-channel.h (module 'spectrum'): void ns3::SpectrumChannel::StartTx(ns3::Ptr<ns3::SpectrumSignalParameters> params) [member function]
    cls.add_method('StartTx',
                   'void',
                   [param('ns3::Ptr< ns3::SpectrumSignalParameters >', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3StringChecker_methods(root_module, cls):
    ## string.h (module 'core'): ns3::StringChecker::StringChecker() [constructor]
    cls.add_constructor([])
    ## string.h (module 'core'): ns3::StringChecker::StringChecker(ns3::StringChecker const & arg0) [constructor]
    cls.add_constructor([param('ns3::StringChecker const &', 'arg0')])
    return

def register_Ns3StringValue_methods(root_module, cls):
    ## string.h (module 'core'): ns3::StringValue::StringValue() [constructor]
    cls.add_constructor([])
    ## string.h (module 'core'): ns3::StringValue::StringValue(std::string const & value) [constructor]
    cls.add_constructor([param('std::string const &', 'value')])
    ## string.h (module 'core'): ns3::StringValue::StringValue(ns3::StringValue const & arg0) [constructor]
    cls.add_constructor([param('ns3::StringValue const &', 'arg0')])
    ## string.h (module 'core'): ns3::Ptr<ns3::AttributeValue> ns3::StringValue::Copy() const [member function]
    cls.add_method('Copy',
                   'ns3::Ptr< ns3::AttributeValue >',
                   [],
                   is_const=True, is_virtual=True)
    ## string.h (module 'core'): bool ns3::StringValue::DeserializeFromString(std::string value, ns3::Ptr<const ns3::AttributeChecker> checker) [member function]
    cls.add_method('DeserializeFromString',
                   'bool',
                   [param('std::string', 'value'), param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_virtual=True)
    ## string.h (module 'core'): std::string ns3::StringValue::Get() const [member function]
    cls.add_method('Get',
                   'std::string',
                   [],
                   is_const=True)
    ## string.h (module 'core'): std::string ns3::StringValue::SerializeToString(ns3::Ptr<const ns3::AttributeChecker> checker) const [member function]
    cls.add_method('SerializeToString',
                   'std::string',
                   [param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_const=True, is_virtual=True)
    ## string.h (module 'core'): void ns3::StringValue::Set(std::string const & value) [member function]
    cls.add_method('Set',
                   'void',
                   [param('std::string const &', 'value')])
    return

def register_Ns3TimeValue_methods(root_module, cls):
    ## nstime.h (module 'core'): ns3::TimeValue::TimeValue() [constructor]
    cls.add_constructor([])
    ## nstime.h (module 'core'): ns3::TimeValue::TimeValue(ns3::Time const & value) [constructor]
    cls.add_constructor([param('ns3::Time const &', 'value')])
    ## nstime.h (module 'core'): ns3::TimeValue::TimeValue(ns3::TimeValue const & arg0) [constructor]
    cls.add_constructor([param('ns3::TimeValue const &', 'arg0')])
    ## nstime.h (module 'core'): ns3::Ptr<ns3::AttributeValue> ns3::TimeValue::Copy() const [member function]
    cls.add_method('Copy',
                   'ns3::Ptr< ns3::AttributeValue >',
                   [],
                   is_const=True, is_virtual=True)
    ## nstime.h (module 'core'): bool ns3::TimeValue::DeserializeFromString(std::string value, ns3::Ptr<const ns3::AttributeChecker> checker) [member function]
    cls.add_method('DeserializeFromString',
                   'bool',
                   [param('std::string', 'value'), param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_virtual=True)
    ## nstime.h (module 'core'): ns3::Time ns3::TimeValue::Get() const [member function]
    cls.add_method('Get',
                   'ns3::Time',
                   [],
                   is_const=True)
    ## nstime.h (module 'core'): std::string ns3::TimeValue::SerializeToString(ns3::Ptr<const ns3::AttributeChecker> checker) const [member function]
    cls.add_method('SerializeToString',
                   'std::string',
                   [param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_const=True, is_virtual=True)
    ## nstime.h (module 'core'): void ns3::TimeValue::Set(ns3::Time const & value) [member function]
    cls.add_method('Set',
                   'void',
                   [param('ns3::Time const &', 'value')])
    return

def register_Ns3TypeIdChecker_methods(root_module, cls):
    ## type-id.h (module 'core'): ns3::TypeIdChecker::TypeIdChecker() [constructor]
    cls.add_constructor([])
    ## type-id.h (module 'core'): ns3::TypeIdChecker::TypeIdChecker(ns3::TypeIdChecker const & arg0) [constructor]
    cls.add_constructor([param('ns3::TypeIdChecker const &', 'arg0')])
    return

def register_Ns3TypeIdValue_methods(root_module, cls):
    ## type-id.h (module 'core'): ns3::TypeIdValue::TypeIdValue() [constructor]
    cls.add_constructor([])
    ## type-id.h (module 'core'): ns3::TypeIdValue::TypeIdValue(ns3::TypeId const & value) [constructor]
    cls.add_constructor([param('ns3::TypeId const &', 'value')])
    ## type-id.h (module 'core'): ns3::TypeIdValue::TypeIdValue(ns3::TypeIdValue const & arg0) [constructor]
    cls.add_constructor([param('ns3::TypeIdValue const &', 'arg0')])
    ## type-id.h (module 'core'): ns3::Ptr<ns3::AttributeValue> ns3::TypeIdValue::Copy() const [member function]
    cls.add_method('Copy',
                   'ns3::Ptr< ns3::AttributeValue >',
                   [],
                   is_const=True, is_virtual=True)
    ## type-id.h (module 'core'): bool ns3::TypeIdValue::DeserializeFromString(std::string value, ns3::Ptr<const ns3::AttributeChecker> checker) [member function]
    cls.add_method('DeserializeFromString',
                   'bool',
                   [param('std::string', 'value'), param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_virtual=True)
    ## type-id.h (module 'core'): ns3::TypeId ns3::TypeIdValue::Get() const [member function]
    cls.add_method('Get',
                   'ns3::TypeId',
                   [],
                   is_const=True)
    ## type-id.h (module 'core'): std::string ns3::TypeIdValue::SerializeToString(ns3::Ptr<const ns3::AttributeChecker> checker) const [member function]
    cls.add_method('SerializeToString',
                   'std::string',
                   [param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_const=True, is_virtual=True)
    ## type-id.h (module 'core'): void ns3::TypeIdValue::Set(ns3::TypeId const & value) [member function]
    cls.add_method('Set',
                   'void',
                   [param('ns3::TypeId const &', 'value')])
    return

def register_Ns3UintegerValue_methods(root_module, cls):
    ## uinteger.h (module 'core'): ns3::UintegerValue::UintegerValue() [constructor]
    cls.add_constructor([])
    ## uinteger.h (module 'core'): ns3::UintegerValue::UintegerValue(uint64_t const & value) [constructor]
    cls.add_constructor([param('uint64_t const &', 'value')])
    ## uinteger.h (module 'core'): ns3::UintegerValue::UintegerValue(ns3::UintegerValue const & arg0) [constructor]
    cls.add_constructor([param('ns3::UintegerValue const &', 'arg0')])
    ## uinteger.h (module 'core'): ns3::Ptr<ns3::AttributeValue> ns3::UintegerValue::Copy() const [member function]
    cls.add_method('Copy',
                   'ns3::Ptr< ns3::AttributeValue >',
                   [],
                   is_const=True, is_virtual=True)
    ## uinteger.h (module 'core'): bool ns3::UintegerValue::DeserializeFromString(std::string value, ns3::Ptr<const ns3::AttributeChecker> checker) [member function]
    cls.add_method('DeserializeFromString',
                   'bool',
                   [param('std::string', 'value'), param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_virtual=True)
    ## uinteger.h (module 'core'): uint64_t ns3::UintegerValue::Get() const [member function]
    cls.add_method('Get',
                   'uint64_t',
                   [],
                   is_const=True)
    ## uinteger.h (module 'core'): std::string ns3::UintegerValue::SerializeToString(ns3::Ptr<const ns3::AttributeChecker> checker) const [member function]
    cls.add_method('SerializeToString',
                   'std::string',
                   [param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_const=True, is_virtual=True)
    ## uinteger.h (module 'core'): void ns3::UintegerValue::Set(uint64_t const & value) [member function]
    cls.add_method('Set',
                   'void',
                   [param('uint64_t const &', 'value')])
    return

def register_Ns3UlDciLteControlMessage_methods(root_module, cls):
    ## lte-control-messages.h (module 'lte'): ns3::UlDciLteControlMessage::UlDciLteControlMessage(ns3::UlDciLteControlMessage const & arg0) [constructor]
    cls.add_constructor([param('ns3::UlDciLteControlMessage const &', 'arg0')])
    ## lte-control-messages.h (module 'lte'): ns3::UlDciLteControlMessage::UlDciLteControlMessage() [constructor]
    cls.add_constructor([])
    ## lte-control-messages.h (module 'lte'): ns3::UlDciListElement_s ns3::UlDciLteControlMessage::GetDci() [member function]
    cls.add_method('GetDci',
                   'ns3::UlDciListElement_s',
                   [])
    ## lte-control-messages.h (module 'lte'): void ns3::UlDciLteControlMessage::SetDci(ns3::UlDciListElement_s dci) [member function]
    cls.add_method('SetDci',
                   'void',
                   [param('ns3::UlDciListElement_s', 'dci')])
    return

def register_Ns3Vector2DChecker_methods(root_module, cls):
    ## vector.h (module 'core'): ns3::Vector2DChecker::Vector2DChecker() [constructor]
    cls.add_constructor([])
    ## vector.h (module 'core'): ns3::Vector2DChecker::Vector2DChecker(ns3::Vector2DChecker const & arg0) [constructor]
    cls.add_constructor([param('ns3::Vector2DChecker const &', 'arg0')])
    return

def register_Ns3Vector2DValue_methods(root_module, cls):
    ## vector.h (module 'core'): ns3::Vector2DValue::Vector2DValue() [constructor]
    cls.add_constructor([])
    ## vector.h (module 'core'): ns3::Vector2DValue::Vector2DValue(ns3::Vector2D const & value) [constructor]
    cls.add_constructor([param('ns3::Vector2D const &', 'value')])
    ## vector.h (module 'core'): ns3::Vector2DValue::Vector2DValue(ns3::Vector2DValue const & arg0) [constructor]
    cls.add_constructor([param('ns3::Vector2DValue const &', 'arg0')])
    ## vector.h (module 'core'): ns3::Ptr<ns3::AttributeValue> ns3::Vector2DValue::Copy() const [member function]
    cls.add_method('Copy',
                   'ns3::Ptr< ns3::AttributeValue >',
                   [],
                   is_const=True, is_virtual=True)
    ## vector.h (module 'core'): bool ns3::Vector2DValue::DeserializeFromString(std::string value, ns3::Ptr<const ns3::AttributeChecker> checker) [member function]
    cls.add_method('DeserializeFromString',
                   'bool',
                   [param('std::string', 'value'), param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_virtual=True)
    ## vector.h (module 'core'): ns3::Vector2D ns3::Vector2DValue::Get() const [member function]
    cls.add_method('Get',
                   'ns3::Vector2D',
                   [],
                   is_const=True)
    ## vector.h (module 'core'): std::string ns3::Vector2DValue::SerializeToString(ns3::Ptr<const ns3::AttributeChecker> checker) const [member function]
    cls.add_method('SerializeToString',
                   'std::string',
                   [param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_const=True, is_virtual=True)
    ## vector.h (module 'core'): void ns3::Vector2DValue::Set(ns3::Vector2D const & value) [member function]
    cls.add_method('Set',
                   'void',
                   [param('ns3::Vector2D const &', 'value')])
    return

def register_Ns3Vector3DChecker_methods(root_module, cls):
    ## vector.h (module 'core'): ns3::Vector3DChecker::Vector3DChecker() [constructor]
    cls.add_constructor([])
    ## vector.h (module 'core'): ns3::Vector3DChecker::Vector3DChecker(ns3::Vector3DChecker const & arg0) [constructor]
    cls.add_constructor([param('ns3::Vector3DChecker const &', 'arg0')])
    return

def register_Ns3Vector3DValue_methods(root_module, cls):
    ## vector.h (module 'core'): ns3::Vector3DValue::Vector3DValue() [constructor]
    cls.add_constructor([])
    ## vector.h (module 'core'): ns3::Vector3DValue::Vector3DValue(ns3::Vector3D const & value) [constructor]
    cls.add_constructor([param('ns3::Vector3D const &', 'value')])
    ## vector.h (module 'core'): ns3::Vector3DValue::Vector3DValue(ns3::Vector3DValue const & arg0) [constructor]
    cls.add_constructor([param('ns3::Vector3DValue const &', 'arg0')])
    ## vector.h (module 'core'): ns3::Ptr<ns3::AttributeValue> ns3::Vector3DValue::Copy() const [member function]
    cls.add_method('Copy',
                   'ns3::Ptr< ns3::AttributeValue >',
                   [],
                   is_const=True, is_virtual=True)
    ## vector.h (module 'core'): bool ns3::Vector3DValue::DeserializeFromString(std::string value, ns3::Ptr<const ns3::AttributeChecker> checker) [member function]
    cls.add_method('DeserializeFromString',
                   'bool',
                   [param('std::string', 'value'), param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_virtual=True)
    ## vector.h (module 'core'): ns3::Vector3D ns3::Vector3DValue::Get() const [member function]
    cls.add_method('Get',
                   'ns3::Vector3D',
                   [],
                   is_const=True)
    ## vector.h (module 'core'): std::string ns3::Vector3DValue::SerializeToString(ns3::Ptr<const ns3::AttributeChecker> checker) const [member function]
    cls.add_method('SerializeToString',
                   'std::string',
                   [param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_const=True, is_virtual=True)
    ## vector.h (module 'core'): void ns3::Vector3DValue::Set(ns3::Vector3D const & value) [member function]
    cls.add_method('Set',
                   'void',
                   [param('ns3::Vector3D const &', 'value')])
    return

def register_Ns3AddressChecker_methods(root_module, cls):
    ## address.h (module 'network'): ns3::AddressChecker::AddressChecker() [constructor]
    cls.add_constructor([])
    ## address.h (module 'network'): ns3::AddressChecker::AddressChecker(ns3::AddressChecker const & arg0) [constructor]
    cls.add_constructor([param('ns3::AddressChecker const &', 'arg0')])
    return

def register_Ns3AddressValue_methods(root_module, cls):
    ## address.h (module 'network'): ns3::AddressValue::AddressValue() [constructor]
    cls.add_constructor([])
    ## address.h (module 'network'): ns3::AddressValue::AddressValue(ns3::Address const & value) [constructor]
    cls.add_constructor([param('ns3::Address const &', 'value')])
    ## address.h (module 'network'): ns3::AddressValue::AddressValue(ns3::AddressValue const & arg0) [constructor]
    cls.add_constructor([param('ns3::AddressValue const &', 'arg0')])
    ## address.h (module 'network'): ns3::Ptr<ns3::AttributeValue> ns3::AddressValue::Copy() const [member function]
    cls.add_method('Copy',
                   'ns3::Ptr< ns3::AttributeValue >',
                   [],
                   is_const=True, is_virtual=True)
    ## address.h (module 'network'): bool ns3::AddressValue::DeserializeFromString(std::string value, ns3::Ptr<const ns3::AttributeChecker> checker) [member function]
    cls.add_method('DeserializeFromString',
                   'bool',
                   [param('std::string', 'value'), param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_virtual=True)
    ## address.h (module 'network'): ns3::Address ns3::AddressValue::Get() const [member function]
    cls.add_method('Get',
                   'ns3::Address',
                   [],
                   is_const=True)
    ## address.h (module 'network'): std::string ns3::AddressValue::SerializeToString(ns3::Ptr<const ns3::AttributeChecker> checker) const [member function]
    cls.add_method('SerializeToString',
                   'std::string',
                   [param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')],
                   is_const=True, is_virtual=True)
    ## address.h (module 'network'): void ns3::AddressValue::Set(ns3::Address const & value) [member function]
    cls.add_method('Set',
                   'void',
                   [param('ns3::Address const &', 'value')])
    return

def register_Ns3BsrLteControlMessage_methods(root_module, cls):
    ## lte-control-messages.h (module 'lte'): ns3::BsrLteControlMessage::BsrLteControlMessage(ns3::BsrLteControlMessage const & arg0) [constructor]
    cls.add_constructor([param('ns3::BsrLteControlMessage const &', 'arg0')])
    ## lte-control-messages.h (module 'lte'): ns3::BsrLteControlMessage::BsrLteControlMessage() [constructor]
    cls.add_constructor([])
    ## lte-control-messages.h (module 'lte'): ns3::MacCeListElement_s ns3::BsrLteControlMessage::GetBsr() [member function]
    cls.add_method('GetBsr',
                   'ns3::MacCeListElement_s',
                   [])
    ## lte-control-messages.h (module 'lte'): void ns3::BsrLteControlMessage::SetBsr(ns3::MacCeListElement_s bsr) [member function]
    cls.add_method('SetBsr',
                   'void',
                   [param('ns3::MacCeListElement_s', 'bsr')])
    return

def register_Ns3CallbackImpl__Bool_Ns3Ptr__lt__ns3NetDevice__gt___Ns3Ptr__lt__const_ns3Packet__gt___Unsigned_short_Const_ns3Address___amp___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<bool, ns3::Ptr<ns3::NetDevice>, ns3::Ptr<const ns3::Packet>, unsigned short, const ns3::Address &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<bool, ns3::Ptr<ns3::NetDevice>, ns3::Ptr<const ns3::Packet>, unsigned short, const ns3::Address &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<bool, ns3::Ptr<ns3::NetDevice>, ns3::Ptr<const ns3::Packet>, unsigned short, const ns3::Address &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< bool, ns3::Ptr< ns3::NetDevice >, ns3::Ptr< ns3::Packet const >, unsigned short, ns3::Address const &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<bool, ns3::Ptr<ns3::NetDevice>, ns3::Ptr<const ns3::Packet>, unsigned short, const ns3::Address &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<bool, ns3::Ptr<ns3::NetDevice>, ns3::Ptr<const ns3::Packet>, unsigned short, const ns3::Address &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): bool ns3::CallbackImpl<bool, ns3::Ptr<ns3::NetDevice>, ns3::Ptr<const ns3::Packet>, unsigned short, const ns3::Address &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::Ptr<ns3::NetDevice> arg0, ns3::Ptr<const ns3::Packet> arg1, short unsigned int arg2, ns3::Address const & arg3) [member operator]
    cls.add_method('operator()',
                   'bool',
                   [param('ns3::Ptr< ns3::NetDevice >', 'arg0'), param('ns3::Ptr< ns3::Packet const >', 'arg1'), param('short unsigned int', 'arg2'), param('ns3::Address const &', 'arg3')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Bool_Ns3Ptr__lt__ns3Socket__gt___Const_ns3Address___amp___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<bool, ns3::Ptr<ns3::Socket>, const ns3::Address &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<bool, ns3::Ptr<ns3::Socket>, const ns3::Address &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<bool, ns3::Ptr<ns3::Socket>, const ns3::Address &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< bool, ns3::Ptr< ns3::Socket >, ns3::Address const &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<bool, ns3::Ptr<ns3::Socket>, const ns3::Address &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<bool, ns3::Ptr<ns3::Socket>, const ns3::Address &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): bool ns3::CallbackImpl<bool, ns3::Ptr<ns3::Socket>, const ns3::Address &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::Ptr<ns3::Socket> arg0, ns3::Address const & arg1) [member operator]
    cls.add_method('operator()',
                   'bool',
                   [param('ns3::Ptr< ns3::Socket >', 'arg0'), param('ns3::Address const &', 'arg1')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Ns3ObjectBase___star___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<ns3::ObjectBase *, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<ns3::ObjectBase *, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<ns3::ObjectBase *, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< ns3::ObjectBase *, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<ns3::ObjectBase *, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<ns3::ObjectBase *, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): ns3::ObjectBase * ns3::CallbackImpl<ns3::ObjectBase *, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()() [member operator]
    cls.add_method('operator()',
                   'ns3::ObjectBase *',
                   [],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Bool_Bool_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, bool, bool, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, bool, bool, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, bool, bool, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, bool, bool, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, bool, bool, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, bool, bool, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, bool, bool, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(bool arg0, bool arg1) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('bool', 'arg0'), param('bool', 'arg1')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Const_ns3SpectrumValue___amp___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, const ns3::SpectrumValue &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, const ns3::SpectrumValue &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, const ns3::SpectrumValue &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, ns3::SpectrumValue const &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, const ns3::SpectrumValue &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, const ns3::SpectrumValue &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, const ns3::SpectrumValue &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::SpectrumValue const & arg0) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('ns3::SpectrumValue const &', 'arg0')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Ns3DlSchedulingCallbackInfo_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::DlSchedulingCallbackInfo, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::DlSchedulingCallbackInfo, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, ns3::DlSchedulingCallbackInfo, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, ns3::DlSchedulingCallbackInfo, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, ns3::DlSchedulingCallbackInfo, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, ns3::DlSchedulingCallbackInfo, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::DlSchedulingCallbackInfo, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::DlSchedulingCallbackInfo arg0) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('ns3::DlSchedulingCallbackInfo', 'arg0')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Ns3EpcUeNasState_Ns3EpcUeNasState_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::EpcUeNas::State, ns3::EpcUeNas::State, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::EpcUeNas::State, ns3::EpcUeNas::State, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, ns3::EpcUeNas::State, ns3::EpcUeNas::State, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, ns3::EpcUeNas::State, ns3::EpcUeNas::State, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, ns3::EpcUeNas::State, ns3::EpcUeNas::State, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, ns3::EpcUeNas::State, ns3::EpcUeNas::State, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::EpcUeNas::State, ns3::EpcUeNas::State, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::EpcUeNas::State arg0, ns3::EpcUeNas::State arg1) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('ns3::EpcUeNas::State', 'arg0'), param('ns3::EpcUeNas::State', 'arg1')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Ns3PhyReceptionStatParameters_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::PhyReceptionStatParameters, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::PhyReceptionStatParameters, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, ns3::PhyReceptionStatParameters, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, ns3::PhyReceptionStatParameters, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, ns3::PhyReceptionStatParameters, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, ns3::PhyReceptionStatParameters, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::PhyReceptionStatParameters, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::PhyReceptionStatParameters arg0) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('ns3::PhyReceptionStatParameters', 'arg0')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Ns3PhyTransmissionStatParameters_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::PhyTransmissionStatParameters, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::PhyTransmissionStatParameters, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, ns3::PhyTransmissionStatParameters, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, ns3::PhyTransmissionStatParameters, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, ns3::PhyTransmissionStatParameters, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, ns3::PhyTransmissionStatParameters, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::PhyTransmissionStatParameters, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::PhyTransmissionStatParameters arg0) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('ns3::PhyTransmissionStatParameters', 'arg0')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__const_ns3MobilityModel__gt___Ns3Ptr__lt__const_ns3MobilityModel__gt___Double_Double_Double_Double_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<const ns3::MobilityModel>, ns3::Ptr<const ns3::MobilityModel>, double, double, double, double, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<const ns3::MobilityModel>, ns3::Ptr<const ns3::MobilityModel>, double, double, double, double, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, ns3::Ptr<const ns3::MobilityModel>, ns3::Ptr<const ns3::MobilityModel>, double, double, double, double, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, ns3::Ptr< ns3::MobilityModel const >, ns3::Ptr< ns3::MobilityModel const >, double, double, double, double, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, ns3::Ptr<const ns3::MobilityModel>, ns3::Ptr<const ns3::MobilityModel>, double, double, double, double, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, ns3::Ptr<const ns3::MobilityModel>, ns3::Ptr<const ns3::MobilityModel>, double, double, double, double, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::Ptr<const ns3::MobilityModel>, ns3::Ptr<const ns3::MobilityModel>, double, double, double, double, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::Ptr<const ns3::MobilityModel> arg0, ns3::Ptr<const ns3::MobilityModel> arg1, double arg2, double arg3, double arg4, double arg5) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('ns3::Ptr< ns3::MobilityModel const >', 'arg0'), param('ns3::Ptr< ns3::MobilityModel const >', 'arg1'), param('double', 'arg2'), param('double', 'arg3'), param('double', 'arg4'), param('double', 'arg5')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__const_ns3MobilityModel__gt___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<const ns3::MobilityModel>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<const ns3::MobilityModel>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, ns3::Ptr<const ns3::MobilityModel>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, ns3::Ptr< ns3::MobilityModel const >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, ns3::Ptr<const ns3::MobilityModel>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, ns3::Ptr<const ns3::MobilityModel>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::Ptr<const ns3::MobilityModel>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::Ptr<const ns3::MobilityModel> arg0) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('ns3::Ptr< ns3::MobilityModel const >', 'arg0')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__const_ns3Packet__gt___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<const ns3::Packet>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<const ns3::Packet>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, ns3::Ptr<const ns3::Packet>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, ns3::Ptr< ns3::Packet const >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, ns3::Ptr<const ns3::Packet>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, ns3::Ptr<const ns3::Packet>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::Ptr<const ns3::Packet>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::Ptr<const ns3::Packet> arg0) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('ns3::Ptr< ns3::Packet const >', 'arg0')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__const_ns3PacketBurst__gt___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<const ns3::PacketBurst>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<const ns3::PacketBurst>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, ns3::Ptr<const ns3::PacketBurst>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, ns3::Ptr< ns3::PacketBurst const >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, ns3::Ptr<const ns3::PacketBurst>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, ns3::Ptr<const ns3::PacketBurst>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::Ptr<const ns3::PacketBurst>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::Ptr<const ns3::PacketBurst> arg0) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('ns3::Ptr< ns3::PacketBurst const >', 'arg0')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__const_ns3QueueDiscItem__gt___Const_char___star___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<const ns3::QueueDiscItem>, const char *, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<const ns3::QueueDiscItem>, const char *, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, ns3::Ptr<const ns3::QueueDiscItem>, const char *, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, ns3::Ptr< ns3::QueueDiscItem const >, char const *, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, ns3::Ptr<const ns3::QueueDiscItem>, const char *, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, ns3::Ptr<const ns3::QueueDiscItem>, const char *, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::Ptr<const ns3::QueueDiscItem>, const char *, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::Ptr<const ns3::QueueDiscItem> arg0, char const * arg1) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('ns3::Ptr< ns3::QueueDiscItem const >', 'arg0'), param('char const *', 'arg1')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__const_ns3QueueDiscItem__gt___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<const ns3::QueueDiscItem>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<const ns3::QueueDiscItem>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, ns3::Ptr<const ns3::QueueDiscItem>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, ns3::Ptr< ns3::QueueDiscItem const >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, ns3::Ptr<const ns3::QueueDiscItem>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, ns3::Ptr<const ns3::QueueDiscItem>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::Ptr<const ns3::QueueDiscItem>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::Ptr<const ns3::QueueDiscItem> arg0) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('ns3::Ptr< ns3::QueueDiscItem const >', 'arg0')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__const_ns3SpectrumPhy__gt___Ns3Ptr__lt__const_ns3SpectrumPhy__gt___Double_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<const ns3::SpectrumPhy>, ns3::Ptr<const ns3::SpectrumPhy>, double, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<const ns3::SpectrumPhy>, ns3::Ptr<const ns3::SpectrumPhy>, double, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, ns3::Ptr<const ns3::SpectrumPhy>, ns3::Ptr<const ns3::SpectrumPhy>, double, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, ns3::Ptr< ns3::SpectrumPhy const >, ns3::Ptr< ns3::SpectrumPhy const >, double, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, ns3::Ptr<const ns3::SpectrumPhy>, ns3::Ptr<const ns3::SpectrumPhy>, double, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, ns3::Ptr<const ns3::SpectrumPhy>, ns3::Ptr<const ns3::SpectrumPhy>, double, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::Ptr<const ns3::SpectrumPhy>, ns3::Ptr<const ns3::SpectrumPhy>, double, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::Ptr<const ns3::SpectrumPhy> arg0, ns3::Ptr<const ns3::SpectrumPhy> arg1, double arg2) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('ns3::Ptr< ns3::SpectrumPhy const >', 'arg0'), param('ns3::Ptr< ns3::SpectrumPhy const >', 'arg1'), param('double', 'arg2')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__ns3LteUeRrc__gt___StdList__lt__ns3LteRrcSapSCellToAddMod__stdAllocator__lt__ns3LteRrcSapSCellToAddMod__gt_____gt___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<ns3::LteUeRrc>, std::list<ns3::LteRrcSap::SCellToAddMod, std::allocator<ns3::LteRrcSap::SCellToAddMod> >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<ns3::LteUeRrc>, std::list<ns3::LteRrcSap::SCellToAddMod, std::allocator<ns3::LteRrcSap::SCellToAddMod> >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, ns3::Ptr<ns3::LteUeRrc>, std::list<ns3::LteRrcSap::SCellToAddMod, std::allocator<ns3::LteRrcSap::SCellToAddMod> >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, ns3::Ptr< ns3::LteUeRrc >, std::list< ns3::LteRrcSap::SCellToAddMod >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, ns3::Ptr<ns3::LteUeRrc>, std::list<ns3::LteRrcSap::SCellToAddMod, std::allocator<ns3::LteRrcSap::SCellToAddMod> >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, ns3::Ptr<ns3::LteUeRrc>, std::list<ns3::LteRrcSap::SCellToAddMod, std::allocator<ns3::LteRrcSap::SCellToAddMod> >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::Ptr<ns3::LteUeRrc>, std::list<ns3::LteRrcSap::SCellToAddMod, std::allocator<ns3::LteRrcSap::SCellToAddMod> >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::Ptr<ns3::LteUeRrc> arg0, std::list<ns3::LteRrcSap::SCellToAddMod, std::allocator<ns3::LteRrcSap::SCellToAddMod> > arg1) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('ns3::Ptr< ns3::LteUeRrc >', 'arg0'), param('std::list< ns3::LteRrcSap::SCellToAddMod >', 'arg1')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    cls.add_copy_constructor()
    return

def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__ns3NetDevice__gt___Ns3Ptr__lt__const_ns3Packet__gt___Unsigned_short_Const_ns3Address___amp___Const_ns3Address___amp___Ns3NetDevicePacketType_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<ns3::NetDevice>, ns3::Ptr<const ns3::Packet>, unsigned short, const ns3::Address &, const ns3::Address &, ns3::NetDevice::PacketType, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<ns3::NetDevice>, ns3::Ptr<const ns3::Packet>, unsigned short, const ns3::Address &, const ns3::Address &, ns3::NetDevice::PacketType, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, ns3::Ptr<ns3::NetDevice>, ns3::Ptr<const ns3::Packet>, unsigned short, const ns3::Address &, const ns3::Address &, ns3::NetDevice::PacketType, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, ns3::Ptr< ns3::NetDevice >, ns3::Ptr< ns3::Packet const >, unsigned short, ns3::Address const &, ns3::Address const &, ns3::NetDevice::PacketType, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, ns3::Ptr<ns3::NetDevice>, ns3::Ptr<const ns3::Packet>, unsigned short, const ns3::Address &, const ns3::Address &, ns3::NetDevice::PacketType, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, ns3::Ptr<ns3::NetDevice>, ns3::Ptr<const ns3::Packet>, unsigned short, const ns3::Address &, const ns3::Address &, ns3::NetDevice::PacketType, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::Ptr<ns3::NetDevice>, ns3::Ptr<const ns3::Packet>, unsigned short, const ns3::Address &, const ns3::Address &, ns3::NetDevice::PacketType, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::Ptr<ns3::NetDevice> arg0, ns3::Ptr<const ns3::Packet> arg1, short unsigned int arg2, ns3::Address const & arg3, ns3::Address const & arg4, ns3::NetDevice::PacketType arg5) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('ns3::Ptr< ns3::NetDevice >', 'arg0'), param('ns3::Ptr< ns3::Packet const >', 'arg1'), param('short unsigned int', 'arg2'), param('ns3::Address const &', 'arg3'), param('ns3::Address const &', 'arg4'), param('ns3::NetDevice::PacketType', 'arg5')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__ns3NetDevice__gt___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<ns3::NetDevice>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<ns3::NetDevice>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, ns3::Ptr<ns3::NetDevice>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, ns3::Ptr< ns3::NetDevice >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, ns3::Ptr<ns3::NetDevice>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, ns3::Ptr<ns3::NetDevice>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::Ptr<ns3::NetDevice>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::Ptr<ns3::NetDevice> arg0) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('ns3::Ptr< ns3::NetDevice >', 'arg0')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__ns3Packet__gt___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<ns3::Packet>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<ns3::Packet>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, ns3::Ptr<ns3::Packet>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, ns3::Ptr< ns3::Packet >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, ns3::Ptr<ns3::Packet>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, ns3::Ptr<ns3::Packet>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::Ptr<ns3::Packet>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::Ptr<ns3::Packet> arg0) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'arg0')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__ns3Socket__gt___Const_ns3Address___amp___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<ns3::Socket>, const ns3::Address &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<ns3::Socket>, const ns3::Address &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, ns3::Ptr<ns3::Socket>, const ns3::Address &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, ns3::Ptr< ns3::Socket >, ns3::Address const &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, ns3::Ptr<ns3::Socket>, const ns3::Address &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, ns3::Ptr<ns3::Socket>, const ns3::Address &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::Ptr<ns3::Socket>, const ns3::Address &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::Ptr<ns3::Socket> arg0, ns3::Address const & arg1) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('ns3::Ptr< ns3::Socket >', 'arg0'), param('ns3::Address const &', 'arg1')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__ns3Socket__gt___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<ns3::Socket>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<ns3::Socket>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, ns3::Ptr<ns3::Socket>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, ns3::Ptr< ns3::Socket >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, ns3::Ptr<ns3::Socket>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, ns3::Ptr<ns3::Socket>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::Ptr<ns3::Socket>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::Ptr<ns3::Socket> arg0) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('ns3::Ptr< ns3::Socket >', 'arg0')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__ns3Socket__gt___Unsigned_int_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<ns3::Socket>, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<ns3::Socket>, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, ns3::Ptr<ns3::Socket>, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, ns3::Ptr< ns3::Socket >, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, ns3::Ptr<ns3::Socket>, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, ns3::Ptr<ns3::Socket>, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::Ptr<ns3::Socket>, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::Ptr<ns3::Socket> arg0, unsigned int arg1) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('ns3::Ptr< ns3::Socket >', 'arg0'), param('unsigned int', 'arg1')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__ns3SpectrumSignalParameters__gt___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<ns3::SpectrumSignalParameters>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<ns3::SpectrumSignalParameters>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, ns3::Ptr<ns3::SpectrumSignalParameters>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, ns3::Ptr< ns3::SpectrumSignalParameters >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, ns3::Ptr<ns3::SpectrumSignalParameters>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, ns3::Ptr<ns3::SpectrumSignalParameters>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::Ptr<ns3::SpectrumSignalParameters>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::Ptr<ns3::SpectrumSignalParameters> arg0) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('ns3::Ptr< ns3::SpectrumSignalParameters >', 'arg0')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Ns3Time_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Time, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Time, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, ns3::Time, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, ns3::Time, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, ns3::Time, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, ns3::Time, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::Time, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::Time arg0) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('ns3::Time', 'arg0')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()() [member operator]
    cls.add_method('operator()',
                   'void',
                   [],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Ns3MmwaveRxPacketTraceParams_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::mmwave::RxPacketTraceParams, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::mmwave::RxPacketTraceParams, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, ns3::mmwave::RxPacketTraceParams, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, ns3::mmwave::RxPacketTraceParams, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, ns3::mmwave::RxPacketTraceParams, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, ns3::mmwave::RxPacketTraceParams, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::mmwave::RxPacketTraceParams, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::mmwave::RxPacketTraceParams arg0) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('ns3::mmwave::RxPacketTraceParams', 'arg0')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Unsigned_int_Unsigned_int_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned int, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned int, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, unsigned int, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, unsigned int, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, unsigned int, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, unsigned int, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, unsigned int, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(unsigned int arg0, unsigned int arg1) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('unsigned int', 'arg0'), param('unsigned int', 'arg1')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Unsigned_int_Unsigned_int_Unsigned_short_Unsigned_char_Unsigned_short_Unsigned_char_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned int, unsigned int, unsigned short, unsigned char, unsigned short, unsigned char, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned int, unsigned int, unsigned short, unsigned char, unsigned short, unsigned char, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, unsigned int, unsigned int, unsigned short, unsigned char, unsigned short, unsigned char, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, unsigned int, unsigned int, unsigned short, unsigned char, unsigned short, unsigned char, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, unsigned int, unsigned int, unsigned short, unsigned char, unsigned short, unsigned char, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, unsigned int, unsigned int, unsigned short, unsigned char, unsigned short, unsigned char, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, unsigned int, unsigned int, unsigned short, unsigned char, unsigned short, unsigned char, ns3::empty, ns3::empty, ns3::empty>::operator()(unsigned int arg0, unsigned int arg1, short unsigned int arg2, unsigned char arg3, short unsigned int arg4, unsigned char arg5) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('unsigned int', 'arg0'), param('unsigned int', 'arg1'), param('short unsigned int', 'arg2'), param('unsigned char', 'arg3'), param('short unsigned int', 'arg4'), param('unsigned char', 'arg5')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Unsigned_long_Ns3SpectrumValue___amp___Ns3SpectrumValue___amp___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned long, ns3::SpectrumValue &, ns3::SpectrumValue &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned long, ns3::SpectrumValue &, ns3::SpectrumValue &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, unsigned long, ns3::SpectrumValue &, ns3::SpectrumValue &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, unsigned long, ns3::SpectrumValue &, ns3::SpectrumValue &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, unsigned long, ns3::SpectrumValue &, ns3::SpectrumValue &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, unsigned long, ns3::SpectrumValue &, ns3::SpectrumValue &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, unsigned long, ns3::SpectrumValue &, ns3::SpectrumValue &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(long unsigned int arg0, ns3::SpectrumValue & arg1, ns3::SpectrumValue & arg2) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('long unsigned int', 'arg0'), param('ns3::SpectrumValue &', 'arg1'), param('ns3::SpectrumValue &', 'arg2')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Unsigned_long_Unsigned_long_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned long, unsigned long, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned long, unsigned long, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, unsigned long, unsigned long, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, unsigned long, unsigned long, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, unsigned long, unsigned long, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, unsigned long, unsigned long, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, unsigned long, unsigned long, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(long unsigned int arg0, long unsigned int arg1) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('long unsigned int', 'arg0'), param('long unsigned int', 'arg1')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Unsigned_long_Unsigned_short_Long_double_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned long, unsigned short, long double, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned long, unsigned short, long double, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, unsigned long, unsigned short, long double, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, unsigned long, unsigned short, long double, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, unsigned long, unsigned short, long double, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, unsigned long, unsigned short, long double, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, unsigned long, unsigned short, long double, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(long unsigned int arg0, short unsigned int arg1, long double arg2) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('long unsigned int', 'arg0'), param('short unsigned int', 'arg1'), param('long double', 'arg2')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Unsigned_long_Unsigned_short_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned long, unsigned short, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned long, unsigned short, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, unsigned long, unsigned short, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, unsigned long, unsigned short, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, unsigned long, unsigned short, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, unsigned long, unsigned short, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, unsigned long, unsigned short, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(long unsigned int arg0, short unsigned int arg1) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('long unsigned int', 'arg0'), param('short unsigned int', 'arg1')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Unsigned_long_Unsigned_short_Unsigned_short_Ns3LteRrcSapMeasurementReport_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned long, unsigned short, unsigned short, ns3::LteRrcSap::MeasurementReport, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned long, unsigned short, unsigned short, ns3::LteRrcSap::MeasurementReport, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, unsigned long, unsigned short, unsigned short, ns3::LteRrcSap::MeasurementReport, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, unsigned long, unsigned short, unsigned short, ns3::LteRrcSap::MeasurementReport, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, unsigned long, unsigned short, unsigned short, ns3::LteRrcSap::MeasurementReport, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, unsigned long, unsigned short, unsigned short, ns3::LteRrcSap::MeasurementReport, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, unsigned long, unsigned short, unsigned short, ns3::LteRrcSap::MeasurementReport, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(long unsigned int arg0, short unsigned int arg1, short unsigned int arg2, ns3::LteRrcSap::MeasurementReport arg3) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('long unsigned int', 'arg0'), param('short unsigned int', 'arg1'), param('short unsigned int', 'arg2'), param('ns3::LteRrcSap::MeasurementReport', 'arg3')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Unsigned_long_Unsigned_short_Unsigned_short_Ns3LteUeRrcState_Ns3LteUeRrcState_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned long, unsigned short, unsigned short, ns3::LteUeRrc::State, ns3::LteUeRrc::State, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned long, unsigned short, unsigned short, ns3::LteUeRrc::State, ns3::LteUeRrc::State, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, unsigned long, unsigned short, unsigned short, ns3::LteUeRrc::State, ns3::LteUeRrc::State, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, unsigned long, unsigned short, unsigned short, ns3::LteUeRrc::State, ns3::LteUeRrc::State, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, unsigned long, unsigned short, unsigned short, ns3::LteUeRrc::State, ns3::LteUeRrc::State, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, unsigned long, unsigned short, unsigned short, ns3::LteUeRrc::State, ns3::LteUeRrc::State, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, unsigned long, unsigned short, unsigned short, ns3::LteUeRrc::State, ns3::LteUeRrc::State, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(long unsigned int arg0, short unsigned int arg1, short unsigned int arg2, ns3::LteUeRrc::State arg3, ns3::LteUeRrc::State arg4) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('long unsigned int', 'arg0'), param('short unsigned int', 'arg1'), param('short unsigned int', 'arg2'), param('ns3::LteUeRrc::State', 'arg3'), param('ns3::LteUeRrc::State', 'arg4')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Unsigned_long_Unsigned_short_Unsigned_short_Ns3UeManagerState_Ns3UeManagerState_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned long, unsigned short, unsigned short, ns3::UeManager::State, ns3::UeManager::State, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned long, unsigned short, unsigned short, ns3::UeManager::State, ns3::UeManager::State, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, unsigned long, unsigned short, unsigned short, ns3::UeManager::State, ns3::UeManager::State, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, unsigned long, unsigned short, unsigned short, ns3::UeManager::State, ns3::UeManager::State, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, unsigned long, unsigned short, unsigned short, ns3::UeManager::State, ns3::UeManager::State, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, unsigned long, unsigned short, unsigned short, ns3::UeManager::State, ns3::UeManager::State, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, unsigned long, unsigned short, unsigned short, ns3::UeManager::State, ns3::UeManager::State, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(long unsigned int arg0, short unsigned int arg1, short unsigned int arg2, ns3::UeManager::State arg3, ns3::UeManager::State arg4) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('long unsigned int', 'arg0'), param('short unsigned int', 'arg1'), param('short unsigned int', 'arg2'), param('ns3::UeManager::State', 'arg3'), param('ns3::UeManager::State', 'arg4')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Unsigned_long_Unsigned_short_Unsigned_short_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned long, unsigned short, unsigned short, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned long, unsigned short, unsigned short, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, unsigned long, unsigned short, unsigned short, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, unsigned long, unsigned short, unsigned short, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, unsigned long, unsigned short, unsigned short, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, unsigned long, unsigned short, unsigned short, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, unsigned long, unsigned short, unsigned short, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(long unsigned int arg0, short unsigned int arg1, short unsigned int arg2) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('long unsigned int', 'arg0'), param('short unsigned int', 'arg1'), param('short unsigned int', 'arg2')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Unsigned_long_Unsigned_short_Unsigned_short_Unsigned_short_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned long, unsigned short, unsigned short, unsigned short, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned long, unsigned short, unsigned short, unsigned short, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, unsigned long, unsigned short, unsigned short, unsigned short, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, unsigned long, unsigned short, unsigned short, unsigned short, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, unsigned long, unsigned short, unsigned short, unsigned short, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, unsigned long, unsigned short, unsigned short, unsigned short, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, unsigned long, unsigned short, unsigned short, unsigned short, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(long unsigned int arg0, short unsigned int arg1, short unsigned int arg2, short unsigned int arg3) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('long unsigned int', 'arg0'), param('short unsigned int', 'arg1'), param('short unsigned int', 'arg2'), param('short unsigned int', 'arg3')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Unsigned_short_Ns3Ptr__lt__ns3SpectrumValue__gt___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned short, ns3::Ptr<ns3::SpectrumValue>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned short, ns3::Ptr<ns3::SpectrumValue>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, unsigned short, ns3::Ptr<ns3::SpectrumValue>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, unsigned short, ns3::Ptr< ns3::SpectrumValue >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, unsigned short, ns3::Ptr<ns3::SpectrumValue>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, unsigned short, ns3::Ptr<ns3::SpectrumValue>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, unsigned short, ns3::Ptr<ns3::SpectrumValue>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(short unsigned int arg0, ns3::Ptr<ns3::SpectrumValue> arg1) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('short unsigned int', 'arg0'), param('ns3::Ptr< ns3::SpectrumValue >', 'arg1')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Unsigned_short_Unsigned_char_Unsigned_int_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned short, unsigned char, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned short, unsigned char, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, unsigned short, unsigned char, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, unsigned short, unsigned char, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, unsigned short, unsigned char, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, unsigned short, unsigned char, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, unsigned short, unsigned char, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(short unsigned int arg0, unsigned char arg1, unsigned int arg2) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('short unsigned int', 'arg0'), param('unsigned char', 'arg1'), param('unsigned int', 'arg2')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Unsigned_short_Unsigned_char_Unsigned_int_Unsigned_int_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned short, unsigned char, unsigned int, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned short, unsigned char, unsigned int, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, unsigned short, unsigned char, unsigned int, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, unsigned short, unsigned char, unsigned int, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, unsigned short, unsigned char, unsigned int, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, unsigned short, unsigned char, unsigned int, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, unsigned short, unsigned char, unsigned int, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(short unsigned int arg0, unsigned char arg1, unsigned int arg2, unsigned int arg3) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('short unsigned int', 'arg0'), param('unsigned char', 'arg1'), param('unsigned int', 'arg2'), param('unsigned int', 'arg3')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Unsigned_short_Unsigned_char_Unsigned_int_Unsigned_long_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned short, unsigned char, unsigned int, unsigned long, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned short, unsigned char, unsigned int, unsigned long, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, unsigned short, unsigned char, unsigned int, unsigned long, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, unsigned short, unsigned char, unsigned int, unsigned long, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, unsigned short, unsigned char, unsigned int, unsigned long, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, unsigned short, unsigned char, unsigned int, unsigned long, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, unsigned short, unsigned char, unsigned int, unsigned long, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(short unsigned int arg0, unsigned char arg1, unsigned int arg2, long unsigned int arg3) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('short unsigned int', 'arg0'), param('unsigned char', 'arg1'), param('unsigned int', 'arg2'), param('long unsigned int', 'arg3')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Unsigned_short_Unsigned_short_Double_Double_Bool_Unsigned_char_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned short, unsigned short, double, double, bool, unsigned char, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned short, unsigned short, double, double, bool, unsigned char, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, unsigned short, unsigned short, double, double, bool, unsigned char, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, unsigned short, unsigned short, double, double, bool, unsigned char, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, unsigned short, unsigned short, double, double, bool, unsigned char, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, unsigned short, unsigned short, double, double, bool, unsigned char, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, unsigned short, unsigned short, double, double, bool, unsigned char, ns3::empty, ns3::empty, ns3::empty>::operator()(short unsigned int arg0, short unsigned int arg1, double arg2, double arg3, bool arg4, unsigned char arg5) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('short unsigned int', 'arg0'), param('short unsigned int', 'arg1'), param('double', 'arg2'), param('double', 'arg3'), param('bool', 'arg4'), param('unsigned char', 'arg5')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Unsigned_short_Unsigned_short_Double_Double_Unsigned_char_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned short, unsigned short, double, double, unsigned char, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned short, unsigned short, double, double, unsigned char, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, unsigned short, unsigned short, double, double, unsigned char, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, unsigned short, unsigned short, double, double, unsigned char, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, unsigned short, unsigned short, double, double, unsigned char, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, unsigned short, unsigned short, double, double, unsigned char, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, unsigned short, unsigned short, double, double, unsigned char, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(short unsigned int arg0, short unsigned int arg1, double arg2, double arg3, unsigned char arg4) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('short unsigned int', 'arg0'), param('short unsigned int', 'arg1'), param('double', 'arg2'), param('double', 'arg3'), param('unsigned char', 'arg4')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Unsigned_short_Unsigned_short_Double_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned short, unsigned short, double, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned short, unsigned short, double, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, unsigned short, unsigned short, double, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, unsigned short, unsigned short, double, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, unsigned short, unsigned short, double, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, unsigned short, unsigned short, double, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, unsigned short, unsigned short, double, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(short unsigned int arg0, short unsigned int arg1, double arg2) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('short unsigned int', 'arg0'), param('short unsigned int', 'arg1'), param('double', 'arg2')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Unsigned_short_Unsigned_short_Double_Unsigned_char_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned short, unsigned short, double, unsigned char, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned short, unsigned short, double, unsigned char, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, unsigned short, unsigned short, double, unsigned char, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, unsigned short, unsigned short, double, unsigned char, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, unsigned short, unsigned short, double, unsigned char, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, unsigned short, unsigned short, double, unsigned char, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, unsigned short, unsigned short, double, unsigned char, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(short unsigned int arg0, short unsigned int arg1, double arg2, unsigned char arg3) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('short unsigned int', 'arg0'), param('short unsigned int', 'arg1'), param('double', 'arg2'), param('unsigned char', 'arg3')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Unsigned_short_Unsigned_short_Ns3LteUePhyState_Ns3LteUePhyState_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned short, unsigned short, ns3::LteUePhy::State, ns3::LteUePhy::State, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned short, unsigned short, ns3::LteUePhy::State, ns3::LteUePhy::State, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, unsigned short, unsigned short, ns3::LteUePhy::State, ns3::LteUePhy::State, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, unsigned short, unsigned short, ns3::LteUePhy::State, ns3::LteUePhy::State, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, unsigned short, unsigned short, ns3::LteUePhy::State, ns3::LteUePhy::State, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, unsigned short, unsigned short, ns3::LteUePhy::State, ns3::LteUePhy::State, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, unsigned short, unsigned short, ns3::LteUePhy::State, ns3::LteUePhy::State, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(short unsigned int arg0, short unsigned int arg1, ns3::LteUePhy::State arg2, ns3::LteUePhy::State arg3) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('short unsigned int', 'arg0'), param('short unsigned int', 'arg1'), param('ns3::LteUePhy::State', 'arg2'), param('ns3::LteUePhy::State', 'arg3')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Unsigned_short_Unsigned_short_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned short, unsigned short, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned short, unsigned short, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, unsigned short, unsigned short, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, unsigned short, unsigned short, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, unsigned short, unsigned short, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, unsigned short, unsigned short, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, unsigned short, unsigned short, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(short unsigned int arg0, short unsigned int arg1) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('short unsigned int', 'arg0'), param('short unsigned int', 'arg1')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3CallbackImpl__Void_Unsigned_short_Unsigned_short_Unsigned_int_Unsigned_char_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned short, unsigned short, unsigned int, unsigned char, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
    cls.add_constructor([])
    ## callback.h (module 'core'): ns3::CallbackImpl<void, unsigned short, unsigned short, unsigned int, unsigned char, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, unsigned short, unsigned short, unsigned int, unsigned char, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
    cls.add_constructor([param('ns3::CallbackImpl< void, unsigned short, unsigned short, unsigned int, unsigned char, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, unsigned short, unsigned short, unsigned int, unsigned char, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
    cls.add_method('DoGetTypeid',
                   'std::string',
                   [],
                   is_static=True)
    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, unsigned short, unsigned short, unsigned int, unsigned char, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
    cls.add_method('GetTypeid',
                   'std::string',
                   [],
                   is_const=True, is_virtual=True)
    ## callback.h (module 'core'): void ns3::CallbackImpl<void, unsigned short, unsigned short, unsigned int, unsigned char, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(short unsigned int arg0, short unsigned int arg1, unsigned int arg2, unsigned char arg3) [member operator]
    cls.add_method('operator()',
                   'void',
                   [param('short unsigned int', 'arg0'), param('short unsigned int', 'arg1'), param('unsigned int', 'arg2'), param('unsigned char', 'arg3')],
                   is_pure_virtual=True, is_virtual=True, custom_name=u'__call__')
    return

def register_Ns3DlCqiLteControlMessage_methods(root_module, cls):
    ## lte-control-messages.h (module 'lte'): ns3::DlCqiLteControlMessage::DlCqiLteControlMessage(ns3::DlCqiLteControlMessage const & arg0) [constructor]
    cls.add_constructor([param('ns3::DlCqiLteControlMessage const &', 'arg0')])
    ## lte-control-messages.h (module 'lte'): ns3::DlCqiLteControlMessage::DlCqiLteControlMessage() [constructor]
    cls.add_constructor([])
    ## lte-control-messages.h (module 'lte'): ns3::CqiListElement_s ns3::DlCqiLteControlMessage::GetDlCqi() [member function]
    cls.add_method('GetDlCqi',
                   'ns3::CqiListElement_s',
                   [])
    ## lte-control-messages.h (module 'lte'): void ns3::DlCqiLteControlMessage::SetDlCqi(ns3::CqiListElement_s dlcqi) [member function]
    cls.add_method('SetDlCqi',
                   'void',
                   [param('ns3::CqiListElement_s', 'dlcqi')])
    return

def register_Ns3DlDciLteControlMessage_methods(root_module, cls):
    ## lte-control-messages.h (module 'lte'): ns3::DlDciLteControlMessage::DlDciLteControlMessage(ns3::DlDciLteControlMessage const & arg0) [constructor]
    cls.add_constructor([param('ns3::DlDciLteControlMessage const &', 'arg0')])
    ## lte-control-messages.h (module 'lte'): ns3::DlDciLteControlMessage::DlDciLteControlMessage() [constructor]
    cls.add_constructor([])
    ## lte-control-messages.h (module 'lte'): ns3::DlDciListElement_s ns3::DlDciLteControlMessage::GetDci() [member function]
    cls.add_method('GetDci',
                   'ns3::DlDciListElement_s',
                   [])
    ## lte-control-messages.h (module 'lte'): void ns3::DlDciLteControlMessage::SetDci(ns3::DlDciListElement_s dci) [member function]
    cls.add_method('SetDci',
                   'void',
                   [param('ns3::DlDciListElement_s', 'dci')])
    return

def register_Ns3DlHarqFeedbackLteControlMessage_methods(root_module, cls):
    ## lte-control-messages.h (module 'lte'): ns3::DlHarqFeedbackLteControlMessage::DlHarqFeedbackLteControlMessage(ns3::DlHarqFeedbackLteControlMessage const & arg0) [constructor]
    cls.add_constructor([param('ns3::DlHarqFeedbackLteControlMessage const &', 'arg0')])
    ## lte-control-messages.h (module 'lte'): ns3::DlHarqFeedbackLteControlMessage::DlHarqFeedbackLteControlMessage() [constructor]
    cls.add_constructor([])
    ## lte-control-messages.h (module 'lte'): ns3::DlInfoListElement_s ns3::DlHarqFeedbackLteControlMessage::GetDlHarqFeedback() [member function]
    cls.add_method('GetDlHarqFeedback',
                   'ns3::DlInfoListElement_s',
                   [])
    ## lte-control-messages.h (module 'lte'): void ns3::DlHarqFeedbackLteControlMessage::SetDlHarqFeedback(ns3::DlInfoListElement_s m) [member function]
    cls.add_method('SetDlHarqFeedback',
                   'void',
                   [param('ns3::DlInfoListElement_s', 'm')])
    return

def register_Ns3HandoverPreparationInfoHeader_methods(root_module, cls):
    ## lte-rrc-header.h (module 'lte'): ns3::HandoverPreparationInfoHeader::HandoverPreparationInfoHeader(ns3::HandoverPreparationInfoHeader const & arg0) [constructor]
    cls.add_constructor([param('ns3::HandoverPreparationInfoHeader const &', 'arg0')])
    ## lte-rrc-header.h (module 'lte'): ns3::HandoverPreparationInfoHeader::HandoverPreparationInfoHeader() [constructor]
    cls.add_constructor([])
    ## lte-rrc-header.h (module 'lte'): uint32_t ns3::HandoverPreparationInfoHeader::Deserialize(ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('Deserialize',
                   'uint32_t',
                   [param('ns3::Buffer::Iterator', 'bIterator')],
                   is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): ns3::LteRrcSap::AsConfig ns3::HandoverPreparationInfoHeader::GetAsConfig() const [member function]
    cls.add_method('GetAsConfig',
                   'ns3::LteRrcSap::AsConfig',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): ns3::LteRrcSap::HandoverPreparationInfo ns3::HandoverPreparationInfoHeader::GetMessage() const [member function]
    cls.add_method('GetMessage',
                   'ns3::LteRrcSap::HandoverPreparationInfo',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::HandoverPreparationInfoHeader::PreSerialize() const [member function]
    cls.add_method('PreSerialize',
                   'void',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::HandoverPreparationInfoHeader::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True, is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::HandoverPreparationInfoHeader::SetMessage(ns3::LteRrcSap::HandoverPreparationInfo msg) [member function]
    cls.add_method('SetMessage',
                   'void',
                   [param('ns3::LteRrcSap::HandoverPreparationInfo', 'msg')])
    return

def register_Ns3LteDataRadioBearerInfo_methods(root_module, cls):
    ## lte-radio-bearer-info.h (module 'lte'): ns3::LteDataRadioBearerInfo::LteDataRadioBearerInfo() [constructor]
    cls.add_constructor([])
    ## lte-radio-bearer-info.h (module 'lte'): ns3::LteDataRadioBearerInfo::LteDataRadioBearerInfo(ns3::LteDataRadioBearerInfo const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteDataRadioBearerInfo const &', 'arg0')])
    ## lte-radio-bearer-info.h (module 'lte'): static ns3::TypeId ns3::LteDataRadioBearerInfo::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## lte-radio-bearer-info.h (module 'lte'): ns3::LteDataRadioBearerInfo::m_drbIdentity [variable]
    cls.add_instance_attribute('m_drbIdentity', 'uint8_t', is_const=False)
    ## lte-radio-bearer-info.h (module 'lte'): ns3::LteDataRadioBearerInfo::m_epsBearer [variable]
    cls.add_instance_attribute('m_epsBearer', 'ns3::EpsBearer', is_const=False)
    ## lte-radio-bearer-info.h (module 'lte'): ns3::LteDataRadioBearerInfo::m_epsBearerIdentity [variable]
    cls.add_instance_attribute('m_epsBearerIdentity', 'uint8_t', is_const=False)
    ## lte-radio-bearer-info.h (module 'lte'): ns3::LteDataRadioBearerInfo::m_gtpTeid [variable]
    cls.add_instance_attribute('m_gtpTeid', 'uint32_t', is_const=False)
    ## lte-radio-bearer-info.h (module 'lte'): ns3::LteDataRadioBearerInfo::m_isMc [variable]
    cls.add_instance_attribute('m_isMc', 'bool', is_const=False)
    ## lte-radio-bearer-info.h (module 'lte'): ns3::LteDataRadioBearerInfo::m_logicalChannelConfig [variable]
    cls.add_instance_attribute('m_logicalChannelConfig', 'ns3::LteRrcSap::LogicalChannelConfig', is_const=False)
    ## lte-radio-bearer-info.h (module 'lte'): ns3::LteDataRadioBearerInfo::m_logicalChannelIdentity [variable]
    cls.add_instance_attribute('m_logicalChannelIdentity', 'uint8_t', is_const=False)
    ## lte-radio-bearer-info.h (module 'lte'): ns3::LteDataRadioBearerInfo::m_rlcConfig [variable]
    cls.add_instance_attribute('m_rlcConfig', 'ns3::LteRrcSap::RlcConfig', is_const=False)
    ## lte-radio-bearer-info.h (module 'lte'): ns3::LteDataRadioBearerInfo::m_rlcSetupRequest [variable]
    cls.add_instance_attribute('m_rlcSetupRequest', 'ns3::EpcX2Sap::RlcSetupRequest', is_const=False)
    ## lte-radio-bearer-info.h (module 'lte'): ns3::LteDataRadioBearerInfo::m_transportLayerAddress [variable]
    cls.add_instance_attribute('m_transportLayerAddress', 'ns3::Ipv4Address', is_const=False)
    return

def register_Ns3LteEnbPhy_methods(root_module, cls):
    ## lte-enb-phy.h (module 'lte'): ns3::LteEnbPhy::LteEnbPhy(ns3::LteEnbPhy const & arg0) [constructor]
    cls.add_constructor([param('ns3::LteEnbPhy const &', 'arg0')])
    ## lte-enb-phy.h (module 'lte'): ns3::LteEnbPhy::LteEnbPhy() [constructor]
    cls.add_constructor([])
    ## lte-enb-phy.h (module 'lte'): ns3::LteEnbPhy::LteEnbPhy(ns3::Ptr<ns3::LteSpectrumPhy> dlPhy, ns3::Ptr<ns3::LteSpectrumPhy> ulPhy) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::LteSpectrumPhy >', 'dlPhy'), param('ns3::Ptr< ns3::LteSpectrumPhy >', 'ulPhy')])
    ## lte-enb-phy.h (module 'lte'): void ns3::LteEnbPhy::CalcChannelQualityForUe(std::vector<double, std::allocator<double> > sinr, ns3::Ptr<ns3::LteSpectrumPhy> ue) [member function]
    cls.add_method('CalcChannelQualityForUe',
                   'void',
                   [param('std::vector< double >', 'sinr'), param('ns3::Ptr< ns3::LteSpectrumPhy >', 'ue')])
    ## lte-enb-phy.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedUlCqiInfoReqParameters ns3::LteEnbPhy::CreatePuschCqiReport(ns3::SpectrumValue const & sinr) [member function]
    cls.add_method('CreatePuschCqiReport',
                   'ns3::FfMacSchedSapProvider::SchedUlCqiInfoReqParameters',
                   [param('ns3::SpectrumValue const &', 'sinr')])
    ## lte-enb-phy.h (module 'lte'): ns3::FfMacSchedSapProvider::SchedUlCqiInfoReqParameters ns3::LteEnbPhy::CreateSrsCqiReport(ns3::SpectrumValue const & sinr) [member function]
    cls.add_method('CreateSrsCqiReport',
                   'ns3::FfMacSchedSapProvider::SchedUlCqiInfoReqParameters',
                   [param('ns3::SpectrumValue const &', 'sinr')])
    ## lte-enb-phy.h (module 'lte'): ns3::Ptr<ns3::SpectrumValue> ns3::LteEnbPhy::CreateTxPowerSpectralDensity() [member function]
    cls.add_method('CreateTxPowerSpectralDensity',
                   'ns3::Ptr< ns3::SpectrumValue >',
                   [],
                   is_virtual=True)
    ## lte-enb-phy.h (module 'lte'): ns3::Ptr<ns3::SpectrumValue> ns3::LteEnbPhy::CreateTxPowerSpectralDensityWithPowerAllocation() [member function]
    cls.add_method('CreateTxPowerSpectralDensityWithPowerAllocation',
                   'ns3::Ptr< ns3::SpectrumValue >',
                   [],
                   is_virtual=True)
    ## lte-enb-phy.h (module 'lte'): std::list<ns3::UlDciLteControlMessage, std::allocator<ns3::UlDciLteControlMessage> > ns3::LteEnbPhy::DequeueUlDci() [member function]
    cls.add_method('DequeueUlDci',
                   'std::list< ns3::UlDciLteControlMessage >',
                   [])
    ## lte-enb-phy.h (module 'lte'): void ns3::LteEnbPhy::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## lte-enb-phy.h (module 'lte'): int8_t ns3::LteEnbPhy::DoGetReferenceSignalPower() const [member function]
    cls.add_method('DoGetReferenceSignalPower',
                   'int8_t',
                   [],
                   is_const=True)
    ## lte-enb-phy.h (module 'lte'): void ns3::LteEnbPhy::DoInitialize() [member function]
    cls.add_method('DoInitialize',
                   'void',
                   [],
                   is_virtual=True)
    ## lte-enb-phy.h (module 'lte'): void ns3::LteEnbPhy::EndFrame() [member function]
    cls.add_method('EndFrame',
                   'void',
                   [])
    ## lte-enb-phy.h (module 'lte'): void ns3::LteEnbPhy::EndSubFrame() [member function]
    cls.add_method('EndSubFrame',
                   'void',
                   [])
    ## lte-enb-phy.h (module 'lte'): void ns3::LteEnbPhy::GenerateCtrlCqiReport(ns3::SpectrumValue const & sinr) [member function]
    cls.add_method('GenerateCtrlCqiReport',
                   'void',
                   [param('ns3::SpectrumValue const &', 'sinr')],
                   is_virtual=True)
    ## lte-enb-phy.h (module 'lte'): void ns3::LteEnbPhy::GenerateDataCqiReport(ns3::SpectrumValue const & sinr) [member function]
    cls.add_method('GenerateDataCqiReport',
                   'void',
                   [param('ns3::SpectrumValue const &', 'sinr')],
                   is_virtual=True)
    ## lte-enb-phy.h (module 'lte'): void ns3::LteEnbPhy::GeneratePowerAllocationMap(uint16_t rnti, int rbId) [member function]
    cls.add_method('GeneratePowerAllocationMap',
                   'void',
                   [param('uint16_t', 'rnti'), param('int', 'rbId')])
    ## lte-enb-phy.h (module 'lte'): ns3::Ptr<ns3::LteSpectrumPhy> ns3::LteEnbPhy::GetDlSpectrumPhy() const [member function]
    cls.add_method('GetDlSpectrumPhy',
                   'ns3::Ptr< ns3::LteSpectrumPhy >',
                   [],
                   is_const=True)
    ## lte-enb-phy.h (module 'lte'): std::vector<int, std::allocator<int> > ns3::LteEnbPhy::GetDownlinkSubChannels() [member function]
    cls.add_method('GetDownlinkSubChannels',
                   'std::vector< int >',
                   [])
    ## lte-enb-phy.h (module 'lte'): ns3::LteEnbCphySapProvider * ns3::LteEnbPhy::GetLteEnbCphySapProvider() [member function]
    cls.add_method('GetLteEnbCphySapProvider',
                   'ns3::LteEnbCphySapProvider *',
                   [])
    ## lte-enb-phy.h (module 'lte'): ns3::LteEnbPhySapProvider * ns3::LteEnbPhy::GetLteEnbPhySapProvider() [member function]
    cls.add_method('GetLteEnbPhySapProvider',
                   'ns3::LteEnbPhySapProvider *',
                   [])
    ## lte-enb-phy.h (module 'lte'): uint8_t ns3::LteEnbPhy::GetMacChDelay() const [member function]
    cls.add_method('GetMacChDelay',
                   'uint8_t',
                   [],
                   is_const=True)
    ## lte-enb-phy.h (module 'lte'): double ns3::LteEnbPhy::GetNoiseFigure() const [member function]
    cls.add_method('GetNoiseFigure',
                   'double',
                   [],
                   is_const=True)
    ## lte-enb-phy.h (module 'lte'): double ns3::LteEnbPhy::GetTxPower() const [member function]
    cls.add_method('GetTxPower',
                   'double',
                   [],
                   is_const=True)
    ## lte-enb-phy.h (module 'lte'): static ns3::TypeId ns3::LteEnbPhy::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## lte-enb-phy.h (module 'lte'): ns3::Ptr<ns3::LteSpectrumPhy> ns3::LteEnbPhy::GetUlSpectrumPhy() const [member function]
    cls.add_method('GetUlSpectrumPhy',
                   'ns3::Ptr< ns3::LteSpectrumPhy >',
                   [],
                   is_const=True)
    ## lte-enb-phy.h (module 'lte'): void ns3::LteEnbPhy::PhyPduReceived(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('PhyPduReceived',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'p')])
    ## lte-enb-phy.h (module 'lte'): void ns3::LteEnbPhy::QueueUlDci(ns3::UlDciLteControlMessage m) [member function]
    cls.add_method('QueueUlDci',
                   'void',
                   [param('ns3::UlDciLteControlMessage', 'm')])
    ## lte-enb-phy.h (module 'lte'): void ns3::LteEnbPhy::ReceiveLteControlMessage(ns3::Ptr<ns3::LteControlMessage> msg) [member function]
    cls.add_method('ReceiveLteControlMessage',
                   'void',
                   [param('ns3::Ptr< ns3::LteControlMessage >', 'msg')],
                   is_virtual=True)
    ## lte-enb-phy.h (module 'lte'): void ns3::LteEnbPhy::ReceiveLteControlMessageList(std::list<ns3::Ptr<ns3::LteControlMessage>, std::allocator<ns3::Ptr<ns3::LteControlMessage> > > arg0) [member function]
    cls.add_method('ReceiveLteControlMessageList',
                   'void',
                   [param('std::list< ns3::Ptr< ns3::LteControlMessage > >', 'arg0')],
                   is_virtual=True)
    ## lte-enb-phy.h (module 'lte'): void ns3::LteEnbPhy::ReceiveLteUlHarqFeedback(ns3::UlInfoListElement_s mes) [member function]
    cls.add_method('ReceiveLteUlHarqFeedback',
                   'void',
                   [param('ns3::UlInfoListElement_s', 'mes')],
                   is_virtual=True)
    ## lte-enb-phy.h (module 'lte'): void ns3::LteEnbPhy::ReportInterference(ns3::SpectrumValue const & interf) [member function]
    cls.add_method('ReportInterference',
                   'void',
                   [param('ns3::SpectrumValue const &', 'interf')],
                   is_virtual=True)
    ## lte-enb-phy.h (module 'lte'): void ns3::LteEnbPhy::ReportRsReceivedPower(ns3::SpectrumValue const & power) [member function]
    cls.add_method('ReportRsReceivedPower',
                   'void',
                   [param('ns3::SpectrumValue const &', 'power')],
                   is_virtual=True)
    ## lte-enb-phy.h (module 'lte'): void ns3::LteEnbPhy::SendControlChannels(std::list<ns3::Ptr<ns3::LteControlMessage>, std::allocator<ns3::Ptr<ns3::LteControlMessage> > > ctrlMsgList) [member function]
    cls.add_method('SendControlChannels',
                   'void',
                   [param('std::list< ns3::Ptr< ns3::LteControlMessage > >', 'ctrlMsgList')])
    ## lte-enb-phy.h (module 'lte'): void ns3::LteEnbPhy::SendDataChannels(ns3::Ptr<ns3::PacketBurst> pb) [member function]
    cls.add_method('SendDataChannels',
                   'void',
                   [param('ns3::Ptr< ns3::PacketBurst >', 'pb')])
    ## lte-enb-phy.h (module 'lte'): void ns3::LteEnbPhy::SetDownlinkSubChannels(std::vector<int, std::allocator<int> > mask) [member function]
    cls.add_method('SetDownlinkSubChannels',
                   'void',
                   [param('std::vector< int >', 'mask')])
    ## lte-enb-phy.h (module 'lte'): void ns3::LteEnbPhy::SetDownlinkSubChannelsWithPowerAllocation(std::vector<int, std::allocator<int> > mask) [member function]
    cls.add_method('SetDownlinkSubChannelsWithPowerAllocation',
                   'void',
                   [param('std::vector< int >', 'mask')])
    ## lte-enb-phy.h (module 'lte'): void ns3::LteEnbPhy::SetHarqPhyModule(ns3::Ptr<ns3::LteHarqPhy> harq) [member function]
    cls.add_method('SetHarqPhyModule',
                   'void',
                   [param('ns3::Ptr< ns3::LteHarqPhy >', 'harq')])
    ## lte-enb-phy.h (module 'lte'): void ns3::LteEnbPhy::SetLteEnbCphySapUser(ns3::LteEnbCphySapUser * s) [member function]
    cls.add_method('SetLteEnbCphySapUser',
                   'void',
                   [param('ns3::LteEnbCphySapUser *', 's')])
    ## lte-enb-phy.h (module 'lte'): void ns3::LteEnbPhy::SetLteEnbPhySapUser(ns3::LteEnbPhySapUser * s) [member function]
    cls.add_method('SetLteEnbPhySapUser',
                   'void',
                   [param('ns3::LteEnbPhySapUser *', 's')])
    ## lte-enb-phy.h (module 'lte'): void ns3::LteEnbPhy::SetMacChDelay(uint8_t delay) [member function]
    cls.add_method('SetMacChDelay',
                   'void',
                   [param('uint8_t', 'delay')])
    ## lte-enb-phy.h (module 'lte'): void ns3::LteEnbPhy::SetNoiseFigure(double pow) [member function]
    cls.add_method('SetNoiseFigure',
                   'void',
                   [param('double', 'pow')])
    ## lte-enb-phy.h (module 'lte'): void ns3::LteEnbPhy::SetTxPower(double pow) [member function]
    cls.add_method('SetTxPower',
                   'void',
                   [param('double', 'pow')])
    ## lte-enb-phy.h (module 'lte'): void ns3::LteEnbPhy::StartFrame() [member function]
    cls.add_method('StartFrame',
                   'void',
                   [])
    ## lte-enb-phy.h (module 'lte'): void ns3::LteEnbPhy::StartSubFrame() [member function]
    cls.add_method('StartSubFrame',
                   'void',
                   [])
    ## lte-enb-phy.h (module 'lte'): void ns3::LteEnbPhy::DoSendMacPdu(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('DoSendMacPdu',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'p')],
                   visibility='private', is_virtual=True)
    return

def register_Ns3LteNetDevice_methods(root_module, cls):
    ## lte-net-device.h (module 'lte'): static ns3::TypeId ns3::LteNetDevice::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## lte-net-device.h (module 'lte'): ns3::LteNetDevice::LteNetDevice() [constructor]
    cls.add_constructor([])
    ## lte-net-device.h (module 'lte'): void ns3::LteNetDevice::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## lte-net-device.h (module 'lte'): void ns3::LteNetDevice::SetIfIndex(uint32_t const index) [member function]
    cls.add_method('SetIfIndex',
                   'void',
                   [param('uint32_t const', 'index')],
                   is_virtual=True)
    ## lte-net-device.h (module 'lte'): uint32_t ns3::LteNetDevice::GetIfIndex() const [member function]
    cls.add_method('GetIfIndex',
                   'uint32_t',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-net-device.h (module 'lte'): ns3::Ptr<ns3::Channel> ns3::LteNetDevice::GetChannel() const [member function]
    cls.add_method('GetChannel',
                   'ns3::Ptr< ns3::Channel >',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-net-device.h (module 'lte'): bool ns3::LteNetDevice::SetMtu(uint16_t const mtu) [member function]
    cls.add_method('SetMtu',
                   'bool',
                   [param('uint16_t const', 'mtu')],
                   is_virtual=True)
    ## lte-net-device.h (module 'lte'): uint16_t ns3::LteNetDevice::GetMtu() const [member function]
    cls.add_method('GetMtu',
                   'uint16_t',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-net-device.h (module 'lte'): void ns3::LteNetDevice::SetAddress(ns3::Address address) [member function]
    cls.add_method('SetAddress',
                   'void',
                   [param('ns3::Address', 'address')],
                   is_virtual=True)
    ## lte-net-device.h (module 'lte'): ns3::Address ns3::LteNetDevice::GetAddress() const [member function]
    cls.add_method('GetAddress',
                   'ns3::Address',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-net-device.h (module 'lte'): bool ns3::LteNetDevice::IsLinkUp() const [member function]
    cls.add_method('IsLinkUp',
                   'bool',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-net-device.h (module 'lte'): void ns3::LteNetDevice::AddLinkChangeCallback(ns3::Callback<void, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> callback) [member function]
    cls.add_method('AddLinkChangeCallback',
                   'void',
                   [param('ns3::Callback< void, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'callback')],
                   is_virtual=True)
    ## lte-net-device.h (module 'lte'): bool ns3::LteNetDevice::IsBroadcast() const [member function]
    cls.add_method('IsBroadcast',
                   'bool',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-net-device.h (module 'lte'): ns3::Address ns3::LteNetDevice::GetBroadcast() const [member function]
    cls.add_method('GetBroadcast',
                   'ns3::Address',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-net-device.h (module 'lte'): bool ns3::LteNetDevice::IsMulticast() const [member function]
    cls.add_method('IsMulticast',
                   'bool',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-net-device.h (module 'lte'): bool ns3::LteNetDevice::IsPointToPoint() const [member function]
    cls.add_method('IsPointToPoint',
                   'bool',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-net-device.h (module 'lte'): bool ns3::LteNetDevice::IsBridge() const [member function]
    cls.add_method('IsBridge',
                   'bool',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-net-device.h (module 'lte'): ns3::Ptr<ns3::Node> ns3::LteNetDevice::GetNode() const [member function]
    cls.add_method('GetNode',
                   'ns3::Ptr< ns3::Node >',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-net-device.h (module 'lte'): void ns3::LteNetDevice::SetNode(ns3::Ptr<ns3::Node> node) [member function]
    cls.add_method('SetNode',
                   'void',
                   [param('ns3::Ptr< ns3::Node >', 'node')],
                   is_virtual=True)
    ## lte-net-device.h (module 'lte'): bool ns3::LteNetDevice::NeedsArp() const [member function]
    cls.add_method('NeedsArp',
                   'bool',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-net-device.h (module 'lte'): void ns3::LteNetDevice::SetReceiveCallback(ns3::NetDevice::ReceiveCallback cb) [member function]
    cls.add_method('SetReceiveCallback',
                   'void',
                   [param('ns3::Callback< bool, ns3::Ptr< ns3::NetDevice >, ns3::Ptr< ns3::Packet const >, unsigned short, ns3::Address const &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'cb')],
                   is_virtual=True)
    ## lte-net-device.h (module 'lte'): ns3::Address ns3::LteNetDevice::GetMulticast(ns3::Ipv4Address addr) const [member function]
    cls.add_method('GetMulticast',
                   'ns3::Address',
                   [param('ns3::Ipv4Address', 'addr')],
                   is_const=True, is_virtual=True)
    ## lte-net-device.h (module 'lte'): ns3::Address ns3::LteNetDevice::GetMulticast(ns3::Ipv6Address addr) const [member function]
    cls.add_method('GetMulticast',
                   'ns3::Address',
                   [param('ns3::Ipv6Address', 'addr')],
                   is_const=True, is_virtual=True)
    ## lte-net-device.h (module 'lte'): void ns3::LteNetDevice::SetPromiscReceiveCallback(ns3::NetDevice::PromiscReceiveCallback cb) [member function]
    cls.add_method('SetPromiscReceiveCallback',
                   'void',
                   [param('ns3::Callback< bool, ns3::Ptr< ns3::NetDevice >, ns3::Ptr< ns3::Packet const >, unsigned short, ns3::Address const &, ns3::Address const &, ns3::NetDevice::PacketType, ns3::empty, ns3::empty, ns3::empty >', 'cb')],
                   is_virtual=True)
    ## lte-net-device.h (module 'lte'): bool ns3::LteNetDevice::SendFrom(ns3::Ptr<ns3::Packet> packet, ns3::Address const & source, ns3::Address const & dest, uint16_t protocolNumber) [member function]
    cls.add_method('SendFrom',
                   'bool',
                   [param('ns3::Ptr< ns3::Packet >', 'packet'), param('ns3::Address const &', 'source'), param('ns3::Address const &', 'dest'), param('uint16_t', 'protocolNumber')],
                   is_virtual=True)
    ## lte-net-device.h (module 'lte'): bool ns3::LteNetDevice::SupportsSendFrom() const [member function]
    cls.add_method('SupportsSendFrom',
                   'bool',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-net-device.h (module 'lte'): void ns3::LteNetDevice::Receive(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('Receive',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'p')])
    return

def register_Ns3MeasurementReportHeader_methods(root_module, cls):
    ## lte-rrc-header.h (module 'lte'): ns3::MeasurementReportHeader::MeasurementReportHeader(ns3::MeasurementReportHeader const & arg0) [constructor]
    cls.add_constructor([param('ns3::MeasurementReportHeader const &', 'arg0')])
    ## lte-rrc-header.h (module 'lte'): ns3::MeasurementReportHeader::MeasurementReportHeader() [constructor]
    cls.add_constructor([])
    ## lte-rrc-header.h (module 'lte'): uint32_t ns3::MeasurementReportHeader::Deserialize(ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('Deserialize',
                   'uint32_t',
                   [param('ns3::Buffer::Iterator', 'bIterator')],
                   is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): ns3::LteRrcSap::MeasurementReport ns3::MeasurementReportHeader::GetMessage() const [member function]
    cls.add_method('GetMessage',
                   'ns3::LteRrcSap::MeasurementReport',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::MeasurementReportHeader::PreSerialize() const [member function]
    cls.add_method('PreSerialize',
                   'void',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::MeasurementReportHeader::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True, is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::MeasurementReportHeader::SetMessage(ns3::LteRrcSap::MeasurementReport msg) [member function]
    cls.add_method('SetMessage',
                   'void',
                   [param('ns3::LteRrcSap::MeasurementReport', 'msg')])
    return

def register_Ns3QueueDiscItem_methods(root_module, cls):
    ## queue-item.h (module 'network'): ns3::QueueDiscItem::QueueDiscItem(ns3::Ptr<ns3::Packet> p, ns3::Address const & addr, uint16_t protocol) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::Packet >', 'p'), param('ns3::Address const &', 'addr'), param('uint16_t', 'protocol')])
    ## queue-item.h (module 'network'): ns3::Address ns3::QueueDiscItem::GetAddress() const [member function]
    cls.add_method('GetAddress',
                   'ns3::Address',
                   [],
                   is_const=True)
    ## queue-item.h (module 'network'): uint16_t ns3::QueueDiscItem::GetProtocol() const [member function]
    cls.add_method('GetProtocol',
                   'uint16_t',
                   [],
                   is_const=True)
    ## queue-item.h (module 'network'): uint8_t ns3::QueueDiscItem::GetTxQueueIndex() const [member function]
    cls.add_method('GetTxQueueIndex',
                   'uint8_t',
                   [],
                   is_const=True)
    ## queue-item.h (module 'network'): void ns3::QueueDiscItem::SetTxQueueIndex(uint8_t txq) [member function]
    cls.add_method('SetTxQueueIndex',
                   'void',
                   [param('uint8_t', 'txq')])
    ## queue-item.h (module 'network'): ns3::Time ns3::QueueDiscItem::GetTimeStamp() const [member function]
    cls.add_method('GetTimeStamp',
                   'ns3::Time',
                   [],
                   is_const=True)
    ## queue-item.h (module 'network'): void ns3::QueueDiscItem::SetTimeStamp(ns3::Time t) [member function]
    cls.add_method('SetTimeStamp',
                   'void',
                   [param('ns3::Time', 't')])
    ## queue-item.h (module 'network'): void ns3::QueueDiscItem::AddHeader() [member function]
    cls.add_method('AddHeader',
                   'void',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## queue-item.h (module 'network'): void ns3::QueueDiscItem::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True, is_virtual=True)
    ## queue-item.h (module 'network'): bool ns3::QueueDiscItem::Mark() [member function]
    cls.add_method('Mark',
                   'bool',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## queue-item.h (module 'network'): uint32_t ns3::QueueDiscItem::Hash(uint32_t perturbation=0) const [member function]
    cls.add_method('Hash',
                   'uint32_t',
                   [param('uint32_t', 'perturbation', default_value='0')],
                   is_const=True, is_virtual=True)
    return

def register_Ns3RrcConnectToMmWaveHeader_methods(root_module, cls):
    ## lte-rrc-header.h (module 'lte'): ns3::RrcConnectToMmWaveHeader::RrcConnectToMmWaveHeader(ns3::RrcConnectToMmWaveHeader const & arg0) [constructor]
    cls.add_constructor([param('ns3::RrcConnectToMmWaveHeader const &', 'arg0')])
    ## lte-rrc-header.h (module 'lte'): ns3::RrcConnectToMmWaveHeader::RrcConnectToMmWaveHeader() [constructor]
    cls.add_constructor([])
    ## lte-rrc-header.h (module 'lte'): uint32_t ns3::RrcConnectToMmWaveHeader::Deserialize(ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('Deserialize',
                   'uint32_t',
                   [param('ns3::Buffer::Iterator', 'bIterator')],
                   is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): uint16_t ns3::RrcConnectToMmWaveHeader::GetMessage() const [member function]
    cls.add_method('GetMessage',
                   'uint16_t',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): static ns3::TypeId ns3::RrcConnectToMmWaveHeader::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcConnectToMmWaveHeader::PreSerialize() const [member function]
    cls.add_method('PreSerialize',
                   'void',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcConnectToMmWaveHeader::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True, is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcConnectToMmWaveHeader::SetMessage(uint16_t mmWaveId) [member function]
    cls.add_method('SetMessage',
                   'void',
                   [param('uint16_t', 'mmWaveId')])
    return

def register_Ns3RrcConnectionReconfigurationCompleteHeader_methods(root_module, cls):
    ## lte-rrc-header.h (module 'lte'): ns3::RrcConnectionReconfigurationCompleteHeader::RrcConnectionReconfigurationCompleteHeader(ns3::RrcConnectionReconfigurationCompleteHeader const & arg0) [constructor]
    cls.add_constructor([param('ns3::RrcConnectionReconfigurationCompleteHeader const &', 'arg0')])
    ## lte-rrc-header.h (module 'lte'): ns3::RrcConnectionReconfigurationCompleteHeader::RrcConnectionReconfigurationCompleteHeader() [constructor]
    cls.add_constructor([])
    ## lte-rrc-header.h (module 'lte'): uint32_t ns3::RrcConnectionReconfigurationCompleteHeader::Deserialize(ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('Deserialize',
                   'uint32_t',
                   [param('ns3::Buffer::Iterator', 'bIterator')],
                   is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReconfigurationCompleted ns3::RrcConnectionReconfigurationCompleteHeader::GetMessage() const [member function]
    cls.add_method('GetMessage',
                   'ns3::LteRrcSap::RrcConnectionReconfigurationCompleted',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): uint8_t ns3::RrcConnectionReconfigurationCompleteHeader::GetRrcTransactionIdentifier() const [member function]
    cls.add_method('GetRrcTransactionIdentifier',
                   'uint8_t',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcConnectionReconfigurationCompleteHeader::PreSerialize() const [member function]
    cls.add_method('PreSerialize',
                   'void',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcConnectionReconfigurationCompleteHeader::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True, is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcConnectionReconfigurationCompleteHeader::SetMessage(ns3::LteRrcSap::RrcConnectionReconfigurationCompleted msg) [member function]
    cls.add_method('SetMessage',
                   'void',
                   [param('ns3::LteRrcSap::RrcConnectionReconfigurationCompleted', 'msg')])
    return

def register_Ns3RrcConnectionReconfigurationHeader_methods(root_module, cls):
    ## lte-rrc-header.h (module 'lte'): ns3::RrcConnectionReconfigurationHeader::RrcConnectionReconfigurationHeader(ns3::RrcConnectionReconfigurationHeader const & arg0) [constructor]
    cls.add_constructor([param('ns3::RrcConnectionReconfigurationHeader const &', 'arg0')])
    ## lte-rrc-header.h (module 'lte'): ns3::RrcConnectionReconfigurationHeader::RrcConnectionReconfigurationHeader() [constructor]
    cls.add_constructor([])
    ## lte-rrc-header.h (module 'lte'): uint32_t ns3::RrcConnectionReconfigurationHeader::Deserialize(ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('Deserialize',
                   'uint32_t',
                   [param('ns3::Buffer::Iterator', 'bIterator')],
                   is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): std::list<ns3::LteRrcSap::DrbToAddMod, std::allocator<ns3::LteRrcSap::DrbToAddMod> > ns3::RrcConnectionReconfigurationHeader::GetDrbToAddModList() const [member function]
    cls.add_method('GetDrbToAddModList',
                   'std::list< ns3::LteRrcSap::DrbToAddMod >',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): std::list<unsigned char, std::allocator<unsigned char> > ns3::RrcConnectionReconfigurationHeader::GetDrbToReleaseList() const [member function]
    cls.add_method('GetDrbToReleaseList',
                   'std::list< unsigned char >',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): bool ns3::RrcConnectionReconfigurationHeader::GetHaveMeasConfig() [member function]
    cls.add_method('GetHaveMeasConfig',
                   'bool',
                   [])
    ## lte-rrc-header.h (module 'lte'): bool ns3::RrcConnectionReconfigurationHeader::GetHaveMobilityControlInfo() [member function]
    cls.add_method('GetHaveMobilityControlInfo',
                   'bool',
                   [])
    ## lte-rrc-header.h (module 'lte'): bool ns3::RrcConnectionReconfigurationHeader::GetHaveNonCriticalExtensionConfig() [member function]
    cls.add_method('GetHaveNonCriticalExtensionConfig',
                   'bool',
                   [])
    ## lte-rrc-header.h (module 'lte'): bool ns3::RrcConnectionReconfigurationHeader::GetHaveRadioResourceConfigDedicated() [member function]
    cls.add_method('GetHaveRadioResourceConfigDedicated',
                   'bool',
                   [])
    ## lte-rrc-header.h (module 'lte'): ns3::LteRrcSap::MeasConfig ns3::RrcConnectionReconfigurationHeader::GetMeasConfig() [member function]
    cls.add_method('GetMeasConfig',
                   'ns3::LteRrcSap::MeasConfig',
                   [])
    ## lte-rrc-header.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReconfiguration ns3::RrcConnectionReconfigurationHeader::GetMessage() const [member function]
    cls.add_method('GetMessage',
                   'ns3::LteRrcSap::RrcConnectionReconfiguration',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): ns3::LteRrcSap::MobilityControlInfo ns3::RrcConnectionReconfigurationHeader::GetMobilityControlInfo() [member function]
    cls.add_method('GetMobilityControlInfo',
                   'ns3::LteRrcSap::MobilityControlInfo',
                   [])
    ## lte-rrc-header.h (module 'lte'): ns3::LteRrcSap::NonCriticalExtensionConfiguration ns3::RrcConnectionReconfigurationHeader::GetNonCriticalExtensionConfig() [member function]
    cls.add_method('GetNonCriticalExtensionConfig',
                   'ns3::LteRrcSap::NonCriticalExtensionConfiguration',
                   [])
    ## lte-rrc-header.h (module 'lte'): ns3::LteRrcSap::PhysicalConfigDedicated ns3::RrcConnectionReconfigurationHeader::GetPhysicalConfigDedicated() const [member function]
    cls.add_method('GetPhysicalConfigDedicated',
                   'ns3::LteRrcSap::PhysicalConfigDedicated',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): ns3::LteRrcSap::RadioResourceConfigDedicated ns3::RrcConnectionReconfigurationHeader::GetRadioResourceConfigDedicated() [member function]
    cls.add_method('GetRadioResourceConfigDedicated',
                   'ns3::LteRrcSap::RadioResourceConfigDedicated',
                   [])
    ## lte-rrc-header.h (module 'lte'): ns3::LteRrcSap::RadioResourceConfigDedicated ns3::RrcConnectionReconfigurationHeader::GetRadioResourceConfigDedicated() const [member function]
    cls.add_method('GetRadioResourceConfigDedicated',
                   'ns3::LteRrcSap::RadioResourceConfigDedicated',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): uint8_t ns3::RrcConnectionReconfigurationHeader::GetRrcTransactionIdentifier() const [member function]
    cls.add_method('GetRrcTransactionIdentifier',
                   'uint8_t',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): std::list<ns3::LteRrcSap::SrbToAddMod, std::allocator<ns3::LteRrcSap::SrbToAddMod> > ns3::RrcConnectionReconfigurationHeader::GetSrbToAddModList() const [member function]
    cls.add_method('GetSrbToAddModList',
                   'std::list< ns3::LteRrcSap::SrbToAddMod >',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): bool ns3::RrcConnectionReconfigurationHeader::HavePhysicalConfigDedicated() const [member function]
    cls.add_method('HavePhysicalConfigDedicated',
                   'bool',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcConnectionReconfigurationHeader::PreSerialize() const [member function]
    cls.add_method('PreSerialize',
                   'void',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcConnectionReconfigurationHeader::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True, is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcConnectionReconfigurationHeader::SetMessage(ns3::LteRrcSap::RrcConnectionReconfiguration msg) [member function]
    cls.add_method('SetMessage',
                   'void',
                   [param('ns3::LteRrcSap::RrcConnectionReconfiguration', 'msg')])
    return

def register_Ns3RrcConnectionReestablishmentCompleteHeader_methods(root_module, cls):
    ## lte-rrc-header.h (module 'lte'): ns3::RrcConnectionReestablishmentCompleteHeader::RrcConnectionReestablishmentCompleteHeader(ns3::RrcConnectionReestablishmentCompleteHeader const & arg0) [constructor]
    cls.add_constructor([param('ns3::RrcConnectionReestablishmentCompleteHeader const &', 'arg0')])
    ## lte-rrc-header.h (module 'lte'): ns3::RrcConnectionReestablishmentCompleteHeader::RrcConnectionReestablishmentCompleteHeader() [constructor]
    cls.add_constructor([])
    ## lte-rrc-header.h (module 'lte'): uint32_t ns3::RrcConnectionReestablishmentCompleteHeader::Deserialize(ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('Deserialize',
                   'uint32_t',
                   [param('ns3::Buffer::Iterator', 'bIterator')],
                   is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReestablishmentComplete ns3::RrcConnectionReestablishmentCompleteHeader::GetMessage() const [member function]
    cls.add_method('GetMessage',
                   'ns3::LteRrcSap::RrcConnectionReestablishmentComplete',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): uint8_t ns3::RrcConnectionReestablishmentCompleteHeader::GetRrcTransactionIdentifier() const [member function]
    cls.add_method('GetRrcTransactionIdentifier',
                   'uint8_t',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcConnectionReestablishmentCompleteHeader::PreSerialize() const [member function]
    cls.add_method('PreSerialize',
                   'void',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcConnectionReestablishmentCompleteHeader::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True, is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcConnectionReestablishmentCompleteHeader::SetMessage(ns3::LteRrcSap::RrcConnectionReestablishmentComplete msg) [member function]
    cls.add_method('SetMessage',
                   'void',
                   [param('ns3::LteRrcSap::RrcConnectionReestablishmentComplete', 'msg')])
    return

def register_Ns3RrcConnectionReestablishmentHeader_methods(root_module, cls):
    ## lte-rrc-header.h (module 'lte'): ns3::RrcConnectionReestablishmentHeader::RrcConnectionReestablishmentHeader(ns3::RrcConnectionReestablishmentHeader const & arg0) [constructor]
    cls.add_constructor([param('ns3::RrcConnectionReestablishmentHeader const &', 'arg0')])
    ## lte-rrc-header.h (module 'lte'): ns3::RrcConnectionReestablishmentHeader::RrcConnectionReestablishmentHeader() [constructor]
    cls.add_constructor([])
    ## lte-rrc-header.h (module 'lte'): uint32_t ns3::RrcConnectionReestablishmentHeader::Deserialize(ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('Deserialize',
                   'uint32_t',
                   [param('ns3::Buffer::Iterator', 'bIterator')],
                   is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReestablishment ns3::RrcConnectionReestablishmentHeader::GetMessage() const [member function]
    cls.add_method('GetMessage',
                   'ns3::LteRrcSap::RrcConnectionReestablishment',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): ns3::LteRrcSap::RadioResourceConfigDedicated ns3::RrcConnectionReestablishmentHeader::GetRadioResourceConfigDedicated() const [member function]
    cls.add_method('GetRadioResourceConfigDedicated',
                   'ns3::LteRrcSap::RadioResourceConfigDedicated',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): uint8_t ns3::RrcConnectionReestablishmentHeader::GetRrcTransactionIdentifier() const [member function]
    cls.add_method('GetRrcTransactionIdentifier',
                   'uint8_t',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcConnectionReestablishmentHeader::PreSerialize() const [member function]
    cls.add_method('PreSerialize',
                   'void',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcConnectionReestablishmentHeader::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True, is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcConnectionReestablishmentHeader::SetMessage(ns3::LteRrcSap::RrcConnectionReestablishment msg) [member function]
    cls.add_method('SetMessage',
                   'void',
                   [param('ns3::LteRrcSap::RrcConnectionReestablishment', 'msg')])
    return

def register_Ns3RrcConnectionReestablishmentRejectHeader_methods(root_module, cls):
    ## lte-rrc-header.h (module 'lte'): ns3::RrcConnectionReestablishmentRejectHeader::RrcConnectionReestablishmentRejectHeader(ns3::RrcConnectionReestablishmentRejectHeader const & arg0) [constructor]
    cls.add_constructor([param('ns3::RrcConnectionReestablishmentRejectHeader const &', 'arg0')])
    ## lte-rrc-header.h (module 'lte'): ns3::RrcConnectionReestablishmentRejectHeader::RrcConnectionReestablishmentRejectHeader() [constructor]
    cls.add_constructor([])
    ## lte-rrc-header.h (module 'lte'): uint32_t ns3::RrcConnectionReestablishmentRejectHeader::Deserialize(ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('Deserialize',
                   'uint32_t',
                   [param('ns3::Buffer::Iterator', 'bIterator')],
                   is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReestablishmentReject ns3::RrcConnectionReestablishmentRejectHeader::GetMessage() const [member function]
    cls.add_method('GetMessage',
                   'ns3::LteRrcSap::RrcConnectionReestablishmentReject',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcConnectionReestablishmentRejectHeader::PreSerialize() const [member function]
    cls.add_method('PreSerialize',
                   'void',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcConnectionReestablishmentRejectHeader::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True, is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcConnectionReestablishmentRejectHeader::SetMessage(ns3::LteRrcSap::RrcConnectionReestablishmentReject msg) [member function]
    cls.add_method('SetMessage',
                   'void',
                   [param('ns3::LteRrcSap::RrcConnectionReestablishmentReject', 'msg')])
    return

def register_Ns3RrcConnectionReestablishmentRequestHeader_methods(root_module, cls):
    ## lte-rrc-header.h (module 'lte'): ns3::RrcConnectionReestablishmentRequestHeader::RrcConnectionReestablishmentRequestHeader(ns3::RrcConnectionReestablishmentRequestHeader const & arg0) [constructor]
    cls.add_constructor([param('ns3::RrcConnectionReestablishmentRequestHeader const &', 'arg0')])
    ## lte-rrc-header.h (module 'lte'): ns3::RrcConnectionReestablishmentRequestHeader::RrcConnectionReestablishmentRequestHeader() [constructor]
    cls.add_constructor([])
    ## lte-rrc-header.h (module 'lte'): uint32_t ns3::RrcConnectionReestablishmentRequestHeader::Deserialize(ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('Deserialize',
                   'uint32_t',
                   [param('ns3::Buffer::Iterator', 'bIterator')],
                   is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReestablishmentRequest ns3::RrcConnectionReestablishmentRequestHeader::GetMessage() const [member function]
    cls.add_method('GetMessage',
                   'ns3::LteRrcSap::RrcConnectionReestablishmentRequest',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): ns3::LteRrcSap::ReestablishmentCause ns3::RrcConnectionReestablishmentRequestHeader::GetReestablishmentCause() const [member function]
    cls.add_method('GetReestablishmentCause',
                   'ns3::LteRrcSap::ReestablishmentCause',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): ns3::LteRrcSap::ReestabUeIdentity ns3::RrcConnectionReestablishmentRequestHeader::GetUeIdentity() const [member function]
    cls.add_method('GetUeIdentity',
                   'ns3::LteRrcSap::ReestabUeIdentity',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcConnectionReestablishmentRequestHeader::PreSerialize() const [member function]
    cls.add_method('PreSerialize',
                   'void',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcConnectionReestablishmentRequestHeader::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True, is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcConnectionReestablishmentRequestHeader::SetMessage(ns3::LteRrcSap::RrcConnectionReestablishmentRequest msg) [member function]
    cls.add_method('SetMessage',
                   'void',
                   [param('ns3::LteRrcSap::RrcConnectionReestablishmentRequest', 'msg')])
    return

def register_Ns3RrcConnectionRejectHeader_methods(root_module, cls):
    ## lte-rrc-header.h (module 'lte'): ns3::RrcConnectionRejectHeader::RrcConnectionRejectHeader(ns3::RrcConnectionRejectHeader const & arg0) [constructor]
    cls.add_constructor([param('ns3::RrcConnectionRejectHeader const &', 'arg0')])
    ## lte-rrc-header.h (module 'lte'): ns3::RrcConnectionRejectHeader::RrcConnectionRejectHeader() [constructor]
    cls.add_constructor([])
    ## lte-rrc-header.h (module 'lte'): uint32_t ns3::RrcConnectionRejectHeader::Deserialize(ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('Deserialize',
                   'uint32_t',
                   [param('ns3::Buffer::Iterator', 'bIterator')],
                   is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): ns3::LteRrcSap::RrcConnectionReject ns3::RrcConnectionRejectHeader::GetMessage() const [member function]
    cls.add_method('GetMessage',
                   'ns3::LteRrcSap::RrcConnectionReject',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcConnectionRejectHeader::PreSerialize() const [member function]
    cls.add_method('PreSerialize',
                   'void',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcConnectionRejectHeader::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True, is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcConnectionRejectHeader::SetMessage(ns3::LteRrcSap::RrcConnectionReject msg) [member function]
    cls.add_method('SetMessage',
                   'void',
                   [param('ns3::LteRrcSap::RrcConnectionReject', 'msg')])
    return

def register_Ns3RrcConnectionReleaseHeader_methods(root_module, cls):
    ## lte-rrc-header.h (module 'lte'): ns3::RrcConnectionReleaseHeader::RrcConnectionReleaseHeader(ns3::RrcConnectionReleaseHeader const & arg0) [constructor]
    cls.add_constructor([param('ns3::RrcConnectionReleaseHeader const &', 'arg0')])
    ## lte-rrc-header.h (module 'lte'): ns3::RrcConnectionReleaseHeader::RrcConnectionReleaseHeader() [constructor]
    cls.add_constructor([])
    ## lte-rrc-header.h (module 'lte'): uint32_t ns3::RrcConnectionReleaseHeader::Deserialize(ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('Deserialize',
                   'uint32_t',
                   [param('ns3::Buffer::Iterator', 'bIterator')],
                   is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): ns3::LteRrcSap::RrcConnectionRelease ns3::RrcConnectionReleaseHeader::GetMessage() const [member function]
    cls.add_method('GetMessage',
                   'ns3::LteRrcSap::RrcConnectionRelease',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcConnectionReleaseHeader::PreSerialize() const [member function]
    cls.add_method('PreSerialize',
                   'void',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcConnectionReleaseHeader::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True, is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcConnectionReleaseHeader::SetMessage(ns3::LteRrcSap::RrcConnectionRelease msg) [member function]
    cls.add_method('SetMessage',
                   'void',
                   [param('ns3::LteRrcSap::RrcConnectionRelease', 'msg')])
    return

def register_Ns3RrcConnectionRequestHeader_methods(root_module, cls):
    ## lte-rrc-header.h (module 'lte'): ns3::RrcConnectionRequestHeader::RrcConnectionRequestHeader(ns3::RrcConnectionRequestHeader const & arg0) [constructor]
    cls.add_constructor([param('ns3::RrcConnectionRequestHeader const &', 'arg0')])
    ## lte-rrc-header.h (module 'lte'): ns3::RrcConnectionRequestHeader::RrcConnectionRequestHeader() [constructor]
    cls.add_constructor([])
    ## lte-rrc-header.h (module 'lte'): uint32_t ns3::RrcConnectionRequestHeader::Deserialize(ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('Deserialize',
                   'uint32_t',
                   [param('ns3::Buffer::Iterator', 'bIterator')],
                   is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): std::bitset<1> ns3::RrcConnectionRequestHeader::GetIsMc() const [member function]
    cls.add_method('GetIsMc',
                   'std::bitset< 1 >',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): ns3::LteRrcSap::RrcConnectionRequest ns3::RrcConnectionRequestHeader::GetMessage() const [member function]
    cls.add_method('GetMessage',
                   'ns3::LteRrcSap::RrcConnectionRequest',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): std::bitset<8> ns3::RrcConnectionRequestHeader::GetMmec() const [member function]
    cls.add_method('GetMmec',
                   'std::bitset< 8 >',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): std::bitset<32> ns3::RrcConnectionRequestHeader::GetMtmsi() const [member function]
    cls.add_method('GetMtmsi',
                   'std::bitset< 32 >',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): static ns3::TypeId ns3::RrcConnectionRequestHeader::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcConnectionRequestHeader::PreSerialize() const [member function]
    cls.add_method('PreSerialize',
                   'void',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcConnectionRequestHeader::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True, is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcConnectionRequestHeader::SetMessage(ns3::LteRrcSap::RrcConnectionRequest msg) [member function]
    cls.add_method('SetMessage',
                   'void',
                   [param('ns3::LteRrcSap::RrcConnectionRequest', 'msg')])
    return

def register_Ns3RrcConnectionSetupCompleteHeader_methods(root_module, cls):
    ## lte-rrc-header.h (module 'lte'): ns3::RrcConnectionSetupCompleteHeader::RrcConnectionSetupCompleteHeader(ns3::RrcConnectionSetupCompleteHeader const & arg0) [constructor]
    cls.add_constructor([param('ns3::RrcConnectionSetupCompleteHeader const &', 'arg0')])
    ## lte-rrc-header.h (module 'lte'): ns3::RrcConnectionSetupCompleteHeader::RrcConnectionSetupCompleteHeader() [constructor]
    cls.add_constructor([])
    ## lte-rrc-header.h (module 'lte'): uint32_t ns3::RrcConnectionSetupCompleteHeader::Deserialize(ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('Deserialize',
                   'uint32_t',
                   [param('ns3::Buffer::Iterator', 'bIterator')],
                   is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): ns3::LteRrcSap::RrcConnectionSetupCompleted ns3::RrcConnectionSetupCompleteHeader::GetMessage() const [member function]
    cls.add_method('GetMessage',
                   'ns3::LteRrcSap::RrcConnectionSetupCompleted',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): uint8_t ns3::RrcConnectionSetupCompleteHeader::GetRrcTransactionIdentifier() const [member function]
    cls.add_method('GetRrcTransactionIdentifier',
                   'uint8_t',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcConnectionSetupCompleteHeader::PreSerialize() const [member function]
    cls.add_method('PreSerialize',
                   'void',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcConnectionSetupCompleteHeader::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True, is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcConnectionSetupCompleteHeader::SetMessage(ns3::LteRrcSap::RrcConnectionSetupCompleted msg) [member function]
    cls.add_method('SetMessage',
                   'void',
                   [param('ns3::LteRrcSap::RrcConnectionSetupCompleted', 'msg')])
    return

def register_Ns3RrcConnectionSetupHeader_methods(root_module, cls):
    ## lte-rrc-header.h (module 'lte'): ns3::RrcConnectionSetupHeader::RrcConnectionSetupHeader(ns3::RrcConnectionSetupHeader const & arg0) [constructor]
    cls.add_constructor([param('ns3::RrcConnectionSetupHeader const &', 'arg0')])
    ## lte-rrc-header.h (module 'lte'): ns3::RrcConnectionSetupHeader::RrcConnectionSetupHeader() [constructor]
    cls.add_constructor([])
    ## lte-rrc-header.h (module 'lte'): uint32_t ns3::RrcConnectionSetupHeader::Deserialize(ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('Deserialize',
                   'uint32_t',
                   [param('ns3::Buffer::Iterator', 'bIterator')],
                   is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): std::list<ns3::LteRrcSap::DrbToAddMod, std::allocator<ns3::LteRrcSap::DrbToAddMod> > ns3::RrcConnectionSetupHeader::GetDrbToAddModList() const [member function]
    cls.add_method('GetDrbToAddModList',
                   'std::list< ns3::LteRrcSap::DrbToAddMod >',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): std::list<unsigned char, std::allocator<unsigned char> > ns3::RrcConnectionSetupHeader::GetDrbToReleaseList() const [member function]
    cls.add_method('GetDrbToReleaseList',
                   'std::list< unsigned char >',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): ns3::LteRrcSap::RrcConnectionSetup ns3::RrcConnectionSetupHeader::GetMessage() const [member function]
    cls.add_method('GetMessage',
                   'ns3::LteRrcSap::RrcConnectionSetup',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): ns3::LteRrcSap::PhysicalConfigDedicated ns3::RrcConnectionSetupHeader::GetPhysicalConfigDedicated() const [member function]
    cls.add_method('GetPhysicalConfigDedicated',
                   'ns3::LteRrcSap::PhysicalConfigDedicated',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): ns3::LteRrcSap::RadioResourceConfigDedicated ns3::RrcConnectionSetupHeader::GetRadioResourceConfigDedicated() const [member function]
    cls.add_method('GetRadioResourceConfigDedicated',
                   'ns3::LteRrcSap::RadioResourceConfigDedicated',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): uint8_t ns3::RrcConnectionSetupHeader::GetRrcTransactionIdentifier() const [member function]
    cls.add_method('GetRrcTransactionIdentifier',
                   'uint8_t',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): std::list<ns3::LteRrcSap::SrbToAddMod, std::allocator<ns3::LteRrcSap::SrbToAddMod> > ns3::RrcConnectionSetupHeader::GetSrbToAddModList() const [member function]
    cls.add_method('GetSrbToAddModList',
                   'std::list< ns3::LteRrcSap::SrbToAddMod >',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): bool ns3::RrcConnectionSetupHeader::HavePhysicalConfigDedicated() const [member function]
    cls.add_method('HavePhysicalConfigDedicated',
                   'bool',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcConnectionSetupHeader::PreSerialize() const [member function]
    cls.add_method('PreSerialize',
                   'void',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcConnectionSetupHeader::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True, is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcConnectionSetupHeader::SetMessage(ns3::LteRrcSap::RrcConnectionSetup msg) [member function]
    cls.add_method('SetMessage',
                   'void',
                   [param('ns3::LteRrcSap::RrcConnectionSetup', 'msg')])
    return

def register_Ns3RrcConnectionSwitchHeader_methods(root_module, cls):
    ## lte-rrc-header.h (module 'lte'): ns3::RrcConnectionSwitchHeader::RrcConnectionSwitchHeader(ns3::RrcConnectionSwitchHeader const & arg0) [constructor]
    cls.add_constructor([param('ns3::RrcConnectionSwitchHeader const &', 'arg0')])
    ## lte-rrc-header.h (module 'lte'): ns3::RrcConnectionSwitchHeader::RrcConnectionSwitchHeader() [constructor]
    cls.add_constructor([])
    ## lte-rrc-header.h (module 'lte'): uint32_t ns3::RrcConnectionSwitchHeader::Deserialize(ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('Deserialize',
                   'uint32_t',
                   [param('ns3::Buffer::Iterator', 'bIterator')],
                   is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): ns3::LteRrcSap::RrcConnectionSwitch ns3::RrcConnectionSwitchHeader::GetMessage() const [member function]
    cls.add_method('GetMessage',
                   'ns3::LteRrcSap::RrcConnectionSwitch',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): uint8_t ns3::RrcConnectionSwitchHeader::GetRrcTransactionIdentifier() const [member function]
    cls.add_method('GetRrcTransactionIdentifier',
                   'uint8_t',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): static ns3::TypeId ns3::RrcConnectionSwitchHeader::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcConnectionSwitchHeader::PreSerialize() const [member function]
    cls.add_method('PreSerialize',
                   'void',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcConnectionSwitchHeader::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True, is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcConnectionSwitchHeader::SetMessage(ns3::LteRrcSap::RrcConnectionSwitch msg) [member function]
    cls.add_method('SetMessage',
                   'void',
                   [param('ns3::LteRrcSap::RrcConnectionSwitch', 'msg')])
    return

def register_Ns3RrcNotifySecondaryConnectedHeader_methods(root_module, cls):
    ## lte-rrc-header.h (module 'lte'): ns3::RrcNotifySecondaryConnectedHeader::RrcNotifySecondaryConnectedHeader(ns3::RrcNotifySecondaryConnectedHeader const & arg0) [constructor]
    cls.add_constructor([param('ns3::RrcNotifySecondaryConnectedHeader const &', 'arg0')])
    ## lte-rrc-header.h (module 'lte'): ns3::RrcNotifySecondaryConnectedHeader::RrcNotifySecondaryConnectedHeader() [constructor]
    cls.add_constructor([])
    ## lte-rrc-header.h (module 'lte'): uint32_t ns3::RrcNotifySecondaryConnectedHeader::Deserialize(ns3::Buffer::Iterator bIterator) [member function]
    cls.add_method('Deserialize',
                   'uint32_t',
                   [param('ns3::Buffer::Iterator', 'bIterator')],
                   is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): std::pair<unsigned short, unsigned short> ns3::RrcNotifySecondaryConnectedHeader::GetMessage() const [member function]
    cls.add_method('GetMessage',
                   'std::pair< unsigned short, unsigned short >',
                   [],
                   is_const=True)
    ## lte-rrc-header.h (module 'lte'): static ns3::TypeId ns3::RrcNotifySecondaryConnectedHeader::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcNotifySecondaryConnectedHeader::PreSerialize() const [member function]
    cls.add_method('PreSerialize',
                   'void',
                   [],
                   is_const=True, is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcNotifySecondaryConnectedHeader::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True, is_virtual=True)
    ## lte-rrc-header.h (module 'lte'): void ns3::RrcNotifySecondaryConnectedHeader::SetMessage(uint16_t mmWaveId, uint16_t mmWaveRnti) [member function]
    cls.add_method('SetMessage',
                   'void',
                   [param('uint16_t', 'mmWaveId'), param('uint16_t', 'mmWaveRnti')])
    return

def register_Ns3LteEnbNetDevice_methods(root_module, cls):
    ## lte-enb-net-device.h (module 'lte'): static ns3::TypeId ns3::LteEnbNetDevice::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## lte-enb-net-device.h (module 'lte'): ns3::LteEnbNetDevice::LteEnbNetDevice() [constructor]
    cls.add_constructor([])
    ## lte-enb-net-device.h (module 'lte'): void ns3::LteEnbNetDevice::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## lte-enb-net-device.h (module 'lte'): bool ns3::LteEnbNetDevice::Send(ns3::Ptr<ns3::Packet> packet, ns3::Address const & dest, uint16_t protocolNumber) [member function]
    cls.add_method('Send',
                   'bool',
                   [param('ns3::Ptr< ns3::Packet >', 'packet'), param('ns3::Address const &', 'dest'), param('uint16_t', 'protocolNumber')],
                   is_virtual=True)
    ## lte-enb-net-device.h (module 'lte'): ns3::Ptr<ns3::LteEnbMac> ns3::LteEnbNetDevice::GetMac() const [member function]
    cls.add_method('GetMac',
                   'ns3::Ptr< ns3::LteEnbMac >',
                   [],
                   is_const=True)
    ## lte-enb-net-device.h (module 'lte'): ns3::Ptr<ns3::LteEnbMac> ns3::LteEnbNetDevice::GetMac(uint8_t index) [member function]
    cls.add_method('GetMac',
                   'ns3::Ptr< ns3::LteEnbMac >',
                   [param('uint8_t', 'index')])
    ## lte-enb-net-device.h (module 'lte'): ns3::Ptr<ns3::LteEnbPhy> ns3::LteEnbNetDevice::GetPhy() const [member function]
    cls.add_method('GetPhy',
                   'ns3::Ptr< ns3::LteEnbPhy >',
                   [],
                   is_const=True)
    ## lte-enb-net-device.h (module 'lte'): ns3::Ptr<ns3::LteEnbPhy> ns3::LteEnbNetDevice::GetPhy(uint8_t index) [member function]
    cls.add_method('GetPhy',
                   'ns3::Ptr< ns3::LteEnbPhy >',
                   [param('uint8_t', 'index')])
    ## lte-enb-net-device.h (module 'lte'): ns3::Ptr<ns3::LteEnbRrc> ns3::LteEnbNetDevice::GetRrc() const [member function]
    cls.add_method('GetRrc',
                   'ns3::Ptr< ns3::LteEnbRrc >',
                   [],
                   is_const=True)
    ## lte-enb-net-device.h (module 'lte'): ns3::Ptr<ns3::LteEnbComponentCarrierManager> ns3::LteEnbNetDevice::GetComponentCarrierManager() const [member function]
    cls.add_method('GetComponentCarrierManager',
                   'ns3::Ptr< ns3::LteEnbComponentCarrierManager >',
                   [],
                   is_const=True)
    ## lte-enb-net-device.h (module 'lte'): uint16_t ns3::LteEnbNetDevice::GetCellId() const [member function]
    cls.add_method('GetCellId',
                   'uint16_t',
                   [],
                   is_const=True)
    ## lte-enb-net-device.h (module 'lte'): bool ns3::LteEnbNetDevice::HasCellId(uint16_t cellId) const [member function]
    cls.add_method('HasCellId',
                   'bool',
                   [param('uint16_t', 'cellId')],
                   is_const=True)
    ## lte-enb-net-device.h (module 'lte'): uint8_t ns3::LteEnbNetDevice::GetUlBandwidth() const [member function]
    cls.add_method('GetUlBandwidth',
                   'uint8_t',
                   [],
                   is_const=True)
    ## lte-enb-net-device.h (module 'lte'): void ns3::LteEnbNetDevice::SetUlBandwidth(uint8_t bw) [member function]
    cls.add_method('SetUlBandwidth',
                   'void',
                   [param('uint8_t', 'bw')])
    ## lte-enb-net-device.h (module 'lte'): uint8_t ns3::LteEnbNetDevice::GetDlBandwidth() const [member function]
    cls.add_method('GetDlBandwidth',
                   'uint8_t',
                   [],
                   is_const=True)
    ## lte-enb-net-device.h (module 'lte'): void ns3::LteEnbNetDevice::SetDlBandwidth(uint8_t bw) [member function]
    cls.add_method('SetDlBandwidth',
                   'void',
                   [param('uint8_t', 'bw')])
    ## lte-enb-net-device.h (module 'lte'): uint32_t ns3::LteEnbNetDevice::GetDlEarfcn() const [member function]
    cls.add_method('GetDlEarfcn',
                   'uint32_t',
                   [],
                   is_const=True)
    ## lte-enb-net-device.h (module 'lte'): void ns3::LteEnbNetDevice::SetDlEarfcn(uint32_t earfcn) [member function]
    cls.add_method('SetDlEarfcn',
                   'void',
                   [param('uint32_t', 'earfcn')])
    ## lte-enb-net-device.h (module 'lte'): uint32_t ns3::LteEnbNetDevice::GetUlEarfcn() const [member function]
    cls.add_method('GetUlEarfcn',
                   'uint32_t',
                   [],
                   is_const=True)
    ## lte-enb-net-device.h (module 'lte'): void ns3::LteEnbNetDevice::SetUlEarfcn(uint32_t earfcn) [member function]
    cls.add_method('SetUlEarfcn',
                   'void',
                   [param('uint32_t', 'earfcn')])
    ## lte-enb-net-device.h (module 'lte'): uint32_t ns3::LteEnbNetDevice::GetCsgId() const [member function]
    cls.add_method('GetCsgId',
                   'uint32_t',
                   [],
                   is_const=True)
    ## lte-enb-net-device.h (module 'lte'): void ns3::LteEnbNetDevice::SetCsgId(uint32_t csgId) [member function]
    cls.add_method('SetCsgId',
                   'void',
                   [param('uint32_t', 'csgId')])
    ## lte-enb-net-device.h (module 'lte'): bool ns3::LteEnbNetDevice::GetCsgIndication() const [member function]
    cls.add_method('GetCsgIndication',
                   'bool',
                   [],
                   is_const=True)
    ## lte-enb-net-device.h (module 'lte'): void ns3::LteEnbNetDevice::SetCsgIndication(bool csgIndication) [member function]
    cls.add_method('SetCsgIndication',
                   'void',
                   [param('bool', 'csgIndication')])
    ## lte-enb-net-device.h (module 'lte'): void ns3::LteEnbNetDevice::SetCcMap(std::map<unsigned char, ns3::Ptr<ns3::ComponentCarrierEnb>, std::less<unsigned char>, std::allocator<std::pair<const unsigned char, ns3::Ptr<ns3::ComponentCarrierEnb> > > > ccm) [member function]
    cls.add_method('SetCcMap',
                   'void',
                   [param('std::map< unsigned char, ns3::Ptr< ns3::ComponentCarrierEnb > >', 'ccm')])
    ## lte-enb-net-device.h (module 'lte'): std::map<unsigned char, ns3::Ptr<ns3::ComponentCarrierEnb>, std::less<unsigned char>, std::allocator<std::pair<const unsigned char, ns3::Ptr<ns3::ComponentCarrierEnb> > > > ns3::LteEnbNetDevice::GetCcMap() [member function]
    cls.add_method('GetCcMap',
                   'std::map< unsigned char, ns3::Ptr< ns3::ComponentCarrierEnb > >',
                   [])
    ## lte-enb-net-device.h (module 'lte'): void ns3::LteEnbNetDevice::DoInitialize() [member function]
    cls.add_method('DoInitialize',
                   'void',
                   [],
                   visibility='protected', is_virtual=True)
    return

def register_Ns3ConfigMatchContainer_methods(root_module, cls):
    ## config.h (module 'core'): ns3::Config::MatchContainer::MatchContainer(ns3::Config::MatchContainer const & arg0) [constructor]
    cls.add_constructor([param('ns3::Config::MatchContainer const &', 'arg0')])
    ## config.h (module 'core'): ns3::Config::MatchContainer::MatchContainer() [constructor]
    cls.add_constructor([])
    ## config.h (module 'core'): ns3::Config::MatchContainer::MatchContainer(std::vector<ns3::Ptr<ns3::Object>, std::allocator<ns3::Ptr<ns3::Object> > > const & objects, std::vector<std::basic_string<char>, std::allocator<std::basic_string<char> > > const & contexts, std::string path) [constructor]
    cls.add_constructor([param('std::vector< ns3::Ptr< ns3::Object > > const &', 'objects'), param('std::vector< std::string > const &', 'contexts'), param('std::string', 'path')])
    ## config.h (module 'core'): ns3::Config::MatchContainer::Iterator ns3::Config::MatchContainer::Begin() const [member function]
    cls.add_method('Begin',
                   'ns3::Config::MatchContainer::Iterator',
                   [],
                   is_const=True)
    ## config.h (module 'core'): void ns3::Config::MatchContainer::Connect(std::string name, ns3::CallbackBase const & cb) [member function]
    cls.add_method('Connect',
                   'void',
                   [param('std::string', 'name'), param('ns3::CallbackBase const &', 'cb')])
    ## config.h (module 'core'): void ns3::Config::MatchContainer::ConnectWithoutContext(std::string name, ns3::CallbackBase const & cb) [member function]
    cls.add_method('ConnectWithoutContext',
                   'void',
                   [param('std::string', 'name'), param('ns3::CallbackBase const &', 'cb')])
    ## config.h (module 'core'): void ns3::Config::MatchContainer::Disconnect(std::string name, ns3::CallbackBase const & cb) [member function]
    cls.add_method('Disconnect',
                   'void',
                   [param('std::string', 'name'), param('ns3::CallbackBase const &', 'cb')])
    ## config.h (module 'core'): void ns3::Config::MatchContainer::DisconnectWithoutContext(std::string name, ns3::CallbackBase const & cb) [member function]
    cls.add_method('DisconnectWithoutContext',
                   'void',
                   [param('std::string', 'name'), param('ns3::CallbackBase const &', 'cb')])
    ## config.h (module 'core'): ns3::Config::MatchContainer::Iterator ns3::Config::MatchContainer::End() const [member function]
    cls.add_method('End',
                   'ns3::Config::MatchContainer::Iterator',
                   [],
                   is_const=True)
    ## config.h (module 'core'): ns3::Ptr<ns3::Object> ns3::Config::MatchContainer::Get(std::size_t i) const [member function]
    cls.add_method('Get',
                   'ns3::Ptr< ns3::Object >',
                   [param('std::size_t', 'i')],
                   is_const=True)
    ## config.h (module 'core'): std::string ns3::Config::MatchContainer::GetMatchedPath(uint32_t i) const [member function]
    cls.add_method('GetMatchedPath',
                   'std::string',
                   [param('uint32_t', 'i')],
                   is_const=True)
    ## config.h (module 'core'): std::size_t ns3::Config::MatchContainer::GetN() const [member function]
    cls.add_method('GetN',
                   'std::size_t',
                   [],
                   is_const=True)
    ## config.h (module 'core'): std::string ns3::Config::MatchContainer::GetPath() const [member function]
    cls.add_method('GetPath',
                   'std::string',
                   [],
                   is_const=True)
    ## config.h (module 'core'): void ns3::Config::MatchContainer::Set(std::string name, ns3::AttributeValue const & value) [member function]
    cls.add_method('Set',
                   'void',
                   [param('std::string', 'name'), param('ns3::AttributeValue const &', 'value')])
    return

def register_Ns3HashImplementation_methods(root_module, cls):
    ## hash-function.h (module 'core'): ns3::Hash::Implementation::Implementation(ns3::Hash::Implementation const & arg0) [constructor]
    cls.add_constructor([param('ns3::Hash::Implementation const &', 'arg0')])
    ## hash-function.h (module 'core'): ns3::Hash::Implementation::Implementation() [constructor]
    cls.add_constructor([])
    ## hash-function.h (module 'core'): uint32_t ns3::Hash::Implementation::GetHash32(char const * buffer, std::size_t const size) [member function]
    cls.add_method('GetHash32',
                   'uint32_t',
                   [param('char const *', 'buffer'), param('std::size_t const', 'size')],
                   is_pure_virtual=True, is_virtual=True)
    ## hash-function.h (module 'core'): uint64_t ns3::Hash::Implementation::GetHash64(char const * buffer, std::size_t const size) [member function]
    cls.add_method('GetHash64',
                   'uint64_t',
                   [param('char const *', 'buffer'), param('std::size_t const', 'size')],
                   is_virtual=True)
    ## hash-function.h (module 'core'): void ns3::Hash::Implementation::clear() [member function]
    cls.add_method('clear',
                   'void',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3HashFunctionFnv1a_methods(root_module, cls):
    ## hash-fnv.h (module 'core'): ns3::Hash::Function::Fnv1a::Fnv1a(ns3::Hash::Function::Fnv1a const & arg0) [constructor]
    cls.add_constructor([param('ns3::Hash::Function::Fnv1a const &', 'arg0')])
    ## hash-fnv.h (module 'core'): ns3::Hash::Function::Fnv1a::Fnv1a() [constructor]
    cls.add_constructor([])
    ## hash-fnv.h (module 'core'): uint32_t ns3::Hash::Function::Fnv1a::GetHash32(char const * buffer, size_t const size) [member function]
    cls.add_method('GetHash32',
                   'uint32_t',
                   [param('char const *', 'buffer'), param('size_t const', 'size')],
                   is_virtual=True)
    ## hash-fnv.h (module 'core'): uint64_t ns3::Hash::Function::Fnv1a::GetHash64(char const * buffer, size_t const size) [member function]
    cls.add_method('GetHash64',
                   'uint64_t',
                   [param('char const *', 'buffer'), param('size_t const', 'size')],
                   is_virtual=True)
    ## hash-fnv.h (module 'core'): void ns3::Hash::Function::Fnv1a::clear() [member function]
    cls.add_method('clear',
                   'void',
                   [],
                   is_virtual=True)
    return

def register_Ns3HashFunctionHash32_methods(root_module, cls):
    ## hash-function.h (module 'core'): ns3::Hash::Function::Hash32::Hash32(ns3::Hash::Function::Hash32 const & arg0) [constructor]
    cls.add_constructor([param('ns3::Hash::Function::Hash32 const &', 'arg0')])
    ## hash-function.h (module 'core'): ns3::Hash::Function::Hash32::Hash32(ns3::Hash::Hash32Function_ptr hp) [constructor]
    cls.add_constructor([param('ns3::Hash::Hash32Function_ptr', 'hp')])
    ## hash-function.h (module 'core'): uint32_t ns3::Hash::Function::Hash32::GetHash32(char const * buffer, std::size_t const size) [member function]
    cls.add_method('GetHash32',
                   'uint32_t',
                   [param('char const *', 'buffer'), param('std::size_t const', 'size')],
                   is_virtual=True)
    ## hash-function.h (module 'core'): void ns3::Hash::Function::Hash32::clear() [member function]
    cls.add_method('clear',
                   'void',
                   [],
                   is_virtual=True)
    return

def register_Ns3HashFunctionHash64_methods(root_module, cls):
    ## hash-function.h (module 'core'): ns3::Hash::Function::Hash64::Hash64(ns3::Hash::Function::Hash64 const & arg0) [constructor]
    cls.add_constructor([param('ns3::Hash::Function::Hash64 const &', 'arg0')])
    ## hash-function.h (module 'core'): ns3::Hash::Function::Hash64::Hash64(ns3::Hash::Hash64Function_ptr hp) [constructor]
    cls.add_constructor([param('ns3::Hash::Hash64Function_ptr', 'hp')])
    ## hash-function.h (module 'core'): uint32_t ns3::Hash::Function::Hash64::GetHash32(char const * buffer, std::size_t const size) [member function]
    cls.add_method('GetHash32',
                   'uint32_t',
                   [param('char const *', 'buffer'), param('std::size_t const', 'size')],
                   is_virtual=True)
    ## hash-function.h (module 'core'): uint64_t ns3::Hash::Function::Hash64::GetHash64(char const * buffer, std::size_t const size) [member function]
    cls.add_method('GetHash64',
                   'uint64_t',
                   [param('char const *', 'buffer'), param('std::size_t const', 'size')],
                   is_virtual=True)
    ## hash-function.h (module 'core'): void ns3::Hash::Function::Hash64::clear() [member function]
    cls.add_method('clear',
                   'void',
                   [],
                   is_virtual=True)
    return

def register_Ns3HashFunctionMurmur3_methods(root_module, cls):
    ## hash-murmur3.h (module 'core'): ns3::Hash::Function::Murmur3::Murmur3(ns3::Hash::Function::Murmur3 const & arg0) [constructor]
    cls.add_constructor([param('ns3::Hash::Function::Murmur3 const &', 'arg0')])
    ## hash-murmur3.h (module 'core'): ns3::Hash::Function::Murmur3::Murmur3() [constructor]
    cls.add_constructor([])
    ## hash-murmur3.h (module 'core'): uint32_t ns3::Hash::Function::Murmur3::GetHash32(char const * buffer, std::size_t const size) [member function]
    cls.add_method('GetHash32',
                   'uint32_t',
                   [param('char const *', 'buffer'), param('std::size_t const', 'size')],
                   is_virtual=True)
    ## hash-murmur3.h (module 'core'): uint64_t ns3::Hash::Function::Murmur3::GetHash64(char const * buffer, std::size_t const size) [member function]
    cls.add_method('GetHash64',
                   'uint64_t',
                   [param('char const *', 'buffer'), param('std::size_t const', 'size')],
                   is_virtual=True)
    ## hash-murmur3.h (module 'core'): void ns3::Hash::Function::Murmur3::clear() [member function]
    cls.add_method('clear',
                   'void',
                   [],
                   is_virtual=True)
    return

def register_Ns3MmwaveAntennaArrayModel_methods(root_module, cls):
    ## antenna-array-model.h (module 'mmwave'): ns3::mmwave::AntennaArrayModel::AntennaArrayModel(ns3::mmwave::AntennaArrayModel const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::AntennaArrayModel const &', 'arg0')])
    ## antenna-array-model.h (module 'mmwave'): ns3::mmwave::AntennaArrayModel::AntennaArrayModel() [constructor]
    cls.add_constructor([])
    ## antenna-array-model.h (module 'mmwave'): void ns3::mmwave::AntennaArrayModel::ChangeBeamformingVectorPanel(ns3::Ptr<ns3::NetDevice> device) [member function]
    cls.add_method('ChangeBeamformingVectorPanel',
                   'void',
                   [param('ns3::Ptr< ns3::NetDevice >', 'device')])
    ## antenna-array-model.h (module 'mmwave'): void ns3::mmwave::AntennaArrayModel::ChangeToOmniTx() [member function]
    cls.add_method('ChangeToOmniTx',
                   'void',
                   [])
    ## antenna-array-model.h (module 'mmwave'): ns3::Vector ns3::mmwave::AntennaArrayModel::GetAntennaLocation(uint8_t index, uint8_t * antennaNum) [member function]
    cls.add_method('GetAntennaLocation',
                   'ns3::Vector',
                   [param('uint8_t', 'index'), param('uint8_t *', 'antennaNum')])
    ## antenna-array-model.h (module 'mmwave'): ns3::mmwave::complexVector_t ns3::mmwave::AntennaArrayModel::GetBeamformingVectorPanel() [member function]
    cls.add_method('GetBeamformingVectorPanel',
                   'ns3::mmwave::complexVector_t',
                   [])
    ## antenna-array-model.h (module 'mmwave'): ns3::mmwave::complexVector_t ns3::mmwave::AntennaArrayModel::GetBeamformingVectorPanel(ns3::Ptr<ns3::NetDevice> device) [member function]
    cls.add_method('GetBeamformingVectorPanel',
                   'ns3::mmwave::complexVector_t',
                   [param('ns3::Ptr< ns3::NetDevice >', 'device')])
    ## antenna-array-model.h (module 'mmwave'): ns3::Ptr<ns3::NetDevice> ns3::mmwave::AntennaArrayModel::GetCurrentDevice() [member function]
    cls.add_method('GetCurrentDevice',
                   'ns3::Ptr< ns3::NetDevice >',
                   [])
    ## antenna-array-model.h (module 'mmwave'): double ns3::mmwave::AntennaArrayModel::GetGainDb(ns3::Angles a) [member function]
    cls.add_method('GetGainDb',
                   'double',
                   [param('ns3::Angles', 'a')],
                   is_virtual=True)
    ## antenna-array-model.h (module 'mmwave'): ns3::Time ns3::mmwave::AntennaArrayModel::GetLastUpdate(ns3::Ptr<ns3::NetDevice> device) [member function]
    cls.add_method('GetLastUpdate',
                   'ns3::Time',
                   [param('ns3::Ptr< ns3::NetDevice >', 'device')])
    ## antenna-array-model.h (module 'mmwave'): double ns3::mmwave::AntennaArrayModel::GetOffset() [member function]
    cls.add_method('GetOffset',
                   'double',
                   [])
    ## antenna-array-model.h (module 'mmwave'): double ns3::mmwave::AntennaArrayModel::GetPlanesId() [member function]
    cls.add_method('GetPlanesId',
                   'double',
                   [])
    ## antenna-array-model.h (module 'mmwave'): double ns3::mmwave::AntennaArrayModel::GetRadiationPattern(double vangle, double hangle=0) [member function]
    cls.add_method('GetRadiationPattern',
                   'double',
                   [param('double', 'vangle'), param('double', 'hangle', default_value='0')])
    ## antenna-array-model.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::AntennaArrayModel::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## antenna-array-model.h (module 'mmwave'): bool ns3::mmwave::AntennaArrayModel::IsOmniTx() [member function]
    cls.add_method('IsOmniTx',
                   'bool',
                   [])
    ## antenna-array-model.h (module 'mmwave'): void ns3::mmwave::AntennaArrayModel::SetBeamformingVectorPanel(ns3::mmwave::complexVector_t antennaWeights, ns3::Ptr<ns3::NetDevice> device=0) [member function]
    cls.add_method('SetBeamformingVectorPanel',
                   'void',
                   [param('std::vector< std::complex< double > >', 'antennaWeights'), param('ns3::Ptr< ns3::NetDevice >', 'device', default_value='0')])
    ## antenna-array-model.h (module 'mmwave'): void ns3::mmwave::AntennaArrayModel::SetBeamformingVectorPanelDevices(ns3::Ptr<ns3::NetDevice> thisDevice=0, ns3::Ptr<ns3::NetDevice> otherDevice=0) [member function]
    cls.add_method('SetBeamformingVectorPanelDevices',
                   'void',
                   [param('ns3::Ptr< ns3::NetDevice >', 'thisDevice', default_value='0'), param('ns3::Ptr< ns3::NetDevice >', 'otherDevice', default_value='0')])
    ## antenna-array-model.h (module 'mmwave'): void ns3::mmwave::AntennaArrayModel::SetBeamformingVectorWithDelay(ns3::mmwave::complexVector_t antennaWeights, ns3::Ptr<ns3::NetDevice> device=0) [member function]
    cls.add_method('SetBeamformingVectorWithDelay',
                   'void',
                   [param('std::vector< std::complex< double > >', 'antennaWeights'), param('ns3::Ptr< ns3::NetDevice >', 'device', default_value='0')])
    ## antenna-array-model.h (module 'mmwave'): void ns3::mmwave::AntennaArrayModel::SetDeviceType(bool isUe) [member function]
    cls.add_method('SetDeviceType',
                   'void',
                   [param('bool', 'isUe')])
    ## antenna-array-model.h (module 'mmwave'): void ns3::mmwave::AntennaArrayModel::SetPlanesNumber(double planesNumber) [member function]
    cls.add_method('SetPlanesNumber',
                   'void',
                   [param('double', 'planesNumber')])
    ## antenna-array-model.h (module 'mmwave'): void ns3::mmwave::AntennaArrayModel::SetSector(uint8_t sector, uint8_t * antennaNum, double elevation=90) [member function]
    cls.add_method('SetSector',
                   'void',
                   [param('uint8_t', 'sector'), param('uint8_t *', 'antennaNum'), param('double', 'elevation', default_value='90')])
    ## antenna-array-model.h (module 'mmwave'): void ns3::mmwave::AntennaArrayModel::SetTotNoArrayElements(double arrayElements) [member function]
    cls.add_method('SetTotNoArrayElements',
                   'void',
                   [param('double', 'arrayElements')])
    return

def register_Ns3MmwaveBeamformingParams_methods(root_module, cls):
    ## mmwave-beamforming.h (module 'mmwave'): ns3::mmwave::BeamformingParams::BeamformingParams() [constructor]
    cls.add_constructor([])
    ## mmwave-beamforming.h (module 'mmwave'): ns3::mmwave::BeamformingParams::BeamformingParams(ns3::mmwave::BeamformingParams const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::BeamformingParams const &', 'arg0')])
    ## mmwave-beamforming.h (module 'mmwave'): ns3::mmwave::BeamformingParams::m_beam [variable]
    cls.add_instance_attribute('m_beam', 'ns3::mmwave::complexVector_t *', is_const=False)
    ## mmwave-beamforming.h (module 'mmwave'): ns3::mmwave::BeamformingParams::m_channelMatrix [variable]
    cls.add_instance_attribute('m_channelMatrix', 'ns3::mmwave::channelMatrix', is_const=False)
    ## mmwave-beamforming.h (module 'mmwave'): ns3::mmwave::BeamformingParams::m_enbW [variable]
    cls.add_instance_attribute('m_enbW', 'ns3::mmwave::complexVector_t', is_const=False)
    ## mmwave-beamforming.h (module 'mmwave'): ns3::mmwave::BeamformingParams::m_ueW [variable]
    cls.add_instance_attribute('m_ueW', 'ns3::mmwave::complexVector_t', is_const=False)
    return

def register_Ns3MmwaveBuildingsObstaclePropagationLossModel_methods(root_module, cls):
    ## buildings-obstacle-propagation-loss-model.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::BuildingsObstaclePropagationLossModel::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## buildings-obstacle-propagation-loss-model.h (module 'mmwave'): ns3::mmwave::BuildingsObstaclePropagationLossModel::BuildingsObstaclePropagationLossModel() [constructor]
    cls.add_constructor([])
    ## buildings-obstacle-propagation-loss-model.h (module 'mmwave'): double ns3::mmwave::BuildingsObstaclePropagationLossModel::GetLoss(ns3::Ptr<ns3::MobilityModel> a, ns3::Ptr<ns3::MobilityModel> b) const [member function]
    cls.add_method('GetLoss',
                   'double',
                   [param('ns3::Ptr< ns3::MobilityModel >', 'a'), param('ns3::Ptr< ns3::MobilityModel >', 'b')],
                   is_const=True, is_virtual=True)
    ## buildings-obstacle-propagation-loss-model.h (module 'mmwave'): double ns3::mmwave::BuildingsObstaclePropagationLossModel::DoCalcRxPower(double txPowerDbm, ns3::Ptr<ns3::MobilityModel> a, ns3::Ptr<ns3::MobilityModel> b) const [member function]
    cls.add_method('DoCalcRxPower',
                   'double',
                   [param('double', 'txPowerDbm'), param('ns3::Ptr< ns3::MobilityModel >', 'a'), param('ns3::Ptr< ns3::MobilityModel >', 'b')],
                   is_const=True, is_virtual=True)
    ## buildings-obstacle-propagation-loss-model.h (module 'mmwave'): void ns3::mmwave::BuildingsObstaclePropagationLossModel::SetConfigurationParameters(ns3::Ptr<ns3::mmwave::MmWavePhyMacCommon> ptrConfig) [member function]
    cls.add_method('SetConfigurationParameters',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWavePhyMacCommon >', 'ptrConfig')])
    ## buildings-obstacle-propagation-loss-model.h (module 'mmwave'): void ns3::mmwave::BuildingsObstaclePropagationLossModel::SetBeamforming(ns3::Ptr<ns3::mmwave::MmWaveBeamforming> beamforming) [member function]
    cls.add_method('SetBeamforming',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWaveBeamforming >', 'beamforming')])
    ## buildings-obstacle-propagation-loss-model.h (module 'mmwave'): void ns3::mmwave::BuildingsObstaclePropagationLossModel::SetLosTracker(ns3::Ptr<ns3::mmwave::MmWaveLosTracker> losTracker) [member function]
    cls.add_method('SetLosTracker',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWaveLosTracker >', 'losTracker')])
    return

def register_Ns3MmwaveChannelParams_methods(root_module, cls):
    ## mmwave-channel-matrix.h (module 'mmwave'): ns3::mmwave::ChannelParams::ChannelParams() [constructor]
    cls.add_constructor([])
    ## mmwave-channel-matrix.h (module 'mmwave'): ns3::mmwave::ChannelParams::ChannelParams(ns3::mmwave::ChannelParams const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::ChannelParams const &', 'arg0')])
    ## mmwave-channel-matrix.h (module 'mmwave'): ns3::mmwave::ChannelParams::m_delaySpread [variable]
    cls.add_instance_attribute('m_delaySpread', 'ns3::mmwave::doubleVector_t', is_const=False)
    ## mmwave-channel-matrix.h (module 'mmwave'): ns3::mmwave::ChannelParams::m_doppler [variable]
    cls.add_instance_attribute('m_doppler', 'ns3::mmwave::doubleVector_t', is_const=False)
    ## mmwave-channel-matrix.h (module 'mmwave'): ns3::mmwave::ChannelParams::m_powerFraction [variable]
    cls.add_instance_attribute('m_powerFraction', 'ns3::mmwave::doubleVector_t', is_const=False)
    ## mmwave-channel-matrix.h (module 'mmwave'): ns3::mmwave::ChannelParams::m_rxSpatialMatrix [variable]
    cls.add_instance_attribute('m_rxSpatialMatrix', 'ns3::mmwave::complex2DVector_t', is_const=False)
    ## mmwave-channel-matrix.h (module 'mmwave'): ns3::mmwave::ChannelParams::m_txSpatialMatrix [variable]
    cls.add_instance_attribute('m_txSpatialMatrix', 'ns3::mmwave::complex2DVector_t', is_const=False)
    return

def register_Ns3MmwaveCoreNetworkStatsCalculator_methods(root_module, cls):
    ## core-network-stats-calculator.h (module 'mmwave'): ns3::mmwave::CoreNetworkStatsCalculator::CoreNetworkStatsCalculator() [constructor]
    cls.add_constructor([])
    ## core-network-stats-calculator.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::CoreNetworkStatsCalculator::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## core-network-stats-calculator.h (module 'mmwave'): void ns3::mmwave::CoreNetworkStatsCalculator::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## core-network-stats-calculator.h (module 'mmwave'): void ns3::mmwave::CoreNetworkStatsCalculator::LogX2Packet(std::string path, uint16_t sourceCellId, uint16_t targetCellId, uint32_t size, uint64_t delay, bool data) [member function]
    cls.add_method('LogX2Packet',
                   'void',
                   [param('std::string', 'path'), param('uint16_t', 'sourceCellId'), param('uint16_t', 'targetCellId'), param('uint32_t', 'size'), param('uint64_t', 'delay'), param('bool', 'data')])
    ## core-network-stats-calculator.h (module 'mmwave'): void ns3::mmwave::CoreNetworkStatsCalculator::LogMmePacket(std::string path, uint16_t sourceCellId, uint16_t targetCellId, uint32_t size, uint64_t delay) [member function]
    cls.add_method('LogMmePacket',
                   'void',
                   [param('std::string', 'path'), param('uint16_t', 'sourceCellId'), param('uint16_t', 'targetCellId'), param('uint32_t', 'size'), param('uint64_t', 'delay')])
    ## core-network-stats-calculator.h (module 'mmwave'): std::string ns3::mmwave::CoreNetworkStatsCalculator::GetX2OutputFilename() [member function]
    cls.add_method('GetX2OutputFilename',
                   'std::string',
                   [])
    ## core-network-stats-calculator.h (module 'mmwave'): std::string ns3::mmwave::CoreNetworkStatsCalculator::GetMmeOutputFilename() [member function]
    cls.add_method('GetMmeOutputFilename',
                   'std::string',
                   [])
    ## core-network-stats-calculator.h (module 'mmwave'): void ns3::mmwave::CoreNetworkStatsCalculator::SetX2OutputFilename(std::string outputFilename) [member function]
    cls.add_method('SetX2OutputFilename',
                   'void',
                   [param('std::string', 'outputFilename')])
    ## core-network-stats-calculator.h (module 'mmwave'): void ns3::mmwave::CoreNetworkStatsCalculator::SetMmeOutputFilename(std::string outputFilename) [member function]
    cls.add_method('SetMmeOutputFilename',
                   'void',
                   [param('std::string', 'outputFilename')])
    return

def register_Ns3MmwaveDciInfoElement_methods(root_module, cls):
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DciInfoElement::DciInfoElement(ns3::mmwave::DciInfoElement const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::DciInfoElement const &', 'arg0')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DciInfoElement::DciInfoElement() [constructor]
    cls.add_constructor([])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DciInfoElement::m_cceIndex [variable]
    cls.add_instance_attribute('m_cceIndex', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DciInfoElement::m_format [variable]
    cls.add_instance_attribute('m_format', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DciInfoElement::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DciInfoElement::m_tbInfoElements [variable]
    cls.add_instance_attribute('m_tbInfoElements', 'std::vector< ns3::mmwave::TbInfoElement >', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DciInfoElement::m_tddBitmap [variable]
    cls.add_instance_attribute('m_tddBitmap', 'uint16_t', is_const=False)
    return

def register_Ns3MmwaveDciInfoElementTdma_methods(root_module, cls):
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DciInfoElementTdma::DciInfoElementTdma(ns3::mmwave::DciInfoElementTdma const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::DciInfoElementTdma const &', 'arg0')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DciInfoElementTdma::DciInfoElementTdma() [constructor]
    cls.add_constructor([])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DciInfoElementTdma::DciInfoElementTdma(uint16_t rnti, uint8_t format, uint8_t symStart, uint8_t numSym, uint8_t mcs, uint32_t tbs, uint8_t ndi, uint8_t rv, uint8_t harqProc) [constructor]
    cls.add_constructor([param('uint16_t', 'rnti'), param('uint8_t', 'format'), param('uint8_t', 'symStart'), param('uint8_t', 'numSym'), param('uint8_t', 'mcs'), param('uint32_t', 'tbs'), param('uint8_t', 'ndi'), param('uint8_t', 'rv'), param('uint8_t', 'harqProc')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DciInfoElementTdma::m_format [variable]
    cls.add_instance_attribute('m_format', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DciInfoElementTdma::m_harqProcess [variable]
    cls.add_instance_attribute('m_harqProcess', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DciInfoElementTdma::m_mcs [variable]
    cls.add_instance_attribute('m_mcs', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DciInfoElementTdma::m_ndi [variable]
    cls.add_instance_attribute('m_ndi', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DciInfoElementTdma::m_numSym [variable]
    cls.add_instance_attribute('m_numSym', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DciInfoElementTdma::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DciInfoElementTdma::m_rv [variable]
    cls.add_instance_attribute('m_rv', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DciInfoElementTdma::m_symStart [variable]
    cls.add_instance_attribute('m_symStart', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DciInfoElementTdma::m_tbSize [variable]
    cls.add_instance_attribute('m_tbSize', 'uint32_t', is_const=False)
    return

def register_Ns3MmwaveDlCqiInfo_methods(root_module, cls):
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DlCqiInfo::DlCqiInfo() [constructor]
    cls.add_constructor([])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DlCqiInfo::DlCqiInfo(ns3::mmwave::DlCqiInfo const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::DlCqiInfo const &', 'arg0')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DlCqiInfo::m_cqiType [variable]
    cls.add_instance_attribute('m_cqiType', 'ns3::mmwave::DlCqiInfo::DlCqiType', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DlCqiInfo::m_rbCqi [variable]
    cls.add_instance_attribute('m_rbCqi', 'std::vector< unsigned char >', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DlCqiInfo::m_ri [variable]
    cls.add_instance_attribute('m_ri', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DlCqiInfo::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DlCqiInfo::m_wbCqi [variable]
    cls.add_instance_attribute('m_wbCqi', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DlCqiInfo::m_wbPmi [variable]
    cls.add_instance_attribute('m_wbPmi', 'uint8_t', is_const=False)
    return

def register_Ns3MmwaveDlDciInfoElementTdma_methods(root_module, cls):
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DlDciInfoElementTdma::DlDciInfoElementTdma(ns3::mmwave::DlDciInfoElementTdma const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::DlDciInfoElementTdma const &', 'arg0')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DlDciInfoElementTdma::DlDciInfoElementTdma() [constructor]
    cls.add_constructor([])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DlDciInfoElementTdma::m_harqProcess [variable]
    cls.add_instance_attribute('m_harqProcess', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DlDciInfoElementTdma::m_mcs [variable]
    cls.add_instance_attribute('m_mcs', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DlDciInfoElementTdma::m_ndi [variable]
    cls.add_instance_attribute('m_ndi', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DlDciInfoElementTdma::m_numSym [variable]
    cls.add_instance_attribute('m_numSym', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DlDciInfoElementTdma::m_rv [variable]
    cls.add_instance_attribute('m_rv', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DlDciInfoElementTdma::m_symStart [variable]
    cls.add_instance_attribute('m_symStart', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DlDciInfoElementTdma::m_tbSize [variable]
    cls.add_instance_attribute('m_tbSize', 'uint32_t', is_const=False)
    return

def register_Ns3MmwaveDlHarqInfo_methods(root_module, cls):
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DlHarqInfo::DlHarqInfo() [constructor]
    cls.add_constructor([])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DlHarqInfo::DlHarqInfo(ns3::mmwave::DlHarqInfo const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::DlHarqInfo const &', 'arg0')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DlHarqInfo::m_harqProcessId [variable]
    cls.add_instance_attribute('m_harqProcessId', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DlHarqInfo::m_harqStatus [variable]
    cls.add_instance_attribute('m_harqStatus', 'ns3::mmwave::DlHarqInfo::HarqStatus', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DlHarqInfo::m_numRetx [variable]
    cls.add_instance_attribute('m_numRetx', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::DlHarqInfo::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    return

def register_Ns3MmwaveEnbPhyPacketCountParameter_methods(root_module, cls):
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::EnbPhyPacketCountParameter::EnbPhyPacketCountParameter() [constructor]
    cls.add_constructor([])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::EnbPhyPacketCountParameter::EnbPhyPacketCountParameter(ns3::mmwave::EnbPhyPacketCountParameter const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::EnbPhyPacketCountParameter const &', 'arg0')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::EnbPhyPacketCountParameter::m_cellId [variable]
    cls.add_instance_attribute('m_cellId', 'uint64_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::EnbPhyPacketCountParameter::m_isTx [variable]
    cls.add_instance_attribute('m_isTx', 'bool', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::EnbPhyPacketCountParameter::m_noBytes [variable]
    cls.add_instance_attribute('m_noBytes', 'uint32_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::EnbPhyPacketCountParameter::m_subframeno [variable]
    cls.add_instance_attribute('m_subframeno', 'uint32_t', is_const=False)
    return

def register_Ns3MmwaveExpectedTbInfo_t_methods(root_module, cls):
    ## mmwave-spectrum-phy.h (module 'mmwave'): ns3::mmwave::ExpectedTbInfo_t::ExpectedTbInfo_t() [constructor]
    cls.add_constructor([])
    ## mmwave-spectrum-phy.h (module 'mmwave'): ns3::mmwave::ExpectedTbInfo_t::ExpectedTbInfo_t(ns3::mmwave::ExpectedTbInfo_t const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::ExpectedTbInfo_t const &', 'arg0')])
    ## mmwave-spectrum-phy.h (module 'mmwave'): ns3::mmwave::ExpectedTbInfo_t::corrupt [variable]
    cls.add_instance_attribute('corrupt', 'bool', is_const=False)
    ## mmwave-spectrum-phy.h (module 'mmwave'): ns3::mmwave::ExpectedTbInfo_t::downlink [variable]
    cls.add_instance_attribute('downlink', 'bool', is_const=False)
    ## mmwave-spectrum-phy.h (module 'mmwave'): ns3::mmwave::ExpectedTbInfo_t::harqFeedbackSent [variable]
    cls.add_instance_attribute('harqFeedbackSent', 'bool', is_const=False)
    ## mmwave-spectrum-phy.h (module 'mmwave'): ns3::mmwave::ExpectedTbInfo_t::harqProcessId [variable]
    cls.add_instance_attribute('harqProcessId', 'uint8_t', is_const=False)
    ## mmwave-spectrum-phy.h (module 'mmwave'): ns3::mmwave::ExpectedTbInfo_t::mcs [variable]
    cls.add_instance_attribute('mcs', 'uint8_t', is_const=False)
    ## mmwave-spectrum-phy.h (module 'mmwave'): ns3::mmwave::ExpectedTbInfo_t::mi [variable]
    cls.add_instance_attribute('mi', 'double', is_const=False)
    ## mmwave-spectrum-phy.h (module 'mmwave'): ns3::mmwave::ExpectedTbInfo_t::ndi [variable]
    cls.add_instance_attribute('ndi', 'uint8_t', is_const=False)
    ## mmwave-spectrum-phy.h (module 'mmwave'): ns3::mmwave::ExpectedTbInfo_t::numSym [variable]
    cls.add_instance_attribute('numSym', 'uint8_t', is_const=False)
    ## mmwave-spectrum-phy.h (module 'mmwave'): ns3::mmwave::ExpectedTbInfo_t::rbBitmap [variable]
    cls.add_instance_attribute('rbBitmap', 'std::vector< int >', is_const=False)
    ## mmwave-spectrum-phy.h (module 'mmwave'): ns3::mmwave::ExpectedTbInfo_t::rv [variable]
    cls.add_instance_attribute('rv', 'uint8_t', is_const=False)
    ## mmwave-spectrum-phy.h (module 'mmwave'): ns3::mmwave::ExpectedTbInfo_t::size [variable]
    cls.add_instance_attribute('size', 'uint16_t', is_const=False)
    ## mmwave-spectrum-phy.h (module 'mmwave'): ns3::mmwave::ExpectedTbInfo_t::symStart [variable]
    cls.add_instance_attribute('symStart', 'uint8_t', is_const=False)
    ## mmwave-spectrum-phy.h (module 'mmwave'): ns3::mmwave::ExpectedTbInfo_t::tbler [variable]
    cls.add_instance_attribute('tbler', 'double', is_const=False)
    return

def register_Ns3MmwaveMacCeElement_methods(root_module, cls):
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::MacCeElement::MacCeElement() [constructor]
    cls.add_constructor([])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::MacCeElement::MacCeElement(ns3::mmwave::MacCeElement const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MacCeElement const &', 'arg0')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::MacCeElement::m_macCeType [variable]
    cls.add_instance_attribute('m_macCeType', 'ns3::mmwave::MacCeElement::MacCeType', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::MacCeElement::m_macCeValue [variable]
    cls.add_instance_attribute('m_macCeValue', 'ns3::mmwave::MacCeValue', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::MacCeElement::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    return

def register_Ns3MmwaveMacCeValue_methods(root_module, cls):
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::MacCeValue::MacCeValue() [constructor]
    cls.add_constructor([])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::MacCeValue::MacCeValue(ns3::mmwave::MacCeValue const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MacCeValue const &', 'arg0')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::MacCeValue::m_bufferStatus [variable]
    cls.add_instance_attribute('m_bufferStatus', 'std::vector< unsigned char >', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::MacCeValue::m_crnti [variable]
    cls.add_instance_attribute('m_crnti', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::MacCeValue::m_phr [variable]
    cls.add_instance_attribute('m_phr', 'uint8_t', is_const=False)
    return

def register_Ns3MmwaveMacPduInfo_methods(root_module, cls):
    ## mmwave-mac.h (module 'mmwave'): ns3::mmwave::MacPduInfo::MacPduInfo(ns3::mmwave::MacPduInfo const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MacPduInfo const &', 'arg0')])
    ## mmwave-mac.h (module 'mmwave'): ns3::mmwave::MacPduInfo::MacPduInfo(ns3::mmwave::SfnSf sfn, uint32_t size, uint8_t numRlcPdu) [constructor]
    cls.add_constructor([param('ns3::mmwave::SfnSf', 'sfn'), param('uint32_t', 'size'), param('uint8_t', 'numRlcPdu')])
    ## mmwave-mac.h (module 'mmwave'): ns3::mmwave::MacPduInfo::MacPduInfo(ns3::mmwave::SfnSf sfn, uint32_t size, uint8_t numRlcPdu, ns3::mmwave::DciInfoElementTdma dci) [constructor]
    cls.add_constructor([param('ns3::mmwave::SfnSf', 'sfn'), param('uint32_t', 'size'), param('uint8_t', 'numRlcPdu'), param('ns3::mmwave::DciInfoElementTdma', 'dci')])
    ## mmwave-mac.h (module 'mmwave'): ns3::mmwave::MacPduInfo::m_macHeader [variable]
    cls.add_instance_attribute('m_macHeader', 'ns3::mmwave::MmWaveMacPduHeader', is_const=False)
    ## mmwave-mac.h (module 'mmwave'): ns3::mmwave::MacPduInfo::m_numRlcPdu [variable]
    cls.add_instance_attribute('m_numRlcPdu', 'uint8_t', is_const=False)
    ## mmwave-mac.h (module 'mmwave'): ns3::mmwave::MacPduInfo::m_pdu [variable]
    cls.add_instance_attribute('m_pdu', 'ns3::Ptr< ns3::Packet >', is_const=False)
    ## mmwave-mac.h (module 'mmwave'): ns3::mmwave::MacPduInfo::m_sfnSf [variable]
    cls.add_instance_attribute('m_sfnSf', 'ns3::mmwave::SfnSf', is_const=False)
    ## mmwave-mac.h (module 'mmwave'): ns3::mmwave::MacPduInfo::m_size [variable]
    cls.add_instance_attribute('m_size', 'uint32_t', is_const=False)
    return

def register_Ns3MmwaveMacSubheader_methods(root_module, cls):
    ## mmwave-mac-pdu-header.h (module 'mmwave'): ns3::mmwave::MacSubheader::MacSubheader(ns3::mmwave::MacSubheader const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MacSubheader const &', 'arg0')])
    ## mmwave-mac-pdu-header.h (module 'mmwave'): ns3::mmwave::MacSubheader::MacSubheader() [constructor]
    cls.add_constructor([])
    ## mmwave-mac-pdu-header.h (module 'mmwave'): ns3::mmwave::MacSubheader::MacSubheader(uint8_t lcid, uint16_t size) [constructor]
    cls.add_constructor([param('uint8_t', 'lcid'), param('uint16_t', 'size')])
    ## mmwave-mac-pdu-header.h (module 'mmwave'): uint32_t ns3::mmwave::MacSubheader::GetSize() [member function]
    cls.add_method('GetSize',
                   'uint32_t',
                   [])
    ## mmwave-mac-pdu-header.h (module 'mmwave'): ns3::mmwave::MacSubheader::m_lcid [variable]
    cls.add_instance_attribute('m_lcid', 'uint8_t', is_const=False)
    ## mmwave-mac-pdu-header.h (module 'mmwave'): ns3::mmwave::MacSubheader::m_size [variable]
    cls.add_instance_attribute('m_size', 'uint32_t', is_const=False)
    return

def register_Ns3MmwaveMcStatsCalculator_methods(root_module, cls):
    ## mc-stats-calculator.h (module 'mmwave'): ns3::mmwave::McStatsCalculator::McStatsCalculator() [constructor]
    cls.add_constructor([])
    ## mc-stats-calculator.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::McStatsCalculator::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mc-stats-calculator.h (module 'mmwave'): void ns3::mmwave::McStatsCalculator::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## mc-stats-calculator.h (module 'mmwave'): std::string ns3::mmwave::McStatsCalculator::GetLteOutputFilename() [member function]
    cls.add_method('GetLteOutputFilename',
                   'std::string',
                   [])
    ## mc-stats-calculator.h (module 'mmwave'): std::string ns3::mmwave::McStatsCalculator::GetMmWaveOutputFilename() [member function]
    cls.add_method('GetMmWaveOutputFilename',
                   'std::string',
                   [])
    ## mc-stats-calculator.h (module 'mmwave'): std::string ns3::mmwave::McStatsCalculator::GetCellIdInTimeOutputFilename() [member function]
    cls.add_method('GetCellIdInTimeOutputFilename',
                   'std::string',
                   [])
    ## mc-stats-calculator.h (module 'mmwave'): void ns3::mmwave::McStatsCalculator::SetLteOutputFilename(std::string outputFilename) [member function]
    cls.add_method('SetLteOutputFilename',
                   'void',
                   [param('std::string', 'outputFilename')])
    ## mc-stats-calculator.h (module 'mmwave'): void ns3::mmwave::McStatsCalculator::SetMmWaveOutputFilename(std::string outputFilename) [member function]
    cls.add_method('SetMmWaveOutputFilename',
                   'void',
                   [param('std::string', 'outputFilename')])
    ## mc-stats-calculator.h (module 'mmwave'): void ns3::mmwave::McStatsCalculator::SetCellIdInTimeOutputFilename(std::string outputFilename) [member function]
    cls.add_method('SetCellIdInTimeOutputFilename',
                   'void',
                   [param('std::string', 'outputFilename')])
    ## mc-stats-calculator.h (module 'mmwave'): void ns3::mmwave::McStatsCalculator::SwitchToLte(uint64_t imsi, uint16_t cellId, uint16_t rnti) [member function]
    cls.add_method('SwitchToLte',
                   'void',
                   [param('uint64_t', 'imsi'), param('uint16_t', 'cellId'), param('uint16_t', 'rnti')])
    ## mc-stats-calculator.h (module 'mmwave'): void ns3::mmwave::McStatsCalculator::SwitchToMmWave(uint64_t imsi, uint16_t cellId, uint16_t rnti) [member function]
    cls.add_method('SwitchToMmWave',
                   'void',
                   [param('uint64_t', 'imsi'), param('uint16_t', 'cellId'), param('uint16_t', 'rnti')])
    return

def register_Ns3MmwaveMcUeNetDevice_methods(root_module, cls):
    ## mc-ue-net-device.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::McUeNetDevice::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mc-ue-net-device.h (module 'mmwave'): ns3::mmwave::McUeNetDevice::McUeNetDevice() [constructor]
    cls.add_constructor([])
    ## mc-ue-net-device.h (module 'mmwave'): void ns3::mmwave::McUeNetDevice::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## mc-ue-net-device.h (module 'mmwave'): void ns3::mmwave::McUeNetDevice::SetIfIndex(uint32_t const index) [member function]
    cls.add_method('SetIfIndex',
                   'void',
                   [param('uint32_t const', 'index')],
                   is_virtual=True)
    ## mc-ue-net-device.h (module 'mmwave'): uint32_t ns3::mmwave::McUeNetDevice::GetIfIndex() const [member function]
    cls.add_method('GetIfIndex',
                   'uint32_t',
                   [],
                   is_const=True, is_virtual=True)
    ## mc-ue-net-device.h (module 'mmwave'): ns3::Ptr<ns3::Channel> ns3::mmwave::McUeNetDevice::GetChannel() const [member function]
    cls.add_method('GetChannel',
                   'ns3::Ptr< ns3::Channel >',
                   [],
                   is_const=True, is_virtual=True)
    ## mc-ue-net-device.h (module 'mmwave'): void ns3::mmwave::McUeNetDevice::SetAddress(ns3::Address address) [member function]
    cls.add_method('SetAddress',
                   'void',
                   [param('ns3::Address', 'address')],
                   is_virtual=True)
    ## mc-ue-net-device.h (module 'mmwave'): ns3::Address ns3::mmwave::McUeNetDevice::GetAddress() const [member function]
    cls.add_method('GetAddress',
                   'ns3::Address',
                   [],
                   is_const=True, is_virtual=True)
    ## mc-ue-net-device.h (module 'mmwave'): bool ns3::mmwave::McUeNetDevice::SetMtu(uint16_t const mtu) [member function]
    cls.add_method('SetMtu',
                   'bool',
                   [param('uint16_t const', 'mtu')],
                   is_virtual=True)
    ## mc-ue-net-device.h (module 'mmwave'): uint16_t ns3::mmwave::McUeNetDevice::GetMtu() const [member function]
    cls.add_method('GetMtu',
                   'uint16_t',
                   [],
                   is_const=True, is_virtual=True)
    ## mc-ue-net-device.h (module 'mmwave'): bool ns3::mmwave::McUeNetDevice::IsLinkUp() const [member function]
    cls.add_method('IsLinkUp',
                   'bool',
                   [],
                   is_const=True, is_virtual=True)
    ## mc-ue-net-device.h (module 'mmwave'): void ns3::mmwave::McUeNetDevice::AddLinkChangeCallback(ns3::Callback<void, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> callback) [member function]
    cls.add_method('AddLinkChangeCallback',
                   'void',
                   [param('ns3::Callback< void, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'callback')],
                   is_virtual=True)
    ## mc-ue-net-device.h (module 'mmwave'): bool ns3::mmwave::McUeNetDevice::IsBroadcast() const [member function]
    cls.add_method('IsBroadcast',
                   'bool',
                   [],
                   is_const=True, is_virtual=True)
    ## mc-ue-net-device.h (module 'mmwave'): ns3::Address ns3::mmwave::McUeNetDevice::GetBroadcast() const [member function]
    cls.add_method('GetBroadcast',
                   'ns3::Address',
                   [],
                   is_const=True, is_virtual=True)
    ## mc-ue-net-device.h (module 'mmwave'): bool ns3::mmwave::McUeNetDevice::IsMulticast() const [member function]
    cls.add_method('IsMulticast',
                   'bool',
                   [],
                   is_const=True, is_virtual=True)
    ## mc-ue-net-device.h (module 'mmwave'): ns3::Address ns3::mmwave::McUeNetDevice::GetMulticast(ns3::Ipv4Address multicastGroup) const [member function]
    cls.add_method('GetMulticast',
                   'ns3::Address',
                   [param('ns3::Ipv4Address', 'multicastGroup')],
                   is_const=True, is_virtual=True)
    ## mc-ue-net-device.h (module 'mmwave'): bool ns3::mmwave::McUeNetDevice::IsBridge() const [member function]
    cls.add_method('IsBridge',
                   'bool',
                   [],
                   is_const=True, is_virtual=True)
    ## mc-ue-net-device.h (module 'mmwave'): bool ns3::mmwave::McUeNetDevice::IsPointToPoint() const [member function]
    cls.add_method('IsPointToPoint',
                   'bool',
                   [],
                   is_const=True, is_virtual=True)
    ## mc-ue-net-device.h (module 'mmwave'): bool ns3::mmwave::McUeNetDevice::SendFrom(ns3::Ptr<ns3::Packet> packet, ns3::Address const & source, ns3::Address const & dest, uint16_t protocolNumber) [member function]
    cls.add_method('SendFrom',
                   'bool',
                   [param('ns3::Ptr< ns3::Packet >', 'packet'), param('ns3::Address const &', 'source'), param('ns3::Address const &', 'dest'), param('uint16_t', 'protocolNumber')],
                   is_virtual=True)
    ## mc-ue-net-device.h (module 'mmwave'): ns3::Ptr<ns3::Node> ns3::mmwave::McUeNetDevice::GetNode() const [member function]
    cls.add_method('GetNode',
                   'ns3::Ptr< ns3::Node >',
                   [],
                   is_const=True, is_virtual=True)
    ## mc-ue-net-device.h (module 'mmwave'): void ns3::mmwave::McUeNetDevice::SetNode(ns3::Ptr<ns3::Node> node) [member function]
    cls.add_method('SetNode',
                   'void',
                   [param('ns3::Ptr< ns3::Node >', 'node')],
                   is_virtual=True)
    ## mc-ue-net-device.h (module 'mmwave'): bool ns3::mmwave::McUeNetDevice::NeedsArp() const [member function]
    cls.add_method('NeedsArp',
                   'bool',
                   [],
                   is_const=True, is_virtual=True)
    ## mc-ue-net-device.h (module 'mmwave'): ns3::Address ns3::mmwave::McUeNetDevice::GetMulticast(ns3::Ipv6Address addr) const [member function]
    cls.add_method('GetMulticast',
                   'ns3::Address',
                   [param('ns3::Ipv6Address', 'addr')],
                   is_const=True, is_virtual=True)
    ## mc-ue-net-device.h (module 'mmwave'): void ns3::mmwave::McUeNetDevice::SetReceiveCallback(ns3::NetDevice::ReceiveCallback cb) [member function]
    cls.add_method('SetReceiveCallback',
                   'void',
                   [param('ns3::Callback< bool, ns3::Ptr< ns3::NetDevice >, ns3::Ptr< ns3::Packet const >, unsigned short, ns3::Address const &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'cb')],
                   is_virtual=True)
    ## mc-ue-net-device.h (module 'mmwave'): void ns3::mmwave::McUeNetDevice::SetPromiscReceiveCallback(ns3::NetDevice::PromiscReceiveCallback cb) [member function]
    cls.add_method('SetPromiscReceiveCallback',
                   'void',
                   [param('ns3::Callback< bool, ns3::Ptr< ns3::NetDevice >, ns3::Ptr< ns3::Packet const >, unsigned short, ns3::Address const &, ns3::Address const &, ns3::NetDevice::PacketType, ns3::empty, ns3::empty, ns3::empty >', 'cb')],
                   is_virtual=True)
    ## mc-ue-net-device.h (module 'mmwave'): bool ns3::mmwave::McUeNetDevice::SupportsSendFrom() const [member function]
    cls.add_method('SupportsSendFrom',
                   'bool',
                   [],
                   is_const=True, is_virtual=True)
    ## mc-ue-net-device.h (module 'mmwave'): bool ns3::mmwave::McUeNetDevice::Send(ns3::Ptr<ns3::Packet> packet, ns3::Address const & dest, uint16_t protocolNumber) [member function]
    cls.add_method('Send',
                   'bool',
                   [param('ns3::Ptr< ns3::Packet >', 'packet'), param('ns3::Address const &', 'dest'), param('uint16_t', 'protocolNumber')],
                   is_virtual=True)
    ## mc-ue-net-device.h (module 'mmwave'): ns3::Ipv4Address ns3::mmwave::McUeNetDevice::GetPacketDestination(ns3::Ptr<ns3::Packet> packet) [member function]
    cls.add_method('GetPacketDestination',
                   'ns3::Ipv4Address',
                   [param('ns3::Ptr< ns3::Packet >', 'packet')])
    ## mc-ue-net-device.h (module 'mmwave'): void ns3::mmwave::McUeNetDevice::Receive(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('Receive',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'p')])
    ## mc-ue-net-device.h (module 'mmwave'): uint32_t ns3::mmwave::McUeNetDevice::GetCsgId() const [member function]
    cls.add_method('GetCsgId',
                   'uint32_t',
                   [],
                   is_const=True)
    ## mc-ue-net-device.h (module 'mmwave'): void ns3::mmwave::McUeNetDevice::SetCsgId(uint32_t csgId) [member function]
    cls.add_method('SetCsgId',
                   'void',
                   [param('uint32_t', 'csgId')])
    ## mc-ue-net-device.h (module 'mmwave'): ns3::Ptr<ns3::EpcUeNas> ns3::mmwave::McUeNetDevice::GetNas() const [member function]
    cls.add_method('GetNas',
                   'ns3::Ptr< ns3::EpcUeNas >',
                   [],
                   is_const=True)
    ## mc-ue-net-device.h (module 'mmwave'): uint64_t ns3::mmwave::McUeNetDevice::GetImsi() const [member function]
    cls.add_method('GetImsi',
                   'uint64_t',
                   [],
                   is_const=True)
    ## mc-ue-net-device.h (module 'mmwave'): ns3::Ptr<ns3::LteUeMac> ns3::mmwave::McUeNetDevice::GetLteMac() const [member function]
    cls.add_method('GetLteMac',
                   'ns3::Ptr< ns3::LteUeMac >',
                   [],
                   is_const=True)
    ## mc-ue-net-device.h (module 'mmwave'): ns3::Ptr<ns3::LteUeMac> ns3::mmwave::McUeNetDevice::GetLteMac(uint8_t index) const [member function]
    cls.add_method('GetLteMac',
                   'ns3::Ptr< ns3::LteUeMac >',
                   [param('uint8_t', 'index')],
                   is_const=True)
    ## mc-ue-net-device.h (module 'mmwave'): ns3::Ptr<ns3::LteUeRrc> ns3::mmwave::McUeNetDevice::GetLteRrc() const [member function]
    cls.add_method('GetLteRrc',
                   'ns3::Ptr< ns3::LteUeRrc >',
                   [],
                   is_const=True)
    ## mc-ue-net-device.h (module 'mmwave'): ns3::Ptr<ns3::LteUeComponentCarrierManager> ns3::mmwave::McUeNetDevice::GetLteComponentCarrierManager() const [member function]
    cls.add_method('GetLteComponentCarrierManager',
                   'ns3::Ptr< ns3::LteUeComponentCarrierManager >',
                   [],
                   is_const=True)
    ## mc-ue-net-device.h (module 'mmwave'): ns3::Ptr<ns3::LteUePhy> ns3::mmwave::McUeNetDevice::GetLtePhy() const [member function]
    cls.add_method('GetLtePhy',
                   'ns3::Ptr< ns3::LteUePhy >',
                   [],
                   is_const=True)
    ## mc-ue-net-device.h (module 'mmwave'): ns3::Ptr<ns3::LteUePhy> ns3::mmwave::McUeNetDevice::GetLtePhy(uint8_t index) const [member function]
    cls.add_method('GetLtePhy',
                   'ns3::Ptr< ns3::LteUePhy >',
                   [param('uint8_t', 'index')],
                   is_const=True)
    ## mc-ue-net-device.h (module 'mmwave'): std::map<unsigned char, ns3::Ptr<ns3::ComponentCarrierUe>, std::less<unsigned char>, std::allocator<std::pair<const unsigned char, ns3::Ptr<ns3::ComponentCarrierUe> > > > ns3::mmwave::McUeNetDevice::GetLteCcMap() [member function]
    cls.add_method('GetLteCcMap',
                   'std::map< unsigned char, ns3::Ptr< ns3::ComponentCarrierUe > >',
                   [])
    ## mc-ue-net-device.h (module 'mmwave'): void ns3::mmwave::McUeNetDevice::SetLteCcMap(std::map<unsigned char, ns3::Ptr<ns3::ComponentCarrierUe>, std::less<unsigned char>, std::allocator<std::pair<const unsigned char, ns3::Ptr<ns3::ComponentCarrierUe> > > > ccm) [member function]
    cls.add_method('SetLteCcMap',
                   'void',
                   [param('std::map< unsigned char, ns3::Ptr< ns3::ComponentCarrierUe > >', 'ccm')])
    ## mc-ue-net-device.h (module 'mmwave'): uint16_t ns3::mmwave::McUeNetDevice::GetLteDlEarfcn() const [member function]
    cls.add_method('GetLteDlEarfcn',
                   'uint16_t',
                   [],
                   is_const=True)
    ## mc-ue-net-device.h (module 'mmwave'): void ns3::mmwave::McUeNetDevice::SetLteDlEarfcn(uint16_t earfcn) [member function]
    cls.add_method('SetLteDlEarfcn',
                   'void',
                   [param('uint16_t', 'earfcn')])
    ## mc-ue-net-device.h (module 'mmwave'): void ns3::mmwave::McUeNetDevice::SetLteTargetEnb(ns3::Ptr<ns3::LteEnbNetDevice> enb) [member function]
    cls.add_method('SetLteTargetEnb',
                   'void',
                   [param('ns3::Ptr< ns3::LteEnbNetDevice >', 'enb')])
    ## mc-ue-net-device.h (module 'mmwave'): ns3::Ptr<ns3::LteEnbNetDevice> ns3::mmwave::McUeNetDevice::GetLteTargetEnb() [member function]
    cls.add_method('GetLteTargetEnb',
                   'ns3::Ptr< ns3::LteEnbNetDevice >',
                   [])
    ## mc-ue-net-device.h (module 'mmwave'): ns3::Ptr<ns3::mmwave::MmWaveUePhy> ns3::mmwave::McUeNetDevice::GetMmWavePhy() const [member function]
    cls.add_method('GetMmWavePhy',
                   'ns3::Ptr< ns3::mmwave::MmWaveUePhy >',
                   [],
                   is_const=True)
    ## mc-ue-net-device.h (module 'mmwave'): ns3::Ptr<ns3::mmwave::MmWaveUePhy> ns3::mmwave::McUeNetDevice::GetMmWavePhy(uint8_t index) const [member function]
    cls.add_method('GetMmWavePhy',
                   'ns3::Ptr< ns3::mmwave::MmWaveUePhy >',
                   [param('uint8_t', 'index')],
                   is_const=True)
    ## mc-ue-net-device.h (module 'mmwave'): ns3::Ptr<ns3::mmwave::MmWaveUeMac> ns3::mmwave::McUeNetDevice::GetMmWaveMac() const [member function]
    cls.add_method('GetMmWaveMac',
                   'ns3::Ptr< ns3::mmwave::MmWaveUeMac >',
                   [],
                   is_const=True)
    ## mc-ue-net-device.h (module 'mmwave'): ns3::Ptr<ns3::mmwave::MmWaveUeMac> ns3::mmwave::McUeNetDevice::GetMmWaveMac(uint8_t index) const [member function]
    cls.add_method('GetMmWaveMac',
                   'ns3::Ptr< ns3::mmwave::MmWaveUeMac >',
                   [param('uint8_t', 'index')],
                   is_const=True)
    ## mc-ue-net-device.h (module 'mmwave'): std::map<unsigned char, ns3::Ptr<ns3::mmwave::MmWaveComponentCarrierUe>, std::less<unsigned char>, std::allocator<std::pair<const unsigned char, ns3::Ptr<ns3::mmwave::MmWaveComponentCarrierUe> > > > ns3::mmwave::McUeNetDevice::GetMmWaveCcMap() [member function]
    cls.add_method('GetMmWaveCcMap',
                   'std::map< unsigned char, ns3::Ptr< ns3::mmwave::MmWaveComponentCarrierUe > >',
                   [])
    ## mc-ue-net-device.h (module 'mmwave'): void ns3::mmwave::McUeNetDevice::SetMmWaveCcMap(std::map<unsigned char, ns3::Ptr<ns3::mmwave::MmWaveComponentCarrierUe>, std::less<unsigned char>, std::allocator<std::pair<const unsigned char, ns3::Ptr<ns3::mmwave::MmWaveComponentCarrierUe> > > > ccm) [member function]
    cls.add_method('SetMmWaveCcMap',
                   'void',
                   [param('std::map< unsigned char, ns3::Ptr< ns3::mmwave::MmWaveComponentCarrierUe > >', 'ccm')])
    ## mc-ue-net-device.h (module 'mmwave'): ns3::Ptr<ns3::LteUeRrc> ns3::mmwave::McUeNetDevice::GetMmWaveRrc() const [member function]
    cls.add_method('GetMmWaveRrc',
                   'ns3::Ptr< ns3::LteUeRrc >',
                   [],
                   is_const=True)
    ## mc-ue-net-device.h (module 'mmwave'): ns3::Ptr<ns3::LteUeComponentCarrierManager> ns3::mmwave::McUeNetDevice::GetMmWaveComponentCarrierManager() const [member function]
    cls.add_method('GetMmWaveComponentCarrierManager',
                   'ns3::Ptr< ns3::LteUeComponentCarrierManager >',
                   [],
                   is_const=True)
    ## mc-ue-net-device.h (module 'mmwave'): uint16_t ns3::mmwave::McUeNetDevice::GetMmWaveEarfcn() const [member function]
    cls.add_method('GetMmWaveEarfcn',
                   'uint16_t',
                   [],
                   is_const=True)
    ## mc-ue-net-device.h (module 'mmwave'): void ns3::mmwave::McUeNetDevice::SetMmWaveEarfcn(uint16_t earfcn) [member function]
    cls.add_method('SetMmWaveEarfcn',
                   'void',
                   [param('uint16_t', 'earfcn')])
    ## mc-ue-net-device.h (module 'mmwave'): void ns3::mmwave::McUeNetDevice::SetMmWaveTargetEnb(ns3::Ptr<ns3::mmwave::MmWaveEnbNetDevice> enb) [member function]
    cls.add_method('SetMmWaveTargetEnb',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWaveEnbNetDevice >', 'enb')])
    ## mc-ue-net-device.h (module 'mmwave'): ns3::Ptr<ns3::mmwave::MmWaveEnbNetDevice> ns3::mmwave::McUeNetDevice::GetMmWaveTargetEnb() [member function]
    cls.add_method('GetMmWaveTargetEnb',
                   'ns3::Ptr< ns3::mmwave::MmWaveEnbNetDevice >',
                   [])
    ## mc-ue-net-device.h (module 'mmwave'): void ns3::mmwave::McUeNetDevice::SetAntennaNum(uint8_t antennaNum) [member function]
    cls.add_method('SetAntennaNum',
                   'void',
                   [param('uint8_t', 'antennaNum')])
    ## mc-ue-net-device.h (module 'mmwave'): uint8_t ns3::mmwave::McUeNetDevice::GetAntennaNum() const [member function]
    cls.add_method('GetAntennaNum',
                   'uint8_t',
                   [],
                   is_const=True)
    ## mc-ue-net-device.h (module 'mmwave'): void ns3::mmwave::McUeNetDevice::DoInitialize() [member function]
    cls.add_method('DoInitialize',
                   'void',
                   [],
                   visibility='protected', is_virtual=True)
    return

def register_Ns3MmwaveMmWave3gppBuildingsPropagationLossModel_methods(root_module, cls):
    ## mmwave-3gpp-buildings-propagation-loss-model.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWave3gppBuildingsPropagationLossModel::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-3gpp-buildings-propagation-loss-model.h (module 'mmwave'): ns3::mmwave::MmWave3gppBuildingsPropagationLossModel::MmWave3gppBuildingsPropagationLossModel() [constructor]
    cls.add_constructor([])
    ## mmwave-3gpp-buildings-propagation-loss-model.h (module 'mmwave'): double ns3::mmwave::MmWave3gppBuildingsPropagationLossModel::GetLoss(ns3::Ptr<ns3::MobilityModel> a, ns3::Ptr<ns3::MobilityModel> b) const [member function]
    cls.add_method('GetLoss',
                   'double',
                   [param('ns3::Ptr< ns3::MobilityModel >', 'a'), param('ns3::Ptr< ns3::MobilityModel >', 'b')],
                   is_const=True, is_virtual=True)
    ## mmwave-3gpp-buildings-propagation-loss-model.h (module 'mmwave'): double ns3::mmwave::MmWave3gppBuildingsPropagationLossModel::DoCalcRxPower(double txPowerDbm, ns3::Ptr<ns3::MobilityModel> a, ns3::Ptr<ns3::MobilityModel> b) const [member function]
    cls.add_method('DoCalcRxPower',
                   'double',
                   [param('double', 'txPowerDbm'), param('ns3::Ptr< ns3::MobilityModel >', 'a'), param('ns3::Ptr< ns3::MobilityModel >', 'b')],
                   is_const=True, is_virtual=True)
    ## mmwave-3gpp-buildings-propagation-loss-model.h (module 'mmwave'): void ns3::mmwave::MmWave3gppBuildingsPropagationLossModel::SetConfigurationParameters(ns3::Ptr<ns3::mmwave::MmWavePhyMacCommon> ptrConfig) [member function]
    cls.add_method('SetConfigurationParameters',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWavePhyMacCommon >', 'ptrConfig')])
    ## mmwave-3gpp-buildings-propagation-loss-model.h (module 'mmwave'): std::string ns3::mmwave::MmWave3gppBuildingsPropagationLossModel::GetScenario() [member function]
    cls.add_method('GetScenario',
                   'std::string',
                   [])
    ## mmwave-3gpp-buildings-propagation-loss-model.h (module 'mmwave'): char ns3::mmwave::MmWave3gppBuildingsPropagationLossModel::GetChannelCondition(ns3::Ptr<ns3::MobilityModel> a, ns3::Ptr<ns3::MobilityModel> b) [member function]
    cls.add_method('GetChannelCondition',
                   'char',
                   [param('ns3::Ptr< ns3::MobilityModel >', 'a'), param('ns3::Ptr< ns3::MobilityModel >', 'b')])
    return

def register_Ns3MmwaveMmWave3gppChannel_methods(root_module, cls):
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::MmWave3gppChannel::MmWave3gppChannel(ns3::mmwave::MmWave3gppChannel const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWave3gppChannel const &', 'arg0')])
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::MmWave3gppChannel::MmWave3gppChannel() [constructor]
    cls.add_constructor([])
    ## mmwave-3gpp-channel.h (module 'mmwave'): void ns3::mmwave::MmWave3gppChannel::ConnectDevices(ns3::Ptr<ns3::NetDevice> dev1, ns3::Ptr<ns3::NetDevice> dev2) [member function]
    cls.add_method('ConnectDevices',
                   'void',
                   [param('ns3::Ptr< ns3::NetDevice >', 'dev1'), param('ns3::Ptr< ns3::NetDevice >', 'dev2')])
    ## mmwave-3gpp-channel.h (module 'mmwave'): void ns3::mmwave::MmWave3gppChannel::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::Ptr<ns3::mmwave::MmWavePhyMacCommon> ns3::mmwave::MmWave3gppChannel::GetConfigurationParameters() const [member function]
    cls.add_method('GetConfigurationParameters',
                   'ns3::Ptr< ns3::mmwave::MmWavePhyMacCommon >',
                   [],
                   is_const=True)
    ## mmwave-3gpp-channel.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWave3gppChannel::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-3gpp-channel.h (module 'mmwave'): void ns3::mmwave::MmWave3gppChannel::Initial(ns3::NetDeviceContainer ueDevices, ns3::NetDeviceContainer enbDevices) [member function]
    cls.add_method('Initial',
                   'void',
                   [param('ns3::NetDeviceContainer', 'ueDevices'), param('ns3::NetDeviceContainer', 'enbDevices')])
    ## mmwave-3gpp-channel.h (module 'mmwave'): void ns3::mmwave::MmWave3gppChannel::SetBeamformingVector(ns3::Ptr<ns3::NetDevice> ueDevice, ns3::Ptr<ns3::NetDevice> enbDevice) [member function]
    cls.add_method('SetBeamformingVector',
                   'void',
                   [param('ns3::Ptr< ns3::NetDevice >', 'ueDevice'), param('ns3::Ptr< ns3::NetDevice >', 'enbDevice')])
    ## mmwave-3gpp-channel.h (module 'mmwave'): void ns3::mmwave::MmWave3gppChannel::SetConfigurationParameters(ns3::Ptr<ns3::mmwave::MmWavePhyMacCommon> ptrConfig) [member function]
    cls.add_method('SetConfigurationParameters',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWavePhyMacCommon >', 'ptrConfig')])
    ## mmwave-3gpp-channel.h (module 'mmwave'): void ns3::mmwave::MmWave3gppChannel::SetInterferenceOrDataMode(bool flag) [member function]
    cls.add_method('SetInterferenceOrDataMode',
                   'void',
                   [param('bool', 'flag')])
    ## mmwave-3gpp-channel.h (module 'mmwave'): void ns3::mmwave::MmWave3gppChannel::SetPathlossModel(ns3::Ptr<ns3::PropagationLossModel> pathloss) [member function]
    cls.add_method('SetPathlossModel',
                   'void',
                   [param('ns3::Ptr< ns3::PropagationLossModel >', 'pathloss')])
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::Ptr<ns3::SpectrumValue> ns3::mmwave::MmWave3gppChannel::DoCalcRxPowerSpectralDensity(ns3::Ptr<const ns3::SpectrumValue> txPsd, ns3::Ptr<const ns3::MobilityModel> a, ns3::Ptr<const ns3::MobilityModel> b) const [member function]
    cls.add_method('DoCalcRxPowerSpectralDensity',
                   'ns3::Ptr< ns3::SpectrumValue >',
                   [param('ns3::Ptr< ns3::SpectrumValue const >', 'txPsd'), param('ns3::Ptr< ns3::MobilityModel const >', 'a'), param('ns3::Ptr< ns3::MobilityModel const >', 'b')],
                   is_const=True, visibility='private', is_virtual=True)
    return

def register_Ns3MmwaveMmWave3gppPropagationLossModel_methods(root_module, cls):
    ## mmwave-3gpp-propagation-loss-model.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWave3gppPropagationLossModel::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-3gpp-propagation-loss-model.h (module 'mmwave'): ns3::mmwave::MmWave3gppPropagationLossModel::MmWave3gppPropagationLossModel() [constructor]
    cls.add_constructor([])
    ## mmwave-3gpp-propagation-loss-model.h (module 'mmwave'): void ns3::mmwave::MmWave3gppPropagationLossModel::SetConfigurationParameters(ns3::Ptr<ns3::mmwave::MmWavePhyMacCommon> ptrConfig) [member function]
    cls.add_method('SetConfigurationParameters',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWavePhyMacCommon >', 'ptrConfig')])
    ## mmwave-3gpp-propagation-loss-model.h (module 'mmwave'): void ns3::mmwave::MmWave3gppPropagationLossModel::SetMinLoss(double minLoss) [member function]
    cls.add_method('SetMinLoss',
                   'void',
                   [param('double', 'minLoss')])
    ## mmwave-3gpp-propagation-loss-model.h (module 'mmwave'): double ns3::mmwave::MmWave3gppPropagationLossModel::GetMinLoss() const [member function]
    cls.add_method('GetMinLoss',
                   'double',
                   [],
                   is_const=True)
    ## mmwave-3gpp-propagation-loss-model.h (module 'mmwave'): double ns3::mmwave::MmWave3gppPropagationLossModel::GetFrequency() const [member function]
    cls.add_method('GetFrequency',
                   'double',
                   [],
                   is_const=True)
    ## mmwave-3gpp-propagation-loss-model.h (module 'mmwave'): char ns3::mmwave::MmWave3gppPropagationLossModel::GetChannelCondition(ns3::Ptr<ns3::MobilityModel> a, ns3::Ptr<ns3::MobilityModel> b) [member function]
    cls.add_method('GetChannelCondition',
                   'char',
                   [param('ns3::Ptr< ns3::MobilityModel >', 'a'), param('ns3::Ptr< ns3::MobilityModel >', 'b')])
    ## mmwave-3gpp-propagation-loss-model.h (module 'mmwave'): std::string ns3::mmwave::MmWave3gppPropagationLossModel::GetScenario() [member function]
    cls.add_method('GetScenario',
                   'std::string',
                   [])
    ## mmwave-3gpp-propagation-loss-model.h (module 'mmwave'): double ns3::mmwave::MmWave3gppPropagationLossModel::GetLoss(ns3::Ptr<ns3::MobilityModel> a, ns3::Ptr<ns3::MobilityModel> b) const [member function]
    cls.add_method('GetLoss',
                   'double',
                   [param('ns3::Ptr< ns3::MobilityModel >', 'a'), param('ns3::Ptr< ns3::MobilityModel >', 'b')],
                   is_const=True)
    ## mmwave-3gpp-propagation-loss-model.h (module 'mmwave'): double ns3::mmwave::MmWave3gppPropagationLossModel::DoCalcRxPower(double txPowerDbm, ns3::Ptr<ns3::MobilityModel> a, ns3::Ptr<ns3::MobilityModel> b) const [member function]
    cls.add_method('DoCalcRxPower',
                   'double',
                   [param('double', 'txPowerDbm'), param('ns3::Ptr< ns3::MobilityModel >', 'a'), param('ns3::Ptr< ns3::MobilityModel >', 'b')],
                   is_const=True, visibility='private', is_virtual=True)
    ## mmwave-3gpp-propagation-loss-model.h (module 'mmwave'): int64_t ns3::mmwave::MmWave3gppPropagationLossModel::DoAssignStreams(int64_t stream) [member function]
    cls.add_method('DoAssignStreams',
                   'int64_t',
                   [param('int64_t', 'stream')],
                   visibility='private', is_virtual=True)
    return

def register_Ns3MmwaveMmWaveAmc_methods(root_module, cls):
    ## mmwave-amc.h (module 'mmwave'): ns3::mmwave::MmWaveAmc::MmWaveAmc(ns3::mmwave::MmWaveAmc const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveAmc const &', 'arg0')])
    ## mmwave-amc.h (module 'mmwave'): ns3::mmwave::MmWaveAmc::MmWaveAmc() [constructor]
    cls.add_constructor([])
    ## mmwave-amc.h (module 'mmwave'): ns3::mmwave::MmWaveAmc::MmWaveAmc(ns3::Ptr<ns3::mmwave::MmWavePhyMacCommon> ConfigParams) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::mmwave::MmWavePhyMacCommon >', 'ConfigParams')])
    ## mmwave-amc.h (module 'mmwave'): int ns3::mmwave::MmWaveAmc::CreateCqiFeedbackWbTdma(ns3::SpectrumValue const & sinr, uint8_t numSym, uint32_t tbs, int & mcsWb) [member function]
    cls.add_method('CreateCqiFeedbackWbTdma',
                   'int',
                   [param('ns3::SpectrumValue const &', 'sinr'), param('uint8_t', 'numSym'), param('uint32_t', 'tbs'), param('int &', 'mcsWb')])
    ## mmwave-amc.h (module 'mmwave'): std::vector<int, std::allocator<int> > ns3::mmwave::MmWaveAmc::CreateCqiFeedbacks(ns3::SpectrumValue const & sinr, uint8_t rbgSize) [member function]
    cls.add_method('CreateCqiFeedbacks',
                   'std::vector< int >',
                   [param('ns3::SpectrumValue const &', 'sinr'), param('uint8_t', 'rbgSize')])
    ## mmwave-amc.h (module 'mmwave'): std::vector<int, std::allocator<int> > ns3::mmwave::MmWaveAmc::CreateCqiFeedbacksTdma(ns3::SpectrumValue const & sinr, uint8_t numSym) [member function]
    cls.add_method('CreateCqiFeedbacksTdma',
                   'std::vector< int >',
                   [param('ns3::SpectrumValue const &', 'sinr'), param('uint8_t', 'numSym')])
    ## mmwave-amc.h (module 'mmwave'): int ns3::mmwave::MmWaveAmc::GetCqiFromSpectralEfficiency(double s) [member function]
    cls.add_method('GetCqiFromSpectralEfficiency',
                   'int',
                   [param('double', 's')])
    ## mmwave-amc.h (module 'mmwave'): int ns3::mmwave::MmWaveAmc::GetMcsFromCqi(int cqi) [member function]
    cls.add_method('GetMcsFromCqi',
                   'int',
                   [param('int', 'cqi')])
    ## mmwave-amc.h (module 'mmwave'): int ns3::mmwave::MmWaveAmc::GetMcsFromSpectralEfficiency(double s) [member function]
    cls.add_method('GetMcsFromSpectralEfficiency',
                   'int',
                   [param('double', 's')])
    ## mmwave-amc.h (module 'mmwave'): int ns3::mmwave::MmWaveAmc::GetNumSymbolsFromTbsMcs(unsigned int tbSize, unsigned int mcs) [member function]
    cls.add_method('GetNumSymbolsFromTbsMcs',
                   'int',
                   [param('unsigned int', 'tbSize'), param('unsigned int', 'mcs')])
    ## mmwave-amc.h (module 'mmwave'): int ns3::mmwave::MmWaveAmc::GetTbSizeFromMcs(unsigned int mcs, unsigned int nprb) [member function]
    cls.add_method('GetTbSizeFromMcs',
                   'int',
                   [param('unsigned int', 'mcs'), param('unsigned int', 'nprb')])
    ## mmwave-amc.h (module 'mmwave'): int ns3::mmwave::MmWaveAmc::GetTbSizeFromMcsSymbols(unsigned int mcs, unsigned int nsym) [member function]
    cls.add_method('GetTbSizeFromMcsSymbols',
                   'int',
                   [param('unsigned int', 'mcs'), param('unsigned int', 'nsym')])
    ## mmwave-amc.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWaveAmc::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-amc.h (module 'mmwave'): ns3::mmwave::MmWaveAmc::m_crcLen [variable]
    cls.add_static_attribute('m_crcLen', 'unsigned int const', is_const=True)
    return

def register_Ns3MmwaveMmWaveBeamforming_methods(root_module, cls):
    ## mmwave-beamforming.h (module 'mmwave'): ns3::mmwave::MmWaveBeamforming::MmWaveBeamforming(ns3::mmwave::MmWaveBeamforming const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveBeamforming const &', 'arg0')])
    ## mmwave-beamforming.h (module 'mmwave'): ns3::mmwave::MmWaveBeamforming::MmWaveBeamforming(uint32_t enbAntenna, uint32_t ueAntenna) [constructor]
    cls.add_constructor([param('uint32_t', 'enbAntenna'), param('uint32_t', 'ueAntenna')])
    ## mmwave-beamforming.h (module 'mmwave'): ns3::Ptr<ns3::SpectrumValue> ns3::mmwave::MmWaveBeamforming::CalcRxPowerSpectralDensity(ns3::Ptr<const ns3::SpectrumValue> txPsd, ns3::Ptr<const ns3::MobilityModel> a, ns3::Ptr<const ns3::MobilityModel> b) const [member function]
    cls.add_method('CalcRxPowerSpectralDensity',
                   'ns3::Ptr< ns3::SpectrumValue >',
                   [param('ns3::Ptr< ns3::SpectrumValue const >', 'txPsd'), param('ns3::Ptr< ns3::MobilityModel const >', 'a'), param('ns3::Ptr< ns3::MobilityModel const >', 'b')],
                   is_const=True)
    ## mmwave-beamforming.h (module 'mmwave'): void ns3::mmwave::MmWaveBeamforming::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## mmwave-beamforming.h (module 'mmwave'): ns3::Ptr<ns3::mmwave::MmWavePhyMacCommon> ns3::mmwave::MmWaveBeamforming::GetConfigurationParameters() const [member function]
    cls.add_method('GetConfigurationParameters',
                   'ns3::Ptr< ns3::mmwave::MmWavePhyMacCommon >',
                   [],
                   is_const=True)
    ## mmwave-beamforming.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWaveBeamforming::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-beamforming.h (module 'mmwave'): void ns3::mmwave::MmWaveBeamforming::Initial(ns3::NetDeviceContainer ueDevices, ns3::NetDeviceContainer enbDevices) [member function]
    cls.add_method('Initial',
                   'void',
                   [param('ns3::NetDeviceContainer', 'ueDevices'), param('ns3::NetDeviceContainer', 'enbDevices')])
    ## mmwave-beamforming.h (module 'mmwave'): void ns3::mmwave::MmWaveBeamforming::LoadFile() [member function]
    cls.add_method('LoadFile',
                   'void',
                   [])
    ## mmwave-beamforming.h (module 'mmwave'): void ns3::mmwave::MmWaveBeamforming::SetBeamformingVector(ns3::Ptr<ns3::NetDevice> ueDevice, ns3::Ptr<ns3::NetDevice> enbDevice) [member function]
    cls.add_method('SetBeamformingVector',
                   'void',
                   [param('ns3::Ptr< ns3::NetDevice >', 'ueDevice'), param('ns3::Ptr< ns3::NetDevice >', 'enbDevice')])
    ## mmwave-beamforming.h (module 'mmwave'): void ns3::mmwave::MmWaveBeamforming::SetConfigurationParameters(ns3::Ptr<ns3::mmwave::MmWavePhyMacCommon> ptrConfig) [member function]
    cls.add_method('SetConfigurationParameters',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWavePhyMacCommon >', 'ptrConfig')])
    ## mmwave-beamforming.h (module 'mmwave'): void ns3::mmwave::MmWaveBeamforming::UpdateMatrices(bool update) [member function]
    cls.add_method('UpdateMatrices',
                   'void',
                   [param('bool', 'update')])
    ## mmwave-beamforming.h (module 'mmwave'): ns3::Ptr<ns3::SpectrumValue> ns3::mmwave::MmWaveBeamforming::DoCalcRxPowerSpectralDensity(ns3::Ptr<const ns3::SpectrumValue> txPsd, ns3::Ptr<const ns3::MobilityModel> a, ns3::Ptr<const ns3::MobilityModel> b) const [member function]
    cls.add_method('DoCalcRxPowerSpectralDensity',
                   'ns3::Ptr< ns3::SpectrumValue >',
                   [param('ns3::Ptr< ns3::SpectrumValue const >', 'txPsd'), param('ns3::Ptr< ns3::MobilityModel const >', 'a'), param('ns3::Ptr< ns3::MobilityModel const >', 'b')],
                   is_const=True, visibility='private', is_virtual=True)
    return

def register_Ns3MmwaveMmWaveBearerStatsCalculator_methods(root_module, cls):
    ## mmwave-bearer-stats-calculator.h (module 'mmwave'): ns3::mmwave::MmWaveBearerStatsCalculator::MmWaveBearerStatsCalculator() [constructor]
    cls.add_constructor([])
    ## mmwave-bearer-stats-calculator.h (module 'mmwave'): ns3::mmwave::MmWaveBearerStatsCalculator::MmWaveBearerStatsCalculator(std::string protocolType) [constructor]
    cls.add_constructor([param('std::string', 'protocolType')])
    ## mmwave-bearer-stats-calculator.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWaveBearerStatsCalculator::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-bearer-stats-calculator.h (module 'mmwave'): void ns3::mmwave::MmWaveBearerStatsCalculator::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## mmwave-bearer-stats-calculator.h (module 'mmwave'): std::string ns3::mmwave::MmWaveBearerStatsCalculator::GetUlOutputFilename() [member function]
    cls.add_method('GetUlOutputFilename',
                   'std::string',
                   [])
    ## mmwave-bearer-stats-calculator.h (module 'mmwave'): std::string ns3::mmwave::MmWaveBearerStatsCalculator::GetDlOutputFilename() [member function]
    cls.add_method('GetDlOutputFilename',
                   'std::string',
                   [])
    ## mmwave-bearer-stats-calculator.h (module 'mmwave'): void ns3::mmwave::MmWaveBearerStatsCalculator::SetUlPdcpOutputFilename(std::string outputFilename) [member function]
    cls.add_method('SetUlPdcpOutputFilename',
                   'void',
                   [param('std::string', 'outputFilename')])
    ## mmwave-bearer-stats-calculator.h (module 'mmwave'): std::string ns3::mmwave::MmWaveBearerStatsCalculator::GetUlPdcpOutputFilename() [member function]
    cls.add_method('GetUlPdcpOutputFilename',
                   'std::string',
                   [])
    ## mmwave-bearer-stats-calculator.h (module 'mmwave'): void ns3::mmwave::MmWaveBearerStatsCalculator::SetDlPdcpOutputFilename(std::string outputFilename) [member function]
    cls.add_method('SetDlPdcpOutputFilename',
                   'void',
                   [param('std::string', 'outputFilename')])
    ## mmwave-bearer-stats-calculator.h (module 'mmwave'): std::string ns3::mmwave::MmWaveBearerStatsCalculator::GetDlPdcpOutputFilename() [member function]
    cls.add_method('GetDlPdcpOutputFilename',
                   'std::string',
                   [])
    ## mmwave-bearer-stats-calculator.h (module 'mmwave'): void ns3::mmwave::MmWaveBearerStatsCalculator::SetStartTime(ns3::Time t) [member function]
    cls.add_method('SetStartTime',
                   'void',
                   [param('ns3::Time', 't')])
    ## mmwave-bearer-stats-calculator.h (module 'mmwave'): ns3::Time ns3::mmwave::MmWaveBearerStatsCalculator::GetStartTime() const [member function]
    cls.add_method('GetStartTime',
                   'ns3::Time',
                   [],
                   is_const=True)
    ## mmwave-bearer-stats-calculator.h (module 'mmwave'): void ns3::mmwave::MmWaveBearerStatsCalculator::SetEpoch(ns3::Time e) [member function]
    cls.add_method('SetEpoch',
                   'void',
                   [param('ns3::Time', 'e')])
    ## mmwave-bearer-stats-calculator.h (module 'mmwave'): ns3::Time ns3::mmwave::MmWaveBearerStatsCalculator::GetEpoch() const [member function]
    cls.add_method('GetEpoch',
                   'ns3::Time',
                   [],
                   is_const=True)
    ## mmwave-bearer-stats-calculator.h (module 'mmwave'): void ns3::mmwave::MmWaveBearerStatsCalculator::UlTxPdu(uint16_t cellId, uint64_t imsi, uint16_t rnti, uint8_t lcid, uint32_t packetSize) [member function]
    cls.add_method('UlTxPdu',
                   'void',
                   [param('uint16_t', 'cellId'), param('uint64_t', 'imsi'), param('uint16_t', 'rnti'), param('uint8_t', 'lcid'), param('uint32_t', 'packetSize')])
    ## mmwave-bearer-stats-calculator.h (module 'mmwave'): void ns3::mmwave::MmWaveBearerStatsCalculator::UlRxPdu(uint16_t cellId, uint64_t imsi, uint16_t rnti, uint8_t lcid, uint32_t packetSize, uint64_t delay) [member function]
    cls.add_method('UlRxPdu',
                   'void',
                   [param('uint16_t', 'cellId'), param('uint64_t', 'imsi'), param('uint16_t', 'rnti'), param('uint8_t', 'lcid'), param('uint32_t', 'packetSize'), param('uint64_t', 'delay')])
    ## mmwave-bearer-stats-calculator.h (module 'mmwave'): void ns3::mmwave::MmWaveBearerStatsCalculator::DlTxPdu(uint16_t cellId, uint64_t imsi, uint16_t rnti, uint8_t lcid, uint32_t packetSize) [member function]
    cls.add_method('DlTxPdu',
                   'void',
                   [param('uint16_t', 'cellId'), param('uint64_t', 'imsi'), param('uint16_t', 'rnti'), param('uint8_t', 'lcid'), param('uint32_t', 'packetSize')])
    ## mmwave-bearer-stats-calculator.h (module 'mmwave'): void ns3::mmwave::MmWaveBearerStatsCalculator::DlRxPdu(uint16_t cellId, uint64_t imsi, uint16_t rnti, uint8_t lcid, uint32_t packetSize, uint64_t delay) [member function]
    cls.add_method('DlRxPdu',
                   'void',
                   [param('uint16_t', 'cellId'), param('uint64_t', 'imsi'), param('uint16_t', 'rnti'), param('uint8_t', 'lcid'), param('uint32_t', 'packetSize'), param('uint64_t', 'delay')])
    ## mmwave-bearer-stats-calculator.h (module 'mmwave'): uint32_t ns3::mmwave::MmWaveBearerStatsCalculator::GetUlTxPackets(uint64_t imsi, uint8_t lcid) [member function]
    cls.add_method('GetUlTxPackets',
                   'uint32_t',
                   [param('uint64_t', 'imsi'), param('uint8_t', 'lcid')])
    ## mmwave-bearer-stats-calculator.h (module 'mmwave'): uint32_t ns3::mmwave::MmWaveBearerStatsCalculator::GetUlRxPackets(uint64_t imsi, uint8_t lcid) [member function]
    cls.add_method('GetUlRxPackets',
                   'uint32_t',
                   [param('uint64_t', 'imsi'), param('uint8_t', 'lcid')])
    ## mmwave-bearer-stats-calculator.h (module 'mmwave'): uint64_t ns3::mmwave::MmWaveBearerStatsCalculator::GetUlTxData(uint64_t imsi, uint8_t lcid) [member function]
    cls.add_method('GetUlTxData',
                   'uint64_t',
                   [param('uint64_t', 'imsi'), param('uint8_t', 'lcid')])
    ## mmwave-bearer-stats-calculator.h (module 'mmwave'): uint64_t ns3::mmwave::MmWaveBearerStatsCalculator::GetUlRxData(uint64_t imsi, uint8_t lcid) [member function]
    cls.add_method('GetUlRxData',
                   'uint64_t',
                   [param('uint64_t', 'imsi'), param('uint8_t', 'lcid')])
    ## mmwave-bearer-stats-calculator.h (module 'mmwave'): uint32_t ns3::mmwave::MmWaveBearerStatsCalculator::GetUlCellId(uint64_t imsi, uint8_t lcid) [member function]
    cls.add_method('GetUlCellId',
                   'uint32_t',
                   [param('uint64_t', 'imsi'), param('uint8_t', 'lcid')])
    ## mmwave-bearer-stats-calculator.h (module 'mmwave'): double ns3::mmwave::MmWaveBearerStatsCalculator::GetUlDelay(uint64_t imsi, uint8_t lcid) [member function]
    cls.add_method('GetUlDelay',
                   'double',
                   [param('uint64_t', 'imsi'), param('uint8_t', 'lcid')])
    ## mmwave-bearer-stats-calculator.h (module 'mmwave'): std::vector<double, std::allocator<double> > ns3::mmwave::MmWaveBearerStatsCalculator::GetUlDelayStats(uint64_t imsi, uint8_t lcid) [member function]
    cls.add_method('GetUlDelayStats',
                   'std::vector< double >',
                   [param('uint64_t', 'imsi'), param('uint8_t', 'lcid')])
    ## mmwave-bearer-stats-calculator.h (module 'mmwave'): std::vector<double, std::allocator<double> > ns3::mmwave::MmWaveBearerStatsCalculator::GetUlPduSizeStats(uint64_t imsi, uint8_t lcid) [member function]
    cls.add_method('GetUlPduSizeStats',
                   'std::vector< double >',
                   [param('uint64_t', 'imsi'), param('uint8_t', 'lcid')])
    ## mmwave-bearer-stats-calculator.h (module 'mmwave'): uint32_t ns3::mmwave::MmWaveBearerStatsCalculator::GetDlTxPackets(uint64_t imsi, uint8_t lcid) [member function]
    cls.add_method('GetDlTxPackets',
                   'uint32_t',
                   [param('uint64_t', 'imsi'), param('uint8_t', 'lcid')])
    ## mmwave-bearer-stats-calculator.h (module 'mmwave'): uint32_t ns3::mmwave::MmWaveBearerStatsCalculator::GetDlRxPackets(uint64_t imsi, uint8_t lcid) [member function]
    cls.add_method('GetDlRxPackets',
                   'uint32_t',
                   [param('uint64_t', 'imsi'), param('uint8_t', 'lcid')])
    ## mmwave-bearer-stats-calculator.h (module 'mmwave'): uint64_t ns3::mmwave::MmWaveBearerStatsCalculator::GetDlTxData(uint64_t imsi, uint8_t lcid) [member function]
    cls.add_method('GetDlTxData',
                   'uint64_t',
                   [param('uint64_t', 'imsi'), param('uint8_t', 'lcid')])
    ## mmwave-bearer-stats-calculator.h (module 'mmwave'): uint64_t ns3::mmwave::MmWaveBearerStatsCalculator::GetDlRxData(uint64_t imsi, uint8_t lcid) [member function]
    cls.add_method('GetDlRxData',
                   'uint64_t',
                   [param('uint64_t', 'imsi'), param('uint8_t', 'lcid')])
    ## mmwave-bearer-stats-calculator.h (module 'mmwave'): uint32_t ns3::mmwave::MmWaveBearerStatsCalculator::GetDlCellId(uint64_t imsi, uint8_t lcid) [member function]
    cls.add_method('GetDlCellId',
                   'uint32_t',
                   [param('uint64_t', 'imsi'), param('uint8_t', 'lcid')])
    ## mmwave-bearer-stats-calculator.h (module 'mmwave'): double ns3::mmwave::MmWaveBearerStatsCalculator::GetDlDelay(uint64_t imsi, uint8_t lcid) [member function]
    cls.add_method('GetDlDelay',
                   'double',
                   [param('uint64_t', 'imsi'), param('uint8_t', 'lcid')])
    ## mmwave-bearer-stats-calculator.h (module 'mmwave'): std::vector<double, std::allocator<double> > ns3::mmwave::MmWaveBearerStatsCalculator::GetDlDelayStats(uint64_t imsi, uint8_t lcid) [member function]
    cls.add_method('GetDlDelayStats',
                   'std::vector< double >',
                   [param('uint64_t', 'imsi'), param('uint8_t', 'lcid')])
    ## mmwave-bearer-stats-calculator.h (module 'mmwave'): std::vector<double, std::allocator<double> > ns3::mmwave::MmWaveBearerStatsCalculator::GetDlPduSizeStats(uint64_t imsi, uint8_t lcid) [member function]
    cls.add_method('GetDlPduSizeStats',
                   'std::vector< double >',
                   [param('uint64_t', 'imsi'), param('uint8_t', 'lcid')])
    return

def register_Ns3MmwaveMmWaveBearerStatsConnector_methods(root_module, cls):
    ## mmwave-bearer-stats-connector.h (module 'mmwave'): ns3::mmwave::MmWaveBearerStatsConnector::MmWaveBearerStatsConnector() [constructor]
    cls.add_constructor([])
    ## mmwave-bearer-stats-connector.h (module 'mmwave'): void ns3::mmwave::MmWaveBearerStatsConnector::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## mmwave-bearer-stats-connector.h (module 'mmwave'): void ns3::mmwave::MmWaveBearerStatsConnector::EnableMcStats(ns3::Ptr<ns3::mmwave::McStatsCalculator> mcStats) [member function]
    cls.add_method('EnableMcStats',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::McStatsCalculator >', 'mcStats')])
    ## mmwave-bearer-stats-connector.h (module 'mmwave'): void ns3::mmwave::MmWaveBearerStatsConnector::EnablePdcpStats(ns3::Ptr<ns3::mmwave::MmWaveBearerStatsCalculator> pdcpStats) [member function]
    cls.add_method('EnablePdcpStats',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWaveBearerStatsCalculator >', 'pdcpStats')])
    ## mmwave-bearer-stats-connector.h (module 'mmwave'): void ns3::mmwave::MmWaveBearerStatsConnector::EnableRlcStats(ns3::Ptr<ns3::mmwave::MmWaveBearerStatsCalculator> rlcStats) [member function]
    cls.add_method('EnableRlcStats',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWaveBearerStatsCalculator >', 'rlcStats')])
    ## mmwave-bearer-stats-connector.h (module 'mmwave'): void ns3::mmwave::MmWaveBearerStatsConnector::EnsureConnected() [member function]
    cls.add_method('EnsureConnected',
                   'void',
                   [])
    ## mmwave-bearer-stats-connector.h (module 'mmwave'): std::string ns3::mmwave::MmWaveBearerStatsConnector::GetCellIdStatsOutputFilename() [member function]
    cls.add_method('GetCellIdStatsOutputFilename',
                   'std::string',
                   [])
    ## mmwave-bearer-stats-connector.h (module 'mmwave'): std::string ns3::mmwave::MmWaveBearerStatsConnector::GetEnbHandoverEndOutputFilename() [member function]
    cls.add_method('GetEnbHandoverEndOutputFilename',
                   'std::string',
                   [])
    ## mmwave-bearer-stats-connector.h (module 'mmwave'): std::string ns3::mmwave::MmWaveBearerStatsConnector::GetEnbHandoverStartOutputFilename() [member function]
    cls.add_method('GetEnbHandoverStartOutputFilename',
                   'std::string',
                   [])
    ## mmwave-bearer-stats-connector.h (module 'mmwave'): std::string ns3::mmwave::MmWaveBearerStatsConnector::GetLteSinrOutputFilename() [member function]
    cls.add_method('GetLteSinrOutputFilename',
                   'std::string',
                   [])
    ## mmwave-bearer-stats-connector.h (module 'mmwave'): std::string ns3::mmwave::MmWaveBearerStatsConnector::GetMmWaveSinrOutputFilename() [member function]
    cls.add_method('GetMmWaveSinrOutputFilename',
                   'std::string',
                   [])
    ## mmwave-bearer-stats-connector.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWaveBearerStatsConnector::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-bearer-stats-connector.h (module 'mmwave'): std::string ns3::mmwave::MmWaveBearerStatsConnector::GetUeHandoverEndOutputFilename() [member function]
    cls.add_method('GetUeHandoverEndOutputFilename',
                   'std::string',
                   [])
    ## mmwave-bearer-stats-connector.h (module 'mmwave'): std::string ns3::mmwave::MmWaveBearerStatsConnector::GetUeHandoverStartOutputFilename() [member function]
    cls.add_method('GetUeHandoverStartOutputFilename',
                   'std::string',
                   [])
    ## mmwave-bearer-stats-connector.h (module 'mmwave'): static void ns3::mmwave::MmWaveBearerStatsConnector::NotifyConnectionReconfigurationEnb(ns3::mmwave::MmWaveBearerStatsConnector * c, std::string context, uint64_t imsi, uint16_t cellid, uint16_t rnti) [member function]
    cls.add_method('NotifyConnectionReconfigurationEnb',
                   'void',
                   [param('ns3::mmwave::MmWaveBearerStatsConnector *', 'c'), param('std::string', 'context'), param('uint64_t', 'imsi'), param('uint16_t', 'cellid'), param('uint16_t', 'rnti')],
                   is_static=True)
    ## mmwave-bearer-stats-connector.h (module 'mmwave'): static void ns3::mmwave::MmWaveBearerStatsConnector::NotifyConnectionReconfigurationUe(ns3::mmwave::MmWaveBearerStatsConnector * c, std::string context, uint64_t imsi, uint16_t cellid, uint16_t rnti) [member function]
    cls.add_method('NotifyConnectionReconfigurationUe',
                   'void',
                   [param('ns3::mmwave::MmWaveBearerStatsConnector *', 'c'), param('std::string', 'context'), param('uint64_t', 'imsi'), param('uint16_t', 'cellid'), param('uint16_t', 'rnti')],
                   is_static=True)
    ## mmwave-bearer-stats-connector.h (module 'mmwave'): static void ns3::mmwave::MmWaveBearerStatsConnector::NotifyConnectionSetupUe(ns3::mmwave::MmWaveBearerStatsConnector * c, std::string context, uint64_t imsi, uint16_t cellid, uint16_t rnti) [member function]
    cls.add_method('NotifyConnectionSetupUe',
                   'void',
                   [param('ns3::mmwave::MmWaveBearerStatsConnector *', 'c'), param('std::string', 'context'), param('uint64_t', 'imsi'), param('uint16_t', 'cellid'), param('uint16_t', 'rnti')],
                   is_static=True)
    ## mmwave-bearer-stats-connector.h (module 'mmwave'): static void ns3::mmwave::MmWaveBearerStatsConnector::NotifyHandoverEndOkEnb(ns3::mmwave::MmWaveBearerStatsConnector * c, std::string context, uint64_t imsi, uint16_t cellid, uint16_t rnti) [member function]
    cls.add_method('NotifyHandoverEndOkEnb',
                   'void',
                   [param('ns3::mmwave::MmWaveBearerStatsConnector *', 'c'), param('std::string', 'context'), param('uint64_t', 'imsi'), param('uint16_t', 'cellid'), param('uint16_t', 'rnti')],
                   is_static=True)
    ## mmwave-bearer-stats-connector.h (module 'mmwave'): static void ns3::mmwave::MmWaveBearerStatsConnector::NotifyHandoverEndOkUe(ns3::mmwave::MmWaveBearerStatsConnector * c, std::string context, uint64_t imsi, uint16_t cellid, uint16_t rnti) [member function]
    cls.add_method('NotifyHandoverEndOkUe',
                   'void',
                   [param('ns3::mmwave::MmWaveBearerStatsConnector *', 'c'), param('std::string', 'context'), param('uint64_t', 'imsi'), param('uint16_t', 'cellid'), param('uint16_t', 'rnti')],
                   is_static=True)
    ## mmwave-bearer-stats-connector.h (module 'mmwave'): static void ns3::mmwave::MmWaveBearerStatsConnector::NotifyHandoverStartEnb(ns3::mmwave::MmWaveBearerStatsConnector * c, std::string context, uint64_t imsi, uint16_t cellid, uint16_t rnti, uint16_t targetCellId) [member function]
    cls.add_method('NotifyHandoverStartEnb',
                   'void',
                   [param('ns3::mmwave::MmWaveBearerStatsConnector *', 'c'), param('std::string', 'context'), param('uint64_t', 'imsi'), param('uint16_t', 'cellid'), param('uint16_t', 'rnti'), param('uint16_t', 'targetCellId')],
                   is_static=True)
    ## mmwave-bearer-stats-connector.h (module 'mmwave'): static void ns3::mmwave::MmWaveBearerStatsConnector::NotifyHandoverStartUe(ns3::mmwave::MmWaveBearerStatsConnector * c, std::string context, uint64_t imsi, uint16_t cellid, uint16_t rnti, uint16_t targetCellId) [member function]
    cls.add_method('NotifyHandoverStartUe',
                   'void',
                   [param('ns3::mmwave::MmWaveBearerStatsConnector *', 'c'), param('std::string', 'context'), param('uint64_t', 'imsi'), param('uint16_t', 'cellid'), param('uint16_t', 'rnti'), param('uint16_t', 'targetCellId')],
                   is_static=True)
    ## mmwave-bearer-stats-connector.h (module 'mmwave'): static void ns3::mmwave::MmWaveBearerStatsConnector::NotifyLteSinr(ns3::mmwave::MmWaveBearerStatsConnector * c, std::string context, uint16_t cellId, uint16_t rnti, double rsrp, double sinr, uint8_t cc) [member function]
    cls.add_method('NotifyLteSinr',
                   'void',
                   [param('ns3::mmwave::MmWaveBearerStatsConnector *', 'c'), param('std::string', 'context'), param('uint16_t', 'cellId'), param('uint16_t', 'rnti'), param('double', 'rsrp'), param('double', 'sinr'), param('uint8_t', 'cc')],
                   is_static=True)
    ## mmwave-bearer-stats-connector.h (module 'mmwave'): static void ns3::mmwave::MmWaveBearerStatsConnector::NotifyMmWaveSinr(ns3::mmwave::MmWaveBearerStatsConnector * c, std::string context, uint64_t imsi, uint16_t cellId, long double sinr) [member function]
    cls.add_method('NotifyMmWaveSinr',
                   'void',
                   [param('ns3::mmwave::MmWaveBearerStatsConnector *', 'c'), param('std::string', 'context'), param('uint64_t', 'imsi'), param('uint16_t', 'cellId'), param('long double', 'sinr')],
                   is_static=True)
    ## mmwave-bearer-stats-connector.h (module 'mmwave'): static void ns3::mmwave::MmWaveBearerStatsConnector::NotifyNewUeContextEnb(ns3::mmwave::MmWaveBearerStatsConnector * c, std::string context, uint16_t cellid, uint16_t rnti) [member function]
    cls.add_method('NotifyNewUeContextEnb',
                   'void',
                   [param('ns3::mmwave::MmWaveBearerStatsConnector *', 'c'), param('std::string', 'context'), param('uint16_t', 'cellid'), param('uint16_t', 'rnti')],
                   is_static=True)
    ## mmwave-bearer-stats-connector.h (module 'mmwave'): static void ns3::mmwave::MmWaveBearerStatsConnector::NotifyRandomAccessSuccessfulUe(ns3::mmwave::MmWaveBearerStatsConnector * c, std::string context, uint64_t imsi, uint16_t cellid, uint16_t rnti) [member function]
    cls.add_method('NotifyRandomAccessSuccessfulUe',
                   'void',
                   [param('ns3::mmwave::MmWaveBearerStatsConnector *', 'c'), param('std::string', 'context'), param('uint64_t', 'imsi'), param('uint16_t', 'cellid'), param('uint16_t', 'rnti')],
                   is_static=True)
    ## mmwave-bearer-stats-connector.h (module 'mmwave'): static void ns3::mmwave::MmWaveBearerStatsConnector::NotifySecondaryMmWaveEnbAvailable(ns3::mmwave::MmWaveBearerStatsConnector * c, std::string context, uint64_t imsi, uint16_t cellId, uint16_t rnti) [member function]
    cls.add_method('NotifySecondaryMmWaveEnbAvailable',
                   'void',
                   [param('ns3::mmwave::MmWaveBearerStatsConnector *', 'c'), param('std::string', 'context'), param('uint64_t', 'imsi'), param('uint16_t', 'cellId'), param('uint16_t', 'rnti')],
                   is_static=True)
    ## mmwave-bearer-stats-connector.h (module 'mmwave'): static void ns3::mmwave::MmWaveBearerStatsConnector::NotifySwitchToMmWaveUe(ns3::mmwave::MmWaveBearerStatsConnector * c, std::string context, uint64_t imsi, uint16_t cellId, uint16_t rnti) [member function]
    cls.add_method('NotifySwitchToMmWaveUe',
                   'void',
                   [param('ns3::mmwave::MmWaveBearerStatsConnector *', 'c'), param('std::string', 'context'), param('uint64_t', 'imsi'), param('uint16_t', 'cellId'), param('uint16_t', 'rnti')],
                   is_static=True)
    ## mmwave-bearer-stats-connector.h (module 'mmwave'): void ns3::mmwave::MmWaveBearerStatsConnector::PrintLteSinr(uint16_t rnti, uint16_t cellId, double sinr) [member function]
    cls.add_method('PrintLteSinr',
                   'void',
                   [param('uint16_t', 'rnti'), param('uint16_t', 'cellId'), param('double', 'sinr')])
    ## mmwave-bearer-stats-connector.h (module 'mmwave'): void ns3::mmwave::MmWaveBearerStatsConnector::PrintMmWaveSinr(uint64_t imsi, uint16_t cellId, long double sinr) [member function]
    cls.add_method('PrintMmWaveSinr',
                   'void',
                   [param('uint64_t', 'imsi'), param('uint16_t', 'cellId'), param('long double', 'sinr')])
    ## mmwave-bearer-stats-connector.h (module 'mmwave'): void ns3::mmwave::MmWaveBearerStatsConnector::SetCellIdStatsOutputFilename(std::string outputFilename) [member function]
    cls.add_method('SetCellIdStatsOutputFilename',
                   'void',
                   [param('std::string', 'outputFilename')])
    ## mmwave-bearer-stats-connector.h (module 'mmwave'): void ns3::mmwave::MmWaveBearerStatsConnector::SetEnbHandoverEndOutputFilename(std::string outputFilename) [member function]
    cls.add_method('SetEnbHandoverEndOutputFilename',
                   'void',
                   [param('std::string', 'outputFilename')])
    ## mmwave-bearer-stats-connector.h (module 'mmwave'): void ns3::mmwave::MmWaveBearerStatsConnector::SetEnbHandoverStartOutputFilename(std::string outputFilename) [member function]
    cls.add_method('SetEnbHandoverStartOutputFilename',
                   'void',
                   [param('std::string', 'outputFilename')])
    ## mmwave-bearer-stats-connector.h (module 'mmwave'): void ns3::mmwave::MmWaveBearerStatsConnector::SetLteSinrOutputFilename(std::string outputFilename) [member function]
    cls.add_method('SetLteSinrOutputFilename',
                   'void',
                   [param('std::string', 'outputFilename')])
    ## mmwave-bearer-stats-connector.h (module 'mmwave'): void ns3::mmwave::MmWaveBearerStatsConnector::SetMmWaveSinrOutputFilename(std::string outputFilename) [member function]
    cls.add_method('SetMmWaveSinrOutputFilename',
                   'void',
                   [param('std::string', 'outputFilename')])
    ## mmwave-bearer-stats-connector.h (module 'mmwave'): void ns3::mmwave::MmWaveBearerStatsConnector::SetUeHandoverEndOutputFilename(std::string outputFilename) [member function]
    cls.add_method('SetUeHandoverEndOutputFilename',
                   'void',
                   [param('std::string', 'outputFilename')])
    ## mmwave-bearer-stats-connector.h (module 'mmwave'): void ns3::mmwave::MmWaveBearerStatsConnector::SetUeHandoverStartOutputFilename(std::string outputFilename) [member function]
    cls.add_method('SetUeHandoverStartOutputFilename',
                   'void',
                   [param('std::string', 'outputFilename')])
    return

def register_Ns3MmwaveMmWaveChannelMatrix_methods(root_module, cls):
    ## mmwave-channel-matrix.h (module 'mmwave'): ns3::mmwave::MmWaveChannelMatrix::MmWaveChannelMatrix(ns3::mmwave::MmWaveChannelMatrix const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveChannelMatrix const &', 'arg0')])
    ## mmwave-channel-matrix.h (module 'mmwave'): ns3::mmwave::MmWaveChannelMatrix::MmWaveChannelMatrix() [constructor]
    cls.add_constructor([])
    ## mmwave-channel-matrix.h (module 'mmwave'): ns3::Ptr<ns3::SpectrumValue> ns3::mmwave::MmWaveChannelMatrix::CalcRxPowerSpectralDensity(ns3::Ptr<const ns3::SpectrumValue> txPsd, ns3::Ptr<const ns3::MobilityModel> a, ns3::Ptr<const ns3::MobilityModel> b) const [member function]
    cls.add_method('CalcRxPowerSpectralDensity',
                   'ns3::Ptr< ns3::SpectrumValue >',
                   [param('ns3::Ptr< ns3::SpectrumValue const >', 'txPsd'), param('ns3::Ptr< ns3::MobilityModel const >', 'a'), param('ns3::Ptr< ns3::MobilityModel const >', 'b')],
                   is_const=True)
    ## mmwave-channel-matrix.h (module 'mmwave'): void ns3::mmwave::MmWaveChannelMatrix::ConnectDevices(ns3::Ptr<ns3::NetDevice> dev1, ns3::Ptr<ns3::NetDevice> dev2) [member function]
    cls.add_method('ConnectDevices',
                   'void',
                   [param('ns3::Ptr< ns3::NetDevice >', 'dev1'), param('ns3::Ptr< ns3::NetDevice >', 'dev2')])
    ## mmwave-channel-matrix.h (module 'mmwave'): void ns3::mmwave::MmWaveChannelMatrix::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## mmwave-channel-matrix.h (module 'mmwave'): ns3::Ptr<ns3::mmwave::MmWavePhyMacCommon> ns3::mmwave::MmWaveChannelMatrix::GetConfigurationParameters() const [member function]
    cls.add_method('GetConfigurationParameters',
                   'ns3::Ptr< ns3::mmwave::MmWavePhyMacCommon >',
                   [],
                   is_const=True)
    ## mmwave-channel-matrix.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWaveChannelMatrix::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-channel-matrix.h (module 'mmwave'): void ns3::mmwave::MmWaveChannelMatrix::Initial(ns3::NetDeviceContainer ueDevices, ns3::NetDeviceContainer enbDevices) [member function]
    cls.add_method('Initial',
                   'void',
                   [param('ns3::NetDeviceContainer', 'ueDevices'), param('ns3::NetDeviceContainer', 'enbDevices')])
    ## mmwave-channel-matrix.h (module 'mmwave'): void ns3::mmwave::MmWaveChannelMatrix::SetConfigurationParameters(ns3::Ptr<ns3::mmwave::MmWavePhyMacCommon> ptrConfig) [member function]
    cls.add_method('SetConfigurationParameters',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWavePhyMacCommon >', 'ptrConfig')])
    ## mmwave-channel-matrix.h (module 'mmwave'): ns3::Ptr<ns3::SpectrumValue> ns3::mmwave::MmWaveChannelMatrix::DoCalcRxPowerSpectralDensity(ns3::Ptr<const ns3::SpectrumValue> txPsd, ns3::Ptr<const ns3::MobilityModel> a, ns3::Ptr<const ns3::MobilityModel> b) const [member function]
    cls.add_method('DoCalcRxPowerSpectralDensity',
                   'ns3::Ptr< ns3::SpectrumValue >',
                   [param('ns3::Ptr< ns3::SpectrumValue const >', 'txPsd'), param('ns3::Ptr< ns3::MobilityModel const >', 'a'), param('ns3::Ptr< ns3::MobilityModel const >', 'b')],
                   is_const=True, visibility='private', is_virtual=True)
    return

def register_Ns3MmwaveMmWaveChannelRaytracing_methods(root_module, cls):
    ## mmwave-channel-raytracing.h (module 'mmwave'): ns3::mmwave::MmWaveChannelRaytracing::MmWaveChannelRaytracing(ns3::mmwave::MmWaveChannelRaytracing const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveChannelRaytracing const &', 'arg0')])
    ## mmwave-channel-raytracing.h (module 'mmwave'): ns3::mmwave::MmWaveChannelRaytracing::MmWaveChannelRaytracing() [constructor]
    cls.add_constructor([])
    ## mmwave-channel-raytracing.h (module 'mmwave'): ns3::Ptr<ns3::SpectrumValue> ns3::mmwave::MmWaveChannelRaytracing::CalcRxPowerSpectralDensity(ns3::Ptr<const ns3::SpectrumValue> txPsd, ns3::Ptr<const ns3::MobilityModel> a, ns3::Ptr<const ns3::MobilityModel> b) const [member function]
    cls.add_method('CalcRxPowerSpectralDensity',
                   'ns3::Ptr< ns3::SpectrumValue >',
                   [param('ns3::Ptr< ns3::SpectrumValue const >', 'txPsd'), param('ns3::Ptr< ns3::MobilityModel const >', 'a'), param('ns3::Ptr< ns3::MobilityModel const >', 'b')],
                   is_const=True)
    ## mmwave-channel-raytracing.h (module 'mmwave'): void ns3::mmwave::MmWaveChannelRaytracing::ConnectDevices(ns3::Ptr<ns3::NetDevice> dev1, ns3::Ptr<ns3::NetDevice> dev2) [member function]
    cls.add_method('ConnectDevices',
                   'void',
                   [param('ns3::Ptr< ns3::NetDevice >', 'dev1'), param('ns3::Ptr< ns3::NetDevice >', 'dev2')])
    ## mmwave-channel-raytracing.h (module 'mmwave'): void ns3::mmwave::MmWaveChannelRaytracing::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## mmwave-channel-raytracing.h (module 'mmwave'): ns3::Ptr<ns3::mmwave::MmWavePhyMacCommon> ns3::mmwave::MmWaveChannelRaytracing::GetConfigurationParameters() const [member function]
    cls.add_method('GetConfigurationParameters',
                   'ns3::Ptr< ns3::mmwave::MmWavePhyMacCommon >',
                   [],
                   is_const=True)
    ## mmwave-channel-raytracing.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWaveChannelRaytracing::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-channel-raytracing.h (module 'mmwave'): void ns3::mmwave::MmWaveChannelRaytracing::Initial(ns3::NetDeviceContainer ueDevices, ns3::NetDeviceContainer enbDevices) [member function]
    cls.add_method('Initial',
                   'void',
                   [param('ns3::NetDeviceContainer', 'ueDevices'), param('ns3::NetDeviceContainer', 'enbDevices')])
    ## mmwave-channel-raytracing.h (module 'mmwave'): void ns3::mmwave::MmWaveChannelRaytracing::LoadTraces() [member function]
    cls.add_method('LoadTraces',
                   'void',
                   [])
    ## mmwave-channel-raytracing.h (module 'mmwave'): void ns3::mmwave::MmWaveChannelRaytracing::SetConfigurationParameters(ns3::Ptr<ns3::mmwave::MmWavePhyMacCommon> ptrConfig) [member function]
    cls.add_method('SetConfigurationParameters',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWavePhyMacCommon >', 'ptrConfig')])
    ## mmwave-channel-raytracing.h (module 'mmwave'): ns3::Ptr<ns3::SpectrumValue> ns3::mmwave::MmWaveChannelRaytracing::DoCalcRxPowerSpectralDensity(ns3::Ptr<const ns3::SpectrumValue> txPsd, ns3::Ptr<const ns3::MobilityModel> a, ns3::Ptr<const ns3::MobilityModel> b) const [member function]
    cls.add_method('DoCalcRxPowerSpectralDensity',
                   'ns3::Ptr< ns3::SpectrumValue >',
                   [param('ns3::Ptr< ns3::SpectrumValue const >', 'txPsd'), param('ns3::Ptr< ns3::MobilityModel const >', 'a'), param('ns3::Ptr< ns3::MobilityModel const >', 'b')],
                   is_const=True, visibility='private', is_virtual=True)
    return

def register_Ns3MmwaveMmWaveComponentCarrier_methods(root_module, cls):
    ## mmwave-component-carrier.h (module 'mmwave'): ns3::mmwave::MmWaveComponentCarrier::MmWaveComponentCarrier(ns3::mmwave::MmWaveComponentCarrier const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveComponentCarrier const &', 'arg0')])
    ## mmwave-component-carrier.h (module 'mmwave'): ns3::mmwave::MmWaveComponentCarrier::MmWaveComponentCarrier() [constructor]
    cls.add_constructor([])
    ## mmwave-component-carrier.h (module 'mmwave'): void ns3::mmwave::MmWaveComponentCarrier::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## mmwave-component-carrier.h (module 'mmwave'): uint32_t ns3::mmwave::MmWaveComponentCarrier::GetBandwidth() const [member function]
    cls.add_method('GetBandwidth',
                   'uint32_t',
                   [],
                   is_const=True)
    ## mmwave-component-carrier.h (module 'mmwave'): double ns3::mmwave::MmWaveComponentCarrier::GetCenterFrequency() const [member function]
    cls.add_method('GetCenterFrequency',
                   'double',
                   [],
                   is_const=True)
    ## mmwave-component-carrier.h (module 'mmwave'): ns3::Ptr<ns3::mmwave::MmWavePhyMacCommon> ns3::mmwave::MmWaveComponentCarrier::GetConfigurationParameters() const [member function]
    cls.add_method('GetConfigurationParameters',
                   'ns3::Ptr< ns3::mmwave::MmWavePhyMacCommon >',
                   [],
                   is_const=True)
    ## mmwave-component-carrier.h (module 'mmwave'): uint32_t ns3::mmwave::MmWaveComponentCarrier::GetCsgId() const [member function]
    cls.add_method('GetCsgId',
                   'uint32_t',
                   [],
                   is_const=True)
    ## mmwave-component-carrier.h (module 'mmwave'): bool ns3::mmwave::MmWaveComponentCarrier::GetCsgIndication() const [member function]
    cls.add_method('GetCsgIndication',
                   'bool',
                   [],
                   is_const=True)
    ## mmwave-component-carrier.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWaveComponentCarrier::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-component-carrier.h (module 'mmwave'): bool ns3::mmwave::MmWaveComponentCarrier::IsPrimary() const [member function]
    cls.add_method('IsPrimary',
                   'bool',
                   [],
                   is_const=True)
    ## mmwave-component-carrier.h (module 'mmwave'): void ns3::mmwave::MmWaveComponentCarrier::SetAsPrimary(bool primaryCarrier) [member function]
    cls.add_method('SetAsPrimary',
                   'void',
                   [param('bool', 'primaryCarrier')])
    ## mmwave-component-carrier.h (module 'mmwave'): void ns3::mmwave::MmWaveComponentCarrier::SetConfigurationParameters(ns3::Ptr<ns3::mmwave::MmWavePhyMacCommon> ptrConfig) [member function]
    cls.add_method('SetConfigurationParameters',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWavePhyMacCommon >', 'ptrConfig')])
    ## mmwave-component-carrier.h (module 'mmwave'): void ns3::mmwave::MmWaveComponentCarrier::SetCsgId(uint32_t csgId) [member function]
    cls.add_method('SetCsgId',
                   'void',
                   [param('uint32_t', 'csgId')])
    ## mmwave-component-carrier.h (module 'mmwave'): void ns3::mmwave::MmWaveComponentCarrier::SetCsgIndication(bool csgIndication) [member function]
    cls.add_method('SetCsgIndication',
                   'void',
                   [param('bool', 'csgIndication')])
    ## mmwave-component-carrier.h (module 'mmwave'): void ns3::mmwave::MmWaveComponentCarrier::DoInitialize() [member function]
    cls.add_method('DoInitialize',
                   'void',
                   [],
                   visibility='protected', is_virtual=True)
    return

def register_Ns3MmwaveMmWaveComponentCarrierEnb_methods(root_module, cls):
    ## mmwave-component-carrier-enb.h (module 'mmwave'): ns3::mmwave::MmWaveComponentCarrierEnb::MmWaveComponentCarrierEnb(ns3::mmwave::MmWaveComponentCarrierEnb const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveComponentCarrierEnb const &', 'arg0')])
    ## mmwave-component-carrier-enb.h (module 'mmwave'): ns3::mmwave::MmWaveComponentCarrierEnb::MmWaveComponentCarrierEnb() [constructor]
    cls.add_constructor([])
    ## mmwave-component-carrier-enb.h (module 'mmwave'): void ns3::mmwave::MmWaveComponentCarrierEnb::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## mmwave-component-carrier-enb.h (module 'mmwave'): uint16_t ns3::mmwave::MmWaveComponentCarrierEnb::GetCellId() [member function]
    cls.add_method('GetCellId',
                   'uint16_t',
                   [])
    ## mmwave-component-carrier-enb.h (module 'mmwave'): ns3::Ptr<ns3::mmwave::MmWaveEnbMac> ns3::mmwave::MmWaveComponentCarrierEnb::GetMac() [member function]
    cls.add_method('GetMac',
                   'ns3::Ptr< ns3::mmwave::MmWaveEnbMac >',
                   [])
    ## mmwave-component-carrier-enb.h (module 'mmwave'): ns3::Ptr<ns3::mmwave::MmWaveMacScheduler> ns3::mmwave::MmWaveComponentCarrierEnb::GetMacScheduler() [member function]
    cls.add_method('GetMacScheduler',
                   'ns3::Ptr< ns3::mmwave::MmWaveMacScheduler >',
                   [])
    ## mmwave-component-carrier-enb.h (module 'mmwave'): ns3::Ptr<ns3::mmwave::MmWaveEnbPhy> ns3::mmwave::MmWaveComponentCarrierEnb::GetPhy() [member function]
    cls.add_method('GetPhy',
                   'ns3::Ptr< ns3::mmwave::MmWaveEnbPhy >',
                   [])
    ## mmwave-component-carrier-enb.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWaveComponentCarrierEnb::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-component-carrier-enb.h (module 'mmwave'): void ns3::mmwave::MmWaveComponentCarrierEnb::SetCellId(uint16_t cellId) [member function]
    cls.add_method('SetCellId',
                   'void',
                   [param('uint16_t', 'cellId')])
    ## mmwave-component-carrier-enb.h (module 'mmwave'): void ns3::mmwave::MmWaveComponentCarrierEnb::SetMac(ns3::Ptr<ns3::mmwave::MmWaveEnbMac> s) [member function]
    cls.add_method('SetMac',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWaveEnbMac >', 's')])
    ## mmwave-component-carrier-enb.h (module 'mmwave'): void ns3::mmwave::MmWaveComponentCarrierEnb::SetMacScheduler(ns3::Ptr<ns3::mmwave::MmWaveMacScheduler> s) [member function]
    cls.add_method('SetMacScheduler',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWaveMacScheduler >', 's')])
    ## mmwave-component-carrier-enb.h (module 'mmwave'): void ns3::mmwave::MmWaveComponentCarrierEnb::SetPhy(ns3::Ptr<ns3::mmwave::MmWaveEnbPhy> s) [member function]
    cls.add_method('SetPhy',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWaveEnbPhy >', 's')])
    ## mmwave-component-carrier-enb.h (module 'mmwave'): void ns3::mmwave::MmWaveComponentCarrierEnb::DoInitialize() [member function]
    cls.add_method('DoInitialize',
                   'void',
                   [],
                   visibility='protected', is_virtual=True)
    return

def register_Ns3MmwaveMmWaveComponentCarrierUe_methods(root_module, cls):
    ## mmwave-component-carrier-ue.h (module 'mmwave'): ns3::mmwave::MmWaveComponentCarrierUe::MmWaveComponentCarrierUe(ns3::mmwave::MmWaveComponentCarrierUe const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveComponentCarrierUe const &', 'arg0')])
    ## mmwave-component-carrier-ue.h (module 'mmwave'): ns3::mmwave::MmWaveComponentCarrierUe::MmWaveComponentCarrierUe() [constructor]
    cls.add_constructor([])
    ## mmwave-component-carrier-ue.h (module 'mmwave'): void ns3::mmwave::MmWaveComponentCarrierUe::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## mmwave-component-carrier-ue.h (module 'mmwave'): ns3::Ptr<ns3::mmwave::MmWaveUeMac> ns3::mmwave::MmWaveComponentCarrierUe::GetMac() const [member function]
    cls.add_method('GetMac',
                   'ns3::Ptr< ns3::mmwave::MmWaveUeMac >',
                   [],
                   is_const=True)
    ## mmwave-component-carrier-ue.h (module 'mmwave'): ns3::Ptr<ns3::mmwave::MmWaveUePhy> ns3::mmwave::MmWaveComponentCarrierUe::GetPhy() const [member function]
    cls.add_method('GetPhy',
                   'ns3::Ptr< ns3::mmwave::MmWaveUePhy >',
                   [],
                   is_const=True)
    ## mmwave-component-carrier-ue.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWaveComponentCarrierUe::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-component-carrier-ue.h (module 'mmwave'): void ns3::mmwave::MmWaveComponentCarrierUe::SetMac(ns3::Ptr<ns3::mmwave::MmWaveUeMac> s) [member function]
    cls.add_method('SetMac',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWaveUeMac >', 's')])
    ## mmwave-component-carrier-ue.h (module 'mmwave'): void ns3::mmwave::MmWaveComponentCarrierUe::SetPhy(ns3::Ptr<ns3::mmwave::MmWaveUePhy> s) [member function]
    cls.add_method('SetPhy',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWaveUePhy >', 's')])
    ## mmwave-component-carrier-ue.h (module 'mmwave'): void ns3::mmwave::MmWaveComponentCarrierUe::DoInitialize() [member function]
    cls.add_method('DoInitialize',
                   'void',
                   [],
                   visibility='protected', is_virtual=True)
    return

def register_Ns3MmwaveMmWaveControlMessage_methods(root_module, cls):
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::MmWaveControlMessage::MmWaveControlMessage(ns3::mmwave::MmWaveControlMessage const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveControlMessage const &', 'arg0')])
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::MmWaveControlMessage::MmWaveControlMessage() [constructor]
    cls.add_constructor([])
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::MmWaveControlMessage::messageType ns3::mmwave::MmWaveControlMessage::GetMessageType() [member function]
    cls.add_method('GetMessageType',
                   'ns3::mmwave::MmWaveControlMessage::messageType',
                   [])
    ## mmwave-control-messages.h (module 'mmwave'): void ns3::mmwave::MmWaveControlMessage::SetMessageType(ns3::mmwave::MmWaveControlMessage::messageType type) [member function]
    cls.add_method('SetMessageType',
                   'void',
                   [param('ns3::mmwave::MmWaveControlMessage::messageType', 'type')])
    return

def register_Ns3MmwaveMmWaveDciMessage_methods(root_module, cls):
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::MmWaveDciMessage::MmWaveDciMessage(ns3::mmwave::MmWaveDciMessage const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveDciMessage const &', 'arg0')])
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::MmWaveDciMessage::MmWaveDciMessage() [constructor]
    cls.add_constructor([])
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::DciInfoElement ns3::mmwave::MmWaveDciMessage::GetDciInfoElement() [member function]
    cls.add_method('GetDciInfoElement',
                   'ns3::mmwave::DciInfoElement',
                   [])
    ## mmwave-control-messages.h (module 'mmwave'): uint32_t ns3::mmwave::MmWaveDciMessage::GetSfnSf() [member function]
    cls.add_method('GetSfnSf',
                   'uint32_t',
                   [])
    ## mmwave-control-messages.h (module 'mmwave'): void ns3::mmwave::MmWaveDciMessage::SetDciInfoElement(ns3::mmwave::DciInfoElement dci) [member function]
    cls.add_method('SetDciInfoElement',
                   'void',
                   [param('ns3::mmwave::DciInfoElement', 'dci')])
    ## mmwave-control-messages.h (module 'mmwave'): void ns3::mmwave::MmWaveDciMessage::SetSfnSf(uint32_t sfn) [member function]
    cls.add_method('SetSfnSf',
                   'void',
                   [param('uint32_t', 'sfn')])
    return

def register_Ns3MmwaveMmWaveDlCqiMessage_methods(root_module, cls):
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::MmWaveDlCqiMessage::MmWaveDlCqiMessage(ns3::mmwave::MmWaveDlCqiMessage const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveDlCqiMessage const &', 'arg0')])
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::MmWaveDlCqiMessage::MmWaveDlCqiMessage() [constructor]
    cls.add_constructor([])
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::DlCqiInfo ns3::mmwave::MmWaveDlCqiMessage::GetDlCqi() [member function]
    cls.add_method('GetDlCqi',
                   'ns3::mmwave::DlCqiInfo',
                   [])
    ## mmwave-control-messages.h (module 'mmwave'): void ns3::mmwave::MmWaveDlCqiMessage::SetDlCqi(ns3::mmwave::DlCqiInfo cqi) [member function]
    cls.add_method('SetDlCqi',
                   'void',
                   [param('ns3::mmwave::DlCqiInfo', 'cqi')])
    return

def register_Ns3MmwaveMmWaveDlHarqFeedbackMessage_methods(root_module, cls):
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::MmWaveDlHarqFeedbackMessage::MmWaveDlHarqFeedbackMessage(ns3::mmwave::MmWaveDlHarqFeedbackMessage const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveDlHarqFeedbackMessage const &', 'arg0')])
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::MmWaveDlHarqFeedbackMessage::MmWaveDlHarqFeedbackMessage() [constructor]
    cls.add_constructor([])
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::DlHarqInfo ns3::mmwave::MmWaveDlHarqFeedbackMessage::GetDlHarqFeedback() [member function]
    cls.add_method('GetDlHarqFeedback',
                   'ns3::mmwave::DlHarqInfo',
                   [])
    ## mmwave-control-messages.h (module 'mmwave'): void ns3::mmwave::MmWaveDlHarqFeedbackMessage::SetDlHarqFeedback(ns3::mmwave::DlHarqInfo m) [member function]
    cls.add_method('SetDlHarqFeedback',
                   'void',
                   [param('ns3::mmwave::DlHarqInfo', 'm')])
    return

def register_Ns3MmwaveMmWaveDlHarqProcessInfo_methods(root_module, cls):
    ## mmwave-enb-mac.h (module 'mmwave'): ns3::mmwave::MmWaveDlHarqProcessInfo::MmWaveDlHarqProcessInfo() [constructor]
    cls.add_constructor([])
    ## mmwave-enb-mac.h (module 'mmwave'): ns3::mmwave::MmWaveDlHarqProcessInfo::MmWaveDlHarqProcessInfo(ns3::mmwave::MmWaveDlHarqProcessInfo const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveDlHarqProcessInfo const &', 'arg0')])
    ## mmwave-enb-mac.h (module 'mmwave'): ns3::mmwave::MmWaveDlHarqProcessInfo::m_lcidList [variable]
    cls.add_instance_attribute('m_lcidList', 'std::vector< unsigned char >', is_const=False)
    ## mmwave-enb-mac.h (module 'mmwave'): ns3::mmwave::MmWaveDlHarqProcessInfo::m_pktBurst [variable]
    cls.add_instance_attribute('m_pktBurst', 'ns3::Ptr< ns3::PacketBurst >', is_const=False)
    return

def register_Ns3MmwaveMmWaveEnbMac_methods(root_module, cls):
    ## mmwave-enb-mac.h (module 'mmwave'): ns3::mmwave::MmWaveEnbMac::MmWaveEnbMac(ns3::mmwave::MmWaveEnbMac const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveEnbMac const &', 'arg0')])
    ## mmwave-enb-mac.h (module 'mmwave'): ns3::mmwave::MmWaveEnbMac::MmWaveEnbMac() [constructor]
    cls.add_constructor([])
    ## mmwave-enb-mac.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbMac::AssociateUeMAC(uint64_t imsi) [member function]
    cls.add_method('AssociateUeMAC',
                   'void',
                   [param('uint64_t', 'imsi')])
    ## mmwave-enb-mac.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbMac::DoCschedCellConfigCnf(ns3::mmwave::MmWaveMacCschedSapUser::CschedCellConfigCnfParameters params) [member function]
    cls.add_method('DoCschedCellConfigCnf',
                   'void',
                   [param('ns3::mmwave::MmWaveMacCschedSapUser::CschedCellConfigCnfParameters', 'params')])
    ## mmwave-enb-mac.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbMac::DoCschedCellConfigUpdateInd(ns3::mmwave::MmWaveMacCschedSapUser::CschedCellConfigUpdateIndParameters params) [member function]
    cls.add_method('DoCschedCellConfigUpdateInd',
                   'void',
                   [param('ns3::mmwave::MmWaveMacCschedSapUser::CschedCellConfigUpdateIndParameters', 'params')])
    ## mmwave-enb-mac.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbMac::DoCschedLcConfigCnf(ns3::mmwave::MmWaveMacCschedSapUser::CschedLcConfigCnfParameters params) [member function]
    cls.add_method('DoCschedLcConfigCnf',
                   'void',
                   [param('ns3::mmwave::MmWaveMacCschedSapUser::CschedLcConfigCnfParameters', 'params')])
    ## mmwave-enb-mac.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbMac::DoCschedLcReleaseCnf(ns3::mmwave::MmWaveMacCschedSapUser::CschedLcReleaseCnfParameters params) [member function]
    cls.add_method('DoCschedLcReleaseCnf',
                   'void',
                   [param('ns3::mmwave::MmWaveMacCschedSapUser::CschedLcReleaseCnfParameters', 'params')])
    ## mmwave-enb-mac.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbMac::DoCschedUeConfigCnf(ns3::mmwave::MmWaveMacCschedSapUser::CschedUeConfigCnfParameters params) [member function]
    cls.add_method('DoCschedUeConfigCnf',
                   'void',
                   [param('ns3::mmwave::MmWaveMacCschedSapUser::CschedUeConfigCnfParameters', 'params')])
    ## mmwave-enb-mac.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbMac::DoCschedUeConfigUpdateInd(ns3::mmwave::MmWaveMacCschedSapUser::CschedUeConfigUpdateIndParameters params) [member function]
    cls.add_method('DoCschedUeConfigUpdateInd',
                   'void',
                   [param('ns3::mmwave::MmWaveMacCschedSapUser::CschedUeConfigUpdateIndParameters', 'params')])
    ## mmwave-enb-mac.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbMac::DoCschedUeReleaseCnf(ns3::mmwave::MmWaveMacCschedSapUser::CschedUeReleaseCnfParameters params) [member function]
    cls.add_method('DoCschedUeReleaseCnf',
                   'void',
                   [param('ns3::mmwave::MmWaveMacCschedSapUser::CschedUeReleaseCnfParameters', 'params')])
    ## mmwave-enb-mac.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbMac::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## mmwave-enb-mac.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbMac::DoReceiveControlMessage(ns3::Ptr<ns3::mmwave::MmWaveControlMessage> msg) [member function]
    cls.add_method('DoReceiveControlMessage',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWaveControlMessage >', 'msg')])
    ## mmwave-enb-mac.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbMac::DoReceivePhyPdu(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('DoReceivePhyPdu',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'p')])
    ## mmwave-enb-mac.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbMac::DoReportBufferStatus(ns3::LteMacSapProvider::ReportBufferStatusParameters arg0) [member function]
    cls.add_method('DoReportBufferStatus',
                   'void',
                   [param('ns3::LteMacSapProvider::ReportBufferStatusParameters', 'arg0')])
    ## mmwave-enb-mac.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbMac::DoReportMacCeToScheduler(ns3::MacCeListElement_s bsr) [member function]
    cls.add_method('DoReportMacCeToScheduler',
                   'void',
                   [param('ns3::MacCeListElement_s', 'bsr')])
    ## mmwave-enb-mac.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbMac::DoSchedConfigIndication(ns3::mmwave::MmWaveMacSchedSapUser::SchedConfigIndParameters ind) [member function]
    cls.add_method('DoSchedConfigIndication',
                   'void',
                   [param('ns3::mmwave::MmWaveMacSchedSapUser::SchedConfigIndParameters', 'ind')])
    ## mmwave-enb-mac.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbMac::DoSubframeIndication(ns3::mmwave::SfnSf sfnSf) [member function]
    cls.add_method('DoSubframeIndication',
                   'void',
                   [param('ns3::mmwave::SfnSf', 'sfnSf')])
    ## mmwave-enb-mac.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbMac::DoTransmitPdu(ns3::LteMacSapProvider::TransmitPduParameters arg0) [member function]
    cls.add_method('DoTransmitPdu',
                   'void',
                   [param('ns3::LteMacSapProvider::TransmitPduParameters', 'arg0')])
    ## mmwave-enb-mac.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbMac::DoUlCqiReport(ns3::mmwave::MmWaveMacSchedSapProvider::SchedUlCqiInfoReqParameters ulcqi) [member function]
    cls.add_method('DoUlCqiReport',
                   'void',
                   [param('ns3::mmwave::MmWaveMacSchedSapProvider::SchedUlCqiInfoReqParameters', 'ulcqi')])
    ## mmwave-enb-mac.h (module 'mmwave'): ns3::Ptr<ns3::mmwave::MmWavePhyMacCommon> ns3::mmwave::MmWaveEnbMac::GetConfigurationParameters() const [member function]
    cls.add_method('GetConfigurationParameters',
                   'ns3::Ptr< ns3::mmwave::MmWavePhyMacCommon >',
                   [],
                   is_const=True)
    ## mmwave-enb-mac.h (module 'mmwave'): ns3::LteEnbCmacSapProvider * ns3::mmwave::MmWaveEnbMac::GetEnbCmacSapProvider() [member function]
    cls.add_method('GetEnbCmacSapProvider',
                   'ns3::LteEnbCmacSapProvider *',
                   [])
    ## mmwave-enb-mac.h (module 'mmwave'): ns3::LteCcmMacSapProvider * ns3::mmwave::MmWaveEnbMac::GetLteCcmMacSapProvider() [member function]
    cls.add_method('GetLteCcmMacSapProvider',
                   'ns3::LteCcmMacSapProvider *',
                   [])
    ## mmwave-enb-mac.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser * ns3::mmwave::MmWaveEnbMac::GetMmWaveMacCschedSapUser() [member function]
    cls.add_method('GetMmWaveMacCschedSapUser',
                   'ns3::mmwave::MmWaveMacCschedSapUser *',
                   [])
    ## mmwave-enb-mac.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapUser * ns3::mmwave::MmWaveEnbMac::GetMmWaveMacSchedSapUser() [member function]
    cls.add_method('GetMmWaveMacSchedSapUser',
                   'ns3::mmwave::MmWaveMacSchedSapUser *',
                   [])
    ## mmwave-enb-mac.h (module 'mmwave'): ns3::mmwave::MmWaveEnbPhySapUser * ns3::mmwave::MmWaveEnbMac::GetPhySapUser() [member function]
    cls.add_method('GetPhySapUser',
                   'ns3::mmwave::MmWaveEnbPhySapUser *',
                   [])
    ## mmwave-enb-mac.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWaveEnbMac::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-enb-mac.h (module 'mmwave'): ns3::LteMacSapProvider * ns3::mmwave::MmWaveEnbMac::GetUeMacSapProvider() [member function]
    cls.add_method('GetUeMacSapProvider',
                   'ns3::LteMacSapProvider *',
                   [])
    ## mmwave-enb-mac.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbMac::ReceiveRachPreamble(uint32_t raId) [member function]
    cls.add_method('ReceiveRachPreamble',
                   'void',
                   [param('uint32_t', 'raId')])
    ## mmwave-enb-mac.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbMac::SetCellId(uint16_t cellId) [member function]
    cls.add_method('SetCellId',
                   'void',
                   [param('uint16_t', 'cellId')])
    ## mmwave-enb-mac.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbMac::SetComponentCarrierId(uint8_t index) [member function]
    cls.add_method('SetComponentCarrierId',
                   'void',
                   [param('uint8_t', 'index')])
    ## mmwave-enb-mac.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbMac::SetConfigurationParameters(ns3::Ptr<ns3::mmwave::MmWavePhyMacCommon> ptrConfig) [member function]
    cls.add_method('SetConfigurationParameters',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWavePhyMacCommon >', 'ptrConfig')])
    ## mmwave-enb-mac.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbMac::SetEnbCmacSapUser(ns3::LteEnbCmacSapUser * s) [member function]
    cls.add_method('SetEnbCmacSapUser',
                   'void',
                   [param('ns3::LteEnbCmacSapUser *', 's')])
    ## mmwave-enb-mac.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbMac::SetForwardUpCallback(ns3::Callback<void, ns3::Ptr<ns3::Packet>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> cb) [member function]
    cls.add_method('SetForwardUpCallback',
                   'void',
                   [param('ns3::Callback< void, ns3::Ptr< ns3::Packet >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'cb')])
    ## mmwave-enb-mac.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbMac::SetLteCcmMacSapUser(ns3::LteCcmMacSapUser * s) [member function]
    cls.add_method('SetLteCcmMacSapUser',
                   'void',
                   [param('ns3::LteCcmMacSapUser *', 's')])
    ## mmwave-enb-mac.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbMac::SetMcs(int mcs) [member function]
    cls.add_method('SetMcs',
                   'void',
                   [param('int', 'mcs')])
    ## mmwave-enb-mac.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbMac::SetMmWaveMacCschedSapProvider(ns3::mmwave::MmWaveMacCschedSapProvider * ptr) [member function]
    cls.add_method('SetMmWaveMacCschedSapProvider',
                   'void',
                   [param('ns3::mmwave::MmWaveMacCschedSapProvider *', 'ptr')])
    ## mmwave-enb-mac.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbMac::SetMmWaveMacSchedSapProvider(ns3::mmwave::MmWaveMacSchedSapProvider * ptr) [member function]
    cls.add_method('SetMmWaveMacSchedSapProvider',
                   'void',
                   [param('ns3::mmwave::MmWaveMacSchedSapProvider *', 'ptr')])
    ## mmwave-enb-mac.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbMac::SetPhySapProvider(ns3::mmwave::MmWavePhySapProvider * ptr) [member function]
    cls.add_method('SetPhySapProvider',
                   'void',
                   [param('ns3::mmwave::MmWavePhySapProvider *', 'ptr')])
    return

def register_Ns3MmwaveMmWaveEnbMacReportBufferStatusParameters_methods(root_module, cls):
    ## mmwave-enb-mac.h (module 'mmwave'): ns3::mmwave::MmWaveEnbMac::ReportBufferStatusParameters::ReportBufferStatusParameters() [constructor]
    cls.add_constructor([])
    ## mmwave-enb-mac.h (module 'mmwave'): ns3::mmwave::MmWaveEnbMac::ReportBufferStatusParameters::ReportBufferStatusParameters(ns3::mmwave::MmWaveEnbMac::ReportBufferStatusParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveEnbMac::ReportBufferStatusParameters const &', 'arg0')])
    ## mmwave-enb-mac.h (module 'mmwave'): ns3::mmwave::MmWaveEnbMac::ReportBufferStatusParameters::lcid [variable]
    cls.add_instance_attribute('lcid', 'uint8_t', is_const=False)
    ## mmwave-enb-mac.h (module 'mmwave'): ns3::mmwave::MmWaveEnbMac::ReportBufferStatusParameters::retxQueueHolDelay [variable]
    cls.add_instance_attribute('retxQueueHolDelay', 'uint16_t', is_const=False)
    ## mmwave-enb-mac.h (module 'mmwave'): ns3::mmwave::MmWaveEnbMac::ReportBufferStatusParameters::retxQueueSize [variable]
    cls.add_instance_attribute('retxQueueSize', 'uint32_t', is_const=False)
    ## mmwave-enb-mac.h (module 'mmwave'): ns3::mmwave::MmWaveEnbMac::ReportBufferStatusParameters::rnti [variable]
    cls.add_instance_attribute('rnti', 'uint16_t', is_const=False)
    ## mmwave-enb-mac.h (module 'mmwave'): ns3::mmwave::MmWaveEnbMac::ReportBufferStatusParameters::statusPduSize [variable]
    cls.add_instance_attribute('statusPduSize', 'uint16_t', is_const=False)
    ## mmwave-enb-mac.h (module 'mmwave'): ns3::mmwave::MmWaveEnbMac::ReportBufferStatusParameters::txQueueHolDelay [variable]
    cls.add_instance_attribute('txQueueHolDelay', 'uint16_t', is_const=False)
    ## mmwave-enb-mac.h (module 'mmwave'): ns3::mmwave::MmWaveEnbMac::ReportBufferStatusParameters::txQueueSize [variable]
    cls.add_instance_attribute('txQueueSize', 'uint32_t', is_const=False)
    return

def register_Ns3MmwaveMmWaveEnbMacTransmitPduParameters_methods(root_module, cls):
    ## mmwave-enb-mac.h (module 'mmwave'): ns3::mmwave::MmWaveEnbMac::TransmitPduParameters::TransmitPduParameters() [constructor]
    cls.add_constructor([])
    ## mmwave-enb-mac.h (module 'mmwave'): ns3::mmwave::MmWaveEnbMac::TransmitPduParameters::TransmitPduParameters(ns3::mmwave::MmWaveEnbMac::TransmitPduParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveEnbMac::TransmitPduParameters const &', 'arg0')])
    ## mmwave-enb-mac.h (module 'mmwave'): ns3::mmwave::MmWaveEnbMac::TransmitPduParameters::harqProcessId [variable]
    cls.add_instance_attribute('harqProcessId', 'uint8_t', is_const=False)
    ## mmwave-enb-mac.h (module 'mmwave'): ns3::mmwave::MmWaveEnbMac::TransmitPduParameters::layer [variable]
    cls.add_instance_attribute('layer', 'uint8_t', is_const=False)
    ## mmwave-enb-mac.h (module 'mmwave'): ns3::mmwave::MmWaveEnbMac::TransmitPduParameters::lcid [variable]
    cls.add_instance_attribute('lcid', 'uint8_t', is_const=False)
    ## mmwave-enb-mac.h (module 'mmwave'): ns3::mmwave::MmWaveEnbMac::TransmitPduParameters::pdu [variable]
    cls.add_instance_attribute('pdu', 'ns3::Ptr< ns3::Packet >', is_const=False)
    ## mmwave-enb-mac.h (module 'mmwave'): ns3::mmwave::MmWaveEnbMac::TransmitPduParameters::rnti [variable]
    cls.add_instance_attribute('rnti', 'uint16_t', is_const=False)
    return

def register_Ns3MmwaveMmWaveEnbPhySapUser_methods(root_module, cls):
    ## mmwave-phy-sap.h (module 'mmwave'): ns3::mmwave::MmWaveEnbPhySapUser::MmWaveEnbPhySapUser() [constructor]
    cls.add_constructor([])
    ## mmwave-phy-sap.h (module 'mmwave'): ns3::mmwave::MmWaveEnbPhySapUser::MmWaveEnbPhySapUser(ns3::mmwave::MmWaveEnbPhySapUser const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveEnbPhySapUser const &', 'arg0')])
    ## mmwave-phy-sap.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbPhySapUser::ReceiveControlMessage(ns3::Ptr<ns3::mmwave::MmWaveControlMessage> msg) [member function]
    cls.add_method('ReceiveControlMessage',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWaveControlMessage >', 'msg')],
                   is_pure_virtual=True, is_virtual=True)
    ## mmwave-phy-sap.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbPhySapUser::ReceivePhyPdu(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('ReceivePhyPdu',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'p')],
                   is_pure_virtual=True, is_virtual=True)
    ## mmwave-phy-sap.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbPhySapUser::ReceiveRachPreamble(uint32_t raId) [member function]
    cls.add_method('ReceiveRachPreamble',
                   'void',
                   [param('uint32_t', 'raId')],
                   is_pure_virtual=True, is_virtual=True)
    ## mmwave-phy-sap.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbPhySapUser::SubframeIndication(ns3::mmwave::SfnSf arg0) [member function]
    cls.add_method('SubframeIndication',
                   'void',
                   [param('ns3::mmwave::SfnSf', 'arg0')],
                   is_pure_virtual=True, is_virtual=True)
    ## mmwave-phy-sap.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbPhySapUser::UlCqiReport(ns3::mmwave::MmWaveMacSchedSapProvider::SchedUlCqiInfoReqParameters ulcqi) [member function]
    cls.add_method('UlCqiReport',
                   'void',
                   [param('ns3::mmwave::MmWaveMacSchedSapProvider::SchedUlCqiInfoReqParameters', 'ulcqi')],
                   is_pure_virtual=True, is_virtual=True)
    ## mmwave-phy-sap.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbPhySapUser::UlHarqFeedback(ns3::mmwave::UlHarqInfo params) [member function]
    cls.add_method('UlHarqFeedback',
                   'void',
                   [param('ns3::mmwave::UlHarqInfo', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3MmwaveMmWaveEnbRrcProtocolIdeal_methods(root_module, cls):
    ## mmwave-rrc-protocol-ideal.h (module 'mmwave'): ns3::mmwave::MmWaveEnbRrcProtocolIdeal::MmWaveEnbRrcProtocolIdeal(ns3::mmwave::MmWaveEnbRrcProtocolIdeal const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveEnbRrcProtocolIdeal const &', 'arg0')])
    ## mmwave-rrc-protocol-ideal.h (module 'mmwave'): ns3::mmwave::MmWaveEnbRrcProtocolIdeal::MmWaveEnbRrcProtocolIdeal() [constructor]
    cls.add_constructor([])
    ## mmwave-rrc-protocol-ideal.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbRrcProtocolIdeal::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## mmwave-rrc-protocol-ideal.h (module 'mmwave'): ns3::LteEnbRrcSapUser * ns3::mmwave::MmWaveEnbRrcProtocolIdeal::GetLteEnbRrcSapUser() [member function]
    cls.add_method('GetLteEnbRrcSapUser',
                   'ns3::LteEnbRrcSapUser *',
                   [])
    ## mmwave-rrc-protocol-ideal.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWaveEnbRrcProtocolIdeal::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-rrc-protocol-ideal.h (module 'mmwave'): ns3::LteUeRrcSapProvider * ns3::mmwave::MmWaveEnbRrcProtocolIdeal::GetUeRrcSapProvider(uint16_t rnti) [member function]
    cls.add_method('GetUeRrcSapProvider',
                   'ns3::LteUeRrcSapProvider *',
                   [param('uint16_t', 'rnti')])
    ## mmwave-rrc-protocol-ideal.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbRrcProtocolIdeal::SetCellId(uint16_t cellId) [member function]
    cls.add_method('SetCellId',
                   'void',
                   [param('uint16_t', 'cellId')])
    ## mmwave-rrc-protocol-ideal.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbRrcProtocolIdeal::SetLteEnbRrcSapProvider(ns3::LteEnbRrcSapProvider * p) [member function]
    cls.add_method('SetLteEnbRrcSapProvider',
                   'void',
                   [param('ns3::LteEnbRrcSapProvider *', 'p')])
    ## mmwave-rrc-protocol-ideal.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbRrcProtocolIdeal::SetUeRrcSapProvider(uint16_t rnti, ns3::LteUeRrcSapProvider * p) [member function]
    cls.add_method('SetUeRrcSapProvider',
                   'void',
                   [param('uint16_t', 'rnti'), param('ns3::LteUeRrcSapProvider *', 'p')])
    return

def register_Ns3MmwaveMmWaveHarqPhy_methods(root_module, cls):
    ## mmwave-harq-phy.h (module 'mmwave'): ns3::mmwave::MmWaveHarqPhy::MmWaveHarqPhy(ns3::mmwave::MmWaveHarqPhy const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveHarqPhy const &', 'arg0')])
    ## mmwave-harq-phy.h (module 'mmwave'): ns3::mmwave::MmWaveHarqPhy::MmWaveHarqPhy(uint32_t harqNum) [constructor]
    cls.add_constructor([param('uint32_t', 'harqNum')])
    ## mmwave-harq-phy.h (module 'mmwave'): double ns3::mmwave::MmWaveHarqPhy::GetAccumulatedMiDl(uint16_t rnti, uint8_t harqId) [member function]
    cls.add_method('GetAccumulatedMiDl',
                   'double',
                   [param('uint16_t', 'rnti'), param('uint8_t', 'harqId')])
    ## mmwave-harq-phy.h (module 'mmwave'): double ns3::mmwave::MmWaveHarqPhy::GetAccumulatedMiUl(uint16_t rnti, uint8_t harqId) [member function]
    cls.add_method('GetAccumulatedMiUl',
                   'double',
                   [param('uint16_t', 'rnti'), param('uint8_t', 'harqId')])
    ## mmwave-harq-phy.h (module 'mmwave'): ns3::mmwave::MmWaveHarqProcessInfoList_t ns3::mmwave::MmWaveHarqPhy::GetHarqProcessInfoDl(uint16_t rnti, uint8_t harqProcId) [member function]
    cls.add_method('GetHarqProcessInfoDl',
                   'ns3::mmwave::MmWaveHarqProcessInfoList_t',
                   [param('uint16_t', 'rnti'), param('uint8_t', 'harqProcId')])
    ## mmwave-harq-phy.h (module 'mmwave'): ns3::mmwave::MmWaveHarqProcessInfoList_t ns3::mmwave::MmWaveHarqPhy::GetHarqProcessInfoUl(uint16_t rnti, uint8_t harqProcId) [member function]
    cls.add_method('GetHarqProcessInfoUl',
                   'ns3::mmwave::MmWaveHarqProcessInfoList_t',
                   [param('uint16_t', 'rnti'), param('uint8_t', 'harqProcId')])
    ## mmwave-harq-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveHarqPhy::ResetDlHarqProcessStatus(uint16_t rnti, uint8_t id) [member function]
    cls.add_method('ResetDlHarqProcessStatus',
                   'void',
                   [param('uint16_t', 'rnti'), param('uint8_t', 'id')])
    ## mmwave-harq-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveHarqPhy::ResetUlHarqProcessStatus(uint16_t rnti, uint8_t id) [member function]
    cls.add_method('ResetUlHarqProcessStatus',
                   'void',
                   [param('uint16_t', 'rnti'), param('uint8_t', 'id')])
    ## mmwave-harq-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveHarqPhy::SubframeIndication(ns3::mmwave::SfnSf arg0) [member function]
    cls.add_method('SubframeIndication',
                   'void',
                   [param('ns3::mmwave::SfnSf', 'arg0')])
    ## mmwave-harq-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveHarqPhy::UpdateDlHarqProcessStatus(uint16_t rnti, uint8_t id, double mi, uint32_t infoBytes, uint32_t codeBytes) [member function]
    cls.add_method('UpdateDlHarqProcessStatus',
                   'void',
                   [param('uint16_t', 'rnti'), param('uint8_t', 'id'), param('double', 'mi'), param('uint32_t', 'infoBytes'), param('uint32_t', 'codeBytes')])
    ## mmwave-harq-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveHarqPhy::UpdateUlHarqProcessStatus(uint16_t rnti, uint8_t harqId, double mi, uint32_t infoBytes, uint32_t codeBytes) [member function]
    cls.add_method('UpdateUlHarqProcessStatus',
                   'void',
                   [param('uint16_t', 'rnti'), param('uint8_t', 'harqId'), param('double', 'mi'), param('uint32_t', 'infoBytes'), param('uint32_t', 'codeBytes')])
    return

def register_Ns3MmwaveMmWaveHarqProcessInfoElement_t_methods(root_module, cls):
    ## mmwave-harq-phy.h (module 'mmwave'): ns3::mmwave::MmWaveHarqProcessInfoElement_t::MmWaveHarqProcessInfoElement_t() [constructor]
    cls.add_constructor([])
    ## mmwave-harq-phy.h (module 'mmwave'): ns3::mmwave::MmWaveHarqProcessInfoElement_t::MmWaveHarqProcessInfoElement_t(ns3::mmwave::MmWaveHarqProcessInfoElement_t const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveHarqProcessInfoElement_t const &', 'arg0')])
    ## mmwave-harq-phy.h (module 'mmwave'): ns3::mmwave::MmWaveHarqProcessInfoElement_t::m_codeBits [variable]
    cls.add_instance_attribute('m_codeBits', 'uint32_t', is_const=False)
    ## mmwave-harq-phy.h (module 'mmwave'): ns3::mmwave::MmWaveHarqProcessInfoElement_t::m_infoBits [variable]
    cls.add_instance_attribute('m_infoBits', 'uint32_t', is_const=False)
    ## mmwave-harq-phy.h (module 'mmwave'): ns3::mmwave::MmWaveHarqProcessInfoElement_t::m_mi [variable]
    cls.add_instance_attribute('m_mi', 'double', is_const=False)
    ## mmwave-harq-phy.h (module 'mmwave'): ns3::mmwave::MmWaveHarqProcessInfoElement_t::m_rv [variable]
    cls.add_instance_attribute('m_rv', 'uint8_t', is_const=False)
    return

def register_Ns3MmwaveMmWaveHelper_methods(root_module, cls):
    ## mmwave-helper.h (module 'mmwave'): ns3::mmwave::MmWaveHelper::MmWaveHelper(ns3::mmwave::MmWaveHelper const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveHelper const &', 'arg0')])
    ## mmwave-helper.h (module 'mmwave'): ns3::mmwave::MmWaveHelper::MmWaveHelper() [constructor]
    cls.add_constructor([])
    ## mmwave-helper.h (module 'mmwave'): void ns3::mmwave::MmWaveHelper::ActivateDataRadioBearer(ns3::NetDeviceContainer ueDevices, ns3::EpsBearer bearer) [member function]
    cls.add_method('ActivateDataRadioBearer',
                   'void',
                   [param('ns3::NetDeviceContainer', 'ueDevices'), param('ns3::EpsBearer', 'bearer')])
    ## mmwave-helper.h (module 'mmwave'): void ns3::mmwave::MmWaveHelper::ActivateDataRadioBearer(ns3::Ptr<ns3::NetDevice> ueDevice, ns3::EpsBearer bearer) [member function]
    cls.add_method('ActivateDataRadioBearer',
                   'void',
                   [param('ns3::Ptr< ns3::NetDevice >', 'ueDevice'), param('ns3::EpsBearer', 'bearer')])
    ## mmwave-helper.h (module 'mmwave'): void ns3::mmwave::MmWaveHelper::AddX2Interface(ns3::NodeContainer enbNodes) [member function]
    cls.add_method('AddX2Interface',
                   'void',
                   [param('ns3::NodeContainer', 'enbNodes')])
    ## mmwave-helper.h (module 'mmwave'): void ns3::mmwave::MmWaveHelper::AddX2Interface(ns3::NodeContainer lteEnbNodes, ns3::NodeContainer mmWaveEnbNodes) [member function]
    cls.add_method('AddX2Interface',
                   'void',
                   [param('ns3::NodeContainer', 'lteEnbNodes'), param('ns3::NodeContainer', 'mmWaveEnbNodes')])
    ## mmwave-helper.h (module 'mmwave'): void ns3::mmwave::MmWaveHelper::AddX2Interface(ns3::Ptr<ns3::Node> enbNode1, ns3::Ptr<ns3::Node> enbNode2) [member function]
    cls.add_method('AddX2Interface',
                   'void',
                   [param('ns3::Ptr< ns3::Node >', 'enbNode1'), param('ns3::Ptr< ns3::Node >', 'enbNode2')])
    ## mmwave-helper.h (module 'mmwave'): void ns3::mmwave::MmWaveHelper::AttachIrToClosestEnb(ns3::NetDeviceContainer ueDevices, ns3::NetDeviceContainer mmWaveEnbDevices, ns3::NetDeviceContainer lteEnbDevices) [member function]
    cls.add_method('AttachIrToClosestEnb',
                   'void',
                   [param('ns3::NetDeviceContainer', 'ueDevices'), param('ns3::NetDeviceContainer', 'mmWaveEnbDevices'), param('ns3::NetDeviceContainer', 'lteEnbDevices')])
    ## mmwave-helper.h (module 'mmwave'): void ns3::mmwave::MmWaveHelper::AttachToClosestEnb(ns3::NetDeviceContainer ueDevices, ns3::NetDeviceContainer enbDevices) [member function]
    cls.add_method('AttachToClosestEnb',
                   'void',
                   [param('ns3::NetDeviceContainer', 'ueDevices'), param('ns3::NetDeviceContainer', 'enbDevices')])
    ## mmwave-helper.h (module 'mmwave'): void ns3::mmwave::MmWaveHelper::AttachToClosestEnb(ns3::NetDeviceContainer ueDevices, ns3::NetDeviceContainer mmWaveEnbDevices, ns3::NetDeviceContainer lteEnbDevices) [member function]
    cls.add_method('AttachToClosestEnb',
                   'void',
                   [param('ns3::NetDeviceContainer', 'ueDevices'), param('ns3::NetDeviceContainer', 'mmWaveEnbDevices'), param('ns3::NetDeviceContainer', 'lteEnbDevices')])
    ## mmwave-helper.h (module 'mmwave'): void ns3::mmwave::MmWaveHelper::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## mmwave-helper.h (module 'mmwave'): void ns3::mmwave::MmWaveHelper::EnableDlPhyTrace() [member function]
    cls.add_method('EnableDlPhyTrace',
                   'void',
                   [])
    ## mmwave-helper.h (module 'mmwave'): void ns3::mmwave::MmWaveHelper::EnableMcTraces() [member function]
    cls.add_method('EnableMcTraces',
                   'void',
                   [])
    ## mmwave-helper.h (module 'mmwave'): void ns3::mmwave::MmWaveHelper::EnablePdcpTraces() [member function]
    cls.add_method('EnablePdcpTraces',
                   'void',
                   [])
    ## mmwave-helper.h (module 'mmwave'): void ns3::mmwave::MmWaveHelper::EnableRlcTraces() [member function]
    cls.add_method('EnableRlcTraces',
                   'void',
                   [])
    ## mmwave-helper.h (module 'mmwave'): void ns3::mmwave::MmWaveHelper::EnableTraces() [member function]
    cls.add_method('EnableTraces',
                   'void',
                   [])
    ## mmwave-helper.h (module 'mmwave'): void ns3::mmwave::MmWaveHelper::EnableUlPhyTrace() [member function]
    cls.add_method('EnableUlPhyTrace',
                   'void',
                   [])
    ## mmwave-helper.h (module 'mmwave'): std::map<unsigned char, ns3::mmwave::MmWaveComponentCarrier, std::less<unsigned char>, std::allocator<std::pair<const unsigned char, ns3::mmwave::MmWaveComponentCarrier> > > ns3::mmwave::MmWaveHelper::GetCcPhyParams() [member function]
    cls.add_method('GetCcPhyParams',
                   'std::map< unsigned char, ns3::mmwave::MmWaveComponentCarrier >',
                   [])
    ## mmwave-helper.h (module 'mmwave'): std::string ns3::mmwave::MmWaveHelper::GetEnbComponentCarrierManagerType() const [member function]
    cls.add_method('GetEnbComponentCarrierManagerType',
                   'std::string',
                   [],
                   is_const=True)
    ## mmwave-helper.h (module 'mmwave'): bool ns3::mmwave::MmWaveHelper::GetHarqEnabled() [member function]
    cls.add_method('GetHarqEnabled',
                   'bool',
                   [])
    ## mmwave-helper.h (module 'mmwave'): std::string ns3::mmwave::MmWaveHelper::GetLteEnbComponentCarrierManagerType() const [member function]
    cls.add_method('GetLteEnbComponentCarrierManagerType',
                   'std::string',
                   [],
                   is_const=True)
    ## mmwave-helper.h (module 'mmwave'): std::string ns3::mmwave::MmWaveHelper::GetLteFfrAlgorithmType() const [member function]
    cls.add_method('GetLteFfrAlgorithmType',
                   'std::string',
                   [],
                   is_const=True)
    ## mmwave-helper.h (module 'mmwave'): std::string ns3::mmwave::MmWaveHelper::GetLteHandoverAlgorithmType() const [member function]
    cls.add_method('GetLteHandoverAlgorithmType',
                   'std::string',
                   [],
                   is_const=True)
    ## mmwave-helper.h (module 'mmwave'): std::string ns3::mmwave::MmWaveHelper::GetLteSchedulerType() const [member function]
    cls.add_method('GetLteSchedulerType',
                   'std::string',
                   [],
                   is_const=True)
    ## mmwave-helper.h (module 'mmwave'): ns3::Ptr<ns3::PropagationLossModel> ns3::mmwave::MmWaveHelper::GetPathLossModel(uint8_t index) [member function]
    cls.add_method('GetPathLossModel',
                   'ns3::Ptr< ns3::PropagationLossModel >',
                   [param('uint8_t', 'index')])
    ## mmwave-helper.h (module 'mmwave'): std::string ns3::mmwave::MmWaveHelper::GetSchedulerType() const [member function]
    cls.add_method('GetSchedulerType',
                   'std::string',
                   [],
                   is_const=True)
    ## mmwave-helper.h (module 'mmwave'): bool ns3::mmwave::MmWaveHelper::GetSnrTest() [member function]
    cls.add_method('GetSnrTest',
                   'bool',
                   [])
    ## mmwave-helper.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWaveHelper::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-helper.h (module 'mmwave'): std::string ns3::mmwave::MmWaveHelper::GetUeComponentCarrierManagerType() const [member function]
    cls.add_method('GetUeComponentCarrierManagerType',
                   'std::string',
                   [],
                   is_const=True)
    ## mmwave-helper.h (module 'mmwave'): ns3::NetDeviceContainer ns3::mmwave::MmWaveHelper::InstallEnbDevice(ns3::NodeContainer c) [member function]
    cls.add_method('InstallEnbDevice',
                   'ns3::NetDeviceContainer',
                   [param('ns3::NodeContainer', 'c')])
    ## mmwave-helper.h (module 'mmwave'): ns3::NetDeviceContainer ns3::mmwave::MmWaveHelper::InstallInterRatHoCapableUeDevice(ns3::NodeContainer c) [member function]
    cls.add_method('InstallInterRatHoCapableUeDevice',
                   'ns3::NetDeviceContainer',
                   [param('ns3::NodeContainer', 'c')])
    ## mmwave-helper.h (module 'mmwave'): ns3::NetDeviceContainer ns3::mmwave::MmWaveHelper::InstallLteEnbDevice(ns3::NodeContainer c) [member function]
    cls.add_method('InstallLteEnbDevice',
                   'ns3::NetDeviceContainer',
                   [param('ns3::NodeContainer', 'c')])
    ## mmwave-helper.h (module 'mmwave'): ns3::NetDeviceContainer ns3::mmwave::MmWaveHelper::InstallMcUeDevice(ns3::NodeContainer c) [member function]
    cls.add_method('InstallMcUeDevice',
                   'ns3::NetDeviceContainer',
                   [param('ns3::NodeContainer', 'c')])
    ## mmwave-helper.h (module 'mmwave'): ns3::NetDeviceContainer ns3::mmwave::MmWaveHelper::InstallUeDevice(ns3::NodeContainer c) [member function]
    cls.add_method('InstallUeDevice',
                   'ns3::NetDeviceContainer',
                   [param('ns3::NodeContainer', 'c')])
    ## mmwave-helper.h (module 'mmwave'): void ns3::mmwave::MmWaveHelper::SetAntenna(uint16_t Nrx, uint16_t Ntx) [member function]
    cls.add_method('SetAntenna',
                   'void',
                   [param('uint16_t', 'Nrx'), param('uint16_t', 'Ntx')])
    ## mmwave-helper.h (module 'mmwave'): void ns3::mmwave::MmWaveHelper::SetBlockageMap(std::map<unsigned char, bool, std::less<unsigned char>, std::allocator<std::pair<const unsigned char, bool> > > blockageMap) [member function]
    cls.add_method('SetBlockageMap',
                   'void',
                   [param('std::map< unsigned char, bool >', 'blockageMap')])
    ## mmwave-helper.h (module 'mmwave'): void ns3::mmwave::MmWaveHelper::SetCcPhyParams(std::map<unsigned char, ns3::mmwave::MmWaveComponentCarrier, std::less<unsigned char>, std::allocator<std::pair<const unsigned char, ns3::mmwave::MmWaveComponentCarrier> > > ccMapParams) [member function]
    cls.add_method('SetCcPhyParams',
                   'void',
                   [param('std::map< unsigned char, ns3::mmwave::MmWaveComponentCarrier >', 'ccMapParams')])
    ## mmwave-helper.h (module 'mmwave'): void ns3::mmwave::MmWaveHelper::SetChannelModelType(std::string type) [member function]
    cls.add_method('SetChannelModelType',
                   'void',
                   [param('std::string', 'type')])
    ## mmwave-helper.h (module 'mmwave'): void ns3::mmwave::MmWaveHelper::SetEnbComponentCarrierManagerType(std::string type) [member function]
    cls.add_method('SetEnbComponentCarrierManagerType',
                   'void',
                   [param('std::string', 'type')])
    ## mmwave-helper.h (module 'mmwave'): void ns3::mmwave::MmWaveHelper::SetEpcHelper(ns3::Ptr<ns3::EpcHelper> epcHelper) [member function]
    cls.add_method('SetEpcHelper',
                   'void',
                   [param('ns3::Ptr< ns3::EpcHelper >', 'epcHelper')])
    ## mmwave-helper.h (module 'mmwave'): void ns3::mmwave::MmWaveHelper::SetHarqEnabled(bool harqEnabled) [member function]
    cls.add_method('SetHarqEnabled',
                   'void',
                   [param('bool', 'harqEnabled')])
    ## mmwave-helper.h (module 'mmwave'): void ns3::mmwave::MmWaveHelper::SetLteCcPhyParams(std::map<unsigned char, ns3::ComponentCarrier, std::less<unsigned char>, std::allocator<std::pair<const unsigned char, ns3::ComponentCarrier> > > ccMapParams) [member function]
    cls.add_method('SetLteCcPhyParams',
                   'void',
                   [param('std::map< unsigned char, ns3::ComponentCarrier >', 'ccMapParams')])
    ## mmwave-helper.h (module 'mmwave'): void ns3::mmwave::MmWaveHelper::SetLteEnbComponentCarrierManagerType(std::string type) [member function]
    cls.add_method('SetLteEnbComponentCarrierManagerType',
                   'void',
                   [param('std::string', 'type')])
    ## mmwave-helper.h (module 'mmwave'): void ns3::mmwave::MmWaveHelper::SetLteFfrAlgorithmType(std::string type) [member function]
    cls.add_method('SetLteFfrAlgorithmType',
                   'void',
                   [param('std::string', 'type')])
    ## mmwave-helper.h (module 'mmwave'): void ns3::mmwave::MmWaveHelper::SetLteHandoverAlgorithmType(std::string type) [member function]
    cls.add_method('SetLteHandoverAlgorithmType',
                   'void',
                   [param('std::string', 'type')])
    ## mmwave-helper.h (module 'mmwave'): void ns3::mmwave::MmWaveHelper::SetLtePathlossModelType(std::string type) [member function]
    cls.add_method('SetLtePathlossModelType',
                   'void',
                   [param('std::string', 'type')])
    ## mmwave-helper.h (module 'mmwave'): void ns3::mmwave::MmWaveHelper::SetLteSchedulerType(std::string type) [member function]
    cls.add_method('SetLteSchedulerType',
                   'void',
                   [param('std::string', 'type')])
    ## mmwave-helper.h (module 'mmwave'): void ns3::mmwave::MmWaveHelper::SetPathlossModelType(std::string type) [member function]
    cls.add_method('SetPathlossModelType',
                   'void',
                   [param('std::string', 'type')])
    ## mmwave-helper.h (module 'mmwave'): void ns3::mmwave::MmWaveHelper::SetSchedulerType(std::string type) [member function]
    cls.add_method('SetSchedulerType',
                   'void',
                   [param('std::string', 'type')])
    ## mmwave-helper.h (module 'mmwave'): void ns3::mmwave::MmWaveHelper::SetSnrTest(bool snrTest) [member function]
    cls.add_method('SetSnrTest',
                   'void',
                   [param('bool', 'snrTest')])
    ## mmwave-helper.h (module 'mmwave'): void ns3::mmwave::MmWaveHelper::SetUeComponentCarrierManagerType(std::string type) [member function]
    cls.add_method('SetUeComponentCarrierManagerType',
                   'void',
                   [param('std::string', 'type')])
    ## mmwave-helper.h (module 'mmwave'): void ns3::mmwave::MmWaveHelper::DoInitialize() [member function]
    cls.add_method('DoInitialize',
                   'void',
                   [],
                   visibility='protected', is_virtual=True)
    return

def register_Ns3MmwaveMmWaveLosTracker_methods(root_module, cls):
    ## mmwave-los-tracker.h (module 'mmwave'): ns3::mmwave::MmWaveLosTracker::MmWaveLosTracker(ns3::mmwave::MmWaveLosTracker const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveLosTracker const &', 'arg0')])
    ## mmwave-los-tracker.h (module 'mmwave'): ns3::mmwave::MmWaveLosTracker::MmWaveLosTracker() [constructor]
    cls.add_constructor([])
    ## mmwave-los-tracker.h (module 'mmwave'): int ns3::mmwave::MmWaveLosTracker::GetLosSamples(ns3::Ptr<ns3::MobilityModel> a, ns3::Ptr<ns3::MobilityModel> b) const [member function]
    cls.add_method('GetLosSamples',
                   'int',
                   [param('ns3::Ptr< ns3::MobilityModel >', 'a'), param('ns3::Ptr< ns3::MobilityModel >', 'b')],
                   is_const=True)
    ## mmwave-los-tracker.h (module 'mmwave'): int ns3::mmwave::MmWaveLosTracker::GetNlosSamples(ns3::Ptr<ns3::MobilityModel> a, ns3::Ptr<ns3::MobilityModel> b) const [member function]
    cls.add_method('GetNlosSamples',
                   'int',
                   [param('ns3::Ptr< ns3::MobilityModel >', 'a'), param('ns3::Ptr< ns3::MobilityModel >', 'b')],
                   is_const=True)
    ## mmwave-los-tracker.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWaveLosTracker::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-los-tracker.h (module 'mmwave'): void ns3::mmwave::MmWaveLosTracker::UpdateLosNlosState(ns3::Ptr<ns3::MobilityModel> a, ns3::Ptr<ns3::MobilityModel> b) [member function]
    cls.add_method('UpdateLosNlosState',
                   'void',
                   [param('ns3::Ptr< ns3::MobilityModel >', 'a'), param('ns3::Ptr< ns3::MobilityModel >', 'b')])
    return

def register_Ns3MmwaveMmWaveLteEnbRrcProtocolReal_methods(root_module, cls):
    ## mmwave-lte-rrc-protocol-real.h (module 'mmwave'): ns3::mmwave::MmWaveLteEnbRrcProtocolReal::MmWaveLteEnbRrcProtocolReal(ns3::mmwave::MmWaveLteEnbRrcProtocolReal const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveLteEnbRrcProtocolReal const &', 'arg0')])
    ## mmwave-lte-rrc-protocol-real.h (module 'mmwave'): ns3::mmwave::MmWaveLteEnbRrcProtocolReal::MmWaveLteEnbRrcProtocolReal() [constructor]
    cls.add_constructor([])
    ## mmwave-lte-rrc-protocol-real.h (module 'mmwave'): void ns3::mmwave::MmWaveLteEnbRrcProtocolReal::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## mmwave-lte-rrc-protocol-real.h (module 'mmwave'): ns3::LteEnbRrcSapUser * ns3::mmwave::MmWaveLteEnbRrcProtocolReal::GetLteEnbRrcSapUser() [member function]
    cls.add_method('GetLteEnbRrcSapUser',
                   'ns3::LteEnbRrcSapUser *',
                   [])
    ## mmwave-lte-rrc-protocol-real.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWaveLteEnbRrcProtocolReal::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-lte-rrc-protocol-real.h (module 'mmwave'): ns3::LteUeRrcSapProvider * ns3::mmwave::MmWaveLteEnbRrcProtocolReal::GetUeRrcSapProvider(uint16_t rnti) [member function]
    cls.add_method('GetUeRrcSapProvider',
                   'ns3::LteUeRrcSapProvider *',
                   [param('uint16_t', 'rnti')])
    ## mmwave-lte-rrc-protocol-real.h (module 'mmwave'): void ns3::mmwave::MmWaveLteEnbRrcProtocolReal::SetCellId(uint16_t cellId) [member function]
    cls.add_method('SetCellId',
                   'void',
                   [param('uint16_t', 'cellId')])
    ## mmwave-lte-rrc-protocol-real.h (module 'mmwave'): void ns3::mmwave::MmWaveLteEnbRrcProtocolReal::SetLteEnbRrcSapProvider(ns3::LteEnbRrcSapProvider * p) [member function]
    cls.add_method('SetLteEnbRrcSapProvider',
                   'void',
                   [param('ns3::LteEnbRrcSapProvider *', 'p')])
    ## mmwave-lte-rrc-protocol-real.h (module 'mmwave'): void ns3::mmwave::MmWaveLteEnbRrcProtocolReal::SetUeRrcSapProvider(uint16_t rnti, ns3::LteUeRrcSapProvider * p) [member function]
    cls.add_method('SetUeRrcSapProvider',
                   'void',
                   [param('uint16_t', 'rnti'), param('ns3::LteUeRrcSapProvider *', 'p')])
    return

def register_Ns3MmwaveMmWaveLteUeRrcProtocolReal_methods(root_module, cls):
    ## mmwave-lte-rrc-protocol-real.h (module 'mmwave'): ns3::mmwave::MmWaveLteUeRrcProtocolReal::MmWaveLteUeRrcProtocolReal(ns3::mmwave::MmWaveLteUeRrcProtocolReal const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveLteUeRrcProtocolReal const &', 'arg0')])
    ## mmwave-lte-rrc-protocol-real.h (module 'mmwave'): ns3::mmwave::MmWaveLteUeRrcProtocolReal::MmWaveLteUeRrcProtocolReal() [constructor]
    cls.add_constructor([])
    ## mmwave-lte-rrc-protocol-real.h (module 'mmwave'): void ns3::mmwave::MmWaveLteUeRrcProtocolReal::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## mmwave-lte-rrc-protocol-real.h (module 'mmwave'): ns3::LteUeRrcSapUser * ns3::mmwave::MmWaveLteUeRrcProtocolReal::GetLteUeRrcSapUser() [member function]
    cls.add_method('GetLteUeRrcSapUser',
                   'ns3::LteUeRrcSapUser *',
                   [])
    ## mmwave-lte-rrc-protocol-real.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWaveLteUeRrcProtocolReal::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-lte-rrc-protocol-real.h (module 'mmwave'): void ns3::mmwave::MmWaveLteUeRrcProtocolReal::SetLteUeRrcSapProvider(ns3::LteUeRrcSapProvider * p) [member function]
    cls.add_method('SetLteUeRrcSapProvider',
                   'void',
                   [param('ns3::LteUeRrcSapProvider *', 'p')])
    ## mmwave-lte-rrc-protocol-real.h (module 'mmwave'): void ns3::mmwave::MmWaveLteUeRrcProtocolReal::SetUeRrc(ns3::Ptr<ns3::LteUeRrc> rrc) [member function]
    cls.add_method('SetUeRrc',
                   'void',
                   [param('ns3::Ptr< ns3::LteUeRrc >', 'rrc')])
    return

def register_Ns3MmwaveMmWaveMac_methods(root_module, cls):
    ## mmwave-mac.h (module 'mmwave'): ns3::mmwave::MmWaveMac::MmWaveMac(ns3::mmwave::MmWaveMac const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveMac const &', 'arg0')])
    ## mmwave-mac.h (module 'mmwave'): ns3::mmwave::MmWaveMac::MmWaveMac() [constructor]
    cls.add_constructor([])
    ## mmwave-mac.h (module 'mmwave'): ns3::Ptr<ns3::mmwave::MmWavePhyMacCommon> ns3::mmwave::MmWaveMac::GetConfigurationParameters() const [member function]
    cls.add_method('GetConfigurationParameters',
                   'ns3::Ptr< ns3::mmwave::MmWavePhyMacCommon >',
                   [],
                   is_const=True)
    ## mmwave-mac.h (module 'mmwave'): ns3::Ptr<ns3::PacketBurst> ns3::mmwave::MmWaveMac::GetPacketBurstFromMacQueue() [member function]
    cls.add_method('GetPacketBurstFromMacQueue',
                   'ns3::Ptr< ns3::PacketBurst >',
                   [])
    ## mmwave-mac.h (module 'mmwave'): bool ns3::mmwave::MmWaveMac::QueueData(ns3::Ptr<ns3::Packet> packet) [member function]
    cls.add_method('QueueData',
                   'bool',
                   [param('ns3::Ptr< ns3::Packet >', 'packet')])
    ## mmwave-mac.h (module 'mmwave'): void ns3::mmwave::MmWaveMac::SetConfigurationParameters(ns3::Ptr<ns3::mmwave::MmWavePhyMacCommon> ptrConfig) [member function]
    cls.add_method('SetConfigurationParameters',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWavePhyMacCommon >', 'ptrConfig')])
    return

def register_Ns3MmwaveMmWaveMacCschedSapProvider_methods(root_module, cls):
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::MmWaveMacCschedSapProvider() [constructor]
    cls.add_constructor([])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::MmWaveMacCschedSapProvider(ns3::mmwave::MmWaveMacCschedSapProvider const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveMacCschedSapProvider const &', 'arg0')])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): void ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReq(ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters const & params) [member function]
    cls.add_method('CschedCellConfigReq',
                   'void',
                   [param('ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): void ns3::mmwave::MmWaveMacCschedSapProvider::CschedLcConfigReq(ns3::mmwave::MmWaveMacCschedSapProvider::CschedLcConfigReqParameters const & params) [member function]
    cls.add_method('CschedLcConfigReq',
                   'void',
                   [param('ns3::mmwave::MmWaveMacCschedSapProvider::CschedLcConfigReqParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): void ns3::mmwave::MmWaveMacCschedSapProvider::CschedLcReleaseReq(ns3::mmwave::MmWaveMacCschedSapProvider::CschedLcReleaseReqParameters const & params) [member function]
    cls.add_method('CschedLcReleaseReq',
                   'void',
                   [param('ns3::mmwave::MmWaveMacCschedSapProvider::CschedLcReleaseReqParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): void ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReq(ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters const & params) [member function]
    cls.add_method('CschedUeConfigReq',
                   'void',
                   [param('ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): void ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeReleaseReq(ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeReleaseReqParameters const & params) [member function]
    cls.add_method('CschedUeReleaseReq',
                   'void',
                   [param('ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeReleaseReqParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3MmwaveMmWaveMacCschedSapProviderCschedCellConfigReqParameters_methods(root_module, cls):
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::CschedCellConfigReqParameters() [constructor]
    cls.add_constructor([])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::CschedCellConfigReqParameters(ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters const &', 'arg0')])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::m_antennaPortsCount [variable]
    cls.add_instance_attribute('m_antennaPortsCount', 'uint8_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::m_deltaPucchShift [variable]
    cls.add_instance_attribute('m_deltaPucchShift', 'uint8_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::m_dlBandwidth [variable]
    cls.add_instance_attribute('m_dlBandwidth', 'uint8_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::m_dlCyclicPrefixLength [variable]
    cls.add_instance_attribute('m_dlCyclicPrefixLength', 'ns3::NormalExtended_e', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::m_duplexMode [variable]
    cls.add_instance_attribute('m_duplexMode', 'ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::DuplexMode_e', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::m_enable64Qam [variable]
    cls.add_instance_attribute('m_enable64Qam', 'ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::Enable64Qam_e', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::m_hoppingMode [variable]
    cls.add_instance_attribute('m_hoppingMode', 'ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::HoppingMode_e', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::m_initialNrOfPdcchOfdmSymbols [variable]
    cls.add_instance_attribute('m_initialNrOfPdcchOfdmSymbols', 'uint8_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::m_macContentionResolutionTimer [variable]
    cls.add_instance_attribute('m_macContentionResolutionTimer', 'uint8_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::m_maxHarqMsg3Tx [variable]
    cls.add_instance_attribute('m_maxHarqMsg3Tx', 'uint8_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::m_mbsfnSubframeConfigRfOffset [variable]
    cls.add_instance_attribute('m_mbsfnSubframeConfigRfOffset', 'std::vector< unsigned char >', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::m_mbsfnSubframeConfigRfPeriod [variable]
    cls.add_instance_attribute('m_mbsfnSubframeConfigRfPeriod', 'std::vector< unsigned char >', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::m_mbsfnSubframeConfigSfAllocation [variable]
    cls.add_instance_attribute('m_mbsfnSubframeConfigSfAllocation', 'std::vector< unsigned char >', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::m_n1PucchAn [variable]
    cls.add_instance_attribute('m_n1PucchAn', 'uint16_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::m_nSb [variable]
    cls.add_instance_attribute('m_nSb', 'uint8_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::m_ncsAn [variable]
    cls.add_instance_attribute('m_ncsAn', 'uint8_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::m_nrbCqi [variable]
    cls.add_instance_attribute('m_nrbCqi', 'uint8_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::m_phichDuration [variable]
    cls.add_instance_attribute('m_phichDuration', 'ns3::NormalExtended_e', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::m_phichResource [variable]
    cls.add_instance_attribute('m_phichResource', 'ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::PhichResource_e', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::m_prachConfigurationIndex [variable]
    cls.add_instance_attribute('m_prachConfigurationIndex', 'uint8_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::m_prachFreqOffset [variable]
    cls.add_instance_attribute('m_prachFreqOffset', 'uint8_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::m_puschHoppingOffset [variable]
    cls.add_instance_attribute('m_puschHoppingOffset', 'uint8_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::m_raResponseWindowSize [variable]
    cls.add_instance_attribute('m_raResponseWindowSize', 'uint8_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::m_siConfiguration [variable]
    cls.add_instance_attribute('m_siConfiguration', 'ns3::SiConfiguration_s', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::m_specialSubframePatterns [variable]
    cls.add_instance_attribute('m_specialSubframePatterns', 'uint8_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::m_srsBandwidthConfiguration [variable]
    cls.add_instance_attribute('m_srsBandwidthConfiguration', 'uint8_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::m_srsMaxUpPts [variable]
    cls.add_instance_attribute('m_srsMaxUpPts', 'bool', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::m_srsSubframeConfiguration [variable]
    cls.add_instance_attribute('m_srsSubframeConfiguration', 'uint8_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::m_srsSubframeOffset [variable]
    cls.add_instance_attribute('m_srsSubframeOffset', 'uint8_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::m_subframeAssignment [variable]
    cls.add_instance_attribute('m_subframeAssignment', 'uint8_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::m_ulBandwidth [variable]
    cls.add_instance_attribute('m_ulBandwidth', 'uint8_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::m_ulCyclicPrefixLength [variable]
    cls.add_instance_attribute('m_ulCyclicPrefixLength', 'ns3::NormalExtended_e', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedCellConfigReqParameters::m_vendorSpecificList [variable]
    cls.add_instance_attribute('m_vendorSpecificList', 'std::vector< ns3::VendorSpecificListElement_s >', is_const=False)
    return

def register_Ns3MmwaveMmWaveMacCschedSapProviderCschedLcConfigReqParameters_methods(root_module, cls):
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedLcConfigReqParameters::CschedLcConfigReqParameters() [constructor]
    cls.add_constructor([])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedLcConfigReqParameters::CschedLcConfigReqParameters(ns3::mmwave::MmWaveMacCschedSapProvider::CschedLcConfigReqParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveMacCschedSapProvider::CschedLcConfigReqParameters const &', 'arg0')])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedLcConfigReqParameters::m_logicalChannelConfigList [variable]
    cls.add_instance_attribute('m_logicalChannelConfigList', 'std::vector< ns3::LogicalChannelConfigListElement_s >', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedLcConfigReqParameters::m_reconfigureFlag [variable]
    cls.add_instance_attribute('m_reconfigureFlag', 'bool', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedLcConfigReqParameters::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedLcConfigReqParameters::m_vendorSpecificList [variable]
    cls.add_instance_attribute('m_vendorSpecificList', 'std::vector< ns3::VendorSpecificListElement_s >', is_const=False)
    return

def register_Ns3MmwaveMmWaveMacCschedSapProviderCschedLcReleaseReqParameters_methods(root_module, cls):
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedLcReleaseReqParameters::CschedLcReleaseReqParameters() [constructor]
    cls.add_constructor([])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedLcReleaseReqParameters::CschedLcReleaseReqParameters(ns3::mmwave::MmWaveMacCschedSapProvider::CschedLcReleaseReqParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveMacCschedSapProvider::CschedLcReleaseReqParameters const &', 'arg0')])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedLcReleaseReqParameters::m_logicalChannelIdentity [variable]
    cls.add_instance_attribute('m_logicalChannelIdentity', 'std::vector< unsigned char >', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedLcReleaseReqParameters::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedLcReleaseReqParameters::m_vendorSpecificList [variable]
    cls.add_instance_attribute('m_vendorSpecificList', 'std::vector< ns3::VendorSpecificListElement_s >', is_const=False)
    return

def register_Ns3MmwaveMmWaveMacCschedSapProviderCschedUeConfigReqParameters_methods(root_module, cls):
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters::CschedUeConfigReqParameters() [constructor]
    cls.add_constructor([])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters::CschedUeConfigReqParameters(ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters const &', 'arg0')])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters::m_ackNackRepetitionFactor [variable]
    cls.add_instance_attribute('m_ackNackRepetitionFactor', 'uint8_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters::m_ackNackSrsSimultaneousTransmission [variable]
    cls.add_instance_attribute('m_ackNackSrsSimultaneousTransmission', 'bool', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters::m_aperiodicCqiRepMode [variable]
    cls.add_instance_attribute('m_aperiodicCqiRepMode', 'ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters::RepMode_e', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters::m_betaOffsetAckIndex [variable]
    cls.add_instance_attribute('m_betaOffsetAckIndex', 'uint8_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters::m_betaOffsetCqiIndex [variable]
    cls.add_instance_attribute('m_betaOffsetCqiIndex', 'uint8_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters::m_betaOffsetRiIndex [variable]
    cls.add_instance_attribute('m_betaOffsetRiIndex', 'uint8_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters::m_cqiConfig [variable]
    cls.add_instance_attribute('m_cqiConfig', 'ns3::CqiConfig_s', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters::m_cqiConfigPresent [variable]
    cls.add_instance_attribute('m_cqiConfigPresent', 'bool', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters::m_drxConfig [variable]
    cls.add_instance_attribute('m_drxConfig', 'ns3::DrxConfig_s', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters::m_drxConfigPresent [variable]
    cls.add_instance_attribute('m_drxConfigPresent', 'bool', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters::m_maxHarqTx [variable]
    cls.add_instance_attribute('m_maxHarqTx', 'uint8_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters::m_measGapConfigPattern [variable]
    cls.add_instance_attribute('m_measGapConfigPattern', 'ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters::MeasGapConfigPattern_e', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters::m_measGapConfigSubframeOffset [variable]
    cls.add_instance_attribute('m_measGapConfigSubframeOffset', 'uint8_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters::m_reconfigureFlag [variable]
    cls.add_instance_attribute('m_reconfigureFlag', 'bool', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters::m_simultaneousAckNackAndCqi [variable]
    cls.add_instance_attribute('m_simultaneousAckNackAndCqi', 'bool', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters::m_spsConfig [variable]
    cls.add_instance_attribute('m_spsConfig', 'ns3::SpsConfig_s', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters::m_spsConfigPresent [variable]
    cls.add_instance_attribute('m_spsConfigPresent', 'bool', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters::m_srConfig [variable]
    cls.add_instance_attribute('m_srConfig', 'ns3::SrConfig_s', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters::m_srConfigPresent [variable]
    cls.add_instance_attribute('m_srConfigPresent', 'bool', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters::m_tddAckNackFeedbackMode [variable]
    cls.add_instance_attribute('m_tddAckNackFeedbackMode', 'ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters::FeedbackMode_e', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters::m_timeAlignmentTimer [variable]
    cls.add_instance_attribute('m_timeAlignmentTimer', 'uint16_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters::m_transmissionMode [variable]
    cls.add_instance_attribute('m_transmissionMode', 'uint8_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters::m_ttiBundling [variable]
    cls.add_instance_attribute('m_ttiBundling', 'bool', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters::m_ueAggregatedMaximumBitrateDl [variable]
    cls.add_instance_attribute('m_ueAggregatedMaximumBitrateDl', 'uint64_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters::m_ueAggregatedMaximumBitrateUl [variable]
    cls.add_instance_attribute('m_ueAggregatedMaximumBitrateUl', 'uint64_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters::m_ueCapabilities [variable]
    cls.add_instance_attribute('m_ueCapabilities', 'ns3::UeCapabilities_s', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters::m_ueTransmitAntennaSelection [variable]
    cls.add_instance_attribute('m_ueTransmitAntennaSelection', 'ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters::OpenClosedLoop_e', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeConfigReqParameters::m_vendorSpecificList [variable]
    cls.add_instance_attribute('m_vendorSpecificList', 'std::vector< ns3::VendorSpecificListElement_s >', is_const=False)
    return

def register_Ns3MmwaveMmWaveMacCschedSapProviderCschedUeReleaseReqParameters_methods(root_module, cls):
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeReleaseReqParameters::CschedUeReleaseReqParameters() [constructor]
    cls.add_constructor([])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeReleaseReqParameters::CschedUeReleaseReqParameters(ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeReleaseReqParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeReleaseReqParameters const &', 'arg0')])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeReleaseReqParameters::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider::CschedUeReleaseReqParameters::m_vendorSpecificList [variable]
    cls.add_instance_attribute('m_vendorSpecificList', 'std::vector< ns3::VendorSpecificListElement_s >', is_const=False)
    return

def register_Ns3MmwaveMmWaveMacCschedSapUser_methods(root_module, cls):
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::MmWaveMacCschedSapUser() [constructor]
    cls.add_constructor([])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::MmWaveMacCschedSapUser(ns3::mmwave::MmWaveMacCschedSapUser const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveMacCschedSapUser const &', 'arg0')])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): void ns3::mmwave::MmWaveMacCschedSapUser::CschedCellConfigCnf(ns3::mmwave::MmWaveMacCschedSapUser::CschedCellConfigCnfParameters const & params) [member function]
    cls.add_method('CschedCellConfigCnf',
                   'void',
                   [param('ns3::mmwave::MmWaveMacCschedSapUser::CschedCellConfigCnfParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): void ns3::mmwave::MmWaveMacCschedSapUser::CschedCellConfigUpdateInd(ns3::mmwave::MmWaveMacCschedSapUser::CschedCellConfigUpdateIndParameters const & params) [member function]
    cls.add_method('CschedCellConfigUpdateInd',
                   'void',
                   [param('ns3::mmwave::MmWaveMacCschedSapUser::CschedCellConfigUpdateIndParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): void ns3::mmwave::MmWaveMacCschedSapUser::CschedLcConfigCnf(ns3::mmwave::MmWaveMacCschedSapUser::CschedLcConfigCnfParameters const & params) [member function]
    cls.add_method('CschedLcConfigCnf',
                   'void',
                   [param('ns3::mmwave::MmWaveMacCschedSapUser::CschedLcConfigCnfParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): void ns3::mmwave::MmWaveMacCschedSapUser::CschedLcReleaseCnf(ns3::mmwave::MmWaveMacCschedSapUser::CschedLcReleaseCnfParameters const & params) [member function]
    cls.add_method('CschedLcReleaseCnf',
                   'void',
                   [param('ns3::mmwave::MmWaveMacCschedSapUser::CschedLcReleaseCnfParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): void ns3::mmwave::MmWaveMacCschedSapUser::CschedUeConfigCnf(ns3::mmwave::MmWaveMacCschedSapUser::CschedUeConfigCnfParameters const & params) [member function]
    cls.add_method('CschedUeConfigCnf',
                   'void',
                   [param('ns3::mmwave::MmWaveMacCschedSapUser::CschedUeConfigCnfParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): void ns3::mmwave::MmWaveMacCschedSapUser::CschedUeConfigUpdateInd(ns3::mmwave::MmWaveMacCschedSapUser::CschedUeConfigUpdateIndParameters const & params) [member function]
    cls.add_method('CschedUeConfigUpdateInd',
                   'void',
                   [param('ns3::mmwave::MmWaveMacCschedSapUser::CschedUeConfigUpdateIndParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): void ns3::mmwave::MmWaveMacCschedSapUser::CschedUeReleaseCnf(ns3::mmwave::MmWaveMacCschedSapUser::CschedUeReleaseCnfParameters const & params) [member function]
    cls.add_method('CschedUeReleaseCnf',
                   'void',
                   [param('ns3::mmwave::MmWaveMacCschedSapUser::CschedUeReleaseCnfParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3MmwaveMmWaveMacCschedSapUserCschedCellConfigCnfParameters_methods(root_module, cls):
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedCellConfigCnfParameters::CschedCellConfigCnfParameters() [constructor]
    cls.add_constructor([])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedCellConfigCnfParameters::CschedCellConfigCnfParameters(ns3::mmwave::MmWaveMacCschedSapUser::CschedCellConfigCnfParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveMacCschedSapUser::CschedCellConfigCnfParameters const &', 'arg0')])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedCellConfigCnfParameters::m_result [variable]
    cls.add_instance_attribute('m_result', 'ns3::Result_e', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedCellConfigCnfParameters::m_vendorSpecificList [variable]
    cls.add_instance_attribute('m_vendorSpecificList', 'std::vector< ns3::VendorSpecificListElement_s >', is_const=False)
    return

def register_Ns3MmwaveMmWaveMacCschedSapUserCschedCellConfigUpdateIndParameters_methods(root_module, cls):
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedCellConfigUpdateIndParameters::CschedCellConfigUpdateIndParameters() [constructor]
    cls.add_constructor([])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedCellConfigUpdateIndParameters::CschedCellConfigUpdateIndParameters(ns3::mmwave::MmWaveMacCschedSapUser::CschedCellConfigUpdateIndParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveMacCschedSapUser::CschedCellConfigUpdateIndParameters const &', 'arg0')])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedCellConfigUpdateIndParameters::m_prbUtilizationDl [variable]
    cls.add_instance_attribute('m_prbUtilizationDl', 'uint8_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedCellConfigUpdateIndParameters::m_prbUtilizationUl [variable]
    cls.add_instance_attribute('m_prbUtilizationUl', 'uint8_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedCellConfigUpdateIndParameters::m_vendorSpecificList [variable]
    cls.add_instance_attribute('m_vendorSpecificList', 'std::vector< ns3::VendorSpecificListElement_s >', is_const=False)
    return

def register_Ns3MmwaveMmWaveMacCschedSapUserCschedLcConfigCnfParameters_methods(root_module, cls):
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedLcConfigCnfParameters::CschedLcConfigCnfParameters() [constructor]
    cls.add_constructor([])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedLcConfigCnfParameters::CschedLcConfigCnfParameters(ns3::mmwave::MmWaveMacCschedSapUser::CschedLcConfigCnfParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveMacCschedSapUser::CschedLcConfigCnfParameters const &', 'arg0')])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedLcConfigCnfParameters::m_logicalChannelIdentity [variable]
    cls.add_instance_attribute('m_logicalChannelIdentity', 'std::vector< unsigned char >', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedLcConfigCnfParameters::m_result [variable]
    cls.add_instance_attribute('m_result', 'ns3::Result_e', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedLcConfigCnfParameters::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedLcConfigCnfParameters::m_vendorSpecificList [variable]
    cls.add_instance_attribute('m_vendorSpecificList', 'std::vector< ns3::VendorSpecificListElement_s >', is_const=False)
    return

def register_Ns3MmwaveMmWaveMacCschedSapUserCschedLcReleaseCnfParameters_methods(root_module, cls):
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedLcReleaseCnfParameters::CschedLcReleaseCnfParameters() [constructor]
    cls.add_constructor([])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedLcReleaseCnfParameters::CschedLcReleaseCnfParameters(ns3::mmwave::MmWaveMacCschedSapUser::CschedLcReleaseCnfParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveMacCschedSapUser::CschedLcReleaseCnfParameters const &', 'arg0')])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedLcReleaseCnfParameters::m_logicalChannelIdentity [variable]
    cls.add_instance_attribute('m_logicalChannelIdentity', 'std::vector< unsigned char >', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedLcReleaseCnfParameters::m_result [variable]
    cls.add_instance_attribute('m_result', 'ns3::Result_e', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedLcReleaseCnfParameters::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedLcReleaseCnfParameters::m_vendorSpecificList [variable]
    cls.add_instance_attribute('m_vendorSpecificList', 'std::vector< ns3::VendorSpecificListElement_s >', is_const=False)
    return

def register_Ns3MmwaveMmWaveMacCschedSapUserCschedUeConfigCnfParameters_methods(root_module, cls):
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedUeConfigCnfParameters::CschedUeConfigCnfParameters() [constructor]
    cls.add_constructor([])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedUeConfigCnfParameters::CschedUeConfigCnfParameters(ns3::mmwave::MmWaveMacCschedSapUser::CschedUeConfigCnfParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveMacCschedSapUser::CschedUeConfigCnfParameters const &', 'arg0')])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedUeConfigCnfParameters::m_result [variable]
    cls.add_instance_attribute('m_result', 'ns3::Result_e', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedUeConfigCnfParameters::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedUeConfigCnfParameters::m_vendorSpecificList [variable]
    cls.add_instance_attribute('m_vendorSpecificList', 'std::vector< ns3::VendorSpecificListElement_s >', is_const=False)
    return

def register_Ns3MmwaveMmWaveMacCschedSapUserCschedUeConfigUpdateIndParameters_methods(root_module, cls):
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedUeConfigUpdateIndParameters::CschedUeConfigUpdateIndParameters() [constructor]
    cls.add_constructor([])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedUeConfigUpdateIndParameters::CschedUeConfigUpdateIndParameters(ns3::mmwave::MmWaveMacCschedSapUser::CschedUeConfigUpdateIndParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveMacCschedSapUser::CschedUeConfigUpdateIndParameters const &', 'arg0')])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedUeConfigUpdateIndParameters::m_cqiConfig [variable]
    cls.add_instance_attribute('m_cqiConfig', 'ns3::CqiConfig_s', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedUeConfigUpdateIndParameters::m_cqiConfigPresent [variable]
    cls.add_instance_attribute('m_cqiConfigPresent', 'bool', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedUeConfigUpdateIndParameters::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedUeConfigUpdateIndParameters::m_spsConfig [variable]
    cls.add_instance_attribute('m_spsConfig', 'ns3::SpsConfig_s', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedUeConfigUpdateIndParameters::m_spsConfigPresent [variable]
    cls.add_instance_attribute('m_spsConfigPresent', 'bool', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedUeConfigUpdateIndParameters::m_srConfig [variable]
    cls.add_instance_attribute('m_srConfig', 'ns3::SrConfig_s', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedUeConfigUpdateIndParameters::m_srConfigPresent [variable]
    cls.add_instance_attribute('m_srConfigPresent', 'bool', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedUeConfigUpdateIndParameters::m_transmissionMode [variable]
    cls.add_instance_attribute('m_transmissionMode', 'uint8_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedUeConfigUpdateIndParameters::m_vendorSpecificList [variable]
    cls.add_instance_attribute('m_vendorSpecificList', 'std::vector< ns3::VendorSpecificListElement_s >', is_const=False)
    return

def register_Ns3MmwaveMmWaveMacCschedSapUserCschedUeReleaseCnfParameters_methods(root_module, cls):
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedUeReleaseCnfParameters::CschedUeReleaseCnfParameters() [constructor]
    cls.add_constructor([])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedUeReleaseCnfParameters::CschedUeReleaseCnfParameters(ns3::mmwave::MmWaveMacCschedSapUser::CschedUeReleaseCnfParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveMacCschedSapUser::CschedUeReleaseCnfParameters const &', 'arg0')])
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedUeReleaseCnfParameters::m_result [variable]
    cls.add_instance_attribute('m_result', 'ns3::Result_e', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedUeReleaseCnfParameters::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    ## mmwave-mac-csched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapUser::CschedUeReleaseCnfParameters::m_vendorSpecificList [variable]
    cls.add_instance_attribute('m_vendorSpecificList', 'std::vector< ns3::VendorSpecificListElement_s >', is_const=False)
    return

def register_Ns3MmwaveMmWaveMacPduHeader_methods(root_module, cls):
    ## mmwave-mac-pdu-header.h (module 'mmwave'): ns3::mmwave::MmWaveMacPduHeader::MmWaveMacPduHeader(ns3::mmwave::MmWaveMacPduHeader const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveMacPduHeader const &', 'arg0')])
    ## mmwave-mac-pdu-header.h (module 'mmwave'): ns3::mmwave::MmWaveMacPduHeader::MmWaveMacPduHeader() [constructor]
    cls.add_constructor([])
    ## mmwave-mac-pdu-header.h (module 'mmwave'): ns3::mmwave::MmWaveMacPduHeader::MmWaveMacPduHeader(uint16_t frameNo, uint8_t sfNo, uint8_t slotNo) [constructor]
    cls.add_constructor([param('uint16_t', 'frameNo'), param('uint8_t', 'sfNo'), param('uint8_t', 'slotNo')])
    ## mmwave-mac-pdu-header.h (module 'mmwave'): void ns3::mmwave::MmWaveMacPduHeader::AddSubheader(ns3::mmwave::MacSubheader rlcPduInfo) [member function]
    cls.add_method('AddSubheader',
                   'void',
                   [param('ns3::mmwave::MacSubheader', 'rlcPduInfo')])
    ## mmwave-mac-pdu-header.h (module 'mmwave'): uint32_t ns3::mmwave::MmWaveMacPduHeader::Deserialize(ns3::Buffer::Iterator i) [member function]
    cls.add_method('Deserialize',
                   'uint32_t',
                   [param('ns3::Buffer::Iterator', 'i')],
                   is_virtual=True)
    ## mmwave-mac-pdu-header.h (module 'mmwave'): ns3::TypeId ns3::mmwave::MmWaveMacPduHeader::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId',
                   'ns3::TypeId',
                   [],
                   is_const=True, is_virtual=True)
    ## mmwave-mac-pdu-header.h (module 'mmwave'): uint32_t ns3::mmwave::MmWaveMacPduHeader::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize',
                   'uint32_t',
                   [],
                   is_const=True, is_virtual=True)
    ## mmwave-mac-pdu-header.h (module 'mmwave'): std::vector<ns3::mmwave::MacSubheader, std::allocator<ns3::mmwave::MacSubheader> > ns3::mmwave::MmWaveMacPduHeader::GetSubheaders() [member function]
    cls.add_method('GetSubheaders',
                   'std::vector< ns3::mmwave::MacSubheader >',
                   [])
    ## mmwave-mac-pdu-header.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWaveMacPduHeader::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-mac-pdu-header.h (module 'mmwave'): void ns3::mmwave::MmWaveMacPduHeader::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True, is_virtual=True)
    ## mmwave-mac-pdu-header.h (module 'mmwave'): void ns3::mmwave::MmWaveMacPduHeader::Serialize(ns3::Buffer::Iterator i) const [member function]
    cls.add_method('Serialize',
                   'void',
                   [param('ns3::Buffer::Iterator', 'i')],
                   is_const=True, is_virtual=True)
    ## mmwave-mac-pdu-header.h (module 'mmwave'): void ns3::mmwave::MmWaveMacPduHeader::SetSubheaders(std::vector<ns3::mmwave::MacSubheader, std::allocator<ns3::mmwave::MacSubheader> > macSubheaderList) [member function]
    cls.add_method('SetSubheaders',
                   'void',
                   [param('std::vector< ns3::mmwave::MacSubheader >', 'macSubheaderList')])
    return

def register_Ns3MmwaveMmWaveMacPduTag_methods(root_module, cls):
    ## mmwave-mac-pdu-tag.h (module 'mmwave'): ns3::mmwave::MmWaveMacPduTag::MmWaveMacPduTag(ns3::mmwave::MmWaveMacPduTag const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveMacPduTag const &', 'arg0')])
    ## mmwave-mac-pdu-tag.h (module 'mmwave'): ns3::mmwave::MmWaveMacPduTag::MmWaveMacPduTag() [constructor]
    cls.add_constructor([])
    ## mmwave-mac-pdu-tag.h (module 'mmwave'): ns3::mmwave::MmWaveMacPduTag::MmWaveMacPduTag(ns3::mmwave::SfnSf sfn) [constructor]
    cls.add_constructor([param('ns3::mmwave::SfnSf', 'sfn')])
    ## mmwave-mac-pdu-tag.h (module 'mmwave'): ns3::mmwave::MmWaveMacPduTag::MmWaveMacPduTag(ns3::mmwave::SfnSf sfn, uint8_t symStart, uint8_t numSym) [constructor]
    cls.add_constructor([param('ns3::mmwave::SfnSf', 'sfn'), param('uint8_t', 'symStart'), param('uint8_t', 'numSym')])
    ## mmwave-mac-pdu-tag.h (module 'mmwave'): void ns3::mmwave::MmWaveMacPduTag::Deserialize(ns3::TagBuffer i) [member function]
    cls.add_method('Deserialize',
                   'void',
                   [param('ns3::TagBuffer', 'i')],
                   is_virtual=True)
    ## mmwave-mac-pdu-tag.h (module 'mmwave'): ns3::TypeId ns3::mmwave::MmWaveMacPduTag::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId',
                   'ns3::TypeId',
                   [],
                   is_const=True, is_virtual=True)
    ## mmwave-mac-pdu-tag.h (module 'mmwave'): uint8_t ns3::mmwave::MmWaveMacPduTag::GetNumSym() [member function]
    cls.add_method('GetNumSym',
                   'uint8_t',
                   [])
    ## mmwave-mac-pdu-tag.h (module 'mmwave'): uint32_t ns3::mmwave::MmWaveMacPduTag::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize',
                   'uint32_t',
                   [],
                   is_const=True, is_virtual=True)
    ## mmwave-mac-pdu-tag.h (module 'mmwave'): ns3::mmwave::SfnSf ns3::mmwave::MmWaveMacPduTag::GetSfn() const [member function]
    cls.add_method('GetSfn',
                   'ns3::mmwave::SfnSf',
                   [],
                   is_const=True)
    ## mmwave-mac-pdu-tag.h (module 'mmwave'): uint8_t ns3::mmwave::MmWaveMacPduTag::GetSymStart() [member function]
    cls.add_method('GetSymStart',
                   'uint8_t',
                   [])
    ## mmwave-mac-pdu-tag.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWaveMacPduTag::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-mac-pdu-tag.h (module 'mmwave'): void ns3::mmwave::MmWaveMacPduTag::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True, is_virtual=True)
    ## mmwave-mac-pdu-tag.h (module 'mmwave'): void ns3::mmwave::MmWaveMacPduTag::Serialize(ns3::TagBuffer i) const [member function]
    cls.add_method('Serialize',
                   'void',
                   [param('ns3::TagBuffer', 'i')],
                   is_const=True, is_virtual=True)
    ## mmwave-mac-pdu-tag.h (module 'mmwave'): void ns3::mmwave::MmWaveMacPduTag::SetNumSym(uint8_t numSym) [member function]
    cls.add_method('SetNumSym',
                   'void',
                   [param('uint8_t', 'numSym')])
    ## mmwave-mac-pdu-tag.h (module 'mmwave'): void ns3::mmwave::MmWaveMacPduTag::SetSfn(ns3::mmwave::SfnSf sfn) [member function]
    cls.add_method('SetSfn',
                   'void',
                   [param('ns3::mmwave::SfnSf', 'sfn')])
    ## mmwave-mac-pdu-tag.h (module 'mmwave'): void ns3::mmwave::MmWaveMacPduTag::SetSymStart(uint8_t symStart) [member function]
    cls.add_method('SetSymStart',
                   'void',
                   [param('uint8_t', 'symStart')])
    return

def register_Ns3MmwaveMmWaveMacSchedSapProvider_methods(root_module, cls):
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider::MmWaveMacSchedSapProvider() [constructor]
    cls.add_constructor([])
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider::MmWaveMacSchedSapProvider(ns3::mmwave::MmWaveMacSchedSapProvider const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveMacSchedSapProvider const &', 'arg0')])
    ## mmwave-mac-sched-sap.h (module 'mmwave'): void ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlCqiInfoReq(ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlCqiInfoReqParameters const & params) [member function]
    cls.add_method('SchedDlCqiInfoReq',
                   'void',
                   [param('ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlCqiInfoReqParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## mmwave-mac-sched-sap.h (module 'mmwave'): void ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlRlcBufferReq(ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlRlcBufferReqParameters const & params) [member function]
    cls.add_method('SchedDlRlcBufferReq',
                   'void',
                   [param('ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlRlcBufferReqParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## mmwave-mac-sched-sap.h (module 'mmwave'): void ns3::mmwave::MmWaveMacSchedSapProvider::SchedSetMcs(int mcs) [member function]
    cls.add_method('SchedSetMcs',
                   'void',
                   [param('int', 'mcs')],
                   is_virtual=True)
    ## mmwave-mac-sched-sap.h (module 'mmwave'): void ns3::mmwave::MmWaveMacSchedSapProvider::SchedTriggerReq(ns3::mmwave::MmWaveMacSchedSapProvider::SchedTriggerReqParameters const & params) [member function]
    cls.add_method('SchedTriggerReq',
                   'void',
                   [param('ns3::mmwave::MmWaveMacSchedSapProvider::SchedTriggerReqParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## mmwave-mac-sched-sap.h (module 'mmwave'): void ns3::mmwave::MmWaveMacSchedSapProvider::SchedUlCqiInfoReq(ns3::mmwave::MmWaveMacSchedSapProvider::SchedUlCqiInfoReqParameters const & params) [member function]
    cls.add_method('SchedUlCqiInfoReq',
                   'void',
                   [param('ns3::mmwave::MmWaveMacSchedSapProvider::SchedUlCqiInfoReqParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## mmwave-mac-sched-sap.h (module 'mmwave'): void ns3::mmwave::MmWaveMacSchedSapProvider::SchedUlMacCtrlInfoReq(ns3::mmwave::MmWaveMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters const & params) [member function]
    cls.add_method('SchedUlMacCtrlInfoReq',
                   'void',
                   [param('ns3::mmwave::MmWaveMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3MmwaveMmWaveMacSchedSapProviderSchedDlCqiInfoReqParameters_methods(root_module, cls):
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlCqiInfoReqParameters::SchedDlCqiInfoReqParameters() [constructor]
    cls.add_constructor([])
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlCqiInfoReqParameters::SchedDlCqiInfoReqParameters(ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlCqiInfoReqParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlCqiInfoReqParameters const &', 'arg0')])
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlCqiInfoReqParameters::m_cqiList [variable]
    cls.add_instance_attribute('m_cqiList', 'std::vector< ns3::mmwave::DlCqiInfo >', is_const=False)
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlCqiInfoReqParameters::m_sfnsf [variable]
    cls.add_instance_attribute('m_sfnsf', 'ns3::mmwave::SfnSf', is_const=False)
    return

def register_Ns3MmwaveMmWaveMacSchedSapProviderSchedDlRlcBufferReqParameters_methods(root_module, cls):
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlRlcBufferReqParameters::SchedDlRlcBufferReqParameters() [constructor]
    cls.add_constructor([])
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlRlcBufferReqParameters::SchedDlRlcBufferReqParameters(ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlRlcBufferReqParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlRlcBufferReqParameters const &', 'arg0')])
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlRlcBufferReqParameters::m_arrivalRate [variable]
    cls.add_instance_attribute('m_arrivalRate', 'double', is_const=False)
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlRlcBufferReqParameters::m_logicalChannelIdentity [variable]
    cls.add_instance_attribute('m_logicalChannelIdentity', 'uint8_t', is_const=False)
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlRlcBufferReqParameters::m_retxPacketDelays [variable]
    cls.add_instance_attribute('m_retxPacketDelays', 'std::list< double >', is_const=False)
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlRlcBufferReqParameters::m_retxPacketSizes [variable]
    cls.add_instance_attribute('m_retxPacketSizes', 'std::list< unsigned int >', is_const=False)
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlRlcBufferReqParameters::m_rlcRetransmissionHolDelay [variable]
    cls.add_instance_attribute('m_rlcRetransmissionHolDelay', 'uint16_t', is_const=False)
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlRlcBufferReqParameters::m_rlcRetransmissionQueueSize [variable]
    cls.add_instance_attribute('m_rlcRetransmissionQueueSize', 'uint32_t', is_const=False)
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlRlcBufferReqParameters::m_rlcStatusPduSize [variable]
    cls.add_instance_attribute('m_rlcStatusPduSize', 'uint16_t', is_const=False)
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlRlcBufferReqParameters::m_rlcTransmissionQueueHolDelay [variable]
    cls.add_instance_attribute('m_rlcTransmissionQueueHolDelay', 'uint16_t', is_const=False)
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlRlcBufferReqParameters::m_rlcTransmissionQueueSize [variable]
    cls.add_instance_attribute('m_rlcTransmissionQueueSize', 'uint32_t', is_const=False)
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlRlcBufferReqParameters::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlRlcBufferReqParameters::m_txPacketDelays [variable]
    cls.add_instance_attribute('m_txPacketDelays', 'std::list< double >', is_const=False)
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlRlcBufferReqParameters::m_txPacketSizes [variable]
    cls.add_instance_attribute('m_txPacketSizes', 'std::list< unsigned int >', is_const=False)
    return

def register_Ns3MmwaveMmWaveMacSchedSapProviderSchedTriggerReqParameters_methods(root_module, cls):
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider::SchedTriggerReqParameters::SchedTriggerReqParameters() [constructor]
    cls.add_constructor([])
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider::SchedTriggerReqParameters::SchedTriggerReqParameters(ns3::mmwave::MmWaveMacSchedSapProvider::SchedTriggerReqParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveMacSchedSapProvider::SchedTriggerReqParameters const &', 'arg0')])
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider::SchedTriggerReqParameters::m_dlHarqInfoList [variable]
    cls.add_instance_attribute('m_dlHarqInfoList', 'std::vector< ns3::mmwave::DlHarqInfo >', is_const=False)
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider::SchedTriggerReqParameters::m_snfSf [variable]
    cls.add_instance_attribute('m_snfSf', 'ns3::mmwave::SfnSf', is_const=False)
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider::SchedTriggerReqParameters::m_ueList [variable]
    cls.add_instance_attribute('m_ueList', 'std::list< unsigned short >', is_const=False)
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider::SchedTriggerReqParameters::m_ulHarqInfoList [variable]
    cls.add_instance_attribute('m_ulHarqInfoList', 'std::vector< ns3::mmwave::UlHarqInfo >', is_const=False)
    return

def register_Ns3MmwaveMmWaveMacSchedSapProviderSchedUlCqiInfoReqParameters_methods(root_module, cls):
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider::SchedUlCqiInfoReqParameters::SchedUlCqiInfoReqParameters() [constructor]
    cls.add_constructor([])
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider::SchedUlCqiInfoReqParameters::SchedUlCqiInfoReqParameters(ns3::mmwave::MmWaveMacSchedSapProvider::SchedUlCqiInfoReqParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveMacSchedSapProvider::SchedUlCqiInfoReqParameters const &', 'arg0')])
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider::SchedUlCqiInfoReqParameters::m_sfnSf [variable]
    cls.add_instance_attribute('m_sfnSf', 'ns3::mmwave::SfnSf', is_const=False)
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider::SchedUlCqiInfoReqParameters::m_ulCqi [variable]
    cls.add_instance_attribute('m_ulCqi', 'ns3::mmwave::UlCqiInfo', is_const=False)
    return

def register_Ns3MmwaveMmWaveMacSchedSapProviderSchedUlMacCtrlInfoReqParameters_methods(root_module, cls):
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters::SchedUlMacCtrlInfoReqParameters() [constructor]
    cls.add_constructor([])
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters::SchedUlMacCtrlInfoReqParameters(ns3::mmwave::MmWaveMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters const &', 'arg0')])
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters::m_macCeList [variable]
    cls.add_instance_attribute('m_macCeList', 'std::vector< ns3::mmwave::MacCeElement >', is_const=False)
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters::m_sfnSf [variable]
    cls.add_instance_attribute('m_sfnSf', 'ns3::mmwave::SfnSf', is_const=False)
    return

def register_Ns3MmwaveMmWaveMacSchedSapUser_methods(root_module, cls):
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapUser::MmWaveMacSchedSapUser() [constructor]
    cls.add_constructor([])
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapUser::MmWaveMacSchedSapUser(ns3::mmwave::MmWaveMacSchedSapUser const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveMacSchedSapUser const &', 'arg0')])
    ## mmwave-mac-sched-sap.h (module 'mmwave'): void ns3::mmwave::MmWaveMacSchedSapUser::SchedConfigInd(ns3::mmwave::MmWaveMacSchedSapUser::SchedConfigIndParameters const & params) [member function]
    cls.add_method('SchedConfigInd',
                   'void',
                   [param('ns3::mmwave::MmWaveMacSchedSapUser::SchedConfigIndParameters const &', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3MmwaveMmWaveMacSchedSapUserSchedConfigIndParameters_methods(root_module, cls):
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapUser::SchedConfigIndParameters::SchedConfigIndParameters() [constructor]
    cls.add_constructor([])
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapUser::SchedConfigIndParameters::SchedConfigIndParameters(ns3::mmwave::MmWaveMacSchedSapUser::SchedConfigIndParameters const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveMacSchedSapUser::SchedConfigIndParameters const &', 'arg0')])
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapUser::SchedConfigIndParameters::m_dlSfAllocInfo [variable]
    cls.add_instance_attribute('m_dlSfAllocInfo', 'ns3::mmwave::SfAllocInfo', is_const=False)
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapUser::SchedConfigIndParameters::m_schedInfoMap [variable]
    cls.add_instance_attribute('m_schedInfoMap', 'std::map< unsigned short, ns3::mmwave::SchedInfo >', is_const=False)
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapUser::SchedConfigIndParameters::m_sfAllocInfo [variable]
    cls.add_instance_attribute('m_sfAllocInfo', 'ns3::mmwave::SfAllocInfo', is_const=False)
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapUser::SchedConfigIndParameters::m_sfnSf [variable]
    cls.add_instance_attribute('m_sfnSf', 'ns3::mmwave::SfnSf', is_const=False)
    ## mmwave-mac-sched-sap.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapUser::SchedConfigIndParameters::m_ulSfAllocInfo [variable]
    cls.add_instance_attribute('m_ulSfAllocInfo', 'ns3::mmwave::SfAllocInfo', is_const=False)
    return

def register_Ns3MmwaveMmWaveMacScheduler_methods(root_module, cls):
    ## mmwave-mac-scheduler.h (module 'mmwave'): ns3::mmwave::MmWaveMacScheduler::MmWaveMacScheduler(ns3::mmwave::MmWaveMacScheduler const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveMacScheduler const &', 'arg0')])
    ## mmwave-mac-scheduler.h (module 'mmwave'): ns3::mmwave::MmWaveMacScheduler::MmWaveMacScheduler() [constructor]
    cls.add_constructor([])
    ## mmwave-mac-scheduler.h (module 'mmwave'): void ns3::mmwave::MmWaveMacScheduler::ConfigureCommonParameters(ns3::Ptr<ns3::mmwave::MmWavePhyMacCommon> config) [member function]
    cls.add_method('ConfigureCommonParameters',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWavePhyMacCommon >', 'config')],
                   is_pure_virtual=True, is_virtual=True)
    ## mmwave-mac-scheduler.h (module 'mmwave'): void ns3::mmwave::MmWaveMacScheduler::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## mmwave-mac-scheduler.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider * ns3::mmwave::MmWaveMacScheduler::GetMacCschedSapProvider() [member function]
    cls.add_method('GetMacCschedSapProvider',
                   'ns3::mmwave::MmWaveMacCschedSapProvider *',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## mmwave-mac-scheduler.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider * ns3::mmwave::MmWaveMacScheduler::GetMacSchedSapProvider() [member function]
    cls.add_method('GetMacSchedSapProvider',
                   'ns3::mmwave::MmWaveMacSchedSapProvider *',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## mmwave-mac-scheduler.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWaveMacScheduler::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-mac-scheduler.h (module 'mmwave'): void ns3::mmwave::MmWaveMacScheduler::SetMacCschedSapUser(ns3::mmwave::MmWaveMacCschedSapUser * sap) [member function]
    cls.add_method('SetMacCschedSapUser',
                   'void',
                   [param('ns3::mmwave::MmWaveMacCschedSapUser *', 'sap')],
                   is_pure_virtual=True, is_virtual=True)
    ## mmwave-mac-scheduler.h (module 'mmwave'): void ns3::mmwave::MmWaveMacScheduler::SetMacSchedSapUser(ns3::mmwave::MmWaveMacSchedSapUser * sap) [member function]
    cls.add_method('SetMacSchedSapUser',
                   'void',
                   [param('ns3::mmwave::MmWaveMacSchedSapUser *', 'sap')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3MmwaveMmWaveMiErrorModel_methods(root_module, cls):
    ## mmwave-mi-error-model.h (module 'mmwave'): ns3::mmwave::MmWaveMiErrorModel::MmWaveMiErrorModel() [constructor]
    cls.add_constructor([])
    ## mmwave-mi-error-model.h (module 'mmwave'): ns3::mmwave::MmWaveMiErrorModel::MmWaveMiErrorModel(ns3::mmwave::MmWaveMiErrorModel const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveMiErrorModel const &', 'arg0')])
    ## mmwave-mi-error-model.h (module 'mmwave'): static ns3::mmwave::MmWaveTbStats_t ns3::mmwave::MmWaveMiErrorModel::GetTbDecodificationStats(ns3::SpectrumValue const & sinr, std::vector<int, std::allocator<int> > const & map, uint32_t size, uint8_t mcs, ns3::mmwave::MmWaveHarqProcessInfoList_t miHistory) [member function]
    cls.add_method('GetTbDecodificationStats',
                   'ns3::mmwave::MmWaveTbStats_t',
                   [param('ns3::SpectrumValue const &', 'sinr'), param('std::vector< int > const &', 'map'), param('uint32_t', 'size'), param('uint8_t', 'mcs'), param('std::vector< ns3::mmwave::MmWaveHarqProcessInfoElement_t >', 'miHistory')],
                   is_static=True)
    ## mmwave-mi-error-model.h (module 'mmwave'): static double ns3::mmwave::MmWaveMiErrorModel::MappingMiBler(double mib, uint8_t ecrId, uint32_t cbSize) [member function]
    cls.add_method('MappingMiBler',
                   'double',
                   [param('double', 'mib'), param('uint8_t', 'ecrId'), param('uint32_t', 'cbSize')],
                   is_static=True)
    ## mmwave-mi-error-model.h (module 'mmwave'): static double ns3::mmwave::MmWaveMiErrorModel::Mib(ns3::SpectrumValue const & sinr, std::vector<int, std::allocator<int> > const & map, uint8_t mcs) [member function]
    cls.add_method('Mib',
                   'double',
                   [param('ns3::SpectrumValue const &', 'sinr'), param('std::vector< int > const &', 'map'), param('uint8_t', 'mcs')],
                   is_static=True)
    return

def register_Ns3MmwaveMmWaveMibMessage_methods(root_module, cls):
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::MmWaveMibMessage::MmWaveMibMessage(ns3::mmwave::MmWaveMibMessage const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveMibMessage const &', 'arg0')])
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::MmWaveMibMessage::MmWaveMibMessage() [constructor]
    cls.add_constructor([])
    ## mmwave-control-messages.h (module 'mmwave'): ns3::LteRrcSap::MasterInformationBlock ns3::mmwave::MmWaveMibMessage::GetMib() const [member function]
    cls.add_method('GetMib',
                   'ns3::LteRrcSap::MasterInformationBlock',
                   [],
                   is_const=True)
    ## mmwave-control-messages.h (module 'mmwave'): void ns3::mmwave::MmWaveMibMessage::SetMib(ns3::LteRrcSap::MasterInformationBlock mib) [member function]
    cls.add_method('SetMib',
                   'void',
                   [param('ns3::LteRrcSap::MasterInformationBlock', 'mib')])
    return

def register_Ns3MmwaveMmWaveNetDevice_methods(root_module, cls):
    ## mmwave-net-device.h (module 'mmwave'): ns3::mmwave::MmWaveNetDevice::MmWaveNetDevice(ns3::mmwave::MmWaveNetDevice const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveNetDevice const &', 'arg0')])
    ## mmwave-net-device.h (module 'mmwave'): ns3::mmwave::MmWaveNetDevice::MmWaveNetDevice() [constructor]
    cls.add_constructor([])
    ## mmwave-net-device.h (module 'mmwave'): void ns3::mmwave::MmWaveNetDevice::AddLinkChangeCallback(ns3::Callback<void, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> callback) [member function]
    cls.add_method('AddLinkChangeCallback',
                   'void',
                   [param('ns3::Callback< void, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'callback')],
                   is_virtual=True)
    ## mmwave-net-device.h (module 'mmwave'): void ns3::mmwave::MmWaveNetDevice::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## mmwave-net-device.h (module 'mmwave'): bool ns3::mmwave::MmWaveNetDevice::DoSend(ns3::Ptr<ns3::Packet> packet, ns3::Address const & dest, uint16_t protocolNumber) [member function]
    cls.add_method('DoSend',
                   'bool',
                   [param('ns3::Ptr< ns3::Packet >', 'packet'), param('ns3::Address const &', 'dest'), param('uint16_t', 'protocolNumber')],
                   is_pure_virtual=True, is_virtual=True)
    ## mmwave-net-device.h (module 'mmwave'): ns3::Address ns3::mmwave::MmWaveNetDevice::GetAddress() const [member function]
    cls.add_method('GetAddress',
                   'ns3::Address',
                   [],
                   is_const=True, is_virtual=True)
    ## mmwave-net-device.h (module 'mmwave'): ns3::Address ns3::mmwave::MmWaveNetDevice::GetBroadcast() const [member function]
    cls.add_method('GetBroadcast',
                   'ns3::Address',
                   [],
                   is_const=True, is_virtual=True)
    ## mmwave-net-device.h (module 'mmwave'): ns3::Ptr<ns3::Channel> ns3::mmwave::MmWaveNetDevice::GetChannel() const [member function]
    cls.add_method('GetChannel',
                   'ns3::Ptr< ns3::Channel >',
                   [],
                   is_const=True, is_virtual=True)
    ## mmwave-net-device.h (module 'mmwave'): uint32_t ns3::mmwave::MmWaveNetDevice::GetIfIndex() const [member function]
    cls.add_method('GetIfIndex',
                   'uint32_t',
                   [],
                   is_const=True, is_virtual=True)
    ## mmwave-net-device.h (module 'mmwave'): uint16_t ns3::mmwave::MmWaveNetDevice::GetMtu() const [member function]
    cls.add_method('GetMtu',
                   'uint16_t',
                   [],
                   is_const=True, is_virtual=True)
    ## mmwave-net-device.h (module 'mmwave'): ns3::Address ns3::mmwave::MmWaveNetDevice::GetMulticast(ns3::Ipv4Address multicastGroup) const [member function]
    cls.add_method('GetMulticast',
                   'ns3::Address',
                   [param('ns3::Ipv4Address', 'multicastGroup')],
                   is_const=True, is_virtual=True)
    ## mmwave-net-device.h (module 'mmwave'): ns3::Address ns3::mmwave::MmWaveNetDevice::GetMulticast(ns3::Ipv6Address addr) const [member function]
    cls.add_method('GetMulticast',
                   'ns3::Address',
                   [param('ns3::Ipv6Address', 'addr')],
                   is_const=True, is_virtual=True)
    ## mmwave-net-device.h (module 'mmwave'): ns3::Ptr<ns3::Node> ns3::mmwave::MmWaveNetDevice::GetNode() const [member function]
    cls.add_method('GetNode',
                   'ns3::Ptr< ns3::Node >',
                   [],
                   is_const=True, is_virtual=True)
    ## mmwave-net-device.h (module 'mmwave'): ns3::Ipv4Address ns3::mmwave::MmWaveNetDevice::GetPacketDestination(ns3::Ptr<ns3::Packet> packet) [member function]
    cls.add_method('GetPacketDestination',
                   'ns3::Ipv4Address',
                   [param('ns3::Ptr< ns3::Packet >', 'packet')])
    ## mmwave-net-device.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWaveNetDevice::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-net-device.h (module 'mmwave'): bool ns3::mmwave::MmWaveNetDevice::IsBridge() const [member function]
    cls.add_method('IsBridge',
                   'bool',
                   [],
                   is_const=True, is_virtual=True)
    ## mmwave-net-device.h (module 'mmwave'): bool ns3::mmwave::MmWaveNetDevice::IsBroadcast() const [member function]
    cls.add_method('IsBroadcast',
                   'bool',
                   [],
                   is_const=True, is_virtual=True)
    ## mmwave-net-device.h (module 'mmwave'): bool ns3::mmwave::MmWaveNetDevice::IsLinkUp() const [member function]
    cls.add_method('IsLinkUp',
                   'bool',
                   [],
                   is_const=True, is_virtual=True)
    ## mmwave-net-device.h (module 'mmwave'): bool ns3::mmwave::MmWaveNetDevice::IsMulticast() const [member function]
    cls.add_method('IsMulticast',
                   'bool',
                   [],
                   is_const=True, is_virtual=True)
    ## mmwave-net-device.h (module 'mmwave'): bool ns3::mmwave::MmWaveNetDevice::IsPointToPoint() const [member function]
    cls.add_method('IsPointToPoint',
                   'bool',
                   [],
                   is_const=True, is_virtual=True)
    ## mmwave-net-device.h (module 'mmwave'): bool ns3::mmwave::MmWaveNetDevice::NeedsArp() const [member function]
    cls.add_method('NeedsArp',
                   'bool',
                   [],
                   is_const=True, is_virtual=True)
    ## mmwave-net-device.h (module 'mmwave'): void ns3::mmwave::MmWaveNetDevice::Receive(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('Receive',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'p')])
    ## mmwave-net-device.h (module 'mmwave'): bool ns3::mmwave::MmWaveNetDevice::Send(ns3::Ptr<ns3::Packet> packet, ns3::Address const & dest, uint16_t protocolNumber) [member function]
    cls.add_method('Send',
                   'bool',
                   [param('ns3::Ptr< ns3::Packet >', 'packet'), param('ns3::Address const &', 'dest'), param('uint16_t', 'protocolNumber')],
                   is_virtual=True)
    ## mmwave-net-device.h (module 'mmwave'): bool ns3::mmwave::MmWaveNetDevice::SendFrom(ns3::Ptr<ns3::Packet> packet, ns3::Address const & source, ns3::Address const & dest, uint16_t protocolNumber) [member function]
    cls.add_method('SendFrom',
                   'bool',
                   [param('ns3::Ptr< ns3::Packet >', 'packet'), param('ns3::Address const &', 'source'), param('ns3::Address const &', 'dest'), param('uint16_t', 'protocolNumber')],
                   is_virtual=True)
    ## mmwave-net-device.h (module 'mmwave'): void ns3::mmwave::MmWaveNetDevice::SetAddress(ns3::Address address) [member function]
    cls.add_method('SetAddress',
                   'void',
                   [param('ns3::Address', 'address')],
                   is_virtual=True)
    ## mmwave-net-device.h (module 'mmwave'): void ns3::mmwave::MmWaveNetDevice::SetIfIndex(uint32_t const index) [member function]
    cls.add_method('SetIfIndex',
                   'void',
                   [param('uint32_t const', 'index')],
                   is_virtual=True)
    ## mmwave-net-device.h (module 'mmwave'): bool ns3::mmwave::MmWaveNetDevice::SetMtu(uint16_t const mtu) [member function]
    cls.add_method('SetMtu',
                   'bool',
                   [param('uint16_t const', 'mtu')],
                   is_virtual=True)
    ## mmwave-net-device.h (module 'mmwave'): void ns3::mmwave::MmWaveNetDevice::SetNode(ns3::Ptr<ns3::Node> node) [member function]
    cls.add_method('SetNode',
                   'void',
                   [param('ns3::Ptr< ns3::Node >', 'node')],
                   is_virtual=True)
    ## mmwave-net-device.h (module 'mmwave'): void ns3::mmwave::MmWaveNetDevice::SetPromiscReceiveCallback(ns3::NetDevice::PromiscReceiveCallback cb) [member function]
    cls.add_method('SetPromiscReceiveCallback',
                   'void',
                   [param('ns3::Callback< bool, ns3::Ptr< ns3::NetDevice >, ns3::Ptr< ns3::Packet const >, unsigned short, ns3::Address const &, ns3::Address const &, ns3::NetDevice::PacketType, ns3::empty, ns3::empty, ns3::empty >', 'cb')],
                   is_virtual=True)
    ## mmwave-net-device.h (module 'mmwave'): void ns3::mmwave::MmWaveNetDevice::SetReceiveCallback(ns3::NetDevice::ReceiveCallback cb) [member function]
    cls.add_method('SetReceiveCallback',
                   'void',
                   [param('ns3::Callback< bool, ns3::Ptr< ns3::NetDevice >, ns3::Ptr< ns3::Packet const >, unsigned short, ns3::Address const &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'cb')],
                   is_virtual=True)
    ## mmwave-net-device.h (module 'mmwave'): bool ns3::mmwave::MmWaveNetDevice::SupportsSendFrom() const [member function]
    cls.add_method('SupportsSendFrom',
                   'bool',
                   [],
                   is_const=True, is_virtual=True)
    return

def register_Ns3MmwaveMmWaveNoOpComponentCarrierManager_methods(root_module, cls):
    ## mmwave-no-op-component-carrier-manager.h (module 'mmwave'): ns3::mmwave::MmWaveNoOpComponentCarrierManager::MmWaveNoOpComponentCarrierManager(ns3::mmwave::MmWaveNoOpComponentCarrierManager const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveNoOpComponentCarrierManager const &', 'arg0')])
    ## mmwave-no-op-component-carrier-manager.h (module 'mmwave'): ns3::mmwave::MmWaveNoOpComponentCarrierManager::MmWaveNoOpComponentCarrierManager() [constructor]
    cls.add_constructor([])
    ## mmwave-no-op-component-carrier-manager.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWaveNoOpComponentCarrierManager::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-no-op-component-carrier-manager.h (module 'mmwave'): void ns3::mmwave::MmWaveNoOpComponentCarrierManager::DoAddLc(ns3::LteEnbCmacSapProvider::LcInfo lcInfo, ns3::LteMacSapUser * msu) [member function]
    cls.add_method('DoAddLc',
                   'void',
                   [param('ns3::LteEnbCmacSapProvider::LcInfo', 'lcInfo'), param('ns3::LteMacSapUser *', 'msu')],
                   visibility='protected', is_virtual=True)
    ## mmwave-no-op-component-carrier-manager.h (module 'mmwave'): void ns3::mmwave::MmWaveNoOpComponentCarrierManager::DoAddUe(uint16_t rnti, uint8_t state) [member function]
    cls.add_method('DoAddUe',
                   'void',
                   [param('uint16_t', 'rnti'), param('uint8_t', 'state')],
                   visibility='protected', is_virtual=True)
    ## mmwave-no-op-component-carrier-manager.h (module 'mmwave'): ns3::LteMacSapUser * ns3::mmwave::MmWaveNoOpComponentCarrierManager::DoConfigureSignalBearer(ns3::LteEnbCmacSapProvider::LcInfo lcinfo, ns3::LteMacSapUser * msu) [member function]
    cls.add_method('DoConfigureSignalBearer',
                   'ns3::LteMacSapUser *',
                   [param('ns3::LteEnbCmacSapProvider::LcInfo', 'lcinfo'), param('ns3::LteMacSapUser *', 'msu')],
                   visibility='protected', is_virtual=True)
    ## mmwave-no-op-component-carrier-manager.h (module 'mmwave'): void ns3::mmwave::MmWaveNoOpComponentCarrierManager::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   visibility='protected', is_virtual=True)
    ## mmwave-no-op-component-carrier-manager.h (module 'mmwave'): void ns3::mmwave::MmWaveNoOpComponentCarrierManager::DoInitialize() [member function]
    cls.add_method('DoInitialize',
                   'void',
                   [],
                   visibility='protected', is_virtual=True)
    ## mmwave-no-op-component-carrier-manager.h (module 'mmwave'): void ns3::mmwave::MmWaveNoOpComponentCarrierManager::DoNotifyHarqDeliveryFailure() [member function]
    cls.add_method('DoNotifyHarqDeliveryFailure',
                   'void',
                   [],
                   visibility='protected', is_virtual=True)
    ## mmwave-no-op-component-carrier-manager.h (module 'mmwave'): void ns3::mmwave::MmWaveNoOpComponentCarrierManager::DoNotifyPrbOccupancy(double prbOccupancy, uint8_t componentCarrierId) [member function]
    cls.add_method('DoNotifyPrbOccupancy',
                   'void',
                   [param('double', 'prbOccupancy'), param('uint8_t', 'componentCarrierId')],
                   visibility='protected', is_virtual=True)
    ## mmwave-no-op-component-carrier-manager.h (module 'mmwave'): void ns3::mmwave::MmWaveNoOpComponentCarrierManager::DoNotifyTxOpportunity(uint32_t bytes, uint8_t layer, uint8_t harqId, uint8_t componentCarrierId, uint16_t rnti, uint8_t lcid) [member function]
    cls.add_method('DoNotifyTxOpportunity',
                   'void',
                   [param('uint32_t', 'bytes'), param('uint8_t', 'layer'), param('uint8_t', 'harqId'), param('uint8_t', 'componentCarrierId'), param('uint16_t', 'rnti'), param('uint8_t', 'lcid')],
                   visibility='protected', is_virtual=True)
    ## mmwave-no-op-component-carrier-manager.h (module 'mmwave'): void ns3::mmwave::MmWaveNoOpComponentCarrierManager::DoReceivePdu(ns3::Ptr<ns3::Packet> p, uint16_t rnti, uint8_t lcid) [member function]
    cls.add_method('DoReceivePdu',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'p'), param('uint16_t', 'rnti'), param('uint8_t', 'lcid')],
                   visibility='protected', is_virtual=True)
    ## mmwave-no-op-component-carrier-manager.h (module 'mmwave'): std::vector<unsigned char, std::allocator<unsigned char> > ns3::mmwave::MmWaveNoOpComponentCarrierManager::DoReleaseDataRadioBearer(uint16_t rnti, uint8_t lcid) [member function]
    cls.add_method('DoReleaseDataRadioBearer',
                   'std::vector< unsigned char >',
                   [param('uint16_t', 'rnti'), param('uint8_t', 'lcid')],
                   visibility='protected', is_virtual=True)
    ## mmwave-no-op-component-carrier-manager.h (module 'mmwave'): void ns3::mmwave::MmWaveNoOpComponentCarrierManager::DoRemoveUe(uint16_t rnti) [member function]
    cls.add_method('DoRemoveUe',
                   'void',
                   [param('uint16_t', 'rnti')],
                   visibility='protected', is_virtual=True)
    ## mmwave-no-op-component-carrier-manager.h (module 'mmwave'): void ns3::mmwave::MmWaveNoOpComponentCarrierManager::DoReportBufferStatus(ns3::LteMacSapProvider::ReportBufferStatusParameters params) [member function]
    cls.add_method('DoReportBufferStatus',
                   'void',
                   [param('ns3::LteMacSapProvider::ReportBufferStatusParameters', 'params')],
                   visibility='protected', is_virtual=True)
    ## mmwave-no-op-component-carrier-manager.h (module 'mmwave'): void ns3::mmwave::MmWaveNoOpComponentCarrierManager::DoReportUeMeas(uint16_t rnti, ns3::LteRrcSap::MeasResults measResults) [member function]
    cls.add_method('DoReportUeMeas',
                   'void',
                   [param('uint16_t', 'rnti'), param('ns3::LteRrcSap::MeasResults', 'measResults')],
                   visibility='protected', is_virtual=True)
    ## mmwave-no-op-component-carrier-manager.h (module 'mmwave'): std::vector<ns3::LteCcmRrcSapProvider::LcsConfig, std::allocator<ns3::LteCcmRrcSapProvider::LcsConfig> > ns3::mmwave::MmWaveNoOpComponentCarrierManager::DoSetupDataRadioBearer(ns3::EpsBearer bearer, uint8_t bearerId, uint16_t rnti, uint8_t lcid, uint8_t lcGroup, ns3::LteMacSapUser * msu) [member function]
    cls.add_method('DoSetupDataRadioBearer',
                   'std::vector< ns3::LteCcmRrcSapProvider::LcsConfig >',
                   [param('ns3::EpsBearer', 'bearer'), param('uint8_t', 'bearerId'), param('uint16_t', 'rnti'), param('uint8_t', 'lcid'), param('uint8_t', 'lcGroup'), param('ns3::LteMacSapUser *', 'msu')],
                   visibility='protected', is_virtual=True)
    ## mmwave-no-op-component-carrier-manager.h (module 'mmwave'): void ns3::mmwave::MmWaveNoOpComponentCarrierManager::DoTransmitPdu(ns3::LteMacSapProvider::TransmitPduParameters params) [member function]
    cls.add_method('DoTransmitPdu',
                   'void',
                   [param('ns3::LteMacSapProvider::TransmitPduParameters', 'params')],
                   visibility='protected', is_virtual=True)
    ## mmwave-no-op-component-carrier-manager.h (module 'mmwave'): void ns3::mmwave::MmWaveNoOpComponentCarrierManager::DoUlReceiveMacCe(ns3::MacCeListElement_s bsr, uint8_t componentCarrierId) [member function]
    cls.add_method('DoUlReceiveMacCe',
                   'void',
                   [param('ns3::MacCeListElement_s', 'bsr'), param('uint8_t', 'componentCarrierId')],
                   visibility='protected', is_virtual=True)
    return

def register_Ns3MmwaveMmWavePhy_methods(root_module, cls):
    ## mmwave-phy.h (module 'mmwave'): ns3::mmwave::MmWavePhy::MmWavePhy(ns3::mmwave::MmWavePhy const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWavePhy const &', 'arg0')])
    ## mmwave-phy.h (module 'mmwave'): ns3::mmwave::MmWavePhy::MmWavePhy() [constructor]
    cls.add_constructor([])
    ## mmwave-phy.h (module 'mmwave'): ns3::mmwave::MmWavePhy::MmWavePhy(ns3::Ptr<ns3::mmwave::MmWaveSpectrumPhy> dlChannelPhy, ns3::Ptr<ns3::mmwave::MmWaveSpectrumPhy> ulChannelPhy) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::mmwave::MmWaveSpectrumPhy >', 'dlChannelPhy'), param('ns3::Ptr< ns3::mmwave::MmWaveSpectrumPhy >', 'ulChannelPhy')])
    ## mmwave-phy.h (module 'mmwave'): void ns3::mmwave::MmWavePhy::AddLosTracker(ns3::Ptr<ns3::mmwave::MmWaveLosTracker> arg0) [member function]
    cls.add_method('AddLosTracker',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWaveLosTracker >', 'arg0')])
    ## mmwave-phy.h (module 'mmwave'): void ns3::mmwave::MmWavePhy::AddPropagationLossModel(ns3::Ptr<ns3::PropagationLossModel> model) [member function]
    cls.add_method('AddPropagationLossModel',
                   'void',
                   [param('ns3::Ptr< ns3::PropagationLossModel >', 'model')])
    ## mmwave-phy.h (module 'mmwave'): void ns3::mmwave::MmWavePhy::AddSpectrumPropagationLossModel(ns3::Ptr<ns3::SpectrumPropagationLossModel> model) [member function]
    cls.add_method('AddSpectrumPropagationLossModel',
                   'void',
                   [param('ns3::Ptr< ns3::SpectrumPropagationLossModel >', 'model')])
    ## mmwave-phy.h (module 'mmwave'): ns3::Ptr<ns3::SpectrumValue> ns3::mmwave::MmWavePhy::CreateTxPowerSpectralDensity() [member function]
    cls.add_method('CreateTxPowerSpectralDensity',
                   'ns3::Ptr< ns3::SpectrumValue >',
                   [],
                   is_pure_virtual=True, is_virtual=True)
    ## mmwave-phy.h (module 'mmwave'): void ns3::mmwave::MmWavePhy::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## mmwave-phy.h (module 'mmwave'): void ns3::mmwave::MmWavePhy::DoInitialize() [member function]
    cls.add_method('DoInitialize',
                   'void',
                   [],
                   is_virtual=True)
    ## mmwave-phy.h (module 'mmwave'): void ns3::mmwave::MmWavePhy::DoSetCellId(uint16_t cellId) [member function]
    cls.add_method('DoSetCellId',
                   'void',
                   [param('uint16_t', 'cellId')])
    ## mmwave-phy.h (module 'mmwave'): uint8_t ns3::mmwave::MmWavePhy::GetComponentCarrierId() [member function]
    cls.add_method('GetComponentCarrierId',
                   'uint8_t',
                   [])
    ## mmwave-phy.h (module 'mmwave'): ns3::Ptr<ns3::mmwave::MmWavePhyMacCommon> ns3::mmwave::MmWavePhy::GetConfigurationParameters() const [member function]
    cls.add_method('GetConfigurationParameters',
                   'ns3::Ptr< ns3::mmwave::MmWavePhyMacCommon >',
                   [],
                   is_const=True)
    ## mmwave-phy.h (module 'mmwave'): std::list<ns3::Ptr<ns3::mmwave::MmWaveControlMessage>, std::allocator<ns3::Ptr<ns3::mmwave::MmWaveControlMessage> > > ns3::mmwave::MmWavePhy::GetControlMessages() [member function]
    cls.add_method('GetControlMessages',
                   'std::list< ns3::Ptr< ns3::mmwave::MmWaveControlMessage > >',
                   [])
    ## mmwave-phy.h (module 'mmwave'): ns3::Ptr<ns3::NetDevice> ns3::mmwave::MmWavePhy::GetDevice() [member function]
    cls.add_method('GetDevice',
                   'ns3::Ptr< ns3::NetDevice >',
                   [])
    ## mmwave-phy.h (module 'mmwave'): double ns3::mmwave::MmWavePhy::GetNoiseFigure() const [member function]
    cls.add_method('GetNoiseFigure',
                   'double',
                   [],
                   is_const=True)
    ## mmwave-phy.h (module 'mmwave'): ns3::Ptr<ns3::PacketBurst> ns3::mmwave::MmWavePhy::GetPacketBurst(ns3::mmwave::SfnSf arg0) [member function]
    cls.add_method('GetPacketBurst',
                   'ns3::Ptr< ns3::PacketBurst >',
                   [param('ns3::mmwave::SfnSf', 'arg0')],
                   is_virtual=True)
    ## mmwave-phy.h (module 'mmwave'): ns3::mmwave::MmWavePhySapProvider * ns3::mmwave::MmWavePhy::GetPhySapProvider() [member function]
    cls.add_method('GetPhySapProvider',
                   'ns3::mmwave::MmWavePhySapProvider *',
                   [])
    ## mmwave-phy.h (module 'mmwave'): ns3::mmwave::SfAllocInfo ns3::mmwave::MmWavePhy::GetSfAllocInfo(uint8_t subframeNum) [member function]
    cls.add_method('GetSfAllocInfo',
                   'ns3::mmwave::SfAllocInfo',
                   [param('uint8_t', 'subframeNum')])
    ## mmwave-phy.h (module 'mmwave'): double ns3::mmwave::MmWavePhy::GetTti() const [member function]
    cls.add_method('GetTti',
                   'double',
                   [],
                   is_const=True)
    ## mmwave-phy.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWavePhy::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-phy.h (module 'mmwave'): void ns3::mmwave::MmWavePhy::SendRachPreamble(uint32_t PreambleId, uint32_t Rnti) [member function]
    cls.add_method('SendRachPreamble',
                   'void',
                   [param('uint32_t', 'PreambleId'), param('uint32_t', 'Rnti')],
                   is_virtual=True)
    ## mmwave-phy.h (module 'mmwave'): void ns3::mmwave::MmWavePhy::SetChannel(ns3::Ptr<ns3::SpectrumChannel> c) [member function]
    cls.add_method('SetChannel',
                   'void',
                   [param('ns3::Ptr< ns3::SpectrumChannel >', 'c')])
    ## mmwave-phy.h (module 'mmwave'): void ns3::mmwave::MmWavePhy::SetComponentCarrierId(uint8_t index) [member function]
    cls.add_method('SetComponentCarrierId',
                   'void',
                   [param('uint8_t', 'index')])
    ## mmwave-phy.h (module 'mmwave'): void ns3::mmwave::MmWavePhy::SetConfigurationParameters(ns3::Ptr<ns3::mmwave::MmWavePhyMacCommon> ptrConfig) [member function]
    cls.add_method('SetConfigurationParameters',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWavePhyMacCommon >', 'ptrConfig')])
    ## mmwave-phy.h (module 'mmwave'): void ns3::mmwave::MmWavePhy::SetControlMessage(ns3::Ptr<ns3::mmwave::MmWaveControlMessage> m) [member function]
    cls.add_method('SetControlMessage',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWaveControlMessage >', 'm')])
    ## mmwave-phy.h (module 'mmwave'): void ns3::mmwave::MmWavePhy::SetDevice(ns3::Ptr<ns3::NetDevice> d) [member function]
    cls.add_method('SetDevice',
                   'void',
                   [param('ns3::Ptr< ns3::NetDevice >', 'd')])
    ## mmwave-phy.h (module 'mmwave'): void ns3::mmwave::MmWavePhy::SetDlSfAllocInfo(ns3::mmwave::SfAllocInfo sfAllocInfo) [member function]
    cls.add_method('SetDlSfAllocInfo',
                   'void',
                   [param('ns3::mmwave::SfAllocInfo', 'sfAllocInfo')])
    ## mmwave-phy.h (module 'mmwave'): void ns3::mmwave::MmWavePhy::SetMacPdu(ns3::Ptr<ns3::Packet> pb) [member function]
    cls.add_method('SetMacPdu',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'pb')],
                   is_virtual=True)
    ## mmwave-phy.h (module 'mmwave'): void ns3::mmwave::MmWavePhy::SetNoiseFigure(double nf) [member function]
    cls.add_method('SetNoiseFigure',
                   'void',
                   [param('double', 'nf')])
    ## mmwave-phy.h (module 'mmwave'): void ns3::mmwave::MmWavePhy::SetUlSfAllocInfo(ns3::mmwave::SfAllocInfo sfAllocInfo) [member function]
    cls.add_method('SetUlSfAllocInfo',
                   'void',
                   [param('ns3::mmwave::SfAllocInfo', 'sfAllocInfo')])
    ## mmwave-phy.h (module 'mmwave'): void ns3::mmwave::MmWavePhy::UpdateCurrentAllocationAndSchedule(uint32_t frame, uint32_t sf) [member function]
    cls.add_method('UpdateCurrentAllocationAndSchedule',
                   'void',
                   [param('uint32_t', 'frame'), param('uint32_t', 'sf')])
    return

def register_Ns3MmwaveMmWavePhyMacCommon_methods(root_module, cls):
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::MmWavePhyMacCommon::MmWavePhyMacCommon(ns3::mmwave::MmWavePhyMacCommon const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWavePhyMacCommon const &', 'arg0')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::MmWavePhyMacCommon::MmWavePhyMacCommon() [constructor]
    cls.add_constructor([])
    ## mmwave-phy-mac-common.h (module 'mmwave'): uint8_t ns3::mmwave::MmWavePhyMacCommon::GetCcId() [member function]
    cls.add_method('GetCcId',
                   'uint8_t',
                   [])
    ## mmwave-phy-mac-common.h (module 'mmwave'): double ns3::mmwave::MmWavePhyMacCommon::GetCenterFrequency() [member function]
    cls.add_method('GetCenterFrequency',
                   'double',
                   [])
    ## mmwave-phy-mac-common.h (module 'mmwave'): double ns3::mmwave::MmWavePhyMacCommon::GetChunkWidth() [member function]
    cls.add_method('GetChunkWidth',
                   'double',
                   [])
    ## mmwave-phy-mac-common.h (module 'mmwave'): uint32_t ns3::mmwave::MmWavePhyMacCommon::GetCtrlSymbols() [member function]
    cls.add_method('GetCtrlSymbols',
                   'uint32_t',
                   [])
    ## mmwave-phy-mac-common.h (module 'mmwave'): uint32_t ns3::mmwave::MmWavePhyMacCommon::GetDlCtrlSymbols() [member function]
    cls.add_method('GetDlCtrlSymbols',
                   'uint32_t',
                   [])
    ## mmwave-phy-mac-common.h (module 'mmwave'): double ns3::mmwave::MmWavePhyMacCommon::GetGuardPeriod() [member function]
    cls.add_method('GetGuardPeriod',
                   'double',
                   [])
    ## mmwave-phy-mac-common.h (module 'mmwave'): uint8_t ns3::mmwave::MmWavePhyMacCommon::GetHarqTimeout() [member function]
    cls.add_method('GetHarqTimeout',
                   'uint8_t',
                   [])
    ## mmwave-phy-mac-common.h (module 'mmwave'): uint32_t ns3::mmwave::MmWavePhyMacCommon::GetL1L2CtrlLatency() [member function]
    cls.add_method('GetL1L2CtrlLatency',
                   'uint32_t',
                   [])
    ## mmwave-phy-mac-common.h (module 'mmwave'): uint32_t ns3::mmwave::MmWavePhyMacCommon::GetL1L2DataLatency() [member function]
    cls.add_method('GetL1L2DataLatency',
                   'uint32_t',
                   [])
    ## mmwave-phy-mac-common.h (module 'mmwave'): uint32_t ns3::mmwave::MmWavePhyMacCommon::GetMaxTbSize() [member function]
    cls.add_method('GetMaxTbSize',
                   'uint32_t',
                   [])
    ## mmwave-phy-mac-common.h (module 'mmwave'): uint32_t ns3::mmwave::MmWavePhyMacCommon::GetNumChunkPerRb() [member function]
    cls.add_method('GetNumChunkPerRb',
                   'uint32_t',
                   [])
    ## mmwave-phy-mac-common.h (module 'mmwave'): uint32_t ns3::mmwave::MmWavePhyMacCommon::GetNumHarqProcess() [member function]
    cls.add_method('GetNumHarqProcess',
                   'uint32_t',
                   [])
    ## mmwave-phy-mac-common.h (module 'mmwave'): uint32_t ns3::mmwave::MmWavePhyMacCommon::GetNumRb() [member function]
    cls.add_method('GetNumRb',
                   'uint32_t',
                   [])
    ## mmwave-phy-mac-common.h (module 'mmwave'): uint32_t ns3::mmwave::MmWavePhyMacCommon::GetNumRbPerRbg() [member function]
    cls.add_method('GetNumRbPerRbg',
                   'uint32_t',
                   [])
    ## mmwave-phy-mac-common.h (module 'mmwave'): uint32_t ns3::mmwave::MmWavePhyMacCommon::GetNumRefScPerRb() [member function]
    cls.add_method('GetNumRefScPerRb',
                   'uint32_t',
                   [])
    ## mmwave-phy-mac-common.h (module 'mmwave'): uint32_t ns3::mmwave::MmWavePhyMacCommon::GetNumRefScPerSym() [member function]
    cls.add_method('GetNumRefScPerSym',
                   'uint32_t',
                   [])
    ## mmwave-phy-mac-common.h (module 'mmwave'): uint32_t ns3::mmwave::MmWavePhyMacCommon::GetNumReferenceSymbols() [member function]
    cls.add_method('GetNumReferenceSymbols',
                   'uint32_t',
                   [])
    ## mmwave-phy-mac-common.h (module 'mmwave'): uint32_t ns3::mmwave::MmWavePhyMacCommon::GetNumSCperChunk() [member function]
    cls.add_method('GetNumSCperChunk',
                   'uint32_t',
                   [])
    ## mmwave-phy-mac-common.h (module 'mmwave'): double ns3::mmwave::MmWavePhyMacCommon::GetRBWidth() [member function]
    cls.add_method('GetRBWidth',
                   'double',
                   [])
    ## mmwave-phy-mac-common.h (module 'mmwave'): uint32_t ns3::mmwave::MmWavePhyMacCommon::GetSlotsPerSubframe() [member function]
    cls.add_method('GetSlotsPerSubframe',
                   'uint32_t',
                   [])
    ## mmwave-phy-mac-common.h (module 'mmwave'): std::string ns3::mmwave::MmWavePhyMacCommon::GetStaticTDDPattern() [member function]
    cls.add_method('GetStaticTDDPattern',
                   'std::string',
                   [])
    ## mmwave-phy-mac-common.h (module 'mmwave'): double ns3::mmwave::MmWavePhyMacCommon::GetSubframePeriod() [member function]
    cls.add_method('GetSubframePeriod',
                   'double',
                   [])
    ## mmwave-phy-mac-common.h (module 'mmwave'): uint32_t ns3::mmwave::MmWavePhyMacCommon::GetSubframesPerFrame() [member function]
    cls.add_method('GetSubframesPerFrame',
                   'uint32_t',
                   [])
    ## mmwave-phy-mac-common.h (module 'mmwave'): uint32_t ns3::mmwave::MmWavePhyMacCommon::GetSymbPerSlot() [member function]
    cls.add_method('GetSymbPerSlot',
                   'uint32_t',
                   [])
    ## mmwave-phy-mac-common.h (module 'mmwave'): double ns3::mmwave::MmWavePhyMacCommon::GetSymbolPeriod() [member function]
    cls.add_method('GetSymbolPeriod',
                   'double',
                   [])
    ## mmwave-phy-mac-common.h (module 'mmwave'): uint32_t ns3::mmwave::MmWavePhyMacCommon::GetSymbolsPerSubframe() [member function]
    cls.add_method('GetSymbolsPerSubframe',
                   'uint32_t',
                   [])
    ## mmwave-phy-mac-common.h (module 'mmwave'): double ns3::mmwave::MmWavePhyMacCommon::GetSystemBandwidth() [member function]
    cls.add_method('GetSystemBandwidth',
                   'double',
                   [])
    ## mmwave-phy-mac-common.h (module 'mmwave'): uint32_t ns3::mmwave::MmWavePhyMacCommon::GetTbDecodeLatency() [member function]
    cls.add_method('GetTbDecodeLatency',
                   'uint32_t',
                   [])
    ## mmwave-phy-mac-common.h (module 'mmwave'): uint32_t ns3::mmwave::MmWavePhyMacCommon::GetTotalNumChunk() [member function]
    cls.add_method('GetTotalNumChunk',
                   'uint32_t',
                   [])
    ## mmwave-phy-mac-common.h (module 'mmwave'): double ns3::mmwave::MmWavePhyMacCommon::GetTti() [member function]
    cls.add_method('GetTti',
                   'double',
                   [])
    ## mmwave-phy-mac-common.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWavePhyMacCommon::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-phy-mac-common.h (module 'mmwave'): uint32_t ns3::mmwave::MmWavePhyMacCommon::GetUlCtrlSymbols() [member function]
    cls.add_method('GetUlCtrlSymbols',
                   'uint32_t',
                   [])
    ## mmwave-phy-mac-common.h (module 'mmwave'): uint8_t ns3::mmwave::MmWavePhyMacCommon::GetUlSchedDelay() [member function]
    cls.add_method('GetUlSchedDelay',
                   'uint8_t',
                   [])
    ## mmwave-phy-mac-common.h (module 'mmwave'): double ns3::mmwave::MmWavePhyMacCommon::GetWbCqiPeriodUs() [member function]
    cls.add_method('GetWbCqiPeriodUs',
                   'double',
                   [])
    ## mmwave-phy-mac-common.h (module 'mmwave'): void ns3::mmwave::MmWavePhyMacCommon::SetCcId(uint8_t ccId) [member function]
    cls.add_method('SetCcId',
                   'void',
                   [param('uint8_t', 'ccId')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): void ns3::mmwave::MmWavePhyMacCommon::SetCentreFrequency(double fc) [member function]
    cls.add_method('SetCentreFrequency',
                   'void',
                   [param('double', 'fc')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): void ns3::mmwave::MmWavePhyMacCommon::SetChunkWidth(double chumkWidth) [member function]
    cls.add_method('SetChunkWidth',
                   'void',
                   [param('double', 'chumkWidth')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): void ns3::mmwave::MmWavePhyMacCommon::SetCtrlSymbols(uint32_t ctrlSymbols) [member function]
    cls.add_method('SetCtrlSymbols',
                   'void',
                   [param('uint32_t', 'ctrlSymbols')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): void ns3::mmwave::MmWavePhyMacCommon::SetDlCtrlSymbols(uint32_t ctrlSymbols) [member function]
    cls.add_method('SetDlCtrlSymbols',
                   'void',
                   [param('uint32_t', 'ctrlSymbols')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): void ns3::mmwave::MmWavePhyMacCommon::SetGuardPeriod(double usec) [member function]
    cls.add_method('SetGuardPeriod',
                   'void',
                   [param('double', 'usec')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): void ns3::mmwave::MmWavePhyMacCommon::SetHarqDlTimeout(uint8_t harqDlTimeout) [member function]
    cls.add_method('SetHarqDlTimeout',
                   'void',
                   [param('uint8_t', 'harqDlTimeout')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): void ns3::mmwave::MmWavePhyMacCommon::SetL1L2CtrlLatency(uint32_t delaySfs) [member function]
    cls.add_method('SetL1L2CtrlLatency',
                   'void',
                   [param('uint32_t', 'delaySfs')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): void ns3::mmwave::MmWavePhyMacCommon::SetL1L2DataLatency(uint32_t delaySlots) [member function]
    cls.add_method('SetL1L2DataLatency',
                   'void',
                   [param('uint32_t', 'delaySlots')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): void ns3::mmwave::MmWavePhyMacCommon::SetMaxTbSize(uint32_t bytes) [member function]
    cls.add_method('SetMaxTbSize',
                   'void',
                   [param('uint32_t', 'bytes')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): void ns3::mmwave::MmWavePhyMacCommon::SetNumChunkPerRB(uint32_t numChunk) [member function]
    cls.add_method('SetNumChunkPerRB',
                   'void',
                   [param('uint32_t', 'numChunk')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): void ns3::mmwave::MmWavePhyMacCommon::SetNumHarqProcess(uint32_t numProcess) [member function]
    cls.add_method('SetNumHarqProcess',
                   'void',
                   [param('uint32_t', 'numProcess')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): void ns3::mmwave::MmWavePhyMacCommon::SetNumRb(uint32_t numRB) [member function]
    cls.add_method('SetNumRb',
                   'void',
                   [param('uint32_t', 'numRB')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): void ns3::mmwave::MmWavePhyMacCommon::SetNumRbPerRbg(uint32_t numRB) [member function]
    cls.add_method('SetNumRbPerRbg',
                   'void',
                   [param('uint32_t', 'numRB')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): void ns3::mmwave::MmWavePhyMacCommon::SetNumRefScPerRb(uint32_t numRefSc) [member function]
    cls.add_method('SetNumRefScPerRb',
                   'void',
                   [param('uint32_t', 'numRefSc')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): void ns3::mmwave::MmWavePhyMacCommon::SetNumRefScPerSym(uint32_t numRefSc) [member function]
    cls.add_method('SetNumRefScPerSym',
                   'void',
                   [param('uint32_t', 'numRefSc')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): void ns3::mmwave::MmWavePhyMacCommon::SetNumReferenceSymbols(uint32_t refSym) [member function]
    cls.add_method('SetNumReferenceSymbols',
                   'void',
                   [param('uint32_t', 'refSym')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): void ns3::mmwave::MmWavePhyMacCommon::SetNumSCperChunk(uint32_t numSC) [member function]
    cls.add_method('SetNumSCperChunk',
                   'void',
                   [param('uint32_t', 'numSC')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): void ns3::mmwave::MmWavePhyMacCommon::SetSlotPerSubframe(uint32_t numSlot) [member function]
    cls.add_method('SetSlotPerSubframe',
                   'void',
                   [param('uint32_t', 'numSlot')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): void ns3::mmwave::MmWavePhyMacCommon::SetStaticTDDPattern(std::string p) [member function]
    cls.add_method('SetStaticTDDPattern',
                   'void',
                   [param('std::string', 'p')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): void ns3::mmwave::MmWavePhyMacCommon::SetSubframePerFrame(uint32_t numSf) [member function]
    cls.add_method('SetSubframePerFrame',
                   'void',
                   [param('uint32_t', 'numSf')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): void ns3::mmwave::MmWavePhyMacCommon::SetSubframePeriod(double period) [member function]
    cls.add_method('SetSubframePeriod',
                   'void',
                   [param('double', 'period')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): void ns3::mmwave::MmWavePhyMacCommon::SetSymbPerSlot(uint32_t numSym) [member function]
    cls.add_method('SetSymbPerSlot',
                   'void',
                   [param('uint32_t', 'numSym')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): void ns3::mmwave::MmWavePhyMacCommon::SetSymbolPeriod(double prdSym) [member function]
    cls.add_method('SetSymbolPeriod',
                   'void',
                   [param('double', 'prdSym')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): void ns3::mmwave::MmWavePhyMacCommon::SetSymbolsPerSubframe(uint32_t numSym) [member function]
    cls.add_method('SetSymbolsPerSubframe',
                   'void',
                   [param('uint32_t', 'numSym')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): void ns3::mmwave::MmWavePhyMacCommon::SetTbDecodeLatency(uint32_t us) [member function]
    cls.add_method('SetTbDecodeLatency',
                   'void',
                   [param('uint32_t', 'us')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): void ns3::mmwave::MmWavePhyMacCommon::SetUlCtrlSymbols(uint32_t ctrlSymbols) [member function]
    cls.add_method('SetUlCtrlSymbols',
                   'void',
                   [param('uint32_t', 'ctrlSymbols')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): void ns3::mmwave::MmWavePhyMacCommon::SetUlSchedDelay(uint32_t tti) [member function]
    cls.add_method('SetUlSchedDelay',
                   'void',
                   [param('uint32_t', 'tti')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): void ns3::mmwave::MmWavePhyMacCommon::SetWbCqiPeriodUs(double us) [member function]
    cls.add_method('SetWbCqiPeriodUs',
                   'void',
                   [param('double', 'us')])
    return

def register_Ns3MmwaveMmWavePhyRxTrace_methods(root_module, cls):
    ## mmwave-phy-rx-trace.h (module 'mmwave'): ns3::mmwave::MmWavePhyRxTrace::MmWavePhyRxTrace(ns3::mmwave::MmWavePhyRxTrace const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWavePhyRxTrace const &', 'arg0')])
    ## mmwave-phy-rx-trace.h (module 'mmwave'): ns3::mmwave::MmWavePhyRxTrace::MmWavePhyRxTrace() [constructor]
    cls.add_constructor([])
    ## mmwave-phy-rx-trace.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWavePhyRxTrace::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-phy-rx-trace.h (module 'mmwave'): static void ns3::mmwave::MmWavePhyRxTrace::ReportCurrentCellRsrpSinrCallback(ns3::Ptr<ns3::mmwave::MmWavePhyRxTrace> phyStats, std::string path, uint64_t imsi, ns3::SpectrumValue & sinr, ns3::SpectrumValue & power) [member function]
    cls.add_method('ReportCurrentCellRsrpSinrCallback',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWavePhyRxTrace >', 'phyStats'), param('std::string', 'path'), param('uint64_t', 'imsi'), param('ns3::SpectrumValue &', 'sinr'), param('ns3::SpectrumValue &', 'power')],
                   is_static=True)
    ## mmwave-phy-rx-trace.h (module 'mmwave'): static void ns3::mmwave::MmWavePhyRxTrace::ReportDownLinkTBSize(ns3::Ptr<ns3::mmwave::MmWavePhyRxTrace> phyStats, std::string path, uint64_t imsi, uint64_t tbSize) [member function]
    cls.add_method('ReportDownLinkTBSize',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWavePhyRxTrace >', 'phyStats'), param('std::string', 'path'), param('uint64_t', 'imsi'), param('uint64_t', 'tbSize')],
                   is_static=True)
    ## mmwave-phy-rx-trace.h (module 'mmwave'): static void ns3::mmwave::MmWavePhyRxTrace::ReportPacketCountEnbCallback(ns3::Ptr<ns3::mmwave::MmWavePhyRxTrace> phyStats, std::string path, ns3::mmwave::EnbPhyPacketCountParameter param) [member function]
    cls.add_method('ReportPacketCountEnbCallback',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWavePhyRxTrace >', 'phyStats'), param('std::string', 'path'), param('ns3::mmwave::EnbPhyPacketCountParameter', 'param')],
                   is_static=True)
    ## mmwave-phy-rx-trace.h (module 'mmwave'): static void ns3::mmwave::MmWavePhyRxTrace::ReportPacketCountUeCallback(ns3::Ptr<ns3::mmwave::MmWavePhyRxTrace> phyStats, std::string path, ns3::mmwave::UePhyPacketCountParameter param) [member function]
    cls.add_method('ReportPacketCountUeCallback',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWavePhyRxTrace >', 'phyStats'), param('std::string', 'path'), param('ns3::mmwave::UePhyPacketCountParameter', 'param')],
                   is_static=True)
    ## mmwave-phy-rx-trace.h (module 'mmwave'): static void ns3::mmwave::MmWavePhyRxTrace::RxPacketTraceEnbCallback(ns3::Ptr<ns3::mmwave::MmWavePhyRxTrace> phyStats, std::string path, ns3::mmwave::RxPacketTraceParams param) [member function]
    cls.add_method('RxPacketTraceEnbCallback',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWavePhyRxTrace >', 'phyStats'), param('std::string', 'path'), param('ns3::mmwave::RxPacketTraceParams', 'param')],
                   is_static=True)
    ## mmwave-phy-rx-trace.h (module 'mmwave'): static void ns3::mmwave::MmWavePhyRxTrace::RxPacketTraceUeCallback(ns3::Ptr<ns3::mmwave::MmWavePhyRxTrace> phyStats, std::string path, ns3::mmwave::RxPacketTraceParams param) [member function]
    cls.add_method('RxPacketTraceUeCallback',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWavePhyRxTrace >', 'phyStats'), param('std::string', 'path'), param('ns3::mmwave::RxPacketTraceParams', 'param')],
                   is_static=True)
    ## mmwave-phy-rx-trace.h (module 'mmwave'): void ns3::mmwave::MmWavePhyRxTrace::SetOutputFilename(std::string fileName) [member function]
    cls.add_method('SetOutputFilename',
                   'void',
                   [param('std::string', 'fileName')])
    return

def register_Ns3MmwaveMmWavePhySapProvider_methods(root_module, cls):
    ## mmwave-phy-sap.h (module 'mmwave'): ns3::mmwave::MmWavePhySapProvider::MmWavePhySapProvider() [constructor]
    cls.add_constructor([])
    ## mmwave-phy-sap.h (module 'mmwave'): ns3::mmwave::MmWavePhySapProvider::MmWavePhySapProvider(ns3::mmwave::MmWavePhySapProvider const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWavePhySapProvider const &', 'arg0')])
    ## mmwave-phy-sap.h (module 'mmwave'): void ns3::mmwave::MmWavePhySapProvider::SendControlMessage(ns3::Ptr<ns3::mmwave::MmWaveControlMessage> msg) [member function]
    cls.add_method('SendControlMessage',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWaveControlMessage >', 'msg')],
                   is_pure_virtual=True, is_virtual=True)
    ## mmwave-phy-sap.h (module 'mmwave'): void ns3::mmwave::MmWavePhySapProvider::SendMacPdu(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('SendMacPdu',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'p')],
                   is_pure_virtual=True, is_virtual=True)
    ## mmwave-phy-sap.h (module 'mmwave'): void ns3::mmwave::MmWavePhySapProvider::SendRachPreamble(uint8_t PreambleId, uint8_t Rnti) [member function]
    cls.add_method('SendRachPreamble',
                   'void',
                   [param('uint8_t', 'PreambleId'), param('uint8_t', 'Rnti')],
                   is_pure_virtual=True, is_virtual=True)
    ## mmwave-phy-sap.h (module 'mmwave'): void ns3::mmwave::MmWavePhySapProvider::SetDlSfAllocInfo(ns3::mmwave::SfAllocInfo sfAllocInfo) [member function]
    cls.add_method('SetDlSfAllocInfo',
                   'void',
                   [param('ns3::mmwave::SfAllocInfo', 'sfAllocInfo')],
                   is_pure_virtual=True, is_virtual=True)
    ## mmwave-phy-sap.h (module 'mmwave'): void ns3::mmwave::MmWavePhySapProvider::SetUlSfAllocInfo(ns3::mmwave::SfAllocInfo sfAllocInfo) [member function]
    cls.add_method('SetUlSfAllocInfo',
                   'void',
                   [param('ns3::mmwave::SfAllocInfo', 'sfAllocInfo')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3MmwaveMmWavePointToPointEpcHelper_methods(root_module, cls):
    ## mmwave-point-to-point-epc-helper.h (module 'mmwave'): ns3::mmwave::MmWavePointToPointEpcHelper::MmWavePointToPointEpcHelper() [constructor]
    cls.add_constructor([])
    ## mmwave-point-to-point-epc-helper.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWavePointToPointEpcHelper::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-point-to-point-epc-helper.h (module 'mmwave'): void ns3::mmwave::MmWavePointToPointEpcHelper::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## mmwave-point-to-point-epc-helper.h (module 'mmwave'): void ns3::mmwave::MmWavePointToPointEpcHelper::AddEnb(ns3::Ptr<ns3::Node> enbNode, ns3::Ptr<ns3::NetDevice> lteEnbNetDevice, uint16_t cellId) [member function]
    cls.add_method('AddEnb',
                   'void',
                   [param('ns3::Ptr< ns3::Node >', 'enbNode'), param('ns3::Ptr< ns3::NetDevice >', 'lteEnbNetDevice'), param('uint16_t', 'cellId')],
                   is_virtual=True)
    ## mmwave-point-to-point-epc-helper.h (module 'mmwave'): void ns3::mmwave::MmWavePointToPointEpcHelper::AddUe(ns3::Ptr<ns3::NetDevice> ueLteDevice, uint64_t imsi) [member function]
    cls.add_method('AddUe',
                   'void',
                   [param('ns3::Ptr< ns3::NetDevice >', 'ueLteDevice'), param('uint64_t', 'imsi')],
                   is_virtual=True)
    ## mmwave-point-to-point-epc-helper.h (module 'mmwave'): void ns3::mmwave::MmWavePointToPointEpcHelper::AddX2Interface(ns3::Ptr<ns3::Node> enbNode1, ns3::Ptr<ns3::Node> enbNode2) [member function]
    cls.add_method('AddX2Interface',
                   'void',
                   [param('ns3::Ptr< ns3::Node >', 'enbNode1'), param('ns3::Ptr< ns3::Node >', 'enbNode2')],
                   is_virtual=True)
    ## mmwave-point-to-point-epc-helper.h (module 'mmwave'): uint8_t ns3::mmwave::MmWavePointToPointEpcHelper::ActivateEpsBearer(ns3::Ptr<ns3::NetDevice> ueLteDevice, uint64_t imsi, ns3::Ptr<ns3::EpcTft> tft, ns3::EpsBearer bearer) [member function]
    cls.add_method('ActivateEpsBearer',
                   'uint8_t',
                   [param('ns3::Ptr< ns3::NetDevice >', 'ueLteDevice'), param('uint64_t', 'imsi'), param('ns3::Ptr< ns3::EpcTft >', 'tft'), param('ns3::EpsBearer', 'bearer')],
                   is_virtual=True)
    ## mmwave-point-to-point-epc-helper.h (module 'mmwave'): uint8_t ns3::mmwave::MmWavePointToPointEpcHelper::ActivateEpsBearer(ns3::Ptr<ns3::NetDevice> ueLteDevice, ns3::Ptr<ns3::EpcUeNas> ueNas, uint64_t imsi, ns3::Ptr<ns3::EpcTft> tft, ns3::EpsBearer bearer) [member function]
    cls.add_method('ActivateEpsBearer',
                   'uint8_t',
                   [param('ns3::Ptr< ns3::NetDevice >', 'ueLteDevice'), param('ns3::Ptr< ns3::EpcUeNas >', 'ueNas'), param('uint64_t', 'imsi'), param('ns3::Ptr< ns3::EpcTft >', 'tft'), param('ns3::EpsBearer', 'bearer')],
                   is_virtual=True)
    ## mmwave-point-to-point-epc-helper.h (module 'mmwave'): ns3::Ptr<ns3::Node> ns3::mmwave::MmWavePointToPointEpcHelper::GetPgwNode() [member function]
    cls.add_method('GetPgwNode',
                   'ns3::Ptr< ns3::Node >',
                   [],
                   is_virtual=True)
    ## mmwave-point-to-point-epc-helper.h (module 'mmwave'): ns3::Ptr<ns3::Node> ns3::mmwave::MmWavePointToPointEpcHelper::GetMmeNode() [member function]
    cls.add_method('GetMmeNode',
                   'ns3::Ptr< ns3::Node >',
                   [],
                   is_virtual=True)
    ## mmwave-point-to-point-epc-helper.h (module 'mmwave'): ns3::Ipv4InterfaceContainer ns3::mmwave::MmWavePointToPointEpcHelper::AssignUeIpv4Address(ns3::NetDeviceContainer ueDevices) [member function]
    cls.add_method('AssignUeIpv4Address',
                   'ns3::Ipv4InterfaceContainer',
                   [param('ns3::NetDeviceContainer', 'ueDevices')],
                   is_virtual=True)
    ## mmwave-point-to-point-epc-helper.h (module 'mmwave'): ns3::Ipv6InterfaceContainer ns3::mmwave::MmWavePointToPointEpcHelper::AssignUeIpv6Address(ns3::NetDeviceContainer ueDevices) [member function]
    cls.add_method('AssignUeIpv6Address',
                   'ns3::Ipv6InterfaceContainer',
                   [param('ns3::NetDeviceContainer', 'ueDevices')],
                   is_virtual=True)
    ## mmwave-point-to-point-epc-helper.h (module 'mmwave'): ns3::Ipv4Address ns3::mmwave::MmWavePointToPointEpcHelper::GetUeDefaultGatewayAddress() [member function]
    cls.add_method('GetUeDefaultGatewayAddress',
                   'ns3::Ipv4Address',
                   [],
                   is_virtual=True)
    ## mmwave-point-to-point-epc-helper.h (module 'mmwave'): ns3::Ipv6Address ns3::mmwave::MmWavePointToPointEpcHelper::GetUeDefaultGatewayAddress6() [member function]
    cls.add_method('GetUeDefaultGatewayAddress6',
                   'ns3::Ipv6Address',
                   [],
                   is_virtual=True)
    return

def register_Ns3MmwaveMmWavePropagationLossModel_methods(root_module, cls):
    ## mmwave-propagation-loss-model.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWavePropagationLossModel::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-propagation-loss-model.h (module 'mmwave'): ns3::mmwave::MmWavePropagationLossModel::MmWavePropagationLossModel() [constructor]
    cls.add_constructor([])
    ## mmwave-propagation-loss-model.h (module 'mmwave'): void ns3::mmwave::MmWavePropagationLossModel::SetConfigurationParameters(ns3::Ptr<ns3::mmwave::MmWavePhyMacCommon> ptrConfig) [member function]
    cls.add_method('SetConfigurationParameters',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWavePhyMacCommon >', 'ptrConfig')])
    ## mmwave-propagation-loss-model.h (module 'mmwave'): void ns3::mmwave::MmWavePropagationLossModel::SetMinLoss(double minLoss) [member function]
    cls.add_method('SetMinLoss',
                   'void',
                   [param('double', 'minLoss')])
    ## mmwave-propagation-loss-model.h (module 'mmwave'): double ns3::mmwave::MmWavePropagationLossModel::GetMinLoss() const [member function]
    cls.add_method('GetMinLoss',
                   'double',
                   [],
                   is_const=True)
    ## mmwave-propagation-loss-model.h (module 'mmwave'): double ns3::mmwave::MmWavePropagationLossModel::GetFrequency() const [member function]
    cls.add_method('GetFrequency',
                   'double',
                   [],
                   is_const=True)
    ## mmwave-propagation-loss-model.h (module 'mmwave'): void ns3::mmwave::MmWavePropagationLossModel::SetLossFixedDb(double loss) [member function]
    cls.add_method('SetLossFixedDb',
                   'void',
                   [param('double', 'loss')])
    ## mmwave-propagation-loss-model.h (module 'mmwave'): double ns3::mmwave::MmWavePropagationLossModel::DoCalcRxPower(double txPowerDbm, ns3::Ptr<ns3::MobilityModel> a, ns3::Ptr<ns3::MobilityModel> b) const [member function]
    cls.add_method('DoCalcRxPower',
                   'double',
                   [param('double', 'txPowerDbm'), param('ns3::Ptr< ns3::MobilityModel >', 'a'), param('ns3::Ptr< ns3::MobilityModel >', 'b')],
                   is_const=True, visibility='private', is_virtual=True)
    ## mmwave-propagation-loss-model.h (module 'mmwave'): int64_t ns3::mmwave::MmWavePropagationLossModel::DoAssignStreams(int64_t stream) [member function]
    cls.add_method('DoAssignStreams',
                   'int64_t',
                   [param('int64_t', 'stream')],
                   visibility='private', is_virtual=True)
    return

def register_Ns3MmwaveMmWaveRachPreambleMessage_methods(root_module, cls):
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::MmWaveRachPreambleMessage::MmWaveRachPreambleMessage(ns3::mmwave::MmWaveRachPreambleMessage const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveRachPreambleMessage const &', 'arg0')])
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::MmWaveRachPreambleMessage::MmWaveRachPreambleMessage() [constructor]
    cls.add_constructor([])
    ## mmwave-control-messages.h (module 'mmwave'): uint32_t ns3::mmwave::MmWaveRachPreambleMessage::GetRapId() const [member function]
    cls.add_method('GetRapId',
                   'uint32_t',
                   [],
                   is_const=True)
    ## mmwave-control-messages.h (module 'mmwave'): void ns3::mmwave::MmWaveRachPreambleMessage::SetRapId(uint32_t rapid) [member function]
    cls.add_method('SetRapId',
                   'void',
                   [param('uint32_t', 'rapid')])
    return

def register_Ns3MmwaveMmWaveRadioBearerTag_methods(root_module, cls):
    ## mmwave-radio-bearer-tag.h (module 'mmwave'): ns3::mmwave::MmWaveRadioBearerTag::MmWaveRadioBearerTag(ns3::mmwave::MmWaveRadioBearerTag const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveRadioBearerTag const &', 'arg0')])
    ## mmwave-radio-bearer-tag.h (module 'mmwave'): ns3::mmwave::MmWaveRadioBearerTag::MmWaveRadioBearerTag() [constructor]
    cls.add_constructor([])
    ## mmwave-radio-bearer-tag.h (module 'mmwave'): ns3::mmwave::MmWaveRadioBearerTag::MmWaveRadioBearerTag(uint16_t rnti, uint8_t lcId, uint32_t size) [constructor]
    cls.add_constructor([param('uint16_t', 'rnti'), param('uint8_t', 'lcId'), param('uint32_t', 'size')])
    ## mmwave-radio-bearer-tag.h (module 'mmwave'): ns3::mmwave::MmWaveRadioBearerTag::MmWaveRadioBearerTag(uint16_t rnti, uint8_t lcId, uint32_t size, uint8_t layer) [constructor]
    cls.add_constructor([param('uint16_t', 'rnti'), param('uint8_t', 'lcId'), param('uint32_t', 'size'), param('uint8_t', 'layer')])
    ## mmwave-radio-bearer-tag.h (module 'mmwave'): void ns3::mmwave::MmWaveRadioBearerTag::Deserialize(ns3::TagBuffer i) [member function]
    cls.add_method('Deserialize',
                   'void',
                   [param('ns3::TagBuffer', 'i')],
                   is_virtual=True)
    ## mmwave-radio-bearer-tag.h (module 'mmwave'): ns3::TypeId ns3::mmwave::MmWaveRadioBearerTag::GetInstanceTypeId() const [member function]
    cls.add_method('GetInstanceTypeId',
                   'ns3::TypeId',
                   [],
                   is_const=True, is_virtual=True)
    ## mmwave-radio-bearer-tag.h (module 'mmwave'): uint8_t ns3::mmwave::MmWaveRadioBearerTag::GetLayer() const [member function]
    cls.add_method('GetLayer',
                   'uint8_t',
                   [],
                   is_const=True)
    ## mmwave-radio-bearer-tag.h (module 'mmwave'): uint8_t ns3::mmwave::MmWaveRadioBearerTag::GetLcid() const [member function]
    cls.add_method('GetLcid',
                   'uint8_t',
                   [],
                   is_const=True)
    ## mmwave-radio-bearer-tag.h (module 'mmwave'): uint16_t ns3::mmwave::MmWaveRadioBearerTag::GetRnti() const [member function]
    cls.add_method('GetRnti',
                   'uint16_t',
                   [],
                   is_const=True)
    ## mmwave-radio-bearer-tag.h (module 'mmwave'): uint32_t ns3::mmwave::MmWaveRadioBearerTag::GetSerializedSize() const [member function]
    cls.add_method('GetSerializedSize',
                   'uint32_t',
                   [],
                   is_const=True, is_virtual=True)
    ## mmwave-radio-bearer-tag.h (module 'mmwave'): uint32_t ns3::mmwave::MmWaveRadioBearerTag::GetSize() const [member function]
    cls.add_method('GetSize',
                   'uint32_t',
                   [],
                   is_const=True)
    ## mmwave-radio-bearer-tag.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWaveRadioBearerTag::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-radio-bearer-tag.h (module 'mmwave'): void ns3::mmwave::MmWaveRadioBearerTag::Print(std::ostream & os) const [member function]
    cls.add_method('Print',
                   'void',
                   [param('std::ostream &', 'os')],
                   is_const=True, is_virtual=True)
    ## mmwave-radio-bearer-tag.h (module 'mmwave'): void ns3::mmwave::MmWaveRadioBearerTag::Serialize(ns3::TagBuffer i) const [member function]
    cls.add_method('Serialize',
                   'void',
                   [param('ns3::TagBuffer', 'i')],
                   is_const=True, is_virtual=True)
    ## mmwave-radio-bearer-tag.h (module 'mmwave'): void ns3::mmwave::MmWaveRadioBearerTag::SetLayer(uint8_t layer) [member function]
    cls.add_method('SetLayer',
                   'void',
                   [param('uint8_t', 'layer')])
    ## mmwave-radio-bearer-tag.h (module 'mmwave'): void ns3::mmwave::MmWaveRadioBearerTag::SetLcid(uint8_t lcid) [member function]
    cls.add_method('SetLcid',
                   'void',
                   [param('uint8_t', 'lcid')])
    ## mmwave-radio-bearer-tag.h (module 'mmwave'): void ns3::mmwave::MmWaveRadioBearerTag::SetRnti(uint16_t rnti) [member function]
    cls.add_method('SetRnti',
                   'void',
                   [param('uint16_t', 'rnti')])
    ## mmwave-radio-bearer-tag.h (module 'mmwave'): void ns3::mmwave::MmWaveRadioBearerTag::SetSize(uint32_t size) [member function]
    cls.add_method('SetSize',
                   'void',
                   [param('uint32_t', 'size')])
    return

def register_Ns3MmwaveMmWaveRarMessage_methods(root_module, cls):
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::MmWaveRarMessage::MmWaveRarMessage(ns3::mmwave::MmWaveRarMessage const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveRarMessage const &', 'arg0')])
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::MmWaveRarMessage::MmWaveRarMessage() [constructor]
    cls.add_constructor([])
    ## mmwave-control-messages.h (module 'mmwave'): void ns3::mmwave::MmWaveRarMessage::AddRar(ns3::mmwave::MmWaveRarMessage::Rar rar) [member function]
    cls.add_method('AddRar',
                   'void',
                   [param('ns3::mmwave::MmWaveRarMessage::Rar', 'rar')])
    ## mmwave-control-messages.h (module 'mmwave'): uint16_t ns3::mmwave::MmWaveRarMessage::GetRaRnti() const [member function]
    cls.add_method('GetRaRnti',
                   'uint16_t',
                   [],
                   is_const=True)
    ## mmwave-control-messages.h (module 'mmwave'): std::list<ns3::mmwave::MmWaveRarMessage::Rar, std::allocator<ns3::mmwave::MmWaveRarMessage::Rar> >::const_iterator ns3::mmwave::MmWaveRarMessage::RarListBegin() const [member function]
    cls.add_method('RarListBegin',
                   'std::list< ns3::mmwave::MmWaveRarMessage::Rar > const_iterator',
                   [],
                   is_const=True)
    ## mmwave-control-messages.h (module 'mmwave'): std::list<ns3::mmwave::MmWaveRarMessage::Rar, std::allocator<ns3::mmwave::MmWaveRarMessage::Rar> >::const_iterator ns3::mmwave::MmWaveRarMessage::RarListEnd() const [member function]
    cls.add_method('RarListEnd',
                   'std::list< ns3::mmwave::MmWaveRarMessage::Rar > const_iterator',
                   [],
                   is_const=True)
    ## mmwave-control-messages.h (module 'mmwave'): void ns3::mmwave::MmWaveRarMessage::SetRaRnti(uint16_t raRnti) [member function]
    cls.add_method('SetRaRnti',
                   'void',
                   [param('uint16_t', 'raRnti')])
    return

def register_Ns3MmwaveMmWaveRarMessageRar_methods(root_module, cls):
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::MmWaveRarMessage::Rar::Rar() [constructor]
    cls.add_constructor([])
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::MmWaveRarMessage::Rar::Rar(ns3::mmwave::MmWaveRarMessage::Rar const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveRarMessage::Rar const &', 'arg0')])
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::MmWaveRarMessage::Rar::rapId [variable]
    cls.add_instance_attribute('rapId', 'uint8_t', is_const=False)
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::MmWaveRarMessage::Rar::rarPayload [variable]
    cls.add_instance_attribute('rarPayload', 'ns3::BuildRarListElement_s', is_const=False)
    return

def register_Ns3MmwaveMmWaveRealProtocolRlcSapUser_methods(root_module, cls):
    ## mmwave-lte-rrc-protocol-real.h (module 'mmwave'): ns3::mmwave::MmWaveRealProtocolRlcSapUser::MmWaveRealProtocolRlcSapUser(ns3::mmwave::MmWaveRealProtocolRlcSapUser const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveRealProtocolRlcSapUser const &', 'arg0')])
    ## mmwave-lte-rrc-protocol-real.h (module 'mmwave'): ns3::mmwave::MmWaveRealProtocolRlcSapUser::MmWaveRealProtocolRlcSapUser(ns3::mmwave::MmWaveLteEnbRrcProtocolReal * pdcp, uint16_t rnti) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveLteEnbRrcProtocolReal *', 'pdcp'), param('uint16_t', 'rnti')])
    ## mmwave-lte-rrc-protocol-real.h (module 'mmwave'): void ns3::mmwave::MmWaveRealProtocolRlcSapUser::ReceivePdcpPdu(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('ReceivePdcpPdu',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'p')],
                   is_virtual=True)
    return

def register_Ns3MmwaveMmWaveRrComponentCarrierManager_methods(root_module, cls):
    ## mmwave-no-op-component-carrier-manager.h (module 'mmwave'): ns3::mmwave::MmWaveRrComponentCarrierManager::MmWaveRrComponentCarrierManager(ns3::mmwave::MmWaveRrComponentCarrierManager const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveRrComponentCarrierManager const &', 'arg0')])
    ## mmwave-no-op-component-carrier-manager.h (module 'mmwave'): ns3::mmwave::MmWaveRrComponentCarrierManager::MmWaveRrComponentCarrierManager() [constructor]
    cls.add_constructor([])
    ## mmwave-no-op-component-carrier-manager.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWaveRrComponentCarrierManager::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-no-op-component-carrier-manager.h (module 'mmwave'): void ns3::mmwave::MmWaveRrComponentCarrierManager::DoReportBufferStatus(ns3::LteMacSapProvider::ReportBufferStatusParameters params) [member function]
    cls.add_method('DoReportBufferStatus',
                   'void',
                   [param('ns3::LteMacSapProvider::ReportBufferStatusParameters', 'params')],
                   visibility='protected', is_virtual=True)
    ## mmwave-no-op-component-carrier-manager.h (module 'mmwave'): void ns3::mmwave::MmWaveRrComponentCarrierManager::DoUlReceiveMacCe(ns3::MacCeListElement_s bsr, uint8_t componentCarrierId) [member function]
    cls.add_method('DoUlReceiveMacCe',
                   'void',
                   [param('ns3::MacCeListElement_s', 'bsr'), param('uint8_t', 'componentCarrierId')],
                   visibility='protected', is_virtual=True)
    return

def register_Ns3MmwaveMmWaveSib1Message_methods(root_module, cls):
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::MmWaveSib1Message::MmWaveSib1Message(ns3::mmwave::MmWaveSib1Message const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveSib1Message const &', 'arg0')])
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::MmWaveSib1Message::MmWaveSib1Message() [constructor]
    cls.add_constructor([])
    ## mmwave-control-messages.h (module 'mmwave'): ns3::LteRrcSap::SystemInformationBlockType1 ns3::mmwave::MmWaveSib1Message::GetSib1() const [member function]
    cls.add_method('GetSib1',
                   'ns3::LteRrcSap::SystemInformationBlockType1',
                   [],
                   is_const=True)
    ## mmwave-control-messages.h (module 'mmwave'): void ns3::mmwave::MmWaveSib1Message::SetSib1(ns3::LteRrcSap::SystemInformationBlockType1 sib1) [member function]
    cls.add_method('SetSib1',
                   'void',
                   [param('ns3::LteRrcSap::SystemInformationBlockType1', 'sib1')])
    return

def register_Ns3MmwaveMmWaveSpectrumPhy_methods(root_module, cls):
    ## mmwave-spectrum-phy.h (module 'mmwave'): ns3::mmwave::MmWaveSpectrumPhy::MmWaveSpectrumPhy() [constructor]
    cls.add_constructor([])
    ## mmwave-spectrum-phy.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWaveSpectrumPhy::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-spectrum-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveSpectrumPhy::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## mmwave-spectrum-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveSpectrumPhy::Reset() [member function]
    cls.add_method('Reset',
                   'void',
                   [])
    ## mmwave-spectrum-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveSpectrumPhy::ResetSpectrumModel() [member function]
    cls.add_method('ResetSpectrumModel',
                   'void',
                   [])
    ## mmwave-spectrum-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveSpectrumPhy::SetDevice(ns3::Ptr<ns3::NetDevice> d) [member function]
    cls.add_method('SetDevice',
                   'void',
                   [param('ns3::Ptr< ns3::NetDevice >', 'd')],
                   is_virtual=True)
    ## mmwave-spectrum-phy.h (module 'mmwave'): ns3::Ptr<ns3::NetDevice> ns3::mmwave::MmWaveSpectrumPhy::GetDevice() const [member function]
    cls.add_method('GetDevice',
                   'ns3::Ptr< ns3::NetDevice >',
                   [],
                   is_const=True, is_virtual=True)
    ## mmwave-spectrum-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveSpectrumPhy::SetMobility(ns3::Ptr<ns3::MobilityModel> m) [member function]
    cls.add_method('SetMobility',
                   'void',
                   [param('ns3::Ptr< ns3::MobilityModel >', 'm')],
                   is_virtual=True)
    ## mmwave-spectrum-phy.h (module 'mmwave'): ns3::Ptr<ns3::MobilityModel> ns3::mmwave::MmWaveSpectrumPhy::GetMobility() [member function]
    cls.add_method('GetMobility',
                   'ns3::Ptr< ns3::MobilityModel >',
                   [],
                   is_virtual=True)
    ## mmwave-spectrum-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveSpectrumPhy::SetChannel(ns3::Ptr<ns3::SpectrumChannel> c) [member function]
    cls.add_method('SetChannel',
                   'void',
                   [param('ns3::Ptr< ns3::SpectrumChannel >', 'c')],
                   is_virtual=True)
    ## mmwave-spectrum-phy.h (module 'mmwave'): ns3::Ptr<const ns3::SpectrumModel> ns3::mmwave::MmWaveSpectrumPhy::GetRxSpectrumModel() const [member function]
    cls.add_method('GetRxSpectrumModel',
                   'ns3::Ptr< ns3::SpectrumModel const >',
                   [],
                   is_const=True, is_virtual=True)
    ## mmwave-spectrum-phy.h (module 'mmwave'): ns3::Ptr<ns3::AntennaModel> ns3::mmwave::MmWaveSpectrumPhy::GetRxAntenna() [member function]
    cls.add_method('GetRxAntenna',
                   'ns3::Ptr< ns3::AntennaModel >',
                   [],
                   is_virtual=True)
    ## mmwave-spectrum-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveSpectrumPhy::SetAntenna(ns3::Ptr<ns3::AntennaModel> a) [member function]
    cls.add_method('SetAntenna',
                   'void',
                   [param('ns3::Ptr< ns3::AntennaModel >', 'a')])
    ## mmwave-spectrum-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveSpectrumPhy::SetState(ns3::mmwave::MmWaveSpectrumPhy::State newState) [member function]
    cls.add_method('SetState',
                   'void',
                   [param('ns3::mmwave::MmWaveSpectrumPhy::State', 'newState')])
    ## mmwave-spectrum-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveSpectrumPhy::SetNoisePowerSpectralDensity(ns3::Ptr<const ns3::SpectrumValue> noisePsd) [member function]
    cls.add_method('SetNoisePowerSpectralDensity',
                   'void',
                   [param('ns3::Ptr< ns3::SpectrumValue const >', 'noisePsd')])
    ## mmwave-spectrum-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveSpectrumPhy::SetTxPowerSpectralDensity(ns3::Ptr<ns3::SpectrumValue> TxPsd) [member function]
    cls.add_method('SetTxPowerSpectralDensity',
                   'void',
                   [param('ns3::Ptr< ns3::SpectrumValue >', 'TxPsd')])
    ## mmwave-spectrum-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveSpectrumPhy::StartRx(ns3::Ptr<ns3::SpectrumSignalParameters> params) [member function]
    cls.add_method('StartRx',
                   'void',
                   [param('ns3::Ptr< ns3::SpectrumSignalParameters >', 'params')],
                   is_virtual=True)
    ## mmwave-spectrum-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveSpectrumPhy::StartRxData(ns3::Ptr<ns3::mmwave::MmwaveSpectrumSignalParametersDataFrame> params) [member function]
    cls.add_method('StartRxData',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmwaveSpectrumSignalParametersDataFrame >', 'params')])
    ## mmwave-spectrum-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveSpectrumPhy::StartRxCtrl(ns3::Ptr<ns3::SpectrumSignalParameters> params) [member function]
    cls.add_method('StartRxCtrl',
                   'void',
                   [param('ns3::Ptr< ns3::SpectrumSignalParameters >', 'params')])
    ## mmwave-spectrum-phy.h (module 'mmwave'): ns3::Ptr<ns3::SpectrumChannel> ns3::mmwave::MmWaveSpectrumPhy::GetSpectrumChannel() [member function]
    cls.add_method('GetSpectrumChannel',
                   'ns3::Ptr< ns3::SpectrumChannel >',
                   [])
    ## mmwave-spectrum-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveSpectrumPhy::SetCellId(uint16_t cellId) [member function]
    cls.add_method('SetCellId',
                   'void',
                   [param('uint16_t', 'cellId')])
    ## mmwave-spectrum-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveSpectrumPhy::SetComponentCarrierId(uint8_t componentCarrierId) [member function]
    cls.add_method('SetComponentCarrierId',
                   'void',
                   [param('uint8_t', 'componentCarrierId')])
    ## mmwave-spectrum-phy.h (module 'mmwave'): bool ns3::mmwave::MmWaveSpectrumPhy::StartTxDataFrames(ns3::Ptr<ns3::PacketBurst> pb, std::list<ns3::Ptr<ns3::mmwave::MmWaveControlMessage>, std::allocator<ns3::Ptr<ns3::mmwave::MmWaveControlMessage> > > ctrlMsgList, ns3::Time duration, uint8_t slotInd) [member function]
    cls.add_method('StartTxDataFrames',
                   'bool',
                   [param('ns3::Ptr< ns3::PacketBurst >', 'pb'), param('std::list< ns3::Ptr< ns3::mmwave::MmWaveControlMessage > >', 'ctrlMsgList'), param('ns3::Time', 'duration'), param('uint8_t', 'slotInd')])
    ## mmwave-spectrum-phy.h (module 'mmwave'): bool ns3::mmwave::MmWaveSpectrumPhy::StartTxDlControlFrames(std::list<ns3::Ptr<ns3::mmwave::MmWaveControlMessage>, std::allocator<ns3::Ptr<ns3::mmwave::MmWaveControlMessage> > > ctrlMsgList, ns3::Time duration) [member function]
    cls.add_method('StartTxDlControlFrames',
                   'bool',
                   [param('std::list< ns3::Ptr< ns3::mmwave::MmWaveControlMessage > >', 'ctrlMsgList'), param('ns3::Time', 'duration')])
    ## mmwave-spectrum-phy.h (module 'mmwave'): bool ns3::mmwave::MmWaveSpectrumPhy::StartTxUlControlFrames() [member function]
    cls.add_method('StartTxUlControlFrames',
                   'bool',
                   [])
    ## mmwave-spectrum-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveSpectrumPhy::SetPhyRxDataEndOkCallback(ns3::mmwave::MmWavePhyRxDataEndOkCallback c) [member function]
    cls.add_method('SetPhyRxDataEndOkCallback',
                   'void',
                   [param('ns3::Callback< void, ns3::Ptr< ns3::Packet >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'c')])
    ## mmwave-spectrum-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveSpectrumPhy::SetPhyRxCtrlEndOkCallback(ns3::mmwave::MmWavePhyRxCtrlEndOkCallback c) [member function]
    cls.add_method('SetPhyRxCtrlEndOkCallback',
                   'void',
                   [param('ns3::Callback< void, std::list< ns3::Ptr< ns3::mmwave::MmWaveControlMessage > >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'c')])
    ## mmwave-spectrum-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveSpectrumPhy::SetPhyDlHarqFeedbackCallback(ns3::mmwave::MmWavePhyDlHarqFeedbackCallback c) [member function]
    cls.add_method('SetPhyDlHarqFeedbackCallback',
                   'void',
                   [param('ns3::Callback< void, ns3::mmwave::DlHarqInfo, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'c')])
    ## mmwave-spectrum-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveSpectrumPhy::SetPhyUlHarqFeedbackCallback(ns3::mmwave::MmWavePhyUlHarqFeedbackCallback c) [member function]
    cls.add_method('SetPhyUlHarqFeedbackCallback',
                   'void',
                   [param('ns3::Callback< void, ns3::mmwave::UlHarqInfo, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'c')])
    ## mmwave-spectrum-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveSpectrumPhy::AddDataPowerChunkProcessor(ns3::Ptr<ns3::mmwave::mmWaveChunkProcessor> p) [member function]
    cls.add_method('AddDataPowerChunkProcessor',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::mmWaveChunkProcessor >', 'p')])
    ## mmwave-spectrum-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveSpectrumPhy::AddDataSinrChunkProcessor(ns3::Ptr<ns3::mmwave::mmWaveChunkProcessor> p) [member function]
    cls.add_method('AddDataSinrChunkProcessor',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::mmWaveChunkProcessor >', 'p')])
    ## mmwave-spectrum-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveSpectrumPhy::UpdateSinrPerceived(ns3::SpectrumValue const & sinr) [member function]
    cls.add_method('UpdateSinrPerceived',
                   'void',
                   [param('ns3::SpectrumValue const &', 'sinr')])
    ## mmwave-spectrum-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveSpectrumPhy::AddExpectedTb(uint16_t rnti, uint8_t ndi, uint16_t size, uint8_t mcs, std::vector<int, std::allocator<int> > map, uint8_t harqId, uint8_t rv, bool downlink, uint8_t symStart, uint8_t numSym) [member function]
    cls.add_method('AddExpectedTb',
                   'void',
                   [param('uint16_t', 'rnti'), param('uint8_t', 'ndi'), param('uint16_t', 'size'), param('uint8_t', 'mcs'), param('std::vector< int >', 'map'), param('uint8_t', 'harqId'), param('uint8_t', 'rv'), param('bool', 'downlink'), param('uint8_t', 'symStart'), param('uint8_t', 'numSym')])
    ## mmwave-spectrum-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveSpectrumPhy::SetHarqPhyModule(ns3::Ptr<ns3::mmwave::MmWaveHarqPhy> harq) [member function]
    cls.add_method('SetHarqPhyModule',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWaveHarqPhy >', 'harq')])
    return

def register_Ns3MmwaveMmWaveSpectrumSignalParametersDlCtrlFrame_methods(root_module, cls):
    ## mmwave-spectrum-signal-parameters.h (module 'mmwave'): ns3::mmwave::MmWaveSpectrumSignalParametersDlCtrlFrame::MmWaveSpectrumSignalParametersDlCtrlFrame() [constructor]
    cls.add_constructor([])
    ## mmwave-spectrum-signal-parameters.h (module 'mmwave'): ns3::mmwave::MmWaveSpectrumSignalParametersDlCtrlFrame::MmWaveSpectrumSignalParametersDlCtrlFrame(ns3::mmwave::MmWaveSpectrumSignalParametersDlCtrlFrame const & p) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveSpectrumSignalParametersDlCtrlFrame const &', 'p')])
    ## mmwave-spectrum-signal-parameters.h (module 'mmwave'): ns3::Ptr<ns3::SpectrumSignalParameters> ns3::mmwave::MmWaveSpectrumSignalParametersDlCtrlFrame::Copy() [member function]
    cls.add_method('Copy',
                   'ns3::Ptr< ns3::SpectrumSignalParameters >',
                   [],
                   is_virtual=True)
    ## mmwave-spectrum-signal-parameters.h (module 'mmwave'): ns3::mmwave::MmWaveSpectrumSignalParametersDlCtrlFrame::cellId [variable]
    cls.add_instance_attribute('cellId', 'uint16_t', is_const=False)
    ## mmwave-spectrum-signal-parameters.h (module 'mmwave'): ns3::mmwave::MmWaveSpectrumSignalParametersDlCtrlFrame::ctrlMsgList [variable]
    cls.add_instance_attribute('ctrlMsgList', 'std::list< ns3::Ptr< ns3::mmwave::MmWaveControlMessage > >', is_const=False)
    ## mmwave-spectrum-signal-parameters.h (module 'mmwave'): ns3::mmwave::MmWaveSpectrumSignalParametersDlCtrlFrame::pss [variable]
    cls.add_instance_attribute('pss', 'bool', is_const=False)
    return

def register_Ns3MmwaveMmWaveSpectrumValueHelper_methods(root_module, cls):
    ## mmwave-spectrum-value-helper.h (module 'mmwave'): ns3::mmwave::MmWaveSpectrumValueHelper::MmWaveSpectrumValueHelper() [constructor]
    cls.add_constructor([])
    ## mmwave-spectrum-value-helper.h (module 'mmwave'): ns3::mmwave::MmWaveSpectrumValueHelper::MmWaveSpectrumValueHelper(ns3::mmwave::MmWaveSpectrumValueHelper const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveSpectrumValueHelper const &', 'arg0')])
    ## mmwave-spectrum-value-helper.h (module 'mmwave'): static ns3::Ptr<ns3::SpectrumValue> ns3::mmwave::MmWaveSpectrumValueHelper::CreateNoisePowerSpectralDensity(ns3::Ptr<ns3::mmwave::MmWavePhyMacCommon> ptrConfig, double noiseFigure) [member function]
    cls.add_method('CreateNoisePowerSpectralDensity',
                   'ns3::Ptr< ns3::SpectrumValue >',
                   [param('ns3::Ptr< ns3::mmwave::MmWavePhyMacCommon >', 'ptrConfig'), param('double', 'noiseFigure')],
                   is_static=True)
    ## mmwave-spectrum-value-helper.h (module 'mmwave'): static ns3::Ptr<ns3::SpectrumValue> ns3::mmwave::MmWaveSpectrumValueHelper::CreateNoisePowerSpectralDensity(double noiseFigure, ns3::Ptr<ns3::SpectrumModel> spectrumModel) [member function]
    cls.add_method('CreateNoisePowerSpectralDensity',
                   'ns3::Ptr< ns3::SpectrumValue >',
                   [param('double', 'noiseFigure'), param('ns3::Ptr< ns3::SpectrumModel >', 'spectrumModel')],
                   is_static=True)
    ## mmwave-spectrum-value-helper.h (module 'mmwave'): static ns3::Ptr<ns3::SpectrumValue> ns3::mmwave::MmWaveSpectrumValueHelper::CreateTxPowerSpectralDensity(ns3::Ptr<ns3::mmwave::MmWavePhyMacCommon> ptrConfig, double powerTx, std::vector<int, std::allocator<int> > activeRbs) [member function]
    cls.add_method('CreateTxPowerSpectralDensity',
                   'ns3::Ptr< ns3::SpectrumValue >',
                   [param('ns3::Ptr< ns3::mmwave::MmWavePhyMacCommon >', 'ptrConfig'), param('double', 'powerTx'), param('std::vector< int >', 'activeRbs')],
                   is_static=True)
    ## mmwave-spectrum-value-helper.h (module 'mmwave'): static ns3::Ptr<ns3::SpectrumValue> ns3::mmwave::MmWaveSpectrumValueHelper::CreateTxPowerSpectralDensity(ns3::Ptr<ns3::mmwave::MmWavePhyMacCommon> ptrConfig, double powerTx, std::map<int, double, std::less<int>, std::allocator<std::pair<const int, double> > > powerTxMap, std::vector<int, std::allocator<int> > activeRbs) [member function]
    cls.add_method('CreateTxPowerSpectralDensity',
                   'ns3::Ptr< ns3::SpectrumValue >',
                   [param('ns3::Ptr< ns3::mmwave::MmWavePhyMacCommon >', 'ptrConfig'), param('double', 'powerTx'), param('std::map< int, double >', 'powerTxMap'), param('std::vector< int >', 'activeRbs')],
                   is_static=True)
    ## mmwave-spectrum-value-helper.h (module 'mmwave'): static ns3::Ptr<ns3::SpectrumModel> ns3::mmwave::MmWaveSpectrumValueHelper::GetSpectrumModel(ns3::Ptr<ns3::mmwave::MmWavePhyMacCommon> ptrConfig) [member function]
    cls.add_method('GetSpectrumModel',
                   'ns3::Ptr< ns3::SpectrumModel >',
                   [param('ns3::Ptr< ns3::mmwave::MmWavePhyMacCommon >', 'ptrConfig')],
                   is_static=True)
    return

def register_Ns3MmwaveMmWaveTbStats_t_methods(root_module, cls):
    ## mmwave-mi-error-model.h (module 'mmwave'): ns3::mmwave::MmWaveTbStats_t::MmWaveTbStats_t() [constructor]
    cls.add_constructor([])
    ## mmwave-mi-error-model.h (module 'mmwave'): ns3::mmwave::MmWaveTbStats_t::MmWaveTbStats_t(ns3::mmwave::MmWaveTbStats_t const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveTbStats_t const &', 'arg0')])
    ## mmwave-mi-error-model.h (module 'mmwave'): ns3::mmwave::MmWaveTbStats_t::mi [variable]
    cls.add_instance_attribute('mi', 'double', is_const=False)
    ## mmwave-mi-error-model.h (module 'mmwave'): ns3::mmwave::MmWaveTbStats_t::miTotal [variable]
    cls.add_instance_attribute('miTotal', 'double', is_const=False)
    ## mmwave-mi-error-model.h (module 'mmwave'): ns3::mmwave::MmWaveTbStats_t::tbler [variable]
    cls.add_instance_attribute('tbler', 'double', is_const=False)
    return

def register_Ns3MmwaveMmWaveTdmaDciMessage_methods(root_module, cls):
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::MmWaveTdmaDciMessage::MmWaveTdmaDciMessage(ns3::mmwave::MmWaveTdmaDciMessage const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveTdmaDciMessage const &', 'arg0')])
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::MmWaveTdmaDciMessage::MmWaveTdmaDciMessage() [constructor]
    cls.add_constructor([])
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::DciInfoElementTdma ns3::mmwave::MmWaveTdmaDciMessage::GetDciInfoElement() [member function]
    cls.add_method('GetDciInfoElement',
                   'ns3::mmwave::DciInfoElementTdma',
                   [])
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::SfnSf ns3::mmwave::MmWaveTdmaDciMessage::GetSfnSf() [member function]
    cls.add_method('GetSfnSf',
                   'ns3::mmwave::SfnSf',
                   [])
    ## mmwave-control-messages.h (module 'mmwave'): void ns3::mmwave::MmWaveTdmaDciMessage::SetDciInfoElement(ns3::mmwave::DciInfoElementTdma dci) [member function]
    cls.add_method('SetDciInfoElement',
                   'void',
                   [param('ns3::mmwave::DciInfoElementTdma', 'dci')])
    ## mmwave-control-messages.h (module 'mmwave'): void ns3::mmwave::MmWaveTdmaDciMessage::SetSfnSf(ns3::mmwave::SfnSf sfn) [member function]
    cls.add_method('SetSfnSf',
                   'void',
                   [param('ns3::mmwave::SfnSf', 'sfn')])
    return

def register_Ns3MmwaveMmWaveUeMac_methods(root_module, cls):
    ## mmwave-ue-mac.h (module 'mmwave'): ns3::mmwave::MmWaveUeMac::MmWaveUeMac(ns3::mmwave::MmWaveUeMac const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveUeMac const &', 'arg0')])
    ## mmwave-ue-mac.h (module 'mmwave'): ns3::mmwave::MmWaveUeMac::MmWaveUeMac() [constructor]
    cls.add_constructor([])
    ## mmwave-ue-mac.h (module 'mmwave'): int64_t ns3::mmwave::MmWaveUeMac::AssignStreams(int64_t stream) [member function]
    cls.add_method('AssignStreams',
                   'int64_t',
                   [param('int64_t', 'stream')])
    ## mmwave-ue-mac.h (module 'mmwave'): void ns3::mmwave::MmWaveUeMac::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## mmwave-ue-mac.h (module 'mmwave'): void ns3::mmwave::MmWaveUeMac::DoSubframeIndication(ns3::mmwave::SfnSf sfn) [member function]
    cls.add_method('DoSubframeIndication',
                   'void',
                   [param('ns3::mmwave::SfnSf', 'sfn')])
    ## mmwave-ue-mac.h (module 'mmwave'): ns3::Ptr<ns3::mmwave::MmWavePhyMacCommon> ns3::mmwave::MmWaveUeMac::GetConfigurationParameters() const [member function]
    cls.add_method('GetConfigurationParameters',
                   'ns3::Ptr< ns3::mmwave::MmWavePhyMacCommon >',
                   [],
                   is_const=True)
    ## mmwave-ue-mac.h (module 'mmwave'): ns3::mmwave::MmWaveUePhySapUser * ns3::mmwave::MmWaveUeMac::GetPhySapUser() [member function]
    cls.add_method('GetPhySapUser',
                   'ns3::mmwave::MmWaveUePhySapUser *',
                   [])
    ## mmwave-ue-mac.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWaveUeMac::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-ue-mac.h (module 'mmwave'): ns3::LteUeCmacSapProvider * ns3::mmwave::MmWaveUeMac::GetUeCmacSapProvider() [member function]
    cls.add_method('GetUeCmacSapProvider',
                   'ns3::LteUeCmacSapProvider *',
                   [])
    ## mmwave-ue-mac.h (module 'mmwave'): ns3::LteMacSapProvider * ns3::mmwave::MmWaveUeMac::GetUeMacSapProvider() [member function]
    cls.add_method('GetUeMacSapProvider',
                   'ns3::LteMacSapProvider *',
                   [])
    ## mmwave-ue-mac.h (module 'mmwave'): void ns3::mmwave::MmWaveUeMac::RecvRaResponse(ns3::BuildRarListElement_s raResponse) [member function]
    cls.add_method('RecvRaResponse',
                   'void',
                   [param('ns3::BuildRarListElement_s', 'raResponse')])
    ## mmwave-ue-mac.h (module 'mmwave'): void ns3::mmwave::MmWaveUeMac::SetComponentCarrierId(uint8_t index) [member function]
    cls.add_method('SetComponentCarrierId',
                   'void',
                   [param('uint8_t', 'index')])
    ## mmwave-ue-mac.h (module 'mmwave'): void ns3::mmwave::MmWaveUeMac::SetConfigurationParameters(ns3::Ptr<ns3::mmwave::MmWavePhyMacCommon> ptrConfig) [member function]
    cls.add_method('SetConfigurationParameters',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWavePhyMacCommon >', 'ptrConfig')])
    ## mmwave-ue-mac.h (module 'mmwave'): void ns3::mmwave::MmWaveUeMac::SetPhySapProvider(ns3::mmwave::MmWavePhySapProvider * ptr) [member function]
    cls.add_method('SetPhySapProvider',
                   'void',
                   [param('ns3::mmwave::MmWavePhySapProvider *', 'ptr')])
    ## mmwave-ue-mac.h (module 'mmwave'): void ns3::mmwave::MmWaveUeMac::SetUeCmacSapUser(ns3::LteUeCmacSapUser * s) [member function]
    cls.add_method('SetUeCmacSapUser',
                   'void',
                   [param('ns3::LteUeCmacSapUser *', 's')])
    return

def register_Ns3MmwaveMmWaveUeNetDevice_methods(root_module, cls):
    ## mmwave-ue-net-device.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWaveUeNetDevice::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-ue-net-device.h (module 'mmwave'): ns3::mmwave::MmWaveUeNetDevice::MmWaveUeNetDevice() [constructor]
    cls.add_constructor([])
    ## mmwave-ue-net-device.h (module 'mmwave'): void ns3::mmwave::MmWaveUeNetDevice::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## mmwave-ue-net-device.h (module 'mmwave'): uint32_t ns3::mmwave::MmWaveUeNetDevice::GetCsgId() const [member function]
    cls.add_method('GetCsgId',
                   'uint32_t',
                   [],
                   is_const=True)
    ## mmwave-ue-net-device.h (module 'mmwave'): void ns3::mmwave::MmWaveUeNetDevice::SetCsgId(uint32_t csgId) [member function]
    cls.add_method('SetCsgId',
                   'void',
                   [param('uint32_t', 'csgId')])
    ## mmwave-ue-net-device.h (module 'mmwave'): void ns3::mmwave::MmWaveUeNetDevice::UpdateConfig() [member function]
    cls.add_method('UpdateConfig',
                   'void',
                   [])
    ## mmwave-ue-net-device.h (module 'mmwave'): bool ns3::mmwave::MmWaveUeNetDevice::DoSend(ns3::Ptr<ns3::Packet> packet, ns3::Address const & dest, uint16_t protocolNumber) [member function]
    cls.add_method('DoSend',
                   'bool',
                   [param('ns3::Ptr< ns3::Packet >', 'packet'), param('ns3::Address const &', 'dest'), param('uint16_t', 'protocolNumber')],
                   is_virtual=True)
    ## mmwave-ue-net-device.h (module 'mmwave'): ns3::Ptr<ns3::mmwave::MmWaveUePhy> ns3::mmwave::MmWaveUeNetDevice::GetPhy() const [member function]
    cls.add_method('GetPhy',
                   'ns3::Ptr< ns3::mmwave::MmWaveUePhy >',
                   [],
                   is_const=True)
    ## mmwave-ue-net-device.h (module 'mmwave'): ns3::Ptr<ns3::mmwave::MmWaveUePhy> ns3::mmwave::MmWaveUeNetDevice::GetPhy(uint8_t index) const [member function]
    cls.add_method('GetPhy',
                   'ns3::Ptr< ns3::mmwave::MmWaveUePhy >',
                   [param('uint8_t', 'index')],
                   is_const=True)
    ## mmwave-ue-net-device.h (module 'mmwave'): ns3::Ptr<ns3::mmwave::MmWaveUeMac> ns3::mmwave::MmWaveUeNetDevice::GetMac() const [member function]
    cls.add_method('GetMac',
                   'ns3::Ptr< ns3::mmwave::MmWaveUeMac >',
                   [],
                   is_const=True)
    ## mmwave-ue-net-device.h (module 'mmwave'): uint64_t ns3::mmwave::MmWaveUeNetDevice::GetImsi() const [member function]
    cls.add_method('GetImsi',
                   'uint64_t',
                   [],
                   is_const=True)
    ## mmwave-ue-net-device.h (module 'mmwave'): uint16_t ns3::mmwave::MmWaveUeNetDevice::GetEarfcn() const [member function]
    cls.add_method('GetEarfcn',
                   'uint16_t',
                   [],
                   is_const=True)
    ## mmwave-ue-net-device.h (module 'mmwave'): ns3::Ptr<ns3::EpcUeNas> ns3::mmwave::MmWaveUeNetDevice::GetNas() const [member function]
    cls.add_method('GetNas',
                   'ns3::Ptr< ns3::EpcUeNas >',
                   [],
                   is_const=True)
    ## mmwave-ue-net-device.h (module 'mmwave'): ns3::Ptr<ns3::LteUeComponentCarrierManager> ns3::mmwave::MmWaveUeNetDevice::GetComponentCarrierManager() const [member function]
    cls.add_method('GetComponentCarrierManager',
                   'ns3::Ptr< ns3::LteUeComponentCarrierManager >',
                   [],
                   is_const=True)
    ## mmwave-ue-net-device.h (module 'mmwave'): ns3::Ptr<ns3::LteUeRrc> ns3::mmwave::MmWaveUeNetDevice::GetRrc() const [member function]
    cls.add_method('GetRrc',
                   'ns3::Ptr< ns3::LteUeRrc >',
                   [],
                   is_const=True)
    ## mmwave-ue-net-device.h (module 'mmwave'): void ns3::mmwave::MmWaveUeNetDevice::SetEarfcn(uint16_t earfcn) [member function]
    cls.add_method('SetEarfcn',
                   'void',
                   [param('uint16_t', 'earfcn')])
    ## mmwave-ue-net-device.h (module 'mmwave'): void ns3::mmwave::MmWaveUeNetDevice::SetTargetEnb(ns3::Ptr<ns3::mmwave::MmWaveEnbNetDevice> enb) [member function]
    cls.add_method('SetTargetEnb',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWaveEnbNetDevice >', 'enb')])
    ## mmwave-ue-net-device.h (module 'mmwave'): ns3::Ptr<ns3::mmwave::MmWaveEnbNetDevice> ns3::mmwave::MmWaveUeNetDevice::GetTargetEnb() [member function]
    cls.add_method('GetTargetEnb',
                   'ns3::Ptr< ns3::mmwave::MmWaveEnbNetDevice >',
                   [])
    ## mmwave-ue-net-device.h (module 'mmwave'): void ns3::mmwave::MmWaveUeNetDevice::SetAntennaNum(uint8_t antennaNum) [member function]
    cls.add_method('SetAntennaNum',
                   'void',
                   [param('uint8_t', 'antennaNum')])
    ## mmwave-ue-net-device.h (module 'mmwave'): uint8_t ns3::mmwave::MmWaveUeNetDevice::GetAntennaNum() const [member function]
    cls.add_method('GetAntennaNum',
                   'uint8_t',
                   [],
                   is_const=True)
    ## mmwave-ue-net-device.h (module 'mmwave'): std::map<unsigned char, ns3::Ptr<ns3::mmwave::MmWaveComponentCarrierUe>, std::less<unsigned char>, std::allocator<std::pair<const unsigned char, ns3::Ptr<ns3::mmwave::MmWaveComponentCarrierUe> > > > ns3::mmwave::MmWaveUeNetDevice::GetCcMap() [member function]
    cls.add_method('GetCcMap',
                   'std::map< unsigned char, ns3::Ptr< ns3::mmwave::MmWaveComponentCarrierUe > >',
                   [])
    ## mmwave-ue-net-device.h (module 'mmwave'): void ns3::mmwave::MmWaveUeNetDevice::SetCcMap(std::map<unsigned char, ns3::Ptr<ns3::mmwave::MmWaveComponentCarrierUe>, std::less<unsigned char>, std::allocator<std::pair<const unsigned char, ns3::Ptr<ns3::mmwave::MmWaveComponentCarrierUe> > > > ccm) [member function]
    cls.add_method('SetCcMap',
                   'void',
                   [param('std::map< unsigned char, ns3::Ptr< ns3::mmwave::MmWaveComponentCarrierUe > >', 'ccm')])
    ## mmwave-ue-net-device.h (module 'mmwave'): void ns3::mmwave::MmWaveUeNetDevice::DoInitialize() [member function]
    cls.add_method('DoInitialize',
                   'void',
                   [],
                   visibility='protected', is_virtual=True)
    return

def register_Ns3MmwaveMmWaveUePhy_methods(root_module, cls):
    ## mmwave-ue-phy.h (module 'mmwave'): ns3::mmwave::MmWaveUePhy::MmWaveUePhy(ns3::mmwave::MmWaveUePhy const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveUePhy const &', 'arg0')])
    ## mmwave-ue-phy.h (module 'mmwave'): ns3::mmwave::MmWaveUePhy::MmWaveUePhy() [constructor]
    cls.add_constructor([])
    ## mmwave-ue-phy.h (module 'mmwave'): ns3::mmwave::MmWaveUePhy::MmWaveUePhy(ns3::Ptr<ns3::mmwave::MmWaveSpectrumPhy> ulPhy, ns3::Ptr<ns3::mmwave::MmWaveSpectrumPhy> dlPhy) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::mmwave::MmWaveSpectrumPhy >', 'ulPhy'), param('ns3::Ptr< ns3::mmwave::MmWaveSpectrumPhy >', 'dlPhy')])
    ## mmwave-ue-phy.h (module 'mmwave'): ns3::Ptr<ns3::mmwave::MmWaveDlCqiMessage> ns3::mmwave::MmWaveUePhy::CreateDlCqiFeedbackMessage(ns3::SpectrumValue const & sinr) [member function]
    cls.add_method('CreateDlCqiFeedbackMessage',
                   'ns3::Ptr< ns3::mmwave::MmWaveDlCqiMessage >',
                   [param('ns3::SpectrumValue const &', 'sinr')])
    ## mmwave-ue-phy.h (module 'mmwave'): ns3::Ptr<ns3::SpectrumValue> ns3::mmwave::MmWaveUePhy::CreateTxPowerSpectralDensity() [member function]
    cls.add_method('CreateTxPowerSpectralDensity',
                   'ns3::Ptr< ns3::SpectrumValue >',
                   [],
                   is_virtual=True)
    ## mmwave-ue-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveUePhy::DelayPhyDataPacketReceived(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('DelayPhyDataPacketReceived',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'p')])
    ## mmwave-ue-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveUePhy::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## mmwave-ue-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveUePhy::DoInitialize() [member function]
    cls.add_method('DoInitialize',
                   'void',
                   [],
                   is_virtual=True)
    ## mmwave-ue-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveUePhy::DoSendControlMessage(ns3::Ptr<ns3::mmwave::MmWaveControlMessage> msg) [member function]
    cls.add_method('DoSendControlMessage',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWaveControlMessage >', 'msg')])
    ## mmwave-ue-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveUePhy::DoSetSubChannels() [member function]
    cls.add_method('DoSetSubChannels',
                   'void',
                   [])
    ## mmwave-ue-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveUePhy::EndSlot() [member function]
    cls.add_method('EndSlot',
                   'void',
                   [])
    ## mmwave-ue-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveUePhy::GenerateDlCqiReport(ns3::SpectrumValue const & sinr) [member function]
    cls.add_method('GenerateDlCqiReport',
                   'void',
                   [param('ns3::SpectrumValue const &', 'sinr')])
    ## mmwave-ue-phy.h (module 'mmwave'): uint32_t ns3::mmwave::MmWaveUePhy::GetAbsoluteSubframeNo() [member function]
    cls.add_method('GetAbsoluteSubframeNo',
                   'uint32_t',
                   [])
    ## mmwave-ue-phy.h (module 'mmwave'): ns3::Ptr<ns3::mmwave::MmWaveSpectrumPhy> ns3::mmwave::MmWaveUePhy::GetDlSpectrumPhy() const [member function]
    cls.add_method('GetDlSpectrumPhy',
                   'ns3::Ptr< ns3::mmwave::MmWaveSpectrumPhy >',
                   [],
                   is_const=True)
    ## mmwave-ue-phy.h (module 'mmwave'): uint64_t ns3::mmwave::MmWaveUePhy::GetImsi() const [member function]
    cls.add_method('GetImsi',
                   'uint64_t',
                   [],
                   is_const=True)
    ## mmwave-ue-phy.h (module 'mmwave'): double ns3::mmwave::MmWaveUePhy::GetNoiseFigure() const [member function]
    cls.add_method('GetNoiseFigure',
                   'double',
                   [],
                   is_const=True)
    ## mmwave-ue-phy.h (module 'mmwave'): uint16_t ns3::mmwave::MmWaveUePhy::GetRnti() [member function]
    cls.add_method('GetRnti',
                   'uint16_t',
                   [])
    ## mmwave-ue-phy.h (module 'mmwave'): std::vector<int, std::allocator<int> > ns3::mmwave::MmWaveUePhy::GetSubChannelsForReception() [member function]
    cls.add_method('GetSubChannelsForReception',
                   'std::vector< int >',
                   [])
    ## mmwave-ue-phy.h (module 'mmwave'): std::vector<int, std::allocator<int> > ns3::mmwave::MmWaveUePhy::GetSubChannelsForTransmission() [member function]
    cls.add_method('GetSubChannelsForTransmission',
                   'std::vector< int >',
                   [])
    ## mmwave-ue-phy.h (module 'mmwave'): uint32_t ns3::mmwave::MmWaveUePhy::GetSubframeNumber() [member function]
    cls.add_method('GetSubframeNumber',
                   'uint32_t',
                   [])
    ## mmwave-ue-phy.h (module 'mmwave'): double ns3::mmwave::MmWaveUePhy::GetTxPower() const [member function]
    cls.add_method('GetTxPower',
                   'double',
                   [],
                   is_const=True)
    ## mmwave-ue-phy.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWaveUePhy::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-ue-phy.h (module 'mmwave'): ns3::LteUeCphySapProvider * ns3::mmwave::MmWaveUePhy::GetUeCphySapProvider() [member function]
    cls.add_method('GetUeCphySapProvider',
                   'ns3::LteUeCphySapProvider *',
                   [])
    ## mmwave-ue-phy.h (module 'mmwave'): ns3::Ptr<ns3::mmwave::MmWaveSpectrumPhy> ns3::mmwave::MmWaveUePhy::GetUlSpectrumPhy() const [member function]
    cls.add_method('GetUlSpectrumPhy',
                   'ns3::Ptr< ns3::mmwave::MmWaveSpectrumPhy >',
                   [],
                   is_const=True)
    ## mmwave-ue-phy.h (module 'mmwave'): bool ns3::mmwave::MmWaveUePhy::IsReceptionEnabled() [member function]
    cls.add_method('IsReceptionEnabled',
                   'bool',
                   [])
    ## mmwave-ue-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveUePhy::PhyDataPacketReceived(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('PhyDataPacketReceived',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'p')])
    ## mmwave-ue-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveUePhy::ReceiveControlMessageList(std::list<ns3::Ptr<ns3::mmwave::MmWaveControlMessage>, std::allocator<ns3::Ptr<ns3::mmwave::MmWaveControlMessage> > > msgList) [member function]
    cls.add_method('ReceiveControlMessageList',
                   'void',
                   [param('std::list< ns3::Ptr< ns3::mmwave::MmWaveControlMessage > >', 'msgList')])
    ## mmwave-ue-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveUePhy::ReceiveLteDlHarqFeedback(ns3::mmwave::DlHarqInfo m) [member function]
    cls.add_method('ReceiveLteDlHarqFeedback',
                   'void',
                   [param('ns3::mmwave::DlHarqInfo', 'm')])
    ## mmwave-ue-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveUePhy::RegisterOtherEnb(uint16_t cellId, ns3::Ptr<ns3::mmwave::MmWavePhyMacCommon> config, ns3::Ptr<ns3::mmwave::MmWaveEnbNetDevice> enb) [member function]
    cls.add_method('RegisterOtherEnb',
                   'void',
                   [param('uint16_t', 'cellId'), param('ns3::Ptr< ns3::mmwave::MmWavePhyMacCommon >', 'config'), param('ns3::Ptr< ns3::mmwave::MmWaveEnbNetDevice >', 'enb')])
    ## mmwave-ue-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveUePhy::RegisterToEnb(uint16_t cellId, ns3::Ptr<ns3::mmwave::MmWavePhyMacCommon> config) [member function]
    cls.add_method('RegisterToEnb',
                   'void',
                   [param('uint16_t', 'cellId'), param('ns3::Ptr< ns3::mmwave::MmWavePhyMacCommon >', 'config')])
    ## mmwave-ue-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveUePhy::ResetReception() [member function]
    cls.add_method('ResetReception',
                   'void',
                   [])
    ## mmwave-ue-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveUePhy::SendCtrlChannels(std::list<ns3::Ptr<ns3::mmwave::MmWaveControlMessage>, std::allocator<ns3::Ptr<ns3::mmwave::MmWaveControlMessage> > > ctrlMsg, ns3::Time prd) [member function]
    cls.add_method('SendCtrlChannels',
                   'void',
                   [param('std::list< ns3::Ptr< ns3::mmwave::MmWaveControlMessage > >', 'ctrlMsg'), param('ns3::Time', 'prd')])
    ## mmwave-ue-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveUePhy::SendDataChannels(ns3::Ptr<ns3::PacketBurst> pb, std::list<ns3::Ptr<ns3::mmwave::MmWaveControlMessage>, std::allocator<ns3::Ptr<ns3::mmwave::MmWaveControlMessage> > > ctrlMsg, ns3::Time duration, uint8_t slotInd) [member function]
    cls.add_method('SendDataChannels',
                   'void',
                   [param('ns3::Ptr< ns3::PacketBurst >', 'pb'), param('std::list< ns3::Ptr< ns3::mmwave::MmWaveControlMessage > >', 'ctrlMsg'), param('ns3::Time', 'duration'), param('uint8_t', 'slotInd')])
    ## mmwave-ue-phy.h (module 'mmwave'): bool ns3::mmwave::MmWaveUePhy::SendPacket(ns3::Ptr<ns3::Packet> packet) [member function]
    cls.add_method('SendPacket',
                   'bool',
                   [param('ns3::Ptr< ns3::Packet >', 'packet')])
    ## mmwave-ue-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveUePhy::SetHarqPhyModule(ns3::Ptr<ns3::mmwave::MmWaveHarqPhy> harq) [member function]
    cls.add_method('SetHarqPhyModule',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWaveHarqPhy >', 'harq')])
    ## mmwave-ue-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveUePhy::SetImsi(uint64_t imsi) [member function]
    cls.add_method('SetImsi',
                   'void',
                   [param('uint64_t', 'imsi')])
    ## mmwave-ue-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveUePhy::SetNoiseFigure(double pf) [member function]
    cls.add_method('SetNoiseFigure',
                   'void',
                   [param('double', 'pf')])
    ## mmwave-ue-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveUePhy::SetPhySapUser(ns3::mmwave::MmWaveUePhySapUser * ptr) [member function]
    cls.add_method('SetPhySapUser',
                   'void',
                   [param('ns3::mmwave::MmWaveUePhySapUser *', 'ptr')])
    ## mmwave-ue-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveUePhy::SetSubChannelsForReception(std::vector<int, std::allocator<int> > mask) [member function]
    cls.add_method('SetSubChannelsForReception',
                   'void',
                   [param('std::vector< int >', 'mask')])
    ## mmwave-ue-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveUePhy::SetSubChannelsForTransmission(std::vector<int, std::allocator<int> > mask) [member function]
    cls.add_method('SetSubChannelsForTransmission',
                   'void',
                   [param('std::vector< int >', 'mask')])
    ## mmwave-ue-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveUePhy::SetTxPower(double pow) [member function]
    cls.add_method('SetTxPower',
                   'void',
                   [param('double', 'pow')])
    ## mmwave-ue-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveUePhy::SetUeCphySapUser(ns3::LteUeCphySapUser * s) [member function]
    cls.add_method('SetUeCphySapUser',
                   'void',
                   [param('ns3::LteUeCphySapUser *', 's')])
    ## mmwave-ue-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveUePhy::StartSlot() [member function]
    cls.add_method('StartSlot',
                   'void',
                   [])
    ## mmwave-ue-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveUePhy::SubframeIndication(uint16_t frameNum, uint8_t subframeNum) [member function]
    cls.add_method('SubframeIndication',
                   'void',
                   [param('uint16_t', 'frameNum'), param('uint8_t', 'subframeNum')])
    ## mmwave-ue-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveUePhy::UpdateSinrEstimate(uint16_t cellId, double sinr) [member function]
    cls.add_method('UpdateSinrEstimate',
                   'void',
                   [param('uint16_t', 'cellId'), param('double', 'sinr')])
    return

def register_Ns3MmwaveMmWaveUePhySapUser_methods(root_module, cls):
    ## mmwave-phy-sap.h (module 'mmwave'): ns3::mmwave::MmWaveUePhySapUser::MmWaveUePhySapUser() [constructor]
    cls.add_constructor([])
    ## mmwave-phy-sap.h (module 'mmwave'): ns3::mmwave::MmWaveUePhySapUser::MmWaveUePhySapUser(ns3::mmwave::MmWaveUePhySapUser const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveUePhySapUser const &', 'arg0')])
    ## mmwave-phy-sap.h (module 'mmwave'): void ns3::mmwave::MmWaveUePhySapUser::ReceiveControlMessage(ns3::Ptr<ns3::mmwave::MmWaveControlMessage> msg) [member function]
    cls.add_method('ReceiveControlMessage',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWaveControlMessage >', 'msg')],
                   is_pure_virtual=True, is_virtual=True)
    ## mmwave-phy-sap.h (module 'mmwave'): void ns3::mmwave::MmWaveUePhySapUser::ReceivePhyPdu(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('ReceivePhyPdu',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'p')],
                   is_pure_virtual=True, is_virtual=True)
    ## mmwave-phy-sap.h (module 'mmwave'): void ns3::mmwave::MmWaveUePhySapUser::SetConfigurationParameters(ns3::Ptr<ns3::mmwave::MmWavePhyMacCommon> params) [member function]
    cls.add_method('SetConfigurationParameters',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWavePhyMacCommon >', 'params')],
                   is_pure_virtual=True, is_virtual=True)
    ## mmwave-phy-sap.h (module 'mmwave'): void ns3::mmwave::MmWaveUePhySapUser::SubframeIndication(ns3::mmwave::SfnSf arg0) [member function]
    cls.add_method('SubframeIndication',
                   'void',
                   [param('ns3::mmwave::SfnSf', 'arg0')],
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3MmwaveMmWaveUeRrcProtocolIdeal_methods(root_module, cls):
    ## mmwave-rrc-protocol-ideal.h (module 'mmwave'): ns3::mmwave::MmWaveUeRrcProtocolIdeal::MmWaveUeRrcProtocolIdeal(ns3::mmwave::MmWaveUeRrcProtocolIdeal const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveUeRrcProtocolIdeal const &', 'arg0')])
    ## mmwave-rrc-protocol-ideal.h (module 'mmwave'): ns3::mmwave::MmWaveUeRrcProtocolIdeal::MmWaveUeRrcProtocolIdeal() [constructor]
    cls.add_constructor([])
    ## mmwave-rrc-protocol-ideal.h (module 'mmwave'): void ns3::mmwave::MmWaveUeRrcProtocolIdeal::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## mmwave-rrc-protocol-ideal.h (module 'mmwave'): ns3::LteUeRrcSapUser * ns3::mmwave::MmWaveUeRrcProtocolIdeal::GetLteUeRrcSapUser() [member function]
    cls.add_method('GetLteUeRrcSapUser',
                   'ns3::LteUeRrcSapUser *',
                   [])
    ## mmwave-rrc-protocol-ideal.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWaveUeRrcProtocolIdeal::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-rrc-protocol-ideal.h (module 'mmwave'): void ns3::mmwave::MmWaveUeRrcProtocolIdeal::SetLteUeRrcSapProvider(ns3::LteUeRrcSapProvider * p) [member function]
    cls.add_method('SetLteUeRrcSapProvider',
                   'void',
                   [param('ns3::LteUeRrcSapProvider *', 'p')])
    ## mmwave-rrc-protocol-ideal.h (module 'mmwave'): void ns3::mmwave::MmWaveUeRrcProtocolIdeal::SetUeRrc(ns3::Ptr<ns3::LteUeRrc> rrc) [member function]
    cls.add_method('SetUeRrc',
                   'void',
                   [param('ns3::Ptr< ns3::LteUeRrc >', 'rrc')])
    return

def register_Ns3MmwaveMmwaveSpectrumSignalParametersDataFrame_methods(root_module, cls):
    ## mmwave-spectrum-signal-parameters.h (module 'mmwave'): ns3::mmwave::MmwaveSpectrumSignalParametersDataFrame::MmwaveSpectrumSignalParametersDataFrame() [constructor]
    cls.add_constructor([])
    ## mmwave-spectrum-signal-parameters.h (module 'mmwave'): ns3::mmwave::MmwaveSpectrumSignalParametersDataFrame::MmwaveSpectrumSignalParametersDataFrame(ns3::mmwave::MmwaveSpectrumSignalParametersDataFrame const & p) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmwaveSpectrumSignalParametersDataFrame const &', 'p')])
    ## mmwave-spectrum-signal-parameters.h (module 'mmwave'): ns3::Ptr<ns3::SpectrumSignalParameters> ns3::mmwave::MmwaveSpectrumSignalParametersDataFrame::Copy() [member function]
    cls.add_method('Copy',
                   'ns3::Ptr< ns3::SpectrumSignalParameters >',
                   [],
                   is_virtual=True)
    ## mmwave-spectrum-signal-parameters.h (module 'mmwave'): ns3::mmwave::MmwaveSpectrumSignalParametersDataFrame::cellId [variable]
    cls.add_instance_attribute('cellId', 'uint16_t', is_const=False)
    ## mmwave-spectrum-signal-parameters.h (module 'mmwave'): ns3::mmwave::MmwaveSpectrumSignalParametersDataFrame::ctrlMsgList [variable]
    cls.add_instance_attribute('ctrlMsgList', 'std::list< ns3::Ptr< ns3::mmwave::MmWaveControlMessage > >', is_const=False)
    ## mmwave-spectrum-signal-parameters.h (module 'mmwave'): ns3::mmwave::MmwaveSpectrumSignalParametersDataFrame::packetBurst [variable]
    cls.add_instance_attribute('packetBurst', 'ns3::Ptr< ns3::PacketBurst >', is_const=False)
    ## mmwave-spectrum-signal-parameters.h (module 'mmwave'): ns3::mmwave::MmwaveSpectrumSignalParametersDataFrame::slotInd [variable]
    cls.add_instance_attribute('slotInd', 'uint8_t', is_const=False)
    return

def register_Ns3MmwaveParams3gpp_methods(root_module, cls):
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::Params3gpp::Params3gpp() [constructor]
    cls.add_constructor([])
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::Params3gpp::Params3gpp(ns3::mmwave::Params3gpp const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::Params3gpp const &', 'arg0')])
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::Params3gpp::m_DS [variable]
    cls.add_instance_attribute('m_DS', 'double', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::Params3gpp::m_K [variable]
    cls.add_instance_attribute('m_K', 'double', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::Params3gpp::m_allLongTermMap [variable]
    cls.add_instance_attribute('m_allLongTermMap', 'std::map< ns3::Ptr< ns3::NetDevice >, std::vector< std::complex< double > > >', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::Params3gpp::m_angle [variable]
    cls.add_instance_attribute('m_angle', 'ns3::mmwave::double2DVector_t', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::Params3gpp::m_channel [variable]
    cls.add_instance_attribute('m_channel', 'ns3::mmwave::complex3DVector_t', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::Params3gpp::m_clusterPhase [variable]
    cls.add_instance_attribute('m_clusterPhase', 'ns3::mmwave::double2DVector_t', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::Params3gpp::m_delay [variable]
    cls.add_instance_attribute('m_delay', 'ns3::mmwave::doubleVector_t', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::Params3gpp::m_dis2D [variable]
    cls.add_instance_attribute('m_dis2D', 'double', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::Params3gpp::m_dis3D [variable]
    cls.add_instance_attribute('m_dis3D', 'double', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::Params3gpp::m_generatedTime [variable]
    cls.add_instance_attribute('m_generatedTime', 'ns3::Time', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::Params3gpp::m_locUT [variable]
    cls.add_instance_attribute('m_locUT', 'ns3::Vector', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::Params3gpp::m_longTerm [variable]
    cls.add_instance_attribute('m_longTerm', 'ns3::mmwave::complexVector_t', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::Params3gpp::m_los [variable]
    cls.add_instance_attribute('m_los', 'bool', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::Params3gpp::m_losPhase [variable]
    cls.add_instance_attribute('m_losPhase', 'double', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::Params3gpp::m_nonSelfBlocking [variable]
    cls.add_instance_attribute('m_nonSelfBlocking', 'ns3::mmwave::double2DVector_t', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::Params3gpp::m_norRvAngles [variable]
    cls.add_instance_attribute('m_norRvAngles', 'ns3::mmwave::double2DVector_t', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::Params3gpp::m_numCluster [variable]
    cls.add_instance_attribute('m_numCluster', 'uint8_t', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::Params3gpp::m_o2i [variable]
    cls.add_instance_attribute('m_o2i', 'bool', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::Params3gpp::m_preLocUT [variable]
    cls.add_instance_attribute('m_preLocUT', 'ns3::Vector', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::Params3gpp::m_rxW [variable]
    cls.add_instance_attribute('m_rxW', 'ns3::mmwave::complexVector_t', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::Params3gpp::m_speed [variable]
    cls.add_instance_attribute('m_speed', 'ns3::Vector', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::Params3gpp::m_txW [variable]
    cls.add_instance_attribute('m_txW', 'ns3::mmwave::complexVector_t', is_const=False)
    return

def register_Ns3MmwaveParamsTable_methods(root_module, cls):
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::ParamsTable::ParamsTable(ns3::mmwave::ParamsTable const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::ParamsTable const &', 'arg0')])
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::ParamsTable::ParamsTable() [constructor]
    cls.add_constructor([])
    ## mmwave-3gpp-channel.h (module 'mmwave'): void ns3::mmwave::ParamsTable::SetParams(uint8_t numOfCluster, uint8_t raysPerCluster, double uLgDS, double sigLgDS, double uLgASD, double sigLgASD, double uLgASA, double sigLgASA, double uLgZSA, double sigLgZSA, double uLgZSD, double sigLgZSD, double offsetZOD, double cDS, double cASD, double cASA, double cZSA, double uK, double sigK, double rTau, double shadowingStd) [member function]
    cls.add_method('SetParams',
                   'void',
                   [param('uint8_t', 'numOfCluster'), param('uint8_t', 'raysPerCluster'), param('double', 'uLgDS'), param('double', 'sigLgDS'), param('double', 'uLgASD'), param('double', 'sigLgASD'), param('double', 'uLgASA'), param('double', 'sigLgASA'), param('double', 'uLgZSA'), param('double', 'sigLgZSA'), param('double', 'uLgZSD'), param('double', 'sigLgZSD'), param('double', 'offsetZOD'), param('double', 'cDS'), param('double', 'cASD'), param('double', 'cASA'), param('double', 'cZSA'), param('double', 'uK'), param('double', 'sigK'), param('double', 'rTau'), param('double', 'shadowingStd')])
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::ParamsTable::m_cASA [variable]
    cls.add_instance_attribute('m_cASA', 'double', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::ParamsTable::m_cASD [variable]
    cls.add_instance_attribute('m_cASD', 'double', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::ParamsTable::m_cDS [variable]
    cls.add_instance_attribute('m_cDS', 'double', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::ParamsTable::m_cZSA [variable]
    cls.add_instance_attribute('m_cZSA', 'double', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::ParamsTable::m_numOfCluster [variable]
    cls.add_instance_attribute('m_numOfCluster', 'uint8_t', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::ParamsTable::m_offsetZOD [variable]
    cls.add_instance_attribute('m_offsetZOD', 'double', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::ParamsTable::m_rTau [variable]
    cls.add_instance_attribute('m_rTau', 'double', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::ParamsTable::m_raysPerCluster [variable]
    cls.add_instance_attribute('m_raysPerCluster', 'uint8_t', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::ParamsTable::m_shadowingStd [variable]
    cls.add_instance_attribute('m_shadowingStd', 'double', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::ParamsTable::m_sigK [variable]
    cls.add_instance_attribute('m_sigK', 'double', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::ParamsTable::m_sigLgASA [variable]
    cls.add_instance_attribute('m_sigLgASA', 'double', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::ParamsTable::m_sigLgASD [variable]
    cls.add_instance_attribute('m_sigLgASD', 'double', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::ParamsTable::m_sigLgDS [variable]
    cls.add_instance_attribute('m_sigLgDS', 'double', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::ParamsTable::m_sigLgZSA [variable]
    cls.add_instance_attribute('m_sigLgZSA', 'double', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::ParamsTable::m_sigLgZSD [variable]
    cls.add_instance_attribute('m_sigLgZSD', 'double', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::ParamsTable::m_sqrtC [variable]
    cls.add_instance_attribute('m_sqrtC', 'double [ 7 ] [ 7 ]', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::ParamsTable::m_uK [variable]
    cls.add_instance_attribute('m_uK', 'double', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::ParamsTable::m_uLgASA [variable]
    cls.add_instance_attribute('m_uLgASA', 'double', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::ParamsTable::m_uLgASD [variable]
    cls.add_instance_attribute('m_uLgASD', 'double', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::ParamsTable::m_uLgDS [variable]
    cls.add_instance_attribute('m_uLgDS', 'double', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::ParamsTable::m_uLgZSA [variable]
    cls.add_instance_attribute('m_uLgZSA', 'double', is_const=False)
    ## mmwave-3gpp-channel.h (module 'mmwave'): ns3::mmwave::ParamsTable::m_uLgZSD [variable]
    cls.add_instance_attribute('m_uLgZSD', 'double', is_const=False)
    return

def register_Ns3MmwaveRlcListElement_methods(root_module, cls):
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::RlcListElement::RlcListElement() [constructor]
    cls.add_constructor([])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::RlcListElement::RlcListElement(ns3::mmwave::RlcListElement const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::RlcListElement const &', 'arg0')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::RlcListElement::m_rlcPduElements [variable]
    cls.add_instance_attribute('m_rlcPduElements', 'std::vector< ns3::mmwave::RlcPduInfo >', is_const=False)
    return

def register_Ns3MmwaveRlcPduInfo_methods(root_module, cls):
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::RlcPduInfo::RlcPduInfo(ns3::mmwave::RlcPduInfo const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::RlcPduInfo const &', 'arg0')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::RlcPduInfo::RlcPduInfo() [constructor]
    cls.add_constructor([])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::RlcPduInfo::RlcPduInfo(uint8_t lcid, uint16_t size) [constructor]
    cls.add_constructor([param('uint8_t', 'lcid'), param('uint16_t', 'size')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::RlcPduInfo::m_lcid [variable]
    cls.add_instance_attribute('m_lcid', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::RlcPduInfo::m_size [variable]
    cls.add_instance_attribute('m_size', 'uint32_t', is_const=False)
    return

def register_Ns3MmwaveRxPacketTraceParams_methods(root_module, cls):
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::RxPacketTraceParams::RxPacketTraceParams() [constructor]
    cls.add_constructor([])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::RxPacketTraceParams::RxPacketTraceParams(ns3::mmwave::RxPacketTraceParams const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::RxPacketTraceParams const &', 'arg0')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::RxPacketTraceParams::m_ccId [variable]
    cls.add_instance_attribute('m_ccId', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::RxPacketTraceParams::m_cellId [variable]
    cls.add_instance_attribute('m_cellId', 'uint64_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::RxPacketTraceParams::m_corrupt [variable]
    cls.add_instance_attribute('m_corrupt', 'bool', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::RxPacketTraceParams::m_frameNum [variable]
    cls.add_instance_attribute('m_frameNum', 'uint32_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::RxPacketTraceParams::m_mcs [variable]
    cls.add_instance_attribute('m_mcs', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::RxPacketTraceParams::m_numSym [variable]
    cls.add_instance_attribute('m_numSym', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::RxPacketTraceParams::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::RxPacketTraceParams::m_rv [variable]
    cls.add_instance_attribute('m_rv', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::RxPacketTraceParams::m_sfNum [variable]
    cls.add_instance_attribute('m_sfNum', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::RxPacketTraceParams::m_sinr [variable]
    cls.add_instance_attribute('m_sinr', 'double', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::RxPacketTraceParams::m_sinrMin [variable]
    cls.add_instance_attribute('m_sinrMin', 'double', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::RxPacketTraceParams::m_slotNum [variable]
    cls.add_instance_attribute('m_slotNum', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::RxPacketTraceParams::m_symStart [variable]
    cls.add_instance_attribute('m_symStart', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::RxPacketTraceParams::m_tbSize [variable]
    cls.add_instance_attribute('m_tbSize', 'uint32_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::RxPacketTraceParams::m_tbler [variable]
    cls.add_instance_attribute('m_tbler', 'double', is_const=False)
    return

def register_Ns3MmwaveSchedInfo_methods(root_module, cls):
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SchedInfo::SchedInfo(ns3::mmwave::SchedInfo const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::SchedInfo const &', 'arg0')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SchedInfo::SchedInfo() [constructor]
    cls.add_constructor([])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SchedInfo::SchedInfo(unsigned int numSlots) [constructor]
    cls.add_constructor([param('unsigned int', 'numSlots')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SchedInfo::m_dci [variable]
    cls.add_instance_attribute('m_dci', 'ns3::mmwave::DciInfoElement', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SchedInfo::m_frameNum [variable]
    cls.add_instance_attribute('m_frameNum', 'uint16_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SchedInfo::m_rlcPduMap [variable]
    cls.add_instance_attribute('m_rlcPduMap', 'std::map< unsigned char, std::vector< ns3::mmwave::RlcPduInfo > >', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SchedInfo::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SchedInfo::m_sfAllocInfo [variable]
    cls.add_instance_attribute('m_sfAllocInfo', 'ns3::mmwave::SfAllocInfo', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SchedInfo::m_sfNum [variable]
    cls.add_instance_attribute('m_sfNum', 'uint8_t', is_const=False)
    return

def register_Ns3MmwaveSfAllocInfo_methods(root_module, cls):
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SfAllocInfo::SfAllocInfo(ns3::mmwave::SfAllocInfo const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::SfAllocInfo const &', 'arg0')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SfAllocInfo::SfAllocInfo() [constructor]
    cls.add_constructor([])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SfAllocInfo::SfAllocInfo(ns3::mmwave::SfnSf sfn) [constructor]
    cls.add_constructor([param('ns3::mmwave::SfnSf', 'sfn')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SfAllocInfo::m_dlSlotAllocInfo [variable]
    cls.add_instance_attribute('m_dlSlotAllocInfo', 'std::deque< ns3::mmwave::SlotAllocInfo >', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SfAllocInfo::m_numSymAlloc [variable]
    cls.add_instance_attribute('m_numSymAlloc', 'uint32_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SfAllocInfo::m_sfnSf [variable]
    cls.add_instance_attribute('m_sfnSf', 'ns3::mmwave::SfnSf', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SfAllocInfo::m_slotAllocInfo [variable]
    cls.add_instance_attribute('m_slotAllocInfo', 'std::deque< ns3::mmwave::SlotAllocInfo >', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SfAllocInfo::m_ulSlotAllocInfo [variable]
    cls.add_instance_attribute('m_ulSlotAllocInfo', 'std::deque< ns3::mmwave::SlotAllocInfo >', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SfAllocInfo::m_ulSymStart [variable]
    cls.add_instance_attribute('m_ulSymStart', 'uint32_t', is_const=False)
    return

def register_Ns3MmwaveSfnSf_methods(root_module, cls):
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SfnSf::SfnSf(ns3::mmwave::SfnSf const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::SfnSf const &', 'arg0')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SfnSf::SfnSf() [constructor]
    cls.add_constructor([])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SfnSf::SfnSf(uint16_t frameNum, uint8_t sfNum, uint8_t slotNum) [constructor]
    cls.add_constructor([param('uint16_t', 'frameNum'), param('uint8_t', 'sfNum'), param('uint8_t', 'slotNum')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): void ns3::mmwave::SfnSf::Decode(uint32_t sfn) [member function]
    cls.add_method('Decode',
                   'void',
                   [param('uint32_t', 'sfn')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): uint32_t ns3::mmwave::SfnSf::Encode() const [member function]
    cls.add_method('Encode',
                   'uint32_t',
                   [],
                   is_const=True)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SfnSf::m_frameNum [variable]
    cls.add_instance_attribute('m_frameNum', 'uint16_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SfnSf::m_sfNum [variable]
    cls.add_instance_attribute('m_sfNum', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SfnSf::m_slotNum [variable]
    cls.add_instance_attribute('m_slotNum', 'uint8_t', is_const=False)
    return

def register_Ns3MmwaveSlotAllocInfo_methods(root_module, cls):
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SlotAllocInfo::SlotAllocInfo(ns3::mmwave::SlotAllocInfo const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::SlotAllocInfo const &', 'arg0')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SlotAllocInfo::SlotAllocInfo() [constructor]
    cls.add_constructor([])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SlotAllocInfo::SlotAllocInfo(uint8_t slotIdx, ns3::mmwave::SlotAllocInfo::TddMode tddMode, ns3::mmwave::SlotAllocInfo::TddSlotType slotType, ns3::mmwave::SlotAllocInfo::CtrlTxMode ctrlTxMode, uint16_t rnti) [constructor]
    cls.add_constructor([param('uint8_t', 'slotIdx'), param('ns3::mmwave::SlotAllocInfo::TddMode', 'tddMode'), param('ns3::mmwave::SlotAllocInfo::TddSlotType', 'slotType'), param('ns3::mmwave::SlotAllocInfo::CtrlTxMode', 'ctrlTxMode'), param('uint16_t', 'rnti')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SlotAllocInfo::m_ctrlTxMode [variable]
    cls.add_instance_attribute('m_ctrlTxMode', 'ns3::mmwave::SlotAllocInfo::CtrlTxMode', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SlotAllocInfo::m_dci [variable]
    cls.add_instance_attribute('m_dci', 'ns3::mmwave::DciInfoElementTdma', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SlotAllocInfo::m_isOmni [variable]
    cls.add_instance_attribute('m_isOmni', 'bool', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SlotAllocInfo::m_numCtrlSym [variable]
    cls.add_instance_attribute('m_numCtrlSym', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SlotAllocInfo::m_rlcPduInfo [variable]
    cls.add_instance_attribute('m_rlcPduInfo', 'std::vector< ns3::mmwave::RlcPduInfo >', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SlotAllocInfo::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SlotAllocInfo::m_slotIdx [variable]
    cls.add_instance_attribute('m_slotIdx', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SlotAllocInfo::m_slotType [variable]
    cls.add_instance_attribute('m_slotType', 'ns3::mmwave::SlotAllocInfo::TddSlotType', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::SlotAllocInfo::m_tddMode [variable]
    cls.add_instance_attribute('m_tddMode', 'ns3::mmwave::SlotAllocInfo::TddMode', is_const=False)
    return

def register_Ns3MmwaveTbAllocInfo_methods(root_module, cls):
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::TbAllocInfo::TbAllocInfo(ns3::mmwave::TbAllocInfo const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::TbAllocInfo const &', 'arg0')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::TbAllocInfo::TbAllocInfo() [constructor]
    cls.add_constructor([])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::TbAllocInfo::m_rbMap [variable]
    cls.add_instance_attribute('m_rbMap', 'std::vector< unsigned int >', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::TbAllocInfo::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::TbAllocInfo::m_sfnSf [variable]
    cls.add_instance_attribute('m_sfnSf', 'ns3::mmwave::SfnSf', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::TbAllocInfo::m_tbInfo [variable]
    cls.add_instance_attribute('m_tbInfo', 'ns3::mmwave::TbInfoElement', is_const=False)
    return

def register_Ns3MmwaveTbInfoElement_methods(root_module, cls):
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::TbInfoElement::TbInfoElement(ns3::mmwave::TbInfoElement const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::TbInfoElement const &', 'arg0')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::TbInfoElement::TbInfoElement() [constructor]
    cls.add_constructor([])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::TbInfoElement::m_harqProcess [variable]
    cls.add_instance_attribute('m_harqProcess', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::TbInfoElement::m_isUplink [variable]
    cls.add_instance_attribute('m_isUplink', 'bool', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::TbInfoElement::m_mcs [variable]
    cls.add_instance_attribute('m_mcs', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::TbInfoElement::m_ndi [variable]
    cls.add_instance_attribute('m_ndi', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::TbInfoElement::m_numSym [variable]
    cls.add_instance_attribute('m_numSym', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::TbInfoElement::m_rbBitmap [variable]
    cls.add_instance_attribute('m_rbBitmap', 'uint32_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::TbInfoElement::m_rbLen [variable]
    cls.add_instance_attribute('m_rbLen', 'uint16_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::TbInfoElement::m_rbShift [variable]
    cls.add_instance_attribute('m_rbShift', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::TbInfoElement::m_rbStart [variable]
    cls.add_instance_attribute('m_rbStart', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::TbInfoElement::m_resAlloc [variable]
    cls.add_instance_attribute('m_resAlloc', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::TbInfoElement::m_rv [variable]
    cls.add_instance_attribute('m_rv', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::TbInfoElement::m_slotIdx [variable]
    cls.add_instance_attribute('m_slotIdx', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::TbInfoElement::m_symStart [variable]
    cls.add_instance_attribute('m_symStart', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::TbInfoElement::m_tbSize [variable]
    cls.add_instance_attribute('m_tbSize', 'uint32_t', is_const=False)
    return

def register_Ns3MmwaveTraceParams_methods(root_module, cls):
    ## mmwave-channel-raytracing.h (module 'mmwave'): ns3::mmwave::TraceParams::TraceParams() [constructor]
    cls.add_constructor([])
    ## mmwave-channel-raytracing.h (module 'mmwave'): ns3::mmwave::TraceParams::TraceParams(ns3::mmwave::TraceParams const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::TraceParams const &', 'arg0')])
    ## mmwave-channel-raytracing.h (module 'mmwave'): ns3::mmwave::TraceParams::m_delaySpread [variable]
    cls.add_instance_attribute('m_delaySpread', 'ns3::mmwave::doubleVector_t', is_const=False)
    ## mmwave-channel-raytracing.h (module 'mmwave'): ns3::mmwave::TraceParams::m_doppler [variable]
    cls.add_instance_attribute('m_doppler', 'ns3::mmwave::doubleVector_t', is_const=False)
    ## mmwave-channel-raytracing.h (module 'mmwave'): ns3::mmwave::TraceParams::m_powerFraction [variable]
    cls.add_instance_attribute('m_powerFraction', 'ns3::mmwave::doubleVector_t', is_const=False)
    ## mmwave-channel-raytracing.h (module 'mmwave'): ns3::mmwave::TraceParams::m_rxSpatialMatrix [variable]
    cls.add_instance_attribute('m_rxSpatialMatrix', 'ns3::mmwave::complex2DVector_t', is_const=False)
    ## mmwave-channel-raytracing.h (module 'mmwave'): ns3::mmwave::TraceParams::m_txSpatialMatrix [variable]
    cls.add_instance_attribute('m_txSpatialMatrix', 'ns3::mmwave::complex2DVector_t', is_const=False)
    return

def register_Ns3MmwaveUePhyPacketCountParameter_methods(root_module, cls):
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::UePhyPacketCountParameter::UePhyPacketCountParameter() [constructor]
    cls.add_constructor([])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::UePhyPacketCountParameter::UePhyPacketCountParameter(ns3::mmwave::UePhyPacketCountParameter const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::UePhyPacketCountParameter const &', 'arg0')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::UePhyPacketCountParameter::m_imsi [variable]
    cls.add_instance_attribute('m_imsi', 'uint64_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::UePhyPacketCountParameter::m_isTx [variable]
    cls.add_instance_attribute('m_isTx', 'bool', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::UePhyPacketCountParameter::m_noBytes [variable]
    cls.add_instance_attribute('m_noBytes', 'uint32_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::UePhyPacketCountParameter::m_subframeno [variable]
    cls.add_instance_attribute('m_subframeno', 'uint32_t', is_const=False)
    return

def register_Ns3MmwaveUlCqiInfo_methods(root_module, cls):
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::UlCqiInfo::UlCqiInfo() [constructor]
    cls.add_constructor([])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::UlCqiInfo::UlCqiInfo(ns3::mmwave::UlCqiInfo const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::UlCqiInfo const &', 'arg0')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::UlCqiInfo::m_sinr [variable]
    cls.add_instance_attribute('m_sinr', 'std::vector< double >', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::UlCqiInfo::m_type [variable]
    cls.add_instance_attribute('m_type', 'ns3::mmwave::UlCqiInfo::UlCqiType', is_const=False)
    return

def register_Ns3MmwaveUlHarqInfo_methods(root_module, cls):
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::UlHarqInfo::UlHarqInfo() [constructor]
    cls.add_constructor([])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::UlHarqInfo::UlHarqInfo(ns3::mmwave::UlHarqInfo const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::UlHarqInfo const &', 'arg0')])
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::UlHarqInfo::m_harqProcessId [variable]
    cls.add_instance_attribute('m_harqProcessId', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::UlHarqInfo::m_numRetx [variable]
    cls.add_instance_attribute('m_numRetx', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::UlHarqInfo::m_receptionStatus [variable]
    cls.add_instance_attribute('m_receptionStatus', 'ns3::mmwave::UlHarqInfo::ReceptionStatus', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::UlHarqInfo::m_rnti [variable]
    cls.add_instance_attribute('m_rnti', 'uint16_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::UlHarqInfo::m_tpc [variable]
    cls.add_instance_attribute('m_tpc', 'uint8_t', is_const=False)
    ## mmwave-phy-mac-common.h (module 'mmwave'): ns3::mmwave::UlHarqInfo::m_ulReception [variable]
    cls.add_instance_attribute('m_ulReception', 'std::vector< unsigned short >', is_const=False)
    return

def register_Ns3MmwaveChannelCondition_methods(root_module, cls):
    ## mmwave-3gpp-propagation-loss-model.h (module 'mmwave'): ns3::mmwave::channelCondition::channelCondition() [constructor]
    cls.add_constructor([])
    ## mmwave-3gpp-propagation-loss-model.h (module 'mmwave'): ns3::mmwave::channelCondition::channelCondition(ns3::mmwave::channelCondition const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::channelCondition const &', 'arg0')])
    ## mmwave-3gpp-propagation-loss-model.h (module 'mmwave'): ns3::mmwave::channelCondition::m_carPenetrationLoss [variable]
    cls.add_instance_attribute('m_carPenetrationLoss', 'double', is_const=False)
    ## mmwave-3gpp-propagation-loss-model.h (module 'mmwave'): ns3::mmwave::channelCondition::m_channelCondition [variable]
    cls.add_instance_attribute('m_channelCondition', 'char', is_const=False)
    ## mmwave-3gpp-propagation-loss-model.h (module 'mmwave'): ns3::mmwave::channelCondition::m_hE [variable]
    cls.add_instance_attribute('m_hE', 'double', is_const=False)
    ## mmwave-3gpp-propagation-loss-model.h (module 'mmwave'): ns3::mmwave::channelCondition::m_position [variable]
    cls.add_instance_attribute('m_position', 'ns3::Vector', is_const=False)
    ## mmwave-3gpp-propagation-loss-model.h (module 'mmwave'): ns3::mmwave::channelCondition::m_shadowing [variable]
    cls.add_instance_attribute('m_shadowing', 'double', is_const=False)
    return

def register_Ns3MmwaveChannelMatrix_methods(root_module, cls):
    ## mmwave-beamforming.h (module 'mmwave'): ns3::mmwave::channelMatrix::channelMatrix() [constructor]
    cls.add_constructor([])
    ## mmwave-beamforming.h (module 'mmwave'): ns3::mmwave::channelMatrix::channelMatrix(ns3::mmwave::channelMatrix const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::channelMatrix const &', 'arg0')])
    ## mmwave-beamforming.h (module 'mmwave'): ns3::mmwave::channelMatrix::m_enbSpatialMatrix [variable]
    cls.add_instance_attribute('m_enbSpatialMatrix', 'ns3::mmwave::complex2DVector_t', is_const=False)
    ## mmwave-beamforming.h (module 'mmwave'): ns3::mmwave::channelMatrix::m_powerFraction [variable]
    cls.add_instance_attribute('m_powerFraction', 'ns3::mmwave::doubleVector_t', is_const=False)
    ## mmwave-beamforming.h (module 'mmwave'): ns3::mmwave::channelMatrix::m_ueSpatialMatrix [variable]
    cls.add_instance_attribute('m_ueSpatialMatrix', 'ns3::mmwave::complex2DVector_t', is_const=False)
    return

def register_Ns3MmwaveChannelScenario_methods(root_module, cls):
    ## mmwave-propagation-loss-model.h (module 'mmwave'): ns3::mmwave::channelScenario::channelScenario() [constructor]
    cls.add_constructor([])
    ## mmwave-propagation-loss-model.h (module 'mmwave'): ns3::mmwave::channelScenario::channelScenario(ns3::mmwave::channelScenario const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::channelScenario const &', 'arg0')])
    ## mmwave-propagation-loss-model.h (module 'mmwave'): ns3::mmwave::channelScenario::m_channelScenario [variable]
    cls.add_instance_attribute('m_channelScenario', 'char', is_const=False)
    ## mmwave-propagation-loss-model.h (module 'mmwave'): ns3::mmwave::channelScenario::m_shadowing [variable]
    cls.add_instance_attribute('m_shadowing', 'double', is_const=False)
    return

def register_Ns3MmwaveMmWaveBeamFormingParams_methods(root_module, cls):
    ## mmwave-channel-matrix.h (module 'mmwave'): ns3::mmwave::mmWaveBeamFormingParams::mmWaveBeamFormingParams() [constructor]
    cls.add_constructor([])
    ## mmwave-channel-matrix.h (module 'mmwave'): ns3::mmwave::mmWaveBeamFormingParams::mmWaveBeamFormingParams(ns3::mmwave::mmWaveBeamFormingParams const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::mmWaveBeamFormingParams const &', 'arg0')])
    ## mmwave-channel-matrix.h (module 'mmwave'): ns3::mmwave::mmWaveBeamFormingParams::m_channelParams [variable]
    cls.add_instance_attribute('m_channelParams', 'ns3::Ptr< ns3::mmwave::ChannelParams >', is_const=False)
    ## mmwave-channel-matrix.h (module 'mmwave'): ns3::mmwave::mmWaveBeamFormingParams::m_rxW [variable]
    cls.add_instance_attribute('m_rxW', 'ns3::mmwave::complexVector_t', is_const=False)
    ## mmwave-channel-matrix.h (module 'mmwave'): ns3::mmwave::mmWaveBeamFormingParams::m_txW [variable]
    cls.add_instance_attribute('m_txW', 'ns3::mmwave::complexVector_t', is_const=False)
    return

def register_Ns3MmwaveMmWaveBeamFormingTraces_methods(root_module, cls):
    ## mmwave-channel-raytracing.h (module 'mmwave'): ns3::mmwave::mmWaveBeamFormingTraces::mmWaveBeamFormingTraces() [constructor]
    cls.add_constructor([])
    ## mmwave-channel-raytracing.h (module 'mmwave'): ns3::mmwave::mmWaveBeamFormingTraces::mmWaveBeamFormingTraces(ns3::mmwave::mmWaveBeamFormingTraces const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::mmWaveBeamFormingTraces const &', 'arg0')])
    ## mmwave-channel-raytracing.h (module 'mmwave'): ns3::mmwave::mmWaveBeamFormingTraces::m_channelParams [variable]
    cls.add_instance_attribute('m_channelParams', 'ns3::Ptr< ns3::mmwave::TraceParams >', is_const=False)
    ## mmwave-channel-raytracing.h (module 'mmwave'): ns3::mmwave::mmWaveBeamFormingTraces::m_rxW [variable]
    cls.add_instance_attribute('m_rxW', 'ns3::mmwave::complexVector_t', is_const=False)
    ## mmwave-channel-raytracing.h (module 'mmwave'): ns3::mmwave::mmWaveBeamFormingTraces::m_txW [variable]
    cls.add_instance_attribute('m_txW', 'ns3::mmwave::complexVector_t', is_const=False)
    return

def register_Ns3MmwaveMmWaveChunkProcessor_methods(root_module, cls):
    ## mmwave-chunk-processor.h (module 'mmwave'): ns3::mmwave::mmWaveChunkProcessor::mmWaveChunkProcessor(ns3::mmwave::mmWaveChunkProcessor const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::mmWaveChunkProcessor const &', 'arg0')])
    ## mmwave-chunk-processor.h (module 'mmwave'): ns3::mmwave::mmWaveChunkProcessor::mmWaveChunkProcessor() [constructor]
    cls.add_constructor([])
    ## mmwave-chunk-processor.h (module 'mmwave'): void ns3::mmwave::mmWaveChunkProcessor::AddCallback(ns3::mmwave::mmWaveChunkProcessorCallback c) [member function]
    cls.add_method('AddCallback',
                   'void',
                   [param('ns3::Callback< void, ns3::SpectrumValue const &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'c')],
                   is_virtual=True)
    ## mmwave-chunk-processor.h (module 'mmwave'): void ns3::mmwave::mmWaveChunkProcessor::End() [member function]
    cls.add_method('End',
                   'void',
                   [],
                   is_virtual=True)
    ## mmwave-chunk-processor.h (module 'mmwave'): void ns3::mmwave::mmWaveChunkProcessor::EvaluateChunk(ns3::SpectrumValue const & sinr, ns3::Time duration) [member function]
    cls.add_method('EvaluateChunk',
                   'void',
                   [param('ns3::SpectrumValue const &', 'sinr'), param('ns3::Time', 'duration')],
                   is_virtual=True)
    ## mmwave-chunk-processor.h (module 'mmwave'): void ns3::mmwave::mmWaveChunkProcessor::Start() [member function]
    cls.add_method('Start',
                   'void',
                   [],
                   is_virtual=True)
    return

def register_Ns3MmwaveMmWaveInterference_methods(root_module, cls):
    ## mmwave-interference.h (module 'mmwave'): ns3::mmwave::mmWaveInterference::mmWaveInterference(ns3::mmwave::mmWaveInterference const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::mmWaveInterference const &', 'arg0')])
    ## mmwave-interference.h (module 'mmwave'): ns3::mmwave::mmWaveInterference::mmWaveInterference() [constructor]
    cls.add_constructor([])
    ## mmwave-interference.h (module 'mmwave'): void ns3::mmwave::mmWaveInterference::AddPowerChunkProcessor(ns3::Ptr<ns3::mmwave::mmWaveChunkProcessor> p) [member function]
    cls.add_method('AddPowerChunkProcessor',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::mmWaveChunkProcessor >', 'p')])
    ## mmwave-interference.h (module 'mmwave'): void ns3::mmwave::mmWaveInterference::AddSignal(ns3::Ptr<const ns3::SpectrumValue> spd, ns3::Time const duration) [member function]
    cls.add_method('AddSignal',
                   'void',
                   [param('ns3::Ptr< ns3::SpectrumValue const >', 'spd'), param('ns3::Time const', 'duration')])
    ## mmwave-interference.h (module 'mmwave'): void ns3::mmwave::mmWaveInterference::AddSinrChunkProcessor(ns3::Ptr<ns3::mmwave::mmWaveChunkProcessor> p) [member function]
    cls.add_method('AddSinrChunkProcessor',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::mmWaveChunkProcessor >', 'p')])
    ## mmwave-interference.h (module 'mmwave'): void ns3::mmwave::mmWaveInterference::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## mmwave-interference.h (module 'mmwave'): void ns3::mmwave::mmWaveInterference::EndRx() [member function]
    cls.add_method('EndRx',
                   'void',
                   [])
    ## mmwave-interference.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::mmWaveInterference::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-interference.h (module 'mmwave'): void ns3::mmwave::mmWaveInterference::SetNoisePowerSpectralDensity(ns3::Ptr<const ns3::SpectrumValue> noisePsd) [member function]
    cls.add_method('SetNoisePowerSpectralDensity',
                   'void',
                   [param('ns3::Ptr< ns3::SpectrumValue const >', 'noisePsd')])
    ## mmwave-interference.h (module 'mmwave'): void ns3::mmwave::mmWaveInterference::StartRx(ns3::Ptr<const ns3::SpectrumValue> rxPsd) [member function]
    cls.add_method('StartRx',
                   'void',
                   [param('ns3::Ptr< ns3::SpectrumValue const >', 'rxPsd')])
    return

def register_Ns3MmwaveMmwaveSpectrumSignalParameters_methods(root_module, cls):
    ## mmwave-spectrum-signal-parameters.h (module 'mmwave'): ns3::mmwave::mmwaveSpectrumSignalParameters::mmwaveSpectrumSignalParameters() [constructor]
    cls.add_constructor([])
    ## mmwave-spectrum-signal-parameters.h (module 'mmwave'): ns3::mmwave::mmwaveSpectrumSignalParameters::mmwaveSpectrumSignalParameters(ns3::mmwave::mmwaveSpectrumSignalParameters const & p) [constructor]
    cls.add_constructor([param('ns3::mmwave::mmwaveSpectrumSignalParameters const &', 'p')])
    ## mmwave-spectrum-signal-parameters.h (module 'mmwave'): ns3::Ptr<ns3::SpectrumSignalParameters> ns3::mmwave::mmwaveSpectrumSignalParameters::Copy() [member function]
    cls.add_method('Copy',
                   'ns3::Ptr< ns3::SpectrumSignalParameters >',
                   [],
                   is_virtual=True)
    ## mmwave-spectrum-signal-parameters.h (module 'mmwave'): ns3::mmwave::mmwaveSpectrumSignalParameters::packetBurst [variable]
    cls.add_instance_attribute('packetBurst', 'ns3::Ptr< ns3::PacketBurst >', is_const=False)
    return

def register_Ns3MmwaveMmWaveBaRrComponentCarrierManager_methods(root_module, cls):
    ## mmwave-no-op-component-carrier-manager.h (module 'mmwave'): ns3::mmwave::MmWaveBaRrComponentCarrierManager::MmWaveBaRrComponentCarrierManager(ns3::mmwave::MmWaveBaRrComponentCarrierManager const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveBaRrComponentCarrierManager const &', 'arg0')])
    ## mmwave-no-op-component-carrier-manager.h (module 'mmwave'): ns3::mmwave::MmWaveBaRrComponentCarrierManager::MmWaveBaRrComponentCarrierManager() [constructor]
    cls.add_constructor([])
    ## mmwave-no-op-component-carrier-manager.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWaveBaRrComponentCarrierManager::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-no-op-component-carrier-manager.h (module 'mmwave'): void ns3::mmwave::MmWaveBaRrComponentCarrierManager::DoReportBufferStatus(ns3::LteMacSapProvider::ReportBufferStatusParameters params) [member function]
    cls.add_method('DoReportBufferStatus',
                   'void',
                   [param('ns3::LteMacSapProvider::ReportBufferStatusParameters', 'params')],
                   visibility='protected', is_virtual=True)
    ## mmwave-no-op-component-carrier-manager.h (module 'mmwave'): void ns3::mmwave::MmWaveBaRrComponentCarrierManager::DoUlReceiveMacCe(ns3::MacCeListElement_s bsr, uint8_t componentCarrierId) [member function]
    cls.add_method('DoUlReceiveMacCe',
                   'void',
                   [param('ns3::MacCeListElement_s', 'bsr'), param('uint8_t', 'componentCarrierId')],
                   visibility='protected', is_virtual=True)
    return

def register_Ns3MmwaveMmWaveBsrMessage_methods(root_module, cls):
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::MmWaveBsrMessage::MmWaveBsrMessage(ns3::mmwave::MmWaveBsrMessage const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveBsrMessage const &', 'arg0')])
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::MmWaveBsrMessage::MmWaveBsrMessage() [constructor]
    cls.add_constructor([])
    ## mmwave-control-messages.h (module 'mmwave'): ns3::mmwave::MacCeElement ns3::mmwave::MmWaveBsrMessage::GetBsr() [member function]
    cls.add_method('GetBsr',
                   'ns3::mmwave::MacCeElement',
                   [])
    ## mmwave-control-messages.h (module 'mmwave'): void ns3::mmwave::MmWaveBsrMessage::SetBsr(ns3::mmwave::MacCeElement bsr) [member function]
    cls.add_method('SetBsr',
                   'void',
                   [param('ns3::mmwave::MacCeElement', 'bsr')])
    return

def register_Ns3MmwaveMmWaveEnbNetDevice_methods(root_module, cls):
    ## mmwave-enb-net-device.h (module 'mmwave'): ns3::mmwave::MmWaveEnbNetDevice::MmWaveEnbNetDevice(ns3::mmwave::MmWaveEnbNetDevice const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveEnbNetDevice const &', 'arg0')])
    ## mmwave-enb-net-device.h (module 'mmwave'): ns3::mmwave::MmWaveEnbNetDevice::MmWaveEnbNetDevice() [constructor]
    cls.add_constructor([])
    ## mmwave-enb-net-device.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbNetDevice::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## mmwave-enb-net-device.h (module 'mmwave'): bool ns3::mmwave::MmWaveEnbNetDevice::DoSend(ns3::Ptr<ns3::Packet> packet, ns3::Address const & dest, uint16_t protocolNumber) [member function]
    cls.add_method('DoSend',
                   'bool',
                   [param('ns3::Ptr< ns3::Packet >', 'packet'), param('ns3::Address const &', 'dest'), param('uint16_t', 'protocolNumber')],
                   is_virtual=True)
    ## mmwave-enb-net-device.h (module 'mmwave'): uint8_t ns3::mmwave::MmWaveEnbNetDevice::GetAntennaNum() const [member function]
    cls.add_method('GetAntennaNum',
                   'uint8_t',
                   [],
                   is_const=True)
    ## mmwave-enb-net-device.h (module 'mmwave'): uint8_t ns3::mmwave::MmWaveEnbNetDevice::GetBandwidth() const [member function]
    cls.add_method('GetBandwidth',
                   'uint8_t',
                   [],
                   is_const=True)
    ## mmwave-enb-net-device.h (module 'mmwave'): std::map<unsigned char, ns3::Ptr<ns3::mmwave::MmWaveComponentCarrierEnb>, std::less<unsigned char>, std::allocator<std::pair<const unsigned char, ns3::Ptr<ns3::mmwave::MmWaveComponentCarrierEnb> > > > ns3::mmwave::MmWaveEnbNetDevice::GetCcMap() [member function]
    cls.add_method('GetCcMap',
                   'std::map< unsigned char, ns3::Ptr< ns3::mmwave::MmWaveComponentCarrierEnb > >',
                   [])
    ## mmwave-enb-net-device.h (module 'mmwave'): uint16_t ns3::mmwave::MmWaveEnbNetDevice::GetCellId() const [member function]
    cls.add_method('GetCellId',
                   'uint16_t',
                   [],
                   is_const=True)
    ## mmwave-enb-net-device.h (module 'mmwave'): uint16_t ns3::mmwave::MmWaveEnbNetDevice::GetEarfcn() const [member function]
    cls.add_method('GetEarfcn',
                   'uint16_t',
                   [],
                   is_const=True)
    ## mmwave-enb-net-device.h (module 'mmwave'): ns3::Ptr<ns3::mmwave::MmWaveEnbMac> ns3::mmwave::MmWaveEnbNetDevice::GetMac() [member function]
    cls.add_method('GetMac',
                   'ns3::Ptr< ns3::mmwave::MmWaveEnbMac >',
                   [])
    ## mmwave-enb-net-device.h (module 'mmwave'): ns3::Ptr<ns3::mmwave::MmWaveEnbMac> ns3::mmwave::MmWaveEnbNetDevice::GetMac(uint8_t index) [member function]
    cls.add_method('GetMac',
                   'ns3::Ptr< ns3::mmwave::MmWaveEnbMac >',
                   [param('uint8_t', 'index')])
    ## mmwave-enb-net-device.h (module 'mmwave'): ns3::Ptr<ns3::mmwave::MmWaveEnbPhy> ns3::mmwave::MmWaveEnbNetDevice::GetPhy() const [member function]
    cls.add_method('GetPhy',
                   'ns3::Ptr< ns3::mmwave::MmWaveEnbPhy >',
                   [],
                   is_const=True)
    ## mmwave-enb-net-device.h (module 'mmwave'): ns3::Ptr<ns3::mmwave::MmWaveEnbPhy> ns3::mmwave::MmWaveEnbNetDevice::GetPhy(uint8_t index) [member function]
    cls.add_method('GetPhy',
                   'ns3::Ptr< ns3::mmwave::MmWaveEnbPhy >',
                   [param('uint8_t', 'index')])
    ## mmwave-enb-net-device.h (module 'mmwave'): ns3::Ptr<ns3::LteEnbRrc> ns3::mmwave::MmWaveEnbNetDevice::GetRrc() [member function]
    cls.add_method('GetRrc',
                   'ns3::Ptr< ns3::LteEnbRrc >',
                   [])
    ## mmwave-enb-net-device.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWaveEnbNetDevice::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-enb-net-device.h (module 'mmwave'): bool ns3::mmwave::MmWaveEnbNetDevice::HasCellId(uint16_t cellId) const [member function]
    cls.add_method('HasCellId',
                   'bool',
                   [param('uint16_t', 'cellId')],
                   is_const=True)
    ## mmwave-enb-net-device.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbNetDevice::SetAntennaNum(uint8_t antennaNum) [member function]
    cls.add_method('SetAntennaNum',
                   'void',
                   [param('uint8_t', 'antennaNum')])
    ## mmwave-enb-net-device.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbNetDevice::SetBandwidth(uint8_t bw) [member function]
    cls.add_method('SetBandwidth',
                   'void',
                   [param('uint8_t', 'bw')])
    ## mmwave-enb-net-device.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbNetDevice::SetCcMap(std::map<unsigned char, ns3::Ptr<ns3::mmwave::MmWaveComponentCarrierEnb>, std::less<unsigned char>, std::allocator<std::pair<const unsigned char, ns3::Ptr<ns3::mmwave::MmWaveComponentCarrierEnb> > > > ccm) [member function]
    cls.add_method('SetCcMap',
                   'void',
                   [param('std::map< unsigned char, ns3::Ptr< ns3::mmwave::MmWaveComponentCarrierEnb > >', 'ccm')])
    ## mmwave-enb-net-device.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbNetDevice::SetEarfcn(uint16_t earfcn) [member function]
    cls.add_method('SetEarfcn',
                   'void',
                   [param('uint16_t', 'earfcn')])
    ## mmwave-enb-net-device.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbNetDevice::SetRrc(ns3::Ptr<ns3::LteEnbRrc> rrc) [member function]
    cls.add_method('SetRrc',
                   'void',
                   [param('ns3::Ptr< ns3::LteEnbRrc >', 'rrc')])
    ## mmwave-enb-net-device.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbNetDevice::DoInitialize() [member function]
    cls.add_method('DoInitialize',
                   'void',
                   [],
                   visibility='protected', is_virtual=True)
    ## mmwave-enb-net-device.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbNetDevice::UpdateConfig() [member function]
    cls.add_method('UpdateConfig',
                   'void',
                   [],
                   visibility='protected')
    return

def register_Ns3MmwaveMmWaveEnbPhy_methods(root_module, cls):
    ## mmwave-enb-phy.h (module 'mmwave'): ns3::mmwave::MmWaveEnbPhy::MmWaveEnbPhy(ns3::mmwave::MmWaveEnbPhy const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveEnbPhy const &', 'arg0')])
    ## mmwave-enb-phy.h (module 'mmwave'): ns3::mmwave::MmWaveEnbPhy::MmWaveEnbPhy() [constructor]
    cls.add_constructor([])
    ## mmwave-enb-phy.h (module 'mmwave'): ns3::mmwave::MmWaveEnbPhy::MmWaveEnbPhy(ns3::Ptr<ns3::mmwave::MmWaveSpectrumPhy> arg0, ns3::Ptr<ns3::mmwave::MmWaveSpectrumPhy> arg1) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::mmwave::MmWaveSpectrumPhy >', 'arg0'), param('ns3::Ptr< ns3::mmwave::MmWaveSpectrumPhy >', 'arg1')])
    ## mmwave-enb-phy.h (module 'mmwave'): double ns3::mmwave::MmWaveEnbPhy::AddGaussianNoise(double sample) [member function]
    cls.add_method('AddGaussianNoise',
                   'double',
                   [param('double', 'sample')])
    ## mmwave-enb-phy.h (module 'mmwave'): bool ns3::mmwave::MmWaveEnbPhy::AddUePhy(uint64_t imsi, ns3::Ptr<ns3::NetDevice> ueDevice) [member function]
    cls.add_method('AddUePhy',
                   'bool',
                   [param('uint64_t', 'imsi'), param('ns3::Ptr< ns3::NetDevice >', 'ueDevice')])
    ## mmwave-enb-phy.h (module 'mmwave'): std::pair<unsigned long, unsigned long> ns3::mmwave::MmWaveEnbPhy::ApplyFilter(std::vector<double, std::allocator<double> > arg0) [member function]
    cls.add_method('ApplyFilter',
                   'std::pair< unsigned long, unsigned long >',
                   [param('std::vector< double >', 'arg0')])
    ## mmwave-enb-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbPhy::CalcChannelQualityForUe(std::vector<double, std::allocator<double> > sinr, ns3::Ptr<ns3::mmwave::MmWaveSpectrumPhy> ue) [member function]
    cls.add_method('CalcChannelQualityForUe',
                   'void',
                   [param('std::vector< double >', 'sinr'), param('ns3::Ptr< ns3::mmwave::MmWaveSpectrumPhy >', 'ue')])
    ## mmwave-enb-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbPhy::CallPathloss() [member function]
    cls.add_method('CallPathloss',
                   'void',
                   [])
    ## mmwave-enb-phy.h (module 'mmwave'): ns3::Ptr<ns3::SpectrumValue> ns3::mmwave::MmWaveEnbPhy::CreateTxPowerSpectralDensity() [member function]
    cls.add_method('CreateTxPowerSpectralDensity',
                   'ns3::Ptr< ns3::SpectrumValue >',
                   [],
                   is_virtual=True)
    ## mmwave-enb-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbPhy::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## mmwave-enb-phy.h (module 'mmwave'): int8_t ns3::mmwave::MmWaveEnbPhy::DoGetReferenceSignalPower() const [member function]
    cls.add_method('DoGetReferenceSignalPower',
                   'int8_t',
                   [],
                   is_const=True)
    ## mmwave-enb-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbPhy::DoInitialize() [member function]
    cls.add_method('DoInitialize',
                   'void',
                   [],
                   is_virtual=True)
    ## mmwave-enb-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbPhy::DoSetSubChannels() [member function]
    cls.add_method('DoSetSubChannels',
                   'void',
                   [])
    ## mmwave-enb-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbPhy::EndSlot() [member function]
    cls.add_method('EndSlot',
                   'void',
                   [])
    ## mmwave-enb-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbPhy::EndSubFrame() [member function]
    cls.add_method('EndSubFrame',
                   'void',
                   [])
    ## mmwave-enb-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbPhy::GenerateDataCqiReport(ns3::SpectrumValue const & sinr) [member function]
    cls.add_method('GenerateDataCqiReport',
                   'void',
                   [param('ns3::SpectrumValue const &', 'sinr')])
    ## mmwave-enb-phy.h (module 'mmwave'): uint32_t ns3::mmwave::MmWaveEnbPhy::GetAbsoluteSubframeNo() [member function]
    cls.add_method('GetAbsoluteSubframeNo',
                   'uint32_t',
                   [])
    ## mmwave-enb-phy.h (module 'mmwave'): ns3::Ptr<ns3::mmwave::MmWaveSpectrumPhy> ns3::mmwave::MmWaveEnbPhy::GetDlSpectrumPhy() const [member function]
    cls.add_method('GetDlSpectrumPhy',
                   'ns3::Ptr< ns3::mmwave::MmWaveSpectrumPhy >',
                   [],
                   is_const=True)
    ## mmwave-enb-phy.h (module 'mmwave'): ns3::LteEnbCphySapProvider * ns3::mmwave::MmWaveEnbPhy::GetMmWaveEnbCphySapProvider() [member function]
    cls.add_method('GetMmWaveEnbCphySapProvider',
                   'ns3::LteEnbCphySapProvider *',
                   [])
    ## mmwave-enb-phy.h (module 'mmwave'): double ns3::mmwave::MmWaveEnbPhy::GetNoiseFigure() const [member function]
    cls.add_method('GetNoiseFigure',
                   'double',
                   [],
                   is_const=True)
    ## mmwave-enb-phy.h (module 'mmwave'): double ns3::mmwave::MmWaveEnbPhy::GetTxPower() const [member function]
    cls.add_method('GetTxPower',
                   'double',
                   [],
                   is_const=True)
    ## mmwave-enb-phy.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWaveEnbPhy::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-enb-phy.h (module 'mmwave'): ns3::Ptr<ns3::mmwave::MmWaveSpectrumPhy> ns3::mmwave::MmWaveEnbPhy::GetUlSpectrumPhy() const [member function]
    cls.add_method('GetUlSpectrumPhy',
                   'ns3::Ptr< ns3::mmwave::MmWaveSpectrumPhy >',
                   [],
                   is_const=True)
    ## mmwave-enb-phy.h (module 'mmwave'): double ns3::mmwave::MmWaveEnbPhy::MakeAvg(std::vector<double, std::allocator<double> > arg0) [member function]
    cls.add_method('MakeAvg',
                   'double',
                   [param('std::vector< double >', 'arg0')])
    ## mmwave-enb-phy.h (module 'mmwave'): std::vector<double, std::allocator<double> > ns3::mmwave::MmWaveEnbPhy::MakeFilter(std::vector<double, std::allocator<double> > arg0, std::vector<double, std::allocator<double> > arg1, std::pair<unsigned long, unsigned long> arg2) [member function]
    cls.add_method('MakeFilter',
                   'std::vector< double >',
                   [param('std::vector< double >', 'arg0'), param('std::vector< double >', 'arg1'), param('std::pair< unsigned long, unsigned long >', 'arg2')])
    ## mmwave-enb-phy.h (module 'mmwave'): double ns3::mmwave::MmWaveEnbPhy::MakeVar(std::vector<double, std::allocator<double> > arg0, double arg1) [member function]
    cls.add_method('MakeVar',
                   'double',
                   [param('std::vector< double >', 'arg0'), param('double', 'arg1')])
    ## mmwave-enb-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbPhy::PhyCtrlMessagesReceived(std::list<ns3::Ptr<ns3::mmwave::MmWaveControlMessage>, std::allocator<ns3::Ptr<ns3::mmwave::MmWaveControlMessage> > > msgList) [member function]
    cls.add_method('PhyCtrlMessagesReceived',
                   'void',
                   [param('std::list< ns3::Ptr< ns3::mmwave::MmWaveControlMessage > >', 'msgList')])
    ## mmwave-enb-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbPhy::PhyDataPacketReceived(ns3::Ptr<ns3::Packet> p) [member function]
    cls.add_method('PhyDataPacketReceived',
                   'void',
                   [param('ns3::Ptr< ns3::Packet >', 'p')])
    ## mmwave-enb-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbPhy::ReceiveUlHarqFeedback(ns3::mmwave::UlHarqInfo mes) [member function]
    cls.add_method('ReceiveUlHarqFeedback',
                   'void',
                   [param('ns3::mmwave::UlHarqInfo', 'mes')])
    ## mmwave-enb-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbPhy::SendCtrlChannels(std::list<ns3::Ptr<ns3::mmwave::MmWaveControlMessage>, std::allocator<ns3::Ptr<ns3::mmwave::MmWaveControlMessage> > > ctrlMsg, ns3::Time slotPrd) [member function]
    cls.add_method('SendCtrlChannels',
                   'void',
                   [param('std::list< ns3::Ptr< ns3::mmwave::MmWaveControlMessage > >', 'ctrlMsg'), param('ns3::Time', 'slotPrd')])
    ## mmwave-enb-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbPhy::SendDataChannels(ns3::Ptr<ns3::PacketBurst> pb, ns3::Time slotPrd, ns3::mmwave::SlotAllocInfo & slotInfo) [member function]
    cls.add_method('SendDataChannels',
                   'void',
                   [param('ns3::Ptr< ns3::PacketBurst >', 'pb'), param('ns3::Time', 'slotPrd'), param('ns3::mmwave::SlotAllocInfo &', 'slotInfo')])
    ## mmwave-enb-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbPhy::SetHarqPhyModule(ns3::Ptr<ns3::mmwave::MmWaveHarqPhy> harq) [member function]
    cls.add_method('SetHarqPhyModule',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWaveHarqPhy >', 'harq')])
    ## mmwave-enb-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbPhy::SetMmWaveEnbCphySapUser(ns3::LteEnbCphySapUser * s) [member function]
    cls.add_method('SetMmWaveEnbCphySapUser',
                   'void',
                   [param('ns3::LteEnbCphySapUser *', 's')])
    ## mmwave-enb-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbPhy::SetNoiseFigure(double pf) [member function]
    cls.add_method('SetNoiseFigure',
                   'void',
                   [param('double', 'pf')])
    ## mmwave-enb-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbPhy::SetPhySapUser(ns3::mmwave::MmWaveEnbPhySapUser * ptr) [member function]
    cls.add_method('SetPhySapUser',
                   'void',
                   [param('ns3::mmwave::MmWaveEnbPhySapUser *', 'ptr')])
    ## mmwave-enb-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbPhy::SetSubChannels(std::vector<int, std::allocator<int> > mask) [member function]
    cls.add_method('SetSubChannels',
                   'void',
                   [param('std::vector< int >', 'mask')])
    ## mmwave-enb-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbPhy::SetTxPower(double pow) [member function]
    cls.add_method('SetTxPower',
                   'void',
                   [param('double', 'pow')])
    ## mmwave-enb-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbPhy::StartSlot() [member function]
    cls.add_method('StartSlot',
                   'void',
                   [])
    ## mmwave-enb-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbPhy::StartSubFrame() [member function]
    cls.add_method('StartSubFrame',
                   'void',
                   [])
    ## mmwave-enb-phy.h (module 'mmwave'): void ns3::mmwave::MmWaveEnbPhy::UpdateUeSinrEstimate() [member function]
    cls.add_method('UpdateUeSinrEstimate',
                   'void',
                   [])
    return

def register_Ns3MmwaveMmWaveFlexTtiMacScheduler_methods(root_module, cls):
    ## mmwave-flex-tti-mac-scheduler.h (module 'mmwave'): ns3::mmwave::MmWaveFlexTtiMacScheduler::MmWaveFlexTtiMacScheduler(ns3::mmwave::MmWaveFlexTtiMacScheduler const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveFlexTtiMacScheduler const &', 'arg0')])
    ## mmwave-flex-tti-mac-scheduler.h (module 'mmwave'): ns3::mmwave::MmWaveFlexTtiMacScheduler::MmWaveFlexTtiMacScheduler() [constructor]
    cls.add_constructor([])
    ## mmwave-flex-tti-mac-scheduler.h (module 'mmwave'): void ns3::mmwave::MmWaveFlexTtiMacScheduler::ConfigureCommonParameters(ns3::Ptr<ns3::mmwave::MmWavePhyMacCommon> config) [member function]
    cls.add_method('ConfigureCommonParameters',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWavePhyMacCommon >', 'config')],
                   is_virtual=True)
    ## mmwave-flex-tti-mac-scheduler.h (module 'mmwave'): void ns3::mmwave::MmWaveFlexTtiMacScheduler::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## mmwave-flex-tti-mac-scheduler.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider * ns3::mmwave::MmWaveFlexTtiMacScheduler::GetMacCschedSapProvider() [member function]
    cls.add_method('GetMacCschedSapProvider',
                   'ns3::mmwave::MmWaveMacCschedSapProvider *',
                   [],
                   is_virtual=True)
    ## mmwave-flex-tti-mac-scheduler.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider * ns3::mmwave::MmWaveFlexTtiMacScheduler::GetMacSchedSapProvider() [member function]
    cls.add_method('GetMacSchedSapProvider',
                   'ns3::mmwave::MmWaveMacSchedSapProvider *',
                   [],
                   is_virtual=True)
    ## mmwave-flex-tti-mac-scheduler.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWaveFlexTtiMacScheduler::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-flex-tti-mac-scheduler.h (module 'mmwave'): void ns3::mmwave::MmWaveFlexTtiMacScheduler::RefreshDlCqiMaps() [member function]
    cls.add_method('RefreshDlCqiMaps',
                   'void',
                   [])
    ## mmwave-flex-tti-mac-scheduler.h (module 'mmwave'): void ns3::mmwave::MmWaveFlexTtiMacScheduler::RefreshUlCqiMaps() [member function]
    cls.add_method('RefreshUlCqiMaps',
                   'void',
                   [])
    ## mmwave-flex-tti-mac-scheduler.h (module 'mmwave'): void ns3::mmwave::MmWaveFlexTtiMacScheduler::SetMacCschedSapUser(ns3::mmwave::MmWaveMacCschedSapUser * s) [member function]
    cls.add_method('SetMacCschedSapUser',
                   'void',
                   [param('ns3::mmwave::MmWaveMacCschedSapUser *', 's')],
                   is_virtual=True)
    ## mmwave-flex-tti-mac-scheduler.h (module 'mmwave'): void ns3::mmwave::MmWaveFlexTtiMacScheduler::SetMacSchedSapUser(ns3::mmwave::MmWaveMacSchedSapUser * sap) [member function]
    cls.add_method('SetMacSchedSapUser',
                   'void',
                   [param('ns3::mmwave::MmWaveMacSchedSapUser *', 'sap')],
                   is_virtual=True)
    ## mmwave-flex-tti-mac-scheduler.h (module 'mmwave'): static bool ns3::mmwave::MmWaveFlexTtiMacScheduler::SortRlcBufferReq(ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlRlcBufferReqParameters i, ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlRlcBufferReqParameters j) [member function]
    cls.add_method('SortRlcBufferReq',
                   'bool',
                   [param('ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlRlcBufferReqParameters', 'i'), param('ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlRlcBufferReqParameters', 'j')],
                   is_static=True)
    ## mmwave-flex-tti-mac-scheduler.h (module 'mmwave'): void ns3::mmwave::MmWaveFlexTtiMacScheduler::UpdateDlRlcBufferInfo(uint16_t rnti, uint8_t lcid, uint16_t size) [member function]
    cls.add_method('UpdateDlRlcBufferInfo',
                   'void',
                   [param('uint16_t', 'rnti'), param('uint8_t', 'lcid'), param('uint16_t', 'size')])
    ## mmwave-flex-tti-mac-scheduler.h (module 'mmwave'): void ns3::mmwave::MmWaveFlexTtiMacScheduler::UpdateUlRlcBufferInfo(uint16_t rnti, uint16_t size) [member function]
    cls.add_method('UpdateUlRlcBufferInfo',
                   'void',
                   [param('uint16_t', 'rnti'), param('uint16_t', 'size')])
    return

def register_Ns3MmwaveMmWaveFlexTtiMaxRateMacScheduler_methods(root_module, cls):
    ## mmwave-flex-tti-maxrate-mac-scheduler.h (module 'mmwave'): ns3::mmwave::MmWaveFlexTtiMaxRateMacScheduler::MmWaveFlexTtiMaxRateMacScheduler(ns3::mmwave::MmWaveFlexTtiMaxRateMacScheduler const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveFlexTtiMaxRateMacScheduler const &', 'arg0')])
    ## mmwave-flex-tti-maxrate-mac-scheduler.h (module 'mmwave'): ns3::mmwave::MmWaveFlexTtiMaxRateMacScheduler::MmWaveFlexTtiMaxRateMacScheduler() [constructor]
    cls.add_constructor([])
    ## mmwave-flex-tti-maxrate-mac-scheduler.h (module 'mmwave'): void ns3::mmwave::MmWaveFlexTtiMaxRateMacScheduler::ConfigureCommonParameters(ns3::Ptr<ns3::mmwave::MmWavePhyMacCommon> config) [member function]
    cls.add_method('ConfigureCommonParameters',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWavePhyMacCommon >', 'config')],
                   is_virtual=True)
    ## mmwave-flex-tti-maxrate-mac-scheduler.h (module 'mmwave'): void ns3::mmwave::MmWaveFlexTtiMaxRateMacScheduler::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## mmwave-flex-tti-maxrate-mac-scheduler.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider * ns3::mmwave::MmWaveFlexTtiMaxRateMacScheduler::GetMacCschedSapProvider() [member function]
    cls.add_method('GetMacCschedSapProvider',
                   'ns3::mmwave::MmWaveMacCschedSapProvider *',
                   [],
                   is_virtual=True)
    ## mmwave-flex-tti-maxrate-mac-scheduler.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider * ns3::mmwave::MmWaveFlexTtiMaxRateMacScheduler::GetMacSchedSapProvider() [member function]
    cls.add_method('GetMacSchedSapProvider',
                   'ns3::mmwave::MmWaveMacSchedSapProvider *',
                   [],
                   is_virtual=True)
    ## mmwave-flex-tti-maxrate-mac-scheduler.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWaveFlexTtiMaxRateMacScheduler::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-flex-tti-maxrate-mac-scheduler.h (module 'mmwave'): void ns3::mmwave::MmWaveFlexTtiMaxRateMacScheduler::RefreshDlCqiMaps() [member function]
    cls.add_method('RefreshDlCqiMaps',
                   'void',
                   [])
    ## mmwave-flex-tti-maxrate-mac-scheduler.h (module 'mmwave'): void ns3::mmwave::MmWaveFlexTtiMaxRateMacScheduler::RefreshUlCqiMaps() [member function]
    cls.add_method('RefreshUlCqiMaps',
                   'void',
                   [])
    ## mmwave-flex-tti-maxrate-mac-scheduler.h (module 'mmwave'): void ns3::mmwave::MmWaveFlexTtiMaxRateMacScheduler::SetMacCschedSapUser(ns3::mmwave::MmWaveMacCschedSapUser * s) [member function]
    cls.add_method('SetMacCschedSapUser',
                   'void',
                   [param('ns3::mmwave::MmWaveMacCschedSapUser *', 's')],
                   is_virtual=True)
    ## mmwave-flex-tti-maxrate-mac-scheduler.h (module 'mmwave'): void ns3::mmwave::MmWaveFlexTtiMaxRateMacScheduler::SetMacSchedSapUser(ns3::mmwave::MmWaveMacSchedSapUser * sap) [member function]
    cls.add_method('SetMacSchedSapUser',
                   'void',
                   [param('ns3::mmwave::MmWaveMacSchedSapUser *', 'sap')],
                   is_virtual=True)
    ## mmwave-flex-tti-maxrate-mac-scheduler.h (module 'mmwave'): static bool ns3::mmwave::MmWaveFlexTtiMaxRateMacScheduler::SortRlcBufferReq(ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlRlcBufferReqParameters i, ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlRlcBufferReqParameters j) [member function]
    cls.add_method('SortRlcBufferReq',
                   'bool',
                   [param('ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlRlcBufferReqParameters', 'i'), param('ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlRlcBufferReqParameters', 'j')],
                   is_static=True)
    ## mmwave-flex-tti-maxrate-mac-scheduler.h (module 'mmwave'): void ns3::mmwave::MmWaveFlexTtiMaxRateMacScheduler::UpdateDlRlcBufferInfo(uint16_t rnti, uint8_t lcid, uint16_t size) [member function]
    cls.add_method('UpdateDlRlcBufferInfo',
                   'void',
                   [param('uint16_t', 'rnti'), param('uint8_t', 'lcid'), param('uint16_t', 'size')])
    ## mmwave-flex-tti-maxrate-mac-scheduler.h (module 'mmwave'): void ns3::mmwave::MmWaveFlexTtiMaxRateMacScheduler::UpdateUlRlcBufferInfo(uint16_t rnti, uint16_t size) [member function]
    cls.add_method('UpdateUlRlcBufferInfo',
                   'void',
                   [param('uint16_t', 'rnti'), param('uint16_t', 'size')])
    return

def register_Ns3MmwaveMmWaveFlexTtiMaxWeightMacScheduler_methods(root_module, cls):
    ## mmwave-flex-tti-maxweight-mac-scheduler.h (module 'mmwave'): ns3::mmwave::MmWaveFlexTtiMaxWeightMacScheduler::MmWaveFlexTtiMaxWeightMacScheduler(ns3::mmwave::MmWaveFlexTtiMaxWeightMacScheduler const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveFlexTtiMaxWeightMacScheduler const &', 'arg0')])
    ## mmwave-flex-tti-maxweight-mac-scheduler.h (module 'mmwave'): ns3::mmwave::MmWaveFlexTtiMaxWeightMacScheduler::MmWaveFlexTtiMaxWeightMacScheduler() [constructor]
    cls.add_constructor([])
    ## mmwave-flex-tti-maxweight-mac-scheduler.h (module 'mmwave'): void ns3::mmwave::MmWaveFlexTtiMaxWeightMacScheduler::ConfigureCommonParameters(ns3::Ptr<ns3::mmwave::MmWavePhyMacCommon> config) [member function]
    cls.add_method('ConfigureCommonParameters',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWavePhyMacCommon >', 'config')],
                   is_virtual=True)
    ## mmwave-flex-tti-maxweight-mac-scheduler.h (module 'mmwave'): void ns3::mmwave::MmWaveFlexTtiMaxWeightMacScheduler::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## mmwave-flex-tti-maxweight-mac-scheduler.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider * ns3::mmwave::MmWaveFlexTtiMaxWeightMacScheduler::GetMacCschedSapProvider() [member function]
    cls.add_method('GetMacCschedSapProvider',
                   'ns3::mmwave::MmWaveMacCschedSapProvider *',
                   [],
                   is_virtual=True)
    ## mmwave-flex-tti-maxweight-mac-scheduler.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider * ns3::mmwave::MmWaveFlexTtiMaxWeightMacScheduler::GetMacSchedSapProvider() [member function]
    cls.add_method('GetMacSchedSapProvider',
                   'ns3::mmwave::MmWaveMacSchedSapProvider *',
                   [],
                   is_virtual=True)
    ## mmwave-flex-tti-maxweight-mac-scheduler.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWaveFlexTtiMaxWeightMacScheduler::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-flex-tti-maxweight-mac-scheduler.h (module 'mmwave'): void ns3::mmwave::MmWaveFlexTtiMaxWeightMacScheduler::RefreshDlCqiMaps() [member function]
    cls.add_method('RefreshDlCqiMaps',
                   'void',
                   [])
    ## mmwave-flex-tti-maxweight-mac-scheduler.h (module 'mmwave'): void ns3::mmwave::MmWaveFlexTtiMaxWeightMacScheduler::RefreshUlCqiMaps() [member function]
    cls.add_method('RefreshUlCqiMaps',
                   'void',
                   [])
    ## mmwave-flex-tti-maxweight-mac-scheduler.h (module 'mmwave'): void ns3::mmwave::MmWaveFlexTtiMaxWeightMacScheduler::SetMacCschedSapUser(ns3::mmwave::MmWaveMacCschedSapUser * s) [member function]
    cls.add_method('SetMacCschedSapUser',
                   'void',
                   [param('ns3::mmwave::MmWaveMacCschedSapUser *', 's')],
                   is_virtual=True)
    ## mmwave-flex-tti-maxweight-mac-scheduler.h (module 'mmwave'): void ns3::mmwave::MmWaveFlexTtiMaxWeightMacScheduler::SetMacSchedSapUser(ns3::mmwave::MmWaveMacSchedSapUser * sap) [member function]
    cls.add_method('SetMacSchedSapUser',
                   'void',
                   [param('ns3::mmwave::MmWaveMacSchedSapUser *', 'sap')],
                   is_virtual=True)
    ## mmwave-flex-tti-maxweight-mac-scheduler.h (module 'mmwave'): static bool ns3::mmwave::MmWaveFlexTtiMaxWeightMacScheduler::SortRlcBufferReq(ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlRlcBufferReqParameters i, ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlRlcBufferReqParameters j) [member function]
    cls.add_method('SortRlcBufferReq',
                   'bool',
                   [param('ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlRlcBufferReqParameters', 'i'), param('ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlRlcBufferReqParameters', 'j')],
                   is_static=True)
    ## mmwave-flex-tti-maxweight-mac-scheduler.h (module 'mmwave'): void ns3::mmwave::MmWaveFlexTtiMaxWeightMacScheduler::UpdateDlRlcBufferInfo(uint16_t rnti, uint8_t lcid, uint16_t size) [member function]
    cls.add_method('UpdateDlRlcBufferInfo',
                   'void',
                   [param('uint16_t', 'rnti'), param('uint8_t', 'lcid'), param('uint16_t', 'size')])
    ## mmwave-flex-tti-maxweight-mac-scheduler.h (module 'mmwave'): void ns3::mmwave::MmWaveFlexTtiMaxWeightMacScheduler::UpdateUlRlcBufferInfo(uint16_t rnti, uint16_t size) [member function]
    cls.add_method('UpdateUlRlcBufferInfo',
                   'void',
                   [param('uint16_t', 'rnti'), param('uint16_t', 'size')])
    return

def register_Ns3MmwaveMmWaveFlexTtiPfMacScheduler_methods(root_module, cls):
    ## mmwave-flex-tti-pf-mac-scheduler.h (module 'mmwave'): ns3::mmwave::MmWaveFlexTtiPfMacScheduler::MmWaveFlexTtiPfMacScheduler(ns3::mmwave::MmWaveFlexTtiPfMacScheduler const & arg0) [constructor]
    cls.add_constructor([param('ns3::mmwave::MmWaveFlexTtiPfMacScheduler const &', 'arg0')])
    ## mmwave-flex-tti-pf-mac-scheduler.h (module 'mmwave'): ns3::mmwave::MmWaveFlexTtiPfMacScheduler::MmWaveFlexTtiPfMacScheduler() [constructor]
    cls.add_constructor([])
    ## mmwave-flex-tti-pf-mac-scheduler.h (module 'mmwave'): void ns3::mmwave::MmWaveFlexTtiPfMacScheduler::ConfigureCommonParameters(ns3::Ptr<ns3::mmwave::MmWavePhyMacCommon> config) [member function]
    cls.add_method('ConfigureCommonParameters',
                   'void',
                   [param('ns3::Ptr< ns3::mmwave::MmWavePhyMacCommon >', 'config')],
                   is_virtual=True)
    ## mmwave-flex-tti-pf-mac-scheduler.h (module 'mmwave'): void ns3::mmwave::MmWaveFlexTtiPfMacScheduler::DoDispose() [member function]
    cls.add_method('DoDispose',
                   'void',
                   [],
                   is_virtual=True)
    ## mmwave-flex-tti-pf-mac-scheduler.h (module 'mmwave'): ns3::mmwave::MmWaveMacCschedSapProvider * ns3::mmwave::MmWaveFlexTtiPfMacScheduler::GetMacCschedSapProvider() [member function]
    cls.add_method('GetMacCschedSapProvider',
                   'ns3::mmwave::MmWaveMacCschedSapProvider *',
                   [],
                   is_virtual=True)
    ## mmwave-flex-tti-pf-mac-scheduler.h (module 'mmwave'): ns3::mmwave::MmWaveMacSchedSapProvider * ns3::mmwave::MmWaveFlexTtiPfMacScheduler::GetMacSchedSapProvider() [member function]
    cls.add_method('GetMacSchedSapProvider',
                   'ns3::mmwave::MmWaveMacSchedSapProvider *',
                   [],
                   is_virtual=True)
    ## mmwave-flex-tti-pf-mac-scheduler.h (module 'mmwave'): static ns3::TypeId ns3::mmwave::MmWaveFlexTtiPfMacScheduler::GetTypeId() [member function]
    cls.add_method('GetTypeId',
                   'ns3::TypeId',
                   [],
                   is_static=True)
    ## mmwave-flex-tti-pf-mac-scheduler.h (module 'mmwave'): void ns3::mmwave::MmWaveFlexTtiPfMacScheduler::RefreshDlCqiMaps() [member function]
    cls.add_method('RefreshDlCqiMaps',
                   'void',
                   [])
    ## mmwave-flex-tti-pf-mac-scheduler.h (module 'mmwave'): void ns3::mmwave::MmWaveFlexTtiPfMacScheduler::RefreshUlCqiMaps() [member function]
    cls.add_method('RefreshUlCqiMaps',
                   'void',
                   [])
    ## mmwave-flex-tti-pf-mac-scheduler.h (module 'mmwave'): void ns3::mmwave::MmWaveFlexTtiPfMacScheduler::SetMacCschedSapUser(ns3::mmwave::MmWaveMacCschedSapUser * s) [member function]
    cls.add_method('SetMacCschedSapUser',
                   'void',
                   [param('ns3::mmwave::MmWaveMacCschedSapUser *', 's')],
                   is_virtual=True)
    ## mmwave-flex-tti-pf-mac-scheduler.h (module 'mmwave'): void ns3::mmwave::MmWaveFlexTtiPfMacScheduler::SetMacSchedSapUser(ns3::mmwave::MmWaveMacSchedSapUser * sap) [member function]
    cls.add_method('SetMacSchedSapUser',
                   'void',
                   [param('ns3::mmwave::MmWaveMacSchedSapUser *', 'sap')],
                   is_virtual=True)
    ## mmwave-flex-tti-pf-mac-scheduler.h (module 'mmwave'): static bool ns3::mmwave::MmWaveFlexTtiPfMacScheduler::SortRlcBufferReq(ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlRlcBufferReqParameters i, ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlRlcBufferReqParameters j) [member function]
    cls.add_method('SortRlcBufferReq',
                   'bool',
                   [param('ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlRlcBufferReqParameters', 'i'), param('ns3::mmwave::MmWaveMacSchedSapProvider::SchedDlRlcBufferReqParameters', 'j')],
                   is_static=True)
    ## mmwave-flex-tti-pf-mac-scheduler.h (module 'mmwave'): void ns3::mmwave::MmWaveFlexTtiPfMacScheduler::UpdateDlRlcBufferInfo(uint16_t rnti, uint8_t lcid, uint16_t size) [member function]
    cls.add_method('UpdateDlRlcBufferInfo',
                   'void',
                   [param('uint16_t', 'rnti'), param('uint8_t', 'lcid'), param('uint16_t', 'size')])
    ## mmwave-flex-tti-pf-mac-scheduler.h (module 'mmwave'): void ns3::mmwave::MmWaveFlexTtiPfMacScheduler::UpdateUlRlcBufferInfo(uint16_t rnti, uint16_t size) [member function]
    cls.add_method('UpdateUlRlcBufferInfo',
                   'void',
                   [param('uint16_t', 'rnti'), param('uint16_t', 'size')])
    return

def register_functions(root_module):
    module = root_module
    register_functions_ns3_Config(module.add_cpp_namespace('Config'), root_module)
    register_functions_ns3_FatalImpl(module.add_cpp_namespace('FatalImpl'), root_module)
    register_functions_ns3_Hash(module.add_cpp_namespace('Hash'), root_module)
    register_functions_ns3_TracedValueCallback(module.add_cpp_namespace('TracedValueCallback'), root_module)
    register_functions_ns3_internal(module.add_cpp_namespace('internal'), root_module)
    register_functions_ns3_mmwave(module.add_cpp_namespace('mmwave'), root_module)
    return

def register_functions_ns3_Config(module, root_module):
    return

def register_functions_ns3_FatalImpl(module, root_module):
    return

def register_functions_ns3_Hash(module, root_module):
    register_functions_ns3_Hash_Function(module.add_cpp_namespace('Function'), root_module)
    return

def register_functions_ns3_Hash_Function(module, root_module):
    return

def register_functions_ns3_TracedValueCallback(module, root_module):
    return

def register_functions_ns3_internal(module, root_module):
    return

def register_functions_ns3_mmwave(module, root_module):
    return

def main():
    out = FileCodeSink(sys.stdout)
    root_module = module_init()
    register_types(root_module)
    register_methods(root_module)
    register_functions(root_module)
    root_module.generate(out)

if __name__ == '__main__':
    main()
